/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],T=0,A=G.length;T<A;T++)e[T]=ie[G[T]];return e};define(ie[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(L){return(I,h,c)=>{let b=null,E=null;if(typeof c.value=="function"?(b="value",E=c.value):typeof c.get=="function"&&(b="get",E=c.get),!E)throw new Error("not supported");c[b]=L(E,h)}}function A(L,I,h){let c=null,b=null;if(typeof h.value=="function"?(c="value",b=h.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",b=h.get),!b)throw new Error("not supported");const E=`$memoize$${I}`;h[c]=function(...y){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[E]}}e.memoize=A;function O(L,I,h){return T((c,b)=>{const E=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...v){this[y]||(this[y]=h?h():void 0),clearTimeout(this[E]),I&&(this[y]=I(this[y],...v),v=[this[y]]),this[E]=setTimeout(()=>{c.apply(this,v),this[y]=h?h():void 0},L)}})}e.debounce=O;function C(L,I,h){return T((c,b)=>{const E=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,N=`$throttle$pending$${b}`;return function(...k){if(this[y]||(this[y]=h?h():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[y]=I(this[y],...k)),this[N])return;const u=this[v]+L;u<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0):(this[N]=!0,this[E]=setTimeout(()=>{this[N]=!1,this[v]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0},u-Date.now()))}})}e.throttle=C}),define(ie[70],ne([0,1,9]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function O(h,c="Unreachable"){throw new Error(c)}e.assertNever=O;function C(h){if(!h)throw new T.BugIndicatingError("Assertion Failed")}e.assert=C;function L(h){if(!h()){debugger;h(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function I(h,c){let b=0;for(;b<h.length-1;){const E=h[b],y=h[b+1];if(!c(E,y))return!1;b++}return!0}e.checkAdjacentItems=I}),define(ie[51],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function L(t,a=!1){let n=0;const i=t.length;let r="",o=0,l=16,d=0;function S(re){let le=0,fe=0;for(;le<re;){const ae=t.charCodeAt(n);if(ae>=48&&ae<=57)fe=fe*16+ae-48;else if(ae>=65&&ae<=70)fe=fe*16+ae-65+10;else if(ae>=97&&ae<=102)fe=fe*16+ae-97+10;else break;n++,le++}return le<re&&(fe=-1),fe}function D(re){n=re,r="",o=0,l=16,d=0}function j(){const re=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return d=3,t.substring(re,n);let le=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;le=n}else d=3;return t.substring(re,le)}function K(){let re="",le=n;for(;;){if(n>=i){re+=t.substring(le,n),d=2;break}const fe=t.charCodeAt(n);if(fe===34){re+=t.substring(le,n),n++;break}if(fe===92){if(re+=t.substring(le,n),n++,n>=i){d=2;break}switch(t.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const $=S(4);$>=0?re+=String.fromCharCode($):d=4;break}default:d=5}le=n;continue}if(fe>=0&&fe<=31)if(h(fe)){re+=t.substring(le,n),d=2;break}else d=6;n++}return re}function Q(){if(r="",d=0,o=n,n>=i)return o=i,l=17;let re=t.charCodeAt(n);if(I(re)){do n++,r+=String.fromCharCode(re),re=t.charCodeAt(n);while(I(re));return l=15}if(h(re))return n++,r+=String.fromCharCode(re),re===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),l=14;switch(re){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=K(),l=10;case 47:{const le=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!h(t.charCodeAt(n));)n++;return r=t.substring(le,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const fe=i-1;let ae=!1;for(;n<fe;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,ae=!0;break}n++}return ae||(n++,d=1),r=t.substring(le,n),l=13}return r+=String.fromCharCode(re),n++,l=16}case 45:if(r+=String.fromCharCode(re),n++,n===i||!c(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=j(),l=11;default:for(;n<i&&ee(re);)n++,re=t.charCodeAt(n);if(o!==n){switch(r=t.substring(o,n),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(re),n++,l=16}}function ee(re){if(I(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let re;do re=Q();while(re>=12&&re<=15);return re}return{setPosition:D,getPosition:()=>n,scan:a?se:Q,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>d}}e.createScanner=L;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function E(t,a){const n=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(S,D,j,K){o.value=S,o.offset=D,o.length=j,o.type=K,o.colonOffset=void 0,r=o}try{w(t,{onObjectBegin:(S,D)=>{if(a<=S)throw i;r=void 0,l=a>S,n.push("")},onObjectProperty:(S,D,j)=>{if(a<D||(d(S,D,j,"property"),n[n.length-1]=S,a<=D+j))throw i},onObjectEnd:(S,D)=>{if(a<=S)throw i;r=void 0,n.pop()},onArrayBegin:(S,D)=>{if(a<=S)throw i;r=void 0,n.push(0)},onArrayEnd:(S,D)=>{if(a<=S)throw i;r=void 0,n.pop()},onLiteralValue:(S,D,j)=>{if(a<D||(d(S,D,j,P(S)),a<=D+j))throw i},onSeparator:(S,D,j)=>{if(a<=D)throw i;if(S===":"&&r&&r.type==="property")r.colonOffset=D,l=!1,r=void 0;else if(S===","){const K=n[n.length-1];typeof K=="number"?n[n.length-1]=K+1:(l=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==i)throw S}return{path:n,previousNode:r,isAtPropertyKey:l,matches:S=>{let D=0;for(let j=0;D<S.length&&j<n.length;j++)if(S[D]===n[j]||S[D]==="*")D++;else if(S[D]!=="**")return!1;return D===S.length}}}e.getLocation=E;function y(t,a=[],n=C.DEFAULT){let i=null,r=[];const o=[];function l(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}return w(t,{onObjectBegin:()=>{const S={};l(S),o.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const S=[];l(S),o.push(r),r=S,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(S,D,j)=>{a.push({error:S,offset:D,length:j})}},n),r[0]}e.parse=y;function v(t,a=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function o(S){return i.children.push(S),S}w(t,{onObjectBegin:S=>{i=o({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,D,j)=>{i=o({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:D,length:j,parent:i})},onObjectEnd:(S,D)=>{i.length=S+D-i.offset,i=i.parent,r(S+D)},onArrayBegin:(S,D)=>{i=o({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,D)=>{i.length=S+D-i.offset,i=i.parent,r(S+D)},onLiteralValue:(S,D,j)=>{o({type:P(S),offset:D,length:j,parent:i,value:S}),r(D+j)},onSeparator:(S,D,j)=>{i.type==="property"&&(S===":"?i.colonOffset=D:S===","&&r(D))},onError:(S,D,j)=>{a.push({error:S,offset:D,length:j})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=v;function N(t,a){if(!t)return;let n=t;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===i){n=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=N;function k(t){if(!t.parent||!t.parent.children)return[];const a=k(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=k;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const a=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(a[n.children[0].value]=u(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=f;function p(t,a,n=!1){if(f(t,a,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const o=p(i[r],a,n);if(o)return o}return t}}e.findNodeAtOffset=p;function w(t,a,n=C.DEFAULT){const i=L(t,!1);function r(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(X){return X?Y=>X(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(a.onObjectBegin),d=o(a.onObjectProperty),S=r(a.onObjectEnd),D=r(a.onArrayBegin),j=r(a.onArrayEnd),K=o(a.onLiteralValue),Q=o(a.onSeparator),ee=r(a.onComment),se=o(a.onError),re=n&&n.disallowComments,le=n&&n.allowTrailingComma;function fe(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(X){case 12:case 13:re?ae(10):ee();break;case 16:ae(1);break;case 15:case 14:break;default:return X}}}function ae(X,Y=[],F=[]){if(se(X),Y.length+F.length>0){let R=i.getToken();for(;R!==17;){if(Y.indexOf(R)!==-1){fe();break}else if(F.indexOf(R)!==-1)break;R=fe()}}}function $(X){const Y=i.getTokenValue();return X?K(Y):d(Y),fe(),!0}function W(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(ae(2),X=0)}catch{ae(2)}K(X);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return fe(),!0}function z(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):($(!1),i.getToken()===6?(Q(":"),fe(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function U(){l(),fe();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||ae(4,[],[]),Q(","),fe(),i.getToken()===2&&le)break}else X&&ae(6,[],[]);z()||ae(4,[],[2,5]),X=!0}return S(),i.getToken()!==2?ae(7,[2],[]):fe(),!0}function q(){D(),fe();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||ae(4,[],[]),Q(","),fe(),i.getToken()===4&&le)break}else X&&ae(6,[],[]);H()||ae(4,[],[4,5]),X=!0}return j(),i.getToken()!==4?ae(8,[4],[]):fe(),!0}function H(){switch(i.getToken()){case 3:return q();case 1:return U();case 10:return $(!0);default:return W()}}return fe(),i.getToken()===17?n.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=w;function g(t,a){const n=L(t),i=[];let r,o=0,l;do switch(l=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:o!==l&&i.push(t.substring(o,l)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=g;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(ie[71],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(I,h,c){return Math.min(Math.max(I,h),c)}e.clamp=T;function A(I,h){return(h+I%h)%h}e.rot=A;class O{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=O;class C{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class L{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=L}),function(){function G(O){const C=[];typeof O=="number"&&C.push("code/timeOrigin",O);function L(h){C.push(h,Date.now())}function I(){const h=[];for(let c=0;c<C.length;c+=2)h.push({name:C[c],startTime:C[c+1]});return h}return{mark:L,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const L of performance.getEntriesByType("mark"))C.push({name:L.name,startTime:Math.round(O+L.startTime)});return C}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function T(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=T(A))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var A in T)(typeof exports=="object"?exports:G)[A]=T[A]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function T(A){if(e[A])return e[A].exports;var O=e[A]={i:A,l:!1,exports:{}};return G[A].call(O.exports,O,O.exports,T),O.l=!0,O.exports}return T.m=G,T.c=e,T.d=function(A,O,C){T.o(A,O)||Object.defineProperty(A,O,{enumerable:!0,get:C})},T.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},T.t=function(A,O){if(1&O&&(A=T(A)),8&O||4&O&&typeof A=="object"&&A&&A.__esModule)return A;var C=Object.create(null);if(T.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:A}),2&O&&typeof A!="string")for(var L in A)T.d(C,L,function(I){return A[I]}.bind(null,L));return C},T.n=function(A){var O=A&&A.__esModule?function(){return A.default}:function(){return A};return T.d(O,"a",O),O},T.o=function(A,O){return Object.prototype.hasOwnProperty.call(A,O)},T.p="",T(T.s=0)}([function(G,e,T){(function(A){var O;e=G.exports=F,O=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],c=0,b=c++;h[b]="0|[1-9]\\d*";var E=c++;h[E]="[0-9]+";var y=c++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;h[v]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var N=c++;h[N]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var k=c++;h[k]="(?:"+h[b]+"|"+h[y]+")";var u=c++;h[u]="(?:"+h[E]+"|"+h[y]+")";var f=c++;h[f]="(?:-("+h[k]+"(?:\\."+h[k]+")*))";var p=c++;h[p]="(?:-?("+h[u]+"(?:\\."+h[u]+")*))";var w=c++;h[w]="[0-9A-Za-z-]+";var g=c++;h[g]="(?:\\+("+h[w]+"(?:\\."+h[w]+")*))";var P=c++,t="v?"+h[v]+h[f]+"?"+h[g]+"?";h[P]="^"+t+"$";var a="[v=\\s]*"+h[N]+h[p]+"?"+h[g]+"?",n=c++;h[n]="^"+a+"$";var i=c++;h[i]="((?:<|>)?=?)";var r=c++;h[r]=h[E]+"|x|X|\\*";var o=c++;h[o]=h[b]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[f]+")?"+h[g]+"?)?)?";var d=c++;h[d]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[p]+")?"+h[g]+"?)?)?";var S=c++;h[S]="^"+h[i]+"\\s*"+h[l]+"$";var D=c++;h[D]="^"+h[i]+"\\s*"+h[d]+"$";var j=c++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=c++;h[K]="(?:~>?)";var Q=c++;h[Q]="(\\s*)"+h[K]+"\\s+",I[Q]=new RegExp(h[Q],"g");var ee=c++;h[ee]="^"+h[K]+h[l]+"$";var se=c++;h[se]="^"+h[K]+h[d]+"$";var re=c++;h[re]="(?:\\^)";var le=c++;h[le]="(\\s*)"+h[re]+"\\s+",I[le]=new RegExp(h[le],"g");var fe=c++;h[fe]="^"+h[re]+h[l]+"$";var ae=c++;h[ae]="^"+h[re]+h[d]+"$";var $=c++;h[$]="^"+h[i]+"\\s*("+a+")$|^$";var W=c++;h[W]="^"+h[i]+"\\s*("+t+")$|^$";var z=c++;h[z]="(\\s*)"+h[i]+"\\s*("+a+"|"+h[l]+")",I[z]=new RegExp(h[z],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var q=c++;h[q]="^\\s*("+h[d]+")\\s+-\\s+("+h[d]+")\\s*$";var H=c++;h[H]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)O(X,h[X]),I[X]||(I[X]=new RegExp(h[X]));function Y(V,J){if(V instanceof F)return V;if(typeof V!="string"||V.length>C||!(J?I[n]:I[P]).test(V))return null;try{return new F(V,J)}catch{return null}}function F(V,J){if(V instanceof F){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof F))return new F(V,J);O("SemVer",V,J),this.loose=J;var _=V.trim().match(J?I[n]:I[P]);if(!_)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Ee=+pe;if(Ee>=0&&Ee<L)return Ee}return pe}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=Y,e.valid=function(V,J){var _=Y(V,J);return _?_.version:null},e.clean=function(V,J){var _=Y(V.trim().replace(/^[=v]+/,""),J);return _?_.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return O("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),s(this.major,V.major)||s(this.minor,V.minor)||s(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var _=this.prerelease[J],pe=V.prerelease[J];if(O("prerelease compare",J,_,pe),_===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(_===void 0)return-1;if(_!==pe)return s(_,pe)}while(++J)},F.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,_,pe){typeof _=="string"&&(pe=_,_=void 0);try{return new F(V,_).inc(J,pe).version}catch{return null}},e.diff=function(V,J){if(B(V,J))return null;var _=Y(V),pe=Y(J);if(_.prerelease.length||pe.prerelease.length){for(var Ee in _)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&_[Ee]!==pe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in _)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&_[Ee]!==pe[Ee])return Ee},e.compareIdentifiers=s;var R=/^[0-9]+$/;function s(V,J){var _=R.test(V),pe=R.test(J);return _&&pe&&(V=+V,J=+J),_&&!pe?-1:pe&&!_?1:V<J?-1:V>J?1:0}function m(V,J,_){return new F(V,_).compare(new F(J,_))}function M(V,J,_){return m(V,J,_)>0}function x(V,J,_){return m(V,J,_)<0}function B(V,J,_){return m(V,J,_)===0}function Z(V,J,_){return m(V,J,_)!==0}function oe(V,J,_){return m(V,J,_)>=0}function he(V,J,_){return m(V,J,_)<=0}function me(V,J,_,pe){var Ee;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),Ee=V===_;break;case"!==":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),Ee=V!==_;break;case"":case"=":case"==":Ee=B(V,_,pe);break;case"!=":Ee=Z(V,_,pe);break;case">":Ee=M(V,_,pe);break;case">=":Ee=oe(V,_,pe);break;case"<":Ee=x(V,_,pe);break;case"<=":Ee=he(V,_,pe);break;default:throw new TypeError("Invalid operator: "+J)}return Ee}function ue(V,J){if(V instanceof ue){if(V.loose===J)return V;V=V.value}if(!(this instanceof ue))return new ue(V,J);O("comparator",V,J),this.loose=J,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(V,J){return s(J,V)},e.major=function(V,J){return new F(V,J).major},e.minor=function(V,J){return new F(V,J).minor},e.patch=function(V,J){return new F(V,J).patch},e.compare=m,e.compareLoose=function(V,J){return m(V,J,!0)},e.rcompare=function(V,J,_){return m(J,V,_)},e.sort=function(V,J){return V.sort(function(_,pe){return e.compare(_,pe,J)})},e.rsort=function(V,J){return V.sort(function(_,pe){return e.rcompare(_,pe,J)})},e.gt=M,e.lt=x,e.eq=B,e.neq=Z,e.gte=oe,e.lte=he,e.cmp=me,e.Comparator=ue;var ge={};function de(V,J){if(V instanceof de)return V.loose===J?V:new de(V.raw,J);if(V instanceof ue)return new de(V.value,J);if(!(this instanceof de))return new de(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ce(V){return!V||V.toLowerCase()==="x"||V==="*"}function ve(V,J,_,pe,Ee,Oe,Ie,Ae,Re,Ne,Fe,De,Te){return((J=ce(_)?"":ce(pe)?">="+_+".0.0":ce(Ee)?">="+_+"."+pe+".0":">="+J)+" "+(Ae=ce(Re)?"":ce(Ne)?"<"+(+Re+1)+".0.0":ce(Fe)?"<"+Re+"."+(+Ne+1)+".0":De?"<="+Re+"."+Ne+"."+Fe+"-"+De:"<="+Ae)).trim()}function Se(V,J){for(var _=0;_<V.length;_++)if(!V[_].test(J))return!1;if(J.prerelease.length){for(_=0;_<V.length;_++)if(O(V[_].semver),V[_].semver!==ge&&V[_].semver.prerelease.length>0){var pe=V[_].semver;if(pe.major===J.major&&pe.minor===J.minor&&pe.patch===J.patch)return!0}return!1}return!0}function Le(V,J,_){try{J=new de(J,_)}catch{return!1}return J.test(V)}function Ue(V,J,_,pe){var Ee,Oe,Ie,Ae,Re;switch(V=new F(V,pe),J=new de(J,pe),_){case">":Ee=M,Oe=he,Ie=x,Ae=">",Re=">=";break;case"<":Ee=x,Oe=oe,Ie=M,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(V,J,pe))return!1;for(var Ne=0;Ne<J.set.length;++Ne){var Fe=J.set[Ne],De=null,Te=null;if(Fe.forEach(function(Ce){Ce.semver===ge&&(Ce=new ue(">=0.0.0")),De=De||Ce,Te=Te||Ce,Ee(Ce.semver,De.semver,pe)?De=Ce:Ie(Ce.semver,Te.semver,pe)&&(Te=Ce)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Oe(V,Te.semver)||Te.operator===Re&&Ie(V,Te.semver))return!1}return!0}ue.prototype.parse=function(V){var J=this.loose?I[$]:I[W],_=V.match(J);if(!_)throw new TypeError("Invalid comparator: "+V);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new F(_[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(V){return O("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),me(V,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(V,J){if(!(V instanceof ue))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new de(V.value,J),Le(this.value,_,J);if(V.operator==="")return _=new de(this.value,J),Le(V.semver,_,J);var pe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Oe=this.semver.version===V.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ae=me(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Re=me(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return pe||Ee||Oe&&Ie||Ae||Re},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),O("range",V,J);var _=J?I[q]:I[U];V=V.replace(_,ve),O("hyphen replace",V),V=V.replace(I[z],"$1$2$3"),O("comparator trim",V,I[z]),V=(V=(V=V.replace(I[Q],"$1~")).replace(I[le],"$1^")).split(/\s+/).join(" ");var pe=J?I[$]:I[W],Ee=V.split(" ").map(function(Oe){return function(Ie,Ae){return O("comp",Ie),Ie=function(Re,Ne){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Te){O("caret",De,Te);var Ce=Te?I[ae]:I[fe];return De.replace(Ce,function(je,we,be,Pe,ke){var Me;return O("caret",De,je,we,be,Pe,ke),ce(we)?Me="":ce(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Pe)?Me=we==="0"?">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":">="+we+"."+be+".0 <"+(+we+1)+".0.0":ke?(O("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+ke+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+ke+" <"+(+we+1)+".0.0"):(O("no pr"),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+" <"+(+we+1)+".0.0"),O("caret return",Me),Me})}(Fe,Ne)}).join(" ")}(Ie,Ae),O("caret",Ie),Ie=function(Re,Ne){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Te){var Ce=Te?I[se]:I[ee];return De.replace(Ce,function(je,we,be,Pe,ke){var Me;return O("tilde",De,je,we,be,Pe,ke),ce(we)?Me="":ce(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Pe)?Me=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":ke?(O("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0"):Me=">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0",O("tilde return",Me),Me})}(Fe,Ne)}).join(" ")}(Ie,Ae),O("tildes",Ie),Ie=function(Re,Ne){return O("replaceXRanges",Re,Ne),Re.split(/\s+/).map(function(Fe){return function(De,Te){De=De.trim();var Ce=Te?I[D]:I[S];return De.replace(Ce,function(je,we,be,Pe,ke,Me){O("xRange",De,je,we,be,Pe,ke,Me);var We=ce(be),xe=We||ce(Pe),Ve=xe||ce(ke);return we==="="&&Ve&&(we=""),We?je=we===">"||we==="<"?"<0.0.0":"*":we&&Ve?(xe&&(Pe=0),Ve&&(ke=0),we===">"?(we=">=",xe?(be=+be+1,Pe=0,ke=0):Ve&&(Pe=+Pe+1,ke=0)):we==="<="&&(we="<",xe?be=+be+1:Pe=+Pe+1),je=we+be+"."+Pe+"."+ke):xe?je=">="+be+".0.0 <"+(+be+1)+".0.0":Ve&&(je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),O("xRange return",je),je})}(Fe,Ne)}).join(" ")}(Ie,Ae),O("xrange",Ie),Ie=function(Re,Ne){return O("replaceStars",Re,Ne),Re.trim().replace(I[H],"")}(Ie,Ae),O("stars",Ie),Ie}(Oe,J)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Oe){return!!Oe.match(pe)})),Ee=Ee.map(function(Oe){return new ue(Oe,J)})},de.prototype.intersects=function(V,J){if(!(V instanceof de))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(pe){return V.set.some(function(Ee){return Ee.every(function(Oe){return pe.intersects(Oe,J)})})})})},e.toComparators=function(V,J){return new de(V,J).set.map(function(_){return _.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var J=0;J<this.set.length;J++)if(Se(this.set[J],V))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(V,J,_){var pe=null,Ee=null;try{var Oe=new de(J,_)}catch{return null}return V.forEach(function(Ie){Oe.test(Ie)&&(pe&&Ee.compare(Ie)!==-1||(Ee=new F(pe=Ie,_)))}),pe},e.minSatisfying=function(V,J,_){var pe=null,Ee=null;try{var Oe=new de(J,_)}catch{return null}return V.forEach(function(Ie){Oe.test(Ie)&&(pe&&Ee.compare(Ie)!==1||(Ee=new F(pe=Ie,_)))}),pe},e.validRange=function(V,J){try{return new de(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,_){return Ue(V,J,"<",_)},e.gtr=function(V,J,_){return Ue(V,J,">",_)},e.outside=Ue,e.prerelease=function(V,J){var _=Y(V,J);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(V,J,_){return V=new de(V,_),J=new de(J,_),V.intersects(J)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var J=V.match(I[j]);return J==null?null:Y((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,T(1))},function(G,e){var T,A,O=G.exports={};function C(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(u){if(T===setTimeout)return setTimeout(u,0);if((T===C||!T)&&setTimeout)return T=setTimeout,setTimeout(u,0);try{return T(u,0)}catch{try{return T.call(null,u,0)}catch{return T.call(this,u,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:C}catch{T=C}try{A=typeof clearTimeout=="function"?clearTimeout:L}catch{A=L}})();var h,c=[],b=!1,E=-1;function y(){b&&h&&(b=!1,h.length?c=h.concat(c):E=-1,c.length&&v())}function v(){if(!b){var u=I(y);b=!0;for(var f=c.length;f;){for(h=c,c=[];++E<f;)h&&h[E].run();E=-1,f=c.length}h=null,b=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===L||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(u)}}function N(u,f){this.fun=u,this.array=f}function k(){}O.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];c.push(new N(u,f)),c.length!==1||b||I(v)},N.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=k,O.addListener=k,O.once=k,O.off=k,O.removeListener=k,O.removeAllListeners=k,O.emit=k,O.prependListener=k,O.prependOnceListener=k,O.listeners=function(u){return[]},O.binding=function(u){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(u){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ie[72],ne([0,1]),function(G,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(I,h,c){this.level=I,this.key=h,this.value=c,this.forward=[]}}const O=void 0;class C{constructor(I,h=2**16){this.comparator=I,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new A(this.c,O,O)}get size(){return this.f}clear(){this.e=new A(this.c,O,O)}has(I){return Boolean(C.g(this,I,this.comparator))}get(I){return C.g(this,I,this.comparator)?.value}set(I,h){return C.h(this,I,h,this.comparator)&&(this.f+=1),this}delete(I){const h=C.k(this,I,this.comparator);return h&&(this.f-=1),h}forEach(I,h){let c=this.e.forward[0];for(;c;)I.call(h,c.value,c.key,this),c=c.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this.e.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static g(I,h,c){let b=I.e;for(let E=I.d-1;E>=0;E--)for(;b.forward[E]&&c(b.forward[E].key,h)<0;)b=b.forward[E];if(b=b.forward[0],b&&c(b.key,h)===0)return b}static h(I,h,c,b){const E=[];let y=I.e;for(let v=I.d-1;v>=0;v--){for(;y.forward[v]&&b(y.forward[v].key,h)<0;)y=y.forward[v];E[v]=y}if(y=y.forward[0],y&&b(y.key,h)===0)return y.value=c,!1;{const v=C.j(I);if(v>I.d){for(let N=I.d;N<v;N++)E[N]=I.e;I.d=v}y=new A(v,h,c);for(let N=0;N<v;N++)y.forward[N]=E[N].forward[N],E[N].forward[N]=y;return!0}}static j(I,h=.5){let c=1;for(;Math.random()<h&&c<I.c;)c+=1;return c}static k(I,h,c){const b=[];let E=I.e;for(let y=I.d-1;y>=0;y--){for(;E.forward[y]&&c(E.forward[y].key,h)<0;)E=E.forward[y];b[y]=E}if(E=E.forward[0],!E||c(E.key,h)!==0)return!1;for(let y=0;y<I.d&&b[y].forward[y]===E;y++)b[y].forward[y]=E.forward[y];for(;I.d>0&&I.e.forward[I.d-1]===O;)I.d-=1;return!0}}e.SkipList=C}),define(ie[44],ne([0,1,9,2]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function O(g){const P=g;return P?typeof P.read=="function":!1}e.isReadable=O;function C(g){const P=g;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function L(g){const P=g;return P?C(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.isReadableBufferedStream=L;function I(g,P){return new h(g,P)}e.newWriteableStream=I;class h{constructor(P,t){this.e=P,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(t=>t(P))}h(P){this.c.error.length===0?(0,T.onUnexpectedError)(P):this.c.error.slice(0).forEach(t=>t(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,t){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(P,t){if(this.a.destroyed)return;let a;switch(P){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(t);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,P){const t=[];let a;for(;(a=g.read())!==null;)t.push(a);return P(t)}e.consumeReadable=c;function b(g,P,t){const a=[];let n;for(;(n=g.read())!==null&&a.length<t;)a.push(n);return n===null&&a.length>0?P(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return g.read()}}}e.peekReadable=b;function E(g,P){return new Promise((t,a)=>{const n=[];y(g,{onData:i=>{P&&n.push(i)},onError:i=>{P?a(i):t(void 0)},onEnd:()=>{t(P?P(n):void 0)}})})}e.consumeStream=E;function y(g,P){let t=!1;return g.on("error",a=>{t||P.onError(a)}),g.on("end",()=>{t||P.onEnd()}),g.on("data",a=>{t||P.onData(a)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=y;function v(g,P){return new Promise((t,a)=>{const n=new A.DisposableStore,i=[],r=d=>{if(i.push(d),i.length>P)return n.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},o=d=>a(d),l=()=>t({stream:g,buffer:i,ended:!0});n.add((0,A.toDisposable)(()=>g.removeListener("error",o))),g.on("error",o),n.add((0,A.toDisposable)(()=>g.removeListener("end",l))),g.on("end",l),n.add((0,A.toDisposable)(()=>g.removeListener("data",r))),g.on("data",r)})}e.peekStream=v;function N(g,P){const t=I(P);return t.end(g),t}e.toStream=N;function k(){const g=I(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=k;function u(g){let P=!1;return{read:()=>P?null:(P=!0,g)}}e.toReadable=u;function f(g,P,t){const a=I(t);return y(g,{onData:n=>a.write(P.data(n)),onError:n=>a.error(P.error?P.error(n):n),onEnd:()=>a.end()}),a}e.transform=f;function p(g,P,t){let a=!1;return{read:()=>{const n=P.read();return a?n:(a=!0,n!==null?t([g,n]):g)}}}e.prefixedReadable=p;function w(g,P,t){let a=!1;const n=I(t);return y(P,{onData:i=>a?n.write(i):(a=!0,n.write(t([g,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(g)),n.end()}}),n}e.prefixedStream=w}),define(ie[14],ne([0,1,44]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let O,C;class L{static alloc(d){return A?new L(Buffer.allocUnsafe(d)):new L(new Uint8Array(d))}static wrap(d){return A&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new L(d)}static fromString(d,S){return!(S?.dontUseNodeBuffer||!1)&&A?new L(Buffer.from(d)):(O||(O=new TextEncoder),new L(O.encode(d)))}static fromByteArray(d){const S=L.alloc(d.length);for(let D=0,j=d.length;D<j;D++)S.buffer[D]=d[D];return S}static concat(d,S){if(typeof S>"u"){S=0;for(let K=0,Q=d.length;K<Q;K++)S+=d[K].byteLength}const D=L.alloc(S);let j=0;for(let K=0,Q=d.length;K<Q;K++){const ee=d[K];D.set(ee,j),j+=ee.byteLength}return D}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=L.alloc(this.byteLength);return d.set(this),d}toString(){return A?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,S){return new L(this.buffer.subarray(d,S))}set(d,S){if(d instanceof L)this.buffer.set(d.buffer,S);else if(d instanceof Uint8Array)this.buffer.set(d,S);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),S);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return c(this.buffer,d)}writeUInt32BE(d,S){b(this.buffer,d,S)}readUInt32LE(d){return E(this.buffer,d)}writeUInt32LE(d,S){y(this.buffer,d,S)}readUInt8(d){return v(this.buffer,d)}writeUInt8(d,S){N(this.buffer,d,S)}}e.VSBuffer=L;function I(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0}e.readUInt16LE=I;function h(l,d,S){l[S+0]=d&255,d=d>>>8,l[S+1]=d&255}e.writeUInt16LE=h;function c(l,d){return l[d]*2**24+l[d+1]*2**16+l[d+2]*2**8+l[d+3]}e.readUInt32BE=c;function b(l,d,S){l[S+3]=d,d=d>>>8,l[S+2]=d,d=d>>>8,l[S+1]=d,d=d>>>8,l[S]=d}e.writeUInt32BE=b;function E(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0|l[d+2]<<16>>>0|l[d+3]<<24>>>0}e.readUInt32LE=E;function y(l,d,S){l[S+0]=d&255,d=d>>>8,l[S+1]=d&255,d=d>>>8,l[S+2]=d&255,d=d>>>8,l[S+3]=d&255}e.writeUInt32LE=y;function v(l,d){return l[d]}e.readUInt8=v;function N(l,d,S){l[S]=d}e.writeUInt8=N;function k(l){return T.consumeReadable(l,d=>L.concat(d))}e.readableToBuffer=k;function u(l){return T.toReadable(l)}e.bufferToReadable=u;function f(l){return T.consumeStream(l,d=>L.concat(d))}e.streamToBuffer=f;async function p(l){return l.ended?L.concat(l.buffer):L.concat([...l.buffer,await f(l.stream)])}e.bufferedStreamToBuffer=p;function w(l){return T.toStream(l,d=>L.concat(d))}e.bufferToStream=w;function g(l){return T.transform(l,{data:d=>typeof d=="string"?L.fromString(d):L.wrap(d)},d=>L.concat(d))}e.streamToBufferReadableStream=g;function P(l){return T.newWriteableStream(d=>L.concat(d),l)}e.newWriteableBufferStream=P;function t(l,d){return T.prefixedReadable(l,d,S=>L.concat(S))}e.prefixedBufferReadable=t;function a(l,d){return T.prefixedStream(l,d,S=>L.concat(S))}e.prefixedBufferStream=a;function n(l){let d=0,S=0,D=0;const j=new Uint8Array(Math.floor(l.length/4*3)),K=ee=>{switch(S){case 3:j[D++]=d|ee,S=0;break;case 2:j[D++]=d|ee>>>2,d=ee<<6,S=3;break;case 1:j[D++]=d|ee>>>4,d=ee<<4,S=2;break;default:d=ee<<2,S=1}};for(let ee=0;ee<l.length;ee++){const se=l.charCodeAt(ee);if(se>=65&&se<=90)K(se-65);else if(se>=97&&se<=122)K(se-97+26);else if(se>=48&&se<=57)K(se-48+52);else if(se===43||se===45)K(62);else if(se===47||se===95)K(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const Q=D;for(;S>0;)K(0);return L.wrap(j).slice(0,Q)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},d=!0,S=!1){const D=S?r:i;let j="";const K=l.byteLength%3;let Q=0;for(;Q<l.byteLength-K;Q+=3){const ee=l[Q+0],se=l[Q+1],re=l[Q+2];j+=D[ee>>>2],j+=D[(ee<<4|se>>>4)&63],j+=D[(se<<2|re>>>6)&63],j+=D[re&63]}if(K===1){const ee=l[Q+0];j+=D[ee>>>2],j+=D[ee<<4&63],d&&(j+="==")}else if(K===2){const ee=l[Q+0],se=l[Q+1];j+=D[ee>>>2],j+=D[(ee<<4|se>>>4)&63],j+=D[se<<2&63],d&&(j+="=")}return j}e.encodeBase64=o}),define(ie[30],ne([0,1,3]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([w,g])=>{p[w]=g&&typeof g=="object"?A(g):g}),p}e.deepClone=A;function O(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const g in w)if(C.call(w,g)){const P=w[g];typeof P=="object"&&!Object.isFrozen(P)&&!(0,T.isTypedArray)(P)&&p.push(P)}}return f}e.deepFreeze=O;const C=Object.prototype.hasOwnProperty;function L(f,p){return I(f,p,new Set)}e.cloneAndChange=L;function I(f,p,w){if((0,T.isUndefinedOrNull)(f))return f;const g=p(f);if(typeof g<"u")return g;if(Array.isArray(f)){const P=[];for(const t of f)P.push(I(t,p,w));return P}if((0,T.isObject)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const P={};for(const t in f)C.call(f,t)&&(P[t]=I(f[t],p,w));return w.delete(f),P}return f}function h(f,p,w=!0){return(0,T.isObject)(f)?((0,T.isObject)(p)&&Object.keys(p).forEach(g=>{g in f?w&&((0,T.isObject)(f[g])&&(0,T.isObject)(p[g])?h(f[g],p[g],w):f[g]=p[g]):f[g]=p[g]}),f):p}e.mixin=h;function c(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let w,g;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(w=0;w<f.length;w++)if(!c(f[w],p[w]))return!1}else{const P=[];for(g in f)P.push(g);P.sort();const t=[];for(g in p)t.push(g);if(t.sort(),!c(P,t))return!1;for(w=0;w<P.length;w++)if(!c(f[P[w]],p[P[w]]))return!1}return!0}e.equals=c;function b(f){const p=new Set;return JSON.stringify(f,(w,g)=>{if((0,T.isObject)(g)||Array.isArray(g)){if(p.has(g))return"[Circular]";p.add(g)}return g})}e.safeStringify=b;function E(f,p){const w=Object.create(null);return!f||!p||Object.keys(p).forEach(P=>{const t=f[P],a=p[P];c(t,a)||(w[P]=a)}),w}e.distinct=E;function y(f,p){const w=p.toLowerCase(),g=Object.keys(f).find(P=>P.toLowerCase()===w);return g?f[g]:f[p]}e.getCaseInsensitive=y;function v(f,p){const w=Object.create(null);for(const[g,P]of Object.entries(f))p(g,P)&&(w[g]=P);return w}e.filter=v;function N(f){let p=[],w=Object.getPrototypeOf(f);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=N;function k(f){const p=[];for(const w of N(f))typeof f[w]=="function"&&p.push(w);return p}e.getAllMethodNames=k;function u(f,p){const w=P=>function(){const t=Array.prototype.slice.call(arguments,0);return p(P,t)},g={};for(const P of f)g[P]=w(P);return g}e.createProxyObject=u}),define(ie[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(O){return T.test(O)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const C=new Uint8Array(16),L=[];for(let I=0;I<256;I++)L.push(I.toString(16).padStart(2,"0"));return function(){O(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let h=0,c="";return c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c+="-",c+=L[C[h++]],c+=L[C[h++]],c+="-",c+=L[C[h++]],c+=L[C[h++]],c+="-",c+=L[C[h++]],c+=L[C[h++]],c+="-",c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c+=L[C[h++]],c}}()}),define(ie[73],ne([0,1,33]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(L){const I=L.replace(/\-/g,":").toLowerCase();return!A.has(I)}function C(){const L=(0,T.networkInterfaces)();for(const I in L){const h=L[I];if(h){for(const{mac:c}of h)if(O(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ie[74],ne([7,4]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[75],ne([0,1,74]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,O=A*60,C=O*24,L=C*7,I=C*30,h=C*365;function c(E,y,v,N){typeof E!="number"&&(E=E.getTime());const k=Math.round((new Date().getTime()-E)/1e3);if(k<-30)return(0,T.localize)(0,null,c(new Date().getTime()+k*1e3,!1));if(!N&&k<30)return(0,T.localize)(1,null);let u;return k<A?(u=k,y?u===1?v?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):v?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u):u===1?v?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):v?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):k<O?(u=Math.floor(k/A),y?u===1?v?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):v?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u):u===1?v?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):v?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):k<C?(u=Math.floor(k/O),y?u===1?v?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):v?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u):u===1?v?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):v?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):k<L?(u=Math.floor(k/C),y?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u)):k<I?(u=Math.floor(k/L),y?u===1?v?(0,T.localize)(30,null,u):(0,T.localize)(31,null,u):v?(0,T.localize)(32,null,u):(0,T.localize)(33,null,u):u===1?v?(0,T.localize)(34,null,u):(0,T.localize)(35,null,u):v?(0,T.localize)(36,null,u):(0,T.localize)(37,null,u)):k<h?(u=Math.floor(k/I),y?u===1?v?(0,T.localize)(38,null,u):(0,T.localize)(39,null,u):v?(0,T.localize)(40,null,u):(0,T.localize)(41,null,u):u===1?v?(0,T.localize)(42,null,u):(0,T.localize)(43,null,u):v?(0,T.localize)(44,null,u):(0,T.localize)(45,null,u)):(u=Math.floor(k/h),y?u===1?v?(0,T.localize)(46,null,u):(0,T.localize)(47,null,u):v?(0,T.localize)(48,null,u):(0,T.localize)(49,null,u):u===1?v?(0,T.localize)(50,null,u):(0,T.localize)(51,null,u):v?(0,T.localize)(52,null,u):(0,T.localize)(53,null,u))}e.fromNow=c;function b(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ie[76],ne([7,4]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,76]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(E,y){return y&&(E.stack||E.stacktrace)?O.localize(0,null,I(E),L(E.stack)||L(E.stacktrace)):I(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?O.localize(1,null,E.message):E.message||O.localize(2,null)}function h(E=null,y=!1){if(!E)return O.localize(3,null);if(Array.isArray(E)){const v=T.coalesce(E),N=h(v[0],y);return v.length>1?O.localize(4,null,N,v.length):N}if(A.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return C(v.error,y);if(v.exception)return C(v.exception,y)}return E.stack?C(E,y):E.message?E.message:O.localize(5,null)}e.toErrorMessage=h;function c(E){const y=E;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=c;function b(E,y){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=y,v}e.createErrorWithActions=b}),define(ie[77],ne([7,4]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[78],ne([0,1,77]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(O){switch(O){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ie[52],ne([0,1,12]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var O;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(O=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(I,...h){const c=h.reduce((y,v)=>(y[v]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!c[y]).forEach(y=>{for(let v=0;v<b.length;v++)if(y.search(b[v])!==-1){delete I[y];break}})}e.sanitizeProcessEnvironment=C;function L(I){!I||(delete I.DEBUG,T.isMacintosh&&delete I.DYLD_LIBRARY_PATH,T.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(ie[45],ne([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(f){return O(f,0)}e.hash=A;function O(f,p){switch(typeof f){case"object":return f===null?C(349,p):Array.isArray(f)?h(f,p):c(f,p);case"string":return I(f,p);case"boolean":return L(f,p);case"number":return C(f,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=O;function C(f,p){return(p<<5)-p+f|0}e.numberHash=C;function L(f,p){return C(f?433:863,p)}function I(f,p){p=C(149417,p);for(let w=0,g=f.length;w<g;w++)p=C(f.charCodeAt(w),p);return p}e.stringHash=I;function h(f,p){return p=C(104579,p),f.reduce((w,g)=>O(g,w),p)}function c(f,p){return p=C(181387,p),Object.keys(f).sort().reduce((w,g)=>(w=I(g,w),O(f[g],w)),p)}class b{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=O(p,this.g),this.g}}e.Hasher=b;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function y(f,p,w=32){const g=w-p,P=~((1<<g)-1);return(f<<p|(P&f)>>>g)>>>0}function v(f,p=0,w=f.byteLength,g=0){for(let P=0;P<w;P++)f[p+P]=g}function N(f,p,w="0"){for(;f.length<p;)f=w+f;return f}function k(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(w=>w.toString(16).padStart(2,"0")).join(""):N((f>>>0).toString(16),p/4)}e.toHexString=k;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const w=p.length;if(w===0)return;const g=this.p;let P=this.r,t=this.u,a,n;for(t!==0?(a=t,n=-1,t=0):(a=p.charCodeAt(0),n=0);;){let i=a;if(T.isHighSurrogate(a))if(n+1<w){const r=p.charCodeAt(n+1);T.isLowSurrogate(r)?(n++,i=T.computeCodePoint(a,r)):i=65533}else{t=a;break}else T.isLowSurrogate(a)&&(i=65533);if(P=this.w(g,P,i),n++,n<w)a=p.charCodeAt(n);else break}this.r=P,this.u=t}w(p,w,g){return g<128?p[w++]=g:g<2048?(p[w++]=192|(g&1984)>>>6,p[w++]=128|(g&63)>>>0):g<65536?(p[w++]=224|(g&61440)>>>12,p[w++]=128|(g&4032)>>>6,p[w++]=128|(g&63)>>>0):(p[w++]=240|(g&1835008)>>>18,p[w++]=128|(g&258048)>>>12,p[w++]=128|(g&4032)>>>6,p[w++]=128|(g&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=u.g,w=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,w.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,y(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let g=this.h,P=this.l,t=this.m,a=this.n,n=this.o,i,r,o;for(let l=0;l<80;l++)l<20?(i=P&t|~P&a,r=1518500249):l<40?(i=P^t^a,r=1859775393):l<60?(i=P&t|P&a|t&a,r=2400959708):(i=P^t^a,r=3395469782),o=y(g,5)+i+n+r+p.getUint32(l*4,!1)&4294967295,n=a,a=t,t=y(P,30),P=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+P&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(ie[53],ne([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(A||(A={})),function(O){const C="error",L="warning",I="warn",h="info",c="ignore";function b(y){return y?T.equalsIgnoreCase(C,y)?O.Error:T.equalsIgnoreCase(L,y)||T.equalsIgnoreCase(I,y)?O.Warning:T.equalsIgnoreCase(h,y)?O.Info:O.Ignore:O.Ignore}O.fromValue=b;function E(y){switch(y){case O.Error:return C;case O.Warning:return L;case O.Info:return h;default:return c}}O.toString=E}(A||(A={})),e.default=A}),define(ie[79],ne([0,1,11]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=A;function O(c){const b=[];let E;try{const y=JSON.parse(c.arguments),v=y[y.length-1];v&&v.__$stack&&(y.pop(),E=v.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:E}}e.parse=O;function C(c){if(typeof c!="string")return C(O(c).stack);const b=c;if(b){const E=L(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(y&&y.length===4)return{uri:T.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=C;function L(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function I(c,b){const{args:E,stack:y}=O(c),v=typeof E[0]=="string"&&E.length===1;let N=L(y);N&&(N=`(${N.trim()})`);let k=[];if(typeof E[0]=="string"?N&&v?k=[`%c[${b}] %c${E[0]} %c${N}`,h("blue"),h(""),h("grey")]:k=[`%c[${b}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:k=[`%c[${b}]%`,h("blue"),...E],N&&!v&&k.push(N),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,k)}e.log=I;function h(c){return`color: ${c}`}}),define(ie[54],ne([0,1,14,29,11]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(c){return JSON.stringify(c,I)}e.stringify=C;function L(c){let b=JSON.parse(c);return b=h(b),b}e.parse=L;function I(c,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,A.regExpFlags)(b)}:b}function h(c,b=0){if(!c||b>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return O.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof T.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=h(c[E],b+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=h(c[E],b+1))}return c}e.revive=h}),define(ie[80],ne([0,1,33,9,55,28,73]),function(G,e,T,A,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=O.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,E=0;const y=(0,T.networkInterfaces)();for(const v in y){const N=y[v];if(N)for(const{mac:k,internal:u}of N)u||(E+=1,this.c(k.toUpperCase())&&(b+=1))}this.b=E>0?b/E:0}return this.b}};let I;async function h(){return I||(I=(async()=>await c()||C.generateUuid())()),I}e.getMachineId=h;async function c(){try{const b=await new Promise((y,v)=>{G(["crypto"],y,v)}),E=(0,L.getMac)();return b.createHash("sha256").update(E,"utf8").digest("hex")}catch(b){A.onUnexpectedError(b);return}}}),define(ie[81],ne([0,1,33,15,20]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class E{constructor(P,t,a){this.exePath=P,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await O.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:g=!1,findPreview:P=!1}={}){const t=y({useAlternateBitness:g});if(!t)return null;const a=A.join(t,"PowerShell");if(!await O.SymlinkSupport.existsDirectory(a))return null;let n=-1,i=null;for(const l of await O.Promises.readdir(a)){let d=-1;if(P){const D=l.indexOf("-");if(D<0)continue;const j=l.substring(0,D);if(!C.test(j)||l.substring(D+1)!=="preview")continue;d=parseInt(j,10)}else{if(!C.test(l))continue;d=parseInt(l,10)}if(d<=n)continue;const S=A.join(a,l,"pwsh.exe");!await O.SymlinkSupport.existsFile(S)||(i=S,n=d)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",o=P?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function N({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const P=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await O.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=g?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await O.Promises.readdir(P))if(t.test(n)){const i=A.join(P,n,"pwsh.exe");return new E(i,a)}return null}function k(){const g=A.join(T.homedir(),".dotnet","tools","pwsh.exe");return new E(g,".NET Core PowerShell Global Tool")}function u(){const g=A.join(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(g,"Windows PowerShell",!0)}async function*f(){let g=await v();g&&(yield g),g=await v({useAlternateBitness:!0}),g&&(yield g),g=await N(),g&&(yield g),g=k(),g&&(yield g),g=await v({findPreview:!0}),g&&(yield g),g=await N({findPreview:!0}),g&&(yield g),g=await v({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=u(),g&&(yield g)}async function*p(){for await(const g of f())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=p;async function w(){for await(const g of p())return g;return null}e.getFirstAvailablePowerShellInstallation=w}),define(ie[56],ne([0,1,15,12,35,52,3,20]),function(G,e,T,A,O,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(E=O.env){return E.comspec||"cmd.exe"}e.getWindowsShell=h;function c(E){let y=[],v=!1;const N=function(k){if(v){y.push(k);return}(!E.send(k,f=>{if(f&&console.error(f),v=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(w=>N(w))}})||A.isWindows)&&(v=!0)};return{send:N}}e.createQueuedSender=c;var b;(function(E){async function y(v,N,k){if(T.isAbsolute(v))return v;if(N===void 0&&(N=O.cwd()),T.dirname(v)!=="."||(k===void 0&&L.isString(O.env.PATH)&&(k=O.env.PATH.split(T.delimiter)),k===void 0||k.length===0))return T.join(N,v);async function f(p){if(await I.Promises.exists(p)){let w;try{w=await I.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(w=await I.Promises.lstat(p))}return w?!w.isDirectory():!1}return!1}for(const p of k){let w;if(T.isAbsolute(p)?w=T.join(p,v):w=T.join(N,p,v),await f(w))return w;let g=w+".com";if(await f(g)||(g=w+".exe",await f(g)))return g}return T.join(N,v)}E.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ie[82],ne([0,1,33,12,81,56]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function L(E,y){return E===1?A.isWindows?b():C.getWindowsShell(y):h(E,y)}e.getSystemShell=L;let I=null;function h(E,y){if(A.isLinux&&E===2||A.isMacintosh&&E===3)return"/bin/bash";if(!I){let v;if(A.isWindows)v="/bin/bash";else{if(v=y.SHELL,!v)try{v=(0,T.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let c=null;async function b(){return c||(c=(await(0,O.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ye=this&&this.__decorate||function(G,e,T,A){var O=arguments.length,C=O<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,T):A,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(G,e,T,A);else for(var I=G.length-1;I>=0;I--)(L=G[I])&&(C=(O<3?L(C):O>3?L(e,T,C):L(e,T))||C);return O>3&&C&&Object.defineProperty(e,T,C),C};define(ie[57],ne([0,1,19,8,14,23,50,9,5,2,54,29,3]),function(G,e,T,A,O,C,L,I,h,c,b,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var v;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(v||(v={}));function N(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(k||(k={}));function u(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function p(z){let U=0;for(let q=0;;q+=7){const H=z.read(1);if(U|=(H.buffer[0]&127)<<q,!(H.buffer[0]&128))return U}}const w=n(0);function g(z,U){if(U===0){z.write(w);return}let q=0;for(let X=U;X!==0;X=X>>>7)q++;const H=O.VSBuffer.alloc(q);for(let X=0;U!==0;X++)H.buffer[X]=U&127,U=U>>>7,U>0&&(H.buffer[X]|=128);z.write(H)}class P{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.BufferReader=P;class t{constructor(){this.a=[]}get buffer(){return O.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var a;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(a||(a={}));function n(z){const U=O.VSBuffer.alloc(1);return U.writeUInt8(z,0),U}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},r=typeof Buffer<"u";function o(z,U){if(typeof U>"u")z.write(i.Undefined);else if(typeof U=="string"){const q=O.VSBuffer.fromString(U);z.write(i.String),g(z,q.byteLength),z.write(q)}else if(r&&Buffer.isBuffer(U)){const q=O.VSBuffer.wrap(U);z.write(i.Buffer),g(z,q.byteLength),z.write(q)}else if(U instanceof O.VSBuffer)z.write(i.VSBuffer),g(z,U.byteLength),z.write(U);else if(Array.isArray(U)){z.write(i.Array),g(z,U.length);for(const q of U)o(z,q)}else if(typeof U=="number"&&(U|0)===U)z.write(i.Uint),g(z,U);else{const q=O.VSBuffer.fromString(JSON.stringify(U));z.write(i.Object),g(z,q.byteLength),z.write(q)}}e.serialize=o;function l(z){switch(z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return z.read(p(z)).toString();case a.Buffer:return z.read(p(z)).buffer;case a.VSBuffer:return z.read(p(z));case a.Array:{const q=p(z),H=[];for(let X=0;X<q;X++)H.push(l(z));return H}case a.Object:return JSON.parse(z.read(p(z)).toString());case a.Int:return p(z)}}e.deserialize=l;class d{constructor(U,q,H=null,X=1e3){this.h=U,this.j=q,this.k=H,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,u(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,u(U.type),U.data);return}}}o(U,q=void 0){const H=new t;return o(H,U),o(H,q),this.p(H.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new P(U),H=l(q),X=l(q),Y=H[0];switch(Y){case 100:return this.k?.logIncoming(U.byteLength,H[1],1,`${N(Y)}: ${H[2]}.${H[3]}`,X),this.s({type:Y,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.k?.logIncoming(U.byteLength,H[1],1,`${N(Y)}: ${H[2]}.${H[3]}`,X),this.t({type:Y,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.k?.logIncoming(U.byteLength,H[1],1,`${N(Y)}`),this.u({type:Y,id:H[1]});case 103:return this.k?.logIncoming(U.byteLength,H[1],1,`${N(Y)}`),this.u({type:Y,id:H[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const H=new C.CancellationTokenSource;let X;try{X=q.call(this.j,U.name,U.arg,H.token)}catch(R){X=Promise.reject(R)}const Y=U.id;X.then(R=>{this.m({id:Y,data:R,type:201}),this.d.delete(U.id)},R=>{R instanceof Error?this.m({id:Y,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:Y,data:R,type:203}),this.d.delete(U.id)});const F=(0,c.toDisposable)(()=>H.cancel());this.d.set(U.id,F)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const H=U.id,Y=q.listen(this.j,U.name,U.arg)(F=>this.m({id:H,data:F,type:204}));this.d.set(U.id,Y)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const H=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:H})}w(U){const q=this.g.get(U);if(q){for(const H of q)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=d;var S;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(U,q=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=q}getChannel(U){const q=this;return{call(H,X,Y){return q.a?Promise.reject(new I.CancellationError):q.m(U,H,X,Y)},listen(H,X){return q.a?h.Event.None:q.o(U,H,X)}}}m(U,q,H,X=C.CancellationToken.None){const Y=this.g++,R={id:Y,type:100,channelName:U,name:q,arg:H};if(X.isCancellationRequested)return Promise.reject(new I.CancellationError);let s;return new Promise((M,x)=>{if(X.isCancellationRequested)return x(new I.CancellationError);const B=()=>{const me=ue=>{switch(ue.type){case 201:this.f.delete(Y),M(ue.data);break;case 202:{this.f.delete(Y);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(Y),x(ue.data);break}};this.f.set(Y,me),this.p(R)};let Z=null;this.b===f.Idle?B():(Z=(0,A.createCancelablePromise)(me=>this.u()),Z.then(()=>{Z=null,B()}));const oe=()=>{Z?(Z.cancel(),Z=null):this.p({id:Y,type:101}),x(new I.CancellationError)},he=X.onCancellationRequested(oe);s=(0,c.combinedDisposable)((0,c.toDisposable)(oe),he),this.d.add(s)}).finally(()=>{this.d.delete(s)})}o(U,q,H){const X=this.g++,F={id:X,type:102,channelName:U,name:q,arg:H};let R=null;const s=new h.Emitter({onWillAddFirstListener:()=>{R=(0,A.createCancelablePromise)(M=>this.u()),R.then(()=>{R=null,this.d.add(s),this.p(F)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(s),this.p({id:X,type:103}))}}),m=M=>s.fire(M.data);return this.f.set(X,m),s.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${N(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,N(U.type));return}}}q(U,q=void 0){const H=new t;return o(H,U),o(H,q),this.r(H.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new P(U),H=l(q),X=l(q),Y=H[0];switch(Y){case 200:return this.j?.logIncoming(U.byteLength,0,0,u(Y)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,H[1],0,u(Y),X),this.t({type:H[0],id:H[1],data:X})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}ye([L.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class j{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:q,onDidClientDisconnect:H})=>{h.Event.once(q.onMessage)(Y=>{const F=new P(Y),R=l(F),s=new d(q,R),m=new D(q);this.a.forEach((x,B)=>s.registerChannel(B,x));const M={channelServer:s,channelClient:m,ctx:R};this.f.add(M),this.g.fire(M),H(()=>{s.dispose(),m.dispose(),this.f.delete(M),this.h.fire(M)})})})}getChannel(U,q){const H=this;return{call(X,Y,F){let R;if((0,y.isFunction)(q)){const m=(0,T.getRandomElement)(H.connections.filter(q));R=m?Promise.resolve(m):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,q))}else R=q.routeCall(H,X,Y);const s=R.then(m=>m.channelClient.getChannel(U));return Q(s).call(X,Y,F)},listen(X,Y){if((0,y.isFunction)(q))return H.j(U,q,X,Y);const F=q.routeEvent(H,X,Y).then(R=>R.channelClient.getChannel(U));return Q(F).listen(X,Y)}}}j(U,q,H,X){const Y=this;let F=new c.DisposableStore;const R=new h.Emitter({onWillAddFirstListener:()=>{F=new c.DisposableStore;const s=new h.EventMultiplexer,m=new Map,M=B=>{const oe=B.channelClient.getChannel(U).listen(H,X),he=s.add(oe);m.set(B,he)},x=B=>{const Z=m.get(B);!Z||(Z.dispose(),m.delete(B))};Y.connections.filter(q).forEach(M),h.Event.filter(Y.onDidAddConnection,q)(M,void 0,F),Y.onDidRemoveConnection(x,void 0,F),s.event(R.fire,R,F),F.add(s)},onDidRemoveLastListener:()=>{F.dispose()}});return R.event}registerChannel(U,q){this.a.set(U,q),this.f.forEach(H=>{H.channelServer.registerChannel(U,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class K{constructor(U,q,H=null){const X=new t;o(X,q),U.send(X.buffer),this.a=new D(U,H),this.d=new d(U,q,H)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=K;function Q(z){return{call(U,q,H){return z.then(X=>X.call(U,q,H))},listen(U,q){const H=new h.Relay;return z.then(X=>H.input=X.listen(U,q)),H.event}}}e.getDelayedChannel=Q;function ee(z){let U=!1;return{call(q,H,X){return U?z.call(q,H,X):(0,A.timeout)(0).then(()=>U=!0).then(()=>z.call(q,H,X))},listen(q,H){if(U)return z.listen(q,H);const X=new h.Relay;return(0,A.timeout)(0).then(()=>U=!0).then(()=>X.input=z.listen(q,H)),X.event}}}e.getNextTickChannel=ee;class se{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=se;var re;(function(z){function U(Y,F){const R=Y,s=F&&F.disableMarshalling,m=new Map;for(const M in R)H(M)&&m.set(M,h.Event.buffer(R[M],!0));return new class{listen(M,x,B){const Z=m.get(x);if(Z)return Z;if(X(x)){const oe=R[x];if(typeof oe=="function")return oe.call(R,B)}throw new Error(`Event not found: ${x}`)}call(M,x,B){const Z=R[x];if(typeof Z=="function"){if(!s&&Array.isArray(B))for(let oe=0;oe<B.length;oe++)B[oe]=(0,b.revive)(B[oe]);return Z.apply(R,B)}throw new Error(`Method not found: ${x}`)}}}z.fromService=U;function q(Y,F){const R=F&&F.disableMarshalling;return new Proxy({},{get(s,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):X(m)?function(M){return Y.listen(m,M)}:H(m)?Y.listen(m):async function(...M){let x;F&&!(0,y.isUndefinedOrNull)(F.context)?x=[F.context,...M]:x=M;const B=await Y.call(m,x);return R?B:(0,b.revive)(B)};throw new Error(`Property not found: ${String(m)}`)}})}z.toService=q;function H(Y){return Y[0]==="o"&&Y[1]==="n"&&E.isUpperAsciiLetter(Y.charCodeAt(2))}function X(Y){return/^onDynamic/.test(Y)&&E.isUpperAsciiLetter(Y.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const U=z.toString();if(U!=="[object Object]")return U}return z}function ae(z){return Array.isArray(z)?z.map(fe):fe(z)}function $(z,U,q,H,X,Y,F){F=ae(F);const R=le[X],s=R[H%R.length];let m=[`%c[${z}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(Y)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class W{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,H,X,Y){this.b+=U,$(this.d,this.b,U,q,H,X,Y)}logIncoming(U,q,H,X,Y){this.a+=U,$(this.f,this.a,U,q,H,X,Y)}}e.IPCLogger=W}),define(ie[83],ne([0,1,58,8,14,23,79,9,5,2,30,56,52,57]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class N extends v.ChannelServer{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>O.VSBuffer.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=N;class k{constructor(f,p){this.i=f,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const w=p&&p.timeout?p.timeout:6e4;this.b=new A.Delayer(w),this.d=null,this.f=null}getChannel(f){const p=this;return{call(w,g,P){return p.k(f,w,g,P)},listen(w,g){return p.l(f,w,g)}}}k(f,p,w,g=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const P=this.n(f),t=(0,A.createCancelablePromise)(i=>P.call(p,w,i)),a=g.onCancellationRequested(()=>t.cancel()),n=(0,c.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,p,w){if(!this.b)return h.Event.None;this.b.cancel();let g;const P=new h.Emitter({onWillAddFirstListener:()=>{g=this.n(f).listen(p,w)(P.fire,P),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(p.env),this.d=(0,T.fork)(this.i,f,p);const w=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,L.isRemoteConsoleLog)(r)){(0,L.log)(r,`IPC Library: ${this.j.serverName}`);return}w.fire(O.VSBuffer.wrap(Buffer.from(r,"base64")))});const P=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&P.send(r.buffer.toString("base64")),a=w.event,n={send:t,onMessage:a};this.f=new v.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.dispose)(l)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let p=this.g.get(f);return p||(p=this.m.getChannel(f),this.g.set(f,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=k}),define(ie[84],ne([0,1,8,5,2,3]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L=e.StorageHint||(e.StorageHint={}));function I(E){const y=E;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var h;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class c extends O.Disposable{constructor(y,v=Object.create(null)){super(),this.m=y,this.n=v,this.b=this.D(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new T.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(y=>this.q(y)))}q(y){y.changed?.forEach((v,N)=>this.r(N,v)),y.deleted?.forEach(v=>this.r(v,void 0))}r(y,v){if(this.c===h.Closed)return;let N=!1;(0,C.isUndefinedOrNull)(v)?N=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),N=!0),N&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,v){const N=this.f.get(y);return(0,C.isUndefinedOrNull)(N)?v:N}getBoolean(y,v){const N=this.get(y);return(0,C.isUndefinedOrNull)(N)?v:N==="true"}getNumber(y,v){const N=this.get(y);return(0,C.isUndefinedOrNull)(N)?v:parseInt(N,10)}async set(y,v){if(this.c===h.Closed)return;if((0,C.isUndefinedOrNull)(v))return this.delete(y);const N=String(v);if(this.f.get(y)!==N)return this.f.set(y,N),this.j.set(y,N),this.h.delete(y),this.b.fire(y),this.v()}async delete(y){if(!(this.c===h.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=h.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.t)return this.v(y)}async v(y){return this.g.trigger(()=>this.u(),y)}async whenFlushed(){if(!!this.t)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===L.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class b{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,N)=>this.a.set(N,v)),y.delete?.forEach(v=>this.a.delete(v))}async close(){}}e.InMemoryStorageDatabase=b}),define(ie[85],ne([7,4]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ie[86],ne([7,4]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[87],ne([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[88],ne([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ie[89],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[90],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[91],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[92],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[93],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[94],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[95],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[96],ne([7,4]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[97],ne([7,4]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[98],ne([7,4]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[99],ne([7,4]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[100],ne([7,4]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[101],ne([7,4]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[102],ne([7,4]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[103],ne([7,4]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[104],ne([7,4]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[105],ne([7,4]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[106],ne([0,1,9,88]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(O=e.TokenType||(e.TokenType={}));function C(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const L=(0,A.localize)(3,null),I=(0,A.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(C("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(C("&&"));break;case 124:this.h(124)?this.k(16):this.l(C("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const E=this.d,y=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:y};this.g.push({offset:E,lexeme:y,additionalInfo:b}),this.f.push(v)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const E=this.c.substring(this.d,this.e),y=h.b.get(E);y?this.k(y):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,E=!1,y=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(I);return}const N=this.c.charCodeAt(b);if(E)E=!1;else if(N===47&&!y){b++;break}else N===91?y=!0:N===92?E=!0:N===93&&(y=!1);b++}for(;b<this.c.length&&h.a.has(this.c.charCodeAt(b));)b++;this.e=b;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}h.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),h.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=h}),define(ie[107],ne([0,1,75,50,16,15,35,17,11]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,C.dirname)(O.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",v)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=L.env.VSCODE_PORTABLE;return v?h.URI.file((0,C.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,C.resolve)(v):(0,C.normalize)((0,C.join)(O.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?h.URI.file((0,C.resolve)(v)):h.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,C.resolve)(v);const N=L.env.VSCODE_EXTENSIONS;if(N)return N;const k=L.env.VSCODE_PORTABLE;return k?(0,C.join)(k,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(N=>/^[^:/?#]+?:\/\//.test(N)?h.URI.parse(N):h.URI.file((0,C.normalize)(N)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?h.URI.parse(v):h.URI.file((0,C.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const N of this.args.log||[]){const k=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(N);k&&k[1]&&k[2]&&v.push([k[1],k[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=L.env.VSCODE_PORTABLE;return v?h.URI.file((0,C.join)(v,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,N,k){this.a=v,this.b=N,this.c=k,this.editSessionId=this.args.editSessionId}}ye([A.memoize],c.prototype,"appRoot",null),ye([A.memoize],c.prototype,"userHome",null),ye([A.memoize],c.prototype,"userDataPath",null),ye([A.memoize],c.prototype,"appSettingsHome",null),ye([A.memoize],c.prototype,"tmpDir",null),ye([A.memoize],c.prototype,"cacheHome",null),ye([A.memoize],c.prototype,"stateResource",null),ye([A.memoize],c.prototype,"userRoamingDataHome",null),ye([A.memoize],c.prototype,"userDataSyncHome",null),ye([A.memoize],c.prototype,"sync",null),ye([A.memoize],c.prototype,"machineSettingsResource",null),ye([A.memoize],c.prototype,"workspaceStorageHome",null),ye([A.memoize],c.prototype,"localHistoryHome",null),ye([A.memoize],c.prototype,"keyboardLayoutResource",null),ye([A.memoize],c.prototype,"argvResource",null),ye([A.memoize],c.prototype,"isExtensionDevelopment",null),ye([A.memoize],c.prototype,"untitledWorkspacesHome",null),ye([A.memoize],c.prototype,"installSourcePath",null),ye([A.memoize],c.prototype,"builtinExtensionsPath",null),ye([A.memoize],c.prototype,"extensionsPath",null),ye([A.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ye([A.memoize],c.prototype,"extensionDevelopmentKind",null),ye([A.memoize],c.prototype,"extensionTestsLocationURI",null),ye([A.memoize],c.prototype,"debugExtensionHost",null),ye([A.memoize],c.prototype,"logLevel",null),ye([A.memoize],c.prototype,"extensionLogLevel",null),ye([A.memoize],c.prototype,"serviceMachineIdResource",null),ye([A.memoize],c.prototype,"disableTelemetry",null),ye([A.memoize],c.prototype,"disableWorkspaceTrust",null),ye([A.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function b(y,v){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,v,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=b;function E(y,v,N,k,u,f){const w=Number(v||y)||(k?null:N),g=w?Boolean(!!v):!1;let P;if(f)try{P=JSON.parse(f)}catch{}return{port:w,break:g,debugId:u,env:P}}e.parseDebugParams=E}),function(){"use strict";function G(e,T,A){function O(L,I){const h=C(L,I),c=[h];return e.isAbsolute(h)||c.unshift(A),e.resolve(...c)}function C(L,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const b=L["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(E,"AppData","Roaming")}break;case"darwin":c=e.join(T.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:O}}if(typeof define=="function")define(ie[108],ne([161,33,35]),function(e,T,A){return G(e,T,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=G(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[109],ne([0,1,33,107,108]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class C extends A.AbstractNativeEnvironmentService{constructor(c,b){super(c,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,O.getUserDataPath)(c,b.nameShort)},b)}}e.NativeEnvironmentService=C;function L(h,c){return(0,A.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.parsePtyHostDebugPort=L;function I(h,c){return(0,A.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(ie[110],ne([0,1,3,92]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function O(L,I,h){try{C(L,I,h)}catch(c){console.error(c?.message??c)}return L}e.localizeManifest=O;function C(L,I,h){const c=(b,E,y)=>{const v=b[E];if((0,T.isString)(v)){const N=v,k=N.length;if(k>1&&N[0]==="%"&&N[k-1]==="%"){const u=N.substr(1,k-2);let f=I[u];f===void 0&&h&&(f=h[u]);const p=typeof f=="string"?f:f?.message,w=h?.[u],g=typeof w=="string"?w:w?.message;if(!p){g||console.warn(`[${L.name}]: ${(0,A.localize)(0,null,u)}`);return}if(y&&(E==="title"||E==="category")&&g&&g!==p){const P={value:p,original:g};b[E]=P}else b[E]=p}}else if((0,T.isObject)(v))for(const N in v)v.hasOwnProperty(N)&&(N==="commands"?c(v,N,!0):c(v,N,y));else if(Array.isArray(v))for(let N=0;N<v.length;N++)c(v,N,y)};for(const b in L)L.hasOwnProperty(b)&&c(L,b)}}),define(ie[46],ne([0,1,17,53,96,41]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(f){return f=f.trim(),f==="*"||L.test(f)}e.isValidVersionStr=h;function c(f){if(!h(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=c;function b(f){if(!f)return null;const p=f.majorBase,w=f.majorMustEqual,g=f.minorBase;let P=f.minorMustEqual;const t=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(p===0||(P=!1),a=!1);let n=0;if(f.preRelease){const i=I.exec(f.preRelease);if(i){const[,r,o,l]=i;n=Date.UTC(Number(r),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:w,minorBase:g,minorMustEqual:P,patchBase:t,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:n}}e.normalizeVersion=b;function E(f,p,w){let g;typeof f=="string"?g=b(c(f)):g=f;let P;p instanceof Date?P=p.getTime():typeof p=="string"&&(P=new Date(p).getTime());let t;if(typeof w=="string"?t=b(c(w)):t=w,!g||!t)return!1;const a=g.majorBase,n=g.minorBase,i=g.patchBase;let r=t.majorBase,o=t.minorBase,l=t.patchBase;const d=t.notBefore;let S=t.majorMustEqual,D=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:n>o?!0:n<o||P&&P<d?!1:i>=l:(a===1&&r===0&&(!S||!D||!j)&&(r=1,o=0,l=0,S=!0,D=!1,j=!1),a<r?!1:a>r?!S:n<o?!1:n>o?!D:i<l?!1:i>l?!j:!(P&&P<d))}e.isValidVersion=E;function y(f,p,w,g,P){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([A.default.Error,O.localize(0,null)]),t;if(typeof g.name!="string")return t.push([A.default.Error,O.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([A.default.Error,O.localize(2,null,"version")]),t;if(!g.engines)return t.push([A.default.Error,O.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([A.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!u(g.extensionDependencies))return t.push([A.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!u(g.activationEvents))return t.push([A.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([A.default.Error,O.localize(7,null,"activationEvents","main")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([A.default.Warning,O.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([A.default.Error,O.localize(9,null,"main")]),t;{const i=(0,T.joinPath)(w,g.main);(0,T.isEqualOrParent)(i,w)||t.push([A.default.Warning,O.localize(10,null,i.path,w.path)])}if(typeof g.activationEvents>"u")return t.push([A.default.Error,O.localize(11,null,"activationEvents","main")]),t}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([A.default.Error,O.localize(12,null,"browser")]),t;{const i=(0,T.joinPath)(w,g.browser);(0,T.isEqualOrParent)(i,w)||t.push([A.default.Warning,O.localize(13,null,i.path,w.path)])}if(typeof g.activationEvents>"u")return t.push([A.default.Error,O.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(g.version))return t.push([A.default.Error,O.localize(15,null)]),t;const a=[];if(!v(f,p,g,P,a))for(const i of a)t.push([A.default.Error,i]);return t}e.validateExtensionManifest=y;function v(f,p,w,g,P){return g||typeof w.main>"u"&&typeof w.browser>"u"?!0:k(f,p,w.engines.vscode,P)}e.isValidExtensionVersion=v;function N(f,p,w){return f==="*"||k(p,w,f)}e.isEngineValid=N;function k(f,p,w,g=[]){const P=b(c(w));if(!P)return g.push(O.localize(16,null,w)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(O.localize(17,null,w)),!1}else if(!P.majorMustEqual)return g.push(O.localize(18,null,w)),!1;return E(f,p,P)?!0:(g.push(O.localize(19,null,f,w)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let p=0,w=f.length;p<w;p++)if(typeof f[p]!="string")return!1;return!0}}),define(ie[111],ne([0,1,14,28]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function O(C,L,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const b=(await L.readFile(C.serviceMachineIdResource)).value.toString();h=(0,A.isUUID)(b)?b:null}catch{h=null}if(!h){h=(0,A.generateUuid)();try{await L.writeFile(C.serviceMachineIdResource,T.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=O}),define(ie[47],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(O,C=[],L=!1){this.ctor=O,this.staticArguments=C,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=T}),define(ie[112],ne([0,1,47]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var O;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(O=e.InstantiationType||(e.InstantiationType={}));function C(I,h,c){h instanceof T.SyncDescriptor||(h=new T.SyncDescriptor(h,[],Boolean(c))),A.push([I,h])}e.registerSingleton=C;function L(){return A}e.getSingletonServiceDescriptors=L}),define(ie[113],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(C,L){this.key=C,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class A{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const L of this.a.values())L.outgoing.size===0&&C.push(L);return C}insertEdge(C,L){const I=this.lookupOrInsertNode(C),h=this.lookupOrInsertNode(L);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(C){const L=this.b(C);this.a.delete(L);for(const I of this.a.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(C){const L=this.b(C);let I=this.a.get(L);return I||(I=new T(L,C),this.a.set(L,I)),I}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[L,I]of this.a)C.push(`${L}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,L]of this.a){const I=new Set([C]),h=this.c(L,I);if(h)return h}}c(C,L){for(const[I,h]of C.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const c=this.c(h,L);if(c)return c;L.delete(I)}}}e.Graph=A}),define(ie[24],ne([0,1,3,11,10]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,O.createDecorator)("configurationService");function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationOverrides=C;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=L;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function c(u,f){const p=Object.create(null);for(const w in u)b(p,w,u[w],f);return p}e.toValuesTree=c;function b(u,f,p,w){const g=f.split("."),P=g.pop();let t=u;for(let a=0;a<g.length;a++){const n=g[a];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${f} as ${g.slice(0,a+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[P]=p}catch{w(`Ignoring ${f} as ${g.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${f} as ${g.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function E(u,f){const p=f.split(".");y(u,p)}e.removeFromValueTree=E;function y(u,f){const p=f.shift();if(f.length===0){delete u[p];return}if(Object.keys(u).indexOf(p)!==-1){const w=u[p];typeof w=="object"&&!Array.isArray(w)&&(y(w,f),Object.keys(w).length===0&&delete u[p])}}function v(u,f,p){function w(t,a){let n=t;for(const i of a){if(typeof n!="object"||n===null)return;n=n[i]}return n}const g=f.split("."),P=w(u,g);return typeof P>"u"?p:P}e.getConfigurationValue=v;function N(u,f,p){Object.keys(f).forEach(w=>{w!=="__proto__"&&(w in u?T.isObject(u[w])&&T.isObject(f[w])?N(u[w],f[w],p):p&&(u[w]=f[w]):u[w]=f[w])})}e.merge=N;function k(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=k}),define(ie[114],ne([0,1,12,29,106,10,87]),function(G,e,T,A,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",T.isMacintosh),I.set("isLinux",T.isLinux),I.set("isWindows",T.isWindows),I.set("isWeb",T.isWeb),I.set("isMacNative",T.isMacintosh&&!T.isWeb),I.set("isEdge",T.isEdge),I.set("isFirefox",T.isFirefox),I.set("isChrome",T.isChrome),I.set("isSafari",T.isSafari);const h=Object.prototype.hasOwnProperty;var c;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(c=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(s){return l.create(s)}static equals(s,m){return d.create(s,m)}static notEquals(s,m){return j.create(s,m)}static regex(s,m){return fe.create(s,m)}static in(s,m){return S.create(s,m)}static notIn(s,m){return D.create(s,m)}static not(s){return K.create(s)}static and(...s){return W.create(s,null,!0)}static or(...s){return z.create(s,null,!0)}static greater(s,m){return ee.create(s,m)}static greaterEquals(s,m){return se.create(s,m)}static smaller(s,m){return re.create(s,m)}static smallerEquals(s,m){return le.create(s,m)}static deserialize(s){if(!!s)return this.c(s)}static c(s){const m=s.split("||");return z.create(m.map(M=>this.d(M)),null,!0)}static d(s){const m=s.split("&&");return W.create(m.map(M=>this.f(M)),null,!0)}static f(s){if(s=s.trim(),s.indexOf("!=")>=0){const m=s.split("!=");return j.create(m[0].trim(),this.g(m[1]))}if(s.indexOf("==")>=0){const m=s.split("==");return d.create(m[0].trim(),this.g(m[1]))}if(s.indexOf("=~")>=0){const m=s.split("=~");return fe.create(m[0].trim(),this.h(m[1]))}if(s.indexOf(" not in ")>=0){const m=s.split(" not in ");return D.create(m[0].trim(),this.g(m[1]))}if(s.indexOf(" in ")>=0){const m=s.split(" in ");return S.create(m[0].trim(),this.g(m[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const m=s.split(">=");return se.create(m[0].trim(),m[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const m=s.split(">");return ee.create(m[0].trim(),m[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const m=s.split("<=");return le.create(m[0].trim(),m[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const m=s.split("<");return re.create(m[0].trim(),m[1].trim())}return/^\!\s*/.test(s)?K.create(s.substr(1).trim()):l.create(s)}static g(s){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;const m=/^'([^']*)'$/.exec(s);return m?m[1].trim():s}static h(s){if((0,A.isFalsyOrWhitespace)(s))return null;const m=s.indexOf("/"),M=s.lastIndexOf("/");if(m===M||m<0)return null;const x=s.slice(m+1,M),B=s[M+1]==="i"?"i":"";try{return new RegExp(x,B)}catch{return null}}}e.ContextKeyExpr=b;const E={regexParsingWithErrorRecovery:!0};class y extends Error{}const v=(0,L.localize)(0,null),N=(0,L.localize)(1,null),k=(0,L.localize)(2,null),u=(0,L.localize)(3,null),f=(0,L.localize)(4,null),p=(0,L.localize)(5,null),w=(0,L.localize)(6,null),g=(0,L.localize)(7,null),P=(0,L.localize)(8,null);class t{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(s=E){this.h=s,this.c=new O.Scanner,this.d=[],this.f=0,this.g=[]}parse(s){if(s===""){this.g.push({message:v,offset:0,lexeme:"",additionalInfo:N});return}this.d=this.c.reset(s).scan(),this.f=0,this.g=[];try{const m=this.k();if(!this.C()){const M=this.B(),x=M.type===17?w:void 0;throw this.g.push({message:p,offset:M.offset,lexeme:O.Scanner.getLexeme(M),additionalInfo:x}),new y}return m}catch(m){if(!(m instanceof y))throw m;return}}k(){return this.l()}l(){const s=[this.o()];for(;this.w(16);){const m=this.o();s.push(m)}return s.length===1?s[0]:b.or(...s)}o(){const s=[this.s()];for(;this.w(15);){const m=this.s();s.push(m)}return s.length===1?s[0]:b.and(...s)}s(){if(this.w(2)){const s=this.B();switch(s.type){case 17:return this.x(),b.not(s.lexeme);case 11:return this.x(),b.false();case 12:return this.x(),b.true();default:throw this.z("CONTEXT | true | false",s,k)}}return this.t()}t(){const s=this.B();switch(s.type){case 11:return this.x(),b.true();case 12:return this.x(),b.false();case 0:{this.x();const m=this.k();return this.y(1,f),m}case 17:{const m=s.lexeme;if(this.x(),this.w(9)){const x=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),x.type!==10)throw this.z("REGEX",x);const B=x.lexeme,Z=B.lastIndexOf("/"),oe=Z===B.length-1?void 0:B.substring(Z+1);let he;try{he=new RegExp(B.substring(1,Z),oe)}catch{throw this.z("REGEX",x)}return fe.create(m,he)}switch(x.type){case 10:case 19:{const B=[x.lexeme];this.x();let Z=this.B(),oe=0;for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?oe++:x.lexeme.charCodeAt(de)===41&&oe--;for(;!this.C()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let de=0;de<Z.lexeme.length;de++)Z.lexeme.charCodeAt(de)===40?oe++:x.lexeme.charCodeAt(de)===41&&oe--}if(oe<0)break;B.push(O.Scanner.getLexeme(Z)),this.x(),Z=this.B()}const he=B.join(""),me=he.lastIndexOf("/"),ue=me===he.length-1?void 0:he.substring(me+1);let ge;try{ge=new RegExp(he.substring(1,me),ue)}catch{throw this.z("REGEX",x)}return b.regex(m,ge)}case 18:{const B=x.lexeme;this.x();let Z=null;if(!(0,A.isFalsyOrWhitespace)(B)){const oe=B.indexOf("/"),he=B.lastIndexOf("/");if(oe!==he&&oe>=0){const me=B.slice(oe+1,he),ue=B[he+1]==="i"?"i":"";try{Z=new RegExp(me,ue)}catch{throw this.z("REGEX",x)}}}if(Z===null)throw this.z("REGEX",x);return fe.create(m,Z)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,u);const x=this.u();return b.notIn(m,x)}switch(this.B().type){case 3:{this.x();const x=this.u();if(this.v().type===18)return b.equals(m,x);switch(x){case"true":return b.has(m);case"false":return b.not(m);default:return b.equals(m,x)}}case 4:{this.x();const x=this.u();if(this.v().type===18)return b.notEquals(m,x);switch(x){case"true":return b.not(m);case"false":return b.has(m);default:return b.notEquals(m,x)}}case 5:return this.x(),re.create(m,this.u());case 6:return this.x(),le.create(m,this.u());case 7:return this.x(),ee.create(m,this.u());case 8:return this.x(),se.create(m,this.u());case 13:return this.x(),b.in(m,this.u());default:return b.has(m)}}case 20:throw this.g.push({message:g,offset:s.offset,lexeme:"",additionalInfo:P}),new y;default:throw this.z(`true | false | CONTEXT 
	| CONTEXT '=~' REGEX 
	| CONTEXT ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const s=this.B();switch(s.type){case 17:case 18:return this.x(),s.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(s){return this.A(s)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(s,m){if(this.A(s))return this.x();throw this.z(m,this.B())}z(s,m,M){const x=(0,L.localize)(9,null,s,O.Scanner.getLexeme(m)),B=m.offset,Z=O.Scanner.getLexeme(m);return this.g.push({message:x,offset:B,lexeme:Z,additionalInfo:M}),new y}A(s){return this.B().type===s}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=t;function a(R){const s=new t({regexParsingWithErrorRecovery:!1});return R.map(m=>(s.parse(m),s.lexingErrors.length>0?s.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,L.localize)(10,null,M.additionalInfo):(0,L.localize)(11,null),offset:M.offset,length:M.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=a;function n(R,s){const m=R?R.substituteConstants():void 0,M=s?s.substituteConstants():void 0;return!m&&!M?!0:!m||!M?!1:m.equals(M)}e.expressionsAreEqualWithConstantSubstitution=n;function i(R,s){return R.cmp(s)}class r{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return o.INSTANCE}}r.INSTANCE=new r,e.ContextKeyFalseExpr=r;class o{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}o.INSTANCE=new o,e.ContextKeyTrueExpr=o;class l{static create(s,m=null){const M=I.get(s);return typeof M=="boolean"?M?o.INSTANCE:r.INSTANCE:new l(s,m)}constructor(s,m){this.key=s,this.c=m,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:q(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=I.get(this.key);return typeof s=="boolean"?s?o.INSTANCE:r.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.c||(this.c=K.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class d{static create(s,m,M=null){if(typeof m=="boolean")return m?l.create(s,M):K.create(s,M);const x=I.get(s);return typeof x=="boolean"?m===(x?"true":"false")?o.INSTANCE:r.INSTANCE:new d(s,m,M)}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=I.get(this.c);if(typeof s=="boolean"){const m=s?"true":"false";return this.d===m?o.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(s){return s.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class S{static create(s,m){return new S(s,m)}constructor(s,m){this.d=s,this.f=m,this.type=10,this.c=null}cmp(s){return s.type!==this.type?this.type-s.type:H(this.d,this.f,s.d,s.f)}equals(s){return s.type===this.type?this.d===s.d&&this.f===s.f:!1}substituteConstants(){return this}evaluate(s){const m=s.getValue(this.f),M=s.getValue(this.d);return Array.isArray(m)?m.includes(M):typeof M=="string"&&typeof m=="object"&&m!==null?h.call(m,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(s){return s.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=S;class D{static create(s,m){return new D(s,m)}constructor(s,m){this.d=s,this.f=m,this.type=11,this.c=S.create(s,m)}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(s){return s.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=D;class j{static create(s,m,M=null){if(typeof m=="boolean")return m?K.create(s,M):l.create(s,M);const x=I.get(s);return typeof x=="boolean"?m===(x?"true":"false")?r.INSTANCE:o.INSTANCE:new j(s,m,M)}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=I.get(this.c);if(typeof s=="boolean"){const m=s?"true":"false";return this.d===m?r.INSTANCE:o.INSTANCE}return this}evaluate(s){return s.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(s){return s.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=j;class K{static create(s,m=null){const M=I.get(s);return typeof M=="boolean"?M?r.INSTANCE:o.INSTANCE:new K(s,m)}constructor(s,m){this.c=s,this.d=m,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:q(this.c,s.c)}equals(s){return s.type===this.type?this.c===s.c:!1}substituteConstants(){const s=I.get(this.c);return typeof s=="boolean"?s?r.INSTANCE:o.INSTANCE:this}evaluate(s){return!s.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(s){return s.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=K;function Q(R,s){if(typeof R=="string"){const m=parseFloat(R);isNaN(m)||(R=m)}return typeof R=="string"||typeof R=="number"?s(R):r.INSTANCE}class ee{static create(s,m,M=null){return Q(m,x=>new ee(s,x,M))}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=ee;class se{static create(s,m,M=null){return Q(m,x=>new se(s,x,M))}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=se;class re{static create(s,m,M=null){return Q(m,x=>new re(s,x,M))}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=re;class le{static create(s,m,M=null){return Q(m,x=>new le(s,x,M))}constructor(s,m,M){this.c=s,this.d=m,this.f=M,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=le;class fe{static create(s,m){return new fe(s,m)}constructor(s,m){this.d=s,this.f=m,this.type=7,this.c=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.d<s.d)return-1;if(this.d>s.d)return 1;const m=this.f?this.f.source:"",M=s.f?s.f.source:"";return m<M?-1:m>M?1:0}equals(s){if(s.type===this.type){const m=this.f?this.f.source:"",M=s.f?s.f.source:"";return this.d===s.d&&m===M}return!1}substituteConstants(){return this}evaluate(s){const m=s.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const s=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${s}`}keys(){return[this.d]}map(s){return s.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.ContextKeyRegexExpr=fe;class ae{static create(s){return new ae(s)}constructor(s){this.c=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(s){return new ae(this.c.map(s))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ae;function $(R){let s=null;for(let m=0,M=R.length;m<M;m++){const x=R[m].substituteConstants();if(R[m]!==x&&s===null){s=[];for(let B=0;B<m;B++)s[B]=R[B]}s!==null&&(s[m]=x)}return s===null?R:s}class W{static create(s,m,M){return W.d(s,m,M)}constructor(s,m){this.expr=s,this.c=m,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const x=i(this.expr[m],s.expr[m]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(s.expr[m]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:W.create(s,this.c,!1)}evaluate(s){for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].evaluate(s))return!1;return!0}static d(s,m,M){const x=[];let B=!1;for(const Z of s)if(!!Z){if(Z.type===1){B=!0;continue}if(Z.type===0)return r.INSTANCE;if(Z.type===6){x.push(...Z.expr);continue}x.push(Z)}if(x.length===0&&B)return o.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(i);for(let Z=1;Z<x.length;Z++)x[Z-1].equals(x[Z])&&(x.splice(Z,1),Z--);if(x.length===1)return x[0];for(;x.length>1;){const Z=x[x.length-1];if(Z.type!==9)break;x.pop();const oe=x.pop(),he=x.length===0,me=z.create(Z.expr.map(ue=>W.create([ue,oe],null,M)),null,he);me&&(x.push(me),x.sort(i))}if(x.length===1)return x[0];if(M){for(let Z=0;Z<x.length;Z++)for(let oe=Z+1;oe<x.length;oe++)if(x[Z].negate().equals(x[oe]))return r.INSTANCE;if(x.length===1)return x[0]}return new W(x,m)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const m of this.expr)s.push(...m.keys());return s}map(s){return new W(this.expr.map(m=>m.map(s)),null)}negate(){if(!this.c){const s=[];for(const m of this.expr)s.push(m.negate());this.c=z.create(s,this,!0)}return this.c}}class z{static create(s,m,M){return z.d(s,m,M)}constructor(s,m){this.expr=s,this.c=m,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const x=i(this.expr[m],s.expr[m]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(s.expr[m]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:z.create(s,this.c,!1)}evaluate(s){for(let m=0,M=this.expr.length;m<M;m++)if(this.expr[m].evaluate(s))return!0;return!1}static d(s,m,M){let x=[],B=!1;if(s){for(let Z=0,oe=s.length;Z<oe;Z++){const he=s[Z];if(!!he){if(he.type===0){B=!0;continue}if(he.type===1)return o.INSTANCE;if(he.type===9){x=x.concat(he.expr);continue}x.push(he)}}if(x.length===0&&B)return r.INSTANCE;x.sort(i)}if(x.length!==0){if(x.length===1)return x[0];for(let Z=1;Z<x.length;Z++)x[Z-1].equals(x[Z])&&(x.splice(Z,1),Z--);if(x.length===1)return x[0];if(M){for(let Z=0;Z<x.length;Z++)for(let oe=Z+1;oe<x.length;oe++)if(x[Z].negate().equals(x[oe]))return o.INSTANCE;if(x.length===1)return x[0]}return new z(x,m)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const m of this.expr)s.push(...m.keys());return s}map(s){return new z(this.expr.map(m=>m.map(s)),null)}negate(){if(!this.c){const s=[];for(const m of this.expr)s.push(m.negate());for(;s.length>1;){const m=s.shift(),M=s.shift(),x=[];for(const B of F(m))for(const Z of F(M))x.push(W.create([B,Z],null,!1));s.unshift(z.create(x,null,!1))}this.c=z.create(s,this,!0)}return this.c}}class U extends l{static all(){return U.d.values()}constructor(s,m,M){super(s,null),this.f=m,typeof M=="object"?U.d.push({...M,key:s}):M!==!0&&U.d.push({key:s,description:M,type:m!=null?typeof m:void 0})}bindTo(s){return s.createKey(this.key,this.f)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return d.create(this.key,s)}notEqualsTo(s){return j.create(this.key,s)}}U.d=[],e.RawContextKey=U,e.IContextKeyService=(0,C.createDecorator)("contextKeyService");function q(R,s){return R<s?-1:R>s?1:0}function H(R,s,m,M){return R<m?-1:R>m?1:s<M?-1:s>M?1:0}function X(R,s){if(R.type===0||s.type===1)return!0;if(R.type===9)return s.type===9?Y(R.expr,s.expr):!1;if(s.type===9){for(const m of s.expr)if(X(R,m))return!0;return!1}if(R.type===6){if(s.type===6)return Y(s.expr,R.expr);for(const m of R.expr)if(X(m,s))return!0;return!1}return R.equals(s)}e.implies=X;function Y(R,s){let m=0,M=0;for(;m<R.length&&M<s.length;){const x=R[m].cmp(s[M]);if(x<0)return!1;x===0&&m++,M++}return m===R.length}function F(R){return R.type===9?R.expr:[R]}}),define(ie[59],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ie[18],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[21],ne([0,1,90,10]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function O(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=O;function C(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function L(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function I(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(f,p,w){return I(p,w)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===w?!0:c(w).includes(f)}e.isTargetPlatformCompatible=h;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var y;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var v;(function(f){f.Install="install",f.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var N;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(N=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var k;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(k=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,T.localize)(1,null),original:"Preferences"}}),define(ie[60],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((C,L)=>G(["node-vsce-sign"],async I=>C(I),L))),this.a}async verify(C,L,I){let h;try{h=await this.b()}catch{return!1}return h.verify(C,L,I)}}e.ExtensionSignatureVerificationService=A}),define(ie[61],ne([0,1,14,9,98,13]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(b,E,y,v,N,k){let u;try{await I(b,E,y,v,N,k)}catch(f){u=f}finally{u&&N.errorTransformer&&(u=N.errorTransformer(u)),typeof u<"u"&&y.error(u),y.end()}}e.readFileIntoStream=L;async function I(b,E,y,v,N,k){h(k);const u=await b.open(E,{create:!1});try{h(k);let f=0,p=0,w=N&&typeof N.length=="number"?N.length:void 0,g=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof w=="number"?w:N.bufferSize)),P=N&&typeof N.position=="number"?N.position:0,t=0;do p=await b.read(u,P,g.buffer,t,g.byteLength-t),P+=p,t+=p,f+=p,typeof w=="number"&&(w-=p),t===g.byteLength&&(await y.write(v(g)),g=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof w=="number"?w:N.bufferSize)),t=0);while(p>0&&(typeof w!="number"||w>0)&&h(k)&&c(f,N));if(t>0){let a=t;typeof w=="number"&&(a=Math.min(t,w)),y.write(v(g.slice(0,a)))}}catch(f){throw(0,C.ensureFileSystemProviderError)(f)}finally{await b.close(u)}}function h(b){if(b.isCancellationRequested)throw(0,A.canceled)();return!0}function c(b,E){if(E?.limits){if(typeof E.limits.memory=="number"&&b>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,O.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&b>E.limits.size)throw(0,C.createFileSystemProviderError)((0,O.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[115],ne([0,1,5,162,2,12,163]),function(G,e,T,A,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends O.Disposable{constructor(){super(...arguments),this.a=this.D(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.i(c),E=b.filter(v=>{const N=this.c.get(v.path);return N?!(0,A.patternsEquals)(N.request.excludes,v.excludes)||!(0,A.patternsEquals)(N.request.includes,v.includes):!0}),y=Array.from(this.c.values()).filter(({request:v})=>!b.find(N=>N.path===v.path&&(0,A.patternsEquals)(N.excludes,v.excludes)&&(0,A.patternsEquals)(N.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.j(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const v of y)this.h(v);for(const v of E)this.g(v)}g(c){const b=new L.NodeJSFileWatcherLibrary(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),E={request:c,instance:b};this.c.set(c.path,E)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}i(c){const b=new Map;for(const E of c){const y=C.isLinux?E.path:E.path.toLowerCase();b.set(y,E)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(ie[116],ne([0,1,62,115]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class O extends T.AbstractNonRecursiveWatcherClient{constructor(L,I,h){super(L,I,h),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=O}),define(ie[117],ne([0,1,16,57,83,62]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends C.AbstractUniversalWatcherClient{constructor(h,c,b){super(h,c,b),this.m()}l(h){const c=h.add(new O.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:b,signal:E})=>this.n(`terminated by itself with code ${b}, signal: ${E}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(ie[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...O){this.a=new Map;for(const[C,L]of O)this.set(C,L)}set(O,C){const L=this.a.get(O);return this.a.set(O,C),L}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.ServiceCollection=T}),define(ie[118],ne([0,1,8,9,2,47,113,10,63,164]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new h.ServiceCollection,f=!1,p,w=b){this.f=u,this.g=f,this.h=p,this.i=w,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=w?p?._globalGraph??new L.Graph(g=>g):void 0}createChild(u){return new y(u,this.g,this,this.i)}invokeFunction(u,...f){const p=N.traceInvocation(this.i,u);let w=!1;try{return u({get:P=>{if(w)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(P,p);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...f)}finally{w=!0,p.stop()}}createInstance(u,...f){let p,w;return u instanceof C.SyncDescriptor?(p=N.traceCreation(this.i,u.ctor),w=this.j(u.ctor,u.staticArguments.concat(f),p)):(p=N.traceCreation(this.i,u),w=this.j(u,f,p)),p.stop(),w}j(u,f=[],p){const w=I._util.getServiceDependencies(u).sort((t,a)=>t.index-a.index),g=[];for(const t of w){const a=this.m(t.id,p);a||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(a)}const P=w.length>0?w[0].index:f.length;if(f.length!==P){console.trace(`[createInstance] First service dependency of ${u.name} at position ${P+1} conflicts with ${f.length} static arguments`);const t=P-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,P)}return Reflect.construct(u,f.concat(g))}k(u,f){if(this.f.get(u)instanceof C.SyncDescriptor)this.f.set(u,f);else if(this.h)this.h.k(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const f=this.f.get(u);return!f&&this.h?this.h.l(u):f}m(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const p=this.l(u);return p instanceof C.SyncDescriptor?this.q(u,p,f.branch(u,!0)):(f.branch(u,!1),p)}q(u,f,p){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,f,p)}finally{this.o.delete(u)}}r(u,f,p){const w=new L.Graph(t=>t.id.toString());let g=0;const P=[{id:u,desc:f,_trace:p}];for(;P.length;){const t=P.pop();if(w.lookupOrInsertNode(t),g++>1e3)throw new E(w);for(const a of I._util.getServiceDependencies(t.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),n instanceof C.SyncDescriptor){const i={id:a.id,desc:n,_trace:t._trace.branch(a.id,!0)};w.insertEdge(t,i),P.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:a}of t){if(this.l(a.id)instanceof C.SyncDescriptor){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}w.removeNode(a)}}return this.l(u)}s(u,f,p=[],w,g){if(this.f.get(u)instanceof C.SyncDescriptor)return this.t(u,f,p,w,g);if(this.h)return this.h.s(u,f,p,w,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(u,f,p=[],w,g){if(w){const P=new y(void 0,this.g,this,this.i);P.c=String(u);const t=new Map,a=new T.IdleValue(()=>{const n=P.j(f,p,g);for(const[i,r]of t){const o=n[i];if(typeof o=="function")for(const l of r)o.apply(n,l)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=t.get(i);return l||(l=new c.LinkedList,t.set(i,l)),(S,D,j)=>{const K=l.push([S,D,j]);return(0,O.toDisposable)(K)}}if(i in n)return n[i];const r=a.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),n[i]=o),o},set(n,i,r){return a.value[i]=r,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,p,g)}u(u,f){if(f&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=y;var v;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(v||(v={}));class N{static traceInvocation(u,f){return u?new N(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):N.c}static traceCreation(u,f){return u?new N(1,f.name):N.c}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const p=new N(3,u.toString());return this.h.push([u,f,p]),p}stop(){const u=Date.now()-this.g;N.f+=u;let f=!1;function p(g,P){const t=[],a=new Array(g+1).join("	");for(const[n,i,r]of P.h)if(i&&r){f=!0,t.push(`${a}CREATES -> ${n}`);const o=p(g+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${n}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${N.f.toFixed(2)}ms)`];(u>2||f)&&N.all.add(w.join(`
`))}}N.all=new Set,N.c=new class extends N{constructor(){super(0,null)}stop(){}branch(){return this}},N.f=0,e.Trace=N});var te=this&&this.__param||function(G,e){return function(T,A){e(T,A,G)}};define(ie[64],ne([0,1,23,2,12,100,21,10]),function(G,e,T,A,O,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function h(b){return b.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=h,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let c=class extends A.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new T.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const N=y.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(u=>u.startsWith("lp-"))).map(k=>{const u=k.properties.localizedLanguages?.[0],f=h(k);return{...this.f(f,u,k),extensionId:k.identifier.id,galleryExtension:k}});return N.push(this.f("en","English")),N}f(E,y,v){const N=y??E;let k;if(N!==E&&(k=`(${E})`),E.toLowerCase()===O.language.toLowerCase()&&(k??="",k+=(0,C.localize)(0,null)),v?.installCount){k??="";const u=v.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),k+=` $(cloud-download) ${f}`}return{id:E,label:N,description:k}}};c=ye([te(0,L.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(ie[6],ne([0,1,34,5,45,2,36,12,17,3,11,114,10]),function(G,e,T,A,O,C,L,I,h,c,b,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function v(){return new Date().toISOString()}function N(S){return(0,c.isNumber)(S)}e.isLogLevel=N;var k;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(k=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=k.Info;function u(S,D,j){switch(D){case k.Trace:S.trace(j);break;case k.Debug:S.debug(j);break;case k.Info:S.info(j);break;case k.Warning:S.warn(j);break;case k.Error:S.error(j);break;case k.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=u;function f(S,D=!1){let j="";for(let K=0;K<S.length;K++){let Q=S[K];if(Q instanceof Error&&(Q=(0,T.toErrorMessage)(Q,D)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}j+=(K>0?" ":"")+Q}return j}class p extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==k.Off&&this.b<=D}}e.AbstractLogger=p;class w extends p{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...j){this.f(k.Trace)&&this.g(k.Trace,f([D,...j],!0))}debug(D,...j){this.f(k.Debug)&&this.g(k.Debug,f([D,...j]))}info(D,...j){this.f(k.Info)&&this.g(k.Info,f([D,...j]))}warn(D,...j){this.f(k.Warning)&&this.g(k.Warning,f([D,...j]))}error(D,...j){if(this.f(k.Error))if(D instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=D.stack,this.g(k.Error,f(K))}else this.g(k.Error,f([D,...j]))}flush(){}}e.AbstractMessageLogger=w;class g extends p{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.g=!I.isWindows}trace(D,...j){this.f(k.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...j):console.log(`[main ${v()}]`,D,...j))}debug(D,...j){this.f(k.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...j):console.log(`[main ${v()}]`,D,...j))}info(D,...j){this.f(k.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...j):console.log(`[main ${v()}]`,D,...j))}warn(D,...j){this.f(k.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,D,...j):console.warn(`[main ${v()}]`,D,...j))}error(D,...j){this.f(k.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,D,...j):console.error(`[main ${v()}]`,D,...j))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class P extends p{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D)}trace(D,...j){this.f(k.Trace)&&console.log("%cTRACE","color: #888",D,...j)}debug(D,...j){this.f(k.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",D,...j)}info(D,...j){this.f(k.Info)&&console.log("%c INFO","color: #33f",D,...j)}warn(D,...j){this.f(k.Warning)&&console.log("%c WARN","color: #993",D,...j)}error(D,...j){this.f(k.Error)&&console.log("%c  ERR","color: #f33",D,...j)}dispose(){}flush(){}}e.ConsoleLogger=P;class t extends p{constructor(D,j=e.DEFAULT_LOG_LEVEL){super(),this.g=D,this.setLevel(j)}trace(D,...j){this.f(k.Trace)&&this.g.log(k.Trace,[this.h(D),...j])}debug(D,...j){this.f(k.Debug)&&this.g.log(k.Debug,[this.h(D),...j])}info(D,...j){this.f(k.Info)&&this.g.log(k.Info,[this.h(D),...j])}warn(D,...j){this.f(k.Warning)&&this.g.log(k.Warning,[this.h(D),...j])}error(D,...j){this.f(k.Error)&&this.g.log(k.Error,[this.h(D),...j])}h(D){return typeof D=="string"?D:(0,T.toErrorMessage)(D,this.f(k.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends p{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const j of this.g)j.setLevel(D);super.setLevel(D)}trace(D,...j){for(const K of this.g)K.trace(D,...j)}debug(D,...j){for(const K of this.g)K.debug(D,...j)}info(D,...j){for(const K of this.g)K.info(D,...j)}warn(D,...j){for(const K of this.g)K.warn(D,...j)}error(D,...j){for(const K of this.g)K.error(D,...j)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.MultiplexLogger=a;class n extends C.Disposable{constructor(D,j,K){if(super(),this.h=D,this.j=j,this.b=new L.ResourceMap,this.c=this.D(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new A.Emitter),this.onDidChangeVisibility=this.g.event,K)for(const Q of K)this.b.set(Q.resource,{logger:void 0,info:Q})}k(D){return(0,c.isString)(D)?[...this.b.values()].find(j=>j.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,j){const K=this.l(D),Q=(0,c.isString)(D)?D:j?.id??(0,O.hash)(K.toString()).toString(16);let ee=this.b.get(K)?.logger;const se=j?.logLevel==="always"?k.Trace:j?.logLevel;ee||(ee=this.m(K,se??this.getLogLevel(K)??this.h,{...j,id:Q}));const re={logger:ee,info:{resource:K,id:Q,logLevel:se,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(K,re),ee}l(D){return(0,c.isString)(D)?(0,h.joinPath)(this.j,`${D}.log`):D}setLogLevel(D,j){if(b.URI.isUri(D)){const K=D,Q=j,ee=this.b.get(K);ee&&Q!==ee.info.logLevel&&(ee.info.logLevel=Q===this.h?void 0:Q,ee.logger?.setLevel(Q),this.b.set(ee.info.resource,ee),this.f.fire([K,Q]))}else{this.h=D;for(const[K,Q]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,j){const K=this.k(D);K&&j!==!K.info.hidden&&(K.info.hidden=!j,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,j]))}getLogLevel(D){let j;return D&&(j=this.b.get(D)?.info.logLevel),j??this.h}registerLogger(D){const j=this.b.get(D.resource);j?j.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const j=this.b.get(D);j&&(j.logger&&j.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(D){}getLevel(){return k.Info}trace(D,...j){}debug(D,...j){}info(D,...j){}warn(D,...j){}error(D,...j){}critical(D,...j){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(S){if(S.verbose)return k.Trace;if(typeof S.logLevel=="string"){const D=d(S.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(S){switch(S){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Off:return"off"}}e.LogLevelToString=l;function d(S){switch(S){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Error;case"off":return k.Off}}e.parseLogLevel=d,e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",l(k.Info))}),define(ie[119],ne([0,1,19,8,9,5,2,15,62,6]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(y,v){super(),this.a=y,this.b=v,this.c=this.D(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new A.ThrottledDelayer(0)),this.r=[],this.s=this.D(new A.ThrottledDelayer(0))}watch(y,v){return v.recursive||this.b?.watcher?.forceUniversal?this.l(y,v):this.t(y,v)}l(y,v){const N={path:this.z(y),excludes:v.excludes,includes:v.includes,recursive:v.recursive},k=(0,T.insert)(this.j,N);return this.m(),(0,L.toDisposable)(()=>{k(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,O.onUnexpectedError)(y))}n(){this.h||(this.h=this.D(this.p(v=>this.c.fire((0,h.toFileChanges)(v)),v=>this.y(v),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const v of this.j)(0,h.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const v of this.j)(0,h.isRecursiveWatchRequest)(v)&&y.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(y,v){const N={path:this.z(y),excludes:v.excludes,includes:v.includes,recursive:!1},k=(0,T.insert)(this.r,N);return this.u(),(0,L.toDisposable)(()=>{k(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(y=>(0,O.onUnexpectedError)(y))}v(){return this.q||(this.q=this.D(this.w(y=>this.c.fire((0,h.toFileChanges)(y)),y=>this.y(y),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.q.watch(this.r)}y(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}z(y){return(0,I.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ie[120],ne([0,1,19,8,14,23,5,45,65,2,55,16,121,17,44,97,13,61,6,9]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.D(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new L.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new L.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new L.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new A.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),n.add(a.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(a))))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(n){a.push(n)}}),!this.h.has(t)&&await A.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return h.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,v.isAbsolutePath)(t))throw new u.FileOperationError((0,k.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const n=new w.ErrorNoTelemetry;throw n.message=(0,k.localize)(1,null,t.toString()),n}return a}async k(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a)||(0,u.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,k.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,a){const n=await this.j(t),i=this.O(n),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,d=await n.stat(t);let S;return this.p(n,t,d,void 0,!!l,(D,j)=>(S||(S=b.TernarySearchTree.forUris(()=>!i),S.set(t,!0),r&&S.fill(!0,r)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?j===1:!1))}async p(t,a,n,i,r,o){const{providerExtUri:l}=this.N(t),d={resource:a,name:l.basename(a),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(d.isDirectory&&o(d,i)){try{const S=await t.readdir(a),D=await A.Promises.settled(S.map(async([j,K])=>{try{const Q=l.joinPath(a,j),ee=r?await t.stat(Q):{type:K};return await this.p(t,Q,ee,S.length,r,o)}catch(Q){return this.b.trace(Q),null}}));d.children=(0,T.coalesce)(D)}catch(S){this.b.trace(S),d.children=[]}return d}return d}async resolveAll(t){return A.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),n=await a.stat(t);return this.p(a,t,n,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.q(t,a)}catch(n){return n}return!0}async q(t,a){if(!a?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,k.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=O.VSBuffer.fromString(""),n){await this.q(t,n);const i=await this.writeFile(t,a);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,a,n){const i=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(i);try{await this.r(i,t,n)||await this.P(i,r.dirname(t));let l;if((0,u.hasReadWriteCapability)(i)&&!(a instanceof O.VSBuffer))if((0,N.isReadableStream)(a)){const d=await(0,N.peekStream)(a,3);d.ended?l=O.VSBuffer.concat(d.buffer):l=d}else l=(0,N.peekReadable)(a,d=>O.VSBuffer.concat(d),3);else l=a;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&l instanceof O.VSBuffer?await this.cb(i,t,n,l):await this.Y(i,t,n,l instanceof O.VSBuffer?(0,O.bufferToReadable)(l):l),this.m.fire(new u.FileOperationEvent(t,4))}catch(o){throw new u.FileOperationError((0,k.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),n)}return this.resolve(t,{resolveMetadata:!0})}async r(t,a,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,k.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,k.localize)(6,null,this.nb(a)),0,n);if(this.mb(a,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:r.size}))throw new u.FileOperationError((0,k.localize)(7,null),3,n);return r}async readFile(t,a,n){const i=await this.k(t);return a?.atomic?this.s(i,t,a,n):this.t(i,t,a,n)}async s(t,a,n,i){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.t(t,a,n,i);r(l)}catch(l){o(l)}})})}async t(t,a,n,i){const r=await this.u(t,a,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,O.streamToBuffer)(r.value)}}async readFileStream(t,a,n){const i=await this.k(t);return this.u(i,t,a,n)}async u(t,a,n,i){const r=new C.CancellationTokenSource(i),o=this.F(a,n).then(d=>d,d=>{throw r.cancel(),d});let l;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await o,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?l=this.C(t,a,n):(0,u.hasFileReadStreamCapability)(t)?l=this.w(t,a,r.token,n):l=this.z(t,a,r.token,n),{...await o,value:l}}catch(d){throw l&&await(0,N.consumeStream)(l),this.v(d,a,n)}}v(t,a,n){const i=(0,k.localize)(8,null,this.nb(a),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}w(t,a,n,i=Object.create(null)){const r=t.readFileStream(a,i,n);return(0,N.transform)(r,{data:o=>o instanceof O.VSBuffer?o:O.VSBuffer.wrap(o),error:o=>this.v(o,a,i)},o=>O.VSBuffer.concat(o))}z(t,a,n,i=Object.create(null)){const r=(0,O.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,a,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.v(o,a,i)},n),r}C(t,a,n){const i=(0,N.newWriteableStream)(r=>O.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(a,r.byteLength,n),i.end(O.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async F(t,a){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,k.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==u.ETAG_DISABLED&&a.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,k.localize)(10,null),n,a);return this.G(t,n.size,a),n}G(t,a,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&a>n.limits.size&&(i=7),typeof i=="number")throw new u.TooLargeFileOperationError((0,k.localize)(11,null,this.nb(t)),i,a,n)}}async canMove(t,a,n){return this.H(t,a,"move",n)}async canCopy(t,a,n){return this.H(t,a,"copy",n)}async H(t,a,n,i){if(t.toString()!==a.toString())try{const r=n==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,n,i)}catch(r){return r}return!0}async move(t,a,n){const i=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"move",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="move"?2:3,l)),l}async copy(t,a,n){const i=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"copy",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="copy"?3:2,l)),l}async I(t,a,n,i,r,o){if(a.toString()===i.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.M(t,a,n,i,r,o);if(l&&!d&&o&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(a,i,{overwrite:o});else{const S=await this.resolve(a);S.isDirectory?await this.L(t,S,n,i):await this.J(t,a,n,i)}return r}else return t===n?(await t.rename(a,i,{overwrite:o}),r):(await this.I(t,a,n,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.eb(t,a,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.kb(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.ib(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.gb(t,a,n,i)}async L(t,a,n,i){await n.mkdir(i),Array.isArray(a.children)&&await A.Promises.settled(a.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),n,o):this.J(t,r.resource,n,o)}))}async M(t,a,n,i,r,o){let l=!1;if(t===n){const{providerExtUri:S,isPathCaseSensitive:D}=this.N(t);if(D||(l=S.isEqual(a,i)),l&&r==="copy")throw new Error((0,k.localize)(12,null,this.nb(a),this.nb(i)));if(!l&&S.isEqualOrParent(i,a))throw new Error((0,k.localize)(13,null,this.nb(a),this.nb(i)))}const d=await this.exists(i);if(d&&!l){if(!o)throw new u.FileOperationError((0,k.localize)(14,null,this.nb(a),this.nb(i)),4);if(t===n){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(a,i))throw new Error((0,k.localize)(15,null,this.nb(a),this.nb(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,a){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(a,i.dirname(a));)try{if(((await t.stat(a)).type&u.FileType.Directory)===0)throw new Error((0,k.localize)(16,null,this.nb(a)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(a)),a=i.dirname(a)}for(let r=n.length-1;r>=0;r--){a=i.joinPath(a,n[r]);try{await t.mkdir(a)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(n){return n}return!0}async Q(t,a){const n=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,k.localize)(17,null,this.nb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,k.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,k.localize)(19,null,this.nb(t)))}return n}async del(t,a){const n=await this.Q(t,a),i=!!a?.useTrash,r=!!a?.recursive;await n.delete(t,{recursive:r,useTrash:i}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,a){const n=await this.j(t),i=this.lb(await this.l(a),a);if(n===i&&this.N(n).providerExtUri.isEqual(t,a))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,a);await this.P(i,this.N(i).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(n,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);i?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(t,a){const n=await this.j(t),i=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(i);return r||(r={count:0,disposable:n.watch(t,a)},this.U.set(i,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,N.isReadableStream)(i)||(0,N.isReadableBufferedStream)(i)?await this.Z(t,r,i):await this.ab(t,r,i)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,n){let i=0,r;if((0,N.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=O.VSBuffer.concat(n.buffer);await this.bb(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,l)=>{(0,N.listenStream)(r,{onData:async d=>{r.pause();try{await this.bb(t,a,d,d.byteLength,i,0)}catch(S){return l(S)}i+=d.byteLength,setTimeout(()=>r.resume())},onError:d=>l(d),onEnd:()=>o()})})}async ab(t,a,n){let i=0,r;for(;(r=n.read())!==null;)await this.bb(t,a,r,r.byteLength,i,0),i+=r.byteLength}async bb(t,a,n,i,r,o){let l=0;for(;l<i;)l+=await t.write(a,r+l,n.buffer,o+l,i-l)}async cb(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,n,i))}async db(t,a,n,i){let r;i instanceof O.VSBuffer?r=i:(0,N.isReadableStream)(i)?r=await(0,O.streamToBuffer)(i):(0,N.isReadableBufferedStream)(i)?r=await(0,O.bufferedStreamToBuffer)(i):r=(0,O.readableToBuffer)(i),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,a,n,i))}async fb(t,a,n,i){let r,o;try{r=await t.open(a,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const l=O.VSBuffer.alloc(this.a);let d=0,S=0,D=0;do D=await t.read(r,d,l.buffer,S,l.byteLength-S),await this.bb(n,o,l,D,d,S),d+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await A.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async gb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,a,n,i))}async hb(t,a,n,i){return n.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,a,n,i))}async jb(t,a,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(n,r,O.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async kb(t,a,n,i){const r=await(0,O.streamToBuffer)(this.z(t,a,C.CancellationToken.None));await this.cb(n,i,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new u.FileOperationError((0,k.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,k.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};g=ye([te(0,p.ILogService)],g),e.FileService=g}),define(ie[122],ne([0,1,123,165,8,36,14,5,166,2,15,12,17,44,20,99,13,61,119,34,117,116]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(T)}catch(a){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(a)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.H=new C.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:r}=await N.SymlinkSupport.stat(this.z(n));return{type:this.G(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(n){try{const i=await N.Promises.readdir(this.z(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,y.joinPath)(n,o.name))).type:l=this.G(o),r.push([o.name,l])}catch(l){this.a.trace(l)}})),r}catch(i){throw this.Y(i)}}G(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async I(n){const i=this.z(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new O.Barrier;return this.H.set(n,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(n)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(n)})`),r=await this.I(n));const o=this.z(n);return await N.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(n){t.C&&this.a.trace(n)}readFileStream(n,i,r){const o=(0,v.newWriteableStream)(l=>L.VSBuffer.concat(l.map(d=>L.VSBuffer.wrap(d))).buffer);return(0,f.readFileIntoStream)(this,n,o,l=>l.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(n,i,r){let o;try{const l=this.z(n);if(!r.create||!r.overwrite){if(await N.Promises.exists(l)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,k.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,k.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.Z(n,l)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(n){t.O=n}async open(n,i){const r=this.z(n);let o;(0,u.isFileOpenForWriteOptions)(i)&&(o=await this.I(n));let l;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await N.SymlinkSupport.stat(r);S.mode&128||await N.Promises.chmod(r,S.mode|128)}catch(S){this.a.trace(S)}let d;if((0,u.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await N.Promises.truncate(r,0),d="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}d||(d="w")}else d="r";l=await N.Promises.open(r,d)}catch(d){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.Z(n,d):this.Y(d)}if(this.L.set(l,0),(0,u.isFileOpenForWriteOptions)(i)&&this.N.set(l,n),o){const d=this.M.get(l);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.M.set(l,o),d&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),d.dispose())}return l}async close(n){const i=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&t.O)try{await N.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await N.Promises.close(n)}catch(r){throw this.Y(r)}finally{i&&(this.M.get(n)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,o,l){const d=this.P(n,i);let S=null;try{S=(await N.Promises.read(n,r,o,l,d)).bytesRead}catch(D){throw this.Y(D)}finally{this.Q(n,d,S)}return S}P(n,i){return i===this.L.get(n)?null:i}Q(n,i,r){const o=this.L.get(n);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.L.set(n,o+r):this.L.delete(n)))}async write(n,i,r,o,l){return(0,O.retry)(()=>this.R(n,i,r,o,l),100,3)}async R(n,i,r,o,l){const d=this.P(n,i);let S=null;try{S=(await N.Promises.write(n,r,o,l,d)).bytesWritten}catch(D){throw await this.Z(this.N.get(n),D)}finally{this.Q(n,d,S)}return S}async mkdir(n){try{await N.Promises.mkdir(this.z(n))}catch(i){throw this.Y(i)}}async delete(n,i){try{const r=this.z(n);i.recursive?await N.Promises.rm(r,N.RimRafMode.MOVE):await N.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(n,i,r){const o=this.z(n),l=this.z(i);if(o!==l)try{await this.S(n,i,"move",r.overwrite),await N.Promises.move(o,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,k.localize)(2,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(l)),d.toString()))),this.Y(d)}}async copy(n,i,r){const o=this.z(n),l=this.z(i);if(o!==l)try{await this.S(n,i,"copy",r.overwrite),await N.Promises.copy(o,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,k.localize)(3,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(l)),d.toString()))),this.Y(d)}}async S(n,i,r,o){const l=this.z(n),d=this.z(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,h.isEqual)(l,d,!0)),S&&r==="copy")throw(0,u.createFileSystemProviderError)((0,k.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!S&&await N.Promises.exists(d)){if(!o)throw(0,u.createFileSystemProviderError)((0,k.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.U(n,i,!1)}async U(n,i,r){const o=this.z(n),l=this.z(i),d=!!(this.capabilities&1024);if((0,h.isEqual)(o,l,!d))return;const S=new c.DisposableStore;try{const[D,j]=await Promise.all([this.I(n),this.I(i)]);S.add(D),S.add(j),r&&await N.Promises.mkdir((0,b.dirname)(l),{recursive:!0}),await N.Promises.copyFile(o,l)}catch(D){if(D.code==="ENOENT"&&!r)return this.U(n,i,!0);throw this.Y(D)}finally{S.dispose()}}p(n,i,r){return new g.UniversalWatcherClient(o=>n(o),o=>i(o),r)}w(n,i,r){return new P.NodeJSWatcherClient(o=>n(o),o=>i(o),r)}Y(n){if(n instanceof u.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,i)}async Z(n,i){let r=this.Y(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await N.SymlinkSupport.stat(this.z(n));o.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.C=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ie[124],ne([0,1,2,6]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class O extends T.Disposable{constructor(L,I=[]){super(),this.a=new A.MultiplexLogger([L,...I]),this.D(L.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...I){this.a.trace(L,...I)}debug(L,...I){this.a.debug(L,...I)}info(L,...I){this.a.info(L,...I)}warn(L,...I){this.a.warn(L,...I)}error(L,...I){this.a.error(L,...I)}flush(){this.a.flush()}}e.LogService=O}),define(ie[125],ne([0,1,13,6]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var O;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(O||(O={}));async function C(c,b,E,y,v){try{const N=await new Promise((u,f)=>{G(["spdlog"],u,f)});N.setFlushOn(O.Trace);const k=await N.createAsyncRotatingLogger(c,b,E,y);return v?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(N){console.error(N)}return null}function L(c,b,E){switch(b){case A.LogLevel.Trace:c.trace(E);break;case A.LogLevel.Debug:c.debug(E);break;case A.LogLevel.Info:c.info(E);break;case A.LogLevel.Warning:c.warn(E);break;case A.LogLevel.Error:c.error(E);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function I(c,b){switch(b){case A.LogLevel.Trace:c.setLevel(O.Trace);break;case A.LogLevel.Debug:c.setLevel(O.Debug);break;case A.LogLevel.Info:c.setLevel(O.Info);break;case A.LogLevel.Warning:c.setLevel(O.Warning);break;case A.LogLevel.Error:c.setLevel(O.Error);break;case A.LogLevel.Off:c.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class h extends A.AbstractMessageLogger{constructor(b,E,y,v,N){super(),this.k=[],this.setLevel(N),this.l=this.n(b,E,y,v),this.D(this.onDidChangeLogLevel(k=>{this.m&&I(this.m,k)}))}async n(b,E,y,v){const N=y?6:1,k=30/N*T.ByteSize.MB,u=await C(b,E,k,N,v);if(u){this.m=u,I(this.m,this.getLevel());for(const{level:f,message:p}of this.k)L(this.m,f,p);this.k=[]}}g(b,E){this.m?L(this.m,b,E):this.getLevel()<=b&&this.k.push({level:b,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(ie[126],ne([0,1,28,6,125]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends A.AbstractLoggerService{m(I,h,c){return new O.SpdLogLogger((0,T.generateUuid)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.LoggerService=C}),define(ie[38],ne([0,1,5,65,2,10]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class L extends O.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.i(c),A.Iterable.reduce(this.g.entries(),(E,[y,v])=>({...E,[y]:v}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[b,E])=>({...c,[b]:{definition:E,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=L;class I{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ie[127],ne([0,1,8,5,65,3,13,6,38]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(E,y){const v=[];for(const N of new Set(O.Iterable.concat(E.keys(),y.keys())))E.get(N)!==y.get(N)&&v.push(N);return v}let b=class extends h.AbstractPolicyService{constructor(y,v,N){super(),this.j=y,this.k=v,this.l=N,this.c=this.D(new T.ThrottledDelayer(500));const k=A.Event.filter(v.onDidFilesChange,u=>u.affects(y));this.D(v.watch(y)),this.D(k(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const v=await this.k.readFile(this.j),N=JSON.parse(v.value.toString());if(!(0,C.isObject)(N))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(N))this.f[k]&&y.set(k,N[k])}catch(v){v.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",v)}return y}async p(){const y=await this.n(),v=c(this.g,y);this.g=y,v.length>0&&this.h.fire(v)}};b=ye([te(1,L.IFileService),te(2,I.ILogService)],b),e.FilePolicyService=b}),define(ie[128],ne([0,1,38,8,167,2,6]),function(G,e,T,A,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends T.AbstractPolicyService{constructor(c,b){super(),this.j=c,this.k=b,this.a=new A.Throttler,this.b=this.D(new C.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,E)=>{try{this.b.value=(0,O.createWatcher)(this.k,c,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),E(y)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const E=c[b];E===void 0?this.g.delete(b):this.g.set(b,E)}this.h.fire(Object.keys(c))}};I=ye([te(0,L.ILogService)],I),e.NativePolicyService=I}),define(ie[31],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[37],ne([0,1,70,3]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class O{constructor(){this.a=new Map}add(L,I){T.ok(A.isString(L)),T.ok(A.isObject(I)),T.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,I)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new O}),define(ie[129],ne([0,1,5,37]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function O(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[O(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const L=new C;A.Registry.add(e.Extensions.JSONContribution,L)}),define(ie[42],ne([0,1,19,5,3,86,24,129,37]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=h.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const n=new Set;this.n(t,a,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const a=new Set;this.o(t,a),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const n=new Set;this.o(a,n),this.n(t,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const n=[];for(const{overrides:i,source:r}of t)for(const o in i)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.a.get(o),d=l?.valuesSources??new Map;if(r)for(const K of Object.keys(i[o]))d.set(K,r);const S={...l?.value||{},...i[o]};this.a.set(o,{source:r,value:S,valuesSources:d});const D=(0,L.getLanguageTagSettingPlainKey)(o),j={type:"object",default:S,description:C.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:O.isString(r)?void 0:r,defaultValueSource:r};n.push(...k(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:i[o],source:r});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(n)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:n,source:i}of t)for(const r in n){const o=this.a.get(r),l=O.isString(i)?i:i?.id,d=O.isString(o?.source)?o?.source:o?.source?.id;if(l===d)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const S=this.d[r];S&&(this.w(r,S),this.r(r,S))}}this.u()}deltaConfiguration(t){let a=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,n){t.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,a){const n=i=>{if(i.properties)for(const r in i.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.c.indexOf(i);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,n,i,r=3,o){r=O.isUndefinedOrNull(t.scope)?r:t.scope;const l=t.properties;if(l)for(const S in l){const D=l[S];if(a&&w(S,D)){delete l[S];continue}if(D.source=n,D.defaultDefaultValue=l[S].default,this.w(S,D),e.OVERRIDE_PROPERTY_REGEX.test(S)?D.scope=void 0:(D.scope=O.isUndefinedOrNull(D.scope)?r:D.scope,D.restricted=O.isUndefinedOrNull(D.restricted)?!!i?.includes(S):D.restricted),l[S].hasOwnProperty("included")&&!l[S].included){this.f[S]=l[S],delete l[S];continue}else this.d[S]=l[S],l[S].policy?.name&&this.e.set(l[S].policy.name,S);!l[S].deprecationMessage&&l[S].markdownDeprecationMessage&&(l[S].deprecationMessage=l[S].markdownDeprecationMessage),o.add(S)}const d=t.allOf;if(d)for(const S of d)this.p(S,a,n,i,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=n=>{const i=n.properties;if(i)for(const o in i)this.r(o,i[o]);n.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const n=this.a.get(t);let i=n?.value,r=n?.source;O.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),O.isUndefined(i)&&(i=f(a.type)),a.default=i,a.defaultValueSource=r}}const v="\\[([^\\]]+)\\]",N=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function k(P){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(P)){let a=N.exec(P);for(;a?.length;){const n=a[1].trim();n&&t.push(n),a=N.exec(P)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=k;function u(P){return P.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=u;function f(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new y;h.Registry.add(e.Extensions.Configuration,p);function w(P,t){return P.trim()?e.OVERRIDE_PROPERTY_REGEX.test(P)?C.localize(7,null,P):p.getConfigurationProperties()[P]!==void 0?C.localize(8,null,P):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,P,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=w;function g(){const P=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))P.push([a,t[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=g}),define(ie[66],ne([0,1,19,5,51,2,36,30,3,11,24,42,37]),function(G,e,T,A,O,C,L,I,h,c,b,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(a){return Object.isFrozen(a)?a:I.deepFreeze(a)}class N{constructor(n={},i=[],r=[],o){this.b=n,this.c=i,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof N)return i;const r=new k("");return r.parseRaw(i),r.configurationModel});this.f=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,b.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:l}}getOverrideValue(n,i){const r=this.i(i);return r?n?(0,b.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const d of n)if(l.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(i,d.contents);for(const S of d.overrides){const[D]=r.filter(j=>T.equals(j.identifiers,S.identifiers));D?(this.h(D.contents,S.contents),D.keys.push(...S.keys),D.keys=T.distinct(D.keys)):r.push(I.deepClone(S))}for(const S of d.keys)o.indexOf(S)===-1&&o.push(S)}return new N(i,o,r,l.every(d=>d instanceof N)?void 0:l)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const d=i[o];d&&(typeof l=="object"&&typeof d=="object"?(l=I.deepClone(l),this.h(l,d)):l=d),r[o]=l}return new N(r,this.keys,this.overrides)}h(n,i){for(const r of Object.keys(i)){if(r in n&&h.isObject(n[r])&&h.isObject(i[r])){this.h(n[r],i[r]);continue}n[r]=I.deepClone(i[r])}}i(n){let i=null,r=null;const o=l=>{l&&(r?this.h(r,l):r=I.deepClone(l))};for(const l of this.overrides)T.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&o(l.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,b.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}j(n,i,r){(0,b.addToValueTree)(this.contents,n,i,o=>console.error(o)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,b.toValuesTree)(this.contents[n],o=>console.error(o))})}}e.ConfigurationModel=N;class k{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new N}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!h.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:l,restricted:d,hasExcludedProperties:S}=this.h(n,i);this.b=new N(r,o,l,S?[n]:void 0),this.c=d||[]}g(n){let i={},r=null,o=[];const l=[],d=[];function S(j){Array.isArray(o)?o.push(j):r!==null&&(o[r]=j)}const D={onObjectBegin:()=>{const j={};S(j),l.push(o),o=j,r=null},onObjectProperty:j=>{r=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];S(j),l.push(o),o=j,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(j,K,Q)=>{d.push({error:j,offset:K,length:Q})}};if(n)try{O.visit(n,D),i=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}h(n,i){const r=y.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.i(n,r,!0,i);n=o.raw;const l=(0,b.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),d=Object.keys(n),S=this.j(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:l,keys:d,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(n,i,r,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const d={},S=[];for(const D in n)if(E.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const j=this.i(n[D],i,!1,o);d[D]=j.raw,l=l||j.hasExcludedProperties,S.push(...j.restricted)}else{const j=i[D],K=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&S.push(D),(K===void 0||o.scopes===void 0||o.scopes.includes(K))&&!(o.skipRestricted&&j?.restricted)?d[D]=n[D]:l=!0}return{raw:d,restricted:S,hasExcludedProperties:l}}j(n,i){const r=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const d in n[o])l[d]=n[o][d];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,b.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=k;class u extends C.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.D(new A.Emitter),this.onDidChange=this.c.event,this.a=new k(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(r.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(A.Event.any(A.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new N}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class f{constructor(n,i,r,o,l,d,S,D,j,K,Q,ee,se){this.a=n,this.b=i,this.c=r,this.overrideIdentifiers=o,this.d=l,this.f=d,this.g=S,this.h=D,this.i=j,this.j=K,this.k=Q,this.l=ee,this.m=se}get value(){return v(this.c)}n(n,i,r){const o=n.inspect(i,r);return{get value(){return v(o.value)},get override(){return v(o.override)},get merged(){return v(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(n,i,r,o,l=new N,d=new N,S=new L.ResourceMap,D=new N,j=new L.ResourceMap){this.c=n,this.d=i,this.f=r,this.g=o,this.h=l,this.i=d,this.j=S,this.l=D,this.m=j,this.a=null,this.b=new L.ResourceMap,this.n=null}getValue(n,i,r){return this.q(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new N,this.m.set(r.resource,o))):o=this.l,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.q(n,i,r),l=this.u(i.resource,r),d=i.resource?this.m.get(i.resource)||this.l:this.l,S=new Set;for(const D of o.overrides)for(const j of D.identifiers)o.getOverrideValue(n,j)!==void 0&&S.add(j);return new f(n,i,o.getValue(n),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,l||void 0,d)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:l,removed:d}=P(this.c,n);i=[...o,...l,...d]}for(const o of i)for(const l of(0,E.overrideIdentifiersFromKey)(o)){const d=this.c.getKeysForOverrideIdentifier(l),S=n.getKeysForOverrideIdentifier(l),D=[...S.filter(j=>d.indexOf(j)===-1),...d.filter(j=>S.indexOf(j)===-1),...d.filter(j=>!I.equals(this.c.override(l).getValue(j),n.override(l).getValue(j)))];r.push([l,D])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=P(this.d,n),l=[...i,...r,...o];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=P(this.applicationConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=P(this.localUserConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=P(this.remoteUserConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=P(this.workspaceConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const r=this.p.get(n),{added:o,updated:l,removed:d,overrides:S}=P(r,i),D=[...o,...l,...d];return(D.length||!r)&&this.updateFolderConfiguration(n,i),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:l,overrides:d}=P(i,void 0);return{keys:[...r,...o,...l],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,r){let o=this.r(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}r({resource:n},i){let r=this.s();if(i&&n){const o=i.getFolder(n);o&&(r=this.t(o.uri)||r);const l=this.m.get(n);l&&(r=r.merge(l))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const r=this.s(),o=this.j.get(n);o?(i=r.merge(o),this.b.set(n,i)):i=r}return i}u(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:l}=this.j.get(i);return n.push([i,{contents:r,overrides:o,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.i.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.x(n.defaults),r=this.x(n.policy),o=this.x(n.application),l=this.x(n.user),d=this.x(n.workspace),S=n.folders.reduce((D,j)=>(D.set(c.URI.revive(j[0]),this.x(j[1])),D),new L.ResourceMap);return new p(i,r,o,l,new N,d,S,new N,new L.ResourceMap)}static x(n){return new N(n.contents,n.keys,n.overrides)}}e.Configuration=p;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const o of a)o.keys.forEach(l=>n.add(l)),o.overrides.forEach(([l,d])=>{const S=(0,L.getOrSet)(i,l,new Set);d.forEach(D=>S.add(D))});const r=[];return i.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=w;class g{constructor(n,i,r,o){this.change=n,this.f=i,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const d of l)this.affectedKeys.add(d);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(n,i){const r=this.a+n,o=this.d.indexOf(r);if(o<0)return!1;const l=o+r.length;if(l>=this.d.length)return!1;const d=this.d.charCodeAt(l);if(d!==this.b&&d!==this.c)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,D=this.g.getValue(n,i,this.h);return!I.equals(S,D)}return!0}}e.ConfigurationChangeEvent=g;function P(a,n){const{added:i,removed:r,updated:o}=t(n?.rawConfiguration,a?.rawConfiguration),l=[],d=a?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const D=S.filter(j=>!d.includes(j));for(const j of D)l.push([j,n.getKeysForOverrideIdentifier(j)])}if(a){const D=d.filter(j=>!S.includes(j));for(const j of D)l.push([j,a.getKeysForOverrideIdentifier(j)])}if(n&&a){for(const D of d)if(S.includes(D)){const j=t({contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});l.push([D,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:r,updated:o,overrides:l}}function t(a,n){const i=a?n?a.keys.filter(l=>n.keys.indexOf(l)===-1):[...a.keys]:[],r=n?a?n.keys.filter(l=>a.keys.indexOf(l)===-1):[...n.keys]:[],o=[];if(a&&n){for(const l of n.keys)if(a.keys.indexOf(l)!==-1){const d=(0,b.getConfigurationValue)(n.contents,l),S=(0,b.getConfigurationValue)(a.contents,l);I.equals(d,S)||o.push(l)}}return{added:i,removed:r,updated:o}}}),define(ie[130],ne([0,1,19,5,2,30,3,66,42,6,38,37]),function(G,e,T,A,O,C,L,I,h,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends O.Disposable{constructor(){super(...arguments),this.a=this.D(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(E.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.c(Array.from(u),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,f){this.h(u,E.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new I.ConfigurationModel;const u=E.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,f){const p=this.f();for(const w of u){const g=p[w],P=f[w];g!==void 0?this.b.addValue(w,g):P?this.b.addValue(w,P.default):this.b.removeValue(w)}}}e.DefaultConfiguration=y;class v{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let N=class extends O.Disposable{get configurationModel(){return this.b}constructor(u,f,p){super(),this.c=u,this.f=f,this.g=p,this.a=this.D(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(u=>this.i(u))),this.D(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},p=[],w=E.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const g of u){const P=w[g];if(!P){p.push(g);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}p.push(g),f[P.policy.name]={type:P.type}}}return(0,L.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),p}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const f=E.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),p=(0,T.coalesce)(u.map(w=>f.get(w)));this.j(p,!0)}j(u,f){this.g.trace("PolicyConfiguration#update",u);const p=E.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),w=[],g=this.b.isEmpty();for(const P of u){const t=p[P]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(g?a!==void 0:!(0,C.equals)(this.b.getValue(P),a))&&w.push([P,a])}else this.b.getValue(P)!==void 0&&w.push([P,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const P=this.b;this.b=new I.ConfigurationModel;for(const t of P.keys)this.b.setValue(t,P.getValue(t));for(const[t,a]of w)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);f&&this.a.fire(this.b)}}};N=ye([te(1,b.IPolicyService),te(2,c.ILogService)],N),e.PolicyConfiguration=N}),define(ie[131],ne([0,1,8,5,2,17,24,66,130,38]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends O.Disposable{constructor(y,v,N,k){super(),this.i=y,this.h=this.D(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new h.DefaultConfiguration),this.c=N instanceof c.NullPolicyService?new h.NullPolicyConfiguration:this.D(new h.PolicyConfiguration(this.b,N,k)),this.f=this.D(new I.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,v)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.D(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:u,properties:f})=>this.k(u,f))),this.D(this.c.onDidChangeConfiguration(u=>this.l(u))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,v,N]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(y,v,new I.ConfigurationModel,N)}getConfigurationData(){return this.a.toData()}getValue(y,v){const N=typeof y=="string"?y:void 0,k=(0,L.isConfigurationOverrides)(y)?y:(0,L.isConfigurationOverrides)(v)?v:{};return this.a.getValue(N,k,void 0)}updateValue(y,v,N,k){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const v=this.a.toData(),N=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(N,v,2)}k(y,v){const N=this.a.toData(),k=this.a.compareAndUpdateDefaultConfiguration(y,v);this.m(k,N,7)}l(y){const v=this.a.toData(),N=this.a.compareAndUpdatePolicyConfiguration(y);this.m(N,v,7)}m(y,v,N){const k=new I.ConfigurationChangeEvent(y,{data:v},this.a);k.source=N,k.sourceConfig=this.n(N),this.h.fire(k)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ie[67],ne([0,1,16]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(c){return c.scheme===T.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=A;function O(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.getRemoteName=O;function C(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=C;function L(c){const{host:b,port:E}=h(c);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:E}}e.parseAuthorityWithPort=L;function I(c,b){let{host:E,port:y}=h(c);return typeof y>"u"&&(y=b),{host:E,port:y}}e.parseAuthorityWithOptionalPort=I;function h(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const E=c.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(ie[32],ne([0,1,29,10,67]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.getWorkspaceSupportTypeMessage=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));var I;(function(k){k.WIN32_X64="win32-x64",k.WIN32_IA32="win32-ia32",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(u){this.value=u,this.c=u.toLowerCase()}static equals(u,f){if(typeof u>"u"||u===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof u=="string"||typeof f=="string"){const p=typeof u=="string"?u:u.value,w=typeof f=="string"?f:f.value;return T.equalsIgnoreCase(p,w)}return u.c===f.c}static toKey(u){return typeof u=="string"?u.toLowerCase():u.c}}e.ExtensionIdentifier=h;class c{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const f of u)this.add(f)}add(u){this.c.add(h.toKey(u))}delete(u){return this.c.delete(h.toKey(u))}has(u){return this.c.has(h.toKey(u))}}e.ExtensionIdentifierSet=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(h.toKey(u))}get(u){return this.c.get(h.toKey(u))}has(u){return this.c.has(h.toKey(u))}set(u,f){this.c.set(h.toKey(u),f)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=b;function E(k){return y(k)}e.isApplicationScopedExtension=E;function y(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function v(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function N(k,u){if(u){const f=`onResolveRemoteAuthority:${(0,O.getRemoteName)(u)}`;return!!k.activationEvents?.includes(f)}return!1}e.isResolverExtension=N,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[132],ne([0,1,2,15,20,32]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends T.Disposable{constructor(h,c){super(),this.b=h,this.a=(0,A.join)(this.b.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this.D(c.onDidInstallExtensions(b=>this.c(b))),this.D(c.onDidUninstallExtension(b=>this.f(b)))}c(h){h.some(c=>!!c.local)&&this.invalidate()}f(h){h.error||this.invalidate()}invalidate(){O.Promises.rm(this.a,O.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(ie[43],ne([0,1,14,9,2,101,42,10,6,37]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class b{constructor(P){this.b=P}toJSON(){if(!this.a){const P=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?P[t]="*****":P[t]=this.b[t];this.a=P}return this.a}}class E extends O.Disposable{constructor(P,t){super(),this.b=0,this.a=t.createLogger("request",{name:P?(0,C.localize)(0,null):(0,C.localize)(1,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async c(P,t,a){const n=`${P} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new b(t.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,A.getErrorMessage)(i)),i}}}e.AbstractRequestService=E;function y(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=y;function v(g){return g.res.statusCode===204}async function N(g){return v(g)?null:(await(0,T.streamToBuffer)(g.stream)).toString()}e.asText=N;async function k(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);return N(g)}e.asTextOrError=k;async function u(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);if(v(g))return null;const t=(await(0,T.streamToBuffer)(g.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=u;function f(g){w(g)}e.updateProxyConfigurationsScope=f;let p;function w(g){const P=c.Registry.as(L.Extensions.Configuration),t=p;p={id:"http",order:15,title:(0,C.localize)(2,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(6,null),(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null)],default:"override",description:(0,C.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(11,null),restricted:!0}}},P.updateConfigurations({add:[p],remove:t?[t]:[]})}w(2)}),define(ie[133],ne([0,1,23,16,13,43]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,b=T.CancellationToken.None){if(h.scheme===A.Schemas.file||h.scheme===A.Schemas.vscodeRemote){await this.b.copy(h,c);return}const E={type:"GET",url:h.toString(!0)},y=await this.a.request(E,b);if(y.res.statusCode===200)await this.b.writeFile(c,y.stream);else{const v=await(0,C.asTextOrError)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${v}`)}}};L=ye([te(0,C.IRequestService),te(1,O.IFileService)],L),e.DownloadService=L}),define(ie[134],ne([0,1,135,3]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function O(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(L,I,h={}){const c=(0,T.parse)(L),b=h.proxyUrl||O(c,I);if(!b)return null;const E=(0,T.parse)(b);if(!/^https?:$/.test(E.protocol||""))return null;const y={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,A.isBoolean)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((v,N)=>{G(["http-proxy-agent"],v,N)}))(y):new(await new Promise((v,N)=>{G(["https-proxy-agent"],v,N)}))(y)}e.getProxyAgent=C}),define(ie[136],ne([0,1,58,15,102,23,34,9,12,28,82,168,8,71]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let N;async function k(f,p,w,g){return w["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!w["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),N||(N=y.Promises.withAsyncBody(async(P,t)=>{const a=new C.CancellationTokenSource;let n=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,v.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,O.localize)(0,null)))},n);try{P(await u(p,a.token))}catch(o){!(0,I.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,O.localize)(1,null,(0,L.toErrorMessage)(o)))):P({})}finally{clearTimeout(r),a.dispose()}})),N)}e.getResolvedShellEnv=k;async function u(f,p){const w=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",w);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",g);const P=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",a);const n=await(0,b.getSystemShell)(h.OS,a);return f.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(p.isCancellationRequested)return r(new I.CancellationError);const o=(0,A.basename)(n);let l,d;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${S} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' ${S} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,o==="tcsh"||o==="csh"?d=["-ic"]:d=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const D=(0,T.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(D.kill(),r(new I.CancellationError))),D.on("error",Q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(Q)),r(Q)});const j=[];D.stdout.on("data",Q=>j.push(Q));const K=[];D.stderr.on("data",Q=>K.push(Q)),D.on("close",(Q,ee)=>{const se=Buffer.concat(j).toString("utf8");f.trace("getUnixShellEnvironment#raw",se);const re=Buffer.concat(K).toString("utf8");if(re.trim()&&f.trace("getUnixShellEnvironment#stderr",re),Q||ee)return r(new Error((0,O.localize)(2,null,Q,ee)));const le=t.exec(se),fe=le?le[1]:"{}";try{const ae=JSON.parse(fe);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,g?ae.ELECTRON_NO_ATTACH_CONSOLE=g:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){f.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ae)),r(ae)}})})}}),define(ie[137],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,T.createDecorator)("stateReadService"),e.IStateService=(0,T.createDecorator)("stateService")}),define(ie[68],ne([0,1,8,14,3,18,13,6]),function(G,e,T,A,O,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(h=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(v,N,k,u){this.f=v,this.g=k,this.h=u,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=N===0?void 0:new T.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,N){const k=this.a[v];return(0,O.isUndefinedOrNull)(k)?N:k}setItem(v,N){this.setItems([{key:v,data:N}])}setItems(v){let N=!1;for(const{key:k,data:u}of v)this.a[k]!==u&&((0,O.isUndefinedOrNull)(u)?(0,O.isUndefined)(this.a[k])||(this.a[k]=void 0,N=!0):(this.a[k]=u,N=!0));N&&this.j()}removeItem(v){(0,O.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(v)),this.b=v}catch(N){this.g.error(N)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let b=class{constructor(v,N,k,u){this.a=new c(N.stateResource,v,k,u)}async init(){await this.a.init()}getItem(v,N){return this.a.getItem(v,N)}};b=ye([te(1,C.IEnvironmentService),te(2,I.ILogService),te(3,L.IFileService)],b),e.StateReadonlyService=b;class E extends b{setItem(v,N){this.a.setItem(v,N)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.StateService=E}),define(ie[69],ne([0,1,12,35,11,28]),function(G,e,T,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(c){if(T.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function I(c,b,E,y,v,N,k,u,f,p){const w=Object.create(null);w["common.machineId"]=k,w.sessionID=(0,C.generateUuid)()+Date.now(),w.commitHash=v,w.version=N,w["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,T.PlatformToString)(T.platform),w["common.nodePlatform"]=A.platform,w["common.nodeArch"]=y,w["common.product"]=p||"desktop",u&&(w["common.msftInternal"]=u);let g=0;const P=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-P,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),T.isLinuxSnap&&(w["common.snap"]="true");const t=L(E);t&&(w["common.platformDetail"]=t);try{const a=await c.readFile(O.URI.file(f));w["common.source"]=a.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=I;function h(c){const b=A.env.USERDNSDOMAIN;if(!b)return!1;const E=b.toLowerCase();return c.some(y=>E===y)}e.verifyMicrosoftInternalDomain=h}),define(ie[25],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var O;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(O=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[39],ne([0,1,30,3,5,24,67,69,25]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(r){this.value=r}}e.TelemetryTrustedValue=c;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class E{async publicLog(r,o,l){}async publicLogError(r,o,l){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return O.Event.debounce(r.onDidChangeConfiguration,(l,d)=>{const S=l?new Set([...l.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:S}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=y;function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=v;function N(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=N;function k(i){const r=i.getValue(h.TELEMETRY_SETTING_ID),o=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=k;function u(i){const r={},o={},l={};w(i,l);for(let d in l){d=d.length>150?d.substr(d.length-149):d;const S=l[d];typeof S=="number"?o[d]=S:typeof S=="boolean"?o[d]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${S.length}`),r[d]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(r[d]=S)}return{properties:r,measurements:o}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const r=(0,L.getRemoteName)(i);return f.has(r)?r:"other"}e.cleanRemoteAuthority=p;function w(i,r,o=0,l){if(!!i)for(const d of Object.getOwnPropertyNames(i)){const S=i[d],D=l?l+d:d;Array.isArray(S)?r[D]=(0,T.safeStringify)(S):S instanceof Date?r[D]=S.toISOString():(0,A.isObject)(S)?o<2?w(S,r,o+1,D+"."):r[D]=(0,T.safeStringify)(S):r[D]=S}}function g(i,r){const o=i.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(o)||l}e.isInternalTelemetry=g;function P(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=P;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const j of r)for(;;){const K=j.exec(i);if(!K)break;l.push([K.index,j.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(o="";;){const j=S.exec(i);if(!j)break;const K=l.some(([Q,ee])=>j.index<ee&&Q<S.lastIndex);!d.test(j[0])&&!K&&(o+=i.substring(D,j.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<i.length&&(o+=i.substr(D)),o}function a(i){if(!i)return i;const r=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of o)if(l.regex.test(r))return`<REDACTED: ${l.label}>`;return i}function n(i,r){return(0,T.cloneAndChange)(i,o=>{if(o instanceof c)return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=t(l,r);for(const d of r)l=l.replace(d,"");return l=a(l),l}})}e.cleanData=n}),define(ie[26],ne([0,1,29,21,32,12,11,9,35,39]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=b;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,r,o)}static parse(i){const r=E.exec(i);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function N(n){const i=v.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=N;function k(n,i){return`${n}.${i}`}e.getExtensionId=k;function u(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(n,i){return u(k(n,i))}e.getGalleryExtensionId=f;function p(n,i){const r=[],o=l=>{for(const d of r)if(d.some(S=>b(i(S),i(l))))return d;return null};for(const l of n){const d=o(l);d?d.push(l):r.push([l])}return r}e.groupByExtension=p;function w(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function g(n){return{id:new c.TelemetryTrustedValue(n.identifier.id),name:new c.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function P(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&r.every(d=>!b(d.identifier,{id:l}))){const d=n.filter(S=>b(S.identifier,{id:l}));d.length===1&&(r.push(d[0]),o.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=P;async function t(n,i){if(!C.isLinux)return!1;let r;try{r=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const r=await t(n,i),o=(0,A.getTargetPlatform)(r?"alpine":C.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ie[138],ne([0,1,23,9,16,17,41,11,91,21,26,32]),function(G,e,T,A,O,C,L,I,h,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const y=u=>(0,h.localize)(0,null,u),v=(0,h.localize)(1,null,"ms-dotnettools.csharp");function N(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let k=class{constructor(f,p){this.a=f,this.b=p}get d(){}async listExtensions(f,p,w,g=console){let P=await this.a.getInstalled(1,w);const t=E.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(p&&p!==""){if(t.indexOf(p.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}P=P.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){g.log("Possible Categories: "),t.forEach(n=>{g.log(n)});return}this.d&&g.log((0,h.localize)(2,null,this.d)),P=P.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let a;for(const n of P)a!==n.identifier.id&&(a=n.identifier.id,g.log(N(n.manifest,f)))}async installExtensions(f,p,w,g,P=console){const t=[],a=[];f.length&&P.log(this.d?(0,h.localize)(3,null,this.d):(0,h.localize)(4,null));const n=await this.a.getInstalled(1,w.profileLocation),i=(d,S)=>{const D=n.find(j=>(0,b.areSameExtensions)(j.identifier,{id:d}));if(D){if(!g&&(!S||S==="prerelease"&&D.preRelease))return P.log((0,h.localize)(5,null,d,D.manifest.version,d)),!1;if(S&&D.manifest.version===S)return P.log((0,h.localize)(6,null,`${d}@${S}`)),!1}return!0},r=(d,S,D)=>{l.push({id:d,version:S!=="prerelease"?S:void 0,installOptions:{...w,isBuiltin:D,installPreReleaseVersion:S==="prerelease"||w.installPreReleaseVersion}})},o=[],l=[];for(const d of f)if(d instanceof I.URI)o.push({vsix:d,installOptions:w});else{const[S,D]=(0,b.getIdAndVersion)(d);i(S,D)&&r(S,D,!1)}for(const d of p)if(d instanceof I.URI)o.push({vsix:d,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!1}});else{const[S,D]=(0,b.getIdAndVersion)(d);i(S,D)&&r(S,D,!0)}if(o.length&&await Promise.all(o.map(async({vsix:d,installOptions:S})=>{try{const D=await this.f(d,S,g,P);D&&a.push(D)}catch(D){P.error(D.message||D.stack||D),t.push(d.toString())}})),l.length){const d=await this.g(l);await Promise.all(l.map(async S=>{const D=d.get(S.id.toLowerCase());if(D)try{const j=await this.h(S,D,n,g,P);j&&a.push(j)}catch(j){P.error(j.message||j.stack||j),t.push(S.id)}else P.error(`${y(S.version?`${S.id}@${S.version}`:S.id)}
${v}`),t.push(S.id)}))}if(t.length)throw new Error((0,h.localize)(7,null,t.join(", ")))}async f(f,p,w,g){const P=await this.a.getManifest(f);if(!P)throw new Error("Invalid vsix");if(await this.k(P,w,p.profileLocation,g))try{return await this.a.install(f,p),g.log((0,h.localize)(8,null,(0,C.basename)(f))),P}catch(a){if((0,A.isCancellationError)(a))return g.log((0,h.localize)(9,null,(0,C.basename)(f))),null;throw a}return null}async g(f){const p=new Map,w=f.some(P=>P.installOptions.installPreReleaseVersion),g=await this.b.getExtensions(f.map(P=>({...P,preRelease:w})),T.CancellationToken.None);for(const P of g)p.set(P.identifier.id.toLowerCase(),P);return p}async h({id:f,version:p,installOptions:w},g,P,t,a){const n=await this.b.getManifest(g,T.CancellationToken.None);if(n&&!this.j(n,a))return null;const i=P.find(r=>(0,b.areSameExtensions)(r.identifier,g.identifier));if(i){if(g.version===i.manifest.version)return a.log((0,h.localize)(10,null,p?`${f}@${p}`:f)),null;a.log((0,h.localize)(11,null,f,g.version))}try{w.isBuiltin?a.log(p?(0,h.localize)(12,null,f,p):(0,h.localize)(13,null,f)):a.log(p?(0,h.localize)(14,null,f,p):(0,h.localize)(15,null,f));const r=await this.a.installFromGallery(g,{...w,installGivenVersion:!!p});return a.log((0,h.localize)(16,null,f,r.manifest.version)),n}catch(r){if((0,A.isCancellationError)(r))return a.log((0,h.localize)(17,null,f)),null;throw r}}j(f,p){return!0}async k(f,p,w,g){const P={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},a=(await this.a.getInstalled(1,w)).find(n=>(0,b.areSameExtensions)(P,n.identifier)&&(0,L.gt)(n.manifest.version,f.version));return a&&!p?(g.log((0,h.localize)(18,null,a.identifier.id,a.manifest.version,f.version)),!1):this.j(f,g)}async uninstallExtensions(f,p,w,g=console){const P=async a=>{if(a instanceof I.URI){const n=await this.a.getManifest(a);return N(n)}return a},t=[];for(const a of f){const n=await P(a),r=(await this.a.getInstalled(void 0,w)).filter(o=>(0,b.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.l(n)}
${v}`);if(r.some(o=>o.type===0)){g.log((0,h.localize)(19,null,n));return}if(!p&&r.some(o=>o.isBuiltin)){g.log((0,h.localize)(20,null,n));return}g.log((0,h.localize)(21,null,n));for(const o of r)await this.a.uninstall(o,{profileLocation:w}),t.push(o);this.d?g.log((0,h.localize)(22,null,n,this.d)):g.log((0,h.localize)(23,null,n))}}async locateExtension(f,p=console){const w=await this.a.getInstalled();f.forEach(g=>{w.forEach(P=>{if(P.identifier.id===g&&P.location.scheme===O.Schemas.file){p.log(P.location.fsPath);return}})})}l(f){return this.d?(0,h.localize)(24,null,f,this.d):(0,h.localize)(25,null,f)}};k=ye([te(0,c.IExtensionManagementService),te(1,c.IExtensionGalleryService)],k),e.ExtensionManagementCLI=k}),define(ie[139],ne([0,1,5,2,36,26,32]),function(G,e,T,A,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends A.Disposable{constructor(c,b,E,y,v,N,k){super(),this.f=c,this.g=b,this.h=E,this.i=y,this.j=v,this.k=N,this.l=k,this.a=this.D(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.D(new A.DisposableMap),this.m().then(null,u=>k.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.z()}n(){this.D(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.D(this.i.onAddExtensions(c=>this.q(c))),this.D(this.i.onDidAddExtensions(c=>this.r(c))),this.D(this.i.onRemoveExtensions(c=>this.s(c))),this.D(this.i.onDidRemoveExtensions(c=>this.t(c))),this.D(this.k.onDidFilesChange(c=>this.u(c)))}async p(c,b){try{await Promise.all(b.map(E=>(this.c.deleteAndDispose(E.id),this.y(E.extensionsResource)))),c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,A.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.w(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async q(c){for(const b of c.extensions)this.C(this.G(b.identifier,b.version),c.profileLocation)}async r(c){for(const b of c.extensions){const E=this.G(b.identifier,b.version);c.error?this.F(E,c.profileLocation):this.C(E,c.profileLocation)}}async s(c){for(const b of c.extensions)this.F(this.G(b.identifier,b.version),c.profileLocation)}async t(c){const b=[],E=[];for(const y of c.extensions){const v=this.G(y.identifier,y.version);c.error?this.C(v,c.profileLocation):(this.F(v,c.profileLocation),this.b.has(v)||(this.l.debug("Extension is removed from all profiles",y.identifier.id,y.version),E.push(this.f.scanInstalledExtensionAtLocation(y.location).then(N=>{N?b.push(N):this.l.info("Extension not found at the location",y.location.toString())},N=>this.l.error(N)))))}try{await Promise.all(E),b.length&&await this.z(b)}catch(y){this.l.error(y)}}u(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.v(b.extensionsResource)}async v(c){const b=[],E=[],y=await this.i.scanProfileExtensions(c),v=new Set,N=new Set;for(const[k,u]of this.b)u.has(c)&&N.add(k);for(const k of y){const u=this.G(k.identifier,k.version);v.add(u),N.has(u)||(b.push(k.identifier),this.C(u,c))}for(const k of N)if(!v.has(k)){const u=this.H(k);u&&(E.push(u.identifier),this.F(k,c))}(b.length||E.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:E.length?{extensions:E,profileLocation:c}:void 0})}async w(c){const b=await this.i.scanProfileExtensions(c);for(const E of b)this.C(this.G(E.identifier,E.version),c)}async y(c){for(const b of[...this.b.keys()])this.F(b,c);await this.z()}async z(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}C(c,b){let E=this.b.get(c);E||this.b.set(c,E=new O.ResourceSet(y=>this.j.extUri.getComparisonKey(y))),E.add(b)}F(c,b){const E=this.b.get(c);E&&E.delete(b),E?.size||this.b.delete(c)}G(c,b){return`${L.ExtensionIdentifier.toKey(c.id)}@${b}`}H(c){const[b,E]=(0,C.getIdAndVersion)(c);return E?{identifier:{id:b},version:E}:void 0}}e.ExtensionsWatcher=I}),define(ie[140],ne([0,1,111,39]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function O(C,L,I,h,c,b,E){const y={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${L.nameShort})`};if((0,A.supportsTelemetry)(L,I)&&(0,A.getTelemetryLevel)(h)===3){const v=await(0,T.getServiceMachineId)(I,c,b),{machineId:N}=await E.getTelemetryInfo();y["X-Market-User-Id"]=v,y["VSCode-SessionId"]=N||v}return y}e.resolveMarketplaceHeaders=O}),define(ie[141],ne([0,1,169,19,8,2,16,15,20,18,21,26,6,64,11]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let k=class extends v.LanguagePackBaseService{constructor(w,g,P,t){super(P),this.h=w,this.i=t,this.g=this.D(new u(g,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(w,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.i.warn(`No language pack found for ${g}`);return}const a=t.translations[w];return a?N.URI.file(a):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),g=Object.keys(w).map(P=>{const t=w[P];return{...this.f(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((P,t)=>P.label.localeCompare(t.label)),g}async j(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",w.identifier.id),await this.update())}async k(w){const g=await this.g.getLanguagePacks();Object.keys(g).some(P=>g[P]&&g[P].extensions.some(t=>(0,E.areSameExtensions)(t.extensionIdentifier,w.identifier)))&&(this.i.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(g);return!(0,A.equals)(Object.keys(w),Object.keys(P))}};k=ye([te(0,b.IExtensionManagementService),te(1,c.INativeEnvironmentService),te(2,b.IExtensionGalleryService),te(3,y.ILogService)],k),e.NativeLanguagePackService=k;let u=class extends C.Disposable{constructor(w,g){super(),this.i=g,this.c={},this.f=(0,I.join)(w.userDataPath,"languagepacks.json"),this.g=new O.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.m(g=>{Object.keys(g).forEach(P=>delete g[P]),this.j(g,...w)}).then(()=>this.c)}j(w,...g){for(const P of g)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.k(w,P);Object.keys(w).forEach(P=>this.l(w[P]))}k(w,g){const P=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const a of t)if(g.location.scheme===L.Schemas.file&&f(a)){let n=w[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},w[a.languageId]=n);const i=n.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,P))[0];i?i.version=g.manifest.version:n.extensions.push({extensionIdentifier:P,version:g.manifest.version});for(const r of a.translations)n.translations[r.id]=(0,I.join)(g.location.fsPath,r.path)}}l(w){if(w){const g=(0,T.createHash)("md5");for(const P of w.extensions)g.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);w.hash=g.digest("hex")}}m(w=()=>null){return this.g.queue(()=>{let g=null;return h.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(g=w(P),P)).then(P=>{for(const a of Object.keys(P))P[a]||delete P[a];this.c=P,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),h.Promises.writeFile(this.f,t)}).then(()=>g,P=>this.i.error(P))})}};u=ye([te(0,c.INativeEnvironmentService),te(1,y.ILogService)],u);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const w of p.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[142],ne([0,1,9,30,39]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",L="https://mobile.events.data.microsoft.com/ping";async function I(c,b,E){const y=await new Promise((f,p)=>{G(["@microsoft/1ds-core-js"],f,p)}),v=await new Promise((f,p)=>{G(["@microsoft/1ds-post-js"],f,p)}),N=new y.AppInsightsCore,k=new v.PostChannel,u={instrumentationKey:c,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[k]]};if(E){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:E};u.extensionConfig[k.identifier]=f}return N.initialize(u,[]),N.addTelemetryInitializer(f=>{b&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),N}class h{constructor(b,E,y,v,N){this.e=b,this.f=E,this.g=y,this.h=N,this.c=C,this.d=L,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(E=>{b(E)},E=>{(0,T.onUnexpectedError)(E),console.error(E)})}}log(b,E){if(!this.a)return;E=(0,A.mixin)(E,this.g),E=(0,O.validateTelemetryData)(E);const y=this.f+"/"+b;try{this.i(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:y,baseData:{name:y,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(ie[143],ne([0,1,2,30,12,29,103,24,42,144,31,37,25,39]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let N=class{constructor(f,p,w){this.k=p,this.l=w,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(y.TELEMETRY_SETTING_ID)||g.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||g.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,p){this.d[f]=p}m(){let f=(0,v.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const w=p.usage?3:p.error?2:0;f=Math.min(f,w)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,p=f.sessionID,w=f["common.machineId"],g=f["common.firstSessionDate"],P=f["common.msftInternal"];return{sessionId:p,machineId:w,firstSessionDate:g,msftInternal:P}}dispose(){this.i.dispose()}n(f,p,w){return this.g<p?Promise.resolve(void 0):this.c.then(g=>{w=(0,A.mixin)(w,this.d),w=(0,v.cleanData)(w,this.j),w=(0,A.mixin)(w,g),this.b.forEach(P=>P.log(f,w))},g=>{console.error(g)})}publicLog(f,p){return this.n(f,3,p)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return this.h?this.n(f,2,p):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}};N.IDLE_START_EVENT_NAME="UserIdleStart",N.IDLE_STOP_EVENT_NAME="UserIdleStop",N=ye([te(1,I.IConfigurationService),te(2,b.IProductService)],N),e.TelemetryService=N;function k(){const u=(0,L.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=O.isWeb?"":(0,L.localize)(3,null),w=(0,L.localize)(4,null),g=(0,L.localize)(5,null),P=(0,L.localize)(6,null),t=(0,L.localize)(7,null),a=`
|       | ${w} | ${g} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${u} ${f} ${p}

&nbsp;

${t}
${a}

&nbsp;

${n}
`}E.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[145],ne([0,1,170,142]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class O extends A.AbstractOneDataSystemAppender{constructor(L,I,h,c){const b={sendPOST:(E,y)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const N=T.request(E.urlString,v,k=>{k.on("data",function(u){y(k.statusCode??200,k.headers,u.toString())}),k.on("error",function(u){y(0,{})})});N.write(E.data),N.end()}catch{y(0,{})}}};super(L,I,h,c,b)}}e.OneDataSystemAppender=O}),define(ie[146],ne([0,1,15,20]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function O(C,L){const I=Object.create(null),h=(b,E)=>{const y=JSON.parse(b);I[E]=y};if(L){const b=[],E=await A.Promises.readdir(L);for(const v of E)try{(await A.Promises.stat((0,T.join)(L,v))).isDirectory()&&b.push(v)}catch{}const y=[];for(const v of b)(await A.Promises.readdir((0,T.join)(L,v))).filter(k=>k==="telemetry.json").length===1&&y.push(v);for(const v of y){const N=(await A.Promises.readFile((0,T.join)(L,v,"telemetry.json"))).toString();h(N,v)}}let c=(await A.Promises.readFile((0,T.join)(C,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await A.Promises.readFile((0,T.join)(C,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(I,null,4)}e.buildTelemetryMessage=O}),define(ie[147],ne([0,1,12,80,25]),function(G,e,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(L){let I=L.getItem(O.machineIdKey);return(typeof I!="string"||T.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,A.getMachineId)()),I}e.resolveMachineId=C}),define(ie[27],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(ie[148],ne([0,1,27,112,13,17,72,5,2]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let b=class{constructor(y){this.g=y,this.c=new h.DisposableStore,this.f=2**16;const v=new Map,N=k=>{let u=v.get(k.scheme);return u===void 0&&(u=y.hasProvider(k)&&!this.g.hasCapability(k,1024),v.set(k.scheme,u)),u};this.c.add(I.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(k=>{v.delete(k.scheme)})),this.extUri=new C.ExtUri(N),this.d=new L.SkipList((k,u)=>this.extUri.compare(k,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,C.normalizePath)(y));const v=this.d.get(y);return v?v.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((N,k)=>N[1].time<k[1].time?1:N[1].time>k[1].time?-1:0);c._clock=0,this.d.clear();const v=this.f*.5;for(let N=0;N<v;N++)this.d.set(y[N][0],y[N][1].touch())}};b=ye([te(0,O.IFileService)],b),e.UriIdentityService=b,(0,A.registerSingleton)(T.IUriIdentityService,b,1)}),define(ie[149],ne([0,1,105,15,55,17,11,10,16]),function(G,e,T,A,O,C,L,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(i){const r=i;return typeof r?.id=="string"&&L.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=c;function b(i){return typeof i?.id=="string"&&!c(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=E;function y(i){const r=i;return typeof r?.id=="string"&&L.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=y;function v(i){const r=i;if(r?.uri)return{id:r.id,uri:L.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=v;var N;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(N=e.WorkbenchState||(e.WorkbenchState={}));function k(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=k;function u(i){const r=i;return!!(r&&typeof r=="object"&&L.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(r,o,l,d,S){this.h=r,this.j=l,this.k=d,this.l=S,this.c=O.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=O.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,C.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function w(i){return new p({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(i,r){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function P(i){let r;return L.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=P,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(i,r){return!g(i,r)&&!P(i)}e.isSavedWorkspace=a;function n(i){return(typeof i=="string"?(0,A.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ie[22],ne([0,1,45,5,2,17,11,104,18,13,10,6,149,36,27,8,28,29,3]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&L.URI.isUri(i.location)&&L.URI.isUri(i.globalStorageHome)&&L.URI.isUri(i.settingsResource)&&L.URI.isUri(i.keybindingsResource)&&L.URI.isUri(i.tasksResource)&&L.URI.isUri(i.snippetsHome)&&L.URI.isUri(i.extensionsResource))}e.isUserDataProfile=w,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function g(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:L.URI.revive(n.location).with({scheme:i}),globalStorageHome:L.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:L.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:L.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:L.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:L.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:L.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=g;function P(n,i,r,o){return{id:n,name:i,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,C.joinPath)(r,"globalStorage"),settingsResource:(0,C.joinPath)(r,"settings.json"),keybindingsResource:(0,C.joinPath)(r,"keybindings.json"),tasksResource:(0,C.joinPath)(r,"tasks.json"),snippetsHome:(0,C.joinPath)(r,"snippets"),extensionsResource:(0,C.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=P;let t=class extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(i,r,o,l){super(),this.m=i,this.n=r,this.q=o,this.r=l,this.f=!0,this.g=this.D(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(i){this.f!==i&&(this.s=void 0,this.f=i)}isEnabled(){return this.f}get t(){if(!this.s){const i=[];if(this.f)try{for(const d of this.I()){if(!d.name||!(0,p.isString)(d.name)||!d.location){this.r.warn("Skipping the invalid stored profile",d.location||d.name);continue}i.push(P((0,C.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}}catch(d){this.r.error(d)}const r=new v.ResourceMap,o=new Map,l=this.u();if(i.unshift({...l,extensionsResource:this.N()??l.extensionsResource,isDefault:!0}),i.length)try{const d=this.L();if(d.workspaces)for(const[S,D]of Object.entries(d.workspaces)){const j=L.URI.parse(S),K=i.find(Q=>Q.id===D);K&&r.set(j,K)}if(d.emptyWindows)for(const[S,D]of Object.entries(d.emptyWindows)){const j=i.find(K=>K.id===D);j&&o.set(S,j)}}catch(d){this.r.error(d)}this.s={profiles:i,workspaces:r,emptyWindows:o}}return this.s}u(){return P("__default__profile__",(0,I.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const S of this.profiles){const D=o.exec(S.name),j=D?parseInt(D[1]):0;l=j>l?j:l}const d=`${r} ${l+1}`;return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),d,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=await this.v(i,r,o);return l&&await this.setProfileForWorkspace(l,d),d}async v(i,r,o){if(!(0,p.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.k.get(r);return l||(l=(async()=>{try{const d=this.profiles.find(j=>j.name===r||j.id===i);if(d)return d;const S=P(i,r,(0,C.joinPath)(this.profilesHome,i),o);await this.n.createFolder(S.location);const D=[];return this.h.fire({profile:S,join(j){D.push(j)}}),await k.Promises.settled(D),this.z([S],[],[]),S}finally{this.k.delete(r)}})(),this.k.set(r,l)),l}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=P(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.i.fire({profile:r,join(l){o.push(l)}});try{await Promise.allSettled(o)}catch(l){this.r.error(l)}for(const l of[...this.t.emptyWindows.keys()])r.id===this.t.emptyWindows.get(l)?.id&&this.t.emptyWindows.delete(l);for(const l of[...this.t.workspaces.keys()])r.id===this.t.workspaces.get(l)?.id&&this.t.workspaces.delete(l);this.G(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(l){this.r.error(l)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(l=>l.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.q.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.w(i);return L.URI.isUri(r)?this.l.workspaces.get(r)??this.t.workspaces.get(r):this.l.emptyWindows.get(r)??this.t.emptyWindows.get(r)}w(i){return(0,y.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,y.isWorkspaceIdentifier)(i)?i.configPath:i.id}y(i){return!!([...this.l.emptyWindows.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.l.workspaces.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.t.emptyWindows.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.t.workspaces.values()].some(r=>this.q.extUri.isEqual(r.location,i.location)))}z(i,r,o){const l=[...this.profiles,...i],d=[];this.l.profiles=[];for(let S of l)S.isDefault||r.some(D=>S.id===D.id)||(S=o.find(D=>S.id===D.id)??S,S.isTransient?this.l.profiles.push(S):d.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.J(d),this.s=void 0,this.C(i,r,o)}C(i,r,o){this.g.fire({added:i,removed:r,updated:o,all:this.profiles})}F(i,r,o){o=r?.isTransient?!0:o,o||this.F(i,void 0,!0);const l=this.w(i),d=o?this.l:this.t;L.URI.isUri(l)?(d.workspaces.delete(l),r&&d.workspaces.set(l,r)):(d.emptyWindows.delete(l),r&&d.emptyWindows.set(l,r)),o||this.G()}G(){const i={};for(const[o,l]of this.t.workspaces.entries())i[o.toString()]=l.id;const r={};for(const[o,l]of this.t.emptyWindows.entries())r[o.toString()]=l.id;this.M({workspaces:i,emptyWindows:r}),this.s=void 0}H(i){const r={},o=this.u();if(i.workspaces)for(const[d,S]of Object.entries(i.workspaces)){const D=L.URI.parse(S);r[d]=this.q.extUri.isEqual(D,o.location)?o.id:this.q.extUri.basename(D)}const l={};if(i.emptyWindows)for(const[d,S]of Object.entries(i.emptyWindows)){const D=L.URI.parse(S);l[d]=this.q.extUri.isEqual(D,o.location)?o.id:this.q.extUri.basename(D)}return{workspaces:r,emptyWindows:l}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([te(0,h.IEnvironmentService),te(1,c.IFileService),te(2,N.IUriIdentityService),te(3,E.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=a}),define(ie[150],ne([0,1,19,8,23,9,5,2,12,11,89,21,26,32,6,31,25,22]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var p;(function(n){n.Verified="Verified",n.Unverified="Unverified",n.UnknownError="UnknownError"})(p=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let w=class extends I.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,l,d){super(),this.s=i,this.t=r,this.u=o,this.v=l,this.w=d,this.h=0,this.j=new Map,this.k=new Map,this.l=this.D(new L.Emitter),this.m=this.D(new L.Emitter),this.n=this.D(new L.Emitter),this.p=this.D(new L.Emitter),this.q=[],this.D((0,I.toDisposable)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.k.forEach(S=>S.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.s.isEnabled())throw new E.ExtensionManagementError(b.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.y(o.manifest,o.extension,r)}catch(o){throw t(this.t,"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(i),error:o}),this.u.error("Failed to install extension.",i.identifier.id),this.u.error(o),P(o)}}async uninstall(i,r={}){return this.u.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.q.push(i)}async y(i,r,o){const l={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,v.isApplicationScopedExtension)(i)?this.w.defaultProfile.extensionsResource:o.profileLocation??this.P()},d=ee=>`${y.ExtensionKey.create(ee).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const ee=this.j.get(d(r));if(ee)return this.u.info("Extensions is already requested to install",r.identifier.id),ee.task.waitUntilTaskIsFinished()}const S=[],D=[],j=[],K=this.Q(i,r,l);c.URI.isUri(r)||this.j.set(d(r),{task:K,waitingTasks:[]}),this.l.fire({identifier:K.identifier,source:r,profileLocation:l.profileLocation}),this.u.info("Installing extension:",K.identifier.id),S.push({task:K,manifest:i});let Q=!1;try{if(l.donotIncludePackAndDependencies)this.u.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const se=await this.F(K.identifier,i,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),re=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:le,manifest:fe}of(0,T.distinct)(se,({gallery:ae})=>ae.identifier.id)){Q=Q||!!fe.extensionDependencies?.some(W=>(0,y.areSameExtensions)({id:W},K.identifier));const ae=d(le),$=this.j.get(ae);if($){if(this.z(K,$.task)){const W=$.task.identifier;this.u.info("Waiting for already requested installing extension",W.id,K.identifier.id),$.waitingTasks.push(K),D.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,z=>z.some(U=>(0,y.areSameExtensions)(U.identifier,W)))).then(z=>{if(this.u.info("Finished waiting for already requested installing extension",W.id,K.identifier.id),!z.find(q=>(0,y.areSameExtensions)(q.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!re.some(({identifier:W})=>(0,y.areSameExtensions)(W,le.identifier))){const W=this.Q(fe,le,{...l,donotIncludePackAndDependencies:!0});this.j.set(ae,{task:W,waitingTasks:[K]}),this.l.fire({identifier:W.identifier,source:le,profileLocation:l.profileLocation}),this.u.info("Installing extension:",W.identifier.id,K.identifier.id),S.push({task:W,manifest:fe})}}}catch(se){if(c.URI.isUri(K.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.u.warn("Cannot install dependencies of extension:",K.identifier.id,se.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.u.warn("Cannot install packed extensions of extension:",K.identifier.id,se.message);else throw this.u.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),se}const ee=S.reduce((se,{task:re,manifest:le})=>(se.set(re.identifier.id.toLowerCase(),{task:re,manifest:le}),se),new Map);for(;ee.size;){let se;const re=[...ee.values()].filter(({manifest:le})=>!le.extensionDependencies?.some(fe=>ee.has(fe.toLowerCase())));re.length?se=ee.size===1?re:re.filter(({task:le})=>!(le===K&&!Q)):(this.u.info("Found extensions with circular dependencies",re.map(({task:le})=>le.identifier.id)),se=[...ee.values()]),await this.C(se.map(async({task:le})=>{const fe=new Date().getTime();try{const ae=await le.run();if(await this.C(this.q.map($=>$.postInstall(ae,le.source,l,O.CancellationToken.None))),!c.URI.isUri(le.source)){const $=le.operation===3,W=$?void 0:(new Date().getTime()-le.source.lastUpdated)/1e3;if(t(this.t,$?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(le.source),verificationStatus:le.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:W}),h.isWeb&&le.operation!==3)try{await this.s.reportStatistic(ae.manifest.publisher,ae.manifest.name,ae.manifest.version,"install")}catch{}}j.push({local:ae,identifier:le.identifier,operation:le.operation,source:le.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:ae.isApplicationScoped})}catch(ae){throw c.URI.isUri(le.source)||t(this.t,le.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(le.source),verificationStatus:le.verificationStatus,duration:new Date().getTime()-fe,error:ae}),this.u.error("Error while installing the extension:",le.identifier.id),ae}finally{ee.delete(le.identifier.id.toLowerCase())}}))}return D.length&&await this.C(D),j.forEach(({identifier:se})=>this.u.info("Extension installed successfully:",se.id)),this.m.fire(j),j.filter(({identifier:se})=>(0,y.areSameExtensions)(se,K.identifier))[0].local}catch(ee){if(S.forEach(({task:se})=>se.cancel()),j.length)try{const se=await Promise.allSettled(j.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let re=0;re<se.length;re++){const le=se[re],{identifier:fe}=j[re];le.status==="fulfilled"?this.u.info("Rollback: Uninstalled extension",fe.id):this.u.warn("Rollback: Error while uninstalling extension",fe.id,(0,C.getErrorMessage)(le.reason))}}catch(se){this.u.warn("Error while rolling back extensions",(0,C.getErrorMessage)(se),j.map(({identifier:re})=>re.id))}throw this.m.fire(S.map(({task:se})=>({identifier:se.identifier,operation:2,source:se.source,context:l.context,profileLocation:l.profileLocation}))),ee}finally{for(const{task:ee}of S)ee.source&&!c.URI.isUri(ee.source)&&this.j.delete(d(ee.source))}}z(i,r){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(r)||l.some(d=>this.z(d,r)))||o===r&&l[0]&&!this.z(i,l[0]))return!1;return!0}async C(i){const r=[],o=[],l=await Promise.allSettled(i);for(const d of l)d.status==="fulfilled"?r.push(d.value):o.push(d.reason);if(o.length)throw g(o);return r}async F(i,r,o,l,d){if(!this.s.isEnabled())return[];const S=await this.getInstalled(void 0,d),D=[],j=[],K=async(Q,ee)=>{D.push(Q);const se=ee.extensionDependencies||[],re=[...se];if(ee.extensionPack){const le=o?S.find(fe=>(0,y.areSameExtensions)(fe.identifier,Q)):void 0;for(const fe of ee.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(ae=>(0,y.areSameExtensions)({id:ae},{id:fe}))||re.every(ae=>!(0,y.areSameExtensions)({id:ae},{id:fe}))&&re.push(fe)}if(re.length){const le=re.filter(fe=>D.every(ae=>!(0,y.areSameExtensions)(ae,{id:fe})));if(le.length){const fe=await this.s.getExtensions(le.map(ae=>({id:ae,preRelease:l})),O.CancellationToken.None);for(const ae of fe){if(D.find(z=>(0,y.areSameExtensions)(z,ae.identifier)))continue;const $=se.some(z=>(0,y.areSameExtensions)({id:z},ae.identifier));let W;try{W=await this.G(ae,!1,l)}catch(z){if(z instanceof E.ExtensionManagementError&&z.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.u.info("Skipping the packed extension as it cannot be installed",ae.identifier.id);continue}else throw z}j.push({gallery:W.extension,manifest:W.manifest}),await K(W.extension.identifier,W.manifest)}}}};return await K(i,r),j}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,y.areSameExtensions)(i.identifier,D)))throw new E.ExtensionManagementError(b.localize(1,null,i.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new E.ExtensionManagementError(b.localize(2,null,i.identifier.id,this.v.nameLong,(0,E.TargetPlatformToString)(D)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const d=await this.H(i,r,o);if(d){if(o&&!r&&i.hasPreReleaseVersion&&!d.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(b.localize(3,null,i.identifier.id,this.v.nameLong,this.v.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.s.getExtensions([i.identifier],O.CancellationToken.None))[0]?new E.ExtensionManagementError(b.localize(4,null,i.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(b.localize(5,null,i.identifier.id,this.v.nameLong,this.v.version),E.ExtensionManagementErrorCode.Incompatible);this.u.info("Getting Manifest...",d.identifier.id);const S=await this.s.getManifest(d,O.CancellationToken.None);if(S===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(S.version!==d.version)throw new E.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:d,manifest:S}}async H(i,r,o){const l=await this.getTargetPlatform();let d=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(d=(await this.s.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},O.CancellationToken.None))[0]||null),!d&&await this.s.isExtensionCompatible(i,o,l)&&(d=i),d||(r?d=(await this.s.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},O.CancellationToken.None))[0]||null:d=await this.s.getCompatibleExtension(i,o,l)),d}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.w.defaultProfile.extensionsResource:r.profileLocation??this.P()},l=Q=>`${Q.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,d=this.k.get(l(i.identifier));if(d)return this.u.info("Extensions is already requested to uninstall",i.identifier.id),d.waitUntilTaskIsFinished();const S=Q=>{const ee=this.R(Q,o);return this.k.set(l(ee.extension.identifier),ee),o.profileLocation?this.u.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString()):this.u.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this.n.fire({identifier:Q.identifier,profileLocation:o.profileLocation,applicationScoped:Q.isApplicationScoped}),ee},D=(Q,ee)=>{ee?o.profileLocation?this.u.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString(),ee.message):this.u.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,ee.message):o.profileLocation?this.u.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString()):this.u.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),t(this.t,"extensionGallery:uninstall",{extensionData:(0,y.getLocalExtensionTelemetryData)(Q),error:ee}),this.p.fire({identifier:Q.identifier,error:ee?.code,profileLocation:o.profileLocation,applicationScoped:Q.isApplicationScoped})},j=[],K=[];try{j.push(S(i));const Q=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.u.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.M(i,Q);for(const se of ee)this.k.has(l(se.identifier))?this.u.info("Extensions is already requested to uninstall",se.identifier.id):j.push(S(se))}o.donotCheckDependents?this.u.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(j.map(ee=>ee.extension),Q,i),await this.C(j.map(async ee=>{try{if(await ee.run(),await this.C(this.q.map(se=>se.postUninstall(ee.extension,o,O.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.s.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}D(ee.extension)}catch(se){const re=se instanceof E.ExtensionManagementError?se:new E.ExtensionManagementError((0,C.getErrorMessage)(se),E.ExtensionManagementErrorCode.Internal);throw D(ee.extension,re),re}finally{K.push(ee)}}))}catch(Q){const ee=Q instanceof E.ExtensionManagementError?Q:new E.ExtensionManagementError((0,C.getErrorMessage)(Q),E.ExtensionManagementErrorCode.Internal);for(const se of j){try{se.cancel()}catch{}K.includes(se)||D(se.extension,ee)}throw ee}finally{for(const Q of j)this.k.delete(l(Q.extension.identifier))||this.u.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}J(i,r,o){for(const l of i){const d=this.N(l,r);if(d.length){const S=d.filter(D=>!i.some(j=>(0,y.areSameExtensions)(j.identifier,D.identifier)));if(S.length)throw new Error(this.L(l,S,o))}}}L(i,r,o){return o===i?r.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const d=r.filter(D=>!D.isBuiltin&&l.some(j=>(0,y.areSameExtensions)({id:j},D.identifier))),S=[];for(const D of d)S.push(...this.M(D,r,o));return[...d,...S]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,y.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.u.trace("ExtensionManagementService.refreshReportedCache");const i=await this.s.getExtensionsControlManifest();return this.u.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.u.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};w=ye([te(0,E.IExtensionGalleryService),te(1,u.ITelemetryService),te(2,N.ILogService),te(3,k.IProductService),te(4,f.IUserDataProfilesService)],w),e.AbstractExtensionManagementService=w;function g(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=g;function P(n){if(n instanceof E.ExtensionManagementError)return n;const i=new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:o,duration:l,error:d,durationSinceUpdate:S}){let D,j;d&&(d instanceof E.ExtensionManagementError?(D=d.code,d.code===E.ExtensionManagementErrorCode.Signature&&(j=d.message)):D=E.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!d,duration:l,errorcode:D,errorcodeDetail:j,durationSinceUpdate:S})}class a{constructor(){this.d=new A.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.createCancelablePromise)(i=>new Promise((r,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new C.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(ie[40],ne([0,1,8,14,2,5,36,11,21,26,13,10,6,22,27,3,9,25]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class w extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=w,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let g=class extends O.Disposable{constructor(n,i,r,o,l,d){super(),this.i=n,this.j=i,this.k=r,this.l=o,this.m=l,this.n=d,this.b=this.D(new C.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new C.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new C.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new C.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new L.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],o=[];try{return await this.p(i,l=>{const d=[];for(const S of l)n.some(([D])=>(0,c.areSameExtensions)(D.identifier,S.identifier)&&D.manifest.version!==S.version)?r.push(S):d.push(S);for(const[S,D]of n)if(!d.some(j=>(0,c.areSameExtensions)(j.identifier,S.identifier)&&j.version===S.manifest.version)){const j={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:D};o.push(j),d.push(j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),d}),o.length&&this.c.fire({extensions:o,profileLocation:i}),r.length&&this.g.fire({extensions:r,profileLocation:i}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:i}),r.length&&this.g.fire({extensions:r,error:l,profileLocation:i}),l}}async updateMetadata(n,i){const r=[];return await this.p(i,o=>{const l=[];for(const d of o){const S=n.find(([D])=>(0,c.areSameExtensions)(D.identifier,d.identifier)&&D.manifest.version===d.version);S&&(d.metadata={...d.metadata,...S[1]},r.push(d)),l.push(d)}return l}),r}async removeExtensionFromProfile(n,i){const r=[];this.f.fire({extensions:r,profileLocation:i});try{await this.p(i,o=>{const l=[];for(const d of o)(0,c.areSameExtensions)(d.identifier,n.identifier)?r.push(d):l.push(d);return r.length&&this.f.fire({extensions:r,profileLocation:i}),l}),r.length&&this.g.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:i}),o}}async p(n,i,r){return this.v(n).queue(async()=>{let o=[],l;try{const d=await this.j.readFile(n);l=JSON.parse(d.value.toString().trim()||"[]")}catch(d){if((0,b.toFileOperationResult)(d)!==1)throw d;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(l=await this.u()),!l&&r?.bailOutWhenFileNotFound)throw new w((0,u.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.q(n);let d=!1;for(const S of l){P(S)||this.q(n);let D;if((0,k.isString)(S.relativeLocation)&&S.relativeLocation)D=this.s(S.relativeLocation);else if((0,k.isString)(S.location))D=this.s(S.location),d=!0,S.relativeLocation=S.location,S.location=D.toJSON();else{D=I.URI.revive(S.location);const j=this.r(D);j&&(d=!0,S.relativeLocation=j)}o.push({identifier:S.identifier,location:D,version:S.version,metadata:S.metadata})}d&&await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const d=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.r(S.location),metadata:S.metadata}));await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(d)))}return o})}q(n){const i=new w(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}r(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}s(n){return this.l.extUri.joinPath(this.i,n)}async u(){return this.t||(this.t=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(n)).value.toString()}catch(l){if((0,b.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(d=>P(d))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(n)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(i)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.n.error(l)}return o})()),this.t}v(n){let i=this.h.get(n);return i||(i=new T.Queue,this.h.set(n,i)),i}};g=ye([te(1,b.IFileService),te(2,v.IUserDataProfilesService),te(3,N.IUriIdentityService),te(4,f.ITelemetryService),te(5,y.ILogService)],g),e.AbstractExtensionsProfileScannerService=g;function P(a){return(0,k.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,k.isString)(a.location)&&a.location)&&((0,k.isUndefined)(a.relativeLocation)||(0,k.isString)(a.relativeLocation))&&a.version&&(0,k.isString)(a.version)}function t(a){return a?(0,k.isString)(a.path)&&(0,k.isString)(a.scheme):!1}}),define(ie[48],ne([0,1,19,8,30,14,9,51,78,2,16,15,12,17,41,53,3,11,93,18,26,32,46,13,10,6,31,5,54,40,22,27,110]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w,g,P,t,a,n,i,r,o,l,d,S,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ae){function $(W,z){if(W===z)return!0;const U=Object.keys(W),q=new Set;for(const H of Object.keys(z))q.add(H);if(U.length!==q.size)return!1;for(const H of U){if(W[H]!==z[H])return!1;q.delete(H)}return q.size===0}ae.equals=$})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let Q=class extends c.Disposable{constructor($,W,z,U,q,H,X,Y,F,R,s,m){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=W,this.l=z,this.m=U,this.n=q,this.p=H,this.q=X,this.r=Y,this.s=F,this.t=R,this.u=s,this.v=m,this.g=this.D(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(re,(0,v.joinPath)(this.m,P.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(re,(0,v.joinPath)(this.m,P.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(se,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,g.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions($,W,z){const[U,q]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(W)]),H=z?await this.scanExtensionsUnderDevelopment($,[...U,...q]):[];return this.F(U,q,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const W=[];W.push(this.G(!!$.useCache,$.language)),W.push(this.H($.language,!!$.checkControlFile));const[z,U]=await Promise.all(W);return this.C([...z,...U],0,$,!1)}async scanUserExtensions($){const W=$.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",W);const z=this.u.extUri.isEqual($.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.J(W,!!$.profileLocation,1,!$.includeUninstalled,$.language,!0,z),q=$.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let H;try{H=await q.scanExtensions(U)}catch(X){if(X instanceof d.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),H=await q.scanExtensions(U);else throw X}return H=await this.C(H,1,$,!0),this.r.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment($,W){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const z=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter(U=>U.scheme===b.Schemas.file).map(async U=>{const q=await this.J(U,!1,1,!0,$.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(q)).map(X=>(X.type=W.find(Y=>(0,g.areSameExtensions)(Y.identifier,X.identifier))?.type??X.type,this.k.validate(X,q)))}))).flat();return this.C(z,"development",$,!0)}return[]}async scanExistingExtension($,W,z){const U=await this.J($,!1,W,!0,z.language,!0,void 0),q=await this.k.scanExtension(U);return!q||!z.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions($,W,z){const U=await this.J($,!1,W,!0,z.language,!0,void 0),q=await this.k.scanOneOrMultipleExtensions(U);return this.C(q,W,z,!0)}async scanMetadata($){const W=(0,v.joinPath)($,"package.json"),z=(await this.q.readFile(W)).value.toString();return JSON.parse(z).__metadata}async updateMetadata($,W){const z=(0,v.joinPath)($,"package.json"),U=(await this.q.readFile(z)).value.toString(),q=JSON.parse(U);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,q.__metadata={...q.__metadata,...W},await this.q.writeFile((0,v.joinPath)($,"package.json"),C.VSBuffer.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch($){if($ instanceof d.ExtensionsProfileScanningError&&$.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw $}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});if($.length)await this.p.addExtensionsToProfile($.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,a.toFileOperationResult)(W)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(W))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch($){this.r.error($)}finally{this.y=void 0}})()),this.y}async C($,W,z,U){return z.includeAllVersions||($=this.F(W===0?$:void 0,W===1?$:void 0,W==="development"?$:void 0,await this.getTargetPlatform(),U)),z.includeInvalid||($=$.filter(q=>q.isValid)),$.sort((q,H)=>{const X=E.basename(q.location.fsPath),Y=E.basename(H.location.fsPath);return X<Y?-1:X>Y?1:0})}F($,W,z,U,q){const H=(Y,F,R)=>{if(Y.isValid&&!F.isValid)return!1;if(Y.isValid===F.isValid){if(q&&N.gt(Y.manifest.version,F.manifest.version))return this.r.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(N.eq(Y.manifest.version,F.manifest.version)){if(Y.type===0)return this.r.debug(`Skipping extension ${F.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===U)return this.r.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return R?this.r.warn(`Overwriting user extension ${Y.location.path} with ${F.location.path}.`):this.r.debug(`Overwriting user extension ${Y.location.path} with ${F.location.path}.`),!0},X=new P.ExtensionIdentifierMap;return $?.forEach(Y=>{const F=X.get(Y.identifier.id);(!F||H(F,Y,!1))&&X.set(Y.identifier.id,Y)}),W?.forEach(Y=>{const F=X.get(Y.identifier.id);if(!F&&$&&Y.type===0){this.r.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!F||H(F,Y,!1))&&X.set(Y.identifier.id,Y)}),z?.forEach(Y=>{const F=X.get(Y.identifier.id);(!F||H(F,Y,!0))&&X.set(Y.identifier.id,Y),X.set(Y.identifier.id,Y)}),[...X.values()]}async G($,W){this.r.trace("Started scanning system extensions");const z=await this.J(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),q=await($&&!z.devMode?this.i:this.k).scanExtensions(z);return this.r.trace("Scanned system extensions:",q.length),q}async H($,W){const z=this.s.isBuilt?[]:this.t.builtInExtensions;if(!z?.length)return[];this.r.trace("Started scanning dev system extensions");const U=W?await this.I():{},q=[],H=f.URI.file(E.normalize(E.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of z){const F=U[Y.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":q.push((0,v.joinPath)(H,Y.name));break;default:q.push(f.URI.file(F));break}}const X=await Promise.all(q.map(async Y=>this.k.scanExtension(await this.J(Y,!1,0,!0,$,!0,void 0))));return this.r.trace("Scanned dev system extensions:",X.length),(0,T.coalesce)(X)}async I(){try{const $=await this.q.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async J($,W,z,U,q,H,X){const Y=await this.f(q??y.language),F=await this.L($),R=W&&!this.u.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,s=R?await this.L(R):void 0;return new ee($,F,R,s,W,X,z,U,H,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,q,Y)}async L($){try{const W=await this.q.stat($);if(typeof W.mtime=="number")return W.mtime}catch{}}};Q=ye([te(4,S.IUserDataProfilesService),te(5,d.IExtensionsProfileScannerService),te(6,a.IFileService),te(7,i.ILogService),te(8,w.IEnvironmentService),te(9,r.IProductService),te(10,D.IUriIdentityService),te(11,n.IInstantiationService)],Q),e.AbstractExtensionsScannerService=Q;class ee{constructor($,W,z,U,q,H,X,Y,F,R,s,m,M,x,B){this.location=$,this.mtime=W,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=U,this.profile=q,this.profileScanOptions=H,this.type=X,this.excludeObsolete=Y,this.validate=F,this.productVersion=R,this.productDate=s,this.productCommit=m,this.devMode=M,this.language=x,this.translations=B}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,W){return(0,v.isEqual)($.location,W.location)&&$.mtime===W.mtime&&(0,v.isEqual)($.applicationExtensionslocation,W.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&$.profile===W.profile&&O.equals($.profileScanOptions,W.profileScanOptions)&&$.type===W.type&&$.excludeObsolete===W.excludeObsolete&&$.validate===W.validate&&$.productVersion===W.productVersion&&$.productDate===W.productDate&&$.productCommit===W.productCommit&&$.devMode===W.devMode&&$.language===W.language&&K.equals($.translations,W.translations)}}e.ExtensionScannerInput=ee;let se=class extends c.Disposable{constructor($,W,z,U,q){super(),this.f=$,this.g=W,this.h=z,this.i=U,this.j=q}async scanExtensions($){const W=$.profile?await this.l($):await this.k($);let z={};if($.excludeObsolete&&$.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();z=JSON.parse(U)}catch{}return(0,u.isEmptyObject)(z)?W:W.filter(U=>!z[g.ExtensionKey.create(U).toString()])}async k($){const W=await this.i.resolve($.location);if(!W.children?.length)return[];const z=await Promise.all(W.children.map(async U=>{if(!U.isDirectory||$.type===1&&(0,v.basename)(U.resource).indexOf(".")===0)return null;const q=new ee(U.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(q)}));return(0,T.coalesce)(z).sort((U,q)=>U.location.path<q.location.path?-1:1)}async l($){let W=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){W=W.filter(U=>!U.metadata?.isApplicationScoped);const z=await this.m($.applicationExtensionslocation,U=>!!U.metadata?.isApplicationScoped,$);W.push(...z)}return W}async m($,W,z){const U=await this.g.scanProfileExtensions($,z.profileScanOptions);if(!U.length)return[];const q=await Promise.all(U.map(async H=>{if(W(H)){const X=new ee(H.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(X,H.metadata)}return null}));return(0,T.coalesce)(q)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,v.joinPath)($.location,"package.json"))){const W=await this.scanExtension($);return W?[W]:[]}else return await this.scanExtensions($)}catch(W){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,L.getErrorMessage)(W)),[]}}async scanExtension($,W){try{let z=await this.scanExtensionManifest($.location);if(z){z.publisher||(z.publisher=P.UNDEFINED_PUBLISHER),W=W??z.__metadata,delete z.__metadata;const U=(0,g.getGalleryExtensionId)(z.publisher,z.name),q=W?.id?{id:U,uuid:W.id}:{id:U},H=W?.isSystem?0:$.type,X=H===0||!!W?.isBuiltin;z=await this.n($.location,z,ee.createNlsConfiguration($));const Y={type:H,identifier:q,manifest:z,location:$.location,isBuiltin:X,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return $.validate?this.validate(Y,$):Y}}catch(z){$.type!==0&&this.j.error(z)}return null}validate($,W){let z=!0;const U=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,$.manifest,$.isBuiltin);for(const[q,H]of U)q===k.default.Error&&(z=!1,this.j.error(this.s(W.location,H)));return $.isValid=z,$.validations=U,$}async scanExtensionManifest($){const W=(0,v.joinPath)($,"package.json");let z;try{z=(await this.i.readFile(W)).value.toString()}catch(q){return(0,a.toFileOperationResult)(q)!==1&&this.j.error(this.s($,(0,p.localize)(0,null,W.path,q.message))),null}let U;try{U=JSON.parse(z)}catch{const H=[];(0,I.parse)(z,H);for(const X of H)this.j.error(this.s($,(0,p.localize)(1,null,W.path,X.offset,X.length,(0,h.getParseErrorMessage)(X.error))));return null}return(0,I.getNodeType)(U)!=="object"?(this.j.error(this.s($,(0,p.localize)(2,null,W.path))),null):U}async n($,W,z){const U=await this.p($,W,z);if(U)try{const q=[],H=await this.q(U.default,q);if(q.length>0)return q.forEach(Y=>{this.j.error(this.s($,(0,p.localize)(3,null,U.default?.path,(0,h.getParseErrorMessage)(Y.error))))}),W;if((0,I.getNodeType)(U)!=="object")return this.j.error(this.s($,(0,p.localize)(4,null,U.default?.path))),W;const X=U.values||Object.create(null);return(0,j.localizeManifest)(W,X,H)}catch{}return W}async p($,W,z){const U=(0,v.joinPath)($,"package.nls.json"),q=(F,R)=>{R.forEach(s=>{this.j.error(this.s($,(0,p.localize)(5,null,F?.path,(0,h.getParseErrorMessage)(s.error))))})},H=F=>{this.j.error(this.s($,(0,p.localize)(6,null,F?.path)))},X=`${W.publisher}.${W.name}`,Y=z.translations[X];if(Y)try{const F=f.URI.file(Y),R=(await this.i.readFile(F)).value.toString(),s=[],m=(0,I.parse)(R,s);return s.length>0?(q(F,s),{values:void 0,default:U}):(0,I.getNodeType)(m)!=="object"?(H(F),{values:void 0,default:U}):{values:m.contents?m.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let R;try{R=await this.r($,z)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const s=(await this.i.readFile(R.localized)).value.toString(),m=[],M=(0,I.parse)(s,m);return m.length>0?(q(R.localized,m),{values:void 0,default:R.original}):(0,I.getNodeType)(M)!=="object"?(H(R.localized),{values:void 0,default:R.original}):{values:M,default:R.original}}catch{return{values:void 0,default:R.original}}}}async q($,W){if($)try{const z=(await this.i.readFile($)).value.toString();return(0,I.parse)(z,W)}catch{}}r($,W){return new Promise((z,U)=>{const q=H=>{const X=(0,v.joinPath)($,`package.nls.${H}.json`);this.i.exists(X).then(Y=>{Y&&z({localized:X,original:(0,v.joinPath)($,"package.nls.json")});const F=H.lastIndexOf("-");F===-1?z({localized:(0,v.joinPath)($,"package.nls.json"),original:null}):(H=H.substring(0,F),q(H))})};if(W.devMode||W.pseudo||!W.language)return z({localized:(0,v.joinPath)($,"package.nls.json"),original:null});q(W.language)})}s($,W){return`[${$.path}]: ${W}`}};se=ye([te(1,d.IExtensionsProfileScannerService),te(2,D.IUriIdentityService),te(3,a.IFileService),te(4,i.ILogService)],se);let re=class extends se{constructor($,W,z,U,q,H){super(W,z,U,q,H),this.w=$,this.u=this.D(new A.ThrottledDelayer(3e3)),this.v=this.D(new o.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions($){const W=await this.y();if(this.t=$,W&&W.input&&ee.equals(W.input,this.t))return this.j.debug("Using cached extensions scan result",$.location.toString()),this.u.trigger(()=>this.C()),W.result.map(U=>(U.location=f.URI.revive(U.location),U));const z=await super.scanExtensions($);return await this.z({input:$,result:z}),z}async y(){try{const $=await this.i.readFile(this.w),W=JSON.parse($.value.toString());return{result:W.result,input:(0,l.revive)(W.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,L.getErrorMessage)($))}return null}async z($){try{await this.i.writeFile(this.w,C.VSBuffer.fromString(JSON.stringify($)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,L.getErrorMessage)(W))}}async C(){if(!this.t)return;const $=await this.y();if(!$)return;const W=$.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!O.equals(z,W))try{this.j.info("Invalidating Cache",W,z),await this.i.del(this.w),this.v.fire()}catch(U){this.j.error(U)}}};re=ye([te(2,d.IExtensionsProfileScannerService),te(3,D.IUriIdentityService),te(4,a.IFileService),te(5,i.ILogService)],re);function le(ae,$){const W=(0,g.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:W,identifier:new P.ExtensionIdentifier(W),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:$,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.toExtensionDescription=le;class fe extends Q{constructor($,W,z,U,q,H,X,Y,F,R,s,m){super($,W,(0,v.joinPath)(z,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(U,P.MANIFEST_CACHE_FOLDER),q,H,X,Y,F,R,s,m),this.M=(async()=>{if(y.translationsConfigFile)try{const M=await this.q.readFile(f.URI.file(y.translationsConfigFile));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f($){return this.M}}e.NativeExtensionsScannerService=fe}),define(ie[151],ne([0,1,58,8,34,5,2,16,15,20,6,22]),function(G,e,T,A,O,C,L,I,h,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends L.Disposable{constructor(N,k){super(),this.b=N,this.f=k,this.a=new A.Limiter(5)}async postUninstall(N){const k=this.g(N,"uninstall");k&&(this.f.info(N.identifier.id,N.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,N),this.f.info("Finished running post uninstall script",N.identifier.id,N.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",N.identifier.id,N.manifest.version),this.f.error(u)}}));try{await c.Promises.rm(this.j(N))}catch(u){this.f.error("Error while removing extension storage path",N.identifier.id),this.f.error(u)}}g(N,k){const u=`vscode:${k}`;if(N.location.scheme===I.Schemas.file&&N.manifest&&N.manifest.scripts&&typeof N.manifest.scripts[u]=="string"){const f=N.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(N.identifier.id,N.manifest.version,`${u} should be a node script`),null):{script:(0,h.join)(N.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(N,k,u,f,p){return new Promise((w,g)=>{const P=this.i(N,k,u,p);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?g(n):w(void 0)};P.on("error",n=>{a((0,O.toErrorMessage)(n)||"Unknown")}),P.on("exit",(n,i)=>{a(n?`post-${k} process exited with code ${n}`:void 0)}),f&&(t=setTimeout(()=>{t=null,P.kill(),g("timed out")},5e3))})}i(N,k,u,f){const p={silent:!0,execArgv:void 0},w=(0,T.fork)(N,[`--type=extension-post-${k}`,...u],p);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const g=C.Event.fromNodeEventEmitter(w.stdout,"data"),P=C.Event.fromNodeEventEmitter(w.stderr,"data");g(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${k}`,n)),P(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${k}`,n));const t=C.Event.any(C.Event.map(g,n=>({data:`%c${n}`,format:[""]})),C.Event.map(P,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),w}j(N){return(0,h.join)(this.b.defaultProfile.globalStorageHome.fsPath,N.identifier.id.toLowerCase())}};y=ye([te(0,E.IUserDataProfilesService),te(1,b.ILogService)],y),e.ExtensionsLifecycle=y}),define(ie[152],ne([0,1,6,22,27,25,40,13,18,11]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends L.AbstractExtensionsProfileScannerService{constructor(y,v,N,k,u,f){super(c.URI.file(y.extensionsPath),v,N,k,u,f)}};b=ye([te(0,h.INativeEnvironmentService),te(1,I.IFileService),te(2,A.IUserDataProfilesService),te(3,O.IUriIdentityService),te(4,C.ITelemetryService),te(5,T.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ie[153],ne([0,1,11,18,40,48,13,10,6,31,27,22]),function(G,e,T,A,O,C,L,I,h,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends C.NativeExtensionsScannerService{constructor(N,k,u,f,p,w,g,P){super(T.URI.file(p.builtinExtensionsPath),T.URI.file(p.extensionsPath),p.userHome,T.URI.file(p.userDataPath),N,k,u,f,p,w,g,P)}};y=ye([te(0,E.IUserDataProfilesService),te(1,O.IExtensionsProfileScannerService),te(2,L.IFileService),te(3,h.ILogService),te(4,A.INativeEnvironmentService),te(5,c.IProductService),te(6,b.IUriIdentityService),te(7,I.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ie[154],ne([0,1,8,5,2,121,3,84,10,22]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function v(p){const w=p.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=v;class N extends O.Disposable{constructor(w={flushInterval:N.a}){super(),this.j=w,this.b=this.D(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new O.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,O.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,g){if(g===e.TARGET_KEY){switch(w){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:g,target:this.F(w)[g]})}q(w){this.f.fire({reason:w})}get(w,g,P){return this.L(g)?.get(w,P)}getBoolean(w,g,P){return this.L(g)?.getBoolean(w,P)}getNumber(w,g,P){return this.L(g)?.getNumber(w,P)}store(w,g,P,t){if((0,L.isUndefinedOrNull)(g)){this.remove(w,P);return}this.r(()=>{this.t(w,P,t),this.L(P)?.set(w,g)})}remove(w,g){this.r(()=>{this.t(w,g,void 0),this.L(g)?.delete(w)})}r(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,g){const P=[],t=this.F(w);for(const a of Object.keys(t))t[a]===g&&P.push(a);return P}t(w,g,P){const t=this.F(g);typeof P=="number"?t[w]!==P&&(t[w]=P,this.L(g)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.L(g)?.set(e.TARGET_KEY,JSON.stringify(t)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(w){switch(w){case-1:return this.C;case 0:return this.y;default:return this.v}}G(w){const g=this.L(w);return g?v(g):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=b.NONE){this.f.fire({reason:w});const g=this.L(-1),P=this.L(0),t=this.L(1);switch(w){case b.NONE:await T.Promises.settled([g?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await T.Promises.settled([g?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,g=this.L(0)?.items??new Map,P=this.L(1)?.items??new Map;return f(w,g,P,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,g){return this.q(b.NONE),(0,c.isUserDataProfile)(w)?this.N(w,g):this.O(w,g)}H(w,g){return!(w.id===g.id||k(g)&&k(w))}I(w,g,P,t){this.r(()=>{if(t)for(const[a,n]of w)g.set(a,n);else{const a=new Set;for(const[n,i]of w)a.add(n),g.get(n)!==i&&this.n(P,n);for(const[n]of g.items)a.has(n)||this.n(P,n)}})}}N.a=60*1e3,e.AbstractStorageService=N;function k(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=k;class u extends N{constructor(){super(),this.p=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.D(this.P.onDidChangeStorage(w=>this.n(0,w))),this.D(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=u;async function f(p,w,g,P,t,a){const n=K=>{try{return JSON.parse(K)}catch{return K}},i=new Map,r=new Map;p.forEach((K,Q)=>{i.set(Q,K),r.set(Q,n(K))});const o=new Map,l=new Map;w.forEach((K,Q)=>{o.set(Q,K),l.set(Q,n(K))});const d=new Map,S=new Map;g.forEach((K,Q)=>{d.set(Q,K),S.set(Q,n(K))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const D=[];if(i.forEach((K,Q)=>{D.push({key:Q,value:K})}),console.table(D),console.groupEnd(),console.log(r),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const K=[];o.forEach((Q,ee)=>{K.push({key:ee,value:Q})}),console.table(K),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const j=[];d.forEach((K,Q)=>{j.push({key:Q,value:K})}),console.table(j),console.groupEnd(),console.log(S)}e.logStorage=f}),define(ie[155],ne([0,1,19,23,9,12,35,3,11,24,18,21,26,46,13,6,31,43,140,154,25]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const P=C.isWeb?"web":(0,E.getTargetPlatform)(C.platform,L.arch),t="X-Market-Search-Activity-Id";var a;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function n(...R){return String(R.reduce((s,m)=>s|m,0))}var i;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class S{constructor(s=d){this.d=s}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(s,m=this.d.pageSize){return new S({...this.d,pageNumber:s,pageSize:m})}withFilter(s,...m){const M=[...this.d.criteria,...m.length?m.map(x=>({filterType:s,value:x})):[{filterType:s}]];return new S({...this.d,criteria:M})}withSortBy(s){return new S({...this.d,sortBy:s})}withSortOrder(s){return new S({...this.d,sortOrder:s})}withFlags(...s){return new S({...this.d,flags:s.reduce((m,M)=>m|M,0)})}withAssetTypes(...s){return new S({...this.d,assetTypes:s})}withSource(s){return new S({...this.d,source:s})}get raw(){const{criteria:s,pageNumber:m,pageSize:M,sortBy:x,sortOrder:B,flags:Z,assetTypes:oe}=this.d;return{filters:[{criteria:s,pageNumber:m,pageSize:M,sortBy:x,sortOrder:B}],assetTypes:oe,flags:Z}}get searchText(){const s=this.d.criteria.filter(m=>m.filterType===i.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(s=>String(s.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(R,s){const m=(R||[]).filter(M=>M.statisticName===s)[0];return m?m.value:0}function j(R){const s="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(M=>M.assetType.indexOf(s)===0).reduce((M,x)=>{const B=ee(R,x.assetType);return B&&M.push([x.assetType.substring(s.length),B]),M},[])}function K(R){if(R.properties){const s=R.properties.filter(x=>x.key===r.Repository),m=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=s.filter(x=>m.test(x.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return ee(R,r.Repository)}function Q(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function ee(R,s){return R.files.filter(M=>M.assetType===s)[0]?{uri:`${R.assetUri}/${s}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${s}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function se(R,s){const m=R.properties?R.properties.filter(x=>x.key===s):[],M=m.length>0&&m[0].value;return M?M.split(",").map(x=>(0,y.adoptToGalleryExtensionId)(x)):[]}function re(R){const s=R.properties?R.properties.filter(m=>m.key===o.Engine):[];return s.length>0&&s[0].value||""}function le(R){const s=R.properties?R.properties.filter(m=>m.key===o.PreRelease):[];return s.length>0&&s[0].value==="true"}function fe(R){const s=R.properties?R.properties.filter(M=>M.key===o.LocalizedLanguages):[],m=s.length>0&&s[0].value||"";return m?m.split(","):[]}function ae(R){return R.properties?.find(s=>s.key===o.SponsorLink)?.value}function $(R){return R.indexOf("preview")!==-1}function W(R){return R.targetPlatform?(0,E.toTargetPlatform)(R.targetPlatform):"undefined"}function z(R){const s=(0,T.distinct)(R.versions.map(W)),m=!!R.tags?.includes(E.WEB_EXTENSION_TAG),M=s.indexOf("web");return m?M===-1&&s.push("web"):M!==-1&&s.splice(M,1),s}function U(R,s){const m=(0,E.getFallbackTargetPlarforms)(s);for(let M=0;M<R.length;M++){const x=R[M];if(x.version===R[M-1]?.version){let B=M;const Z=W(x);if(Z===s)for(;B>0&&R[B-1].version===x.version;)B--;else if(m.includes(Z))for(;B>0&&R[B-1].version===x.version&&W(R[B-1])!==s;)B--;B!==M&&(R.splice(M,1),R.splice(B,0,x))}}return R}e.sortExtensionVersions=U;function q(R,s,m){R.telemetryData={index:s,querySource:m,queryActivityId:R.queryContext?.[t]}}function H(R,s,m,M){const x=R.versions[0],B={manifest:ee(s,r.Manifest),readme:ee(s,r.Details),changelog:ee(s,r.Changelog),license:ee(s,r.License),repository:K(s),download:Q(s),icon:ee(s,r.Icon),signature:ee(s,r.Signature),coreTranslations:j(s)};return{identifier:{id:(0,y.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:s.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(x),description:R.shortDescription||"",installCount:D(R.statistics,"install"),rating:D(R.statistics,"averagerating"),ratingCount:D(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:m,assets:B,properties:{dependencies:se(s,o.Dependency),extensionPack:se(s,o.ExtensionPack),engine:re(s),localizedLanguages:fe(s),targetPlatform:W(s),isPreReleaseVersion:le(s)},hasPreReleaseVersion:le(x),hasReleaseVersion:!0,preview:$(R.flags),isSigned:!!B.signature,queryContext:M}}let X=class{constructor(s,m,M,x,B,Z,oe,he){this.k=m,this.l=M,this.n=x,this.o=B,this.q=Z,this.u=oe,this.w=he;const me=oe.extensionsGallery,ue=me?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.d=ue?me.servicePPEUrl:me?.serviceUrl,this.g=ue?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,p.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,s,this.o)}x(s=""){return`${this.d}${s}`}isEnabled(){return!!this.d}async getExtensions(s,m,M){const x=A.CancellationToken.isCancellationToken(m)?{}:m,B=A.CancellationToken.isCancellationToken(m)?m:M,Z=[],oe=[],he=[],me=[];let ue=!0;for(const ce of s){ce.uuid?oe.push(ce.uuid):Z.push(ce.id);const ve=!!(ce.version||ce.preRelease);he.push({id:ce.id,uuid:ce.uuid,includePreRelease:ve}),ce.version&&me.push({id:ce.id,uuid:ce.uuid,version:ce.version}),ue=ue&&!!ce.hasPreRelease&&!ve}if(!oe.length&&!Z.length)return[];let ge=new S().withPage(1,s.length);oe.length&&(ge=ge.withFilter(i.ExtensionId,...oe)),Z.length&&(ge=ge.withFilter(i.ExtensionName,...Z)),(x.queryAllVersions||ue)&&(ge=ge.withFlags(ge.flags,a.IncludeVersions)),x.source&&(ge=ge.withSource(x.source));const{extensions:de}=await this.z(ge,{targetPlatform:x.targetPlatform??P,includePreRelease:he,versions:me,compatible:!!x.compatible},B);return x.source&&de.forEach((ce,ve)=>q(ce,ve,x.source)),de}async getCompatibleExtension(s,m,M){if((0,E.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(s,m,M))return s;const x=new S().withFlags(a.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,s.identifier.uuid),{extensions:B}=await this.z(x,{targetPlatform:M,compatible:!0,includePreRelease:m},A.CancellationToken.None);return B[0]||null}async isExtensionCompatible(s,m,M){if(!(0,E.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,M)||!m&&s.properties.isPreReleaseVersion)return!1;let x=s.properties.engine;if(!x){const B=await this.getManifest(s,A.CancellationToken.None);if(!B)throw new Error("Manifest was not found");x=B.engines.vscode}return(0,v.isEngineValid)(x,this.u.version,this.u.date)}async y(s,m,M,x,B){if(!(0,E.isTargetPlatformCompatible)(W(s),x,B)||m!=="any"&&le(s)!==(m==="prerelease"))return!1;if(M)try{const Z=await this.E(s);if(!(0,v.isEngineValid)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${s.version}.`,(0,O.getErrorMessage)(Z)),!1}return!0}async query(s,m){let M=s.text||"";const x=s.pageSize??50;let B=new S().withPage(1,x);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,de)=>(B=B.withFilter(i.Category,de||ge),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,de)=>(B=B.withFilter(i.Tag,de||ge),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(i.SearchText,M)),B=B.withSortBy(0)):s.ids?B=B.withFilter(i.ExtensionId,...s.ids):s.names?B=B.withFilter(i.ExtensionName,...s.names):B=B.withSortBy(4),typeof s.sortBy=="number"&&(B=B.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(B=B.withSortOrder(s.sortOrder)),s.source&&(B=B.withSource(s.source));const Z=async(ue,ge)=>{const{extensions:de,total:ce}=await this.z(ue,{targetPlatform:P,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return de.forEach((ve,Se)=>q(ve,(ue.pageNumber-1)*ue.pageSize+Se,s.source)),{extensions:de,total:ce}},{extensions:oe,total:he}=await Z(B,m),me=async(ue,ge)=>{if(ge.isCancellationRequested)throw new O.CancellationError;const{extensions:de}=await Z(B.withPage(ue+1),ge);return de};return{firstPage:oe,total:he,pageSize:B.pageSize,getPage:me}}async z(s,m,M){const x=s.flags;!!(s.flags&a.IncludeLatestVersionOnly)&&!!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(s.flags&a.IncludeLatestVersionOnly)&&!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags,a.IncludeLatestVersionOnly)),m.versions?.length&&(s=s.withFlags(s.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),s=s.withFlags(s.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:B,total:Z,context:oe}=await this.B(s,M);if(!(s.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const de of B){const ce=await this.A(de,m,oe);ce&&ge.push(ce)}return{extensions:ge,total:Z}}const me=[],ue=new Map;for(let ge=0;ge<B.length;ge++){const de=B[ge],ce={id:(0,y.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},ve=(0,I.isBoolean)(m.includePreRelease)?m.includePreRelease:!!m.includePreRelease.find(Le=>(0,y.areSameExtensions)(Le,ce))?.includePreRelease;if(m.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(z(de),m.targetPlatform))continue;const Se=await this.A(de,m,oe);!Se||Se.properties.isPreReleaseVersion&&(!ve||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==m.targetPlatform&&Se.hasPreReleaseVersion?ue.set(de.extensionId,ge):me.push([ge,Se])}if(ue.size){const ge=new Date().getTime(),de=new S().withFlags(x&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:ce}=await this.z(de,m,M);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ue.size});for(const ve of ce){const Se=ue.get(ve.identifier.uuid);me.push([Se,ve])}}return{extensions:me.sort((ge,de)=>ge[0]-de[0]).map(([,ge])=>ge),total:Z}}async A(s,m,M){const x={id:(0,y.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},B=m.versions?.find(me=>(0,y.areSameExtensions)(me,x))?.version,Z=(0,I.isBoolean)(m.includePreRelease)?m.includePreRelease:!!m.includePreRelease.find(me=>(0,y.areSameExtensions)(me,x))?.includePreRelease,oe=z(s),he=U(s.versions,m.targetPlatform);if(m.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(oe,m.targetPlatform))return null;for(let me=0;me<he.length;me++){const ue=he[me];if(!(B&&ue.version!==B)){if(await this.y(ue,Z?"any":"release",m.compatible,oe,m.targetPlatform))return H(s,ue,oe,M);if(B&&ue.version===B)return null}}return B||m.compatible?null:H(s,s.versions[0],oe)}async B(s,m){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,a.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(a.Unpublished));const M=await this.j,x=JSON.stringify(s.raw),B={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},Z=new Date().getTime();let oe,he,me=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&s.criteria.some(ge=>ge.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:B},m),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:me};const ue=await(0,f.asJson)(oe);if(ue){const ge=ue.results[0],de=ge.extensions,ce=ge.resultMetadata&&ge.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return me=ce&&ce.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:me,context:{[t]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ue){throw he=ue,ue}finally{this.o.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-Z,success:!!oe&&(0,f.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:he?(0,O.isCancellationError)(he)?"canceled":(0,O.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(s,m,M,x){if(!this.isEnabled())return;const B=C.isWeb?this.x(`/itemName/${s}.${m}/version/${M}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${s}/extensions/${m}/${M}/stats?statType=${x}`),Z=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:B,headers:he},A.CancellationToken.None)}catch{}}async download(s,m,M){this.l.trace("ExtensionGalleryService#download",s.identifier.id);const x=(0,y.getGalleryExtensionTelemetryData)(s),B=new Date().getTime(),Z=ge=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:ge}),oe=M===2?"install":M===3?"update":"",he=oe?{uri:`${s.assets.download.uri}${h.URI.parse(s.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${s.assets.download.fallbackUri}${h.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:s.assets.download,me=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,ue=await this.D(he,me?{headers:me}:void 0);await this.q.writeFile(m,ue.stream),Z(new Date().getTime()-B)}async downloadSignatureArchive(s,m){if(!s.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const M=await this.D(s.assets.signature);await this.q.writeFile(m,M.stream)}async getReadme(s,m){if(s.assets.readme){const M=await this.D(s.assets.readme,{},m);return await(0,f.asTextOrError)(M)||""}return""}async getManifest(s,m){if(s.assets.manifest){const M=await this.D(s.assets.manifest,{},m),x=await(0,f.asTextOrError)(M);return x?JSON.parse(x):null}return null}async C(s,m){const M=ee(s,r.Manifest);if(!M)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},B=await this.D(M,{headers:x});return await(0,f.asJson)(B)}async getCoreTranslation(s,m){const M=s.assets.coreTranslations.filter(x=>x[0]===m.toUpperCase())[0];if(M){const x=await this.D(M[1]),B=await(0,f.asTextOrError)(x);return B?JSON.parse(B):null}return null}async getChangelog(s,m){if(s.assets.changelog){const M=await this.D(s.assets.changelog,{},m);return await(0,f.asTextOrError)(M)||""}return""}async getAllCompatibleVersions(s,m,M){let x=new S().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?x=x.withFilter(i.ExtensionId,s.identifier.uuid):x=x.withFilter(i.ExtensionName,s.identifier.id);const{galleryExtensions:B}=await this.B(x,A.CancellationToken.None);if(!B.length)return[];const Z=z(B[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(Z,M))return[];const oe=[];await Promise.all(B[0].versions.map(async ue=>{try{await this.y(ue,m?"any":"release",!0,Z,M)&&oe.push(ue)}catch{}}));const he=[],me=new Set;for(const ue of U(oe,M))me.has(ue.version)||(me.add(ue.version),he.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:le(ue)}));return he}async D(s,m={},M=A.CancellationToken.None){const x=await this.j,B={type:"GET"},Z={...x,...m.headers||{}};m={...m,...B,headers:Z};const oe=s.uri,he=s.fallbackUri,me={...m,url:oe};try{const ue=await this.k.request(me,M);if(ue.res.statusCode===200)return ue;const ge=await(0,f.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ge}`)}catch(ue){if((0,O.isCancellationError)(ue))throw ue;const ge=(0,O.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ge});const de={...m,url:he};return this.k.request(de,M)}}async E(s){let m=re(s);if(!m){const M=await this.C(s,A.CancellationToken.None);if(!M)throw new Error("Manifest was not found");m=M.engines.vscode}return m}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const s=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const m=await(0,f.asJson)(s),M=[],x={};if(m){for(const B of m.malicious)M.push({id:B});if(m.migrateToPreRelease)for(const[B,Z]of Object.entries(m.migrateToPreRelease))(!Z.engine||(0,v.isEngineValid)(Z.engine,this.u.version,this.u.date))&&(x[B.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(m.deprecated)for(const[B,Z]of Object.entries(m.deprecated))Z&&(x[B.toLowerCase()]=(0,I.isBoolean)(Z)?{}:Z)}return{malicious:M,deprecated:x}}};X=ye([te(1,f.IRequestService),te(2,k.ILogService),te(3,b.IEnvironmentService),te(4,g.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],X);let Y=class extends X{constructor(s,m,M,x,B,Z,oe,he){super(s,m,M,x,B,Z,oe,he)}};Y=ye([te(0,w.IStorageService),te(1,f.IRequestService),te(2,k.ILogService),te(3,b.IEnvironmentService),te(4,g.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],Y),e.ExtensionGalleryService=Y;let F=class extends X{constructor(s,m,M,x,B,Z,oe){super(void 0,s,m,M,x,B,Z,oe)}};F=ye([te(0,f.IRequestService),te(1,k.ILogService),te(2,b.IEnvironmentService),te(3,g.ITelemetryService),te(4,N.IFileService),te(5,u.IProductService),te(6,c.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F}),define(ie[156],ne([0,1,11,18,13,6,137,27,22,3,68]),function(G,e,T,A,O,C,L,I,h,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=class $e extends h.UserDataProfilesService{constructor(k,u,f,p,w){super(f,p,u,w),this.O=k,this.P=f}I(){return this.O.getItem($e.b,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.q.extUri.joinPath(this.profilesHome,u.location):T.URI.revive(u.location)}))}L(){const k=this.O.getItem($e.c,{});return this.O.getItem($e.a,!1)?k:this.H(k)}N(){return this.q.extUri.joinPath(T.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};E.a="profileAssociationsMigration",E=ye([te(0,L.IStateReadService),te(1,I.IUriIdentityService),te(2,A.INativeEnvironmentService),te(3,O.IFileService),te(4,C.ILogService)],E),e.UserDataProfilesReadonlyService=E;let y=class ze extends E{constructor(k,u,f,p,w){super(k,u,f,p,w),this.U=k}J(k){k.length?this.U.setItem(ze.b,k.map(u=>({...u,location:this.q.extUri.basename(u.location)}))):this.U.removeItem(ze.b)}I(){const k=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(k),this.U.setItem("userDataProfilesMigration",!0)),k}M(k){k.emptyWindows||k.workspaces?this.U.setItem(ze.c,k):this.U.removeItem(ze.c)}L(){const k="workspaceAndProfileInfo",u=this.U.getItem(k,void 0);if(u){this.U.removeItem(k);const p=u.reduce((w,{workspace:g,profile:P})=>(w[T.URI.revive(g).toString()]=T.URI.revive(P).toString(),w),{});this.U.setItem(ze.c,{workspaces:p})}const f=super.L();return this.U.getItem(ze.a,!1)||(this.M(f),this.U.setItem(ze.a,!0)),f}};y=ye([te(0,L.IStateService),te(1,I.IUriIdentityService),te(2,A.INativeEnvironmentService),te(3,O.IFileService),te(4,C.ILogService)],y),e.UserDataProfilesService=y;let v=class extends y{constructor(k,u,f,p){super(new b.StateService(0,u,p,f),k,u,f,p)}async init(){return await this.U.init(),super.init()}};v=ye([te(0,I.IUriIdentityService),te(1,A.INativeEnvironmentService),te(2,O.IFileService),te(3,C.ILogService)],v),e.ServerUserDataProfilesService=v}),define(ie[49],ne([0,1,123,8,15,3,20,85,171,172]),function(G,e,T,A,O,C,L,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const b=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.ExtractError=E;function y(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function v(t){if(t instanceof E)return t;let a;return b.test(t.message)&&(a="CorruptZip"),new E(a,t)}function N(t,a,n,i,r,o){const l=O.dirname(a),d=O.join(i,l);if(!d.startsWith(i))return Promise.reject(new Error(I.localize(0,null,a)));const S=O.join(i,a);let D;return o.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(L.Promises.mkdir(d,{recursive:!0})).then(()=>new Promise((j,K)=>{if(!o.isCancellationRequested)try{D=(0,T.createWriteStream)(S,{mode:n}),D.once("close",()=>j()),D.once("error",K),t.once("error",K),t.pipe(D)}catch(Q){K(Q)}}))}function k(t,a,n,i){let r=(0,A.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((l,d)=>{const S=new A.Sequencer,D=j=>{j.isCancellationRequested||(o++,t.readEntry())};t.once("error",d),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===o?l():d(new E("Incomplete",new Error(I.localize(1,null,o,t.entryCount))))},d)),t.readEntry(),t.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){D(i);return}const K=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(K)){const se=O.join(a,K);r=(0,A.createCancelablePromise)(re=>L.Promises.mkdir(se,{recursive:!0}).then(()=>D(re)).then(void 0,d));return}const Q=f(t,j),ee=y(j);r=(0,A.createCancelablePromise)(se=>S.queue(()=>Q.then(re=>N(re,K,ee,a,n,se).then(()=>D(se)))).then(null,d))})})}function u(t,a=!1){return new Promise((n,i)=>{(0,h.open)(t,a?{lazyEntries:!0}:void 0,(r,o)=>{r?i(v(r)):n((0,C.assertIsDefined)(o))})})}function f(t,a){return new Promise((n,i)=>{t.openReadStream(a,(r,o)=>{r?i(v(r)):n((0,C.assertIsDefined)(o))})})}function p(t,a){return new Promise((n,i)=>{const r=new c.ZipFile;a.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const o=(0,T.createWriteStream)(t);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(t))})}e.zip=p;function w(t,a,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=u(t,!0);return n.overwrite&&(o=o.then(l=>L.Promises.rm(a).then(()=>l))),o.then(l=>k(l,a,{sourcePathRegex:r},i))}e.extract=w;function g(t,a){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===a&&f(n,o).then(l=>i(l),l=>r(l))}),n.once("close",()=>r(new Error(I.localize(2,null,a))))}))}function P(t,a){return g(t,a).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",l=>o.push(l)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=P}),define(ie[157],ne([0,1,8,9,2,16,12,17,41,3,28,20,49,24,18,21,26,60,13,6]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class qe extends O.Disposable{constructor(t,a,n,i,r,o){super(),this.h=a,this.i=n,this.j=i,this.k=r,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,a){await this.g;const n=(0,I.joinPath)(this.extensionsDownloadDir,this.u(t));try{await this.q(t,n,r=>this.i.download(t,r,a))}catch(r){throw new k.ExtensionManagementError(r.message,k.ExtensionManagementErrorCode.Download)}let i="Unverified";if(this.m(t)){const r=await this.n(t);try{await this.k.verify(n.fsPath,r.fsPath,this.l.getLevel()===w.LogLevel.Trace)&&(i="Verified"),this.l.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${i}.`)}catch(o){const l=o,d=l.code;if(l.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${l.output}`),d==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${i}.`);else{if(d==="PackageIsInvalidZip"||d==="SignatureArchiveIsInvalidZip")throw new k.ExtensionManagementError(y.CorruptZipMessage,k.ExtensionManagementErrorCode.CorruptZip);if(!l.didExecute)this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${i} (${d})`);else throw await this.delete(n),new k.ExtensionManagementError(d,k.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(o){this.l.error(o)}}}return{location:n,verificationStatus:i}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(a)?a:!0}async n(t){await this.g;const a=(0,I.joinPath)(this.extensionsDownloadDir,`${this.u(t)}${qe.c}`);return await this.q(t,a,n=>this.i.downloadSignatureArchive(t,n)),a}async q(t,a,n){if(await this.h.exists(a))return;if(a.scheme!==C.Schemas.file){await n(a);return}const i=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.h.exists(i)||await n(i);try{await this.r(i,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(i)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,A.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.g,await this.h.del(t)}async r(t,a,n){try{await E.Promises.rename(t.fsPath,a.fsPath)}catch(i){if(L.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.r(t,a,n);throw i}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],n=[],i=[];for(const l of t.children)if(l.name.endsWith(qe.c))i.push(l.resource);else{const d=u.ExtensionKey.parse(l.name);d&&n.push([d,l])}const r=(0,u.groupByExtension)(n,([l])=>l),o=[];for(const l of r)l.sort((d,S)=>h.rcompare(d[0].version,S[0].version)),a.push(...l.slice(1).map(d=>d[1].resource)),o.push(l[0][1]);o.sort((l,d)=>l.mtime-d.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),a.push(...i),await T.Promises.settled(a.map(l=>(this.l.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.l.error(t)}}u(t){return this.f?u.ExtensionKey.create(t).toString().toLowerCase():(0,b.generateUuid)()}};g.c=".sigzip",g=ye([te(0,N.INativeEnvironmentService),te(1,p.IFileService),te(2,k.IExtensionGalleryService),te(3,v.IConfigurationService),te(4,f.IExtensionSignatureVerificationService),te(5,w.ILogService)],g),e.ExtensionsDownloader=g}),define(ie[158],ne([0,1,49,95]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function O(C){return(0,T.buffer)(C,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.getManifest=O}),define(ie[159],ne([0,1,8,14,23,34,9,5,2,36,16,15,12,17,41,3,11,28,20,49,94,59,18,150,21,26,40,48,157,151,158,132,139,32,46,13,10,6,31,25,27,22]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w,g,P,t,a,n,i,r,o,l,d,S,D,j,K,Q,ee,se,re,le,fe,ae,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,se.refineServiceDecorator)(n.IExtensionManagementService);let W=class extends a.AbstractExtensionManagementService{constructor(F,R,s,m,M,x,B,Z,oe,he,me,ue){super(F,R,s,he,ue),this.Z=M,this.ab=x,this.bb=B,this.cb=oe,this.db=me,this.X=this.D(new I.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const ge=this.D(Z.createInstance(d.ExtensionsLifecycle));this.S=this.D(Z.createInstance(z,ce=>ge.postUninstall(ce))),this.U=this.D(new D.ExtensionsManifestCache(m,this)),this.W=this.D(Z.createInstance(l.ExtensionsDownloader));const de=this.D(new j.ExtensionsWatcher(this,this.Z,ue,x,me,oe,s));this.D(de.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.u)),this.eb}async zip(F){this.u.trace("ExtensionManagementService#zip",F.identifier.id);const R=await this.jb(F),s=await(0,w.zip)((0,v.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,R);return u.URI.file(s)}async unzip(F){return this.u.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:R,cleanup:s}=await this.fb(F),m=E.resolve(R.fsPath);try{return await(0,S.getManifest)(m)}finally{await s()}}getInstalled(F,R=this.w.defaultProfile.extensionsResource){return this.S.scanExtensions(F??null,R)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.S.scanUserExtensionAtLocation(F)}async install(F,R={}){this.u.trace("ExtensionManagementService#install",F.toString());const{location:s,cleanup:m}=await this.fb(F);try{const M=await(0,S.getManifest)(E.resolve(s.fsPath));if(M.engines&&M.engines.vscode&&!(0,Q.isEngineValid)(M.engines.vscode,this.v.version,this.v.date))throw new Error(g.localize(0,null,(0,i.getGalleryExtensionId)(M.publisher,M.name),this.v.version));return await this.y(M,s,R)}finally{await m()}}async installFromLocation(F,R){this.u.trace("ExtensionManagementService#installFromLocation",F.toString());const s=await this.S.scanUserExtensionAtLocation(F);if(!s)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ob([[s,void 0]],R),this.u.info("Successfully installed extension",s.identifier.id,R.toString()),s}async installExtensionsFromProfile(F,R,s){this.u.trace("ExtensionManagementService#installExtensionsFromProfile",F,R.toString(),s.toString());const m=(await this.S.scanExtensions(1,R)).filter(M=>F.some(x=>(0,i.areSameExtensions)(x,M.identifier)));if(m.length){const M=await Promise.all(m.map(x=>this.S.scanMetadata(x,R)));await this.ob(m.map((x,B)=>[x,M[B]]),s),this.u.info("Successfully installed extensions",m.map(x=>x.identifier.id),s.toString())}return m}async updateMetadata(F,R,s=this.w.defaultProfile.extensionsResource){return this.u.trace("ExtensionManagementService#updateMetadata",F.identifier.id),R.isPreReleaseVersion&&(R.preRelease=!0),R.isMachineScoped=R.isMachineScoped||void 0,R.isBuiltin=R.isBuiltin||void 0,R.pinned=R.pinned||void 0,F=await this.S.updateMetadata(F,R,s),this.U.invalidate(),this.X.fire(F),F}async reinstallFromGallery(F){if(this.u.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.s.isEnabled())throw new Error(g.localize(1,null));const R=await this.getTargetPlatform(),[s]=await this.s.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:R,compatible:!0},O.CancellationToken.None);if(!s)throw new Error(g.localize(2,null));await this.S.setUninstalled(F);try{await this.S.removeUninstalledExtension(F)}catch(m){throw new Error(g.localize(3,null,(0,C.toErrorMessage)(m)))}return this.installFromGallery(s)}copyExtensions(F,R){return this.S.copyExtensions(F,R)}markAsUninstalled(...F){return this.S.setUninstalled(...F)}async cleanUp(){this.u.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(F){this.u.error(F)}}async download(F,R){const{location:s}=await this.W.download(F,R);return s}async fb(F){if(F.scheme===b.Schemas.file)return{location:F,async cleanup(){}};this.u.trace("Downloading extension from",F.toString());const R=(0,v.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(F,R),this.u.info("Downloaded extension to",R.toString()),{location:R,cleanup:async()=>{try{await this.cb.del(R)}catch(m){this.u.error(m)}}}}P(){return this.w.defaultProfile.extensionsResource}Q(F,R,s){if(u.URI.isUri(R))return new H(F,R,s,this.s,this.S,this.db,this.w,this.Z,this.ab,this.u);const m=i.ExtensionKey.create(R).toString();let M=this.Y.get(m);return M||(this.Y.set(m,M=new q(F,R,s,this.W,this.S,this.db,this.w,this.Z,this.ab,this.u)),M.waitUntilTaskIsFinished().then(()=>this.Y.delete(m))),M}R(F,R){return new X(F,R.profileLocation,this.ab)}async jb(F){const R=async m=>{let M=await p.Promises.readdir(m);M=M.map(Z=>E.join(m,Z));const x=await Promise.all(M.map(Z=>p.Promises.stat(Z)));let B=Promise.resolve([]);return x.forEach((Z,oe)=>{const he=M[oe];Z.isFile()&&(B=B.then(me=>[...me,he])),Z.isDirectory()&&(B=B.then(me=>R(he).then(ue=>[...me,...ue])))}),B};return(await R(F.location.fsPath)).map(m=>({path:`extension/${E.relative(F.location.fsPath,m)}`,localPath:m}))}async kb({added:F,removed:R}){if(R)for(const s of R.extensions)this.u.info("Extensions removed from another source",s.id,R.profileLocation.toString()),this.p.fire({identifier:s,profileLocation:R.profileLocation});if(F){const m=(await this.S.scanExtensions(1,F.profileLocation)).filter(M=>F.extensions.some(x=>(0,i.areSameExtensions)(x,M.identifier)));this.m.fire(m.map(M=>(this.u.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:1})))}}async mb(){this.D(this.S.onExtract(R=>this.lb.add(R)));const F=await this.cb.resolve(this.Z.userExtensionsLocation);for(const R of F.children??[])R.isDirectory&&this.lb.add(R.resource);this.D(this.cb.watch(this.Z.userExtensionsLocation)),this.D(this.cb.onDidFilesChange(R=>this.nb(R)))}async nb(F){if(!F.affects(this.Z.userExtensionsLocation,1))return;const R=[];for(const s of F.rawAdded){if(this.lb.has(s)||!this.db.extUri.isEqual(this.db.extUri.dirname(s),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(s,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(s).startsWith(".")||!(await this.cb.stat(s)).isDirectory)continue;const m=await this.S.scanUserExtensionAtLocation(s);m&&m.installedTimestamp===void 0&&(this.lb.add(s),R.push(m))}R.length&&(await this.ob(R.map(s=>[s,void 0]),this.w.defaultProfile.extensionsResource),this.u.info("Added extensions to default profile from external source",R.map(s=>s.identifier.id)))}async ob(F,R){const s=F.map(m=>m[0]);await this.pb(s),await this.ab.addExtensionsToProfile(F,R),this.m.fire(s.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:R})))}async pb(F){const R=await this.S.getUninstalledExtensions();for(const s of F){const m=i.ExtensionKey.create(s);!R[m.toString()]||(this.u.trace("Removing the extension from uninstalled list:",m.id),await this.S.setInstalled(m),this.u.info("Removed the extension from uninstalled list:",m.id))}}};W=ye([te(0,n.IExtensionGalleryService),te(1,fe.ITelemetryService),te(2,re.ILogService),te(3,t.INativeEnvironmentService),te(4,o.IExtensionsScannerService),te(5,r.IExtensionsProfileScannerService),te(6,P.IDownloadService),te(7,se.IInstantiationService),te(8,ee.IFileService),te(9,le.IProductService),te(10,ae.IUriIdentityService),te(11,$.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let z=class extends h.Disposable{constructor(F,R,s,m,M,x){super(),this.k=F,this.l=R,this.m=s,this.n=m,this.p=M,this.q=x,this.h=this.D(new I.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,v.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new T.Queue}async cleanUp(){await this.y(),this.j=this.j.then(()=>this.z()),await this.j}async scanExtensions(F,R){const s={includeInvalid:!0,profileLocation:R};let m=[];return F===null||F===0?m.push(...await this.m.scanAllExtensions({includeInvalid:!0},s,!1)):F===1&&m.push(...await this.m.scanUserExtensions(s)),m=F!==null?m.filter(M=>M.type===F):m,Promise.all(m.map(M=>this.w(M)))}async scanAllUserExtensions(F){const R=await this.m.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(R.map(s=>this.w(s)))}async scanUserExtensionAtLocation(F){try{const R=await this.m.scanExistingExtension(F,1,{includeInvalid:!0});if(R)return await this.w(R)}catch(R){this.q.error(R)}return null}async extractUserExtension(F,R,s,m){await this.j.catch(()=>{});const M=F.toString(),x=E.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),B=E.join(this.m.userExtensionsLocation.fsPath,M);try{await p.Promises.rm(B)}catch{throw new n.ExtensionManagementError(g.localize(4,null,B,F.id),n.ExtensionManagementErrorCode.Delete)}await this.t(F,R,x,m),await this.m.updateMetadata(u.URI.file(x),s);try{this.h.fire(u.URI.file(B)),await this.u(F,x,B,Date.now()+2*60*1e3),this.q.info("Renamed to",B)}catch(Z){try{await p.Promises.rm(x)}catch{}if(Z.code==="ENOTEMPTY")this.q.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.q.info(`Rename failed because of ${(0,L.getErrorMessage)(Z)}. Deleted from extracted location`,x),Z}return this.v(u.URI.file(B),1)}async scanMetadata(F,R){return R?(await this.n.scanProfileExtensions(R)).find(m=>(0,i.areSameExtensions)(m.identifier,F.identifier))?.metadata:this.m.scanMetadata(F.location)}async updateMetadata(F,R,s){return s?await this.n.updateMetadata([[F,R]],s):await this.m.updateMetadata(F.location,R),this.v(F.location,F.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...F){const R=F.map(s=>i.ExtensionKey.create(s));await this.s(s=>R.forEach(m=>{s[m.toString()]=!0,this.q.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.s(R=>delete R[F.toString()])}async removeExtension(F,R){this.q.trace(`Deleting ${R} extension from disk`,F.identifier.id,F.location.fsPath);const s=this.p.extUri.joinPath(this.p.extUri.dirname(F.location),`.${(0,f.generateUuid)()}`);await this.u(F.identifier,F.location.fsPath,s.fsPath,Date.now()+2*60*1e3),await this.l.del(s,{recursive:!0}),this.q.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.s(R=>delete R[i.ExtensionKey.create(F).toString()])}async copyExtensions(F,R){const s=await this.scanExtensions(1,F),m=await Promise.all(s.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.n.addExtensionsToProfile(m,R)}async s(F){return this.g.queue(async()=>{let R;try{R=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,ee.toFileOperationResult)(m)!==1)throw m}let s={};if(R)try{s=JSON.parse(R)}catch{}return F&&(F(s),Object.keys(s).length?await this.l.writeFile(this.c,A.VSBuffer.fromString(JSON.stringify(s))):await this.l.del(this.c)),s})}async t(F,R,s,m){this.q.trace(`Started extracting the extension from ${R} to ${s}`);try{await p.Promises.rm(s)}catch(M){throw new n.ExtensionManagementError(this.C(M).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(R,s,{sourcePath:"extension",overwrite:!0},m),this.q.info(`Extracted extension to ${s}:`,F.id)}catch(M){try{await p.Promises.rm(s)}catch{}let x=n.ExtensionManagementErrorCode.Extract;throw M instanceof w.ExtractError&&(M.type==="CorruptZip"?x=n.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(x=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(M.message,x)}}async u(F,R,s,m){try{await p.Promises.rename(R,s)}catch(M){if(y.isWindows&&M&&M.code==="EPERM"&&Date.now()<m)return this.q.info(`Failed renaming ${R} to ${s} with 'EPERM' error. Trying again...`,F.id),this.u(F,R,s,m);throw new n.ExtensionManagementError(M.message||g.localize(5,null,R,s),M.code||n.ExtensionManagementErrorCode.Rename)}}async v(F,R){const s=await this.m.scanExistingExtension(F,R,{includeInvalid:!0});if(s)return this.w(s);throw new Error(g.localize(6,null,F.path))}async w(F){const R=await this.l.resolve(F.location);let s,m;return R.children&&(s=R.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,m=R.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:s,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async y(){const F=await this.getUninstalledExtensions();this.q.debug("Removing uninstalled extensions:",Object.keys(F));const R=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),s=new Set;for(const M of R)F[i.ExtensionKey.create(M).toString()]||s.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(R,x=>x.identifier);await T.Promises.settled(M.map(async x=>{const B=x.sort((Z,oe)=>N.rcompare(Z.manifest.version,oe.manifest.version))[0];s.has(B.identifier.id.toLowerCase())||await this.k(await this.w(B))}))}catch(M){this.q.error(M)}const m=R.filter(M=>M.metadata&&F[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(m.map(M=>this.removeUninstalledExtension(M)))}async z(){this.q.trace("ExtensionManagementService#removeGeneratedFolders");const F=[];let R;try{R=await this.l.resolve(this.m.userExtensionsLocation)}catch(s){(0,ee.toFileOperationResult)(s)!==1&&this.q.error(s)}for(const s of R?.children??[])s.isDirectory&&s.name.startsWith(".")&&(0,f.isUUID)(s.name.substring(1))&&F.push((async()=>{this.q.trace("Deleting the generated extension folder",s.resource.toString());try{await this.l.del(s.resource,{recursive:!0}),this.q.info("Deleted the generated extension folder",s.resource.toString())}catch(m){this.q.error(m)}})());await Promise.allSettled(F)}C(F){const R=Array.isArray(F)?F:[F];return R.length===1?R[0]instanceof Error?R[0]:new Error(R[0]):R.reduce((s,m)=>new Error(`${s.message}${s.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}};z=ye([te(1,ee.IFileService),te(2,o.IExtensionsScannerService),te(3,r.IExtensionsProfileScannerService),te(4,ae.IUriIdentityService),te(5,re.ILogService)],z),e.ExtensionsScanner=z;class U extends a.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,k.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(F,R,s,m,M,x,B,Z,oe){super(),this.identifier=F,this.source=R,this.l=s,this.m=m,this.n=M,this.o=x,this.p=B,this.q=Z,this.s=oe,this.j="Unverified",this.k=2}async h(F){const[R,s]=await this.x(F);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[R,s]],this.l.profileLocation),R}async u({zipPath:F,key:R,metadata:s},m){let M=await this.v(R);return M||(this.s.trace("Extracting extension...",R.id),M=await this.m.extractUserExtension(R,F,s,m),this.s.info("Extracting extension completed.",R.id)),M}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.ExtensionKey.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class q extends U{constructor(F,R,s,m,M,x,B,Z,oe,he){super(R.identifier,R,s,M,x,B,Z,oe,he),this.y=F,this.z=R,this.A=m}async x(F){const s=(await this.m.scanExtensions(null,this.l.profileLocation)).find(B=>(0,i.areSameExtensions)(B.identifier,this.z.identifier));s&&(this.k=3);const m={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,K.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||s?.isMachineScoped,isBuiltin:this.l.isBuiltin||s?.isBuiltin,isSystem:s?.type===0?!0:void 0,updated:!!s,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,k.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:s?.preRelease)};if(s?.manifest.version===this.z.version)return[await this.m.updateMetadata(s,m),m];const{location:M,verificationStatus:x}=await this.A.download(this.z,this.k);try{return this.j=x,this.C(M.fsPath),[await this.u({zipPath:M.fsPath,key:i.ExtensionKey.create(this.z),metadata:m},F),m]}catch(B){try{await this.A.delete(M)}catch(Z){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,L.getErrorMessage)(Z))}throw B}}async C(F){try{await(0,S.getManifest)(F)}catch(R){throw new n.ExtensionManagementError((0,a.joinErrors)(R).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class H extends U{constructor(F,R,s,m,M,x,B,Z,oe,he){super({id:(0,i.getGalleryExtensionId)(F.publisher,F.name)},R,s,M,x,B,Z,oe,he),this.y=F,this.z=R,this.A=m}async h(F){const R=await super.h(F);return this.D(R,F),R}async x(F){const R=new i.ExtensionKey(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.l.profileLocation)).find(B=>(0,i.areSameExtensions)(this.identifier,B.identifier)),M={isApplicationScoped:(0,K.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||m?.isMachineScoped,isBuiltin:this.l.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0};if(m)if(this.k=3,R.equals(new i.ExtensionKey(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&N.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const B=await this.v(R);if(B)try{await this.m.removeExtension(B,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:E.resolve(this.z.fsPath),key:R,metadata:M},F),M]}async D(F,R){try{let[s]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],R);if(s||([s]=await this.A.getExtensions([{id:F.identifier.id}],R)),s){const m={id:s.identifier.uuid,publisherDisplayName:s.publisherDisplayName,publisherId:s.publisherId,isPreReleaseVersion:s.properties.isPreReleaseVersion,preRelease:s.properties.isPreReleaseVersion||this.l.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.l.profileLocation)}}catch{}}}class X extends a.AbstractExtensionTask{constructor(F,R,s){super(),this.extension=F,this.j=R,this.k=s}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,135,8,14,9,3,24,18,136,6,43,134,173]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let N=class extends E.AbstractRequestService{constructor(u,f,p,w){super(!!f.isRemoteServer,w),this.j=u,this.k=f,this.l=p,this.m(),this.D(u.onDidChangeConfiguration(g=>{g.affectsConfiguration("http")&&this.m()}))}m(){const u=this.j.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,f){const{f:p,g:w}=this;let g;try{g=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(a){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,C.getErrorMessage)(a)))}const P={...process.env,...g},t=u.agent?u.agent:await(0,y.getProxyAgent)(u.url||"",P,{proxyUrl:p,strictSSL:w});return u.agent=t,u.strictSSL=w,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.p(u,f)}async n(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((w,g)=>{G(["https"],w,g)}):await new Promise((w,g)=>{G(["http"],w,g)})).request}p(u,f){return this.c(u.isChromiumNetwork?"electron":"node",u,()=>A.Promises.withAsyncBody(async(p,w)=>{const g=(0,T.parse)(u.url),P=u.getRawRequest?u.getRawRequest(u):await this.n(u),t={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,L.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const a=P(t,n=>{const i=(0,L.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this.p({...u,url:n.headers.location,followRedirects:i-1},f).then(p,w);else{let r=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,v.createGunzip)())),p({res:n,stream:(0,O.streamToBufferReadableStream)(r)})}});a.on("error",w),u.timeout&&a.setTimeout(u.timeout),u.isChromiumNetwork&&a.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&a.write(u.data),a.end(),f.onCancellationRequested(()=>{a.abort(),w(new C.CancellationError)})}))}async resolveProxy(u){}};N=ye([te(0,I.IConfigurationService),te(1,h.INativeEnvironmentService),te(2,b.ILogService),te(3,b.ILoggerService)],N),e.RequestService=N}),define(ie[174],ne([0,1,33,8,14,34,9,2,16,15,12,35,11,20,24,131,59,133,18,109,155,21,60,138,40,48,159,153,13,120,122,47,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,22,156,147,152,124,126,4]),function(G,e,T,A,O,C,L,I,h,c,b,E,y,v,N,k,u,f,p,w,g,P,t,a,n,i,r,o,l,d,S,D,j,K,Q,ee,se,re,le,fe,ae,$,W,z,U,q,H,X,Y,F,R,s,m,M,x,B,Z,oe,he,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends I.Disposable{constructor(ce){super(),this.b=ce,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ce,ve]=await this.f();return ce.invokeFunction(async Se=>{const Le=Se.get(se.ILogService),Ue=Se.get(l.IFileService),V=Se.get(p.INativeEnvironmentService),J=Se.get(M.IUserDataProfilesService);Le.info("CLI main",this.b),this.g(Le),await this.h(V,Ue,J,ce),await Promise.all(ve.map(_=>{(0,A.raceTimeout)(_.flush(),1e3)}))})}async f(){const ce=new K.ServiceCollection,ve={_serviceBrand:void 0,...ae.default};ce.set($.IProductService,ve);const Se=new w.NativeEnvironmentService(this.b,ve);ce.set(p.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(De=>De?v.Promises.mkdir(De,{recursive:!0}):void 0));const Le=new he.LoggerService((0,se.getLogLevel)(Se),Se.logsHome);ce.set(se.ILoggerService,Le);const Ue=this.D(Le.createLogger("cli",{name:(0,me.localize)(0,null)})),V=[];Le.getLogLevel()===se.LogLevel.Trace&&V.push(new se.ConsoleLogger(Le.getLogLevel()));const J=this.D(new oe.LogService(Ue,V));ce.set(se.ILogService,J);const _=this.D(new d.FileService(J));ce.set(l.IFileService,_);const pe=this.D(new S.DiskFileSystemProvider(J));_.registerProvider(h.Schemas.file,pe);const Ee=new m.UriIdentityService(_);ce.set(s.IUriIdentityService,Ee);const Oe=new U.StateReadonlyService(1,Se,J,_),Ie=new x.UserDataProfilesReadonlyService(Oe,Ee,Se,_,J);ce.set(M.IUserDataProfilesService,Ie);const Ae=b.isWindows&&ve.win32RegValueName?this.D(new fe.NativePolicyService(J,ve.win32RegValueName)):Se.policyFile?this.D(new re.FilePolicyService(Se.policyFile,_,J)):new le.NullPolicyService;ce.set(le.IPolicyService,Ae);const Re=this.D(new k.ConfigurationService(Ie.defaultProfile.settingsResource,_,Ae,J));ce.set(N.IConfigurationService,Re),await Promise.all([Oe.init(),Re.initialize()]),Ie.init(),ce.set(s.IUriIdentityService,new m.UriIdentityService(_)),ce.set(W.IRequestService,new D.SyncDescriptor(z.RequestService,void 0,!0)),ce.set(u.IDownloadService,new D.SyncDescriptor(f.DownloadService,void 0,!0)),ce.set(n.IExtensionsProfileScannerService,new D.SyncDescriptor(Z.ExtensionsProfileScannerService,void 0,!0)),ce.set(i.IExtensionsScannerService,new D.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),ce.set(t.IExtensionSignatureVerificationService,new D.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),ce.set(r.INativeServerExtensionManagementService,new D.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),ce.set(P.IExtensionGalleryService,new D.SyncDescriptor(g.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ce.set(Q.ILanguagePackService,new D.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Ne=[],Fe=(0,Y.isInternalTelemetry)(ve,Re);if((0,Y.supportsTelemetry)(ve,Se)){ve.aiConfig&&ve.aiConfig.ariaKey&&Ne.push(new F.OneDataSystemAppender(Fe,"monacoworkbench",null,ve.aiConfig.ariaKey));const{installSourcePath:De}=Se,Te={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,B.resolveMachineId)(Oe)}catch(je){je.code!=="ENOENT"&&J.error(je)}return(0,q.resolveCommonProperties)(_,(0,T.release)(),(0,T.hostname)(),process.arch,ve.commit,ve.version,Ce,Fe,De)})(),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Se)};ce.set(H.ITelemetryService,new D.SyncDescriptor(X.TelemetryService,[Te],!1))}else ce.set(H.ITelemetryService,Y.NullTelemetryService);return[new j.InstantiationService(ce),Ne]}g(ce){(0,L.setUnexpectedErrorHandler)(ve=>{const Se=(0,C.toErrorMessage)(ve,!0);!Se||ce.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ve=>{(0,L.isSigPipeError)(ve)||(0,L.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,L.onUnexpectedError)(ve))}async h(ce,ve,Se,Le){let Ue;if(ce.args.profile&&(Ue=Se.profiles.find(J=>J.name===ce.args.profile),!Ue))throw new Error(`Profile '${ce.args.profile}' not found.`);const V=(Ue??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(ce,ve,this.b["install-source"]);if(this.b["list-extensions"])return Le.createInstance(a.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const J={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Le.createInstance(a.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),J,!!this.b.force)}else{if(this.b["uninstall-extension"])return Le.createInstance(a.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Le.createInstance(a.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,R.buildTelemetryMessage)(ce.appRoot,ce.extensionsPath))}}i(ce){return ce.map(ve=>/\.vsix$/i.test(ve)?y.URI.file((0,c.isAbsolute)(ve)?ve:(0,c.join)((0,E.cwd)(),ve)):ve)}async j(ce,ve,Se){await ve.writeFile(y.URI.file(ce.installSourcePath),O.VSBuffer.fromString(Se.slice(0,30)))}}async function ge(de){const ce=new ue(de);try{await ce.run()}finally{ce.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/155cd6db223feb1f8c734ca70e108b9efec7b054/core/vs/code/node/cliProcessMain.js.map
