/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],L=0,U=te.length;L<U;L++)e[L]=re[te[L]];return e};define(re[62],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(O){return(D,I,w)=>{let P=null,S=null;if(typeof w.value=="function"?(P="value",S=w.value):typeof w.get=="function"&&(P="get",S=w.get),!S)throw new Error("not supported");w[P]=O(S,I)}}function U(O,D,I){let w=null,P=null;if(typeof I.value=="function"?(w="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(w="get",P=I.get),!P)throw new Error("not supported");const S=`$memoize$${D}`;I[w]=function(...p){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[S]}}e.memoize=U;function l(O,D,I){return L((w,P)=>{const S=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...d){this[p]||(this[p]=I?I():void 0),clearTimeout(this[S]),D&&(this[p]=D(this[p],...d),d=[this[p]]),this[S]=setTimeout(()=>{w.apply(this,d),this[p]=I?I():void 0},O)}})}e.debounce=l;function A(O,D,I){return L((w,P)=>{const S=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...C){if(this[p]||(this[p]=I?I():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),D&&(this[p]=D(this[p],...C)),this[m])return;const c=this[d]+O;c<=Date.now()?(this[d]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0):(this[m]=!0,this[S]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0},c-Date.now()))}})}e.throttle=A}),define(re[10],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=L,e.errorHandler=new L;function U(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=U;function l(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(n){w(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=A;function O(n){w(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=O;function D(n){if(n instanceof Error){const{name:r,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:r,message:t,stack:i,noTelemetry:v.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=D;const I="Canceled";function w(n){return n instanceof P?!0:n instanceof Error&&n.name===I&&n.message===I}e.isCancellationError=w;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function S(){const n=new Error(I);return n.name=n.message,n}e.canceled=S;function p(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=p;function d(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=d;function m(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function C(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=C;function c(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=c;class u extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=u;class f extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=f;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const t=new v;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class R extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype);debugger}}e.BugIndicatingError=R}),define(re[21],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function U(q,J=0){return q[q.length-(1+J)]}e.tail=U;function l(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=l;function A(q,J,ee=(ce,he)=>ce===he){if(q===J)return!0;if(!q||!J||q.length!==J.length)return!1;for(let ce=0,he=q.length;ce<he;ce++)if(!ee(q[ce],J[ce]))return!1;return!0}e.equals=A;function O(q,J){const ee=q.length-1;J<ee&&(q[J]=q[ee]),q.pop()}e.removeFastWithoutKeepingOrder=O;function D(q,J,ee){return I(q.length,ce=>ee(q[ce],J))}e.binarySearch=D;function I(q,J){let ee=0,ce=q-1;for(;ee<=ce;){const he=(ee+ce)/2|0,me=J(he);if(me<0)ee=he+1;else if(me>0)ce=he-1;else return he}return-(ee+1)}e.binarySearch2=I;function w(q,J){let ee=0,ce=q.length;if(ce===0)return 0;for(;ee<ce;){const he=Math.floor((ee+ce)/2);J(q[he])?ce=he:ee=he+1}return ee}e.findFirstInSorted=w;function P(q,J,ee){if(q=q|0,q>=J.length)throw new TypeError("invalid index");const ce=J[Math.floor(J.length*Math.random())],he=[],me=[],de=[];for(const we of J){const Ce=ee(we,ce);Ce<0?he.push(we):Ce>0?me.push(we):de.push(we)}return q<he.length?P(q,he,ee):q<he.length+de.length?de[0]:P(q-(he.length+de.length),me,ee)}e.quickSelect=P;function S(q,J){const ee=[];let ce;for(const he of q.slice(0).sort(J))!ce||J(ce[0],he)!==0?(ce=[he],ee.push(ce)):ce.push(he);return ee}e.groupBy=S;function p(q,J,ee){const ce=[];function he(we,Ce,Re){if(Ce===0&&Re.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Ce,ke.toInsert.push(...Re)):ce.push({start:we,deleteCount:Ce,toInsert:Re})}let me=0,de=0;for(;;){if(me===q.length){he(me,0,J.slice(de));break}if(de===J.length){he(me,q.length-me,[]);break}const we=q[me],Ce=J[de],Re=ee(we,Ce);Re===0?(me+=1,de+=1):Re<0?(he(me,1,[]),me+=1):Re>0&&(he(me,0,[Ce]),de+=1)}return ce}e.sortedDiff=p;function d(q,J,ee){const ce=p(q,J,ee),he=[],me=[];for(const de of ce)he.push(...q.slice(de.start,de.start+de.deleteCount)),me.push(...de.toInsert);return{removed:he,added:me}}e.delta=d;function m(q,J,ee){if(ee===0)return[];const ce=q.slice(0,ee).sort(J);return c(q,J,ce,ee,q.length),ce}e.top=m;function C(q,J,ee,ce,he){return ee===0?Promise.resolve([]):new Promise((me,de)=>{(async()=>{const we=q.length,Ce=q.slice(0,ee).sort(J);for(let Re=ee,ke=Math.min(ee+ce,we);Re<we;Re=ke,ke=Math.min(ke+ce,we)){if(Re>ee&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new L.CancellationError;c(q,J,Ce,Re,ke)}return Ce})().then(me,de)})}e.topAsync=C;function c(q,J,ee,ce,he){for(const me=ee.length;ce<he;ce++){const de=q[ce];if(J(de,ee[me-1])<0){ee.pop();const we=w(ee,Ce=>J(de,Ce)<0);ee.splice(we,0,de)}}}function u(q){return q.filter(J=>!!J)}e.coalesce=u;function f(q){let J=0;for(let ee=0;ee<q.length;ee++)q[ee]&&(q[J]=q[ee],J+=1);q.length=J}e.coalesceInPlace=f;function g(q,J,ee){q.splice(ee,0,q.splice(J,1)[0])}e.move=g;function v(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=v;function R(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=R;function n(q,J=ee=>ee){const ee=new Set;return q.filter(ce=>{const he=J(ce);return ee.has(he)?!1:(ee.add(he),!0)})}e.distinct=n;function r(q){const J=new Set;return ee=>{const ce=q(ee);return J.has(ce)?!1:(J.add(ce),!0)}}e.uniqueFilter=r;function t(q,J){const ee=i(q,J);if(ee!==-1)return q[ee]}e.findLast=t;function i(q,J){for(let ee=q.length-1;ee>=0;ee--){const ce=q[ee];if(J(ce))return ee}return-1}e.lastIndex=i;function s(q,J){return q.length>0?q[0]:J}e.firstOrDefault=s;function a(q,J){return q.length>0?q[q.length-1]:J}e.lastOrDefault=a;function o(q,J,ee=(ce,he)=>ce===he){let ce=0;for(let he=0,me=Math.min(q.length,J.length);he<me&&ee(q[he],J[he]);he++)ce++;return ce}e.commonPrefixLength=o;function h(q){return[].concat(...q)}e.flatten=h;function b(q,J){let ee=typeof J=="number"?q:0;typeof J=="number"?ee=q:(ee=0,J=q);const ce=[];if(ee<=J)for(let he=ee;he<J;he++)ce.push(he);else for(let he=ee;he>J;he--)ce.push(he);return ce}e.range=b;function y(q,J,ee){return q.reduce((ce,he)=>(ce[J(he)]=ee?ee(he):he,ce),Object.create(null))}e.index=y;function k(q,J){return q.push(J),()=>T(q,J)}e.insert=k;function T(q,J){const ee=q.indexOf(J);if(ee>-1)return q.splice(ee,1),J}e.remove=T;function F(q,J,ee){const ce=q.slice(0,J),he=q.slice(J);return ce.concat(ee,he)}e.arrayInsert=F;function j(q,J){let ee;if(typeof J=="number"){let ce=J;ee=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else ee=Math.random;for(let ce=q.length-1;ce>0;ce-=1){const he=Math.floor(ee()*(ce+1)),me=q[ce];q[ce]=q[he],q[he]=me}}e.shuffle=j;function B(q,J){const ee=q.indexOf(J);ee>-1&&(q.splice(ee,1),q.unshift(J))}e.pushToStart=B;function V(q,J){const ee=q.indexOf(J);ee>-1&&(q.splice(ee,1),q.push(J))}e.pushToEnd=V;function W(q,J){for(const ee of J)q.push(ee)}e.pushMany=W;function Q(q,J){return Array.isArray(q)?q.map(J):J(q)}e.mapArrayOrNot=Q;function X(q){return Array.isArray(q)?q:[q]}e.asArray=X;function Y(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=Y;function Z(q,J){for(const ee of q){const ce=J(ee);if(ce!==void 0)return ce}}e.mapFind=Z;function H(q,J,ee){const ce=_(q,J),he=q.length,me=ee.length;q.length=he+me;for(let de=he-1;de>=ce;de--)q[de+me]=q[de];for(let de=0;de<me;de++)q[de+ce]=ee[de]}e.insertInto=H;function $(q,J,ee,ce){const he=_(q,J),me=q.splice(he,ee);return H(q,he,ce),me}e.splice=$;function _(q,J){return J<0?Math.max(J+q.length,0):Math.min(J,q.length)}var ie;(function(q){function J(he){return he<0}q.isLessThan=J;function ee(he){return he>0}q.isGreaterThan=ee;function ce(he){return he===0}q.isNeitherLessOrGreaterThan=ce,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function se(q,J){return(ee,ce)=>J(q(ee),q(ce))}e.compareBy=se;function ae(...q){return(J,ee)=>{for(const ce of q){const he=ce(J,ee);if(!ie.isNeitherLessOrGreaterThan(he))return he}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const x=(q,J)=>q-J;e.numberComparator=x;function M(q,J){if(q.length===0)return;let ee=q[0];for(let ce=1;ce<q.length;ce++){const he=q[ce];J(he,ee)>0&&(ee=he)}return ee}e.findMaxBy=M;function E(q,J){if(q.length===0)return;let ee=q[0];for(let ce=1;ce<q.length;ce++){const he=q[ce];J(he,ee)>=0&&(ee=he)}return ee}e.findLastMaxBy=E;function N(q,J){return M(q,(ee,ce)=>-J(ee,ce))}e.findMinBy=N;class z{constructor(J){this.f=J,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(J){let ee=this.c;for(;ee<this.f.length&&J(this.f[ee]);)ee++;const ce=ee===this.c?null:this.f.slice(this.c,ee);return this.c=ee,ce}takeFromEndWhile(J){let ee=this.d;for(;ee>=0&&J(this.f[ee]);)ee--;const ce=ee===this.d?null:this.f.slice(ee+1,this.d+1);return this.d=ee,ce}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const J=this.f[this.c];return this.c++,J}removeLast(){const J=this.f[this.d];return this.d--,J}takeCount(J){const ee=this.f.slice(this.c,this.c+J);return this.c+=J,ee}}e.ArrayQueue=z;class G{constructor(J){this.iterate=J}forEach(J){this.iterate(ee=>(J(ee),!0))}toArray(){const J=[];return this.iterate(ee=>(J.push(ee),!0)),J}filter(J){return new G(ee=>this.iterate(ce=>J(ce)?ee(ce):!0))}map(J){return new G(ee=>this.iterate(ce=>ee(J(ce))))}some(J){let ee=!1;return this.iterate(ce=>(ee=J(ce),!ee)),ee}findFirst(J){let ee;return this.iterate(ce=>J(ce)?(ee=ce,!1):!0),ee}findLast(J){let ee;return this.iterate(ce=>(J(ce)&&(ee=ce),!0)),ee}findLastMaxBy(J){let ee,ce=!0;return this.iterate(he=>((ce||ie.isGreaterThan(J(he,ee)))&&(ce=!1,ee=he),!0)),ee}}G.empty=new G(q=>{}),e.CallbackIterable=G}),define(re[129],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=U;function l(I,w="Unreachable"){throw new Error(w)}e.assertNever=l;function A(I){if(!I)throw new L.BugIndicatingError("Assertion Failed")}e.assert=A;function O(I){if(!I()){debugger;I(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function D(I,w){let P=0;for(;P<I.length-1;){const S=I[P],p=I[P+1];if(!w(S,p))return!1;P++}return!0}e.checkAdjacentItems=D}),define(re[82],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(U){const l=this;let A=!1,O;return function(){return A||(A=!0,O=U.apply(l,arguments)),O}}e.once=L}),define(re[63],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(U){function l(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}U.is=l;const A=Object.freeze([]);function O(){return A}U.empty=O;function*D(v){yield v}U.single=D;function I(v){return l(v)?v:D(v)}U.wrap=I;function w(v){return v||A}U.from=w;function P(v){return!v||v[Symbol.iterator]().next().done===!0}U.isEmpty=P;function S(v){return v[Symbol.iterator]().next().value}U.first=S;function p(v,R){for(const n of v)if(R(n))return!0;return!1}U.some=p;function d(v,R){for(const n of v)if(R(n))return n}U.find=d;function*m(v,R){for(const n of v)R(n)&&(yield n)}U.filter=m;function*C(v,R){let n=0;for(const r of v)yield R(r,n++)}U.map=C;function*c(...v){for(const R of v)for(const n of R)yield n}U.concat=c;function u(v,R,n){let r=n;for(const t of v)r=R(r,t);return r}U.reduce=u;function*f(v,R,n=v.length){for(R<0&&(R+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);R<n;R++)yield v[R]}U.slice=f;function g(v,R=Number.POSITIVE_INFINITY){const n=[];if(R===0)return[n,v];const r=v[Symbol.iterator]();for(let t=0;t<R;t++){const i=r.next();if(i.done)return[n,U.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return r}}]}U.consume=g})(L=e.Iterable||(e.Iterable={}))}),define(re[35],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var U;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(U=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(n,r=!1){let t=0;const i=n.length;let s="",a=0,o=16,h=0;function b(V){let W=0,Q=0;for(;W<V;){const X=n.charCodeAt(t);if(X>=48&&X<=57)Q=Q*16+X-48;else if(X>=65&&X<=70)Q=Q*16+X-65+10;else if(X>=97&&X<=102)Q=Q*16+X-97+10;else break;t++,W++}return W<V&&(Q=-1),Q}function y(V){t=V,s="",a=0,o=16,h=0}function k(){const V=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&w(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&w(n.charCodeAt(t)))for(t++;t<n.length&&w(n.charCodeAt(t));)t++;else return h=3,n.substring(V,t);let W=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&w(n.charCodeAt(t))){for(t++;t<n.length&&w(n.charCodeAt(t));)t++;W=t}else h=3;return n.substring(V,W)}function T(){let V="",W=t;for(;;){if(t>=i){V+=n.substring(W,t),h=2;break}const Q=n.charCodeAt(t);if(Q===34){V+=n.substring(W,t),t++;break}if(Q===92){if(V+=n.substring(W,t),t++,t>=i){h=2;break}switch(n.charCodeAt(t++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const Y=b(4);Y>=0?V+=String.fromCharCode(Y):h=4;break}default:h=5}W=t;continue}if(Q>=0&&Q<=31)if(I(Q)){V+=n.substring(W,t),h=2;break}else h=6;t++}return V}function F(){if(s="",h=0,a=t,t>=i)return a=i,o=17;let V=n.charCodeAt(t);if(D(V)){do t++,s+=String.fromCharCode(V),V=n.charCodeAt(t);while(D(V));return o=15}if(I(V))return t++,s+=String.fromCharCode(V),V===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),o=14;switch(V){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,s=T(),o=10;case 47:{const W=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!I(n.charCodeAt(t));)t++;return s=n.substring(W,t),o=12}if(n.charCodeAt(t+1)===42){t+=2;const Q=i-1;let X=!1;for(;t<Q;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,X=!0;break}t++}return X||(t++,h=1),s=n.substring(W,t),o=13}return s+=String.fromCharCode(V),t++,o=16}case 45:if(s+=String.fromCharCode(V),t++,t===i||!w(n.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=k(),o=11;default:for(;t<i&&j(V);)t++,V=n.charCodeAt(t);if(a!==t){switch(s=n.substring(a,t),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(V),t++,o=16}}function j(V){if(D(V)||I(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let V;do V=F();while(V>=12&&V<=15);return V}return{setPosition:y,getPosition:()=>t,scan:r?B:F,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>h}}e.createScanner=O;function D(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function S(n,r){const t=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(b,y,k,T){a.value=b,a.offset=y,a.length=k,a.type=T,a.colonOffset=void 0,s=a}try{g(n,{onObjectBegin:(b,y)=>{if(r<=b)throw i;s=void 0,o=r>b,t.push("")},onObjectProperty:(b,y,k)=>{if(r<y||(h(b,y,k,"property"),t[t.length-1]=b,r<=y+k))throw i},onObjectEnd:(b,y)=>{if(r<=b)throw i;s=void 0,t.pop()},onArrayBegin:(b,y)=>{if(r<=b)throw i;s=void 0,t.push(0)},onArrayEnd:(b,y)=>{if(r<=b)throw i;s=void 0,t.pop()},onLiteralValue:(b,y,k)=>{if(r<y||(h(b,y,k,R(b)),r<=y+k))throw i},onSeparator:(b,y,k)=>{if(r<=y)throw i;if(b===":"&&s&&s.type==="property")s.colonOffset=y,o=!1,s=void 0;else if(b===","){const T=t[t.length-1];typeof T=="number"?t[t.length-1]=T+1:(o=!0,t[t.length-1]=""),s=void 0}}})}catch(b){if(b!==i)throw b}return{path:t,previousNode:s,isAtPropertyKey:o,matches:b=>{let y=0;for(let k=0;y<b.length&&k<t.length;k++)if(b[y]===t[k]||b[y]==="*")y++;else if(b[y]!=="**")return!1;return y===b.length}}}e.getLocation=S;function p(n,r=[],t=A.DEFAULT){let i=null,s=[];const a=[];function o(b){Array.isArray(s)?s.push(b):i!==null&&(s[i]=b)}return g(n,{onObjectBegin:()=>{const b={};o(b),a.push(s),s=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const b=[];o(b),a.push(s),s=b,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(b,y,k)=>{r.push({error:b,offset:y,length:k})}},t),s[0]}e.parse=p;function d(n,r=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function a(b){return i.children.push(b),b}g(n,{onObjectBegin:b=>{i=a({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,y,k)=>{i=a({type:"property",offset:y,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:y,length:k,parent:i})},onObjectEnd:(b,y)=>{i.length=b+y-i.offset,i=i.parent,s(b+y)},onArrayBegin:(b,y)=>{i=a({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,y)=>{i.length=b+y-i.offset,i=i.parent,s(b+y)},onLiteralValue:(b,y,k)=>{a({type:R(b),offset:y,length:k,parent:i,value:b}),s(y+k)},onSeparator:(b,y,k)=>{i.type==="property"&&(b===":"?i.colonOffset=y:b===","&&s(y))},onError:(b,y,k)=>{r.push({error:b,offset:y,length:k})}},t);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=d;function m(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===i){t=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=m;function C(n){if(!n.parent||!n.parent.children)return[];const r=C(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=C;function c(n){switch(n.type){case"array":return n.children.map(c);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=c(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=c;function u(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=u;function f(n,r,t=!1){if(u(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const a=f(i[s],r,t);if(a)return a}return n}}e.findNodeAtOffset=f;function g(n,r,t=A.DEFAULT){const i=O(n,!1);function s(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(se){return se?ae=>se(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),h=a(r.onObjectProperty),b=s(r.onObjectEnd),y=s(r.onArrayBegin),k=s(r.onArrayEnd),T=a(r.onLiteralValue),F=a(r.onSeparator),j=s(r.onComment),B=a(r.onError),V=t&&t.disallowComments,W=t&&t.allowTrailingComma;function Q(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:V||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(se){case 12:case 13:V?X(10):j();break;case 16:X(1);break;case 15:case 14:break;default:return se}}}function X(se,ae=[],x=[]){if(B(se),ae.length+x.length>0){let M=i.getToken();for(;M!==17;){if(ae.indexOf(M)!==-1){Q();break}else if(x.indexOf(M)!==-1)break;M=Q()}}}function Y(se){const ae=i.getTokenValue();return se?T(ae):h(ae),Q(),!0}function Z(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(X(2),se=0)}catch{X(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return Q(),!0}function H(){return i.getToken()!==10?(X(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(F(":"),Q(),ie()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function $(){o(),Q();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||X(4,[],[]),F(","),Q(),i.getToken()===2&&W)break}else se&&X(6,[],[]);H()||X(4,[],[2,5]),se=!0}return b(),i.getToken()!==2?X(7,[2],[]):Q(),!0}function _(){y(),Q();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||X(4,[],[]),F(","),Q(),i.getToken()===4&&W)break}else se&&X(6,[],[]);ie()||X(4,[],[4,5]),se=!0}return k(),i.getToken()!==4?X(8,[4],[]):Q(),!0}function ie(){switch(i.getToken()){case 3:return _();case 1:return $();case 10:return Y(!0);default:return Z()}}return Q(),i.getToken()===17?t.allowEmptyContent?!0:(X(4,[],[]),!1):ie()?(i.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=g;function v(n,r){const t=O(n),i=[];let s,a=0,o;do switch(o=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==o&&i.push(n.substring(a,o)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),a=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=v;function R(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(re[42],oe([0,1,35]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(w,P,S){let p,d,m,C,c;if(P){for(C=P.offset,c=C+P.length,m=C;m>0&&!I(w,m-1);)m--;let o=c;for(;o<w.length&&!I(w,o);)o++;d=w.substring(m,o),p=O(d,S)}else d=w,p=0,m=0,C=0,c=w.length;const u=D(S,w);let f=!1,g=0,v;S.insertSpaces?v=A(" ",S.tabSize||4):v="	";const R=(0,L.createScanner)(d,!1);let n=!1;function r(){return u+A(v,p+g)}function t(){let o=R.scan();for(f=!1;o===15||o===14;)f=f||o===14,o=R.scan();return n=o===16||R.getTokenError()!==0,o}const i=[];function s(o,h,b){!n&&h<c&&b>C&&w.substring(h,b)!==o&&i.push({offset:h,length:b-h,content:o})}let a=t();if(a!==17){const o=R.getTokenOffset()+m,h=A(v,p);s(h,m,o)}for(;a!==17;){let o=R.getTokenOffset()+R.getTokenLength()+m,h=t(),b="";for(;!f&&(h===12||h===13);){const k=R.getTokenOffset()+m;s(" ",o,k),o=R.getTokenOffset()+R.getTokenLength()+m,b=h===12?r():"",h=t()}if(h===2)a!==1&&(g--,b=r());else if(h===4)a!==3&&(g--,b=r());else{switch(a){case 3:case 1:g++,b=r();break;case 5:case 12:b=r();break;case 13:f?b=r():b=" ";break;case 6:b=" ";break;case 10:if(h===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?b=" ":h!==5&&h!==17&&(n=!0);break;case 16:n=!0;break}f&&(h===12||h===13)&&(b=r())}const y=R.getTokenOffset()+m;s(b,o,y),a=h}return i}e.format=U;function l(w,P){const S=JSON.stringify(w,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}e.toFormattedString=l;function A(w,P){let S="";for(let p=0;p<P;p++)S+=w;return S}function O(w,P){let S=0,p=0;const d=P.tabSize||4;for(;S<w.length;){const m=w.charAt(S);if(m===" ")p++;else if(m==="	")p+=d;else break;S++}return Math.floor(p/d)}function D(w,P){for(let S=0;S<P.length;S++){const p=P.charAt(S);if(p==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=D;function I(w,P){return`\r
`.indexOf(w.charAt(P))!==-1}e.isEOL=I}),define(re[83],oe([0,1,35,42]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(w,P,S){return A(w,P,void 0,S)}e.removeProperty=l;function A(w,P,S,p,d){const m=P.slice(),C=[],c=(0,L.parseTree)(w,C);let u,f;for(;m.length>0&&(f=m.pop(),u=(0,L.findNodeAtLocation)(c,m),u===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(u)if(u.type==="object"&&typeof f=="string"&&Array.isArray(u.children)){const g=(0,L.findNodeAtLocation)(u,[f]);if(g!==void 0)if(S===void 0){if(!g.parent)throw new Error("Malformed AST");const v=u.children.indexOf(g.parent);let R,n=g.parent.offset+g.parent.length;if(v>0){const r=u.children[v-1];R=r.offset+r.length}else R=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return O(w,{offset:R,length:n-R,content:""},p)}else return O(w,{offset:g.offset,length:g.length,content:JSON.stringify(S)},p);else{if(S===void 0)return[];const v=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,R=d?d(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(R>0){const r=u.children[R-1];n={offset:r.offset+r.length,length:0,content:","+v}}else u.children.length===0?n={offset:u.offset+1,length:0,content:v}:n={offset:u.offset+1,length:0,content:v+","};return O(w,n,p)}}else if(u.type==="array"&&typeof f=="number"&&Array.isArray(u.children))if(S!==void 0){const g=`${JSON.stringify(S)}`;let v;if(u.children.length===0||f===0)v={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const R=f===-1||f>u.children.length?u.children.length:f,n=u.children[R-1];v={offset:n.offset+n.length,length:0,content:","+g}}return O(w,v,p)}else{const g=f,v=u.children[g];let R;if(u.children.length===1)R={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const n=u.children[g-1],r=n.offset+n.length,t=u.offset+u.length;R={offset:r,length:t-2-r,content:""}}else R={offset:v.offset,length:u.children[g+1].offset-v.offset,content:""};return O(w,R,p)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${u.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return O(w,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(S)},p)}}e.setProperty=A;function O(w,P,S){let p=D(w,P),d=P.offset,m=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,U.isEOL)(p,d-1);)d--;for(;m<p.length&&!(0,U.isEOL)(p,m);)m++}const C=(0,U.format)(p,{offset:d,length:m-d},S);for(let u=C.length-1;u>=0;u--){const f=C[u];p=D(p,f),d=Math.min(d,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const c=w.length-(p.length-m)-d;return[{offset:d,length:c,content:p.substring(d,m)}]}e.withFormatting=O;function D(w,P){return w.substring(0,P.offset)+P.content+w.substring(P.offset+P.length)}e.applyEdit=D;function I(w,P){const S=P.slice(0).sort((d,m)=>{const C=d.offset-m.offset;return C===0?d.length-m.length:C});let p=w.length;for(let d=S.length-1;d>=0;d--){const m=S[d];if(m.offset+m.length<=p)w=D(w,m);else throw new Error("Overlapping edit");p=m.offset}return w}e.applyEdits=I}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(re[2],oe([0,1,82,63]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function O(a){A=a}if(e.setDisposableTracker=O,l){const a="__is_disposable_tracked__";O(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[a]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==f.None)try{o[a]=!0}catch{}}markAsDisposed(o){if(o&&o!==f.None)try{o[a]=!0}catch{}}markAsSingleton(o){}})}function D(a){return A?.trackDisposable(a),a}function I(a){A?.markAsDisposed(a)}function w(a,o){A?.setParent(a,o)}function P(a,o){if(!!A)for(const h of a)A.setParent(h,o)}function S(a){return A?.markAsSingleton(a),a}e.markAsSingleton=S;function p(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=p;function d(a){if(U.Iterable.is(a)){const o=[];for(const h of a)if(h)try{h.dispose()}catch(b){o.push(b)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function m(a){for(const o of a)p(o)&&o.dispose();return[]}e.disposeIfDisposable=m;function C(...a){const o=c(()=>d(a));return P(a,o),o}e.combinedDisposable=C;function c(a){const o=D({dispose:(0,L.once)(()=>{I(o),a()})});return o}e.toDisposable=c;class u{constructor(){this.c=new Set,this.f=!1,D(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class f{constructor(){this.B=new u,D(this),w(this.B,this)}dispose(){I(this),this.B.dispose()}D(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(o)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class g{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&w(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&w(o,null),o}}e.MutableDisposable=g;class v{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(o){let h=o;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,I(this))},this}}e.SafeDisposable=R;class n{constructor(){this.a=new Map}acquire(o,...h){let b=this.a.get(o);b||(b={counter:0,object:this.b(o,...h)},this.a.set(o,b));const{object:y}=b,k=(0,L.once)(()=>{--b.counter===0&&(this.c(o,b.object),this.a.delete(o))});return b.counter++,{object:y,dispose:k}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...h){const b=this.a.acquire(o,...h);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(y){throw b.dispose(),y}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function i(a){const o=new u;try{a(o)}finally{o.dispose()}}e.disposeOnReturn=i;class s{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,h,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(o)?.dispose(),this.a.set(o,h)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(A){this.element=A,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class U{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let A=this.a;for(;A!==L.Undefined;){const O=A.next;A.prev=L.Undefined,A.next=L.Undefined,A=O}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const D=new L(A);if(this.a===L.Undefined)this.a=D,this.b=D;else if(O){const w=this.b;this.b=D,D.prev=w,w.next=D}else{const w=this.a;this.a=D,D.next=w,w.prev=D}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(D))}}shift(){if(this.a!==L.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==L.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==L.Undefined&&A.next!==L.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===L.Undefined&&A.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):A.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):A.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==L.Undefined;)yield A.element,A=A.next}}e.LinkedList=U}),define(re[37],oe([0,1]),function(te,e){"use strict";var L,U,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(C,c,u){let f=C.get(c);return f===void 0&&(f=u,C.set(c,f)),f}e.getOrSet=A;function O(C){const c=[];return C.forEach((u,f)=>{c.push(`${f} => ${u}`)}),`Map(${C.size}) {${c.join(", ")}}`}e.mapToString=O;function D(C){const c=[];return C.forEach(u=>{c.push(u)}),`Set(${C.size}) {${c.join(", ")}}`}e.setToString=D;class I{constructor(c,u){this.uri=c,this.value=u}}class w{constructor(c,u){this[L]="ResourceMap",c instanceof w?(this.b=new Map(c.b),this.c=u??w.a):(this.b=new Map,this.c=c??w.a)}set(c,u){return this.b.set(this.c(c),new I(c,u)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[f,g]of this.b)c(g.value,g.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}w.a=C=>C.toString(),e.ResourceMap=w;class P{constructor(c,u){this[U]="ResourceSet",!c||typeof c=="function"?this.a=new w(c):(this.a=new w(u),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,u){this.a.forEach((f,g)=>c.call(u,g,g,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var S;(function(C){C[C.None=0]="None",C[C.AsOld=1]="AsOld",C[C.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class p{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,u=0){const f=this.a.get(c);if(!!f)return u!==0&&this.j(f,u),f.value}set(c,u,f=0){let g=this.a.get(c);if(g)g.value=u,f!==0&&this.j(g,f);else{switch(g={key:c,value:u,next:void 0,previous:void 0},f){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(c,g),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this.a.get(c);if(!!u)return this.a.delete(c),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,u){const f=this.e;let g=this.b;for(;g;){if(u?c.bind(u)(g.value,g.key,this):c(g.value,g.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const c=this,u=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return g}values(){const c=this,u=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return g}entries(){const c=this,u=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this.b,f=this.size;for(;u&&f>c;)this.a.delete(u.key),u=u.next,f--;this.b=u,this.d=f,u&&(u.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const u=c.next,f=c.previous;if(!u||!f)throw new Error("Invalid list");u.previous=f,f.next=u}c.next=void 0,c.previous=void 0,this.e++}j(c,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this.b)return;const f=c.next,g=c.previous;c===this.c?(g.next=void 0,this.c=g):(f.previous=g,g.next=f),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(u===2){if(c===this.c)return;const f=c.next,g=c.previous;c===this.b?(f.previous=void 0,this.b=f):(f.previous=g,g.next=f),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((u,f)=>{c.push([f,u])}),c}fromJSON(c){this.clear();for(const[u,f]of c)this.set(u,f)}}e.LinkedMap=p;class d extends p{constructor(c,u=1){super(),this.k=c,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class m{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let u=this.a.get(c)||0;return u===0?!1:(u--,u===0?this.a.delete(c):this.a.set(c,u),!0)}has(c){return this.a.has(c)}}e.CounterSet=m}),define(re[85],oe([0,1,37]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new L.LRUCache(1e4);function l(w){return I(w,"NFC",U)}e.normalizeNFC=l;const A=new L.LRUCache(1e4);function O(w){return I(w,"NFD",A)}e.normalizeNFD=O;const D=/[^\u0000-\u0080]/;function I(w,P,S){if(!w)return w;const p=S.get(w);if(p)return p;let d;return D.test(w)?d=w.normalize(P):d=w,S.set(w,d),d}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(P){return O(P).replace(w,"")}}()}),define(re[131],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(D,I,w){return Math.min(Math.max(D,I),w)}e.clamp=L;function U(D,I){return(I+D%I)%I}e.rot=U;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class A{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class O{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const w=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function te(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function O(I){A.push(I,Date.now())}function D(){const I=[];for(let w=0;w<A.length;w+=2)I.push({name:A[w],startTime:A[w+1]});return I}return{mark:O,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(l+O.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function L(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=L(U))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var U in L)(typeof exports=="object"?exports:te)[U]=L[U]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function L(U){if(e[U])return e[U].exports;var l=e[U]={i:U,l:!1,exports:{}};return te[U].call(l.exports,l,l.exports,L),l.l=!0,l.exports}return L.m=te,L.c=e,L.d=function(U,l,A){L.o(U,l)||Object.defineProperty(U,l,{enumerable:!0,get:A})},L.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},L.t=function(U,l){if(1&l&&(U=L(U)),8&l||4&l&&typeof U=="object"&&U&&U.__esModule)return U;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:U}),2&l&&typeof U!="string")for(var O in U)L.d(A,O,function(D){return U[D]}.bind(null,O));return A},L.n=function(U){var l=U&&U.__esModule?function(){return U.default}:function(){return U};return L.d(l,"a",l),l},L.o=function(U,l){return Object.prototype.hasOwnProperty.call(U,l)},L.p="",L(L.s=0)}([function(te,e,L){(function(U){var l;e=te.exports=x,l=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],I=e.src=[],w=0,P=w++;I[P]="0|[1-9]\\d*";var S=w++;I[S]="[0-9]+";var p=w++;I[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=w++;I[d]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var m=w++;I[m]="("+I[S]+")\\.("+I[S]+")\\.("+I[S]+")";var C=w++;I[C]="(?:"+I[P]+"|"+I[p]+")";var c=w++;I[c]="(?:"+I[S]+"|"+I[p]+")";var u=w++;I[u]="(?:-("+I[C]+"(?:\\."+I[C]+")*))";var f=w++;I[f]="(?:-?("+I[c]+"(?:\\."+I[c]+")*))";var g=w++;I[g]="[0-9A-Za-z-]+";var v=w++;I[v]="(?:\\+("+I[g]+"(?:\\."+I[g]+")*))";var R=w++,n="v?"+I[d]+I[u]+"?"+I[v]+"?";I[R]="^"+n+"$";var r="[v=\\s]*"+I[m]+I[f]+"?"+I[v]+"?",t=w++;I[t]="^"+r+"$";var i=w++;I[i]="((?:<|>)?=?)";var s=w++;I[s]=I[S]+"|x|X|\\*";var a=w++;I[a]=I[P]+"|x|X|\\*";var o=w++;I[o]="[v=\\s]*("+I[a]+")(?:\\.("+I[a]+")(?:\\.("+I[a]+")(?:"+I[u]+")?"+I[v]+"?)?)?";var h=w++;I[h]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[f]+")?"+I[v]+"?)?)?";var b=w++;I[b]="^"+I[i]+"\\s*"+I[o]+"$";var y=w++;I[y]="^"+I[i]+"\\s*"+I[h]+"$";var k=w++;I[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=w++;I[T]="(?:~>?)";var F=w++;I[F]="(\\s*)"+I[T]+"\\s+",D[F]=new RegExp(I[F],"g");var j=w++;I[j]="^"+I[T]+I[o]+"$";var B=w++;I[B]="^"+I[T]+I[h]+"$";var V=w++;I[V]="(?:\\^)";var W=w++;I[W]="(\\s*)"+I[V]+"\\s+",D[W]=new RegExp(I[W],"g");var Q=w++;I[Q]="^"+I[V]+I[o]+"$";var X=w++;I[X]="^"+I[V]+I[h]+"$";var Y=w++;I[Y]="^"+I[i]+"\\s*("+r+")$|^$";var Z=w++;I[Z]="^"+I[i]+"\\s*("+n+")$|^$";var H=w++;I[H]="(\\s*)"+I[i]+"\\s*("+r+"|"+I[o]+")",D[H]=new RegExp(I[H],"g");var $=w++;I[$]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var _=w++;I[_]="^\\s*("+I[h]+")\\s+-\\s+("+I[h]+")\\s*$";var ie=w++;I[ie]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,I[se]),D[se]||(D[se]=new RegExp(I[se]));function ae(le,fe){if(le instanceof x)return le;if(typeof le!="string"||le.length>A||!(fe?D[t]:D[R]).test(le))return null;try{return new x(le,fe)}catch{return null}}function x(le,fe){if(le instanceof x){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof x))return new x(le,fe);l("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?D[t]:D[R]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<O)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ae,e.valid=function(le,fe){var ge=ae(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=ae(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(le){return l("SemVer.compare",this.version,this.loose,le),le instanceof x||(le=new x(le,this.loose)),this.compareMain(le)||this.comparePre(le)},x.prototype.compareMain=function(le){return le instanceof x||(le=new x(le,this.loose)),E(this.major,le.major)||E(this.minor,le.minor)||E(this.patch,le.patch)},x.prototype.comparePre=function(le){if(le instanceof x||(le=new x(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=le.prerelease[fe];if(l("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return E(ge,Ie)}while(++fe)},x.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new x(le,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(le,fe){if(q(le,fe))return null;var ge=ae(le),Ie=ae(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=E;var M=/^[0-9]+$/;function E(le,fe){var ge=M.test(le),Ie=M.test(fe);return ge&&Ie&&(le=+le,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:le<fe?-1:le>fe?1:0}function N(le,fe,ge){return new x(le,ge).compare(new x(fe,ge))}function z(le,fe,ge){return N(le,fe,ge)>0}function G(le,fe,ge){return N(le,fe,ge)<0}function q(le,fe,ge){return N(le,fe,ge)===0}function J(le,fe,ge){return N(le,fe,ge)!==0}function ee(le,fe,ge){return N(le,fe,ge)>=0}function ce(le,fe,ge){return N(le,fe,ge)<=0}function he(le,fe,ge,Ie){var Pe;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le!==ge;break;case"":case"=":case"==":Pe=q(le,ge,Ie);break;case"!=":Pe=J(le,ge,Ie);break;case">":Pe=z(le,ge,Ie);break;case">=":Pe=ee(le,ge,Ie);break;case"<":Pe=G(le,ge,Ie);break;case"<=":Pe=ce(le,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function me(le,fe){if(le instanceof me){if(le.loose===fe)return le;le=le.value}if(!(this instanceof me))return new me(le,fe);l("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===de?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(le,fe){return E(fe,le)},e.major=function(le,fe){return new x(le,fe).major},e.minor=function(le,fe){return new x(le,fe).minor},e.patch=function(le,fe){return new x(le,fe).patch},e.compare=N,e.compareLoose=function(le,fe){return N(le,fe,!0)},e.rcompare=function(le,fe,ge){return N(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=z,e.lt=G,e.eq=q,e.neq=J,e.gte=ee,e.lte=ce,e.cmp=he,e.Comparator=me;var de={};function we(le,fe){if(le instanceof we)return le.loose===fe?le:new we(le.raw,fe);if(le instanceof me)return new we(le.value,fe);if(!(this instanceof we))return new we(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ce(le){return!le||le.toLowerCase()==="x"||le==="*"}function Re(le,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue){return((fe=Ce(ge)?"":Ce(Ie)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(qe=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(je)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+je+"-"+ne:"<="+qe)).trim()}function ke(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(l(le[ge].semver),le[ge].semver!==de&&le[ge].semver.prerelease.length>0){var Ie=le[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(le,fe,ge){try{fe=new we(fe,ge)}catch{return!1}return fe.test(le)}function Ye(le,fe,ge,Ie){var Pe,Fe,Le,qe,Me;switch(le=new x(le,Ie),fe=new we(fe,Ie),ge){case">":Pe=z,Fe=ce,Le=G,qe=">",Me=">=";break;case"<":Pe=G,Fe=ee,Le=z,qe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(le,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var je=fe.set[Ne],ne=null,ue=null;if(je.forEach(function(pe){pe.semver===de&&(pe=new me(">=0.0.0")),ne=ne||pe,ue=ue||pe,Pe(pe.semver,ne.semver,Ie)?ne=pe:Le(pe.semver,ue.semver,Ie)&&(ue=pe)}),ne.operator===qe||ne.operator===Me||(!ue.operator||ue.operator===qe)&&Fe(le,ue.semver)||ue.operator===Me&&Le(le,ue.semver))return!1}return!0}me.prototype.parse=function(le){var fe=this.loose?D[Y]:D[Z],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new x(ge[2],this.loose):this.semver=de},me.prototype.toString=function(){return this.value},me.prototype.test=function(le){return l("Comparator.test",le,this.loose),this.semver===de||(typeof le=="string"&&(le=new x(le,this.loose)),he(le,this.operator,this.semver,this.loose))},me.prototype.intersects=function(le,fe){if(!(le instanceof me))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(le.value,fe),We(this.value,ge,fe);if(le.operator==="")return ge=new we(this.value,fe),We(le.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Fe=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=he(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=he(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ie||Pe||Fe&&Le||qe||Me},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),l("range",le,fe);var ge=fe?D[_]:D[$];le=le.replace(ge,Re),l("hyphen replace",le),le=le.replace(D[H],"$1$2$3"),l("comparator trim",le,D[H]),le=(le=(le=le.replace(D[F],"$1~")).replace(D[W],"$1^")).split(/\s+/).join(" ");var Ie=fe?D[Y]:D[Z],Pe=le.split(" ").map(function(Fe){return function(Le,qe){return l("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){l("caret",ne,ue);var pe=ue?D[X]:D[Q];return ne.replace(pe,function(Se,ve,Ee,De,Ae){var Te;return l("caret",ne,Se,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ae?(l("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+Ae+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){var pe=ue?D[B]:D[j];return ne.replace(pe,function(Se,ve,Ee,De,Ae){var Te;return l("tilde",ne,Se,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ae?(l("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("tildes",Le),Le=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(je){return function(ne,ue){ne=ne.trim();var pe=ue?D[y]:D[b];return ne.replace(pe,function(Se,ve,Ee,De,Ae,Te){l("xRange",ne,Se,ve,Ee,De,Ae,Te);var Ue=Ce(Ee),$e=Ue||Ce(De),ze=$e||Ce(Ae);return ve==="="&&ze&&(ve=""),Ue?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(De=0),ze&&(Ae=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,De=0,Ae=0):ze&&(De=+De+1,Ae=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:De=+De+1),Se=ve+Ee+"."+De+"."+Ae):$e?Se=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Se=">="+Ee+"."+De+".0 <"+Ee+"."+(+De+1)+".0"),l("xRange return",Se),Se})}(je,Ne)}).join(" ")}(Le,qe),l("xrange",Le),Le=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(D[ie],"")}(Le,qe),l("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new me(Fe,fe)})},we.prototype.intersects=function(le,fe){if(!(le instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return le.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(le,fe){return new we(le,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},we.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new x(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],le))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new we(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new x(Ie=Le,ge)))}),Ie},e.minSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new we(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new x(Ie=Le,ge)))}),Ie},e.validRange=function(le,fe){try{return new we(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Ye(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Ye(le,fe,">",ge)},e.outside=Ye,e.prerelease=function(le,fe){var ge=ae(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new we(le,ge),fe=new we(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof x)return le;if(typeof le!="string")return null;var fe=le.match(D[k]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(te,e){var L,U,l=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function D(c){if(L===setTimeout)return setTimeout(c,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{U=typeof clearTimeout=="function"?clearTimeout:O}catch{U=O}})();var I,w=[],P=!1,S=-1;function p(){P&&I&&(P=!1,I.length?w=I.concat(w):S=-1,w.length&&d())}function d(){if(!P){var c=D(p);P=!0;for(var u=w.length;u;){for(I=w,w=[];++S<u;)I&&I[S].run();S=-1,u=w.length}I=null,P=!1,function(f){if(U===clearTimeout)return clearTimeout(f);if((U===O||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(f);try{U(f)}catch{try{return U.call(null,f)}catch{return U.call(this,f)}}}(c)}}function m(c,u){this.fun=c,this.array=u}function C(){}l.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];w.push(new m(c,u)),w.length!==1||P||D(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=C,l.addListener=C,l.once=C,l.off=C,l.removeListener=C,l.removeAllListeners=C,l.emit=C,l.prependListener=C,l.prependOnceListener=C,l.listeners=function(c){return[]},l.binding=function(c){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(c){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(re[132],oe([0,1]),function(te,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(D,I,w){this.level=D,this.key=I,this.value=w,this.forward=[]}}const l=void 0;class A{constructor(D,I=2**16){this.comparator=D,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new U(this.c,l,l)}get size(){return this.f}clear(){this.e=new U(this.c,l,l)}has(D){return Boolean(A.g(this,D,this.comparator))}get(D){return A.g(this,D,this.comparator)?.value}set(D,I){return A.h(this,D,I,this.comparator)&&(this.f+=1),this}delete(D){const I=A.k(this,D,this.comparator);return I&&(this.f-=1),I}forEach(D,I){let w=this.e.forward[0];for(;w;)D.call(I,w.value,w.key,this),w=w.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this.e.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this.e.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this.e.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",I=this.e.forward[0];for(;I;)D+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return D}static g(D,I,w){let P=D.e;for(let S=D.d-1;S>=0;S--)for(;P.forward[S]&&w(P.forward[S].key,I)<0;)P=P.forward[S];if(P=P.forward[0],P&&w(P.key,I)===0)return P}static h(D,I,w,P){const S=[];let p=D.e;for(let d=D.d-1;d>=0;d--){for(;p.forward[d]&&P(p.forward[d].key,I)<0;)p=p.forward[d];S[d]=p}if(p=p.forward[0],p&&P(p.key,I)===0)return p.value=w,!1;{const d=A.j(D);if(d>D.d){for(let m=D.d;m<d;m++)S[m]=D.e;D.d=d}p=new U(d,I,w);for(let m=0;m<d;m++)p.forward[m]=S[m].forward[m],S[m].forward[m]=p;return!0}}static j(D,I=.5){let w=1;for(;Math.random()<I&&w<D.c;)w+=1;return w}static k(D,I,w){const P=[];let S=D.e;for(let p=D.d-1;p>=0;p--){for(;S.forward[p]&&w(S.forward[p].key,I)<0;)S=S.forward[p];P[p]=S}if(S=S.forward[0],!S||w(S.key,I)!==0)return!1;for(let p=0;p<D.d&&P[p].forward[p]===S;p++)P[p].forward[p]=S.forward[p];for(;D.d>0&&D.e.forward[D.d-1]===l;)D.d-=1;return!0}}e.SkipList=A}),define(re[43],oe([0,1,10,2]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(v){const R=v;return R?typeof R.read=="function":!1}e.isReadable=l;function A(v){const R=v;return R?[R.on,R.pause,R.resume,R.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function O(v){const R=v;return R?A(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=O;function D(v,R){return new I(v,R)}e.newWriteableStream=D;class I{constructor(R,n){this.e=R,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(n=>n(R))}h(R){this.c.error.length===0?(0,L.onUnexpectedError)(R):this.c.error.slice(0).forEach(n=>n(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,n){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(R,n){if(this.a.destroyed)return;let r;switch(R){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(v,R){const n=[];let r;for(;(r=v.read())!==null;)n.push(r);return R(n)}e.consumeReadable=w;function P(v,R,n){const r=[];let t;for(;(t=v.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?R(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return v.read()}}}e.peekReadable=P;function S(v,R){return new Promise((n,r)=>{const t=[];p(v,{onData:i=>{R&&t.push(i)},onError:i=>{R?r(i):n(void 0)},onEnd:()=>{n(R?R(t):void 0)}})})}e.consumeStream=S;function p(v,R){let n=!1;return v.on("error",r=>{n||R.onError(r)}),v.on("end",()=>{n||R.onEnd()}),v.on("data",r=>{n||R.onData(r)}),(0,U.toDisposable)(()=>n=!0)}e.listenStream=p;function d(v,R){return new Promise((n,r)=>{const t=new U.DisposableStore,i=[],s=h=>{if(i.push(h),i.length>R)return t.dispose(),v.pause(),n({stream:v,buffer:i,ended:!1})},a=h=>r(h),o=()=>n({stream:v,buffer:i,ended:!0});t.add((0,U.toDisposable)(()=>v.removeListener("error",a))),v.on("error",a),t.add((0,U.toDisposable)(()=>v.removeListener("end",o))),v.on("end",o),t.add((0,U.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=d;function m(v,R){const n=D(R);return n.end(v),n}e.toStream=m;function C(){const v=D(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=C;function c(v){let R=!1;return{read:()=>R?null:(R=!0,v)}}e.toReadable=c;function u(v,R,n){const r=D(n);return p(v,{onData:t=>r.write(R.data(t)),onError:t=>r.error(R.error?R.error(t):t),onEnd:()=>r.end()}),r}e.transform=u;function f(v,R,n){let r=!1;return{read:()=>{const t=R.read();return r?t:(r=!0,t!==null?n([v,t]):v)}}}e.prefixedReadable=f;function g(v,R,n){let r=!1;const t=D(n);return p(R,{onData:i=>r?t.write(i):(r=!0,t.write(n([v,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(v)),t.end()}}),t}e.prefixedStream=g}),define(re[16],oe([0,1,43]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const U=typeof Buffer<"u";let l,A;class O{static alloc(h){return U?new O(Buffer.allocUnsafe(h)):new O(new Uint8Array(h))}static wrap(h){return U&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new O(h)}static fromString(h,b){return!(b?.dontUseNodeBuffer||!1)&&U?new O(Buffer.from(h)):(l||(l=new TextEncoder),new O(l.encode(h)))}static fromByteArray(h){const b=O.alloc(h.length);for(let y=0,k=h.length;y<k;y++)b.buffer[y]=h[y];return b}static concat(h,b){if(typeof b>"u"){b=0;for(let T=0,F=h.length;T<F;T++)b+=h[T].byteLength}const y=O.alloc(b);let k=0;for(let T=0,F=h.length;T<F;T++){const j=h[T];y.set(j,k),k+=j.byteLength}return y}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=O.alloc(this.byteLength);return h.set(this),h}toString(){return U?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(h,b){return new O(this.buffer.subarray(h,b))}set(h,b){if(h instanceof O)this.buffer.set(h.buffer,b);else if(h instanceof Uint8Array)this.buffer.set(h,b);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),b);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return w(this.buffer,h)}writeUInt32BE(h,b){P(this.buffer,h,b)}readUInt32LE(h){return S(this.buffer,h)}writeUInt32LE(h,b){p(this.buffer,h,b)}readUInt8(h){return d(this.buffer,h)}writeUInt8(h,b){m(this.buffer,h,b)}}e.VSBuffer=O;function D(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0}e.readUInt16LE=D;function I(o,h,b){o[b+0]=h&255,h=h>>>8,o[b+1]=h&255}e.writeUInt16LE=I;function w(o,h){return o[h]*2**24+o[h+1]*2**16+o[h+2]*2**8+o[h+3]}e.readUInt32BE=w;function P(o,h,b){o[b+3]=h,h=h>>>8,o[b+2]=h,h=h>>>8,o[b+1]=h,h=h>>>8,o[b]=h}e.writeUInt32BE=P;function S(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0|o[h+2]<<16>>>0|o[h+3]<<24>>>0}e.readUInt32LE=S;function p(o,h,b){o[b+0]=h&255,h=h>>>8,o[b+1]=h&255,h=h>>>8,o[b+2]=h&255,h=h>>>8,o[b+3]=h&255}e.writeUInt32LE=p;function d(o,h){return o[h]}e.readUInt8=d;function m(o,h,b){o[b]=h}e.writeUInt8=m;function C(o){return L.consumeReadable(o,h=>O.concat(h))}e.readableToBuffer=C;function c(o){return L.toReadable(o)}e.bufferToReadable=c;function u(o){return L.consumeStream(o,h=>O.concat(h))}e.streamToBuffer=u;async function f(o){return o.ended?O.concat(o.buffer):O.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=f;function g(o){return L.toStream(o,h=>O.concat(h))}e.bufferToStream=g;function v(o){return L.transform(o,{data:h=>typeof h=="string"?O.fromString(h):O.wrap(h)},h=>O.concat(h))}e.streamToBufferReadableStream=v;function R(o){return L.newWriteableStream(h=>O.concat(h),o)}e.newWriteableBufferStream=R;function n(o,h){return L.prefixedReadable(o,h,b=>O.concat(b))}e.prefixedBufferReadable=n;function r(o,h){return L.prefixedStream(o,h,b=>O.concat(b))}e.prefixedBufferStream=r;function t(o){let h=0,b=0,y=0;const k=new Uint8Array(Math.floor(o.length/4*3)),T=j=>{switch(b){case 3:k[y++]=h|j,b=0;break;case 2:k[y++]=h|j>>>2,h=j<<6,b=3;break;case 1:k[y++]=h|j>>>4,h=j<<4,b=2;break;default:h=j<<2,b=1}};for(let j=0;j<o.length;j++){const B=o.charCodeAt(j);if(B>=65&&B<=90)T(B-65);else if(B>=97&&B<=122)T(B-97+26);else if(B>=48&&B<=57)T(B-48+52);else if(B===43||B===45)T(62);else if(B===47||B===95)T(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${o[j]}`)}}const F=y;for(;b>0;)T(0);return O.wrap(k).slice(0,F)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},h=!0,b=!1){const y=b?s:i;let k="";const T=o.byteLength%3;let F=0;for(;F<o.byteLength-T;F+=3){const j=o[F+0],B=o[F+1],V=o[F+2];k+=y[j>>>2],k+=y[(j<<4|B>>>4)&63],k+=y[(B<<2|V>>>6)&63],k+=y[V&63]}if(T===1){const j=o[F+0];k+=y[j>>>2],k+=y[j<<4&63],h&&(k+="==")}else if(T===2){const j=o[F+0],B=o[F+1];k+=y[j>>>2],k+=y[(j<<4|B>>>4)&63],k+=y[B<<2&63],h&&(k+="=")}return k}e.encodeBase64=a}),define(re[133],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(re[12],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(r){return typeof r=="string"}e.isString=L;function U(r){return Array.isArray(r)&&r.every(t=>L(t))}e.isStringArray=U;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=A;function O(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=O;function D(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=D;function I(r){return r===!0||r===!1}e.isBoolean=I;function w(r){return typeof r>"u"}e.isUndefined=w;function P(r){return!S(r)}e.isDefined=P;function S(r){return w(r)||r===null}e.isUndefinedOrNull=S;function p(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function d(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=d;function m(...r){const t=[];for(let i=0;i<r.length;i++){const s=r[i];if(S(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=m;const C=Object.prototype.hasOwnProperty;function c(r){if(!l(r))return!1;for(const t in r)if(C.call(r,t))return!1;return!0}e.isEmptyObject=c;function u(r){return typeof r=="function"}e.isFunction=u;function f(...r){return r.length>0&&r.every(u)}e.areFunctions=f;function g(r,t){const i=Math.min(r.length,t.length);for(let s=0;s<i;s++)v(r[s],t[s])}e.validateConstraints=g;function v(r,t){if(L(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(r instanceof t)return}catch{}if(!S(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function R(r){return r===null?void 0:r}e.withNullAsUndefined=R;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(re[52],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const U=Object.create(null);function l(D,I){if((0,L.isString)(I)){const w=U[I];if(w===void 0)throw new Error(`${D} references an unknown codicon: ${I}`);I=w}return U[D]=I,{id:D}}function A(){return U}e.getCodiconFontCharacters=A;function O(){return Object.values(e.Codicon)}e.getAllCodicons=O,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(re[32],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,v])=>{f[g]=v&&typeof v=="object"?U(v):v}),f}e.deepClone=U;function l(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const g=f.shift();Object.freeze(g);for(const v in g)if(A.call(g,v)){const R=g[v];typeof R=="object"&&!Object.isFrozen(R)&&!(0,L.isTypedArray)(R)&&f.push(R)}}return u}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function O(u,f){return D(u,f,new Set)}e.cloneAndChange=O;function D(u,f,g){if((0,L.isUndefinedOrNull)(u))return u;const v=f(u);if(typeof v<"u")return v;if(Array.isArray(u)){const R=[];for(const n of u)R.push(D(n,f,g));return R}if((0,L.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const R={};for(const n in u)A.call(u,n)&&(R[n]=D(u[n],f,g));return g.delete(u),R}return u}function I(u,f,g=!0){return(0,L.isObject)(u)?((0,L.isObject)(f)&&Object.keys(f).forEach(v=>{v in u?g&&((0,L.isObject)(u[v])&&(0,L.isObject)(f[v])?I(u[v],f[v],g):u[v]=f[v]):u[v]=f[v]}),u):f}e.mixin=I;function w(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let g,v;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(g=0;g<u.length;g++)if(!w(u[g],f[g]))return!1}else{const R=[];for(v in u)R.push(v);R.sort();const n=[];for(v in f)n.push(v);if(n.sort(),!w(R,n))return!1;for(g=0;g<R.length;g++)if(!w(u[R[g]],f[R[g]]))return!1}return!0}e.equals=w;function P(u){const f=new Set;return JSON.stringify(u,(g,v)=>{if((0,L.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=P;function S(u,f){const g=Object.create(null);return!u||!f||Object.keys(f).forEach(R=>{const n=u[R],r=f[R];w(n,r)||(g[R]=r)}),g}e.distinct=S;function p(u,f){const g=f.toLowerCase(),v=Object.keys(u).find(R=>R.toLowerCase()===g);return v?u[v]:u[f]}e.getCaseInsensitive=p;function d(u,f){const g=Object.create(null);for(const[v,R]of Object.entries(u))f(v,R)&&(g[v]=R);return g}e.filter=d;function m(u){let f=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)f=f.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return f}e.getAllPropertyNames=m;function C(u){const f=[];for(const g of m(u))typeof u[g]=="function"&&f.push(g);return f}e.getAllMethodNames=C;function c(u,f){const g=R=>function(){const n=Array.prototype.slice.call(arguments,0);return f(R,n)},v={};for(const R of u)v[R]=g(R);return v}e.createProxyObject=c}),define(re[134],oe([0,1,52]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var U;(function(O){function D(I){return I&&typeof I=="object"&&typeof I.id=="string"}O.isThemeColor=D})(U=e.ThemeColor||(e.ThemeColor={}));function l(O){return{id:O}}e.themeColorFromId=l;var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function I(f){const g=D.exec(f.id);if(!g)return I(L.Codicon.error);const[,v,R]=g,n=["codicon","codicon-"+v];return R&&n.push("codicon-modifier-"+R.substring(1)),n}O.asClassNameArray=I;function w(f){return I(f).join(" ")}O.asClassName=w;function P(f){return"."+I(f).join(".")}O.asCSSSelector=P;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||U.isThemeColor(f.color))}O.isThemeIcon=S;const p=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function d(f){const g=p.exec(f);if(!g)return;const[,v]=g;return{id:v}}O.fromString=d;function m(f){return{id:f}}O.fromId=m;function C(f,g){let v=f.id;const R=v.lastIndexOf("~");return R!==-1&&(v=v.substring(0,R)),g&&(v=`${v}~${g}`),{id:v}}O.modify=C;function c(f){const g=f.id.lastIndexOf("~");if(g!==-1)return f.id.substring(g+1)}O.getModifier=c;function u(f,g){return f.id===g.id&&f.color?.id===g.color?.id}O.isEqual=u})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(re[31],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(l){return L.test(l)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),O=[];for(let D=0;D<256;D++)O.push(D.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,w="";return w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w+="-",w+=O[A[I++]],w+=O[A[I++]],w+="-",w+=O[A[I++]],w+=O[A[I++]],w+="-",w+=O[A[I++]],w+=O[A[I++]],w+="-",w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w+=O[A[I++]],w}}()}),define(re[135],oe([0,1,34]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(O){const D=O.replace(/\-/g,":").toLowerCase();return!U.has(D)}function A(){const O=(0,L.networkInterfaces)();for(const D in O){const I=O[D];if(I){for(const{mac:w}of I)if(l(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(re[136],oe([0,1,86]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(D,I,w,P=1){let S=!1;return new Promise(p=>{const d=setTimeout(()=>{if(!S)return S=!0,p(0)},w);l(D,I,P,m=>{if(!S)return S=!0,clearTimeout(d),p(m)})})}e.findFreePort=U;function l(D,I,w,P){if(I===0)return P(0);const S=new L.Socket;S.once("connect",()=>(O(S),l(D+w,I-1,w,P))),S.once("data",()=>{}),S.once("error",p=>(O(S),p.code!=="ECONNREFUSED"?l(D+w,I-1,w,P):P(D))),S.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(D,I,w,P="127.0.0.1"){let S=!1,p,d=1;const m=L.createServer({pauseOnConnect:!0});function C(c,u){S||(S=!0,m.removeAllListeners(),m.close(),p&&clearTimeout(p),u(c))}return new Promise(c=>{p=setTimeout(()=>{C(0,c)},w),m.on("listening",()=>{C(D,c)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<I?(D++,d++,m.listen(D,P)):C(0,c)}),m.on("close",()=>{C(0,c)}),m.listen(D,P)})}e.findFreePortFaster=A;function O(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(I){console.error(I)}}}),define(re[87],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(U){return!!U.parentPort}e.isUtilityProcess=L}),define(re[137],oe([8,7]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[64],oe([0,1,137]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,l=U*60,A=l*24,O=A*7,D=A*30,I=A*365;function w(S,p,d,m){typeof S!="number"&&(S=S.getTime());const C=Math.round((new Date().getTime()-S)/1e3);if(C<-30)return(0,L.localize)(0,null,w(new Date().getTime()+C*1e3,!1));if(!m&&C<30)return(0,L.localize)(1,null);let c;return C<U?(c=C,p?c===1?d?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):d?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?d?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):d?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):C<l?(c=Math.floor(C/U),p?c===1?d?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):d?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?d?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):d?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):C<A?(c=Math.floor(C/l),p?c===1?d?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):d?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?d?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):d?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):C<O?(c=Math.floor(C/A),p?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):C<D?(c=Math.floor(C/O),p?c===1?d?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):d?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?d?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):d?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):C<I?(c=Math.floor(C/D),p?c===1?d?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):d?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?d?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):d?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(C/I),p?c===1?d?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):d?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?d?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):d?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=w;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(re[138],oe([8,7]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,21,12,138]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(S,p){return p&&(S.stack||S.stacktrace)?l.localize(0,null,D(S),O(S.stack)||O(S.stacktrace)):D(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function D(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?l.localize(1,null,S.message):S.message||l.localize(2,null)}function I(S=null,p=!1){if(!S)return l.localize(3,null);if(Array.isArray(S)){const d=L.coalesce(S),m=I(d[0],p);return d.length>1?l.localize(4,null,m,d.length):m}if(U.isString(S))return S;if(S.detail){const d=S.detail;if(d.error)return A(d.error,p);if(d.exception)return A(d.exception,p)}return S.stack?A(S,p):S.message?S.message:l.localize(5,null)}e.toErrorMessage=I;function w(S){const p=S;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=w;function P(S,p){let d;return typeof S=="string"?d=new Error(S):d=S,d.actions=p,d}e.createErrorWithActions=P}),define(re[139],oe([8,7]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[140],oe([0,1,139]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(l){switch(l){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(re[141],oe([8,7]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,141]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,l=!1,A=!1,O=!1,D=!1,I=!1,w=!1,P=!1,S=!1,p=!1,d,m=e.LANGUAGE_DEFAULT,C,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const f=typeof u?.versions?.electron=="string",g=f&&u?.type==="renderer";if(typeof navigator=="object"&&!g)c=navigator.userAgent,U=c.indexOf("Windows")>=0,l=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,I=!0,d=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,m=d;else if(typeof u=="object"){U=u.platform==="win32",l=u.platform==="darwin",A=u.platform==="linux",O=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=f,S=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),b=h.availableLanguages["*"];d=h.locale,m=b||e.LANGUAGE_DEFAULT,C=h._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var v;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function R(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let n=0;l?n=1:U?n=3:A&&(n=2),e.isWindows=U,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=O,e.isNative=D,e.isElectron=w,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=p,e.isCI=S,e.platform=n,e.userAgent=c,e.language=m;var r;(function(o){function h(){return e.language}o.value=h;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=b;function y(){return e.language==="en"}o.isDefault=y})(r=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let y=0,k=o.length;y<k;y++){const T=o[y];if(T.id===b.data.vscodeScheduleAsyncWork){o.splice(y,1),T.callback();return}}});let h=0;return b=>{const y=++h;o.push({id:y,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||P?2:U?1:3;let i=!0,s=!1;function a(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,i=new Uint16Array(o.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const l=L.globals.vscode.process;U={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(re[13],oe([0,1,36]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,l=97,A=90,O=122,D=46,I=47,w=92,P=58,S=63;class p extends Error{constructor(r,t,i){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const a=r.indexOf(".")!==-1?"property":"argument";let o=`The "${r}" ${a} ${s} of type ${t}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,r){if(n===null||typeof n!="object")throw new p(r,"Object",n)}function m(n,r){if(typeof n!="string")throw new p(r,"string",n)}const C=L.platform==="win32";function c(n){return n===I||n===w}function u(n){return n===I}function f(n){return n>=U&&n<=A||n>=l&&n<=O}function g(n,r,t,i){let s="",a=0,o=-1,h=0,b=0;for(let y=0;y<=n.length;++y){if(y<n.length)b=n.charCodeAt(y);else{if(i(b))break;b=I}if(i(b)){if(!(o===y-1||h===1))if(h===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==D||s.charCodeAt(s.length-2)!==D){if(s.length>2){const k=s.lastIndexOf(t);k===-1?(s="",a=0):(s=s.slice(0,k),a=s.length-1-s.lastIndexOf(t)),o=y,h=0;continue}else if(s.length!==0){s="",a=0,o=y,h=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",a=2)}else s.length>0?s+=`${t}${n.slice(o+1,y)}`:s=n.slice(o+1,y),a=y-o-1;o=y,h=0}else b===D&&h!==-1?++h:h=-1}return s}function v(n,r){d(r,"pathObject");const t=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let r="",t="",i=!1;for(let s=n.length-1;s>=-1;s--){let a;if(s>=0){if(a=n[s],m(a,"path"),a.length===0)continue}else r.length===0?a=L.cwd():(a=L.env[`=${r}`]||L.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${r}\\`));const o=a.length;let h=0,b="",y=!1;const k=a.charCodeAt(0);if(o===1)c(k)&&(h=1,y=!0);else if(c(k))if(y=!0,c(a.charCodeAt(1))){let T=2,F=T;for(;T<o&&!c(a.charCodeAt(T));)T++;if(T<o&&T!==F){const j=a.slice(F,T);for(F=T;T<o&&c(a.charCodeAt(T));)T++;if(T<o&&T!==F){for(F=T;T<o&&!c(a.charCodeAt(T));)T++;(T===o||T!==F)&&(b=`\\\\${j}\\${a.slice(F,T)}`,h=T)}}}else h=1;else f(k)&&a.charCodeAt(1)===P&&(b=a.slice(0,2),h=2,o>2&&c(a.charCodeAt(2))&&(y=!0,h=3));if(b.length>0)if(r.length>0){if(b.toLowerCase()!==r.toLowerCase())continue}else r=b;if(i){if(r.length>0)break}else if(t=`${a.slice(h)}\\${t}`,i=y,y&&r.length>0)break}return t=g(t,!i,"\\",c),i?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){m(n,"path");const r=n.length;if(r===0)return".";let t=0,i,s=!1;const a=n.charCodeAt(0);if(r===1)return u(a)?"\\":n;if(c(a))if(s=!0,c(n.charCodeAt(1))){let h=2,b=h;for(;h<r&&!c(n.charCodeAt(h));)h++;if(h<r&&h!==b){const y=n.slice(b,h);for(b=h;h<r&&c(n.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&!c(n.charCodeAt(h));)h++;if(h===r)return`\\\\${y}\\${n.slice(b)}\\`;h!==b&&(i=`\\\\${y}\\${n.slice(b,h)}`,t=h)}}}else t=1;else f(a)&&n.charCodeAt(1)===P&&(i=n.slice(0,2),t=2,r>2&&c(n.charCodeAt(2))&&(s=!0,t=3));let o=t<r?g(n.slice(t),!s,"\\",c):"";return o.length===0&&!s&&(o="."),o.length>0&&c(n.charCodeAt(r-1))&&(o+="\\"),i===void 0?s?`\\${o}`:o:s?`${i}\\${o}`:`${i}${o}`},isAbsolute(n){m(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return c(t)||r>2&&f(t)&&n.charCodeAt(1)===P&&c(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let a=0;a<n.length;++a){const o=n[a];m(o,"path"),o.length>0&&(r===void 0?r=t=o:r+=`\\${o}`)}if(r===void 0)return".";let i=!0,s=0;if(typeof t=="string"&&c(t.charCodeAt(0))){++s;const a=t.length;a>1&&c(t.charCodeAt(1))&&(++s,a>2&&(c(t.charCodeAt(2))?++s:i=!1))}if(i){for(;s<r.length&&c(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r)return"";const t=e.win32.resolve(n),i=e.win32.resolve(r);if(t===i||(n=t.toLowerCase(),r=i.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===w;)s++;let a=n.length;for(;a-1>s&&n.charCodeAt(a-1)===w;)a--;const o=a-s;let h=0;for(;h<r.length&&r.charCodeAt(h)===w;)h++;let b=r.length;for(;b-1>h&&r.charCodeAt(b-1)===w;)b--;const y=b-h,k=o<y?o:y;let T=-1,F=0;for(;F<k;F++){const B=n.charCodeAt(s+F);if(B!==r.charCodeAt(h+F))break;B===w&&(T=F)}if(F!==k){if(T===-1)return i}else{if(y>k){if(r.charCodeAt(h+F)===w)return i.slice(h+F+1);if(F===2)return i.slice(h+F)}o>k&&(n.charCodeAt(s+F)===w?T=F:F===2&&(T=3)),T===-1&&(T=0)}let j="";for(F=s+T+1;F<=a;++F)(F===a||n.charCodeAt(F)===w)&&(j+=j.length===0?"..":"\\..");return h+=T,j.length>0?`${j}${i.slice(h,b)}`:(i.charCodeAt(h)===w&&++h,i.slice(h,b))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===w){if(r.charCodeAt(1)===w){const t=r.charCodeAt(2);if(t!==S&&t!==D)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(f(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===w)return`\\\\?\\${r}`;return n},dirname(n){m(n,"path");const r=n.length;if(r===0)return".";let t=-1,i=0;const s=n.charCodeAt(0);if(r===1)return c(s)?n:".";if(c(s)){if(t=i=1,c(n.charCodeAt(1))){let h=2,b=h;for(;h<r&&!c(n.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&c(n.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&!c(n.charCodeAt(h));)h++;if(h===r)return n;h!==b&&(t=i=h+1)}}}}else f(s)&&n.charCodeAt(1)===P&&(t=r>2&&c(n.charCodeAt(2))?3:2,i=t);let a=-1,o=!0;for(let h=r-1;h>=i;--h)if(c(n.charCodeAt(h))){if(!o){a=h;break}}else o=!1;if(a===-1){if(t===-1)return".";a=t}return n.slice(0,a)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let t=0,i=-1,s=!0,a;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let o=r.length-1,h=-1;for(a=n.length-1;a>=t;--a){const b=n.charCodeAt(a);if(c(b)){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),o>=0&&(b===r.charCodeAt(o)?--o===-1&&(i=a):(o=-1,i=h))}return t===i?i=h:i===-1&&(i=n.length),n.slice(t,i)}for(a=n.length-1;a>=t;--a)if(c(n.charCodeAt(a))){if(!s){t=a+1;break}}else i===-1&&(s=!1,i=a+1);return i===-1?"":n.slice(t,i)},extname(n){m(n,"path");let r=0,t=-1,i=0,s=-1,a=!0,o=0;n.length>=2&&n.charCodeAt(1)===P&&f(n.charCodeAt(0))&&(r=i=2);for(let h=n.length-1;h>=r;--h){const b=n.charCodeAt(h);if(c(b)){if(!a){i=h+1;break}continue}s===-1&&(a=!1,s=h+1),b===D?t===-1?t=h:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||s===-1||o===0||o===1&&t===s-1&&t===i+1?"":n.slice(t,s)},format:v.bind(null,"\\"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let i=0,s=n.charCodeAt(0);if(t===1)return c(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(c(s)){if(i=1,c(n.charCodeAt(1))){let T=2,F=T;for(;T<t&&!c(n.charCodeAt(T));)T++;if(T<t&&T!==F){for(F=T;T<t&&c(n.charCodeAt(T));)T++;if(T<t&&T!==F){for(F=T;T<t&&!c(n.charCodeAt(T));)T++;T===t?i=T:T!==F&&(i=T+1)}}}}else if(f(s)&&n.charCodeAt(1)===P){if(t<=2)return r.root=r.dir=n,r;if(i=2,c(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;i=3}}i>0&&(r.root=n.slice(0,i));let a=-1,o=i,h=-1,b=!0,y=n.length-1,k=0;for(;y>=i;--y){if(s=n.charCodeAt(y),c(s)){if(!b){o=y+1;break}continue}h===-1&&(b=!1,h=y+1),s===D?a===-1?a=y:k!==1&&(k=1):a!==-1&&(k=-1)}return h!==-1&&(a===-1||k===0||k===1&&a===h-1&&a===o+1?r.base=r.name=n.slice(o,h):(r.name=n.slice(o,a),r.base=n.slice(o,h),r.ext=n.slice(a,h))),o>0&&o!==i?r.dir=n.slice(0,o-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(C){const n=/\\/g;return()=>{const r=L.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const s=i>=0?n[i]:R();m(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===I)}return r=g(r,!t,"/",u),t?`/${r}`:r.length>0?r:"."},normalize(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I,t=n.charCodeAt(n.length-1)===I;return n=g(n,!r,"/",u),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return m(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const i=n[t];m(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,i=n.length,s=i-t,a=1,o=r.length-a,h=s<o?s:o;let b=-1,y=0;for(;y<h;y++){const T=n.charCodeAt(t+y);if(T!==r.charCodeAt(a+y))break;T===I&&(b=y)}if(y===h)if(o>h){if(r.charCodeAt(a+y)===I)return r.slice(a+y+1);if(y===0)return r.slice(a+y)}else s>h&&(n.charCodeAt(t+y)===I?b=y:y===0&&(b=0));let k="";for(y=t+b+1;y<=i;++y)(y===i||n.charCodeAt(y)===I)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(a+b)}`},toNamespacedPath(n){return n},dirname(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I;let t=-1,i=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!i){t=s;break}}else i=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let t=0,i=-1,s=!0,a;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let o=r.length-1,h=-1;for(a=n.length-1;a>=0;--a){const b=n.charCodeAt(a);if(b===I){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),o>=0&&(b===r.charCodeAt(o)?--o===-1&&(i=a):(o=-1,i=h))}return t===i?i=h:i===-1&&(i=n.length),n.slice(t,i)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===I){if(!s){t=a+1;break}}else i===-1&&(s=!1,i=a+1);return i===-1?"":n.slice(t,i)},extname(n){m(n,"path");let r=-1,t=0,i=-1,s=!0,a=0;for(let o=n.length-1;o>=0;--o){const h=n.charCodeAt(o);if(h===I){if(!s){t=o+1;break}continue}i===-1&&(s=!1,i=o+1),h===D?r===-1?r=o:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||i===-1||a===0||a===1&&r===i-1&&r===t+1?"":n.slice(r,i)},format:v.bind(null,"/"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===I;let i;t?(r.root="/",i=1):i=0;let s=-1,a=0,o=-1,h=!0,b=n.length-1,y=0;for(;b>=i;--b){const k=n.charCodeAt(b);if(k===I){if(!h){a=b+1;break}continue}o===-1&&(h=!1,o=b+1),k===D?s===-1?s=b:y!==1&&(y=1):s!==-1&&(y=-1)}if(o!==-1){const k=a===0&&t?1:a;s===-1||y===0||y===1&&s===o-1&&s===a+1?r.base=r.name=n.slice(k,o):(r.name=n.slice(k,s),r.base=n.slice(k,o),r.ext=n.slice(s,o))}return a>0?r.dir=n.slice(0,a-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=C?e.win32.normalize:e.posix.normalize,e.isAbsolute=C?e.win32.isAbsolute:e.posix.isAbsolute,e.join=C?e.win32.join:e.posix.join,e.resolve=C?e.win32.resolve:e.posix.resolve,e.relative=C?e.win32.relative:e.posix.relative,e.dirname=C?e.win32.dirname:e.posix.dirname,e.basename=C?e.win32.basename:e.posix.basename,e.extname=C?e.win32.extname:e.posix.extname,e.format=C?e.win32.format:e.posix.format,e.parse=C?e.win32.parse:e.posix.parse,e.toNamespacedPath=C?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=C?e.win32.sep:e.posix.sep,e.delimiter=C?e.win32.delimiter:e.posix.delimiter}),define(re[142],oe([0,1,13]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const S=(0,L.extname)(P),p=U[S.toLowerCase()];return p!==void 0?p:O(P)}e.getMediaOrTextMime=A;function O(P){const S=(0,L.extname)(P);return l[S.toLowerCase()]}e.getMediaMime=O;function D(P){for(const S in l)if(l[S]===P)return S}e.getExtensionForMimeType=D;const I=/^(.+)\/(.+?)(;.+)?$/;function w(P,S){const p=I.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:S?void 0:P}e.normalizeMimeType=w}),define(re[88],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(U=e.Source||(e.Source={}));var l;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(D,...I){const w=I.reduce((p,d)=>(p[d]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(p=>!w[p]).forEach(p=>{for(let d=0;d<P.length;d++)if(p.search(P[d])!==-1){delete D[p];break}})}e.sanitizeProcessEnvironment=A;function O(D){!D||(delete D.DEBUG,L.isMacintosh&&delete D.DYLD_LIBRARY_PATH,L.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(re[89],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const U=L.globals.performance&&typeof L.globals.performance.now=="function";class l{static create(O=!0){return new l(O)}constructor(O){this.a=U&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=l}),define(re[3],oe([0,1,10,82,2,84,89]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,I=!1;var w;(function(a){a.None=()=>l.Disposable.None;function o(N){if(I){const{onDidAddListener:z}=N,G=m.create();let q=0;N.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),z?.()}}}function h(N,z){return W(N,()=>{},0,void 0,!0,void 0,z)}a.defer=h;function b(N){return(z,G=null,q)=>{let J=!1,ee;return ee=N(ce=>{if(!J)return ee?ee.dispose():J=!0,z.call(G,ce)},null,q),J&&ee.dispose(),ee}}a.once=b;function y(N,z,G){return V((q,J=null,ee)=>N(ce=>q.call(J,z(ce)),null,ee),G)}a.map=y;function k(N,z,G){return V((q,J=null,ee)=>N(ce=>{z(ce),q.call(J,ce)},null,ee),G)}a.forEach=k;function T(N,z,G){return V((q,J=null,ee)=>N(ce=>z(ce)&&q.call(J,ce),null,ee),G)}a.filter=T;function F(N){return N}a.signal=F;function j(...N){return(z,G=null,q)=>(0,l.combinedDisposable)(...N.map(J=>J(ee=>z.call(G,ee),null,q)))}a.any=j;function B(N,z,G,q){let J=G;return y(N,ee=>(J=z(J,ee),J),q)}a.reduce=B;function V(N,z){let G;const q={onWillAddFirstListener(){G=N(J.fire,J)},onDidRemoveLastListener(){G?.dispose()}};z||o(q);const J=new c(q);return z?.add(J),J.event}function W(N,z,G=100,q=!1,J=!1,ee,ce){let he,me,de,we=0,Ce;const Re={leakWarningThreshold:ee,onWillAddFirstListener(){he=N(We=>{we++,me=z(me,We),q&&!de&&(ke.fire(me),me=void 0),Ce=()=>{const Ye=me;me=void 0,de=void 0,(!q||we>1)&&ke.fire(Ye),we=0},typeof G=="number"?(clearTimeout(de),de=setTimeout(Ce,G)):de===void 0&&(de=0,queueMicrotask(Ce))})},onWillRemoveListener(){J&&we>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};ce||o(Re);const ke=new c(Re);return ce?.add(ke),ke.event}a.debounce=W;function Q(N,z=0,G){return a.debounce(N,(q,J)=>q?(q.push(J),q):[J],z,void 0,!0,void 0,G)}a.accumulate=Q;function X(N,z=(q,J)=>q===J,G){let q=!0,J;return T(N,ee=>{const ce=q||!z(ee,J);return q=!1,J=ee,ce},G)}a.latch=X;function Y(N,z,G){return[a.filter(N,z,G),a.filter(N,q=>!z(q),G)]}a.split=Y;function Z(N,z=!1,G=[]){let q=G.slice(),J=N(he=>{q?q.push(he):ce.fire(he)});const ee=()=>{q?.forEach(he=>ce.fire(he)),q=null},ce=new c({onWillAddFirstListener(){J||(J=N(he=>ce.fire(he)))},onDidAddFirstListener(){q&&(z?setTimeout(ee):ee())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return ce.event}a.buffer=Z;class H{constructor(z){this.event=z,this.c=new l.DisposableStore}map(z){return new H(y(this.event,z,this.c))}forEach(z){return new H(k(this.event,z,this.c))}filter(z){return new H(T(this.event,z,this.c))}reduce(z,G){return new H(B(this.event,z,G,this.c))}latch(){return new H(X(this.event,void 0,this.c))}debounce(z,G=100,q=!1,J=!1,ee){return new H(W(this.event,z,G,q,J,ee,this.c))}on(z,G,q){return this.event(z,G,q)}once(z,G,q){return b(this.event)(z,G,q)}dispose(){this.c.dispose()}}function $(N){return new H(N)}a.chain=$;function _(N,z,G=q=>q){const q=(...he)=>ce.fire(G(...he)),J=()=>N.on(z,q),ee=()=>N.removeListener(z,q),ce=new c({onWillAddFirstListener:J,onDidRemoveLastListener:ee});return ce.event}a.fromNodeEventEmitter=_;function ie(N,z,G=q=>q){const q=(...he)=>ce.fire(G(...he)),J=()=>N.addEventListener(z,q),ee=()=>N.removeEventListener(z,q),ce=new c({onWillAddFirstListener:J,onDidRemoveLastListener:ee});return ce.event}a.fromDOMEventEmitter=ie;function se(N){return new Promise(z=>b(N)(z))}a.toPromise=se;function ae(N,z){return z(void 0),N(G=>z(G))}a.runAndSubscribe=ae;function x(N,z){let G=null;function q(ee){G?.dispose(),G=new l.DisposableStore,z(ee,G)}q(void 0);const J=N(ee=>q(ee));return(0,l.toDisposable)(()=>{J.dispose(),G?.dispose()})}a.runAndSubscribeWithStore=x;class M{constructor(z,G){this.obs=z,this.c=0,this.d=!1;const q={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};G||o(q),this.emitter=new c(q),G&&G.add(this.emitter)}beginUpdate(z){this.c++}handleChange(z,G){this.d=!0}endUpdate(z){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function E(N,z){return new M(N,z).emitter.event}a.fromObservable=E})(w=e.Event||(e.Event={}));class P{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${P.c++}`,P.all.add(this)}start(o){this.d=new O.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let S=-1;function p(a){const o=S;return S=a,{dispose(){S=o}}}e.setGlobalLeakWarningThreshold=p;class d{constructor(o,h=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=h,this.d=0}dispose(){this.c?.clear()}check(o,h){const b=this.threshold;if(b<=0||h<b)return;this.c||(this.c=new Map);const y=this.c.get(o.value)||0;if(this.c.set(o.value,y+1),this.d-=1,this.d<=0){this.d=b*.5;let k,T=0;for(const[F,j]of this.c)(!k||T<j)&&(k=F,T=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${T}):`),console.warn(k)}return()=>{const k=this.c.get(o.value)||0;this.c.set(o.value,k-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(o,h,b){this.callback=o,this.callbackThis=h,this.stack=b,this.subscription=new l.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class c{constructor(o){this.j=!1,this.d=o,this.f=S>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(D){const o=Array.from(this.q);queueMicrotask(()=>{for(const h of o)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,h,b)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const y=this.q.isEmpty();y&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let k,T;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(T=m.create(),k=this.f.check(T,this.q.size+1)),D&&(T=T??m.create());const F=new C(o,h,T),j=this.q.push(F);y&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,h);const B=F.subscription.set(()=>{k?.(),this.j||(this.d?.onWillRemoveListener?.(this),j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof l.DisposableStore?b.add(B):Array.isArray(b)&&b.push(B),B}),this.l}fire(o){if(this.q){this.m||(this.m=new f);for(const h of this.q)this.m.push(this,h,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class u{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(o,h,b){this.c.push(new g(o,h,b))}clear(o){const h=new A.LinkedList;for(const b of this.c)b.emitter!==o&&h.push(b);this.c=h}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(h){(0,L.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=u;class f extends u{clear(o){this.c.clear()}}class g{constructor(o,h,b){this.emitter=o,this.listener=h,this.event=b}}class v extends c{async fireAsync(o,h,b){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const y of this.q)this.c.push([y,o]);for(;this.c.size>0&&!h.isCancellationRequested;){const[y,k]=this.c.shift(),T=[],F={...k,token:h,waitUntil:j=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");b&&(j=b(j,y.callback)),T.push(j)}};try{y.invoke(F)}catch(j){(0,L.onUnexpectedError)(j);continue}Object.freeze(T),await Promise.allSettled(T).then(j=>{for(const B of j)B.status==="rejected"&&(0,L.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=v;class R extends c{constructor(o){super(o),this.h=0,this.s=new A.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=R;class n extends R{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends c{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const h={event:o,listener:null};this.f.push(h),this.d&&this.j(h);const b=()=>{this.d&&this.k(h);const y=this.f.indexOf(h);this.f.splice(y,1)};return(0,l.toDisposable)((0,U.once)(b))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(h=>this.c.fire(h))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.c=[]}wrapEvent(o){return(h,b,y)=>o(k=>{const T=this.c[this.c.length-1];T?T.push(()=>h.call(b,k)):h.call(b,k)},void 0,y)}bufferEvents(o){const h=[];this.c.push(h);const b=o();return this.c.pop(),h.forEach(y=>y()),b}}e.EventBufferer=i;class s{constructor(){this.c=!1,this.d=w.None,this.f=l.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[25],oe([0,1,3]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(D,I){const w=setTimeout(D.bind(I),0);return{dispose(){clearTimeout(w)}}});var l;(function(D){function I(w){return w===D.None||w===D.Cancelled||w instanceof A?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}D.isCancellationToken=I,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(l=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?U:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=O}),define(re[143],oe([0,1,25]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new L.CancellationTokenSource,I=this.b(D.token);return this.a={promise:I,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}e.Cache=U;class l{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const I=JSON.stringify(D);return this.b!==I&&(this.b=I,this.a=this.c(D)),this.a}}e.LRUCachedFunction=l;class A{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const I=this.b(D);return this.a.set(D,I),I}}e.CachedFunction=A}),define(re[27],oe([0,1,143,130]),function(te,e,L,U){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=A;const O=/{(\d+)}/g;function D(ne,...ue){return ue.length===0?ne:ne.replace(O,function(pe,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=ue.length?pe:ue[ve]})}e.format=D;const I=/{([^}]+)}/g;function w(ne,ue){return ne.replace(I,(pe,Se)=>ue[Se]??pe)}e.format2=w;function P(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function S(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function p(ne,ue){let pe=0;const Se=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===Se&&pe++;return pe}e.count=p;function d(ne,ue,pe="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${pe}`}e.truncate=d;function m(ne,ue=" "){const pe=C(ne,ue);return c(pe,ue)}e.trim=m;function C(ne,ue){if(!ne||!ue)return ne;const pe=ue.length;if(pe===0||ne.length===0)return ne;let Se=0;for(;ne.indexOf(ue,Se)===Se;)Se=Se+pe;return ne.substring(Se)}e.ltrim=C;function c(ne,ue){if(!ne||!ue)return ne;const pe=ue.length,Se=ne.length;if(pe===0||Se===0)return ne;let ve=Se,Ee=-1;for(;Ee=ne.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+pe!==ve);){if(Ee===0)return"";ve=Ee}return ne.substring(0,ve)}e.rtrim=c;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function f(ne){return ne.replace(/\*/g,"")}e.stripWildcards=f;function g(ne,ue,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=S(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Se="";return pe.global&&(Se+="g"),pe.matchCase||(Se+="i"),pe.multiline&&(Se+="m"),pe.unicode&&(Se+="u"),new RegExp(ne,Se)}e.createRegExp=g;function v(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function R(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function n(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=n;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let ue=0,pe=ne.length;ue<pe;ue++){const Se=ne.charCodeAt(ue);if(Se!==32&&Se!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function i(ne,ue=0,pe=ne.length){for(let Se=ue;Se<pe;Se++){const ve=ne.charCodeAt(Se);if(ve!==32&&ve!==9)return ne.substring(ue,Se)}return ne.substring(ue,pe)}e.getLeadingWhitespace=i;function s(ne,ue=ne.length-1){for(let pe=ue;pe>=0;pe--){const Se=ne.charCodeAt(pe);if(Se!==32&&Se!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function a(ne,ue,pe){const Se=[];let ve=0;for(const Ee of ne.matchAll(ue)){if(Se.push(ne.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,Se.push(pe(Ee[0],...Ee.slice(1),Ee.index,ne,Ee.groups))}return Se.push(ne.slice(ve)),Promise.all(Se).then(Ee=>Ee.join(""))}e.replaceAsync=a;function o(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=o;function h(ne,ue,pe=0,Se=ne.length,ve=0,Ee=ue.length){for(;pe<Se&&ve<Ee;pe++,ve++){const Te=ne.charCodeAt(pe),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const De=Se-pe,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstring=h;function b(ne,ue){return y(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=b;function y(ne,ue,pe=0,Se=ne.length,ve=0,Ee=ue.length){for(;pe<Se&&ve<Ee;pe++,ve++){let Te=ne.charCodeAt(pe),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return h(ne.toLowerCase(),ue.toLowerCase(),pe,Se,ve,Ee);T(Te)&&(Te-=32),T(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const De=Se-pe,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstringIgnoreCase=y;function k(ne){return ne>=48&&ne<=57}e.isAsciiDigit=k;function T(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=T;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function j(ne,ue){return ne.length===ue.length&&y(ne,ue)===0}e.equalsIgnoreCase=j;function B(ne,ue){const pe=ue.length;return ue.length>ne.length?!1:y(ne,ue,0,pe)===0}e.startsWithIgnoreCase=B;function V(ne,ue){const pe=Math.min(ne.length,ue.length);let Se;for(Se=0;Se<pe;Se++)if(ne.charCodeAt(Se)!==ue.charCodeAt(Se))return Se;return pe}e.commonPrefixLength=V;function W(ne,ue){const pe=Math.min(ne.length,ue.length);let Se;const ve=ne.length-1,Ee=ue.length-1;for(Se=0;Se<pe;Se++)if(ne.charCodeAt(ve-Se)!==ue.charCodeAt(Ee-Se))return Se;return pe}e.commonSuffixLength=W;function Q(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=Q;function X(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=X;function Y(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=Y;function Z(ne,ue,pe){const Se=ne.charCodeAt(pe);if(Q(Se)&&pe+1<ue){const ve=ne.charCodeAt(pe+1);if(X(ve))return Y(Se,ve)}return Se}e.getNextCodePoint=Z;function H(ne,ue){const pe=ne.charCodeAt(ue-1);if(X(pe)&&ue>1){const Se=ne.charCodeAt(ue-2);if(Q(Se))return Y(Se,pe)}return pe}class ${get offset(){return this.e}constructor(ue,pe=0){this.c=ue,this.d=ue.length,this.e=pe}setOffset(ue){this.e=ue}prevCodePoint(){const ue=H(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Z(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=$;class _{get offset(){return this.c.offset}constructor(ue,pe=0){this.c=new $(ue,pe)}nextGraphemeLength(){const ue=Ie.getInstance(),pe=this.c,Se=pe.offset;let ve=ue.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ee=pe.offset,De=ue.getGraphemeBreakType(pe.nextCodePoint());if(fe(ve,De)){pe.setOffset(Ee);break}ve=De}return pe.offset-Se}prevGraphemeLength(){const ue=Ie.getInstance(),pe=this.c,Se=pe.offset;let ve=ue.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ee=pe.offset,De=ue.getGraphemeBreakType(pe.prevCodePoint());if(fe(De,ve)){pe.setOffset(Ee);break}ve=De}return Se-pe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=_;function ie(ne,ue){return new _(ne,ue).nextGraphemeLength()}e.nextCharLength=ie;function se(ne,ue){return new _(ne,ue).prevGraphemeLength()}e.prevCharLength=se;function ae(ne,ue){ue>0&&X(ne.charCodeAt(ue))&&ue--;const pe=ue+ie(ne,ue);return[pe-se(ne,pe),pe]}e.getCharContainingOffset=ae;function x(ne){const ue=new _(ne);let pe=0;for(;!ue.eol();)pe++,ue.nextGraphemeLength();return pe}e.charCount=x;let M;function E(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ne){return M||(M=E()),M.test(ne)}e.containsRTL=N;const z=/^[\t\n\r\x20-\x7E]*$/;function G(ne){return z.test(ne)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=q;function J(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=J;function ee(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ee;function ce(ne,ue){if(ne.length<ue)return ne;const pe=/\b/g;let Se=0;for(;pe.test(ne)&&!(ne.length-pe.lastIndex<ue);)Se=pe.lastIndex,pe.lastIndex+=1;return ne.substring(Se).replace(/^\s/,"")}e.lcut=ce;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function we(ne){return de(ne)?ne.substr(1):ne}e.stripUTF8BOM=we;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const pe=ue.length,Se=ne.toLowerCase();let ve=0,Ee=-1;for(;ve<pe;){const De=Se.indexOf(ue[ve],Ee+1);if(De<0)return!1;Ee=De,ve++}return!0}e.fuzzyContains=Ce;function Re(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Re;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function We(ne,ue=1){if(ue===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ue--;while(ue>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}e.getNLines=We;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function le(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=le;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var ge;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const pe=this.d,Se=pe.length/3;let ve=1;for(;ve<=Se;)if(ue<pe[3*ve])ve=2*ve;else if(ue>pe[3*ve+1])ve=2*ve+1;else return pe[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const pe=Le(ne,ue);if(pe!==void 0)return pe;const Se=new $(ue,ne);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Fe;function Le(ne,ue){const pe=new $(ue,ne);let Se=pe.prevCodePoint();for(;qe(Se)||Se===65039||Se===8419;){if(pe.offset===0)return;Se=pe.prevCodePoint()}if(!ee(Se))return;let ve=pe.offset;return ve>0&&pe.prevCodePoint()===8205&&(ve=pe.offset),ve}function qe(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new L.LRUCachedFunction(ne=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function pe(Ue,$e){const ze=new Map(Ue);for(const[et,nt]of $e)ze.set(et,nt);return ze}function Se(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,nt]of Ue)$e.has(et)&&ze.set(et,nt);return ze}const ve=l.c.value;let Ee=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let De;for(const Ue of Ee){const $e=ue(ve[Ue]);De=Se(De,$e)}const Ae=ue(ve._common),Te=pe(Ae,De);return new Ne(Te)}),Ne.e=new U.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ue){return je.e().has(ue)}static get codePoints(){return je.e()}}je.d=void 0,e.InvisibleCharacters=je}),define(re[48],oe([0,1,13,4,27,12]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(s){return s===47||s===92}e.isPathSeparator=O;function D(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function I(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function w(s,a=L.posix.sep){if(!s)return"";const o=s.length,h=s.charCodeAt(0);if(O(h)){if(O(s.charCodeAt(1))&&!O(s.charCodeAt(2))){let y=3;const k=y;for(;y<o&&!O(s.charCodeAt(y));y++);if(k!==y&&!O(s.charCodeAt(y+1))){for(y+=1;y<o;y++)if(O(s.charCodeAt(y)))return s.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(u(h)&&s.charCodeAt(1)===58)return O(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<o;b++)if(O(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=w;function P(s){if(!U.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const h=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(h===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=P;const S=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(s,a=U.isWindows){const o=a?S:p;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&d.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=m;function C(s,a,o){const h=s===a;return!o||h?h:!s||!a?!1:(0,l.equalsIgnoreCase)(s,a)}e.isEqual=C;function c(s,a,o,h=L.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,l.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let y=a.length;return a.charAt(a.length-1)===h&&y--,s.charAt(y)===h}return a.charAt(a.length-1)!==h&&(a+=h),s.indexOf(a)===0}e.isEqualOrParent=c;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function f(s,a){return U.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(a,s)),s=(0,L.normalize)(s),U.isWindows?(s=(0,l.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,l.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=f;function g(s){const a=(0,L.normalize)(s);return U.isWindows?s.length>3?!1:v(a)&&(s.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function v(s,a=U.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function R(s){return v(s)?s[0]:void 0}e.getDriveLetter=R;function n(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=n;function r(s){const a=s.split(":");let o,h,b;for(const y of a){const k=Number(y);(0,A.isNumber)(k)?h===void 0?h=k:b===void 0&&(b=k):o=o?[o,y].join(":"):y}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:b!==void 0?b:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,o=8){let h="";for(let y=0;y<o;y++)h+=t.charAt(Math.floor(Math.random()*t.length));let b;return a?b=`${a}-${h}`:b=h,s?(0,L.join)(s,b):b}e.randomPath=i}),define(re[53],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(u){return l(u,0)}e.hash=U;function l(u,f){switch(typeof u){case"object":return u===null?A(349,f):Array.isArray(u)?I(u,f):w(u,f);case"string":return D(u,f);case"boolean":return O(u,f);case"number":return A(u,f);case"undefined":return A(937,f);default:return A(617,f)}}e.doHash=l;function A(u,f){return(f<<5)-f+u|0}e.numberHash=A;function O(u,f){return A(u?433:863,f)}function D(u,f){f=A(149417,f);for(let g=0,v=u.length;g<v;g++)f=A(u.charCodeAt(g),f);return f}e.stringHash=D;function I(u,f){return f=A(104579,f),u.reduce((g,v)=>l(v,g),f)}function w(u,f){return f=A(181387,f),Object.keys(u).sort().reduce((g,v)=>(g=D(v,g),l(u[v],g)),f)}class P{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=l(f,this.g),this.g}}e.Hasher=P;var S;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function p(u,f,g=32){const v=g-f,R=~((1<<v)-1);return(u<<f|(R&u)>>>v)>>>0}function d(u,f=0,g=u.byteLength,v=0){for(let R=0;R<g;R++)u[f+R]=v}function m(u,f,g="0"){for(;u.length<f;)u=g+u;return u}function C(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),f/4)}e.toHexString=C;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const g=f.length;if(g===0)return;const v=this.p;let R=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=f.charCodeAt(0),t=0);;){let i=r;if(L.isHighSurrogate(r))if(t+1<g){const s=f.charCodeAt(t+1);L.isLowSurrogate(s)?(t++,i=L.computeCodePoint(r,s)):i=65533}else{n=r;break}else L.isLowSurrogate(r)&&(i=65533);if(R=this.w(v,R,i),t++,t<g)r=f.charCodeAt(t);else break}this.r=R,this.u=n}w(f,g,v){return v<128?f[g++]=v:v<2048?(f[g++]=192|(v&1984)>>>6,f[g++]=128|(v&63)>>>0):v<65536?(f[g++]=224|(v&61440)>>>12,f[g++]=128|(v&4032)>>>6,f[g++]=128|(v&63)>>>0):(f[g++]=240|(v&1835008)>>>18,f[g++]=128|(v&258048)>>>12,f[g++]=128|(v&4032)>>>6,f[g++]=128|(v&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),C(this.h)+C(this.l)+C(this.m)+C(this.n)+C(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=c.g,g=this.q;for(let o=0;o<64;o+=4)f.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,p(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let v=this.h,R=this.l,n=this.m,r=this.n,t=this.o,i,s,a;for(let o=0;o<80;o++)o<20?(i=R&n|~R&r,s=1518500249):o<40?(i=R^n^r,s=1859775393):o<60?(i=R&n|R&r|n&r,s=2400959708):(i=R^n^r,s=3395469782),a=p(v,5)+i+t+s+f.getUint32(o*4,!1)&4294967295,t=r,r=n,n=p(R,30),R=v,v=a;this.h=this.h+v&4294967295,this.l=this.l+R&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}c.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(re[90],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(U||(U={})),function(l){const A="error",O="warning",D="warn",I="info",w="ignore";function P(p){return p?L.equalsIgnoreCase(A,p)?l.Error:L.equalsIgnoreCase(O,p)||L.equalsIgnoreCase(D,p)?l.Warning:L.equalsIgnoreCase(I,p)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function S(p){switch(p){case l.Error:return A;case l.Warning:return O;case l.Info:return I;default:return w}}l.toString=S}(U||(U={})),e.default=U}),define(re[49],oe([0,1,21,27]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const m=d.charCodeAt(0),C=this.b.charCodeAt(this.c);return m-C}value(){return this.b[this.c]}}e.StringIterator=l;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,U.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,U.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class O{constructor(d=!0,m=!0){this.f=d,this.g=m}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let m=d.length-1;m>=0;m--,this.c--){const C=this.b.charCodeAt(m);if(!(C===47||this.f&&C===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,U.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,U.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var D;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(D||(D={}));class I{constructor(d,m){this.f=d,this.g=m,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,U.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,U.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,U.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,U.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class S{static forUris(d=()=>!1,m=()=>!1){return new S(new I(d,m))}static forPaths(d=!1){return new S(new O(void 0,!d))}static forStrings(){return new S(new l)}static forConfigKeys(){return new S(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,m){if(m){const C=m.slice(0);(0,L.shuffle)(C);for(const c of C)this.set(c,d)}else{const C=d.slice(0);(0,L.shuffle)(C);for(const c of C)this.set(c[0],c[1])}}set(d,m){const C=this.b.reset(d);let c;this.c||(this.c=new w,this.c.segment=C.value());const u=[];for(c=this.c;;){const g=C.cmp(c.segment);if(g>0)c.left||(c.left=new w,c.left.segment=C.value()),u.push([-1,c]),c=c.left;else if(g<0)c.right||(c.right=new w,c.right.segment=C.value()),u.push([1,c]),c=c.right;else if(C.hasNext())C.next(),c.mid||(c.mid=new w,c.mid.segment=C.value()),u.push([0,c]),c=c.mid;else break}const f=c.value;c.value=m,c.key=d;for(let g=u.length-1;g>=0;g--){const v=u[g][1];v.updateHeight();const R=v.balanceFactor();if(R<-1||R>1){const n=u[g][0],r=u[g+1][0];if(n===1&&r===1)u[g][1]=v.rotateLeft();else if(n===-1&&r===-1)u[g][1]=v.rotateRight();else if(n===1&&r===-1)v.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=v.rotateLeft();else if(n===-1&&r===1)v.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=v.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return f}get(d){return this.d(d)?.value}d(d){const m=this.b.reset(d);let C=this.c;for(;C;){const c=m.cmp(C.segment);if(c>0)C=C.left;else if(c<0)C=C.right;else if(m.hasNext())m.next(),C=C.mid;else break}return C}has(d){const m=this.d(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,m){const C=this.b.reset(d),c=[];let u=this.c;for(;u;){const f=C.cmp(u.segment);if(f>0)c.push([-1,u]),u=u.left;else if(f<0)c.push([1,u]),u=u.right;else if(C.hasNext())C.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this.f(u.right);if(f.key){const{key:g,value:v,segment:R}=f;this.e(f.key,!1),u.key=g,u.value=v,u.segment=R}}else{const f=u.left??u.right;if(c.length>0){const[g,v]=c[c.length-1];switch(g){case-1:v.left=f;break;case 0:v.mid=f;break;case 1:v.right=f;break}}else this.c=f}for(let f=c.length-1;f>=0;f--){const g=c[f][1];g.updateHeight();const v=g.balanceFactor();if(v>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),c[f][1]=g.rotateLeft()):v<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),c[f][1]=g.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this.b.reset(d);let C=this.c,c;for(;C;){const u=m.cmp(C.segment);if(u>0)C=C.left;else if(u<0)C=C.right;else if(m.hasNext())m.next(),c=C.value||c,C=C.mid;else break}return C&&C.value||c}findSuperstr(d){return this.g(d,!1)}g(d,m){const C=this.b.reset(d);let c=this.c;for(;c;){const u=C.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(C.hasNext())C.next(),c=c.mid;else return c.mid?this.h(c.mid):m?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[m,C]of this)d(C,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const m=[];return this.j(d,m),m[Symbol.iterator]()}j(d,m){!d||(d.left&&this.j(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this.j(d.mid,m),d.right&&this.j(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const C=m.balanceFactor();return C<-1||C>1?!1:d(m.left)&&d(m.right)};return d(this.c)}}e.TernarySearchTree=S}),define(re[11],oe([0,1,13,4]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function D(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!l.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,i){return!t&&!i?"file":t}function w(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==S&&(i=S+i):i=S;break}return i}const P="",S="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,a,o,h,b=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=I(i,b),this.authority=s||P,this.path=w(this.scheme,a||P),this.query=o||P,this.fragment=h||P,D(this,b))}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:o,query:h,fragment:b}=i;return s===void 0?s=this.scheme:s===null&&(s=P),a===void 0?a=this.authority:a===null&&(a=P),o===void 0?o=this.path:o===null&&(o=P),h===void 0?h=this.query:h===null&&(h=P),b===void 0?b=this.fragment:b===null&&(b=P),s===this.scheme&&a===this.authority&&o===this.path&&h===this.query&&b===this.fragment?this:new C(s,a,o,h,b)}static parse(i,s=!1){const a=p.exec(i);return a?new C(a[2]||P,r(a[4]||P),r(a[5]||P),r(a[7]||P),r(a[9]||P),s):new C(P,P,P,P,P)}static file(i){let s=P;if(U.isWindows&&(i=i.replace(/\\/g,S)),i[0]===S&&i[1]===S){const a=i.indexOf(S,2);a===-1?(s=i.substring(2),i=S):(s=i.substring(2,a),i=i.substring(a)||S)}return new C("file",s,i,P,P)}static from(i){const s=new C(i.scheme,i.authority,i.path,i.query,i.fragment);return D(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&i.scheme==="file"?a=d.file(L.win32.join(g(i,!0),...s)).path:a=L.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return v(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const s=new C(i);return s._formatted=i.external,s._fsPath=i._sep===m?i.fsPath:null,s}}else return i}}e.URI=d;const m=U.isWindows?1:void 0;class C extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=m),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,i,s){let a,o=-1;for(let h=0;h<t.length;h++){const b=t.charCodeAt(h);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47||s&&b===91||s&&b===93||s&&b===58)o!==-1&&(a+=encodeURIComponent(t.substring(o,h)),o=-1),a!==void 0&&(a+=t.charAt(h));else{a===void 0&&(a=t.substr(0,h));const y=c[b];y!==void 0?(o!==-1&&(a+=encodeURIComponent(t.substring(o,h)),o=-1),a+=y):o===-1&&(o=h)}}return o!==-1&&(a+=encodeURIComponent(t.substring(o))),a!==void 0?a:t}function f(t){let i;for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);a===35||a===63?(i===void 0&&(i=t.substr(0,s)),i+=c[a]):i!==void 0&&(i+=t[s])}return i!==void 0?i:t}function g(t,i){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,U.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function v(t,i){const s=i?f:u;let a="",{scheme:o,authority:h,path:b,query:y,fragment:k}=t;if(o&&(a+=o,a+=":"),(h||o==="file")&&(a+=S,a+=S),h){let T=h.indexOf("@");if(T!==-1){const F=h.substr(0,T);h=h.substr(T+1),T=F.lastIndexOf(":"),T===-1?a+=s(F,!1,!1):(a+=s(F.substr(0,T),!1,!1),a+=":",a+=s(F.substr(T+1),!1,!0)),a+="@"}h=h.toLowerCase(),T=h.lastIndexOf(":"),T===-1?a+=s(h,!1,!0):(a+=s(h.substr(0,T),!1,!0),a+=h.substr(T))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const T=b.charCodeAt(1);T>=65&&T<=90&&(b=`/${String.fromCharCode(T+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const T=b.charCodeAt(0);T>=65&&T<=90&&(b=`${String.fromCharCode(T+32)}:${b.substr(2)}`)}a+=s(b,!0,!1)}return y&&(a+="?",a+=s(y,!1,!1)),k&&(a+="#",a+=i?k:u(k,!1,!1)),a}function R(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+R(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,i=>R(i)):t}}),define(re[144],oe([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(w){const P=w;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=U;function l(w){const P=[];let S;try{const p=JSON.parse(w.arguments),d=p[p.length-1];d&&d.__$stack&&(p.pop(),S=d.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",w.arguments)}return{args:P,stack:S}}e.parse=l;function A(w){if(typeof w!="string")return A(l(w).stack);const P=w;if(P){const S=O(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(p&&p.length===4)return{uri:L.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=A;function O(w){if(!w)return w;const P=w.indexOf(`
`);return P===-1?w:w.substring(0,P)}function D(w,P){const{args:S,stack:p}=l(w),d=typeof S[0]=="string"&&S.length===1;let m=O(p);m&&(m=`(${m.trim()})`);let C=[];if(typeof S[0]=="string"?m&&d?C=[`%c[${P}] %c${S[0]} %c${m}`,I("blue"),I(""),I("grey")]:C=[`%c[${P}] %c${S[0]}`,I("blue"),I(""),...S.slice(1)]:C=[`%c[${P}]%`,I("blue"),...S],m&&!d&&C.push(m),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=D;function I(w){return`color: ${w}`}}),define(re[91],oe([0,1,16,27,11]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(w){return JSON.stringify(w,D)}e.stringify=A;function O(w){let P=JSON.parse(w);return P=I(P),P}e.parse=O;function D(w,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,U.regExpFlags)(P)}:P}function I(w,P=0){if(!w||P>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return l.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof L.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let S=0;S<w.length;++S)w[S]=I(w[S],P+1);else for(const S in w)Object.hasOwnProperty.call(w,S)&&(w[S]=I(w[S],P+1))}return w}e.revive=I}),define(re[22],oe([0,1,10,4,11]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${A.vscodeRemoteResource}`}set(P,S,p){this.a[P]=S,this.b[P]=p}setConnectionToken(P,S){this.c[P]=S}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(c){return L.onUnexpectedError(c),P}const S=P.authority;let p=this.a[S];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this.b[S],m=this.c[S];let C=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),l.URI.from({scheme:U.isWeb?this.d:A.vscodeRemoteResource,authority:`${p}:${d}`,path:this.f,query:C})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(P){const S=this.b(P,te);return this.uriToBrowserUri(S)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===A.file&&(U.isNative||U.isWebWorker&&U.globals.origin===`${A.vscodeFileResource}://${D.a}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||D.a,query:null,fragment:null}):P}asFileUri(P){const S=this.b(P,te);return this.uriToFileUri(S)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==D.a?P.authority:null,query:null,fragment:null}):P}b(P,S){return l.URI.isUri(P)?P:l.URI.parse(S.toUrl(P))}}D.a="vscode-app",e.FileAccess=new D;var I;(function(w){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(P.get("3"));const S="vscode-coi";function p(m){let C;typeof m=="string"?C=new URL(m).searchParams:m instanceof URL?C=m.searchParams:l.URI.isUri(m)&&(C=new URL(m.toString(!0)).searchParams);const c=C?.get(S);if(!!c)return P.get(c)}w.getHeadersFromQuery=p;function d(m,C,c){if(!globalThis.crossOriginIsolated)return;const u=C&&c?"3":c?"2":"1";m instanceof URLSearchParams?m.set(S,u):m[S]=u}w.addSearchParam=d})(I=e.COI||(e.COI={}))}),define(re[23],oe([0,1,48,22,13,4,27,11]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(d){return(0,D.uriToFsPath)(d,!0)}e.originalFSPath=I;class w{constructor(m){this.a=m}compare(m,C,c=!1){return m===C?0:(0,O.compare)(this.getComparisonKey(m,c),this.getComparisonKey(C,c))}isEqual(m,C,c=!1){return m===C?!0:!m||!C?!1:this.getComparisonKey(m,c)===this.getComparisonKey(C,c)}getComparisonKey(m,C=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,C,c=!1){if(m.scheme===C.scheme){if(m.scheme===U.Schemas.file)return L.isEqualOrParent(I(m),I(C),this.a(m))&&m.query===C.query&&(c||m.fragment===C.fragment);if((0,e.isEqualAuthority)(m.authority,C.authority))return L.isEqualOrParent(m.path,C.path,this.a(m),"/")&&m.query===C.query&&(c||m.fragment===C.fragment)}return!1}joinPath(m,...C){return D.URI.joinPath(m,...C)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return l.posix.basename(m.path)}extname(m){return l.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let C;return m.scheme===U.Schemas.file?C=D.URI.file(l.dirname(I(m))).path:(C=l.posix.dirname(m.path),m.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),C="/")),m.with({path:C})}normalizePath(m){if(!m.path.length)return m;let C;return m.scheme===U.Schemas.file?C=D.URI.file(l.normalize(I(m))).path:C=l.posix.normalize(m.path),m.with({path:C})}relativePath(m,C){if(m.scheme!==C.scheme||!(0,e.isEqualAuthority)(m.authority,C.authority))return;if(m.scheme===U.Schemas.file){const f=l.relative(I(m),I(C));return A.isWindows?L.toSlashes(f):f}let c=m.path||"/";const u=C.path||"/";if(this.a(m)){let f=0;for(const g=Math.min(c.length,u.length);f<g&&!(c.charCodeAt(f)!==u.charCodeAt(f)&&c.charAt(f).toLowerCase()!==u.charAt(f).toLowerCase());f++);c=u.substr(0,f)+c.substr(f)}return l.posix.relative(c,u)}resolvePath(m,C){if(m.scheme===U.Schemas.file){const c=D.URI.file(l.resolve(I(m),C));return m.with({authority:c.authority,path:c.path})}return C=L.toPosixPath(C),m.with({path:l.posix.resolve(m.path,C)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,C){return m===C||m!==void 0&&C!==void 0&&(0,O.equalsIgnoreCase)(m,C)}hasTrailingPathSeparator(m,C=l.sep){if(m.scheme===U.Schemas.file){const c=I(m);return c.length>L.getRoot(c).length&&c[c.length-1]===C}else{const c=m.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,C=l.sep){return(0,e.hasTrailingPathSeparator)(m,C)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,C=l.sep){let c=!1;if(m.scheme===U.Schemas.file){const u=I(m);c=u!==void 0&&u.length===L.getRoot(u).length&&u[u.length-1]===C}else{C="/";const u=m.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(m,C)?m.with({path:m.path+"/"}):m}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(d=>d.scheme===U.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new w(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,m){const C=[];for(let c=0;c<d.length;c++){const u=m(d[c]);d.some((f,g)=>g===c?!1:(0,e.isEqualOrParent)(u,m(f)))||C.push(d[c])}return C}e.distinctParents=P;var S;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(C){const c=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,R]=g.split(":");v&&R&&c.set(v,R)});const f=C.path.substring(0,C.path.indexOf(";"));return f&&c.set(d.META_DATA_MIME,f),c}d.parseMetaData=m})(S=e.DataUri||(e.DataUri={}));function p(d,m,C){if(m){let c=d.path;return c&&c[0]!==l.posix.sep&&(c=l.posix.sep+c),d.with({scheme:C,authority:m,path:c})}return d.with({scheme:C})}e.toLocalResource=p}),define(re[6],oe([0,1,25,10,3,2,23,4,133]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(x){return!!x&&typeof x.then=="function"}e.isThenable=w;function P(x){const M=new L.CancellationTokenSource,E=x(M.token),N=new Promise((z,G)=>{const q=M.token.onCancellationRequested(()=>{q.dispose(),M.dispose(),G(new U.CancellationError)});Promise.resolve(E).then(J=>{q.dispose(),M.dispose(),z(J)},J=>{q.dispose(),M.dispose(),G(J)})});return new class{cancel(){M.cancel()}then(z,G){return N.then(z,G)}catch(z){return this.then(void 0,z)}finally(z){return N.finally(z)}}}e.createCancelablePromise=P;function S(x,M,E){return new Promise((N,z)=>{const G=M.onCancellationRequested(()=>{G.dispose(),N(E)});x.then(N,z).finally(()=>G.dispose())})}e.raceCancellation=S;function p(x,M){return new Promise((E,N)=>{const z=M.onCancellationRequested(()=>{z.dispose(),N(new U.CancellationError)});x.then(E,N).finally(()=>z.dispose())})}e.raceCancellationError=p;async function d(x){let M=-1;const E=x.map((z,G)=>z.then(q=>(M=G,q))),N=await Promise.race(E);return x.forEach((z,G)=>{G!==M&&z.cancel()}),N}e.raceCancellablePromises=d;function m(x,M,E){let N;const z=setTimeout(()=>{N?.(void 0),E?.()},M);return Promise.race([x.finally(()=>clearTimeout(z)),new Promise(G=>N=G)])}e.raceTimeout=m;function C(x){return new Promise((M,E)=>{const N=x();w(N)?N.then(M,E):M(N)})}e.asPromise=C;class c{constructor(){this.a=null,this.b=null,this.d=null}queue(M){if(this.a){if(this.d=M,!this.b){const E=()=>{this.b=null;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(E,E).then(N)})}return new Promise((E,N)=>{this.b.then(E,N)})}return this.a=M(),new Promise((E,N)=>{this.a.then(z=>{this.a=null,E(z)},z=>{this.a=null,N(z)})})}}e.Throttler=c;class u{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.Sequencer=u;class f{constructor(){this.a=new Map}queue(M,E){const z=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(M)===z&&this.a.delete(M)});return this.a.set(M,z),z}}e.SequencerByKey=f;const g=(x,M)=>{let E=!0;const N=setTimeout(()=>{E=!1,M()},x);return{isTriggered:()=>E,dispose:()=>{clearTimeout(N),E=!1}}},v=x=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,x())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class R{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,E=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((z,G)=>{this.d=z,this.f=G}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=E===I.MicrotaskDelay?v(N):g(E,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new U.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=R;class n{constructor(M){this.a=new R(M),this.b=new c}trigger(M,E){return this.a.trigger(()=>this.b.queue(M),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this.a=!1,this.b=new Promise((M,E)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class t extends r{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function i(x,M){return M?new Promise((E,N)=>{const z=setTimeout(()=>{G.dispose(),E()},x),G=M.onCancellationRequested(()=>{clearTimeout(z),G.dispose(),N(new U.CancellationError)})}):P(E=>i(x,E))}e.timeout=i;function s(x,M=0){const E=setTimeout(x,M);return(0,A.toDisposable)(()=>clearTimeout(E))}e.disposableTimeout=s;function a(x){const M=[];let E=0;const N=x.length;function z(){return E<N?x[E++]():null}function G(q){q!=null&&M.push(q);const J=z();return J?J.then(G):Promise.resolve(M)}return Promise.resolve(null).then(G)}e.sequence=a;function o(x,M=N=>!!N,E=null){let N=0;const z=x.length,G=()=>{if(N>=z)return Promise.resolve(E);const q=x[N++];return Promise.resolve(q()).then(ee=>M(ee)?Promise.resolve(ee):G())};return G()}e.first=o;function h(x,M=N=>!!N,E=null){if(x.length===0)return Promise.resolve(E);let N=x.length;const z=()=>{N=-1;for(const G of x)G.cancel?.()};return new Promise((G,q)=>{for(const J of x)J.then(ee=>{--N>=0&&M(ee)?(z(),G(ee)):N===0&&G(E)}).catch(ee=>{--N>=0&&(z(),q(ee))})})}e.firstParallel=h;class b{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((E,N)=>{this.f.push({factory:M,c:E,e:N}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const E=M.factory();E.then(M.c,M.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=b;class y extends b{constructor(){super(1)}}e.Queue=y;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new H;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,E=O.extUri){const N=E.getComparisonKey(M);let z=this.a.get(N);return z||(z=new y,l.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(N),this.f()}),this.a.set(N,z)),z}f(){!this.d()||this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class T{constructor(M,E){this.a=-1,typeof M=="function"&&typeof E=="number"&&this.setIfNotSet(M,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},E)}setIfNotSet(M,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},E))}}e.TimeoutTimer=T;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,E){this.cancel(),this.a=setInterval(()=>{M()},E)}}e.IntervalTimer=F;class j{constructor(M,E){this.b=-1,this.a=M,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class B{constructor(M,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=M,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=B;class V extends j{constructor(M,E){super(M,E),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=V;class W extends A.Disposable{constructor(M,E){super(),this.g=M,this.h=E,this.a=[],this.b=this.D(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of M)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,D.setTimeout0)(()=>{if(M)return;const E=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(x,M)=>{const E=requestIdleCallback(x,typeof M=="number"?{timeout:M}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(E))}}}}();class Q{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Q;async function X(x,M,E){let N;for(let z=0;z<E;z++)try{return await x()}catch(G){N=G,await i(M)}throw N}e.retry=X;class Y{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,E,N){return this.a={taskId:M,cancel:()=>N?.(),promise:E},E.then(()=>this.d(M),()=>this.d(M)),E}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let E,N;const z=new Promise((G,q)=>{E=G,N=q});this.b={run:M,promise:z,promiseResolve:E,promiseReject:N}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Y;class Z{constructor(M,E=()=>Date.now()){this.d=M,this.f=E,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((M,E)=>{this.a=M,this.b=E})}complete(M){return new Promise(E=>{this.a(M),this.f=!0,E()})}error(M){return new Promise(E=>{this.b(M),this.d=!0,E()})}cancel(){new Promise(M=>{this.b(new U.CancellationError),this.d=!0,M()})}}e.DeferredPromise=H;var $;(function(x){async function M(N){let z;const G=await Promise.all(N.map(q=>q.then(J=>J,J=>{z||(z=J)})));if(typeof z<"u")throw z;return G}x.settled=M;function E(N){return new Promise(async(z,G)=>{try{await N(z,G)}catch(q){G(q)}})}x.withAsyncBody=E})($=e.Promises||(e.Promises={}));var _;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(_||(_={}));class ie{static fromArray(M){return new ie(E=>{E.emitMany(M)})}static fromPromise(M){return new ie(async E=>{E.emitMany(await M)})}static fromPromises(M){return new ie(async E=>{await Promise.all(M.map(async N=>E.emitOne(await N)))})}static merge(M){return new ie(async E=>{await Promise.all(M.map(async N=>{for await(const z of N)E.emitOne(z)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const E={emitOne:N=>this.g(N),emitMany:N=>this.h(N),reject:N=>this.k(N)};try{await Promise.resolve(M(E)),this.j()}catch(N){this.k(N)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(M,E){return new ie(async N=>{for await(const z of M)N.emitOne(E(z))})}map(M){return ie.map(this,M)}static filter(M,E){return new ie(async N=>{for await(const z of M)E(z)&&N.emitOne(z)})}filter(M){return ie.filter(this,M)}static coalesce(M){return ie.filter(M,E=>!!E)}coalesce(){return ie.coalesce(this)}static async toPromise(M){const E=[];for await(const N of M)E.push(N);return E}toPromise(){return ie.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class se extends ie{constructor(M,E){super(E),this.l=M}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function ae(x){const M=new L.CancellationTokenSource,E=x(M.token);return new se(M,async N=>{const z=M.token.onCancellationRequested(()=>{z.dispose(),M.dispose(),N.reject(new U.CancellationError)});try{for await(const G of E){if(M.token.isCancellationRequested)return;N.emitOne(G)}z.dispose(),M.dispose()}catch(G){z.dispose(),M.dispose(),N.reject(G)}})}e.createCancelableAsyncIterable=ae}),define(re[92],oe([0,1,21,6,48,37,13,4,27]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",S="[^/\\\\]",p=/\//g;function d(Z,H){switch(Z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}${H?`|${P}${S}+`:""})*?`}}function m(Z,H){if(!Z)return[];const $=[];let _=!1,ie=!1,se="";for(const ae of Z){switch(ae){case H:if(!_&&!ie){$.push(se),se="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}se+=ae}return se&&$.push(se),$}e.splitGlobAware=m;function C(Z){if(!Z)return"";let H="";const $=m(Z,e.GLOB_SPLIT);if($.every(_=>_===e.GLOBSTAR))H=".*";else{let _=!1;$.forEach((ie,se)=>{if(ie===e.GLOBSTAR){if(_)return;H+=d(2,se===$.length-1)}else{let ae=!1,x="",M=!1,E="";for(const N of ie){if(N!=="}"&&ae){x+=N;continue}if(M&&(N!=="]"||!E)){let z;N==="-"?z=N:(N==="^"||N==="!")&&!E?z="^":N===e.GLOB_SPLIT?z="":z=(0,I.escapeRegExpCharacters)(N),E+=z;continue}switch(N){case"{":ae=!0;continue;case"[":M=!0;continue;case"}":{H+=`(?:${m(x,",").map(q=>C(q)).join("|")})`,ae=!1,x="";break}case"]":{H+="["+E+"]",M=!1,E="";break}case"?":H+=S;continue;case"*":H+=d(1);continue;default:H+=(0,I.escapeRegExpCharacters)(N)}}se<$.length-1&&($[se+1]!==e.GLOBSTAR||se+2<$.length)&&(H+=P)}_=ie===e.GLOBSTAR})}return H}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(Z,H){if(!Z)return t;let $;typeof Z!="string"?$=Z.pattern:$=Z,$=$.trim();const _=`${$}_${!!H.trimForExclusions}`;let ie=n.get(_);if(ie)return s(ie,Z);let se;return c.test($)?ie=o($.substr(4),$):(se=u.exec(a($,H)))?ie=h(se[1],$):(H.trimForExclusions?g:f).test($)?ie=b($,H):(se=v.exec(a($,H)))?ie=y(se[1].substr(1),$,!0):(se=R.exec(a($,H)))?ie=y(se[1],$,!1):ie=k($),n.set(_,ie),s(ie,Z)}function s(Z,H){if(typeof H=="string")return Z;const $=function(_,ie){return(0,l.isEqualOrParent)(_,H.base,!D.isLinux)?Z((0,I.ltrim)(_.substr(H.base.length),O.sep),ie):null};return $.allBasenames=Z.allBasenames,$.allPaths=Z.allPaths,$.basenames=Z.basenames,$.patterns=Z.patterns,$}function a(Z,H){return H.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function o(Z,H){return function($,_){return typeof $=="string"&&$.endsWith(Z)?H:null}}function h(Z,H){const $=`/${Z}`,_=`\\${Z}`,ie=function(ae,x){return typeof ae!="string"?null:x?x===Z?H:null:ae===Z||ae.endsWith($)||ae.endsWith(_)?H:null},se=[Z];return ie.basenames=se,ie.patterns=[H],ie.allBasenames=se,ie}function b(Z,H){const $=X(Z.slice(1,-1).split(",").map(x=>i(x,H)).filter(x=>x!==t),Z),_=$.length;if(!_)return t;if(_===1)return $[0];const ie=function(x,M){for(let E=0,N=$.length;E<N;E++)if($[E](x,M))return Z;return null},se=$.find(x=>!!x.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((x,M)=>M.allPaths?x.concat(M.allPaths):x,[]);return ae.length&&(ie.allPaths=ae),ie}function y(Z,H,$){const _=O.sep===O.posix.sep,ie=_?Z:Z.replace(p,O.sep),se=O.sep+ie,ae=O.posix.sep+Z;let x;return $?x=function(M,E){return typeof M=="string"&&(M===ie||M.endsWith(se)||!_&&(M===Z||M.endsWith(ae)))?H:null}:x=function(M,E){return typeof M=="string"&&(M===ie||!_&&M===Z)?H:null},x.allPaths=[($?"*/":"./")+Z],x}function k(Z){try{const H=new RegExp(`^${C(Z)}$`);return function($){return H.lastIndex=0,typeof $=="string"&&H.test($)?Z:null}}catch{return t}}function T(Z,H,$){return!Z||typeof H!="string"?!1:F(Z)(H,void 0,$)}e.match=T;function F(Z,H={}){if(!Z)return r;if(typeof Z=="string"||j(Z)){const $=i(Z,H);if($===t)return r;const _=function(ie,se){return!!$(ie,se)};return $.allBasenames&&(_.allBasenames=$.allBasenames),$.allPaths&&(_.allPaths=$.allPaths),_}return W(Z,H)}e.parse=F;function j(Z){const H=Z;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=j;function B(Z){return Z.allBasenames||[]}e.getBasenameTerms=B;function V(Z){return Z.allPaths||[]}e.getPathTerms=V;function W(Z,H){const $=X(Object.getOwnPropertyNames(Z).map(x=>Q(x,Z[x],H)).filter(x=>x!==t)),_=$.length;if(!_)return t;if(!$.some(x=>!!x.requiresSiblings)){if(_===1)return $[0];const x=function(N,z){let G;for(let q=0,J=$.length;q<J;q++){const ee=$[q](N,z);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(G||(G=[]),G.push(ee))}return G?(async()=>{for(const q of G){const J=await q;if(typeof J=="string")return J}return null})():null},M=$.find(N=>!!N.allBasenames);M&&(x.allBasenames=M.allBasenames);const E=$.reduce((N,z)=>z.allPaths?N.concat(z.allPaths):N,[]);return E.length&&(x.allPaths=E),x}const ie=function(x,M,E){let N,z;for(let G=0,q=$.length;G<q;G++){const J=$[G];J.requiresSiblings&&E&&(M||(M=(0,O.basename)(x)),N||(N=M.substr(0,M.length-(0,O.extname)(x).length)));const ee=J(x,M,N,E);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const G of z){const q=await G;if(typeof q=="string")return q}return null})():null},se=$.find(x=>!!x.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((x,M)=>M.allPaths?x.concat(M.allPaths):x,[]);return ae.length&&(ie.allPaths=ae),ie}function Q(Z,H,$){if(H===!1)return t;const _=i(Z,$);if(_===t)return t;if(typeof H=="boolean")return _;if(H){const ie=H.when;if(typeof ie=="string"){const se=(ae,x,M,E)=>{if(!E||!_(ae,x))return null;const N=ie.replace("$(basename)",()=>M),z=E(N);return(0,U.isThenable)(z)?z.then(G=>G?Z:null):z?Z:null};return se.requiresSiblings=!0,se}}return _}function X(Z,H){const $=Z.filter(x=>!!x.basenames);if($.length<2)return Z;const _=$.reduce((x,M)=>{const E=M.basenames;return E?x.concat(E):x},[]);let ie;if(H){ie=[];for(let x=0,M=_.length;x<M;x++)ie.push(H)}else ie=$.reduce((x,M)=>{const E=M.patterns;return E?x.concat(E):x},[]);const se=function(x,M){if(typeof x!="string")return null;if(!M){let N;for(N=x.length;N>0;N--){const z=x.charCodeAt(N-1);if(z===47||z===92)break}M=x.substr(N)}const E=_.indexOf(M);return E!==-1?ie[E]:null};se.basenames=_,se.patterns=ie,se.allBasenames=_;const ae=Z.filter(x=>!x.basenames);return ae.push(se),ae}function Y(Z,H){return(0,L.equals)(Z,H,($,_)=>typeof $=="string"&&typeof _=="string"?$===_:typeof $!="string"&&typeof _!="string"?$.base===_.base&&$.pattern===_.pattern:!1)}e.patternsEquals=Y}),define(re[93],oe([0,1,16,11]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(S){return S.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:l(U.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:l(U.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:U.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function O(S,p,d){if(!S||d>200)return null;if(typeof S=="object"){if(S instanceof U.URI)return p.transformOutgoing(S);for(const m in S)if(Object.hasOwnProperty.call(S,m)){const C=O(S[m],p,d+1);C!==null&&(S[m]=C)}}return null}function D(S,p){const d=O(S,p,0);return d===null?S:d}e.transformOutgoingURIs=D;function I(S,p,d,m){if(!S||m>200)return null;if(typeof S=="object"){if(S.$mid===1)return d?U.URI.revive(p.transformIncoming(S)):p.transformIncoming(S);if(S instanceof L.VSBuffer)return null;for(const C in S)if(Object.hasOwnProperty.call(S,C)){const c=I(S[C],p,d,m+1);c!==null&&(S[C]=c)}}return null}function w(S,p){const d=I(S,p,!1,0);return d===null?S:d}e.transformIncomingURIs=w;function P(S,p){const d=I(S,p,!0,0);return d===null?S:d}e.transformAndReviveIncomingURIs=P}),define(re[145],oe([0,1,34,10,49,31,135]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,S=0;const p=(0,L.networkInterfaces)();for(const d in p){const m=p[d];if(m)for(const{mac:C,internal:c}of m)c||(S+=1,this.c(C.toUpperCase())&&(P+=1))}this.b=S>0?P/S:0}return this.b}};let D;async function I(){return D||(D=(async()=>await w()||A.generateUuid())()),D}e.getMachineId=I;async function w(){try{const P=await new Promise((p,d)=>{te(["crypto"],p,d)}),S=(0,O.getMac)();return P.createHash("sha256").update(S,"utf8").digest("hex")}catch(P){U.onUnexpectedError(P);return}}}),define(re[28],oe([0,1,54,34,291,6,48,85,13,4,23,11]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function d(W,Q=p.UNLINK){if((0,O.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return Q===p.UNLINK?C(W):m(W)}async function m(W){try{const Q=(0,O.randomPath)((0,U.tmpdir)());try{await L.promises.rename(W,Q)}catch(X){return X.code==="ENOENT"?void 0:C(W)}C(Q).catch(X=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function C(W){return(0,l.promisify)(L.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function c(W){if((0,O.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(W,Q){return v(await(Q?f(W):(0,l.promisify)(L.readdir)(W)))}async function f(W){try{return await(0,l.promisify)(L.readdir)(W,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const Q=[],X=await u(W);for(const Y of X){let Z=!1,H=!1,$=!1;try{const _=await e.Promises.lstat((0,I.join)(W,Y));Z=_.isFile(),H=_.isDirectory(),$=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}Q.push({name:Y,isFile:()=>Z,isDirectory:()=>H,isSymbolicLink:()=>$})}return Q}function g(W){return v(L.readdirSync(W))}e.readdirSync=g;function v(W){return W.map(Q=>typeof Q=="string"?w.isMacintosh?(0,D.normalizeNFC)(Q):Q:(Q.name=w.isMacintosh?(0,D.normalizeNFC)(Q.name):Q.name,Q))}async function R(W){const Q=await u(W),X=[];for(const Y of Q)await r.existsDirectory((0,I.join)(W,Y))&&X.push(Y);return X}function n(W,Q=1e3){return new Promise(X=>{let Y=!1;const Z=setInterval(()=>{Y||(Y=!0,L.access(W,H=>{Y=!1,H&&(clearInterval(Z),X(void 0))}))},Q)})}e.whenDeleted=n;var r;(function(W){async function Q(Z){let H;try{if(H=await e.Promises.lstat(Z),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(w.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw _}throw $}}W.stat=Q;async function X(Z){try{const{stat:H,symbolicLink:$}=await W.stat(Z);return H.isFile()&&$?.dangling!==!0}catch{}return!1}W.existsFile=X;async function Y(Z){try{const{stat:H,symbolicLink:$}=await W.stat(Z);return H.isDirectory()&&$?.dangling!==!0}catch{}return!1}W.existsDirectory=Y})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function i(W,Q,X){return t.queueFor(S.URI.file(W),P.extUriBiasedIgnorePathCase).queue(()=>{const Y=b(X);return new Promise((Z,H)=>o(W,Q,Y,$=>$?H($):Z()))})}let s=!0;function a(W){s=W}e.configureFlushOnWrite=a;function o(W,Q,X,Y){if(!s)return L.writeFile(W,Q,{mode:X.mode,flag:X.flag},Y);L.open(W,X.flag,X.mode,(Z,H)=>{if(Z)return Y(Z);L.writeFile(H,Q,$=>{if($)return L.close(H,()=>Y($));L.fdatasync(H,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),a(!1)),L.close(H,ie=>Y(ie))))})})}function h(W,Q,X){const Y=b(X);if(!s)return L.writeFileSync(W,Q,{mode:Y.mode,flag:Y.flag});const Z=L.openSync(W,Y.flag,Y.mode);try{L.writeFileSync(Z,Q);try{L.fdatasyncSync(Z)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),a(!1)}}finally{L.closeSync(Z)}}e.writeFileSync=h;function b(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function y(W,Q){if(W!==Q)try{await e.Promises.rename(W,Q)}catch(X){if(W.toLowerCase()!==Q.toLowerCase()&&X.code==="EXDEV"||W.endsWith("."))await k(W,Q,{preserveSymlinks:!1}),await d(W,p.MOVE);else throw X}}async function k(W,Q,X){return F(W,Q,{root:{source:W,target:Q},options:X,handledSourcePaths:new Set})}const T=511;async function F(W,Q,X){if(X.handledSourcePaths.has(W))return;X.handledSourcePaths.add(W);const{stat:Y,symbolicLink:Z}=await r.stat(W);if(Z){if(X.options.preserveSymlinks)try{return await V(W,Q,X)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Z.dangling)return}return Y.isDirectory()?j(W,Q,Y.mode&T,X):B(W,Q,Y.mode&T)}async function j(W,Q,X,Y){await e.Promises.mkdir(Q,{recursive:!0,mode:X});const Z=await u(W);for(const H of Z)await F((0,I.join)(W,H),(0,I.join)(Q,H),Y)}async function B(W,Q,X){await e.Promises.copyFile(W,Q),await e.Promises.chmod(Q,X)}async function V(W,Q,X){let Y=await e.Promises.readlink(W);(0,O.isEqualOrParent)(Y,X.root.source,!w.isLinux)&&(Y=(0,I.join)(X.root.target,Y.substr(X.root.source.length+1))),await e.Promises.symlink(Y,Q)}e.Promises=new class{get access(){return(0,l.promisify)(L.access)}get stat(){return(0,l.promisify)(L.stat)}get lstat(){return(0,l.promisify)(L.lstat)}get utimes(){return(0,l.promisify)(L.utimes)}get read(){return(W,Q,X,Y,Z)=>new Promise((H,$)=>{L.read(W,Q,X,Y,Z,(_,ie,se)=>_?$(_):H({bytesRead:ie,buffer:se}))})}get readFile(){return(0,l.promisify)(L.readFile)}get write(){return(W,Q,X,Y,Z)=>new Promise((H,$)=>{L.write(W,Q,X,Y,Z,(_,ie,se)=>_?$(_):H({bytesWritten:ie,buffer:se}))})}get appendFile(){return(0,l.promisify)(L.appendFile)}get fdatasync(){return(0,l.promisify)(L.fdatasync)}get truncate(){return(0,l.promisify)(L.truncate)}get rename(){return(0,l.promisify)(L.rename)}get copyFile(){return(0,l.promisify)(L.copyFile)}get open(){return(0,l.promisify)(L.open)}get close(){return(0,l.promisify)(L.close)}get symlink(){return(0,l.promisify)(L.symlink)}get readlink(){return(0,l.promisify)(L.readlink)}get chmod(){return(0,l.promisify)(L.chmod)}get mkdir(){return(0,l.promisify)(L.mkdir)}get unlink(){return(0,l.promisify)(L.unlink)}get rmdir(){return(0,l.promisify)(L.rmdir)}get realpath(){return(0,l.promisify)(L.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return R}get writeFile(){return i}get rm(){return d}get move(){return y}get copy(){return k}}}),define(re[146],oe([0,1,54,13,4,27,28]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(p){if(l.isLinux)return p;const d=(0,U.dirname)(p);if(p===d)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const c=(0,O.readdirSync)(d).filter(u=>u.toLowerCase()===m);if(c.length===1){const u=D(d);if(u)return(0,U.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(m);if(u>=0){const f=D(d);if(f)return(0,U.join)(f,c[u])}}}catch{}return null}e.realcaseSync=D;async function I(p){if(l.isLinux)return p;const d=(0,U.dirname)(p);if(p===d)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const c=(await O.Promises.readdir(d)).filter(u=>u.toLowerCase()===m);if(c.length===1){const u=await I(d);if(u)return(0,U.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(m);if(u>=0){const f=await I(d);if(f)return(0,U.join)(f,c[u])}}}catch{}return null}e.realcase=I;async function w(p){try{return await O.Promises.realpath(p)}catch{const m=S(p);return await O.Promises.access(m,L.constants.R_OK),m}}e.realpath=w;function P(p){try{return L.realpathSync(p)}catch{const m=S(p);return L.accessSync(m,L.constants.R_OK),m}}e.realpathSync=P;function S(p){return(0,A.rtrim)((0,U.normalize)(p),U.sep)}}),define(re[94],oe([0,1,34,13,28]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var I;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(I||(I={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class S{constructor(R,n,r){this.exePath=R,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:v=!1}={}){return v?w===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:v=!1,findPreview:R=!1}={}){const n=p({useAlternateBitness:v});if(!n)return null;const r=U.join(n,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const o of await l.Promises.readdir(r)){let h=-1;if(R){const y=o.indexOf("-");if(y<0)continue;const k=o.substring(0,y);if(!A.test(k)||o.substring(y+1)!=="preview")continue;h=parseInt(k,10)}else{if(!A.test(o))continue;h=parseInt(o,10)}if(h<=t)continue;const b=U.join(r,o,"pwsh.exe");!await l.SymlinkSupport.existsFile(b)||(i=b,t=h)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",a=R?" Preview":"";return new S(i,`PowerShell${a}${s}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const R=U.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=v?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await l.Promises.readdir(R))if(n.test(t)){const i=U.join(R,t,"pwsh.exe");return new S(i,r)}return null}function C(){const v=U.join(L.homedir(),".dotnet","tools","pwsh.exe");return new S(v,".NET Core PowerShell Global Tool")}function c(){const v=U.join(process.env.windir,w===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(v,"Windows PowerShell",!0)}async function*u(){let v=await d();v&&(yield v),v=await d({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=C(),v&&(yield v),v=await d({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await d({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=c(),v&&(yield v)}async function*f(){for await(const v of u())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=f;async function g(){for await(const v of f())return v;return null}e.getFirstAvailablePowerShellInstallation=g}),define(re[95],oe([0,1,13,4,36,88,12,28]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function I(S=l.env){return S.comspec||"cmd.exe"}e.getWindowsShell=I;function w(S){let p=[],d=!1;const m=function(C){if(d){p.push(C);return}(!S.send(C,u=>{if(u&&console.error(u),d=!1,p.length>0){const f=p.slice(0);p=[],f.forEach(g=>m(g))}})||U.isWindows)&&(d=!0)};return{send:m}}e.createQueuedSender=w;var P;(function(S){async function p(d,m,C){if(L.isAbsolute(d))return d;if(m===void 0&&(m=l.cwd()),L.dirname(d)!=="."||(C===void 0&&O.isString(l.env.PATH)&&(C=l.env.PATH.split(L.delimiter)),C===void 0||C.length===0))return L.join(m,d);async function u(f){if(await D.Promises.exists(f)){let g;try{g=await D.Promises.stat(f)}catch(v){v.message.startsWith("EACCES")&&(g=await D.Promises.lstat(f))}return g?!g.isDirectory():!1}return!1}for(const f of C){let g;if(L.isAbsolute(f)?g=L.join(f,d):g=L.join(m,f,d),await u(g))return g;let v=g+".com";if(await u(v)||(v=g+".exe",await u(v)))return v}return L.join(m,d)}S.findExecutable=p})(P=e.win32||(e.win32={}))}),define(re[147],oe([0,1,50,22]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(O){return new Promise((D,I)=>{let w;const P=new Map;function S(d,m,C,c,u){const f=P.get(m);if(d===O||f){const g={name:p(C),cmd:C,pid:d,ppid:m,load:c,mem:u};P.set(d,g),d===O&&(w=g),f&&(f.children||(f.children=[]),f.children.push(g),f.children.length>1&&(f.children=f.children.sort((v,R)=>v.pid-R.pid)))}}function p(d){const m=/--utility-sub-type=network/i,C=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,f=/conhost\.exe/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(d))return"electron-crash-reporter";if(u.exec(d))return"winpty-process";if(f.exec(d))return"console-window-host (Windows internal process)";let v=g.exec(d);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?m.exec(d)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const R=/[a-zA-Z-]+\.js/g;let n="";do v=R.exec(d),v&&(n+=v+" ");while(v);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${n})`:C.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,C)=>{te(["windows-process-tree"],m,C)}).then(m=>{m.getProcessList(O,C=>{if(!C){I(new Error(`Root process ${O} not found`));return}m.getProcessCpuUsage(C,c=>{const u=new Map;c.forEach(f=>{const g=d(f.commandLine||"");u.set(f.pid,{name:p(g),cmd:g,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),w=u.get(O),w?(u.forEach(f=>{const g=u.get(f.ppid);g&&(g.children||(g.children=[]),g.children.push(f))}),u.forEach(f=>{f.children&&(f.children=f.children.sort((g,v)=>g.pid-v.pid))}),D(w)):I(new Error(`Root process ${O} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[w];const C=[];for(;m.length;){const u=m.shift();u&&(C.push(u.pid),u.children&&(m=m.concat(u.children)))}let c=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+C.join(" "),(0,L.exec)(c,{},(u,f,g)=>{if(u||g)I(u||new Error(g.toString()));else{const v=f.toString().split(`
`);for(let R=0;R<C.length;R++){const n=P.get(C[R]);n.load=parseFloat(v[R])}if(!w){I(new Error(`Root process ${O} not found`));return}D(w)}})};(0,L.exec)("which ps",{},(m,C,c)=>{if(m||c)if(process.platform!=="linux")I(m||new Error(c.toString()));else{const u=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(u,{},(f,g,v)=>{f||v?I(f||new Error(v.toString())):(A(g,S),d())})}else{const u=C.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${u} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,R)=>{g||R&&!R.includes("screen size is bogus")?I(g||new Error(R.toString())):(A(v,S),process.platform==="linux"?d():w?D(w):I(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=l;function A(O,D){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=O.toString().split(`
`);for(const P of w){const S=I.exec(P.trim());S&&S.length===6&&D(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(re[148],oe([0,1,34,4,94,95]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(S,p){return S===1?U.isWindows?P():A.getWindowsShell(p):I(S,p)}e.getSystemShell=O;let D=null;function I(S,p){if(U.isLinux&&S===2||U.isMacintosh&&S===3)return"/bin/bash";if(!D){let d;if(U.isWindows)d="/bin/bash";else{if(d=p.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}D=d}return D}let w=null;async function P(){return w||(w=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),w}});var ye=this&&this.__decorate||function(te,e,L,U){var l=arguments.length,A=l<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,L):U,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,L,U);else for(var D=te.length-1;D>=0;D--)(O=te[D])&&(A=(l<3?O(A):l>3?O(e,L,A):O(e,L))||A);return l>3&&A&&Object.defineProperty(e,L,A),A};define(re[39],oe([0,1,21,6,16,25,62,10,3,2,91,27,12]),function(te,e,L,U,l,A,O,D,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(d||(d={}));function m(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(C||(C={}));function c(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(u||(u={}));function f(H){let $=0;for(let _=0;;_+=7){const ie=H.read(1);if($|=(ie.buffer[0]&127)<<_,!(ie.buffer[0]&128))return $}}const g=t(0);function v(H,$){if($===0){H.write(g);return}let _=0;for(let se=$;se!==0;se=se>>>7)_++;const ie=l.VSBuffer.alloc(_);for(let se=0;$!==0;se++)ie.buffer[se]=$&127,$=$>>>7,$>0&&(ie.buffer[se]|=128);H.write(ie)}class R{constructor($){this.b=$,this.a=0}read($){const _=this.b.slice(this.a,this.a+$);return this.a+=_.byteLength,_}}e.BufferReader=R;class n{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write($){this.a.push($)}}e.BufferWriter=n;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function t(H){const $=l.VSBuffer.alloc(1);return $.writeUInt8(H,0),$}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function a(H,$){if(typeof $>"u")H.write(i.Undefined);else if(typeof $=="string"){const _=l.VSBuffer.fromString($);H.write(i.String),v(H,_.byteLength),H.write(_)}else if(s&&Buffer.isBuffer($)){const _=l.VSBuffer.wrap($);H.write(i.Buffer),v(H,_.byteLength),H.write(_)}else if($ instanceof l.VSBuffer)H.write(i.VSBuffer),v(H,$.byteLength),H.write($);else if(Array.isArray($)){H.write(i.Array),v(H,$.length);for(const _ of $)a(H,_)}else if(typeof $=="number"&&($|0)===$)H.write(i.Uint),v(H,$);else{const _=l.VSBuffer.fromString(JSON.stringify($));H.write(i.Object),v(H,_.byteLength),H.write(_)}}e.serialize=a;function o(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(f(H)).toString();case r.Buffer:return H.read(f(H)).buffer;case r.VSBuffer:return H.read(f(H));case r.Array:{const _=f(H),ie=[];for(let se=0;se<_;se++)ie.push(o(H));return ie}case r.Object:return JSON.parse(H.read(f(H)).toString());case r.Int:return f(H)}}e.deserialize=o;class h{constructor($,_,ie=null,se=1e3){this.h=$,this.j=_,this.k=ie,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel($,_){this.b.set($,_),setTimeout(()=>this.w($),0)}m($){switch($.type){case 200:{const _=this.o([$.type]);this.k?.logOutgoing(_,0,1,c($.type));return}case 201:case 202:case 204:case 203:{const _=this.o([$.type,$.id],$.data);this.k?.logOutgoing(_,$.id,1,c($.type),$.data);return}}}o($,_=void 0){const ie=new n;return a(ie,$),a(ie,_),this.p(ie.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const _=new R($),ie=o(_),se=o(_),ae=ie[0];switch(ae){case 100:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.s({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 102:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.t({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 101:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]});case 103:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]})}}s($){const _=this.b.get($.channelName);if(!_){this.v($);return}const ie=new A.CancellationTokenSource;let se;try{se=_.call(this.j,$.name,$.arg,ie.token)}catch(M){se=Promise.reject(M)}const ae=$.id;se.then(M=>{this.m({id:ae,data:M,type:201}),this.d.delete($.id)},M=>{M instanceof Error?this.m({id:ae,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:ae,data:M,type:203}),this.d.delete($.id)});const x=(0,w.toDisposable)(()=>ie.cancel());this.d.set($.id,x)}t($){const _=this.b.get($.channelName);if(!_){this.v($);return}const ie=$.id,ae=_.listen(this.j,$.name,$.arg)(x=>this.m({id:ie,data:x,type:204}));this.d.set($.id,ae)}u($){const _=this.d.get($.id);_&&(_.dispose(),this.d.delete($.id))}v($){let _=this.g.get($.channelName);_||(_=[],this.g.set($.channelName,_));const ie=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);_.push({request:$,timeoutTimer:ie})}w($){const _=this.g.get($);if(_){for(const ie of _)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var b;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor($,_=null){this.l=$,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=_}getChannel($){const _=this;return{call(ie,se,ae){return _.a?Promise.reject(new D.CancellationError):_.m($,ie,se,ae)},listen(ie,se){return _.a?I.Event.None:_.o($,ie,se)}}}m($,_,ie,se=A.CancellationToken.None){const ae=this.g++,M={id:ae,type:100,channelName:$,name:_,arg:ie};if(se.isCancellationRequested)return Promise.reject(new D.CancellationError);let E;return new Promise((z,G)=>{if(se.isCancellationRequested)return G(new D.CancellationError);const q=()=>{const he=me=>{switch(me.type){case 201:this.f.delete(ae),z(me.data);break;case 202:{this.f.delete(ae);const de=new Error(me.data.message);de.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,de.name=me.data.name,G(de);break}case 203:this.f.delete(ae),G(me.data);break}};this.f.set(ae,he),this.p(M)};let J=null;this.b===u.Idle?q():(J=(0,U.createCancelablePromise)(he=>this.u()),J.then(()=>{J=null,q()}));const ee=()=>{J?(J.cancel(),J=null):this.p({id:ae,type:101}),G(new D.CancellationError)},ce=se.onCancellationRequested(ee);E=(0,w.combinedDisposable)((0,w.toDisposable)(ee),ce),this.d.add(E)}).finally(()=>{this.d.delete(E)})}o($,_,ie){const se=this.g++,x={id:se,type:102,channelName:$,name:_,arg:ie};let M=null;const E=new I.Emitter({onWillAddFirstListener:()=>{M=(0,U.createCancelablePromise)(z=>this.u()),M.then(()=>{M=null,this.d.add(E),this.p(x)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(E),this.p({id:se,type:103}))}}),N=z=>E.fire(z.data);return this.f.set(se,N),E.event}p($){switch($.type){case 100:case 102:{const _=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(_,$.id,0,`${m($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const _=this.q([$.type,$.id]);this.j?.logOutgoing(_,$.id,0,m($.type));return}}}q($,_=void 0){const ie=new n;return a(ie,$),a(ie,_),this.r(ie.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const _=new R($),ie=o(_),se=o(_),ae=ie[0];switch(ae){case 200:return this.j?.logIncoming($.byteLength,0,0,c(ae)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming($.byteLength,ie[1],0,c(ae),se),this.t({type:ie[0],id:ie[1],data:se})}}t($){if($.type===200){this.b=u.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}ye([O.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class k{get connections(){const $=[];return this.f.forEach(_=>$.push(_)),$}constructor($){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,$(({protocol:_,onDidClientDisconnect:ie})=>{I.Event.once(_.onMessage)(ae=>{const x=new R(ae),M=o(x),E=new h(_,M),N=new y(_);this.a.forEach((G,q)=>E.registerChannel(q,G));const z={channelServer:E,channelClient:N,ctx:M};this.f.add(z),this.g.fire(z),ie(()=>{E.dispose(),N.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel($,_){const ie=this;return{call(se,ae,x){let M;if((0,p.isFunction)(_)){const N=(0,L.getRandomElement)(ie.connections.filter(_));M=N?Promise.resolve(N):I.Event.toPromise(I.Event.filter(ie.onDidAddConnection,_))}else M=_.routeCall(ie,se,ae);const E=M.then(N=>N.channelClient.getChannel($));return F(E).call(se,ae,x)},listen(se,ae){if((0,p.isFunction)(_))return ie.j($,_,se,ae);const x=_.routeEvent(ie,se,ae).then(M=>M.channelClient.getChannel($));return F(x).listen(se,ae)}}}j($,_,ie,se){const ae=this;let x=new w.DisposableStore;const M=new I.Emitter({onWillAddFirstListener:()=>{x=new w.DisposableStore;const E=new I.EventMultiplexer,N=new Map,z=q=>{const ee=q.channelClient.getChannel($).listen(ie,se),ce=E.add(ee);N.set(q,ce)},G=q=>{const J=N.get(q);!J||(J.dispose(),N.delete(q))};ae.connections.filter(_).forEach(z),I.Event.filter(ae.onDidAddConnection,_)(z,void 0,x),ae.onDidRemoveConnection(G,void 0,x),E.event(M.fire,M,x),x.add(E)},onDidRemoveLastListener:()=>{x.dispose()}});return M.event}registerChannel($,_){this.a.set($,_),this.f.forEach(ie=>{ie.channelServer.registerChannel($,_)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class T{constructor($,_,ie=null){const se=new n;a(se,_),$.send(se.buffer),this.a=new y($,ie),this.d=new h($,_,ie)}getChannel($){return this.a.getChannel($)}registerChannel($,_){this.d.registerChannel($,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=T;function F(H){return{call($,_,ie){return H.then(se=>se.call($,_,ie))},listen($,_){const ie=new I.Relay;return H.then(se=>ie.input=se.listen($,_)),ie.event}}}e.getDelayedChannel=F;function j(H){let $=!1;return{call(_,ie,se){return $?H.call(_,ie,se):(0,U.timeout)(0).then(()=>$=!0).then(()=>H.call(_,ie,se))},listen(_,ie){if($)return H.listen(_,ie);const se=new I.Relay;return(0,U.timeout)(0).then(()=>$=!0).then(()=>se.input=H.listen(_,ie)),se.event}}}e.getNextTickChannel=j;class B{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const _ of $.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await I.Event.toPromise($.onDidAddConnection),await this.b($)}}e.StaticRouter=B;var V;(function(H){function $(ae,x){const M=ae,E=x&&x.disableMarshalling,N=new Map;for(const z in M)ie(z)&&N.set(z,I.Event.buffer(M[z],!0));return new class{listen(z,G,q){const J=N.get(G);if(J)return J;if(se(G)){const ee=M[G];if(typeof ee=="function")return ee.call(M,q)}throw new Error(`Event not found: ${G}`)}call(z,G,q){const J=M[G];if(typeof J=="function"){if(!E&&Array.isArray(q))for(let ee=0;ee<q.length;ee++)q[ee]=(0,P.revive)(q[ee]);return J.apply(M,q)}throw new Error(`Method not found: ${G}`)}}}H.fromService=$;function _(ae,x){const M=x&&x.disableMarshalling;return new Proxy({},{get(E,N){if(typeof N=="string")return x?.properties?.has(N)?x.properties.get(N):se(N)?function(z){return ae.listen(N,z)}:ie(N)?ae.listen(N):async function(...z){let G;x&&!(0,p.isUndefinedOrNull)(x.context)?G=[x.context,...z]:G=z;const q=await ae.call(N,G);return M?q:(0,P.revive)(q)};throw new Error(`Property not found: ${String(N)}`)}})}H.toService=_;function ie(ae){return ae[0]==="o"&&ae[1]==="n"&&S.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&S.isUpperAsciiLetter(ae.charCodeAt(9))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const $=H.toString();if($!=="[object Object]")return $}return H}function X(H){return Array.isArray(H)?H.map(Q):Q(H)}function Y(H,$,_,ie,se,ae,x){x=X(x);const M=W[se],E=M[ie%M.length];let N=[`%c[${H}]%c[${String($).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${E}`];/\($/.test(ae)?(N=N.concat(x),N.push(")")):N.push(x),console.log.apply(console,N)}class Z{constructor($,_){this.d=$,this.f=_,this.a=0,this.b=0}logOutgoing($,_,ie,se,ae){this.b+=$,Y(this.d,this.b,$,_,ie,se,ae)}logIncoming($,_,ie,se,ae){this.a+=$,Y(this.f,this.a,$,_,ie,se,ae)}}e.IPCLogger=Z}),define(re[149],oe([0,1,16,3,39]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(I){this.a=I,this.onMessage=U.Event.fromDOMEventEmitter(this.a,"message",w=>L.VSBuffer.wrap(w.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class O extends l.IPCClient{constructor(I,w){const P=new A(I);super(P,w),this.b=P}dispose(){this.b.disconnect()}}e.Client=O}),define(re[96],oe([0,1,6,16,3,2,39]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(y){y.Created="created",y.Read="read",y.Write="write",y.Open="open",y.Error="error",y.Close="close",y.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",y.NodeEndReceived="nodeEndReceived",y.NodeEndSent="nodeEndSent",y.NodeDrainBegin="nodeDrainBegin",y.NodeDrainEnd="nodeDrainEnd",y.zlibInflateError="zlibInflateError",y.zlibInflateData="zlibInflateData",y.zlibInflateInitialWrite="zlibInflateInitialWrite",y.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",y.zlibInflateWrite="zlibInflateWrite",y.zlibInflateFlushFired="zlibInflateFlushFired",y.zlibDeflateError="zlibDeflateError",y.zlibDeflateData="zlibDeflateData",y.zlibDeflateWrite="zlibDeflateWrite",y.zlibDeflateFlushFired="zlibDeflateFlushFired",y.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",y.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",y.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",y.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",y.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",y.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",y.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",y.ProtocolHeaderRead="protocolHeaderRead",y.ProtocolMessageRead="protocolMessageRead",y.ProtocolHeaderWrite="protocolHeaderWrite",y.ProtocolMessageWrite="protocolMessageWrite",y.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(y){y.enableDiagnostics=!1,y.records=[];const k=new WeakMap;let T=0;function F(B,V){if(!k.has(B)){const W=String(++T);k.set(B,W)}return k.get(B)}function j(B,V,W,Q){if(!y.enableDiagnostics)return;const X=F(B,V);if(Q instanceof U.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const Y=U.VSBuffer.alloc(Q.byteLength);Y.set(Q),y.records.push({timestamp:Date.now(),id:X,label:V,type:W,buff:Y})}else y.records.push({timestamp:Date.now(),id:X,label:V,type:W,data:Q})}y.traceSocketEvent=j})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(y){y[y.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",y[y.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function S(){return P||(P=U.VSBuffer.alloc(0)),P}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(k){this.a.push(k),this.b+=k.byteLength}read(k){return this.c(k,!0)}peek(k){return this.c(k,!1)}c(k,T){if(k===0)return S();if(k>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===k){const V=this.a[0];return T&&(this.a.shift(),this.b-=k),V}if(this.a[0].byteLength>k){const V=this.a[0].slice(0,k);return T&&(this.a[0]=this.a[0].slice(k),this.b-=k),V}const F=U.VSBuffer.alloc(k);let j=0,B=0;for(;k>0;){const V=this.a[B];if(V.byteLength>k){const W=V.slice(0,k);F.set(W,j),j+=k,T&&(this.a[B]=V.slice(k),this.b-=k),k-=k}else F.set(V,j),j+=V.byteLength,T?(this.a.shift(),this.b-=V.byteLength):B++,k-=V.byteLength}return F}}e.ChunkStream=p;var d;(function(y){y[y.None=0]="None",y[y.Regular=1]="Regular",y[y.Control=2]="Control",y[y.Ack=3]="Ack",y[y.Disconnect=5]="Disconnect",y[y.ReplayRequest=6]="ReplayRequest",y[y.Pause=7]="Pause",y[y.Resume=8]="Resume",y[y.KeepAlive=9]="KeepAlive",y[y.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",y[y.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function m(y){switch(y){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var C;(function(y){y[y.HeaderLength=13]="HeaderLength",y[y.AcknowledgeTime=2e3]="AcknowledgeTime",y[y.TimeoutTime=2e4]="TimeoutTime",y[y.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",y[y.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",y[y.KeepAliveSendTime=5e3]="KeepAliveSendTime",y[y.LatencySampleTime=6e4]="LatencySampleTime",y[y.LatencySampleCount=5]="LatencySampleCount",y[y.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",y[y.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(C=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(k,T,F,j){this.type=k,this.id=T,this.ack=F,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends A.Disposable{constructor(k){super(),this.f=this.D(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=k,this.b=!1,this.c=new p,this.D(this.a.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(k){if(!(!k||k.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(k);this.c.byteLength>=this.g.readLen;){const T=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=T.readUInt32BE(9),this.g.messageType=T.readUInt8(0),this.g.id=T.readUInt32BE(1),this.g.ack=T.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,j=this.g.id,B=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",T),this.f.fire(new c(F,j,B,T)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(k){this.k=null,this.a=!1,this.b=!1,this.c=k,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(k){if(this.a)return;k.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=U.VSBuffer.alloc(13);T.writeUInt8(k.type,0),T.writeUInt32BE(k.id,1),T.writeUInt32BE(k.ack,5),T.writeUInt32BE(k.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(k.type),id:k.id,ack:k.ack,messageSize:k.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",k.data),this.j(T,k.data)}g(k,T){const F=this.f===0;return this.d.push(k,T),this.f+=k.byteLength+T.byteLength,F}h(){const k=U.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,k}j(k,T){this.g(k,T)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const k=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:k.byteLength}),this.c.write(k)}}class g extends A.Disposable{constructor(k){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=k,this.b=this.D(new f(this.a)),this.c=this.D(new u(this.a)),this.D(this.c.onMessage(T=>{T.type===1&&this.f.fire(T.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(k){this.b.write(new c(1,0,0,k))}}e.Protocol=g;class v extends O.IPCClient{static fromSocket(k,T){return new v(new g(k),T)}get onDidDispose(){return this.b.onDidDispose}constructor(k,T,F=null){super(k,T,F),this.b=k}dispose(){super.dispose();const k=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),k.end()}}e.Client=v;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(k){this.b?this.d.length>0?this.d.push(k):this.a.fire(k):this.d.push(k)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class n{constructor(k){this.data=k,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let k=0,T=this.a;for(;T;)T=T.next,k++;return k}peek(){return this.a?this.a.data:null}toArray(){const k=[];let T=0,F=this.a;for(;F;)k[T++]=F.data,F=F.next;return k}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(k){const T=new n(k);if(!this.a){this.a=T,this.b=T;return}this.b.next=T,this.b=T}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const k=Date.now();for(let T=0;T<t.a;T++)this.c[T]=k-1e3*T;setInterval(()=>{for(let T=t.a;T>=1;T--)this.c[T]=this.c[T-1];this.c[0]=Date.now()},1e3)}d(){const k=Date.now(),T=(1+t.a)*1e3;let F=0;for(let j=0;j<t.a;j++)k-this.c[j]<=T&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var i;(function(y){y[y.Good=0]="Good",y[y.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function s(y){switch(y){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(k){this.connectionHealth=k}}e.ConnectionHealthChangedEvent=a;class o{constructor(k,T){this.roundTripTime=k,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=o;class h{get unacknowledgedCount(){return this.c-this.d}constructor(k){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=k.loadEstimator??t.getInstance(),this.v=k.measureRoundTripTime??!1,this.w=k.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=k.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(T=>this.E(T))),this.t.add(this.o.onClose(T=>this.A.fire(T))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(T=>this.J(T))),this.t.add(this.r.onHighRoundTripTime(T=>this.C.fire(T))),this.t.add(this.r.onDidChangeConnectionHealth(T=>this.D.fire(T))),this.v&&this.r.start(),k.initialChunk&&this.q.acceptChunk(k.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const k=new c(5,0,0,S());this.p.write(k),this.p.flush()}sendPause(){const k=new c(7,0,0,S());this.p.write(k)}sendResume(){const k=new c(8,0,0,S());this.p.write(k)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(k,T){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=k,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(T)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const k=new c(3,0,this.h,S());this.p.write(k);const T=this.b.toArray();for(let F=0,j=T.length;F<j;F++)this.p.write(T[F]);this.G()}acceptDisconnect(){this.z.fire()}E(k){if(k.ack>this.d){this.d=k.ack;do{const T=this.b.peek();if(T&&T.id<=k.ack)this.b.pop();else break}while(!0)}switch(k.type){case 0:break;case 1:{if(k.id>this.g)if(k.id!==this.g+1){const T=Date.now();T-this.m>1e4&&(this.m=T,this.p.write(new c(6,0,0,S())))}else this.g=k.id,this.j=Date.now(),this.F(),this.y.fire(k.data);break}case 2:{this.x.fire(k.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const T=this.b.toArray();for(let F=0,j=T.length;F<j;F++)this.p.write(T[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(k.data);break}case 11:{this.r.handleResponse(k.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(k){const T=++this.c;this.h=this.g;const F=new c(1,T,this.h,k);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(k){const T=new c(2,0,0,k);this.p.write(T)}F(){if(this.g<=this.h||this.k)return;const k=Date.now()-this.j;if(k>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-k+5)}G(){if(this.c<=this.d||this.f||this.a)return;const k=this.b.peek(),T=Date.now()-k.writtenTime,F=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(T>=2e4&&F>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:F});return}const B=Math.max(2e4-T,2e4-F,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},B)}H(){if(this.g<=this.h)return;this.h=this.g;const k=new c(3,0,this.h,S());this.p.write(k)}I(){this.h=this.g;const k=new c(9,0,this.h,S());this.p.write(k)}J(k){this.h=this.g;const T=new c(10,0,this.h,k);this.p.write(T)}K(k){this.h=this.g;const T=new c(11,0,this.h,k);this.p.write(T)}}e.PersistentProtocol=h;class b extends A.Disposable{constructor(){super(),this.a=this.D(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},k=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const k=++this.h,T=U.VSBuffer.alloc(4);T.writeUInt32BE(k,0),this.a.fire(T)},6e4)}handleResponse(k){if(k.byteLength!==4)return;const T=k.readUInt32BE(0);if(this.g<=0||T!==this.h)return;const F=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=F;const B=this.l,V=this.j.filter(W=>W>=1e3).length;this.l=V>=3?1:0,F>1e3&&this.b.fire(new o(F,V)),B!==this.l&&this.c.fire(this.l)}}}),define(re[150],oe([0,1,151,3,39,149]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends l.IPCServer{static b(){const I=U.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(w,P)=>P);return U.Event.map(I,w=>{const{port1:P,port2:S}=new MessageChannel,d={protocol:new A.Protocol(P),onDidClientDisconnect:U.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[S]),d})}constructor(){super(O.b())}}e.Server=O}),define(re[65],oe([0,1,50,6,16,25,144,10,3,2,32,95,88,39]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",f=>l.VSBuffer.wrap(Buffer.from(f,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class C{constructor(u,f){this.i=u,this.j=f,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const g=f&&f.timeout?f.timeout:6e4;this.b=new U.Delayer(g),this.d=null,this.f=null}getChannel(u){const f=this;return{call(g,v,R){return f.k(u,g,v,R)},listen(g,v){return f.l(u,g,v)}}}k(u,f,g,v=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(D.canceled());this.b.cancel();const R=this.n(u),n=(0,U.createCancelablePromise)(i=>R.call(f,g,i)),r=v.onCancellationRequested(()=>n.cancel()),t=(0,w.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,f,g){if(!this.b)return I.Event.None;this.b.cancel();let v;const R=new I.Emitter({onWillAddFirstListener:()=>{v=this.n(u).listen(f,g)(R.fire,R),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(f.env),this.d=(0,L.fork)(this.i,u,f);const g=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,O.isRemoteConsoleLog)(s)){(0,O.log)(s,`IPC Library: ${this.j.serverName}`);return}g.fire(l.VSBuffer.wrap(Buffer.from(s,"base64")))});const R=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&R.send(s.buffer.toString("base64")),r=g.event,t={send:n,onMessage:r};this.f=new d.ChannelClient(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,w.dispose)(o)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(u){let f=this.g.get(u);return f||(f=this.m.getChannel(u),this.g.set(u,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=C}),define(re[152],oe([0,1,87,16,39,3,12,21]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(p){this.a=p,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",d=>U.VSBuffer.wrap(d.data)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class w extends l.IPCServer{static b(){(0,O.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const p=new A.Emitter;return process.parentPort.on("message",d=>{const m=(0,D.firstOrDefault)(d.ports);m&&p.fire(m)}),A.Event.map(p.event,d=>({protocol:new I(d),onDidClientDisconnect:A.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(w.b())}}e.Server=w;function P(S,p,d){const m=C=>{C.data===p&&(S.removeListener("message",m),d())};S.on("message",m)}e.once=P}),define(re[153],oe([0,1,16,10,3,2,13,4,31,39,96]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class p{traceSocketEvent(o,h){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,h)}constructor(o,h=""){this.f=!0,this.debugLabel=h,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,U.onUnexpectedError)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent("close",{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const h=b=>{this.traceSocketEvent("read",b),o(L.VSBuffer.wrap(b))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(o){const h=b=>{o({type:0,hadError:b,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(o){const h=()=>{o()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,U.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,U.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=p;var d;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize",a[a.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var m;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(m||(m={}));class C extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,h){this.socket.traceSocketEvent(o,h)}constructor(o,h,b,y){super(),this.f=this.D(new l.Emitter),this.g=this.D(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:b?.byteLength||0,recordInflateBytes:y}),this.a=this.D(new c(this,h,b,y,this.f,(k,T)=>this.k(k,T))),this.D(this.a.onError(k=>{console.error(k),(0,U.onUnexpectedError)(k),this.g.fire({type:0,hadError:!0,error:k})})),this.b=new P.ChunkStream,this.D(this.socket.onData(k=>this.l(k))),this.D(this.socket.onClose(async k=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(k)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){let h=0;for(;h<o.byteLength;)this.a.writeMessage(o.slice(h,Math.min(h+262144,o.byteLength))),h+=262144}k(o,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let b=2;o.byteLength<126?b+=0:o.byteLength<2**16?b+=2:b+=8;const y=L.VSBuffer.alloc(b);if(h?y.writeUInt8(194,0):y.writeUInt8(130,0),o.byteLength<126)y.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){y.writeUInt8(126,1);let k=1;y.writeUInt8(o.byteLength>>>8&255,++k),y.writeUInt8(o.byteLength>>>0&255,++k)}else{y.writeUInt8(127,1);let k=1;y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(o.byteLength>>>24&255,++k),y.writeUInt8(o.byteLength>>>16&255,++k),y.writeUInt8(o.byteLength>>>8&255,++k),y.writeUInt8(o.byteLength>>>0&255,++k)}this.socket.write(L.VSBuffer.concat([y,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),b=h.readUInt8(0),y=(b&128)>>>7,k=(b&64)>>>6,T=h.readUInt8(1),F=(T&128)>>>7,j=T&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=y,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(k)),this.j.firstFrameOfMessage=Boolean(y),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),b=h.readUInt8(1),y=(b&128)>>>7;let k=b&127,T=1;k===126?k=h.readUInt8(++T)*2**8+h.readUInt8(++T):k===127&&(k=h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T));let F=0;y&&(F=h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T)),this.j.state=3,this.j.readLen=k,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),g(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class c extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(o,h,b,y,k,T){super(),this.l=o,this.m=k,this.n=T,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,h?(this.b=this.D(new u(this.l,y,b,{windowBits:15})),this.f=this.D(new f(this.l,{windowBits:15})),this.D(this.b.onError(F=>this.a.fire(F))),this.D(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const h=await this.r(this.f,o);this.n(h,!0)}else this.n(o,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(o,h){return new Promise((b,y)=>{o.write(h),o.flush(k=>b(k))})}acceptFrame(o,h,b){this.h.push({data:o,isCompressed:h,isLastFrameOfMessage:b}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const h=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.m.fire(h)}else this.m.fire(o.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(o,h,b){return new Promise((y,k)=>{o.write(h),b&&o.write(L.VSBuffer.fromByteArray([0,0,255,255])),o.flush(T=>y(T))})}}class u extends A.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(o,h,b,y){super(),this.h=o,this.j=h,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(y),this.b.on("error",k=>{this.h.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.h.traceSocketEvent("zlibInflateData",k),this.g.push(L.VSBuffer.wrap(k))}),b&&(this.h.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=L.VSBuffer.concat(this.g);this.g.length=0,o(h)})}}class f extends A.Disposable{constructor(o,h){super(),this.g=o,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent("zlibDeflateData",b),this.f.push(L.VSBuffer.wrap(b))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=L.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),o(h)})}}function g(a,o){if(o===0)return;const h=a.byteLength>>>2;for(let j=0;j<h;j++){const B=a.readUInt32BE(j*4);a.writeUInt32BE(B^o,j*4)}const b=h*4,y=a.byteLength-b,k=o>>>24&255,T=o>>>16&255,F=o>>>8&255;y>=1&&a.writeUInt8(a.readUInt8(b)^k,b),y>=2&&a.writeUInt8(a.readUInt8(b+1)^T,b+1),y>=3&&a.writeUInt8(a.readUInt8(b+2)^F,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function R(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;const o=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:S().os.tmpdir(),h=(0,O.join)(o,`vscode-ipc-${a}.sock`);return r(h),h}e.createRandomIPCHandle=R;function n(a,o,h){const b=S().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${h}-${o}-sock`;const y=h.substr(0,4),k=o.substr(0,6),T=b.substr(0,8);let F;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${T}-${y}-${k}.sock`):F=(0,O.join)(a,`${y}-${k}.sock`),r(F),F}e.createStaticIPCHandle=n;function r(a){const o=v[D.platform];typeof o=="number"&&a.length>=o&&console.warn(`WARNING: IPC handle "${a}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends w.IPCServer{static b(o){const h=l.Event.fromNodeEventEmitter(o,"connection");return l.Event.map(h,b=>({protocol:new P.Protocol(new p(b,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(b,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function i(a){return new Promise((o,h)=>{const b=S().net.createServer();b.on("error",h),b.listen(a,()=>{b.removeListener("error",h),o(new t(b))})})}e.serve=i;function s(a,o){return new Promise((h,b)=>{const y=S().net.createConnection(a,()=>{y.removeListener("error",b),h(P.Client.fromSocket(new p(y,`ipc-client${o}`),o))});y.once("error",b)})}e.connect=s}),define(re[66],oe([0,1,6,3,2,12]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function D(S){const p=S;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var I;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class w extends l.Disposable{constructor(p,d=Object.create(null)){super(),this.m=p,this.n=d,this.b=this.D(new U.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new L.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(p=>this.q(p)))}q(p){p.changed?.forEach((d,m)=>this.r(m,d)),p.deleted?.forEach(d=>this.r(d,void 0))}r(p,d){if(this.c===I.Closed)return;let m=!1;(0,A.isUndefinedOrNull)(d)?m=this.f.delete(p):this.f.get(p)!==d&&(this.f.set(p,d),m=!0),m&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,d){const m=this.f.get(p);return(0,A.isUndefinedOrNull)(m)?d:m}getBoolean(p,d){const m=this.get(p);return(0,A.isUndefinedOrNull)(m)?d:m==="true"}getNumber(p,d){const m=this.get(p);return(0,A.isUndefinedOrNull)(m)?d:parseInt(m,10)}async set(p,d){if(this.c===I.Closed)return;if((0,A.isUndefinedOrNull)(d))return this.delete(p);const m=String(d);if(this.f.get(p)!==m)return this.f.set(p,m),this.j.set(p,m),this.h.delete(p),this.b.fire(p),this.v()}async delete(p){if(!(this.c===I.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=I.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.t)return this.v(p)}async v(p){return this.g.trigger(()=>this.u(),p)}async whenFlushed(){if(!!this.t)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}w.a=100,e.Storage=w;class P{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((d,m)=>this.a.set(m,d)),p.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=P}),define(re[154],oe([8,7]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[155],oe([8,7]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[156],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[157],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[158],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argv",e)}),define(re[159],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argvHelper",e)}),define(re[160],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[161],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[162],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[163],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(re[164],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[165],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[166],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[167],oe([8,7]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[168],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[169],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[170],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[171],oe([8,7]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[172],oe([8,7]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[173],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[174],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[175],oe([8,7]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[176],oe([8,7]),function(te,e){return te.create("vs/platform/shell/node/shellEnv",e)}),define(re[177],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[178],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[179],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[180],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[181],oe([8,7]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[182],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[183],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[184],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[185],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[186],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[187],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[188],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[189],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[190],oe([8,7]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[191],oe([0,1,10,157]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function A(...w){switch(w.length){case 1:return(0,U.localize)(0,null,w[0]);case 2:return(0,U.localize)(1,null,w[0],w[1]);case 3:return(0,U.localize)(2,null,w[0],w[1],w[2]);default:return}}const O=(0,U.localize)(3,null),D=(0,U.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,p=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:p};this.g.push({offset:S,lexeme:p,additionalInfo:P}),this.f.push(d)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),p=I.b.get(S);p?this.k(p):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(D);return}const m=this.c.charCodeAt(P);if(S)S=!1;else if(m===47&&!p){P++;break}else m===91?p=!0:m===92?S=!0:m===93&&(p=!1);P++}for(;P<this.c.length&&I.a.has(this.c.charCodeAt(P));)P++;this.e=P;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(re[192],oe([0,1,64,62,22,13,36,23,11]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,A.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(I.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=O.env.VSCODE_PORTABLE;return d?I.URI.file((0,A.join)(d,"argv.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?I.URI.file((0,A.resolve)(d)):I.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const m=O.env.VSCODE_EXTENSIONS;if(m)return m;const C=O.env.VSCODE_PORTABLE;return C?(0,A.join)(C,"extensions"):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,A.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?I.URI.parse(d):I.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const m of this.args.log||[]){const C=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);C&&C[1]&&C[2]&&d.push([C[1],C[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=O.env.VSCODE_PORTABLE;return d?I.URI.file((0,A.join)(d,"policy.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,m,C){this.a=d,this.b=m,this.c=C,this.editSessionId=this.args.editSessionId}}ye([U.memoize],w.prototype,"appRoot",null),ye([U.memoize],w.prototype,"userHome",null),ye([U.memoize],w.prototype,"userDataPath",null),ye([U.memoize],w.prototype,"appSettingsHome",null),ye([U.memoize],w.prototype,"tmpDir",null),ye([U.memoize],w.prototype,"cacheHome",null),ye([U.memoize],w.prototype,"stateResource",null),ye([U.memoize],w.prototype,"userRoamingDataHome",null),ye([U.memoize],w.prototype,"userDataSyncHome",null),ye([U.memoize],w.prototype,"sync",null),ye([U.memoize],w.prototype,"machineSettingsResource",null),ye([U.memoize],w.prototype,"workspaceStorageHome",null),ye([U.memoize],w.prototype,"localHistoryHome",null),ye([U.memoize],w.prototype,"keyboardLayoutResource",null),ye([U.memoize],w.prototype,"argvResource",null),ye([U.memoize],w.prototype,"isExtensionDevelopment",null),ye([U.memoize],w.prototype,"untitledWorkspacesHome",null),ye([U.memoize],w.prototype,"installSourcePath",null),ye([U.memoize],w.prototype,"builtinExtensionsPath",null),ye([U.memoize],w.prototype,"extensionsPath",null),ye([U.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ye([U.memoize],w.prototype,"extensionDevelopmentKind",null),ye([U.memoize],w.prototype,"extensionTestsLocationURI",null),ye([U.memoize],w.prototype,"debugExtensionHost",null),ye([U.memoize],w.prototype,"logLevel",null),ye([U.memoize],w.prototype,"extensionLogLevel",null),ye([U.memoize],w.prototype,"serviceMachineIdResource",null),ye([U.memoize],w.prototype,"disableTelemetry",null),ye([U.memoize],w.prototype,"disableWorkspaceTrust",null),ye([U.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function P(p,d){return S(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId,p.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function S(p,d,m,C,c,u){const g=Number(d||p)||(C?null:m),v=g?Boolean(!!d):!1;let R;if(u)try{R=JSON.parse(u)}catch{}return{port:g,break:v,debugId:c,env:R}}e.parseDebugParams=S}),define(re[193],oe([0,1,292,4,158]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function D(C,c,u=O){const f=C.find(a=>a.length>0&&a[0]!=="-"),g={},v=["_"],R=[],n={};let r;for(const a in c){const o=c[a];o.type==="subcommand"?a===f&&(r=o):(o.alias&&(g[a]=o.alias),o.type==="string"||o.type==="string[]"?(v.push(a),o.deprecates&&v.push(...o.deprecates)):o.type==="boolean"&&(R.push(a),o.deprecates&&R.push(...o.deprecates)),o.global&&(n[a]=o))}if(r&&f){const a=n;for(const y in r.options)a[y]=r.options[y];const o=C.filter(y=>y!==f),h=u.getSubcommandReporter?u.getSubcommandReporter(f):void 0,b=D(o,a,h);return{[f]:b,_:[]}}const t=L(C,{string:v,boolean:R,alias:g}),i={},s=t;i._=t._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in c){const o=c[a];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let h=s[a];if(o.deprecates)for(const b of o.deprecates)s.hasOwnProperty(b)&&(h||(h=s[b],h&&u.onDeprecatedOption(b,o.deprecationMessage||(0,l.localize)(36,null,a))),delete s[b]);if(typeof h<"u"){if(o.type==="string[]"){if(Array.isArray(h)||(h=[h]),!o.allowEmptyValue){const b=h.filter(y=>y.length>0);b.length!==h.length&&(u.onEmptyValue(a),h=b.length>0?b:void 0)}}else o.type==="string"&&(Array.isArray(h)?(h=h.pop(),u.onMultipleValues(a,h)):!h&&!o.allowEmptyValue&&(u.onEmptyValue(a),h=void 0));i[a]=h,o.deprecationMessage&&u.onDeprecatedOption(a,o.deprecationMessage)}delete s[a]}for(const a in s)u.onUnknownOption(a);return i}e.parseArgs=D;function I(C,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${C}${u}`:`--${C}${u}`}function w(C,c){const u=[];for(const f in C){const g=C[f],v=I(f,g);u.push([v,g.description])}return P(u,c)}e.formatOptions=w;function P(C,c){const f=C.reduce((R,n)=>Math.max(R,n[0].length),12)+2+1;if(c-f<25)return C.reduce((R,n)=>R.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=c-f-1,v=[];for(const R of C){const n=R[0],r=p(R[1],g),t=S(f-n.length-2);v.push("  "+n+t+r[0]);for(let i=1;i<r.length;i++)v.push(S(f)+r[i])}return v}function S(C){return" ".repeat(C)}function p(C,c){const u=[];for(;C.length;){const f=C.length<c?C.length:C.lastIndexOf(" ",c),g=C.slice(0,f).trim();C=C.slice(f),u.push(g)}return u}function d(C,c,u,f,g){const v=process.stdout.isTTY&&process.stdout.columns||80,R=g?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",n=[`${C} ${u}`];n.push(""),n.push(`${(0,l.localize)(38,null)}: ${c} [${(0,l.localize)(39,null)}]${R}`),n.push(""),g?.noPipe!==!0&&(U.isWindows?n.push((0,l.localize)(40,null,c)):n.push((0,l.localize)(41,null,c)),n.push(""));const r={},t=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&t.push({command:i,description:s.description});else if(s.description&&s.cat){let a=r[s.cat];a||(r[s.cat]=a={}),a[i]=s}}for(const i in r){const s=i,a=r[s];a&&(n.push(A[s]),n.push(...w(a,v)),n.push(""))}return t.length&&(n.push((0,l.localize)(42,null)),n.push(...P(t.map(i=>[i.command,i.description]),v)),n.push("")),n.join(`
`)}e.buildHelpMessage=d;function m(C,c){return`${C||(0,l.localize)(43,null)}
${c||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(re[194],oe([0,1,293,159,193]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function O(p,d){const m=(v,R)=>{console.warn((0,U.localize)(0,null,v,R))},C=v=>{console.warn((0,U.localize)(1,null,v))},c=(v,R)=>{console.warn((0,U.localize)(2,null,v,R))},u=v=>({onUnknownOption:R=>{v!=="tunnel"&&console.warn((0,U.localize)(3,null,R,v))},onMultipleValues:m,onEmptyValue:C,onDeprecatedOption:c,getSubcommandReporter:v!=="tunnel"?u:void 0}),f={onUnknownOption:v=>{console.warn((0,U.localize)(4,null,v))},onMultipleValues:m,onEmptyValue:C,onDeprecatedOption:c,getSubcommandReporter:u},g=(0,l.parseArgs)(p,l.OPTIONS,d?f:void 0);return g.goto&&g._.forEach(v=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,U.localize)(5,null))),g["max-memory"]&&L(parseInt(g["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),g}function D(p){const d=p.findIndex(m=>!/^-/.test(m));if(d>-1)return[...p.slice(0,d),...p.slice(d+1)]}function I(p){let[,...d]=p;process.env.VSCODE_DEV&&(d=D(d)||[]);const m=!S(process.env);return O(d,m)}e.parseMainProcessArgv=I;function w(p){let[,,...d]=p;return process.env.VSCODE_DEV&&(d=D(d)||[]),O(d,!0)}e.parseCLIProcessArgv=w;function P(p,...d){const m=p.indexOf("--");return m===-1?p.push(...d):p.splice(m,0,...d),p}e.addArg=P;function S(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function te(e,L,U){function l(O,D){const I=A(O,D),w=[I];return e.isAbsolute(I)||w.unshift(U),e.resolve(...w)}function A(O,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,D);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(S,"AppData","Roaming")}break;case"darwin":w=e.join(L.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,D)}return{getUserDataPath:l}}if(typeof define=="function")define(re[195],oe([294,34,36]),function(e,L,U){return te(e,L,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=te(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[97],oe([0,1,34,192,195]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends U.AbstractNativeEnvironmentService{constructor(w,P){super(w,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,l.getUserDataPath)(w,P.nameShort)},P)}}e.NativeEnvironmentService=A;function O(I,w){return(0,U.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,w,I.extensionEnvironment)}e.parsePtyHostDebugPort=O;function D(I,w){return(0,U.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,w,I.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(re[196],oe([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const U=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,D=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(c){const u=c.match(O);return u?u[1]:null}function P(c){if(c.indexOf("://")===-1){const u=c.match(U);return u?w(u[2]):null}try{const u=L.URI.parse(c);if(u.authority)return w(u.authority)}catch{}return null}function S(c,u){const f=new Set;let g;for(;g=D.exec(c);){const R=P(g[1]);R&&f.add(R)}const v=new Set(u);return Array.from(f).map(R=>v.has(R)?R:R.replace(I,"a"))}e.getDomainsOfRemotes=S;function p(c){const u=c.match(A);return u?u[2]:null}function d(c,u,f){return c&&u?(f&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${c}${u}`:`${c}/${u}`):null}function m(c,u){if(c.indexOf("://")===-1){const f=c.match(l);if(f)return d(f[2],f[3],u)}try{const f=L.URI.parse(c);if(f.authority)return d(p(f.authority),f.path,u)}catch{}return null}function C(c,u=!1){const f=[];let g;for(;g=D.exec(c);){const v=m(g[1],u);v&&f.push(v)}return f}e.getRemotes=C}),define(re[197],oe([0,1,12,162]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(O,D,I){try{A(O,D,I)}catch(w){console.error(w?.message??w)}return O}e.localizeManifest=l;function A(O,D,I){const w=(P,S,p)=>{const d=P[S];if((0,L.isString)(d)){const m=d,C=m.length;if(C>1&&m[0]==="%"&&m[C-1]==="%"){const c=m.substr(1,C-2);let u=D[c];u===void 0&&I&&(u=I[c]);const f=typeof u=="string"?u:u?.message,g=I?.[c],v=typeof g=="string"?g:g?.message;if(!f){v||console.warn(`[${O.name}]: ${(0,U.localize)(0,null,c)}`);return}if(p&&(S==="title"||S==="category")&&v&&v!==f){const R={value:f,original:v};P[S]=R}else P[S]=f}}else if((0,L.isObject)(d))for(const m in d)d.hasOwnProperty(m)&&(m==="commands"?w(d,m,!0):w(d,m,p));else if(Array.isArray(d))for(let m=0;m<d.length;m++)w(d,m,p)};for(const P in O)O.hasOwnProperty(P)&&w(O,P)}}),define(re[198],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,D,I){return this.a.call("promptImportantExtensionsInstallNotification",[A,O,D,I])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class U{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,D){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(re[67],oe([0,1,23,90,167,55]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||O.test(u)}e.isValidVersionStr=I;function w(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=w;function P(u){if(!u)return null;const f=u.majorBase,g=u.majorMustEqual,v=u.minorBase;let R=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(f===0||(R=!1),r=!1);let t=0;if(u.preRelease){const i=D.exec(u.preRelease);if(i){const[,s,a,o]=i;t=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:f,majorMustEqual:g,minorBase:v,minorMustEqual:R,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function S(u,f,g){let v;typeof u=="string"?v=P(w(u)):v=u;let R;f instanceof Date?R=f.getTime():typeof f=="string"&&(R=new Date(f).getTime());let n;if(typeof g=="string"?n=P(w(g)):n=g,!v||!n)return!1;const r=v.majorBase,t=v.minorBase,i=v.patchBase;let s=n.majorBase,a=n.minorBase,o=n.patchBase;const h=n.notBefore;let b=n.majorMustEqual,y=n.minorMustEqual,k=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>a?!0:t<a||R&&R<h?!1:i>=o:(r===1&&s===0&&(!b||!y||!k)&&(s=1,a=0,o=0,b=!0,y=!1,k=!1),r<s?!1:r>s?!b:t<a?!1:t>a?!y:i<o?!1:i>o?!k:!(R&&R<h))}e.isValidVersion=S;function p(u,f,g,v,R){const n=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return n.push([U.default.Error,l.localize(0,null)]),n;if(typeof v.name!="string")return n.push([U.default.Error,l.localize(1,null,"name")]),n;if(typeof v.version!="string")return n.push([U.default.Error,l.localize(2,null,"version")]),n;if(!v.engines)return n.push([U.default.Error,l.localize(3,null,"engines")]),n;if(typeof v.engines.vscode!="string")return n.push([U.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof v.extensionDependencies<"u"&&!c(v.extensionDependencies))return n.push([U.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof v.activationEvents<"u"){if(!c(v.activationEvents))return n.push([U.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof v.main>"u"&&typeof v.browser>"u")return n.push([U.default.Error,l.localize(7,null,"activationEvents","main")]),n}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&n.push([U.default.Warning,l.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return n.push([U.default.Error,l.localize(9,null,"main")]),n;{const i=(0,L.joinPath)(g,v.main);(0,L.isEqualOrParent)(i,g)||n.push([U.default.Warning,l.localize(10,null,i.path,g.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(11,null,"activationEvents","main")]),n}if(typeof v.browser<"u"){if(typeof v.browser!="string")return n.push([U.default.Error,l.localize(12,null,"browser")]),n;{const i=(0,L.joinPath)(g,v.browser);(0,L.isEqualOrParent)(i,g)||n.push([U.default.Warning,l.localize(13,null,i.path,g.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(v.version))return n.push([U.default.Error,l.localize(15,null)]),n;const r=[];if(!d(u,f,v,R,r))for(const i of r)n.push([U.default.Error,i]);return n}e.validateExtensionManifest=p;function d(u,f,g,v,R){return v||typeof g.main>"u"&&typeof g.browser>"u"?!0:C(u,f,g.engines.vscode,R)}e.isValidExtensionVersion=d;function m(u,f,g){return u==="*"||C(f,g,u)}e.isEngineValid=m;function C(u,f,g,v=[]){const R=P(w(g));if(!R)return v.push(l.localize(16,null,g)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return v.push(l.localize(17,null,g)),!1}else if(!R.majorMustEqual)return v.push(l.localize(18,null,g)),!1;return S(u,f,R)?!0:(v.push(l.localize(19,null,u,g)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let f=0,g=u.length;f<g;f++)if(typeof u[f]!="string")return!1;return!0}}),define(re[44],oe([0,1,16,31]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(A,O,D){let I=D&&D.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await O.readFile(A.serviceMachineIdResource)).value.toString();I=(0,U.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,U.generateUuid)();try{await O.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(I))}catch{}}return D?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(l,A=[],O=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=L}),define(re[199],oe([0,1,68]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var l;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function A(D,I,w){I instanceof L.SyncDescriptor||(I=new L.SyncDescriptor(I,[],Boolean(w))),U.push([D,I])}e.registerSingleton=A;function O(){return U}e.getSingletonServiceDescriptors=O}),define(re[200],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class U{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const D=this.lookupOrInsertNode(A),I=this.lookupOrInsertNode(O);D.outgoing.set(I.key,I),I.incoming.set(D.key,D)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const D of this.a.values())D.outgoing.delete(O),D.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let D=this.a.get(O);return D||(D=new L(O,A),this.a.set(O,D)),D}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,D]of this.a)A.push(`${O}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const D=new Set([A]),I=this.c(O,D);if(I)return I}}c(A,O){for(const[D,I]of A.outgoing){if(O.has(D))return[...O,D].join(" -> ");O.add(D);const w=this.c(I,O);if(w)return w;O.delete(D)}}}e.Graph=U}),define(re[5],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=D})(L=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function U(O,D,I){D[L.DI_TARGET]===D?D[L.DI_DEPENDENCIES].push({id:O,index:I}):(D[L.DI_DEPENDENCIES]=[{id:O,index:I}],D[L.DI_TARGET]=D)}function l(O){if(L.serviceIds.has(O))return L.serviceIds.get(O);const D=function(I,w,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(D,I,P)};return D.toString=()=>O,L.serviceIds.set(O,D),D}e.createDecorator=l;function A(O){return O}e.refineServiceDecorator=A}),define(re[201],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(re[17],oe([0,1,12,11,5]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof U.URI)}e.isConfigurationOverrides=A;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=O;var D;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function w(c,u){const f=Object.create(null);for(const g in c)P(f,g,c[g],u);return f}e.toValuesTree=w;function P(c,u,f,g){const v=u.split("."),R=v.pop();let n=c;for(let r=0;r<v.length;r++){const t=v[r];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:g(`Ignoring ${u} as ${v.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[R]=f}catch{g(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function S(c,u){const f=u.split(".");p(c,f)}e.removeFromValueTree=S;function p(c,u){const f=u.shift();if(u.length===0){delete c[f];return}if(Object.keys(c).indexOf(f)!==-1){const g=c[f];typeof g=="object"&&!Array.isArray(g)&&(p(g,u),Object.keys(g).length===0&&delete c[f])}}function d(c,u,f){function g(n,r){let t=n;for(const i of r){if(typeof t!="object"||t===null)return;t=t[i]}return t}const v=u.split("."),R=g(c,v);return typeof R>"u"?f:R}e.getConfigurationValue=d;function m(c,u,f){Object.keys(u).forEach(g=>{g!=="__proto__"&&(g in c?L.isObject(c[g])&&L.isObject(u[g])?m(c[g],u[g],f):f&&(c[g]=u[g]):c[g]=u[g])})}e.merge=m;function C(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(re[69],oe([0,1,4,27,191,5,156]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",L.isMacintosh),D.set("isLinux",L.isLinux),D.set("isWindows",L.isWindows),D.set("isWeb",L.isWeb),D.set("isMacNative",L.isMacintosh&&!L.isWeb),D.set("isEdge",L.isEdge),D.set("isFirefox",L.isFirefox),D.set("isChrome",L.isChrome),D.set("isSafari",L.isSafari);const I=Object.prototype.hasOwnProperty;var w;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return s.INSTANCE}static true(){return a.INSTANCE}static has(E){return o.create(E)}static equals(E,N){return h.create(E,N)}static notEquals(E,N){return k.create(E,N)}static regex(E,N){return Q.create(E,N)}static in(E,N){return b.create(E,N)}static notIn(E,N){return y.create(E,N)}static not(E){return T.create(E)}static and(...E){return Z.create(E,null,!0)}static or(...E){return H.create(E,null,!0)}static greater(E,N){return j.create(E,N)}static greaterEquals(E,N){return B.create(E,N)}static smaller(E,N){return V.create(E,N)}static smallerEquals(E,N){return W.create(E,N)}static deserialize(E){if(!!E)return this.c(E)}static c(E){const N=E.split("||");return H.create(N.map(z=>this.d(z)),null,!0)}static d(E){const N=E.split("&&");return Z.create(N.map(z=>this.f(z)),null,!0)}static f(E){if(E=E.trim(),E.indexOf("!=")>=0){const N=E.split("!=");return k.create(N[0].trim(),this.g(N[1]))}if(E.indexOf("==")>=0){const N=E.split("==");return h.create(N[0].trim(),this.g(N[1]))}if(E.indexOf("=~")>=0){const N=E.split("=~");return Q.create(N[0].trim(),this.h(N[1]))}if(E.indexOf(" not in ")>=0){const N=E.split(" not in ");return y.create(N[0].trim(),this.g(N[1]))}if(E.indexOf(" in ")>=0){const N=E.split(" in ");return b.create(N[0].trim(),this.g(N[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const N=E.split(">=");return B.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const N=E.split(">");return j.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const N=E.split("<=");return W.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const N=E.split("<");return V.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(E)?T.create(E.substr(1).trim()):o.create(E)}static g(E){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;const N=/^'([^']*)'$/.exec(E);return N?N[1].trim():E}static h(E){if((0,U.isFalsyOrWhitespace)(E))return null;const N=E.indexOf("/"),z=E.lastIndexOf("/");if(N===z||N<0)return null;const G=E.slice(N+1,z),q=E[z+1]==="i"?"i":"";try{return new RegExp(G,q)}catch{return null}}}e.ContextKeyExpr=P;const S={regexParsingWithErrorRecovery:!0};class p extends Error{}const d=(0,O.localize)(0,null),m=(0,O.localize)(1,null),C=(0,O.localize)(2,null),c=(0,O.localize)(3,null),u=(0,O.localize)(4,null),f=(0,O.localize)(5,null),g=(0,O.localize)(6,null),v=(0,O.localize)(7,null),R=(0,O.localize)(8,null);class n{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(E=S){this.h=E,this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}parse(E){if(E===""){this.g.push({message:d,offset:0,lexeme:"",additionalInfo:m});return}this.d=this.c.reset(E).scan(),this.f=0,this.g=[];try{const N=this.k();if(!this.C()){const z=this.B(),G=z.type===17?g:void 0;throw this.g.push({message:f,offset:z.offset,lexeme:l.Scanner.getLexeme(z),additionalInfo:G}),new p}return N}catch(N){if(!(N instanceof p))throw N;return}}k(){return this.l()}l(){const E=[this.o()];for(;this.w(16);){const N=this.o();E.push(N)}return E.length===1?E[0]:P.or(...E)}o(){const E=[this.s()];for(;this.w(15);){const N=this.s();E.push(N)}return E.length===1?E[0]:P.and(...E)}s(){if(this.w(2)){const E=this.B();switch(E.type){case 17:return this.x(),P.not(E.lexeme);case 11:return this.x(),P.false();case 12:return this.x(),P.true();default:throw this.z("CONTEXT | true | false",E,C)}}return this.t()}t(){const E=this.B();switch(E.type){case 11:return this.x(),P.true();case 12:return this.x(),P.false();case 0:{this.x();const N=this.k();return this.y(1,u),N}case 17:{const N=E.lexeme;if(this.x(),this.w(9)){const G=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),G.type!==10)throw this.z("REGEX",G);const q=G.lexeme,J=q.lastIndexOf("/"),ee=J===q.length-1?void 0:q.substring(J+1);let ce;try{ce=new RegExp(q.substring(1,J),ee)}catch{throw this.z("REGEX",G)}return Q.create(N,ce)}switch(G.type){case 10:case 19:{const q=[G.lexeme];this.x();let J=this.B(),ee=0;for(let we=0;we<G.lexeme.length;we++)G.lexeme.charCodeAt(we)===40?ee++:G.lexeme.charCodeAt(we)===41&&ee--;for(;!this.C()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let we=0;we<J.lexeme.length;we++)J.lexeme.charCodeAt(we)===40?ee++:G.lexeme.charCodeAt(we)===41&&ee--}if(ee<0)break;q.push(l.Scanner.getLexeme(J)),this.x(),J=this.B()}const ce=q.join(""),he=ce.lastIndexOf("/"),me=he===ce.length-1?void 0:ce.substring(he+1);let de;try{de=new RegExp(ce.substring(1,he),me)}catch{throw this.z("REGEX",G)}return P.regex(N,de)}case 18:{const q=G.lexeme;this.x();let J=null;if(!(0,U.isFalsyOrWhitespace)(q)){const ee=q.indexOf("/"),ce=q.lastIndexOf("/");if(ee!==ce&&ee>=0){const he=q.slice(ee+1,ce),me=q[ce+1]==="i"?"i":"";try{J=new RegExp(he,me)}catch{throw this.z("REGEX",G)}}}if(J===null)throw this.z("REGEX",G);return Q.create(N,J)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,c);const G=this.u();return P.notIn(N,G)}switch(this.B().type){case 3:{this.x();const G=this.u();if(this.v().type===18)return P.equals(N,G);switch(G){case"true":return P.has(N);case"false":return P.not(N);default:return P.equals(N,G)}}case 4:{this.x();const G=this.u();if(this.v().type===18)return P.notEquals(N,G);switch(G){case"true":return P.not(N);case"false":return P.has(N);default:return P.notEquals(N,G)}}case 5:return this.x(),V.create(N,this.u());case 6:return this.x(),W.create(N,this.u());case 7:return this.x(),j.create(N,this.u());case 8:return this.x(),B.create(N,this.u());case 13:return this.x(),P.in(N,this.u());default:return P.has(N)}}case 20:throw this.g.push({message:v,offset:E.offset,lexeme:"",additionalInfo:R}),new p;default:throw this.z(`true | false | CONTEXT 
	| CONTEXT '=~' REGEX 
	| CONTEXT ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const E=this.B();switch(E.type){case 17:case 18:return this.x(),E.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(E){return this.A(E)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(E,N){if(this.A(E))return this.x();throw this.z(N,this.B())}z(E,N,z){const G=(0,O.localize)(9,null,E,l.Scanner.getLexeme(N)),q=N.offset,J=l.Scanner.getLexeme(N);return this.g.push({message:G,offset:q,lexeme:J,additionalInfo:z}),new p}A(E){return this.B().type===E}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=n;function r(M){const E=new n({regexParsingWithErrorRecovery:!1});return M.map(N=>(E.parse(N),E.lexingErrors.length>0?E.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(10,null,z.additionalInfo):(0,O.localize)(11,null),offset:z.offset,length:z.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=r;function t(M,E){const N=M?M.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!N&&!z?!0:!N||!z?!1:N.equals(z)}e.expressionsAreEqualWithConstantSubstitution=t;function i(M,E){return M.cmp(E)}class s{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return a.INSTANCE}}s.INSTANCE=new s,e.ContextKeyFalseExpr=s;class a{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return s.INSTANCE}}a.INSTANCE=new a,e.ContextKeyTrueExpr=a;class o{static create(E,N=null){const z=D.get(E);return typeof z=="boolean"?z?a.INSTANCE:s.INSTANCE:new o(E,N)}constructor(E,N){this.key=E,this.c=N,this.type=2}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=D.get(this.key);return typeof E=="boolean"?E?a.INSTANCE:s.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=o;class h{static create(E,N,z=null){if(typeof N=="boolean")return N?o.create(E,z):T.create(E,z);const G=D.get(E);return typeof G=="boolean"?N===(G?"true":"false")?a.INSTANCE:s.INSTANCE:new h(E,N,z)}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=4}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=D.get(this.c);if(typeof E=="boolean"){const N=E?"true":"false";return this.d===N?a.INSTANCE:s.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class b{static create(E,N){return new b(E,N)}constructor(E,N){this.d=E,this.f=N,this.type=10,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const N=E.getValue(this.f),z=E.getValue(this.d);return Array.isArray(N)?N.includes(z):typeof z=="string"&&typeof N=="object"&&N!==null?I.call(N,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=b;class y{static create(E,N){return new y(E,N)}constructor(E,N){this.d=E,this.f=N,this.type=11,this.c=b.create(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=y;class k{static create(E,N,z=null){if(typeof N=="boolean")return N?T.create(E,z):o.create(E,z);const G=D.get(E);return typeof G=="boolean"?N===(G?"true":"false")?s.INSTANCE:a.INSTANCE:new k(E,N,z)}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=5}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=D.get(this.c);if(typeof E=="boolean"){const N=E?"true":"false";return this.d===N?s.INSTANCE:a.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=k;class T{static create(E,N=null){const z=D.get(E);return typeof z=="boolean"?z?s.INSTANCE:a.INSTANCE:new T(E,N)}constructor(E,N){this.c=E,this.d=N,this.type=3}cmp(E){return E.type!==this.type?this.type-E.type:_(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=D.get(this.c);return typeof E=="boolean"?E?s.INSTANCE:a.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.ContextKeyNotExpr=T;function F(M,E){if(typeof M=="string"){const N=parseFloat(M);isNaN(N)||(M=N)}return typeof M=="string"||typeof M=="number"?E(M):s.INSTANCE}class j{static create(E,N,z=null){return F(N,G=>new j(E,G,z))}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=12}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=j;class B{static create(E,N,z=null){return F(N,G=>new B(E,G,z))}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=13}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=B;class V{static create(E,N,z=null){return F(N,G=>new V(E,G,z))}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=14}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=V;class W{static create(E,N,z=null){return F(N,G=>new W(E,G,z))}constructor(E,N,z){this.c=E,this.d=N,this.f=z,this.type=15}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=W;class Q{static create(E,N){return new Q(E,N)}constructor(E,N){this.d=E,this.f=N,this.type=7,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const N=this.f?this.f.source:"",z=E.f?E.f.source:"";return N<z?-1:N>z?1:0}equals(E){if(E.type===this.type){const N=this.f?this.f.source:"",z=E.f?E.f.source:"";return this.d===E.d&&N===z}return!1}substituteConstants(){return this}evaluate(E){const N=E.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.ContextKeyRegexExpr=Q;class X{static create(E){return new X(E)}constructor(E){this.c=E,this.type=8}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(E){return new X(this.c.map(E))}negate(){return this.c}}e.ContextKeyNotRegexExpr=X;function Y(M){let E=null;for(let N=0,z=M.length;N<z;N++){const G=M[N].substituteConstants();if(M[N]!==G&&E===null){E=[];for(let q=0;q<N;q++)E[q]=M[q]}E!==null&&(E[N]=G)}return E===null?M:E}class Z{static create(E,N,z){return Z.d(E,N,z)}constructor(E,N){this.expr=E,this.c=N,this.type=6}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const G=i(this.expr[N],E.expr[N]);if(G!==0)return G}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=Y(this.expr);return E===this.expr?this:Z.create(E,this.c,!1)}evaluate(E){for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].evaluate(E))return!1;return!0}static d(E,N,z){const G=[];let q=!1;for(const J of E)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return s.INSTANCE;if(J.type===6){G.push(...J.expr);continue}G.push(J)}if(G.length===0&&q)return a.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(i);for(let J=1;J<G.length;J++)G[J-1].equals(G[J])&&(G.splice(J,1),J--);if(G.length===1)return G[0];for(;G.length>1;){const J=G[G.length-1];if(J.type!==9)break;G.pop();const ee=G.pop(),ce=G.length===0,he=H.create(J.expr.map(me=>Z.create([me,ee],null,z)),null,ce);he&&(G.push(he),G.sort(i))}if(G.length===1)return G[0];if(z){for(let J=0;J<G.length;J++)for(let ee=J+1;ee<G.length;ee++)if(G[J].negate().equals(G[ee]))return s.INSTANCE;if(G.length===1)return G[0]}return new Z(G,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const N of this.expr)E.push(...N.keys());return E}map(E){return new Z(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.c){const E=[];for(const N of this.expr)E.push(N.negate());this.c=H.create(E,this,!0)}return this.c}}class H{static create(E,N,z){return H.d(E,N,z)}constructor(E,N){this.expr=E,this.c=N,this.type=9}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const G=i(this.expr[N],E.expr[N]);if(G!==0)return G}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=Y(this.expr);return E===this.expr?this:H.create(E,this.c,!1)}evaluate(E){for(let N=0,z=this.expr.length;N<z;N++)if(this.expr[N].evaluate(E))return!0;return!1}static d(E,N,z){let G=[],q=!1;if(E){for(let J=0,ee=E.length;J<ee;J++){const ce=E[J];if(!!ce){if(ce.type===0){q=!0;continue}if(ce.type===1)return a.INSTANCE;if(ce.type===9){G=G.concat(ce.expr);continue}G.push(ce)}}if(G.length===0&&q)return s.INSTANCE;G.sort(i)}if(G.length!==0){if(G.length===1)return G[0];for(let J=1;J<G.length;J++)G[J-1].equals(G[J])&&(G.splice(J,1),J--);if(G.length===1)return G[0];if(z){for(let J=0;J<G.length;J++)for(let ee=J+1;ee<G.length;ee++)if(G[J].negate().equals(G[ee]))return a.INSTANCE;if(G.length===1)return G[0]}return new H(G,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const N of this.expr)E.push(...N.keys());return E}map(E){return new H(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.c){const E=[];for(const N of this.expr)E.push(N.negate());for(;E.length>1;){const N=E.shift(),z=E.shift(),G=[];for(const q of x(N))for(const J of x(z))G.push(Z.create([q,J],null,!1));E.unshift(H.create(G,null,!1))}this.c=H.create(E,this,!0)}return this.c}}class $ extends o{static all(){return $.d.values()}constructor(E,N,z){super(E,null),this.f=N,typeof z=="object"?$.d.push({...z,key:E}):z!==!0&&$.d.push({key:E,description:z,type:N!=null?typeof N:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return h.create(this.key,E)}notEqualsTo(E){return k.create(this.key,E)}}$.d=[],e.RawContextKey=$,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function _(M,E){return M<E?-1:M>E?1:0}function ie(M,E,N,z){return M<N?-1:M>N?1:E<z?-1:E>z?1:0}function se(M,E){if(M.type===0||E.type===1)return!0;if(M.type===9)return E.type===9?ae(M.expr,E.expr):!1;if(E.type===9){for(const N of E.expr)if(se(M,N))return!0;return!1}if(M.type===6){if(E.type===6)return ae(E.expr,M.expr);for(const N of M.expr)if(se(N,E))return!0;return!1}return M.equals(E)}e.implies=se;function ae(M,E){let N=0,z=0;for(;N<M.length&&z<E.length;){const G=M[N].cmp(E[z]);if(G<0)return!1;G===0&&N++,z++}return N===M.length}function x(M){return M.type===9?M.expr:[M]}}),define(re[98],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function U(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=U;class l{async getPerformanceInfo(O,D){return{}}async getSystemInfo(O,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,D){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=l}),define(re[99],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(re[15],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],oe([0,1,161,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function O(u,f){switch(u){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function D(u,f){return f==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function I(u,f,g){return D(f,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:w(g).includes(u)}e.isTargetPlatformCompatible=I;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var C;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(C=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(f,g){super(f),this.code=g,this.name=g}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(re[202],oe([0,1,3,2,32,11,93,29]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(c,u){return c?A.URI.revive(u?u.transformIncoming(c):c):void 0}function w(c,u){return u?u.transformOutgoingURI(c):c}function P(c,u){u=u||O.DefaultURITransformer;const f=c.manifest;return{...(0,O.transformAndReviveIncomingURIs)({...c,manifest:void 0},u),manifest:f}}function S(c,u){return c?.profileLocation?(0,O.transformAndReviveIncomingURIs)(c,u??O.DefaultURITransformer):c}function p(c,u){return u?(0,l.cloneAndChange)(c,f=>f instanceof A.URI?u.transformOutgoingURI(f):void 0):c}class d{constructor(u,f){this.a=u,this.b=f,this.onInstallExtension=L.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,f){const g=this.b(u);switch(f){case"onInstallExtension":return L.Event.map(this.onInstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,v=>v.map(R=>({...R,local:R.local?p(R.local,g):R.local,profileLocation:R.profileLocation?w(R.profileLocation,g):R.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,v=>p(v,g))}throw new Error("Invalid listen")}async call(u,f,g){const v=this.b(u);switch(f){case"zip":{const R=P(g[0],v),n=await this.a.zip(R);return w(n,v)}case"unzip":return this.a.unzip(I(g[0],v));case"install":return this.a.install(I(g[0],v),S(g[1],v));case"installFromLocation":return this.a.installFromLocation(I(g[0],v),I(g[1],v));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],I(g[1],v),I(g[2],v));case"getManifest":return this.a.getManifest(I(g[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],S(g[1],v));case"uninstall":return this.a.uninstall(P(g[0],v),S(g[1],v));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(g[0],v));case"getInstalled":return(await this.a.getInstalled(g[0],I(g[1],v))).map(n=>p(n,v));case"copyExtensions":return this.a.copyExtensions(I(g[0],v),I(g[1],v));case"updateMetadata":{const R=await this.a.updateMetadata(P(g[0],v),g[1],I(g[2],v));return p(R,v)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class m extends U.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.D(new L.Emitter),this.f=this.D(new L.Emitter),this.g=this.D(new L.Emitter),this.h=this.D(new L.Emitter),this.j=this.D(new L.Emitter),this.D(this.k.listen("onInstallExtension")(f=>this.l(this.c,{...f,source:this.m(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.D(this.k.listen("onDidInstallExtensions")(f=>this.l(this.f,f.map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.m(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))))),this.D(this.k.listen("onUninstallExtension")(f=>this.l(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.D(this.k.listen("onDidUninstallExtension")(f=>this.l(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.D(this.k.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(P(f,null))))}l(u,f){u.fire(f)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const f=await this.getTargetPlatform();return u.allTargetPlatforms.some(g=>(0,D.isTargetPlatformCompatible)(g,u.allTargetPlatforms,f))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(f=>A.URI.revive(f)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,f){return Promise.resolve(this.k.call("install",[u,f])).then(g=>P(g,null))}installFromLocation(u,f){return Promise.resolve(this.k.call("installFromLocation",[u,f])).then(g=>P(g,null))}async installExtensionsFromProfile(u,f,g){return(await this.k.call("installExtensionsFromProfile",[u,f,g])).map(R=>P(R,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,f){return Promise.resolve(this.k.call("installFromGallery",[u,f])).then(g=>P(g,null))}uninstall(u,f){return Promise.resolve(this.k.call("uninstall",[u,f]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(f=>P(f,null))}getInstalled(u=null,f){return Promise.resolve(this.k.call("getInstalled",[u,f])).then(g=>g.map(v=>P(v,null)))}updateMetadata(u,f,g){return Promise.resolve(this.k.call("updateMetadata",[u,f,g])).then(v=>P(v,null))}copyExtensions(u,f){return this.k.call("copyExtensions",[u,f])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,f){const g=await this.k.call("download",[u,f]);return A.URI.revive(g)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class C{constructor(u){this.a=u}listen(u,f){throw new Error("Invalid listen")}call(u,f,g){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(re[100],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class U{b(){return this.a||(this.a=new Promise((A,O)=>te(["node-vsce-sign"],async D=>A(D),O))),this.a}async verify(A,O,D){let I;try{I=await this.b()}catch{return!1}return I.verify(A,O,D)}}e.ExtensionSignatureVerificationService=U}),define(re[101],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(U=e.RecommendationSource||(e.RecommendationSource={}));function l(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],oe([0,1,49,13,27,12,11,169,5,4,22]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S($){return $.create===!0}e.isFileOpenForWriteOptions=S;var p;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var d;(function($){$[$.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var m;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C($){return!!($.capabilities&2)}e.hasReadWriteCapability=C;function c($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=c;function u($){return!!($.capabilities&32768)}e.hasFileCloneCapability=u;function f($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;function v($){return C($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var R;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(R=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(_,ie){const se=new n(_.toString(),ie);return i(se,ie),se}constructor(_,ie){super(_),this.code=ie}}e.FileSystemProviderError=n;function r($,_){return n.create($,_)}e.createFileSystemProviderError=r;function t($){return $||r((0,D.localize)(0,null),R.Unknown)}e.ensureFileSystemProviderError=t;function i($,_){return $.name=_?`${_} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function s($){if(!$)return R.Unknown;if($ instanceof n)return $.code;const _=/^(.+) \(FileSystemError\)$/.exec($.name);if(!_)return R.Unknown;switch(_[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileExceedsMemoryLimit:return R.FileExceedsMemoryLimit;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}e.toFileSystemProviderErrorCode=s;function a($){if($ instanceof T)return $.fileOperationResult;switch(s($)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 10;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileExceedsMemoryLimit:return 9;case R.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var o;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class h{constructor(_,ie,se){this.resource=_,this.operation=ie,this.target=se}isOperation(_){return this.operation===_}}e.FileOperationEvent=h;var b;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class y{constructor(_,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of _){const x=se.get(ae.type);switch(x?x.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,x]of se)switch(ae){case 1:this.a=L.TernarySearchTree.forUris(()=>ie),this.a.fill(x);break;case 0:this.b=L.TernarySearchTree.forUris(()=>ie),this.b.fill(x);break;case 2:this.c=L.TernarySearchTree.forUris(()=>ie),this.c.fill(x);break}}contains(_,...ie){return this.d(_,{includeChildren:!1},...ie)}affects(_,...ie){return this.d(_,{includeChildren:!0},...ie)}d(_,ie,...se){if(!_)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(_)||ie.includeChildren&&this.a?.findSuperstr(_))||(!ae||se.includes(0))&&(this.b?.get(_)||ie.includeChildren&&this.b?.findSuperstr(_))||(!ae||se.includes(2))&&(this.c?.findSubstr(_)||ie.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function k($,_,ie){return!$||!_||$===_||_.length>$.length?!1:(_.charAt(_.length-1)!==U.sep&&(_+=U.sep),ie?(0,l.startsWithIgnoreCase)($,_):$.indexOf(_)===0)}e.isParent=k;class T extends Error{constructor(_,ie,se){super(_),this.fileOperationResult=ie,this.options=se}}e.FileOperationError=T;class F extends T{constructor(_,ie,se,ae){super(_,ie,ae),this.fileOperationResult=ie,this.size=se}}e.TooLargeFileOperationError=F;class j extends T{constructor(_,ie,se){super(_,2,se),this.stat=ie}}e.NotModifiedSinceFileOperationError=j;var B;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(B=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=W;async function Q($,_){if(!_.hasProvider(O.URI.from({scheme:$.scheme})))return new Promise(ie=>{const se=_.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===$.scheme&&ae.added&&(se.dispose(),ie())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(_){return(0,A.isNumber)(_)||(_=0),_<X.KB?(0,D.localize)(1,null,_.toFixed(0)):_<X.MB?(0,D.localize)(2,null,(_/X.KB).toFixed(2)):_<X.GB?(0,D.localize)(3,null,(_/X.MB).toFixed(2)):_<X.TB?(0,D.localize)(4,null,(_/X.GB).toFixed(2)):(0,D.localize)(5,null,(_/X.TB).toFixed(2))}}X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB,e.ByteSize=X;var Y;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Z($){return{maxFileSize:$===0?300*X.MB:16*X.GB,maxHeapSize:$===0?700*X.MB:2*700*X.MB}}e.getPlatformFileLimits=Z;function H($){const _=typeof $=="string"||$?.scheme===P.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===P.Schemas.file?1024*X.MB:_?10*X.MB:w.isWeb?50*X.MB:1024*X.MB}e.getLargeFileConfirmationLimit=H});var K=this&&this.__param||function(te,e){return function(L,U){e(L,U,te)}};define(re[203],oe([0,1,102,43,14]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(D){this.a=D}async checksum(D){const I=(await this.a.readFileStream(D)).value;return new Promise((w,P)=>{const S=(0,L.createHash)("md5");(0,U.listenStream)(I,{onData:p=>S.update(p.buffer),onError:p=>P(p),onEnd:()=>w(S.digest("base64").replace(/=+$/,""))})})}};A=ye([K(0,l.IFileService)],A),e.ChecksumService=A}),define(re[204],oe([0,1,16,38,10,3,2,43,11,31,14]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends O.Disposable{constructor(d,m){super(),this.a=d,this.b=m,this.onDidChangeCapabilities=A.Event.None,this.f=this.D(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,m){const{buffer:C}=await this.a.call("readFile",[d,m]);return C}readFileStream(d,m,C){const c=(0,D.newWriteableStream)(f=>L.VSBuffer.concat(f.map(g=>L.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[d,m])(f=>{if(f instanceof L.VSBuffer)c.write(f.buffer);else{if(f==="end")c.end();else{let g;if(f instanceof Error)g=f;else{const v=f;g=(0,P.createFileSystemProviderError)(v.message??(0,U.toErrorMessage)(v),v.code??P.FileSystemProviderErrorCode.Unknown)}c.error(g),c.end()}u.dispose()}});return C.onCancellationRequested(()=>{c.error((0,l.canceled)()),c.end(),u.dispose()}),c}writeFile(d,m,C){return this.a.call("writeFile",[d,L.VSBuffer.wrap(m),C])}open(d,m){return this.a.call("open",[d,m])}close(d){return this.a.call("close",[d])}async read(d,m,C,c,u){const[f,g]=await this.a.call("read",[d,m,u]);return C.set(f.buffer.slice(0,g),c),g}write(d,m,C,c,u){return this.a.call("write",[d,m,L.VSBuffer.wrap(C),c,u])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,m){return this.a.call("delete",[d,m])}rename(d,m,C){return this.a.call("rename",[d,m,C])}copy(d,m,C){return this.a.call("copy",[d,m,C])}cloneFile(d,m){return this.a.call("cloneFile",[d,m])}i(){this.D(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const m=d;this.f.fire(m.map(C=>({resource:I.URI.revive(C.resource),type:C.type})))}else{const m=d;this.g.fire(m)}}))}watch(d,m){const C=(0,w.generateUuid)();return this.a.call("watch",[this.h,C,d,m]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,C]))}}e.DiskFileSystemProviderClient=S}),define(re[103],oe([0,1,16,10,170,14]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(P,S,p,d,m,C){let c;try{await D(P,S,p,d,m,C)}catch(u){c=u}finally{c&&m.errorTransformer&&(c=m.errorTransformer(c)),typeof c<"u"&&p.error(c),p.end()}}e.readFileIntoStream=O;async function D(P,S,p,d,m,C){I(C);const c=await P.open(S,{create:!1});try{I(C);let u=0,f=0,g=m&&typeof m.length=="number"?m.length:void 0,v=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),R=m&&typeof m.position=="number"?m.position:0,n=0;do f=await P.read(c,R,v.buffer,n,v.byteLength-n),R+=f,n+=f,u+=f,typeof g=="number"&&(g-=f),n===v.byteLength&&(await p.write(d(v)),v=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),n=0);while(f>0&&(typeof g!="number"||g>0)&&I(C)&&w(u,m));if(n>0){let r=n;typeof g=="number"&&(r=Math.min(n,g)),p.write(d(v.slice(0,r)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await P.close(c)}}function I(P){if(P.isCancellationRequested)throw(0,U.canceled)();return!0}function w(P,S){if(S?.limits){if(typeof S.limits.memory=="number"&&P>S.limits.memory)throw(0,A.createFileSystemProviderError)((0,l.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&P>S.limits.size)throw(0,A.createFileSystemProviderError)((0,l.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],oe([0,1,92,2,13,4,11,14]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class w extends U.Disposable{constructor(f,g,v,R){super(),this.h=f,this.i=g,this.j=v,this.k=R,this.c=this.D(new U.MutableDisposable),this.f=void 0,this.g=0}m(){const f=new U.DisposableStore;this.c.value=f,this.b=this.l(f),this.b.setVerboseLogging(this.j),f.add(this.b.onDidChangeFile(g=>this.h(g))),f.add(this.b.onDidLogMessage(g=>this.i(g))),f.add(this.b.onDidError(g=>this.n(g)))}n(f){this.k.restartOnError?this.g<w.a&&this.f?(this.q(`restarting watcher after error: ${f}`),this.p(this.f)):this.q(`gave up attempting to restart watcher after error: ${f}`):this.q(f)}p(f){this.g++,this.m(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.j=f,await this.b?.setVerboseLogging(f)}q(f){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${f}`})}r(f){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}w.a=5,e.AbstractWatcherClient=w;class P extends w{constructor(f,g,v){super(f,g,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class S extends w{constructor(f,g,v){super(f,g,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function p(u){return u.map(f=>({type:f.type,resource:O.URI.file(f.path)}))}e.toFileChanges=p;function d(u){const f=new c;for(const g of u)f.processEvent(g);return f.coalesce()}e.coalesceEvents=d;function m(u,f){return typeof f=="string"&&!f.startsWith(L.GLOBSTAR)&&!(0,l.isAbsolute)(f)?{base:u,pattern:f}:f}e.normalizeWatcherPattern=m;function C(u,f){const g=[];for(const v of f)g.push((0,L.parse)(m(u,v)));return g}e.parseWatcherPatterns=C;class c{constructor(){this.a=new Set,this.b=new Map}c(f){return A.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const g=this.b.get(this.c(f));let v=!1;if(g){const R=g.type,n=f.type;g.path!==f.path&&(f.type===2||f.type===1)?v=!0:R===1&&n===2?(this.b.delete(this.c(f)),this.a.delete(g)):R===2&&n===1?g.type=0:R===1&&n===0||(g.type=n)}else v=!0;v&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],g=[];return Array.from(this.a).filter(v=>v.type!==2?(f.push(v),!1):!0).sort((v,R)=>v.path.length-R.path.length).filter(v=>g.some(R=>(0,D.isParent)(v.path,R,!A.isLinux))?!1:(g.push(v.path),!0)).concat(f)}}}),define(re[205],oe([0,1,54,6,25,48,2,85,13,4,146,28,56]),function(te,e,L,U,l,A,O,D,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends O.Disposable{constructor(c,u,f,g){super(),this.j=c,this.k=u,this.l=f,this.m=g,this.c=this.D(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.D(new U.RunOnceWorker(v=>this.t(v),d.b)),this.g=(0,p.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.q(this.j);if(this.i.token.isCancellationRequested)return;const u=await S.Promises.stat(c);this.D(await this.r(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.v(c):this.y(c)}}async q(c){let u=c.path;try{u=await S.Promises.realpath(c.path),c.path===u&&(u=await(0,P.realcase)(c.path)??c.path),c.path!==u&&this.y(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async r(c,u){if(w.isMacintosh&&(0,A.isEqualOrParent)(c,"/Volumes/",!0))return this.v(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const f=new l.CancellationTokenSource(this.i.token),g=new O.DisposableStore;try{const v=(0,I.basename)(c),R=(0,L.watch)(c);g.add((0,O.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.y(`Started watching: '${c}'`);const n=new Set;if(u)try{for(const t of await S.Promises.readdir(c))n.add(t)}catch(t){this.v(t)}const r=new Map;g.add((0,O.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),R.on("error",(t,i)=>{this.v(`Failed to watch ${c} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),R.on("change",(t,i)=>{if(f.token.isCancellationRequested)return;this.y(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),w.isMacintosh&&(s=(0,D.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===v&&!await S.Promises.exists(c)){this.w("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.u((0,I.join)(c,s));if(f.token.isCancellationRequested)return;let h;o?n.has(s)?h=0:(h=1,n.add(s)):(n.delete(s),h=2),this.s({path:(0,I.join)(this.j.path,s),type:h})},d.a);r.set(s,(0,O.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(s)?a=0:(a=1,n.add(s)),this.s({path:(0,I.join)(this.j.path,s),type:a})}else if(t==="rename"||s!==v){const a=setTimeout(async()=>{const o=await S.Promises.exists(c);f.token.isCancellationRequested||(o?(this.s({path:this.j.path,type:0},!0),g.add(await this.r(c,!1))):(this.s({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);g.clear(),g.add((0,O.toDisposable)(()=>clearTimeout(a)))}else this.s({path:this.j.path,type:0},!0)})}catch(v){await S.Promises.exists(c)&&!f.token.isCancellationRequested&&this.v(`Failed to watch ${c} for changes using fs.watch() (${v.toString()})`)}return(0,O.toDisposable)(()=>{f.dispose(!0),g.dispose()})}s(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.y(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(f=>f(c.path))?this.m&&this.y(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(f=>f(c.path))?this.m&&this.y(` >> ignored (not included) ${c.path}`):this.f.work(c))}t(c){const u=(0,p.coalesceEvents)(c);if(u.length>0){if(this.m)for(const g of u)this.y(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(u)?this.c.pending>0&&this.y(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.w(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async u(c){if(w.isLinux)return S.Promises.exists(c);try{const u=(0,I.basename)(c);return(await S.Promises.readdir((0,I.dirname)(c))).some(g=>g===u)}catch(u){return this.y(u),!1}}setVerboseLogging(c){this.m=c}v(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}w(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}y(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.y(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function m(C,c,u,f,g=512){const v=await S.Promises.open(C,"r"),R=Buffer.allocUnsafe(g),n=new l.CancellationTokenSource(f);let r,t=!1;const i={path:C,excludes:[],recursive:!1},s=new d(i,a=>{(async()=>{for(const{type:o}of a)if(o===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await S.Promises.read(v,R,0,g,null);if(!h||n.token.isCancellationRequested)break;c(R.slice(0,h))}}catch(h){r=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((a,o)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await S.Promises.close(v)}catch(h){r=new Error(h)}r?o(r):a()})})}e.watchFileContents=m}),define(re[206],oe([0,1,3,92,2,4,205]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(w){const P=this.i(w),S=P.filter(d=>{const m=this.c.get(d.path);return m?!(0,U.patternsEquals)(m.request.excludes,d.excludes)||!(0,U.patternsEquals)(m.request.includes,d.includes):!0}),p=Array.from(this.c.values()).filter(({request:d})=>!P.find(m=>m.path===d.path&&(0,U.patternsEquals)(m.excludes,d.excludes)&&(0,U.patternsEquals)(m.includes,d.includes))).map(({request:d})=>d.path);S.length&&this.j(`Request to start watching: ${S.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const d of p)this.h(d);for(const d of S)this.g(d)}g(w){const P=new O.NodeJSFileWatcherLibrary(w,p=>this.a.fire(p),p=>this.b.fire(p),this.f),S={request:w,instance:P};this.c.set(w.path,S)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const P=this.c.get(w);P&&(this.c.delete(w),P.instance.dispose())}i(w){const P=new Map;for(const S of w){const p=A.isLinux?S.path:S.path.toLowerCase();P.set(p,S)}return Array.from(P.values())}async setVerboseLogging(w){this.f=w;for(const[,P]of this.c)P.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,P){return P?`[File Watcher (node.js)] ${w} (path: ${P.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=D}),define(re[207],oe([0,1,56,206]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends L.AbstractNonRecursiveWatcherClient{constructor(O,D,I){super(O,D,I),this.m()}l(){return new U.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(re[208],oe([0,1,22,39,65,56]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends A.AbstractUniversalWatcherClient{constructor(I,w,P){super(I,w,P),this.m()}l(I){const w=I.add(new l.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(w.onDidProcessExit(({code:P,signal:S})=>this.n(`terminated by itself with code ${P}, signal: ${S}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(re[70],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...l){this.a=new Map;for(const[A,O]of l)this.set(A,O)}set(l,A){const O=this.a.get(l);return this.a.set(l,A),O}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=L}),define(re[209],oe([0,1,6,10,2,68,200,5,70,84]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class S extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class p{constructor(c=new I.ServiceCollection,u=!1,f,g=P){this.f=c,this.g=u,this.h=f,this.i=g,this.o=new Set,this.f.set(D.IInstantiationService,this),this._globalGraph=g?f?._globalGraph??new O.Graph(v=>v):void 0}createChild(c){return new p(c,this.g,this,this.i)}invokeFunction(c,...u){const f=m.traceInvocation(this.i,c);let g=!1;try{return c({get:R=>{if(g)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(R,f);if(!n)throw new Error(`[invokeFunction] unknown service '${R}'`);return n}},...u)}finally{g=!0,f.stop()}}createInstance(c,...u){let f,g;return c instanceof A.SyncDescriptor?(f=m.traceCreation(this.i,c.ctor),g=this.j(c.ctor,c.staticArguments.concat(u),f)):(f=m.traceCreation(this.i,c),g=this.j(c,u,f)),f.stop(),g}j(c,u=[],f){const g=D._util.getServiceDependencies(c).sort((n,r)=>n.index-r.index),v=[];for(const n of g){const r=this.m(n.id,f);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${n.id}.`,!1),v.push(r)}const R=g.length>0?g[0].index:u.length;if(u.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${u.length} static arguments`);const n=R-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,R)}return Reflect.construct(c,u.concat(v))}k(c,u){if(this.f.get(c)instanceof A.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const f=this.l(c);return f instanceof A.SyncDescriptor?this.q(c,f,u.branch(c,!0)):(u.branch(c,!1),f)}q(c,u,f){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,f)}finally{this.o.delete(c)}}r(c,u,f){const g=new O.Graph(n=>n.id.toString());let v=0;const R=[{id:c,desc:u,_trace:f}];for(;R.length;){const n=R.pop();if(g.lookupOrInsertNode(n),v++>1e3)throw new S(g);for(const r of D._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof A.SyncDescriptor){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};g.insertEdge(n,i),R.push(i)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new S(g);break}for(const{data:r}of n){if(this.l(r.id)instanceof A.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}g.removeNode(r)}}return this.l(c)}s(c,u,f=[],g,v){if(this.f.get(c)instanceof A.SyncDescriptor)return this.t(c,u,f,g,v);if(this.h)return this.h.s(c,u,f,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,f=[],g,v){if(g){const R=new p(void 0,this.g,this,this.i);R.c=String(c);const n=new Map,r=new L.IdleValue(()=>{const t=R.j(u,f,v);for(const[i,s]of n){const a=t[i];if(typeof a=="function")for(const o of s)a.apply(t,o)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=n.get(i);return o||(o=new w.LinkedList,n.set(i,o)),(b,y,k)=>{const T=o.push([b,y,k]);return(0,l.toDisposable)(T)}}if(i in t)return t[i];const s=r.value;let a=s[i];return typeof a!="function"||(a=a.bind(s),t[i]=a),a},set(t,i,s){return r.value[i]=s,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,f,v)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=p;var d;(function(C){C[C.None=0]="None",C[C.Creation=1]="Creation",C[C.Invocation=2]="Invocation",C[C.Branch=3]="Branch"})(d||(d={}));class m{static traceInvocation(c,u){return c?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(c,u){return c?new m(1,u.name):m.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const f=new m(3,c.toString());return this.h.push([c,u,f]),f}stop(){const c=Date.now()-this.g;m.f+=c;let u=!1;function f(v,R){const n=[],r=new Array(v+1).join("	");for(const[t,i,s]of R.h)if(i&&s){u=!0,n.push(`${r}CREATES -> ${t}`);const a=f(v+1,s);a&&n.push(a)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(c>2||u)&&m.all.add(g.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(re[71],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class U{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.MainProcessService=U}),define(re[72],oe([0,1,25,2,4,172,29,5]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let w=class extends U.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new L.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const m=p.firstPage.filter(C=>C.properties.localizedLanguages?.length&&C.tags.some(c=>c.startsWith("lp-"))).map(C=>{const c=C.properties.localizedLanguages?.[0],u=I(C);return{...this.f(u,c,C),extensionId:C.identifier.id,galleryExtension:C}});return m.push(this.f("en","English")),m}f(S,p,d){const m=p??S;let C;if(m!==S&&(C=`(${S})`),S.toLowerCase()===l.language.toLowerCase()&&(C??="",C+=(0,A.localize)(0,null)),d?.installCount){C??="";const c=d.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),C+=` $(cloud-download) ${u}`}return{id:S,label:m,description:C}}};w=ye([K(0,O.IExtensionGalleryService)],w),e.LanguagePackBaseService=w}),define(re[210],oe([0,1,2,72]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends L.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};l=ye([K(0,U.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(re[9],oe([0,1,38,3,53,2,37,4,23,12,11,69,5]),function(te,e,L,U,l,A,O,D,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function d(){return new Date().toISOString()}function m(b){return(0,w.isNumber)(b)}e.isLogLevel=m;var C;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function c(b,y,k){switch(y){case C.Trace:b.trace(k);break;case C.Debug:b.debug(k);break;case C.Info:b.info(k);break;case C.Warning:b.warn(k);break;case C.Error:b.error(k);break;case C.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=c;function u(b,y=!1){let k="";for(let T=0;T<b.length;T++){let F=b[T];if(F instanceof Error&&(F=(0,L.toErrorMessage)(F,y)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(T>0?" ":"")+F}return k}class f extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new U.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==C.Off&&this.b<=y}}e.AbstractLogger=f;class g extends f{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...k){this.f(C.Trace)&&this.g(C.Trace,u([y,...k],!0))}debug(y,...k){this.f(C.Debug)&&this.g(C.Debug,u([y,...k]))}info(y,...k){this.f(C.Info)&&this.g(C.Info,u([y,...k]))}warn(y,...k){this.f(C.Warning)&&this.g(C.Warning,u([y,...k]))}error(y,...k){if(this.f(C.Error))if(y instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=y.stack,this.g(C.Error,u(T))}else this.g(C.Error,u([y,...k]))}flush(){}}e.AbstractMessageLogger=g;class v extends f{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.g=!D.isWindows}trace(y,...k){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}debug(y,...k){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}info(y,...k){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}warn(y,...k){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,y,...k):console.warn(`[main ${d()}]`,y,...k))}error(y,...k){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,y,...k):console.error(`[main ${d()}]`,y,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class R extends f{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y)}trace(y,...k){this.f(C.Trace)&&console.log("%cTRACE","color: #888",y,...k)}debug(y,...k){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",y,...k)}info(y,...k){this.f(C.Info)&&console.log("%c INFO","color: #33f",y,...k)}warn(y,...k){this.f(C.Warning)&&console.log("%c WARN","color: #993",y,...k)}error(y,...k){this.f(C.Error)&&console.log("%c  ERR","color: #f33",y,...k)}dispose(){}flush(){}}e.ConsoleLogger=R;class n extends f{constructor(y,k=e.DEFAULT_LOG_LEVEL){super(),this.g=y,this.setLevel(k)}trace(y,...k){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(y),...k])}debug(y,...k){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(y),...k])}info(y,...k){this.f(C.Info)&&this.g.log(C.Info,[this.h(y),...k])}warn(y,...k){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(y),...k])}error(y,...k){this.f(C.Error)&&this.g.log(C.Error,[this.h(y),...k])}h(y){return typeof y=="string"?y:(0,L.toErrorMessage)(y,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends f{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const k of this.g)k.setLevel(y);super.setLevel(y)}trace(y,...k){for(const T of this.g)T.trace(y,...k)}debug(y,...k){for(const T of this.g)T.debug(y,...k)}info(y,...k){for(const T of this.g)T.info(y,...k)}warn(y,...k){for(const T of this.g)T.warn(y,...k)}error(y,...k){for(const T of this.g)T.error(y,...k)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.MultiplexLogger=r;class t extends A.Disposable{constructor(y,k,T){if(super(),this.h=y,this.j=k,this.b=new O.ResourceMap,this.c=this.D(new U.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new U.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new U.Emitter),this.onDidChangeVisibility=this.g.event,T)for(const F of T)this.b.set(F.resource,{logger:void 0,info:F})}k(y){return(0,w.isString)(y)?[...this.b.values()].find(k=>k.info.id===y):this.b.get(y)}getLogger(y){return this.k(y)?.logger}createLogger(y,k){const T=this.l(y),F=(0,w.isString)(y)?y:k?.id??(0,l.hash)(T.toString()).toString(16);let j=this.b.get(T)?.logger;const B=k?.logLevel==="always"?C.Trace:k?.logLevel;j||(j=this.m(T,B??this.getLogLevel(T)??this.h,{...k,id:F}));const V={logger:j,info:{resource:T,id:F,logLevel:B,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(V.info),this.b.set(T,V),j}l(y){return(0,w.isString)(y)?(0,I.joinPath)(this.j,`${y}.log`):y}setLogLevel(y,k){if(P.URI.isUri(y)){const T=y,F=k,j=this.b.get(T);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([T,F]))}else{this.h=y;for(const[T,F]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,k){const T=this.k(y);T&&k!==!T.info.hidden&&(T.info.hidden=!k,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,k]))}getLogLevel(y){let k;return y&&(k=this.b.get(y)?.info.logLevel),k??this.h}registerLogger(y){const k=this.b.get(y.resource);k?k.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const k=this.b.get(y);k&&(k.logger&&k.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(y){}getLevel(){return C.Info}trace(y,...k){}debug(y,...k){}info(y,...k){}warn(y,...k){}error(y,...k){}critical(y,...k){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;function a(b){if(b.verbose)return C.Trace;if(typeof b.logLevel=="string"){const y=h(b.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function o(b){switch(b){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=o;function h(b){switch(b){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=h,e.CONTEXT_LOG_LEVEL=new S.RawContextKey("logLevel",o(C.Info))}),define(re[211],oe([0,1,6,10,2,23,28,15,9]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends l.Disposable{constructor(S,p){super(),this.a=S,this.b=p,this.D(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const S=(0,A.basename)(this.a.logsHome),p=(0,A.dirname)(this.a.logsHome),C=(await O.Promises.readdir(p.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==S),c=C.slice(0,Math.max(0,C.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(u=>O.Promises.rm((0,A.joinPath)(p,u).fsPath))))}catch(S){(0,U.onUnexpectedError)(S)}}};w=ye([K(0,D.IEnvironmentService),K(1,I.ILogService)],w),e.LogsDataCleaner=w}),define(re[212],oe([0,1,21,6,10,3,2,13,56,9]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends O.Disposable{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.D(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new U.ThrottledDelayer(0)),this.r=[],this.s=this.D(new U.ThrottledDelayer(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(p,d):this.t(p,d)}l(p,d){const m={path:this.z(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive},C=(0,L.insert)(this.j,m);return this.m(),(0,O.toDisposable)(()=>{C(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,l.onUnexpectedError)(p))}n(){this.h||(this.h=this.D(this.p(d=>this.c.fire((0,I.toFileChanges)(d)),d=>this.y(d),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(p,d){const m={path:this.z(p),excludes:d.excludes,includes:d.includes,recursive:!1},C=(0,L.insert)(this.r,m);return this.u(),(0,O.toDisposable)(()=>{C(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(p=>(0,l.onUnexpectedError)(p))}v(){return this.q||(this.q=this.D(this.w(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.y(p),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.q.watch(this.r)}y(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}z(p){return(0,D.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(re[213],oe([0,1,21,6,16,25,3,53,63,2,49,22,104,23,43,168,14,103,9,10]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends w.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.D(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new O.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new O.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new O.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new U.ResourceQueue)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const t=new w.DisposableStore;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(i=>this.R.fire(new c.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,w.dispose)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await U.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return I.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,d.isAbsolutePath)(n))throw new c.FileOperationError((0,C.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new g.ErrorNoTelemetry;throw t.message=(0,C.localize)(1,null,n.toString()),t}return r}async k(n){const r=await this.j(n);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r)||(0,c.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const r=await this.j(n);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.n(n,r)}catch(t){throw(0,c.toFileSystemProviderErrorCode)(t)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,C.localize)(2,null,this.nb(n)),1):(0,c.ensureFileSystemProviderError)(t)}}async n(n,r){const t=await this.j(n),i=this.O(t),s=r?.resolveTo,a=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,h=await t.stat(n);let b;return this.p(t,n,h,void 0,!!o,(y,k)=>(b||(b=P.TernarySearchTree.forUris(()=>!i),b.set(n,!0),s&&b.fill(!0,s)),b.get(y.resource)||b.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?k===1:!1))}async p(n,r,t,i,s,a){const{providerExtUri:o}=this.N(n),h={resource:r,name:o.basename(r),isFile:(t.type&c.FileType.File)!==0,isDirectory:(t.type&c.FileType.Directory)!==0,isSymbolicLink:(t.type&c.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&c.FilePermission.Readonly)||Boolean(n.capabilities&2048),etag:(0,c.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(h.isDirectory&&a(h,i)){try{const b=await n.readdir(r),y=await U.Promises.settled(b.map(async([k,T])=>{try{const F=o.joinPath(r,k),j=s?await n.stat(F):{type:T};return await this.p(n,F,j,b.length,s,a)}catch(F){return this.b.trace(F),null}}));h.children=(0,L.coalesce)(y)}catch(b){this.b.trace(b),h.children=[]}return h}return h}async resolveAll(n){return U.Promises.settled(n.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.p(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.q(n,r)}catch(t){return t}return!0}async q(n,r){if(!r?.overwrite&&await this.exists(n))throw new c.FileOperationError((0,C.localize)(3,null,this.nb(n)),3,r)}async createFile(n,r=l.VSBuffer.fromString(""),t){await this.q(n,t);const i=await this.writeFile(n,r);return this.m.fire(new c.FileOperationEvent(n,0,i)),i}async writeFile(n,r,t){const i=this.lb(await this.l(n),n),{providerExtUri:s}=this.N(i);try{await this.r(i,n,t)||await this.P(i,s.dirname(n));let o;if((0,c.hasReadWriteCapability)(i)&&!(r instanceof l.VSBuffer))if((0,m.isReadableStream)(r)){const h=await(0,m.peekStream)(r,3);h.ended?o=l.VSBuffer.concat(h.buffer):o=h}else o=(0,m.peekReadable)(r,h=>l.VSBuffer.concat(h),3);else o=r;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&o instanceof l.VSBuffer?await this.cb(i,n,t,o):await this.Y(i,n,t,o instanceof l.VSBuffer?(0,l.bufferToReadable)(o):o),this.m.fire(new c.FileOperationEvent(n,4))}catch(a){throw new c.FileOperationError((0,C.localize)(4,null,this.nb(n),(0,c.ensureFileSystemProviderError)(a).toString()),(0,c.toFileOperationResult)(a),t)}return this.resolve(n,{resolveMetadata:!0})}async r(n,r,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,C.localize)(5,null,this.nb(r)));let s;try{s=await n.stat(r)}catch{return}if((s.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,C.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==c.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,c.etag)({mtime:t.mtime,size:s.size}))throw new c.FileOperationError((0,C.localize)(7,null),3,t);return s}async readFile(n,r,t){const i=await this.k(n);return r?.atomic?this.s(i,n,r,t):this.t(i,n,r,t)}async s(n,r,t,i){return new Promise((s,a)=>{this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{try{const o=await this.t(n,r,t,i);s(o)}catch(o){a(o)}})})}async t(n,r,t,i){const s=await this.u(n,r,{...t,preferUnbuffered:!0},i);return{...s,value:await(0,l.streamToBuffer)(s.value)}}async readFileStream(n,r,t){const i=await this.k(n);return this.u(i,n,r,t)}async u(n,r,t,i){const s=new A.CancellationTokenSource(i),a=this.F(r,t).then(h=>h,h=>{throw s.cancel(),h});let o;try{return typeof t?.etag=="string"&&t.etag!==c.ETAG_DISABLED&&await a,t?.atomic&&(0,c.hasFileAtomicReadCapability)(n)||!((0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasFileReadStreamCapability)(n))||(0,c.hasReadWriteCapability)(n)&&t?.preferUnbuffered?o=this.C(n,r,t):(0,c.hasFileReadStreamCapability)(n)?o=this.w(n,r,s.token,t):o=this.z(n,r,s.token,t),{...await a,value:o}}catch(h){throw o&&await(0,m.consumeStream)(o),this.v(h,r,t)}}v(n,r,t){const i=(0,C.localize)(8,null,this.nb(r),(0,c.ensureFileSystemProviderError)(n).toString());return n instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new c.FileOperationError(i,(0,c.toFileOperationResult)(n),t)}w(n,r,t,i=Object.create(null)){const s=n.readFileStream(r,i,t);return(0,m.transform)(s,{data:a=>a instanceof l.VSBuffer?a:l.VSBuffer.wrap(a),error:a=>this.v(a,r,i)},a=>l.VSBuffer.concat(a))}z(n,r,t,i=Object.create(null)){const s=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(n,r,s,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.v(a,r,i)},t),s}C(n,r,t){const i=(0,m.newWriteableStream)(s=>l.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,c.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),i.end(l.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async F(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new c.FileOperationError((0,C.localize)(9,null,this.nb(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==c.ETAG_DISABLED&&r.etag===t.etag)throw new c.NotModifiedSinceFileOperationError((0,C.localize)(10,null),t,r);return this.G(n,t.size,r),t}G(n,r,t){if(t?.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new c.TooLargeFileOperationError((0,C.localize)(11,null,this.nb(n)),i,r,t)}}async canMove(n,r,t){return this.H(n,r,"move",t)}async canCopy(n,r,t){return this.H(n,r,"copy",t)}async H(n,r,t,i){if(n.toString()!==r.toString())try{const s=t==="move"?this.lb(await this.l(n),n):await this.k(n),a=this.lb(await this.l(r),r);await this.M(s,n,a,r,t,i)}catch(s){return s}return!0}async move(n,r,t){const i=this.lb(await this.l(n),n),s=this.lb(await this.l(r),r),a=await this.I(i,n,s,r,"move",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,a==="move"?2:3,o)),o}async copy(n,r,t){const i=await this.k(n),s=this.lb(await this.l(r),r),a=await this.I(i,n,s,r,"copy",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,a==="copy"?3:2,o)),o}async I(n,r,t,i,s,a){if(r.toString()===i.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.M(n,r,t,i,s,a);if(o&&!h&&a&&await this.del(i,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(i)),s==="copy"){if(n===t&&(0,c.hasFileFolderCopyCapability)(n))await n.copy(r,i,{overwrite:a});else{const b=await this.resolve(r);b.isDirectory?await this.L(n,b,t,i):await this.J(n,r,t,i)}return s}else return n===t?(await n.rename(r,i,{overwrite:a}),s):(await this.I(n,r,t,i,"copy",a),await this.del(r,{recursive:!0}),"copy")}async J(n,r,t,i){if((0,c.hasOpenReadWriteCloseCapability)(n)&&(0,c.hasOpenReadWriteCloseCapability)(t))return this.eb(n,r,t,i);if((0,c.hasOpenReadWriteCloseCapability)(n)&&(0,c.hasReadWriteCapability)(t))return this.kb(n,r,t,i);if((0,c.hasReadWriteCapability)(n)&&(0,c.hasOpenReadWriteCloseCapability)(t))return this.ib(n,r,t,i);if((0,c.hasReadWriteCapability)(n)&&(0,c.hasReadWriteCapability)(t))return this.gb(n,r,t,i)}async L(n,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await U.Promises.settled(r.children.map(async s=>{const a=this.N(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),t,a):this.J(n,s.resource,t,a)}))}async M(n,r,t,i,s,a){let o=!1;if(n===t){const{providerExtUri:b,isPathCaseSensitive:y}=this.N(n);if(y||(o=b.isEqual(r,i)),o&&s==="copy")throw new Error((0,C.localize)(12,null,this.nb(r),this.nb(i)));if(!o&&b.isEqualOrParent(i,r))throw new Error((0,C.localize)(13,null,this.nb(r),this.nb(i)))}const h=await this.exists(i);if(h&&!o){if(!a)throw new c.FileOperationError((0,C.localize)(14,null,this.nb(r),this.nb(i)),4);if(n===t){const{providerExtUri:b}=this.N(n);if(b.isEqualOrParent(r,i))throw new Error((0,C.localize)(15,null,this.nb(r),this.nb(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}N(n){const r=this.O(n);return{providerExtUri:r?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:r}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.lb(await this.j(n),n);await this.P(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,0,t)),t}async P(n,r){const t=[],{providerExtUri:i}=this.N(n);for(;!i.isEqual(r,i.dirname(r));)try{if(((await n.stat(r)).type&c.FileType.Directory)===0)throw new Error((0,C.localize)(16,null,this.nb(r)));break}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(r)),r=i.dirname(r)}for(let s=t.length-1;s>=0;s--){r=i.joinPath(r,t[s]);try{await n.mkdir(r)}catch(a){if((0,c.toFileSystemProviderErrorCode)(a)!==c.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(n,r){try{await this.Q(n,r)}catch(t){return t}return!0}async Q(n,r){const t=this.lb(await this.j(n),n);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,C.localize)(17,null,this.nb(n)));let s;try{s=await t.stat(n)}catch{}if(s)this.mb(n,s);else throw new c.FileOperationError((0,C.localize)(18,null,this.nb(n)),1);if(!!!r?.recursive){const o=await this.resolve(n);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,C.localize)(19,null,this.nb(n)))}return t}async del(n,r){const t=await this.Q(n,r),i=!!r?.useTrash,s=!!r?.recursive;await t.delete(n,{recursive:s,useTrash:i}),this.m.fire(new c.FileOperationEvent(n,1))}async cloneFile(n,r){const t=await this.j(n),i=this.lb(await this.l(r),r);if(t===i&&this.N(t).providerExtUri.isEqual(n,r))return;if(t===i&&(0,c.hasFileCloneCapability)(t))return t.cloneFile(n,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const s=this.X.queueFor(n,this.N(t).providerExtUri);return t===i&&(0,c.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(n,r,{overwrite:!0})):s.queue(()=>this.J(t,n,i,r))}watch(n,r={recursive:!1,excludes:[]}){const t=new w.DisposableStore;let i=!1,s=()=>{i=!0};return t.add((0,w.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(n,r);i?(0,w.dispose)(a):s=()=>(0,w.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(n,r){const t=await this.j(n),i=(0,D.hash)([this.N(t).providerExtUri.getComparisonKey(n),r]);let s=this.U.get(i);return s||(s={count:0,disposable:t.watch(n,r)},this.U.set(i,s)),s.count+=1,(0,w.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,w.dispose)(s.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,w.dispose)(n.disposable);this.U.clear()}async Y(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.Z(n,s,i):await this.ab(n,s,i)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await n.close(s)}})}async Z(n,r,t){let i=0,s;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=l.VSBuffer.concat(t.buffer);await this.bb(n,r,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((a,o)=>{(0,m.listenStream)(s,{onData:async h=>{s.pause();try{await this.bb(n,r,h,h.byteLength,i,0)}catch(b){return o(b)}i+=h.byteLength,setTimeout(()=>s.resume())},onError:h=>o(h),onEnd:()=>a()})})}async ab(n,r,t){let i=0,s;for(;(s=t.read())!==null;)await this.bb(n,r,s,s.byteLength,i,0),i+=s.byteLength}async bb(n,r,t,i,s,a){let o=0;for(;o<i;)o+=await n.write(r,s+o,t.buffer,a+o,i-o)}async cb(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(()=>this.db(n,r,t,i))}async db(n,r,t,i){let s;i instanceof l.VSBuffer?s=i:(0,m.isReadableStream)(i)?s=await(0,l.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?s=await(0,l.bufferedStreamToBuffer)(i):s=(0,l.readableToBuffer)(i),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.fb(n,r,t,i))}async fb(n,r,t,i){let s,a;try{s=await n.open(r,{create:!1}),a=await t.open(i,{create:!0,unlock:!1});const o=l.VSBuffer.alloc(this.a);let h=0,b=0,y=0;do y=await n.read(s,h,o.buffer,b,o.byteLength-b),await this.bb(t,a,o,y,h,b),h+=y,b+=y,b===o.byteLength&&(b=0);while(y>0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await U.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.hb(n,r,t,i))}async hb(n,r,t,i){return t.writeFile(i,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.jb(n,r,t,i))}async jb(n,r,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const a=await n.readFile(r);await this.bb(t,s,l.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async kb(n,r,t,i){const s=await(0,l.streamToBuffer)(this.z(n,r,A.CancellationToken.None));await this.cb(t,i,void 0,s)}lb(n,r){if(n.capabilities&2048)throw new c.FileOperationError((0,C.localize)(20,null,this.nb(r)),6);return n}mb(n,r){if((r.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,C.localize)(21,null,this.nb(n)),6)}nb(n){return n.scheme===S.Schemas.file?n.fsPath:n.toString(!0)}};v=ye([K(0,f.ILogService)],v),e.FileService=v}),define(re[214],oe([0,1,54,295,6,37,16,3,48,2,13,4,23,43,28,171,14,103,212,38,208,207]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class n extends f.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=D.Event.None,this.H=new A.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.z(t));return{type:this.G(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(t){try{const i=await m.Promises.readdir(this.z(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,p.joinPath)(t,a.name))).type:o=this.G(a),s.push([a.name,o])}catch(o){this.a.trace(o)}})),s}catch(i){throw this.Y(i)}}G(t,i){let s;return i?.dangling?s=c.FileType.Unknown:t.isFile()?s=c.FileType.File:t.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,i&&(s|=c.FileType.SymbolicLink),s}async I(t){const i=this.z(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new l.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(t)})`),s=await this.I(t));const a=this.z(t);return await m.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(t){n.C&&this.a.trace(t)}readFileStream(t,i,s){const a=(0,d.newWriteableStream)(o=>O.VSBuffer.concat(o.map(h=>O.VSBuffer.wrap(h))).buffer);return(0,u.readFileIntoStream)(this,t,a,o=>o.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(t,i,s){let a;try{const o=this.z(t);if(!s.create||!s.overwrite){if(await m.Promises.exists(o)){if(!s.overwrite)throw(0,c.createFileSystemProviderError)((0,C.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.createFileSystemProviderError)((0,C.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){n.O=t}async open(t,i){const s=this.z(t);let a;(0,c.isFileOpenForWriteOptions)(i)&&(a=await this.I(t));let o;try{if((0,c.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:b}=await m.SymlinkSupport.stat(s);b.mode&128||await m.Promises.chmod(s,b.mode|128)}catch(b){this.a.trace(b)}let h;if((0,c.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await m.Promises.truncate(s,0),h="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}h||(h="w")}else h="r";o=await m.Promises.open(s,h)}catch(h){throw a?.dispose(),(0,c.isFileOpenForWriteOptions)(i)?await this.Z(t,h):this.Y(h)}if(this.L.set(o,0),(0,c.isFileOpenForWriteOptions)(i)&&this.N.set(o,t),a){const h=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,a),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),h.dispose())}return o}async close(t){const i=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await m.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(t)}catch(s){throw this.Y(s)}finally{i&&(this.M.get(t)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,a,o){const h=this.P(t,i);let b=null;try{b=(await m.Promises.read(t,s,a,o,h)).bytesRead}catch(y){throw this.Y(y)}finally{this.Q(t,h,b)}return b}P(t,i){return i===this.L.get(t)?null:i}Q(t,i,s){const a=this.L.get(t);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.L.set(t,a+s):this.L.delete(t)))}async write(t,i,s,a,o){return(0,l.retry)(()=>this.R(t,i,s,a,o),100,3)}async R(t,i,s,a,o){const h=this.P(t,i);let b=null;try{b=(await m.Promises.write(t,s,a,o,h)).bytesWritten}catch(y){throw await this.Z(this.N.get(t),y)}finally{this.Q(t,h,b)}return b}async mkdir(t){try{await m.Promises.mkdir(this.z(t))}catch(i){throw this.Y(i)}}async delete(t,i){try{const s=this.z(t);i.recursive?await m.Promises.rm(s,m.RimRafMode.MOVE):await m.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,i,s){const a=this.z(t),o=this.z(i);if(a!==o)try{await this.S(t,i,"move",s.overwrite),await m.Promises.move(a,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,C.localize)(2,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(o)),h.toString()))),this.Y(h)}}async copy(t,i,s){const a=this.z(t),o=this.z(i);if(a!==o)try{await this.S(t,i,"copy",s.overwrite),await m.Promises.copy(a,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,C.localize)(3,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(o)),h.toString()))),this.Y(h)}}async S(t,i,s,a){const o=this.z(t),h=this.z(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,I.isEqual)(o,h,!0)),b&&s==="copy")throw(0,c.createFileSystemProviderError)((0,C.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!b&&await m.Promises.exists(h)){if(!a)throw(0,c.createFileSystemProviderError)((0,C.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.U(t,i,!1)}async U(t,i,s){const a=this.z(t),o=this.z(i),h=!!(this.capabilities&1024);if((0,I.isEqual)(a,o,!h))return;const b=new w.DisposableStore;try{const[y,k]=await Promise.all([this.I(t),this.I(i)]);b.add(y),b.add(k),s&&await m.Promises.mkdir((0,P.dirname)(o),{recursive:!0}),await m.Promises.copyFile(a,o)}catch(y){if(y.code==="ENOENT"&&!s)return this.U(t,i,!0);throw this.Y(y)}finally{b.dispose()}}p(t,i,s){return new v.UniversalWatcherClient(a=>t(a),a=>i(a),s)}w(t,i,s){return new R.NodeJSWatcherClient(a=>t(a),a=>i(a),s)}Y(t){if(t instanceof c.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(t,i)}async Z(t,i){let s=this.Y(i);if(t&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await m.SymlinkSupport.stat(this.z(t));a.mode&128||(s=(0,c.createFileSystemProviderError)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}n.C=!1,n.O=!0,e.DiskFileSystemProvider=n}),define(re[105],oe([0,1,3,2,5,9]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let O=class extends U.Disposable{constructor(I){super(),this.b=I,this.a=this.D(new L.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};O=ye([K(0,A.ILogService)],O),e.SharedProcessLifecycleService=O}),define(re[106],oe([0,1,11,3,9,2]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class O extends l.AbstractLoggerService{constructor(S,p,d,m,C){super(p,d,m),this.n=S,this.p=C,this.D(C.listen("onDidChangeLogLevel",S)(c=>{(0,l.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this.D(C.listen("onDidChangeVisibility",S)(([c,u])=>super.setVisibility(L.URI.revive(c),u))),this.D(C.listen("onDidChangeLoggers",S)(({added:c,removed:u})=>{for(const f of c)super.registerLogger({...f,resource:L.URI.revive(f.resource)});for(const f of u)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(S,p)=>{this.p.call("consoleLog",[S,p])}})}registerLogger(S){super.registerLogger(S),this.p.call("registerLogger",[S,this.n])}deregisterLogger(S){super.deregisterLogger(S),this.p.call("deregisterLogger",[S,this.n])}setLogLevel(S,p){super.setLogLevel(S,p),this.p.call("setLogLevel",[S,p])}setVisibility(S,p){super.setVisibility(S,p),this.p.call("setVisibility",[S,p])}m(S,p,d){return new D(this.p,S,p,d,this.n)}static setLogLevel(S,p,d){return S.call("setLogLevel",[p,d])}}e.LoggerChannelClient=O;class D extends l.AbstractMessageLogger{constructor(S,p,d,m,C){super(m?.logLevel==="always"),this.m=S,this.n=p,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[p,m,C]).then(()=>{this.q(this.l),this.k=!0})}g(S,p){const d=[[S,p]];this.k?this.q(d):this.l.push(...d)}q(S){this.m.call("log",[this.n,S])}}class I{constructor(S,p){this.a=S,this.b=p}listen(S,p){const d=this.b(S);switch(p){case"onDidChangeLoggers":return U.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(C=>this.c(C,d)),removed:[...m.removed].map(C=>this.c(C,d))}));case"onDidChangeVisibility":return U.Event.map(this.a.onDidChangeVisibility,m=>[d.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return U.Event.map(this.a.onDidChangeLogLevel,m=>(0,l.isLogLevel)(m)?m:[d.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${p}`)}async call(S,p,d){const m=this.b(S);switch(p){case"setLogLevel":return(0,l.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(L.URI.revive(m.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(C=>this.c(C,m)))}throw new Error(`Call not found: ${p}`)}c(S,p){return{...S,resource:p.transformOutgoingURI(S.resource)}}}e.LoggerChannel=I;class w extends A.Disposable{constructor(S,p){super(),p.call("setLogLevel",[S.getLogLevel()]),this.D(S.onDidChangeLogLevel(d=>p.call("setLogLevel",[d]))),p.call("getRegisteredLoggers").then(d=>{for(const m of d)S.registerLogger({...m,resource:L.URI.revive(m.resource)})}),this.D(p.listen("onDidChangeVisibility")(([d,m])=>S.setVisibility(L.URI.revive(d),m))),this.D(p.listen("onDidChangeLoggers")(({added:d,removed:m})=>{for(const C of d)S.registerLogger({...C,resource:L.URI.revive(C.resource)});for(const C of m)S.deregisterLogger(C.resource)}))}}e.RemoteLoggerChannelClient=w}),define(re[215],oe([0,1,2,9]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends L.Disposable{constructor(O,D=[]){super(),this.a=new U.MultiplexLogger([O,...D]),this.D(O.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...D){this.a.trace(O,...D)}debug(O,...D){this.a.debug(O,...D)}info(O,...D){this.a.info(O,...D)}warn(O,...D){this.a.warn(O,...D)}error(O,...D){this.a.error(O,...D)}flush(){this.a.flush()}}e.LogService=l}),define(re[57],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(re[58],oe([0,1,3,63,2,5]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class O extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const P=Object.keys(this.f).length;return this.f={...w,...this.f},P!==Object.keys(this.f).length&&await this.i(w),U.Iterable.reduce(this.g.entries(),(S,[p,d])=>({...S,[p]:d}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return U.Iterable.reduce(Object.entries(this.f),(w,[P,S])=>({...w,[P]:{definition:S,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=O;class D{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(re[216],oe([0,1,3,2,58]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(I){this.b=I,this.a=new U.DisposableStore}listen(I,w){switch(w){case"onDidChange":return L.Event.map(this.b.onDidChange,P=>P.reduce((S,p)=>({...S,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(I,w,P){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class O extends l.AbstractPolicyService{constructor(I,w){super(),this.a=w;for(const P in I){const{definition:S,value:p}=I[P];this.f[P]=S,p!==void 0&&this.g.set(P,p)}this.a.listen("onDidChange")(P=>{for(const S in P){const p=P[S];p===null?this.g.delete(S):this.g.set(S,p)}this.h.fire(Object.keys(P))})}async i(I){const w=await this.a.call("updatePolicyDefinitions",I);for(const P in w)this.g.set(P,w[P])}}e.PolicyChannelClient=O}),define(re[107],oe([0,1,4,36]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const A=L.globals.vscode.context.configuration();if(A)l=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,U.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:A.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(re[26],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[217],oe([0,1,6,10,2,13,28,9,26]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends l.Disposable{constructor(S,p,d){super(),this.b=p,this.c=d,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.D(new L.RunOnceScheduler(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),d=(0,A.dirname)(S),m=(0,A.basename)(S),C=await O.Promises.readdir(d);await Promise.all(C.map(async c=>{if(c===m)return;const u=(0,A.join)(d,c),f=await O.Promises.stat(u);if(f.isDirectory()&&p-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),O.Promises.rm(u)}))}catch(p){(0,U.onUnexpectedError)(p)}}};w=ye([K(1,I.IProductService),K(2,D.ILogService)],w),e.CodeCacheCleaner=w}),define(re[218],oe([0,1,6,10,2,13,28,15,9,26]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends l.Disposable{constructor(p,d,m){super(),this.b=p,this.c=d,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.D(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),d=JSON.parse(await O.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(d)){const g=d[f];p[`${g.hash}.${f}`]=!0}const m=(0,A.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(m))return;const c=await O.Promises.readdir(m);for(const f of c){if(p[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await O.Promises.rm((0,A.join)(m,f))}const u=Date.now();for(const f of Object.keys(p)){const g=(0,A.join)(m,f),v=await O.Promises.readdir(g);for(const R of v){if(R==="tcf.json")continue;const n=(0,A.join)(g,R),r=await O.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(f,R)}`),await O.Promises.rm(n))}}}catch(p){(0,U.onUnexpectedError)(p)}}};P=ye([K(0,D.INativeEnvironmentService),K(1,I.ILogService),K(2,w.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(re[219],oe([0,1,13,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var l;(function(A){function O(I){return Boolean(I.samples&&I.timeDeltas)}A.isValidProfile=O;function D(I,w="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(w,(0,L.basename)(P.callFrame.url)));return I}A.rewriteAbsolutePaths=D})(l=e.Utils||(e.Utils={}))}),define(re[220],oe([0,1,31]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this.a=new Map}async startProfiling(A){const D=await(await new Promise((w,P)=>{te(["v8-inspect-profiler"],w,P)})).startProfiling({port:A.port,checkForPaused:!0}),I=(0,L.generateUuid)();return this.a.set(I,D),I}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const D=await O.stop();return this.a.delete(A),D.profile}}e.InspectProfilingService=U}),define(re[40],oe([0,1,129,12]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(O,D){L.ok(U.isString(O)),L.ok(U.isObject(D)),L.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,D)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new l}),define(re[108],oe([0,1,3,40]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,w){this.a[l(I)]=w,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;U.Registry.add(e.Extensions.JSONContribution,O)}),define(re[45],oe([0,1,21,3,12,155,17,108,40]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=I.Registry.as(D.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new U.Emitter,this.onDidSchemaChange=this.i.event,this.j=new U.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const a in i)if(r.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),h=o?.valuesSources??new Map;if(s)for(const T of Object.keys(i[a]))h.set(T,s);const b={...o?.value||{},...i[a]};this.a.set(a,{source:s,value:b,valuesSources:h});const y=(0,O.getLanguageTagSettingPlainKey)(a),k={type:"object",default:b,description:A.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:l.isString(s)?void 0:s,defaultValueSource:s};t.push(...C(a)),this.d[a]=k,this.b.properties[a]=k}else{this.a.set(a,{value:i[a],source:s});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const a=this.a.get(s),o=l.isString(i)?i:i?.id,h=l.isString(a?.source)?a?.source:a?.source?.id;if(o===h)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,a){s=l.isUndefinedOrNull(n.scope)?s:n.scope;const o=n.properties;if(o)for(const b in o){const y=o[b];if(r&&g(b,y)){delete o[b];continue}if(y.source=t,y.defaultDefaultValue=o[b].default,this.w(b,y),e.OVERRIDE_PROPERTY_REGEX.test(b)?y.scope=void 0:(y.scope=l.isUndefinedOrNull(y.scope)?s:y.scope,y.restricted=l.isUndefinedOrNull(y.restricted)?!!i?.includes(b):y.restricted),o[b].hasOwnProperty("included")&&!o[b].included){this.f[b]=o[b],delete o[b];continue}else this.d[b]=o[b],o[b].policy?.name&&this.e.set(o[b].policy.name,b);!o[b].deprecationMessage&&o[b].markdownDeprecationMessage&&(o[b].deprecationMessage=o[b].markdownDeprecationMessage),a.add(b)}const h=n.allOf;if(h)for(const b of h)this.p(b,r,t,i,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const a in i)this.r(a,i[a]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;l.isUndefined(i)&&(i=r.defaultDefaultValue,s=void 0),l.isUndefined(i)&&(i=u(r.type)),r.default=i,r.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(R){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let r=m.exec(R);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=m.exec(R)}}return(0,L.distinct)(n)}e.overrideIdentifiersFromKey=C;function c(R){return R.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=c;function u(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const f=new p;I.Registry.add(e.Extensions.Configuration,f);function g(R,n){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?A.localize(7,null,R):f.getConfigurationProperties()[R]!==void 0?A.localize(8,null,R):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,R,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=g;function v(){const R=[],n=f.getConfigurationProperties();for(const r of Object.keys(n))R.push([r,n[r].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=v}),define(re[73],oe([0,1,21,3,35,2,37,32,12,11,17,45,40]),function(te,e,L,U,l,A,O,D,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(r){return Object.isFrozen(r)?r:D.deepFreeze(r)}class m{constructor(t={},i=[],s=[],a){this.b=t,this.c=i,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof m)return i;const s=new C("");return s.parseRaw(i),s.configurationModel});this.f=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const s=this.rawConfiguration.getValue(t),a=i?this.rawConfiguration.getOverrideValue(t,i):void 0,o=i?this.rawConfiguration.override(i).getValue(t):s;return{value:s,override:a,merged:o}}getOverrideValue(t,i){const s=this.i(i);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.distinct(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=D.deepClone(this.contents),s=D.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const h of t)if(o.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(i,h.contents);for(const b of h.overrides){const[y]=s.filter(k=>L.equals(k.identifiers,b.identifiers));y?(this.h(y.contents,b.contents),y.keys.push(...b.keys),y.keys=L.distinct(y.keys)):s.push(D.deepClone(b))}for(const b of h.keys)a.indexOf(b)===-1&&a.push(b)}return new m(i,a,s,o.every(h=>h instanceof m)?void 0:o)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[a];const h=i[a];h&&(typeof o=="object"&&typeof h=="object"?(o=D.deepClone(o),this.h(o,h)):o=h),s[a]=o}return new m(s,this.keys,this.overrides)}h(t,i){for(const s of Object.keys(i)){if(s in t&&I.isObject(t[s])&&I.isObject(i[s])){this.h(t[s],i[s]);continue}t[s]=D.deepClone(i[s])}}i(t){let i=null,s=null;const a=o=>{o&&(s?this.h(s,o):s=D.deepClone(o))};for(const o of this.overrides)L.equals(o.identifiers,[t])?i=o.contents:o.identifiers.includes(t)&&a(o.contents);return a(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,t),S.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,S.overrideIdentifiersFromKey)(t))),1))}j(t,i,s){(0,P.addToValueTree)(this.contents,t,i,a=>console.error(a)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),S.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=m;class C{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!I.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:a,overrides:o,restricted:h,hasExcludedProperties:b}=this.h(t,i);this.b=new m(s,a,o,b?[t]:void 0),this.c=h||[]}g(t){let i={},s=null,a=[];const o=[],h=[];function b(k){Array.isArray(a)?a.push(k):s!==null&&(a[s]=k)}const y={onObjectBegin:()=>{const k={};b(k),o.push(a),a=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const k=[];b(k),o.push(a),a=k,s=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:b,onError:(k,T,F)=>{h.push({error:k,offset:T,length:F})}};if(t)try{l.visit(t,y),i=a[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return i}h(t,i){const s=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,s,!0,i);t=a.raw;const o=(0,P.toValuesTree)(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),h=Object.keys(t),b=this.j(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:o,keys:h,overrides:b,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,i,s,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const h={},b=[];for(const y in t)if(S.OVERRIDE_PROPERTY_REGEX.test(y)&&s){const k=this.i(t[y],i,!1,a);h[y]=k.raw,o=o||k.hasExcludedProperties,b.push(...k.restricted)}else{const k=i[y],T=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&b.push(y),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&k?.restricted)?h[y]=t[y]:o=!0}return{raw:h,restricted:b,hasExcludedProperties:o}}j(t,i){const s=[];for(const a of Object.keys(t))if(S.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const h in t[a])o[h]=t[a][h];s.push({identifiers:(0,S.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,P.toValuesTree)(o,i)})}return s}}e.ConfigurationModelParser=C;class c extends A.Disposable{constructor(t,i,s,a){super(),this.f=t,this.g=i,this.h=a,this.c=this.D(new U.Emitter),this.onDidChange=this.c.event,this.a=new C(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(s.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(U.Event.any(U.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),U.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&s.isEqual(o.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class u{constructor(t,i,s,a,o,h,b,y,k,T,F,j,B){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=a,this.d=o,this.f=h,this.g=b,this.h=y,this.i=k,this.j=T,this.k=F,this.l=j,this.m=B}get value(){return d(this.c)}n(t,i,s){const a=t.inspect(i,s);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(t,i,s,a,o=new m,h=new m,b=new O.ResourceMap,y=new m,k=new O.ResourceMap){this.c=t,this.d=i,this.f=s,this.g=a,this.h=o,this.i=h,this.j=b,this.l=y,this.m=k,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(t,i,s){return this.q(t,i,s).getValue(t)}updateValue(t,i,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new m,this.m.set(s.resource,a))):a=this.l,i===void 0?a.removeValue(t):a.setValue(t,i),s.resource||(this.a=null)}inspect(t,i,s){const a=this.q(t,i,s),o=this.u(i.resource,s),h=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const y of a.overrides)for(const k of y.identifiers)a.getOverrideValue(t,k)!==void 0&&b.add(k);return new u(t,i,a.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,o||void 0,h)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:a,updated:o,removed:h}=R(this.c,t);i=[...a,...o,...h]}for(const a of i)for(const o of(0,S.overrideIdentifiersFromKey)(a)){const h=this.c.getKeysForOverrideIdentifier(o),b=t.getKeysForOverrideIdentifier(o),y=[...b.filter(k=>h.indexOf(k)===-1),...h.filter(k=>b.indexOf(k)===-1),...h.filter(k=>!D.equals(this.c.override(o).getValue(k),t.override(o).getValue(k)))];s.push([o,y])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:a}=R(this.d,t),o=[...i,...s,...a];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:a,overrides:o}=R(this.applicationConfiguration,t),h=[...i,...s,...a];return h.length&&this.updateApplicationConfiguration(t),{keys:h,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:o}=R(this.localUserConfiguration,t),h=[...i,...s,...a];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:o}=R(this.remoteUserConfiguration,t),h=[...i,...s,...a];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:a,overrides:o}=R(this.workspaceConfiguration,t),h=[...i,...s,...a];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const s=this.p.get(t),{added:a,updated:o,removed:h,overrides:b}=R(s,i),y=[...a,...o,...h];return(y.length||!s)&&this.updateFolderConfiguration(t,i),{keys:y,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:o,overrides:h}=R(i,void 0);return{keys:[...s,...a,...o],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,s){let a=this.r(i,s);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},i){let s=this.s();if(i&&t){const a=i.getFolder(t);a&&(s=this.t(a.uri)||s);const o=this.m.get(t);o&&(s=s.merge(o))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const s=this.s(),a=this.j.get(t);a?(i=s.merge(a),this.b.set(t,i)):i=s}return i}u(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:s,overrides:a,keys:o}=this.j.get(i);return t.push([i,{contents:s,overrides:a,keys:o}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.x(t.defaults),s=this.x(t.policy),a=this.x(t.application),o=this.x(t.user),h=this.x(t.workspace),b=t.folders.reduce((y,k)=>(y.set(w.URI.revive(k[0]),this.x(k[1])),y),new O.ResourceMap);return new f(i,s,a,o,new m,h,b,new m,new O.ResourceMap)}static x(t){return new m(t.contents,t.keys,t.overrides)}}e.Configuration=f;function g(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const a of r)a.keys.forEach(o=>t.add(o)),a.overrides.forEach(([o,h])=>{const b=(0,O.getOrSet)(i,o,new Set);h.forEach(y=>b.add(y))});const s=[];return i.forEach((a,o)=>s.push([o,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=g;class v{constructor(t,i,s,a){this.change=t,this.f=i,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of t.keys)this.affectedKeys.add(o);for(const[,o]of t.overrides)for(const h of o)this.affectedKeys.add(h);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(t,i){const s=this.a+t,a=this.d.indexOf(s);if(a<0)return!1;const o=a+s.length;if(o>=this.d.length)return!1;const h=this.d.charCodeAt(o);if(h!==this.b&&h!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,y=this.g.getValue(t,i,this.h);return!D.equals(b,y)}return!0}}e.ConfigurationChangeEvent=v;function R(r,t){const{added:i,removed:s,updated:a}=n(t?.rawConfiguration,r?.rawConfiguration),o=[],h=r?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const y=b.filter(k=>!h.includes(k));for(const k of y)o.push([k,t.getKeysForOverrideIdentifier(k)])}if(r){const y=h.filter(k=>!b.includes(k));for(const k of y)o.push([k,r.getKeysForOverrideIdentifier(k)])}if(t&&r){for(const y of h)if(b.includes(y)){const k=n({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:t.getOverrideValue(void 0,y)||{},keys:t.getKeysForOverrideIdentifier(y)});o.push([y,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:s,updated:a,overrides:o}}function n(r,t){const i=r?t?r.keys.filter(o=>t.keys.indexOf(o)===-1):[...r.keys]:[],s=t?r?t.keys.filter(o=>r.keys.indexOf(o)===-1):[...t.keys]:[],a=[];if(r&&t){for(const o of t.keys)if(r.keys.indexOf(o)!==-1){const h=(0,P.getConfigurationValue)(t.contents,o),b=(0,P.getConfigurationValue)(r.contents,o);D.equals(h,b)||a.push(o)}}return{added:i,removed:s,updated:a}}}),define(re[221],oe([0,1,21,3,2,32,12,73,45,9,58,40]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class p extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(S.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,S.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new D.ConfigurationModel;const c=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const f=this.f();for(const g of c){const v=f[g],R=u[g];v!==void 0?this.b.addValue(g,v):R?this.b.addValue(g,R.default):this.b.removeValue(g)}}}e.DefaultConfiguration=p;class d{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let m=class extends l.Disposable{get configurationModel(){return this.b}constructor(c,u,f){super(),this.c=c,this.f=u,this.g=f,this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(c=>this.i(c))),this.D(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},f=[],g=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const v of c){const R=g[v];if(!R){f.push(v);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}f.push(v),u[R.policy.name]={type:R.type}}}return(0,O.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),f}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=S.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),f=(0,L.coalesce)(c.map(g=>u.get(g)));this.j(f,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const f=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),g=[],v=this.b.isEmpty();for(const R of c){const n=f[R]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(v?r!==void 0:!(0,A.equals)(this.b.getValue(R),r))&&g.push([R,r])}else this.b.getValue(R)!==void 0&&g.push([R,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const R=this.b;this.b=new D.ConfigurationModel;for(const n of R.keys)this.b.setValue(n,R.getValue(n));for(const[n,r]of g)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);u&&this.a.fire(this.b)}}};m=ye([K(1,P.IPolicyService),K(2,w.ILogService)],m),e.PolicyConfiguration=m}),define(re[222],oe([0,1,6,3,2,23,17,73,221,58]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends l.Disposable{constructor(p,d,m,C){super(),this.i=p,this.h=this.D(new U.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new I.DefaultConfiguration),this.c=m instanceof w.NullPolicyService?new I.NullPolicyConfiguration:this.D(new I.PolicyConfiguration(this.b,m,C)),this.f=this.D(new D.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,d)),this.a=new D.Configuration(this.b.configurationModel,this.c.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.g=this.D(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.D(this.c.onDidChangeConfiguration(c=>this.l(c))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,d,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new D.Configuration(p,d,new D.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(p,d){const m=typeof p=="string"?p:void 0,C=(0,O.isConfigurationOverrides)(p)?p:(0,O.isConfigurationOverrides)(d)?d:{};return this.a.getValue(m,C,void 0)}updateValue(p,d,m,C){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const d=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(m,d,2)}k(p,d){const m=this.a.toData(),C=this.a.compareAndUpdateDefaultConfiguration(p,d);this.m(C,m,7)}l(p){const d=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(p);this.m(m,d,7)}m(p,d,m){const C=new D.ConfigurationChangeEvent(p,{data:d},this.a);C.source=m,C.sourceConfig=this.n(m),this.h.fire(C)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(re[223],oe([0,1,10,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var l;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends L.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof A&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof A&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof A&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof A&&I.isHandled}constructor(I,w=l.Unknown,P){super(I),this._message=I,this._code=w,this._detail=P,this.isHandled=w===l.NotAvailable&&P===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function O(D){const I=D.indexOf("+");return I===-1?D:D.substring(0,I)}e.getRemoteAuthorityPrefix=O}),define(re[74],oe([0,1,22]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(w){return w.scheme===L.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=U;function l(w){if(!w)return;const P=w.indexOf("+");return P<0?w:w.substr(0,P)}e.getRemoteName=l;function A(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=A;function O(w){const{host:P,port:S}=I(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:S}}e.parseAuthorityWithPort=O;function D(w,P){let{host:S,port:p}=I(w);return typeof p>"u"&&(p=P),{host:S,port:p}}e.parseAuthorityWithOptionalPort=D;function I(w){const P=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(re[46],oe([0,1,27,5,74]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var D;(function(C){C.WIN32_X64="win32-x64",C.WIN32_IA32="win32-ia32",C.WIN32_ARM64="win32-arm64",C.LINUX_X64="linux-x64",C.LINUX_ARM64="linux-arm64",C.LINUX_ARMHF="linux-armhf",C.ALPINE_X64="alpine-x64",C.ALPINE_ARM64="alpine-arm64",C.DARWIN_X64="darwin-x64",C.DARWIN_ARM64="darwin-arm64",C.WEB="web",C.UNIVERSAL="universal",C.UNKNOWN="unknown",C.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(c){this.value=c,this.c=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const f=typeof c=="string"?c:c.value,g=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(f,g)}return c.c===u.c}static toKey(c){return typeof c=="string"?c.toLowerCase():c.c}}e.ExtensionIdentifier=I;class w{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const u of c)this.add(u)}add(c){this.c.add(I.toKey(c))}delete(c){return this.c.delete(I.toKey(c))}has(c){return this.c.has(I.toKey(c))}}e.ExtensionIdentifierSet=w;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(I.toKey(c))}get(c){return this.c.get(I.toKey(c))}has(c){return this.c.has(I.toKey(c))}set(c,u){this.c.set(I.toKey(c),u)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function S(C){return p(C)}e.isApplicationScopedExtension=S;function p(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function d(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function m(C,c){if(c){const u=`onResolveRemoteAuthority:${(0,l.getRemoteName)(c)}`;return!!C.activationEvents?.includes(u)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[224],oe([0,1,2,13,28,46]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends L.Disposable{constructor(I,w){super(),this.b=I,this.a=(0,U.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.D(w.onDidInstallExtensions(P=>this.c(P))),this.D(w.onDidUninstallExtension(P=>this.f(P)))}c(I){I.some(w=>!!w.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(re[225],oe([0,1,6,16,25,10,3,2,104,89,31,96,223,74]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var C;(function(E){E[E.Management=1]="Management",E[E.ExtensionHost=2]="ExtensionHost",E[E.Tunnel=3]="Tunnel"})(C=e.ConnectionType||(e.ConnectionType={}));function c(E){switch(E){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(E){const N=new l.CancellationTokenSource;return setTimeout(()=>N.cancel(),E),N.token}function f(E,N){if(E.isCancellationRequested||N.isCancellationRequested)return l.CancellationToken.Cancelled;const z=new l.CancellationTokenSource;return E.onCancellationRequested(()=>z.cancel()),N.onCancellationRequested(()=>z.cancel()),z.token}class g{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new D.DisposableStore,this.promise=new Promise((z,G)=>{this.f=z,this.g=G}),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function v(E,N){const z=new g(N);return z.registerDisposable(E.onControlMessage(G=>{const q=JSON.parse(G.toString()),J=_(q);J?z.reject(J):z.resolve(q)})),z.promise}function R(E,N,z,G,q,J,ee,ce,he){const me=new g(he),de=w.StopWatch.create(!1);return E.info(`Creating a socket (${ce})...`),I.mark(`code/willCreateSocket/${ee}`),N.connect(z,G,q,J,ce,(we,Ce)=>{me.didTimeout?(I.mark(`code/didCreateSocketError/${ee}`),E.info(`Creating a socket (${ce}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),we&&E.error(we),Ce?.dispose()):we||!Ce?(I.mark(`code/didCreateSocketError/${ee}`),E.info(`Creating a socket (${ce}) returned an error after ${de.elapsed()} ms.`),me.reject(we)):(I.mark(`code/didCreateSocketOK/${ee}`),E.info(`Creating a socket (${ce}) was successful after ${de.elapsed()} ms.`),me.resolve(Ce))}),me.promise}function n(E,N){const z=new g(N);return E.then(G=>{z.didTimeout||z.resolve(G)},G=>{z.didTimeout||z.reject(G)}),z.promise}async function r(E,N,z,G){const q=x(E,N);E.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let J;try{J=await R(E.logService,E.socketFactory,E.host,E.port,(0,d.getRemoteServerRootPath)(E),`reconnectionToken=${E.reconnectionToken}&reconnection=${E.reconnectionProtocol?"true":"false"}`,c(N),`renderer-${c(N)}-${E.reconnectionToken}`,G)}catch(de){throw E.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),E.logService.error(de),de}E.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let ee,ce;E.reconnectionProtocol?(E.reconnectionProtocol.beginAcceptReconnection(J,null),ee=E.reconnectionProtocol,ce=!1):(ee=new S.PersistentProtocol({socket:J,measureRoundTripTime:!0}),ce=!0),E.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const he=await n(E.signService.createNewMessage((0,P.generateUuid)()),G),me={type:"auth",auth:E.connectionToken||"00000000000000000000",data:he.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(me)));try{const de=await v(ee,f(G,u(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(E.logService.trace(`${q} 4/6. received SignRequest control message.`),!await n(E.signService.validate(he,de.signedData),G)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await n(E.signService.sign(de.data),G),Re={type:"connectionType",commit:E.commit,signedData:Ce,desiredConnectionType:N};return z&&(Re.args=z),E.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ee,ownsProtocol:ce}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(E.logService.error(`${q} the handshake timed out. Error:`),E.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(E.logService.error(`${q} received error control message when negotiating connection. Error:`),E.logService.error(de)),ce&&$(ee),de}}async function t(E,N,z,G){const q=Date.now(),J=x(E,N),{protocol:ee,ownsProtocol:ce}=await r(E,N,z,G),he=new g(G);return he.registerDisposable(ee.onControlMessage(me=>{const de=JSON.parse(me.toString()),we=_(de);we?(E.logService.error(`${J} received error control message when negotiating connection. Error:`),E.logService.error(we),ce&&$(ee),he.reject(we)):(E.reconnectionProtocol?.endAcceptReconnection(),E.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${M(q)}!`),he.resolve({protocol:ee,firstMessage:de}))})),he.promise}async function i(E,N){const{protocol:z}=await t(E,1,void 0,N);return{protocol:z}}async function s(E,N,z){const{protocol:G,firstMessage:q}=await t(E,2,N,z),J=q&&q.debugPort;return{protocol:G,debugPort:J}}async function a(E,N,z){const G=Date.now(),q=x(E,3),{protocol:J}=await r(E,3,N,z);return E.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${M(G)}!`),J}async function o(E,N,z){const{host:G,port:q,connectionToken:J}=await E.addressProvider.getAddress();return{commit:E.commit,quality:E.quality,host:G,port:q,connectionToken:J,reconnectionToken:N,reconnectionProtocol:z,socketFactory:E.socketFactory,signService:E.signService,logService:E.logService}}async function h(E,N,z){return y(E,async G=>{const{protocol:q}=await i(G,l.CancellationToken.None);return new Z(E,N,z,G.reconnectionToken,q)})}e.connectRemoteAgentManagement=h;async function b(E,N){return y(E,async z=>{const{protocol:G,debugPort:q}=await s(z,N,l.CancellationToken.None);return new H(E,N,z.reconnectionToken,G,q)})}e.connectRemoteAgentExtensionHost=b;async function y(E,N){for(let G=1;;G++)try{const q=(0,P.generateUuid)(),J=await o(E,q,null);return await N(J)}catch(q){if(G<5)E.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),E.logService.error(q);else throw E.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),E.logService.error(q),Y.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(q)),q}}async function k(E,N,z){const G=await o(E,(0,P.generateUuid)(),null);return await a(G,{host:N,port:z},l.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function T(E){return(0,L.createCancelablePromise)(N=>new Promise((z,G)=>{const q=setTimeout(z,E*1e3);N.onCancellationRequested(()=>{clearTimeout(q),z()})}))}var F;(function(E){E[E.ConnectionLost=0]="ConnectionLost",E[E.ReconnectionWait=1]="ReconnectionWait",E[E.ReconnectionRunning=2]="ReconnectionRunning",E[E.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",E[E.ConnectionGain=4]="ConnectionGain",E[E.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class j{constructor(N,z){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=j;class B{constructor(N,z,G,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.durationSeconds=G,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=B;class V{constructor(N,z,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=V;class W{constructor(N,z,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=G,this.type=4}}e.ConnectionGainEvent=W;class Q{constructor(N,z){this.reconnectionToken=N,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=Q;class X{constructor(N,z,G,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=G,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class Y extends D.Disposable{static triggerPermanentFailure(N,z,G){this._permanentFailure=!0,this.f=N,this.g=z,this.h=G,this.i.forEach(q=>q.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(N=>N.r())}static debugPauseSocketWriting(){this.i.forEach(N=>N.v())}get k(){return this.c||Y._permanentFailure}constructor(N,z,G,q,J){super(),this.n=N,this.p=z,this.reconnectionToken=G,this.protocol=q,this.q=J,this.j=this.D(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.D(q.onSocketClose(ee=>{const ce=ae(this.n,this.reconnectionToken,!0);ee?ee.type===0?(this.p.logService.info(`${ce} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.p.logService.error(ee.error)):(this.p.logService.info(`${ce} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.p.logService.error(ee.event)):this.p.logService.info(`${ce} received socket close event.`),this.r()})),this.D(q.onSocketTimeout(ee=>{const ce=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.r()})),this.D(q.onHighRoundTripTime(ee=>{const ce=se(this.n,this.reconnectionToken);this.p.logService.info(`${ce} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of ${5} recent samples)`)})),this.D(q.onDidChangeConnectionHealth(ee=>{this.j.fire(new Q(this.reconnectionToken,ee))})),Y.i.push(this),this.D((0,D.toDisposable)(()=>{const ee=Y.i.indexOf(this);ee>=0&&Y.i.splice(ee,1)})),this.k&&this.u(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k||this.m)return;const N=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const q=G<z.length?z[G]:z[z.length-1];try{if(q>0){const ee=T(q);this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,ee)),this.p.logService.info(`${N} waiting for ${q} seconds before reconnecting...`);try{await ee}catch{}}if(this.k){this.p.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.p.logService.info(`${N} resolving connection...`);const J=await o(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${N} connecting to ${J.host}:${J.port}...`),await this.w(J,u(m)),this.p.logService.info(`${N} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(J),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.p.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(J),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(J)){this.p.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.p.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((0,A.isCancellationError)(J)){this.p.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if(J instanceof p.RemoteAuthorityResolverError){this.p.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(J),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,p.RemoteAuthorityResolverError.isHandled(J));break}this.p.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(J),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k&&!this.m)}t(N,z,G){this.q?Y.triggerPermanentFailure(N,z,G):this.u(N,z,G)}u(N,z,G){this.j.fire(new X(this.reconnectionToken,N,z,G)),$(this.protocol)}v(){this.protocol.pauseSocketWriting()}}Y._permanentFailure=!1,Y.f=0,Y.g=0,Y.h=!1,Y.i=[],e.PersistentConnection=Y;class Z extends Y{constructor(N,z,G,q,J){super(1,N,q,J,!0),this.client=this.D(new S.Client(J,{remoteAuthority:z,clientId:G},N.ipcLogger))}async w(N,z){await i(N,z)}}e.ManagementPersistentConnection=Z;class H extends Y{constructor(N,z,G,q,J){super(2,N,G,q,!1),this.y=z,this.debugPort=J}async w(N,z){await s(N,this.y,z)}}e.ExtensionHostPersistentConnection=H;function $(E){try{E.acceptDisconnect();const N=E.getSocket();E.dispose(),N.dispose()}catch(N){(0,A.onUnexpectedError)(N)}}function _(E){if(E&&E.type==="error"){const N=new Error(`Connection error: ${E.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function ie(E,N){for(;E.length<N;)E+=" ";return E}function se(E,N){return`[remote-connection][${ie(c(E),13)}][${N.substr(0,5)}\u2026]`}function ae(E,N,z){return`${se(E,N)}[${z?"reconnect":"initial"}]`}function x(E,N){return`${ae(N,E.reconnectionToken,!!E.reconnectionProtocol)}[${E.host}:${E.port}]`}function M(E){return`${Date.now()-E} ms`}}),define(re[226],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[227],oe([0,1,86,153]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,A,O,D,I,w){const P=p=>w(p,void 0),S=L.createConnection({host:l,port:A},()=>{S.removeListener("error",P);const p=Buffer.alloc(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const d=p.toString("base64"),m=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${A}${O}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];S.write(m.join(`\r
`)+`\r
\r
`);const C=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",C),w(void 0,new U.NodeSocket(S,I)))};S.on("data",C)});S.setNoDelay(!0),S.once("error",P)}}}),define(re[109],oe([0,1,5,173]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var l;(function(A){A.disconnected={type:"disconnected"},A.uninitialized={type:"uninitialized"},A.connected=O=>({type:"connected",info:O}),A.connecting=O=>({type:"connecting",progress:O})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(re[59],oe([0,1,16,10,2,175,45,5,9,40]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class P{constructor(R){this.b=R}toJSON(){if(!this.a){const R=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?R[n]="*****":R[n]=this.b[n];this.a=R}return this.a}}class S extends l.Disposable{constructor(R,n){super(),this.b=0,this.a=n.createLogger("request",{name:R?(0,A.localize)(0,null):(0,A.localize)(1,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async c(R,n,r){const t=`${R} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new P(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,U.getErrorMessage)(i)),i}}}e.AbstractRequestService=S;function p(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=p;function d(v){return v.res.statusCode===204}async function m(v){return d(v)?null:(await(0,L.streamToBuffer)(v.stream)).toString()}e.asText=m;async function C(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}e.asTextOrError=C;async function c(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);if(d(v))return null;const n=(await(0,L.streamToBuffer)(v.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=c;function u(v){g(v)}e.updateProxyConfigurationsScope=u;let f;function g(v){const R=w.Registry.as(O.Extensions.Configuration),n=f;f={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},R.updateConfigurations({add:[f],remove:n?[n]:[]})}g(2)}),define(re[228],oe([0,1,25,22,14,59]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(I,w){this.a=I,this.b=w}async download(I,w,P=L.CancellationToken.None){if(I.scheme===U.Schemas.file||I.scheme===U.Schemas.vscodeRemote){await this.b.copy(I,w);return}const S={type:"GET",url:I.toString(!0)},p=await this.a.request(S,P);if(p.res.statusCode===200)await this.b.writeFile(w,p.stream);else{const d=await(0,A.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${d}`)}}};O=ye([K(0,A.IRequestService),K(1,l.IFileService)],O),e.DownloadService=O}),define(re[229],oe([0,1,16,25]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(D){this.a=D}listen(D,I){throw new Error("Invalid listen")}call(D,I,w,P=U.CancellationToken.None){switch(I){case"request":return this.a.request(w[0],P).then(async({res:S,stream:p})=>{const d=await(0,L.streamToBuffer)(p);return[{statusCode:S.statusCode,headers:S.headers},d]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class A{constructor(D){this.a=D}async request(D,I){const[w,P]=await this.a.call("request",[D],I);return{res:w,stream:(0,L.bufferToStream)(P)}}async resolveProxy(D){return this.a.call("resolveProxy",[D])}}e.RequestChannelClient=A}),define(re[110],oe([0,1,53,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(A){return(0,L.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,U.createDecorator)("sharedProcessWorkerService")}),define(re[230],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(U){U.Spawn="vscode:shared-process->shared-process-worker=spawn",U.Terminate="vscode:shared-process->shared-process-worker=terminate",U.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",U.Ready="vscode:shared-process-worker->shared-process=ready",U.Ack="vscode:shared-process-worker->shared-process=ack",U.Trace="vscode:shared-process-worker->shared-process=trace",U.Info="vscode:shared-process-worker->shared-process=info",U.Warn="vscode:shared-process-worker->shared-process=warn",U.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[231],oe([0,1,151,6,25,3,2,22,31,9,110,230]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(C){this.d=C,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(C){const c=`window: ${C.reply.windowId}, moduleId: ${C.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${c})`);const u=(0,P.hash)(C);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.f(C));const f=new l.CancellationTokenSource;let g,v,R;this.b.set(u,i=>{f.dispose(!0),g?.terminate(C,l.CancellationToken.None),v?.close(),R?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:i}))}),g=await this.e(C);const n=new Promise(i=>{this.c.set(u,i)});if(f.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return v=r,R=t,await g.spawn(C,R,f.token),f.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",C,[v])),n}e(C){let c=this.a.get(C.process.moduleId);if(!c){this.d.trace(`SharedProcess: creating new web worker (${C.process.moduleId})`);const u=new d(C.process.type,this.d);c=u.init(),u.onDidProcessSelfTerminate(({configuration:f,reason:g})=>{this.f(f,g)}),this.a.set(C.process.moduleId,c)}return c}async disposeWorker(C){return this.f(C)}f(C,c){const u=this.b.get((0,P.hash)(C));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${C.reply.windowId}, moduleId: ${C.process.moduleId})`),u(c))}};p=ye([K(0,w.ILogService)],p),e.SharedProcessWorkerService=p;class d extends O.Disposable{constructor(C,c){super(),this.f=C,this.g=c,this.a=this.D(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const C=new U.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return c.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},c.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},c.onmessage=u=>{const{id:f,message:g,configuration:v,nonce:R}=u.data;switch(f){case S.SharedProcessWorkerMessages.Ready:C.complete(c);break;case S.SharedProcessWorkerMessages.Ack:if(R){const n=this.c.get(R);n&&(this.c.delete(R),n())}break;case S.SharedProcessWorkerMessages.SelfTerminated:v&&g&&this.a.fire({configuration:v,reason:JSON.parse(g)});break;case S.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,g);break;case S.SharedProcessWorkerMessages.Info:g&&this.g.info(g);break;case S.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,g);break;case S.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,g);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),C.p}async i(C,c,u){const f=await this.b;if(!c.isCancellationRequested)return new Promise(g=>{const v=(0,I.generateUuid)();this.c.set(v,g);const R={...C,nonce:v};u?f.postMessage(R,[u]):f.postMessage(R),c.onCancellationRequested(()=>{this.c.delete(v)&&g()})})}spawn(C,c,u){const f={id:S.SharedProcessWorkerMessages.Spawn,configuration:C,environment:{bootstrapPath:D.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(f,u,c)}terminate(C,c){const u={id:S.SharedProcessWorkerMessages.Terminate,configuration:C};return this.i(u,c)}}}),define(re[232],oe([0,1,62,22,97]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:U.Schemas.vscodeUserData})}}ye([L.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(re[233],oe([0,1,50,13,176,25,38,10,4,31,148,194,6,131]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function C(u,f,g,v){return g["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(v)&&!g["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=p.Promises.withAsyncBody(async(R,n)=>{const r=new A.CancellationTokenSource;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,d.clamp)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,l.localize)(0,null)))},t);try{R(await c(f,r.token))}catch(a){!(0,D.isCancellationError)(a)&&!r.token.isCancellationRequested?n(new Error((0,l.localize)(1,null,(0,O.toErrorMessage)(a)))):R({})}finally{clearTimeout(s),r.dispose()}})),m)}e.getResolvedShellEnv=C;async function c(u,f){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",v);const R=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(R+"({.*})"+R),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const t=await(0,P.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new D.CancellationError);const a=(0,U.basename)(t);let o,h;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${b} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,h=["-Login","-Command"]):(o=`'${process.execPath}' ${b} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,a==="tcsh"||a==="csh"?h=["-ic"]:h=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),o);const y=(0,L.spawn)(t,[...h,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(y.kill(),s(new D.CancellationError))),y.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(F)),s(F)});const k=[];y.stdout.on("data",F=>k.push(F));const T=[];y.stderr.on("data",F=>T.push(F)),y.on("close",(F,j)=>{const B=Buffer.concat(k).toString("utf8");u.trace("getUnixShellEnvironment#raw",B);const V=Buffer.concat(T).toString("utf8");if(V.trim()&&u.trace("getUnixShellEnvironment#stderr",V),F||j)return s(new Error((0,l.localize)(2,null,F,j)));const W=n.exec(B),Q=W?W[1]:"{}";try{const X=JSON.parse(Q);g?X.ELECTRON_RUN_AS_NODE=g:delete X.ELECTRON_RUN_AS_NODE,v?X.ELECTRON_NO_ATTACH_CONSOLE=v:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",X),i(X)}catch(X){u.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(X)),s(X)}})})}}),define(re[111],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[234],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((l,A)=>te(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.c(),O=new A.validator;if(O){const D=String(L.a++);return this.b.set(D,O),{id:D,data:O.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const O=this.b.get(l.id);if(!O)return!1;this.b.delete(l.id);try{return O.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.c(),O=new A.signer;if(O)return O.sign(l)}catch{}return l}}L.a=1,e.SignService=L}),define(re[75],oe([0,1,3,2]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends U.Disposable{constructor(S,p,d){super(),this.a=S,this.b=p,this.c=d}async getItems(){const S={profile:this.b,workspace:this.c},p=await this.a.call("getItems",S);return new Map(p)}updateItems(S){const p={profile:this.b,workspace:this.c};return S.insert&&(p.insert=Array.from(S.insert.entries())),S.delete&&(p.delete=Array.from(S.delete.values())),this.a.call("updateItems",p)}}class A extends l{constructor(S,p){super(S,p,void 0),this.f=this.D(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.D(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class O extends A{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class D extends A{constructor(S,p){super(S,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class I extends l{constructor(S,p){super(S,void 0,p),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class w{constructor(S){this.a=S}isUsed(S){const p={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.StorageClient=w}),define(re[112],oe([0,1,4,36,11,31]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(w){if(L.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function D(w,P,S,p,d,m,C,c,u,f){const g=Object.create(null);g["common.machineId"]=C,g.sessionID=(0,A.generateUuid)()+Date.now(),g.commitHash=d,g.version=m,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=U.platform,g["common.nodeArch"]=p,g["common.product"]=f||"desktop",c&&(g["common.msftInternal"]=c);let v=0;const R=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const n=O(S);n&&(g["common.platformDetail"]=n);try{const r=await w.readFile(l.URI.file(u));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=D;function I(w){const P=U.env.USERDNSDOMAIN;if(!P)return!1;const S=P.toLowerCase();return w.some(p=>S===p)}e.verifyMicrosoftInternalDomain=I}),define(re[19],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(U=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[235],oe([0,1,34,6,35,22,13,4,11,145,28,147,98,14,26,19]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(n,r){const t=`${n}::${r.join(":")}`,i=c.get(t);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,o=new Map,h=2e4;function b(k,T,F,j){const B=T.substring(k.length+1);return U.Promises.withAsyncBody(async V=>{let W;try{W=await P.Promises.readdir(T,{withFileTypes:!0})}catch{V();return}if(j.count>=h){j.count+=W.length,j.maxReached=!0,V();return}let Q=W.length;if(Q===0){V();return}let X=W;j.count+W.length>h&&(j.maxReached=!0,Q=h-j.count,X=W.slice(0,Q)),j.count+=W.length;for(const Y of X)if(Y.isDirectory()){if(F.includes(Y.name)||await b(k,(0,O.join)(T,Y.name),F,j),--Q===0){V();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const H=Y.name.substring(Z+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of s)H.relativePathPattern?.test(B)!==!1&&H.filePattern.test(Y.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--Q===0){V();return}}})}const y=U.Promises.withAsyncBody(async k=>{const T={count:0,maxReached:!1};await b(n,n,r,T);const F=await v(n);k({configFiles:f(o),fileTypes:f(a),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:F})});return c.set(t,y),y}e.collectWorkspaceStats=u;function f(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function g(){const n={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},r=L.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=g;async function v(n){try{const r=new Map,t=(0,O.join)(n,".vscode","launch.json"),i=await P.Promises.readFile(t),s=[],a=(0,l.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,l.getNodeType)(a)==="object"&&a.configurations)for(const o of a.configurations){const h=o.type;h&&(r.has(h)?r.set(h,r.get(h)+1):r.set(h,1))}return f(r)}catch{return[]}}e.collectLaunchConfigs=v;let R=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const i=L.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||t.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[s,a]=i,o=this.m(r,s);return t.forEach(h=>{if((0,p.isRemoteDiagnosticError)(h))o+=`
${h.errorMessage}`,a+=`
${h.errorMessage}`;else if(o+=`

Remote: ${h.hostName}`,h.processes&&(o+=`
${this.m(r,h.processes)}`),h.workspaceMetadata){a+=`
|  Remote: ${h.hostName}`;for(const b of Object.keys(h.workspaceMetadata)){const y=h.workspaceMetadata[b];let k=`${y.fileCount} files`;y.maxFilesReached&&(k=`more than ${k}`),a+=`|    Folder (${b}): ${k}`,a+=this.h(y)}}}),{processInfo:o,workspaceInfo:a}})}async getSystemInfo(r,t){const{memory:i,vmHint:s,os:a,cpus:o}=g(),h={os:a,memory:i,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return D.isWindows||(h.load=`${L.loadavg().map(b=>Math.round(b)).join(", ")}`),D.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(r,t){const i=[];return(0,S.listProcesses)(r.mainPID).then(async s=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,s)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),t.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(r,a.processes)),a.workspaceMetadata)for(const o of Object.keys(a.workspaceMetadata)){const h=a.workspaceMetadata[o];let b=`${h.fileCount} files`;h.maxFilesReached&&(b=`more than ${b}`),i.push(`Folder (${o}): ${b}`),i.push(this.h(h))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const t=[];let s=0;const a=(y,k)=>{const T=` ${y}(${k})`;s+T.length>60?(t.push(o),o="|                 ",s=o.length):s+=T.length,o+=T};let o="|      File types:";const h=10,b=r.fileTypes.length>h?h:r.fileTypes.length;for(let y=0;y<b;y++){const k=r.fileTypes[y];a(k.name,k.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(y=>{a(y.name,y.count)}),t.push(o)),r.launchConfigFiles.length>0){let y="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{y+=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`}),t.push(y)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const t=[],i=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const o=I.URI.revive(a);if(o.scheme===A.Schemas.file){const h=o.fsPath;i.push(u(h,["node_modules",".git"]).then(b=>{let y=`${b.fileCount} files`;b.maxFilesReached&&(y=`more than ${y}`),t.push(`|    Folder (${(0,O.basename)(h)}): ${y}`),t.push(this.h(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${h} (${b.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const i=new Map;r.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),r.pidToNames.forEach(({pid:a,name:o})=>i.set(a,o));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,i,s,t,0),s.join(`
`)}n(r,t,i,s,a){const o=a===0;let h;o?h=s.pid===r?`${this.d.applicationName} main`:"remote agent":t.has(s.pid)?h=t.get(s.pid):h=`${"  ".repeat(a)} ${s.name}`;const b=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(b/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(y=>this.n(r,t,i,y,a+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:i}of r.folders){const s=I.URI.revive(i);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(h=>t.add(h.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const i=I.URI.revive(t);if(i.scheme!==A.Schemas.file)continue;const s=i.fsPath;try{const a=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};R=ye([K(0,C.ITelemetryService),K(1,m.IProductService)],R),e.DiagnosticsService=R}),define(re[236],oe([0,1,109,3,19,15,2,9,13,50,26,4,6,105,17,174,34]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const u=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let f=class extends O.Disposable{constructor(v,R,n,r,t,i){super(),this.q=v,this.r=R,this.s=n,this.t=i,this.b=new U.Emitter,this.onDidTokenFailed=this.b.event,this.f=new U.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new U.Emitter,this.onDidChangeAccount=this.g.event,this.k=L.TunnelStates.disconnected,this.h=this.D(r.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this.n=new p.Delayer(100),this.D(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,D.LogLevelToString)(s)))),this.D(t.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.D(i.onDidChangeConfiguration(s=>{u.some(a=>s.affectsConfiguration(a))&&this.n.trigger(()=>this.v())}))}async getAccount(){return this.i}async updateAccount(v){if(v&&this.i?v.token!==this.i.token||v.providerId!==this.i.providerId:v!==this.i){this.i=v,this.g.fire(v),v?this.h.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.h.info("Account reset"),this.q.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.n.trigger(()=>this.v())}catch(R){this.h.error(R)}}return this.k}u(){if(!this.p){let v;S.isMacintosh?v=this.s.appRoot:v=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.p=(0,I.join)(v,"bin",`${this.r.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this.p}async v(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.w(L.TunnelStates.disconnected);return}const{token:v,providerId:R,accountLabel:n}=this.i;this.w(L.TunnelStates.connecting((0,C.localize)(0,null,n,R)));const r=(o,h)=>{o=o.replaceAll(v,"*".repeat(4)),h?this.h.error(o):this.h.info(o),!this.s.isBuilt&&o.startsWith("   Compiling")&&this.w(L.TunnelStates.connecting((0,C.localize)(1,null)))},t=this.y("login",["user","login","--provider",R,"--access-token",v,"--log",(0,D.LogLevelToString)(this.h.getLevel())],r);this.j=t;try{if(await t,this.j!==t)return}catch(o){this.h.error(o),this.j=void 0,this.b.fire(!0),this.w(L.TunnelStates.disconnected);return}const i=this.C();i?this.w(L.TunnelStates.connecting((0,C.localize)(2,null,i))):this.w(L.TunnelStates.connecting((0,C.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,D.LogLevelToString)(this.h.getLevel())];i?s.push("--name",i):s.push("--random-name"),this.z()&&s.push("--no-sleep");const a=this.y("tunnel",s,(o,h)=>{h?this.h.error(o):this.h.info(o);const b=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const y={link:b[1],domain:b[2],hostName:b[4]};this.w(L.TunnelStates.connected(y))}else o.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.w(L.TunnelStates.disconnected))});this.j=a,a.finally(()=>{a===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.w(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}w(v){this.k=v,this.f.fire(v)}y(v,R,n=()=>{}){return(0,p.createCancelablePromise)(r=>new Promise((t,i)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.h.info(`${v} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${v} Spawning: cargo run -- tunnel ${R.join(" ")}`,!1),s=(0,w.spawn)("cargo",["run","--","tunnel",...R],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const a=this.u();n(`${v} Spawning: ${a} tunnel ${R.join(" ")}`,!1),s=(0,w.spawn)(a,["tunnel",...R],{cwd:(0,c.homedir)()})}s.stdout.on("data",a=>{if(s){const o=a.toString();n(o,!1)}}),s.stderr.on("data",a=>{if(s){const o=a.toString();n(o,!0)}}),s.on("exit",a=>{s&&(n(`${v} exit(${s.pid}): + ${a} `,!1),s=void 0,a===0?t():i())}),s.on("error",a=>{s&&(n(`${v} error(${s.pid}): + ${a} `,!0),s=void 0,i())})}))}async getHostName(){return this.C()}z(){return!!this.t.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}C(){let v=this.t.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};f=ye([K(0,l.ITelemetryService),K(1,P.IProductService),K(2,A.INativeEnvironmentService),K(3,D.ILoggerService),K(4,d.ISharedProcessLifecycleService),K(5,m.IConfigurationService)],f),e.RemoteTunnelService=f}),define(re[113],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:D,data:I}){return this.b.forEach(w=>w.log(D,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class U{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(re[47],oe([0,1,32,12,3,17,74,112,19]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(s){this.value=s}}e.TelemetryTrustedValue=w;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,a){return Promise.resolve(void 0)}publicLog2(s,a){return this.publicLog(s,a)}publicLogError(s,a){return Promise.resolve(void 0)}publicLogError2(s,a){return this.publicLogError(s,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class S{async publicLog(s,a,o){}async publicLogError(s,a,o){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,s){return l.Event.debounce(s.onDidChangeConfiguration,(o,h)=>{const b=o?new Set([...o.affectedKeys,...h.affectedKeys]):h.affectedKeys;return{...h,affectedKeys:b}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.configurationTelemetry=p;function d(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function m(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=m;function C(i){const s=i.getValue(I.TELEMETRY_SETTING_ID),a=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function c(i){const s={},a={},o={};g(i,o);for(let h in o){h=h.length>150?h.substr(h.length-149):h;const b=o[h];typeof b=="number"?a[h]=b:typeof b=="boolean"?a[h]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${b.length}`),s[h]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(s[h]=b)}return{properties:s,measurements:a}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const s=(0,O.getRemoteName)(i);return u.has(s)?s:"other"}e.cleanRemoteAuthority=f;function g(i,s,a=0,o){if(!!i)for(const h of Object.getOwnPropertyNames(i)){const b=i[h],y=o?o+h:h;Array.isArray(b)?s[y]=(0,L.safeStringify)(b):b instanceof Date?s[y]=b.toISOString():(0,U.isObject)(b)?a<2?g(b,s,a+1,y+"."):s[y]=(0,L.safeStringify)(b):s[y]=b}}function v(i,s){const a=i.msftInternalDomains||[],o=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(a)||o}e.isInternalTelemetry=v;function R(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=R;function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const o=[];for(const k of s)for(;;){const T=k.exec(i);if(!T)break;o.push([T.index,k.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(a="";;){const k=b.exec(i);if(!k)break;const T=o.some(([F,j])=>k.index<j&&F<b.lastIndex);!h.test(k[0])&&!T&&(a+=i.substring(y,k.index)+"<REDACTED: user-file-path>",y=b.lastIndex)}return y<i.length&&(a+=i.substr(y)),a}function r(i){if(!i)return i;const s=i.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of a)if(o.regex.test(s))return`<REDACTED: ${o.label}>`;return i}function t(i,s){return(0,L.cloneAndChange)(i,a=>{if(a instanceof w)return a.value;if(typeof a=="string"){let o=a.replaceAll("%20"," ");o=n(o,s);for(const h of s)o=o.replace(h,"");return o=r(o),o}})}e.cleanData=t}),define(re[33],oe([0,1,27,29,46,4,11,10,36,47]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const s=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,s,a)}static parse(i){const s=S.exec(i);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=p;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(t){const i=d.exec(t);return i&&i[1]?[c(i[1]),i[2]]:[c(t),void 0]}e.getIdAndVersion=m;function C(t,i){return`${t}.${i}`}e.getExtensionId=C;function c(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function u(t,i){return c(C(t,i))}e.getGalleryExtensionId=u;function f(t,i){const s=[],a=o=>{for(const h of s)if(h.some(b=>P(i(b),i(o))))return h;return null};for(const o of t){const h=a(o);h?h.push(o):s.push([o])}return s}e.groupByExtension=f;function g(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(t){return{id:new w.TelemetryTrustedValue(t.identifier.id),name:new w.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function R(t,i){const s=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&s.every(h=>!P(h.identifier,{id:o}))){const h=t.filter(b=>P(b.identifier,{id:o}));h.length===1&&(s.push(h[0]),a.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=R;async function n(t,i){if(!A.isLinux)return!1;let s;try{s=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),a=(0,U.getTargetPlatform)(s?"alpine":A.platform,I.arch);return i.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(re[237],oe([0,1,21,2,23,11,196,14,26,6,3,13,4,36,163,33]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let c=class extends U.Disposable{constructor(R,n){super(),this.b=R,this.c=n,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(R){return this.f(R)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(R){const n=[];for(const[r,t]of this.a)if(!(t.configScheme&&t.configScheme!==R.scheme))try{const i=await this.b.readFile((0,l.joinPath)(R,r)),s=new Map;Object.entries(t.recommendations).forEach(([o,h])=>{if((0,L.isNonEmptyArray)(h.remotes))for(const b of h.remotes)s.set(b,{extensionId:o,extensionName:h.name,configName:t.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled});else n.push({extensionId:o,extensionName:h.name,configName:t.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})});const a=(0,O.getDomainsOfRemotes)(i.value.toString(),[...s.keys()]);for(const o of a){const h=s.get(o);h&&n.push(h)}}catch{}return n}};c=ye([K(0,D.IFileService),K(1,I.IProductService)],c),e.ExtensionTipsService=c;const u="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";class g extends c{constructor(R,n,r,t,i,s,a,o){super(a,o),this.m=R,this.n=n,this.p=r,this.q=t,this.r=i,this.s=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,o.exeBasedExtensionTips&&Object.entries(o.exeBasedExtensionTips).forEach(([h,b])=>{const y=[],k=[],T=[];Object.entries(b.recommendations).forEach(([F,j])=>{j.important?b.important?y.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):k.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):T.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),y.length&&this.g.set(h,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:y}),k.length&&this.h.set(h,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:k}),T.length&&this.j.set(h,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:T})}),(0,w.timeout)(3e3).then(async()=>{await this.t(),this.v(),this.w()})}async getImportantExecutableBasedTips(){const R=await this.J(this.g),n=await this.J(this.h);return[...R,...n]}getOtherExecutableBasedTips(){return this.J(this.j)}async t(){const R=await this.J(this.g),n=await this.J(this.h),r=await this.q.getInstalled();this.k=this.u(R,r),this.l=this.u(n,r)}u(R,n){const r=new Map;R.forEach(o=>r.set(o.extensionId.toLowerCase(),o));const{installed:t,uninstalled:i}=this.I([...r.keys()],n);for(const o of t){const h=r.get(o);h&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:o,exeName:h.exeName})}for(const o of i){const h=r.get(o);h&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:o,exeName:h.exeName})}const s=this.G(),a=new Map;for(const o of i){const h=r.get(o);if(h&&(!s[h.exeName]||!s[h.exeName].includes(h.extensionId))){let b=a.get(h.exeName);b||(b=[],a.set(h.exeName,b)),b.push(h)}}return a}v(){if(this.k.size===0)return;const[R,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.H(n[0].exeName,n);break;case"ignored":this.k.delete(R);break;case"incompatibleWindow":{const t=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(t(()=>this.v()));break}case"toomany":{const t=this.D((0,w.disposableTimeout)(()=>{t.dispose(),this.v()},36e5));break}}})}w(){if(this.l.size===0)return;const R=this.C(),n=Date.now()-R,r=7*24*60*60*1e3;if(n<r){const s=this.D((0,w.disposableTimeout)(()=>{s.dispose(),this.w()},r-n));return}const[t,i]=[...this.l.entries()][0];this.z(i).then(s=>{switch(s){case"reacted":{this.F(Date.now()),this.l.delete(t),this.H(i[0].exeName,i);const a=this.D((0,w.disposableTimeout)(()=>{a.dispose(),this.w()},r));break}case"ignored":this.l.delete(t),this.w();break;case"incompatibleWindow":{const a=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(a(()=>this.w()));break}case"toomany":{const a=this.D((0,w.disposableTimeout)(()=>{a.dispose(),this.w()},36e5));break}}})}async z(R){const n=await this.q.getInstalled(1),r=R.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(s=>n.every(a=>!(0,C.areSameExtensions)(a.identifier,{id:s})))).map(({extensionId:i})=>i.toLowerCase()),t=(0,m.localize)(0,null,R[0].exeFriendlyName);return this.s.promptImportantExtensionsInstallNotification(r,t,`@exe:"${R[0].exeName}"`,3)}C(){let R=this.r.getNumber(f,-1);return R||(R=Date.now(),this.F(R)),R}F(R){this.r.store(f,R,-1,1)}G(){return JSON.parse(this.r.get(u,-1,"{}"))}H(R,n){const r=this.G();r[R]=n.map(({extensionId:t})=>t.toLowerCase()),this.r.store(u,JSON.stringify(r),-1,0)}I(R,n){const r=[],t=[],i=n.reduce((s,a)=>(s.add(a.identifier.id.toLowerCase()),s),new Set);return R.forEach(s=>{i.has(s.toLowerCase())?r.push(s):t.push(s)}),{installed:r,uninstalled:t}}async J(R){const n=[],r=new Map;for(const t of R.keys()){const i=R.get(t);if(!i||!(0,L.isNonEmptyArray)(i.recommendations))continue;const s=[];p.isWindows?i.windowsPath&&s.push(i.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(s.push((0,S.join)("/usr/local/bin",t)),s.push((0,S.join)("/usr/bin",t)),s.push((0,S.join)(this.m.fsPath,t)));for(const a of s){let o=r.get(a);if(o===void 0&&(o=await this.b.exists(A.URI.file(a)),r.set(a,o)),o)for(const{extensionId:h,extensionName:b,isExtensionPack:y,whenNotInstalled:k}of i.recommendations)n.push({extensionId:h,extensionName:b,isExtensionPack:y,exeName:t,exeFriendlyName:i.exeFriendlyName,windowsPath:i.windowsPath,whenNotInstalled:k})}}return n}}e.AbstractNativeExtensionTipsService=g}),define(re[238],oe([0,1,25,33]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(A,O,D,I,w){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const S=await A.getInstalled(1);for(const[p,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:m,autoMigrate:C,preRelease:c}=d.extension;if(!C)continue;const u=S.find(g=>(0,U.areSameExtensions)(g.identifier,{id:p}));if(!u)continue;const f=(await O.getExtensions([{id:m,preRelease:c}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!f){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${m}' extension...`);const g=!I.getDisabledExtensions().some(R=>(0,U.areSameExtensions)(R,u.identifier));await A.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let v=S.find(R=>(0,U.areSameExtensions)(R.identifier,{id:m}));(!v||!v.isPreReleaseVersion&&g)&&(v=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${v.identifier.id}'`),g||(await I.disableExtension(v.identifier),w.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),C.storage&&(D.addToMigrationList((0,U.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,U.getExtensionId)(v.manifest.publisher,v.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${m}' extension.`)}catch(g){w.error(g)}}}catch(P){w.error(P)}}e.migrateUnsupportedExtensions=l}),define(re[239],oe([0,1,3,2,37,33,46]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends U.Disposable{constructor(w,P,S,p,d,m,C){super(),this.f=w,this.g=P,this.h=S,this.i=p,this.j=d,this.k=m,this.l=C,this.a=this.D(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.D(new U.DisposableMap),this.m().then(null,c=>C.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.z()}n(){this.D(this.h.onDidChangeProfiles(w=>this.p(w.added,w.removed))),this.D(this.i.onAddExtensions(w=>this.q(w))),this.D(this.i.onDidAddExtensions(w=>this.r(w))),this.D(this.i.onRemoveExtensions(w=>this.s(w))),this.D(this.i.onDidRemoveExtensions(w=>this.t(w))),this.D(this.k.onDidFilesChange(w=>this.u(w)))}async p(w,P){try{await Promise.all(P.map(S=>(this.c.deleteAndDispose(S.id),this.y(S.extensionsResource)))),w.length&&await Promise.all(w.map(S=>(this.c.set(S.id,(0,U.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.w(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async q(w){for(const P of w.extensions)this.C(this.G(P.identifier,P.version),w.profileLocation)}async r(w){for(const P of w.extensions){const S=this.G(P.identifier,P.version);w.error?this.F(S,w.profileLocation):this.C(S,w.profileLocation)}}async s(w){for(const P of w.extensions)this.F(this.G(P.identifier,P.version),w.profileLocation)}async t(w){const P=[],S=[];for(const p of w.extensions){const d=this.G(p.identifier,p.version);w.error?this.C(d,w.profileLocation):(this.F(d,w.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",p.identifier.id,p.version),S.push(this.f.scanInstalledExtensionAtLocation(p.location).then(m=>{m?P.push(m):this.l.info("Extension not found at the location",p.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(S),P.length&&await this.z(P)}catch(p){this.l.error(p)}}u(w){for(const P of this.h.profiles)w.contains(P.extensionsResource,0,1)&&this.v(P.extensionsResource)}async v(w){const P=[],S=[],p=await this.i.scanProfileExtensions(w),d=new Set,m=new Set;for(const[C,c]of this.b)c.has(w)&&m.add(C);for(const C of p){const c=this.G(C.identifier,C.version);d.add(c),m.has(c)||(P.push(C.identifier),this.C(c,w))}for(const C of m)if(!d.has(C)){const c=this.H(C);c&&(S.push(c.identifier),this.F(C,w))}(P.length||S.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:w}:void 0,removed:S.length?{extensions:S,profileLocation:w}:void 0})}async w(w){const P=await this.i.scanProfileExtensions(w);for(const S of P)this.C(this.G(S.identifier,S.version),w)}async y(w){for(const P of[...this.b.keys()])this.F(P,w);await this.z()}async z(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.G(S.identifier,S.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}C(w,P){let S=this.b.get(w);S||this.b.set(w,S=new l.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),S.add(P)}F(w,P){const S=this.b.get(w);S&&S.delete(P),S?.size||this.b.delete(w)}G(w,P){return`${O.ExtensionIdentifier.toKey(w.id)}@${P}`}H(w){const[P,S]=(0,A.getIdAndVersion)(w);return S?{identifier:{id:P},version:S}:void 0}}e.ExtensionsWatcher=D}),define(re[240],oe([0,1,44,47]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(A,O,D,I,w,P,S){const p={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,U.supportsTelemetry)(O,D)&&(0,U.getTelemetryLevel)(I)===3){const d=await(0,L.getServiceMachineId)(D,w,P),{machineId:m}=await S.getTelemetryInfo();p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=m||d}return p}e.resolveMarketplaceHeaders=l}),define(re[241],oe([0,1,102,21,6,2,22,13,28,15,29,33,9,72,11]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let C=class extends d.LanguagePackBaseService{constructor(g,v,R,n){super(R),this.h=g,this.i=n,this.g=this.D(new c(v,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(g,v){const n=(await this.g.getLanguagePacks())[v];if(!n){this.i.warn(`No language pack found for ${v}`);return}const r=n.translations[g];return r?m.URI.file(r):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),v=Object.keys(g).map(R=>{const n=g[R];return{...this.f(R,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((R,n)=>R.label.localeCompare(n.label)),v}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const v=await this.g.getLanguagePacks();Object.keys(v).some(R=>v[R]&&v[R].extensions.some(n=>(0,S.areSameExtensions)(n.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),R=await this.g.update(v);return!(0,U.equals)(Object.keys(g),Object.keys(R))}};C=ye([K(0,P.IExtensionManagementService),K(1,w.INativeEnvironmentService),K(2,P.IExtensionGalleryService),K(3,p.ILogService)],C),e.NativeLanguagePackService=C;let c=class extends A.Disposable{constructor(g,v){super(),this.i=v,this.c={},this.f=(0,D.join)(g.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(v=>{Object.keys(v).forEach(R=>delete v[R]),this.j(v,...g)}).then(()=>this.c)}j(g,...v){for(const R of v)R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&this.k(g,R);Object.keys(g).forEach(R=>this.l(g[R]))}k(g,v){const R=v.identifier,n=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const r of n)if(v.location.scheme===O.Schemas.file&&u(r)){let t=g[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},g[r.languageId]=t);const i=t.extensions.filter(s=>(0,S.areSameExtensions)(s.extensionIdentifier,R))[0];i?i.version=v.manifest.version:t.extensions.push({extensionIdentifier:R,version:v.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,D.join)(v.location.fsPath,s.path)}}l(g){if(g){const v=(0,L.createHash)("md5");for(const R of g.extensions)v.update(R.extensionIdentifier.uuid||R.extensionIdentifier.id).update(R.version);g.hash=v.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let v=null;return I.Promises.readFile(this.f,"utf8").then(void 0,R=>R.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(R)).then(R=>{try{return JSON.parse(R)}catch{return{}}}).then(R=>(v=g(R),R)).then(R=>{for(const r of Object.keys(R))R[r]||delete R[r];this.c=R,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),I.Promises.writeFile(this.f,n)}).then(()=>v,R=>this.i.error(R))})}};c=ye([K(0,w.INativeEnvironmentService),K(1,p.ILogService)],c);function u(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const g of f.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(re[242],oe([0,1,10,32,47]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function D(w,P,S){const p=await new Promise((u,f)=>{te(["@microsoft/1ds-core-js"],u,f)}),d=await new Promise((u,f)=>{te(["@microsoft/1ds-post-js"],u,f)}),m=new p.AppInsightsCore,C=new d.PostChannel,c={instrumentationKey:w,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[C]]};if(S){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:S};c.extensionConfig[C.identifier]=u}return m.initialize(c,[]),m.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class I{constructor(P,S,p,d,m){this.e=P,this.f=S,this.g=p,this.h=m,this.c=A,this.d=O,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=D(this.a,this.e,this.h)),this.b.then(S=>{P(S)},S=>{(0,L.onUnexpectedError)(S),console.error(S)})}}log(P,S){if(!this.a)return;S=(0,U.mixin)(S,this.g),S=(0,l.validateTelemetryData)(S);const p=this.f+"/"+P;try{this.i(d=>{d.pluginVersionString=S?.properties.version??"Unknown",d.track({name:p,baseData:{name:p,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[114],oe([0,1,2,177,15,9,26,47]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends L.Disposable{constructor(P,S,p,d,m=""){super(),this.b=m;const C=S.getLogger(D.telemetryLogId);if(C)this.a=this.D(C);else{const u=(0,D.isLoggingOnly)(d,p)?" (Not Sent)":"",f=()=>(0,D.supportsTelemetry)(d,p)&&P.getLevel()===A.LogLevel.Trace;this.a=this.D(S.createLogger(D.telemetryLogId,{name:(0,U.localize)(0,null,u),hidden:!f()})),this.D(P.onDidChangeLogLevel(()=>S.setVisibility(D.telemetryLogId,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,D.validateTelemetryData)(S))}};I=ye([K(0,A.ILogService),K(1,A.ILoggerService),K(2,l.IEnvironmentService),K(3,O.IProductService)],I),e.TelemetryLogAppender=I}),define(re[115],oe([0,1,2,32,4,27,178,17,45,107,26,40,19,47]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,f,g){this.k=f,this.l=g,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(p.TELEMETRY_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,f){this.d[u]=f}m(){let u=(0,d.getTelemetryLevel)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const g=f.usage?3:f.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,f=u.sessionID,g=u["common.machineId"],v=u["common.firstSessionDate"],R=u["common.msftInternal"];return{sessionId:f,machineId:g,firstSessionDate:v,msftInternal:R}}dispose(){this.i.dispose()}n(u,f,g){return this.g<f?Promise.resolve(void 0):this.c.then(v=>{g=(0,U.mixin)(g,this.d),g=(0,d.cleanData)(g,this.j),g=(0,U.mixin)(g,v),this.b.forEach(R=>R.log(u,g))},v=>{console.error(v)})}publicLog(u,f){return this.n(u,3,f)}publicLog2(u,f){return this.publicLog(u,f)}publicLogError(u,f){return this.h?this.n(u,2,f):Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ye([K(1,D.IConfigurationService),K(2,P.IProductService)],m),e.TelemetryService=m;function C(){const c=(0,O.localize)(0,null,w.default.nameLong),u=w.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=l.isWeb?"":(0,O.localize)(3,null),g=(0,O.localize)(4,null),v=(0,O.localize)(5,null),R=(0,O.localize)(6,null),n=(0,O.localize)(7,null),r=`
|       | ${g} | ${v} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${c} ${u} ${f}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,O.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,O.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[243],oe([0,1,296,242]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends U.AbstractOneDataSystemAppender{constructor(O,D,I,w){const P={sendPOST:(S,p)=>{const d={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const m=L.request(S.urlString,d,C=>{C.on("data",function(c){p(C.statusCode??200,C.headers,c.toString())}),C.on("error",function(c){p(0,{})})});m.write(S.data),m.end()}catch{p(0,{})}}};super(O,D,I,w,P)}}e.OneDataSystemAppender=l}),define(re[244],oe([0,1,22,65,17,15,9,26,19,113,114,115]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(m,C,c,u,f,g){this.b=m,this.c=C,this.d=c,this.e=u,this.f=f,this.g=g,this.a=new Map}async h(m){if(!this.a.has(m.id)){const{machineId:C,sessionId:c}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=C,u["common.vscodesessionid"]=c;const f=[m.id,JSON.stringify(u),m.aiKey],v=new U.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new w.TelemetryAppenderClient(v),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${m.id}] `)];this.a.set(m.id,new S.TelemetryService({appenders:R,sendErrorTelemetry:m.sendErrorTelemetry},this.b,this.g))}return this.a.get(m.id)}async publicLog(m,C,c){await(await this.h(m)).publicLog(C,c)}async publicLogError(m,C,c){await(await this.h(m)).publicLogError(C,c)}};p=ye([K(0,l.IConfigurationService),K(1,I.ITelemetryService),K(2,O.ILogService),K(3,O.ILoggerService),K(4,A.IEnvironmentService),K(5,D.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[116],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(re[245],oe([0,1,4,116]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(I){this.collections=I,this.map=new Map,I.forEach((w,P)=>{const S=w.map.entries();let p=S.next();for(;!p.done;){const d=p.value[0];let m=this.map.get(d);if(m||(m=[],this.map.set(d,m)),m.length>0&&m[0].type===U.EnvironmentVariableMutatorType.Replace){p=S.next();continue}const C=p.value[1];m.unshift({extensionIdentifier:P,value:C.value,type:C.type}),p=S.next()}})}async applyToProcessEnvironment(I,w){let P;L.isWindows&&(P={},Object.keys(I).forEach(S=>P[S.toLowerCase()]=S));for(const[S,p]of this.map){const d=L.isWindows&&P[S.toLowerCase()]||S;for(const m of p){const C=w?await w(m.value):m.value;switch(m.type){case U.EnvironmentVariableMutatorType.Append:I[d]=(I[d]||"")+C;break;case U.EnvironmentVariableMutatorType.Prepend:I[d]=C+(I[d]||"");break;case U.EnvironmentVariableMutatorType.Replace:I[d]=C;break}}}}diff(I){const w=new Map,P=new Map,S=new Map;if(I.map.forEach((p,d)=>{const m=this.map.get(d),C=A(p,m);C&&w.set(d,C)}),this.map.forEach((p,d)=>{const m=I.map.get(d),C=A(p,m);C&&S.set(d,C)}),this.map.forEach((p,d)=>{const m=I.map.get(d),C=O(p,m);C&&P.set(d,C)}),!(w.size===0&&P.size===0&&S.size===0))return{added:w,changed:P,removed:S}}}e.MergedEnvironmentVariableCollection=l;function A(D,I){if(!I)return D;const w=new Set;I.forEach(S=>w.add(S.extensionIdentifier));const P=[];return D.forEach(S=>{w.has(S.extensionIdentifier)||P.push(S)}),P.length===0?void 0:P}function O(D,I){if(!I)return;const w=new Map;I.forEach(S=>w.set(S.extensionIdentifier,S));const P=[];return D.forEach(S=>{const p=w.get(S.extensionIdentifier);p&&(S.type!==p.type||S.value!==p.value)&&P.push(p)}),P.length===0?void 0:P}}),define(re[246],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(O){return[...O.entries()]}e.serializeEnvironmentVariableCollection=L;function U(O){return new Map(O)}e.deserializeEnvironmentVariableCollection=U;function l(O){return Array.from(O.entries()).map(D=>[D[0],L(D[1].map)])}e.serializeEnvironmentVariableCollections=l;function A(O){return new Map(O.map(D=>[D[0],{map:U(D[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(re[247],oe([0,1,6,25,3,2,9]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends A.Disposable{constructor(w,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.D(new l.Emitter),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w}createRequest(w){return new Promise((P,S)=>{const p=++this.a;this.c.set(p,P),this.g.fire({requestId:p,...w});const d=new U.CancellationTokenSource;(0,L.timeout)(this.b,d.token).then(()=>S(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,A.toDisposable)(()=>d.cancel())])})}acceptReply(w,P){const S=this.c.get(w);S?(this.c.delete(w),(0,A.dispose)(this.f.get(w)||[]),this.f.delete(w),S(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};D=ye([K(1,O.ILogService)],D),e.RequestStore=D}),define(re[117],oe([0,1,5,69]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new U.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(l=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var A;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(A=e.TerminalSettingId||(e.TerminalSettingId={}));var O;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var D;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(D=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Logger="logger",g.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var P;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var d;(function(g){g.TerminalView="view",g.Editor="editor"})(d=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var C;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(C=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}));var u;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var f;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(f=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[248],oe([0,1,52,11,180,134]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(p,d){const m=[{name:null,description:(0,l.localize)(0,null)}];return m.push(...p.map(C=>({name:C.profileName,description:D(C)}))),d&&m.push(...d.map(C=>({name:C.title,description:I(C)}))),{values:m.map(C=>C.name),markdownDescriptions:m.map(C=>C.description)}}e.createProfileSchemaEnums=O;function D(p){let d=`$(${A.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:L.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?d+=`
- args: "${p.args}"`:d+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(d+=`
- overrideName: ${p.overrideName}`),p.color&&(d+=`
- color: ${p.color}`),p.env&&(d+=`
- env: ${JSON.stringify(p.env)}`),d}function I(p){return`$(${A.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:L.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function w(p,d){if(!p&&!d)return!0;if(typeof p=="string"&&typeof d=="string")return p===d;if(Array.isArray(p)&&Array.isArray(d)){if(p.length!==d.length)return!1;for(let m=0;m<p.length;m++)if(p[m]!==d[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function P(p,d){if(!p&&!d)return!0;if(!p||!d)return!1;if(A.ThemeIcon.isThemeIcon(p)&&A.ThemeIcon.isThemeIcon(d))return p.id===d.id&&p.color===d.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof d=="object"&&"light"in d&&"dark"in d){const m=p,C=d;if((U.URI.isUri(m.light)||S(m.light))&&(U.URI.isUri(m.dark)||S(m.dark))&&(U.URI.isUri(C.light)||S(C.light))&&(U.URI.isUri(C.dark)||S(C.dark)))return m.light.path===C.light.path&&m.dark.path===C.dark.path}if(U.URI.isUri(p)&&U.URI.isUri(d)||S(p)||S(d)){const m=p,C=d;return m.path===C.path&&m.scheme===C.scheme}return!1}e.terminalIconsEqual=P;function S(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=S}),define(re[249],oe([0,1,52,179,45,40,248]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),v=>`$(${v.id})`)};const D={args:{description:(0,U.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,U.localize)(1,null),type:"boolean"},icon:{description:(0,U.localize)(2,null),...e.terminalIconSchema},color:{description:(0,U.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,U.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},w={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(6,null),type:["string"],items:{type:"string"}},...D}},P=(0,U.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,U.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,U.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,U.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,U.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),C=(0,U.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,U.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,U.localize)(26,null)}},{type:"string",markdownDescription:(0,U.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,U.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(30,null),type:"string"},id:{description:(0,U.localize)(31,null),type:"string"},title:{description:(0,U.localize)(32,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(34,null),type:"string"},id:{description:(0,U.localize)(35,null),type:"string"},title:{description:(0,U.localize)(36,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(38,null),type:"string"},id:{description:(0,U.localize)(39,null),type:"string"},title:{description:(0,U.localize)(40,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,U.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,U.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,U.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,U.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,U.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){A.Registry.as(l.Extensions.Configuration).registerConfiguration(c),g()}e.registerTerminalPlatformConfiguration=u;let f;function g(v,R){const n=A.Registry.as(l.Extensions.Configuration);let r;v&&(r=(0,O.createProfileSchemaEnums)(v?.profiles,R));const t=f;f={id:"terminal",order:100,title:(0,U.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[f],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(re[250],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(re[251],oe([0,1,34,22,32,13,4,36,27,12,28,116,246,245]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}e.getWindowsBuildNumber=m;async function C(i,s,a,o=D.env,h=P.Promises.exists){if(A.isAbsolute(i))return await h(i)?i:void 0;if(s===void 0&&(s=D.cwd()),A.dirname(i)!=="."){const T=A.join(s,i);return await h(T)?T:void 0}const y=(0,l.getCaseInsensitive)(o,"PATH");if(a===void 0&&(0,w.isString)(y)&&(a=y.split(A.delimiter)),a===void 0||a.length===0){const T=A.join(s,i);return await h(T)?T:void 0}for(const T of a){let F;if(A.isAbsolute(T)?F=A.join(T,i):F=A.join(s,T,i),await h(F))return F;if(O.isWindows){let j=F+".com";if(await h(j)||(j=F+".exe",await h(j)))return j}}const k=A.join(s,i);return await h(k)?k:void 0}e.findExecutable=C;function c(i,s,a,o,h){const b=O.isWindows&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||b)return;const y=i.args,k=D.platform==="win32"?A.basename(i.executable).toLowerCase():A.basename(i.executable),T=A.dirname(U.FileAccess.asFileUri("").fsPath);let F;const j={VSCODE_INJECTION:"1"};if(O.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!y||r(y)?F=g.get(f.WindowsPwsh):n(y)&&(F=g.get(f.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T,""),s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:j}):void 0;o.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(k){case"bash":return!y||y.length===0?F=g.get(f.Bash):t(y)&&(j.VSCODE_SHELL_LOGIN="1",u(s,j),F=g.get(f.Bash)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T),{newArgs:F,envMixin:j}):void 0;case"fish":{const B=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=A.join(T,"out/vs/workbench/contrib/xdg_data");return j.XDG_DATA_DIRS=`${B}:${V}`,u(s,j),{newArgs:void 0,envMixin:j}}case"pwsh":return!y||r(y)?F=g.get(f.Pwsh):n(y)&&(F=g.get(f.PwshLogin)),F?(s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T,""),{newArgs:F,envMixin:j}):void 0;case"zsh":{if(!y||y.length===0?F=g.get(f.Zsh):t(y)?(F=g.get(f.ZshLogin),u(s,j)):(y===g.get(f.Zsh)||y===g.get(f.ZshLogin))&&(F=y),!F)return;F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T);let B;try{B=L.userInfo().username}catch{B="unknown"}const V=A.join(L.tmpdir(),`${B}-${h.applicationName}-zsh`);j.ZDOTDIR=V;const W=a?.ZDOTDIR??L.homedir()??"~";j.USER_ZDOTDIR=W;const Q=[];return Q.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(V,".zshrc")}),Q.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(V,".zprofile")}),Q.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(V,".zshenv")}),Q.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(V,".zlogin")}),{newArgs:F,envMixin:j,filesToCopy:Q}}}o.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=c;function u(i,s){if(O.isMacintosh&&i.environmentVariableCollections){const a=(0,p.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),h=new d.MergedEnvironmentVariableCollection(a).map.get("PATH"),b=[];if(h)for(const y of h)y.type===S.EnvironmentVariableMutatorType.Prepend&&b.push(y.value);b.length>0&&(s.VSCODE_PATH_PREFIX=b.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const g=new Map;g.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(f.Zsh,["-i"]),g.set(f.ZshLogin,["-il"]),g.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],R=["-nol","-nologo"];function n(i){return typeof i=="string"?v.includes(i.toLowerCase()):i.length===1&&v.includes(i[0].toLowerCase())||i.length===2&&(v.includes(i[0].toLowerCase())||v.includes(i[1].toLowerCase()))&&(R.includes(i[0].toLowerCase())||R.includes(i[1].toLowerCase()))}function r(i){return typeof i=="string"?R.includes(i.toLowerCase()):i.length===0||i?.length===1&&R.includes(i[0].toLowerCase())}function t(i){return i==="string"&&v.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&v.includes(i[0].toLowerCase())}}),define(re[252],oe([0,1,50,52,13,4,12,28,94,251]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,S=!0;function p(r,t,i,s,a=process.env,o,h,b,y){return o=o||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},A.isWindows?d(i,o,a,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),y,b):v(o,h,i,r&&typeof r=="object"?{...r}:s.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),y,b,a)}e.detectAvailableProfiles=p;async function d(r,t,i,s,a,o,h,b,y){const k=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${k?"Sysnative":"System32"}`;let F=!1;(0,w.getWindowsBuildNumber)()>=16299&&(F=!0),await c(b);const j=new Map;if(r){j.set("PowerShell",{source:"PowerShell",icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),j.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:U.Codicon.terminalCmd,isAutoDetected:!0}),j.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),j.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:U.Codicon.terminalBash,isAutoDetected:!0});const V=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;j.set("Cmder",{path:`${T}\\cmd.exe`,args:["/K",V],requiresPath:process.env.CMDER_ROOT?V:{path:V,isUnsafe:!0},isAutoDetected:!0})}R(o,j);const B=await m(j.entries(),h,t,i,s,y);if(r||a)try{const V=await f(`${T}\\${F?"wsl":"bash"}.exe`,h);for(const W of V)(!o||!(W.profileName in o))&&B.push(W)}catch{S&&(s?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return B}async function m(r,t,i,s=process.env,a,o){const h=[];for(const[b,y]of r){if(y===null)continue;let k,T,F;if("source"in y){const W=P?.get(y.source);if(!W)continue;k=W.paths,T=y.args||W.args,y.icon?F=C(y.icon):W.icon&&(F=W.icon)}else k=Array.isArray(y.path)?y.path:[y.path],T=A.isWindows||Array.isArray(y.args)?y.args:void 0,F=C(y.icon);let j;if(o){const W=k.map(X=>typeof X=="string"?X:X.path),Q=await o(W);j=new Array(k.length);for(let X=0;X<k.length;X++)typeof k[X]=="string"?j[X]=Q[X]:j[X]={path:Q[X],isUnsafe:!0}}else j=k.slice();let B;if(y.requiresPath){let W;if((0,O.isString)(y.requiresPath)?W=y.requiresPath:(W=y.requiresPath.path,y.requiresPath.isUnsafe&&(B=W)),!await i.existsFile(W))continue}const V=await n(b,t,j,i,s,T,y.env,y.overrideName,y.isAutoDetected,B);V?(V.isAutoDetected=y.isAutoDetected,V.icon=F,V.color=y.color,h.push(V)):a?.debug("Terminal profile not validated",b,k)}return a?.debug("Validated terminal profiles",h),h}function C(r){return typeof r=="string"?{id:r}:r}async function c(r){P&&!r||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:U.Codicon.terminalPowershell}))}async function u(){const r=[];for await(const t of(0,I.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function f(r,t){const i=[],s=await new Promise((h,b)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(y,k)=>{if(y)return b("Problem occurred when getting wsl distros");h(k)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),o=s.split(a).filter(h=>h.trim().length>0&&h!=="");for(const h of o){if(h===""||h.startsWith("docker-desktop"))continue;const b=`${h} (WSL)`,y={profileName:b,path:r,args:["-d",`${h}`],isDefault:b===t,icon:g(h),isAutoDetected:!1};i.push(y)}return i}function g(r){return r.includes("Ubuntu")?U.Codicon.terminalUbuntu:r.includes("Debian")?U.Codicon.terminalDebian:U.Codicon.terminalLinux}async function v(r,t,i,s,a,o,h,b){const y=new Map;if(i){const k=(await r.readFile("/etc/shells")).toString(),T=o||k.split(`
`).filter(j=>j.trim().includes("#")&&j.trim().length>0),F=new Map;for(const j of T){let B=(0,l.basename)(j),V=F.get(B)||0;V++,V>1&&(B=`${B} (${V})`),F.set(B,V),y.set(B,{path:j,isAutoDetected:!0})}}return R(s,y),await m(y.entries(),a,r,b,t,h)}function R(r,t){if(!!r)for(const[i,s]of Object.entries(r))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?t.delete(i):(s.icon=s.icon||t.get(i)?.icon,t.set(i,s))}async function n(r,t,i,s,a,o,h,b,y,k){if(i.length===0)return Promise.resolve(void 0);const T=i.shift();if(T==="")return n(r,t,i,s,a,o,h,b,y);const F=typeof T!="string"&&T.isUnsafe,j=typeof T=="string"?T:T.path,B={profileName:r,path:j,args:o,env:h,overrideName:b,isAutoDetected:y,isDefault:r===t,isUnsafePath:F,requiresUnsafePath:k};if((0,l.basename)(j)===j){const W=a.PATH?a.PATH.split(l.delimiter):void 0,Q=await(0,w.findExecutable)(j,void 0,W,void 0,s.existsFile);return Q?(B.path=Q,B.isFromPath=!0,B):n(r,t,i,s,a,o)}return await s.existsFile((0,l.normalize)(j))?B:n(r,t,i,s,a,o,h,b,y)}}),define(re[253],oe([0,1,3,2,22,4,39,65,17,15,97,233,9,247,117,249,252,106]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(R){R[R.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let g=0,v=class extends U.Disposable{constructor(n,r,t,i,s,a){super(),this.z=n,this.C=r,this.F=t,this.G=i,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.D(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.D(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.D(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.D(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.q=this.D(new L.Emitter),this.onPtyHostRequestResolveVariables=this.q.event,this.r=this.D(new L.Emitter),this.onProcessData=this.r.event,this.s=this.D(new L.Emitter),this.onProcessReady=this.s.event,this.t=this.D(new L.Emitter),this.onProcessReplay=this.t.event,this.u=this.D(new L.Emitter),this.onProcessOrphanQuestion=this.u.event,this.v=this.D(new L.Emitter),this.onDidRequestDetach=this.v.event,this.w=this.D(new L.Emitter),this.onDidChangeProperty=this.w.event,this.y=this.D(new L.Emitter),this.onProcessExit=this.y.event,(0,C.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.D((0,U.toDisposable)(()=>this.O())),this.f=this.D(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.q.fire,this.q),[this.a,this.b]=this.N(),this.D(this.F.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(A.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(n){return this.H.error("ptyHost was unable to resolve shell environment",n),{}}}N(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_PTY_REMOTE:this.C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.z.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.z.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.z.scrollback}},r=(0,P.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new D.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),O.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.D(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=f.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.D(new u.RemoteLoggerChannelClient(this.I,t.getChannel(m.TerminalIpcChannels.Logger)));const s=O.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.PtyHost));return this.D(s.onProcessData(a=>this.r.fire(a))),this.D(s.onProcessReady(a=>this.s.fire(a))),this.D(s.onProcessExit(a=>this.y.fire(a))),this.D(s.onDidChangeProperty(a=>this.w.fire(a))),this.D(s.onProcessReplay(a=>this.t.fire(a))),this.D(s.onProcessOrphanQuestion(a=>this.u.fire(a))),this.D(s.onDidRequestDetach(a=>this.v.fire(a))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,i,s,a,o,h,b,y,k){const T=setTimeout(()=>this.S(),m.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(n,r,t,i,s,a,o,h,b,y,k);return clearTimeout(T),g=Math.max(g,F),F}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,i){return this.b.updateIcon(n,r,t,i)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,i=!1){const s=await this.c;return(0,c.detectAvailableProfiles)(r,t,i,this.F,s,void 0,this.H,this.W.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,r){return this.b.getWslPath(n,r)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};v=ye([K(2,I.IConfigurationService),K(3,w.IEnvironmentService),K(4,p.ILogService),K(5,p.ILoggerService)],v),e.PtyHostService=v}),define(re[76],oe([0,1,3,17,5,9]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var O;(function(C){C.Http="http",C.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(C){C.ConstantPrivate="constantPrivate",C.Private="private",C.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(C){C[C.Notify=1]="Notify",C[C.OpenBrowser=2]="OpenBrowser",C[C.OpenPreview=3]="OpenPreview",C[C.Silent=4]="Silent",C[C.Ignore=5]="Ignore",C[C.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(C){if(C.scheme!=="http"&&C.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(C.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(C){return e.LOCALHOST_ADDRESSES.indexOf(C)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(C){return e.ALL_INTERFACES_ADDRESSES.indexOf(C)>=0}e.isAllInterfaces=S;function p(C,c,u,f){if(u===1)return!1;if(u===2&&S(c)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(g?.length===4&&parseInt(g[1])>=18)return!1}return C<1024}e.isPortPrivileged=p;class d{constructor(c,u,f){this.remoteAddress=c,this.localAddress=u,this.b=f,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let m=class{constructor(c,u){this.i=c,this.j=u,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const f of u){const g=Array.from(f.values());for(const v of g){const R=await v.value;R&&c.push(R)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(f=>f?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,f,g,v){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:f,privacy:g,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(S(c)||P(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const f=this.q(c,u);if(f)return++f.refcount,f.value}openTunnel(c,u,f,g,v,R=!1,n,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${f} on local port ${v}.`),!c)return;if(u||(u="localhost"),g||(g=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(c,u,f,g,v,R,n,r);return t?t.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const f=u.get(c.tunnelRemotePort);f&&(f.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,f))}}}}async n(c,u,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const g=f.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),g}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const f=this.d.get(c);if(f&&f.has(u)){const g=f.get(u);g.refcount=0,await this.n(c,u,g)}}o(c,u,f){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:f})}async p(c,u){const f=this.d.get(c);f&&(await f.get(u)||f.delete(u),f.size===0&&this.d.delete(c))}q(c,u){const f=[c];P(c)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):S(c)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const g=f.map(v=>this.d.get(v));for(const v of g){const R=v?.get(u);if(R)return R}}canTunnel(c){return!!w(c)}s(c,u,f,g,v,R,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${f} on local port ${g}.`);const r=f;this.h.add(r);const t=g===void 0?f:g,i={elevationRequired:v?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:f},localAddressPort:g,privacy:R,public:R?R!==D.Private:void 0,protocol:n},a=c.forwardPort(s,i);return a?(this.o(u,f,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),a}};m=ye([K(0,A.ILogService),K(1,U.IConfigurationService)],m),e.AbstractTunnelService=m}),define(re[254],oe([0,1,9,76,2,10,6]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.D(P)}}let I=class Dt extends l.Disposable{constructor(P,S){super(),this.f=P,this.g=S,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(P,S,p,d,m,C,c){const u=new D,f=await Promise.resolve(this.f.openTunnel(P,u,p,d,m,C,c));if(!f)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${d} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(S))throw this.c.delete(S),u.dispose(),await f.dispose(),(0,A.canceled)();return u.setTunnel(f),this.b.set(S,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${f.localAddress} (local) to ${p}:${d} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(P,S){const p=this.b.get(P);!p||p.setAddress(S)}async destroyTunnel(P){const S=this.b.get(P);if(S){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await S.dispose();return}this.c.add(P)}};I.a=0,I=ye([K(0,U.ISharedTunnelsService),K(1,L.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[255],oe([0,1,86,34,136,227,6,2,17,9,26,225,76,111,4]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function C(v,R,n,r,t){let i;for(let s=3;s&&(i?.dispose(),i=await new c(v,R,n,r,t).waitForReady(),!(t&&l.BROWSER_RESTRICTED_PORTS[t]||!l.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class c extends D.Disposable{constructor(R,n,r,t,i){super(),this.j=n,this.k=i,this.privacy=p.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=L.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,l.findFreePortFaster)(R,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(R){R.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,S.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,i=r.readEntireBuffer();r.dispose(),i.byteLength>0&&R.write(i.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),t.end()}),R.on("close",()=>t.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),t.destroy()}),t.on("end",()=>R.end()),t.on("close",()=>R.end()),t.on("error",()=>{R.destroy()}),R.pipe(t),t.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),t.end()})}}let u=class extends p.AbstractTunnelService{constructor(R,n,r,t,i){super(n,i),this.t=R,this.u=r,this.v=t}isPortPrivileged(R){return(0,p.isPortPrivileged)(R,this.k,m.OS,U.release())}r(R,n,r,t,i,s,a,o){const h=this.q(n,r);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,n,r,i,s,a,o);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const b={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},y=C(b,t,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,y),y}}};u=ye([K(1,w.ILogService),K(2,d.ISignService),K(3,P.IProductService),K(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let f=class extends u{constructor(R,n,r,t){super(A.nodeSocketFactory,R,n,r,t)}};f=ye([K(0,w.ILogService),K(1,d.ISignService),K(2,P.IProductService),K(3,I.IConfigurationService)],f),e.TunnelService=f;let g=class extends D.Disposable{constructor(R,n,r,t){super(),this.b=R,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(R,n,r,t,i,s,a,o,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(R)){const b=new f(this.b,this.f,this.c,this.g);this.D(b),this.a.set(R,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(n,r,t,i,s,a,o,h)}};g=ye([K(0,w.ILogService),K(1,P.IProductService),K(2,d.ISignService),K(3,I.IConfigurationService)],g),e.SharedTunnelsService=g}),define(re[30],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(re[256],oe([0,1,30,199,14,23,132,3,2]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let P=class{constructor(p){this.g=p,this.c=new I.DisposableStore,this.f=2**16;const d=new Map,m=C=>{let c=d.get(C.scheme);return c===void 0&&(c=p.hasProvider(C)&&!this.g.hasCapability(C,1024),d.set(C.scheme,c)),c};this.c.add(D.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(C=>{d.delete(C.scheme)})),this.extUri=new A.ExtUri(m),this.d=new O.SkipList((C,c)=>this.extUri.compare(C,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,A.normalizePath)(p));const d=this.d.get(p);return d?d.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new w(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((m,C)=>m[1].time<C[1].time?1:m[1].time>C[1].time?-1:0);w._clock=0,this.d.clear();const d=this.f*.5;for(let m=0;m<d;m++)this.d.set(p[m][0],p[m][1].touch())}};P=ye([K(0,l.IFileService)],P),e.UriIdentityService=P,(0,U.registerSingleton)(L.IUriIdentityService,P,1)}),define(re[257],oe([0,1,3,2,14,43,49,16]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends U.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,S,p,d){super(),this.c=P,this.f=S,this.g=p,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.D(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.D(this.f.onDidChangeFile(m=>this.i(m)))}watch(P,S){this.b.set(P,P);const p=this.f.watch(this.j(P),S);return(0,U.toDisposable)(()=>{this.b.delete(P),p.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,S,p){return this.f.rename(this.j(P),this.j(S),p)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,S,p){const d=(0,A.newWriteableStream)(m=>D.VSBuffer.concat(m.map(C=>D.VSBuffer.wrap(C))).buffer);return(async()=>{try{const m=await this.readFile(P);d.end(m)}catch(m){d.error(m),d.end()}})(),d}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,S,p){return this.f.writeFile(this.j(P),S,p)}delete(P,S){return this.f.delete(this.j(P),S)}copy(P,S,p){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(S),p);throw new Error("copy not supported")}i(P){const S=[];for(const p of P){if(p.resource.scheme!==this.c)continue;const d=this.k(p.resource);this.b.findSubstr(d)&&S.push({resource:d,type:p.type})}S.length&&(this.h.debug("User data changed"),this.a.fire(S))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[60],oe([0,1,83]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(O,D,I,w){const P=(0,L.setProperty)(O,D,I,w)[0];return P&&(O=O.substring(0,P.offset)+P.content+O.substring(P.offset+P.length)),O}e.edit=U;function l(O,D,I){let w=I;for(;w>=0;){if(O.charAt(w)===D.charAt(D.length-1)&&D.length===1)return w+1;if(w--,D.length===2&&w>=0&&O.charAt(w)===D.charAt(0))return w+2}return 0}e.getLineStartOffset=l;function A(O,D,I){let w=I;for(;w>=0;)if(O.charAt(w)===D.charAt(D.length-1)&&D.length===1||(w++,D.length===2&&w>=0&&O.charAt(w)===D.charAt(1)))return w;return O.length-1}e.getLineEndOffset=A}),define(re[258],oe([0,1,32,55,12]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(d,m,C,c,u,f){const g=[],v=[],R=[];if(!m){const V=d.filter(({identifier:W})=>u.every(Q=>Q.toLowerCase()!==W.id.toLowerCase()));return{local:{added:g,removed:v,updated:R},remote:V.length>0?{added:V,updated:[],removed:[],all:V}:null}}d=d.map(S),m=m.map(S),C=C?C.map(S):null;const n=new Map,r=V=>{V.uuid&&n.set(V.id.toLowerCase(),V.uuid)};d.forEach(({identifier:V})=>r(V)),m.forEach(({identifier:V})=>r(V)),C?.forEach(({identifier:V})=>r(V));const t=V=>{const W=V.identifier.uuid||n.get(V.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${V.identifier.id.toLowerCase()}`},i=(V,W)=>(V.set(t(W),W),V),s=d.reduce(i,new Map),a=m.reduce(i,new Map),o=m.reduce((V,W)=>i(V,(0,L.deepClone)(W)),new Map),h=C?C.reduce(i,new Map):null,b=c.reduce(i,new Map),y=u.reduce((V,W)=>{const Q=n.get(W.toLowerCase());return V.add(Q?`uuid:${Q}`:`id:${W.toLowerCase()}`)},new Set),k=f?f.reduce((V,{id:W,uuid:Q})=>(Q=Q??n.get(W.toLowerCase()),V.add(Q?`uuid:${Q}`:`id:${W.toLowerCase()}`)),new Set):null,T=O(s,a,y,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const V=O(h,s,y,!1),W=O(h,a,y,!0),Q=(X,Y,Z,H)=>{let $,_,ie;return Y.installed?($=H.pinned,ie=H.preRelease,$&&(_=H.version)):($=Z.pinned,ie=Z.preRelease,$&&(_=Z.version)),$===void 0&&($=Y.pinned,$&&(_=Y.version)),ie===void 0&&(ie=Y.preRelease),{...H,installed:Y.installed||Z.installed,pinned:$,preRelease:ie,version:_??(Z.version&&(!Y.installed||U.gt(Z.version,Y.version))?Z.version:Y.version),state:I(Y,Z,h?.get(X))}};for(const X of W.removed.values()){const Y=s.get(X);if(!Y)continue;const Z=(0,l.assertIsDefined)(h?.get(X)),H=k&&!k.has(X)&&Z.installed;Y.installed&&H?v.push(Y.identifier):o.set(X,Y)}for(const X of W.added.values()){const Y=(0,l.assertIsDefined)(a.get(X)),Z=s.get(X);if(Z){if(T.updated.has(X)){const H=Q(X,Z,Y,Y);D(Z,Y,!1,!1)||R.push(p(H,X)),o.set(X,H)}}else Y.installed&&g.push(p(Y,X))}for(const X of W.updated.values()){const Y=(0,l.assertIsDefined)(a.get(X)),Z=(0,l.assertIsDefined)(h?.get(X)),H=s.get(X);if(H)if(k&&!k.has(X)&&Z.installed&&H.installed&&!Y.installed)v.push(H.identifier);else{const _=Q(X,H,Y,Y);R.push(p(_,X)),o.set(X,_)}else Y.installed&&g.push(p(Y,X))}for(const X of V.added.values())W.added.has(X)||o.set(X,(0,l.assertIsDefined)(s.get(X)));for(const X of V.updated.values()){if(W.removed.has(X)||W.updated.has(X))continue;const Y=(0,l.assertIsDefined)(s.get(X)),Z=(0,l.assertIsDefined)(a.get(X));o.set(X,Q(X,Y,Z,Y))}for(const X of V.removed.values())W.updated.has(X)||W.removed.has(X)||b.has(X)||!(0,l.assertIsDefined)(a.get(X)).installed||!k||k.has(X)||!(0,l.assertIsDefined)(h?.get(X)).installed||o.delete(X)}const F=[],j=O(a,o,new Set,!0),B=j.added.size>0||j.updated.size>0||j.removed.size>0;return B&&o.forEach((V,W)=>F.push(p(V,W))),{local:{added:g,removed:v,updated:R},remote:B?{added:[...j.added].map(V=>o.get(V)),updated:[...j.updated].map(V=>o.get(V)),removed:[...j.removed].map(V=>a.get(V)),all:F}:null}}e.merge=A;function O(d,m,C,c){const u=d?[...d.keys()].filter(n=>!C.has(n)):[],f=[...m.keys()].filter(n=>!C.has(n)),g=f.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),v=u.filter(n=>f.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),R=new Set;for(const n of u){if(v.has(n))continue;const r=d.get(n),t=m.get(n);(!t||!D(r,t,c,!0))&&R.add(n)}return{added:g,removed:v,updated:R}}function D(d,m,C,c){return!(d.disabled!==m.disabled||c&&d.installed!==m.installed||d.installed&&m.installed&&(d.preRelease!==m.preRelease||d.pinned!==m.pinned||m.pinned&&d.version!==m.version)||!P(d.state,m.state)||C&&d.version!==m.version)}function I(d,m,C){const c=d.state,u=m.state,f=C?.state;if(!m.version||c&&U.gt(d.version,m.version))return c;if(u&&U.gt(m.version,d.version)||!c)return u;if(!u)return c;const g=(0,L.deepClone)(c),v=f?w(f,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},R=f?w(f,c):{added:Object.keys(c).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...v.added.values(),...v.updated.values()])g[n]=u[n];for(const n of v.removed.values())R.updated.has(n)||delete g[n];return g}function w(d,m){const C=Object.keys(d),c=Object.keys(m),u=c.filter(v=>C.indexOf(v)===-1).reduce((v,R)=>(v.add(R),v),new Set),f=C.filter(v=>c.indexOf(v)===-1).reduce((v,R)=>(v.add(R),v),new Set),g=new Set;for(const v of C){if(f.has(v))continue;const R=d[v],n=m[v];(0,L.equals)(R,n)||g.add(v)}return{added:u,removed:f,updated:g}}function P(d={},m={}){const{added:C,removed:c,updated:u}=w(d,m);return C.size===0&&c.size===0&&u.size===0}function S(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function p(d,m){const C={identifier:{id:d.identifier.id,uuid:m.startsWith("uuid:")?m.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(C.disabled=!0),d.installed&&(C.installed=!0),d.state&&(C.state=d.state),C}}),define(re[118],oe([0,1,21,17,5]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(D){this.a=D}hasToNeverSyncExtension(D){return this.b().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.b().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==D&&P!==`-${D}`),I&&w.push(D.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(D,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==D&&P!==`-${D}`),I&&w.push(`-${D.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(D){const I=D.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),w=this.b().map(p=>p.toLowerCase()),P=[],S=[];if(Array.isArray(w))for(const p of w)p.startsWith("-")?S.push(p.substring(1)):P.push(p);return(0,L.distinct)([...I,...P].filter(p=>S.indexOf(p)===-1))}b(){let D=this.a.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.a.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};A=ye([K(0,U.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(re[259],oe([0,1,21,35,32,69,60]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(v){return(0,U.parse)(v)||[]}async function I(v,R,n,r,t){const i=D(v),s=D(R),a=n?D(n):null,o=[...i,...s,...a||[]].map(Q=>Q.key),h=await t.resolveUserBindings(o),b=P(i,s,a,h);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const y=p(i),k=p(s),T=a?p(a):null,F=m(y,k,h),j=T?m(T,y,h):{added:[...y.keys()].reduce((Q,X)=>(Q.add(X),Q),new Set),removed:new Set,updated:new Set},B=T?m(T,k,h):{added:[...k.keys()].reduce((Q,X)=>(Q.add(X),Q),new Set),removed:new Set,updated:new Set},V=w(F,j,B);let W=v;for(const Q of V.removed.values())V.conflicts.has(Q)||(W=f(W,Q,r));for(const Q of V.added.values()){if(V.conflicts.has(Q))continue;const X=k.get(Q);if(X.some(Y=>Y.command!==`-${Q}`&&b.conflicts.has(h[Y.key]))){V.conflicts.add(Q);continue}W=u(W,X,r)}for(const Q of V.updated.values()){if(V.conflicts.has(Q))continue;const X=k.get(Q);if(X.some(Y=>Y.command!==`-${Q}`&&b.conflicts.has(h[Y.key]))){V.conflicts.add(Q);continue}W=g(W,Q,X,r)}return{mergeContent:W,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=I;function w(v,R,n){const r=new Set,t=new Set,i=new Set,s=new Set;for(const a of R.removed.values())n.updated.has(a)&&s.add(a);for(const a of n.removed.values())s.has(a)||(R.updated.has(a)?s.add(a):t.add(a));for(const a of R.added.values())s.has(a)||n.added.has(a)&&v.updated.has(a)&&s.add(a);for(const a of n.added.values())s.has(a)||(R.added.has(a)?v.updated.has(a)&&s.add(a):r.add(a));for(const a of R.updated.values())s.has(a)||n.updated.has(a)&&v.updated.has(a)&&s.add(a);for(const a of n.updated.values())s.has(a)||(R.updated.has(a)?v.updated.has(a)&&s.add(a):i.add(a));return{added:r,removed:t,updated:i,conflicts:s}}function P(v,R,n,r){const t=new Set,i=S(v,r),s=S(R,r),a=n?S(n,r):null,o=d(i,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=a?d(a,i):{added:[...i.keys()].reduce((j,B)=>(j.add(B),j),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const b=a?d(a,s):{added:[...s.keys()].reduce((j,B)=>(j.add(B),j),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:y,removed:k,updated:T,conflicts:F}=w(o,h,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:y,removed:k,updated:T,conflicts:F}}function S(v,R){const n=new Map;for(const r of v){const t=R[r.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(r)}return n}function p(v){const R=new Map;for(const n of v){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=R.get(r);t||(t=[],R.set(r,t)),t.push(n)}return R}function d(v,R){const n=[...v.keys()],r=[...R.keys()],t=r.filter(a=>n.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),i=n.filter(a=>r.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),s=new Set;for(const a of n){if(i.has(a))continue;const o=v.get(a).map(b=>({...b,key:a})),h=R.get(a).map(b=>({...b,key:a}));(0,L.equals)(o,h,(b,y)=>c(b,y))||s.add(a)}return{added:t,removed:i,updated:s}}function m(v,R,n){const r=[...v.keys()],t=[...R.keys()],i=t.filter(o=>r.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),s=r.filter(o=>t.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),a=new Set;for(const o of r){if(s.has(o))continue;const h=v.get(o).map(y=>({...y,key:n[y.key]})),b=R.get(o).map(y=>({...y,key:n[y.key]}));C(h,b)||a.add(o)}return{added:i,removed:s,updated:a}}function C(v,R){return!(!(0,L.equals)(v.filter(({command:n})=>n[0]!=="-"),R.filter(({command:n})=>n[0]!=="-"),(n,r)=>c(n,r))||!(0,L.equals)(v.filter(({command:n})=>n[0]==="-"),R.filter(({command:n})=>n[0]==="-"),(n,r)=>c(n,r)))}function c(v,R){if(v.command!==R.command||v.key!==R.key)return!1;const n=A.ContextKeyExpr.deserialize(v.when),r=A.ContextKeyExpr.deserialize(R.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!l.equals(v.args,R.args))}function u(v,R,n){for(const r of R)v=O.edit(v,[-1],r,n);return v}function f(v,R,n){const r=D(v);for(let t=r.length-1;t>=0;t--)(r[t].command===R||r[t].command===`-${R}`)&&(v=O.edit(v,[t],void 0,n));return v}function g(v,R,n,r){const t=D(v),i=t.findIndex(s=>s.command===R||s.command===`-${R}`);for(let s=t.length-1;s>=0;s--)(t[s].command===R||t[s].command===`-${R}`)&&(v=O.edit(v,[s],void 0,r));for(let s=n.length-1;s>=0;s--)v=O.edit(v,[i],n[s],r);return v}}),define(re[260],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(A,O,D){const I={},w={},P=new Set;if(!O)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const S=U(A,O);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=U(D,A),d=U(D,O),m={},C={},c=new Set,u=new Set;for(const f of p.removed.values())d.updated.has(f)?I[f]=O[f]:c.add(f);for(const f of d.removed.values())u.has(f)||(p.updated.has(f)?u.add(f):P.add(f));for(const f of p.updated.values())u.has(f)||(d.updated.has(f)?S.updated.has(f)&&u.add(f):C[f]=A[f]);for(const f of d.updated.values())u.has(f)||(p.updated.has(f)?S.updated.has(f)&&u.add(f):A[f]!==void 0&&(w[f]=O[f]));for(const f of p.added.values())u.has(f)||(d.added.has(f)?S.updated.has(f)&&u.add(f):m[f]=A[f]);for(const f of d.added.values())u.has(f)||(p.added.has(f)?S.updated.has(f)&&u.add(f):I[f]=O[f]);return{local:{added:I,removed:[...P.values()],updated:w},remote:{added:m,removed:[...c.values()],updated:C},conflicts:[...u.values()]}}e.merge=L;function U(A,O){const D=A?Object.keys(A):[],I=O?Object.keys(O):[],w=I.filter(p=>D.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),P=D.filter(p=>I.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),S=new Set;for(const p of D){if(P.has(p))continue;const d=A[p],m=O[p];d!==m&&S.add(p)}return{added:w,removed:P,updated:S}}function l(A,O){const{added:D,removed:I,updated:w}=U(A,O);return D.size===0&&I.size===0&&w.size===0}e.areSame=l}),define(re[261],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(l,A,O,D){const I={added:[],removed:[],updated:[]};let w={added:[],removed:[],updated:[]};if(!A){const S=l.filter(({id:p})=>!D.includes(p));return S.length?w.added=S:w=null,{local:I,remote:w}}const P=U(l,A,D);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const S=U(O,l,D),p=U(O,A,D);for(const d of p.removed){const m=l.find(C=>C.id===d);m&&I.removed.push(m)}for(const d of p.added){const m=A.find(C=>C.id===d);S.added.includes(d)?P.updated.includes(d)&&I.updated.push(m):I.added.push(m)}for(const d of p.updated)I.updated.push(A.find(m=>m.id===d));for(const d of S.added)p.added.includes(d)||w.added.push(l.find(m=>m.id===d));for(const d of S.updated)p.removed.includes(d)||p.updated.includes(d)||w.updated.push(l.find(m=>m.id===d));for(const d of S.removed){const m=A.find(C=>C.id===d);m&&w.removed.push(m)}}return w.added.length===0&&w.removed.length===0&&w.updated.length===0&&(w=null),{local:I,remote:w}}e.merge=L;function U(l,A,O){l=l?l.filter(({id:p})=>!O.includes(p)):[],A=A.filter(({id:p})=>!O.includes(p));const D=l.map(({id:p})=>p),I=A.map(({id:p})=>p),w=I.filter(p=>D.indexOf(p)===-1),P=D.filter(p=>I.indexOf(p)===-1),S=[];for(const{id:p,name:d,shortName:m}of l){if(P.includes(p))continue;const C=A.find(c=>c.id===p);(!C||C.name!==d||C.shortName!==m)&&S.push(p)}return{added:w,removed:P,updated:S}}}),define(re[24],oe([0,1,21,12,186,45,29,5,108,40]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=w.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function S(){const s=w.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(b=>!!s[b].ignoreSync),o=Object.keys(s).filter(b=>s[b].scope===2||s[b].scope===6),h=P();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...o,...h])}e.getDefaultIgnoredSettings=S,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function p(){const s="vscode://schemas/ignoredSettings",a=w.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=w.Registry.as(I.Extensions.JSONContribution),h=()=>{const b=P(),y=S().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),k=Object.keys(A.allSettings.properties).filter(j=>y.indexOf(j)===-1),T=y.filter(j=>b.indexOf(j)===-1),F={items:{type:"string",enum:[...k,...T.map(j=>`-${j}`)]}};o.registerSchema(s,F)};return a.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=p;function d(s){return s&&(0,U.isObject)(s)&&(0,U.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=d;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function C(s,...a){return s?[s,...a]:a}e.getPathSegments=C;function c(s,a,o,h){return h.joinPath(o.userDataSyncHome,...C(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=u;var f;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(f=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(a,o,h,b){super(a),this.code=o,this.resource=h,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class v extends g{constructor(a,o,h,b,y){super(a,h,void 0,y),this.url=o,this.serverCode=b}}e.UserDataSyncStoreError=v;class R extends g{constructor(a,o){super(a,o)}}e.UserDataAutoSyncError=R,function(s){function a(o){if(o instanceof s)return o;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(h&&h[1]){const b=h[2]==="unknown"?void 0:h[2],y=h[3]==="unknown"?void 0:h[3];return new s(o.message,h[1],b,y)}return new s(o.message,"Unknown")}s.toUserDataSyncError=a}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[262],oe([0,1,32,24]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(O,D,I,w,P){if(!D)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const S=A(O,D);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=I?A(I,D):{added:Object.keys(D).reduce((f,g)=>(f.add(g),f),new Set),removed:new Set,updated:new Set},d=I?A(I,O):{added:Object.keys(O).reduce((f,g)=>(f.add(g),f),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},C=L.deepClone(D),c=!I;for(const f of d.added.values())f!==U.SYNC_SERVICE_URL_TYPE&&c&&p.added.has(f)||(C[f]=O[f]);for(const f of d.updated.values())C[f]=O[f];for(const f of d.removed.values())w.unregistered.includes(f)||delete C[f];for(const f of p.added.values()){const g=D[f];if(w.machine.includes(f)){P.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(f))continue;const v=O[f];v&&v.value===g.value||f===U.SYNC_SERVICE_URL_TYPE&&c&&d.added.has(f)||(v?m.updated[f]=g:m.added[f]=g)}for(const f of p.updated.values()){const g=D[f];if(w.machine.includes(f)){P.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(f)||d.removed.has(f))continue;const v=O[f];v&&v.value===g.value||(m.updated[f]=g)}for(const f of p.removed.values()){if(w.machine.includes(f)){P.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}d.updated.has(f)||d.removed.has(f)||m.removed.push(f)}const u=A(D,C);return{local:m,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:C}}}e.merge=l;function A(O,D){const I=Object.keys(O),w=Object.keys(D),P=w.filter(d=>I.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),S=I.filter(d=>w.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),p=new Set;for(const d of I){if(S.has(d))continue;const m=O[d],C=D[d];L.equals(m,C)||p.add(d)}return{added:P,removed:S,updated:p}}}),define(re[263],oe([0,1,21,35,83,42,32,60,24]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(o,h,b){let y=[];b?y=S(b):y=P(h);const k=[],T=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const F of y)F.startsWith("-")?T.push(F.substring(1)):k.push(F);return(0,L.distinct)([...o,...k].filter(F=>T.indexOf(F)===-1))}e.getIgnoredSettings=w;function P(o){let h=o.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=o.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:o.getValue("settingsSync.ignoredSettings")||[]}function S(o){const h=(0,U.parse)(o);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function p(o,h){const b=(0,U.parse)(o)||{};let y="{}";for(const k of Object.keys(b)){const T=(0,l.setProperty)(y,[k],b[k],h);y=(0,l.applyEdits)(y,T)}return y}e.removeComments=p;function d(o,h,b,y){if(b.length){const k=a(h),T=(0,U.parse)(h)||{},F=(0,U.parse)(o);if(!F)return o;const j=[];for(const B of b){const V=T[B],W=F[B];V===void 0?o=D.edit(o,[B],void 0,y):W!==void 0?o=D.edit(o,[B],V,y):j.push(n(B,k))}j.sort((B,V)=>B.startOffset-V.startOffset),j.forEach(B=>o=f(B.setting.key,h,o,y))}return o}e.updateIgnoredSettings=d;function m(o,h,b,y,k,T){const F=d(o,h,y,T),j=b!==F,B=b!==h;if(!j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(B&&!j)return{conflictsSettings:[],localContent:d(h,o,y,T),remoteContent:null,hasConflicts:!1};if(b===null&&c(o)){const N=C(o,h,y)?null:d(h,o,y,T);return{conflictsSettings:[],localContent:N,remoteContent:null,hasConflicts:!1}}let V=o,W=h;const Q=(0,U.parse)(o),X=(0,U.parse)(h),Y=b?(0,U.parse)(b):null,Z=y.reduce((N,z)=>(N.add(z),N),new Set),H=u(Q,X,Z),$=u(Y,Q,Z),_=u(Y,X,Z),ie=new Map,se=new Set,ae=N=>{se.add(N);const z=k.filter(({key:G})=>G===N)[0];z?(V=D.edit(V,[N],z.value,T),W=D.edit(W,[N],z.value,T)):ie.set(N,{key:N,localValue:Q[N],remoteValue:X[N]})};for(const N of $.removed.values())_.updated.has(N)?ae(N):W=D.edit(W,[N],void 0,T);for(const N of _.removed.values())se.has(N)||($.updated.has(N)?ae(N):V=D.edit(V,[N],void 0,T));for(const N of $.updated.values())se.has(N)||(_.updated.has(N)?H.updated.has(N)&&ae(N):W=D.edit(W,[N],Q[N],T));for(const N of _.updated.values())se.has(N)||($.updated.has(N)?H.updated.has(N)&&ae(N):V=D.edit(V,[N],X[N],T));for(const N of $.added.values())se.has(N)||(_.added.has(N)?H.updated.has(N)&&ae(N):W=f(N,V,W,T));for(const N of _.added.values())se.has(N)||($.added.has(N)?H.updated.has(N)&&ae(N):V=f(N,W,V,T));const x=ie.size>0||!C(V,W,y),M=x||!C(V,o,[]),E=x||!C(W,h,[]);return{localContent:M?V:null,remoteContent:E?W:null,conflictsSettings:[...ie.values()],hasConflicts:x}}e.merge=m;function C(o,h,b){if(o===h)return!0;const y=(0,U.parse)(o),k=(0,U.parse)(h),T=b.reduce((B,V)=>(B.add(V),B),new Set),F=a(o).filter(B=>!(B.setting&&T.has(B.setting.key))),j=a(h).filter(B=>!(B.setting&&T.has(B.setting.key)));if(F.length!==j.length)return!1;for(let B=0;B<F.length;B++){const V=F[B],W=j[B];if(V.setting&&W.setting){if(V.setting.key!==W.setting.key||!O.equals(y[V.setting.key],k[V.setting.key]))return!1}else if(!V.setting&&!W.setting){if(V.value!==W.value)return!1}else return!1}return!0}function c(o){return o?a(o).length===0:!0}e.isEmpty=c;function u(o,h,b){const y=o?Object.keys(o).filter(B=>!b.has(B)):[],k=Object.keys(h).filter(B=>!b.has(B)),T=k.filter(B=>y.indexOf(B)===-1).reduce((B,V)=>(B.add(V),B),new Set),F=y.filter(B=>k.indexOf(B)===-1).reduce((B,V)=>(B.add(V),B),new Set),j=new Set;if(o)for(const B of y){if(F.has(B))continue;const V=o[B],W=h[B];O.equals(V,W)||j.add(B)}return{added:T,removed:F,updated:j}}function f(o,h,b,y){const k=(0,U.parse)(h),T=a(h),F=a(b),j=g(o,T,F);return v(b,o,k[o],j,F,y)}e.addSetting=f;function g(o,h,b){const y=h.findIndex(T=>T.setting?.key===o),k=h[y-1];if(k){if(k.setting){const F=n(k.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!0}}else{const F=r(y,h);if(F){const j=n(F.setting.key,b);if(j){const B=t(b.indexOf(j),b),V=i(h,F,h[y]);if(B){const W=i(b,j,B),Q=s(V,W);return Q?{index:b.indexOf(Q),insertAfter:!0}:{index:b.indexOf(B),insertAfter:!1}}else{const W=i(b,j,b[b.length-1]),Q=s(V,W);return Q?{index:b.indexOf(Q),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const T=h[y+1];if(T)if(T.setting){const F=n(T.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!1}}else{const F=t(y,h);if(F){const j=n(F.setting.key,b);if(j){const B=r(b.indexOf(j),b),V=i(h,h[y],F);if(B){const W=i(b,B,j),Q=s(V.reverse(),W.reverse());return Q?{index:b.indexOf(Q),insertAfter:!1}:{index:b.indexOf(B),insertAfter:!0}}else{const W=i(b,b[0],j),Q=s(V.reverse(),W.reverse());return Q?{index:b.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function v(o,h,b,y,k,T){let F;return y.index===-1?F=(0,l.setProperty)(o,[h],b,T):F=R(o,h,b,y,k,T).map(j=>(0,l.withFormatting)(o,j,T)[0]),(0,l.applyEdits)(o,F)}function R(o,h,b,y,k,T){const F=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,j=(0,A.getEOL)(T,o),B=k[y.index];if(y.insertAfter){const V=[];if(B.setting)V.push({offset:B.endOffset,length:0,content:","+F});else{const W=t(y.index,k),Q=r(y.index,k),X=Q?.setting?.commaOffset;Q&&X===void 0&&V.push({offset:Q.endOffset,length:0,content:","});const Y=X!==void 0&&X>B.endOffset;V.push({offset:Y?X+1:B.endOffset,length:0,content:W?j+F+",":j+F})}return V}else{if(B.setting)return[{offset:B.startOffset,length:0,content:F+","}];const V=(k[y.index-1]&&!k[y.index-1].setting?j:"")+F+(t(y.index,k)?",":"")+j;return[{offset:B.startOffset,length:0,content:V}]}}function n(o,h){return h.filter(b=>b.setting?.key===o)[0]}function r(o,h){for(let b=o-1;b>=0;b--)if(h[b].setting)return h[b]}function t(o,h){for(let b=o+1;b<h.length;b++)if(h[b].setting)return h[b]}function i(o,h,b){const y=o.indexOf(h),k=o.indexOf(b);return o.filter((T,F)=>y<F&&F<k)}function s(o,h){if(o.length&&h.length){let b=0;for(;b<h.length&&b<o.length;b++)if(o[b].value!==h[b].value)return h[b-1];return h[b-1]}}function a(o){const h=[];let b=-1,y,k;const T={onObjectBegin:F=>{b++},onObjectProperty:(F,j,B)=>{b===0&&(y=j,k=F)},onObjectEnd:(F,j)=>{b--,b===0&&h.push({startOffset:y,endOffset:F+j,value:o.substring(y,F+j),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(F,j)=>{b++},onArrayEnd:(F,j)=>{b--,b===0&&h.push({startOffset:y,endOffset:F+j,value:o.substring(y,F+j),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(F,j,B)=>{b===0&&h.push({startOffset:y,endOffset:j+B,value:o.substring(y,j+B),setting:{key:k,commaOffset:void 0}})},onSeparator:(F,j,B)=>{if(b===0&&F===","){let V=h.length-1;for(;V>=0&&!h[V].setting;V--);const W=h[V];W&&h.splice(V,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:j}})}},onComment:(F,j)=>{b===0&&h.push({startOffset:F,endOffset:F+j,value:o.substring(F,F+j)})}};return(0,U.visit)(o,T),h}}),define(re[77],oe([0,1,3,2,5,24]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let O=class extends U.Disposable{get account(){return this.a}constructor(I,w){super(),this.g=I,this.h=w,this.b=this.D(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.D(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.D(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.D(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};O=ye([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(re[264],oe([0,1,2,11]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(p){this.a=p}listen(p,d){switch(d){case"onError":return this.a.onError}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"triggerSync":return this.a.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class A{constructor(p){this.a=p}listen(p,d){throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(U.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(p){this.a=p}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.a.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.a.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=O;class D{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${d}`)}async call(p,d,m){switch(d){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(m[0],m[1]);case"setEnablements":return this.a.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class I{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class w{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class P extends L.Disposable{constructor(p){super(),this.a=p,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.a.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.a.call("getPreviousUserDataSyncStore");return this.b(p)}b(p){return{url:U.URI.revive(p.url),type:p.type,defaultUrl:U.URI.revive(p.defaultUrl),insidersUrl:U.URI.revive(p.insidersUrl),stableUrl:U.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(re[265],oe([0,1,187,9,24]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends U.AbstractLogger{constructor(D){super(),this.g=this.D(D.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(D,...I){this.g.trace(D,...I)}debug(D,...I){this.g.debug(D,...I)}info(D,...I){this.g.info(D,...I)}warn(D,...I){this.g.warn(D,...I)}error(D,...I){this.g.error(D,...I)}flush(){this.g.flush()}};A=ye([K(0,U.ILoggerService)],A),e.UserDataSyncLogService=A}),define(re[266],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(re[267],oe([0,1,6,3,2]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends l.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:I,getActiveWindowId:w}){super(),this.a=this.D(new l.DisposableStore),U.Event.latch(U.Event.any(D,I))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>w()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(D){this.b&&(this.b.cancel(),this.b=void 0),this.c=D}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(re[119],oe([0,1,190,13,49,23,11,5,22]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function w(i){const s=i;return typeof s?.id=="string"&&O.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=w;function P(i){return typeof i?.id=="string"&&!w(i)&&!p(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,U.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=S;function p(i){const s=i;return typeof s?.id=="string"&&O.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=p;function d(i){const s=i;if(s?.uri)return{id:s.id,uri:O.URI.revive(s.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:O.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function C(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=C;function c(i){const s=i;return!!(s&&typeof s=="object"&&O.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(s,a,o,h,b){this.h=s,this.j=o,this.k=h,this.l=b,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class f{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function g(i){return new f({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(i,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function R(i){let s;return O.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=R,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(i,s){return!v(i,s)&&!R(i)}e.isSavedWorkspace=r;function t(i){return(typeof i=="string"?(0,U.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(re[18],oe([0,1,53,3,2,23,11,181,15,14,5,9,119,37,30,6,31,27,12]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function g(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function v(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:i}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function R(t,i,s,a){return{id:t,name:i,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,A.joinPath)(s,"globalStorage"),settingsResource:(0,A.joinPath)(s,"settings.json"),keybindingsResource:(0,A.joinPath)(s,"keybindings.json"),tasksResource:(0,A.joinPath)(s,"tasks.json"),snippetsHome:(0,A.joinPath)(s,"snippets"),extensionsResource:(0,A.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=R;let n=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(i,s,a,o){super(),this.m=i,this.n=s,this.q=a,this.r=o,this.f=!0,this.g=this.D(new U.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new U.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new U.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new U.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(i){this.f!==i&&(this.s=void 0,this.f=i)}isEnabled(){return this.f}get t(){if(!this.s){const i=[];if(this.f)try{for(const h of this.I()){if(!h.name||!(0,f.isString)(h.name)||!h.location){this.r.warn("Skipping the invalid stored profile",h.location||h.name);continue}i.push(R((0,A.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.r.error(h)}const s=new d.ResourceMap,a=new Map,o=this.u();if(i.unshift({...o,extensionsResource:this.N()??o.extensionsResource,isDefault:!0}),i.length)try{const h=this.L();if(h.workspaces)for(const[b,y]of Object.entries(h.workspaces)){const k=O.URI.parse(b),T=i.find(F=>F.id===y);T&&s.set(k,T)}if(h.emptyWindows)for(const[b,y]of Object.entries(h.emptyWindows)){const k=i.find(T=>T.id===y);k&&a.set(b,k)}}catch(h){this.r.error(h)}this.s={profiles:i,workspaces:s,emptyWindows:a}}return this.s}u(){return R("__default__profile__",(0,D.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const s="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const b of this.profiles){const y=a.exec(b.name),k=y?parseInt(y[1]):0;o=k>o?k:o}const h=`${s} ${o+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),h,{transient:!0},i)}async createNamedProfile(i,s,a){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),i,s,a)}async createProfile(i,s,a,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.v(i,s,a);return o&&await this.setProfileForWorkspace(o,h),h}async v(i,s,a){if(!(0,f.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const h=this.profiles.find(k=>k.name===s||k.id===i);if(h)return h;const b=R(i,s,(0,A.joinPath)(this.profilesHome,i),a);await this.n.createFolder(b.location);const y=[];return this.h.fire({profile:b,join(k){y.push(k)}}),await C.Promises.settled(y),this.z([b],[],[]),b}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=R(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.i.fire({profile:s,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.r.error(o)}for(const o of[...this.t.emptyWindows.keys()])s.id===this.t.emptyWindows.get(o)?.id&&this.t.emptyWindows.delete(o);for(const o of[...this.t.workspaces.keys()])s.id===this.t.workspaces.get(o)?.id&&this.t.workspaces.delete(o);this.G(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.r.error(o)}}async setProfileForWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.F(i,a)}unsetWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.q.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.w(i);return O.URI.isUri(s)?this.l.workspaces.get(s)??this.t.workspaces.get(s):this.l.emptyWindows.get(s)??this.t.emptyWindows.get(s)}w(i){return(0,p.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,p.isWorkspaceIdentifier)(i)?i.configPath:i.id}y(i){return!!([...this.l.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.l.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.t.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.t.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,i.location)))}z(i,s,a){const o=[...this.profiles,...i],h=[];this.l.profiles=[];for(let b of o)b.isDefault||s.some(y=>b.id===y.id)||(b=a.find(y=>b.id===y.id)??b,b.isTransient?this.l.profiles.push(b):h.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.J(h),this.s=void 0,this.C(i,s,a)}C(i,s,a){this.g.fire({added:i,removed:s,updated:a,all:this.profiles})}F(i,s,a){a=s?.isTransient?!0:a,a||this.F(i,void 0,!0);const o=this.w(i),h=a?this.l:this.t;O.URI.isUri(o)?(h.workspaces.delete(o),s&&h.workspaces.set(o,s)):(h.emptyWindows.delete(o),s&&h.emptyWindows.set(o,s)),a||this.G()}G(){const i={};for(const[a,o]of this.t.workspaces.entries())i[a.toString()]=o.id;const s={};for(const[a,o]of this.t.emptyWindows.entries())s[a.toString()]=o.id;this.M({workspaces:i,emptyWindows:s}),this.s=void 0}H(i){const s={},a=this.u();if(i.workspaces)for(const[h,b]of Object.entries(i.workspaces)){const y=O.URI.parse(b);s[h]=this.q.extUri.isEqual(y,a.location)?a.id:this.q.extUri.basename(y)}const o={};if(i.emptyWindows)for(const[h,b]of Object.entries(i.emptyWindows)){const y=O.URI.parse(b);o[h]=this.q.extUri.isEqual(y,a.location)?a.id:this.q.extUri.basename(y)}return{workspaces:s,emptyWindows:o}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};n.b="userDataProfiles",n.c="profileAssociations",n=ye([K(0,I.IEnvironmentService),K(1,w.IFileService),K(2,m.IUriIdentityService),K(3,S.ILogService)],n),e.UserDataProfilesService=n;class r extends n{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=r}),define(re[268],oe([0,1,6,2,18]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends U.Disposable{constructor(D){super(),this.D(new L.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};A=ye([K(0,l.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(re[269],oe([0,1,21,6,25,10,3,2,4,11,160,29,33,46,9,26,19,18]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var f;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(f=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let g=class extends D.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,s,a,o,h){super(),this.s=i,this.t=s,this.u=a,this.v=o,this.w=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.D(new O.Emitter),this.m=this.D(new O.Emitter),this.n=this.D(new O.Emitter),this.p=this.D(new O.Emitter),this.q=[],this.D((0,D.toDisposable)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.k.forEach(b=>b.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,S.isTargetPlatformCompatible)(a,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{if(!this.s.isEnabled())throw new S.ExtensionManagementError(P.localize(0,null),S.ExtensionManagementErrorCode.Internal);const a=await this.G(i,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.y(a.manifest,a.extension,s)}catch(a){throw n(this.t,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(i),error:a}),this.u.error("Failed to install extension.",i.identifier.id),this.u.error(a),R(a)}}async uninstall(i,s={}){return this.u.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.q.push(i)}async y(i,s,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,d.isApplicationScopedExtension)(i)?this.w.defaultProfile.extensionsResource:a.profileLocation??this.P()},h=j=>`${p.ExtensionKey.create(j).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!w.URI.isUri(s)){const j=this.j.get(h(s));if(j)return this.u.info("Extensions is already requested to install",s.identifier.id),j.task.waitUntilTaskIsFinished()}const b=[],y=[],k=[],T=this.Q(i,s,o);w.URI.isUri(s)||this.j.set(h(s),{task:T,waitingTasks:[]}),this.l.fire({identifier:T.identifier,source:s,profileLocation:o.profileLocation}),this.u.info("Installing extension:",T.identifier.id),b.push({task:T,manifest:i});let F=!1;try{if(o.donotIncludePackAndDependencies)this.u.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const B=await this.F(T.identifier,i,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),V=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:W,manifest:Q}of(0,L.distinct)(B,({gallery:X})=>X.identifier.id)){F=F||!!Q.extensionDependencies?.some(Z=>(0,p.areSameExtensions)({id:Z},T.identifier));const X=h(W),Y=this.j.get(X);if(Y){if(this.z(T,Y.task)){const Z=Y.task.identifier;this.u.info("Waiting for already requested installing extension",Z.id,T.identifier.id),Y.waitingTasks.push(T),y.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,H=>H.some($=>(0,p.areSameExtensions)($.identifier,Z)))).then(H=>{if(this.u.info("Finished waiting for already requested installing extension",Z.id,T.identifier.id),!H.find(_=>(0,p.areSameExtensions)(_.identifier,Z))?.local)throw new Error(`Extension ${Z.id} is not installed`)}))}}else if(!V.some(({identifier:Z})=>(0,p.areSameExtensions)(Z,W.identifier))){const Z=this.Q(Q,W,{...o,donotIncludePackAndDependencies:!0});this.j.set(X,{task:Z,waitingTasks:[T]}),this.l.fire({identifier:Z.identifier,source:W,profileLocation:o.profileLocation}),this.u.info("Installing extension:",Z.identifier.id,T.identifier.id),b.push({task:Z,manifest:Q})}}}catch(B){if(w.URI.isUri(T.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.u.warn("Cannot install dependencies of extension:",T.identifier.id,B.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.u.warn("Cannot install packed extensions of extension:",T.identifier.id,B.message);else throw this.u.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),B}const j=b.reduce((B,{task:V,manifest:W})=>(B.set(V.identifier.id.toLowerCase(),{task:V,manifest:W}),B),new Map);for(;j.size;){let B;const V=[...j.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(Q=>j.has(Q.toLowerCase())));V.length?B=j.size===1?V:V.filter(({task:W})=>!(W===T&&!F)):(this.u.info("Found extensions with circular dependencies",V.map(({task:W})=>W.identifier.id)),B=[...j.values()]),await this.C(B.map(async({task:W})=>{const Q=new Date().getTime();try{const X=await W.run();if(await this.C(this.q.map(Y=>Y.postInstall(X,W.source,o,l.CancellationToken.None))),!w.URI.isUri(W.source)){const Y=W.operation===3,Z=Y?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(n(this.t,Y?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:Z}),I.isWeb&&W.operation!==3)try{await this.s.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}k.push({local:X,identifier:W.identifier,operation:W.operation,source:W.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw w.URI.isUri(W.source)||n(this.t,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-Q,error:X}),this.u.error("Error while installing the extension:",W.identifier.id),X}finally{j.delete(W.identifier.id.toLowerCase())}}))}return y.length&&await this.C(y),k.forEach(({identifier:B})=>this.u.info("Extension installed successfully:",B.id)),this.m.fire(k),k.filter(({identifier:B})=>(0,p.areSameExtensions)(B,T.identifier))[0].local}catch(j){if(b.forEach(({task:B})=>B.cancel()),k.length)try{const B=await Promise.allSettled(k.map(({local:V})=>this.R(V,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let V=0;V<B.length;V++){const W=B[V],{identifier:Q}=k[V];W.status==="fulfilled"?this.u.info("Rollback: Uninstalled extension",Q.id):this.u.warn("Rollback: Error while uninstalling extension",Q.id,(0,A.getErrorMessage)(W.reason))}}catch(B){this.u.warn("Error while rolling back extensions",(0,A.getErrorMessage)(B),k.map(({identifier:V})=>V.id))}throw this.m.fire(b.map(({task:B})=>({identifier:B.identifier,operation:2,source:B.source,context:o.context,profileLocation:o.profileLocation}))),j}finally{for(const{task:j}of b)j.source&&!w.URI.isUri(j.source)&&this.j.delete(h(j.source))}}z(i,s){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===i&&(o.includes(s)||o.some(h=>this.z(h,s)))||a===s&&o[0]&&!this.z(i,o[0]))return!1;return!0}async C(i){const s=[],a=[],o=await Promise.allSettled(i);for(const h of o)h.status==="fulfilled"?s.push(h.value):a.push(h.reason);if(a.length)throw v(a);return s}async F(i,s,a,o,h){if(!this.s.isEnabled())return[];const b=await this.getInstalled(void 0,h),y=[],k=[],T=async(F,j)=>{y.push(F);const B=j.extensionDependencies||[],V=[...B];if(j.extensionPack){const W=a?b.find(Q=>(0,p.areSameExtensions)(Q.identifier,F)):void 0;for(const Q of j.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(X=>(0,p.areSameExtensions)({id:X},{id:Q}))||V.every(X=>!(0,p.areSameExtensions)({id:X},{id:Q}))&&V.push(Q)}if(V.length){const W=V.filter(Q=>y.every(X=>!(0,p.areSameExtensions)(X,{id:Q})));if(W.length){const Q=await this.s.getExtensions(W.map(X=>({id:X,preRelease:o})),l.CancellationToken.None);for(const X of Q){if(y.find(H=>(0,p.areSameExtensions)(H,X.identifier)))continue;const Y=B.some(H=>(0,p.areSameExtensions)({id:H},X.identifier));let Z;try{Z=await this.G(X,!1,o)}catch(H){if(H instanceof S.ExtensionManagementError&&H.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.u.info("Skipping the packed extension as it cannot be installed",X.identifier.id);continue}else throw H}k.push({gallery:Z.extension,manifest:Z.manifest}),await T(Z.extension.identifier,Z.manifest)}}}};return await T(i,s),k}async G(i,s,a){if((await this.getExtensionsControlManifest()).malicious.some(y=>(0,p.areSameExtensions)(i.identifier,y)))throw new S.ExtensionManagementError(P.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const y=await this.getTargetPlatform();throw new S.ExtensionManagementError(P.localize(2,null,i.identifier.id,this.v.nameLong,(0,S.TargetPlatformToString)(y)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(i,s,a);if(h){if(a&&!s&&i.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(P.localize(3,null,i.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&i.properties.isPreReleaseVersion&&(await this.s.getExtensions([i.identifier],l.CancellationToken.None))[0]?new S.ExtensionManagementError(P.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(P.localize(5,null,i.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.Incompatible);this.u.info("Getting Manifest...",h.identifier.id);const b=await this.s.getManifest(h,l.CancellationToken.None);if(b===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(b.version!==h.version)throw new S.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:b}}async H(i,s,a){const o=await this.getTargetPlatform();let h=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(h=(await this.s.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},l.CancellationToken.None))[0]||null),!h&&await this.s.isExtensionCompatible(i,a,o)&&(h=i),h||(s?h=(await this.s.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:o,compatible:!0},l.CancellationToken.None))[0]||null:h=await this.s.getCompatibleExtension(i,a,o)),h}async I(i,s){const a={...s,profileLocation:i.isApplicationScoped?this.w.defaultProfile.extensionsResource:s.profileLocation??this.P()},o=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,h=this.k.get(o(i.identifier));if(h)return this.u.info("Extensions is already requested to uninstall",i.identifier.id),h.waitUntilTaskIsFinished();const b=F=>{const j=this.R(F,a);return this.k.set(o(j.extension.identifier),j),a.profileLocation?this.u.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.u.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),j},y=(F,j)=>{j?a.profileLocation?this.u.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),j.message):this.u.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,j.message):a.profileLocation?this.u.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.u.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),n(this.t,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(F),error:j}),this.p.fire({identifier:F.identifier,error:j?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},k=[],T=[];try{k.push(b(i));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.u.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const j=this.M(i,F);for(const B of j)this.k.has(o(B.identifier))?this.u.info("Extensions is already requested to uninstall",B.identifier.id):k.push(b(B))}a.donotCheckDependents?this.u.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(k.map(j=>j.extension),F,i),await this.C(k.map(async j=>{try{if(await j.run(),await this.C(this.q.map(B=>B.postUninstall(j.extension,a,l.CancellationToken.None))),j.extension.identifier.uuid)try{await this.s.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}y(j.extension)}catch(B){const V=B instanceof S.ExtensionManagementError?B:new S.ExtensionManagementError((0,A.getErrorMessage)(B),S.ExtensionManagementErrorCode.Internal);throw y(j.extension,V),V}finally{T.push(j)}}))}catch(F){const j=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,A.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);for(const B of k){try{B.cancel()}catch{}T.includes(B)||y(B.extension,j)}throw j}finally{for(const F of k)this.k.delete(o(F.extension.identifier))||this.u.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(i,s,a){for(const o of i){const h=this.N(o,s);if(h.length){const b=h.filter(y=>!i.some(k=>(0,p.areSameExtensions)(k.identifier,y.identifier)));if(b.length)throw new Error(this.L(o,b,a))}}}L(i,s,a){return a===i?s.length===1?P.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?P.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(i,s,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const o=i.manifest.extensionPack?i.manifest.extensionPack:[];if(o.length){const h=s.filter(y=>!y.isBuiltin&&o.some(k=>(0,p.areSameExtensions)({id:k},y.identifier))),b=[];for(const y of h)b.push(...this.M(y,s,a));return[...h,...b]}return[]}N(i,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},i.identifier)))}async O(){try{this.u.trace("ExtensionManagementService.refreshReportedCache");const i=await this.s.getExtensionsControlManifest();return this.u.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.u.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=ye([K(0,S.IExtensionGalleryService),K(1,c.ITelemetryService),K(2,m.ILogService),K(3,C.IProductService),K(4,u.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=v;function R(t){if(t instanceof S.ExtensionManagementError)return t;const i=new S.ExtensionManagementError(t.message,S.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:a,duration:o,error:h,durationSinceUpdate:b}){let y,k;h&&(h instanceof S.ExtensionManagementError?(y=h.code,h.code===S.ExtensionManagementErrorCode.Signature&&(k=h.message)):y=S.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...s,verificationStatus:a,success:!h,duration:o,errorcode:y,errorcodeDetail:k,durationSinceUpdate:b})}class r{constructor(){this.d=new U.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,U.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,U.createCancelablePromise)(i=>new Promise((s,a)=>{const o=i.onCancellationRequested(()=>{o.dispose(),a(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(re[51],oe([0,1,6,16,2,3,37,11,29,33,14,5,9,18,30,12,10,19]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class g extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let v=class extends l.Disposable{constructor(t,i,s,a,o,h){super(),this.i=t,this.j=i,this.k=s,this.l=a,this.m=o,this.n=h,this.b=this.D(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new O.ResourceMap}scanProfileExtensions(t,i){return this.p(t,void 0,i)}async addExtensionsToProfile(t,i){const s=[],a=[];try{return await this.p(i,o=>{const h=[];for(const b of o)t.some(([y])=>(0,w.areSameExtensions)(y.identifier,b.identifier)&&y.manifest.version!==b.version)?s.push(b):h.push(b);for(const[b,y]of t)if(!h.some(k=>(0,w.areSameExtensions)(k.identifier,b.identifier)&&k.version===b.manifest.version)){const k={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:y};a.push(k),h.push(k)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),h}),a.length&&this.c.fire({extensions:a,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),a}catch(o){throw a.length&&this.c.fire({extensions:a,error:o,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async updateMetadata(t,i){const s=[];return await this.p(i,a=>{const o=[];for(const h of a){const b=t.find(([y])=>(0,w.areSameExtensions)(y.identifier,h.identifier)&&y.manifest.version===h.version);b&&(h.metadata={...h.metadata,...b[1]},s.push(h)),o.push(h)}return o}),s}async removeExtensionFromProfile(t,i){const s=[];this.f.fire({extensions:s,profileLocation:i});try{await this.p(i,a=>{const o=[];for(const h of a)(0,w.areSameExtensions)(h.identifier,t.identifier)?s.push(h):o.push(h);return s.length&&this.f.fire({extensions:s,profileLocation:i}),o}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(a){throw s.length&&this.g.fire({extensions:s,error:a,profileLocation:i}),a}}async p(t,i,s){return this.v(t).queue(async()=>{let a=[],o;try{const h=await this.j.readFile(t);o=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,P.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(o=await this.u()),!o&&s?.bailOutWhenFileNotFound)throw new g((0,c.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.q(t);let h=!1;for(const b of o){R(b)||this.q(t);let y;if((0,C.isString)(b.relativeLocation)&&b.relativeLocation)y=this.s(b.relativeLocation);else if((0,C.isString)(b.location))y=this.s(b.location),h=!0,b.relativeLocation=b.location,b.location=y.toJSON();else{y=D.URI.revive(b.location);const k=this.r(y);k&&(h=!0,b.relativeLocation=k)}a.push({identifier:b.identifier,location:y,version:b.version,metadata:b.metadata})}h&&await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(o)))}if(i){a=i(a);const h=a.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.r(b.location),metadata:b.metadata}));await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(h)))}return a})}q(t){const i=new g(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}r(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}s(t){return this.l.extUri.joinPath(this.i,t)}async u(){return this.t||(this.t=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(o){if((0,P.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",t.toString());let a;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(h=>R(h))?a=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(t)}catch(o){(0,P.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(i)}catch(o){(0,P.toFileOperationResult)(o)!==1&&this.n.error(o)}return a})()),this.t}v(t){let i=this.h.get(t);return i||(i=new L.Queue,this.h.set(t,i)),i}};v=ye([K(1,P.IFileService),K(2,d.IUserDataProfilesService),K(3,m.IUriIdentityService),K(4,u.ITelemetryService),K(5,p.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function R(r){return(0,C.isObject)(r)&&(0,I.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,C.isString)(r.location)&&r.location)&&((0,C.isUndefined)(r.relativeLocation)||(0,C.isString)(r.relativeLocation))&&r.version&&(0,C.isString)(r.version)}function n(r){return r?(0,C.isString)(r.path)&&(0,C.isString)(r.scheme):!1}}),define(re[78],oe([0,1,21,6,32,16,10,35,140,2,22,13,4,23,55,90,12,11,164,15,33,46,67,14,5,9,26,3,91,51,18,30,197]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r,t,i,s,a,o,h,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(X){function Y(Z,H){if(Z===H)return!0;const $=Object.keys(Z),_=new Set;for(const ie of Object.keys(H))_.add(ie);if($.length!==_.size)return!1;for(const ie of $){if(Z[ie]!==H[ie])return!1;_.delete(ie)}return _.size===0}X.equals=Y})(T=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends w.Disposable{constructor(Y,Z,H,$,_,ie,se,ae,x,M,E,N){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.l=H,this.m=$,this.n=_,this.p=ie,this.q=se,this.r=ae,this.s=x,this.t=M,this.u=E,this.v=N,this.g=this.D(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(V,(0,d.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(V,(0,d.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(B,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,v.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(Y,Z,H){const[$,_]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),ie=H?await this.scanExtensionsUnderDevelopment(Y,[...$,..._]):[];return this.F($,_,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.G(!!Y.useCache,Y.language)),Z.push(this.H(Y.language,!!Y.checkControlFile));const[H,$]=await Promise.all(Z);return this.C([...H,...$],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",Z);const H=this.u.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,H),_=Y.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let ie;try{ie=await _.scanExtensions($)}catch(se){if(se instanceof h.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),ie=await _.scanExtensions($);else throw se}return ie=await this.C(ie,1,Y,!0),this.r.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(Y,Z){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const H=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter($=>$.scheme===P.Schemas.file).map(async $=>{const _=await this.J($,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(_)).map(se=>(se.type=Z.find(ae=>(0,v.areSameExtensions)(ae.identifier,se.identifier))?.type??se.type,this.k.validate(se,_)))}))).flat();return this.C(H,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,H){const $=await this.J(Y,!1,Z,!0,H.language,!0,void 0),_=await this.k.scanExtension($);return!_||!H.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(Y,Z,H){const $=await this.J(Y,!1,Z,!0,H.language,!0,void 0),_=await this.k.scanOneOrMultipleExtensions($);return this.C(_,Z,H,!0)}async scanMetadata(Y){const Z=(0,d.joinPath)(Y,"package.json"),H=(await this.q.readFile(Z)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Y,Z){const H=(0,d.joinPath)(Y,"package.json"),$=(await this.q.readFile(H)).value.toString(),_=JSON.parse($);Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,_.__metadata={..._.__metadata,...Z},await this.q.writeFile((0,d.joinPath)(Y,"package.json"),A.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof h.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw Y}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.p.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,r.toFileOperationResult)(Z)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(Z))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.r.error(Y)}finally{this.y=void 0}})()),this.y}async C(Y,Z,H,$){return H.includeAllVersions||(Y=this.F(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),$)),H.includeInvalid||(Y=Y.filter(_=>_.isValid)),Y.sort((_,ie)=>{const se=S.basename(_.location.fsPath),ae=S.basename(ie.location.fsPath);return se<ae?-1:se>ae?1:0})}F(Y,Z,H,$,_){const ie=(ae,x,M)=>{if(ae.isValid&&!x.isValid)return!1;if(ae.isValid===x.isValid){if(_&&m.gt(ae.manifest.version,x.manifest.version))return this.r.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(m.eq(ae.manifest.version,x.manifest.version)){if(ae.type===0)return this.r.debug(`Skipping extension ${x.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===$)return this.r.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return M?this.r.warn(`Overwriting user extension ${ae.location.path} with ${x.location.path}.`):this.r.debug(`Overwriting user extension ${ae.location.path} with ${x.location.path}.`),!0},se=new R.ExtensionIdentifierMap;return Y?.forEach(ae=>{const x=se.get(ae.identifier.id);(!x||ie(x,ae,!1))&&se.set(ae.identifier.id,ae)}),Z?.forEach(ae=>{const x=se.get(ae.identifier.id);if(!x&&Y&&ae.type===0){this.r.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!x||ie(x,ae,!1))&&se.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const x=se.get(ae.identifier.id);(!x||ie(x,ae,!0))&&se.set(ae.identifier.id,ae),se.set(ae.identifier.id,ae)}),[...se.values()]}async G(Y,Z){this.r.trace("Started scanning system extensions");const H=await this.J(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),_=await(Y&&!H.devMode?this.i:this.k).scanExtensions(H);return this.r.trace("Scanned system extensions:",_.length),_}async H(Y,Z){const H=this.s.isBuilt?[]:this.t.builtInExtensions;if(!H?.length)return[];this.r.trace("Started scanning dev system extensions");const $=Z?await this.I():{},_=[],ie=u.URI.file(S.normalize(S.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const x=$[ae.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":_.push((0,d.joinPath)(ie,ae.name));break;default:_.push(u.URI.file(x));break}}const se=await Promise.all(_.map(async ae=>this.k.scanExtension(await this.J(ae,!1,0,!0,Y,!0,void 0))));return this.r.trace("Scanned dev system extensions:",se.length),(0,L.coalesce)(se)}async I(){try{const Y=await this.q.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async J(Y,Z,H,$,_,ie,se){const ae=await this.f(_??p.language),x=await this.L(Y),M=Z&&!this.u.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,E=M?await this.L(M):void 0;return new j(Y,x,M,E,Z,se,H,$,ie,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,_,ae)}async L(Y){try{const Z=await this.q.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};F=ye([K(4,b.IUserDataProfilesService),K(5,h.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,i.ILogService),K(8,g.IEnvironmentService),K(9,s.IProductService),K(10,y.IUriIdentityService),K(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class j{constructor(Y,Z,H,$,_,ie,se,ae,x,M,E,N,z,G,q){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=$,this.profile=_,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=ae,this.validate=x,this.productVersion=M,this.productDate=E,this.productCommit=N,this.devMode=z,this.language=G,this.translations=q}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,d.isEqual)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,d.isEqual)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&l.equals(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&T.equals(Y.translations,Z.translations)}}e.ExtensionScannerInput=j;let B=class extends w.Disposable{constructor(Y,Z,H,$,_){super(),this.f=Y,this.g=Z,this.h=H,this.i=$,this.j=_}async scanExtensions(Y){const Z=Y.profile?await this.l(Y):await this.k(Y);let H={};if(Y.excludeObsolete&&Y.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();H=JSON.parse($)}catch{}return(0,c.isEmptyObject)(H)?Z:Z.filter($=>!H[v.ExtensionKey.create($).toString()])}async k(Y){const Z=await this.i.resolve(Y.location);if(!Z.children?.length)return[];const H=await Promise.all(Z.children.map(async $=>{if(!$.isDirectory||Y.type===1&&(0,d.basename)($.resource).indexOf(".")===0)return null;const _=new j($.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(_)}));return(0,L.coalesce)(H).sort(($,_)=>$.location.path<_.location.path?-1:1)}async l(Y){let Z=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter($=>!$.metadata?.isApplicationScoped);const H=await this.m(Y.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,Y);Z.push(...H)}return Z}async m(Y,Z,H){const $=await this.g.scanProfileExtensions(Y,H.profileScanOptions);if(!$.length)return[];const _=await Promise.all($.map(async ie=>{if(Z(ie)){const se=new j(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,L.coalesce)(_)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,d.joinPath)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,O.getErrorMessage)(Z)),[]}}async scanExtension(Y,Z){try{let H=await this.scanExtensionManifest(Y.location);if(H){H.publisher||(H.publisher=R.UNDEFINED_PUBLISHER),Z=Z??H.__metadata,delete H.__metadata;const $=(0,v.getGalleryExtensionId)(H.publisher,H.name),_=Z?.id?{id:$,uuid:Z.id}:{id:$},ie=Z?.isSystem?0:Y.type,se=ie===0||!!Z?.isBuiltin;H=await this.n(Y.location,H,j.createNlsConfiguration(Y));const ae={type:ie,identifier:_,manifest:H,location:Y.location,isBuiltin:se,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(ae,Y):ae}}catch(H){Y.type!==0&&this.j.error(H)}return null}validate(Y,Z){let H=!0;const $=(0,n.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[_,ie]of $)_===C.default.Error&&(H=!1,this.j.error(this.s(Z.location,ie)));return Y.isValid=H,Y.validations=$,Y}async scanExtensionManifest(Y){const Z=(0,d.joinPath)(Y,"package.json");let H;try{H=(await this.i.readFile(Z)).value.toString()}catch(_){return(0,r.toFileOperationResult)(_)!==1&&this.j.error(this.s(Y,(0,f.localize)(0,null,Z.path,_.message))),null}let $;try{$=JSON.parse(H)}catch{const ie=[];(0,D.parse)(H,ie);for(const se of ie)this.j.error(this.s(Y,(0,f.localize)(1,null,Z.path,se.offset,se.length,(0,I.getParseErrorMessage)(se.error))));return null}return(0,D.getNodeType)($)!=="object"?(this.j.error(this.s(Y,(0,f.localize)(2,null,Z.path))),null):$}async n(Y,Z,H){const $=await this.p(Y,Z,H);if($)try{const _=[],ie=await this.q($.default,_);if(_.length>0)return _.forEach(ae=>{this.j.error(this.s(Y,(0,f.localize)(3,null,$.default?.path,(0,I.getParseErrorMessage)(ae.error))))}),Z;if((0,D.getNodeType)($)!=="object")return this.j.error(this.s(Y,(0,f.localize)(4,null,$.default?.path))),Z;const se=$.values||Object.create(null);return(0,k.localizeManifest)(Z,se,ie)}catch{}return Z}async p(Y,Z,H){const $=(0,d.joinPath)(Y,"package.nls.json"),_=(x,M)=>{M.forEach(E=>{this.j.error(this.s(Y,(0,f.localize)(5,null,x?.path,(0,I.getParseErrorMessage)(E.error))))})},ie=x=>{this.j.error(this.s(Y,(0,f.localize)(6,null,x?.path)))},se=`${Z.publisher}.${Z.name}`,ae=H.translations[se];if(ae)try{const x=u.URI.file(ae),M=(await this.i.readFile(x)).value.toString(),E=[],N=(0,D.parse)(M,E);return E.length>0?(_(x,E),{values:void 0,default:$}):(0,D.getNodeType)(N)!=="object"?(ie(x),{values:void 0,default:$}):{values:N.contents?N.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let M;try{M=await this.r(Y,H)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const E=(await this.i.readFile(M.localized)).value.toString(),N=[],z=(0,D.parse)(E,N);return N.length>0?(_(M.localized,N),{values:void 0,default:M.original}):(0,D.getNodeType)(z)!=="object"?(ie(M.localized),{values:void 0,default:M.original}):{values:z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async q(Y,Z){if(Y)try{const H=(await this.i.readFile(Y)).value.toString();return(0,D.parse)(H,Z)}catch{}}r(Y,Z){return new Promise((H,$)=>{const _=ie=>{const se=(0,d.joinPath)(Y,`package.nls.${ie}.json`);this.i.exists(se).then(ae=>{ae&&H({localized:se,original:(0,d.joinPath)(Y,"package.nls.json")});const x=ie.lastIndexOf("-");x===-1?H({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null}):(ie=ie.substring(0,x),_(ie))})};if(Z.devMode||Z.pseudo||!Z.language)return H({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null});_(Z.language)})}s(Y,Z){return`[${Y.path}]: ${Z}`}};B=ye([K(1,h.IExtensionsProfileScannerService),K(2,y.IUriIdentityService),K(3,r.IFileService),K(4,i.ILogService)],B);let V=class extends B{constructor(Y,Z,H,$,_,ie){super(Z,H,$,_,ie),this.w=Y,this.u=this.D(new U.ThrottledDelayer(3e3)),this.v=this.D(new a.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(Y){const Z=await this.y();if(this.t=Y,Z&&Z.input&&j.equals(Z.input,this.t))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.u.trigger(()=>this.C()),Z.result.map($=>($.location=u.URI.revive($.location),$));const H=await super.scanExtensions(Y);return await this.z({input:Y,result:H}),H}async y(){try{const Y=await this.i.readFile(this.w),Z=JSON.parse(Y.value.toString());return{result:Z.result,input:(0,o.revive)(Z.input)}}catch(Y){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,O.getErrorMessage)(Y))}return null}async z(Y){try{await this.i.writeFile(this.w,A.VSBuffer.fromString(JSON.stringify(Y)))}catch(Z){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,O.getErrorMessage)(Z))}}async C(){if(!this.t)return;const Y=await this.y();if(!Y)return;const Z=Y.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!l.equals(H,Z))try{this.j.info("Invalidating Cache",Z,H),await this.i.del(this.w),this.v.fire()}catch($){this.j.error($)}}};V=ye([K(2,h.IExtensionsProfileScannerService),K(3,y.IUriIdentityService),K(4,r.IFileService),K(5,i.ILogService)],V);function W(X,Y){const Z=(0,v.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:Z,identifier:new R.ExtensionIdentifier(Z),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:Y,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.toExtensionDescription=W;class Q extends F{constructor(Y,Z,H,$,_,ie,se,ae,x,M,E,N){super(Y,Z,(0,d.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)($,R.MANIFEST_CACHE_FOLDER),_,ie,se,ae,x,M,E,N),this.M=(async()=>{if(p.translationsConfigFile)try{const z=await this.q.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.M}}e.NativeExtensionsScannerService=Q}),define(re[270],oe([0,1,50,6,38,3,2,22,13,28,9,18]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends O.Disposable{constructor(m,C){super(),this.b=m,this.f=C,this.a=new U.Limiter(5)}async postUninstall(m){const C=this.g(m,"uninstall");C&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(C.script,"uninstall",C.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(c)}}));try{await w.Promises.rm(this.j(m))}catch(c){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(c)}}g(m,C){const c=`vscode:${C}`;if(m.location.scheme===D.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[c]=="string"){const u=m.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${c} should be a node script`),null):{script:(0,I.join)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(m,C,c,u,f){return new Promise((g,v)=>{const R=this.i(m,C,c,f);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?v(t):g(void 0)};R.on("error",t=>{r((0,l.toErrorMessage)(t)||"Unknown")}),R.on("exit",(t,i)=>{r(t?`post-${C} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,R.kill(),v("timed out")},5e3))})}i(m,C,c,u){const f={silent:!0,execArgv:void 0},g=(0,L.fork)(m,[`--type=extension-post-${C}`,...c],f);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(g.stdout,"data"),R=A.Event.fromNodeEventEmitter(g.stderr,"data");v(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${C}`,t)),R(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${C}`,t));const n=A.Event.any(A.Event.map(v,t=>({data:`%c${t}`,format:[""]})),A.Event.map(R,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}j(m){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};p=ye([K(0,S.IUserDataProfilesService),K(1,P.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[271],oe([0,1,9,18,30,19,51,14,15,11]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends O.AbstractExtensionsProfileScannerService{constructor(p,d,m,C,c,u){super(w.URI.file(p.extensionsPath),d,m,C,c,u)}};P=ye([K(0,I.INativeEnvironmentService),K(1,D.IFileService),K(2,U.IUserDataProfilesService),K(3,l.IUriIdentityService),K(4,A.ITelemetryService),K(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(re[272],oe([0,1,11,15,51,78,14,5,9,26,30,18]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends A.NativeExtensionsScannerService{constructor(m,C,c,u,f,g,v,R){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,L.URI.file(f.userDataPath),m,C,c,u,f,g,v,R)}};p=ye([K(0,S.IUserDataProfilesService),K(1,l.IExtensionsProfileScannerService),K(2,O.IFileService),K(3,I.ILogService),K(4,U.INativeEnvironmentService),K(5,w.IProductService),K(6,P.IUriIdentityService),K(7,D.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(re[20],oe([0,1,6,3,2,104,12,66,5,18]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var p;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function d(f){const g=f.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=d;class m extends l.Disposable{constructor(g={flushInterval:m.a}){super(),this.j=g,this.b=this.D(new U.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new U.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new U.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new l.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,v){if(v===e.TARGET_KEY){switch(g){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:v,target:this.F(g)[v]})}q(g){this.f.fire({reason:g})}get(g,v,R){return this.L(v)?.get(g,R)}getBoolean(g,v,R){return this.L(v)?.getBoolean(g,R)}getNumber(g,v,R){return this.L(v)?.getNumber(g,R)}store(g,v,R,n){if((0,O.isUndefinedOrNull)(v)){this.remove(g,R);return}this.r(()=>{this.t(g,R,n),this.L(R)?.set(g,v)})}remove(g,v){this.r(()=>{this.t(g,v,void 0),this.L(v)?.delete(g)})}r(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,v){const R=[],n=this.F(g);for(const r of Object.keys(n))n[r]===v&&R.push(r);return R}t(g,v,R){const n=this.F(v);typeof R=="number"?n[g]!==R&&(n[g]=R,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(g){switch(g){case-1:return this.C;case 0:return this.y;default:return this.v}}G(g){const v=this.L(g);return v?d(v):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this.f.fire({reason:g});const v=this.L(-1),R=this.L(0),n=this.L(1);switch(g){case P.NONE:await L.Promises.settled([v?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([v?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return u(g,v,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,v){return this.q(P.NONE),(0,w.isUserDataProfile)(g)?this.N(g,v):this.O(g,v)}H(g,v){return!(g.id===v.id||C(v)&&C(g))}I(g,v,R,n){this.r(()=>{if(n)for(const[r,t]of g)v.set(r,t);else{const r=new Set;for(const[t,i]of g)r.add(t),v.get(t)!==i&&this.n(R,t);for(const[t]of v.items)r.has(t)||this.n(R,t)}})}}m.a=60*1e3,e.AbstractStorageService=m;function C(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=C;class c extends m{constructor(){super(),this.p=this.D(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.D(this.P.onDidChangeStorage(g=>this.n(0,g))),this.D(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=c;async function u(f,g,v,R,n,r){const t=T=>{try{return JSON.parse(T)}catch{return T}},i=new Map,s=new Map;f.forEach((T,F)=>{i.set(F,T),s.set(F,t(T))});const a=new Map,o=new Map;g.forEach((T,F)=>{a.set(F,T),o.set(F,t(T))});const h=new Map,b=new Map;v.forEach((T,F)=>{h.set(F,T),b.set(F,t(T))}),console.group(R!==n?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const y=[];if(i.forEach((T,F)=>{y.push({key:F,value:T})}),console.table(y),console.groupEnd(),console.log(s),R!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const T=[];a.forEach((F,j)=>{T.push({key:j,value:F})}),console.table(T),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const k=[];h.forEach((T,F)=>{k.push({key:F,value:T})}),console.table(k),console.groupEnd(),console.log(b)}e.logStorage=u}),define(re[120],oe([0,1,3,2,12,29,33,20]),function(te,e,L,U,l,A,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends U.Disposable{constructor(S,p){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.D(new w(S)),this.D(this.b.onDidChange(d=>this.a.fire({extensions:d,source:"storage"}))),this.D(p.onDidInstallExtensions(d=>d.forEach(({local:m,operation:C})=>{m&&C===4&&this.f(m.identifier)})))}async enableExtension(S,p){return this.f(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}async disableExtension(S,p){return this.c(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const p=this.getDisabledExtensions();return p.every(d=>!(0,O.areSameExtensions)(d,S))?(p.push(S),this.g(p),!0):!1}f(S){const p=this.getDisabledExtensions();for(let d=0;d<p.length;d++){const m=p[d];if((0,O.areSameExtensions)(m,S))return p.splice(d,1),this.g(p),!0}return!1}g(S){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,S)}h(S){return this.b.get(S,0)}i(S,p){this.b.set(S,p,0)}};I=ye([K(0,D.IStorageService),K(1,A.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class w extends U.Disposable{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.D(new L.Emitter),this.onDidChange=this.b.event,this.D(S.onDidChangeValue(p=>this.f(p)))}get(S,p){let d;return p===0?((0,l.isUndefinedOrNull)(this.a[S])&&(this.a[S]=this.g(S,p)),d=this.a[S]):d=this.g(S,p),JSON.parse(d)}set(S,p,d){const m=JSON.stringify(p.map(({id:c,uuid:u})=>({id:c,uuid:u})));this.g(S,d)!==m&&(d===0&&(p.length?this.a[S]=m:delete this.a[S]),this.h(S,p.length?m:void 0,d))}f(S){if(S.scope===0&&!(0,l.isUndefinedOrNull)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const d=this.get(S.key,S.scope);delete this.a[S.key];const m=this.get(S.key,S.scope),C=d.filter(u=>!m.some(f=>(0,O.areSameExtensions)(u,f))),c=m.filter(u=>!d.some(f=>(0,O.areSameExtensions)(f,u)));(C.length||c.length)&&this.b.fire([...C,...c])}}g(S,p){return this.c.get(S,p,"[]")}h(S,p,d){p?this.c.store(S,p,d,1):this.c.remove(S,d)}}e.StorageManager=w}),define(re[273],oe([0,1,21,25,10,4,36,12,11,17,15,29,33,67,14,9,26,59,240,20,19]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=A.isWeb?"web":(0,S.getTargetPlatform)(A.platform,O.arch),n="X-Market-Search-Activity-Id";var r;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...M){return String(M.reduce((E,N)=>E|N,0))}var i;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class b{constructor(E=h){this.d=E}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(E,N=this.d.pageSize){return new b({...this.d,pageNumber:E,pageSize:N})}withFilter(E,...N){const z=[...this.d.criteria,...N.length?N.map(G=>({filterType:E,value:G})):[{filterType:E}]];return new b({...this.d,criteria:z})}withSortBy(E){return new b({...this.d,sortBy:E})}withSortOrder(E){return new b({...this.d,sortOrder:E})}withFlags(...E){return new b({...this.d,flags:E.reduce((N,z)=>N|z,0)})}withAssetTypes(...E){return new b({...this.d,assetTypes:E})}withSource(E){return new b({...this.d,source:E})}get raw(){const{criteria:E,pageNumber:N,pageSize:z,sortBy:G,sortOrder:q,flags:J,assetTypes:ee}=this.d;return{filters:[{criteria:E,pageNumber:N,pageSize:z,sortBy:G,sortOrder:q}],assetTypes:ee,flags:J}}get searchText(){const E=this.d.criteria.filter(N=>N.filterType===i.SearchText)[0];return E&&E.value?E.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(E=>String(E.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(M,E){const N=(M||[]).filter(z=>z.statisticName===E)[0];return N?N.value:0}function k(M){const E="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(z=>z.assetType.indexOf(E)===0).reduce((z,G)=>{const q=j(M,G.assetType);return q&&z.push([G.assetType.substring(E.length),q]),z},[])}function T(M){if(M.properties){const E=M.properties.filter(G=>G.key===s.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=E.filter(G=>N.test(G.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return j(M,s.Repository)}function F(M){return{uri:`${M.fallbackAssetUri}/${s.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${s.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function j(M,E){return M.files.filter(z=>z.assetType===E)[0]?{uri:`${M.assetUri}/${E}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${E}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function B(M,E){const N=M.properties?M.properties.filter(G=>G.key===E):[],z=N.length>0&&N[0].value;return z?z.split(",").map(G=>(0,p.adoptToGalleryExtensionId)(G)):[]}function V(M){const E=M.properties?M.properties.filter(N=>N.key===a.Engine):[];return E.length>0&&E[0].value||""}function W(M){const E=M.properties?M.properties.filter(N=>N.key===a.PreRelease):[];return E.length>0&&E[0].value==="true"}function Q(M){const E=M.properties?M.properties.filter(z=>z.key===a.LocalizedLanguages):[],N=E.length>0&&E[0].value||"";return N?N.split(","):[]}function X(M){return M.properties?.find(E=>E.key===a.SponsorLink)?.value}function Y(M){return M.indexOf("preview")!==-1}function Z(M){return M.targetPlatform?(0,S.toTargetPlatform)(M.targetPlatform):"undefined"}function H(M){const E=(0,L.distinct)(M.versions.map(Z)),N=!!M.tags?.includes(S.WEB_EXTENSION_TAG),z=E.indexOf("web");return N?z===-1&&E.push("web"):z!==-1&&E.splice(z,1),E}function $(M,E){const N=(0,S.getFallbackTargetPlarforms)(E);for(let z=0;z<M.length;z++){const G=M[z];if(G.version===M[z-1]?.version){let q=z;const J=Z(G);if(J===E)for(;q>0&&M[q-1].version===G.version;)q--;else if(N.includes(J))for(;q>0&&M[q-1].version===G.version&&Z(M[q-1])!==E;)q--;q!==z&&(M.splice(z,1),M.splice(q,0,G))}}return M}e.sortExtensionVersions=$;function _(M,E,N){M.telemetryData={index:E,querySource:N,queryActivityId:M.queryContext?.[n]}}function ie(M,E,N,z){const G=M.versions[0],q={manifest:j(E,s.Manifest),readme:j(E,s.Details),changelog:j(E,s.Changelog),license:j(E,s.License),repository:T(E),download:F(E),icon:j(E,s.Icon),signature:j(E,s.Signature),coreTranslations:k(E)};return{identifier:{id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:E.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:X(G),description:M.shortDescription||"",installCount:y(M.statistics,"install"),rating:y(M.statistics,"averagerating"),ratingCount:y(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:N,assets:q,properties:{dependencies:B(E,a.Dependency),extensionPack:B(E,a.ExtensionPack),engine:V(E),localizedLanguages:Q(E),targetPlatform:Z(E),isPreReleaseVersion:W(E)},hasPreReleaseVersion:W(G),hasReleaseVersion:!0,preview:Y(M.flags),isSigned:!!q.signature,queryContext:z}}let se=class{constructor(E,N,z,G,q,J,ee,ce){this.k=N,this.l=z,this.n=G,this.o=q,this.q=J,this.u=ee,this.w=ce;const he=ee.extensionsGallery,me=he?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=me?he.servicePPEUrl:he?.serviceUrl,this.g=me?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,f.resolveMarketplaceHeaders)(ee.version,ee,this.n,this.w,this.q,E,this.o)}x(E=""){return`${this.d}${E}`}isEnabled(){return!!this.d}async getExtensions(E,N,z){const G=U.CancellationToken.isCancellationToken(N)?{}:N,q=U.CancellationToken.isCancellationToken(N)?N:z,J=[],ee=[],ce=[],he=[];let me=!0;for(const Ce of E){Ce.uuid?ee.push(Ce.uuid):J.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);ce.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),me=me&&!!Ce.hasPreRelease&&!Re}if(!ee.length&&!J.length)return[];let de=new b().withPage(1,E.length);ee.length&&(de=de.withFilter(i.ExtensionId,...ee)),J.length&&(de=de.withFilter(i.ExtensionName,...J)),(G.queryAllVersions||me)&&(de=de.withFlags(de.flags,r.IncludeVersions)),G.source&&(de=de.withSource(G.source));const{extensions:we}=await this.z(de,{targetPlatform:G.targetPlatform??R,includePreRelease:ce,versions:he,compatible:!!G.compatible},q);return G.source&&we.forEach((Ce,Re)=>_(Ce,Re,G.source)),we}async getCompatibleExtension(E,N,z){if((0,S.isNotWebExtensionInWebTargetPlatform)(E.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(E,N,z))return E;const G=new b().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,E.identifier.uuid),{extensions:q}=await this.z(G,{targetPlatform:z,compatible:!0,includePreRelease:N},U.CancellationToken.None);return q[0]||null}async isExtensionCompatible(E,N,z){if(!(0,S.isTargetPlatformCompatible)(E.properties.targetPlatform,E.allTargetPlatforms,z)||!N&&E.properties.isPreReleaseVersion)return!1;let G=E.properties.engine;if(!G){const q=await this.getManifest(E,U.CancellationToken.None);if(!q)throw new Error("Manifest was not found");G=q.engines.vscode}return(0,d.isEngineValid)(G,this.u.version,this.u.date)}async y(E,N,z,G,q){if(!(0,S.isTargetPlatformCompatible)(Z(E),G,q)||N!=="any"&&W(E)!==(N==="prerelease"))return!1;if(z)try{const J=await this.E(E);if(!(0,d.isEngineValid)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${E.version}.`,(0,l.getErrorMessage)(J)),!1}return!0}async query(E,N){let z=E.text||"";const G=E.pageSize??50;let q=new b().withPage(1,G);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,de,we)=>(q=q.withFilter(i.Category,we||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,de,we)=>(q=q.withFilter(i.Tag,we||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(i.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),q=q.withFilter(i.SearchText,z)),q=q.withSortBy(0)):E.ids?q=q.withFilter(i.ExtensionId,...E.ids):E.names?q=q.withFilter(i.ExtensionName,...E.names):q=q.withSortBy(4),typeof E.sortBy=="number"&&(q=q.withSortBy(E.sortBy)),typeof E.sortOrder=="number"&&(q=q.withSortOrder(E.sortOrder)),E.source&&(q=q.withSource(E.source));const J=async(me,de)=>{const{extensions:we,total:Ce}=await this.z(me,{targetPlatform:R,compatible:!1,includePreRelease:!!E.includePreRelease},de);return we.forEach((Re,ke)=>_(Re,(me.pageNumber-1)*me.pageSize+ke,E.source)),{extensions:we,total:Ce}},{extensions:ee,total:ce}=await J(q,N),he=async(me,de)=>{if(de.isCancellationRequested)throw new l.CancellationError;const{extensions:we}=await J(q.withPage(me+1),de);return we};return{firstPage:ee,total:ce,pageSize:q.pageSize,getPage:he}}async z(E,N,z){const G=E.flags;!!(E.flags&r.IncludeLatestVersionOnly)&&!!(E.flags&r.IncludeVersions)&&(E=E.withFlags(E.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(E.flags&r.IncludeLatestVersionOnly)&&!(E.flags&r.IncludeVersions)&&(E=E.withFlags(E.flags,r.IncludeLatestVersionOnly)),N.versions?.length&&(E=E.withFlags(E.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),E=E.withFlags(E.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:q,total:J,context:ee}=await this.B(E,z);if(!(E.flags&r.IncludeLatestVersionOnly)){const de=[];for(const we of q){const Ce=await this.A(we,N,ee);Ce&&de.push(Ce)}return{extensions:de,total:J}}const he=[],me=new Map;for(let de=0;de<q.length;de++){const we=q[de],Ce={id:(0,p.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Re=(0,D.isBoolean)(N.includePreRelease)?N.includePreRelease:!!N.includePreRelease.find(We=>(0,p.areSameExtensions)(We,Ce))?.includePreRelease;if(N.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(H(we),N.targetPlatform))continue;const ke=await this.A(we,N,ee);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==N.targetPlatform&&ke.hasPreReleaseVersion?me.set(we.extensionId,de):he.push([de,ke])}if(me.size){const de=new Date().getTime(),we=new b().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,me.size).withFilter(i.ExtensionId,...me.keys()),{extensions:Ce}=await this.z(we,N,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:me.size});for(const Re of Ce){const ke=me.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:J}}async A(E,N,z){const G={id:(0,p.getGalleryExtensionId)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},q=N.versions?.find(he=>(0,p.areSameExtensions)(he,G))?.version,J=(0,D.isBoolean)(N.includePreRelease)?N.includePreRelease:!!N.includePreRelease.find(he=>(0,p.areSameExtensions)(he,G))?.includePreRelease,ee=H(E),ce=$(E.versions,N.targetPlatform);if(N.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(ee,N.targetPlatform))return null;for(let he=0;he<ce.length;he++){const me=ce[he];if(!(q&&me.version!==q)){if(await this.y(me,J?"any":"release",N.compatible,ee,N.targetPlatform))return ie(E,me,ee,z);if(q&&me.version===q)return null}}return q||N.compatible?null:ie(E,E.versions[0],ee)}async B(E,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");E=E.withFlags(E.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(r.Unpublished));const z=await this.j,G=JSON.stringify(E.raw),q={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},J=new Date().getTime();let ee,ce,he=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&E.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:q},N),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(ee);if(me){const de=me.results[0],we=de.extensions,Ce=de.resultMetadata&&de.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw ce=me,me}finally{this.o.publicLog2("galleryService:query",{...E.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-J,success:!!ee&&(0,u.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ce?(0,l.isCancellationError)(ce)?"canceled":(0,l.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(E,N,z,G){if(!this.isEnabled())return;const q=A.isWeb?this.x(`/itemName/${E}.${N}/version/${z}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${E}/extensions/${N}/${z}/stats?statType=${G}`),J=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:q,headers:ce},U.CancellationToken.None)}catch{}}async download(E,N,z){this.l.trace("ExtensionGalleryService#download",E.identifier.id);const G=(0,p.getGalleryExtensionTelemetryData)(E),q=new Date().getTime(),J=de=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:de}),ee=z===2?"install":z===3?"update":"",ce=ee?{uri:`${E.assets.download.uri}${I.URI.parse(E.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${E.assets.download.fallbackUri}${I.URI.parse(E.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:E.assets.download,he=E.queryContext?.[n]?{[n]:E.queryContext[n]}:void 0,me=await this.D(ce,he?{headers:he}:void 0);await this.q.writeFile(N,me.stream),J(new Date().getTime()-q)}async downloadSignatureArchive(E,N){if(!E.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",E.identifier.id);const z=await this.D(E.assets.signature);await this.q.writeFile(N,z.stream)}async getReadme(E,N){if(E.assets.readme){const z=await this.D(E.assets.readme,{},N);return await(0,u.asTextOrError)(z)||""}return""}async getManifest(E,N){if(E.assets.manifest){const z=await this.D(E.assets.manifest,{},N),G=await(0,u.asTextOrError)(z);return G?JSON.parse(G):null}return null}async C(E,N){const z=j(E,s.Manifest);if(!z)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},q=await this.D(z,{headers:G});return await(0,u.asJson)(q)}async getCoreTranslation(E,N){const z=E.assets.coreTranslations.filter(G=>G[0]===N.toUpperCase())[0];if(z){const G=await this.D(z[1]),q=await(0,u.asTextOrError)(G);return q?JSON.parse(q):null}return null}async getChangelog(E,N){if(E.assets.changelog){const z=await this.D(E.assets.changelog,{},N);return await(0,u.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(E,N,z){let G=new b().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);E.identifier.uuid?G=G.withFilter(i.ExtensionId,E.identifier.uuid):G=G.withFilter(i.ExtensionName,E.identifier.id);const{galleryExtensions:q}=await this.B(G,U.CancellationToken.None);if(!q.length)return[];const J=H(q[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(J,z))return[];const ee=[];await Promise.all(q[0].versions.map(async me=>{try{await this.y(me,N?"any":"release",!0,J,z)&&ee.push(me)}catch{}}));const ce=[],he=new Set;for(const me of $(ee,z))he.has(me.version)||(he.add(me.version),ce.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:W(me)}));return ce}async D(E,N={},z=U.CancellationToken.None){const G=await this.j,q={type:"GET"},J={...G,...N.headers||{}};N={...N,...q,headers:J};const ee=E.uri,ce=E.fallbackUri,he={...N,url:ee};try{const me=await this.k.request(he,z);if(me.res.statusCode===200)return me;const de=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${de}`)}catch(me){if((0,l.isCancellationError)(me))throw me;const de=(0,l.getErrorMessage)(me);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:de});const we={...N,url:ce};return this.k.request(we,z)}}async E(E){let N=V(E);if(!N){const z=await this.C(E,U.CancellationToken.None);if(!z)throw new Error("Manifest was not found");N=z.engines.vscode}return N}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const E=await this.k.request({type:"GET",url:this.h},U.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,u.asJson)(E),z=[],G={};if(N){for(const q of N.malicious)z.push({id:q});if(N.migrateToPreRelease)for(const[q,J]of Object.entries(N.migrateToPreRelease))(!J.engine||(0,d.isEngineValid)(J.engine,this.u.version,this.u.date))&&(G[q.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(N.deprecated)for(const[q,J]of Object.entries(N.deprecated))J&&(G[q.toLowerCase()]=(0,D.isBoolean)(J)?{}:J)}return{malicious:z,deprecated:G}}};se=ye([K(1,u.IRequestService),K(2,C.ILogService),K(3,P.IEnvironmentService),K(4,v.ITelemetryService),K(5,m.IFileService),K(6,c.IProductService),K(7,w.IConfigurationService)],se);let ae=class extends se{constructor(E,N,z,G,q,J,ee,ce){super(E,N,z,G,q,J,ee,ce)}};ae=ye([K(0,g.IStorageService),K(1,u.IRequestService),K(2,C.ILogService),K(3,P.IEnvironmentService),K(4,v.ITelemetryService),K(5,m.IFileService),K(6,c.IProductService),K(7,w.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let x=class extends se{constructor(E,N,z,G,q,J,ee){super(void 0,E,N,z,G,q,J,ee)}};x=ye([K(0,u.IRequestService),K(1,C.ILogService),K(2,P.IEnvironmentService),K(3,v.ITelemetryService),K(4,m.IFileService),K(5,c.IProductService),K(6,w.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(re[79],oe([0,1,5,3,2,20,33,26,21,9,12]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends l.Disposable{static b(m){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static c(m){const C=S.exec(m);if(C&&C[1])return{id:C[1],version:C[2]}}static async removeOutdatedExtensionVersions(m,C){const c=await m.getInstalled(),u=[];for(const[f,g]of Xe.f(C)){const v=c.find(R=>(0,O.areSameExtensions)(R.identifier,{id:f}))?.manifest.version;for(const R of g)v!==R&&u.push(Xe.b({id:f,version:R}))}for(const f of u)C.remove(f,0)}static f(m){const C=new Map,c=m.keys(0,1);for(const u of c){const f=Xe.c(u);if(f){let g=C.get(f.id.toLowerCase());g||C.set(f.id.toLowerCase(),g=[]),g.push(f.version)}}return C}constructor(m,C,c){super(),this.i=m,this.j=C,this.k=c,this.g=this.D(new U.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(m),this.D(this.i.onDidChangeValue(u=>this.l(u)))}l(m){if(m.scope!==0)return;if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const C=Xe.c(m.key);if(C){if(this.i.get(m.key,0)===void 0)this.h.delete(C.id.toLowerCase());else{let c=this.h.get(C.id.toLowerCase());c||this.h.set(C.id.toLowerCase(),c=[]),c.push(C.version),this.g.fire()}return}}m(m){if((0,P.isString)(m))return m;const C=m.manifest?m.manifest.publisher:m.publisher,c=m.manifest?m.manifest.name:m.name;return(0,O.getExtensionId)(C,c)}getExtensionState(m,C){const c=this.m(m),u=this.getExtensionStateRaw(m,C);if(u)try{return JSON.parse(u)}catch(f){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${C}): ${f}`)}}getExtensionStateRaw(m,C){const c=this.m(m),u=this.i.get(c,C?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${C}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(m,C,c){const u=this.m(m);C===void 0?this.i.remove(u,c?0:1):this.i.store(u,JSON.stringify(C),c?0:1,1)}setKeysForSync(m,C){this.i.store(Xe.b(m),JSON.stringify(C),0,1)}getKeysForSync(m){const C=this.j.extensionSyncedKeys?.[m.id.toLowerCase()],c=this.i.get(Xe.b(m),0),u=c?JSON.parse(c):void 0;return u&&C?(0,I.distinct)([...u,...C]):u||C}addToMigrationList(m,C){if(m!==C){const c=this.n.filter(u=>!u.includes(m)&&!u.includes(C));c.push([m,C]),this.n=c}}getSourceExtensionToMigrate(m){const C=this.n.find(([,c])=>m===c);return C?C[0]:void 0}get n(){const m=this.i.get("extensionStorage.migrationList",-1,"[]");try{const C=JSON.parse(m);if(Array.isArray(C))return C}catch{}return[]}set n(m){m.length?this.i.store("extensionStorage.migrationList",JSON.stringify(m),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};p.a=512*1024,p=ye([K(0,A.IStorageService),K(1,D.IProductService),K(2,w.ILogService)],p),e.ExtensionStorageService=p}),define(re[274],oe([0,1,29,14,26,15,101,57,20,19,237]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends P.AbstractNativeExtensionTipsService{constructor(d,m,C,c,u,f,g,v){super(d.userHome,u,m,C,c,f,g,v)}};S=ye([K(0,A.INativeEnvironmentService),K(1,w.ITelemetryService),K(2,L.IExtensionManagementService),K(3,I.IStorageService),K(4,D.INativeHostService),K(5,O.IExtensionRecommendationNotificationService),K(6,U.IFileService),K(7,l.IProductService)],S),e.ExtensionTipsService=S}),define(re[275],oe([0,1,6,2,23,66,20,75,18]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class w extends O.AbstractStorageService{constructor(S,p,d,m){super(),this.X=S,this.Y=p,this.Z=d,this.ab=m,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.D(new U.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.D(new U.DisposableStore),this.W=this.db(this.X)}bb(){const S=this.D(new D.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),p=this.D(new A.Storage(S));return this.D(p.onDidChangeStorage(d=>this.n(-1,d))),p}cb(S){this.Q.clear(),this.P=S;let p;if((0,O.isProfileUsingDefaultStorage)(S))p=this.s;else{const d=this.Q.add(new D.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.Q.add(new A.Storage(d))}return this.Q.add(p.onDidChangeStorage(d=>this.n(0,d))),p}db(S){this.U.clear(),this.S=S?.id;let p;if(S){const d=this.U.add(new D.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.U.add(new A.Storage(d)),this.U.add(p.onDidChangeStorage(m=>this.n(1,m)))}return p}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(S){switch(S){case-1:return this.s;case 0:return this.R;default:return this.W}}M(S){switch(S){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.q(O.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(S,p){if(!this.H(this.P,S))return;const d=this.R,m=d.items;d!==this.s&&await d.close(),this.R=this.cb(S),await this.R.init(),this.I(m,this.R,0,p)}async O(S,p){const d=this.W,m=d?.items??new Map;await d?.close(),this.W=this.db(S),await this.W.init(),this.I(m,this.W,1,p)}hasScope(S){return(0,I.isUserDataProfile)(S)?this.P.id===S.id:this.S===S.id}}e.RemoteStorageService=w}),define(re[276],oe([0,1,3,2,18,93]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class O{constructor(w,P){this.a=w,this.b=P}listen(w,P){const S=this.b(w);switch(P){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(d=>(0,A.transformOutgoingURIs)({...d},S)),added:p.added.map(d=>(0,A.transformOutgoingURIs)({...d},S)),removed:p.removed.map(d=>(0,A.transformOutgoingURIs)({...d},S)),updated:p.updated.map(d=>(0,A.transformOutgoingURIs)({...d},S))}))}throw new Error(`Invalid listen ${P}`)}async call(w,P,S){const p=this.b(w);switch(P){case"createProfile":{const d=await this.a.createProfile(S[0],S[1],S[2]);return(0,A.transformOutgoingURIs)({...d},p)}case"updateProfile":{let d=(0,l.reviveProfile)((0,A.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,S[1]),(0,A.transformOutgoingURIs)({...d},p)}case"removeProfile":{const d=(0,l.reviveProfile)((0,A.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=O;class D extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,P,S){super(),this.profilesHome=P,this.f=S,this.a=[],this.b=this.D(new L.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(p=>(0,l.reviveProfile)(p,this.profilesHome.scheme)),this.D(this.f.listen("onDidChangeProfiles")(p=>{const d=p.added.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),m=p.removed.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),C=p.updated.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme));this.a=p.all.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),this.b.fire({added:d,removed:m,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,P,S){const p=await this.f.call("createNamedProfile",[w,P,S]);return(0,l.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(w,P,S,p){const d=await this.f.call("createProfile",[w,P,S,p]);return(0,l.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(w){const P=await this.f.call("createTransientProfile",[w]);return(0,l.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(w,P){await this.f.call("setProfileForWorkspace",[w,P])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,P){const S=await this.f.call("updateProfile",[w,P]);return(0,l.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(re[61],oe([0,1,2,66,5,20,3,75,18]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let w=class extends L.Disposable{constructor(d){super(),this.a=d}async readStorageData(d){return this.withProfileScopedStorageService(d,async m=>this.b(m))}async updateStorageData(d,m,C){return this.withProfileScopedStorageService(d,async c=>this.c(c,m,C))}async withProfileScopedStorageService(d,m){if(this.a.hasScope(d))return m(this.a);const C=await this.g(d),c=new S(C);try{await c.initialize();const u=await m(c);return await c.flush(),u}finally{c.dispose(),await this.f(C)}}b(d){const m=new Map,C=c=>{for(const u of d.keys(0,c))m.set(u,{value:d.get(u,0),target:c})};return C(0),C(1),m}c(d,m,C){for(const[c,u]of m)d.store(c,u,0,C)}async f(d){try{await d.close()}finally{(0,L.isDisposable)(d)&&d.dispose()}}};w=ye([K(0,A.IStorageService)],w),e.AbstractUserDataProfileStorageService=w;class P extends w{constructor(d,m,C,c){super(C),this.i=d;const u=d.getChannel("profileStorageListener"),f=this.D(new L.MutableDisposable);this.h=this.D(new O.Emitter({onWillAddFirstListener:()=>{f.value=u.listen("onDidChange")(g=>{c.trace("profile storage changes",g),this.h.fire({targetChanges:g.targetChanges.map(v=>(0,I.reviveProfile)(v,m.profilesHome.scheme)),valueChanges:g.valueChanges.map(v=>({...v,profile:(0,I.reviveProfile)(v.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(d){const m=this.i.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(d)?new D.ApplicationStorageDatabaseClient(m):new D.ProfileStorageDatabaseClient(m,d)}}e.RemoteUserDataProfileStorageService=P;class S extends A.AbstractStorageService{constructor(d){super({flushInterval:100}),this.p=this.D(new U.Storage(d))}J(){return this.p.init()}L(d){return d===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[277],oe([0,1,20,9,18,71,61]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=class extends O.RemoteUserDataProfileStorageService{constructor(w,P,S,p){super(w,P,S,p)}};D=ye([K(0,A.IMainProcessService),K(1,l.IUserDataProfilesService),K(2,L.IStorageService),K(3,U.ILogService)],D),e.NativeUserDataProfileStorageService=D}),define(re[41],oe([0,1,21,6,16,25,3,35,2,27,12,182,17,15,14,9,44,20,19,30,24,18]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||r(h.syncData)))}e.isRemoteUserData=n;function r(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=r;function t(h,b){return`${(0,w.uppercaseFirstLetter)(h)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=t;let i=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,y,k,T,F,j,B,V,W,Q,X,Y){super(),this.syncResource=b,this.collection=y,this.z=k,this.C=T,this.F=F,this.G=j,this.H=B,this.I=V,this.J=W,this.L=Q,this.M=X,this.c=null,this.k="idle",this.l=this.D(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.D(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.q=new U.ThrottledDelayer(50),this.s=this.D(new O.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=t(b.syncResource,b.profile),this.h=Y.extUri,this.f=this.h.joinPath(T.userDataSyncHome,...(0,v.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.t=(0,v.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,T,this.h),this.j=(0,c.getServiceMachineId)(T,k,F)}N(){this.q.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const y=await this.U(b.remoteUserData,b.lastSyncUserData,!0,this.mb());this.P(y)}else{this.L.trace(`${this.w}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.sb(b):!0)&&this.s.fire()}}P(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,y={}){await this.Q(b,!0,this.mb(),y)}async preview(b,y,k={}){return this.Q(b,!1,y,k)}async apply(b,y={}){try{this.y={...y};const k=await this.Y(b);return this.P(k),this.c}finally{this.y={}}}async Q(b,y,k,T){try{if(this.y={...T},this.status==="hasConflicts")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let F="idle";try{const j=await this.getLastSyncUserData(),B=await this.S(b,j);return F=await this.U(B,j,y,k),F==="hasConflicts"?this.L.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(F)}}finally{this.y={}}}async replace(b){const y=this.ib(b);if(!y)return!1;await this.stop();try{this.L.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const k=await this.getLastSyncUserData(),T=await this.S(null,k),F=await this.R(T),j=await this.ob({ref:T.ref,syncData:y},k,F,this.mb(),A.CancellationToken.None),B=[];for(const V of j){const W=await this.qb(V,V.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.qb(V,V.previewResource,V.remoteContent,A.CancellationToken.None);B.push([V,{...W,remoteChange:Q!==0?Q:2}])}await this.rb(T,k,B,!1),this.L.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(b){const y=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===y}async S(b,y){if(y){const k=b?b[this.resource]:void 0;if(y.ref===k||k===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async U(b,y,k,T){if(b.syncData&&b.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,S.localize)(0,null,this.resource,this.nb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(b,y,k,T)}catch(F){if(F instanceof v.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.U(b,y,k,T);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.U(b,y,k,T)}throw F}}async W(b,y,k,T){try{const F=await this.R(b),j=!F&&y===null&&this.eb()!==void 0,B=k&&!j;this.c||(this.c=(0,U.createCancelablePromise)(W=>this.cb(b,y,F,B,T,W)));let V=await this.c;if(k&&j){this.L.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const W of V.resourcePreviews)V=await this.accept(W.remoteResource)||V}return this.ab(V.resourcePreviews),V.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":k?await this.Y(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(b){return await this.X(b,async y=>{const k=await this.pb(y,A.CancellationToken.None);await this.z.writeFile(y.previewResource,l.VSBuffer.fromString(k?.content||""));const T=k&&!k.hasConflicts?await this.qb(y,y.previewResource,void 0,A.CancellationToken.None):void 0;return y.acceptResult=T,y.mergeState=k.hasConflicts?"conflict":T?"accepted":"preview",y.localChange=T?T.localChange:k.localChange,y.remoteChange=T?T.remoteChange:k.remoteChange,y}),this.c}async accept(b,y){return await this.X(b,async k=>{const T=await this.qb(k,b,y,A.CancellationToken.None);return k.acceptResult=T,k.mergeState="accepted",k.localChange=T.localChange,k.remoteChange=T.remoteChange,k}),this.c}async discard(b){return await this.X(b,async y=>{const k=await this.pb(y,A.CancellationToken.None);return await this.z.writeFile(y.previewResource,l.VSBuffer.fromString(k.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=k.localChange,y.remoteChange=k.remoteChange,y}),this.c}async X(b,y){if(!this.c)return;let k=await this.c;const T=k.resourcePreviews.findIndex(({localResource:F,remoteResource:j,previewResource:B})=>this.h.isEqual(F,b)||this.h.isEqual(j,b)||this.h.isEqual(B,b));T!==-1&&(this.c=(0,U.createCancelablePromise)(async F=>{const j=[...k.resourcePreviews];return j[T]=await y(j[T]),{...k,resourcePreviews:j}}),k=await this.c,this.ab(k.resourcePreviews),k.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(b){if(!this.c)return"idle";const y=await this.c;return y.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.rb(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(k=>[k,k.acceptResult]),b),this.c=null,await this.Z(),"idle")}async Z(){try{await this.z.del(this.g,{recursive:!0})}catch{}}ab(b){const y=b.filter(({mergeState:k})=>k==="conflict");(0,L.equals)(this.m,y,(k,T)=>this.h.isEqual(k.previewResource,T.previewResource))||(this.m=y,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async bb(b){const y=this.c?await this.c:null;if(y)for(const k of y.resourcePreviews){if(this.h.isEqual(k.acceptedResource,b))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,b))return k.remoteContent;if(this.h.isEqual(k.localResource,b))return k.localContent;if(this.h.isEqual(k.baseResource,b))return k.baseContent}return null}async resetLocal(){this.F.remove(this.u,-1);try{await this.z.del(this.t)}catch(b){(0,m.toFileOperationResult)(b)!==1&&this.L.error(b)}}async cb(b,y,k,T,F,j){const B=await this.ob(b,y,k,F,j),V=[];for(const W of B){const Q=W.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)V.push({...W,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=T?await this.pb(W,j):void 0;if(j.isCancellationRequested)break;await this.z.writeFile(W.previewResource,l.VSBuffer.fromString(X?.content||""));const Y=X&&!X.hasConflicts?await this.qb(W,W.previewResource,void 0,j):void 0;V.push({...W,acceptResult:Y,mergeState:X?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:X?X.localChange:W.localChange,remoteChange:Y?Y.remoteChange:X?X.remoteChange:W.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:y,resourcePreviews:V,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let b=this.eb();if(b||(b=await this.hb()),!b)return this.L.info(`${this.w}: Last sync data state does not exist.`),null;const y=JSON.parse(b),k=this.I.getResourceSyncStateVersion(this.resource);if(this.v=!!y.version&&!!k&&y.version!==k,this.v)return this.L.info(`${this.w}: Reset last sync state because last sync state version ${y.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let T,F=1;for(;T===void 0&&F++<6;)try{const j=await this.fb();j&&(j.ref===y.ref?T=j.syncData:this.L.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof m.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(j instanceof v.UserDataSyncError)throw j;this.L.error(j,F)}}if(T===void 0)try{const j=await this.G.resolveResourceContent(this.resource,y.ref,this.collection,this.y);T=j===null?null:this.ib(j),await this.gb({ref:y.ref,syncData:T})}catch(j){if(j instanceof v.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.w}: Last sync resource does not exist remotely.`);else throw j}return T===void 0?null:{...y,syncData:T}}async db(b,y={}){if(y.ref||y.version)throw new Error("Cannot have core properties as additional");const k=this.I.getResourceSyncStateVersion(this.resource),T={ref:b.ref,version:k,...y};this.F.store(this.u,JSON.stringify(T),-1,1),await this.gb(b)}eb(){return this.F.get(this.u,-1)}async fb(){const b=(await this.z.readFile(this.t)).value.toString();try{const y=b?JSON.parse(b):void 0;if(n(y))return y}catch(y){this.L.error(y)}}async gb(b){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(b)))}async hb(){try{const b=await this.z.readFile(this.t),y=JSON.parse(b.value.toString());await this.z.del(this.t),y.ref&&y.content!==void 0?(this.F.store(this.u,JSON.stringify({...y,content:void 0}),-1,1),await this.gb({ref:y.ref,syncData:y.content===null?null:JSON.parse(y.content)})):this.L.info(`${this.w}: Migrating last sync user data. Invalid data.`,y)}catch(b){b instanceof m.FileOperationError&&b.fileOperationResult===1?this.L.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.u,-1)}async getRemoteUserData(b){const{ref:y,content:k}=await this.jb(b);let T=null;return k!==null&&(T=this.ib(k)),{ref:y,syncData:T}}ib(b){try{const y=JSON.parse(b);if(r(y))return y}catch(y){this.L.error(y)}throw new v.UserDataSyncError((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(b){const y=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,y,this.collection,this.y)}async kb(b,y){const k=await this.j,T={version:this.nb,machineId:k,content:b};try{return y=await this.G.writeResource(this.resource,JSON.stringify(T),y,this.collection,this.y),{ref:y,syncData:T}}catch(F){throw F instanceof v.UserDataSyncError&&F.code==="TooLarge"&&(F=new v.UserDataSyncError(F.message,F.code,this.resource)),F}}async lb(b){const y={version:this.nb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=ye([K(2,m.IFileService),K(3,d.IEnvironmentService),K(4,u.IStorageService),K(5,v.IUserDataSyncStoreService),K(6,v.IUserDataSyncBackupStoreService),K(7,v.IUserDataSyncEnablementService),K(8,f.ITelemetryService),K(9,v.IUserDataSyncLogService),K(10,p.IConfigurationService),K(11,g.IUriIdentityService)],i),e.AbstractSynchroniser=i;let s=class extends i{constructor(b,y,k,T,F,j,B,V,W,Q,X,Y,Z){super(y,k,T,F,j,B,V,W,Q,X,Y,Z),this.i=b,this.D(this.z.watch(this.h.dirname(b))),this.D(this.z.onDidFilesChange(H=>this.ub(H)))}async p(){try{return await this.z.readFile(this.i)}catch{return null}}async r(b,y,k){try{y?await this.z.writeFile(this.i,l.VSBuffer.fromString(b),k?void 0:y):await this.z.createFile(this.i,l.VSBuffer.fromString(b),{overwrite:k})}catch(T){throw T instanceof m.FileOperationError&&T.fileOperationResult===1||T instanceof m.FileOperationError&&T.fileOperationResult===3?new v.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async tb(){try{await this.z.del(this.i)}catch(b){if(!(b instanceof m.FileOperationError&&b.fileOperationResult===1))throw b}}ub(b){!b.contains(this.i)||this.N()}};s=ye([K(3,m.IFileService),K(4,d.IEnvironmentService),K(5,u.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,f.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,p.IConfigurationService),K(12,g.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(b,y,k,T,F,j,B,V,W,Q,X,Y,Z,H){super(b,y,k,T,F,j,B,V,W,Q,X,Z,H),this.vb=Y,this.xb=void 0}wb(b,y){const k=[],T=(0,D.parse)(b,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,P.isUndefined)(T)&&y!==Array.isArray(T)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};a=ye([K(3,m.IFileService),K(4,d.IEnvironmentService),K(5,u.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,f.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,v.IUserDataSyncUtilService),K(12,p.IConfigurationService),K(13,g.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let o=class{constructor(b,y,k,T,F,j,B){this.resource=b,this.g=y,this.h=k,this.j=T,this.k=F,this.l=j,this.d=B.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,k,this.d)}async initialize({ref:b,content:y}){if(!y){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(y);if(!!k)try{await this.o({ref:b,syncData:k})}catch(T){this.j.error(T)}}m(b){try{const y=JSON.parse(b);if(r(y))return y}catch(y){this.j.error(y)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,y={}){if(y.ref||y.version)throw new Error("Cannot have core properties as additional");const k={ref:b.ref,version:void 0,...y};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,l.VSBuffer.fromString(JSON.stringify(b)))}};o=ye([K(1,R.IUserDataProfilesService),K(2,d.IEnvironmentService),K(3,C.ILogService),K(4,m.IFileService),K(5,u.IStorageService),K(6,g.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[121],oe([0,1,6,25,10,3,42,2,27,17,15,120,29,33,79,14,5,70,9,20,19,30,18,41,258,118,24,61]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r,t,i,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(F,j){const B=JSON.parse(F.content);if(F.version===1||F.version===2){const V=(await j.getInstalled(0)).filter(W=>W.isBuiltin);for(const W of B)F.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),F.version===2&&V.every(Q=>!(0,d.areSameExtensions)(Q.identifier,W.identifier))&&(W.installed=!0)}return B}function h(F){return JSON.parse(F.content)}e.parseExtensions=h;function b(F,j){return F.sort((B,V)=>!B.identifier.uuid&&V.identifier.uuid?-1:B.identifier.uuid&&!V.identifier.uuid?1:(0,I.compare)(B.identifier.id,V.identifier.id)),j?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=b;let y=class extends r.AbstractSynchroniser{constructor(j,B,V,W,Q,X,Y,Z,H,$,_,ie,se,ae,x,M,E){super({syncResource:"extensions",profile:j},B,W,V,Q,X,Y,ie,se,$,_,x),this.zb=Z,this.Ab=H,this.Bb=E,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(k),this.D(A.Event.any(A.Event.filter(this.zb.onDidInstallExtensions,N=>N.some(({local:z})=>!!z)),A.Event.filter(this.zb.onDidUninstallExtension,N=>!N.error),A.Event.filter(M.onDidChange,N=>N.valueChanges.some(({profile:z,changes:G})=>this.syncResource.profile.id===z.id&&G.some(q=>q.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(j,B){const V=j.syncData?await o(j.syncData,this.zb):null,W=B?.skippedExtensions??[],Q=B?.builtinExtensions??null,X=B?.syncData?await o(B.syncData,this.zb):null,{localExtensions:Y,ignoredExtensions:Z}=await this.yb.getLocalExtensions(this.syncResource.profile);V?this.L.trace(`${this.w}: Merging remote extensions with local extensions...`):this.L.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:$}=(0,t.merge)(Y,V,X,W,Z,Q),_={local:H,remote:$,content:this.Eb(Y,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:$!==null?2:0},ie=this.Lb(Y,!1);return[{skippedExtensions:W,builtinExtensions:Q,baseResource:this.ub,baseContent:X?this.Lb(X,!1):ie,localResource:this.vb,localContent:ie,localExtensions:Y,remoteResource:this.wb,remoteExtensions:V,remoteContent:V?this.Lb(V,!1):null,previewResource:this.tb,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.xb}]}async sb(j){const B=j.syncData?await o(j.syncData,this.zb):null,{localExtensions:V,ignoredExtensions:W}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,t.merge)(V,B,B,j.skippedExtensions||[],W,j.builtinExtensions||[]);return Q!==null}Eb(j,B,V,W){const Q=[...B,...V],X=new Set,Y=Z=>{X.add(Z.id.toLowerCase()),Z.uuid&&X.add(Z.uuid)};Q.forEach(({identifier:Z})=>Y(Z)),W.forEach(Y);for(const Z of j)X.has(Z.identifier.id.toLowerCase())||Z.identifier.uuid&&X.has(Z.identifier.uuid)||Q.push(Z);return this.Lb(Q,!1)}async pb(j,B){return{...j.previewResult,hasConflicts:!1}}async qb(j,B,V,W){if(this.h.isEqual(B,this.vb))return this.Hb(j);if(this.h.isEqual(B,this.wb))return this.Ib(j);if(this.h.isEqual(B,this.tb))return j.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Hb(j){const B=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(B),W=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,V,j.builtinExtensions),{local:Q,remote:X}=W;return{content:j.localContent,local:Q,remote:X,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:X!==null?2:0}}async Ib(j){const B=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(B),W=j.remoteContent?JSON.parse(j.remoteContent):null;if(W!==null){const Q=(0,t.merge)(j.localExtensions,W,j.localExtensions,[],V,j.builtinExtensions),{local:X,remote:Y}=Q;return{content:j.remoteContent,local:X,remote:Y,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(j,B,V,W){let{skippedExtensions:Q,builtinExtensions:X,localExtensions:Y}=V[0][0];const{local:Z,remote:H,localChange:$,remoteChange:_}=V[0][1];if($===0&&_===0&&this.L.info(`${this.w}: No changes found during synchronizing extensions.`),$!==0&&(await this.lb(JSON.stringify(Y)),Q=await this.yb.updateLocalExtensions(Z.added,Z.removed,Z.updated,Q,this.syncResource.profile)),H){this.L.trace(`${this.w}: Updating remote extensions...`);const ie=JSON.stringify(H.all);j=await this.kb(ie,W?null:j.ref),this.L.info(`${this.w}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(se=>se.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(se=>se.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(se=>se.identifier.id))}.`:""}`)}B?.ref!==j.ref&&(this.L.trace(`${this.w}: Updating last synchronized extensions...`),X=this.Kb(Y,X),await this.db(j,{skippedExtensions:Q,builtinExtensions:X}),this.L.info(`${this.w}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ie=>ie.identifier.id))}.`:""}`))}Kb(j,B){const V=new Set,W=[];for(const Q of j)V.add(Q.identifier.id.toLowerCase()),Q.installed||W.push(Q.identifier);if(B)for(const Q of B)V.has(Q.id.toLowerCase())||W.push(Q);return W}async resolveContent(j){if(this.h.isEqual(this.wb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.vb,j)||this.h.isEqual(this.xb,j)){const B=await this.bb(j);return B&&this.Lb(JSON.parse(B),!0)}return null}Lb(j,B){return b(j,B)}async hasLocalData(){try{const{localExtensions:j}=await this.yb.getLocalExtensions(this.syncResource.profile);if(j.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};y=ye([K(2,P.IEnvironmentService),K(3,C.IFileService),K(4,g.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,p.IExtensionManagementService),K(8,i.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,v.ITelemetryService),K(13,m.IExtensionStorageService),K(14,R.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,c.IInstantiationService)],y),e.ExtensionsSynchroniser=y;let k=class{constructor(j,B,V,W,Q,X){this.a=j,this.b=B,this.c=V,this.d=W,this.f=Q,this.g=X}async getLocalExtensions(j){const B=await this.a.getInstalled(void 0,j.extensionsResource),V=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(j,async(Q,X)=>{const Y=Q.getDisabledExtensions();return B.map(Z=>{const{identifier:H,isBuiltin:$,manifest:_,preRelease:ie,pinned:se}=Z,ae={identifier:H,preRelease:ie,version:_.version,pinned:!!se};Y.some(x=>(0,d.areSameExtensions)(x,H))&&(ae.disabled=!0),$||(ae.installed=!0);try{const x=X.getKeysForSync({id:H.id,version:_.version});if(x){const M=X.getExtensionState(Z,!0)||{};ae.state=Object.keys(M).reduce((E,N)=>(x.includes(N)&&(E[N]=M[N]),E),{})}}catch(x){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,l.getErrorMessage)(x))}return ae})}),ignoredExtensions:V}}async updateLocalExtensions(j,B,V,W,Q){const X=(0,r.getSyncResourceLogLabel)("extensions",Q),Y=[],Z=[],H=[],$=await this.a.getInstalled(void 0,Q.extensionsResource);if((j.length||V.length)&&await this.j(Q,async(ie,se)=>{await L.Promises.settled([...j,...V].map(async ae=>{const x=$.find(N=>(0,d.areSameExtensions)(N.identifier,ae.identifier));if(x&&x.isBuiltin){ae.state&&x.manifest.version===ae.version&&this.h(ae.state,x,x.manifest.version,se),ie.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${X}: Disabling extension...`,ae.identifier.id),await ie.disableExtension(ae.identifier),this.g.info(`${X}: Disabled extension`,ae.identifier.id)):(this.g.trace(`${X}: Enabling extension...`,ae.identifier.id),await ie.enableExtension(ae.identifier),this.g.info(`${X}: Enabled extension`,ae.identifier.id))),Z.push(ae.identifier);return}const M=ae.pinned?ae.version:void 0,E=(await this.c.getExtensions([{...ae.identifier,version:M,preRelease:M?void 0:ae.preRelease}],U.CancellationToken.None))[0];if(ae.state&&(x?x.manifest.version===ae.version:!!E)&&this.h(ae.state,x||E,x?.manifest.version,se),E)try{ie.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${X}: Disabling extension...`,ae.identifier.id,E.version),await ie.disableExtension(E.identifier),this.g.info(`${X}: Disabled extension`,ae.identifier.id,E.version)):(this.g.trace(`${X}: Enabling extension...`,ae.identifier.id,E.version),await ie.enableExtension(E.identifier),this.g.info(`${X}: Enabled extension`,ae.identifier.id,E.version))),(!x||x.preRelease!==ae.preRelease||x.pinned!==ae.pinned||M&&x.manifest.version!==M)&&(await this.a.canInstall(E)?Y.push([ae,E]):(this.g.info(`${X}: Skipped synchronizing extension because it cannot be installed.`,E.displayName||E.identifier.id),H.push(ae)))}catch(N){H.push(ae),this.g.error(N),this.g.info(`${X}: Skipped synchronizing extension`,E.displayName||E.identifier.id)}else H.push(ae),this.g.info(`${X}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),B.length){const ie=$.filter(({identifier:se,isBuiltin:ae})=>!ae&&B.some(x=>(0,d.areSameExtensions)(se,x)));await L.Promises.settled(ie.map(async se=>{this.g.trace(`${X}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${X}: Uninstalled local extension.`,se.identifier.id),Z.push(se.identifier)}))}for(const[ie,se]of Y)try{this.g.trace(`${X}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ie.pinned&&!!ie.version,installPreReleaseVersion:ie.preRelease,profileLocation:Q.extensionsResource,context:{[p.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[p.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${X}: Installed extension.`,se.identifier.id,se.version),Z.push(se.identifier)}catch(ae){H.push(ie),ae instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.g.info(`${X}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(ae),this.g.info(`${X}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const _=[];for(const ie of W)Z.some(se=>(0,d.areSameExtensions)(se,ie.identifier))||_.push(ie);for(const ie of H)_.some(se=>(0,d.areSameExtensions)(se.identifier,ie.identifier))||_.push(ie);return _}h(j,B,V,W){const Q=W.getExtensionState(B,!0)||{},X=V?W.getKeysForSync({id:B.identifier.id,version:V}):void 0;X?X.forEach(Y=>{Q[Y]=j[Y]}):Object.keys(j).forEach(Y=>Q[Y]=j[Y]),W.setExtensionState(B,Q,!0)}async j(j,B){return this.b.withProfileScopedStorageService(j,async V=>{const W=new D.DisposableStore,Q=this.f.createChild(new u.ServiceCollection([g.IStorageService,V])),X=W.add(Q.createInstance(S.GlobalExtensionEnablementService)),Y=W.add(Q.createInstance(m.ExtensionStorageService));try{return await B(X,Y)}finally{W.dispose()}})}};k=ye([K(0,p.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,p.IExtensionGalleryService),K(3,i.IIgnoredExtensionsManagementService),K(4,c.IInstantiationService),K(5,s.IUserDataSyncLogService)],k),e.LocalExtensionsProvider=k;let T=class extends r.AbstractInitializer{constructor(j,B,V,W,Q,X,Y,Z){super("extensions",W,Q,X,V,Y,Z),this.p=j,this.q=B}async t(j){return j.syncData?await o(j.syncData,this.p):null}u(j,B){const V=[],W=[],Q=[];for(const X of j){if(this.q.hasToNeverSyncExtension(X.identifier.id))continue;const Y=B.find(Z=>(0,d.areSameExtensions)(Z.identifier,X.identifier));Y?(V.push(Y),X.disabled&&Q.push(X.identifier)):X.installed&&(W.push({...X.identifier,preRelease:!!X.preRelease}),X.disabled&&Q.push(X.identifier))}return{installedExtensions:V,newExtensions:W,disabledExtensions:Q,remoteExtensions:j}}};T=ye([K(0,p.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,C.IFileService),K(3,n.IUserDataProfilesService),K(4,P.IEnvironmentService),K(5,f.ILogService),K(6,g.IStorageService),K(7,R.IUriIdentityService)],T),e.AbstractExtensionsInitializer=T}),define(re[122],oe([0,1,16,10,3,35,42,4,31,17,15,14,9,44,20,19,30,41,60,262,24,18,61,5]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function s(k,T){const F=k.storage?Object.keys(k.storage).sort():[],j={};return F.forEach(B=>j[B]=k.storage[B]),k.storage=j,T?(0,O.toFormattedString)(k,{}):JSON.stringify(k)}e.stringify=s;const a=1;let o=class extends u.AbstractSynchroniser{constructor(T,F,j,B,V,W,Q,X,Y,Z,H,$,_,ie){super({syncResource:"globalState",profile:T},F,B,X,$,V,W,Y,Z,Q,H,_),this.xb=j,this.nb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ie.createInstance(h),this.D(B.watch(this.h.dirname(this.C.argvResource))),this.D(l.Event.any(l.Event.filter(B.onDidFilesChange,se=>se.contains(this.C.argvResource)),l.Event.filter(j.onDidChange,se=>!!(se.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||se.valueChanges.some(({profile:ae,changes:x})=>this.syncResource.profile.id===ae.id&&x.some(M=>M.target===0)))))(()=>this.N()))}async ob(T,F,j){const B=T.syncData?JSON.parse(T.syncData.content):null;F=F===null&&j?T:F;const V=F&&F.syncData?JSON.parse(F.syncData.content):null,W=await this.wb.getLocalGlobalState(this.syncResource.profile);B?this.L.trace(`${this.w}: Merging remote ui state with local ui state...`):this.L.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Fb(V),{local:X,remote:Y}=(0,g.merge)(W.storage,B?B.storage:null,V?V.storage:null,Q,this.L),Z={content:null,local:X,remote:Y,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},H=s(W,!1);return[{baseResource:this.r,baseContent:V?s(V,!1):H,localResource:this.tb,localContent:H,localUserData:W,remoteResource:this.ub,remoteContent:B?s(B,!1):null,previewResource:this.p,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.vb,storageKeys:Q}]}async sb(T){const F=T.syncData?JSON.parse(T.syncData.content):null;if(F===null)return!0;const j=await this.wb.getLocalGlobalState(this.syncResource.profile),B=await this.Fb(F),{remote:V}=(0,g.merge)(j.storage,F.storage,F.storage,B,this.L);return V.all!==null}async pb(T,F){return{...T.previewResult,hasConflicts:!1}}async qb(T,F,j,B){if(this.h.isEqual(F,this.tb))return this.Cb(T);if(this.h.isEqual(F,this.ub))return this.Db(T);if(this.h.isEqual(F,this.p))return T.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Cb(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(T.localUserData.storage),removed:[],updated:[],all:T.localUserData.storage},localChange:0,remoteChange:2}}async Db(T){if(T.remoteContent!==null){const F=JSON.parse(T.remoteContent),{local:j,remote:B}=(0,g.merge)(T.localUserData.storage,F.storage,null,T.storageKeys,this.L);return{content:T.remoteContent,local:j,remote:B,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(T,F,j,B){const{localUserData:V}=j[0][0],{local:W,remote:Q,localChange:X,remoteChange:Y}=j[0][1];if(X===0&&Y===0&&this.L.info(`${this.w}: No changes found during synchronizing ui state.`),X!==0&&(this.L.trace(`${this.w}: Updating local ui state...`),await this.lb(JSON.stringify(V)),await this.wb.writeLocalGlobalState(W,this.syncResource.profile),this.L.info(`${this.w}: Updated local ui state`)),Y!==0){this.L.trace(`${this.w}: Updating remote ui state...`);const Z=JSON.stringify({storage:Q.all});T=await this.kb(Z,B?null:T.ref),this.L.info(`${this.w}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}F?.ref!==T.ref&&(this.L.trace(`${this.w}: Updating last synchronized ui state...`),await this.db(T),this.L.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(T){if(this.h.isEqual(this.ub,T)||this.h.isEqual(this.r,T)||this.h.isEqual(this.tb,T)||this.h.isEqual(this.vb,T)){const F=await this.bb(T);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:T}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(T).length>1||T[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(T){const F=await this.xb.readStorageData(this.syncResource.profile),j=[],B=[];for(const[Q,X]of F)X.target===0?j.push(Q):X.target===1&&B.push(Q);const V=[...j,...B],W=T?.storage?Object.keys(T.storage).filter(Q=>!Q.startsWith(t)&&!V.includes(Q)&&F.get(Q)!==void 0):[];if(!D.isWeb){const Q=[...v.ALL_SYNC_RESOURCES.map(X=>(0,v.getEnablementKey)(X)),v.SYNC_SERVICE_URL_TYPE];W.push(...Q),B.push(...Q)}return{user:j,machine:B,unregistered:W}}};o=ye([K(2,n.IUserDataProfileStorageService),K(3,S.IFileService),K(4,v.IUserDataSyncStoreService),K(5,v.IUserDataSyncBackupStoreService),K(6,v.IUserDataSyncLogService),K(7,P.IEnvironmentService),K(8,v.IUserDataSyncEnablementService),K(9,C.ITelemetryService),K(10,w.IConfigurationService),K(11,m.IStorageService),K(12,c.IUriIdentityService),K(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let h=class{constructor(T,F,j,B){this.a=T,this.b=F,this.c=j,this.d=B}async getLocalGlobalState(T){const F={};if(T.isDefault){const B=await this.f(),V=(0,A.parse)(B);for(const W of i)V[W]!==void 0&&(F[`${t}${W}`]={version:1,value:V[W]})}const j=await this.c.readStorageData(T);for(const[B,V]of j)V.value&&V.target===0&&(F[B]={version:1,value:V.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const T=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),T.value.toString()}catch(T){this.d.debug((0,U.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:F,updated:j},B){const V=(0,u.getSyncResourceLogLabel)("globalState",B),W={},Q=new Map,X=await this.c.readStorageData(B),Y=(Z,H)=>{for(const $ of Z){if($.startsWith(t)){W[$.substring(t.length)]=H?H[$].value:void 0;continue}if(H){const _=H[$];_.value!==X.get($)?.value&&Q.set($,_.value)}else X.get($)!==void 0&&Q.set($,void 0)}};if(Y(Object.keys(T),T),Y(Object.keys(j),j),Y(F),Object.keys(W).length){this.d.trace(`${V}: Updating locale...`);const Z=await this.f();let H=Z;for(const $ of Object.keys(W))H=(0,f.edit)(H,[$],W[$],{});Z!==H&&(this.d.trace(`${V}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(H)),this.d.info(`${V}: Updated locale.`)),this.d.info(`${V}: Updated locale`)}Q.size&&(this.d.trace(`${V}: Updating global state...`),await this.c.updateStorageData(B,Q,0),this.d.info(`${V}: Updated global state`,[...Q.keys()]))}};h=ye([K(0,S.IFileService),K(1,P.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,v.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let b=class extends u.AbstractInitializer{constructor(T,F,j,B,V,W){super("globalState",j,B,V,F,T,W)}async o(T){const F=T.syncData?JSON.parse(T.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},B={};for(const V of Object.keys(F.storage))V.startsWith(t)?j[V.substring(t.length)]=F.storage[V].value:this.l.get(V,0)===void 0&&(B[V]=F.storage[V].value);if(Object.keys(j).length){let V="{}";try{V=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const W of Object.keys(j))V=(0,f.edit)(V,[W],j[W],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString(V))}if(Object.keys(B).length)for(const V of Object.keys(B))this.l.store(V,B[V],0,0)}};b=ye([K(0,m.IStorageService),K(1,S.IFileService),K(2,R.IUserDataProfilesService),K(3,P.IEnvironmentService),K(4,v.IUserDataSyncLogService),K(5,c.IUriIdentityService)],b),e.GlobalStateInitializer=b;let y=class{constructor(T,F,j,B,V){this.a=T,this.b=F,this.c=j,this.d=B,this.f=V}getSyncStoreType(T){return this.h(T)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const F=(0,v.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(T,F)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(T,F)}throw j}}async g(T,F){const j=await this.a.readResource("globalState",null,void 0,F),B=this.h(j)||{storage:{}};B.storage[v.SYNC_SERVICE_URL_TYPE]={value:T,version:a};const V=await(0,d.getServiceMachineId)(this.c,this.d,this.b),W={version:a,machineId:V,content:s(B,!1)};await this.a.writeResource("globalState",JSON.stringify(W),j.ref,void 0,F)}h({content:T}){if(!T)return null;const F=JSON.parse(T);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};y=ye([K(1,m.IStorageService),K(2,P.IEnvironmentService),K(3,S.IFileService),K(4,p.ILogService)],y),e.UserDataSyncStoreTypeSynchronizer=y}),define(re[123],oe([0,1,21,16,3,35,4,12,183,17,15,14,20,19,30,18,41,259,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(n,r,t){try{const i=JSON.parse(n);if(!r)return(0,D.isUndefined)(i.all)?null:i.all;switch(O.OS){case 2:return(0,D.isUndefined)(i.mac)?null:i.mac;case 3:return(0,D.isUndefined)(i.linux)?null:i.linux;case 1:return(0,D.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=g;let v=class extends c.AbstractJsonFileSynchroniser{constructor(r,t,i,s,a,o,h,b,y,k,T,F,j){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,b,y,k,i,s,h,F,a,T,o,j),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.D(l.Event.filter(o.onDidChangeConfiguration,B=>B.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(r,t,i,s){const a=r.syncData?g(r.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&i?r:t;const o=t?this.Kb(t):null,h=await this.p(),b=await this.yb();let y=null,k=!1,T=!1,F=!1;if(a){let V=h?h.value.toString():"[]";if(V=V||"[]",this.wb(V,!0))throw new f.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==V||o!==a){this.L.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const W=await(0,u.merge)(V,a,o,b,this.vb);W.hasChanges&&(y=W.mergeContent,F=W.hasConflicts,k=F||W.mergeContent!==V,T=F||W.mergeContent!==a)}}else h&&(this.L.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=h.value.toString(),T=!0);const j={content:F?o:y,localChange:k?h?2:1:0,remoteChange:T?2:0,hasConflicts:F},B=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Bb,baseContent:o,localResource:this.Cb,localContent:B,localChange:j.localChange,remoteResource:this.Db,remoteContent:a,remoteChange:j.remoteChange,previewResource:this.Ab,previewResult:j,acceptedResource:this.Eb}]}async sb(r){const t=this.Kb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString():"",a=await this.yb(),o=await(0,u.merge)(s||"[]",t,t,a,this.vb);return o.hasConflicts||o.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,i,s){if(this.h.isEqual(t,this.Cb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:a}=i[0][0];let{content:o,localChange:h,remoteChange:b}=i[0][1];if(h===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.wb(o,!0)))throw new f.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.L.trace(`${this.w}: Updating local keybindings...`),a&&await this.lb(this.Lb(a.value.toString())),await this.r(o||"[]",a,s),this.L.info(`${this.w}: Updated local keybindings`)),b!==0){this.L.trace(`${this.w}: Updating remote keybindings...`);const y=this.Lb(o||"[]",r.syncData?.content);r=await this.kb(y,s?null:r.ref),this.L.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.w}: Updating last synchronized keybindings...`),await this.db(r,{platformSpecific:this.Mb()}),this.L.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,A.parse)(r.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Db,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Eb,r)?this.bb(r):null}Kb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Mb()?null:g(r.syncData.content,this.Mb(),this.L)}Lb(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete i.all:i.all=r,O.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}Mb(){return!!this.M.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=ye([K(2,f.IUserDataSyncStoreService),K(3,f.IUserDataSyncBackupStoreService),K(4,f.IUserDataSyncLogService),K(5,w.IConfigurationService),K(6,f.IUserDataSyncEnablementService),K(7,S.IFileService),K(8,P.IEnvironmentService),K(9,p.IStorageService),K(10,f.IUserDataSyncUtilService),K(11,d.ITelemetryService),K(12,m.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let R=class extends c.AbstractInitializer{constructor(r,t,i,s,a,o){super("keybindings",t,i,s,r,a,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,U.VSBuffer.fromString(t)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}p(r){try{return g(r,!0,this.j)}catch(t){return this.j.error(t),null}}};R=ye([K(0,S.IFileService),K(1,C.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,p.IStorageService),K(5,m.IUriIdentityService)],R),e.KeybindingsInitializer=R}),define(re[124],oe([0,1,16,3,184,17,73,15,29,14,20,19,30,18,41,60,263,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function g(n){const r=JSON.parse(n);return f(r)?r:{settings:n}}e.parseSettingsSyncContent=g;let v=class extends m.AbstractJsonFileSynchroniser{constructor(r,t,i,s,a,o,h,b,y,k,T,F,j,B){super(r.settingsResource,{syncResource:"settings",profile:r},t,i,s,a,o,h,T,F,b,y,k,B),this.Ab=j,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.S(r,t),s=this.Hb(i),a=new O.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,i){const s=await this.p(),a=await this.yb(),o=this.Hb(r);t=t===null&&i?r:t;const h=t?this.Hb(t):null,b=await this.Lb();let y=null,k=!1,T=!1,F=!1;if(o){let W=s?s.value.toString().trim():"{}";W=W||"{}",this.Mb(W),this.L.trace(`${this.w}: Merging remote settings with local settings...`);const Q=(0,c.merge)(W,o.settings,h?h.settings:null,b,[],a);y=Q.localContent||Q.remoteContent,k=Q.localContent!==null,T=Q.remoteContent!==null,F=Q.hasConflicts}else s&&(this.L.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),y=s.value.toString().trim()||"{}",this.Mb(y),T=!0);const j=s?s.value.toString():null,B=h?.settings??null,V={content:F?B:y,localChange:k?2:0,remoteChange:T?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:B,localResource:this.localResource,localContent:j,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Hb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString().trim():"",a=await this.Lb(),o=await this.yb();return(0,c.merge)(s||"{}",t.settings,t.settings,a,[],o).remoteContent!==null}async pb(r,t){const i=await this.yb(),s=await this.Lb();return{...r.previewResult,content:r.previewResult.content?(0,c.updateIgnoredSettings)(r.previewResult.content,"{}",s,i):null}}async qb(r,t,i,s){const a=await this.yb(),o=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,c.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,c.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,c.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:a}=i[0][0];let{content:o,localChange:h,remoteChange:b}=i[0][1];if(h===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Mb(o),h!==0&&(this.L.trace(`${this.w}: Updating local settings...`),a&&await this.lb(JSON.stringify(this.Jb(a.value.toString()))),await this.r(o,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.w}: Updated local settings`)),b!==0){const y=await this.yb(),k=this.Hb(r),T=await this.Lb(o);o=(0,c.updateIgnoredSettings)(o,k?k.settings:"{}",T,y),this.L.trace(`${this.w}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Jb(o)),s?null:r.ref),this.L.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.w}: Updating last synchronized settings...`),await this.db(r),this.L.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),i=(0,C.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,c.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.bb(r):null}async bb(r){let t=await super.bb(r);if(t){const i=await this.yb(),s=await this.Lb();t=(0,c.updateIgnoredSettings)(t,"{}",s,i)}return t}Hb(r){return r.syncData?this.Ib(r.syncData.content):null}Ib(r){try{return g(r)}catch(t){this.L.error(t)}return null}Jb(r){return{settings:r}}async Lb(r){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const i=U.Event.any(U.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),U.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,c.getIgnoredSettings)(t,this.M,r)}Mb(r){if(this.wb(r,!1))throw new u.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};v=ye([K(2,w.IFileService),K(3,D.IEnvironmentService),K(4,P.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,S.ITelemetryService),K(12,I.IExtensionManagementService),K(13,p.IUriIdentityService)],v),e.SettingsSynchroniser=v;let R=class extends m.AbstractInitializer{constructor(r,t,i,s,a,o){super("settings",t,i,s,r,a,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,c.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return g(r)}catch(t){this.j.error(t)}return null}};R=ye([K(0,w.IFileService),K(1,d.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,P.IStorageService),K(5,p.IUriIdentityService)],R),e.SettingsInitializer=R}),define(re[125],oe([0,1,16,3,32,17,15,14,20,19,30,18,41,260,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function C(f){return JSON.parse(f.content)}e.parseSnippets=C;let c=class extends p.AbstractSynchroniser{constructor(g,v,R,n,r,t,i,s,a,o,h,b){super({syncResource:"snippets",profile:g},v,n,R,r,t,i,o,h,s,a,b),this.nb=1,this.p=g.snippetsHome,this.D(this.z.watch(R.userRoamingDataHome)),this.D(this.z.watch(this.p)),this.D(U.Event.filter(this.z.onDidFilesChange,y=>y.affects(this.p))(()=>this.N()))}async ob(g,v,R){const n=await this.Db(),r=this.Cb(n),t=g.syncData?this.Bb(g.syncData):null;v=v===null&&R?g:v;const i=v&&v.syncData?this.Bb(v.syncData):null;t?this.L.trace(`${this.w}: Merging remote snippets with local snippets...`):this.L.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(r,t,i);return this.xb(s,n,t||{},i||{})}async sb(g){const v=g.syncData?this.Bb(g.syncData):null;if(v===null)return!0;const R=await this.Db(),n=this.Cb(R),r=(0,d.merge)(n,v,v);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(g,v){return g.previewResult}async qb(g,v,R,n){if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return R===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:R,localChange:R===null?g.fileContent!==null?3:0:2,remoteChange:R===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async rb(g,v,R,n){const r=R.map(([t,i])=>({...t,acceptResult:i}));r.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.L.info(`${this.w}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.zb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(g=await this.Ab(r,g,n)),v?.ref!==g.ref&&(this.L.trace(`${this.w}: Updating last synchronized snippets...`),await this.db(g),this.L.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.z.del(t)}catch{}}xb(g,v,R,n){const r=new Map;for(const t of Object.keys(g.local.added)){const i={content:g.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.local.updated)){const i={content:g.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.added)){const i={content:g.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.updated)){const i={content:g.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:R[t]?2:1},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!r.has(t)){const i={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(g){return this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(g):null}async hasLocalData(){try{const g=await this.Db();if(Object.keys(g).length)return!0}catch{}return!1}async yb(g){const v={};for(const R of g)R.fileContent&&(v[this.h.basename(R.localResource)]=R.fileContent);await this.lb(JSON.stringify(this.Cb(v)))}async zb(g,v){for(const{fileContent:R,acceptResult:n,localResource:r,remoteResource:t,localChange:i}of g)if(i!==0){const s=t?this.h.basename(t):this.h.basename(r),a=this.h.joinPath(this.p,s);i===3?(this.L.trace(`${this.w}: Deleting snippet...`,this.h.basename(a)),await this.z.del(a),this.L.info(`${this.w}: Deleted snippet`,this.h.basename(a))):i===1?(this.L.trace(`${this.w}: Creating snippet...`,this.h.basename(a)),await this.z.createFile(a,L.VSBuffer.fromString(n.content),{overwrite:v}),this.L.info(`${this.w}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.w}: Updating snippet...`,this.h.basename(a)),await this.z.writeFile(a,L.VSBuffer.fromString(n.content),v?void 0:R),this.L.info(`${this.w}: Updated snippet`,this.h.basename(a)))}}async Ab(g,v,R){const n=v.syncData?this.Bb(v.syncData):{},r=(0,l.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:s,remoteChange:a}of g)if(a!==0){const o=i?this.h.basename(i):this.h.basename(s);a===3?delete r[o]:r[o]=t.content}return(0,d.areSame)(n,r)||(this.L.trace(`${this.w}: Updating remote snippets...`),v=await this.kb(JSON.stringify(r),R?null:v.ref),this.L.info(`${this.w}: Updated remote snippets`)),v}Bb(g){return C(g)}Cb(g){const v={};for(const R of Object.keys(g))v[R]=g[R].value.toString();return v}async Db(){const g={};let v;try{v=await this.z.resolve(this.p)}catch(R){if(R instanceof D.FileOperationError&&R.fileOperationResult===1)return g;throw R}for(const R of v.children||[]){const n=R.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),i=await this.z.readFile(n);g[t]=i}}return g}};c=ye([K(2,O.IEnvironmentService),K(3,D.IFileService),K(4,I.IStorageService),K(5,m.IUserDataSyncStoreService),K(6,m.IUserDataSyncBackupStoreService),K(7,m.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,m.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,P.IUriIdentityService)],c),e.SnippetsSynchroniser=c;let u=class extends p.AbstractInitializer{constructor(g,v,R,n,r,t){super("snippets",v,R,n,g,r,t)}async o(g){const v=g.syncData?JSON.parse(g.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(v)){const r=v[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,L.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(g)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};u=ye([K(0,D.IFileService),K(1,S.IUserDataProfilesService),K(2,O.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,I.IStorageService),K(5,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[126],oe([0,1,16,17,15,14,20,19,30,18,41,24]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(c,u){try{return JSON.parse(c).tasks??null}catch(f){return u.error(f),null}}e.getTasksContentFromSyncContent=p;let d=class extends P.AbstractFileSynchroniser{constructor(u,f,g,v,R,n,r,t,i,s,a,o){super(u.tasksResource,{syncResource:"tasks",profile:u},f,t,i,s,g,v,r,a,R,n,o),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,f,g,v){const R=u.syncData?p(u.syncData.content,this.L):null;f=f===null&&g?u:f;const n=f?.syncData?p(f.syncData.content,this.L):null,r=await this.p();let t=null,i=!1,s=!1,a=!1;if(u.syncData){const b=r?r.value.toString():null;if(!n||n!==b||n!==R){this.L.trace(`${this.w}: Merging remote tasks with local tasks...`);const y=C(b,R,n);t=y.content,a=y.hasConflicts,i=y.hasLocalChanged,s=y.hasRemoteChanged}}else r&&(this.L.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const o={content:a?n:t,localChange:i?r?2:1:0,remoteChange:s?2:0,hasConflicts:a},h=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:h,localChange:o.localChange,remoteResource:this.zb,remoteContent:R,remoteChange:o.remoteChange,previewResource:this.wb,previewResult:o,acceptedResource:this.Ab}]}async sb(u){const f=u?.syncData?p(u.syncData.content,this.L):null;if(f===null)return!0;const g=await this.p(),v=g?g.value.toString():null,R=C(v,f,f);return R.hasLocalChanged||R.hasRemoteChanged}async pb(u,f){return u.previewResult}async qb(u,f,g,v){if(this.h.isEqual(f,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.zb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.wb))return g===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async rb(u,f,g,v){const{fileContent:R}=g[0][0],{content:n,localChange:r,remoteChange:t}=g[0][1];if(r===0&&t===0&&this.L.info(`${this.w}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.w}: Updating local tasks...`),R&&await this.lb(JSON.stringify(this.Gb(R.value.toString()))),n?await this.r(n,R,v):await this.tb(),this.L.info(`${this.w}: Updated local tasks`)),t!==0){this.L.trace(`${this.w}: Updating remote tasks...`);const i=JSON.stringify(this.Gb(n));u=await this.kb(i,v?null:u.ref),this.L.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}f?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized tasks...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.zb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Ab,u)?this.bb(u):null}Gb(u){return u?{tasks:u}:{}}};d=ye([K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncBackupStoreService),K(4,S.IUserDataSyncLogService),K(5,U.IConfigurationService),K(6,S.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,l.IEnvironmentService),K(9,O.IStorageService),K(10,D.ITelemetryService),K(11,I.IUriIdentityService)],d),e.TasksSynchroniser=d;let m=class extends P.AbstractInitializer{constructor(u,f,g,v,R,n){super("tasks",f,g,v,u,R,n),this.c=this.g.defaultProfile.tasksResource}async o(u){const f=u.syncData?p(u.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(f)),await this.n(u)}async p(){return this.k.exists(this.c)}};m=ye([K(0,A.IFileService),K(1,w.IUserDataProfilesService),K(2,l.IEnvironmentService),K(3,S.IUserDataSyncLogService),K(4,O.IStorageService),K(5,I.IUriIdentityService)],m),e.TasksInitializer=m;function C(c,u,f){if(c===null&&u===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=f!==c,v=f!==u;return!g&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!v?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!g?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[127],oe([0,1,42,17,15,14,20,19,30,18,41,261,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=class extends P.AbstractSynchroniser{constructor(u,f,g,v,R,n,r,t,i,s,a,o,h){super({syncResource:"profiles",profile:u},f,v,R,n,r,t,a,o,i,s,h),this.r=g,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?C(u.syncData):null}async getRemoteSyncedProfiles(u){const f=await this.getLastSyncUserData(),g=await this.S(u,f);return g?.syncData?C(g.syncData):null}async ob(u,f,g){if(!this.r.isEnabled())throw new p.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=u.syncData?C(u.syncData):null,R=f?.syncData?C(f.syncData):null,n=this.Ab(),{local:r,remote:t}=(0,S.merge)(n,v,R,[]),i={local:r,remote:t,content:R?this.Bb(R):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=m(n,!1);return[{baseResource:this.baseResource,baseContent:R?this.Bb(R):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:v?this.Bb(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const f=u?.syncData?C(u.syncData):null,g=this.Ab(),{remote:v}=(0,S.merge)(g,f,f,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async pb(u,f){return{...u.previewResult,hasConflicts:!1}}async qb(u,f,g,v){if(this.h.isEqual(f,this.localResource))return this.xb(u);if(this.h.isEqual(f,this.remoteResource))return this.yb(u);if(this.h.isEqual(f,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async xb(u){const f=this.Ab(),g=(0,S.merge)(f,null,null,[]),{local:v,remote:R}=g;return{content:u.localContent,local:v,remote:R,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:R!==null?2:0}}async yb(u){const f=u.remoteContent?JSON.parse(u.remoteContent):null,g=[],v=[];for(const R of this.Ab()){const n=f?.find(r=>r.id===R.id);n&&(g.push({id:R.id,name:R.name,collection:n.collection}),v.push(R))}if(f!==null){const R=(0,S.merge)(v,f,g,[]),{local:n,remote:r}=R;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,f,g,v){const{local:R,remote:n,localChange:r,remoteChange:t}=g[0][1];r===0&&t===0&&this.L.info(`${this.w}: No changes found during synchronizing profiles.`);const i=g[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new p.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.lb(m(this.Ab(),!1));const s=[];for(const a of R.added)s.push((async()=>{this.L.trace(`${this.w}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.w}: Created profile '${a.name}'.`)})());for(const a of R.removed)s.push((async()=>{this.L.trace(`${this.w}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.w}: Removed profile '${a.name}'.`)})());for(const a of R.updated){const o=this.r.profiles.find(h=>h.id===a.id);o?s.push((async()=>{this.L.trace(`${this.w}: Updating '${a.name}' profile...`),await this.r.updateProfile(o,{name:a.name,shortName:a.shortName}),this.L.info(`${this.w}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.w}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.w}: Updating remote profiles...`);const s=[],a=i.length+(n?.added.length??0)<=20;if(a)for(const o of n?.added||[]){const h=await this.G.createCollection(this.y);s.push(h),i.push({id:o.id,name:o.name,collection:h,shortName:o.shortName})}else this.L.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const o of n?.removed||[])i.splice(i.findIndex(({id:h})=>o.id===h),1);for(const o of n?.updated||[]){const h=i.find(({id:b})=>o.id===b);h&&i.splice(i.indexOf(h),1,{id:o.id,name:o.name,collection:h.collection,shortName:o.shortName})}try{u=await this.updateRemoteProfiles(i,v?null:u.ref),this.L.info(`${this.w}: Updated remote profiles.${a&&n?.added.length?` Added: ${JSON.stringify(n.added.map(o=>o.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(o=>o.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.L.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.G.deleteCollection(h,this.y)}throw o}for(const o of n?.removed||[])await this.G.deleteCollection(o.collection,this.y)}f?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized profiles...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,f){return this.kb(this.Bb(u),f)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const f=await this.bb(u);return f&&(0,L.toFormattedString)(JSON.parse(f),{})}return null}Ab(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((f,g)=>f.name.localeCompare(g.name)))}};d=ye([K(2,w.IUserDataProfilesService),K(3,A.IFileService),K(4,l.IEnvironmentService),K(5,O.IStorageService),K(6,p.IUserDataSyncStoreService),K(7,p.IUserDataSyncBackupStoreService),K(8,p.IUserDataSyncLogService),K(9,U.IConfigurationService),K(10,p.IUserDataSyncEnablementService),K(11,D.ITelemetryService),K(12,I.IUriIdentityService)],d),e.UserDataProfilesManifestSynchroniser=d;function m(c,u){const f=[...c].sort((g,v)=>g.name.localeCompare(v.name)).map(g=>({id:g.id,name:g.name}));return u?(0,L.toFormattedString)(f,{}):JSON.stringify(f)}e.stringifyLocalProfiles=m;function C(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=C}),define(re[278],oe([0,1,6,16,64,2,23,17,15,14,18,24]),function(te,e,L,U,l,A,O,D,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends A.Disposable{constructor(m,C,c,u,f){super(),this.a=m,this.b=C,this.c=c,this.f=u,this.g=f,this.h()}async h(){for(const C of this.g.profiles)for(const c of S.ALL_SYNC_RESOURCES)try{await this.j(this.i(C,c))}catch(u){this.f.error(u)}let m;try{m=await this.b.resolve(this.a.userDataSyncHome)}catch(C){(0,w.toFileOperationResult)(C)!==1&&this.f.error(C);return}if(m.children){for(const C of m.children)if(C.isDirectory&&!this.g.profiles.some(c=>c.id===C.name))try{this.f.info("Deleting non existing profile from backup",C.resource.path),await this.b.del(C.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs(m,C){const c=this.i(m,C);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.k(g)}))}catch(u){if((0,w.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(m,C,c){const u=this.i(m,C),f=(0,O.joinPath)(u,c);try{return(await this.b.readFile(f)).value.toString()}catch(g){return this.f.error(g),null}}async backup(m,C,c){const u=this.i(m,C),f=(0,O.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(f,U.VSBuffer.fromString(c))}catch(g){this.f.error(g)}try{this.j(u)}catch{}}i(m,C){return(0,O.joinPath)(this.a.userDataSyncHome,...m.isDefault?[C]:[m.id,C])}async j(m){try{try{if(!await this.b.exists(m))return}catch{return}const C=await this.b.resolve(m);if(C.children){const c=C.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=c.filter(v=>Date.now()-this.k(v)>u);const g=c.length-f.length;g<10&&(f=f.slice(10-g)),await L.Promises.settled(f.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(C){this.f.error(C)}}k(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};p=ye([K(0,I.IEnvironmentService),K(1,w.IFileService),K(2,D.IConfigurationService),K(3,S.IUserDataSyncLogService),K(4,P.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(re[279],oe([0,1,3,2,4,15,20,19,24]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let P=class extends U.Disposable{constructor(p,d,m,C){super(),this.c=p,this.f=d,this.g=m,this.h=C,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.D(p.onDidChangeValue(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:p}),this.c.store(w,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,I.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,d){if(this.isResourceEnabled(p)!==d){const m=(0,I.getEnablementKey)(p);this.i(m,d)}}getResourceSyncStateVersion(p){}i(p,d){this.c.store(p,d,-1,l.isWeb?0:1)}j(p){if(p.scope!==-1)return;if(w===p.key){this.a.fire(this.isEnabled());return}const d=I.ALL_SYNC_RESOURCES.filter(m=>(0,I.getEnablementKey)(m)===p.key)[0];if(d){this.b.fire([d,this.isResourceEnabled(d)]);return}}};P=ye([K(0,O.IStorageService),K(1,D.ITelemetryService),K(2,A.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(re[80],oe([0,1,3,2,4,27,188,15,14,5,26,44,20,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const m="sync.currentMachineName",C="Safari",c="Chrome",u="Edge",f="Firefox",g="Android";function v(r){switch(r){case C:case c:case u:case f:case g:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function R(){return l.isSafari?C:l.isChrome?c:l.isEdge?u:l.isFirefox?f:l.isAndroid?g:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let n=class it extends U.Disposable{constructor(t,i,s,a,o,h){super(),this.h=s,this.i=a,this.j=o,this.k=h,this.c=this.D(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(t){const i=await this.f,s=await this.m(t);s.machines.some(({id:a})=>a===i)||(s.machines.push({id:i,name:this.l(s.machines),platform:R()}),await this.n(s))}async removeCurrentMachine(t){const i=await this.f,s=await this.m(t),a=s.machines.filter(({id:o})=>o!==i);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(t,i,s){const a=await this.m(s),o=a.machines.find(({id:h})=>h===t);if(o){o.name=i,await this.n(a);const h=await this.f;t===h&&this.h.store(m,i,-1,1)}}async setEnablements(t){const i=await this.m();for(const[s,a]of t){const o=i.machines.find(h=>h.id===s);o&&(o.disabled=a?void 0:!0)}await this.n(i)}l(t){const i=this.h.get(m,-1);if(i)return i;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${R()} (${this.k.nameShort})`,a=new RegExp(`${(0,A.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let o=0;for(const h of t){const b=a.exec(h.name),y=b?parseInt(b[1]):0;o=y>o?y:o}return`${s} #${o+1}`}async m(t){this.g=await this.p(t);const i=this.q(this.g);if(i.version!==it.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return i}async n(t){const i=JSON.stringify(t),s=await this.i.writeResource(it.b,i,this.g?.ref||null);this.g={ref:s,content:i},this.c.fire()}async p(t){if(this.g){const i=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}q(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.j.error(i)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",n=ye([K(0,D.IEnvironmentService),K(1,I.IFileService),K(2,p.IStorageService),K(3,d.IUserDataSyncStoreService),K(4,d.IUserDataSyncLogService),K(5,P.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[280],oe([0,1,6,64,38,10,3,2,4,23,11,185,26,20,19,24,77,80]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",g="sync.sessionId",v="sync.storeUrl",R="sync.productQuality";let n=class extends D.Disposable{get j(){const i=this.y.get(v,-1);return i?P.URI.parse(i):void 0}set j(i){i?this.y.store(v,i.toString(),-1,1):this.y.remove(v,-1)}get l(){return this.y.get(R,-1)}set l(i){i?this.y.store(R,i,-1,1):this.y.remove(R,-1)}constructor(i,s,a,o,h,b,y,k,T,F){super(),this.n=s,this.p=a,this.q=o,this.r=h,this.s=b,this.u=y,this.v=k,this.w=T,this.y=F,this.a=this.D(new D.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.D(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.D(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=i.quality,this.j&&(this.s.info("Using settings sync service",this.j.toString()),this.D(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.s.info("Using settings sync service",this.j.toString()))})),this.q.isEnabled()?this.s.info("Auto Sync is enabled."):this.s.info("Auto Sync is disabled."),this.z(),this.L()&&this.J(),this.D(y.onDidChangeAccount(()=>this.z())),this.D(a.onDidChangeDonotMakeRequestsUntil(()=>this.z())),this.D(h.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.D(O.Event.filter(this.q.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.D(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}z(){const{enabled:i,message:s}=this.F();i?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.r,this.w,this.s,this.y),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.C()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.s.info(s),this.a.clear()):s&&this.q.isEnabled()&&this.s.info(s))}C(){return!0}F(){return this.q.isEnabled()?this.u.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(i,s,a){try{this.u.account&&!a&&await this.w.removeCurrentMachine(),this.G(!1),this.y.remove(g,-1),i?(this.v.publicLog2("sync/turnOffEveryWhere"),await this.r.reset()):await this.r.resetLocal()}catch(o){if(this.s.error(o),s)this.G(!1);else throw o}}G(i){this.q.isEnabled()!==i&&(this.q.setEnablement(i),this.z())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(i){if(!i){this.b=0;return}const s=C.UserDataSyncError.toUserDataSyncError(i);s instanceof C.UserDataAutoSyncError&&this.v.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.s.info("Auto Sync: Suspended sync because of making too many requests to server"),this.z()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.s.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.s.error(s),this.b++),this.h.fire(s)}async J(){this.y.store(f,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.q.isEnabled()&&this.u.account&&await this.w.removeCurrentMachine())}L(){return this.y.getBoolean(f,-1,!1)}M(){this.y.remove(f,-1)}async triggerSync(i,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.s.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...i),this.f.trigger(async()=>{this.s.trace("activity sources",...this.N);const o=this.u.account?.authenticationProviderId||"";this.v.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=ye([K(0,p.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,C.IUserDataSyncLogService),K(6,c.IUserDataSyncAccountService),K(7,m.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,d.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends D.Disposable{constructor(i,s,a,o,h,b,y,k){super(),this.j=i,this.k=s,this.l=a,this.m=o,this.n=h,this.p=b,this.q=y,this.r=k,this.b=this.D(new D.MutableDisposable),this.c=this.D(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.D(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.D(this.onDidFinishSync(()=>this.s())),this.D((0,D.toDisposable)(()=>{this.i&&(this.i.cancel(),this.q.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.q.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}s(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(i,s){const a=(0,L.createCancelablePromise)(async o=>{if(this.i)try{this.q.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(h){if((0,A.isCancellationError)(h))return}return this.w(i,s,o)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}u(){return this.j!==void 0&&!(0,w.isEqual)(this.j,this.l.userDataSyncStore?.url)}async v(){const i=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!i&&(!(0,w.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,w.isEqual)(s.stableUrl,i.stableUrl))}async w(i,s,a){this.q.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.y(s,a)}catch(h){if(this.q.error(h),o=h,C.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.q.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.q.info("Auto Sync: Retrying sync..."),await this.y(s,a),o=void 0}catch(b){this.q.error(b),o=b}}this.f.fire(o)}async y(i,s){if(this.h=await this.n.createSyncTask(this.g,i),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.u()?await this.v()?new C.UserDataAutoSyncError((0,S.localize)(0,null),"DefaultServiceChanged"):new C.UserDataAutoSyncError((0,S.localize)(1,null),"ServiceChanged"):new C.UserDataAutoSyncError((0,S.localize)(2,null),"TurnedOff");const a=this.r.get(g,-1);if(a&&this.g&&a!==this.g.session)throw this.u()?await this.v()?new C.UserDataAutoSyncError((0,S.localize)(3,null),"DefaultServiceChanged"):new C.UserDataAutoSyncError((0,S.localize)(4,null),"ServiceChanged"):new C.UserDataAutoSyncError((0,S.localize)(5,null),"SessionExpired");const o=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=o.find(b=>b.isCurrent);if(h?.disabled)throw new C.UserDataAutoSyncError((0,S.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new C.UserDataAutoSyncError((0,l.toErrorMessage)(b),b instanceof C.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==a&&this.r.store(g,this.g.session,-1,1),!s.isCancellationRequested&&(h||await this.p.addCurrentMachine(this.g||void 0))}register(i){return super.D(i)}}r.a="Interval"}),define(re[281],oe([0,1,11,189,15,14,44,20,30,24,18,41,125,124,123,17,126,121,122,5,127,42]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class He{constructor(t,i,s,a,o,h,b,y,k,T){this.e=t,this.f=i,this.g=s,this.h=o,this.i=h,this.j=b,this.k=y,this.l=k,this.m=T,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const i=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.e.getAllResourceRefs(t,i?.collection)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.f.getAllRefs(i,t)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.J(t),s=i?this.k.profiles.find(a=>a.id===i.profile):void 0;return i&&s?{profile:s,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.J(t);if(!i)return[];const s=this.k.profiles.find(a=>a.id===i.profile);switch(i.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const i=this.J(t);if(!!i){if(i.remote){if(i.ref){const{content:s}=await this.L(i.syncResource,i.ref,i.collection);if(s)return this.K(s,i.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const i=this.J(t);if(!i||i.node===He.a)return null;if(i.ref){const s=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&s?this.o(i.syncResource,s,i.node):s}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(t,i,s,a,o){if(t){const{content:b}=await this.L(i,o,a);return b}const h=this.k.profiles.find(b=>b.id===s);return h?this.f.resolveContent(h,i,o):null}o(t,i,s){const a=this.K(i,t);switch(t){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(t,i){const s=this.k.profiles.find(a=>a.id===i);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,i){const s=this.d.joinPath(t,"settings.json"),a=i?i.settingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}s(t,i){switch(i){case"settings.json":return(0,d.parseSettingsSyncContent)(t.content).settings}return null}t(t,i){const s=this.d.joinPath(t,"keybindings.json"),a=i?i.keybindingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}u(t,i){switch(i){case"keybindings.json":return(0,m.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,i){const s=this.d.joinPath(t,"tasks.json"),a=i?i.tasksResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}w(t,i){switch(i){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,i){const s=await this.resolveContent(t);if(s){const a=this.K(s,"snippets");if(a){const o=(0,p.parseSnippets)(a),h=[];for(const b of Object.keys(o)){const y=this.d.joinPath(t,b),k=i?this.d.joinPath(i.snippetsHome,b):this.d.joinPath(t,He.a);h.push({resource:y,comparableResource:k})}return h}}return[]}y(t,i){return(0,p.parseSnippets)(t)[i]||null}z(t,i){const s=this.d.joinPath(t,"extensions.json"),a=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}A(t,i){switch(i){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:i}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(i,!0)}C(t,i){const s=this.d.joinPath(t,"globalState.json"),a=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}D(t,i){switch(i){case"globalState.json":return(0,f.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const i=await this.m.createInstance(f.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,f.stringify)(i,!0)}F(t,i){const s=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(t,i){switch(i){case"profiles.json":return(0,R.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(t){const i=t.remote?He.b:He.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(L.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...s)}J(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==He.c&&t.authority!==He.b)return;const i=[];for(;t.path!=="/";)i.unshift(this.d.basename(t)),t=this.d.dirname(t);if(i.length<2)return;const s=t.authority===He.b,a=i.shift(),o=i.shift();let h,b,y;for(;i.length;){const k=i.shift();k.startsWith("collection:")?h=k.substring(11):k.startsWith("ref:")?b=k.substring(4):y=k}return{remote:s,syncResource:a,profile:o,collection:h,ref:b,node:y}}K(t,i){try{const s=JSON.parse(t);if((0,S.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new w.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",i)}async L(t,i,s){const a=await this.e.resolveResourceContent(t,i,s);return{ref:i,content:a}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=ye([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,l.IEnvironmentService),K(5,D.IStorageService),K(6,A.IFileService),K(7,P.IUserDataProfilesService),K(8,C.IConfigurationService),K(9,g.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[282],oe([0,1,21,6,25,38,3,2,23,12,31,17,29,5,20,19,18,121,122,123,124,125,126,127,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let s=class extends D.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(y,k,T,F,j,B,V,W,Q){super(),this.u=y,this.v=k,this.w=T,this.y=F,this.z=j,this.C=B,this.F=V,this.G=W,this.H=Q,this.f="uninitialized",this.g=this.D(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.D(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.D(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.D(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.D(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.q=this.D(new O.Emitter),this.onDidResetLocal=this.q.event,this.r=this.D(new O.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.f=k.userDataSyncStore?"idle":"uninitialized",this.m=this.C.getNumber(i,-1,void 0),this.D((0,D.toDisposable)(()=>this.W()))}async createSyncTask(y,k){this.X(),this.y.info("Sync started.");const T=new Date().getTime(),F=(0,P.generateUuid)();try{const W=(0,t.createSyncHeaders)(F);k&&(W["Cache-Control"]="no-cache"),y=await this.u.manifest(y,W)}catch(W){const Q=t.UserDataSyncError.toUserDataSyncError(W);throw h(Q,F,this.v,this.z),Q}const j=!1,B=this;let V;return{manifest:y,async run(){if(j)throw new Error("Can run a task only once");V=(0,U.createCancelablePromise)(W=>B.I(y,!1,F,W)),await V.finally(()=>V=void 0),B.y.info(`Sync done. Took ${new Date().getTime()-T}ms`),B.S()},stop(){return V?.cancel(),B.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const y=new Date().getTime(),k=(0,P.generateUuid)(),T=(0,t.createSyncHeaders)(k);let F;try{F=await this.u.manifest(null,T)}catch(V){const W=t.UserDataSyncError.toUserDataSyncError(V);throw h(W,k,this.v,this.z),W}await this.resetLocal();const j=this,B=new l.CancellationTokenSource;return{id:k,async merge(){return j.I(F,!0,k,B.token)},async apply(){try{try{await j.L(F,k,B.token)}catch(V){if(t.UserDataSyncError.toUserDataSyncError(V).code==="MethodNotFound")j.y.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.y.info("Applying manual sync again..."),await j.L(F,k,B.token);else throw V}}catch(V){throw j.y.error(V),V}j.y.info(`Sync done. Took ${new Date().getTime()-y}ms`),j.S()},async stop(){B.cancel(),await j.N(),await j.resetLocal()}}}async I(y,k,T,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,y,k,T,F));const B=j.enabled.find(V=>V.resource==="profiles");if(B){const V=await B.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J(V,y,k,T,F)}}finally{this.l.fire(this.k)}}async J(y,k,T,F,j){for(const B of y){if(j.isCancellationRequested)return;const V=this.G.profiles.find(Q=>Q.id===B.id);if(!V){this.y.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",B.name);const W=this.getOrCreateActiveProfileSynchronizer(V,B);this.k.push(...await this.M(W,k,T,F,j))}for(const[B,V]of this.t.entries())this.G.profiles.some(W=>W.id===V[0].profile.id)||(V[1].dispose(),this.t.delete(B))}async L(y,k,T){const F=this.U();for(const Q of F){if(T.isCancellationRequested)return;await Q.apply(k,T)}const j=F.find(Q=>Q.profile.isDefault);if(!j)return;const B=j.enabled.find(Q=>Q.resource==="profiles");if(!B)return;const W=(await B.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(Q=>F.every(X=>X.profile.id!==Q.id));W.length&&await this.J(W,y,!1,k,T)}async M(y,k,T,F,j){return(await y.sync(k,T,F,j)).map(([V,W])=>({profile:y.profile,syncResource:V,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(y=>y.stop()))}async resolveContent(y){const k=await this.H.resolveContent(y);if(k)return k;for(const T of this.U())for(const F of T.enabled){const j=await F.resolveContent(y);if(j)return j}return null}async replace(y){this.X();const k=this.H.resolveUserDataSyncResource(y);if(!k)return;const T=await this.resolveContent(y.uri);!T||await this.O(k.profile,async F=>{if(k.syncResource===F.resource)return await F.replace(T),!0})}async accept(y,k,T,F){this.X(),await this.O(y.profile,async j=>{if(y.syncResource===j.resource)return await j.accept(k,T),F&&await j.apply((0,w.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(y,k){return this.H.getRemoteSyncResourceHandles(y,k)}async getLocalSyncResourceHandles(y,k){return this.H.getLocalSyncResourceHandles(y,k??this.G.defaultProfile)}async getAssociatedResources(y){return this.H.getAssociatedResources(y)}async getMachineId(y){return this.H.getMachineId(y)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(y){this.y.error(y)}this.r.fire()}async resetLocal(){this.X(),this.m=void 0,this.C.remove(i,-1);for(const[y]of this.t.values())try{await y.resetLocal()}catch(k){this.y.error(k)}this.W(),this.q.fire(),this.y.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.H.getRemoteSyncedProfiles(),k=y.map(B=>B.collection),T=await this.u.getAllCollections(),F=T.filter(B=>!k.includes(B));F.length&&(this.y.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(B=>this.u.deleteCollection(B))),this.y.info("Deleted redundant collections on server"));const j=y.filter(B=>T.includes(B.collection));if(j.length!==y.length){this.y.info("Updating remote profiles with invalid collections on server");const B=this.w.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await B.updateRemoteProfiles(j,null),this.y.info("Updated remote profiles on server")}finally{B.dispose()}}}async O(y,k){const T=new D.DisposableStore;try{const F=this.t.get(y.id);if(F){const Q=await this.P(F[0],k,T);return(0,w.isUndefined)(Q)?null:Q}if(y.isDefault){const Q=T.add(this.w.createInstance(a,y,void 0)),X=await this.P(Q,k,T);return(0,w.isUndefined)(X)?null:X}if(this.G.isEnabled())return null;const j=T.add(this.w.createInstance(r.UserDataProfilesManifestSynchroniser,y,void 0)),B=await this.u.manifest(null),W=(await j.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Q=>Q.id===y.id);if(W){const Q=T.add(this.w.createInstance(a,y,W.collection)),X=await this.P(Q,k,T);return(0,w.isUndefined)(X)?null:X}return null}finally{T.dispose()}}async P(y,k,T){const F=[...y.enabled,...y.disabled.map(j=>T.add(y.createSynchronizer(j)))];for(const j of F){const B=await k(j);if(!(0,w.isUndefined)(B))return B}}Q(y){const k=this.f;this.f!==y&&(this.f=y,this.g.fire(y),k==="hasConflicts"&&this.S())}R(){const y=this.U().map(k=>k.conflicts).flat();(0,L.equals)(this.i,y,(k,T)=>k.profile.id===T.profile.id&&k.syncResource===T.syncResource&&(0,L.equals)(k.conflicts,T.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.i=y,this.j.fire(y))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.C.store(i,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(y,k){let T=this.t.get(y.id);if(T&&T[0].collection!==k?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.t.delete(y.id)),!T){const F=new D.DisposableStore,j=F.add(this.w.createInstance(a,y,k?.collection));F.add(j.onDidChangeStatus(B=>this.Q(B))),F.add(j.onDidChangeConflicts(B=>this.R())),F.add(j.onDidChangeLocal(B=>this.h.fire(B))),this.t.set(y.id,T=[j,F])}return T[0]}U(){const y=[];for(const[k]of this.t.values())y.push(k);return y}W(){this.t.forEach(([,y])=>y.dispose()),this.t.clear()}X(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};s=ye([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,d.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,C.ITelemetryService),K(5,m.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,c.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends D.Disposable{get enabled(){return this.f.sort((y,k)=>y[1]-k[1]).map(([y])=>y)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(y=>!this.l.isResourceEnabled(y))}get status(){return this.g}get conflicts(){return this.j}constructor(y,k,T,F,j,B,V,W,Q,X){super(),this.profile=y,this.collection=k,this.l=T,this.m=F,this.n=j,this.q=B,this.r=V,this.t=W,this.u=Q,this.v=X,this.f=[],this.g="idle",this.h=this.D(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.D(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.D(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.D(T.onDidChangeResourceEnablement(([Y,Z])=>this.w(Y,Z))),this.D((0,D.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of t.ALL_SYNC_RESOURCES)T.isResourceEnabled(Y)&&this.y(Y)}w(y,k){k?this.y(y):this.z(y)}y(y){if(this.f.some(([j])=>j.resource===y))return;if(y==="extensions"&&!this.n.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.u.isEnabled()))return;const k=new D.DisposableStore,T=k.add(this.createSynchronizer(y));k.add(T.onDidChangeStatus(()=>this.G())),k.add(T.onDidChangeConflicts(()=>this.H())),k.add(T.onDidChangeLocal(()=>this.i.fire(y)));const F=this.I(y);this.f.push([T,F,k])}z(y){const k=this.f.findIndex(([T])=>T.resource===y);if(k!==-1){const[[T,,F]]=this.f.splice(k,1);F.dispose(),this.G(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,j=>this.t.error(j))}}createSynchronizer(y){switch(y){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(R.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(f.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(y,k,T,F){if(F.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const B=[],V=(0,t.createSyncHeaders)(T),W=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,Q=k?await this.C(W):{};for(const X of j){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(X.resource))return[];try{if(k){const Y=await X.preview(W,Q,V);if(Y)for(const Z of Y.resourcePreviews)(Z.localChange!==0||Z.remoteChange!==0)&&Z.mergeState==="preview"&&await X.merge(Z.previewResource)}else await X.sync(W,V)}catch(Y){const Z=t.UserDataSyncError.toUserDataSyncError(Y);if(h(Z,T,this.q,this.r),o(Y))throw Z;this.t.error(Y),this.t.error(`${X.resource}: ${(0,A.toErrorMessage)(Y)}`),B.push([X.resource,Z])}}return B}finally{this.G()}}async apply(y,k){const T=(0,t.createSyncHeaders)(y);for(const F of this.enabled){if(k.isCancellationRequested)return;try{await F.apply(!1,T)}catch(j){const B=t.UserDataSyncError.toUserDataSyncError(j);if(h(B,y,this.q,this.r),o(j))throw B;this.t.error(j),this.t.error(`${F.resource}: ${(0,A.toErrorMessage)(j)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(k){this.t.error(k)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(k){this.t.error(`${y.resource}: ${(0,A.toErrorMessage)(k)}`),this.t.error(k)}}async C(y){if(!this.profile.isDefault)return{};const k=this.v.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),T=this.enabled.find(F=>F instanceof v.SettingsSynchroniser);if(T){const F=await T.getRemoteUserDataSyncConfiguration(y);return{...k,...F}}return k}F(y){this.g!==y&&(this.g=y,this.h.fire(y))}G(){return this.H(),this.enabled.some(y=>y.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const y=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,L.equals)(this.j,y,(k,T)=>k.syncResource===T.syncResource&&(0,L.equals)(k.conflicts,T.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.j=y,this.k.fire(y))}I(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([K(2,t.IUserDataSyncEnablementService),K(3,d.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,C.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,c.IUserDataProfilesService),K(9,S.IConfigurationService)],a);function o(b){if(b instanceof t.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(b,y,k,T){T.publicLog2("sync/error",{code:b.code,serverCode:b instanceof t.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof t.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:y,service:k.userDataSyncStore.url.toString()})}}),define(re[283],oe([0,1,3,2,11,18,24]),function(te,e,L,U,l,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(p,d){return{...p,profile:(0,A.reviveProfile)(p.profile,d.profilesHome.scheme)}}function I(p){return{created:p.created,uri:l.URI.revive(p.uri)}}class w{constructor(d,m,C){this.c=d,this.d=m,this.f=C,this.a=new Map,this.b=new L.Emitter}listen(d,m){switch(m){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${m}`)}async call(d,m,C){try{return await this.g(d,m,C)}catch(c){throw this.f.error(c),c}}async g(d,m,C){switch(m){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(C[0]));case"accept":return this.c.accept(D(C[0],this.d),l.URI.revive(C[1]),C[2],C[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(C[0],C[1]?(0,A.reviveProfile)(C[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(C[0],C[1]);case"replace":return this.c.replace(I(C[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(C[0]));case"getMachineId":return this.c.getMachineId(I(C[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(m.startsWith("manualSync/")){const c=m.substring(11),u=C[0],f=this.h(u);switch(C=C.slice(1),c){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(d){const m=this.a.get(this.j(d));if(!m)throw new Error(`Manual sync taks not found: ${d}`);return m}async i(){const d=await this.c.createManualSyncTask();return this.a.set(this.j(d.id),d),d.id}j(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=w;let P=class extends U.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(d,m){super(),this.k=m,this.b="uninitialized",this.c=this.D(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.D(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.D(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.D(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(C,c,u){return d.call(C,c,u).then(null,f=>{throw O.UserDataSyncError.toUserDataSyncError(f)})},listen(C,c){return d.listen(C,c)}},this.a.call("_getInitialData").then(([C,c,u])=>{this.l(C),this.m(c),u&&this.n(u),this.D(this.a.listen("onDidChangeStatus")(f=>this.l(f))),this.D(this.a.listen("onDidChangeLastSyncTime")(f=>this.n(f)))}),this.D(this.a.listen("onDidChangeConflicts")(C=>this.m(C))),this.D(this.a.listen("onSyncErrors")(C=>this.j.fire(C.map(c=>({...c,error:O.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.a.call("createManualSyncTask"),m=this;return new S(d,{async call(c,u,f){return m.a.call(`manualSync/${c}`,[d,...Array.isArray(u)?u:[u]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(d,m,C,c){return this.a.call("accept",[d,m,C,c])}resolveContent(d){return this.a.call("resolveContent",[d])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,m){return(await this.a.call("getLocalSyncResourceHandles",[d,m])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(d,m){return(await this.a.call("getRemoteSyncResourceHandles",[d,m])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getAssociatedResources(d){return(await this.a.call("getAssociatedResources",[d])).map(({resource:C,comparableResource:c})=>({resource:l.URI.revive(C),comparableResource:l.URI.revive(c)}))}getMachineId(d){return this.a.call("getMachineId",[d])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(d){return this.a.call("replace",[d])}async l(d){this.b=d,this.c.fire(d)}async m(d){this.f=d.map(m=>({syncResource:m.syncResource,profile:(0,A.reviveProfile)(m.profile,this.k.profilesHome.scheme),conflicts:m.conflicts.map(C=>({...C,baseResource:l.URI.revive(C.baseResource),localResource:l.URI.revive(C.localResource),remoteResource:l.URI.revive(C.remoteResource),previewResource:l.URI.revive(C.previewResource)}))})),this.g.fire(this.f)}n(d){this.h!==d&&(this.h=d,this.i.fire(d))}};P=ye([K(1,A.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class S extends U.Disposable{constructor(d,m){super(),this.id=d,this.a=m}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[284],oe([0,1,6,25,10,3,2,142,4,23,12,11,31,17,15,14,26,59,44,20,24]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const R="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let a=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(T){this.h.store(v.SYNC_SERVICE_URL_TYPE,T,-1,I.isWeb?0:1)}constructor(T,F,j){super(),this.f=T,this.g=F,this.h=j,this.a=this.D(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.D(A.Event.filter(j.onDidChangeValue,B=>B.key===v.SYNC_SERVICE_URL_TYPE&&B.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(T,F){T=I.isWeb&&T?.web?{...T,...T.web}:T;const j={...T||{},...F||{}};if(j&&(0,P.isString)(j.url)&&(0,P.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(B=>Array.isArray(j.authenticationProviders[B].scopes))){const B=j,V=!!B.canSwitch&&!F?.url,W=B.url===B.insidersUrl?"insiders":"stable",Q=(V?this.c:void 0)||W,X=F?.url||(Q==="insiders"?B.insidersUrl:Q==="stable"?B.stableUrl:B.url);return{url:S.URI.parse(X),type:Q,defaultType:W,defaultUrl:S.URI.parse(B.url),stableUrl:S.URI.parse(B.stableUrl),insidersUrl:S.URI.parse(B.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(B.authenticationProviders).reduce((Y,Z)=>(Y.push({id:Z,scopes:B.authenticationProviders[Z].scopes}),Y),[])}}}};a=ye([K(0,c.IProductService),K(1,d.IConfigurationService),K(2,g.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let o=class extends a{constructor(T,F,j){super(T,F,j);const B=this.h.get(R,-1);B&&(this.k=JSON.parse(B));const V=this.f[v.CONFIGURATION_SYNC_STORE_KEY];V?this.h.store(R,JSON.stringify(V),-1,1):this.h.remove(R,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=ye([K(0,c.IProductService),K(1,d.IConfigurationService),K(2,g.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let h=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(T,F,j,B,V,W,Q){super(),this.k=j,this.l=B,this.n=Q,this.g=this.D(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.D(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.D(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.p(T),this.c=(0,f.getServiceMachineId)(V,W,Q).then(X=>{const Y={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Y["X-Client-Commit"]=F.commit),Y}),this.f=new y(i,s,this.k,this.l),this.q(),this.D((0,O.toDisposable)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}p(T){this.a=T?(0,w.joinPath)(T,"v1"):void 0}q(){const T=this.n.getNumber(n,-1);T&&Date.now()<T&&this.s(new Date(T))}s(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.r=(0,L.createCancelablePromise)(F=>(0,L.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const j=await this.v(F,{type:"GET",headers:T},[],U.CancellationToken.None);return(await(0,u.asJson)(j))?.map(({id:B})=>B)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]=D.Mimes.text;const j=await this.v(F,{type:"POST",headers:T},[],U.CancellationToken.None),B=await(0,u.asTextOrError)(j);if(!B)throw new v.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",j.res.statusCode,j.res.headers[v.HEADER_OPERATION_ID]);return B}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=T?(0,w.joinPath)(this.a,"collection",T).toString():(0,w.joinPath)(this.a,"collection").toString();F={...F},await this.v(j,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.t(this.a,F,T),B={},V=await this.v(j.toString(),{type:"GET",headers:B},[],U.CancellationToken.None);return(await(0,u.asJson)(V)||[]).map(({url:Q,created:X})=>({ref:(0,w.relativePath)(j,j.with({path:Q})),created:X*1e3}))}async resolveResourceContent(T,F,j,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,T),F).toString();B={...B},B["Cache-Control"]="no-cache";const W=await this.v(V,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,u.asTextOrError)(W)}async deleteResource(T,F,j){if(!this.a)throw new Error("No settings sync store url configured.");const B=F!==null?(0,w.joinPath)(this.t(this.a,j,T),F).toString():this.t(this.a,j,T).toString(),V={};await this.v(B,{type:"DELETE",headers:V},[],U.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.joinPath)(this.a,"resource").toString(),F={"Content-Type":D.Mimes.text};await this.v(T,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async readResource(T,F,j,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,T),"latest").toString();B={...B},B["Cache-Control"]="no-cache",F&&(B["If-None-Match"]=F.ref);const W=await this.v(V,{type:"GET",headers:B},[304],U.CancellationToken.None);let Q=null;if(W.res.statusCode===304&&(Q=F),Q===null){const X=W.res.headers.etag;if(!X)throw new v.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",W.res.statusCode,W.res.headers[v.HEADER_OPERATION_ID]);const Y=await(0,u.asTextOrError)(W);if(!Y&&W.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",V,"EmptyResponse",W.res.statusCode,W.res.headers[v.HEADER_OPERATION_ID]);Q={ref:X,content:Y}}return Q}async writeResource(T,F,j,B,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.t(this.a,B,T).toString();V={...V},V["Content-Type"]=D.Mimes.text,j&&(V["If-Match"]=j);const Q=await this.v(W,{type:"POST",data:F,headers:V},[],U.CancellationToken.None),X=Q.res.headers.etag;if(!X)throw new v.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",Q.res.statusCode,Q.res.headers[v.HEADER_OPERATION_ID]);return X}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,w.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const B=await this.v(j,{type:"GET",headers:F},[304],U.CancellationToken.None);let V=null;if(B.res.statusCode===304&&(V=T),!V){const Q=B.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);const X=await(0,u.asTextOrError)(B);if(!X&&B.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",j,"EmptyResponse",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);X&&(V={...JSON.parse(X),ref:Q})}const W=this.n.get(r,-1);return W&&V&&W!==V.session&&this.u(),V===null&&W&&this.u(),V&&this.n.store(r,V.session,-1,1),V}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(T,F,j){return F?(0,w.joinPath)(T,"collection",F,"resource",j):(0,w.joinPath)(T,"resource",j)}u(){this.n.remove(r,-1),this.n.remove(t,-1)}async v(T,F,j,B){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const V=await this.c;F.headers={...F.headers||{},...V,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(T,F,B)}catch(H){if(!(H instanceof v.UserDataSyncStoreError)){let $="RequestFailed";const _=(0,l.getErrorMessage)(H).toLowerCase();_.includes("xhr timeout")?$="RequestTimeout":_.includes("protocol")&&_.includes("not supported")?$="RequestProtocolNotSupported":_.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":_.includes("headers must be an object")?$="RequestHeadersNotObject":(0,l.isCancellationError)(H)&&($="RequestCanceled"),H=new v.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,$,void 0,void 0)}throw this.l.info("Request failed",T),H}const Q=W.res.headers[v.HEADER_OPERATION_ID],X={url:T,status:W.res.statusCode,"execution-id":F.headers[v.HEADER_EXECUTION_ID],"operation-id":Q},Y=(0,u.isSuccess)(W)||W.res.statusCode&&j.indexOf(W.res.statusCode)!==-1;let Z="";if(Y?this.l.trace("Request succeeded",X):(this.l.info("Request failed",X),Z=await(0,u.asText)(W)||""),W.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",W.res.statusCode,Q);if(this.h.fire(),W.res.statusCode===404)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",W.res.statusCode,Q);if(W.res.statusCode===405)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${Z}`,T,"MethodNotFound",W.res.statusCode,Q);if(W.res.statusCode===409)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",W.res.statusCode,Q);if(W.res.statusCode===410)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",W.res.statusCode,Q);if(W.res.statusCode===412)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",W.res.statusCode,Q);if(W.res.statusCode===413)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",W.res.statusCode,Q);if(W.res.statusCode===426)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",W.res.statusCode,Q);if(W.res.statusCode===429){const H=W.res.headers["retry-after"];throw H?(this.s(new Date(Date.now()+parseInt(H)*1e3)),new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",W.res.statusCode,Q)):new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",W.res.statusCode,Q)}if(!Y)throw new v.UserDataSyncStoreError("Server returned "+W.res.statusCode,T,"Unknown",W.res.statusCode,Q);return W}w(T){let F=this.n.get(t,-1);F===void 0&&(F=(0,p.generateUuid)(),this.n.store(t,F,-1,1)),T["X-Machine-Session-Id"]=F;const j=this.n.get(r,-1);j!==void 0&&(T["X-User-Session-Id"]=j)}};h=ye([K(1,c.IProductService),K(2,u.IRequestService),K(3,v.IUserDataSyncLogService),K(4,m.IEnvironmentService),K(5,C.IFileService),K(6,g.IStorageService)],h),e.UserDataSyncStoreClient=h;let b=class extends h{constructor(T,F,j,B,V,W,Q){super(T.userDataSyncStore?.url,F,j,B,V,W,Q),this.D(T.onDidChangeUserDataSyncStore(()=>this.p(T.userDataSyncStore?.url)))}};b=ye([K(0,v.IUserDataSyncStoreManagementService),K(1,c.IProductService),K(2,u.IRequestService),K(3,v.IUserDataSyncLogService),K(4,m.IEnvironmentService),K(5,C.IFileService),K(6,g.IStorageService)],b),e.UserDataSyncStoreService=b;class y{constructor(T,F,j,B){this.c=T,this.d=F,this.f=j,this.g=B,this.a=[],this.b=void 0}request(T,F,j){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=y}),define(re[285],oe([0,1,3,57,26,20,19,280,24,77,80]),function(te,e,L,U,l,A,O,D,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends D.UserDataAutoSyncService{constructor(d,m,C,c,u,f,g,v,R,n,r){super(d,m,C,c,u,g,v,R,n,r),this.D(L.Event.debounce(L.Event.any(L.Event.map(f.onDidFocusWindow,()=>"windowFocus"),L.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};S=ye([K(0,l.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,U.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,w.IUserDataSyncAccountService),K(8,O.ITelemetryService),K(9,P.IUserDataSyncMachinesService),K(10,A.IStorageService)],S),e.UserDataAutoSyncService=S}),define(re[286],oe([0,1,102,22,4,23]),function(te,e,L,U,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(w){function P(){let S=w.scheme===U.Schemas.file?(0,A.originalFSPath)(w):w.toString();return l.isLinux||(S=S.toLowerCase()),(0,L.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:w}}e.getWorkspaceIdentifier=O;function D(w,P){function S(){if(w.scheme!==U.Schemas.file)return(0,L.createHash)("md5").update(w.toString()).digest("hex");if(!P)return;let d;return l.isLinux?d=P.ino:l.isMacintosh?d=P.birthtime.getTime():l.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,L.createHash)("md5").update(w.fsPath).update(d?String(d):"").digest("hex")}const p=S();if(typeof p=="string")return{id:p,uri:w}}e.getSingleFolderWorkspaceIdentifier=D;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[287],oe([0,1,6,10,2,13,28,15,9,75,119,286,57,71]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let m=class extends l.Disposable{constructor(c,u,f,g){super(),this.a=c,this.b=u,this.c=f,this.f=g,this.D(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new w.StorageClient(this.f.getChannel("storage"));await Promise.all(c.map(async f=>{const g=(0,A.join)(this.a.workspaceStorageHome.fsPath,f);f.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||f===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===f)||await u.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await O.Promises.rm(g))}))}catch(c){(0,U.onUnexpectedError)(c)}}};m=ye([K(0,D.INativeEnvironmentService),K(1,I.ILogService),K(2,p.INativeHostService),K(3,d.IMainProcessService)],m),e.UnusedWorkspaceStorageDataCleaner=m}),define(re[81],oe([0,1,54,6,13,12,28,154,297,298]),function(te,e,L,U,l,A,O,D,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.ExtractError=S;function p(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function d(n){if(n instanceof S)return n;let r;return P.test(n.message)&&(r="CorruptZip"),new S(r,n)}function m(n,r,t,i,s,a){const o=l.dirname(r),h=l.join(i,o);if(!h.startsWith(i))return Promise.reject(new Error(D.localize(0,null,r)));const b=l.join(i,r);let y;return a.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(O.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((k,T)=>{if(!a.isCancellationRequested)try{y=(0,L.createWriteStream)(b,{mode:t}),y.once("close",()=>k()),y.once("error",T),n.once("error",T),n.pipe(y)}catch(F){T(F)}}))}function C(n,r,t,i){let s=(0,U.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((o,h)=>{const b=new U.Sequencer,y=k=>{k.isCancellationRequested||(a++,n.readEntry())};n.once("error",h),n.once("close",()=>s.then(()=>{i.isCancellationRequested||n.entryCount===a?o():h(new S("Incomplete",new Error(D.localize(1,null,a,n.entryCount))))},h)),n.readEntry(),n.on("entry",k=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(k.fileName)){y(i);return}const T=k.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(T)){const B=l.join(r,T);s=(0,U.createCancelablePromise)(V=>O.Promises.mkdir(B,{recursive:!0}).then(()=>y(V)).then(void 0,h));return}const F=u(n,k),j=p(k);s=(0,U.createCancelablePromise)(B=>b.queue(()=>F.then(V=>m(V,T,j,r,t,B).then(()=>y(B)))).then(null,h))})})}function c(n,r=!1){return new Promise((t,i)=>{(0,I.open)(n,r?{lazyEntries:!0}:void 0,(s,a)=>{s?i(d(s)):t((0,A.assertIsDefined)(a))})})}function u(n,r){return new Promise((t,i)=>{n.openReadStream(r,(s,a)=>{s?i(d(s)):t((0,A.assertIsDefined)(a))})})}function f(n,r){return new Promise((t,i)=>{const s=new w.ZipFile;r.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const a=(0,L.createWriteStream)(n);s.outputStream.pipe(a),s.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>t(n))})}e.zip=f;function g(n,r,t={},i){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let a=c(n,!0);return t.overwrite&&(a=a.then(o=>O.Promises.rm(r).then(()=>o))),a.then(o=>C(o,r,{sourcePathRegex:s},i))}e.extract=g;function v(n,r){return c(n).then(t=>new Promise((i,s)=>{t.on("entry",a=>{a.fileName===r&&u(t,a).then(o=>i(o),o=>s(o))}),t.once("close",()=>s(new Error(D.localize(2,null,r))))}))}function R(n,r){return v(n,r).then(t=>new Promise((i,s)=>{const a=[];t.once("error",s),t.on("data",o=>a.push(o)),t.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=R}),define(re[288],oe([0,1,6,10,2,22,4,23,55,12,31,28,81,17,15,29,33,100,14,9]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends l.Disposable{constructor(n,r,t,i,s,a){super(),this.h=r,this.i=t,this.j=i,this.k=s,this.l=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(n,r){await this.g;const t=(0,D.joinPath)(this.extensionsDownloadDir,this.u(n));try{await this.q(n,t,s=>this.i.download(n,s,r))}catch(s){throw new C.ExtensionManagementError(s.message,C.ExtensionManagementErrorCode.Download)}let i="Unverified";if(this.m(n)){const s=await this.n(n);try{await this.k.verify(t.fsPath,s.fsPath,this.l.getLevel()===g.LogLevel.Trace)&&(i="Verified"),this.l.info(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`)}catch(a){const o=a,h=o.code;if(o.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${o.output}`),h==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`);else{if(h==="PackageIsInvalidZip"||h==="SignatureArchiveIsInvalidZip")throw new C.ExtensionManagementError(p.CorruptZipMessage,C.ExtensionManagementErrorCode.CorruptZip);if(!o.didExecute)this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i} (${h})`);else throw await this.delete(t),new C.ExtensionManagementError(h,C.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(s)}catch(a){this.l.error(a)}}}return{location:t,verificationStatus:i}}m(n){if(!n.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,w.isBoolean)(r)?r:!0}async n(n){await this.g;const r=(0,D.joinPath)(this.extensionsDownloadDir,`${this.u(n)}${yt.c}`);return await this.q(n,r,t=>this.i.downloadSignatureArchive(n,t)),r}async q(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const i=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await t(i);try{await this.r(i,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,U.getErrorMessage)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async r(n,r,t){try{await S.Promises.rename(n.fsPath,r.fsPath)}catch(i){if(O.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.r(n,r,t);throw i}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const o of n.children)if(o.name.endsWith(yt.c))i.push(o.resource);else{const h=c.ExtensionKey.parse(o.name);h&&t.push([h,o])}const s=(0,c.groupByExtension)(t,([o])=>o),a=[];for(const o of s)o.sort((h,b)=>I.rcompare(h[0].version,b[0].version)),r.push(...o.slice(1).map(h=>h[1].resource)),a.push(o[0][1]);a.sort((o,h)=>o.mtime-h.mtime),r.push(...a.slice(0,Math.max(0,a.length-this.f)).map(o=>o.resource)),r.push(...i),await L.Promises.settled(r.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(n){this.l.error(n)}}u(n){return this.f?c.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};v.c=".sigzip",v=ye([K(0,m.INativeEnvironmentService),K(1,f.IFileService),K(2,C.IExtensionGalleryService),K(3,d.IConfigurationService),K(4,u.IExtensionSignatureVerificationService),K(5,g.ILogService)],v),e.ExtensionsDownloader=v}),define(re[289],oe([0,1,81,166]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(A){return(0,L.buffer)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=l}),define(re[128],oe([0,1,6,16,25,38,10,3,2,37,22,13,4,23,55,12,11,31,28,81,165,99,15,269,29,33,51,78,288,270,289,224,239,46,67,14,5,9,26,19,30,18]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r,t,i,s,a,o,h,b,y,k,T,F,j,B,V,W,Q,X,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(t.IExtensionManagementService);let Z=class extends r.AbstractExtensionManagementService{constructor(x,M,E,N,z,G,q,J,ee,ce,he,me){super(x,M,E,ce,me),this.Z=z,this.ab=G,this.bb=q,this.cb=ee,this.db=he,this.X=this.D(new D.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new w.ResourceSet;const de=this.D(J.createInstance(h.ExtensionsLifecycle));this.S=this.D(J.createInstance(H,Ce=>de.postUninstall(Ce))),this.U=this.D(new y.ExtensionsManifestCache(N,this)),this.W=this.D(J.createInstance(o.ExtensionsDownloader));const we=this.D(new k.ExtensionsWatcher(this,this.Z,me,G,he,ee,E));this.D(we.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.u)),this.eb}async zip(x){this.u.trace("ExtensionManagementService#zip",x.identifier.id);const M=await this.jb(x),E=await(0,g.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,M);return c.URI.file(E)}async unzip(x){return this.u.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const{location:M,cleanup:E}=await this.fb(x),N=S.resolve(M.fsPath);try{return await(0,b.getManifest)(N)}finally{await E()}}getInstalled(x,M=this.w.defaultProfile.extensionsResource){return this.S.scanExtensions(x??null,M)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(x){return this.S.scanUserExtensionAtLocation(x)}async install(x,M={}){this.u.trace("ExtensionManagementService#install",x.toString());const{location:E,cleanup:N}=await this.fb(x);try{const z=await(0,b.getManifest)(S.resolve(E.fsPath));if(z.engines&&z.engines.vscode&&!(0,F.isEngineValid)(z.engines.vscode,this.v.version,this.v.date))throw new Error(v.localize(0,null,(0,i.getGalleryExtensionId)(z.publisher,z.name),this.v.version));return await this.y(z,E,M)}finally{await N()}}async installFromLocation(x,M){this.u.trace("ExtensionManagementService#installFromLocation",x.toString());const E=await this.S.scanUserExtensionAtLocation(x);if(!E)throw new Error(`Cannot find a valid extension from the location ${x.toString()}`);return await this.ob([[E,void 0]],M),this.u.info("Successfully installed extension",E.identifier.id,M.toString()),E}async installExtensionsFromProfile(x,M,E){this.u.trace("ExtensionManagementService#installExtensionsFromProfile",x,M.toString(),E.toString());const N=(await this.S.scanExtensions(1,M)).filter(z=>x.some(G=>(0,i.areSameExtensions)(G,z.identifier)));if(N.length){const z=await Promise.all(N.map(G=>this.S.scanMetadata(G,M)));await this.ob(N.map((G,q)=>[G,z[q]]),E),this.u.info("Successfully installed extensions",N.map(G=>G.identifier.id),E.toString())}return N}async updateMetadata(x,M,E=this.w.defaultProfile.extensionsResource){return this.u.trace("ExtensionManagementService#updateMetadata",x.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0),M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.pinned=M.pinned||void 0,x=await this.S.updateMetadata(x,M,E),this.U.invalidate(),this.X.fire(x),x}async reinstallFromGallery(x){if(this.u.trace("ExtensionManagementService#reinstallFromGallery",x.identifier.id),!this.s.isEnabled())throw new Error(v.localize(1,null));const M=await this.getTargetPlatform(),[E]=await this.s.getExtensions([{...x.identifier,preRelease:x.preRelease}],{targetPlatform:M,compatible:!0},l.CancellationToken.None);if(!E)throw new Error(v.localize(2,null));await this.S.setUninstalled(x);try{await this.S.removeUninstalledExtension(x)}catch(N){throw new Error(v.localize(3,null,(0,A.toErrorMessage)(N)))}return this.installFromGallery(E)}copyExtensions(x,M){return this.S.copyExtensions(x,M)}markAsUninstalled(...x){return this.S.setUninstalled(...x)}async cleanUp(){this.u.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(x){this.u.error(x)}}async download(x,M){const{location:E}=await this.W.download(x,M);return E}async fb(x){if(x.scheme===P.Schemas.file)return{location:x,async cleanup(){}};this.u.trace("Downloading extension from",x.toString());const M=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(x,M),this.u.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.cb.del(M)}catch(N){this.u.error(N)}}}}P(){return this.w.defaultProfile.extensionsResource}Q(x,M,E){if(c.URI.isUri(M))return new ie(x,M,E,this.s,this.S,this.db,this.w,this.Z,this.ab,this.u);const N=i.ExtensionKey.create(M).toString();let z=this.Y.get(N);return z||(this.Y.set(N,z=new _(x,M,E,this.W,this.S,this.db,this.w,this.Z,this.ab,this.u)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(N))),z}R(x,M){return new se(x,M.profileLocation,this.ab)}async jb(x){const M=async N=>{let z=await f.Promises.readdir(N);z=z.map(J=>S.join(N,J));const G=await Promise.all(z.map(J=>f.Promises.stat(J)));let q=Promise.resolve([]);return G.forEach((J,ee)=>{const ce=z[ee];J.isFile()&&(q=q.then(he=>[...he,ce])),J.isDirectory()&&(q=q.then(he=>M(ce).then(me=>[...he,...me])))}),q};return(await M(x.location.fsPath)).map(N=>({path:`extension/${S.relative(x.location.fsPath,N)}`,localPath:N}))}async kb({added:x,removed:M}){if(M)for(const E of M.extensions)this.u.info("Extensions removed from another source",E.id,M.profileLocation.toString()),this.p.fire({identifier:E,profileLocation:M.profileLocation});if(x){const N=(await this.S.scanExtensions(1,x.profileLocation)).filter(z=>x.extensions.some(G=>(0,i.areSameExtensions)(G,z.identifier)));this.m.fire(N.map(z=>(this.u.info("Extensions added from another source",z.identifier.id,x.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:x.profileLocation,operation:1})))}}async mb(){this.D(this.S.onExtract(M=>this.lb.add(M)));const x=await this.cb.resolve(this.Z.userExtensionsLocation);for(const M of x.children??[])M.isDirectory&&this.lb.add(M.resource);this.D(this.cb.watch(this.Z.userExtensionsLocation)),this.D(this.cb.onDidFilesChange(M=>this.nb(M)))}async nb(x){if(!x.affects(this.Z.userExtensionsLocation,1))return;const M=[];for(const E of x.rawAdded){if(this.lb.has(E)||!this.db.extUri.isEqual(this.db.extUri.dirname(E),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(E,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(E).startsWith(".")||!(await this.cb.stat(E)).isDirectory)continue;const N=await this.S.scanUserExtensionAtLocation(E);N&&N.installedTimestamp===void 0&&(this.lb.add(E),M.push(N))}M.length&&(await this.ob(M.map(E=>[E,void 0]),this.w.defaultProfile.extensionsResource),this.u.info("Added extensions to default profile from external source",M.map(E=>E.identifier.id)))}async ob(x,M){const E=x.map(N=>N[0]);await this.pb(E),await this.ab.addExtensionsToProfile(x,M),this.m.fire(E.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:M})))}async pb(x){const M=await this.S.getUninstalledExtensions();for(const E of x){const N=i.ExtensionKey.create(E);!M[N.toString()]||(this.u.trace("Removing the extension from uninstalled list:",N.id),await this.S.setInstalled(N),this.u.info("Removed the extension from uninstalled list:",N.id))}}};Z=ye([K(0,t.IExtensionGalleryService),K(1,Q.ITelemetryService),K(2,V.ILogService),K(3,n.INativeEnvironmentService),K(4,a.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,R.IDownloadService),K(7,B.IInstantiationService),K(8,j.IFileService),K(9,W.IProductService),K(10,X.IUriIdentityService),K(11,Y.IUserDataProfilesService)],Z),e.ExtensionManagementService=Z;let H=class extends I.Disposable{constructor(x,M,E,N,z,G){super(),this.k=x,this.l=M,this.m=E,this.n=N,this.p=z,this.q=G,this.h=this.D(new D.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.y(),this.j=this.j.then(()=>this.z()),await this.j}async scanExtensions(x,M){const E={includeInvalid:!0,profileLocation:M};let N=[];return x===null||x===0?N.push(...await this.m.scanAllExtensions({includeInvalid:!0},E,!1)):x===1&&N.push(...await this.m.scanUserExtensions(E)),N=x!==null?N.filter(z=>z.type===x):N,Promise.all(N.map(z=>this.w(z)))}async scanAllUserExtensions(x){const M=await this.m.scanUserExtensions({includeAllVersions:!x,includeInvalid:!0});return Promise.all(M.map(E=>this.w(E)))}async scanUserExtensionAtLocation(x){try{const M=await this.m.scanExistingExtension(x,1,{includeInvalid:!0});if(M)return await this.w(M)}catch(M){this.q.error(M)}return null}async extractUserExtension(x,M,E,N){await this.j.catch(()=>{});const z=x.toString(),G=S.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),q=S.join(this.m.userExtensionsLocation.fsPath,z);try{await f.Promises.rm(q)}catch{throw new t.ExtensionManagementError(v.localize(4,null,q,x.id),t.ExtensionManagementErrorCode.Delete)}await this.t(x,M,G,N),await this.m.updateMetadata(c.URI.file(G),E);try{this.h.fire(c.URI.file(q)),await this.u(x,G,q,Date.now()+2*60*1e3),this.q.info("Renamed to",q)}catch(J){try{await f.Promises.rm(G)}catch{}if(J.code==="ENOTEMPTY")this.q.info("Rename failed because extension was installed by another source. So ignoring renaming.",x.id);else throw this.q.info(`Rename failed because of ${(0,O.getErrorMessage)(J)}. Deleted from extracted location`,G),J}return this.v(c.URI.file(q),1)}async scanMetadata(x,M){return M?(await this.n.scanProfileExtensions(M)).find(N=>(0,i.areSameExtensions)(N.identifier,x.identifier))?.metadata:this.m.scanMetadata(x.location)}async updateMetadata(x,M,E){return E?await this.n.updateMetadata([[x,M]],E):await this.m.updateMetadata(x.location,M),this.v(x.location,x.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...x){const M=x.map(E=>i.ExtensionKey.create(E));await this.s(E=>M.forEach(N=>{E[N.toString()]=!0,this.q.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(x){await this.s(M=>delete M[x.toString()])}async removeExtension(x,M){this.q.trace(`Deleting ${M} extension from disk`,x.identifier.id,x.location.fsPath);const E=this.p.extUri.joinPath(this.p.extUri.dirname(x.location),`.${(0,u.generateUuid)()}`);await this.u(x.identifier,x.location.fsPath,E.fsPath,Date.now()+2*60*1e3),await this.l.del(E,{recursive:!0}),this.q.info("Deleted from disk",x.identifier.id,x.location.fsPath)}async removeUninstalledExtension(x){await this.removeExtension(x,"uninstalled"),await this.s(M=>delete M[i.ExtensionKey.create(x).toString()])}async copyExtensions(x,M){const E=await this.scanExtensions(1,x),N=await Promise.all(E.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,x)]));await this.n.addExtensionsToProfile(N,M)}async s(x){return this.g.queue(async()=>{let M;try{M=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(N){if((0,j.toFileOperationResult)(N)!==1)throw N}let E={};if(M)try{E=JSON.parse(M)}catch{}return x&&(x(E),Object.keys(E).length?await this.l.writeFile(this.c,U.VSBuffer.fromString(JSON.stringify(E))):await this.l.del(this.c)),E})}async t(x,M,E,N){this.q.trace(`Started extracting the extension from ${M} to ${E}`);try{await f.Promises.rm(E)}catch(z){throw new t.ExtensionManagementError(this.C(z).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(M,E,{sourcePath:"extension",overwrite:!0},N),this.q.info(`Extracted extension to ${E}:`,x.id)}catch(z){try{await f.Promises.rm(E)}catch{}let G=t.ExtensionManagementErrorCode.Extract;throw z instanceof g.ExtractError&&(z.type==="CorruptZip"?G=t.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(G=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(z.message,G)}}async u(x,M,E,N){try{await f.Promises.rename(M,E)}catch(z){if(p.isWindows&&z&&z.code==="EPERM"&&Date.now()<N)return this.q.info(`Failed renaming ${M} to ${E} with 'EPERM' error. Trying again...`,x.id),this.u(x,M,E,N);throw new t.ExtensionManagementError(z.message||v.localize(5,null,M,E),z.code||t.ExtensionManagementErrorCode.Rename)}}async v(x,M){const E=await this.m.scanExistingExtension(x,M,{includeInvalid:!0});if(E)return this.w(E);throw new Error(v.localize(6,null,x.path))}async w(x){const M=await this.l.resolve(x.location);let E,N;return M.children&&(E=M.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,N=M.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:x.identifier,type:x.type,isBuiltin:x.isBuiltin||!!x.metadata?.isBuiltin,location:x.location,manifest:x.manifest,targetPlatform:x.targetPlatform,validations:x.validations,isValid:x.isValid,readmeUrl:E,changelogUrl:N,publisherDisplayName:x.metadata?.publisherDisplayName||null,publisherId:x.metadata?.publisherId||null,isApplicationScoped:!!x.metadata?.isApplicationScoped,isMachineScoped:!!x.metadata?.isMachineScoped,isPreReleaseVersion:!!x.metadata?.isPreReleaseVersion,preRelease:!!x.metadata?.preRelease,installedTimestamp:x.metadata?.installedTimestamp,updated:!!x.metadata?.updated,pinned:!!x.metadata?.pinned}}async y(){const x=await this.getUninstalledExtensions();this.q.debug("Removing uninstalled extensions:",Object.keys(x));const M=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),E=new Set;for(const z of M)x[i.ExtensionKey.create(z).toString()]||E.add(z.identifier.id.toLowerCase());try{const z=(0,i.groupByExtension)(M,G=>G.identifier);await L.Promises.settled(z.map(async G=>{const q=G.sort((J,ee)=>m.rcompare(J.manifest.version,ee.manifest.version))[0];E.has(q.identifier.id.toLowerCase())||await this.k(await this.w(q))}))}catch(z){this.q.error(z)}const N=M.filter(z=>z.metadata&&x[i.ExtensionKey.create(z).toString()]);await Promise.allSettled(N.map(z=>this.removeUninstalledExtension(z)))}async z(){this.q.trace("ExtensionManagementService#removeGeneratedFolders");const x=[];let M;try{M=await this.l.resolve(this.m.userExtensionsLocation)}catch(E){(0,j.toFileOperationResult)(E)!==1&&this.q.error(E)}for(const E of M?.children??[])E.isDirectory&&E.name.startsWith(".")&&(0,u.isUUID)(E.name.substring(1))&&x.push((async()=>{this.q.trace("Deleting the generated extension folder",E.resource.toString());try{await this.l.del(E.resource,{recursive:!0}),this.q.info("Deleted the generated extension folder",E.resource.toString())}catch(N){this.q.error(N)}})());await Promise.allSettled(x)}C(x){const M=Array.isArray(x)?x:[x];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((E,N)=>new Error(`${E.message}${E.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};H=ye([K(1,j.IFileService),K(2,a.IExtensionsScannerService),K(3,s.IExtensionsProfileScannerService),K(4,X.IUriIdentityService),K(5,V.ILogService)],H),e.ExtensionsScanner=H;class $ extends r.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,C.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(x,M,E,N,z,G,q,J,ee){super(),this.identifier=x,this.source=M,this.l=E,this.m=N,this.n=z,this.o=G,this.p=q,this.q=J,this.s=ee,this.j="Unverified",this.k=2}async h(x){const[M,E]=await this.x(x);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[M,E]],this.l.profileLocation),M}async u({zipPath:x,key:M,metadata:E},N){let z=await this.v(M);return z||(this.s.trace("Extracting extension...",M.id),z=await this.m.extractUserExtension(M,x,E,N),this.s.info("Extracting extension completed.",M.id)),z}async v(x){return await this.w(x)?(this.s.trace("Removing the extension from uninstalled list:",x.id),await this.m.setInstalled(x),this.s.info("Removed the extension from uninstalled list:",x.id),(await this.m.scanAllUserExtensions(!0)).find(N=>i.ExtensionKey.create(N).equals(x))):void 0}async w(x){return!!(await this.m.getUninstalledExtensions())[x.toString()]}}class _ extends ${constructor(x,M,E,N,z,G,q,J,ee,ce){super(M.identifier,M,E,z,G,q,J,ee,ce),this.y=x,this.z=M,this.A=N}async x(x){const E=(await this.m.scanExtensions(null,this.l.profileLocation)).find(q=>(0,i.areSameExtensions)(q.identifier,this.z.identifier));E&&(this.k=3);const N={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||E?.isMachineScoped,isBuiltin:this.l.isBuiltin||E?.isBuiltin,isSystem:E?.type===0?!0:void 0,updated:!!E,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,C.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:E?.preRelease)};if(E?.manifest.version===this.z.version)return[await this.m.updateMetadata(E,N),N];const{location:z,verificationStatus:G}=await this.A.download(this.z,this.k);try{return this.j=G,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.ExtensionKey.create(this.z),metadata:N},x),N]}catch(q){try{await this.A.delete(z)}catch(J){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,O.getErrorMessage)(J))}throw q}}async C(x){try{await(0,b.getManifest)(x)}catch(M){throw new t.ExtensionManagementError((0,r.joinErrors)(M).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=_;class ie extends ${constructor(x,M,E,N,z,G,q,J,ee,ce){super({id:(0,i.getGalleryExtensionId)(x.publisher,x.name)},M,E,z,G,q,J,ee,ce),this.y=x,this.z=M,this.A=N}async h(x){const M=await super.h(x);return this.D(M,x),M}async x(x){const M=new i.ExtensionKey(this.identifier,this.y.version),N=(await this.m.scanExtensions(1,this.l.profileLocation)).find(q=>(0,i.areSameExtensions)(this.identifier,q.identifier)),z={isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||N?.isMachineScoped,isBuiltin:this.l.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0};if(N)if(this.k=3,M.equals(new i.ExtensionKey(N.identifier,N.manifest.version)))try{await this.m.removeExtension(N,"existing")}catch{throw new Error(v.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&m.gt(N.manifest.version,this.y.version)&&await this.m.setUninstalled(N);else{const q=await this.v(M);if(q)try{await this.m.removeExtension(q,"existing")}catch{throw new Error(v.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:S.resolve(this.z.fsPath),key:M,metadata:z},x),z]}async D(x,M){try{let[E]=await this.A.getExtensions([{id:x.identifier.id,version:x.manifest.version}],M);if(E||([E]=await this.A.getExtensions([{id:x.identifier.id}],M)),E){const N={id:E.identifier.uuid,publisherDisplayName:E.publisherDisplayName,publisherId:E.publisherId,isPreReleaseVersion:E.properties.isPreReleaseVersion,preRelease:E.properties.isPreReleaseVersion||this.l.installPreReleaseVersion};await this.m.updateMetadata(x,N,this.l.profileLocation)}}catch{}}}class se extends r.AbstractExtensionTask{constructor(x,M,E){super(),this.extension=x,this.j=M,this.k=E}async h(x){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[290],oe([0,1,2,29,79,238,128,9,20]),function(te,e,L,U,l,A,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends L.Disposable{constructor(S,p,d,m,C,c){super(),S.cleanUp(),(0,A.migrateUnsupportedExtensions)(S,p,d,m,c),l.ExtensionStorageService.removeOutdatedExtensionVersions(S,C)}};w=ye([K(0,O.INativeServerExtensionManagementService),K(1,U.IExtensionGalleryService),K(2,l.IExtensionStorageService),K(3,U.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,D.ILogService)],w),e.ExtensionsContributions=w}),define(re[299],oe([0,1,150,231,250,34,38,10,2,22,11,39,152,217,218,210,211,287,201,203,17,222,98,235,99,228,15,232,120,273,29,100,202,128,101,14,213,214,68,5,209,70,72,241,9,106,107,26,59,20,112,19,113,114,115,47,244,117,253,79,118,24,77,278,264,265,80,279,282,283,284,61,277,267,111,234,76,255,226,254,110,30,256,4,257,204,220,219,78,272,18,51,216,58,276,243,268,109,281,290,7,215,266,87,105,236,271,229,198,57,285,274,71,275]),function(te,e,L,U,l,A,O,D,I,w,P,S,p,d,m,C,c,u,f,g,v,R,n,r,t,i,s,a,o,h,b,y,k,T,F,j,B,V,W,Q,X,Y,Z,H,$,_,ie,se,ae,x,M,E,N,z,G,q,J,ee,ce,he,me,de,we,Ce,Re,ke,We,Ye,le,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue,pe,Se,ve,Ee,De,Ae,Te,Ue,$e,ze,et,nt,vt,Rt,kt,Lt,wt,At,Ot,Tt,Nt,Ut,Ze,St,Mt,Ft,jt,$t,zt,qt,Wt,bt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class xt extends I.Disposable{constructor(be,Oe){super(),this.f=be,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.D(new p.Server):this.a=this.D(new L.Server),this.h()}h(){let be=!1;const Oe=()=>{be||(be=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,p.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",Be=(st,Ve)=>{this.i(Ve)};this.g.on(xe,Be),this.D((0,I.toDisposable)(()=>this.g.removeListener(xe,Be)))}}i(be){this.b?.disposeWorker(be)}async init(){const be=await this.j();(0,de.registerConfiguration)(),be.invokeFunction(Oe=>{const xe=Oe.get($.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.D((0,I.combinedDisposable)(be.createInstance(d.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(m.LanguagePackCachedDataCleaner),be.createInstance(u.UnusedWorkspaceStorageDataCleaner),be.createInstance(c.LogsDataCleaner),be.createInstance(C.LocalizationsUpdater),be.createInstance(Ot.ExtensionsContributions),be.createInstance(Lt.UserDataProfilesCleaner)))}async j(){const be=new Y.ServiceCollection,Oe={_serviceBrand:void 0,...ie.default};be.set(se.IProductService,Oe);const xe=new S.StaticRouter(Ke=>Ke==="main"),Be=new bt.MainProcessService(this.a,xe);be.set(bt.IMainProcessService,Be);const st=this.f.policiesData?new nt.PolicyChannelClient(this.f.policiesData,Be.getChannel("policy")):new vt.NullPolicyService;be.set(vt.IPolicyService,st);const Ve=new a.SharedProcessEnvironmentService(this.f.args,Oe);be.set(s.INativeEnvironmentService,Ve);const _e=new _.LoggerChannelClient(void 0,this.f.logLevel,Ve.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:P.URI.revive(Ke.resource)})),Be.getChannel("logger"));be.set($.ILoggerService,_e);const ct=this.D(_e.createLogger("sharedprocess",{name:(0,Tt.localize)(0,null)})),ht=this.D(new $.ConsoleLogger(ct.getLevel())),Ge=this.D(new Nt.LogService(ct,[ht]));be.set($.ILogService,Ge),this.c=this.D(new St.SharedProcessLifecycleService(Ge)),be.set(St.ISharedProcessLifecycleService,this.c),this.b=new U.SharedProcessWorkerService(Ge),be.set(ue.ISharedProcessWorkerService,this.b);const Qe=this.D(new B.FileService(Ge));be.set(j.IFileService,Qe);const ft=this.D(new V.DiskFileSystemProvider(Ge));Qe.registerProvider(w.Schemas.file,ft);const dt=this.D(new Ee.FileUserDataProvider(w.Schemas.file,this.D(new De.DiskFileSystemProviderClient(Be.getChannel(De.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ve.isLinux})),w.Schemas.vscodeUserData,Ge));Qe.registerProvider(w.Schemas.vscodeUserData,dt);const tt=this.D(new Rt.UserDataProfilesService(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),Be.getChannel("userDataProfiles")));be.set(ze.IUserDataProfilesService,tt);const Je=this.D(new R.ConfigurationService(tt.defaultProfile.settingsResource,Qe,st,Ge));be.set(v.IConfigurationService,Je);const rt=new Bt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Be,Ve);be.set(x.IStorageService,rt),this.D((0,I.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const gt=new Se.UriIdentityService(Qe);be.set(pe.IUriIdentityService,gt),be.set(ae.IRequestService,new jt.RequestChannelClient(Be.getChannel("request"))),be.set(f.IChecksumService,new W.SyncDescriptor(g.ChecksumService,void 0,!1)),be.set(Te.IV8InspectProfilingService,new W.SyncDescriptor(Ae.InspectProfilingService,void 0,!1));const lt=S.ProxyChannel.toService(Be.getChannel("nativeHost"),{context:this.f.windowId});be.set(zt.INativeHostService,lt),be.set(t.IDownloadService,new W.SyncDescriptor(i.DownloadService,void 0,!0));const mt=this.D(new Fe.ActiveWindowManager(lt)),Vt=new S.StaticRouter(Ke=>mt.getActiveClientId().then(pt=>Ke===pt));be.set(F.IExtensionRecommendationNotificationService,new $t.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Vt)));let ut;const ot=[],Ct=(0,q.isInternalTelemetry)(Oe,Je);if((0,q.supportsTelemetry)(Oe,Ve)){const Ke=new z.TelemetryLogAppender(Ge,_e,Ve,Oe);ot.push(Ke);const{installSourcePath:pt}=Ve;if(Oe.aiConfig?.ariaKey){const Pt=new kt.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.D((0,I.toDisposable)(()=>Pt.flush())),ot.push(Pt)}ut=new G.TelemetryService({appenders:ot,commonProperties:(0,M.resolveCommonProperties)(Qe,(0,A.release)(),(0,A.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct,pt),sendErrorTelemetry:!0,piiPaths:(0,q.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=q.NullTelemetryService;const Ke=q.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new N.TelemetryAppenderChannel(ot)),be.set(E.ITelemetryService,ut);const Ht=new J.CustomEndpointTelemetryService(Je,ut,Ge,_e,Ve,Oe);be.set(E.ICustomEndpointTelemetryService,Ht),be.set(et.IExtensionsProfileScannerService,new W.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),be.set(Ue.IExtensionsScannerService,new W.SyncDescriptor($e.ExtensionsScannerService,void 0,!0)),be.set(y.IExtensionSignatureVerificationService,new W.SyncDescriptor(y.ExtensionSignatureVerificationService,void 0,!0)),be.set(T.INativeServerExtensionManagementService,new W.SyncDescriptor(T.ExtensionManagementService,void 0,!0)),be.set(b.IExtensionGalleryService,new W.SyncDescriptor(h.ExtensionGalleryService,void 0,!0)),be.set(b.IExtensionTipsService,new W.SyncDescriptor(Wt.ExtensionTipsService,void 0,!1)),be.set(Z.ILanguagePackService,new W.SyncDescriptor(H.NativeLanguagePackService,void 0,!1)),be.set(n.IDiagnosticsService,new W.SyncDescriptor(r.DiagnosticsService,void 0,!1)),be.set(we.IUserDataSyncAccountService,new W.SyncDescriptor(we.UserDataSyncAccountService,void 0,!0)),be.set(de.IUserDataSyncLogService,new W.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),be.set(de.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),be.set(b.IGlobalExtensionEnablementService,new W.SyncDescriptor(o.GlobalExtensionEnablementService,void 0,!1)),be.set(me.IIgnoredExtensionsManagementService,new W.SyncDescriptor(me.IgnoredExtensionsManagementService,void 0,!0)),be.set(he.IExtensionStorageService,new W.SyncDescriptor(he.ExtensionStorageService)),be.set(de.IUserDataSyncStoreManagementService,new W.SyncDescriptor(ge.UserDataSyncStoreManagementService,void 0,!0)),be.set(de.IUserDataSyncStoreService,new W.SyncDescriptor(ge.UserDataSyncStoreService,void 0,!0)),be.set(We.IUserDataSyncMachinesService,new W.SyncDescriptor(We.UserDataSyncMachinesService,void 0,!0)),be.set(de.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),be.set(de.IUserDataSyncEnablementService,new W.SyncDescriptor(Ye.UserDataSyncEnablementService,void 0,!0)),be.set(de.IUserDataSyncService,new W.SyncDescriptor(le.UserDataSyncService,void 0,!1)),be.set(Ie.IUserDataProfileStorageService,new W.SyncDescriptor(Pe.NativeUserDataProfileStorageService,void 0,!0)),be.set(de.IUserDataSyncResourceProviderService,new W.SyncDescriptor(At.UserDataSyncResourceProviderService,void 0,!0));const It=new ce.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Je,Ve,Ge,_e);return It.initialize(),be.set(l.ILocalPtyService,this.D(It)),be.set(Le.ISignService,new W.SyncDescriptor(qe.SignService,void 0,!1)),be.set(Me.ISharedTunnelsService,new W.SyncDescriptor(Ne.SharedTunnelsService)),be.set(je.ISharedProcessTunnelService,new W.SyncDescriptor(ne.SharedProcessTunnelService)),be.set(wt.IRemoteTunnelService,new W.SyncDescriptor(Mt.RemoteTunnelService)),new X.InstantiationService(be)}k(be){const Oe=new k.ExtensionManagementChannel(be.get(b.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=S.ProxyChannel.fromService(be.get(Z.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const Be=S.ProxyChannel.fromService(be.get(n.IDiagnosticsService));this.a.registerChannel("diagnostics",Be);const st=new k.ExtensionTipsChannel(be.get(b.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=S.ProxyChannel.fromService(be.get(f.IChecksumService));this.a.registerChannel("checksum",Ve);const _e=S.ProxyChannel.fromService(be.get(Te.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new Re.UserDataSyncMachinesServiceChannel(be.get(We.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=S.ProxyChannel.fromService(be.get(E.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ge=new Re.UserDataSyncAccountServiceChannel(be.get(we.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const Qe=new Re.UserDataSyncStoreManagementServiceChannel(be.get(de.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new fe.UserDataSyncChannel(be.get(de.IUserDataSyncService),be.get(ze.IUserDataProfilesService),be.get($.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.D(be.get(Q.IInstantiationService).createInstance(qt.UserDataAutoSyncService)),tt=new Re.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Je=be.get(l.ILocalPtyService),rt=S.ProxyChannel.fromService(Je);this.a.registerChannel(ee.TerminalIpcChannels.LocalPty,rt);const gt=S.ProxyChannel.fromService(be.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=S.ProxyChannel.fromService(be.get(ue.ISharedProcessWorkerService));this.a.registerChannel(Ut.ipcUtilityProcessWorkerChannelName,lt);const mt=S.ProxyChannel.fromService(be.get(wt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(be){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,D.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,D.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,D.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,D.setUnexpectedErrorHandler)(Oe=>{const xe=(0,O.toErrorMessage)(Oe,!0);!xe||be.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(at){let be;(0,Ze.isUtilityProcess)(process)||(be=(await new Promise((xe,Be)=>{te(["electron"],xe,Be)})).ipcRenderer);const Oe=new xt(at,be);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):be.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):be.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/155cd6db223feb1f8c734ca70e108b9efec7b054/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
