/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","os","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(se){for(var e=[],a=0,A=se.length;a<A;a++)e[a]=Ce[se[a]];return e};define(Ce[61],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(P,T){const y=Object.create(null);for(const m of P){const L=T(m);let I=y[L];I||(I=y[L]=[]),I.push(m)}return y}e.groupBy=a;function A(P,T){const y=[],m=[];for(const L of P)T.has(L)||y.push(L);for(const L of T)P.has(L)||m.push(L);return{removed:y,added:m}}e.diffSets=A;function u(P,T){const y=[],m=[];for(const[L,I]of P)T.has(L)||y.push(I);for(const[L,I]of T)P.has(L)||m.push(I);return{removed:y,added:m}}e.diffMaps=u;class R{constructor(){this.a=new Map}add(T,y){let m=this.a.get(T);m||(m=new Set,this.a.set(T,m)),m.add(y)}delete(T,y){const m=this.a.get(T);!m||(m.delete(y),m.size===0&&this.a.delete(T))}forEach(T,y){const m=this.a.get(T);!m||m.forEach(y)}}e.SetMap=R}),define(Ce[62],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(P){return(T,y,m)=>{let L=null,I=null;if(typeof m.value=="function"?(L="value",I=m.value):typeof m.get=="function"&&(L="get",I=m.get),!I)throw new Error("not supported");m[L]=P(I,y)}}function A(P,T,y){let m=null,L=null;if(typeof y.value=="function"?(m="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",L=y.get),!L)throw new Error("not supported");const I=`$memoize$${T}`;y[m]=function(...S){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[I]}}e.memoize=A;function u(P,T,y){return a((m,L)=>{const I=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...k){this[S]||(this[S]=y?y():void 0),clearTimeout(this[I]),T&&(this[S]=T(this[S],...k),k=[this[S]]),this[I]=setTimeout(()=>{m.apply(this,k),this[S]=y?y():void 0},P)}})}e.debounce=u;function R(P,T,y){return a((m,L)=>{const I=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,k=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...E){if(this[S]||(this[S]=y?y():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[S]=T(this[S],...E)),this[C])return;const r=this[k]+P;r<=Date.now()?(this[k]=Date.now(),m.apply(this,[this[S]]),this[S]=y?y():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[k]=Date.now(),m.apply(this,[this[S]]),this[S]=y?y():void 0},r-Date.now()))}})}e.throttle=R}),define(Ce[10],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?D.isErrorNoTelemetry(o)?new D(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function u(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function R(t){m(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function P(t){m(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=P;function T(t){if(t instanceof Error){const{name:o,message:s}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:o,message:s,stack:c,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=T;const y="Canceled";function m(t){return t instanceof L?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=m;class L extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=L;function I(){const t=new Error(y);return t.name=t.message,t}e.canceled=I;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=k;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function E(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=f;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class D extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof D)return o;const s=new D;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(Ce[17],Ie([1,0,10]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(te,ne=0){return te[te.length-(1+ne)]}e.tail=A;function u(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}e.tail2=u;function R(te,ne,de=(ee,ce)=>ee===ce){if(te===ne)return!0;if(!te||!ne||te.length!==ne.length)return!1;for(let ee=0,ce=te.length;ee<ce;ee++)if(!de(te[ee],ne[ee]))return!1;return!0}e.equals=R;function P(te,ne){const de=te.length-1;ne<de&&(te[ne]=te[de]),te.pop()}e.removeFastWithoutKeepingOrder=P;function T(te,ne,de){return y(te.length,ee=>de(te[ee],ne))}e.binarySearch=T;function y(te,ne){let de=0,ee=te-1;for(;de<=ee;){const ce=(de+ee)/2|0,ae=ne(ce);if(ae<0)de=ce+1;else if(ae>0)ee=ce-1;else return ce}return-(de+1)}e.binarySearch2=y;function m(te,ne){let de=0,ee=te.length;if(ee===0)return 0;for(;de<ee;){const ce=Math.floor((de+ee)/2);ne(te[ce])?ee=ce:de=ce+1}return de}e.findFirstInSorted=m;function L(te,ne,de){if(te=te|0,te>=ne.length)throw new TypeError("invalid index");const ee=ne[Math.floor(ne.length*Math.random())],ce=[],ae=[],N=[];for(const z of ne){const K=de(z,ee);K<0?ce.push(z):K>0?ae.push(z):N.push(z)}return te<ce.length?L(te,ce,de):te<ce.length+N.length?N[0]:L(te-(ce.length+N.length),ae,de)}e.quickSelect=L;function I(te,ne){const de=[];let ee;for(const ce of te.slice(0).sort(ne))!ee||ne(ee[0],ce)!==0?(ee=[ce],de.push(ee)):ee.push(ce);return de}e.groupBy=I;function S(te,ne,de){const ee=[];function ce(z,K,Z){if(K===0&&Z.length===0)return;const fe=ee[ee.length-1];fe&&fe.start+fe.deleteCount===z?(fe.deleteCount+=K,fe.toInsert.push(...Z)):ee.push({start:z,deleteCount:K,toInsert:Z})}let ae=0,N=0;for(;;){if(ae===te.length){ce(ae,0,ne.slice(N));break}if(N===ne.length){ce(ae,te.length-ae,[]);break}const z=te[ae],K=ne[N],Z=de(z,K);Z===0?(ae+=1,N+=1):Z<0?(ce(ae,1,[]),ae+=1):Z>0&&(ce(ae,0,[K]),N+=1)}return ee}e.sortedDiff=S;function k(te,ne,de){const ee=S(te,ne,de),ce=[],ae=[];for(const N of ee)ce.push(...te.slice(N.start,N.start+N.deleteCount)),ae.push(...N.toInsert);return{removed:ce,added:ae}}e.delta=k;function C(te,ne,de){if(de===0)return[];const ee=te.slice(0,de).sort(ne);return r(te,ne,ee,de,te.length),ee}e.top=C;function E(te,ne,de,ee,ce){return de===0?Promise.resolve([]):new Promise((ae,N)=>{(async()=>{const z=te.length,K=te.slice(0,de).sort(ne);for(let Z=de,fe=Math.min(de+ee,z);Z<z;Z=fe,fe=Math.min(fe+ee,z)){if(Z>de&&await new Promise(Se=>setTimeout(Se)),ce&&ce.isCancellationRequested)throw new a.CancellationError;r(te,ne,K,Z,fe)}return K})().then(ae,N)})}e.topAsync=E;function r(te,ne,de,ee,ce){for(const ae=de.length;ee<ce;ee++){const N=te[ee];if(ne(N,de[ae-1])<0){de.pop();const z=m(de,K=>ne(N,K)<0);de.splice(z,0,N)}}}function d(te){return te.filter(ne=>!!ne)}e.coalesce=d;function f(te){let ne=0;for(let de=0;de<te.length;de++)te[de]&&(te[ne]=te[de],ne+=1);te.length=ne}e.coalesceInPlace=f;function g(te,ne,de){te.splice(de,0,te.splice(ne,1)[0])}e.move=g;function D(te){return!Array.isArray(te)||te.length===0}e.isFalsyOrEmpty=D;function p(te){return Array.isArray(te)&&te.length>0}e.isNonEmptyArray=p;function t(te,ne=de=>de){const de=new Set;return te.filter(ee=>{const ce=ne(ee);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function o(te){const ne=new Set;return de=>{const ee=te(de);return ne.has(ee)?!1:(ne.add(ee),!0)}}e.uniqueFilter=o;function s(te,ne){const de=c(te,ne);if(de!==-1)return te[de]}e.findLast=s;function c(te,ne){for(let de=te.length-1;de>=0;de--){const ee=te[de];if(ne(ee))return de}return-1}e.lastIndex=c;function l(te,ne){return te.length>0?te[0]:ne}e.firstOrDefault=l;function v(te,ne){return te.length>0?te[te.length-1]:ne}e.lastOrDefault=v;function i(te,ne,de=(ee,ce)=>ee===ce){let ee=0;for(let ce=0,ae=Math.min(te.length,ne.length);ce<ae&&de(te[ce],ne[ce]);ce++)ee++;return ee}e.commonPrefixLength=i;function n(te){return[].concat(...te)}e.flatten=n;function h(te,ne){let de=typeof ne=="number"?te:0;typeof ne=="number"?de=te:(de=0,ne=te);const ee=[];if(de<=ne)for(let ce=de;ce<ne;ce++)ee.push(ce);else for(let ce=de;ce>ne;ce--)ee.push(ce);return ee}e.range=h;function w(te,ne,de){return te.reduce((ee,ce)=>(ee[ne(ce)]=de?de(ce):ce,ee),Object.create(null))}e.index=w;function b(te,ne){return te.push(ne),()=>O(te,ne)}e.insert=b;function O(te,ne){const de=te.indexOf(ne);if(de>-1)return te.splice(de,1),ne}e.remove=O;function H(te,ne,de){const ee=te.slice(0,ne),ce=te.slice(ne);return ee.concat(de,ce)}e.arrayInsert=H;function x(te,ne){let de;if(typeof ne=="number"){let ee=ne;de=()=>{const ce=Math.sin(ee++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let ee=te.length-1;ee>0;ee-=1){const ce=Math.floor(de()*(ee+1)),ae=te[ee];te[ee]=te[ce],te[ce]=ae}}e.shuffle=x;function _(te,ne){const de=te.indexOf(ne);de>-1&&(te.splice(de,1),te.unshift(ne))}e.pushToStart=_;function G(te,ne){const de=te.indexOf(ne);de>-1&&(te.splice(de,1),te.push(ne))}e.pushToEnd=G;function M(te,ne){for(const de of ne)te.push(de)}e.pushMany=M;function B(te,ne){return Array.isArray(te)?te.map(ne):ne(te)}e.mapArrayOrNot=B;function U(te){return Array.isArray(te)?te:[te]}e.asArray=U;function j(te){return te[Math.floor(Math.random()*te.length)]}e.getRandomElement=j;function he(te,ne){for(const de of te){const ee=ne(de);if(ee!==void 0)return ee}}e.mapFind=he;function ie(te,ne,de){const ee=J(te,ne),ce=te.length,ae=de.length;te.length=ce+ae;for(let N=ce-1;N>=ee;N--)te[N+ae]=te[N];for(let N=0;N<ae;N++)te[N+ee]=de[N]}e.insertInto=ie;function V(te,ne,de,ee){const ce=J(te,ne),ae=te.splice(ce,de);return ie(te,ce,ee),ae}e.splice=V;function J(te,ne){return ne<0?Math.max(ne+te.length,0):Math.min(ne,te.length)}var re;(function(te){function ne(ce){return ce<0}te.isLessThan=ne;function de(ce){return ce>0}te.isGreaterThan=de;function ee(ce){return ce===0}te.isNeitherLessOrGreaterThan=ee,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(re=e.CompareResult||(e.CompareResult={}));function ve(te,ne){return(de,ee)=>ne(te(de),te(ee))}e.compareBy=ve;function ue(...te){return(ne,de)=>{for(const ee of te){const ce=ee(ne,de);if(!re.isNeitherLessOrGreaterThan(ce))return ce}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=ue;const le=(te,ne)=>te-ne;e.numberComparator=le;function q(te,ne){if(te.length===0)return;let de=te[0];for(let ee=1;ee<te.length;ee++){const ce=te[ee];ne(ce,de)>0&&(de=ce)}return de}e.findMaxBy=q;function F(te,ne){if(te.length===0)return;let de=te[0];for(let ee=1;ee<te.length;ee++){const ce=te[ee];ne(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=F;function Q(te,ne){return q(te,(de,ee)=>-ne(de,ee))}e.findMinBy=Q;class me{constructor(ne){this.f=ne,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let de=this.c;for(;de<this.f.length&&ne(this.f[de]);)de++;const ee=de===this.c?null:this.f.slice(this.c,de);return this.c=de,ee}takeFromEndWhile(ne){let de=this.d;for(;de>=0&&ne(this.f[de]);)de--;const ee=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ne=this.f[this.c];return this.c++,ne}removeLast(){const ne=this.f[this.d];return this.d--,ne}takeCount(ne){const de=this.f.slice(this.c,this.c+ne);return this.c+=ne,de}}e.ArrayQueue=me;class Ee{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(de=>(ne(de),!0))}toArray(){const ne=[];return this.iterate(de=>(ne.push(de),!0)),ne}filter(ne){return new Ee(de=>this.iterate(ee=>ne(ee)?de(ee):!0))}map(ne){return new Ee(de=>this.iterate(ee=>de(ne(ee))))}some(ne){let de=!1;return this.iterate(ee=>(de=ne(ee),!de)),de}findFirst(ne){let de;return this.iterate(ee=>ne(ee)?(de=ee,!1):!0),de}findLast(ne){let de;return this.iterate(ee=>(ne(ee)&&(de=ee),!0)),de}findLastMaxBy(ne){let de,ee=!0;return this.iterate(ce=>((ee||re.isGreaterThan(ne(ce,de)))&&(ee=!1,de=ce),!0)),de}}Ee.empty=new Ee(te=>{}),e.CallbackIterable=Ee}),define(Ce[51],Ie([1,0,10]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(y,m){if(!y)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=A;function u(y,m="Unreachable"){throw new Error(m)}e.assertNever=u;function R(y){if(!y)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function P(y){if(!y()){debugger;y(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=P;function T(y,m){let L=0;for(;L<y.length-1;){const I=y[L],S=y[L+1];if(!m(I,S))return!1;L++}return!0}e.checkAdjacentItems=T}),define(Ce[63],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(A){const u=this;let R=!1,P;return function(){return R||(R=!0,P=A.apply(u,arguments)),P}}e.once=a}),define(Ce[102],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ce[64],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(A){function u(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}A.is=u;const R=Object.freeze([]);function P(){return R}A.empty=P;function*T(D){yield D}A.single=T;function y(D){return u(D)?D:T(D)}A.wrap=y;function m(D){return D||R}A.from=m;function L(D){return!D||D[Symbol.iterator]().next().done===!0}A.isEmpty=L;function I(D){return D[Symbol.iterator]().next().value}A.first=I;function S(D,p){for(const t of D)if(p(t))return!0;return!1}A.some=S;function k(D,p){for(const t of D)if(p(t))return t}A.find=k;function*C(D,p){for(const t of D)p(t)&&(yield t)}A.filter=C;function*E(D,p){let t=0;for(const o of D)yield p(o,t++)}A.map=E;function*r(...D){for(const p of D)for(const t of p)yield t}A.concat=r;function d(D,p,t){let o=t;for(const s of D)o=p(o,s);return o}A.reduce=d;function*f(D,p,t=D.length){for(p<0&&(p+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);p<t;p++)yield D[p]}A.slice=f;function g(D,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,D];const o=D[Symbol.iterator]();for(let s=0;s<p;s++){const c=o.next();if(c.done)return[t,A.empty()];t.push(c.value)}return[t,{[Symbol.iterator](){return o}}]}A.consume=g})(a=e.Iterable||(e.Iterable={}))}),define(Ce[147],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function P(t,o=!1){let s=0;const c=t.length;let l="",v=0,i=16,n=0;function h(G){let M=0,B=0;for(;M<G;){const U=t.charCodeAt(s);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;s++,M++}return M<G&&(B=-1),B}function w(G){s=G,l="",v=0,i=16,n=0}function b(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&m(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&m(t.charCodeAt(s)))for(s++;s<t.length&&m(t.charCodeAt(s));)s++;else return n=3,t.substring(G,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&m(t.charCodeAt(s))){for(s++;s<t.length&&m(t.charCodeAt(s));)s++;M=s}else n=3;return t.substring(G,M)}function O(){let G="",M=s;for(;;){if(s>=c){G+=t.substring(M,s),n=2;break}const B=t.charCodeAt(s);if(B===34){G+=t.substring(M,s),s++;break}if(B===92){if(G+=t.substring(M,s),s++,s>=c){n=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:{const j=h(4);j>=0?G+=String.fromCharCode(j):n=4;break}default:n=5}M=s;continue}if(B>=0&&B<=31)if(y(B)){G+=t.substring(M,s),n=2;break}else n=6;s++}return G}function H(){if(l="",n=0,v=s,s>=c)return v=c,i=17;let G=t.charCodeAt(s);if(T(G)){do s++,l+=String.fromCharCode(G),G=t.charCodeAt(s);while(T(G));return i=15}if(y(G))return s++,l+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),i=14;switch(G){case 123:return s++,i=1;case 125:return s++,i=2;case 91:return s++,i=3;case 93:return s++,i=4;case 58:return s++,i=6;case 44:return s++,i=5;case 34:return s++,l=O(),i=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<c&&!y(t.charCodeAt(s));)s++;return l=t.substring(M,s),i=12}if(t.charCodeAt(s+1)===42){s+=2;const B=c-1;let U=!1;for(;s<B;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,n=1),l=t.substring(M,s),i=13}return l+=String.fromCharCode(G),s++,i=16}case 45:if(l+=String.fromCharCode(G),s++,s===c||!m(t.charCodeAt(s)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=b(),i=11;default:for(;s<c&&x(G);)s++,G=t.charCodeAt(s);if(v!==s){switch(l=t.substring(v,s),l){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return l+=String.fromCharCode(G),s++,i=16}}function x(G){if(T(G)||y(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let G;do G=H();while(G>=12&&G<=15);return G}return{setPosition:w,getPosition:()=>s,scan:o?_:H,getToken:()=>i,getTokenValue:()=>l,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>n}}e.createScanner=P;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,o){const s=[],c=new Object;let l;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function n(h,w,b,O){v.value=h,v.offset=w,v.length=b,v.type=O,v.colonOffset=void 0,l=v}try{g(t,{onObjectBegin:(h,w)=>{if(o<=h)throw c;l=void 0,i=o>h,s.push("")},onObjectProperty:(h,w,b)=>{if(o<w||(n(h,w,b,"property"),s[s.length-1]=h,o<=w+b))throw c},onObjectEnd:(h,w)=>{if(o<=h)throw c;l=void 0,s.pop()},onArrayBegin:(h,w)=>{if(o<=h)throw c;l=void 0,s.push(0)},onArrayEnd:(h,w)=>{if(o<=h)throw c;l=void 0,s.pop()},onLiteralValue:(h,w,b)=>{if(o<w||(n(h,w,b,p(h)),o<=w+b))throw c},onSeparator:(h,w,b)=>{if(o<=w)throw c;if(h===":"&&l&&l.type==="property")l.colonOffset=w,i=!1,l=void 0;else if(h===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(i=!0,s[s.length-1]=""),l=void 0}}})}catch(h){if(h!==c)throw h}return{path:s,previousNode:l,isAtPropertyKey:i,matches:h=>{let w=0;for(let b=0;w<h.length&&b<s.length;b++)if(h[w]===s[b]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=I;function S(t,o=[],s=R.DEFAULT){let c=null,l=[];const v=[];function i(h){Array.isArray(l)?l.push(h):c!==null&&(l[c]=h)}return g(t,{onObjectBegin:()=>{const h={};i(h),v.push(l),l=h,c=null},onObjectProperty:h=>{c=h},onObjectEnd:()=>{l=v.pop()},onArrayBegin:()=>{const h=[];i(h),v.push(l),l=h,c=null},onArrayEnd:()=>{l=v.pop()},onLiteralValue:i,onError:(h,w,b)=>{o.push({error:h,offset:w,length:b})}},s),l[0]}e.parse=S;function k(t,o=[],s=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(h){c.type==="property"&&(c.length=h-c.offset,c=c.parent)}function v(h){return c.children.push(h),h}g(t,{onObjectBegin:h=>{c=v({type:"object",offset:h,length:-1,parent:c,children:[]})},onObjectProperty:(h,w,b)=>{c=v({type:"property",offset:w,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:h,offset:w,length:b,parent:c})},onObjectEnd:(h,w)=>{c.length=h+w-c.offset,c=c.parent,l(h+w)},onArrayBegin:(h,w)=>{c=v({type:"array",offset:h,length:-1,parent:c,children:[]})},onArrayEnd:(h,w)=>{c.length=h+w-c.offset,c=c.parent,l(h+w)},onLiteralValue:(h,w,b)=>{v({type:p(h),offset:w,length:b,parent:c,value:h}),l(w+b)},onSeparator:(h,w,b)=>{c.type==="property"&&(h===":"?c.colonOffset=w:h===","&&l(w))},onError:(h,w,b)=>{o.push({error:h,offset:w,length:b})}},s);const n=c.children[0];return n&&delete n.parent,n}e.parseTree=k;function C(t,o){if(!t)return;let s=t;for(const c of o)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===c){s=v.children[1],l=!0;break}if(!l)return}else{const l=c;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=C;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=E;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const o=Object.create(null);for(const s of t.children){const c=s.children[1];c&&(o[s.children[0].value]=r(c))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function d(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=d;function f(t,o,s=!1){if(d(t,o,s)){const c=t.children;if(Array.isArray(c))for(let l=0;l<c.length&&c[l].offset<=o;l++){const v=f(c[l],o,s);if(v)return v}return t}}e.findNodeAtOffset=f;function g(t,o,s=R.DEFAULT){const c=P(t,!1);function l(ve){return ve?()=>ve(c.getTokenOffset(),c.getTokenLength()):()=>!0}function v(ve){return ve?ue=>ve(ue,c.getTokenOffset(),c.getTokenLength()):()=>!0}const i=l(o.onObjectBegin),n=v(o.onObjectProperty),h=l(o.onObjectEnd),w=l(o.onArrayBegin),b=l(o.onArrayEnd),O=v(o.onLiteralValue),H=v(o.onSeparator),x=l(o.onComment),_=v(o.onError),G=s&&s.disallowComments,M=s&&s.allowTrailingComma;function B(){for(;;){const ve=c.scan();switch(c.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:G||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ve){case 12:case 13:G?U(10):x();break;case 16:U(1);break;case 15:case 14:break;default:return ve}}}function U(ve,ue=[],le=[]){if(_(ve),ue.length+le.length>0){let q=c.getToken();for(;q!==17;){if(ue.indexOf(q)!==-1){B();break}else if(le.indexOf(q)!==-1)break;q=B()}}}function j(ve){const ue=c.getTokenValue();return ve?O(ue):n(ue),B(),!0}function he(){switch(c.getToken()){case 11:{let ve=0;try{ve=JSON.parse(c.getTokenValue()),typeof ve!="number"&&(U(2),ve=0)}catch{U(2)}O(ve);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return B(),!0}function ie(){return c.getToken()!==10?(U(3,[],[2,5]),!1):(j(!1),c.getToken()===6?(H(":"),B(),re()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){i(),B();let ve=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ve||U(4,[],[]),H(","),B(),c.getToken()===2&&M)break}else ve&&U(6,[],[]);ie()||U(4,[],[2,5]),ve=!0}return h(),c.getToken()!==2?U(7,[2],[]):B(),!0}function J(){w(),B();let ve=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ve||U(4,[],[]),H(","),B(),c.getToken()===4&&M)break}else ve&&U(6,[],[]);re()||U(4,[],[4,5]),ve=!0}return b(),c.getToken()!==4?U(8,[4],[]):B(),!0}function re(){switch(c.getToken()){case 3:return J();case 1:return V();case 10:return j(!0);default:return he()}}return B(),c.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):re()?(c.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=g;function D(t,o){const s=P(t),c=[];let l,v=0,i;do switch(i=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:v!==i&&c.push(t.substring(v,i)),o!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,o)),v=s.getPosition();break}while(l!==17);return c.join("")}e.stripComments=D;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ce[65],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(Ce[6],Ie([1,0,63,64]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let R=null;function P(v){R=v}if(e.setDisposableTracker=P,u){const v="__is_disposable_tracked__";P(new class{trackDisposable(i){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[v]||console.log(n)},3e3)}setParent(i,n){if(i&&i!==f.None)try{i[v]=!0}catch{}}markAsDisposed(i){if(i&&i!==f.None)try{i[v]=!0}catch{}}markAsSingleton(i){}})}function T(v){return R?.trackDisposable(v),v}function y(v){R?.markAsDisposed(v)}function m(v,i){R?.setParent(v,i)}function L(v,i){if(!!R)for(const n of v)R.setParent(n,i)}function I(v){return R?.markAsSingleton(v),v}e.markAsSingleton=I;function S(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=S;function k(v){if(A.Iterable.is(v)){const i=[];for(const n of v)if(n)try{n.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}e.dispose=k;function C(v){for(const i of v)S(i)&&i.dispose();return[]}e.disposeIfDisposable=C;function E(...v){const i=r(()=>k(v));return L(v,i),i}e.combinedDisposable=E;function r(v){const i=T({dispose:(0,a.once)(()=>{y(i),v()})});return i}e.toDisposable=r;class d{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{k(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return m(i,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class f{constructor(){this.B=new d,T(this),m(this.B,this)}dispose(){y(this),this.B.dispose()}D(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(i)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class g{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&m(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&m(i,null),i}}e.MutableDisposable=g;class D{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(i){let n=i;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,y(this))},this}}e.SafeDisposable=p;class t{constructor(){this.a=new Map}acquire(i,...n){let h=this.a.get(i);h||(h={counter:0,object:this.b(i,...n)},this.a.set(i,h));const{object:w}=h,b=(0,a.once)(()=>{--h.counter===0&&(this.c(i,h.object),this.a.delete(i))});return h.counter++,{object:w,dispose:b}}}e.ReferenceCollection=t;class o{constructor(i){this.a=i}async acquire(i,...n){const h=this.a.acquire(i,...n);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(w){throw h.dispose(),w}}}e.AsyncReferenceCollection=o;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function c(v){const i=new d;try{v(i)}finally{i.dispose()}}e.disposeOnReturn=c;class l{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,n,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(i)?.dispose(),this.a.set(i,n)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(Ce[66],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class A{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const P=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=P}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,P){const T=new a(R);if(this.a===a.Undefined)this.a=T,this.b=T;else if(P){const m=this.b;this.b=T,T.prev=m,m.next=T}else{const m=this.a;this.a=T,T.next=m,m.prev=T}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(Ce[28],Ie([1,0]),function(se,e){"use strict";var a,A,u;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,r,d){let f=E.get(r);return f===void 0&&(f=d,E.set(r,f)),f}e.getOrSet=R;function P(E){const r=[];return E.forEach((d,f)=>{r.push(`${f} => ${d}`)}),`Map(${E.size}) {${r.join(", ")}}`}e.mapToString=P;function T(E){const r=[];return E.forEach(d=>{r.push(d)}),`Set(${E.size}) {${r.join(", ")}}`}e.setToString=T;class y{constructor(r,d){this.uri=r,this.value=d}}class m{constructor(r,d){this[a]="ResourceMap",r instanceof m?(this.b=new Map(r.b),this.c=d??m.a):(this.b=new Map,this.c=r??m.a)}set(r,d){return this.b.set(this.c(r),new y(r,d)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,d){typeof d<"u"&&(r=r.bind(d));for(const[f,g]of this.b)r(g.value,g.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}m.a=E=>E.toString(),e.ResourceMap=m;class L{constructor(r,d){this[A]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m(d),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,d){this.a.forEach((f,g)=>r.call(d,g,g,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var I;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class S{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,d=0){const f=this.a.get(r);if(!!f)return d!==0&&this.j(f,d),f.value}set(r,d,f=0){let g=this.a.get(r);if(g)g.value=d,f!==0&&this.j(g,f);else{switch(g={key:r,value:d,next:void 0,previous:void 0},f){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(r,g),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const d=this.a.get(r);if(!!d)return this.a.delete(r),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,d){const f=this.e;let g=this.b;for(;g;){if(d?r.bind(d)(g.value,g.key,this):r(g.value,g.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,d=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:f.key,done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return g}values(){const r=this,d=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:f.value,done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return g}entries(){const r=this,d=this.e;let f=this.b;const g={[Symbol.iterator](){return g},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:[f.key,f.value],done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return g}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>r;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const d=r.next,f=r.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}r.next=void 0,r.previous=void 0,this.e++}j(r,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(r===this.b)return;const f=r.next,g=r.previous;r===this.c?(g.next=void 0,this.c=g):(f.previous=g,g.next=f),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(d===2){if(r===this.c)return;const f=r.next,g=r.previous;r===this.b?(f.previous=void 0,this.b=f):(f.previous=g,g.next=f),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((d,f)=>{r.push([f,d])}),r}fromJSON(r){this.clear();for(const[d,f]of r)this.set(d,f)}}e.LinkedMap=S;class k extends S{constructor(r,d=1){super(),this.k=r,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,d=2){return super.get(r,d)}peek(r){return super.get(r,0)}set(r,d){return super.set(r,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=k;class C{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let d=this.a.get(r)||0;return d===0?!1:(d--,d===0?this.a.delete(r):this.a.set(r,d),!0)}has(r){return this.a.has(r)}}e.CounterSet=C}),function(se,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[148],Ie([0]),e):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(te,ne){for(var de=0;de<ne.length;de++){var ee=ne[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(te,ee.key,ee)}}function a(te,ne,de){return ne&&e(te.prototype,ne),de&&e(te,de),Object.defineProperty(te,"prototype",{writable:!1}),te}function A(te,ne){if(!!te){if(typeof te=="string")return u(te,ne);var de=Object.prototype.toString.call(te).slice(8,-1);if(de==="Object"&&te.constructor&&(de=te.constructor.name),de==="Map"||de==="Set")return Array.from(te);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return u(te,ne)}}function u(te,ne){(ne==null||ne>te.length)&&(ne=te.length);for(var de=0,ee=new Array(ne);de<ne;de++)ee[de]=te[de];return ee}function R(te,ne){var de=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(de)return(de=de.call(te)).next.bind(de);if(Array.isArray(te)||(de=A(te))||ne&&te&&typeof te.length=="number"){de&&(te=de);var ee=0;return function(){return ee>=te.length?{done:!0}:{done:!1,value:te[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=P();function T(te){se.defaults=te}var y=/[&<>"']/,m=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ne){return S[ne]};function C(te,ne){if(ne){if(y.test(te))return te.replace(m,k)}else if(L.test(te))return te.replace(I,k);return te}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(te){return te.replace(E,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function f(te,ne){te=typeof te=="string"?te:te.source,ne=ne||"";var de={replace:function(ce,ae){return ae=ae.source||ae,ae=ae.replace(d,"$1"),te=te.replace(ce,ae),de},getRegex:function(){return new RegExp(te,ne)}};return de}var g=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(te,ne,de){if(te){var ee;try{ee=decodeURIComponent(r(de)).replace(g,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ne&&!D.test(de)&&(de=l(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(te,ne){t[" "+te]||(o.test(te)?t[" "+te]=te+"/":t[" "+te]=h(te,"/",!0)),te=t[" "+te];var de=te.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:te.replace(s,"$1")+ne:ne.charAt(0)==="/"?de?ne:te.replace(c,"$1")+ne:te+ne}var v={exec:function(){}};function i(te){for(var ne=1,de,ee;ne<arguments.length;ne++){de=arguments[ne];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(te[ee]=de[ee])}return te}function n(te,ne){var de=te.replace(/\|/g,function(ae,N,z){for(var K=!1,Z=N;--Z>=0&&z[Z]==="\\";)K=!K;return K?"|":" |"}),ee=de.split(/ \|/),ce=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ne)ee.splice(ne);else for(;ee.length<ne;)ee.push("");for(;ce<ee.length;ce++)ee[ce]=ee[ce].trim().replace(/\\\|/g,"|");return ee}function h(te,ne,de){var ee=te.length;if(ee===0)return"";for(var ce=0;ce<ee;){var ae=te.charAt(ee-ce-1);if(ae===ne&&!de)ce++;else if(ae!==ne&&de)ce++;else break}return te.slice(0,ee-ce)}function w(te,ne){if(te.indexOf(ne[1])===-1)return-1;for(var de=te.length,ee=0,ce=0;ce<de;ce++)if(te[ce]==="\\")ce++;else if(te[ce]===ne[0])ee++;else if(te[ce]===ne[1]&&(ee--,ee<0))return ce;return-1}function b(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(te,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=te),ne>>=1,te+=te;return de+te}function H(te,ne,de,ee){var ce=ne.href,ae=ne.title?C(ne.title):null,N=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){ee.state.inLink=!0;var z={type:"link",raw:de,href:ce,title:ae,text:N,tokens:ee.inlineTokens(N)};return ee.state.inLink=!1,z}return{type:"image",raw:de,href:ce,title:ae,text:C(N)}}function x(te,ne){var de=te.match(/^(\s+)(?:```)/);if(de===null)return ne;var ee=de[1];return ne.split(`
`).map(function(ce){var ae=ce.match(/^\s+/);if(ae===null)return ce;var N=ae[0];return N.length>=ee.length?ce.slice(ee.length):ce}).join(`
`)}var _=function(){function te(de){this.options=de||se.defaults}var ne=te.prototype;return ne.space=function(ee){var ce=this.rules.block.newline.exec(ee);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(ee){var ce=this.rules.block.code.exec(ee);if(ce){var ae=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:h(ae,`
`)}}},ne.fences=function(ee){var ce=this.rules.block.fences.exec(ee);if(ce){var ae=ce[0],N=x(ae,ce[3]||"");return{type:"code",raw:ae,lang:ce[2]?ce[2].trim():ce[2],text:N}}},ne.heading=function(ee){var ce=this.rules.block.heading.exec(ee);if(ce){var ae=ce[2].trim();if(/#$/.test(ae)){var N=h(ae,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ae=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ae,tokens:this.lexer.inline(ae)}}},ne.hr=function(ee){var ce=this.rules.block.hr.exec(ee);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(ee){var ce=this.rules.block.blockquote.exec(ee);if(ce){var ae=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ae,[]),text:ae}}},ne.list=function(ee){var ce=this.rules.block.list.exec(ee);if(ce){var ae,N,z,K,Z,fe,Se,Ae,we,Pe,ke,ze,qe=ce[1].trim(),tt=qe.length>1,Qe={type:"list",raw:"",ordered:tt,start:tt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=tt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=tt?qe:"[*+-]");for(var it=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(ze=!1,!(!(ce=it.exec(ee))||this.rules.block.hr.test(ee)));){if(ae=ce[0],ee=ee.substring(ae.length),Ae=ce[2].split(`
`,1)[0],we=ee.split(`
`,1)[0],this.options.pedantic?(K=2,ke=Ae.trimLeft()):(K=ce[2].search(/[^ ]/),K=K>4?1:K,ke=Ae.slice(K),K+=ce[1].length),fe=!1,!Ae&&/^ *$/.test(we)&&(ae+=we+`
`,ee=ee.substring(we.length+1),ze=!0),!ze)for(var rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),$=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(Pe=ee.split(`
`,1)[0],Ae=Pe,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Ae)||$.test(Ae)||rt.test(Ae)||Be.test(ee)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())ke+=`
`+Ae.slice(K);else if(!fe)ke+=`
`+Ae;else break;!fe&&!Ae.trim()&&(fe=!0),ae+=Pe+`
`,ee=ee.substring(Pe.length+1)}Qe.loose||(Se?Qe.loose=!0:/\n *\n *$/.test(ae)&&(Se=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&(z=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ae,task:!!N,checked:z,loose:!1,text:ke}),Qe.raw+=ae}Qe.items[Qe.items.length-1].raw=ae.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var Y=Qe.items.length;for(Z=0;Z<Y;Z++){this.lexer.state.top=!1,Qe.items[Z].tokens=this.lexer.blockTokens(Qe.items[Z].text,[]);var ge=Qe.items[Z].tokens.filter(function(Ne){return Ne.type==="space"}),Le=ge.every(function(Ne){for(var je=Ne.raw.split(""),Ye=0,Xe=R(je),nt;!(nt=Xe()).done;){var ot=nt.value;if(ot===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Qe.loose&&ge.length&&Le&&(Qe.loose=!0,Qe.items[Z].loose=!0)}return Qe}},ne.html=function(ee){var ce=this.rules.block.html.exec(ee);if(ce){var ae={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]);ae.type="paragraph",ae.text=N,ae.tokens=this.lexer.inline(N)}return ae}},ne.def=function(ee){var ce=this.rules.block.def.exec(ee);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ae=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ae,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(ee){var ce=this.rules.block.table.exec(ee);if(ce){var ae={type:"table",header:n(ce[1]).map(function(Se){return{text:Se}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=ce[0];var N=ae.align.length,z,K,Z,fe;for(z=0;z<N;z++)/^ *-+: *$/.test(ae.align[z])?ae.align[z]="right":/^ *:-+: *$/.test(ae.align[z])?ae.align[z]="center":/^ *:-+ *$/.test(ae.align[z])?ae.align[z]="left":ae.align[z]=null;for(N=ae.rows.length,z=0;z<N;z++)ae.rows[z]=n(ae.rows[z],ae.header.length).map(function(Se){return{text:Se}});for(N=ae.header.length,K=0;K<N;K++)ae.header[K].tokens=this.lexer.inline(ae.header[K].text);for(N=ae.rows.length,K=0;K<N;K++)for(fe=ae.rows[K],Z=0;Z<fe.length;Z++)fe[Z].tokens=this.lexer.inline(fe[Z].text);return ae}}},ne.lheading=function(ee){var ce=this.rules.block.lheading.exec(ee);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(ee){var ce=this.rules.block.paragraph.exec(ee);if(ce){var ae=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ae,tokens:this.lexer.inline(ae)}}},ne.text=function(ee){var ce=this.rules.block.text.exec(ee);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(ee){var ce=this.rules.inline.escape.exec(ee);if(ce)return{type:"escape",raw:ce[0],text:C(ce[1])}},ne.tag=function(ee){var ce=this.rules.inline.tag.exec(ee);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]):ce[0]}},ne.link=function(ee){var ce=this.rules.inline.link.exec(ee);if(ce){var ae=ce[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var N=h(ae.slice(0,-1),"\\");if((ae.length-N.length)%2===0)return}else{var z=w(ce[2],"()");if(z>-1){var K=ce[0].indexOf("!")===0?5:4,Z=K+ce[1].length+z;ce[2]=ce[2].substring(0,z),ce[0]=ce[0].substring(0,Z).trim(),ce[3]=""}}var fe=ce[2],Se="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);Ae&&(fe=Ae[1],Se=Ae[3])}else Se=ce[3]?ce[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(ae)?fe=fe.slice(1):fe=fe.slice(1,-1)),H(ce,{href:fe&&fe.replace(this.rules.inline._escapes,"$1"),title:Se&&Se.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(ee,ce){var ae;if((ae=this.rules.inline.reflink.exec(ee))||(ae=this.rules.inline.nolink.exec(ee))){var N=(ae[2]||ae[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var z=ae[0].charAt(0);return{type:"text",raw:z,text:z}}return H(ae,N,ae[0],this.lexer)}},ne.emStrong=function(ee,ce,ae){ae===void 0&&(ae="");var N=this.rules.inline.emStrong.lDelim.exec(ee);if(!!N&&!(N[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=N[1]||N[2]||"";if(!z||z&&(ae===""||this.rules.inline.punctuation.exec(ae))){var K=N[0].length-1,Z,fe,Se=K,Ae=0,we=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(we.lastIndex=0,ce=ce.slice(-1*ee.length+K);(N=we.exec(ce))!=null;)if(Z=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Z){if(fe=Z.length,N[3]||N[4]){Se+=fe;continue}else if((N[5]||N[6])&&K%3&&!((K+fe)%3)){Ae+=fe;continue}if(Se-=fe,!(Se>0)){if(fe=Math.min(fe,fe+Se+Ae),Math.min(K,fe)%2){var Pe=ee.slice(1,K+N.index+fe);return{type:"em",raw:ee.slice(0,K+N.index+fe+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var ke=ee.slice(2,K+N.index+fe-1);return{type:"strong",raw:ee.slice(0,K+N.index+fe+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ne.codespan=function(ee){var ce=this.rules.inline.code.exec(ee);if(ce){var ae=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ae),z=/^ /.test(ae)&&/ $/.test(ae);return N&&z&&(ae=ae.substring(1,ae.length-1)),ae=C(ae,!0),{type:"codespan",raw:ce[0],text:ae}}},ne.br=function(ee){var ce=this.rules.inline.br.exec(ee);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(ee){var ce=this.rules.inline.del.exec(ee);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(ee,ce){var ae=this.rules.inline.autolink.exec(ee);if(ae){var N,z;return ae[2]==="@"?(N=C(this.options.mangle?ce(ae[1]):ae[1]),z="mailto:"+N):(N=C(ae[1]),z=N),{type:"link",raw:ae[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},ne.url=function(ee,ce){var ae;if(ae=this.rules.inline.url.exec(ee)){var N,z;if(ae[2]==="@")N=C(this.options.mangle?ce(ae[0]):ae[0]),z="mailto:"+N;else{var K;do K=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(K!==ae[0]);N=C(ae[0]),ae[1]==="www."?z="http://"+N:z=N}return{type:"link",raw:ae[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},ne.inlineText=function(ee,ce){var ae=this.rules.inline.text.exec(ee);if(ae){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]):ae[0]:N=C(this.options.smartypants?ce(ae[0]):ae[0]),{type:"text",raw:ae[0],text:N}}},te}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=f(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=f(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=f(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=f(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=f(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=i({},G),G.gfm=i({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=f(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=i({},G.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:f(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=f(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=f(G._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=f(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=f(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=f(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=f(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=f(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=f(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=f(M.reflink).replace("label",M._label).replace("ref",G._label).getRegex(),M.nolink=f(M.nolink).replace("ref",G._label).getRegex(),M.reflinkSearch=f(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=i({},M),M.pedantic=i({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=i({},M.normal,{escape:f(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=f(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=i({},M.gfm,{br:f(M.br).replace("{2,}","*").getRegex(),text:f(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(te){var ne="",de,ee,ce=te.length;for(de=0;de<ce;de++)ee=te.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ne+="&#"+ee+";";return ne}var j=function(){function te(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||se.defaults,this.options.tokenizer=this.options.tokenizer||new _,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:G.normal,inline:M.normal};this.options.pedantic?(ee.block=G.pedantic,ee.inline=M.pedantic):this.options.gfm&&(ee.block=G.gfm,this.options.breaks?ee.inline=M.breaks:ee.inline=M.gfm),this.tokenizer.rules=ee}te.lex=function(ee,ce){var ae=new te(ce);return ae.lex(ee)},te.lexInline=function(ee,ce){var ae=new te(ce);return ae.inlineTokens(ee)};var ne=te.prototype;return ne.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(Se,Ae,we){return Ae+"    ".repeat(we.length)});for(var N,z,K,Z;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Se){return(N=Se.call({lexer:ae},ee,ce))?(ee=ee.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(ee)){ee=ee.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(ee)){ee=ee.substring(N.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(N);continue}if(N=this.tokenizer.fences(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(ee)){ee=ee.substring(N.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var Se=1/0,Ae=ee.slice(1),we=void 0;ae.options.extensions.startBlock.forEach(function(Pe){we=Pe.call({lexer:this},Ae),typeof we=="number"&&we>=0&&(Se=Math.min(Se,we))}),Se<1/0&&Se>=0&&(K=ee.substring(0,Se+1))}(),this.state.top&&(N=this.tokenizer.paragraph(K))){z=ce[ce.length-1],Z&&z.type==="paragraph"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(N),Z=K.length!==ee.length,ee=ee.substring(N.raw.length);continue}if(N=this.tokenizer.text(ee)){ee=ee.substring(N.raw.length),z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(N);continue}if(ee){var fe="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return this.state.top=!0,ce},ne.inline=function(ee,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ee,tokens:ce}),ce},ne.inlineTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]);var N,z,K,Z=ee,fe,Se,Ae;if(this.tokens.links){var we=Object.keys(this.tokens.links);if(we.length>0)for(;(fe=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)we.includes(fe[0].slice(fe[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(fe=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(fe=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,fe.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(Se||(Ae=""),Se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ae},ee,ce))?(ee=ee.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(ee)){ee=ee.substring(N.raw.length),z=ce[ce.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(N.raw.length),z=ce[ce.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(ee,Z,Ae)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(ee,U)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(ee,U))){ee=ee.substring(N.raw.length),ce.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,ze=ee.slice(1),qe=void 0;ae.options.extensions.startInline.forEach(function(tt){qe=tt.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(ke=Math.min(ke,qe))}),ke<1/0&&ke>=0&&(K=ee.substring(0,ke+1))}(),N=this.tokenizer.inlineText(K,B)){ee=ee.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),Se=!0,z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):ce.push(N);continue}if(ee){var Pe="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return ce},a(te,null,[{key:"rules",get:function(){return{block:G,inline:M}}}]),te}(),he=function(){function te(de){this.options=de||se.defaults}var ne=te.prototype;return ne.code=function(ee,ce,ae){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(ee,N);z!=null&&z!==ee&&(ae=!0,ee=z)}return ee=ee.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+C(N,!0)+'">'+(ae?ee:C(ee,!0))+`</code></pre>
`:"<pre><code>"+(ae?ee:C(ee,!0))+`</code></pre>
`},ne.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ne.html=function(ee){return ee},ne.heading=function(ee,ce,ae,N){if(this.options.headerIds){var z=this.options.headerPrefix+N.slug(ae);return"<h"+ce+' id="'+z+'">'+ee+"</h"+ce+`>
`}return"<h"+ce+">"+ee+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(ee,ce,ae){var N=ce?"ol":"ul",z=ce&&ae!==1?' start="'+ae+'"':"";return"<"+N+z+`>
`+ee+"</"+N+`>
`},ne.listitem=function(ee){return"<li>"+ee+`</li>
`},ne.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(ee){return"<p>"+ee+`</p>
`},ne.table=function(ee,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ce+`</table>
`},ne.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ne.tablecell=function(ee,ce){var ae=ce.header?"th":"td",N=ce.align?"<"+ae+' align="'+ce.align+'">':"<"+ae+">";return N+ee+("</"+ae+`>
`)},ne.strong=function(ee){return"<strong>"+ee+"</strong>"},ne.em=function(ee){return"<em>"+ee+"</em>"},ne.codespan=function(ee){return"<code>"+ee+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(ee){return"<del>"+ee+"</del>"},ne.link=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var N='<a href="'+C(ee)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ae+"</a>",N},ne.image=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var N='<img src="'+ee+'" alt="'+ae+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},ne.text=function(ee){return ee},te}(),ie=function(){function te(){}var ne=te.prototype;return ne.strong=function(ee){return ee},ne.em=function(ee){return ee},ne.codespan=function(ee){return ee},ne.del=function(ee){return ee},ne.html=function(ee){return ee},ne.text=function(ee){return ee},ne.link=function(ee,ce,ae){return""+ae},ne.image=function(ee,ce,ae){return""+ae},ne.br=function(){return""},te}(),V=function(){function te(){this.seen={}}var ne=te.prototype;return ne.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(ee,ce){var ae=ee,N=0;if(this.seen.hasOwnProperty(ae)){N=this.seen[ee];do N++,ae=ee+"-"+N;while(this.seen.hasOwnProperty(ae))}return ce||(this.seen[ee]=N,this.seen[ae]=0),ae},ne.slug=function(ee,ce){ce===void 0&&(ce={});var ae=this.serialize(ee);return this.getNextSafeSlug(ae,ce.dryrun)},te}(),J=function(){function te(de){this.options=de||se.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new V}te.parse=function(ee,ce){var ae=new te(ce);return ae.parse(ee)},te.parseInline=function(ee,ce){var ae=new te(ce);return ae.parseInline(ee)};var ne=te.prototype;return ne.parse=function(ee,ce){ce===void 0&&(ce=!0);var ae="",N,z,K,Z,fe,Se,Ae,we,Pe,ke,ze,qe,tt,Qe,it,rt,Be,et,$,Y=ee.length;for(N=0;N<Y;N++){if(ke=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&($=this.options.extensions.renderers[ke.type].call({parser:this},ke),$!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ae+=$||"";continue}switch(ke.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,r(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(we="",Ae="",Z=ke.header.length,z=0;z<Z;z++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[z].tokens),{header:!0,align:ke.align[z]});for(we+=this.renderer.tablerow(Ae),Pe="",Z=ke.rows.length,z=0;z<Z;z++){for(Se=ke.rows[z],Ae="",fe=Se.length,K=0;K<fe;K++)Ae+=this.renderer.tablecell(this.parseInline(Se[K].tokens),{header:!1,align:ke.align[K]});Pe+=this.renderer.tablerow(Ae)}ae+=this.renderer.table(we,Pe);continue}case"blockquote":{Pe=this.parse(ke.tokens),ae+=this.renderer.blockquote(Pe);continue}case"list":{for(ze=ke.ordered,qe=ke.start,tt=ke.loose,Z=ke.items.length,Pe="",z=0;z<Z;z++)it=ke.items[z],rt=it.checked,Be=it.task,Qe="",it.task&&(et=this.renderer.checkbox(rt),tt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=et+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=et+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:et}):Qe+=et),Qe+=this.parse(it.tokens,tt),Pe+=this.renderer.listitem(Qe,Be,rt);ae+=this.renderer.list(Pe,ze,qe);continue}case"html":{ae+=this.renderer.html(ke.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Pe=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<Y&&ee[N+1].type==="text";)ke=ee[++N],Pe+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ae+=ce?this.renderer.paragraph(Pe):Pe;continue}default:{var ge='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return ae},ne.parseInline=function(ee,ce){ce=ce||this.renderer;var ae="",N,z,K,Z=ee.length;for(N=0;N<Z;N++){if(z=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(K=this.options.extensions.renderers[z.type].call({parser:this},z),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){ae+=K||"";continue}switch(z.type){case"escape":{ae+=ce.text(z.text);break}case"html":{ae+=ce.html(z.text);break}case"link":{ae+=ce.link(z.href,z.title,this.parseInline(z.tokens,ce));break}case"image":{ae+=ce.image(z.href,z.title,z.text);break}case"strong":{ae+=ce.strong(this.parseInline(z.tokens,ce));break}case"em":{ae+=ce.em(this.parseInline(z.tokens,ce));break}case"codespan":{ae+=ce.codespan(z.text);break}case"br":{ae+=ce.br();break}case"del":{ae+=ce.del(this.parseInline(z.tokens,ce));break}case"text":{ae+=ce.text(z.text);break}default:{var fe='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return ae},te}();function re(te,ne,de){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=i({},re.defaults,ne||{}),b(ne),de){var ee=ne.highlight,ce;try{ce=j.lex(te,ne)}catch(Z){return de(Z)}var ae=function(fe){var Se;if(!fe)try{ne.walkTokens&&re.walkTokens(ce,ne.walkTokens),Se=J.parse(ce,ne)}catch(Ae){fe=Ae}return ne.highlight=ee,fe?de(fe):de(null,Se)};if(!ee||ee.length<3||(delete ne.highlight,!ce.length))return ae();var N=0;re.walkTokens(ce,function(Z){Z.type==="code"&&(N++,setTimeout(function(){ee(Z.text,Z.lang,function(fe,Se){if(fe)return ae(fe);Se!=null&&Se!==Z.text&&(Z.text=Se,Z.escaped=!0),N--,N===0&&ae()})},0))}),N===0&&ae();return}function z(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(Z.message+"",!0)+"</pre>";throw Z}try{var K=j.lex(te,ne);if(ne.walkTokens){if(ne.async)return Promise.all(re.walkTokens(K,ne.walkTokens)).then(function(){return J.parse(K,ne)}).catch(z);re.walkTokens(K,ne.walkTokens)}return J.parse(K,ne)}catch(Z){z(Z)}}re.options=re.setOptions=function(te){return i(re.defaults,te),T(re.defaults),re},re.getDefaults=P,re.defaults=se.defaults,re.use=function(){for(var te=arguments.length,ne=new Array(te),de=0;de<te;de++)ne[de]=arguments[de];var ee=i.apply(void 0,[{}].concat(ne)),ce=re.defaults.extensions||{renderers:{},childTokens:{}},ae;ne.forEach(function(N){if(N.extensions&&(ae=!0,N.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Z=ce.renderers?ce.renderers[K.name]:null;Z?ce.renderers[K.name]=function(){for(var fe=arguments.length,Se=new Array(fe),Ae=0;Ae<fe;Ae++)Se[Ae]=arguments[Ae];var we=K.renderer.apply(this,Se);return we===!1&&(we=Z.apply(this,Se)),we}:ce.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[K.level]?ce[K.level].unshift(K.tokenizer):ce[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ce.startBlock?ce.startBlock.push(K.start):ce.startBlock=[K.start]:K.level==="inline"&&(ce.startInline?ce.startInline.push(K.start):ce.startInline=[K.start]))}K.childTokens&&(ce.childTokens[K.name]=K.childTokens)})),N.renderer&&function(){var K=re.defaults.renderer||new he,Z=function(Ae){var we=K[Ae];K[Ae]=function(){for(var Pe=arguments.length,ke=new Array(Pe),ze=0;ze<Pe;ze++)ke[ze]=arguments[ze];var qe=N.renderer[Ae].apply(K,ke);return qe===!1&&(qe=we.apply(K,ke)),qe}};for(var fe in N.renderer)Z(fe);ee.renderer=K}(),N.tokenizer&&function(){var K=re.defaults.tokenizer||new _,Z=function(Ae){var we=K[Ae];K[Ae]=function(){for(var Pe=arguments.length,ke=new Array(Pe),ze=0;ze<Pe;ze++)ke[ze]=arguments[ze];var qe=N.tokenizer[Ae].apply(K,ke);return qe===!1&&(qe=we.apply(K,ke)),qe}};for(var fe in N.tokenizer)Z(fe);ee.tokenizer=K}(),N.walkTokens){var z=re.defaults.walkTokens;ee.walkTokens=function(K){var Z=[];return Z.push(N.walkTokens.call(this,K)),z&&(Z=Z.concat(z.call(this,K))),Z}}ae&&(ee.extensions=ce),re.setOptions(ee)})},re.walkTokens=function(te,ne){for(var de=[],ee=function(){var z=ae.value;switch(de=de.concat(ne.call(re,z)),z.type){case"table":{for(var K=R(z.header),Z;!(Z=K()).done;){var fe=Z.value;de=de.concat(re.walkTokens(fe.tokens,ne))}for(var Se=R(z.rows),Ae;!(Ae=Se()).done;)for(var we=Ae.value,Pe=R(we),ke;!(ke=Pe()).done;){var ze=ke.value;de=de.concat(re.walkTokens(ze.tokens,ne))}break}case"list":{de=de.concat(re.walkTokens(z.items,ne));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[z.type]?re.defaults.extensions.childTokens[z.type].forEach(function(qe){de=de.concat(re.walkTokens(z[qe],ne))}):z.tokens&&(de=de.concat(re.walkTokens(z.tokens,ne)))}},ce=R(te),ae;!(ae=ce()).done;)ee();return de},re.parseInline=function(te,ne){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ne=i({},re.defaults,ne||{}),b(ne);try{var de=j.lexInline(te,ne);return ne.walkTokens&&re.walkTokens(de,ne.walkTokens),J.parseInline(de,ne)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(ee.message+"",!0)+"</pre>";throw ee}},re.Parser=J,re.parser=J.parse,re.Renderer=he,re.TextRenderer=ie,re.Lexer=j,re.lexer=j.lex,re.Tokenizer=_,re.Slugger=V,re.parse=re;var ve=re.options,ue=re.setOptions,le=re.use,q=re.walkTokens,F=re.parseInline,Q=re,me=J.parse,Ee=j.lex;se.Lexer=j,se.Parser=J,se.Renderer=he,se.Slugger=V,se.TextRenderer=ie,se.Tokenizer=_,se.getDefaults=P,se.lexer=Ee,se.marked=re,se.options=ve,se.parse=Q,se.parseInline=F,se.parser=me,se.setOptions=ue,se.use=le,se.walkTokens=q,Object.defineProperty(se,"__esModule",{value:!0})}),define(Ce[87],Ie([1,0,28]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new a.LRUCache(1e4);function u(m){return y(m,"NFC",A)}e.normalizeNFC=u;const R=new a.LRUCache(1e4);function P(m){return y(m,"NFD",R)}e.normalizeNFD=P;const T=/[^\u0000-\u0080]/;function y(m,L,I){if(!m)return m;const S=I.get(m);if(S)return S;let k;return T.test(m)?k=m.normalize(L):k=m,I.set(m,k),k}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(L){return P(L).replace(m,"")}}()}),define(Ce[103],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,y,m){return Math.min(Math.max(T,y),m)}e.clamp=a;function A(T,y){return(y+T%y)%y}e.rot=A;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class P{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const m=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=P}),function(){function se(u){const R=[];typeof u=="number"&&R.push("code/timeOrigin",u);function P(y){R.push(y,Date.now())}function T(){const y=[];for(let m=0;m<R.length;m+=2)y.push({name:R[m],startTime:R[m+1]});return y}return{mark:P,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const P of performance.getEntriesByType("mark"))R.push({name:P.name,startTime:Math.round(u+P.startTime)});return R}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function a(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=a(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var A in a)(typeof exports=="object"?exports:se)[A]=a[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function a(A){if(e[A])return e[A].exports;var u=e[A]={i:A,l:!1,exports:{}};return se[A].call(u.exports,u,u.exports,a),u.l=!0,u.exports}return a.m=se,a.c=e,a.d=function(A,u,R){a.o(A,u)||Object.defineProperty(A,u,{enumerable:!0,get:R})},a.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},a.t=function(A,u){if(1&u&&(A=a(A)),8&u||4&u&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&u&&typeof A!="string")for(var P in A)a.d(R,P,function(T){return A[T]}.bind(null,P));return R},a.n=function(A){var u=A&&A.__esModule?function(){return A.default}:function(){return A};return a.d(u,"a",u),u},a.o=function(A,u){return Object.prototype.hasOwnProperty.call(A,u)},a.p="",a(a.s=0)}([function(se,e,a){(function(A){var u;e=se.exports=le,u=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var we=Array.prototype.slice.call(arguments,0);we.unshift("SEMVER"),console.log.apply(console,we)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],y=e.src=[],m=0,L=m++;y[L]="0|[1-9]\\d*";var I=m++;y[I]="[0-9]+";var S=m++;y[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=m++;y[k]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var C=m++;y[C]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var E=m++;y[E]="(?:"+y[L]+"|"+y[S]+")";var r=m++;y[r]="(?:"+y[I]+"|"+y[S]+")";var d=m++;y[d]="(?:-("+y[E]+"(?:\\."+y[E]+")*))";var f=m++;y[f]="(?:-?("+y[r]+"(?:\\."+y[r]+")*))";var g=m++;y[g]="[0-9A-Za-z-]+";var D=m++;y[D]="(?:\\+("+y[g]+"(?:\\."+y[g]+")*))";var p=m++,t="v?"+y[k]+y[d]+"?"+y[D]+"?";y[p]="^"+t+"$";var o="[v=\\s]*"+y[C]+y[f]+"?"+y[D]+"?",s=m++;y[s]="^"+o+"$";var c=m++;y[c]="((?:<|>)?=?)";var l=m++;y[l]=y[I]+"|x|X|\\*";var v=m++;y[v]=y[L]+"|x|X|\\*";var i=m++;y[i]="[v=\\s]*("+y[v]+")(?:\\.("+y[v]+")(?:\\.("+y[v]+")(?:"+y[d]+")?"+y[D]+"?)?)?";var n=m++;y[n]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[f]+")?"+y[D]+"?)?)?";var h=m++;y[h]="^"+y[c]+"\\s*"+y[i]+"$";var w=m++;y[w]="^"+y[c]+"\\s*"+y[n]+"$";var b=m++;y[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=m++;y[O]="(?:~>?)";var H=m++;y[H]="(\\s*)"+y[O]+"\\s+",T[H]=new RegExp(y[H],"g");var x=m++;y[x]="^"+y[O]+y[i]+"$";var _=m++;y[_]="^"+y[O]+y[n]+"$";var G=m++;y[G]="(?:\\^)";var M=m++;y[M]="(\\s*)"+y[G]+"\\s+",T[M]=new RegExp(y[M],"g");var B=m++;y[B]="^"+y[G]+y[i]+"$";var U=m++;y[U]="^"+y[G]+y[n]+"$";var j=m++;y[j]="^"+y[c]+"\\s*("+o+")$|^$";var he=m++;y[he]="^"+y[c]+"\\s*("+t+")$|^$";var ie=m++;y[ie]="(\\s*)"+y[c]+"\\s*("+o+"|"+y[i]+")",T[ie]=new RegExp(y[ie],"g");var V=m++;y[V]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var J=m++;y[J]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var re=m++;y[re]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)u(ve,y[ve]),T[ve]||(T[ve]=new RegExp(y[ve]));function ue(we,Pe){if(we instanceof le)return we;if(typeof we!="string"||we.length>R||!(Pe?T[s]:T[p]).test(we))return null;try{return new le(we,Pe)}catch{return null}}function le(we,Pe){if(we instanceof le){if(we.loose===Pe)return we;we=we.version}else if(typeof we!="string")throw new TypeError("Invalid Version: "+we);if(we.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(we,Pe);u("SemVer",we,Pe),this.loose=Pe;var ke=we.trim().match(Pe?T[s]:T[p]);if(!ke)throw new TypeError("Invalid Version: "+we);if(this.raw=we,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var qe=+ze;if(qe>=0&&qe<P)return qe}return ze}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=ue,e.valid=function(we,Pe){var ke=ue(we,Pe);return ke?ke.version:null},e.clean=function(we,Pe){var ke=ue(we.trim().replace(/^[=v]+/,""),Pe);return ke?ke.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(we){return u("SemVer.compare",this.version,this.loose,we),we instanceof le||(we=new le(we,this.loose)),this.compareMain(we)||this.comparePre(we)},le.prototype.compareMain=function(we){return we instanceof le||(we=new le(we,this.loose)),F(this.major,we.major)||F(this.minor,we.minor)||F(this.patch,we.patch)},le.prototype.comparePre=function(we){if(we instanceof le||(we=new le(we,this.loose)),this.prerelease.length&&!we.prerelease.length)return-1;if(!this.prerelease.length&&we.prerelease.length)return 1;if(!this.prerelease.length&&!we.prerelease.length)return 0;var Pe=0;do{var ke=this.prerelease[Pe],ze=we.prerelease[Pe];if(u("prerelease compare",Pe,ke,ze),ke===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ke===void 0)return-1;if(ke!==ze)return F(ke,ze)}while(++Pe)},le.prototype.inc=function(we,Pe){switch(we){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+we)}return this.format(),this.raw=this.version,this},e.inc=function(we,Pe,ke,ze){typeof ke=="string"&&(ze=ke,ke=void 0);try{return new le(we,ke).inc(Pe,ze).version}catch{return null}},e.diff=function(we,Pe){if(te(we,Pe))return null;var ke=ue(we),ze=ue(Pe);if(ke.prerelease.length||ze.prerelease.length){for(var qe in ke)if((qe==="major"||qe==="minor"||qe==="patch")&&ke[qe]!==ze[qe])return"pre"+qe;return"prerelease"}for(var qe in ke)if((qe==="major"||qe==="minor"||qe==="patch")&&ke[qe]!==ze[qe])return qe},e.compareIdentifiers=F;var q=/^[0-9]+$/;function F(we,Pe){var ke=q.test(we),ze=q.test(Pe);return ke&&ze&&(we=+we,Pe=+Pe),ke&&!ze?-1:ze&&!ke?1:we<Pe?-1:we>Pe?1:0}function Q(we,Pe,ke){return new le(we,ke).compare(new le(Pe,ke))}function me(we,Pe,ke){return Q(we,Pe,ke)>0}function Ee(we,Pe,ke){return Q(we,Pe,ke)<0}function te(we,Pe,ke){return Q(we,Pe,ke)===0}function ne(we,Pe,ke){return Q(we,Pe,ke)!==0}function de(we,Pe,ke){return Q(we,Pe,ke)>=0}function ee(we,Pe,ke){return Q(we,Pe,ke)<=0}function ce(we,Pe,ke,ze){var qe;switch(Pe){case"===":typeof we=="object"&&(we=we.version),typeof ke=="object"&&(ke=ke.version),qe=we===ke;break;case"!==":typeof we=="object"&&(we=we.version),typeof ke=="object"&&(ke=ke.version),qe=we!==ke;break;case"":case"=":case"==":qe=te(we,ke,ze);break;case"!=":qe=ne(we,ke,ze);break;case">":qe=me(we,ke,ze);break;case">=":qe=de(we,ke,ze);break;case"<":qe=Ee(we,ke,ze);break;case"<=":qe=ee(we,ke,ze);break;default:throw new TypeError("Invalid operator: "+Pe)}return qe}function ae(we,Pe){if(we instanceof ae){if(we.loose===Pe)return we;we=we.value}if(!(this instanceof ae))return new ae(we,Pe);u("comparator",we,Pe),this.loose=Pe,this.parse(we),this.semver===N?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(we,Pe){return F(Pe,we)},e.major=function(we,Pe){return new le(we,Pe).major},e.minor=function(we,Pe){return new le(we,Pe).minor},e.patch=function(we,Pe){return new le(we,Pe).patch},e.compare=Q,e.compareLoose=function(we,Pe){return Q(we,Pe,!0)},e.rcompare=function(we,Pe,ke){return Q(Pe,we,ke)},e.sort=function(we,Pe){return we.sort(function(ke,ze){return e.compare(ke,ze,Pe)})},e.rsort=function(we,Pe){return we.sort(function(ke,ze){return e.rcompare(ke,ze,Pe)})},e.gt=me,e.lt=Ee,e.eq=te,e.neq=ne,e.gte=de,e.lte=ee,e.cmp=ce,e.Comparator=ae;var N={};function z(we,Pe){if(we instanceof z)return we.loose===Pe?we:new z(we.raw,Pe);if(we instanceof ae)return new z(we.value,Pe);if(!(this instanceof z))return new z(we,Pe);if(this.loose=Pe,this.raw=we,this.set=we.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+we);this.format()}function K(we){return!we||we.toLowerCase()==="x"||we==="*"}function Z(we,Pe,ke,ze,qe,tt,Qe,it,rt,Be,et,$,Y){return((Pe=K(ke)?"":K(ze)?">="+ke+".0.0":K(qe)?">="+ke+"."+ze+".0":">="+Pe)+" "+(it=K(rt)?"":K(Be)?"<"+(+rt+1)+".0.0":K(et)?"<"+rt+"."+(+Be+1)+".0":$?"<="+rt+"."+Be+"."+et+"-"+$:"<="+it)).trim()}function fe(we,Pe){for(var ke=0;ke<we.length;ke++)if(!we[ke].test(Pe))return!1;if(Pe.prerelease.length){for(ke=0;ke<we.length;ke++)if(u(we[ke].semver),we[ke].semver!==N&&we[ke].semver.prerelease.length>0){var ze=we[ke].semver;if(ze.major===Pe.major&&ze.minor===Pe.minor&&ze.patch===Pe.patch)return!0}return!1}return!0}function Se(we,Pe,ke){try{Pe=new z(Pe,ke)}catch{return!1}return Pe.test(we)}function Ae(we,Pe,ke,ze){var qe,tt,Qe,it,rt;switch(we=new le(we,ze),Pe=new z(Pe,ze),ke){case">":qe=me,tt=ee,Qe=Ee,it=">",rt=">=";break;case"<":qe=Ee,tt=de,Qe=me,it="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(we,Pe,ze))return!1;for(var Be=0;Be<Pe.set.length;++Be){var et=Pe.set[Be],$=null,Y=null;if(et.forEach(function(ge){ge.semver===N&&(ge=new ae(">=0.0.0")),$=$||ge,Y=Y||ge,qe(ge.semver,$.semver,ze)?$=ge:Qe(ge.semver,Y.semver,ze)&&(Y=ge)}),$.operator===it||$.operator===rt||(!Y.operator||Y.operator===it)&&tt(we,Y.semver)||Y.operator===rt&&Qe(we,Y.semver))return!1}return!0}ae.prototype.parse=function(we){var Pe=this.loose?T[j]:T[he],ke=we.match(Pe);if(!ke)throw new TypeError("Invalid comparator: "+we);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new le(ke[2],this.loose):this.semver=N},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(we){return u("Comparator.test",we,this.loose),this.semver===N||(typeof we=="string"&&(we=new le(we,this.loose)),ce(we,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(we,Pe){if(!(we instanceof ae))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new z(we.value,Pe),Se(this.value,ke,Pe);if(we.operator==="")return ke=new z(this.value,Pe),Se(we.semver,ke,Pe);var ze=!(this.operator!==">="&&this.operator!==">"||we.operator!==">="&&we.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||we.operator!=="<="&&we.operator!=="<"),tt=this.semver.version===we.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||we.operator!==">="&&we.operator!=="<="),it=ce(this.semver,"<",we.semver,Pe)&&(this.operator===">="||this.operator===">")&&(we.operator==="<="||we.operator==="<"),rt=ce(this.semver,">",we.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(we.operator===">="||we.operator===">");return ze||qe||tt&&Qe||it||rt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(we){return we.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(we){var Pe=this.loose;we=we.trim(),u("range",we,Pe);var ke=Pe?T[J]:T[V];we=we.replace(ke,Z),u("hyphen replace",we),we=we.replace(T[ie],"$1$2$3"),u("comparator trim",we,T[ie]),we=(we=(we=we.replace(T[H],"$1~")).replace(T[M],"$1^")).split(/\s+/).join(" ");var ze=Pe?T[j]:T[he],qe=we.split(" ").map(function(tt){return function(Qe,it){return u("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function($,Y){u("caret",$,Y);var ge=Y?T[U]:T[B];return $.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("caret",$,Le,Ne,je,Ye,Xe),K(Ne)?nt="":K(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(Ye)?nt=Ne==="0"?">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+".0 <"+(+Ne+1)+".0.0":Xe?(u("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+Xe+" <"+(+Ne+1)+".0.0"):(u("no pr"),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+" <"+(+Ne+1)+".0.0"),u("caret return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function($,Y){var ge=Y?T[_]:T[x];return $.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("tilde",$,Le,Ne,je,Ye,Xe),K(Ne)?nt="":K(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(Ye)?nt=">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":Xe?(u("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0"):nt=">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0",u("tilde return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("tildes",Qe),Qe=function(rt,Be){return u("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(et){return function($,Y){$=$.trim();var ge=Y?T[w]:T[h];return $.replace(ge,function(Le,Ne,je,Ye,Xe,nt){u("xRange",$,Le,Ne,je,Ye,Xe,nt);var ot=K(je),pt=ot||K(Ye),bt=pt||K(Xe);return Ne==="="&&bt&&(Ne=""),ot?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&bt?(pt&&(Ye=0),bt&&(Xe=0),Ne===">"?(Ne=">=",pt?(je=+je+1,Ye=0,Xe=0):bt&&(Ye=+Ye+1,Xe=0)):Ne==="<="&&(Ne="<",pt?je=+je+1:Ye=+Ye+1),Le=Ne+je+"."+Ye+"."+Xe):pt?Le=">="+je+".0.0 <"+(+je+1)+".0.0":bt&&(Le=">="+je+"."+Ye+".0 <"+je+"."+(+Ye+1)+".0"),u("xRange return",Le),Le})}(et,Be)}).join(" ")}(Qe,it),u("xrange",Qe),Qe=function(rt,Be){return u("replaceStars",rt,Be),rt.trim().replace(T[re],"")}(Qe,it),u("stars",Qe),Qe}(tt,Pe)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(tt){return!!tt.match(ze)})),qe=qe.map(function(tt){return new ae(tt,Pe)})},z.prototype.intersects=function(we,Pe){if(!(we instanceof z))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(ze){return we.set.some(function(qe){return qe.every(function(tt){return ze.intersects(tt,Pe)})})})})},e.toComparators=function(we,Pe){return new z(we,Pe).set.map(function(ke){return ke.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},z.prototype.test=function(we){if(!we)return!1;typeof we=="string"&&(we=new le(we,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(fe(this.set[Pe],we))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(we,Pe,ke){var ze=null,qe=null;try{var tt=new z(Pe,ke)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&(ze&&qe.compare(Qe)!==-1||(qe=new le(ze=Qe,ke)))}),ze},e.minSatisfying=function(we,Pe,ke){var ze=null,qe=null;try{var tt=new z(Pe,ke)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&(ze&&qe.compare(Qe)!==1||(qe=new le(ze=Qe,ke)))}),ze},e.validRange=function(we,Pe){try{return new z(we,Pe).range||"*"}catch{return null}},e.ltr=function(we,Pe,ke){return Ae(we,Pe,"<",ke)},e.gtr=function(we,Pe,ke){return Ae(we,Pe,">",ke)},e.outside=Ae,e.prerelease=function(we,Pe){var ke=ue(we,Pe);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(we,Pe,ke){return we=new z(we,ke),Pe=new z(Pe,ke),we.intersects(Pe)},e.coerce=function(we){if(we instanceof le)return we;if(typeof we!="string")return null;var Pe=we.match(T[b]);return Pe==null?null:ue((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,a(1))},function(se,e){var a,A,u=se.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function T(r){if(a===setTimeout)return setTimeout(r,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(r,0);try{return a(r,0)}catch{try{return a.call(null,r,0)}catch{return a.call(this,r,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{A=typeof clearTimeout=="function"?clearTimeout:P}catch{A=P}})();var y,m=[],L=!1,I=-1;function S(){L&&y&&(L=!1,y.length?m=y.concat(m):I=-1,m.length&&k())}function k(){if(!L){var r=T(S);L=!0;for(var d=m.length;d;){for(y=m,m=[];++I<d;)y&&y[I].run();I=-1,d=m.length}y=null,L=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===P||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(r)}}function C(r,d){this.fun=r,this.array=d}function E(){}u.nextTick=function(r){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];m.push(new C(r,d)),m.length!==1||L||T(k)},C.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=E,u.addListener=E,u.once=E,u.off=E,u.removeListener=E,u.removeAllListeners=E,u.emit=E,u.prependListener=E,u.prependOnceListener=E,u.listeners=function(r){return[]},u.binding=function(r){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(r){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(Ce[104],Ie([1,0,10,6]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(D){const p=D;return p?typeof p.read=="function":!1}e.isReadable=u;function R(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function P(D){const p=D;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=P;function T(D,p){return new y(D,p)}e.newWriteableStream=T;class y{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,a.onUnexpectedError)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let o;switch(p){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(D,p){const t=[];let o;for(;(o=D.read())!==null;)t.push(o);return p(t)}e.consumeReadable=m;function L(D,p,t){const o=[];let s;for(;(s=D.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const c=s;return s=void 0,c}return D.read()}}}e.peekReadable=L;function I(D,p){return new Promise((t,o)=>{const s=[];S(D,{onData:c=>{p&&s.push(c)},onError:c=>{p?o(c):t(void 0)},onEnd:()=>{t(p?p(s):void 0)}})})}e.consumeStream=I;function S(D,p){let t=!1;return D.on("error",o=>{t||p.onError(o)}),D.on("end",()=>{t||p.onEnd()}),D.on("data",o=>{t||p.onData(o)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=S;function k(D,p){return new Promise((t,o)=>{const s=new A.DisposableStore,c=[],l=n=>{if(c.push(n),c.length>p)return s.dispose(),D.pause(),t({stream:D,buffer:c,ended:!1})},v=n=>o(n),i=()=>t({stream:D,buffer:c,ended:!0});s.add((0,A.toDisposable)(()=>D.removeListener("error",v))),D.on("error",v),s.add((0,A.toDisposable)(()=>D.removeListener("end",i))),D.on("end",i),s.add((0,A.toDisposable)(()=>D.removeListener("data",l))),D.on("data",l)})}e.peekStream=k;function C(D,p){const t=T(p);return t.end(D),t}e.toStream=C;function E(){const D=T(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=E;function r(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.toReadable=r;function d(D,p,t){const o=T(t);return S(D,{onData:s=>o.write(p.data(s)),onError:s=>o.error(p.error?p.error(s):s),onEnd:()=>o.end()}),o}e.transform=d;function f(D,p,t){let o=!1;return{read:()=>{const s=p.read();return o?s:(o=!0,s!==null?t([D,s]):D)}}}e.prefixedReadable=f;function g(D,p,t){let o=!1;const s=T(t);return S(p,{onData:c=>o?s.write(c):(o=!0,s.write(t([D,c]))),onError:c=>s.error(c),onEnd:()=>{o||(o=!0,s.write(D)),s.end()}}),s}e.prefixedStream=g}),define(Ce[22],Ie([1,0,104]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let u,R;class P{static alloc(n){return A?new P(Buffer.allocUnsafe(n)):new P(new Uint8Array(n))}static wrap(n){return A&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new P(n)}static fromString(n,h){return!(h?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(n)):(u||(u=new TextEncoder),new P(u.encode(n)))}static fromByteArray(n){const h=P.alloc(n.length);for(let w=0,b=n.length;w<b;w++)h.buffer[w]=n[w];return h}static concat(n,h){if(typeof h>"u"){h=0;for(let O=0,H=n.length;O<H;O++)h+=n[O].byteLength}const w=P.alloc(h);let b=0;for(let O=0,H=n.length;O<H;O++){const x=n[O];w.set(x,b),b+=x.byteLength}return w}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=P.alloc(this.byteLength);return n.set(this),n}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,h){return new P(this.buffer.subarray(n,h))}set(n,h){if(n instanceof P)this.buffer.set(n.buffer,h);else if(n instanceof Uint8Array)this.buffer.set(n,h);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),h);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return m(this.buffer,n)}writeUInt32BE(n,h){L(this.buffer,n,h)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,h){S(this.buffer,n,h)}readUInt8(n){return k(this.buffer,n)}writeUInt8(n,h){C(this.buffer,n,h)}}e.VSBuffer=P;function T(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=T;function y(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255}e.writeUInt16LE=y;function m(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=m;function L(i,n,h){i[h+3]=n,n=n>>>8,i[h+2]=n,n=n>>>8,i[h+1]=n,n=n>>>8,i[h]=n}e.writeUInt32BE=L;function I(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=I;function S(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255,n=n>>>8,i[h+2]=n&255,n=n>>>8,i[h+3]=n&255}e.writeUInt32LE=S;function k(i,n){return i[n]}e.readUInt8=k;function C(i,n,h){i[h]=n}e.writeUInt8=C;function E(i){return a.consumeReadable(i,n=>P.concat(n))}e.readableToBuffer=E;function r(i){return a.toReadable(i)}e.bufferToReadable=r;function d(i){return a.consumeStream(i,n=>P.concat(n))}e.streamToBuffer=d;async function f(i){return i.ended?P.concat(i.buffer):P.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=f;function g(i){return a.toStream(i,n=>P.concat(n))}e.bufferToStream=g;function D(i){return a.transform(i,{data:n=>typeof n=="string"?P.fromString(n):P.wrap(n)},n=>P.concat(n))}e.streamToBufferReadableStream=D;function p(i){return a.newWriteableStream(n=>P.concat(n),i)}e.newWriteableBufferStream=p;function t(i,n){return a.prefixedReadable(i,n,h=>P.concat(h))}e.prefixedBufferReadable=t;function o(i,n){return a.prefixedStream(i,n,h=>P.concat(h))}e.prefixedBufferStream=o;function s(i){let n=0,h=0,w=0;const b=new Uint8Array(Math.floor(i.length/4*3)),O=x=>{switch(h){case 3:b[w++]=n|x,h=0;break;case 2:b[w++]=n|x>>>2,n=x<<6,h=3;break;case 1:b[w++]=n|x>>>4,n=x<<4,h=2;break;default:n=x<<2,h=1}};for(let x=0;x<i.length;x++){const _=i.charCodeAt(x);if(_>=65&&_<=90)O(_-65);else if(_>=97&&_<=122)O(_-97+26);else if(_>=48&&_<=57)O(_-48+52);else if(_===43||_===45)O(62);else if(_===47||_===95)O(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${i[x]}`)}}const H=w;for(;h>0;)O(0);return P.wrap(b).slice(0,H)}e.decodeBase64=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:i},n=!0,h=!1){const w=h?l:c;let b="";const O=i.byteLength%3;let H=0;for(;H<i.byteLength-O;H+=3){const x=i[H+0],_=i[H+1],G=i[H+2];b+=w[x>>>2],b+=w[(x<<4|_>>>4)&63],b+=w[(_<<2|G>>>6)&63],b+=w[G&63]}if(O===1){const x=i[H+0];b+=w[x>>>2],b+=w[x<<4&63],n&&(b+="==")}else if(O===2){const x=i[H+0],_=i[H+1];b+=w[x>>>2],b+=w[(x<<4|_>>>4)&63],b+=w[_<<2&63],n&&(b+="=")}return b}e.encodeBase64=v}),define(Ce[149],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[9],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function A(o){return Array.isArray(o)&&o.every(s=>a(s))}e.isStringArray=A;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function y(o){return o===!0||o===!1}e.isBoolean=y;function m(o){return typeof o>"u"}e.isUndefined=m;function L(o){return!I(o)}e.isDefined=L;function I(o){return m(o)||o===null}e.isUndefinedOrNull=I;function S(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function k(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=k;function C(...o){const s=[];for(let c=0;c<o.length;c++){const l=o[c];if(I(l))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);s.push(l)}return s}e.assertAllDefined=C;const E=Object.prototype.hasOwnProperty;function r(o){if(!u(o))return!1;for(const s in o)if(E.call(o,s))return!1;return!0}e.isEmptyObject=r;function d(o){return typeof o=="function"}e.isFunction=d;function f(...o){return o.length>0&&o.every(d)}e.areFunctions=f;function g(o,s){const c=Math.min(o.length,s.length);for(let l=0;l<c;l++)D(o[l],s[l])}e.validateConstraints=g;function D(o,s){if(a(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(d(s)){try{if(o instanceof s)return}catch{}if(!I(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(Ce[67],Ie([1,0,9]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function u(T,y){if((0,a.isString)(y)){const m=A[y];if(m===void 0)throw new Error(`${T} references an unknown codicon: ${y}`);y=m}return A[T]=y,{id:T}}function R(){return A}e.getCodiconFontCharacters=R;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(Ce[23],Ie([1,0,9]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([g,D])=>{f[g]=D&&typeof D=="object"?A(D):D}),f}e.deepClone=A;function u(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const g=f.shift();Object.freeze(g);for(const D in g)if(R.call(g,D)){const p=g[D];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&f.push(p)}}return d}e.deepFreeze=u;const R=Object.prototype.hasOwnProperty;function P(d,f){return T(d,f,new Set)}e.cloneAndChange=P;function T(d,f,g){if((0,a.isUndefinedOrNull)(d))return d;const D=f(d);if(typeof D<"u")return D;if(Array.isArray(d)){const p=[];for(const t of d)p.push(T(t,f,g));return p}if((0,a.isObject)(d)){if(g.has(d))throw new Error("Cannot clone recursive data-structure");g.add(d);const p={};for(const t in d)R.call(d,t)&&(p[t]=T(d[t],f,g));return g.delete(d),p}return d}function y(d,f,g=!0){return(0,a.isObject)(d)?((0,a.isObject)(f)&&Object.keys(f).forEach(D=>{D in d?g&&((0,a.isObject)(d[D])&&(0,a.isObject)(f[D])?y(d[D],f[D],g):d[D]=f[D]):d[D]=f[D]}),d):f}e.mixin=y;function m(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let g,D;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(g=0;g<d.length;g++)if(!m(d[g],f[g]))return!1}else{const p=[];for(D in d)p.push(D);p.sort();const t=[];for(D in f)t.push(D);if(t.sort(),!m(p,t))return!1;for(g=0;g<p.length;g++)if(!m(d[p[g]],f[p[g]]))return!1}return!0}e.equals=m;function L(d){const f=new Set;return JSON.stringify(d,(g,D)=>{if((0,a.isObject)(D)||Array.isArray(D)){if(f.has(D))return"[Circular]";f.add(D)}return D})}e.safeStringify=L;function I(d,f){const g=Object.create(null);return!d||!f||Object.keys(f).forEach(p=>{const t=d[p],o=f[p];m(t,o)||(g[p]=o)}),g}e.distinct=I;function S(d,f){const g=f.toLowerCase(),D=Object.keys(d).find(p=>p.toLowerCase()===g);return D?d[D]:d[f]}e.getCaseInsensitive=S;function k(d,f){const g=Object.create(null);for(const[D,p]of Object.entries(d))f(D,p)&&(g[D]=p);return g}e.filter=k;function C(d){let f=[],g=Object.getPrototypeOf(d);for(;Object.prototype!==g;)f=f.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return f}e.getAllPropertyNames=C;function E(d){const f=[];for(const g of C(d))typeof d[g]=="function"&&f.push(g);return f}e.getAllMethodNames=E;function r(d,f){const g=p=>function(){const t=Array.prototype.slice.call(arguments,0);return f(p,t)},D={};for(const p of d)D[p]=g(p);return D}e.createProxyObject=r}),define(Ce[52],Ie([1,0,67]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(P){function T(y){return y&&typeof y=="object"&&typeof y.id=="string"}P.isThemeColor=T})(A=e.ThemeColor||(e.ThemeColor={}));function u(P){return{id:P}}e.themeColorFromId=u;var R;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function y(f){const g=T.exec(f.id);if(!g)return y(a.Codicon.error);const[,D,p]=g,t=["codicon","codicon-"+D];return p&&t.push("codicon-modifier-"+p.substring(1)),t}P.asClassNameArray=y;function m(f){return y(f).join(" ")}P.asClassName=m;function L(f){return"."+y(f).join(".")}P.asCSSSelector=L;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||A.isThemeColor(f.color))}P.isThemeIcon=I;const S=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function k(f){const g=S.exec(f);if(!g)return;const[,D]=g;return{id:D}}P.fromString=k;function C(f){return{id:f}}P.fromId=C;function E(f,g){let D=f.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),g&&(D=`${D}~${g}`),{id:D}}P.modify=E;function r(f){const g=f.id.lastIndexOf("~");if(g!==-1)return f.id.substring(g+1)}P.getModifier=r;function d(f,g){return f.id===g.id&&f.color?.id===g.color?.id}P.isEqual=d})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[105],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function u(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=u}),define(Ce[30],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(u){return a.test(u)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(T){for(let y=0;y<T.length;y++)T[y]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),P=[];for(let T=0;T<256;T++)P.push(T.toString(16).padStart(2,"0"));return function(){u(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,m="";return m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m+="-",m+=P[R[y++]],m+=P[R[y++]],m+="-",m+=P[R[y++]],m+=P[R[y++]],m+="-",m+=P[R[y++]],m+=P[R[y++]],m+="-",m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m+=P[R[y++]],m}}()}),define(Ce[150],Ie([1,0,17,30]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(T){return{id:(0,A.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=u;function R(T,y,m){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:y,data:m}),value:void 0}}e.createFileDataTransferItem=R;class P{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,m){const L=this.a.get(y);L?L.push(m):this.a.set(this.b(y),[m])}replace(y,m){this.a.set(this.b(y),[m])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,m]of this.a.entries())for(const L of m)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[m,L]of this.entries())y(L,m)}b(y){return y.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(y=>y.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(y=>!y.startsWith("#"))})}),define(Ce[106],Ie([1,0,105]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(T){const y=(0,a.toUint8)(T);this.c=y,this.a=A.d(y),this.b=new Map}static d(T){const y=new Uint8Array(256);return y.fill(T),y}set(T,y){const m=(0,a.toUint8)(y);T>=0&&T<256?this.a[T]=m:this.b.set(T,m)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var u;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(u||(u={}));class R{constructor(){this.a=new A(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(Ce[53],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(u,R){this.lineNumber=u,this.column=R}with(u=this.lineNumber,R=this.column){return u===this.lineNumber&&R===this.column?this:new a(u,R)}delta(u=0,R=0){return this.with(this.lineNumber+u,this.column+R)}equals(u){return a.equals(this,u)}static equals(u,R){return!u&&!R?!0:!!u&&!!R&&u.lineNumber===R.lineNumber&&u.column===R.column}isBefore(u){return a.isBefore(this,u)}static isBefore(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<R.column}isBeforeOrEqual(u){return a.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<=R.column}static compare(u,R){const P=u.lineNumber|0,T=R.lineNumber|0;if(P===T){const y=u.column|0,m=R.column|0;return y-m}return P-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new a(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=a}),define(Ce[32],Ie([1,0,53]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,P,T,y){R>T||R===T&&P>y?(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=R,this.endColumn=P):(this.startLineNumber=R,this.startColumn=P,this.endLineNumber=T,this.endColumn=y)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<R.startColumn||P.lineNumber===R.endLineNumber&&P.column>R.endColumn)}static strictContainsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<=R.startColumn||P.lineNumber===R.endLineNumber&&P.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<=R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,P){let T,y,m,L;return P.startLineNumber<R.startLineNumber?(T=P.startLineNumber,y=P.startColumn):P.startLineNumber===R.startLineNumber?(T=P.startLineNumber,y=Math.min(P.startColumn,R.startColumn)):(T=R.startLineNumber,y=R.startColumn),P.endLineNumber>R.endLineNumber?(m=P.endLineNumber,L=P.endColumn):P.endLineNumber===R.endLineNumber?(m=P.endLineNumber,L=Math.max(P.endColumn,R.endColumn)):(m=R.endLineNumber,L=R.endColumn),new A(T,y,m,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,P){let T=R.startLineNumber,y=R.startColumn,m=R.endLineNumber,L=R.endColumn;const I=P.startLineNumber,S=P.startColumn,k=P.endLineNumber,C=P.endColumn;return T<I?(T=I,y=S):T===I&&(y=Math.max(y,S)),m>k?(m=k,L=C):m===k&&(L=Math.min(L,C)),T>m||T===m&&y>L?null:new A(T,y,m,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,P){return!R&&!P?!0:!!R&&!!P&&R.startLineNumber===P.startLineNumber&&R.startColumn===P.startColumn&&R.endLineNumber===P.endLineNumber&&R.endColumn===P.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,P){return new A(this.startLineNumber,this.startColumn,R,P)}setStartPosition(R,P){return new A(R,P,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,P=R){return new A(R.lineNumber,R.column,P.lineNumber,P.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn)}static areIntersecting(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,P){if(R&&P){const m=R.startLineNumber|0,L=P.startLineNumber|0;if(m===L){const I=R.startColumn|0,S=P.startColumn|0;if(I===S){const k=R.endLineNumber|0,C=P.endLineNumber|0;if(k===C){const E=R.endColumn|0,r=P.endColumn|0;return E-r}return k-C}return I-S}return m-L}return(R?1:0)-(P?1:0)}static compareRangesUsingEnds(R,P){return R.endLineNumber===P.endLineNumber?R.endColumn===P.endColumn?R.startLineNumber===P.startLineNumber?R.startColumn-P.startColumn:R.startLineNumber-P.startLineNumber:R.endColumn-P.endColumn:R.endLineNumber-P.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(Ce[151],Ie([1,0,53,32]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(T,y,m,L){super(T,y,m,L),this.selectionStartLineNumber=T,this.selectionStartColumn=y,this.positionLineNumber=m,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,y){return T.selectionStartLineNumber===y.selectionStartLineNumber&&T.selectionStartColumn===y.selectionStartColumn&&T.positionLineNumber===y.positionLineNumber&&T.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,T,y):new R(T,y,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,y){return this.getDirection()===0?new R(T,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,y)}static fromPositions(T,y=T){return new R(T.lineNumber,T.column,y.lineNumber,y.column)}static fromRange(T,y){return y===0?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,y){if(T&&!y||!T&&y)return!1;if(!T&&!y)return!0;if(T.length!==y.length)return!1;for(let m=0,L=T.length;m<L;m++)if(!this.selectionsEqual(T[m],y[m]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,y,m,L,I){return I===0?new R(T,y,m,L):new R(m,L,T,y)}}e.Selection=R}),define(Ce[152],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[153],Ie([1,0,106]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends a.CharacterClassifier{constructor(T){super(0);for(let y=0,m=T.length;y<m;y++)this.set(T.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function R(P){const T={};return y=>(T.hasOwnProperty(y)||(T[y]=P(y)),T[y])}e.getMapForWordSeparators=R(P=>new u(P))}),define(Ce[107],Ie([1,0,64,6,66]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)I.indexOf(k)>=0||(S+="\\"+k);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=R();function P(I){let S=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)S=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),S=new RegExp(I.source,k)}return S.lastIndex=0,S}e.ensureValidWordDefinition=P;const T=new u.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(I){const S=T.unshift(I);return(0,A.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=y;function m(I,S,k,C,E){if(E||(E=a.Iterable.first(T)),k.length>E.maxLen){let D=I-E.maxLen/2;return D<0?D=0:C+=D,k=k.substring(D,I+E.maxLen/2),m(I,S,k,C,E)}const r=Date.now(),d=I-1-C;let f=-1,g=null;for(let D=1;!(Date.now()-r>=E.timeBudget);D++){const p=d-E.windowSize*D;S.lastIndex=Math.max(0,p);const t=L(S,k,d,f);if(!t&&g||(g=t,p<=0))break;f=p}if(g){const D={word:g[0],startColumn:C+1+g.index,endColumn:C+1+g.index+g[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=m;function L(I,S,k,C){let E;for(;E=I.exec(S);){const r=E.index||0;if(r<=k&&I.lastIndex>=k)return E;if(C>0&&r>C)return null}return null}}),define(Ce[154],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class A{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let y=0,m=T.notIn.length;y<m;y++)switch(T.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,y){if(T.getTokenCount()===0)return!0;const m=T.findTokenIndexAtOffset(y-2),L=T.getStandardTokenType(m);return this.isOK(L)}g(T,y){for(let m=T;m<=y;m++){const L=String.fromCharCode(m);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class u{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of T)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=u;function R(P,T,y){P.has(T)?P.get(T).push(y):P.set(T,[y])}}),define(Ce[155],Ie([1,0,106]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class u{constructor(C,E,r){const d=new Uint8Array(C*E);for(let f=0,g=C*E;f<g;f++)d[f]=r;this.a=d,this.rows=C,this.cols=E}get(C,E){return this.a[C*this.cols+E]}set(C,E,r){this.a[C*this.cols+E]=r}}class R{constructor(C){let E=0,r=0;for(let f=0,g=C.length;f<g;f++){const[D,p,t]=C[f];p>E&&(E=p),D>r&&(r=D),t>r&&(r=t)}E++,r++;const d=new u(r,E,0);for(let f=0,g=C.length;f<g;f++){const[D,p,t]=C[f];d.set(D,p,t)}this.a=d,this.b=E}nextState(C,E){return E<0||E>=this.b?0:this.a.get(C,E)}}e.StateMachine=R;let P=null;function T(){return P===null&&(P=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var y;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let m=null;function L(){if(m===null){m=new a.CharacterClassifier(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<k.length;E++)m.set(k.charCodeAt(E),1);const C=".,;:";for(let E=0;E<C.length;E++)m.set(C.charCodeAt(E),2)}return m}class I{static a(C,E,r,d,f){let g=f-1;do{const D=E.charCodeAt(g);if(C.get(D)!==2)break;g--}while(g>d);if(d>0){const D=E.charCodeAt(d-1),p=E.charCodeAt(g);(D===40&&p===41||D===91&&p===93||D===123&&p===125)&&g--}return{range:{startLineNumber:r,startColumn:d+1,endLineNumber:r,endColumn:g+2},url:E.substring(d,g+1)}}static computeLinks(C,E=T()){const r=L(),d=[];for(let f=1,g=C.getLineCount();f<=g;f++){const D=C.getLineContent(f),p=D.length;let t=0,o=0,s=0,c=1,l=!1,v=!1,i=!1,n=!1;for(;t<p;){let h=!1;const w=D.charCodeAt(t);if(c===13){let b;switch(w){case 40:l=!0,b=0;break;case 41:b=l?0:1;break;case 91:i=!0,v=!0,b=0;break;case 93:i=!1,b=v?0:1;break;case 123:n=!0,b=0;break;case 125:b=n?0:1;break;case 39:case 34:case 96:s===w?b=1:s===39||s===34||s===96?b=0:b=1;break;case 42:b=s===42?1:0;break;case 124:b=s===124?1:0;break;case 32:b=i?0:1;break;default:b=r.get(w)}b===1&&(d.push(I.a(r,D,f,o,t)),h=!0)}else if(c===12){let b;w===91?(v=!0,b=0):b=r.get(w),b===1?h=!0:c=13}else c=E.nextState(c,w),c===0&&(h=!0);h&&(c=1,l=!1,v=!1,n=!1,o=t+1,s=w),t++}c===13&&d.push(I.a(r,D,f,o,p))}return d}}e.LinkComputer=I;function S(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.computeLinks=S}),define(Ce[108],Ie([1,0,23]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var P;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class m{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,D.indentSize|0),this.a=!1),this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.a===D.a&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=m;class L{constructor(D,p){this._findMatchBrand=void 0,this.range=D,this.matches=p}}e.FindMatch=L;var I;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(g){return g&&typeof g.read=="function"}e.isITextSnapshot=S;var k;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(k=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class E{constructor(D,p,t,o,s,c){this.identifier=D,this.range=p,this.text=t,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=c}}e.ValidAnnotatedEditOperation=E;class r{constructor(D,p,t){this.regex=D,this.wordSeparators=p,this.simpleSearch=t}}e.SearchData=r;class d{constructor(D,p,t){this.reverseEdits=D,this.changes=p,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function f(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(Ce[156],Ie([1,0,17,105]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,m){y=(0,A.toUint32)(y);const L=this.a,I=this.b,S=m.length;return S===0?!1:(this.a=new Uint32Array(L.length+S),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+S),this.a.set(m,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(y,m){return y=(0,A.toUint32)(y),m=(0,A.toUint32)(m),this.a[y]===m?!1:(this.a[y]=m,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,m){y=(0,A.toUint32)(y),m=(0,A.toUint32)(m);const L=this.a,I=this.b;if(y>=L.length)return!1;const S=L.length-y;return m>=S&&(m=S),m===0?!1:(this.a=new Uint32Array(L.length-m),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+m),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,A.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let m=this.c[0]+1;m===0&&(this.b[0]=this.a[0],m++),y>=this.a.length&&(y=this.a.length-1);for(let L=m;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let m=0,L=this.a.length-1,I=0,S=0,k=0;for(;m<=L;)if(I=m+(L-m)/2|0,S=this.b[I],k=S-this.a[I],y<k)L=I-1;else if(y>=S)m=I+1;else break;return new P(I,y-k)}}e.PrefixSumComputer=u;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const m=this.e[y],L=m>0?this.d[m-1]:0;return new P(m,y-L)}removeValues(y,m){this.a.splice(y,m),this.f(y)}insertValues(y,m){this.a=(0,a.arrayInsert)(this.a,y,m),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,m=this.a.length;y<m;y++){const L=this.a[y],I=y>0?this.d[y-1]:0;this.d[y]=I+L;for(let S=0;S<L;S++)this.e[I+S]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,m){this.a[y]!==m&&(this.a[y]=m,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class P{constructor(y,m){this.index=y,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=m}}e.PrefixSumIndexOfResult=P}),define(Ce[157],Ie([14,15]),function(se,e){return se.create("vs/base/common/actions",e)}),define(Ce[158],Ie([14,15]),function(se,e){return se.create("vs/base/common/date",e)}),define(Ce[159],Ie([1,0,158]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,u=A*60,R=u*24,P=R*7,T=R*30,y=R*365;function m(I,S,k,C){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,a.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(!C&&E<30)return(0,a.localize)(1,null);let r;return E<A?(r=E,S?r===1?k?(0,a.localize)(2,null,r):(0,a.localize)(3,null,r):k?(0,a.localize)(4,null,r):(0,a.localize)(5,null,r):r===1?k?(0,a.localize)(6,null,r):(0,a.localize)(7,null,r):k?(0,a.localize)(8,null,r):(0,a.localize)(9,null,r)):E<u?(r=Math.floor(E/A),S?r===1?k?(0,a.localize)(10,null,r):(0,a.localize)(11,null,r):k?(0,a.localize)(12,null,r):(0,a.localize)(13,null,r):r===1?k?(0,a.localize)(14,null,r):(0,a.localize)(15,null,r):k?(0,a.localize)(16,null,r):(0,a.localize)(17,null,r)):E<R?(r=Math.floor(E/u),S?r===1?k?(0,a.localize)(18,null,r):(0,a.localize)(19,null,r):k?(0,a.localize)(20,null,r):(0,a.localize)(21,null,r):r===1?k?(0,a.localize)(22,null,r):(0,a.localize)(23,null,r):k?(0,a.localize)(24,null,r):(0,a.localize)(25,null,r)):E<P?(r=Math.floor(E/R),S?r===1?(0,a.localize)(26,null,r):(0,a.localize)(27,null,r):r===1?(0,a.localize)(28,null,r):(0,a.localize)(29,null,r)):E<T?(r=Math.floor(E/P),S?r===1?k?(0,a.localize)(30,null,r):(0,a.localize)(31,null,r):k?(0,a.localize)(32,null,r):(0,a.localize)(33,null,r):r===1?k?(0,a.localize)(34,null,r):(0,a.localize)(35,null,r):k?(0,a.localize)(36,null,r):(0,a.localize)(37,null,r)):E<y?(r=Math.floor(E/T),S?r===1?k?(0,a.localize)(38,null,r):(0,a.localize)(39,null,r):k?(0,a.localize)(40,null,r):(0,a.localize)(41,null,r):r===1?k?(0,a.localize)(42,null,r):(0,a.localize)(43,null,r):k?(0,a.localize)(44,null,r):(0,a.localize)(45,null,r)):(r=Math.floor(E/y),S?r===1?k?(0,a.localize)(46,null,r):(0,a.localize)(47,null,r):k?(0,a.localize)(48,null,r):(0,a.localize)(49,null,r):r===1?k?(0,a.localize)(50,null,r):(0,a.localize)(51,null,r):k?(0,a.localize)(52,null,r):(0,a.localize)(53,null,r))}e.fromNow=m;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ce[160],Ie([14,15]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(Ce[46],Ie([1,0,17,9,160]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,S){return S&&(I.stack||I.stacktrace)?u.localize(0,null,T(I),P(I.stack)||P(I.stacktrace)):T(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function T(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?u.localize(1,null,I.message):I.message||u.localize(2,null)}function y(I=null,S=!1){if(!I)return u.localize(3,null);if(Array.isArray(I)){const k=a.coalesce(I),C=y(k[0],S);return k.length>1?u.localize(4,null,C,k.length):C}if(A.isString(I))return I;if(I.detail){const k=I.detail;if(k.error)return R(k.error,S);if(k.exception)return R(k.exception,S)}return I.stack?R(I,S):I.message?I.message:u.localize(5,null)}e.toErrorMessage=y;function m(I){const S=I;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function L(I,S){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=S,k}e.createErrorWithActions=L}),define(Ce[161],Ie([14,15]),function(se,e){return se.create("vs/base/common/platform",e)}),define(Ce[11],Ie([1,0,161]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,u=!1,R=!1,P=!1,T=!1,y=!1,m=!1,L=!1,I=!1,S=!1,k,C=e.LANGUAGE_DEFAULT,E,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",g=f&&d?.type==="renderer";if(typeof navigator=="object"&&!g)r=navigator.userAgent,A=r.indexOf("Windows")>=0,u=r.indexOf("Macintosh")>=0,L=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=r.indexOf("Linux")>=0,S=r?.indexOf("Mobi")>=0,y=!0,k=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,C=k;else if(typeof d=="object"){A=d.platform==="win32",u=d.platform==="darwin",R=d.platform==="linux",P=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,m=f,I=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),h=n.availableLanguages["*"];k=n.locale,C=h||e.LANGUAGE_DEFAULT,E=n._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function p(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let t=0;u?t=1:A?t=3:R&&(t=2),e.isWindows=A,e.isMacintosh=u,e.isLinux=R,e.isLinuxSnap=P,e.isNative=T,e.isElectron=m,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=S,e.isCI=I,e.platform=t,e.userAgent=r,e.language=C;var o;(function(i){function n(){return e.language}i.value=n;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function w(){return e.language==="en"}i.isDefault=w})(o=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let w=0,b=i.length;w<b;w++){const O=i[w];if(O.id===h.data.vscodeScheduleAsyncWork){i.splice(w,1),O.callback();return}}});let n=0;return h=>{const w=++n;i.push({id:w,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return i=>setTimeout(i)})();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=u||L?2:A?1:3;let c=!0,l=!1;function v(){if(!l){l=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=v,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[36],Ie([1,0,11]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const u=a.globals.vscode.process;A={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(Ce[12],Ie([1,0,36]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,u=97,R=90,P=122,T=46,y=47,m=92,L=58,I=63;class S extends Error{constructor(o,s,c){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const v=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${v} ${l} of type ${s}`;i+=`. Received type ${typeof c}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,o){if(t===null||typeof t!="object")throw new S(o,"Object",t)}function C(t,o){if(typeof t!="string")throw new S(o,"string",t)}const E=a.platform==="win32";function r(t){return t===y||t===m}function d(t){return t===y}function f(t){return t>=A&&t<=R||t>=u&&t<=P}function g(t,o,s,c){let l="",v=0,i=-1,n=0,h=0;for(let w=0;w<=t.length;++w){if(w<t.length)h=t.charCodeAt(w);else{if(c(h))break;h=y}if(c(h)){if(!(i===w-1||n===1))if(n===2){if(l.length<2||v!==2||l.charCodeAt(l.length-1)!==T||l.charCodeAt(l.length-2)!==T){if(l.length>2){const b=l.lastIndexOf(s);b===-1?(l="",v=0):(l=l.slice(0,b),v=l.length-1-l.lastIndexOf(s)),i=w,n=0;continue}else if(l.length!==0){l="",v=0,i=w,n=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",v=2)}else l.length>0?l+=`${s}${t.slice(i+1,w)}`:l=t.slice(i+1,w),v=w-i-1;i=w,n=0}else h===T&&n!==-1?++n:n=-1}return l}function D(t,o){k(o,"pathObject");const s=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${c}`:`${s}${t}${c}`:c}e.win32={resolve(...t){let o="",s="",c=!1;for(let l=t.length-1;l>=-1;l--){let v;if(l>=0){if(v=t[l],C(v,"path"),v.length===0)continue}else o.length===0?v=a.cwd():(v=a.env[`=${o}`]||a.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==o.toLowerCase()&&v.charCodeAt(2)===m)&&(v=`${o}\\`));const i=v.length;let n=0,h="",w=!1;const b=v.charCodeAt(0);if(i===1)r(b)&&(n=1,w=!0);else if(r(b))if(w=!0,r(v.charCodeAt(1))){let O=2,H=O;for(;O<i&&!r(v.charCodeAt(O));)O++;if(O<i&&O!==H){const x=v.slice(H,O);for(H=O;O<i&&r(v.charCodeAt(O));)O++;if(O<i&&O!==H){for(H=O;O<i&&!r(v.charCodeAt(O));)O++;(O===i||O!==H)&&(h=`\\\\${x}\\${v.slice(H,O)}`,n=O)}}}else n=1;else f(b)&&v.charCodeAt(1)===L&&(h=v.slice(0,2),n=2,i>2&&r(v.charCodeAt(2))&&(w=!0,n=3));if(h.length>0)if(o.length>0){if(h.toLowerCase()!==o.toLowerCase())continue}else o=h;if(c){if(o.length>0)break}else if(s=`${v.slice(n)}\\${s}`,c=w,w&&o.length>0)break}return s=g(s,!c,"\\",r),c?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){C(t,"path");const o=t.length;if(o===0)return".";let s=0,c,l=!1;const v=t.charCodeAt(0);if(o===1)return d(v)?"\\":t;if(r(v))if(l=!0,r(t.charCodeAt(1))){let n=2,h=n;for(;n<o&&!r(t.charCodeAt(n));)n++;if(n<o&&n!==h){const w=t.slice(h,n);for(h=n;n<o&&r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&!r(t.charCodeAt(n));)n++;if(n===o)return`\\\\${w}\\${t.slice(h)}\\`;n!==h&&(c=`\\\\${w}\\${t.slice(h,n)}`,s=n)}}}else s=1;else f(v)&&t.charCodeAt(1)===L&&(c=t.slice(0,2),s=2,o>2&&r(t.charCodeAt(2))&&(l=!0,s=3));let i=s<o?g(t.slice(s),!l,"\\",r):"";return i.length===0&&!l&&(i="."),i.length>0&&r(t.charCodeAt(o-1))&&(i+="\\"),c===void 0?l?`\\${i}`:i:l?`${c}\\${i}`:`${c}${i}`},isAbsolute(t){C(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return r(s)||o>2&&f(s)&&t.charCodeAt(1)===L&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let v=0;v<t.length;++v){const i=t[v];C(i,"path"),i.length>0&&(o===void 0?o=s=i:o+=`\\${i}`)}if(o===void 0)return".";let c=!0,l=0;if(typeof s=="string"&&r(s.charCodeAt(0))){++l;const v=s.length;v>1&&r(s.charCodeAt(1))&&(++l,v>2&&(r(s.charCodeAt(2))?++l:c=!1))}if(c){for(;l<o.length&&r(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o)return"";const s=e.win32.resolve(t),c=e.win32.resolve(o);if(s===c||(t=s.toLowerCase(),o=c.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===m;)l++;let v=t.length;for(;v-1>l&&t.charCodeAt(v-1)===m;)v--;const i=v-l;let n=0;for(;n<o.length&&o.charCodeAt(n)===m;)n++;let h=o.length;for(;h-1>n&&o.charCodeAt(h-1)===m;)h--;const w=h-n,b=i<w?i:w;let O=-1,H=0;for(;H<b;H++){const _=t.charCodeAt(l+H);if(_!==o.charCodeAt(n+H))break;_===m&&(O=H)}if(H!==b){if(O===-1)return c}else{if(w>b){if(o.charCodeAt(n+H)===m)return c.slice(n+H+1);if(H===2)return c.slice(n+H)}i>b&&(t.charCodeAt(l+H)===m?O=H:H===2&&(O=3)),O===-1&&(O=0)}let x="";for(H=l+O+1;H<=v;++H)(H===v||t.charCodeAt(H)===m)&&(x+=x.length===0?"..":"\\..");return n+=O,x.length>0?`${x}${c.slice(n,h)}`:(c.charCodeAt(n)===m&&++n,c.slice(n,h))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const s=o.charCodeAt(2);if(s!==I&&s!==T)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return t},dirname(t){C(t,"path");const o=t.length;if(o===0)return".";let s=-1,c=0;const l=t.charCodeAt(0);if(o===1)return r(l)?t:".";if(r(l)){if(s=c=1,r(t.charCodeAt(1))){let n=2,h=n;for(;n<o&&!r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&!r(t.charCodeAt(n));)n++;if(n===o)return t;n!==h&&(s=c=n+1)}}}}else f(l)&&t.charCodeAt(1)===L&&(s=o>2&&r(t.charCodeAt(2))?3:2,c=s);let v=-1,i=!0;for(let n=o-1;n>=c;--n)if(r(t.charCodeAt(n))){if(!i){v=n;break}}else i=!1;if(v===-1){if(s===-1)return".";v=s}return t.slice(0,v)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,c=-1,l=!0,v;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,n=-1;for(v=t.length-1;v>=s;--v){const h=t.charCodeAt(v);if(r(h)){if(!l){s=v+1;break}}else n===-1&&(l=!1,n=v+1),i>=0&&(h===o.charCodeAt(i)?--i===-1&&(c=v):(i=-1,c=n))}return s===c?c=n:c===-1&&(c=t.length),t.slice(s,c)}for(v=t.length-1;v>=s;--v)if(r(t.charCodeAt(v))){if(!l){s=v+1;break}}else c===-1&&(l=!1,c=v+1);return c===-1?"":t.slice(s,c)},extname(t){C(t,"path");let o=0,s=-1,c=0,l=-1,v=!0,i=0;t.length>=2&&t.charCodeAt(1)===L&&f(t.charCodeAt(0))&&(o=c=2);for(let n=t.length-1;n>=o;--n){const h=t.charCodeAt(n);if(r(h)){if(!v){c=n+1;break}continue}l===-1&&(v=!1,l=n+1),h===T?s===-1?s=n:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||l===-1||i===0||i===1&&s===l-1&&s===c+1?"":t.slice(s,l)},format:D.bind(null,"\\"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let c=0,l=t.charCodeAt(0);if(s===1)return r(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(r(l)){if(c=1,r(t.charCodeAt(1))){let O=2,H=O;for(;O<s&&!r(t.charCodeAt(O));)O++;if(O<s&&O!==H){for(H=O;O<s&&r(t.charCodeAt(O));)O++;if(O<s&&O!==H){for(H=O;O<s&&!r(t.charCodeAt(O));)O++;O===s?c=O:O!==H&&(c=O+1)}}}}else if(f(l)&&t.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=t,o;if(c=2,r(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let v=-1,i=c,n=-1,h=!0,w=t.length-1,b=0;for(;w>=c;--w){if(l=t.charCodeAt(w),r(l)){if(!h){i=w+1;break}continue}n===-1&&(h=!1,n=w+1),l===T?v===-1?v=w:b!==1&&(b=1):v!==-1&&(b=-1)}return n!==-1&&(v===-1||b===0||b===1&&v===n-1&&v===i+1?o.base=o.name=t.slice(i,n):(o.name=t.slice(i,v),o.base=t.slice(i,n),o.ext=t.slice(v,n))),i>0&&i!==c?o.dir=t.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(E){const t=/\\/g;return()=>{const o=a.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let c=t.length-1;c>=-1&&!s;c--){const l=c>=0?t[c]:p();C(l,"path"),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===y)}return o=g(o,!s,"/",d),s?`/${o}`:o.length>0?o:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y,s=t.charCodeAt(t.length-1)===y;return t=g(t,!o,"/",d),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const c=t[s];C(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,c=t.length,l=c-s,v=1,i=o.length-v,n=l<i?l:i;let h=-1,w=0;for(;w<n;w++){const O=t.charCodeAt(s+w);if(O!==o.charCodeAt(v+w))break;O===y&&(h=w)}if(w===n)if(i>n){if(o.charCodeAt(v+w)===y)return o.slice(v+w+1);if(w===0)return o.slice(v+w)}else l>n&&(t.charCodeAt(s+w)===y?h=w:w===0&&(h=0));let b="";for(w=s+h+1;w<=c;++w)(w===c||t.charCodeAt(w)===y)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(v+h)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y;let s=-1,c=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===y){if(!c){s=l;break}}else c=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,c=-1,l=!0,v;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,n=-1;for(v=t.length-1;v>=0;--v){const h=t.charCodeAt(v);if(h===y){if(!l){s=v+1;break}}else n===-1&&(l=!1,n=v+1),i>=0&&(h===o.charCodeAt(i)?--i===-1&&(c=v):(i=-1,c=n))}return s===c?c=n:c===-1&&(c=t.length),t.slice(s,c)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===y){if(!l){s=v+1;break}}else c===-1&&(l=!1,c=v+1);return c===-1?"":t.slice(s,c)},extname(t){C(t,"path");let o=-1,s=0,c=-1,l=!0,v=0;for(let i=t.length-1;i>=0;--i){const n=t.charCodeAt(i);if(n===y){if(!l){s=i+1;break}continue}c===-1&&(l=!1,c=i+1),n===T?o===-1?o=i:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||c===-1||v===0||v===1&&o===c-1&&o===s+1?"":t.slice(o,c)},format:D.bind(null,"/"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===y;let c;s?(o.root="/",c=1):c=0;let l=-1,v=0,i=-1,n=!0,h=t.length-1,w=0;for(;h>=c;--h){const b=t.charCodeAt(h);if(b===y){if(!n){v=h+1;break}continue}i===-1&&(n=!1,i=h+1),b===T?l===-1?l=h:w!==1&&(w=1):l!==-1&&(w=-1)}if(i!==-1){const b=v===0&&s?1:v;l===-1||w===0||w===1&&l===i-1&&l===v+1?o.base=o.name=t.slice(b,i):(o.name=t.slice(b,l),o.base=t.slice(b,i),o.ext=t.slice(l,i))}return v>0?o.dir=t.slice(0,v-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(Ce[109],Ie([1,0,65,12]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new a.Lazy(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),R=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(n,h,w=!1){const b=n||"",O=h||"",H=u.value.collator.compare(b,O);return u.value.collatorIsNumeric&&H===0&&b!==O?b<O?-1:1:H}e.compareFileNames=T;function y(n,h){const w=R.value.collator;return n=n||"",h=h||"",D(w,n,h)}e.compareFileNamesDefault=y;function m(n,h){const w=R.value.collator;return n=n||"",h=h||"",s(n,h)||D(w,n,h)}e.compareFileNamesUpper=m;function L(n,h){const w=R.value.collator;return n=n||"",h=h||"",o(n,h)||D(w,n,h)}e.compareFileNamesLower=L;function I(n,h){return n=n||"",h=h||"",n===h?0:n<h?-1:1}e.compareFileNamesUnicode=I;function S(n,h){const[w,b]=f(n),[O,H]=f(h);let x=u.value.collator.compare(b,H);if(x===0){if(u.value.collatorIsNumeric&&b!==H)return b<H?-1:1;if(x=u.value.collator.compare(w,O),u.value.collatorIsNumeric&&x===0&&w!==O)return w<O?-1:1}return x}e.compareFileExtensions=S;function k(n,h){n=n||"",h=h||"";const w=g(n),b=g(h),O=R.value.collator,H=P.value.collator;return D(H,w,b)||D(O,n,h)}e.compareFileExtensionsDefault=k;function C(n,h){n=n||"",h=h||"";const w=g(n),b=g(h),O=R.value.collator,H=P.value.collator;return D(H,w,b)||s(n,h)||D(O,n,h)}e.compareFileExtensionsUpper=C;function E(n,h){n=n||"",h=h||"";const w=g(n),b=g(h),O=R.value.collator,H=P.value.collator;return D(H,w,b)||o(n,h)||D(O,n,h)}e.compareFileExtensionsLower=E;function r(n,h){n=n||"",h=h||"";const w=g(n).toLowerCase(),b=g(h).toLowerCase();return w!==b?w<b?-1:1:n!==h?n<h?-1:1:0}e.compareFileExtensionsUnicode=r;const d=/^(.*?)(\.([^.]*))?$/;function f(n,h=!1){const w=n?d.exec(n):[];let b=[w&&w[1]||"",w&&w[3]||""];return h&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function g(n){const h=n?d.exec(n):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function D(n,h,w){const b=n.compare(h,w);return b!==0?b:h.length!==w.length?h.length<w.length?-1:1:0}function p(n){const h=n.charAt(0);return h.toLocaleUpperCase()!==h}function t(n){const h=n.charAt(0);return h.toLocaleLowerCase()!==h}function o(n,h){return p(n)&&t(h)?-1:t(n)&&p(h)?1:0}function s(n,h){return t(n)&&p(h)?-1:p(n)&&t(h)?1:0}function c(n,h,w=!1){return w||(n=n&&n.toLowerCase(),h=h&&h.toLowerCase()),n===h?0:n<h?-1:1}function l(n,h,w=!1){const b=n.split(A.sep),O=h.split(A.sep),H=b.length-1,x=O.length-1;let _,G;for(let M=0;;M++){if(_=H===M,G=x===M,_&&G)return T(b[M],O[M],w);if(_)return-1;if(G)return 1;const B=c(b[M],O[M],w);if(B!==0)return B}}e.comparePaths=l;function v(n,h,w){const b=n.toLowerCase(),O=h.toLowerCase(),H=i(n,h,w);if(H)return H;const x=b.endsWith(w),_=O.endsWith(w);if(x!==_)return x?-1:1;const G=T(b,O);return G!==0?G:b.localeCompare(O)}e.compareAnything=v;function i(n,h,w){const b=n.toLowerCase(),O=h.toLowerCase(),H=b.startsWith(w),x=O.startsWith(w);if(H!==x)return H?-1:1;if(H&&x){if(b.length<O.length)return-1;if(b.length>O.length)return 1}return 0}e.compareByPrefix=i}),define(Ce[88],Ie([1,0,12]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const I=(0,a.extname)(L),S=A[I.toLowerCase()];return S!==void 0?S:P(L)}e.getMediaOrTextMime=R;function P(L){const I=(0,a.extname)(L);return u[I.toLowerCase()]}e.getMediaMime=P;function T(L){for(const I in u)if(u[I]===L)return I}e.getExtensionForMimeType=T;const y=/^(.+)\/(.+?)(;.+)?$/;function m(L,I){const S=y.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:I?void 0:L}e.normalizeMimeType=m}),define(Ce[110],Ie([1,0,11]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var u;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...y){const m=y.reduce((S,k)=>(S[k]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(S=>!m[S]).forEach(S=>{for(let k=0;k<L.length;k++)if(S.search(L[k])!==-1){delete T[S];break}})}e.sanitizeProcessEnvironment=R;function P(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=P}),define(Ce[43],Ie([1,0,11]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=a.globals.performance&&typeof a.globals.performance.now=="function";class u{static create(P=!0){return new u(P)}constructor(P){this.a=A&&P,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=u}),define(Ce[3],Ie([1,0,10,63,6,66,43]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,y=!1;var m;(function(v){v.None=()=>u.Disposable.None;function i(Q){if(y){const{onDidAddListener:me}=Q,Ee=C.create();let te=0;Q.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),me?.()}}}function n(Q,me){return M(Q,()=>{},0,void 0,!0,void 0,me)}v.defer=n;function h(Q){return(me,Ee=null,te)=>{let ne=!1,de;return de=Q(ee=>{if(!ne)return de?de.dispose():ne=!0,me.call(Ee,ee)},null,te),ne&&de.dispose(),de}}v.once=h;function w(Q,me,Ee){return G((te,ne=null,de)=>Q(ee=>te.call(ne,me(ee)),null,de),Ee)}v.map=w;function b(Q,me,Ee){return G((te,ne=null,de)=>Q(ee=>{me(ee),te.call(ne,ee)},null,de),Ee)}v.forEach=b;function O(Q,me,Ee){return G((te,ne=null,de)=>Q(ee=>me(ee)&&te.call(ne,ee),null,de),Ee)}v.filter=O;function H(Q){return Q}v.signal=H;function x(...Q){return(me,Ee=null,te)=>(0,u.combinedDisposable)(...Q.map(ne=>ne(de=>me.call(Ee,de),null,te)))}v.any=x;function _(Q,me,Ee,te){let ne=Ee;return w(Q,de=>(ne=me(ne,de),ne),te)}v.reduce=_;function G(Q,me){let Ee;const te={onWillAddFirstListener(){Ee=Q(ne.fire,ne)},onDidRemoveLastListener(){Ee?.dispose()}};me||i(te);const ne=new r(te);return me?.add(ne),ne.event}function M(Q,me,Ee=100,te=!1,ne=!1,de,ee){let ce,ae,N,z=0,K;const Z={leakWarningThreshold:de,onWillAddFirstListener(){ce=Q(Se=>{z++,ae=me(ae,Se),te&&!N&&(fe.fire(ae),ae=void 0),K=()=>{const Ae=ae;ae=void 0,N=void 0,(!te||z>1)&&fe.fire(Ae),z=0},typeof Ee=="number"?(clearTimeout(N),N=setTimeout(K,Ee)):N===void 0&&(N=0,queueMicrotask(K))})},onWillRemoveListener(){ne&&z>0&&K?.()},onDidRemoveLastListener(){K=void 0,ce.dispose()}};ee||i(Z);const fe=new r(Z);return ee?.add(fe),fe.event}v.debounce=M;function B(Q,me=0,Ee){return v.debounce(Q,(te,ne)=>te?(te.push(ne),te):[ne],me,void 0,!0,void 0,Ee)}v.accumulate=B;function U(Q,me=(te,ne)=>te===ne,Ee){let te=!0,ne;return O(Q,de=>{const ee=te||!me(de,ne);return te=!1,ne=de,ee},Ee)}v.latch=U;function j(Q,me,Ee){return[v.filter(Q,me,Ee),v.filter(Q,te=>!me(te),Ee)]}v.split=j;function he(Q,me=!1,Ee=[]){let te=Ee.slice(),ne=Q(ce=>{te?te.push(ce):ee.fire(ce)});const de=()=>{te?.forEach(ce=>ee.fire(ce)),te=null},ee=new r({onWillAddFirstListener(){ne||(ne=Q(ce=>ee.fire(ce)))},onDidAddFirstListener(){te&&(me?setTimeout(de):de())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return ee.event}v.buffer=he;class ie{constructor(me){this.event=me,this.c=new u.DisposableStore}map(me){return new ie(w(this.event,me,this.c))}forEach(me){return new ie(b(this.event,me,this.c))}filter(me){return new ie(O(this.event,me,this.c))}reduce(me,Ee){return new ie(_(this.event,me,Ee,this.c))}latch(){return new ie(U(this.event,void 0,this.c))}debounce(me,Ee=100,te=!1,ne=!1,de){return new ie(M(this.event,me,Ee,te,ne,de,this.c))}on(me,Ee,te){return this.event(me,Ee,te)}once(me,Ee,te){return h(this.event)(me,Ee,te)}dispose(){this.c.dispose()}}function V(Q){return new ie(Q)}v.chain=V;function J(Q,me,Ee=te=>te){const te=(...ce)=>ee.fire(Ee(...ce)),ne=()=>Q.on(me,te),de=()=>Q.removeListener(me,te),ee=new r({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}v.fromNodeEventEmitter=J;function re(Q,me,Ee=te=>te){const te=(...ce)=>ee.fire(Ee(...ce)),ne=()=>Q.addEventListener(me,te),de=()=>Q.removeEventListener(me,te),ee=new r({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}v.fromDOMEventEmitter=re;function ve(Q){return new Promise(me=>h(Q)(me))}v.toPromise=ve;function ue(Q,me){return me(void 0),Q(Ee=>me(Ee))}v.runAndSubscribe=ue;function le(Q,me){let Ee=null;function te(de){Ee?.dispose(),Ee=new u.DisposableStore,me(de,Ee)}te(void 0);const ne=Q(de=>te(de));return(0,u.toDisposable)(()=>{ne.dispose(),Ee?.dispose()})}v.runAndSubscribeWithStore=le;class q{constructor(me,Ee){this.obs=me,this.c=0,this.d=!1;const te={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};Ee||i(te),this.emitter=new r(te),Ee&&Ee.add(this.emitter)}beginUpdate(me){this.c++}handleChange(me,Ee){this.d=!0}endUpdate(me){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function F(Q,me){return new q(Q,me).emitter.event}v.fromObservable=F})(m=e.Event||(e.Event={}));class L{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${L.c++}`,L.all.add(this)}start(i){this.d=new P.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let I=-1;function S(v){const i=I;return I=v,{dispose(){I=i}}}e.setGlobalLeakWarningThreshold=S;class k{constructor(i,n=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=n,this.d=0}dispose(){this.c?.clear()}check(i,n){const h=this.threshold;if(h<=0||n<h)return;this.c||(this.c=new Map);const w=this.c.get(i.value)||0;if(this.c.set(i.value,w+1),this.d-=1,this.d<=0){this.d=h*.5;let b,O=0;for(const[H,x]of this.c)(!b||O<x)&&(b=H,O=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${O}):`),console.warn(b)}return()=>{const b=this.c.get(i.value)||0;this.c.set(i.value,b-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(i,n,h){this.callback=i,this.callbackThis=n,this.stack=h,this.subscription=new u.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class r{constructor(i){this.j=!1,this.d=i,this.f=I>0||this.d?.leakWarningThreshold?new k(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const i=Array.from(this.q);queueMicrotask(()=>{for(const n of i)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,n,h)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let b,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=C.create(),b=this.f.check(O,this.q.size+1)),T&&(O=O??C.create());const H=new E(i,n,O),x=this.q.push(H);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,n);const _=H.subscription.set(()=>{b?.(),this.j||(this.d?.onWillRemoveListener?.(this),x(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof u.DisposableStore?h.add(_):Array.isArray(h)&&h.push(_),_}),this.l}fire(i){if(this.q){this.m||(this.m=new f);for(const n of this.q)this.m.push(this,n,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class d{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(i,n,h){this.c.push(new g(i,n,h))}clear(i){const n=new R.LinkedList;for(const h of this.c)h.emitter!==i&&n.push(h);this.c=n}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(n){(0,a.onUnexpectedError)(n)}}}}e.EventDeliveryQueue=d;class f extends d{clear(i){this.c.clear()}}class g{constructor(i,n,h){this.emitter=i,this.listener=n,this.event=h}}class D extends r{async fireAsync(i,n,h){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const w of this.q)this.c.push([w,i]);for(;this.c.size>0&&!n.isCancellationRequested;){const[w,b]=this.c.shift(),O=[],H={...b,token:n,waitUntil:x=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");h&&(x=h(x,w.callback)),O.push(x)}};try{w.invoke(H)}catch(x){(0,a.onUnexpectedError)(x);continue}Object.freeze(O),await Promise.allSettled(O).then(x=>{for(const _ of x)_.status==="rejected"&&(0,a.onUnexpectedError)(_.reason)})}}}}e.AsyncEmitter=D;class p extends r{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=p;class t extends p{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=t;class o extends r{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const n={event:i,listener:null};this.f.push(n),this.d&&this.j(n);const h=()=>{this.d&&this.k(n);const w=this.f.indexOf(n);this.f.splice(w,1)};return(0,u.toDisposable)((0,A.once)(h))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(n=>this.c.fire(n))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class c{constructor(){this.c=[]}wrapEvent(i){return(n,h,w)=>i(b=>{const O=this.c[this.c.length-1];O?O.push(()=>n.call(h,b)):n.call(h,b)},void 0,w)}bufferEvents(i){const n=[];this.c.push(n);const h=i();return this.c.pop(),n.forEach(w=>w()),h}}e.EventBufferer=c;class l{constructor(){this.c=!1,this.d=m.None,this.f=u.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(Ce[162],Ie([1,0,3,6,157]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(S,k="",C="",E=!0,r){super(),this.h=this.D(new a.Emitter),this.onDidChange=this.h.event,this.u=!0,this.j=S,this.m=k,this.q=C,this.u=E,this.z=r}get id(){return this.j}get label(){return this.m}set label(S){this.C(S)}C(S){this.m!==S&&(this.m=S,this.h.fire({label:S}))}get tooltip(){return this.n||""}set tooltip(S){this.F(S)}F(S){this.n!==S&&(this.n=S,this.h.fire({tooltip:S}))}get class(){return this.q}set class(S){this.G(S)}G(S){this.q!==S&&(this.q=S,this.h.fire({class:S}))}get enabled(){return this.u}set enabled(S){this.H(S)}H(S){this.u!==S&&(this.u=S,this.h.fire({enabled:S}))}get checked(){return this.w}set checked(S){this.I(S)}I(S){this.w!==S&&(this.w=S,this.h.fire({checked:S}))}async run(S,k){this.z&&await this.z(S)}}e.Action=R;class P extends A.Disposable{constructor(){super(...arguments),this.f=this.D(new a.Emitter),this.onWillRun=this.f.event,this.h=this.D(new a.Emitter),this.onDidRun=this.h.event}async run(S,k){if(!S.enabled)return;this.f.fire({action:S});let C;try{await this.k(S,k)}catch(E){C=E}this.h.fire({action:S,error:C})}async k(S,k){await S.run(k)}}e.ActionRunner=P;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...S){let k=[];for(const C of S)C.length&&(k.length?k=[...k,new T,...C]:k=C);return k}async run(){}}T.ID="vs.actions.separator",e.Separator=T;class y{get actions(){return this.a}constructor(S,k,C,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=S,this.label=k,this.class=E,this.a=C}async run(){}}e.SubmenuAction=y;class m extends R{constructor(){super(m.ID,u.localize(0,null),void 0,!1)}}m.ID="vs.actions.empty",e.EmptySubmenuAction=m;function L(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=L}),define(Ce[21],Ie([1,0,3]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(T,y){const m=setTimeout(T.bind(y),0);return{dispose(){clearTimeout(m)}}});var u;(function(T){function y(m){return m===T.None||m===T.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}T.isCancellationToken=y,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(u=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=u.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=P}),define(Ce[163],Ie([1,0,21]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,y=this.b(T.token);return this.a={promise:y,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=A;class u{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const y=JSON.stringify(T);return this.b!==y&&(this.b=y,this.a=this.c(T)),this.a}}e.LRUCachedFunction=u;class R{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const y=this.b(T);return this.a.set(T,y),y}}e.CachedFunction=R}),define(Ce[8],Ie([1,0,163,65]),function(se,e,a,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const P=/{(\d+)}/g;function T($,...Y){return Y.length===0?$:$.replace(P,function(ge,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=Y.length?ge:Y[Ne]})}e.format=T;const y=/{([^}]+)}/g;function m($,Y){return $.replace(y,(ge,Le)=>Y[Le]??ge)}e.format2=m;function L($){return $.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=L;function I($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function S($,Y){let ge=0;const Le=Y.charCodeAt(0);for(let Ne=$.length-1;Ne>=0;Ne--)$.charCodeAt(Ne)===Le&&ge++;return ge}e.count=S;function k($,Y,ge="\u2026"){return $.length<=Y?$:`${$.substr(0,Y)}${ge}`}e.truncate=k;function C($,Y=" "){const ge=E($,Y);return r(ge,Y)}e.trim=C;function E($,Y){if(!$||!Y)return $;const ge=Y.length;if(ge===0||$.length===0)return $;let Le=0;for(;$.indexOf(Y,Le)===Le;)Le=Le+ge;return $.substring(Le)}e.ltrim=E;function r($,Y){if(!$||!Y)return $;const ge=Y.length,Le=$.length;if(ge===0||Le===0)return $;let Ne=Le,je=-1;for(;je=$.lastIndexOf(Y,Ne-1),!(je===-1||je+ge!==Ne);){if(je===0)return"";Ne=je}return $.substring(0,Ne)}e.rtrim=r;function d($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f($){return $.replace(/\*/g,"")}e.stripWildcards=f;function g($,Y,ge={}){if(!$)throw new Error("Cannot create regex from empty string");Y||($=I($)),ge.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return ge.global&&(Le+="g"),ge.matchCase||(Le+="i"),ge.multiline&&(Le+="m"),ge.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=g;function D($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function p($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=t;function o($){return $.split(/\r\n|\r|\n/)}e.splitLines=o;function s($){for(let Y=0,ge=$.length;Y<ge;Y++){const Le=$.charCodeAt(Y);if(Le!==32&&Le!==9)return Y}return-1}e.firstNonWhitespaceIndex=s;function c($,Y=0,ge=$.length){for(let Le=Y;Le<ge;Le++){const Ne=$.charCodeAt(Le);if(Ne!==32&&Ne!==9)return $.substring(Y,Le)}return $.substring(Y,ge)}e.getLeadingWhitespace=c;function l($,Y=$.length-1){for(let ge=Y;ge>=0;ge--){const Le=$.charCodeAt(ge);if(Le!==32&&Le!==9)return ge}return-1}e.lastNonWhitespaceIndex=l;function v($,Y,ge){const Le=[];let Ne=0;for(const je of $.matchAll(Y)){if(Le.push($.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Le.push(ge(je[0],...je.slice(1),je.index,$,je.groups))}return Le.push($.slice(Ne)),Promise.all(Le).then(je=>je.join(""))}e.replaceAsync=v;function i($,Y){return $<Y?-1:$>Y?1:0}e.compare=i;function n($,Y,ge=0,Le=$.length,Ne=0,je=Y.length){for(;ge<Le&&Ne<je;ge++,Ne++){const nt=$.charCodeAt(ge),ot=Y.charCodeAt(Ne);if(nt<ot)return-1;if(nt>ot)return 1}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstring=n;function h($,Y){return w($,Y,0,$.length,0,Y.length)}e.compareIgnoreCase=h;function w($,Y,ge=0,Le=$.length,Ne=0,je=Y.length){for(;ge<Le&&Ne<je;ge++,Ne++){let nt=$.charCodeAt(ge),ot=Y.charCodeAt(Ne);if(nt===ot)continue;if(nt>=128||ot>=128)return n($.toLowerCase(),Y.toLowerCase(),ge,Le,Ne,je);O(nt)&&(nt-=32),O(ot)&&(ot-=32);const pt=nt-ot;if(pt!==0)return pt}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstringIgnoreCase=w;function b($){return $>=48&&$<=57}e.isAsciiDigit=b;function O($){return $>=97&&$<=122}e.isLowerAsciiLetter=O;function H($){return $>=65&&$<=90}e.isUpperAsciiLetter=H;function x($,Y){return $.length===Y.length&&w($,Y)===0}e.equalsIgnoreCase=x;function _($,Y){const ge=Y.length;return Y.length>$.length?!1:w($,Y,0,ge)===0}e.startsWithIgnoreCase=_;function G($,Y){const ge=Math.min($.length,Y.length);let Le;for(Le=0;Le<ge;Le++)if($.charCodeAt(Le)!==Y.charCodeAt(Le))return Le;return ge}e.commonPrefixLength=G;function M($,Y){const ge=Math.min($.length,Y.length);let Le;const Ne=$.length-1,je=Y.length-1;for(Le=0;Le<ge;Le++)if($.charCodeAt(Ne-Le)!==Y.charCodeAt(je-Le))return Le;return ge}e.commonSuffixLength=M;function B($){return 55296<=$&&$<=56319}e.isHighSurrogate=B;function U($){return 56320<=$&&$<=57343}e.isLowSurrogate=U;function j($,Y){return($-55296<<10)+(Y-56320)+65536}e.computeCodePoint=j;function he($,Y,ge){const Le=$.charCodeAt(ge);if(B(Le)&&ge+1<Y){const Ne=$.charCodeAt(ge+1);if(U(Ne))return j(Le,Ne)}return Le}e.getNextCodePoint=he;function ie($,Y){const ge=$.charCodeAt(Y-1);if(U(ge)&&Y>1){const Le=$.charCodeAt(Y-2);if(B(Le))return j(Le,ge)}return ge}class V{get offset(){return this.e}constructor(Y,ge=0){this.c=Y,this.d=Y.length,this.e=ge}setOffset(Y){this.e=Y}prevCodePoint(){const Y=ie(this.c,this.e);return this.e-=Y>=65536?2:1,Y}nextCodePoint(){const Y=he(this.c,this.d,this.e);return this.e+=Y>=65536?2:1,Y}eol(){return this.e>=this.d}}e.CodePointIterator=V;class J{get offset(){return this.c.offset}constructor(Y,ge=0){this.c=new V(Y,ge)}nextGraphemeLength(){const Y=ze.getInstance(),ge=this.c,Le=ge.offset;let Ne=Y.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const je=ge.offset,Ye=Y.getGraphemeBreakType(ge.nextCodePoint());if(Pe(Ne,Ye)){ge.setOffset(je);break}Ne=Ye}return ge.offset-Le}prevGraphemeLength(){const Y=ze.getInstance(),ge=this.c,Le=ge.offset;let Ne=Y.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const je=ge.offset,Ye=Y.getGraphemeBreakType(ge.prevCodePoint());if(Pe(Ye,Ne)){ge.setOffset(je);break}Ne=Ye}return Le-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function re($,Y){return new J($,Y).nextGraphemeLength()}e.nextCharLength=re;function ve($,Y){return new J($,Y).prevGraphemeLength()}e.prevCharLength=ve;function ue($,Y){Y>0&&U($.charCodeAt(Y))&&Y--;const ge=Y+re($,Y);return[ge-ve($,ge),ge]}e.getCharContainingOffset=ue;function le($){const Y=new J($);let ge=0;for(;!Y.eol();)ge++,Y.nextGraphemeLength();return ge}e.charCount=le;let q;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q($){return q||(q=F()),q.test($)}e.containsRTL=Q;const me=/^[\t\n\r\x20-\x7E]*$/;function Ee($){return me.test($)}e.isBasicASCII=Ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function te($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=te;function ne($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ne;function de($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=de;function ee($,Y){if($.length<Y)return $;const ge=/\b/g;let Le=0;for(;ge.test($)&&!($.length-ge.lastIndex<Y);)Le=ge.lastIndex,ge.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ae($){return $&&($=$.replace(ce,"")),$}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function z($){return N($)?$.substr(1):$}e.stripUTF8BOM=z;function K($,Y){if(!$||!Y||$.length<Y.length)return!1;const ge=Y.length,Le=$.toLowerCase();let Ne=0,je=-1;for(;Ne<ge;){const Ye=Le.indexOf(Y[Ne],je+1);if(Ye<0)return!1;je=Ye,Ne++}return!0}e.fuzzyContains=K;function Z($,Y=!1){return $?(Y&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=Z;function fe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=fe;function Se($,Y=1){if(Y===0)return"";let ge=-1;do ge=$.indexOf(`
`,ge+1),Y--;while(Y>0&&ge>=0);return ge===-1?$:($[ge-1]==="\r"&&ge--,$.substr(0,ge))}e.getNLines=Se;function Ae($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ae;function we($){return ze.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=we;function Pe($,Y){return $===0?Y!==5&&Y!==7:$===2&&Y===3?!1:$===4||$===2||$===3||Y===4||Y===2||Y===3?!0:!($===8&&(Y===8||Y===9||Y===11||Y===12)||($===11||$===9)&&(Y===9||Y===10)||($===12||$===10)&&Y===10||Y===5||Y===13||Y===7||$===1||$===13&&Y===14||$===6&&Y===6)}var ke;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{static getInstance(){return ze.c||(ze.c=new ze),ze.c}constructor(){this.d=qe()}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const ge=this.d,Le=ge.length/3;let Ne=1;for(;Ne<=Le;)if(Y<ge[3*Ne])Ne=2*Ne;else if(Y>ge[3*Ne+1])Ne=2*Ne+1;else return ge[3*Ne+2];return 0}}ze.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt($,Y){if($===0)return 0;const ge=Qe($,Y);if(ge!==void 0)return ge;const Le=new V(Y,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=tt;function Qe($,Y){const ge=new V(Y,$);let Le=ge.prevCodePoint();for(;it(Le)||Le===65039||Le===8419;){if(ge.offset===0)return;Le=ge.prevCodePoint()}if(!de(Le))return;let Ne=ge.offset;return Ne>0&&ge.prevCodePoint()===8205&&(Ne=ge.offset),Ne}function it($){return 127995<=$&&$<=127999}var rt;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(Y){return Be.d.get(Array.from(Y))}static getLocales(){return Be.e.value}constructor(Y){this.f=Y}isAmbiguous(Y){return this.f.has(Y)}getPrimaryConfusable(Y){return this.f.get(Y)}getConfusableCodePoints(){return new Set(this.f.keys())}}u=Be,Be.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new a.LRUCachedFunction($=>{function Y(ot){const pt=new Map;for(let bt=0;bt<ot.length;bt+=2)pt.set(ot[bt],ot[bt+1]);return pt}function ge(ot,pt){const bt=new Map(ot);for(const[St,Pt]of pt)bt.set(St,Pt);return bt}function Le(ot,pt){if(!ot)return pt;const bt=new Map;for(const[St,Pt]of ot)pt.has(St)&&bt.set(St,Pt);return bt}const Ne=u.c.value;let je=$.filter(ot=>!ot.startsWith("_")&&ot in Ne);je.length===0&&(je=["_default"]);let Ye;for(const ot of je){const pt=Y(Ne[ot]);Ye=Le(Ye,pt)}const Xe=Y(Ne._common),nt=ge(Xe,Ye);return new Be(nt)}),Be.e=new A.Lazy(()=>Object.keys(Be.c.value).filter($=>!$.startsWith("_"))),e.AmbiguousCharacters=Be;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Y){return et.e().has(Y)}static get codePoints(){return et.e()}}et.d=void 0,e.InvisibleCharacters=et}),define(Ce[33],Ie([1,0,12,11,8,9]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(l){return l===47||l===92}e.isPathSeparator=P;function T(l){return l.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function y(l){return l.indexOf("/")===-1&&(l=T(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function m(l,v=a.posix.sep){if(!l)return"";const i=l.length,n=l.charCodeAt(0);if(P(n)){if(P(l.charCodeAt(1))&&!P(l.charCodeAt(2))){let w=3;const b=w;for(;w<i&&!P(l.charCodeAt(w));w++);if(b!==w&&!P(l.charCodeAt(w+1))){for(w+=1;w<i;w++)if(P(l.charCodeAt(w)))return l.slice(0,w+1).replace(/[\\/]/g,v)}}return v}else if(d(n)&&l.charCodeAt(1)===58)return P(l.charCodeAt(2))?l.slice(0,2)+v:l.slice(0,2);let h=l.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(P(l.charCodeAt(h)))return l.slice(0,h+1)}return""}e.getRoot=m;function L(l){if(!A.isWindows||!l||l.length<5)return!1;let v=l.charCodeAt(0);if(v!==92||(v=l.charCodeAt(1),v!==92))return!1;let i=2;const n=i;for(;i<l.length&&(v=l.charCodeAt(i),v!==92);i++);return!(n===i||(v=l.charCodeAt(i+1),isNaN(v)||v===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(l,v=A.isWindows){const i=v?I:S;return!(!l||l.length===0||/^\s+$/.test(l)||(i.lastIndex=0,i.test(l))||v&&k.test(l)||l==="."||l===".."||v&&l[l.length-1]==="."||v&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=C;function E(l,v,i){const n=l===v;return!i||n?n:!l||!v?!1:(0,u.equalsIgnoreCase)(l,v)}e.isEqual=E;function r(l,v,i,n=a.sep){if(l===v)return!0;if(!l||!v||v.length>l.length)return!1;if(i){if(!(0,u.startsWithIgnoreCase)(l,v))return!1;if(v.length===l.length)return!0;let w=v.length;return v.charAt(v.length-1)===n&&w--,l.charAt(w)===n}return v.charAt(v.length-1)!==n&&(v+=n),l.indexOf(v)===0}e.isEqualOrParent=r;function d(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=d;function f(l,v){return A.isWindows&&l.endsWith(":")&&(l+=a.sep),(0,a.isAbsolute)(l)||(l=(0,a.join)(v,l)),l=(0,a.normalize)(l),A.isWindows?(l=(0,u.rtrim)(l,a.sep),l.endsWith(":")&&(l+=a.sep)):(l=(0,u.rtrim)(l,a.sep),l||(l=a.sep)),l}e.sanitizeFilePath=f;function g(l){const v=(0,a.normalize)(l);return A.isWindows?l.length>3?!1:D(v)&&(l.length===2||v.charCodeAt(2)===92):v===a.posix.sep}e.isRootOrDriveLetter=g;function D(l,v=A.isWindows){return v?d(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function p(l){return D(l)?l[0]:void 0}e.getDriveLetter=p;function t(l,v,i){return v.length>l.length?-1:l===v?0:(i&&(l=l.toLowerCase(),v=v.toLowerCase()),l.indexOf(v))}e.indexOfPath=t;function o(l){const v=l.split(":");let i,n,h;for(const w of v){const b=Number(w);(0,R.isNumber)(b)?n===void 0?n=b:h===void 0&&(h=b):i=i?[i,w].join(":"):w}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:n!==void 0?n:void 0,column:h!==void 0?h:n!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(l,v,i=8){let n="";for(let w=0;w<i;w++)n+=s.charAt(Math.floor(Math.random()*s.length));let h;return v?h=`${v}-${n}`:h=n,l?(0,a.join)(l,h):h}e.randomPath=c}),define(Ce[111],Ie([1,0,28,8]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...ae){return function(N,z){for(let K=0,Z=ae.length;K<Z;K++){const fe=ae[K](N,z);if(fe)return fe}return null}}e.or=u,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ae,N,z){if(!z||z.length<N.length)return null;let K;return ae?K=A.startsWithIgnoreCase(z,N):K=z.indexOf(N)===0,K?N.length>0?[{start:0,end:N.length}]:[]:null}function P(ae,N){const z=N.toLowerCase().indexOf(ae.toLowerCase());return z===-1?null:[{start:z,end:z+ae.length}]}e.matchesContiguousSubString=P;function T(ae,N){return y(ae.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=T;function y(ae,N,z,K){if(z===ae.length)return[];if(K===N.length)return null;if(ae[z]===N[K]){let Z=null;return(Z=y(ae,N,z+1,K+1))?d({start:K,end:K+1},Z):null}return y(ae,N,z,K+1)}function m(ae){return 97<=ae&&ae<=122}function L(ae){return 65<=ae&&ae<=90}e.isUpper=L;function I(ae){return 48<=ae&&ae<=57}function S(ae){return ae===32||ae===9||ae===10||ae===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ae=>k.add(ae.charCodeAt(0)));function C(ae){return S(ae)||k.has(ae)}function E(ae,N){return ae===N||C(ae)&&C(N)}function r(ae){return m(ae)||L(ae)||I(ae)}function d(ae,N){return N.length===0?N=[ae]:ae.end===N[0].start?N[0].start=ae.start:N.unshift(ae),N}function f(ae,N){for(let z=N;z<ae.length;z++){const K=ae.charCodeAt(z);if(L(K)||I(K)||z>0&&!r(ae.charCodeAt(z-1)))return z}return ae.length}function g(ae,N,z,K){if(z===ae.length)return[];if(K===N.length)return null;if(ae[z]!==N[K].toLowerCase())return null;{let Z=null,fe=K+1;for(Z=g(ae,N,z+1,K+1);!Z&&(fe=f(N,fe))<N.length;)Z=g(ae,N,z+1,fe),fe++;return Z===null?null:d({start:K,end:K+1},Z)}}function D(ae){let N=0,z=0,K=0,Z=0,fe=0;for(let ke=0;ke<ae.length;ke++)fe=ae.charCodeAt(ke),L(fe)&&N++,m(fe)&&z++,r(fe)&&K++,I(fe)&&Z++;const Se=N/ae.length,Ae=z/ae.length,we=K/ae.length,Pe=Z/ae.length;return{upperPercent:Se,lowerPercent:Ae,alphaPercent:we,numericPercent:Pe}}function p(ae){const{upperPercent:N,lowerPercent:z}=ae;return z===0&&N>.6}function t(ae){const{upperPercent:N,lowerPercent:z,alphaPercent:K,numericPercent:Z}=ae;return z>.2&&N<.8&&K>.6&&Z<.2}function o(ae){let N=0,z=0,K=0,Z=0;for(let fe=0;fe<ae.length;fe++)K=ae.charCodeAt(fe),L(K)&&N++,m(K)&&z++,S(K)&&Z++;return(N===0||z===0)&&Z===0?ae.length<=30:N<=5}function s(ae,N){if(!N||(N=N.trim(),N.length===0)||!o(ae)||N.length>60)return null;const z=D(N);if(!t(z)){if(!p(z))return null;N=N.toLowerCase()}let K=null,Z=0;for(ae=ae.toLowerCase();Z<N.length&&(K=g(ae,N,0,Z))===null;)Z=f(N,Z+1);return K}e.matchesCamelCase=s;function c(ae,N,z=!1){if(!N||N.length===0)return null;let K=null,Z=0;for(ae=ae.toLowerCase(),N=N.toLowerCase();Z<N.length&&(K=l(ae,N,0,Z,z))===null;)Z=v(N,Z+1);return K}e.matchesWords=c;function l(ae,N,z,K,Z){if(z===ae.length)return[];if(K===N.length)return null;if(E(ae.charCodeAt(z),N.charCodeAt(K))){let fe=null,Se=K+1;if(fe=l(ae,N,z+1,K+1,Z),!Z)for(;!fe&&(Se=v(N,Se))<N.length;)fe=l(ae,N,z+1,Se,Z),Se++;return fe?ae.charCodeAt(z)!==N.charCodeAt(K)?fe:d({start:K,end:K+1},fe):null}else return null}function v(ae,N){for(let z=N;z<ae.length;z++)if(C(ae.charCodeAt(z))||z>0&&C(ae.charCodeAt(z-1)))return z;return ae.length}const i=u(e.matchesPrefix,s,P),n=u(e.matchesPrefix,s,T),h=new a.LRUCache(1e4);function w(ae,N,z=!1){if(typeof ae!="string"||typeof N!="string")return null;let K=h.get(ae);K||(K=new RegExp(A.convertSimple2RegExpPattern(ae),"i"),h.set(ae,K));const Z=K.exec(N);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:z?n(ae,N):i(ae,N)}e.matchesFuzzy=w;function b(ae,N){const z=me(ae,ae.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?H(z):null}e.matchesFuzzy2=b;function O(ae,N,z,K,Z,fe){const Se=Math.min(13,ae.length);for(;z<Se;z++){const Ae=me(ae,N,z,K,Z,fe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,fe]}e.anyScore=O;function H(ae){if(typeof ae>"u")return[];const N=[],z=ae[1];for(let K=ae.length-1;K>1;K--){const Z=ae[K]+z,fe=N[N.length-1];fe&&fe.end===Z?fe.end=Z+1:N.push({start:Z,end:Z+1})}return N}e.createMatches=H;const x=128;function _(){const ae=[],N=[];for(let z=0;z<=x;z++)N[z]=0;for(let z=0;z<=x;z++)ae.push(N.slice(0));return ae}function G(ae){const N=[];for(let z=0;z<=ae;z++)N[z]=0;return N}const M=G(2*x),B=G(2*x),U=_(),j=_(),he=_(),ie=!1;function V(ae,N,z,K,Z){function fe(Ae,we,Pe=" "){for(;Ae.length<we;)Ae=Pe+Ae;return Ae}let Se=` |   |${K.split("").map(Ae=>fe(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=z;Ae++)Ae===0?Se+=" |":Se+=`${N[Ae-1]}|`,Se+=ae[Ae].slice(0,Z+1).map(we=>fe(we.toString(),3)).join("|")+`
`;return Se}function J(ae,N,z,K){ae=ae.substr(N),z=z.substr(K),console.log(V(j,ae,ae.length,z,z.length)),console.log(V(he,ae,ae.length,z,z.length)),console.log(V(U,ae,ae.length,z,z.length))}function re(ae,N){if(N<0||N>=ae.length)return!1;const z=ae.codePointAt(N);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(z)}}function ve(ae,N){if(N<0||N>=ae.length)return!1;switch(ae.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function ue(ae,N,z){return N[ae]!==z[ae]}function le(ae,N,z,K,Z,fe,Se=!1){for(;N<z&&Z<fe;)ae[N]===K[Z]&&(Se&&(M[N]=Z),N+=1),Z+=1;return N===z}e.isPatternInWord=le;var q;(function(ae){ae[ae.Diag=1]="Diag",ae[ae.Left=2]="Left",ae[ae.LeftLeft=3]="LeftLeft"})(q||(q={}));var F;(function(ae){ae.Default=[-100,0];function N(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}ae.isDefault=N})(F=e.FuzzyScore||(e.FuzzyScore={}));class Q{constructor(N,z){this.firstMatchCanBeWeak=N,this.boostFullMatch=z}}Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Q;function me(ae,N,z,K,Z,fe,Se=Q.default){const Ae=ae.length>x?x:ae.length,we=K.length>x?x:K.length;if(z>=Ae||fe>=we||Ae-z>we-fe||!le(N,z,Ae,Z,fe,we,!0))return;Ee(Ae,we,z,fe,N,Z);let Pe=1,ke=1,ze=z,qe=fe;const tt=[!1];for(Pe=1,ze=z;ze<Ae;Pe++,ze++){const et=M[ze],$=B[ze],Y=ze+1<Ae?B[ze+1]:we;for(ke=et-fe+1,qe=et;qe<Y;ke++,qe++){let ge=Number.MIN_SAFE_INTEGER,Le=!1;qe<=$&&(ge=te(ae,N,ze,z,K,Z,qe,we,fe,U[Pe-1][ke-1]===0,tt));let Ne=0;ge!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=ge+j[Pe-1][ke-1]);const je=qe>et,Ye=je?j[Pe][ke-1]+(U[Pe][ke-1]>0?-5:0):0,Xe=qe>et+1&&U[Pe][ke-1]>0,nt=Xe?j[Pe][ke-2]+(U[Pe][ke-2]>0?-5:0):0;if(Xe&&(!je||nt>=Ye)&&(!Le||nt>=Ne))j[Pe][ke]=nt,he[Pe][ke]=3,U[Pe][ke]=0;else if(je&&(!Le||Ye>=Ne))j[Pe][ke]=Ye,he[Pe][ke]=2,U[Pe][ke]=0;else if(Le)j[Pe][ke]=Ne,he[Pe][ke]=1,U[Pe][ke]=U[Pe-1][ke-1]+1;else throw new Error("not possible")}}if(ie&&J(ae,z,K,fe),!tt[0]&&!Se.firstMatchCanBeWeak)return;Pe--,ke--;const Qe=[j[Pe][ke],fe];let it=0,rt=0;for(;Pe>=1;){let et=ke;do{const $=he[Pe][et];if($===3)et=et-2;else if($===2)et=et-1;else break}while(et>=1);it>1&&N[z+Pe-1]===Z[fe+ke-1]&&!ue(et+fe-1,K,Z)&&it+1>U[Pe][et]&&(et=ke),et===ke?it++:it=1,rt||(rt=et),Pe--,ke=et-1,Qe.push(ke)}we===Ae&&Se.boostFullMatch&&(Qe[0]+=2);const Be=rt-Ae;return Qe[0]-=Be,Qe}e.fuzzyScore=me;function Ee(ae,N,z,K,Z,fe){let Se=ae-1,Ae=N-1;for(;Se>=z&&Ae>=K;)Z[Se]===fe[Ae]&&(B[Se]=Ae,Se--),Ae--}function te(ae,N,z,K,Z,fe,Se,Ae,we,Pe,ke){if(N[z]!==fe[Se])return Number.MIN_SAFE_INTEGER;let ze=1,qe=!1;return Se===z-K?ze=ae[z]===Z[Se]?7:5:ue(Se,Z,fe)&&(Se===0||!ue(Se-1,Z,fe))?(ze=ae[z]===Z[Se]?7:5,qe=!0):re(fe,Se)&&(Se===0||!re(fe,Se-1))?ze=5:(re(fe,Se-1)||ve(fe,Se-1))&&(ze=5,qe=!0),ze>1&&z===K&&(ke[0]=!0),qe||(qe=ue(Se,Z,fe)||re(fe,Se-1)||ve(fe,Se-1)),z===K?Se>we&&(ze-=qe?3:5):Pe?ze+=qe?2:0:ze+=qe?0:1,Se+1===Ae&&(ze-=qe?3:5),ze}function ne(ae,N,z,K,Z,fe,Se){return ee(ae,N,z,K,Z,fe,!0,Se)}e.fuzzyScoreGracefulAggressive=ne;function de(ae,N,z,K,Z,fe,Se){return ee(ae,N,z,K,Z,fe,!1,Se)}e.fuzzyScoreGraceful=de;function ee(ae,N,z,K,Z,fe,Se,Ae){let we=me(ae,N,z,K,Z,fe,Ae);if(we&&!Se)return we;if(ae.length>=3){const Pe=Math.min(7,ae.length-1);for(let ke=z+1;ke<Pe;ke++){const ze=ce(ae,ke);if(ze){const qe=me(ze,ze.toLowerCase(),z,K,Z,fe,Ae);qe&&(qe[0]-=3,(!we||qe[0]>we[0])&&(we=qe))}}}return we}function ce(ae,N){if(N+1>=ae.length)return;const z=ae[N],K=ae[N+1];if(z!==K)return ae.slice(0,N)+K+z+ae.slice(N+2)}}),define(Ce[68],Ie([1,0,8]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return u(d,0)}e.hash=A;function u(d,f){switch(typeof d){case"object":return d===null?R(349,f):Array.isArray(d)?y(d,f):m(d,f);case"string":return T(d,f);case"boolean":return P(d,f);case"number":return R(d,f);case"undefined":return R(937,f);default:return R(617,f)}}e.doHash=u;function R(d,f){return(f<<5)-f+d|0}e.numberHash=R;function P(d,f){return R(d?433:863,f)}function T(d,f){f=R(149417,f);for(let g=0,D=d.length;g<D;g++)f=R(d.charCodeAt(g),f);return f}e.stringHash=T;function y(d,f){return f=R(104579,f),d.reduce((g,D)=>u(D,g),f)}function m(d,f){return f=R(181387,f),Object.keys(d).sort().reduce((g,D)=>(g=T(D,g),u(d[D],g)),f)}class L{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=u(f,this.g),this.g}}e.Hasher=L;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function S(d,f,g=32){const D=g-f,p=~((1<<D)-1);return(d<<f|(p&d)>>>D)>>>0}function k(d,f=0,g=d.byteLength,D=0){for(let p=0;p<g;p++)d[f+p]=D}function C(d,f,g="0"){for(;d.length<f;)d=g+d;return d}function E(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),f/4)}e.toHexString=E;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const g=f.length;if(g===0)return;const D=this.p;let p=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let c=o;if(a.isHighSurrogate(o))if(s+1<g){const l=f.charCodeAt(s+1);a.isLowSurrogate(l)?(s++,c=a.computeCodePoint(o,l)):c=65533}else{t=o;break}else a.isLowSurrogate(o)&&(c=65533);if(p=this.w(D,p,c),s++,s<g)o=f.charCodeAt(s);else break}this.r=p,this.u=t}w(f,g,D){return D<128?f[g++]=D:D<2048?(f[g++]=192|(D&1984)>>>6,f[g++]=128|(D&63)>>>0):D<65536?(f[g++]=224|(D&61440)>>>12,f[g++]=128|(D&4032)>>>6,f[g++]=128|(D&63)>>>0):(f[g++]=240|(D&1835008)>>>18,f[g++]=128|(D&258048)>>>12,f[g++]=128|(D&4032)>>>6,f[g++]=128|(D&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=r.g,g=this.q;for(let i=0;i<64;i+=4)f.setUint32(i,g.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)f.setUint32(i,S(f.getUint32(i-12,!1)^f.getUint32(i-32,!1)^f.getUint32(i-56,!1)^f.getUint32(i-64,!1),1),!1);let D=this.h,p=this.l,t=this.m,o=this.n,s=this.o,c,l,v;for(let i=0;i<80;i++)i<20?(c=p&t|~p&o,l=1518500249):i<40?(c=p^t^o,l=1859775393):i<60?(c=p&t|p&o|t&o,l=2400959708):(c=p^t^o,l=3395469782),v=S(D,5)+c+s+l+f.getUint32(i*4,!1)&4294967295,s=o,o=t,t=S(p,30),p=D,D=v;this.h=this.h+D&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}r.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=r}),define(Ce[112],Ie([1,0,109,111,68,12,11,8]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,m=[y,[]];function L(U,j,he,ie){if(!U||!j)return m;const V=U.length,J=j.length;if(V<J)return m;const re=U.toLowerCase();return I(j,he,J,U,re,V,ie)}e.scoreFuzzy=L;function I(U,j,he,ie,V,J,re){const ve=[],ue=[];for(let Q=0;Q<he;Q++){const me=Q*J,Ee=me-J,te=Q>0,ne=U[Q],de=j[Q];for(let ee=0;ee<J;ee++){const ce=ee>0,ae=me+ee,N=ae-1,z=Ee+ee-1,K=ce?ve[N]:0,Z=te&&ce?ve[z]:0,fe=te&&ce?ue[z]:0;let Se;!Z&&te?Se=0:Se=S(ne,de,ie,V,ee,fe),Se&&Z+Se>=K&&(re||te||V.startsWith(j,ee))?(ue[ae]=fe+1,ve[ae]=Z+Se):(ue[ae]=y,ve[ae]=K)}}const le=[];let q=he-1,F=J-1;for(;q>=0&&F>=0;){const Q=q*J+F;ue[Q]===y||(le.push(F),q--),F--}return[ve[he*J-1],le.reverse()]}function S(U,j,he,ie,V,J){let re=0;if(!k(j,ie[V]))return re;if(re+=1,J>0&&(re+=J*5),U===he[V]&&(re+=1),V===0)re+=8;else{const ve=C(he.charCodeAt(V-1));ve?re+=ve:(0,A.isUpper)(he.charCodeAt(V))&&J===0&&(re+=2)}return re}function k(U,j){return U===j?!0:U==="/"||U==="\\"?j==="/"||j==="\\":!1}function C(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function r(U,j,he=0,ie=0){const V=j;return V.values&&V.values.length>1?d(U,V.values,he,ie):f(U,j,he,ie)}e.scoreFuzzy2=r;function d(U,j,he,ie){let V=0;const J=[];for(const re of j){const[ve,ue]=f(U,re,he,ie);if(typeof ve!="number")return E;V+=ve,J.push(...ue)}return[V,n(J)]}function f(U,j,he,ie){const V=(0,A.fuzzyScore)(j.original,j.originalLowercase,he,U,U.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,A.createMatches)(V)]:E}const g=Object.freeze({score:0}),D=1<<18,p=1<<17,t=1<<16;function o(U,j,he,ie){const V=ie.values?ie.values:[ie];return(0,u.hash)({[ie.normalized]:{values:V.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:U,description:j,allowNonContiguousMatches:he}})}function s(U,j,he,ie,V){if(!U||!j.normalized)return g;const J=ie.getItemLabel(U);if(!J)return g;const re=ie.getItemDescription(U),ve=o(J,re,he,j),ue=V[ve];if(ue)return ue;const le=c(J,re,ie.getItemPath(U),j,he);return V[ve]=le,le}e.scoreItemFuzzy=s;function c(U,j,he,ie,V){const J=!he||!ie.containsPathSeparator;return he&&(P.isLinux?ie.pathNormalized===he:(0,T.equalsIgnoreCase)(ie.pathNormalized,he))?{score:D,labelMatch:[{start:0,end:U.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:ie.values&&ie.values.length>1?l(U,j,he,ie.values,J,V):v(U,j,he,ie,J,V)}function l(U,j,he,ie,V,J){let re=0;const ve=[],ue=[];for(const le of ie){const{score:q,labelMatch:F,descriptionMatch:Q}=v(U,j,he,le,V,J);if(q===y)return g;re+=q,F&&ve.push(...F),Q&&ue.push(...Q)}return{score:re,labelMatch:n(ve),descriptionMatch:n(ue)}}function v(U,j,he,ie,V,J){if(V||!j){const[re,ve]=L(U,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(re){const ue=(0,A.matchesPrefix)(ie.normalized,U);let le;return ue?(le=p,le+=Math.round(ie.normalized.length/U.length*100)):le=t,{score:le+re,labelMatch:ue||i(ve)}}}if(j){let re=j;he&&(re=`${j}${R.sep}`);const ve=re.length,ue=`${re}${U}`,[le,q]=L(ue,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(le){const F=i(q),Q=[],me=[];return F.forEach(Ee=>{Ee.start<ve&&Ee.end>ve?(Q.push({start:0,end:Ee.end-ve}),me.push({start:Ee.start,end:ve})):Ee.start>=ve?Q.push({start:Ee.start-ve,end:Ee.end-ve}):me.push(Ee)}),{score:le,labelMatch:Q,descriptionMatch:me}}}return g}function i(U){const j=[];if(!U)return j;let he;for(const ie of U)he&&he.end===ie?he.end+=1:(he={start:ie,end:ie+1},j.push(he));return j}function n(U){const j=U.sort((V,J)=>V.start-J.start),he=[];let ie;for(const V of j)!ie||!h(ie,V)?(ie=V,he.push(V)):(ie.start=Math.min(ie.start,V.start),ie.end=Math.max(ie.end,V.end));return he}function h(U,j){return!(U.end<j.start||j.end<U.start)}function w(U,j,he,ie,V,J){const re=s(U,he,ie,V,J),ve=s(j,he,ie,V,J),ue=re.score,le=ve.score;if((ue===D||le===D)&&ue!==le)return ue===D?-1:1;if(ue>t||le>t){if(ue!==le)return ue>le?-1:1;if(ue<p&&le<p){const ne=O(re.labelMatch,ve.labelMatch);if(ne!==0)return ne}const Ee=V.getItemLabel(U)||"",te=V.getItemLabel(j)||"";if(Ee.length!==te.length)return Ee.length-te.length}if(ue!==le)return ue>le?-1:1;const q=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,F=Array.isArray(ve.labelMatch)&&ve.labelMatch.length>0;if(q&&!F)return-1;if(F&&!q)return 1;const Q=b(U,re,V),me=b(j,ve,V);return Q&&me&&Q!==me?me>Q?-1:1:H(U,j,he,V)}e.compareItemsByFuzzyScore=w;function b(U,j,he){let ie=-1,V=-1;if(j.descriptionMatch&&j.descriptionMatch.length?ie=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(ie=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(V=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=he.getItemDescription(U);J&&(V+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(V=j.descriptionMatch[j.descriptionMatch.length-1].end);return V-ie}function O(U,j){if(!U&&!j||(!U||!U.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!U||!U.length)return 1;const he=U[0].start,V=U[U.length-1].end-he,J=j[0].start,ve=j[j.length-1].end-J;return V===ve?0:ve<V?1:-1}function H(U,j,he,ie){const V=ie.getItemLabel(U)||"",J=ie.getItemLabel(j)||"",re=ie.getItemDescription(U),ve=ie.getItemDescription(j),ue=V.length+(re?re.length:0),le=J.length+(ve?ve.length:0);if(ue!==le)return ue-le;const q=ie.getItemPath(U),F=ie.getItemPath(j);return q&&F&&q.length!==F.length?q.length-F.length:V!==J?(0,a.compareAnything)(V,J,he.normalized):re&&ve&&re!==ve?(0,a.compareAnything)(re,ve,he.normalized):q&&F&&q!==F?(0,a.compareAnything)(q,F,he.normalized):0}function x(U){return U.startsWith('"')&&U.endsWith('"')}const _=" ";function G(U){typeof U!="string"&&(U="");const j=U.toLowerCase(),{pathNormalized:he,normalized:ie,normalizedLowercase:V}=M(U),J=he.indexOf(R.sep)>=0,re=x(U);let ve;const ue=U.split(_);if(ue.length>1)for(const le of ue){const q=x(le),{pathNormalized:F,normalized:Q,normalizedLowercase:me}=M(le);Q&&(ve||(ve=[]),ve.push({original:le,originalLowercase:le.toLowerCase(),pathNormalized:F,normalized:Q,normalizedLowercase:me,expectContiguousMatch:q}))}return{original:U,originalLowercase:j,pathNormalized:he,normalized:ie,normalizedLowercase:V,values:ve,containsPathSeparator:J,expectContiguousMatch:re}}e.prepareQuery=G;function M(U){let j;P.isWindows?j=U.replace(/\//g,R.sep):j=U.replace(/\\/g,R.sep);const he=(0,T.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:he,normalizedLowercase:he.toLowerCase()}}function B(U){return Array.isArray(U)?G(U.map(j=>j.original).join(_)):G(U.original)}e.pieceToQuery=B}),define(Ce[164],Ie([1,0,111,8,52]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",P=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${P.source}`,"g");function y(d){return d.replace(T,(f,g)=>g?f:`\\${f}`)}e.escapeIcons=y;const m=new RegExp(`\\\\${P.source}`,"g");function L(d){return d.replace(m,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(d){return d.indexOf(R)===-1?d:d.replace(I,(f,g,D,p)=>D?f:g||p||"")}e.stripIcons=S;function k(d){return d?d.replace(/\$\((.*?)\)/g,(f,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=k;const C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(d){C.lastIndex=0;let f="";const g=[];let D=0;for(;;){const p=C.lastIndex,t=C.exec(d),o=d.substring(p,t?.index);if(o.length>0){f+=o;for(let s=0;s<o.length;s++)g.push(D)}if(!t)break;D+=t[0].length}return{text:f,iconOffsets:g}}e.parseLabelWithIcons=E;function r(d,f,g=!1){const{text:D,iconOffsets:p}=f;if(!p||p.length===0)return(0,a.matchesFuzzy)(d,D,g);const t=(0,A.ltrim)(D," "),o=D.length-t.length,s=(0,a.matchesFuzzy)(d,t,g);if(s)for(const c of s){const l=p[c.start+o]+o;c.start+=l,c.end+=l}return s}e.matchesFuzzyIconAware=r}),define(Ce[37],Ie([1,0,8]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(A||(A={})),function(u){const R="error",P="warning",T="warn",y="info",m="ignore";function L(S){return S?a.equalsIgnoreCase(R,S)?u.Error:a.equalsIgnoreCase(P,S)||a.equalsIgnoreCase(T,S)?u.Warning:a.equalsIgnoreCase(y,S)?u.Info:u.Ignore:u.Ignore}u.fromValue=L;function I(S){switch(S){case u.Error:return R;case u.Warning:return P;case u.Info:return y;default:return m}}u.toString=I}(A||(A={})),e.default=A}),define(Ce[69],Ie([1,0,17,8]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const C=k.charCodeAt(0),E=this.b.charCodeAt(this.c);return C-E}value(){return this.b[this.c]}}e.StringIterator=u;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,A.compareSubstring)(k,this.b,0,k.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class P{constructor(k=!0,C=!0){this.f=k,this.g=C}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let C=k.length-1;C>=0;C--,this.c--){const E=this.b.charCodeAt(C);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,A.compareSubstring)(k,this.b,0,k.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=P;var T;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(T||(T={}));class y{constructor(k,C){this.f=k,this.g=C,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(k,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,A.compare)(k,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(L||(L={}));class I{static forUris(k=()=>!1,C=()=>!1){return new I(new y(k,C))}static forPaths(k=!1){return new I(new P(void 0,!k))}static forStrings(){return new I(new u)}static forConfigKeys(){return new I(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,C){if(C){const E=C.slice(0);(0,a.shuffle)(E);for(const r of E)this.set(r,k)}else{const E=k.slice(0);(0,a.shuffle)(E);for(const r of E)this.set(r[0],r[1])}}set(k,C){const E=this.b.reset(k);let r;this.c||(this.c=new m,this.c.segment=E.value());const d=[];for(r=this.c;;){const g=E.cmp(r.segment);if(g>0)r.left||(r.left=new m,r.left.segment=E.value()),d.push([-1,r]),r=r.left;else if(g<0)r.right||(r.right=new m,r.right.segment=E.value()),d.push([1,r]),r=r.right;else if(E.hasNext())E.next(),r.mid||(r.mid=new m,r.mid.segment=E.value()),d.push([0,r]),r=r.mid;else break}const f=r.value;r.value=C,r.key=k;for(let g=d.length-1;g>=0;g--){const D=d[g][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const t=d[g][0],o=d[g+1][0];if(t===1&&o===1)d[g][1]=D.rotateLeft();else if(t===-1&&o===-1)d[g][1]=D.rotateRight();else if(t===1&&o===-1)D.right=d[g+1][1]=d[g+1][1].rotateRight(),d[g][1]=D.rotateLeft();else if(t===-1&&o===1)D.left=d[g+1][1]=d[g+1][1].rotateLeft(),d[g][1]=D.rotateRight();else throw new Error;if(g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}return f}get(k){return this.d(k)?.value}d(k){const C=this.b.reset(k);let E=this.c;for(;E;){const r=C.cmp(E.segment);if(r>0)E=E.left;else if(r<0)E=E.right;else if(C.hasNext())C.next(),E=E.mid;else break}return E}has(k){const C=this.d(k);return!(C?.value===void 0&&C?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,C){const E=this.b.reset(k),r=[];let d=this.c;for(;d;){const f=E.cmp(d.segment);if(f>0)r.push([-1,d]),d=d.left;else if(f<0)r.push([1,d]),d=d.right;else if(E.hasNext())E.next(),r.push([0,d]),d=d.mid;else break}if(!!d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this.f(d.right);if(f.key){const{key:g,value:D,segment:p}=f;this.e(f.key,!1),d.key=g,d.value=D,d.segment=p}}else{const f=d.left??d.right;if(r.length>0){const[g,D]=r[r.length-1];switch(g){case-1:D.left=f;break;case 0:D.mid=f;break;case 1:D.right=f;break}}else this.c=f}for(let f=r.length-1;f>=0;f--){const g=r[f][1];g.updateHeight();const D=g.balanceFactor();if(D>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),r[f][1]=g.rotateLeft()):D<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),r[f][1]=g.rotateRight()),f>0)switch(r[f-1][0]){case-1:r[f-1][1].left=r[f][1];break;case 1:r[f-1][1].right=r[f][1];break;case 0:r[f-1][1].mid=r[f][1];break}else this.c=r[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const C=this.b.reset(k);let E=this.c,r;for(;E;){const d=C.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(C.hasNext())C.next(),r=E.value||r,E=E.mid;else break}return E&&E.value||r}findSuperstr(k){return this.g(k,!1)}g(k,C){const E=this.b.reset(k);let r=this.c;for(;r;){const d=E.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(E.hasNext())E.next(),r=r.mid;else return r.mid?this.h(r.mid):C?r.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[C,E]of this)k(E,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const C=[];return this.j(k,C),C[Symbol.iterator]()}j(k,C){!k||(k.left&&this.j(k.left,C),k.value&&C.push([k.key,k.value]),k.mid&&this.j(k.mid,C),k.right&&this.j(k.right,C))}_isBalanced(){const k=C=>{if(!C)return!0;const E=C.balanceFactor();return E<-1||E>1?!1:k(C.left)&&k(C.right)};return k(this.c)}}e.TernarySearchTree=I}),define(Ce[2],Ie([1,0,12,11]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function T(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,c){return!s&&!c?"file":s}function m(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const L="",I="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(c){return c instanceof k?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,v,i,n,h=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=y(c,h),this.authority=l||L,this.path=m(this.scheme,v||L),this.query=i||L,this.fragment=n||L,T(this,h))}get fsPath(){return g(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:v,path:i,query:n,fragment:h}=c;return l===void 0?l=this.scheme:l===null&&(l=L),v===void 0?v=this.authority:v===null&&(v=L),i===void 0?i=this.path:i===null&&(i=L),n===void 0?n=this.query:n===null&&(n=L),h===void 0?h=this.fragment:h===null&&(h=L),l===this.scheme&&v===this.authority&&i===this.path&&n===this.query&&h===this.fragment?this:new E(l,v,i,n,h)}static parse(c,l=!1){const v=S.exec(c);return v?new E(v[2]||L,o(v[4]||L),o(v[5]||L),o(v[7]||L),o(v[9]||L),l):new E(L,L,L,L,L)}static file(c){let l=L;if(A.isWindows&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const v=c.indexOf(I,2);v===-1?(l=c.substring(2),c=I):(l=c.substring(2,v),c=c.substring(v)||I)}return new E("file",l,c,L,L)}static from(c){const l=new E(c.scheme,c.authority,c.path,c.query,c.fragment);return T(l,!0),l}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return A.isWindows&&c.scheme==="file"?v=k.file(a.win32.join(g(c,!0),...l)).path:v=a.posix.join(c.path,...l),c.with({path:v})}toString(c=!1){return D(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof k)return c;{const l=new E(c);return l._formatted=c.external,l._fsPath=c._sep===C?c.fsPath:null,l}}else return c}}e.URI=k;const C=A.isWindows?1:void 0;class E extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(c=!1){return c?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=C),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,c,l){let v,i=-1;for(let n=0;n<s.length;n++){const h=s.charCodeAt(n);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||c&&h===47||l&&h===91||l&&h===93||l&&h===58)i!==-1&&(v+=encodeURIComponent(s.substring(i,n)),i=-1),v!==void 0&&(v+=s.charAt(n));else{v===void 0&&(v=s.substr(0,n));const w=r[h];w!==void 0?(i!==-1&&(v+=encodeURIComponent(s.substring(i,n)),i=-1),v+=w):i===-1&&(i=n)}}return i!==-1&&(v+=encodeURIComponent(s.substring(i))),v!==void 0?v:s}function f(s){let c;for(let l=0;l<s.length;l++){const v=s.charCodeAt(l);v===35||v===63?(c===void 0&&(c=s.substr(0,l)),c+=r[v]):c!==void 0&&(c+=s[l])}return c!==void 0?c:s}function g(s,c){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,A.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=g;function D(s,c){const l=c?f:d;let v="",{scheme:i,authority:n,path:h,query:w,fragment:b}=s;if(i&&(v+=i,v+=":"),(n||i==="file")&&(v+=I,v+=I),n){let O=n.indexOf("@");if(O!==-1){const H=n.substr(0,O);n=n.substr(O+1),O=H.lastIndexOf(":"),O===-1?v+=l(H,!1,!1):(v+=l(H.substr(0,O),!1,!1),v+=":",v+=l(H.substr(O+1),!1,!0)),v+="@"}n=n.toLowerCase(),O=n.lastIndexOf(":"),O===-1?v+=l(n,!1,!0):(v+=l(n.substr(0,O),!1,!0),v+=n.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}v+=l(h,!0,!1)}return w&&(v+="?",v+=l(w,!1,!1)),b&&(v+="#",v+=c?b:d(b,!1,!1)),v}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(t)?s.replace(t,c=>p(c)):s}}),define(Ce[70],Ie([1,0,22,8,2]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,T)}e.stringify=R;function P(m){let L=JSON.parse(m);return L=y(L),L}e.parse=P;function T(m,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function y(m,L=0){if(!m||L>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return u.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof a.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=y(m[I],L+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=y(m[I],L+1))}return m}e.revive=y}),define(Ce[18],Ie([1,0,10,11,2]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,I,S){this.a[L]=I,this.b[L]=S}setConnectionToken(L,I){this.c[L]=I}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(r){return a.onUnexpectedError(r),L}const I=L.authority;let S=this.a[I];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const k=this.b[I],C=this.c[I];let E=`path=${encodeURIComponent(L.path)}`;return typeof C=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),u.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${S}:${k}`,path:this.f,query:E})}}e.RemoteAuthorities=new P,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(L){const I=this.b(L,se);return this.uriToBrowserUri(I)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${T.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||T.a,query:null,fragment:null}):L}asFileUri(L){const I=this.b(L,se);return this.uriToFileUri(I)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==T.a?L.authority:null,query:null,fragment:null}):L}b(L,I){return u.URI.isUri(L)?L:u.URI.parse(I.toUrl(L))}}T.a="vscode-app",e.FileAccess=new T;var y;(function(m){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(L.get("3"));const I="vscode-coi";function S(C){let E;typeof C=="string"?E=new URL(C).searchParams:C instanceof URL?E=C.searchParams:u.URI.isUri(C)&&(E=new URL(C.toString(!0)).searchParams);const r=E?.get(I);if(!!r)return L.get(r)}m.getHeadersFromQuery=S;function k(C,E,r){if(!globalThis.crossOriginIsolated)return;const d=E&&r?"3":r?"2":"1";C instanceof URLSearchParams?C.set(I,d):C[I]=d}m.addSearchParam=k})(y=e.COI||(e.COI={}))}),define(Ce[24],Ie([1,0,33,18,12,11,8,2]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(k){return(0,T.uriToFsPath)(k,!0)}e.originalFSPath=y;class m{constructor(C){this.a=C}compare(C,E,r=!1){return C===E?0:(0,P.compare)(this.getComparisonKey(C,r),this.getComparisonKey(E,r))}isEqual(C,E,r=!1){return C===E?!0:!C||!E?!1:this.getComparisonKey(C,r)===this.getComparisonKey(E,r)}getComparisonKey(C,E=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,E,r=!1){if(C.scheme===E.scheme){if(C.scheme===A.Schemas.file)return a.isEqualOrParent(y(C),y(E),this.a(C))&&C.query===E.query&&(r||C.fragment===E.fragment);if((0,e.isEqualAuthority)(C.authority,E.authority))return a.isEqualOrParent(C.path,E.path,this.a(C),"/")&&C.query===E.query&&(r||C.fragment===E.fragment)}return!1}joinPath(C,...E){return T.URI.joinPath(C,...E)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return u.posix.basename(C.path)}extname(C){return u.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let E;return C.scheme===A.Schemas.file?E=T.URI.file(u.dirname(y(C))).path:(E=u.posix.dirname(C.path),C.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),E="/")),C.with({path:E})}normalizePath(C){if(!C.path.length)return C;let E;return C.scheme===A.Schemas.file?E=T.URI.file(u.normalize(y(C))).path:E=u.posix.normalize(C.path),C.with({path:E})}relativePath(C,E){if(C.scheme!==E.scheme||!(0,e.isEqualAuthority)(C.authority,E.authority))return;if(C.scheme===A.Schemas.file){const f=u.relative(y(C),y(E));return R.isWindows?a.toSlashes(f):f}let r=C.path||"/";const d=E.path||"/";if(this.a(C)){let f=0;for(const g=Math.min(r.length,d.length);f<g&&!(r.charCodeAt(f)!==d.charCodeAt(f)&&r.charAt(f).toLowerCase()!==d.charAt(f).toLowerCase());f++);r=d.substr(0,f)+r.substr(f)}return u.posix.relative(r,d)}resolvePath(C,E){if(C.scheme===A.Schemas.file){const r=T.URI.file(u.resolve(y(C),E));return C.with({authority:r.authority,path:r.path})}return E=a.toPosixPath(E),C.with({path:u.posix.resolve(C.path,E)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,E){return C===E||C!==void 0&&E!==void 0&&(0,P.equalsIgnoreCase)(C,E)}hasTrailingPathSeparator(C,E=u.sep){if(C.scheme===A.Schemas.file){const r=y(C);return r.length>a.getRoot(r).length&&r[r.length-1]===E}else{const r=C.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,E=u.sep){return(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,E=u.sep){let r=!1;if(C.scheme===A.Schemas.file){const d=y(C);r=d!==void 0&&d.length===a.getRoot(d).length&&d[d.length-1]===E}else{E="/";const d=C.path;r=d.length===1&&d.charCodeAt(d.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path+"/"}):C}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(k=>k.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(k,C){const E=[];for(let r=0;r<k.length;r++){const d=C(k[r]);k.some((f,g)=>g===r?!1:(0,e.isEqualOrParent)(d,C(f)))||E.push(k[r])}return E}e.distinctParents=L;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function C(E){const r=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[D,p]=g.split(":");D&&p&&r.set(D,p)});const f=E.path.substring(0,E.path.indexOf(";"));return f&&r.set(k.META_DATA_MIME,f),r}k.parseMetaData=C})(I=e.DataUri||(e.DataUri={}));function S(k,C,E){if(C){let r=k.path;return r&&r[0]!==u.posix.sep&&(r=u.posix.sep+r),k.with({scheme:E,authority:C,path:r})}return k.with({scheme:E})}e.toLocalResource=S}),define(Ce[19],Ie([1,0,21,10,3,6,24,11,149]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(le){return!!le&&typeof le.then=="function"}e.isThenable=m;function L(le){const q=new a.CancellationTokenSource,F=le(q.token),Q=new Promise((me,Ee)=>{const te=q.token.onCancellationRequested(()=>{te.dispose(),q.dispose(),Ee(new A.CancellationError)});Promise.resolve(F).then(ne=>{te.dispose(),q.dispose(),me(ne)},ne=>{te.dispose(),q.dispose(),Ee(ne)})});return new class{cancel(){q.cancel()}then(me,Ee){return Q.then(me,Ee)}catch(me){return this.then(void 0,me)}finally(me){return Q.finally(me)}}}e.createCancelablePromise=L;function I(le,q,F){return new Promise((Q,me)=>{const Ee=q.onCancellationRequested(()=>{Ee.dispose(),Q(F)});le.then(Q,me).finally(()=>Ee.dispose())})}e.raceCancellation=I;function S(le,q){return new Promise((F,Q)=>{const me=q.onCancellationRequested(()=>{me.dispose(),Q(new A.CancellationError)});le.then(F,Q).finally(()=>me.dispose())})}e.raceCancellationError=S;async function k(le){let q=-1;const F=le.map((me,Ee)=>me.then(te=>(q=Ee,te))),Q=await Promise.race(F);return le.forEach((me,Ee)=>{Ee!==q&&me.cancel()}),Q}e.raceCancellablePromises=k;function C(le,q,F){let Q;const me=setTimeout(()=>{Q?.(void 0),F?.()},q);return Promise.race([le.finally(()=>clearTimeout(me)),new Promise(Ee=>Q=Ee)])}e.raceTimeout=C;function E(le){return new Promise((q,F)=>{const Q=le();m(Q)?Q.then(q,F):q(Q)})}e.asPromise=E;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(q){if(this.a){if(this.d=q,!this.b){const F=()=>{this.b=null;const Q=this.queue(this.d);return this.d=null,Q};this.b=new Promise(Q=>{this.a.then(F,F).then(Q)})}return new Promise((F,Q)=>{this.b.then(F,Q)})}return this.a=q(),new Promise((F,Q)=>{this.a.then(me=>{this.a=null,F(me)},me=>{this.a=null,Q(me)})})}}e.Throttler=r;class d{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(q,F){const me=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(q)===me&&this.a.delete(q)});return this.a.set(q,me),me}}e.SequencerByKey=f;const g=(le,q)=>{let F=!0;const Q=setTimeout(()=>{F=!1,q()},le);return{isTriggered:()=>F,dispose:()=>{clearTimeout(Q),F=!1}}},D=le=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,le())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class p{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,F=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((me,Ee)=>{this.d=me,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const Q=()=>{this.a=null,this.d?.(null)};return this.a=F===y.MicrotaskDelay?D(Q):g(F,Q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(q){this.a=new p(q),this.b=new r}trigger(q,F){return this.a.trigger(()=>this.b.queue(q),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this.a=!1,this.b=new Promise((q,F)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function c(le,q){return q?new Promise((F,Q)=>{const me=setTimeout(()=>{Ee.dispose(),F()},le),Ee=q.onCancellationRequested(()=>{clearTimeout(me),Ee.dispose(),Q(new A.CancellationError)})}):L(F=>c(le,F))}e.timeout=c;function l(le,q=0){const F=setTimeout(le,q);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=l;function v(le){const q=[];let F=0;const Q=le.length;function me(){return F<Q?le[F++]():null}function Ee(te){te!=null&&q.push(te);const ne=me();return ne?ne.then(Ee):Promise.resolve(q)}return Promise.resolve(null).then(Ee)}e.sequence=v;function i(le,q=Q=>!!Q,F=null){let Q=0;const me=le.length,Ee=()=>{if(Q>=me)return Promise.resolve(F);const te=le[Q++];return Promise.resolve(te()).then(de=>q(de)?Promise.resolve(de):Ee())};return Ee()}e.first=i;function n(le,q=Q=>!!Q,F=null){if(le.length===0)return Promise.resolve(F);let Q=le.length;const me=()=>{Q=-1;for(const Ee of le)Ee.cancel?.()};return new Promise((Ee,te)=>{for(const ne of le)ne.then(de=>{--Q>=0&&q(de)?(me(),Ee(de)):Q===0&&Ee(F)}).catch(de=>{--Q>=0&&(me(),te(de))})})}e.firstParallel=n;class h{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((F,Q)=>{this.f.push({factory:q,c:F,e:Q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const F=q.factory();F.then(q.c,q.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class w extends h{constructor(){super(1)}}e.Queue=w;class b{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const q=new ie;return this.b.add(q),q.p}d(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,F=P.extUri){const Q=F.getComparisonKey(q);let me=this.a.get(Q);return me||(me=new w,u.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(Q),this.f()}),this.a.set(Q,me)),me}f(){!this.d()||this.g()}g(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.g()}}e.ResourceQueue=b;class O{constructor(q,F){this.a=-1,typeof q=="function"&&typeof F=="number"&&this.setIfNotSet(q,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},F)}setIfNotSet(q,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},F))}}e.TimeoutTimer=O;class H{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,F){this.cancel(),this.a=setInterval(()=>{q()},F)}}e.IntervalTimer=H;class x{constructor(q,F){this.b=-1,this.a=q,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=x;class _{constructor(q,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=q,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=_;class G extends x{constructor(q,F){super(q,F),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=G;class M extends R.Disposable{constructor(q,F){super(),this.g=q,this.h=F,this.a=[],this.b=this.D(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of q)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,T.setTimeout0)(()=>{if(q)return;const F=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(le,q)=>{const F=requestIdleCallback(le,typeof q=="number"?{timeout:q}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(F))}}}}();class B{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=B;async function U(le,q,F){let Q;for(let me=0;me<F;me++)try{return await le()}catch(Ee){Q=Ee,await c(q)}throw Q}e.retry=U;class j{hasPending(q){return this.a?typeof q=="number"?this.a.taskId===q:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(q,F,Q){return this.a={taskId:q,cancel:()=>Q?.(),promise:F},F.then(()=>this.d(q),()=>this.d(q)),F}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this.b)this.b.run=q;else{let F,Q;const me=new Promise((Ee,te)=>{F=Ee,Q=te});this.b={run:q,promise:me,promiseResolve:F,promiseReject:Q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class he{constructor(q,F=()=>Date.now()){this.d=q,this.f=F,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class ie{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((q,F)=>{this.a=q,this.b=F})}complete(q){return new Promise(F=>{this.a(q),this.f=!0,F()})}error(q){return new Promise(F=>{this.b(q),this.d=!0,F()})}cancel(){new Promise(q=>{this.b(new A.CancellationError),this.d=!0,q()})}}e.DeferredPromise=ie;var V;(function(le){async function q(Q){let me;const Ee=await Promise.all(Q.map(te=>te.then(ne=>ne,ne=>{me||(me=ne)})));if(typeof me<"u")throw me;return Ee}le.settled=q;function F(Q){return new Promise(async(me,Ee)=>{try{await Q(me,Ee)}catch(te){Ee(te)}})}le.withAsyncBody=F})(V=e.Promises||(e.Promises={}));var J;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(J||(J={}));class re{static fromArray(q){return new re(F=>{F.emitMany(q)})}static fromPromise(q){return new re(async F=>{F.emitMany(await q)})}static fromPromises(q){return new re(async F=>{await Promise.all(q.map(async Q=>F.emitOne(await Q)))})}static merge(q){return new re(async F=>{await Promise.all(q.map(async Q=>{for await(const me of Q)F.emitOne(me)}))})}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const F={emitOne:Q=>this.g(Q),emitMany:Q=>this.h(Q),reject:Q=>this.k(Q)};try{await Promise.resolve(q(F)),this.j()}catch(Q){this.k(Q)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(q,F){return new re(async Q=>{for await(const me of q)Q.emitOne(F(me))})}map(q){return re.map(this,q)}static filter(q,F){return new re(async Q=>{for await(const me of q)F(me)&&Q.emitOne(me)})}filter(q){return re.filter(this,q)}static coalesce(q){return re.filter(q,F=>!!F)}coalesce(){return re.coalesce(this)}static async toPromise(q){const F=[];for await(const Q of q)F.push(Q);return F}toPromise(){return re.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}re.EMPTY=re.fromArray([]),e.AsyncIterableObject=re;class ve extends re{constructor(q,F){super(F),this.l=q}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ve;function ue(le){const q=new a.CancellationTokenSource,F=le(q.token);return new ve(q,async Q=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),Q.reject(new A.CancellationError)});try{for await(const Ee of F){if(q.token.isCancellationRequested)return;Q.emitOne(Ee)}me.dispose(),q.dispose()}catch(Ee){me.dispose(),q.dispose(),Q.reject(Ee)}})}e.createCancelableAsyncIterable=ue}),define(Ce[38],Ie([1,0,17,19,33,28,12,11,8]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",S=/\//g;function k(he,ie){switch(he){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${ie?`|${L}${I}+`:""})*?`}}function C(he,ie){if(!he)return[];const V=[];let J=!1,re=!1,ve="";for(const ue of he){switch(ue){case ie:if(!J&&!re){V.push(ve),ve="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":re=!0;break;case"]":re=!1;break}ve+=ue}return ve&&V.push(ve),V}e.splitGlobAware=C;function E(he){if(!he)return"";let ie="";const V=C(he,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))ie=".*";else{let J=!1;V.forEach((re,ve)=>{if(re===e.GLOBSTAR){if(J)return;ie+=k(2,ve===V.length-1)}else{let ue=!1,le="",q=!1,F="";for(const Q of re){if(Q!=="}"&&ue){le+=Q;continue}if(q&&(Q!=="]"||!F)){let me;Q==="-"?me=Q:(Q==="^"||Q==="!")&&!F?me="^":Q===e.GLOB_SPLIT?me="":me=(0,y.escapeRegExpCharacters)(Q),F+=me;continue}switch(Q){case"{":ue=!0;continue;case"[":q=!0;continue;case"}":{ie+=`(?:${C(le,",").map(te=>E(te)).join("|")})`,ue=!1,le="";break}case"]":{ie+="["+F+"]",q=!1,F="";break}case"?":ie+=I;continue;case"*":ie+=k(1);continue;default:ie+=(0,y.escapeRegExpCharacters)(Q)}}ve<V.length-1&&(V[ve+1]!==e.GLOBSTAR||ve+2<V.length)&&(ie+=L)}J=re===e.GLOBSTAR})}return ie}const r=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function c(he,ie){if(!he)return s;let V;typeof he!="string"?V=he.pattern:V=he,V=V.trim();const J=`${V}_${!!ie.trimForExclusions}`;let re=t.get(J);if(re)return l(re,he);let ve;return r.test(V)?re=i(V.substr(4),V):(ve=d.exec(v(V,ie)))?re=n(ve[1],V):(ie.trimForExclusions?g:f).test(V)?re=h(V,ie):(ve=D.exec(v(V,ie)))?re=w(ve[1].substr(1),V,!0):(ve=p.exec(v(V,ie)))?re=w(ve[1],V,!1):re=b(V),t.set(J,re),l(re,he)}function l(he,ie){if(typeof ie=="string")return he;const V=function(J,re){return(0,u.isEqualOrParent)(J,ie.base,!T.isLinux)?he((0,y.ltrim)(J.substr(ie.base.length),P.sep),re):null};return V.allBasenames=he.allBasenames,V.allPaths=he.allPaths,V.basenames=he.basenames,V.patterns=he.patterns,V}function v(he,ie){return ie.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function i(he,ie){return function(V,J){return typeof V=="string"&&V.endsWith(he)?ie:null}}function n(he,ie){const V=`/${he}`,J=`\\${he}`,re=function(ue,le){return typeof ue!="string"?null:le?le===he?ie:null:ue===he||ue.endsWith(V)||ue.endsWith(J)?ie:null},ve=[he];return re.basenames=ve,re.patterns=[ie],re.allBasenames=ve,re}function h(he,ie){const V=U(he.slice(1,-1).split(",").map(le=>c(le,ie)).filter(le=>le!==s),he),J=V.length;if(!J)return s;if(J===1)return V[0];const re=function(le,q){for(let F=0,Q=V.length;F<Q;F++)if(V[F](le,q))return he;return null},ve=V.find(le=>!!le.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const ue=V.reduce((le,q)=>q.allPaths?le.concat(q.allPaths):le,[]);return ue.length&&(re.allPaths=ue),re}function w(he,ie,V){const J=P.sep===P.posix.sep,re=J?he:he.replace(S,P.sep),ve=P.sep+re,ue=P.posix.sep+he;let le;return V?le=function(q,F){return typeof q=="string"&&(q===re||q.endsWith(ve)||!J&&(q===he||q.endsWith(ue)))?ie:null}:le=function(q,F){return typeof q=="string"&&(q===re||!J&&q===he)?ie:null},le.allPaths=[(V?"*/":"./")+he],le}function b(he){try{const ie=new RegExp(`^${E(he)}$`);return function(V){return ie.lastIndex=0,typeof V=="string"&&ie.test(V)?he:null}}catch{return s}}function O(he,ie,V){return!he||typeof ie!="string"?!1:H(he)(ie,void 0,V)}e.match=O;function H(he,ie={}){if(!he)return o;if(typeof he=="string"||x(he)){const V=c(he,ie);if(V===s)return o;const J=function(re,ve){return!!V(re,ve)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return M(he,ie)}e.parse=H;function x(he){const ie=he;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=x;function _(he){return he.allBasenames||[]}e.getBasenameTerms=_;function G(he){return he.allPaths||[]}e.getPathTerms=G;function M(he,ie){const V=U(Object.getOwnPropertyNames(he).map(le=>B(le,he[le],ie)).filter(le=>le!==s)),J=V.length;if(!J)return s;if(!V.some(le=>!!le.requiresSiblings)){if(J===1)return V[0];const le=function(Q,me){let Ee;for(let te=0,ne=V.length;te<ne;te++){const de=V[te](Q,me);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(Ee||(Ee=[]),Ee.push(de))}return Ee?(async()=>{for(const te of Ee){const ne=await te;if(typeof ne=="string")return ne}return null})():null},q=V.find(Q=>!!Q.allBasenames);q&&(le.allBasenames=q.allBasenames);const F=V.reduce((Q,me)=>me.allPaths?Q.concat(me.allPaths):Q,[]);return F.length&&(le.allPaths=F),le}const re=function(le,q,F){let Q,me;for(let Ee=0,te=V.length;Ee<te;Ee++){const ne=V[Ee];ne.requiresSiblings&&F&&(q||(q=(0,P.basename)(le)),Q||(Q=q.substr(0,q.length-(0,P.extname)(le).length)));const de=ne(le,q,Q,F);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(me||(me=[]),me.push(de))}return me?(async()=>{for(const Ee of me){const te=await Ee;if(typeof te=="string")return te}return null})():null},ve=V.find(le=>!!le.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const ue=V.reduce((le,q)=>q.allPaths?le.concat(q.allPaths):le,[]);return ue.length&&(re.allPaths=ue),re}function B(he,ie,V){if(ie===!1)return s;const J=c(he,V);if(J===s)return s;if(typeof ie=="boolean")return J;if(ie){const re=ie.when;if(typeof re=="string"){const ve=(ue,le,q,F)=>{if(!F||!J(ue,le))return null;const Q=re.replace("$(basename)",()=>q),me=F(Q);return(0,A.isThenable)(me)?me.then(Ee=>Ee?he:null):me?he:null};return ve.requiresSiblings=!0,ve}}return J}function U(he,ie){const V=he.filter(le=>!!le.basenames);if(V.length<2)return he;const J=V.reduce((le,q)=>{const F=q.basenames;return F?le.concat(F):le},[]);let re;if(ie){re=[];for(let le=0,q=J.length;le<q;le++)re.push(ie)}else re=V.reduce((le,q)=>{const F=q.patterns;return F?le.concat(F):le},[]);const ve=function(le,q){if(typeof le!="string")return null;if(!q){let Q;for(Q=le.length;Q>0;Q--){const me=le.charCodeAt(Q-1);if(me===47||me===92)break}q=le.substr(Q)}const F=J.indexOf(q);return F!==-1?re[F]:null};ve.basenames=J,ve.patterns=re,ve.allBasenames=J;const ue=he.filter(le=>!le.basenames);return ue.push(ve),ue}function j(he,ie){return(0,a.equals)(he,ie,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=j}),define(Ce[113],Ie([1,0,10,164,24,8,2]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",f=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(d,f=0){return this.value+=S(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(g,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,f){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}appendLink(d,f,g){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(d),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(d,f){const g=new RegExp((0,R.escapeRegExpCharacters)(f),"g");return d.replace(g,(D,p)=>d.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=y;function m(r){return L(r)?!r.value:Array.isArray(r)?r.every(m):!0}e.isEmptyMarkdownString=m;function L(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons&&r.supportHtml===d.supportHtml&&(r.baseUri===d.baseUri||!!r.baseUri&&!!d.baseUri&&(0,u.isEqual)(P.URI.from(r.baseUri),P.URI.from(d.baseUri)))}e.markdownStringEqual=I;function S(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function k(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function C(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function E(r){const d=[],f=r.split("|").map(D=>D.trim());r=f[0];const g=f[1];if(g){const D=/height=(\d+)/.exec(g),p=/width=(\d+)/.exec(g),t=D?D[1]:"",o=p?p[1]:"",s=isFinite(parseInt(o)),c=isFinite(parseInt(t));s&&d.push(`width="${o}"`),c&&d.push(`height="${t}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=E}),define(Ce[114],Ie([1,0,17,33,12,11,24,8]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(s,c){const{os:l,tildify:v,relative:i}=c;if(i){const w=m(s,i,l);if(typeof w=="string")return w}let n=s.fsPath;if(l===1&&!R.isWindows?n=n.replace(/\//g,"\\"):l!==1&&R.isWindows&&(n=n.replace(/\\/g,"/")),l!==1&&v?.userHome){const w=v.userHome.fsPath;let b;s.scheme!==v.userHome.scheme&&s.path.startsWith(u.posix.sep)?b=v.userHome.with({path:s.path}).fsPath:b=s.fsPath,n=S(b,w,l)}return(l===1?u.win32:u.posix).normalize(L(n,l===1))}e.getPathLabel=y;function m(s,c,l){const v=l===1?u.win32:u.posix,i=l===3?P.extUri:P.extUriIgnorePathCase,n=c.getWorkspace(),h=(0,a.firstOrDefault)(n.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=h.uri.with({path:s.path}));const w=c.getWorkspaceFolder(s);if(!w)return;let b;if(i.isEqual(w.uri,s)?b="":b=i.relativePath(w.uri,s)??"",b&&(b=v.normalize(b)),n.folders.length>1&&!c.noPrefix){const O=w.name?w.name:i.basenameOrAuthority(w.uri);b=b?`${O} \u2022 ${b}`:O}return b}function L(s,c=R.isWindows){return(0,A.hasDriveLetter)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let I=Object.create(null);function S(s,c,l=R.OS){if(l===1||!s||!c)return s;let v=I.original===c?I.normalized:void 0;v||(v=c,R.isWindows&&(v=(0,A.toSlashes)(v)),v=`${(0,T.rtrim)(v,u.posix.sep)}${u.posix.sep}`,I={original:c,normalized:v});let i=s;return R.isWindows&&(i=(0,A.toSlashes)(i)),(l===3?i.startsWith(v):(0,T.startsWithIgnoreCase)(i,v))?`~/${i.substr(v.length)}`:s}e.tildify=S;function k(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=k;const C="\u2026",E="\\\\",r="~";function d(s,c=u.sep){const l=new Array(s.length);let v=!1;for(let i=0;i<s.length;i++){const n=s[i];if(n===""){l[i]=`.${c}`;continue}if(!n){l[i]=n;continue}v=!0;let h="",w=n;w.indexOf(E)===0?(h=w.substr(0,w.indexOf(E)+E.length),w=w.substr(w.indexOf(E)+E.length)):w.indexOf(c)===0?(h=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(r)===0&&(h=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const b=w.split(c);for(let O=1;v&&O<=b.length;O++)for(let H=b.length-O;v&&H>=0;H--){v=!1;let x=b.slice(H,H+O).join(c);for(let _=0;!v&&_<s.length;_++)if(_!==i&&s[_]&&s[_].indexOf(x)>-1){const G=H+O===b.length,M=H>0&&s[_].indexOf(c)>-1?c+x:x,B=s[_].endsWith(M);v=!G||B}if(!v){let _="";(b[0].endsWith(":")||h!=="")&&(H===1&&(H=0,O++,x=b[0]+c+x),H>0&&(_=b[0]+c),_=h+_),H>0&&(_=_+C+c),_=_+x,H+O<b.length&&(_=_+c+C),l[i]=_}}v&&(l[i]=n)}return l}e.shorten=d;var f;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function g(s,c=Object.create(null)){const l=[];let v=!1,i="";for(const n of s)if(n==="$"||v&&n==="{")i&&l.push({value:i,type:f.TEXT}),i="",v=!0;else if(n==="}"&&v){const h=c[i];if(typeof h=="string")h.length&&l.push({value:h,type:f.VARIABLE});else if(h){const w=l[l.length-1];(!w||w.type!==f.SEPARATOR)&&l.push({value:h.label,type:f.SEPARATOR})}i="",v=!1}else i+=n;return i&&!v&&l.push({value:i,type:f.TEXT}),l.filter((n,h)=>{if(n.type===f.SEPARATOR){const w=l[h-1],b=l[h+1];return[w,b].every(O=>O&&(O.type===f.VARIABLE||O.type===f.TEXT)&&O.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=g;function D(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function p(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(s){const c=s.indexOf("/")!==-1?u.posix:u.win32,l=c.basename(s),v=c.dirname(s);return l.length?{name:l,parentPath:v}:{name:v,parentPath:""}}e.splitName=o}),define(Ce[115],Ie([1,0,22,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(I){return I.toJSON()}class R{constructor(S){this.a=S}transformIncoming(S){const k=this.a.transformIncoming(S);return k===S?S:u(A.URI.from(k))}transformOutgoing(S){const k=this.a.transformOutgoing(S);return k===S?S:u(A.URI.from(k))}transformOutgoingURI(S){const k=this.a.transformOutgoing(S);return k===S?S:A.URI.from(k)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function P(I,S,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof A.URI)return S.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const E=P(I[C],S,k+1);E!==null&&(I[C]=E)}}return null}function T(I,S){const k=P(I,S,0);return k===null?I:k}e.transformOutgoingURIs=T;function y(I,S,k,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?A.URI.revive(S.transformIncoming(I)):S.transformIncoming(I);if(I instanceof a.VSBuffer)return null;for(const E in I)if(Object.hasOwnProperty.call(I,E)){const r=y(I[E],S,k,C+1);r!==null&&(I[E]=r)}}return null}function m(I,S){const k=y(I,S,!1,0);return k===null?I:k}e.transformIncomingURIs=m;function L(I,S){const k=y(I,S,!0,0);return k===null?I:k}e.transformAndReviveIncomingURIs=L}),define(Ce[29],Ie([1,0,71,89,324,19,33,87,12,11,24,2]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function k(M,B=S.UNLINK){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===S.UNLINK?E(M):C(M)}async function C(M){try{const B=(0,P.randomPath)((0,A.tmpdir)());try{await a.promises.rename(M,B)}catch(U){return U.code==="ENOENT"?void 0:E(M)}E(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(M){return(0,u.promisify)(a.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function r(M){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function d(M,B){return D(await(B?f(M):(0,u.promisify)(a.readdir)(M)))}async function f(M){try{return await(0,u.promisify)(a.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const B=[],U=await d(M);for(const j of U){let he=!1,ie=!1,V=!1;try{const J=await e.Promises.lstat((0,y.join)(M,j));he=J.isFile(),ie=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}B.push({name:j,isFile:()=>he,isDirectory:()=>ie,isSymbolicLink:()=>V})}return B}function g(M){return D(a.readdirSync(M))}e.readdirSync=g;function D(M){return M.map(B=>typeof B=="string"?m.isMacintosh?(0,T.normalizeNFC)(B):B:(B.name=m.isMacintosh?(0,T.normalizeNFC)(B.name):B.name,B))}async function p(M){const B=await d(M),U=[];for(const j of B)await o.existsDirectory((0,y.join)(M,j))&&U.push(j);return U}function t(M,B=1e3){return new Promise(U=>{let j=!1;const he=setInterval(()=>{j||(j=!0,a.access(M,ie=>{j=!1,ie&&(clearInterval(he),U(void 0))}))},B)})}e.whenDeleted=t;var o;(function(M){async function B(he){let ie;try{if(ie=await e.Promises.lstat(he),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(he),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(m.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(he)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw J}throw V}}M.stat=B;async function U(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isFile()&&V?.dangling!==!0}catch{}return!1}M.existsFile=U;async function j(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isDirectory()&&V?.dangling!==!0}catch{}return!1}M.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function c(M,B,U){return s.queueFor(I.URI.file(M),L.extUriBiasedIgnorePathCase).queue(()=>{const j=h(U);return new Promise((he,ie)=>i(M,B,j,V=>V?ie(V):he()))})}let l=!0;function v(M){l=M}e.configureFlushOnWrite=v;function i(M,B,U,j){if(!l)return a.writeFile(M,B,{mode:U.mode,flag:U.flag},j);a.open(M,U.flag,U.mode,(he,ie)=>{if(he)return j(he);a.writeFile(ie,B,V=>{if(V)return a.close(ie,()=>j(V));a.fdatasync(ie,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),v(!1)),a.close(ie,re=>j(re))))})})}function n(M,B,U){const j=h(U);if(!l)return a.writeFileSync(M,B,{mode:j.mode,flag:j.flag});const he=a.openSync(M,j.flag,j.mode);try{a.writeFileSync(he,B);try{a.fdatasyncSync(he)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),v(!1)}}finally{a.closeSync(he)}}e.writeFileSync=n;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function w(M,B){if(M!==B)try{await e.Promises.rename(M,B)}catch(U){if(M.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await b(M,B,{preserveSymlinks:!1}),await k(M,S.MOVE);else throw U}}async function b(M,B,U){return H(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const O=511;async function H(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:j,symbolicLink:he}=await o.stat(M);if(he){if(U.options.preserveSymlinks)try{return await G(M,B,U)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(he.dangling)return}return j.isDirectory()?x(M,B,j.mode&O,U):_(M,B,j.mode&O)}async function x(M,B,U,j){await e.Promises.mkdir(B,{recursive:!0,mode:U});const he=await d(M);for(const ie of he)await H((0,y.join)(M,ie),(0,y.join)(B,ie),j)}async function _(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function G(M,B,U){let j=await e.Promises.readlink(M);(0,P.isEqualOrParent)(j,U.root.source,!m.isLinux)&&(j=(0,y.join)(U.root.target,j.substr(U.root.source.length+1))),await e.Promises.symlink(j,B)}e.Promises=new class{get access(){return(0,u.promisify)(a.access)}get stat(){return(0,u.promisify)(a.stat)}get lstat(){return(0,u.promisify)(a.lstat)}get utimes(){return(0,u.promisify)(a.utimes)}get read(){return(M,B,U,j,he)=>new Promise((ie,V)=>{a.read(M,B,U,j,he,(J,re,ve)=>J?V(J):ie({bytesRead:re,buffer:ve}))})}get readFile(){return(0,u.promisify)(a.readFile)}get write(){return(M,B,U,j,he)=>new Promise((ie,V)=>{a.write(M,B,U,j,he,(J,re,ve)=>J?V(J):ie({bytesWritten:re,buffer:ve}))})}get appendFile(){return(0,u.promisify)(a.appendFile)}get fdatasync(){return(0,u.promisify)(a.fdatasync)}get truncate(){return(0,u.promisify)(a.truncate)}get rename(){return(0,u.promisify)(a.rename)}get copyFile(){return(0,u.promisify)(a.copyFile)}get open(){return(0,u.promisify)(a.open)}get close(){return(0,u.promisify)(a.close)}get symlink(){return(0,u.promisify)(a.symlink)}get readlink(){return(0,u.promisify)(a.readlink)}get chmod(){return(0,u.promisify)(a.chmod)}get mkdir(){return(0,u.promisify)(a.mkdir)}get unlink(){return(0,u.promisify)(a.unlink)}get rmdir(){return(0,u.promisify)(a.rmdir)}get realpath(){return(0,u.promisify)(a.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return k}get move(){return w}get copy(){return b}}}),define(Ce[116],Ie([1,0,71,12,11,8,29]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(S){if(u.isLinux)return S;const k=(0,A.dirname)(S);if(S===k)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const r=(0,P.readdirSync)(k).filter(d=>d.toLowerCase()===C);if(r.length===1){const d=T(k);if(d)return(0,A.join)(d,r[0])}else if(r.length>1){const d=r.indexOf(C);if(d>=0){const f=T(k);if(f)return(0,A.join)(f,r[d])}}}catch{}return null}e.realcaseSync=T;async function y(S){if(u.isLinux)return S;const k=(0,A.dirname)(S);if(S===k)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const r=(await P.Promises.readdir(k)).filter(d=>d.toLowerCase()===C);if(r.length===1){const d=await y(k);if(d)return(0,A.join)(d,r[0])}else if(r.length>1){const d=r.indexOf(C);if(d>=0){const f=await y(k);if(f)return(0,A.join)(f,r[d])}}}catch{}return null}e.realcase=y;async function m(S){try{return await P.Promises.realpath(S)}catch{const C=I(S);return await P.Promises.access(C,a.constants.R_OK),C}}e.realpath=m;function L(S){try{return a.realpathSync(S)}catch{const C=I(S);return a.accessSync(C,a.constants.R_OK),C}}e.realpathSync=L;function I(S){return(0,R.rtrim)((0,A.normalize)(S),A.sep)}}),define(Ce[117],Ie([1,0,12,11,36,110,9,29]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(I=u.env){return I.comspec||"cmd.exe"}e.getWindowsShell=y;function m(I){let S=[],k=!1;const C=function(E){if(k){S.push(E);return}(!I.send(E,d=>{if(d&&console.error(d),k=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(g=>C(g))}})||A.isWindows)&&(k=!0)};return{send:C}}e.createQueuedSender=m;var L;(function(I){async function S(k,C,E){if(a.isAbsolute(k))return k;if(C===void 0&&(C=u.cwd()),a.dirname(k)!=="."||(E===void 0&&P.isString(u.env.PATH)&&(E=u.env.PATH.split(a.delimiter)),E===void 0||E.length===0))return a.join(C,k);async function d(f){if(await T.Promises.exists(f)){let g;try{g=await T.Promises.stat(f)}catch(D){D.message.startsWith("EACCES")&&(g=await T.Promises.lstat(f))}return g?!g.isDirectory():!1}return!1}for(const f of E){let g;if(a.isAbsolute(f)?g=a.join(f,k):g=a.join(C,f,k),await d(g))return g;let D=g+".com";if(await d(D)||(D=g+".exe",await d(D)))return D}return a.join(C,k)}I.findExecutable=S})(L=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(se,e,a,A){var u=arguments.length,R=u<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,a):A,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(se,e,a,A);else for(var T=se.length-1;T>=0;T--)(P=se[T])&&(R=(u<3?P(R):u>3?P(e,a,R):P(e,a))||R);return u>3&&R&&Object.defineProperty(e,a,R),R};define(Ce[118],Ie([1,0,17,19,22,21,62,10,3,6,70,8,9]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(k||(k={}));function C(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(E||(E={}));function r(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(d||(d={}));function f(ie){let V=0;for(let J=0;;J+=7){const re=ie.read(1);if(V|=(re.buffer[0]&127)<<J,!(re.buffer[0]&128))return V}}const g=s(0);function D(ie,V){if(V===0){ie.write(g);return}let J=0;for(let ve=V;ve!==0;ve=ve>>>7)J++;const re=u.VSBuffer.alloc(J);for(let ve=0;V!==0;ve++)re.buffer[ve]=V&127,V=V>>>7,V>0&&(re.buffer[ve]|=128);ie.write(re)}class p{constructor(V){this.b=V,this.a=0}read(V){const J=this.b.slice(this.a,this.a+V);return this.a+=J.byteLength,J}}e.BufferReader=p;class t{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=t;var o;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(o||(o={}));function s(ie){const V=u.VSBuffer.alloc(1);return V.writeUInt8(ie,0),V}const c={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},l=typeof Buffer<"u";function v(ie,V){if(typeof V>"u")ie.write(c.Undefined);else if(typeof V=="string"){const J=u.VSBuffer.fromString(V);ie.write(c.String),D(ie,J.byteLength),ie.write(J)}else if(l&&Buffer.isBuffer(V)){const J=u.VSBuffer.wrap(V);ie.write(c.Buffer),D(ie,J.byteLength),ie.write(J)}else if(V instanceof u.VSBuffer)ie.write(c.VSBuffer),D(ie,V.byteLength),ie.write(V);else if(Array.isArray(V)){ie.write(c.Array),D(ie,V.length);for(const J of V)v(ie,J)}else if(typeof V=="number"&&(V|0)===V)ie.write(c.Uint),D(ie,V);else{const J=u.VSBuffer.fromString(JSON.stringify(V));ie.write(c.Object),D(ie,J.byteLength),ie.write(J)}}e.serialize=v;function i(ie){switch(ie.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ie.read(f(ie)).toString();case o.Buffer:return ie.read(f(ie)).buffer;case o.VSBuffer:return ie.read(f(ie));case o.Array:{const J=f(ie),re=[];for(let ve=0;ve<J;ve++)re.push(i(ie));return re}case o.Object:return JSON.parse(ie.read(f(ie)).toString());case o.Int:return f(ie)}}e.deserialize=i;class n{constructor(V,J,re=null,ve=1e3){this.h=V,this.j=J,this.k=re,this.l=ve,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(V,J){this.b.set(V,J),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const J=this.o([V.type]);this.k?.logOutgoing(J,0,1,r(V.type));return}case 201:case 202:case 204:case 203:{const J=this.o([V.type,V.id],V.data);this.k?.logOutgoing(J,V.id,1,r(V.type),V.data);return}}}o(V,J=void 0){const re=new t;return v(re,V),v(re,J),this.p(re.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const J=new p(V),re=i(J),ve=i(J),ue=re[0];switch(ue){case 100:return this.k?.logIncoming(V.byteLength,re[1],1,`${C(ue)}: ${re[2]}.${re[3]}`,ve),this.s({type:ue,id:re[1],channelName:re[2],name:re[3],arg:ve});case 102:return this.k?.logIncoming(V.byteLength,re[1],1,`${C(ue)}: ${re[2]}.${re[3]}`,ve),this.t({type:ue,id:re[1],channelName:re[2],name:re[3],arg:ve});case 101:return this.k?.logIncoming(V.byteLength,re[1],1,`${C(ue)}`),this.u({type:ue,id:re[1]});case 103:return this.k?.logIncoming(V.byteLength,re[1],1,`${C(ue)}`),this.u({type:ue,id:re[1]})}}s(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const re=new R.CancellationTokenSource;let ve;try{ve=J.call(this.j,V.name,V.arg,re.token)}catch(q){ve=Promise.reject(q)}const ue=V.id;ve.then(q=>{this.m({id:ue,data:q,type:201}),this.d.delete(V.id)},q=>{q instanceof Error?this.m({id:ue,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ue,data:q,type:203}),this.d.delete(V.id)});const le=(0,m.toDisposable)(()=>re.cancel());this.d.set(V.id,le)}t(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const re=V.id,ue=J.listen(this.j,V.name,V.arg)(le=>this.m({id:re,data:le,type:204}));this.d.set(V.id,ue)}u(V){const J=this.d.get(V.id);J&&(J.dispose(),this.d.delete(V.id))}v(V){let J=this.g.get(V.channelName);J||(J=[],this.g.set(V.channelName,J));const re=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:V,timeoutTimer:re})}w(V){const J=this.g.get(V);if(J){for(const re of J)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var h;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(V,J=null){this.l=V,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=J}getChannel(V){const J=this;return{call(re,ve,ue){return J.a?Promise.reject(new T.CancellationError):J.m(V,re,ve,ue)},listen(re,ve){return J.a?y.Event.None:J.o(V,re,ve)}}}m(V,J,re,ve=R.CancellationToken.None){const ue=this.g++,q={id:ue,type:100,channelName:V,name:J,arg:re};if(ve.isCancellationRequested)return Promise.reject(new T.CancellationError);let F;return new Promise((me,Ee)=>{if(ve.isCancellationRequested)return Ee(new T.CancellationError);const te=()=>{const ce=ae=>{switch(ae.type){case 201:this.f.delete(ue),me(ae.data);break;case 202:{this.f.delete(ue);const N=new Error(ae.data.message);N.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,N.name=ae.data.name,Ee(N);break}case 203:this.f.delete(ue),Ee(ae.data);break}};this.f.set(ue,ce),this.p(q)};let ne=null;this.b===d.Idle?te():(ne=(0,A.createCancelablePromise)(ce=>this.u()),ne.then(()=>{ne=null,te()}));const de=()=>{ne?(ne.cancel(),ne=null):this.p({id:ue,type:101}),Ee(new T.CancellationError)},ee=ve.onCancellationRequested(de);F=(0,m.combinedDisposable)((0,m.toDisposable)(de),ee),this.d.add(F)}).finally(()=>{this.d.delete(F)})}o(V,J,re){const ve=this.g++,le={id:ve,type:102,channelName:V,name:J,arg:re};let q=null;const F=new y.Emitter({onWillAddFirstListener:()=>{q=(0,A.createCancelablePromise)(me=>this.u()),q.then(()=>{q=null,this.d.add(F),this.p(le)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(F),this.p({id:ve,type:103}))}}),Q=me=>F.fire(me.data);return this.f.set(ve,Q),F.event}p(V){switch(V.type){case 100:case 102:{const J=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(J,V.id,0,`${C(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.q([V.type,V.id]);this.j?.logOutgoing(J,V.id,0,C(V.type));return}}}q(V,J=void 0){const re=new t;return v(re,V),v(re,J),this.r(re.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const J=new p(V),re=i(J),ve=i(J),ue=re[0];switch(ue){case 200:return this.j?.logIncoming(V.byteLength,0,0,r(ue)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,re[1],0,r(ue),ve),this.t({type:re[0],id:re[1],data:ve})}}t(V){if(V.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}Ve([P.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class b{get connections(){const V=[];return this.f.forEach(J=>V.push(J)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:J,onDidClientDisconnect:re})=>{y.Event.once(J.onMessage)(ue=>{const le=new p(ue),q=i(le),F=new n(J,q),Q=new w(J);this.a.forEach((Ee,te)=>F.registerChannel(te,Ee));const me={channelServer:F,channelClient:Q,ctx:q};this.f.add(me),this.g.fire(me),re(()=>{F.dispose(),Q.dispose(),this.f.delete(me),this.h.fire(me)})})})}getChannel(V,J){const re=this;return{call(ve,ue,le){let q;if((0,S.isFunction)(J)){const Q=(0,a.getRandomElement)(re.connections.filter(J));q=Q?Promise.resolve(Q):y.Event.toPromise(y.Event.filter(re.onDidAddConnection,J))}else q=J.routeCall(re,ve,ue);const F=q.then(Q=>Q.channelClient.getChannel(V));return H(F).call(ve,ue,le)},listen(ve,ue){if((0,S.isFunction)(J))return re.j(V,J,ve,ue);const le=J.routeEvent(re,ve,ue).then(q=>q.channelClient.getChannel(V));return H(le).listen(ve,ue)}}}j(V,J,re,ve){const ue=this;let le=new m.DisposableStore;const q=new y.Emitter({onWillAddFirstListener:()=>{le=new m.DisposableStore;const F=new y.EventMultiplexer,Q=new Map,me=te=>{const de=te.channelClient.getChannel(V).listen(re,ve),ee=F.add(de);Q.set(te,ee)},Ee=te=>{const ne=Q.get(te);!ne||(ne.dispose(),Q.delete(te))};ue.connections.filter(J).forEach(me),y.Event.filter(ue.onDidAddConnection,J)(me,void 0,le),ue.onDidRemoveConnection(Ee,void 0,le),F.event(q.fire,q,le),le.add(F)},onDidRemoveLastListener:()=>{le.dispose()}});return q.event}registerChannel(V,J){this.a.set(V,J),this.f.forEach(re=>{re.channelServer.registerChannel(V,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=b;class O{constructor(V,J,re=null){const ve=new t;v(ve,J),V.send(ve.buffer),this.a=new w(V,re),this.d=new n(V,J,re)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,J){this.d.registerChannel(V,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function H(ie){return{call(V,J,re){return ie.then(ve=>ve.call(V,J,re))},listen(V,J){const re=new y.Relay;return ie.then(ve=>re.input=ve.listen(V,J)),re.event}}}e.getDelayedChannel=H;function x(ie){let V=!1;return{call(J,re,ve){return V?ie.call(J,re,ve):(0,A.timeout)(0).then(()=>V=!0).then(()=>ie.call(J,re,ve))},listen(J,re){if(V)return ie.listen(J,re);const ve=new y.Relay;return(0,A.timeout)(0).then(()=>V=!0).then(()=>ve.input=ie.listen(J,re)),ve.event}}}e.getNextTickChannel=x;class _{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const J of V.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=_;var G;(function(ie){function V(ue,le){const q=ue,F=le&&le.disableMarshalling,Q=new Map;for(const me in q)re(me)&&Q.set(me,y.Event.buffer(q[me],!0));return new class{listen(me,Ee,te){const ne=Q.get(Ee);if(ne)return ne;if(ve(Ee)){const de=q[Ee];if(typeof de=="function")return de.call(q,te)}throw new Error(`Event not found: ${Ee}`)}call(me,Ee,te){const ne=q[Ee];if(typeof ne=="function"){if(!F&&Array.isArray(te))for(let de=0;de<te.length;de++)te[de]=(0,L.revive)(te[de]);return ne.apply(q,te)}throw new Error(`Method not found: ${Ee}`)}}}ie.fromService=V;function J(ue,le){const q=le&&le.disableMarshalling;return new Proxy({},{get(F,Q){if(typeof Q=="string")return le?.properties?.has(Q)?le.properties.get(Q):ve(Q)?function(me){return ue.listen(Q,me)}:re(Q)?ue.listen(Q):async function(...me){let Ee;le&&!(0,S.isUndefinedOrNull)(le.context)?Ee=[le.context,...me]:Ee=me;const te=await ue.call(Q,Ee);return q?te:(0,L.revive)(te)};throw new Error(`Property not found: ${String(Q)}`)}})}ie.toService=J;function re(ue){return ue[0]==="o"&&ue[1]==="n"&&I.isUpperAsciiLetter(ue.charCodeAt(2))}function ve(ue){return/^onDynamic/.test(ue)&&I.isUpperAsciiLetter(ue.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const V=ie.toString();if(V!=="[object Object]")return V}return ie}function U(ie){return Array.isArray(ie)?ie.map(B):B(ie)}function j(ie,V,J,re,ve,ue,le){le=U(le);const q=M[ve],F=q[re%q.length];let Q=[`%c[${ie}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(ue)?(Q=Q.concat(le),Q.push(")")):Q.push(le),console.log.apply(console,Q)}class he{constructor(V,J){this.d=V,this.f=J,this.a=0,this.b=0}logOutgoing(V,J,re,ve,ue){this.b+=V,j(this.d,this.b,V,J,re,ve,ue)}logIncoming(V,J,re,ve,ue){this.a+=V,j(this.f,this.a,V,J,re,ve,ue)}}e.IPCLogger=he}),define(Ce[119],Ie([1,0,19,22,3,6,118]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(w){w.enableDiagnostics=!1,w.records=[];const b=new WeakMap;let O=0;function H(_,G){if(!b.has(_)){const M=String(++O);b.set(_,M)}return b.get(_)}function x(_,G,M,B){if(!w.enableDiagnostics)return;const U=H(_,G);if(B instanceof A.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const j=A.VSBuffer.alloc(B.byteLength);j.set(B),w.records.push({timestamp:Date.now(),id:U,label:G,type:M,buff:j})}else w.records.push({timestamp:Date.now(),id:U,label:G,type:M,data:B})}w.traceSocketEvent=x})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function I(){return L||(L=A.VSBuffer.alloc(0)),L}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(b){this.a.push(b),this.b+=b.byteLength}read(b){return this.c(b,!0)}peek(b){return this.c(b,!1)}c(b,O){if(b===0)return I();if(b>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===b){const G=this.a[0];return O&&(this.a.shift(),this.b-=b),G}if(this.a[0].byteLength>b){const G=this.a[0].slice(0,b);return O&&(this.a[0]=this.a[0].slice(b),this.b-=b),G}const H=A.VSBuffer.alloc(b);let x=0,_=0;for(;b>0;){const G=this.a[_];if(G.byteLength>b){const M=G.slice(0,b);H.set(M,x),x+=b,O&&(this.a[_]=G.slice(b),this.b-=b),b-=b}else H.set(G,x),x+=G.byteLength,O?(this.a.shift(),this.b-=G.byteLength):_++,b-=G.byteLength}return H}}e.ChunkStream=S;var k;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function C(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class r{constructor(b,O,H,x){this.type=b,this.id=O,this.ack=H,this.data=x,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(b){super(),this.f=this.D(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=b,this.b=!1,this.c=new S,this.D(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(b){if(!(!b||b.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(b);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const H=this.g.messageType,x=this.g.id,_=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new r(H,x,_,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(b){this.k=null,this.a=!1,this.b=!1,this.c=b,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(b){if(this.a)return;b.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=A.VSBuffer.alloc(13);O.writeUInt8(b.type,0),O.writeUInt32BE(b.id,1),O.writeUInt32BE(b.ack,5),O.writeUInt32BE(b.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(b.type),id:b.id,ack:b.ack,messageSize:b.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",b.data),this.j(O,b.data)}g(b,O){const H=this.f===0;return this.d.push(b,O),this.f+=b.byteLength+O.byteLength,H}h(){const b=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,b}j(b,O){this.g(b,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const b=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:b.byteLength}),this.c.write(b)}}class g extends R.Disposable{constructor(b){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=b,this.b=this.D(new f(this.a)),this.c=this.D(new d(this.a)),this.D(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(b){this.b.write(new r(1,0,0,b))}}e.Protocol=g;class D extends P.IPCClient{static fromSocket(b,O){return new D(new g(b),O)}get onDidDispose(){return this.b.onDidDispose}constructor(b,O,H=null){super(b,O,H),this.b=b}dispose(){super.dispose();const b=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),b.end()}}e.Client=D;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(b){this.b?this.d.length>0?this.d.push(b):this.a.fire(b):this.d.push(b)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class t{constructor(b){this.data=b,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let b=0,O=this.a;for(;O;)O=O.next,b++;return b}peek(){return this.a?this.a.data:null}toArray(){const b=[];let O=0,H=this.a;for(;H;)b[O++]=H.data,H=H.next;return b}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(b){const O=new t(b);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const b=Date.now();for(let O=0;O<s.a;O++)this.c[O]=b-1e3*O;setInterval(()=>{for(let O=s.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const b=Date.now(),O=(1+s.a)*1e3;let H=0;for(let x=0;x<s.a;x++)b-this.c[x]<=O&&H++;return 1-H/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var c;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function l(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class v{constructor(b){this.connectionHealth=b}}e.ConnectionHealthChangedEvent=v;class i{constructor(b,O){this.roundTripTime=b,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=i;class n{get unacknowledgedCount(){return this.c-this.d}constructor(b){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=b.loadEstimator??s.getInstance(),this.v=b.measureRoundTripTime??!1,this.w=b.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=b.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),b.initialChunk&&this.q.acceptChunk(b.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const b=new r(5,0,0,I());this.p.write(b),this.p.flush()}sendPause(){const b=new r(7,0,0,I());this.p.write(b)}sendResume(){const b=new r(8,0,0,I());this.p.write(b)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(b,O){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=b,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(H=>this.E(H))),this.t.add(this.o.onClose(H=>this.A.fire(H))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(H=>this.J(H))),this.t.add(this.r.onHighRoundTripTime(H=>this.C.fire(H))),this.t.add(this.r.onDidChangeConnectionHealth(H=>this.D.fire(H))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const b=new r(3,0,this.h,I());this.p.write(b);const O=this.b.toArray();for(let H=0,x=O.length;H<x;H++)this.p.write(O[H]);this.G()}acceptDisconnect(){this.z.fire()}E(b){if(b.ack>this.d){this.d=b.ack;do{const O=this.b.peek();if(O&&O.id<=b.ack)this.b.pop();else break}while(!0)}switch(b.type){case 0:break;case 1:{if(b.id>this.g)if(b.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new r(6,0,0,I())))}else this.g=b.id,this.j=Date.now(),this.F(),this.y.fire(b.data);break}case 2:{this.x.fire(b.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let H=0,x=O.length;H<x;H++)this.p.write(O[H]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(b.data);break}case 11:{this.r.handleResponse(b.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(b){const O=++this.c;this.h=this.g;const H=new r(1,O,this.h,b);this.b.push(H),this.a||(this.p.write(H),this.G())}sendControl(b){const O=new r(2,0,0,b);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const b=Date.now()-this.j;if(b>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-b+5)}G(){if(this.c<=this.d||this.f||this.a)return;const b=this.b.peek(),O=Date.now()-b.writtenTime,H=Date.now()-this.q.lastReadTime,x=Date.now()-this.n;if(O>=2e4&&H>=2e4&&x>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:H});return}const _=Math.max(2e4-O,2e4-H,2e4-x,500);this.f=setTimeout(()=>{this.f=null,this.G()},_)}H(){if(this.g<=this.h)return;this.h=this.g;const b=new r(3,0,this.h,I());this.p.write(b)}I(){this.h=this.g;const b=new r(9,0,this.h,I());this.p.write(b)}J(b){this.h=this.g;const O=new r(10,0,this.h,b);this.p.write(O)}K(b){this.h=this.g;const O=new r(11,0,this.h,b);this.p.write(O)}}e.PersistentProtocol=n;class h extends R.Disposable{constructor(){super(),this.a=this.D(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},b=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const b=++this.h,O=A.VSBuffer.alloc(4);O.writeUInt32BE(b,0),this.a.fire(O)},6e4)}handleResponse(b){if(b.byteLength!==4)return;const O=b.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const H=Date.now()-this.g,x=this.k++;this.j[x%this.j.length]=H;const _=this.l,G=this.j.filter(M=>M>=1e3).length;this.l=G>=3?1:0,H>1e3&&this.b.fire(new i(H,G)),_!==this.l&&this.c.fire(this.l)}}}),define(Ce[120],Ie([1,0,22,10,3,6,12,11,30,118,119]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(i,n){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,n)}constructor(i,n=""){this.f=!0,this.debugLabel=n,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,A.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const n=h=>{this.traceSocketEvent("read",h),i(a.VSBuffer.wrap(h))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(i){const n=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(i){const n=()=>{i()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,A.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,A.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=S;var k;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var C;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(C||(C={}));class E extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,n){this.socket.traceSocketEvent(i,n)}constructor(i,n,h,w){super(),this.f=this.D(new u.Emitter),this.g=this.D(new u.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:h?.byteLength||0,recordInflateBytes:w}),this.a=this.D(new r(this,n,h,w,this.f,(b,O)=>this.k(b,O))),this.D(this.a.onError(b=>{console.error(b),(0,A.onUnexpectedError)(b),this.g.fire({type:0,hadError:!0,error:b})})),this.b=new L.ChunkStream,this.D(this.socket.onData(b=>this.l(b))),this.D(this.socket.onClose(async b=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(b)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let n=0;for(;n<i.byteLength;)this.a.writeMessage(i.slice(n,Math.min(n+262144,i.byteLength))),n+=262144}k(i,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const w=a.VSBuffer.alloc(h);if(n?w.writeUInt8(194,0):w.writeUInt8(130,0),i.byteLength<126)w.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){w.writeUInt8(126,1);let b=1;w.writeUInt8(i.byteLength>>>8&255,++b),w.writeUInt8(i.byteLength>>>0&255,++b)}else{w.writeUInt8(127,1);let b=1;w.writeUInt8(0,++b),w.writeUInt8(0,++b),w.writeUInt8(0,++b),w.writeUInt8(0,++b),w.writeUInt8(i.byteLength>>>24&255,++b),w.writeUInt8(i.byteLength>>>16&255,++b),w.writeUInt8(i.byteLength>>>8&255,++b),w.writeUInt8(i.byteLength>>>0&255,++b)}this.socket.write(a.VSBuffer.concat([w,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),h=n.readUInt8(0),w=(h&128)>>>7,b=(h&64)>>>6,O=n.readUInt8(1),H=(O&128)>>>7,x=O&127;this.j.state=2,this.j.readLen=2+(H?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(b)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),h=n.readUInt8(1),w=(h&128)>>>7;let b=h&127,O=1;b===126?b=n.readUInt8(++O)*2**8+n.readUInt8(++O):b===127&&(b=n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O));let H=0;w&&(H=n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O)),this.j.state=3,this.j.readLen=b,this.j.mask=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),g(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class r extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(i,n,h,w,b,O){super(),this.l=i,this.m=b,this.n=O,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new u.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new u.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,n?(this.b=this.D(new d(this.l,w,h,{windowBits:15})),this.f=this.D(new f(this.l,{windowBits:15})),this.D(this.b.onError(H=>this.a.fire(H))),this.D(this.f.onError(H=>this.a.fire(H)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const n=await this.r(this.f,i);this.n(n,!0)}else this.n(i,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(i,n){return new Promise((h,w)=>{i.write(n),i.flush(b=>h(b))})}acceptFrame(i,n,h){this.h.push({data:i,isCompressed:n,isLastFrameOfMessage:h}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const n=await this.u(this.b,i.data,i.isLastFrameOfMessage);this.m.fire(n)}else this.m.fire(i.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(i,n,h){return new Promise((w,b)=>{i.write(n),h&&i.write(a.VSBuffer.fromByteArray([0,0,255,255])),i.flush(O=>w(O))})}}class d extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(i,n,h,w){super(),this.h=i,this.j=n,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=I().zlib.createInflateRaw(w),this.b.on("error",b=>{this.h.traceSocketEvent("zlibInflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.h.traceSocketEvent("zlibInflateData",b),this.g.push(a.VSBuffer.wrap(b))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=a.VSBuffer.concat(this.g);this.g.length=0,i(n)})}}class f extends R.Disposable{constructor(i,n){super(),this.g=i,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.f=[],this.b=I().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(a.VSBuffer.wrap(h))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=a.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),i(n)})}}function g(v,i){if(i===0)return;const n=v.byteLength>>>2;for(let x=0;x<n;x++){const _=v.readUInt32BE(x*4);v.writeUInt32BE(_^i,x*4)}const h=n*4,w=v.byteLength-h,b=i>>>24&255,O=i>>>16&255,H=i>>>8&255;w>=1&&v.writeUInt8(v.readUInt8(h)^b,h),w>=2&&v.writeUInt8(v.readUInt8(h+1)^O,h+1),w>=3&&v.writeUInt8(v.readUInt8(h+2)^H,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function p(){const v=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const i=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:I().os.tmpdir(),n=(0,P.join)(i,`vscode-ipc-${v}.sock`);return o(n),n}e.createRandomIPCHandle=p;function t(v,i,n){const h=I().crypto.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${n}-${i}-sock`;const w=n.substr(0,4),b=i.substr(0,6),O=h.substr(0,8);let H;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${w}-${b}.sock`):H=(0,P.join)(v,`${w}-${b}.sock`),o(H),H}e.createStaticIPCHandle=t;function o(v){const i=D[T.platform];typeof i=="number"&&v.length>=i&&console.warn(`WARNING: IPC handle "${v}" is longer than ${i} chars, try a shorter --user-data-dir`)}class s extends m.IPCServer{static b(i){const n=u.Event.fromNodeEventEmitter(i,"connection");return u.Event.map(n,h=>({protocol:new L.Protocol(new S(h,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(s.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function c(v){return new Promise((i,n)=>{const h=I().net.createServer();h.on("error",n),h.listen(v,()=>{h.removeListener("error",n),i(new s(h))})})}e.serve=c;function l(v,i){return new Promise((n,h)=>{const w=I().net.createConnection(v,()=>{w.removeListener("error",h),n(L.Client.fromSocket(new S(w,`ipc-client${i}`),i))});w.once("error",h)})}e.connect=l}),define(Ce[165],Ie([1,0,38,12]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(R,P,T,y,m,L){if(Array.isArray(R)){let I=0;for(const S of R){const k=u(S,P,T,y,m,L);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof R=="string")return y?R==="*"?5:R===T?10:0:0;if(R){const{language:I,pattern:S,scheme:k,hasAccessToAllModels:C,notebookType:E}=R;if(!y&&!C)return 0;E&&m&&(P=m);let r=0;if(k)if(k===P.scheme)r=10;else if(k==="*")r=5;else return 0;if(I)if(I===T)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(E)if(E===L)r=10;else if(E==="*"&&L!==void 0)r=Math.max(r,5);else return 0;if(S){let d;if(typeof S=="string"?d=S:d={...S,base:(0,A.normalize)(S.base)},d===P.fsPath||(0,a.match)(d,P.fsPath))r=10;else return 0}return r}else return 0}}e.score=u}),define(Ce[166],Ie([1,0,8,53,156]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(T,y,m,L){this.c=T,this.d=y,this.f=m,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const y=T.changes;for(const m of y)this.n(m.range),this.o(new A.Position(m.range.startLineNumber,m.range.startColumn),m.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,y=this.d.length,m=new Uint32Array(y);for(let L=0;L<y;L++)m[L]=this.d[L].length+T;this.h=new u.PrefixSumComputer(m)}}l(T,y){this.d[T]=y,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,y){if(y.length===0)return;const m=(0,a.splitLines)(y);if(m.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+m[0]+this.d[T.lineNumber-1].substring(T.column-1));return}m[m.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+m[0]);const L=new Uint32Array(m.length-1);for(let I=1;I<m.length;I++)this.d.splice(T.lineNumber+I-1,0,m[I]),L[I-1]=m[I].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,L)}}e.MirrorTextModel=R}),define(Ce[167],Ie([1,0,8,153,53,32,108]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class y{constructor(f,g,D,p){this.searchString=f,this.isRegex=g,this.matchCase=D,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=m(this.searchString):f=this.searchString.indexOf(`
`)>=0;let g=null;try{g=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!g)return null;let D=!this.isRegex&&!f;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new P.SearchData(g,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=y;function m(d){if(!d||d.length===0)return!1;for(let f=0,g=d.length;f<g;f++){const D=d.charCodeAt(f);if(D===10)return!0;if(D===92){if(f++,f>=g)break;const p=d.charCodeAt(f);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=m;function L(d,f,g){if(!g)return new P.FindMatch(d,null);const D=[];for(let p=0,t=f.length;p<t;p++)D[p]=f[p];return new P.FindMatch(d,D)}e.createFindMatch=L;class I{constructor(f){const g=[];let D=0;for(let p=0,t=f.length;p<t;p++)f.charCodeAt(p)===10&&(g[D++]=p);this.a=g}findLineFeedCountBeforeOffset(f){const g=this.a;let D=0,p=g.length-1;if(p===-1||f<=g[0])return 0;for(;D<p;){const t=D+((p-D)/2>>0);g[t]>=f?p=t-1:g[t+1]>=f?(D=t,p=t):D=t+1}return D+1}}class S{static findMatches(f,g,D,p,t){const o=g.parseSearchRequest();return o?o.regex.multiline?this.b(f,D,new r(o.wordSeparators,o.regex),p,t):this.c(f,D,o,p,t):[]}static a(f,g,D,p,t,o){let s,c=0;p?(c=p.findLineFeedCountBeforeOffset(t),s=g+t+c):s=g+t;let l;if(p){const h=p.findLineFeedCountBeforeOffset(t+o.length)-c;l=s+o.length+h}else l=s+o.length;const v=f.getPositionAt(s),i=f.getPositionAt(l);return new R.Range(v.lineNumber,v.column,i.lineNumber,i.column)}static b(f,g,D,p,t){const o=f.getOffsetAt(g.getStartPosition()),s=f.getValueInRange(g,1),c=f.getEOL()===`\r
`?new I(s):null,l=[];let v=0,i;for(D.reset(0);i=D.next(s);)if(l[v++]=L(this.a(f,o,s,c,i.index,i[0]),i,p),v>=t)return l;return l}static c(f,g,D,p,t){const o=[];let s=0;if(g.startLineNumber===g.endLineNumber){const l=f.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return s=this.d(D,l,g.startLineNumber,g.startColumn-1,s,o,p,t),o}const c=f.getLineContent(g.startLineNumber).substring(g.startColumn-1);s=this.d(D,c,g.startLineNumber,g.startColumn-1,s,o,p,t);for(let l=g.startLineNumber+1;l<g.endLineNumber&&s<t;l++)s=this.d(D,f.getLineContent(l),l,0,s,o,p,t);if(s<t){const l=f.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);s=this.d(D,l,g.endLineNumber,0,s,o,p,t)}return o}static d(f,g,D,p,t,o,s,c){const l=f.wordSeparators;if(!s&&f.simpleSearch){const n=f.simpleSearch,h=n.length,w=g.length;let b=-h;for(;(b=g.indexOf(n,b+h))!==-1;)if((!l||E(l,g,w,b,h))&&(o[t++]=new P.FindMatch(new R.Range(D,b+1+p,D,b+1+h+p),null),t>=c))return t;return t}const v=new r(f.wordSeparators,f.regex);let i;v.reset(0);do if(i=v.next(g),i&&(o[t++]=L(new R.Range(D,i.index+1+p,D,i.index+1+i[0].length+p),i,s),t>=c))return t;while(i);return t}static findNextMatch(f,g,D,p){const t=g.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.e(f,D,o,p):this.f(f,D,o,p)}static e(f,g,D,p){const t=new u.Position(g.lineNumber,1),o=f.getOffsetAt(t),s=f.getLineCount(),c=f.getValueInRange(new R.Range(t.lineNumber,t.column,s,f.getLineMaxColumn(s)),1),l=f.getEOL()===`\r
`?new I(c):null;D.reset(g.column-1);const v=D.next(c);return v?L(this.a(f,o,c,l,v.index,v[0]),v,p):g.lineNumber!==1||g.column!==1?this.e(f,new u.Position(1,1),D,p):null}static f(f,g,D,p){const t=f.getLineCount(),o=g.lineNumber,s=f.getLineContent(o),c=this.g(D,s,o,g.column,p);if(c)return c;for(let l=1;l<=t;l++){const v=(o+l-1)%t,i=f.getLineContent(v+1),n=this.g(D,i,v+1,1,p);if(n)return n}return null}static g(f,g,D,p,t){f.reset(p-1);const o=f.next(g);return o?L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,t):null}static findPreviousMatch(f,g,D,p){const t=g.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.h(f,D,o,p):this.j(f,D,o,p)}static h(f,g,D,p){const t=this.b(f,new R.Range(1,1,g.lineNumber,g.column),D,p,10*T);if(t.length>0)return t[t.length-1];const o=f.getLineCount();return g.lineNumber!==o||g.column!==f.getLineMaxColumn(o)?this.h(f,new u.Position(o,f.getLineMaxColumn(o)),D,p):null}static j(f,g,D,p){const t=f.getLineCount(),o=g.lineNumber,s=f.getLineContent(o).substring(0,g.column-1),c=this.k(D,s,o,p);if(c)return c;for(let l=1;l<=t;l++){const v=(t+o-l-1)%t,i=f.getLineContent(v+1),n=this.k(D,i,v+1,p);if(n)return n}return null}static k(f,g,D,p){let t=null,o;for(f.reset(0);o=f.next(g);)t=L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,p);return t}}e.TextModelSearch=S;function k(d,f,g,D,p){if(D===0)return!0;const t=f.charCodeAt(D-1);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=f.charCodeAt(D);if(d.get(o)!==0)return!0}return!1}function C(d,f,g,D,p){if(D+p===g)return!0;const t=f.charCodeAt(D+p);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=f.charCodeAt(D+p-1);if(d.get(o)!==0)return!0}return!1}function E(d,f,g,D,p){return k(d,f,g,D,p)&&C(d,f,g,D,p)}e.isValidMatch=E;class r{constructor(f,g){this._wordSeparators=f,this.a=g,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const g=f.length;let D;do{if(this.b+this.c===g||(D=this.a.exec(f),!D))return null;const p=D.index,t=D[0].length;if(p===this.b&&t===this.c){if(t===0){a.getNextCodePoint(f,g,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=t,!this._wordSeparators||E(this._wordSeparators,f,g,p,t))return D}while(D);return null}}e.Searcher=r}),define(Ce[121],Ie([1,0,22,11]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(u||(u={}));function R(I){for(let S=0,k=I.length;S<k;S+=4){const C=I[S+0],E=I[S+1],r=I[S+2],d=I[S+3];I[S+0]=d,I[S+1]=r,I[S+2]=E,I[S+3]=C}}function P(I){const S=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return A.isLittleEndian()||R(S),a.VSBuffer.wrap(S)}function T(I){const S=I.buffer;if(A.isLittleEndian()||R(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const k=new Uint8Array(S.byteLength);return k.set(S),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function y(I){const S=new Uint32Array(m(I));let k=0;if(S[k++]=I.id,I.type==="full")S[k++]=1,S[k++]=I.data.length,S.set(I.data,k),k+=I.data.length;else{S[k++]=2,S[k++]=I.deltas.length;for(const C of I.deltas)S[k++]=C.start,S[k++]=C.deleteCount,C.data?(S[k++]=C.data.length,S.set(C.data,k),k+=C.data.length):S[k++]=0}return P(S)}e.encodeSemanticTokensDto=y;function m(I){let S=0;if(S+=1+1,I.type==="full")S+=1+I.data.length;else{S+=1,S+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(S+=k.data.length)}return S}function L(I){const S=T(I);let k=0;const C=S[k++];if(S[k++]===1){const f=S[k++],g=S.subarray(k,k+f);return k+=f,{id:C,type:"full",data:g}}const r=S[k++],d=[];for(let f=0;f<r;f++){const g=S[k++],D=S[k++],p=S[k++];let t;p>0&&(t=S.subarray(k,k+p),k+=p),d[f]={start:g,deleteCount:D,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=L}),define(Ce[168],Ie([1,0,3,6]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,y){return this.a.set(T,y),this.fire([T]),(0,A.toDisposable)(()=>{this.a.get(T)===y&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,y){this.b.get(T)?.dispose();const m=new R(this,T,y);return this.b.set(T,m),(0,A.toDisposable)(()=>{const L=this.b.get(T);!L||L!==m||(this.b.delete(T),L.dispose())})}async getOrCreate(T){const y=this.get(T);if(y)return y;const m=this.b.get(T);return!m||m.isResolved?null:(await m.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const m=this.b.get(T);return!!(!m||m.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class R extends A.Disposable{get isResolved(){return this.c}constructor(T,y,m){super(),this.f=T,this.g=y,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.D(this.f.register(this.g,T))}}}),define(Ce[72],Ie([1,0,67,2,32,168]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class P{constructor(h,w,b){this.offset=h,this.type=w,this.language=b,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=P;class T{constructor(h,w){this.tokens=h,this.endState=w,this._tokenizationResultBrand=void 0}}e.TokenizationResult=T;class y{constructor(h,w){this.tokens=h,this.endState=w,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var m;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(n){const h=new Map;h.set(0,a.Codicon.symbolMethod),h.set(1,a.Codicon.symbolFunction),h.set(2,a.Codicon.symbolConstructor),h.set(3,a.Codicon.symbolField),h.set(4,a.Codicon.symbolVariable),h.set(5,a.Codicon.symbolClass),h.set(6,a.Codicon.symbolStruct),h.set(7,a.Codicon.symbolInterface),h.set(8,a.Codicon.symbolModule),h.set(9,a.Codicon.symbolProperty),h.set(10,a.Codicon.symbolEvent),h.set(11,a.Codicon.symbolOperator),h.set(12,a.Codicon.symbolUnit),h.set(13,a.Codicon.symbolValue),h.set(15,a.Codicon.symbolEnum),h.set(14,a.Codicon.symbolConstant),h.set(15,a.Codicon.symbolEnum),h.set(16,a.Codicon.symbolEnumMember),h.set(17,a.Codicon.symbolKeyword),h.set(27,a.Codicon.symbolSnippet),h.set(18,a.Codicon.symbolText),h.set(19,a.Codicon.symbolColor),h.set(20,a.Codicon.symbolFile),h.set(21,a.Codicon.symbolReference),h.set(22,a.Codicon.symbolCustomColor),h.set(23,a.Codicon.symbolFolder),h.set(24,a.Codicon.symbolTypeParameter),h.set(25,a.Codicon.account),h.set(26,a.Codicon.issues);function w(H){let x=h.get(H);return x||(console.info("No codicon found for CompletionItemKind "+H),x=a.Codicon.symbolProperty),x}n.toIcon=w;const b=new Map;b.set("method",0),b.set("function",1),b.set("constructor",2),b.set("field",3),b.set("variable",4),b.set("class",5),b.set("struct",6),b.set("interface",7),b.set("module",8),b.set("property",9),b.set("event",10),b.set("operator",11),b.set("unit",12),b.set("value",13),b.set("constant",14),b.set("enum",15),b.set("enum-member",16),b.set("enumMember",16),b.set("keyword",17),b.set("snippet",27),b.set("text",18),b.set("color",19),b.set("file",20),b.set("reference",21),b.set("customcolor",22),b.set("folder",23),b.set("type-parameter",24),b.set("typeParameter",24),b.set("account",25),b.set("issue",26);function O(H,x){let _=b.get(H);return typeof _>"u"&&!x&&(_=9),_}n.fromString=O})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(n){n[n.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var r;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(r=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(n){return n&&A.URI.isUri(n.uri)&&u.Range.isIRange(n.range)&&(u.Range.isIRange(n.originSelectionRange)||u.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=f;var g;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var D;(function(n){n[n.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var p;(function(n){const h=new Map;h.set(0,a.Codicon.symbolFile),h.set(1,a.Codicon.symbolModule),h.set(2,a.Codicon.symbolNamespace),h.set(3,a.Codicon.symbolPackage),h.set(4,a.Codicon.symbolClass),h.set(5,a.Codicon.symbolMethod),h.set(6,a.Codicon.symbolProperty),h.set(7,a.Codicon.symbolField),h.set(8,a.Codicon.symbolConstructor),h.set(9,a.Codicon.symbolEnum),h.set(10,a.Codicon.symbolInterface),h.set(11,a.Codicon.symbolFunction),h.set(12,a.Codicon.symbolVariable),h.set(13,a.Codicon.symbolConstant),h.set(14,a.Codicon.symbolString),h.set(15,a.Codicon.symbolNumber),h.set(16,a.Codicon.symbolBoolean),h.set(17,a.Codicon.symbolArray),h.set(18,a.Codicon.symbolObject),h.set(19,a.Codicon.symbolKey),h.set(20,a.Codicon.symbolNull),h.set(21,a.Codicon.symbolEnumMember),h.set(22,a.Codicon.symbolStruct),h.set(23,a.Codicon.symbolEvent),h.set(24,a.Codicon.symbolOperator),h.set(25,a.Codicon.symbolTypeParameter);function w(b){let O=h.get(b);return O||(console.info("No codicon found for SymbolKind "+b),O=a.Codicon.symbolProperty),O}n.toIcon=w})(p=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(h){switch(h){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(h)}constructor(h){this.value=h}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var o;(function(n){function h(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}n.is=h})(o=e.Command||(e.Command={}));var s;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var v;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(v=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ce[169],Ie([14,15]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,169,11,107,17,23,152]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function($){$[$.None=0]="None",$[$.Keep=1]="Keep",$[$.Brackets=2]="Brackets",$[$.Advanced=3]="Advanced",$[$.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=m;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(Y,ge,Le,Ne){this.id=Y,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Y,ge){return k(Y,ge)}compute(Y,ge,Le){return Le}}class S{constructor(Y,ge){this.newValue=Y,this.didChange=ge}}e.ApplyUpdateResult=S;function k($,Y){if(typeof $!="object"||typeof Y!="object"||!$||!Y)return new S(Y,$!==Y);if(Array.isArray($)||Array.isArray(Y)){const Le=Array.isArray($)&&Array.isArray(Y)&&R.equals($,Y);return new S(Y,!Le)}let ge=!1;for(const Le in Y)if(Y.hasOwnProperty(Le)){const Ne=k($[Le],Y[Le]);Ne.didChange&&($[Le]=Ne.newValue,ge=!0)}return new S($,ge)}class C{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ge){return k(Y,ge)}validate(Y){return this.defaultValue}}class E{constructor(Y,ge,Le,Ne){this.id=Y,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Y,ge){return k(Y,ge)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ge,Le){return Le}}function r($,Y){return typeof $>"u"?Y:$==="false"?!1:Boolean($)}e.boolean=r;class d extends E{constructor(Y,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(Y,ge,Le,Ne)}validate(Y){return r(Y,this.defaultValue)}}function f($,Y,ge,Le){if(typeof $>"u")return Y;let Ne=parseInt($,10);return isNaN(Ne)?Y:(Ne=Math.max(ge,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=f;class g extends E{static clampedInt(Y,ge,Le,Ne){return f(Y,ge,Le,Ne)}constructor(Y,ge,Le,Ne,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Le,Ye.minimum=Ne,Ye.maximum=je),super(Y,ge,Le,Ye),this.minimum=Ne,this.maximum=je}validate(Y){return g.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class D extends E{static clamp(Y,ge,Le){return Y<ge?ge:Y>Le?Le:Y}static float(Y,ge){if(typeof Y=="number")return Y;if(typeof Y>"u")return ge;const Le=parseFloat(Y);return isNaN(Le)?ge:Le}constructor(Y,ge,Le,Ne,je){typeof je<"u"&&(je.type="number",je.default=Le),super(Y,ge,Le,je),this.validationFn=Ne}validate(Y){return this.validationFn(D.float(Y,this.defaultValue))}}class p extends E{static string(Y,ge){return typeof Y!="string"?ge:Y}constructor(Y,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(Y,ge,Le,Ne)}validate(Y){return p.string(Y,this.defaultValue)}}function t($,Y,ge){return typeof $!="string"||ge.indexOf($)===-1?Y:$}e.stringSet=t;class o extends E{constructor(Y,ge,Le,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Ne,je.default=Le),super(Y,ge,Le,je),this.c=Ne}validate(Y){return t(Y,this.defaultValue,this.c)}}class s extends I{constructor(Y,ge,Le,Ne,je,Ye,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=Ne),super(Y,ge,Le,Xe),this.c=je,this.d=Ye}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function c($){switch($){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ge,Le){return Le===0?Y.accessibilitySupport:Le}}class v extends I{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertSpace:r(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function($){$[$.Hidden=0]="Hidden",$[$.Blink=1]="Blink",$[$.Smooth=2]="Smooth",$[$.Phase=3]="Phase",$[$.Expand=4]="Expand",$[$.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n($){switch($){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function($){$[$.Line=1]="Line",$[$.Block=2]="Block",$[$.Underline=3]="Underline",$[$.LineThin=4]="LineThin",$[$.BlockOutline=5]="BlockOutline",$[$.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w($){switch($){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function b($){switch($){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends C{constructor(){super(135)}compute(Y,ge,Le){const Ne=["monaco-editor"];return ge.get(36)&&Ne.push(ge.get(36)),Y.extraEditorClassName&&Ne.push(Y.extraEditorClassName),ge.get(70)==="default"?Ne.push("mouse-default"):ge.get(70)==="copy"&&Ne.push("mouse-copy"),ge.get(105)&&Ne.push("showUnused"),ge.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Y,ge,Le){return Le&&Y.emptySelectionClipboard}}class x extends I{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:a.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:a.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{cursorMoveOnType:r(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ge.loop,this.defaultValue.loop)}}}class _ extends I{constructor(){super(48,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?_.OFF:Y==="true"?_.ON:Y:Boolean(Y)?_.ON:_.OFF}}_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on',e.EditorFontLigatures=_;class G extends I{constructor(){super(51,"fontVariations",G.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?G.OFF:Y==="true"?G.TRANSLATE:Y:Boolean(Y)?G.TRANSLATE:G.OFF}compute(Y,ge,Le){return Y.fontInfo.fontVariationSettings}}G.OFF="normal",G.TRANSLATE="translate",e.EditorFontVariations=G;class M extends C{constructor(){super(47)}compute(Y,ge,Le){return Y.fontInfo}}class B extends E{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(Y){const ge=D.float(Y,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ge,6,100)}compute(Y,ge,Le){return Y.fontInfo.fontSize}}class U extends I{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(g.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class j extends I{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Le,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Le,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Le,description:a.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{multiple:t(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??t(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??t(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??t(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??t(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??t(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends I{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:a.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),delay:g.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:r(ge.sticky,this.defaultValue.sticky),above:r(ge.above,this.defaultValue.above)}}}var ie;(function($){$[$.None=0]="None",$[$.Text=1]="Text",$[$.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class V extends C{constructor(){super(138)}compute(Y,ge,Le){return V.computeLayout(ge,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ge=Y.height/Y.lineHeight,Le=Math.floor(Y.paddingTop/Y.lineHeight);let Ne=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ne=Math.max(Ne,ge-1));const je=(Le+Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),Ye=Math.floor(Y.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:Ye}}static c(Y,ge){const Le=Y.outerWidth,Ne=Y.outerHeight,je=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ye=ge.stableMinimapLayoutInput,Xe=Ye&&Y.outerHeight===Ye.outerHeight&&Y.lineHeight===Ye.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ye.pixelRatio&&Y.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Y.paddingTop===Ye.paddingTop&&Y.paddingBottom===Ye.paddingBottom&&Y.minimap.enabled===Ye.minimap.enabled&&Y.minimap.side===Ye.minimap.side&&Y.minimap.size===Ye.minimap.size&&Y.minimap.showSlider===Ye.minimap.showSlider&&Y.minimap.renderCharacters===Ye.minimap.renderCharacters&&Y.minimap.maxColumn===Ye.minimap.maxColumn&&Y.minimap.scale===Ye.minimap.scale&&Y.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Y.isViewportWrapping===Ye.isViewportWrapping,nt=Y.lineHeight,ot=Y.typicalHalfwidthCharacterWidth,pt=Y.scrollBeyondLastLine,bt=Y.minimap.renderCharacters;let St=je>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Pt=Y.minimap.maxColumn,$t=Y.minimap.size,Xt=Y.minimap.side,ft=Y.verticalScrollbarWidth,vt=Y.viewLineCount,Ot=Y.remainingWidth,Ut=Y.isViewportWrapping,Nt=bt?2:3;let wt=Math.floor(je*Ne);const kt=wt/je;let At=!1,Bt=!1,Ke=Nt*St,Wt=St/je,Re=1;if($t==="fill"||$t==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:mt,desiredRatio:gt,minimapLineCount:dt}=V.computeContainedMinimapLineCount({viewLineCount:vt,scrollBeyondLastLine:pt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ne,lineHeight:nt,pixelRatio:je});if(vt/dt>1)At=!0,Bt=!0,St=1,Ke=1,Wt=St/je;else{let yt=!1,Tt=St+1;if($t==="fit"){const Ht=Math.ceil((ct+vt+mt)*Ke);Ut&&Xe&&Ot<=ge.stableFitRemainingWidth?(yt=!0,Tt=ge.stableFitMaxMinimapScale):yt=Ht>wt}if($t==="fill"||yt){At=!0;const Ht=St;Ke=Math.min(nt*je,Math.max(1,Math.floor(1/gt))),Ut&&Xe&&Ot<=ge.stableFitRemainingWidth&&(Tt=ge.stableFitMaxMinimapScale),St=Math.min(Tt,Math.max(1,Math.floor(Ke/Nt))),St>Ht&&(Re=Math.min(2,St/Ht)),Wt=St/je/Re,wt=Math.ceil(Math.max(Ge,ct+vt+mt)*Ke),Ut?(ge.stableMinimapLayoutInput=Y,ge.stableFitRemainingWidth=Ot,ge.stableFitMaxMinimapScale=St):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Fe=Math.floor(Pt*Wt),ye=Math.min(Fe,Math.max(0,Math.floor((Ot-ft-2)*Wt/(ot+Wt)))+e.MINIMAP_GUTTER_WIDTH);let oe=Math.floor(je*ye);const Oe=oe/je;oe=Math.floor(oe*Re);const He=bt?1:2,Ze=Xt==="left"?0:Le-ye-ft;return{renderMinimap:He,minimapLeft:Ze,minimapWidth:ye,minimapHeightIsEditorHeight:At,minimapIsSampling:Bt,minimapScale:St,minimapLineHeight:Ke,minimapCanvasInnerWidth:oe,minimapCanvasInnerHeight:wt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:kt}}static computeLayout(Y,ge){const Le=ge.outerWidth|0,Ne=ge.outerHeight|0,je=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,Xe=ge.typicalHalfwidthCharacterWidth,nt=ge.maxDigitWidth,ot=ge.pixelRatio,pt=ge.viewLineCount,bt=Y.get(130),St=bt==="inherit"?Y.get(129):bt,Pt=St==="inherit"?Y.get(125):St,$t=Y.get(128),Xt=ge.isDominatedByLongLines,ft=Y.get(54),vt=Y.get(64).renderType!==0,Ot=Y.get(65),Ut=Y.get(99),Nt=Y.get(80),wt=Y.get(69),kt=Y.get(97),At=kt.verticalScrollbarSize,Bt=kt.verticalHasArrows,Ke=kt.arrowSize,Wt=kt.horizontalScrollbarSize,Re=Y.get(40),Fe=Y.get(104)!=="never";let ye=Y.get(62);Re&&Fe&&(ye+=16);let oe=0;if(vt){const ai=Math.max(Ye,Ot);oe=Math.round(ai*nt)}let Oe=0;ft&&(Oe=je);let He=0,Ze=He+Oe,Ge=Ze+oe,ct=Ge+ye;const mt=Le-Oe-oe-ye;let gt=!1,dt=!1,lt=-1;St==="inherit"&&Xt?(gt=!0,dt=!0):Pt==="on"||Pt==="bounded"?dt=!0:Pt==="wordWrapColumn"&&(lt=$t);const yt=V.c({outerWidth:Le,outerHeight:Ne,lineHeight:je,typicalHalfwidthCharacterWidth:Xe,pixelRatio:ot,scrollBeyondLastLine:Ut,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:wt,verticalScrollbarWidth:At,viewLineCount:pt,remainingWidth:mt,isViewportWrapping:dt},ge.memory||new L);yt.renderMinimap!==0&&yt.minimapLeft===0&&(He+=yt.minimapWidth,Ze+=yt.minimapWidth,Ge+=yt.minimapWidth,ct+=yt.minimapWidth);const Tt=mt-yt.minimapWidth,Ht=Math.max(1,Math.floor((Tt-At-2)/Xe)),Ft=Bt?Ke:0;return dt&&(lt=Math.max(1,Ht),Pt==="bounded"&&(lt=Math.min(lt,$t))),{width:Le,height:Ne,glyphMarginLeft:He,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:oe,decorationsLeft:Ge,decorationsWidth:ye,contentLeft:ct,contentWidth:Tt,minimap:yt,viewportColumn:Ht,isWordWrapMinified:gt,isViewportWrapping:dt,wrappingColumn:lt,verticalScrollbarWidth:At,horizontalScrollbarHeight:Wt,overviewRuler:{top:Ft,width:At,height:Ne-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=V;class J extends I{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(Y){return t(Y,"simple",["simple","advanced"])}compute(Y,ge,Le){return ge.get(2)===2?"advanced":Le}}class re extends I{constructor(){const Y={enabled:!0};super(61,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:a.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:r(Y.enabled,this.defaultValue.enabled)}}}class ve extends I{constructor(){const Y={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ue extends I{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:a.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:t(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily),padding:r(ge.padding,this.defaultValue.padding)}}}class le extends I{constructor(){super(62,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):g.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ge,Le){return Le<0?g.clampedInt(-Le*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class q extends D{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>D.clamp(Y,0,150),{markdownDescription:a.localize(60,null)})}compute(Y,ge,Le){return Y.fontInfo.lineHeight}}class F extends I{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:Y.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:a.localize(71,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),autohide:r(ge.autohide,this.defaultValue.autohide),size:t(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ge.side,this.defaultValue.side,["right","left"]),showSlider:t(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ge.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(ge.scale,1,1,3),maxColumn:g.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q($){return $==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends I{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{top:g.clampedInt(ge.top,0,0,1e3),bottom:g.clampedInt(ge.bottom,0,0,1e3)}}}class Ee extends I{constructor(){const Y={enabled:!0,cycle:!0};super(81,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:a.localize(75,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),cycle:r(ge.cycle,this.defaultValue.cycle)}}}class te extends C{constructor(){super(136)}compute(Y,ge,Le){return Y.pixelRatio}}class ne extends I{constructor(){const Y={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Y.strings,description:a.localize(79,null)},comments:{anyOf:ge,default:Y.comments,description:a.localize(80,null)},other:{anyOf:ge,default:Y.other,description:a.localize(81,null)}},default:Y,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const ot=Y?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ge,comments:Le,strings:Ne}=Y,je=["on","inline","off"];let Ye,Xe,nt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=t(ge,this.defaultValue.other,je),typeof Le=="boolean"?Xe=Le?"on":"off":Xe=t(Le,this.defaultValue.comments,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=t(Ne,this.defaultValue.strings,je),{other:Ye,comments:Xe,strings:nt}}}var de;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative",$[$.Interval=3]="Interval",$[$.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends I{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(Y){let ge=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ge=4,Le=Y):Y==="interval"?ge=3:Y==="relative"?ge=2:Y==="on"?ge=1:ge=0),{renderType:ge,renderFn:Le}}}function ce($){const Y=$.get(92);return Y==="editable"?$.get(86):Y!=="on"}e.filterValidationDecorations=ce;class ae extends I{constructor(){const Y=[],ge={type:"number",description:a.localize(88,null)};super(96,"rulers",Y,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:Y,description:a.localize(90,null)})}validate(Y){if(Array.isArray(Y)){const ge=[];for(const Le of Y)if(typeof Le=="number")ge.push({column:g.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;ge.push({column:g.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((Le,Ne)=>Le.column-Ne.column),ge}return this.defaultValue}}function N($,Y){if(typeof $!="string")return Y;switch($){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends I{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:a.localize(101,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y,Le=g.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=g.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ge.vertical,this.defaultValue.vertical),horizontal:N(ge.horizontal,this.defaultValue.horizontal),useShadows:r(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:g.clampedInt(ge.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:g.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:r(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends I{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:a.localize(108,null)}})}applyUpdate(Y,ge){let Le=!1;ge.allowedCharacters&&Y&&(P.equals(Y.allowedCharacters,ge.allowedCharacters)||(Y={...Y,allowedCharacters:ge.allowedCharacters},Le=!0)),ge.allowedLocales&&Y&&(P.equals(Y.allowedLocales,ge.allowedLocales)||(Y={...Y,allowedLocales:ge.allowedLocales},Le=!0));const Ne=super.applyUpdate(Y,ge);return Le?new S(Ne.newValue,!0):Ne}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{nonBasicASCII:Ae(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ge){if(typeof Y!="object"||!Y)return ge;const Le={};for(const[Ne,je]of Object.entries(Y))je===!0&&(Le[Ne]=!0);return Le}}class Z extends I{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),mode:t(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class fe extends I{constructor(){const Y={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:r(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Se extends I{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:Y.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:Y.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:Y.highlightActiveIndentation,description:a.localize(128,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{bracketPairs:Ae(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae($,Y,ge){const Le=ge.indexOf($);return Le===-1?Y:ge[Le]}class we extends I{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:Y.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:Y.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertMode:t(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ge.showIcons,this.defaultValue.showIcons),showStatusBar:r(ge.showStatusBar,this.defaultValue.showStatusBar),preview:r(ge.preview,this.defaultValue.preview),previewMode:t(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ge.showMethods,this.defaultValue.showMethods),showFunctions:r(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ge.showFields,this.defaultValue.showFields),showVariables:r(ge.showVariables,this.defaultValue.showVariables),showClasses:r(ge.showClasses,this.defaultValue.showClasses),showStructs:r(ge.showStructs,this.defaultValue.showStructs),showInterfaces:r(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ge.showModules,this.defaultValue.showModules),showProperties:r(ge.showProperties,this.defaultValue.showProperties),showEvents:r(ge.showEvents,this.defaultValue.showEvents),showOperators:r(ge.showOperators,this.defaultValue.showOperators),showUnits:r(ge.showUnits,this.defaultValue.showUnits),showValues:r(ge.showValues,this.defaultValue.showValues),showConstants:r(ge.showConstants,this.defaultValue.showConstants),showEnums:r(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ge.showKeywords,this.defaultValue.showKeywords),showWords:r(ge.showWords,this.defaultValue.showWords),showColors:r(ge.showColors,this.defaultValue.showColors),showFiles:r(ge.showFiles,this.defaultValue.showFiles),showReferences:r(ge.showReferences,this.defaultValue.showReferences),showFolders:r(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ge.showSnippets,this.defaultValue.showSnippets),showUsers:r(ge.showUsers,this.defaultValue.showUsers),showIssues:r(ge.showIssues,this.defaultValue.showIssues)}}}class Pe extends I{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function($){$[$.None=0]="None",$[$.Same=1]="Same",$[$.Indent=2]="Indent",$[$.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class ze extends I{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ge,Le){return ge.get(2)===2?0:Le}}class qe extends C{constructor(){super(139)}compute(Y,ge,Le){const Ne=ge.get(138);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class tt extends I{constructor(){const Y={enabled:!0};super(33,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:a.localize(183,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:r(Y.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?it:A.isLinux?rt:Qe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be($){return e.editorOptionsRegistry[$.id]=$,$}var et;(function($){$[$.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",$[$.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",$[$.accessibilitySupport=2]="accessibilitySupport",$[$.accessibilityPageSize=3]="accessibilityPageSize",$[$.ariaLabel=4]="ariaLabel",$[$.autoClosingBrackets=5]="autoClosingBrackets",$[$.autoClosingDelete=6]="autoClosingDelete",$[$.autoClosingOvertype=7]="autoClosingOvertype",$[$.autoClosingQuotes=8]="autoClosingQuotes",$[$.autoIndent=9]="autoIndent",$[$.automaticLayout=10]="automaticLayout",$[$.autoSurround=11]="autoSurround",$[$.bracketPairColorization=12]="bracketPairColorization",$[$.guides=13]="guides",$[$.codeLens=14]="codeLens",$[$.codeLensFontFamily=15]="codeLensFontFamily",$[$.codeLensFontSize=16]="codeLensFontSize",$[$.colorDecorators=17]="colorDecorators",$[$.colorDecoratorsLimit=18]="colorDecoratorsLimit",$[$.columnSelection=19]="columnSelection",$[$.comments=20]="comments",$[$.contextmenu=21]="contextmenu",$[$.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",$[$.cursorBlinking=23]="cursorBlinking",$[$.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",$[$.cursorStyle=25]="cursorStyle",$[$.cursorSurroundingLines=26]="cursorSurroundingLines",$[$.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",$[$.cursorWidth=28]="cursorWidth",$[$.disableLayerHinting=29]="disableLayerHinting",$[$.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",$[$.domReadOnly=31]="domReadOnly",$[$.dragAndDrop=32]="dragAndDrop",$[$.dropIntoEditor=33]="dropIntoEditor",$[$.emptySelectionClipboard=34]="emptySelectionClipboard",$[$.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",$[$.extraEditorClassName=36]="extraEditorClassName",$[$.fastScrollSensitivity=37]="fastScrollSensitivity",$[$.find=38]="find",$[$.fixedOverflowWidgets=39]="fixedOverflowWidgets",$[$.folding=40]="folding",$[$.foldingStrategy=41]="foldingStrategy",$[$.foldingHighlight=42]="foldingHighlight",$[$.foldingImportsByDefault=43]="foldingImportsByDefault",$[$.foldingMaximumRegions=44]="foldingMaximumRegions",$[$.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",$[$.fontFamily=46]="fontFamily",$[$.fontInfo=47]="fontInfo",$[$.fontLigatures=48]="fontLigatures",$[$.fontSize=49]="fontSize",$[$.fontWeight=50]="fontWeight",$[$.fontVariations=51]="fontVariations",$[$.formatOnPaste=52]="formatOnPaste",$[$.formatOnType=53]="formatOnType",$[$.glyphMargin=54]="glyphMargin",$[$.gotoLocation=55]="gotoLocation",$[$.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",$[$.hover=57]="hover",$[$.inDiffEditor=58]="inDiffEditor",$[$.inlineSuggest=59]="inlineSuggest",$[$.letterSpacing=60]="letterSpacing",$[$.lightbulb=61]="lightbulb",$[$.lineDecorationsWidth=62]="lineDecorationsWidth",$[$.lineHeight=63]="lineHeight",$[$.lineNumbers=64]="lineNumbers",$[$.lineNumbersMinChars=65]="lineNumbersMinChars",$[$.linkedEditing=66]="linkedEditing",$[$.links=67]="links",$[$.matchBrackets=68]="matchBrackets",$[$.minimap=69]="minimap",$[$.mouseStyle=70]="mouseStyle",$[$.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",$[$.mouseWheelZoom=72]="mouseWheelZoom",$[$.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",$[$.multiCursorModifier=74]="multiCursorModifier",$[$.multiCursorPaste=75]="multiCursorPaste",$[$.multiCursorLimit=76]="multiCursorLimit",$[$.occurrencesHighlight=77]="occurrencesHighlight",$[$.overviewRulerBorder=78]="overviewRulerBorder",$[$.overviewRulerLanes=79]="overviewRulerLanes",$[$.padding=80]="padding",$[$.parameterHints=81]="parameterHints",$[$.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",$[$.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",$[$.quickSuggestions=84]="quickSuggestions",$[$.quickSuggestionsDelay=85]="quickSuggestionsDelay",$[$.readOnly=86]="readOnly",$[$.renameOnType=87]="renameOnType",$[$.renderControlCharacters=88]="renderControlCharacters",$[$.renderFinalNewline=89]="renderFinalNewline",$[$.renderLineHighlight=90]="renderLineHighlight",$[$.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",$[$.renderValidationDecorations=92]="renderValidationDecorations",$[$.renderWhitespace=93]="renderWhitespace",$[$.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",$[$.roundedSelection=95]="roundedSelection",$[$.rulers=96]="rulers",$[$.scrollbar=97]="scrollbar",$[$.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",$[$.scrollBeyondLastLine=99]="scrollBeyondLastLine",$[$.scrollPredominantAxis=100]="scrollPredominantAxis",$[$.selectionClipboard=101]="selectionClipboard",$[$.selectionHighlight=102]="selectionHighlight",$[$.selectOnLineNumbers=103]="selectOnLineNumbers",$[$.showFoldingControls=104]="showFoldingControls",$[$.showUnused=105]="showUnused",$[$.snippetSuggestions=106]="snippetSuggestions",$[$.smartSelect=107]="smartSelect",$[$.smoothScrolling=108]="smoothScrolling",$[$.stickyScroll=109]="stickyScroll",$[$.stickyTabStops=110]="stickyTabStops",$[$.stopRenderingLineAfter=111]="stopRenderingLineAfter",$[$.suggest=112]="suggest",$[$.suggestFontSize=113]="suggestFontSize",$[$.suggestLineHeight=114]="suggestLineHeight",$[$.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",$[$.suggestSelection=116]="suggestSelection",$[$.tabCompletion=117]="tabCompletion",$[$.tabIndex=118]="tabIndex",$[$.unicodeHighlighting=119]="unicodeHighlighting",$[$.unusualLineTerminators=120]="unusualLineTerminators",$[$.useShadowDOM=121]="useShadowDOM",$[$.useTabStops=122]="useTabStops",$[$.wordBreak=123]="wordBreak",$[$.wordSeparators=124]="wordSeparators",$[$.wordWrap=125]="wordWrap",$[$.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",$[$.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",$[$.wordWrapColumn=128]="wordWrapColumn",$[$.wordWrapOverride1=129]="wordWrapOverride1",$[$.wordWrapOverride2=130]="wordWrapOverride2",$[$.wrappingIndent=131]="wrappingIndent",$[$.wrappingStrategy=132]="wrappingStrategy",$[$.showDeprecated=133]="showDeprecated",$[$.inlayHints=134]="inlayHints",$[$.editorClassName=135]="editorClassName",$[$.pixelRatio=136]="pixelRatio",$[$.tabFocusMode=137]="tabFocusMode",$[$.layoutInfo=138]="layoutInfo",$[$.wrappingInfo=139]="wrappingInfo"})(et=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Be(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Be(new l),accessibilityPageSize:Be(new g(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new p(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Be(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Be(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Be(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Be(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Be(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Be(new d(10,"automaticLayout",!1)),autoSurround:Be(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Be(new fe),bracketPairGuides:Be(new Se),stickyTabStops:Be(new d(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Be(new d(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Be(new p(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Be(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Be(new d(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Be(new g(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Be(new d(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Be(new v),contextmenu:Be(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new d(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Be(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Be(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Be(new s(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],b,{description:a.localize(222,null)})),cursorSurroundingLines:Be(new g(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Be(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Be(new g(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Be(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new d(31,"domReadOnly",!1)),dragAndDrop:Be(new d(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Be(new H),dropIntoEditor:Be(new tt),stickyScroll:Be(new ve),experimentalWhitespaceRendering:Be(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Be(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new D(37,"fastScrollSensitivity",5,$=>$<=0?5:$,{markdownDescription:a.localize(233,null)})),find:Be(new x),fixedOverflowWidgets:Be(new d(39,"fixedOverflowWidgets",!1)),folding:Be(new d(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Be(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Be(new d(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Be(new d(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Be(new g(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Be(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Be(new M),fontLigatures2:Be(new _),fontSize:Be(new B),fontWeight:Be(new U),fontVariations:Be(new G),formatOnPaste:Be(new d(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Be(new d(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Be(new d(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Be(new j),hideCursorInOverviewRuler:Be(new d(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Be(new he),inDiffEditor:Be(new d(58,"inDiffEditor",!1)),letterSpacing:Be(new D(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,$=>D.clamp($,-5,20),{description:a.localize(247,null)})),lightbulb:Be(new re),lineDecorationsWidth:Be(new le),lineHeight:Be(new q),lineNumbers:Be(new ee),lineNumbersMinChars:Be(new g(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new d(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Be(new d(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Be(new o(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Be(new F),mouseStyle:Be(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new D(71,"mouseWheelScrollSensitivity",1,$=>$===0?1:$,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Be(new d(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Be(new d(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Be(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Be(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Be(new g(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Be(new d(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Be(new d(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Be(new g(79,"overviewRulerLanes",3,0,3)),padding:Be(new me),parameterHints:Be(new Ee),peekWidgetDefaultFocus:Be(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Be(new d(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Be(new ne),quickSuggestionsDelay:Be(new g(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Be(new d(86,"readOnly",!1)),renameOnType:Be(new d(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Be(new d(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Be(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Be(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Be(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Be(new g(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new d(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Be(new ae),scrollbar:Be(new z),scrollBeyondLastColumn:Be(new g(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Be(new d(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Be(new d(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Be(new d(101,"selectionClipboard",!0,{description:a.localize(283,null),included:A.isLinux})),selectionHighlight:Be(new d(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Be(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Be(new d(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Be(new d(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Be(new ue),snippetSuggestions:Be(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Be(new Pe),smoothScrolling:Be(new d(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Be(new g(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new we),inlineSuggest:Be(new Z),suggestFontSize:Be(new g(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new g(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new d(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Be(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Be(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Be(new g(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new K),unusualLineTerminators:Be(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Be(new d(121,"useShadowDOM",!0)),useTabStops:Be(new d(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Be(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Be(new p(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Be(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new g(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Be(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new O),pixelRatio:Be(new te),tabFocusMode:Be(new d(137,"tabFocusMode",!1,{markdownDescription:a.localize(323,null)})),layoutInfo:Be(new V),wrappingInfo:Be(new qe),wrappingIndent:Be(new ze),wrappingStrategy:Be(new J)}}),define(Ce[170],Ie([14,15]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[171],Ie([14,15]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[172],Ie([14,15]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[173],Ie([14,15]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[174],Ie([14,15]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[175],Ie([14,15]),function(se,e){return se.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[176],Ie([14,15]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(Ce[177],Ie([14,15]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(Ce[178],Ie([14,15]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[179],Ie([14,15]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(Ce[180],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[181],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[182],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[183],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[184],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[185],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[186],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[187],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[188],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[189],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[190],Ie([14,15]),function(se,e){return se.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[191],Ie([14,15]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(Ce[192],Ie([14,15]),function(se,e){return se.create("vs/workbench/common/views",e)}),define(Ce[193],Ie([14,15]),function(se,e){return se.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[194],Ie([14,15]),function(se,e){return se.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[195],Ie([14,15]),function(se,e){return se.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[196],Ie([14,15]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[197],Ie([14,15]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[198],Ie([14,15]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[199],Ie([14,15]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[200],Ie([14,15]),function(se,e){return se.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[201],Ie([1,0,10,172]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var u;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(u=e.TokenType||(e.TokenType={}));function R(...m){switch(m.length){case 1:return(0,A.localize)(0,null,m[0]);case 2:return(0,A.localize)(1,null,m[0],m[1]);case 3:return(0,A.localize)(2,null,m[0],m[1],m[2]);default:return}}const P=(0,A.localize)(3,null),T=(0,A.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const I=this.d,S=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:S};this.g.push({offset:I,lexeme:S,additionalInfo:L}),this.f.push(k)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const I=this.c.substring(this.d,this.e),S=y.b.get(I);S?this.k(S):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,I=!1,S=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(T);return}const C=this.c.charCodeAt(L);if(I)I=!1;else if(C===47&&!S){L++;break}else C===91?S=!0:C===92?I=!0:C===93&&(S=!1);L++}for(;L<this.c.length&&y.a.has(this.c.charCodeAt(L));)L++;this.e=L;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}y.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),y.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=y}),define(Ce[202],Ie([1,0,24,37,174,325]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||P.test(d)}e.isValidVersionStr=y;function m(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=m;function L(d){if(!d)return null;const f=d.majorBase,g=d.majorMustEqual,D=d.minorBase;let p=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(f===0||(p=!1),o=!1);let s=0;if(d.preRelease){const c=T.exec(d.preRelease);if(c){const[,l,v,i]=c;s=Date.UTC(Number(l),Number(v)-1,Number(i))}}return{majorBase:f,majorMustEqual:g,minorBase:D,minorMustEqual:p,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function I(d,f,g){let D;typeof d=="string"?D=L(m(d)):D=d;let p;f instanceof Date?p=f.getTime():typeof f=="string"&&(p=new Date(f).getTime());let t;if(typeof g=="string"?t=L(m(g)):t=g,!D||!t)return!1;const o=D.majorBase,s=D.minorBase,c=D.patchBase;let l=t.majorBase,v=t.minorBase,i=t.patchBase;const n=t.notBefore;let h=t.majorMustEqual,w=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?o>l?!0:o<l?!1:s>v?!0:s<v||p&&p<n?!1:c>=i:(o===1&&l===0&&(!h||!w||!b)&&(l=1,v=0,i=0,h=!0,w=!1,b=!1),o<l?!1:o>l?!h:s<v?!1:s>v?!w:c<i?!1:c>i?!b:!(p&&p<n))}e.isValidVersion=I;function S(d,f,g,D,p){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([A.default.Error,u.localize(0,null)]),t;if(typeof D.name!="string")return t.push([A.default.Error,u.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([A.default.Error,u.localize(2,null,"version")]),t;if(!D.engines)return t.push([A.default.Error,u.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([A.default.Error,u.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!r(D.extensionDependencies))return t.push([A.default.Error,u.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!r(D.activationEvents))return t.push([A.default.Error,u.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([A.default.Error,u.localize(7,null,"activationEvents","main")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([A.default.Warning,u.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([A.default.Error,u.localize(9,null,"main")]),t;{const c=(0,a.joinPath)(g,D.main);(0,a.isEqualOrParent)(c,g)||t.push([A.default.Warning,u.localize(10,null,c.path,g.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,u.localize(11,null,"activationEvents","main")]),t}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([A.default.Error,u.localize(12,null,"browser")]),t;{const c=(0,a.joinPath)(g,D.browser);(0,a.isEqualOrParent)(c,g)||t.push([A.default.Warning,u.localize(13,null,c.path,g.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,u.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(D.version))return t.push([A.default.Error,u.localize(15,null)]),t;const o=[];if(!k(d,f,D,p,o))for(const c of o)t.push([A.default.Error,c]);return t}e.validateExtensionManifest=S;function k(d,f,g,D,p){return D||typeof g.main>"u"&&typeof g.browser>"u"?!0:E(d,f,g.engines.vscode,p)}e.isValidExtensionVersion=k;function C(d,f,g){return d==="*"||E(f,g,d)}e.isEngineValid=C;function E(d,f,g,D=[]){const p=L(m(g));if(!p)return D.push(u.localize(16,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(u.localize(17,null,g)),!1}else if(!p.majorMustEqual)return D.push(u.localize(18,null,g)),!1;return I(d,f,p)?!0:(D.push(u.localize(19,null,d,g)),!1)}function r(d){if(!Array.isArray(d))return!1;for(let f=0,g=d.length;f<g;f++)if(typeof d[f]!="string")return!1;return!0}}),define(Ce[90],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(u,R=[],P=!1){this.ctor=u,this.staticArguments=R,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=a}),define(Ce[91],Ie([1,0,90]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var u;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function R(T,y,m){y instanceof a.SyncDescriptor||(y=new a.SyncDescriptor(y,[],Boolean(m))),A.push([T,y])}e.registerSingleton=R;function P(){return A}e.getSingletonServiceDescriptors=P}),define(Ce[203],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,P){this.key=R,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const P of this.a.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const T=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(P);T.outgoing.set(y.key,y),y.incoming.set(T.key,T)}removeNode(R){const P=this.b(R);this.a.delete(P);for(const T of this.a.values())T.outgoing.delete(P),T.incoming.delete(P)}lookupOrInsertNode(R){const P=this.b(R);let T=this.a.get(P);return T||(T=new a(P,R),this.a.set(P,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[P,T]of this.a)R.push(`${P}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,P]of this.a){const T=new Set([R]),y=this.c(P,T);if(y)return y}}c(R,P){for(const[T,y]of R.outgoing){if(P.has(T))return[...P,T].join(" -> ");P.add(T);const m=this.c(y,P);if(m)return m;P.delete(T)}}}e.Graph=A}),define(Ce[4],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function T(y){return y[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function A(P,T,y){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:P,index:y}):(T[a.DI_DEPENDENCIES]=[{id:P,index:y}],T[a.DI_TARGET]=T)}function u(P){if(a.serviceIds.has(P))return a.serviceIds.get(P);const T=function(y,m,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(T,y,L)};return T.toString=()=>P,a.serviceIds.set(P,T),T}e.createDecorator=u;function R(P){return P}e.refineServiceDecorator=R}),define(Ce[54],Ie([1,0,9,2,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=R;function P(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=P;var T;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function m(r,d){const f=Object.create(null);for(const g in r)L(f,g,r[g],d);return f}e.toValuesTree=m;function L(r,d,f,g){const D=d.split("."),p=D.pop();let t=r;for(let o=0;o<D.length;o++){const s=D[o];let c=t[s];switch(typeof c){case"undefined":c=t[s]=Object.create(null);break;case"object":break;default:g(`Ignoring ${d} as ${D.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[p]=f}catch{g(`Ignoring ${d} as ${D.join(".")} is ${JSON.stringify(t)}`)}else g(`Ignoring ${d} as ${D.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=L;function I(r,d){const f=d.split(".");S(r,f)}e.removeFromValueTree=I;function S(r,d){const f=d.shift();if(d.length===0){delete r[f];return}if(Object.keys(r).indexOf(f)!==-1){const g=r[f];typeof g=="object"&&!Array.isArray(g)&&(S(g,d),Object.keys(g).length===0&&delete r[f])}}function k(r,d,f){function g(t,o){let s=t;for(const c of o){if(typeof s!="object"||s===null)return;s=s[c]}return s}const D=d.split("."),p=g(r,D);return typeof p>"u"?f:p}e.getConfigurationValue=k;function C(r,d,f){Object.keys(d).forEach(g=>{g!=="__proto__"&&(g in r?a.isObject(r[g])&&a.isObject(d[g])?C(r[g],d[g],f):f&&(r[g]=d[g]):r[g]=d[g])})}e.merge=C;function E(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Ce[44],Ie([1,0,11,8,201,4,171]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",a.isMacintosh),T.set("isLinux",a.isLinux),T.set("isWindows",a.isWindows),T.set("isWeb",a.isWeb),T.set("isMacNative",a.isMacintosh&&!a.isWeb),T.set("isEdge",a.isEdge),T.set("isFirefox",a.isFirefox),T.set("isChrome",a.isChrome),T.set("isSafari",a.isSafari);const y=Object.prototype.hasOwnProperty;var m;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class L{static false(){return l.INSTANCE}static true(){return v.INSTANCE}static has(F){return i.create(F)}static equals(F,Q){return n.create(F,Q)}static notEquals(F,Q){return b.create(F,Q)}static regex(F,Q){return B.create(F,Q)}static in(F,Q){return h.create(F,Q)}static notIn(F,Q){return w.create(F,Q)}static not(F){return O.create(F)}static and(...F){return he.create(F,null,!0)}static or(...F){return ie.create(F,null,!0)}static greater(F,Q){return x.create(F,Q)}static greaterEquals(F,Q){return _.create(F,Q)}static smaller(F,Q){return G.create(F,Q)}static smallerEquals(F,Q){return M.create(F,Q)}static deserialize(F){if(!!F)return this.c(F)}static c(F){const Q=F.split("||");return ie.create(Q.map(me=>this.d(me)),null,!0)}static d(F){const Q=F.split("&&");return he.create(Q.map(me=>this.f(me)),null,!0)}static f(F){if(F=F.trim(),F.indexOf("!=")>=0){const Q=F.split("!=");return b.create(Q[0].trim(),this.g(Q[1]))}if(F.indexOf("==")>=0){const Q=F.split("==");return n.create(Q[0].trim(),this.g(Q[1]))}if(F.indexOf("=~")>=0){const Q=F.split("=~");return B.create(Q[0].trim(),this.h(Q[1]))}if(F.indexOf(" not in ")>=0){const Q=F.split(" not in ");return w.create(Q[0].trim(),this.g(Q[1]))}if(F.indexOf(" in ")>=0){const Q=F.split(" in ");return h.create(Q[0].trim(),this.g(Q[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const Q=F.split(">=");return _.create(Q[0].trim(),Q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const Q=F.split(">");return x.create(Q[0].trim(),Q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const Q=F.split("<=");return M.create(Q[0].trim(),Q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const Q=F.split("<");return G.create(Q[0].trim(),Q[1].trim())}return/^\!\s*/.test(F)?O.create(F.substr(1).trim()):i.create(F)}static g(F){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const Q=/^'([^']*)'$/.exec(F);return Q?Q[1].trim():F}static h(F){if((0,A.isFalsyOrWhitespace)(F))return null;const Q=F.indexOf("/"),me=F.lastIndexOf("/");if(Q===me||Q<0)return null;const Ee=F.slice(Q+1,me),te=F[me+1]==="i"?"i":"";try{return new RegExp(Ee,te)}catch{return null}}}e.ContextKeyExpr=L;const I={regexParsingWithErrorRecovery:!0};class S extends Error{}const k=(0,P.localize)(0,null),C=(0,P.localize)(1,null),E=(0,P.localize)(2,null),r=(0,P.localize)(3,null),d=(0,P.localize)(4,null),f=(0,P.localize)(5,null),g=(0,P.localize)(6,null),D=(0,P.localize)(7,null),p=(0,P.localize)(8,null);class t{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(F=I){this.h=F,this.c=new u.Scanner,this.d=[],this.f=0,this.g=[]}parse(F){if(F===""){this.g.push({message:k,offset:0,lexeme:"",additionalInfo:C});return}this.d=this.c.reset(F).scan(),this.f=0,this.g=[];try{const Q=this.k();if(!this.C()){const me=this.B(),Ee=me.type===17?g:void 0;throw this.g.push({message:f,offset:me.offset,lexeme:u.Scanner.getLexeme(me),additionalInfo:Ee}),new S}return Q}catch(Q){if(!(Q instanceof S))throw Q;return}}k(){return this.l()}l(){const F=[this.o()];for(;this.w(16);){const Q=this.o();F.push(Q)}return F.length===1?F[0]:L.or(...F)}o(){const F=[this.s()];for(;this.w(15);){const Q=this.s();F.push(Q)}return F.length===1?F[0]:L.and(...F)}s(){if(this.w(2)){const F=this.B();switch(F.type){case 17:return this.x(),L.not(F.lexeme);case 11:return this.x(),L.false();case 12:return this.x(),L.true();default:throw this.z("CONTEXT | true | false",F,E)}}return this.t()}t(){const F=this.B();switch(F.type){case 11:return this.x(),L.true();case 12:return this.x(),L.false();case 0:{this.x();const Q=this.k();return this.y(1,d),Q}case 17:{const Q=F.lexeme;if(this.x(),this.w(9)){const Ee=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),Ee.type!==10)throw this.z("REGEX",Ee);const te=Ee.lexeme,ne=te.lastIndexOf("/"),de=ne===te.length-1?void 0:te.substring(ne+1);let ee;try{ee=new RegExp(te.substring(1,ne),de)}catch{throw this.z("REGEX",Ee)}return B.create(Q,ee)}switch(Ee.type){case 10:case 19:{const te=[Ee.lexeme];this.x();let ne=this.B(),de=0;for(let z=0;z<Ee.lexeme.length;z++)Ee.lexeme.charCodeAt(z)===40?de++:Ee.lexeme.charCodeAt(z)===41&&de--;for(;!this.C()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let z=0;z<ne.lexeme.length;z++)ne.lexeme.charCodeAt(z)===40?de++:Ee.lexeme.charCodeAt(z)===41&&de--}if(de<0)break;te.push(u.Scanner.getLexeme(ne)),this.x(),ne=this.B()}const ee=te.join(""),ce=ee.lastIndexOf("/"),ae=ce===ee.length-1?void 0:ee.substring(ce+1);let N;try{N=new RegExp(ee.substring(1,ce),ae)}catch{throw this.z("REGEX",Ee)}return L.regex(Q,N)}case 18:{const te=Ee.lexeme;this.x();let ne=null;if(!(0,A.isFalsyOrWhitespace)(te)){const de=te.indexOf("/"),ee=te.lastIndexOf("/");if(de!==ee&&de>=0){const ce=te.slice(de+1,ee),ae=te[ee+1]==="i"?"i":"";try{ne=new RegExp(ce,ae)}catch{throw this.z("REGEX",Ee)}}}if(ne===null)throw this.z("REGEX",Ee);return B.create(Q,ne)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,r);const Ee=this.u();return L.notIn(Q,Ee)}switch(this.B().type){case 3:{this.x();const Ee=this.u();if(this.v().type===18)return L.equals(Q,Ee);switch(Ee){case"true":return L.has(Q);case"false":return L.not(Q);default:return L.equals(Q,Ee)}}case 4:{this.x();const Ee=this.u();if(this.v().type===18)return L.notEquals(Q,Ee);switch(Ee){case"true":return L.not(Q);case"false":return L.has(Q);default:return L.notEquals(Q,Ee)}}case 5:return this.x(),G.create(Q,this.u());case 6:return this.x(),M.create(Q,this.u());case 7:return this.x(),x.create(Q,this.u());case 8:return this.x(),_.create(Q,this.u());case 13:return this.x(),L.in(Q,this.u());default:return L.has(Q)}}case 20:throw this.g.push({message:D,offset:F.offset,lexeme:"",additionalInfo:p}),new S;default:throw this.z(`true | false | CONTEXT 
	| CONTEXT '=~' REGEX 
	| CONTEXT ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const F=this.B();switch(F.type){case 17:case 18:return this.x(),F.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(F){return this.A(F)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(F,Q){if(this.A(F))return this.x();throw this.z(Q,this.B())}z(F,Q,me){const Ee=(0,P.localize)(9,null,F,u.Scanner.getLexeme(Q)),te=Q.offset,ne=u.Scanner.getLexeme(Q);return this.g.push({message:Ee,offset:te,lexeme:ne,additionalInfo:me}),new S}A(F){return this.B().type===F}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=t;function o(q){const F=new t({regexParsingWithErrorRecovery:!1});return q.map(Q=>(F.parse(Q),F.lexingErrors.length>0?F.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,P.localize)(10,null,me.additionalInfo):(0,P.localize)(11,null),offset:me.offset,length:me.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=o;function s(q,F){const Q=q?q.substituteConstants():void 0,me=F?F.substituteConstants():void 0;return!Q&&!me?!0:!Q||!me?!1:Q.equals(me)}e.expressionsAreEqualWithConstantSubstitution=s;function c(q,F){return q.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}l.INSTANCE=new l,e.ContextKeyFalseExpr=l;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class i{static create(F,Q=null){const me=T.get(F);return typeof me=="boolean"?me?v.INSTANCE:l.INSTANCE:new i(F,Q)}constructor(F,Q){this.key=F,this.c=Q,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:J(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=i;class n{static create(F,Q,me=null){if(typeof Q=="boolean")return Q?i.create(F,me):O.create(F,me);const Ee=T.get(F);return typeof Ee=="boolean"?Q===(Ee?"true":"false")?v.INSTANCE:l.INSTANCE:new n(F,Q,me)}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=T.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?v.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=n;class h{static create(F,Q){return new h(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:re(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.f),me=F.getValue(this.d);return Array.isArray(Q)?Q.includes(me):typeof me=="string"&&typeof Q=="object"&&Q!==null?y.call(Q,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=h;class w{static create(F,Q){return new w(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=11,this.c=h.create(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=w;class b{static create(F,Q,me=null){if(typeof Q=="boolean")return Q?O.create(F,me):i.create(F,me);const Ee=T.get(F);return typeof Ee=="boolean"?Q===(Ee?"true":"false")?l.INSTANCE:v.INSTANCE:new b(F,Q,me)}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=T.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?l.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=b;class O{static create(F,Q=null){const me=T.get(F);return typeof me=="boolean"?me?l.INSTANCE:v.INSTANCE:new O(F,Q)}constructor(F,Q){this.c=F,this.d=Q,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:J(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=T.get(this.c);return typeof F=="boolean"?F?l.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=i.create(this.c,this)),this.d}}e.ContextKeyNotExpr=O;function H(q,F){if(typeof q=="string"){const Q=parseFloat(q);isNaN(Q)||(q=Q)}return typeof q=="string"||typeof q=="number"?F(q):l.INSTANCE}class x{static create(F,Q,me=null){return H(Q,Ee=>new x(F,Ee,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=x;class _{static create(F,Q,me=null){return H(Q,Ee=>new _(F,Ee,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=_;class G{static create(F,Q,me=null){return H(Q,Ee=>new G(F,Ee,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=G;class M{static create(F,Q,me=null){return H(Q,Ee=>new M(F,Ee,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:re(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=M;class B{static create(F,Q){return new B(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const Q=this.f?this.f.source:"",me=F.f?F.f.source:"";return Q<me?-1:Q>me?1:0}equals(F){if(F.type===this.type){const Q=this.f?this.f.source:"",me=F.f?F.f.source:"";return this.d===F.d&&Q===me}return!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.ContextKeyRegexExpr=B;class U{static create(F){return new U(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new U(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=U;function j(q){let F=null;for(let Q=0,me=q.length;Q<me;Q++){const Ee=q[Q].substituteConstants();if(q[Q]!==Ee&&F===null){F=[];for(let te=0;te<Q;te++)F[te]=q[te]}F!==null&&(F[Q]=Ee)}return F===null?q:F}class he{static create(F,Q,me){return he.d(F,Q,me)}constructor(F,Q){this.expr=F,this.c=Q,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,me=this.expr.length;Q<me;Q++){const Ee=c(this.expr[Q],F.expr[Q]);if(Ee!==0)return Ee}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=j(this.expr);return F===this.expr?this:he.create(F,this.c,!1)}evaluate(F){for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].evaluate(F))return!1;return!0}static d(F,Q,me){const Ee=[];let te=!1;for(const ne of F)if(!!ne){if(ne.type===1){te=!0;continue}if(ne.type===0)return l.INSTANCE;if(ne.type===6){Ee.push(...ne.expr);continue}Ee.push(ne)}if(Ee.length===0&&te)return v.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(c);for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const ne=Ee[Ee.length-1];if(ne.type!==9)break;Ee.pop();const de=Ee.pop(),ee=Ee.length===0,ce=ie.create(ne.expr.map(ae=>he.create([ae,de],null,me)),null,ee);ce&&(Ee.push(ce),Ee.sort(c))}if(Ee.length===1)return Ee[0];if(me){for(let ne=0;ne<Ee.length;ne++)for(let de=ne+1;de<Ee.length;de++)if(Ee[ne].negate().equals(Ee[de]))return l.INSTANCE;if(Ee.length===1)return Ee[0]}return new he(Ee,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new he(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());this.c=ie.create(F,this,!0)}return this.c}}class ie{static create(F,Q,me){return ie.d(F,Q,me)}constructor(F,Q){this.expr=F,this.c=Q,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,me=this.expr.length;Q<me;Q++){const Ee=c(this.expr[Q],F.expr[Q]);if(Ee!==0)return Ee}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=j(this.expr);return F===this.expr?this:ie.create(F,this.c,!1)}evaluate(F){for(let Q=0,me=this.expr.length;Q<me;Q++)if(this.expr[Q].evaluate(F))return!0;return!1}static d(F,Q,me){let Ee=[],te=!1;if(F){for(let ne=0,de=F.length;ne<de;ne++){const ee=F[ne];if(!!ee){if(ee.type===0){te=!0;continue}if(ee.type===1)return v.INSTANCE;if(ee.type===9){Ee=Ee.concat(ee.expr);continue}Ee.push(ee)}}if(Ee.length===0&&te)return l.INSTANCE;Ee.sort(c)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];if(me){for(let ne=0;ne<Ee.length;ne++)for(let de=ne+1;de<Ee.length;de++)if(Ee[ne].negate().equals(Ee[de]))return v.INSTANCE;if(Ee.length===1)return Ee[0]}return new ie(Ee,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new ie(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());for(;F.length>1;){const Q=F.shift(),me=F.shift(),Ee=[];for(const te of le(Q))for(const ne of le(me))Ee.push(he.create([te,ne],null,!1));F.unshift(ie.create(Ee,null,!1))}this.c=ie.create(F,this,!0)}return this.c}}class V extends i{static all(){return V.d.values()}constructor(F,Q,me){super(F,null),this.f=Q,typeof me=="object"?V.d.push({...me,key:F}):me!==!0&&V.d.push({key:F,description:me,type:Q!=null?typeof Q:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return n.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}V.d=[],e.RawContextKey=V,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function J(q,F){return q<F?-1:q>F?1:0}function re(q,F,Q,me){return q<Q?-1:q>Q?1:F<me?-1:F>me?1:0}function ve(q,F){if(q.type===0||F.type===1)return!0;if(q.type===9)return F.type===9?ue(q.expr,F.expr):!1;if(F.type===9){for(const Q of F.expr)if(ve(q,Q))return!0;return!1}if(q.type===6){if(F.type===6)return ue(F.expr,q.expr);for(const Q of q.expr)if(ve(Q,F))return!0;return!1}return q.equals(F)}e.implies=ve;function ue(q,F){let Q=0,me=0;for(;Q<q.length&&me<F.length;){const Ee=q[Q].cmp(F[me]);if(Ee<0)return!1;Ee===0&&Q++,me++}return Q===q.length}function le(q){return q.type===9?q.expr:[q]}}),define(Ce[204],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[123],Ie([1,0,173,4]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function P(d,f){switch(d){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function T(d,f){return f==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function y(d,f,g){return T(f,g)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===g?!0:m(g).includes(d)}e.isTargetPlatformCompatible=y;function m(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L;var I;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var k;(function(d){d.Install="install",d.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var C;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var E;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(f,g){super(f),this.code=g,this.name=g}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(Ce[205],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Ce[206],Ie([1,0,47,18,12,11,110,29,117,175,205]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends S{openTerminal(D,p){return this.spawnTerminal(a,D,y.getWindowsShell(),p)}spawnTerminal(D,p,t,o){const s=p.windowsExec||k.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=u.basename(s,".exe").toLowerCase();if(c==="cmder")return D.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),c==="wt"&&l.push("-d ."),new Promise((v,i)=>{const n=r(process),h=D.spawn(t,l,{cwd:o,env:n});h.on("error",i),h.on("exit",()=>v())})}runInTerminal(D,p,t,o,s){const c="windowsExec"in s&&s.windowsExec?s.windowsExec:k.getDefaultTerminalWindows();return new Promise((l,v)=>{const i=`"${p} - ${I}"`,n=`""${t.join('" "')}" & pause"`,h=Object.assign({},r(process),o);Object.keys(h).filter(x=>h[x]===null).forEach(x=>delete h[x]);const w={cwd:p,env:h,windowsVerbatimArguments:!0};let b,O;u.basename(c,".exe")==="wt"?(b=c,O=["-d",".",k.b,"/c",n]):(b=k.b,O=["/c","start",i,"/wait",c,"/c",n]),a.spawn(b,O,w).on("error",x=>{v(d(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const D=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${D?"Sysnative":"System32"}\\cmd.exe`}return k.d}}k.b="cmd.exe",e.WindowsExternalTerminalService=k;class C extends S{openTerminal(D,p){return this.spawnTerminal(a,D,p)}runInTerminal(D,p,t,o,s){const c=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,v)=>{if(c===L.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const i=c===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",D||I,"-w",p];for(const O of t)h.push("-a"),h.push(O);if(o){const O=Object.assign({},r(process),o);for(const H in O){const x=O[H];x===null?(h.push("-u"),h.push(H)):(h.push("-e"),h.push(`${H}=${x}`))}}let w="";const b=a.spawn(C.b,h);b.on("error",O=>{v(d(O))}),b.stderr.on("data",O=>{w+=O.toString()}),b.on("exit",O=>{if(O===0)l(void 0);else if(w){const H=w.split(`
`,1);v(new Error(H[0]))}else v(new Error(m.localize(1,null,i,O)))})}else v(new Error(m.localize(2,null,c)))})}spawnTerminal(D,p,t){const o=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{const l=["-a",o];t&&l.push(t);const v=r(process),i=D.spawn("/usr/bin/open",l,{cwd:t,env:v});i.on("error",c),i.on("exit",()=>s())})}}C.b="/usr/bin/osascript",e.MacExternalTerminalService=C;class E extends S{openTerminal(D,p){return this.spawnTerminal(a,D,p)}runInTerminal(D,p,t,o,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((l,v)=>{const i=[];c.then(n=>{n.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${f(t)}; echo; read -p "${E.b}" -n1;`;i.push(`''${h}''`);const w=Object.assign({},r(process),o);Object.keys(w).filter(x=>w[x]===null).forEach(x=>delete w[x]);const b={cwd:p,env:w};let O="";const H=a.spawn(n,i,b);H.on("error",x=>{v(d(x))}),H.stderr.on("data",x=>{O+=x.toString()}),H.on("exit",x=>{if(x===0)l(void 0);else if(O){const _=O.split(`
`,1);v(new Error(_[0]))}else v(new Error(m.localize(4,null,n,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!R.isLinux)E.d=Promise.resolve("xterm");else{const D=await T.Promises.exists("/etc/debian_version");E.d=new Promise(p=>{D?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return E.d}spawnTerminal(D,p,t){const o=p.linuxExec?Promise.resolve(p.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{o.then(l=>{const v=r(process),i=D.spawn(l,[],{cwd:t,env:v});i.on("error",c),i.on("exit",()=>s())})})}}E.b=m.localize(3,null),e.LinuxExternalTerminalService=E;function r(g){const D={...g.env};return(0,P.sanitizeProcessEnvironment)(D),D}function d(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(m.localize(5,null,g.path)):g}function f(g){let D="";for(const p of g)p.indexOf(" ")>=0?D+='"'+p+'"':D+=p,D+=" ";return D}}),define(Ce[45],Ie([1,0,69,12,8,9,2,176,4,11,18]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I(V){return V.create===!0}e.isFileOpenForWriteOptions=I;var S;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var k;(function(V){V[V.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function r(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=r;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function g(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=g;function D(V){return E(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(J,re){const ve=new t(J.toString(),re);return c(ve,re),ve}constructor(J,re){super(J),this.code=re}}e.FileSystemProviderError=t;function o(V,J){return t.create(V,J)}e.createFileSystemProviderError=o;function s(V){return V||o((0,T.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function c(V,J){return V.name=J?`${J} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=c;function l(V){if(!V)return p.Unknown;if(V instanceof t)return V.code;const J=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=l;function v(V){if(V instanceof O)return V.fileOperationResult;switch(l(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(J,re,ve){this.resource=J,this.operation=re,this.target=ve}isOperation(J){return this.operation===J}}e.FileOperationEvent=n;var h;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class w{constructor(J,re){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ve=new Map;for(const ue of J){const le=ve.get(ue.type);switch(le?le.push([ue.resource,ue]):ve.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,le]of ve)switch(ue){case 1:this.a=a.TernarySearchTree.forUris(()=>re),this.a.fill(le);break;case 0:this.b=a.TernarySearchTree.forUris(()=>re),this.b.fill(le);break;case 2:this.c=a.TernarySearchTree.forUris(()=>re),this.c.fill(le);break}}contains(J,...re){return this.d(J,{includeChildren:!1},...re)}affects(J,...re){return this.d(J,{includeChildren:!0},...re)}d(J,re,...ve){if(!J)return!1;const ue=ve.length>0;return!!((!ue||ve.includes(1))&&(this.a?.get(J)||re.includeChildren&&this.a?.findSuperstr(J))||(!ue||ve.includes(0))&&(this.b?.get(J)||re.includeChildren&&this.b?.findSuperstr(J))||(!ue||ve.includes(2))&&(this.c?.findSubstr(J)||re.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=w;function b(V,J,re){return!V||!J||V===J||J.length>V.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),re?(0,u.startsWithIgnoreCase)(V,J):V.indexOf(J)===0)}e.isParent=b;class O extends Error{constructor(J,re,ve){super(J),this.fileOperationResult=re,this.options=ve}}e.FileOperationError=O;class H extends O{constructor(J,re,ve,ue){super(J,re,ue),this.fileOperationResult=re,this.size=ve}}e.TooLargeFileOperationError=H;class x extends O{constructor(J,re,ve){super(J,2,ve),this.stat=re}}e.NotModifiedSinceFileOperationError=x;var _;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=M;async function B(V,J){if(!J.hasProvider(P.URI.from({scheme:V.scheme})))return new Promise(re=>{const ve=J.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===V.scheme&&ue.added&&(ve.dispose(),re())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<U.KB?(0,T.localize)(1,null,J.toFixed(0)):J<U.MB?(0,T.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,T.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,T.localize)(4,null,(J/U.GB).toFixed(2)):(0,T.localize)(5,null,(J/U.TB).toFixed(2))}}U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB,e.ByteSize=U;var j;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=he;function ie(V){const J=typeof V=="string"||V?.scheme===L.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===L.Schemas.file?1024*U.MB:J?10*U.MB:m.isWeb?50*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ie}),define(Ce[92],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...u){this.a=new Map;for(const[R,P]of u)this.set(R,P)}set(u,R){const P=this.a.get(u);return this.a.set(u,R),P}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=a}),define(Ce[207],Ie([1,0,19,10,6,90,203,4,92,66]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class S{constructor(r=new y.ServiceCollection,d=!1,f,g=L){this.f=r,this.g=d,this.h=f,this.i=g,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=g?f?._globalGraph??new P.Graph(D=>D):void 0}createChild(r){return new S(r,this.g,this,this.i)}invokeFunction(r,...d){const f=C.traceInvocation(this.i,r);let g=!1;try{return r({get:p=>{if(g)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(p,f);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...d)}finally{g=!0,f.stop()}}createInstance(r,...d){let f,g;return r instanceof R.SyncDescriptor?(f=C.traceCreation(this.i,r.ctor),g=this.j(r.ctor,r.staticArguments.concat(d),f)):(f=C.traceCreation(this.i,r),g=this.j(r,d,f)),f.stop(),g}j(r,d=[],f){const g=T._util.getServiceDependencies(r).sort((t,o)=>t.index-o.index),D=[];for(const t of g){const o=this.m(t.id,f);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(o)}const p=g.length>0?g[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${r.name} at position ${p+1} conflicts with ${d.length} static arguments`);const t=p-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,p)}return Reflect.construct(r,d.concat(D))}k(r,d){if(this.f.get(r)instanceof R.SyncDescriptor)this.f.set(r,d);else if(this.h)this.h.k(r,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const d=this.f.get(r);return!d&&this.h?this.h.l(r):d}m(r,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const f=this.l(r);return f instanceof R.SyncDescriptor?this.q(r,f,d.branch(r,!0)):(d.branch(r,!1),f)}q(r,d,f){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,d,f)}finally{this.o.delete(r)}}r(r,d,f){const g=new P.Graph(t=>t.id.toString());let D=0;const p=[{id:r,desc:d,_trace:f}];for(;p.length;){const t=p.pop();if(g.lookupOrInsertNode(t),D++>1e3)throw new I(g);for(const o of T._util.getServiceDependencies(t.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof R.SyncDescriptor){const c={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};g.insertEdge(t,c),p.push(c)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new I(g);break}for(const{data:o}of t){if(this.l(o.id)instanceof R.SyncDescriptor){const c=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,c)}g.removeNode(o)}}return this.l(r)}s(r,d,f=[],g,D){if(this.f.get(r)instanceof R.SyncDescriptor)return this.t(r,d,f,g,D);if(this.h)return this.h.s(r,d,f,g,D);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(r,d,f=[],g,D){if(g){const p=new S(void 0,this.g,this,this.i);p.c=String(r);const t=new Map,o=new a.IdleValue(()=>{const s=p.j(d,f,D);for(const[c,l]of t){const v=s[c];if(typeof v=="function")for(const i of l)v.apply(s,i)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let i=t.get(c);return i||(i=new m.LinkedList,t.set(c,i)),(h,w,b)=>{const O=i.push([h,w,b]);return(0,u.toDisposable)(O)}}if(c in s)return s[c];const l=o.value;let v=l[c];return typeof v!="function"||(v=v.bind(l),s[c]=v),v},set(s,c,l){return o.value[c]=l,!0},getPrototypeOf(s){return d.prototype}})}else return this.j(d,f,D)}u(r,d){if(d&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=S;var k;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(k||(k={}));class C{static traceInvocation(r,d){return r?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(r,d){return r?new C(1,d.name):C.c}constructor(r,d){this.type=r,this.name=d,this.g=Date.now(),this.h=[]}branch(r,d){const f=new C(3,r.toString());return this.h.push([r,d,f]),f}stop(){const r=Date.now()-this.g;C.f+=r;let d=!1;function f(D,p){const t=[],o=new Array(D+1).join("	");for(const[s,c,l]of p.h)if(c&&l){d=!0,t.push(`${o}CREATES -> ${s}`);const v=f(D+1,l);v&&t.push(v)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(r>2||d)&&C.all.add(g.join(`
`))}}C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0,e.Trace=C}),define(Ce[16],Ie([1,0,46,3,68,6,28,11,24,9,2,44,4]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}function C(h){return(0,m.isNumber)(h)}e.isLogLevel=C;var E;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function r(h,w,b){switch(w){case E.Trace:h.trace(b);break;case E.Debug:h.debug(b);break;case E.Info:h.info(b);break;case E.Warning:h.warn(b);break;case E.Error:h.error(b);break;case E.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=r;function d(h,w=!1){let b="";for(let O=0;O<h.length;O++){let H=h[O];if(H instanceof Error&&(H=(0,a.toErrorMessage)(H,w)),typeof H=="object")try{H=JSON.stringify(H)}catch{}b+=(O>0?" ":"")+H}return b}class f extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==E.Off&&this.b<=w}}e.AbstractLogger=f;class g extends f{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...b){this.f(E.Trace)&&this.g(E.Trace,d([w,...b],!0))}debug(w,...b){this.f(E.Debug)&&this.g(E.Debug,d([w,...b]))}info(w,...b){this.f(E.Info)&&this.g(E.Info,d([w,...b]))}warn(w,...b){this.f(E.Warning)&&this.g(E.Warning,d([w,...b]))}error(w,...b){if(this.f(E.Error))if(w instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=w.stack,this.g(E.Error,d(O))}else this.g(E.Error,d([w,...b]))}flush(){}}e.AbstractMessageLogger=g;class D extends f{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.g=!T.isWindows}trace(w,...b){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,w,...b):console.log(`[main ${k()}]`,w,...b))}debug(w,...b){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,w,...b):console.log(`[main ${k()}]`,w,...b))}info(w,...b){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,w,...b):console.log(`[main ${k()}]`,w,...b))}warn(w,...b){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,w,...b):console.warn(`[main ${k()}]`,w,...b))}error(w,...b){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,w,...b):console.error(`[main ${k()}]`,w,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class p extends f{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w)}trace(w,...b){this.f(E.Trace)&&console.log("%cTRACE","color: #888",w,...b)}debug(w,...b){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",w,...b)}info(w,...b){this.f(E.Info)&&console.log("%c INFO","color: #33f",w,...b)}warn(w,...b){this.f(E.Warning)&&console.log("%c WARN","color: #993",w,...b)}error(w,...b){this.f(E.Error)&&console.log("%c  ERR","color: #f33",w,...b)}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends f{constructor(w,b=e.DEFAULT_LOG_LEVEL){super(),this.g=w,this.setLevel(b)}trace(w,...b){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(w),...b])}debug(w,...b){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(w),...b])}info(w,...b){this.f(E.Info)&&this.g.log(E.Info,[this.h(w),...b])}warn(w,...b){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(w),...b])}error(w,...b){this.f(E.Error)&&this.g.log(E.Error,[this.h(w),...b])}h(w){return typeof w=="string"?w:(0,a.toErrorMessage)(w,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends f{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const b of this.g)b.setLevel(w);super.setLevel(w)}trace(w,...b){for(const O of this.g)O.trace(w,...b)}debug(w,...b){for(const O of this.g)O.debug(w,...b)}info(w,...b){for(const O of this.g)O.info(w,...b)}warn(w,...b){for(const O of this.g)O.warn(w,...b)}error(w,...b){for(const O of this.g)O.error(w,...b)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.MultiplexLogger=o;class s extends R.Disposable{constructor(w,b,O){if(super(),this.h=w,this.j=b,this.b=new P.ResourceMap,this.c=this.D(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new A.Emitter),this.onDidChangeVisibility=this.g.event,O)for(const H of O)this.b.set(H.resource,{logger:void 0,info:H})}k(w){return(0,m.isString)(w)?[...this.b.values()].find(b=>b.info.id===w):this.b.get(w)}getLogger(w){return this.k(w)?.logger}createLogger(w,b){const O=this.l(w),H=(0,m.isString)(w)?w:b?.id??(0,u.hash)(O.toString()).toString(16);let x=this.b.get(O)?.logger;const _=b?.logLevel==="always"?E.Trace:b?.logLevel;x||(x=this.m(O,_??this.getLogLevel(O)??this.h,{...b,id:H}));const G={logger:x,info:{resource:O,id:H,logLevel:_,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(G.info),this.b.set(O,G),x}l(w){return(0,m.isString)(w)?(0,y.joinPath)(this.j,`${w}.log`):w}setLogLevel(w,b){if(L.URI.isUri(w)){const O=w,H=b,x=this.b.get(O);x&&H!==x.info.logLevel&&(x.info.logLevel=H===this.h?void 0:H,x.logger?.setLevel(H),this.b.set(x.info.resource,x),this.f.fire([O,H]))}else{this.h=w;for(const[O,H]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,b){const O=this.k(w);O&&b!==!O.info.hidden&&(O.info.hidden=!b,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,b]))}getLogLevel(w){let b;return w&&(b=this.b.get(w)?.info.logLevel),b??this.h}registerLogger(w){const b=this.b.get(w.resource);b?b.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const b=this.b.get(w);b&&(b.logger&&b.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class c{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(w){}getLevel(){return E.Info}trace(w,...b){}debug(w,...b){}info(w,...b){}warn(w,...b){}error(w,...b){}critical(w,...b){}dispose(){}flush(){}}e.NullLogger=c;class l extends c{}e.NullLogService=l;function v(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const w=n(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function i(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=i;function n(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=n,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",i(E.Info))}),define(Ce[208],Ie([1,0,6,16]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends a.Disposable{constructor(P,T=[]){super(),this.a=new A.MultiplexLogger([P,...T]),this.D(P.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...T){this.a.trace(P,...T)}debug(P,...T){this.a.debug(P,...T)}info(P,...T){this.a.info(P,...T)}warn(P,...T){this.a.warn(P,...T)}error(P,...T){this.a.error(P,...T)}flush(){this.a.flush()}}e.LogService=u}),define(Ce[209],Ie([1,0,45,16]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(u||(u={}));async function R(m,L,I,S,k){try{const C=await new Promise((r,d)=>{se(["spdlog"],r,d)});C.setFlushOn(u.Trace);const E=await C.createAsyncRotatingLogger(m,L,I,S);return k?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(C){console.error(C)}return null}function P(m,L,I){switch(L){case A.LogLevel.Trace:m.trace(I);break;case A.LogLevel.Debug:m.debug(I);break;case A.LogLevel.Info:m.info(I);break;case A.LogLevel.Warning:m.warn(I);break;case A.LogLevel.Error:m.error(I);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function T(m,L){switch(L){case A.LogLevel.Trace:m.setLevel(u.Trace);break;case A.LogLevel.Debug:m.setLevel(u.Debug);break;case A.LogLevel.Info:m.setLevel(u.Info);break;case A.LogLevel.Warning:m.setLevel(u.Warning);break;case A.LogLevel.Error:m.setLevel(u.Error);break;case A.LogLevel.Off:m.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends A.AbstractMessageLogger{constructor(L,I,S,k,C){super(),this.k=[],this.setLevel(C),this.l=this.n(L,I,S,k),this.D(this.onDidChangeLogLevel(E=>{this.m&&T(this.m,E)}))}async n(L,I,S,k){const C=S?6:1,E=30/C*a.ByteSize.MB,r=await R(L,I,E,C,k);if(r){this.m=r,T(this.m,this.getLevel());for(const{level:d,message:f}of this.k)P(this.m,d,f);this.k=[]}}g(L,I){this.m?P(this.m,L,I):this.getLevel()<=L&&this.k.push({level:L,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(Ce[124],Ie([1,0,37,177,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var P;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function m(C,E){return E-C}y.compare=m;const L=Object.create(null);L[y.Error]=(0,A.localize)(0,null),L[y.Warning]=(0,A.localize)(1,null),L[y.Info]=(0,A.localize)(2,null);function I(C){return L[C]||""}y.toString=I;function S(C){switch(C){case a.default.Error:return y.Error;case a.default.Warning:return y.Warning;case a.default.Info:return y.Info;case a.default.Ignore:return y.Hint}}y.fromSeverity=S;function k(C){switch(C){case y.Error:return a.default.Error;case y.Warning:return a.default.Warning;case y.Info:return a.default.Info;case y.Hint:return a.default.Ignore}}y.toSeverity=k}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(y){const m="";function L(S){return I(S,!0)}y.makeKey=L;function I(S,k){const C=[m];return S.source?C.push(S.source.replace("\xA6","\\\xA6")):C.push(m),S.code?typeof S.code=="string"?C.push(S.code.replace("\xA6","\\\xA6")):C.push(S.code.value.replace("\xA6","\\\xA6")):C.push(m),S.severity!==void 0&&S.severity!==null?C.push(P.toString(S.severity)):C.push(m),S.message&&k?C.push(S.message.replace("\xA6","\\\xA6")):C.push(m),S.startLineNumber!==void 0&&S.startLineNumber!==null?C.push(S.startLineNumber.toString()):C.push(m),S.startColumn!==void 0&&S.startColumn!==null?C.push(S.startColumn.toString()):C.push(m),S.endLineNumber!==void 0&&S.endLineNumber!==null?C.push(S.endLineNumber.toString()):C.push(m),S.endColumn!==void 0&&S.endColumn!==null?C.push(S.endColumn.toString()):C.push(m),C.push(m),C.join("\xA6")}y.makeKeyOptionalMessage=I})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(Ce[210],Ie([1,0,3,37,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,u.createDecorator)("notificationService");var R;(function(m){m[m.WORKSPACE=0]="WORKSPACE",m[m.PROFILE=1]="PROFILE",m[m.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(m){m[m.OFF=0]="OFF",m[m.SILENT=1]="SILENT",m[m.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new y,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=T;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(Ce[125],Ie([1,0,8,2,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function R(m,L){return A.URI.isUri(m)?(0,a.equalsIgnoreCase)(m.scheme,L):(0,a.startsWithIgnoreCase)(m,L+":")}e.matchesScheme=R;function P(m,...L){return L.some(I=>R(m,I))}e.matchesSomeScheme=P;function T(m,L){return m.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=T;function y(m){let L;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return I&&(L={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},m=m.with({fragment:""})),{selection:L,uri:m}}e.extractSelection=y}),define(Ce[211],Ie([1,0,11,36]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)u=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:R.version})}}else u={},Object.keys(u).length===0&&Object.assign(u,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(Ce[212],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(se,e){return function(a,A){e(a,A,se)}};define(Ce[126],Ie([1,0,19,21,6,4]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(I){this.b=I}report(I){this.a=I,this.b(this.a)}}T.None=Object.freeze({report(){}}),e.Progress=T;let y=class extends u.Disposable{constructor(I,S){super(),this.a=new a.DeferredPromise,S.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.D((0,u.toDisposable)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};y=Ve([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class m extends u.Disposable{constructor(I){super(),this.g=I,this.a=0,this.b=this.D(new u.DisposableStore)}start(I){this.stop();const S=++this.a,k=new A.CancellationTokenSource;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>k.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:S,token:k.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(Ce[39],Ie([1,0,51,9]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(P,T){a.ok(A.isString(P)),a.ok(A.isObject(T)),a.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,T)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.Registry=new u}),define(Ce[93],Ie([1,0,3,39]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,m){this.a[u(y)]=m,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const P=new R;A.Registry.add(e.Extensions.JSONContribution,P)}),define(Ce[127],Ie([1,0,17,3,9,170,54,93,39]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=y.Registry.as(T.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:c,source:l}of t)for(const v in c)if(o.add(v),e.OVERRIDE_PROPERTY_REGEX.test(v)){const i=this.a.get(v),n=i?.valuesSources??new Map;if(l)for(const O of Object.keys(c[v]))n.set(O,l);const h={...i?.value||{},...c[v]};this.a.set(v,{source:l,value:h,valuesSources:n});const w=(0,P.getLanguageTagSettingPlainKey)(v),b={type:"object",default:h,description:R.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:u.isString(l)?void 0:l,defaultValueSource:l};s.push(...E(v)),this.d[v]=b,this.b.properties[v]=b}else{this.a.set(v,{value:c[v],source:l});const i=this.d[v];i&&(this.w(v,i),this.r(v,i))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:c}of t)for(const l in s){const v=this.a.get(l),i=u.isString(c)?c:c?.id,n=u.isString(v?.source)?v?.source:v?.source?.id;if(i===n)if(o.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const h=this.d[l];h&&(this.w(l,h),this.r(l,h))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(c=>{this.p(c,o,c.extensionInfo,c.restrictedProperties,void 0,s),this.c.push(c),this.q(c)})}o(t,o){const s=c=>{if(c.properties)for(const l in c.properties){o.add(l);const v=this.d[l];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[l],this.s(l,c.properties[l])}c.allOf?.forEach(l=>s(l))};for(const c of t){s(c);const l=this.c.indexOf(c);l!==-1&&this.c.splice(l,1)}}p(t,o=!0,s,c,l=3,v){l=u.isUndefinedOrNull(t.scope)?l:t.scope;const i=t.properties;if(i)for(const h in i){const w=i[h];if(o&&g(h,w)){delete i[h];continue}if(w.source=s,w.defaultDefaultValue=i[h].default,this.w(h,w),e.OVERRIDE_PROPERTY_REGEX.test(h)?w.scope=void 0:(w.scope=u.isUndefinedOrNull(w.scope)?l:w.scope,w.restricted=u.isUndefinedOrNull(w.restricted)?!!c?.includes(h):w.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.f[h]=i[h],delete i[h];continue}else this.d[h]=i[h],i[h].policy?.name&&this.e.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),v.add(h)}const n=t.allOf;if(n)for(const h of n)this.p(h,o,s,c,l,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const c=s.properties;if(c)for(const v in c)this.r(v,c[v]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let c=s?.value,l=s?.source;u.isUndefined(c)&&(c=o.defaultDefaultValue,l=void 0),u.isUndefined(c)&&(c=d(o.type)),o.default=c,o.defaultValueSource=l}}const k="\\[([^\\]]+)\\]",C=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=C.exec(p);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=C.exec(p)}}return(0,a.distinct)(t)}e.overrideIdentifiersFromKey=E;function r(p){return p.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=r;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new S;y.Registry.add(e.Extensions.Configuration,f);function g(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):f.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,p,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function D(){const p=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))p.push([o,t[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=D}),define(Ce[213],Ie([1,0,17,3,147,6,28,23,9,2,54,127,39]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(o){return Object.isFrozen(o)?o:T.deepFreeze(o)}class C{constructor(s={},c=[],l=[],v){this.b=s,this.c=c,this.d=l,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof C)return c;const l=new E("");return l.parseRaw(c),l.configurationModel});this.f=s.reduce((c,l)=>l===c?l:c.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,c){const l=this.rawConfiguration.getValue(s),v=c?this.rawConfiguration.getOverrideValue(s,c):void 0,i=c?this.rawConfiguration.override(c).getValue(s):l;return{value:l,override:v,merged:i}}getOverrideValue(s,c){const l=this.i(c);return l?s?(0,L.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const l of this.overrides)l.identifiers.includes(s)&&c.push(...l.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return a.distinct(s)}override(s){let c=this.a.get(s);return c||(c=this.g(s),this.a.set(s,c)),c}merge(...s){const c=T.deepClone(this.contents),l=T.deepClone(this.overrides),v=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const n of s)if(i.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.h(c,n.contents);for(const h of n.overrides){const[w]=l.filter(b=>a.equals(b.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=a.distinct(w.keys)):l.push(T.deepClone(h))}for(const h of n.keys)v.indexOf(h)===-1&&v.push(h)}return new C(c,v,l,i.every(n=>n instanceof C)?void 0:i)}g(s){const c=this.i(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const l={};for(const v of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let i=this.contents[v];const n=c[v];n&&(typeof i=="object"&&typeof n=="object"?(i=T.deepClone(i),this.h(i,n)):i=n),l[v]=i}return new C(l,this.keys,this.overrides)}h(s,c){for(const l of Object.keys(c)){if(l in s&&y.isObject(s[l])&&y.isObject(c[l])){this.h(s[l],c[l]);continue}s[l]=T.deepClone(c[l])}}i(s){let c=null,l=null;const v=i=>{i&&(l?this.h(l,i):l=T.deepClone(i))};for(const i of this.overrides)a.equals(i.identifiers,[s])?c=i.contents:i.identifiers.includes(s)&&v(i.contents);return v(c),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.j(s,c,!0)}setValue(s,c){this.j(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,L.removeFromValueTree)(this.contents,s),I.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>a.equals(l.identifiers,(0,I.overrideIdentifiersFromKey)(s))),1))}j(s,c,l){(0,L.addToValueTree)(this.contents,s,c,v=>console.error(v)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),I.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],v=>console.error(v))})}}e.ConfigurationModel=C;class E{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!y.isUndefinedOrNull(s)){const l=this.g(s);this.parseRaw(l,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:l,keys:v,overrides:i,restricted:n,hasExcludedProperties:h}=this.h(s,c);this.b=new C(l,v,i,h?[s]:void 0),this.c=n||[]}g(s){let c={},l=null,v=[];const i=[],n=[];function h(b){Array.isArray(v)?v.push(b):l!==null&&(v[l]=b)}const w={onObjectBegin:()=>{const b={};h(b),i.push(v),v=b,l=null},onObjectProperty:b=>{l=b},onObjectEnd:()=>{v=i.pop()},onArrayBegin:()=>{const b=[];h(b),i.push(v),v=b,l=null},onArrayEnd:()=>{v=i.pop()},onLiteralValue:h,onError:(b,O,H)=>{n.push({error:b,offset:O,length:H})}};if(s)try{u.visit(s,w),c=v[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return c}h(s,c){const l=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),v=this.i(s,l,!0,c);s=v.raw;const i=(0,L.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),n=Object.keys(s),h=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:i,keys:n,overrides:h,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(s,c,l,v){let i=!1;if(!v?.scopes&&!v?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:i};const n={},h=[];for(const w in s)if(I.OVERRIDE_PROPERTY_REGEX.test(w)&&l){const b=this.i(s[w],c,!1,v);n[w]=b.raw,i=i||b.hasExcludedProperties,h.push(...b.restricted)}else{const b=c[w],O=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&h.push(w),(O===void 0||v.scopes===void 0||v.scopes.includes(O))&&!(v.skipRestricted&&b?.restricted)?n[w]=s[w]:i=!0}return{raw:n,restricted:h,hasExcludedProperties:i}}j(s,c){const l=[];for(const v of Object.keys(s))if(I.OVERRIDE_PROPERTY_REGEX.test(v)){const i={};for(const n in s[v])i[n]=s[v][n];l.push({identifiers:(0,I.overrideIdentifiersFromKey)(v),keys:Object.keys(i),contents:(0,L.toValuesTree)(i,c)})}return l}}e.ConfigurationModelParser=E;class r extends R.Disposable{constructor(s,c,l,v){super(),this.f=s,this.g=c,this.h=v,this.c=this.D(new A.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(l.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(A.Event.any(A.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&l.isEqual(i.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class d{constructor(s,c,l,v,i,n,h,w,b,O,H,x,_){this.a=s,this.b=c,this.c=l,this.overrideIdentifiers=v,this.d=i,this.f=n,this.g=h,this.h=w,this.i=b,this.j=O,this.k=H,this.l=x,this.m=_}get value(){return k(this.c)}n(s,c,l){const v=s.inspect(c,l);return{get value(){return k(v.value)},get override(){return k(v.override)},get merged(){return k(v.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,c,l,v,i=new C,n=new C,h=new P.ResourceMap,w=new C,b=new P.ResourceMap){this.c=s,this.d=c,this.f=l,this.g=v,this.h=i,this.i=n,this.j=h,this.l=w,this.m=b,this.a=null,this.b=new P.ResourceMap,this.n=null}getValue(s,c,l){return this.q(s,c,l).getValue(s)}updateValue(s,c,l={}){let v;l.resource?(v=this.m.get(l.resource),v||(v=new C,this.m.set(l.resource,v))):v=this.l,c===void 0?v.removeValue(s):v.setValue(s,c),l.resource||(this.a=null)}inspect(s,c,l){const v=this.q(s,c,l),i=this.u(c.resource,l),n=c.resource?this.m.get(c.resource)||this.l:this.l,h=new Set;for(const w of v.overrides)for(const b of w.identifiers)v.getOverrideValue(s,b)!==void 0&&h.add(b);return new d(s,c,v.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,i||void 0,n)}keys(s){const c=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,c){this.j.set(s,c),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const l=[];if(!c){const{added:v,updated:i,removed:n}=p(this.c,s);c=[...v,...i,...n]}for(const v of c)for(const i of(0,I.overrideIdentifiersFromKey)(v)){const n=this.c.getKeysForOverrideIdentifier(i),h=s.getKeysForOverrideIdentifier(i),w=[...h.filter(b=>n.indexOf(b)===-1),...n.filter(b=>h.indexOf(b)===-1),...n.filter(b=>!T.equals(this.c.override(i).getValue(b),s.override(i).getValue(b)))];l.push([i,w])}return this.updateDefaultConfiguration(s),{keys:c,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:l,removed:v}=p(this.d,s),i=[...c,...l,...v];return i.length&&this.updatePolicyConfiguration(s),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:l,removed:v,overrides:i}=p(this.applicationConfiguration,s),n=[...c,...l,...v];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:l,removed:v,overrides:i}=p(this.localUserConfiguration,s),n=[...c,...l,...v];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:l,removed:v,overrides:i}=p(this.remoteUserConfiguration,s),n=[...c,...l,...v];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:l,removed:v,overrides:i}=p(this.workspaceConfiguration,s),n=[...c,...l,...v];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:i}}compareAndUpdateFolderConfiguration(s,c){const l=this.p.get(s),{added:v,updated:i,removed:n,overrides:h}=p(l,c),w=[...v,...i,...n];return(w.length||!l)&&this.updateFolderConfiguration(s,c),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(s){const c=this.p.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:v,removed:i,overrides:n}=p(c,void 0);return{keys:[...l,...v,...i],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,c,l){let v=this.r(c,l);return c.overrideIdentifier&&(v=v.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(v=v.merge(this.d)),v}r({resource:s},c){let l=this.s();if(c&&s){const v=c.getFolder(s);v&&(l=this.t(v.uri)||l);const i=this.m.get(s);i&&(l=l.merge(i))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let c=this.b.get(s);if(!c){const l=this.s(),v=this.j.get(s);v?(c=l.merge(v),this.b.set(s,c)):c=l}return c}u(s,c){if(c&&s){const l=c.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,c)=>{const{contents:l,overrides:v,keys:i}=this.j.get(c);return s.push([c,{contents:l,overrides:v,keys:i}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.i.keys.forEach(c=>s.add(c)),this.j.forEach(c=>c.keys.forEach(l=>s.add(l))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}w(s){const c=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(v=>c.add(v))),[...c.values()]}static parse(s){const c=this.x(s.defaults),l=this.x(s.policy),v=this.x(s.application),i=this.x(s.user),n=this.x(s.workspace),h=s.folders.reduce((w,b)=>(w.set(m.URI.revive(b[0]),this.x(b[1])),w),new P.ResourceMap);return new f(c,l,v,i,new C,n,h,new C,new P.ResourceMap)}static x(s){return new C(s.contents,s.keys,s.overrides)}}e.Configuration=f;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,c=new Map;for(const v of o)v.keys.forEach(i=>s.add(i)),v.overrides.forEach(([i,n])=>{const h=(0,P.getOrSet)(c,i,new Set);n.forEach(w=>h.add(w))});const l=[];return c.forEach((v,i)=>l.push([i,[...v.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=g;class D{constructor(s,c,l,v){this.change=s,this.f=c,this.g=l,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of s.keys)this.affectedKeys.add(i);for(const[,i]of s.overrides)for(const n of i)this.affectedKeys.add(n);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,c){const l=this.a+s,v=this.d.indexOf(l);if(v<0)return!1;const i=v+l.length;if(i>=this.d.length)return!1;const n=this.d.charCodeAt(i);if(n!==this.b&&n!==this.c)return!1;if(c){const h=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,w=this.g.getValue(s,c,this.h);return!T.equals(h,w)}return!0}}e.ConfigurationChangeEvent=D;function p(o,s){const{added:c,removed:l,updated:v}=t(s?.rawConfiguration,o?.rawConfiguration),i=[],n=o?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const w=h.filter(b=>!n.includes(b));for(const b of w)i.push([b,s.getKeysForOverrideIdentifier(b)])}if(o){const w=n.filter(b=>!h.includes(b));for(const b of w)i.push([b,o.getKeysForOverrideIdentifier(b)])}if(s&&o){for(const w of n)if(h.includes(w)){const b=t({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});i.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:c,removed:l,updated:v,overrides:i}}function t(o,s){const c=o?s?o.keys.filter(i=>s.keys.indexOf(i)===-1):[...o.keys]:[],l=s?o?s.keys.filter(i=>o.keys.indexOf(i)===-1):[...s.keys]:[],v=[];if(o&&s){for(const i of s.keys)if(o.keys.indexOf(i)!==-1){const n=(0,L.getConfigurationValue)(s.contents,i),h=(0,L.getConfigurationValue)(o.contents,i);T.equals(n,h)||v.push(i)}}return{added:c,removed:l,updated:v}}}),define(Ce[128],Ie([1,0,10,4]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var u;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===u.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===u.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===u.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,m=u.Unknown,L){super(y),this._message=y,this._code=m,this._detail=L,this.isHandled=m===u.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function P(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}e.getRemoteAuthorityPrefix=P}),define(Ce[73],Ie([1,0,18]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(m){return m.scheme===a.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=A;function u(m){if(!m)return;const L=m.indexOf("+");return L<0?m:m.substr(0,L)}e.getRemoteName=u;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function P(m){const{host:L,port:I}=y(m);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.parseAuthorityWithPort=P;function T(m,L){let{host:I,port:S}=y(m);return typeof S>"u"&&(S=L),{host:I,port:S}}e.parseAuthorityWithOptionalPort=T;function y(m){const L=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Ce[25],Ie([1,0,8,4,73]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var T;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,d){if(typeof r>"u"||r===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof r=="string"||typeof d=="string"){const f=typeof r=="string"?r:r.value,g=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(f,g)}return r.c===d.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=y;class m{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const d of r)this.add(d)}add(r){this.c.add(y.toKey(r))}delete(r){return this.c.delete(y.toKey(r))}has(r){return this.c.has(y.toKey(r))}}e.ExtensionIdentifierSet=m;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(y.toKey(r))}get(r){return this.c.get(y.toKey(r))}has(r){return this.c.has(y.toKey(r))}set(r,d){this.c.set(y.toKey(r),d)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function I(E){return S(E)}e.isApplicationScopedExtension=I;function S(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function k(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=k;function C(E,r){if(r){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(r)}`;return!!E.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[129],Ie([1,0,10,25]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class u{constructor(){this.a=new Map,this.b=new WeakMap}register(P,T){this.a.set(P,T)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const T=Object.create(null);for(const y of P){const m=this.readActivationEvents(y);m.length>0&&(T[A.ExtensionIdentifier.toKey(y.identifier)]=m)}return T}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const T=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return T;for(const y in P.contributes){const m=this.a.get(y);if(!m)continue;const L=P.contributes[y],I=Array.isArray(L)?L:[L];try{m(I,T)}catch(S){(0,a.onUnexpectedError)(S)}}return T}}e.ImplicitActivationEventsImpl=u,e.ImplicitActivationEvents=new u}),define(Ce[214],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((u,R)=>se(["vsda"],u,R))}async createNewMessage(u){try{const R=await this.c(),P=new R.validator;if(P){const T=String(a.a++);return this.b.set(T,P),{id:T,data:P.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,R){if(!u.id)return!0;const P=this.b.get(u.id);if(!P)return!1;this.b.delete(u.id);try{return P.validate(R)==="ok"}catch{return!1}}async sign(u){try{const R=await this.c(),P=new R.signer;if(P)return P.sign(u)}catch{}return u}}a.a=1,e.SignService=a}),define(Ce[215],Ie([1,0,11,36,2,30]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(m){if(a.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function T(m,L,I,S,k,C,E,r,d,f){const g=Object.create(null);g["common.machineId"]=E,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=k,g.version=C,g["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,a.PlatformToString)(a.platform),g["common.nodePlatform"]=A.platform,g["common.nodeArch"]=S,g["common.product"]=f||"desktop",r&&(g["common.msftInternal"]=r);let D=0;const p=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),a.isLinuxSnap&&(g["common.snap"]="true");const t=P(I);t&&(g["common.platformDetail"]=t);try{const o=await m.readFile(u.URI.file(d));g["common.source"]=o.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=T;function y(m){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const I=L.toLowerCase();return m.some(S=>I===S)}e.verifyMicrosoftInternalDomain=y}),define(Ce[216],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[74],Ie([1,0,23,9,3,54,73,215,216]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(l){this.value=l}}e.TelemetryTrustedValue=m;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,v){return Promise.resolve(void 0)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class I{async publicLog(l,v,i){}async publicLogError(l,v,i){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(c,l){return u.Event.debounce(l.onDidChangeConfiguration,(i,n)=>{const h=i?new Set([...i.affectedKeys,...n.affectedKeys]):n.affectedKeys;return{...n,affectedKeys:h}},1e3,!0)(i=>{i.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=S;function k(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=k;function C(c,l){return!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=C;function E(c){const l=c.getValue(y.TELEMETRY_SETTING_ID),v=c.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function r(c){const l={},v={},i={};g(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const h=i[n];typeof h=="number"?v[n]=h:typeof h=="boolean"?v[n]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${h.length}`),l[n]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(l[n]=h)}return{properties:l,measurements:v}}e.validateTelemetryData=r;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(c){if(!c)return"none";const l=(0,P.getRemoteName)(c);return d.has(l)?l:"other"}e.cleanRemoteAuthority=f;function g(c,l,v=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const h=c[n],w=i?i+n:n;Array.isArray(h)?l[w]=(0,a.safeStringify)(h):h instanceof Date?l[w]=h.toISOString():(0,A.isObject)(h)?v<2?g(h,l,v+1,w+"."):l[w]=(0,a.safeStringify)(h):l[w]=h}}function D(c,l){const v=c.msftInternalDomains||[],i=l.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(v)||i}e.isInternalTelemetry=D;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let v=c;const i=[];for(const b of l)for(;;){const O=b.exec(c);if(!O)break;i.push([O.index,b.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(v="";;){const b=h.exec(c);if(!b)break;const O=i.some(([H,x])=>b.index<x&&H<h.lastIndex);!n.test(b[0])&&!O&&(v+=c.substring(w,b.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<c.length&&(v+=c.substr(w)),v}function o(c){if(!c)return c;const l=c.toLowerCase(),v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of v)if(i.regex.test(l))return`<REDACTED: ${i.label}>`;return c}function s(c,l){return(0,a.cloneAndChange)(c,v=>{if(v instanceof m)return v.value;if(typeof v=="string"){let i=v.replaceAll("%20"," ");i=t(i,l);for(const n of l)i=i.replace(n,"");return i=o(i),i}})}e.cleanData=s}),define(Ce[217],Ie([1,0,8,123,25,11,2,10,36,74]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,c){return s.uuid&&c.uuid?s.uuid===c.uuid:s.id===c.id?!0:(0,a.compareIgnoreCase)(s.id,c.id)===0}e.areSameExtensions=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(c){const l=c.manifest?c.manifest.version:c.version,v=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new S(c.identifier,l,v)}static parse(c){const l=I.exec(c);return l&&l[1]&&l[2]?new S({id:l[1]},l[2],l[4]||void 0):null}constructor(c,l,v="undefined"){this.version=l,this.targetPlatform=v,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof S?L(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=S;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const c=k.exec(s);return c&&c[1]?[r(c[1]),c[2]]:[r(s),void 0]}e.getIdAndVersion=C;function E(s,c){return`${s}.${c}`}e.getExtensionId=E;function r(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function d(s,c){return r(E(s,c))}e.getGalleryExtensionId=d;function f(s,c){const l=[],v=i=>{for(const n of l)if(n.some(h=>L(c(h),c(i))))return n;return null};for(const i of s){const n=v(i);n?n.push(i):l.push([i])}return l}e.groupByExtension=f;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function D(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function p(s,c){const l=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const i=v.shift();if(i&&l.every(n=>!L(n.identifier,{id:i}))){const n=s.filter(h=>L(h.identifier,{id:i}));n.length===1&&(l.push(n[0]),v.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=p;async function t(s,c){if(!R.isLinux)return!1;let l;try{l=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){c.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(i))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,c){const l=await t(s,c),v=(0,A.getTargetPlatform)(l?"alpine":R.platform,y.arch);return c.debug("ComputeTargetPlatform:",v),v}e.computeTargetPlatform=o}),define(Ce[218],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=a;function A(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=A;function u(P){return Array.from(P.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=u;function R(P){return new Map(P.map(T=>[T[0],{map:A(T[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(Ce[219],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,R,P=5){const T=R(y=>{const m=typeof y=="string"?y:y.data;let L=this.a.get(u);if(L){L.data.push(m);return}const I=setTimeout(()=>this.flushBuffer(u),P);L={data:[m],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(u),T.dispose()}},this.a.set(u,L)});return T}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const R=this.a.get(u);R&&(this.a.delete(u),this.b(u,R.data.join("")))}}e.TerminalDataBufferer=a}),define(Ce[220],Ie([1,0,19,67,52,3,9,2,178,93,39]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(D){function p(t,o){let s=t.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const c=C.getIcon(s.id);if(!c)return;s=c.defaults}return s}D.getDefinition=p})(I=e.IconContribution||(e.IconContribution={}));var S;(function(D){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}D.toJSONObject=p;function t(o){const s=c=>(0,P.isString)(c)?c:void 0;if(o&&Array.isArray(o.src)&&o.src.every(c=>(0,P.isString)(c.format)&&(0,P.isString)(c.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(c=>({format:c.format,location:T.URI.parse(c.location)}))}}D.fromJSONObject=t})(S=e.IconFontDefinition||(e.IconFontDefinition={}));class k{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,t,o,s){const c=this.b[p];if(c){if(o&&!c.description){c.description=o,this.d.properties[p].markdownDescription=`${o} $(${p})`;const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enumDescriptions[i]=o),this.a.fire()}return c}const l={id:p,description:o,defaults:t,deprecationMessage:s};this.b[p]=l;const v={$ref:"#/definitions/icons"};return s&&(v.deprecationMessage=s),o&&(v.markdownDescription=`${o}: $(${p})`),this.d.properties[p]=v,this.e.enum.push(p),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const t=this.e.enum.indexOf(p);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,t){const o=this.f[p];return o||(this.f[p]=t,this.a.fire(),t)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,l)=>c.id.localeCompare(l.id),t=c=>{for(;u.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(c=>this.b[c]);for(const c of s.filter(l=>!!l.description).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|${u.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const c of s.filter(l=>!u.ThemeIcon.isThemeIcon(l.defaults)).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|`);return o.join(`
`)}}const C=new k;L.Registry.add(e.Extensions.IconContribution,C);function E(D,p,t,o){return C.registerIcon(D,p,t,o)}e.registerIcon=E;function r(){return C}e.getIconRegistry=r;function d(){const D=(0,A.getCodiconFontCharacters)();for(const p in D){const t="\\"+D[p].toString(16);C.registerIcon(p,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const f=L.Registry.as(m.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,C.getIconSchema());const g=new a.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=E("widget-close",A.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",A.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",A.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=u.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(Ce[130],Ie([1,0,3,54,4,16]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var P;(function(E){E.Http="http",E.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=I;function S(E,r,d,f){if(d===1)return!1;if(d===2&&I(r)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(g?.length===4&&parseInt(g[1])>=18)return!1}return E<1024}e.isPortPrivileged=S;class k{constructor(r,d,f){this.remoteAddress=r,this.localAddress=d,this.b=f,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=k;let C=class{constructor(r,d){this.i=r,this.j=d,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],d=Array.from(this.d.values());for(const f of d){const g=Array.from(f.values());for(const D of g){const p=await D.value;p&&r.push(p)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:d}of r.values())await d.then(f=>f?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,d,f,g,D){this.o(r,d,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:d,localAddress:f,privacy:g,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,d){(I(r)||L(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const f=this.q(r,d);if(f)return++f.refcount,f.value}openTunnel(r,d,f,g,D,p=!1,t,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${D}.`),!r)return;if(d||(d="localhost"),g||(g=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(r,d,f,g,D,p,t,o);return s?s.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const d=this.d.get(r.tunnelRemoteHost);if(d){const f=d.get(r.tunnelRemotePort);f&&(f.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,f))}}}}async n(r,d,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${d}.`);const g=f.value.then(async D=>{D&&(await D.dispose(!0),this.b.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(d),g}}async closeTunnel(r,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${d} `);const f=this.d.get(r);if(f&&f.has(d)){const g=f.get(d);g.refcount=0,await this.n(r,d,g)}}o(r,d,f){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(d,{refcount:1,value:f})}async p(r,d){const f=this.d.get(r);f&&(await f.get(d)||f.delete(d),f.size===0&&this.d.delete(r))}q(r,d){const f=[r];L(r)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):I(r)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const g=f.map(D=>this.d.get(D));for(const D of g){const p=D?.get(d);if(p)return p}}canTunnel(r){return!!m(r)}s(r,d,f,g,D,p,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${g}.`);const o=f;this.h.add(o);const s=g===void 0?f:g,c={elevationRequired:D?this.isPortPrivileged(s):!1},l={remoteAddress:{host:d,port:f},localAddressPort:g,privacy:p,public:p?p!==T.Private:void 0,protocol:t},v=r.forwardPort(l,c);return v?(this.o(d,f,v),v.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),v}};C=Ve([We(0,R.ILogService),We(1,A.IConfigurationService)],C),e.AbstractTunnelService=C}),define(Ce[221],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var A;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[222],Ie([1,0,18]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(y){return y.scheme!==a.Schemas.file&&y.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=A;function u(y){if(y.folders.length)return y.folders.every(m=>A(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=u;function R(y){return u(y)?.scheme}e.getVirtualWorkspaceScheme=R;function P(y){return u(y)?.authority}e.getVirtualWorkspaceAuthority=P;function T(y){return u(y)!==void 0}e.isVirtualWorkspace=T}),define(Ce[48],Ie([1,0,179,12,69,24,2,4,18]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function m(c){const l=c;return typeof l?.id=="string"&&P.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=m;function L(c){return typeof c?.id=="string"&&!m(c)&&!S(c)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(c,l){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,A.basename)(c)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const v=c;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}e.toWorkspaceIdentifier=I;function S(c){const l=c;return typeof l?.id=="string"&&P.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=S;function k(c){const l=c;if(l?.uri)return{id:l.id,uri:P.URI.revive(l.uri)};const v=c;if(v?.configPath)return{id:v.id,configPath:P.URI.revive(v.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=k;var C;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function E(c){const l=c;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=E;function r(c){const l=c;return!!(l&&typeof l=="object"&&P.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=r;class d{constructor(l,v,i,n,h){this.h=l,this.j=i,this.k=n,this.l=h,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=v}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class f{constructor(l,v){this.raw=v,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function g(c){return new f({uri:c,index:0,name:(0,R.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(c,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(c,l.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function p(c){let l;return P.URI.isUri(c)?l=c:l=c.configuration,l?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(c,l){return!D(c,l)&&!p(c)}e.isSavedWorkspace=o;function s(c){return(typeof c=="string"?(0,A.extname)(c):(0,R.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ce[75],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const R=this.c++;return this.b.set(R,u),this.e(),R}get(u,R){return this.b.has(u)?this.b.get(u)[R]:void 0}delete(u){this.b.delete(u),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(Ce[49],Ie([1,0,18,24,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(T=>{const y=this.b.get(T.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(T,y){y===null?this.b.delete(T.scheme):this.b.set(T.scheme,y)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ce[223],Ie([1,0,182,16,208,26]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(y,m,L){const I=L.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",S=L.remote.isRemote?(0,a.localize)(0,null):y?(0,a.localize)(1,null):(0,a.localize)(2,null);super(m.createLogger(I,{name:S}))}};P=Ve([We(1,A.ILoggerService),We(2,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ce[224],Ie([1,0,19]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(P,T,y){this.h=new Map,this.a=P,this.b=T,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new a.RunOnceScheduler(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of m.values())L.complete()}catch(L){for(const I of m.values())I.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,T){let y=this.f[P];return typeof y>"u"&&(y=T),y}update(P,T){this.f[P]=T;const y=this.h.get(P);if(y!==void 0)return y.p;const m=new a.DeferredPromise;return this.h.set(P,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class u extends A{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,T){super(P.identifier.value,!0,T),this.j=P}}e.ExtensionGlobalMemento=u}),define(Ce[225],Ie([1,0,3,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(P){this.c=P,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,T,y,m){const I=this.c.getNotebookDocument(A.URI.revive(P)).acceptModelChanged(T.value,y,m);this.b.fire(I)}$acceptDirtyStateChanged(P,T){this.c.getNotebookDocument(A.URI.revive(P)).acceptDirty(T)}$acceptModelSaved(P){const T=this.c.getNotebookDocument(A.URI.revive(P));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(Ce[20],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[226],Ie([1,0,25,3]),function(se,e,a,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(T,y){u.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),Je(this,u,y,"f"),Me(this,u,"f").onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(T){return Me(this,u,"f").get(this.a,T)}store(T,y){return Me(this,u,"f").store(this.a,T,y)}delete(T){return Me(this,u,"f").delete(this.a,T)}}e.ExtensionSecrets=R,u=new WeakMap}),define(Ce[55],Ie([1,0,4,130,3,20]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var P;(function(y){function m(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:I.protocol}}y.fromApiTunnel=m;function L(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==A.TunnelPrivacyId.ConstantPrivate&&I.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}y.fromServiceTunnel=L})(P=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(m){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,L){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,L){return{dispose:()=>{}}}async $providePortAttributes(m,L,I,S,k){return[]}async $forwardPort(m,L){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([We(0,R.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Ce[56],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=A}),define(Ce[227],Ie([1,0,22]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function u(T,y){if(y.serializeBuffersForPostMessage){const m=new A,L=(k,C)=>{if(C instanceof ArrayBuffer){const E=m.add(C);return{$$vscode_array_buffer_reference$$:!0,index:E}}else if(ArrayBuffer.isView(C)){const E=R(C);if(E){const r=m.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:r,view:{type:E,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},I=JSON.stringify(T,L),S=m.buffers.map(k=>{const C=new Uint8Array(k);return a.VSBuffer.wrap(C)});return{message:I,buffers:S}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=u;function R(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(T,y){const m=y.map(S=>{const k=new ArrayBuffer(S.byteLength);return new Uint8Array(k).set(S.buffer),k}),L=y.length?(S,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const C=k,{index:E}=C,r=m[E];if(C.view)switch(C.view.type){case 1:return new Int8Array(r,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return k}:void 0;return{message:JSON.parse(T,L),arrayBuffers:m}}e.deserializeWebviewMessage=P}),define(Ce[228],Ie([1,0,115]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:R,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function u(R){return new a.URITransformer(A(R))}e.createURITransformer=u}),define(Ce[131],Ie([1,0,191,9,2,6,4,39,45,18,46,162,37]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(ue){const le=ue;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.isEditorPaneWithSelection=E;function r(ue,le,q){for(const F of q.visibleEditorPanes)if(F.group.id===le&&ue.matches(F.input))return F.getViewState()}e.findViewStateForEditor=r;function d(ue){if(n(ue))return!1;const le=ue;return u.URI.isUri(le?.resource)}e.isResourceEditorInput=d;function f(ue){if(n(ue))return!1;const le=ue;return le?.original!==void 0&&le.modified!==void 0}e.isResourceDiffEditorInput=f;function g(ue){if(n(ue)||f(ue))return!1;const le=ue;return le?.primary!==void 0&&le.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function D(ue){if(n(ue))return!1;const le=ue;return le?le.resource===void 0||le.resource.scheme===m.Schemas.untitled||le.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const p=/Untitled-\d+/;function t(ue){return ue.scheme===m.Schemas.untitled&&ue.path.length>1&&!p.test(ue.path)}e.isUntitledWithAssociatedResource=t;function o(ue){if(n(ue))return!1;const le=ue;return u.URI.isUri(le?.base?.resource)&&u.URI.isUri(le?.input1?.resource)&&u.URI.isUri(le?.input2?.resource)&&u.URI.isUri(le?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var c;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(le,q){let F=this.a.get(le);return F||(F={source:le,label:q},this.a.set(le,F)),F.source}getSourceLabel(le){return this.a.get(le)?.label??le}}e.SaveSourceRegistry=new l;var v;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors"})(v=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function n(ue){return ue instanceof i}e.isEditorInput=n;function h(ue){const le=ue;return u.URI.isUri(le?.preferredResource)}function w(ue){const le=ue;return n(le?.primary)&&n(le?.secondary)}e.isSideBySideEditorInput=w;function b(ue){const le=ue;return n(le?.modified)&&n(le?.original)}e.isDiffEditorInput=b;function O(ue,le,q,F,Q){return ve(F,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const me={...q,limits:{size:Number.MAX_VALUE}};ue.openEditor(le,me)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>Q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:S.default.Warning})}e.createTooLargeFileError=O;function H(ue){return n(ue?.editor)}e.isEditorInputWithOptions=H;function x(ue){const le=ue;return H(ue)&&le?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function _(ue){const le=ue;return typeof le?.groupId=="number"&&n(le.editor)}e.isEditorIdentifier=_;var G;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(G=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class U{getOriginalUri(le,q){if(!le)return;if(o(le))return e.EditorResourceAccessor.getOriginalUri(le.result,q);if(q?.supportSideBySide){const{primary:Q,secondary:me}=this.a(le);if(Q&&me){if(q?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===B.ANY)return this.getOriginalUri(Q,{filterByScheme:q.filterByScheme})??this.getOriginalUri(me,{filterByScheme:q.filterByScheme});le=q.supportSideBySide===B.PRIMARY?Q:me}}if(f(le)||g(le)||o(le))return;const F=h(le)?le.preferredResource:le.resource;return!F||!q||!q.filterByScheme?F:this.b(F,q.filterByScheme)}a(le){return w(le)||g(le)?{primary:le.primary,secondary:le.secondary}:b(le)||f(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,q){if(!le)return;if(o(le))return e.EditorResourceAccessor.getCanonicalUri(le.result,q);if(q?.supportSideBySide){const{primary:Q,secondary:me}=this.a(le);if(Q&&me){if(q?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===B.ANY)return this.getCanonicalUri(Q,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:q.filterByScheme});le=q.supportSideBySide===B.PRIMARY?Q:me}}if(f(le)||g(le)||o(le))return;const F=le.resource;return!F||!q||!q.filterByScheme?F:this.b(F,q.filterByScheme)}b(le,q){if(Array.isArray(q)){if(q.some(F=>le.scheme===F))return le}else if(q===le.scheme)return le}}e.EditorResourceAccessor=new U;var j;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(le){const q=this.a=le.get(P.IInstantiationService);for(const[F,Q]of this.c)this.e(F,Q,q);this.c.clear()}e(le,q,F){const Q=F.createInstance(q);this.d.set(le,Q)}registerFileEditorFactory(le){if(this.b)throw new Error("Can only register one file editor factory.");this.b=le}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(le,q){if(this.c.has(le)||this.d.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.a?this.e(le,q,this.a):this.c.set(le,q),(0,R.toDisposable)(()=>{this.c.delete(le),this.d.delete(le)})}getEditorSerializer(le){return this.d.get(typeof le=="string"?le:le.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new he);async function ie(ue,le,q){return!ue||!ue.length?[]:await Promise.all(ue.map(async F=>{const Q=u.URI.revive(F.fileUri);if(!Q){q.info("Cannot resolve the path because it is not valid.",F);return}if(!await le.canHandleResource(Q)){q.info("Cannot resolve the path because it cannot be handled",F);return}let Ee=F.exists,te=F.type;if(typeof Ee!="boolean"||typeof te!="number")try{te=(await le.stat(Q)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ee=!0}catch(de){q.error(de),Ee=!1}if(!Ee&&F.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",F);return}if(te===y.FileType.Directory){q.info("Cannot resolve the path because it is a directory",F);return}const ne={...F.options,pinned:!0};return Ee?{resource:Q,options:ne}:{resource:Q,options:ne,forceUntitled:!0}}))}e.pathsToEditors=ie;var V;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function J(ue){const le=ue;if(!le)return!1;const q=le;if(q.modified)return J(q.modified);const F=le;return!!(F.contributionsState&&F.viewState&&Array.isArray(F.cursorState))}e.isTextEditorViewState=J;function re(ue){return(0,L.isErrorWithActions)(ue)}e.isEditorOpenError=re;function ve(ue,le,q){const F=(0,L.createErrorWithActions)(ue,le);return F.forceMessage=q?.forceMessage,F.forceSeverity=q?.forceSeverity,F.allowDialog=q?.allowDialog,F}e.createEditorOpenError=ve}),define(Ce[229],Ie([1,0,3,192,4,6,28,39,17,61,23,67,220]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,S.registerIcon)("default-view-icon",I.Codicon.window,(0,A.localize)(0,null));var k;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(k=e.Extensions||(e.Extensions={}));var C;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(C=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function E(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class r extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(c,l,v){const i=this.get(c.id);if(i)return i;const n=c;return n.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,P.getOrSet)(this.g,l,[]).push(n),v?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:l}),n}deregisterViewContainer(c){for(const l of this.g.keys()){const v=this.g.get(l),i=v?.indexOf(c);if(i!==-1){v?.splice(i,1),v.length===0&&this.g.delete(l),this.f.fire({viewContainer:c,viewContainerLocation:l});return}}}get(c){return this.all.filter(l=>l.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(v=>v?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(l=>this.getViewContainerLocation(l)===c)}}T.Registry.add(k.ViewContainersRegistry,new r);var d;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function f(s,c){const l=s.group??d.More,v=c.group??d.More;return l!==v?l.localeCompare(v):(s.order??5)-(c.order??5)}class g extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new m.SetMap}registerViews(c,l){this.registerViews2([{views:c,viewContainer:l}])}registerViews2(c){c.forEach(({views:l,viewContainer:v})=>this.l(l,v)),this.c.fire(c)}deregisterViews(c,l){const v=this.m(c,l);v.length&&this.f.fire({views:v,viewContainer:l})}moveViews(c,l){for(const v of this.j.keys())if(v!==l){const i=this.m(c,v);i.length&&(this.l(i,l),this.g.fire({views:i,from:v,to:l}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const l of this.i){const v=(this.j.get(l)||[]).filter(i=>i.id===c)[0];if(v)return v}return null}getViewContainer(c){for(const l of this.i)if((this.j.get(l)||[]).filter(i=>i.id===c)[0])return l;return null}registerViewWelcomeContent(c,l){return this.k.add(c,l),this.h.fire(c),(0,R.toDisposable)(()=>{this.k.delete(c,l),this.h.fire(c)})}registerViewWelcomeContent2(c,l){const v=new Map;for(const[i,n]of l)this.k.add(c,n),v.set(i,(0,R.toDisposable)(()=>{this.k.delete(c,n),this.h.fire(c)}));return this.h.fire(c),v}getViewWelcomeContent(c){const l=[];return this.k.forEach(c,v=>l.push(v)),l.sort(f)}l(c,l){let v=this.j.get(l);v||(v=[],this.j.set(l,v),this.i.push(l));for(const i of c){if(this.getView(i.id)!==null)throw new Error((0,A.localize)(1,null,i.id));v.push(i)}}m(c,l){const v=this.j.get(l);if(!v)return[];const i=[],n=[];for(const h of v)c.includes(h)?i.push(h):n.push(h);return i.length&&(n.length?this.j.set(l,n):(this.j.delete(l),this.i.splice(this.i.indexOf(l),1))),i}}T.Registry.add(k.ViewsRegistry,new g),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var D;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(D=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(c,l){this.c=!1,this.d=!1,(0,L.mixin)(this,c),this.d=!!l,this.resolve=async v=>{if(l&&!this.c){const i=await l(v);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class o extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=o}),define(Ce[132],Ie([1,0,3,19,193]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,y,m,L){const I={command:T};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.s("request",I),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:T,message:(0,u.localize)(0,null,L,T)};k(C)}},L)}return m&&this.f.set(I.seq,m),I.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,y){return T.type!=="event"||y.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,A.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const y=T,m=this.f.get(y.request_seq);m&&(this.f.delete(y.request_seq),m(y));break}}}}s(T,y){y.type=T,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((y,m)=>T.set(m,y)),await(0,A.timeout)(500),T.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(Ce[230],Ie([1,0,194,44,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=S=>a.localize(51,null,S);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var P;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(P=e.State||(e.State={}));function T(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var y;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(m=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var I;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[231],Ie([1,0,8,2,12,23,18,32,21,17]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function I(i,n,h){return i.replace(L,function(w,b){return n&&b.length>0&&b[0]!=="_"?w:h&&h.hasOwnProperty(b)?h[b]:w})}e.formatPII=I;function S(i){const n={};for(const h of Object.keys(i))h.startsWith("!")||(n[h]=i[h]);return n}e.filterExceptionsFromTelemetry=S;function k(i){return i.configuration.request==="attach"&&!C(i)&&(!i.parentSession||k(i.parentSession))}e.isSessionAttach=k;function C(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(n,"extensionhost")||(0,a.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function E(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=E;function r(i,n,h){let w,b=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=O.exec(i);){const x=H.index+1,_=x+H[0].length;if(x<=n&&_>=h){w=H[0],b=x;break}}if(w){const x=/\w+/g;let _=null;for(;(_=x.exec(w))&&!(_.index+1+b+_[0].length>=h););_&&(w=w.substring(0,x.lastIndex))}return w?{start:b,end:b+w.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=r;async function d(i,n,h,w){if(i.evaluatableExpressionProvider.has(n)){const b=i.evaluatableExpressionProvider.ordered(n),O=(0,m.coalesce)(await Promise.all(b.map(async H=>{try{return await H.provideEvaluatableExpression(n,h,w??y.CancellationToken.None)}catch{return}})));if(O.length>0){let H=O[0].expression;const x=O[0].range;return H||(H=n.getLineContent(h.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:H}}}else{const b=n.getLineContent(h.lineNumber),{start:O,end:H}=r(b,h.column,h.column),x=b.substring(O-1,H);return{matchingExpression:x,range:new T.Range(h.lineNumber,O,h.lineNumber,O+x.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(i){return!!(i&&i.match(f))}e.isUri=g;function D(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(g(i.path))return A.URI.parse(i.path);if((0,u.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const n=A.URI.revive(i.path);if(n)return n.scheme===P.Schemas.file?n.fsPath:n.toString()}return i.path}function t(i,n){const h=n?D:p,w=(0,R.deepClone)(i);return s(w,(b,O)=>{b&&O&&(O.path=h(O))}),w}e.convertToDAPaths=t;function o(i,n){const h=n?D:p,w=(0,R.deepClone)(i);return s(w,(b,O)=>{!b&&O&&(O.path=h(O))}),w}e.convertToVSCPaths=o;function s(i,n){switch(i.type){case"event":{const h=i;switch(h.event){case"output":n(!1,h.body.source);break;case"loadedSource":n(!1,h.body.source);break;case"breakpoint":n(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=i;switch(h.command){case"setBreakpoints":n(!0,h.arguments.source);break;case"breakpointLocations":n(!0,h.arguments.source);break;case"source":n(!0,h.arguments.source);break;case"gotoTargets":n(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(w=>n(!1,w));break;default:break}break}case"response":{const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(w=>n(!1,w.source));break;case"loadedSources":h.body.sources.forEach(w=>n(!1,w));break;case"scopes":h.body.scopes.forEach(w=>n(!1,w.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(w=>n(!1,w.source));break;case"setBreakpoints":h.body.breakpoints.forEach(w=>n(!1,w.source));break;case"disassemble":h.body?.instructions.forEach(b=>n(!1,b.location));break;default:break}break}}}function c(i){return i.filter(n=>!n.presentation?.hidden).sort((n,h)=>n.presentation?h.presentation?n.presentation.group?h.presentation.group?n.presentation.group!==h.presentation.group?n.presentation.group.localeCompare(h.presentation.group):l(n.presentation.order,h.presentation.order):-1:h.presentation.group?1:l(n.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=c;function l(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function v(i,n){const h=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(h!=="none"&&(await n.saveAll(),h==="allEditorsInActiveGroup")){const w=n.activeEditorPane;w&&w.input.resource?.scheme===P.Schemas.untitled&&await n.save({editor:w.input,groupId:w.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(Ce[232],Ie([1,0,47,233,23,12,11,8,29,195,132]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",g=>this.w(g))}sendMessage(d){if(this.p){const f=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${I.a}${f}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(g){this.m.fire(new Error((g.message||g)+`
`+f))}continue}}else{const f=this.r.indexOf(I.a);if(f!==-1){const D=this.r.toString("utf8",0,f).split(I.b);for(const p of D){const t=p.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(f+I.a.length);continue}}break}}}I.a=`\r
\r
`,I.b=/\r?\n/,I.l=/: */,e.StreamDebugAdapter=I;class S extends I{startSession(){return new Promise((d,f)=>{let g=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),g=!0}),this.x.on("close",()=>{g?this.m.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",D=>{g?this.m.fire(D):f(D)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=S;class k extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=k;class C extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=C;class E extends I{constructor(d,f){super(),this.y=d,this.z=f}async startSession(){const d=this.y.command,f=this.y.args,g=this.y.options||{};try{if(d)if(R.isAbsolute(d)){if(!await y.Promises.exists(d))throw new Error(m.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(m.localize(1,null,this.z));let D=process.env;if(g.env&&Object.keys(g.env).length>0&&(D=u.mixin(u.deepClone(process.env),g.env)),d==="node")if(Array.isArray(f)&&f.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:D,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};g.cwd&&(t.cwd=g.cwd);const o=a.fork(f[0],f.slice(1),t);if(!o.pid)throw new Error(m.localize(2,null,f[0]));this.x=o}else throw new Error(m.localize(3,null));else{const p={env:D};g.cwd&&(p.cwd=g.cwd),this.x=a.spawn(d,f,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,t)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(D){this.m.fire(D)}}async stopSession(){return this.x?(await this.u(),P.isWindows?new Promise((d,f)=>{const g=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(D,p,t){if(D)return f(D)});g.on("exit",d),g.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,f){if(!d)return;const g=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?g.runtime=R.join(f,d.runtime):g.runtime=d.runtime),d.runtimeArgs&&(g.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?g.program=d.program:g.program=R.join(f,d.program)),d.args&&(g.args=d.args);const D=d;return D.win&&(g.win=E.A(D.win,f)),D.winx86&&(g.winx86=E.A(D.winx86,f)),D.windows&&(g.windows=E.A(D.windows,f)),D.osx&&(g.osx=E.A(D.osx,f)),D.linux&&(g.linux=E.A(D.linux,f)),g}static platformAdapterExecutable(d,f){let g=Object.create(null);f=f.toLowerCase();for(const c of d)if(c.contributes){const l=c.contributes.debuggers;l&&l.length>0&&l.filter(v=>typeof v.type=="string"&&T.equalsIgnoreCase(v.type,f)).forEach(v=>{const i=E.A(v,c.extensionLocation.fsPath);g=u.mixin(g,i,c.isBuiltin)})}let D;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?D=g.winx86||g.win||g.windows:P.isWindows?D=g.win||g.windows:P.isMacintosh?D=g.osx:P.isLinux&&(D=g.linux),D=D||g;const p=D.program||g.program,t=D.args||g.args,o=D.runtime||g.runtime,s=D.runtimeArgs||g.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=E}),define(Ce[234],Ie([1,0,47,33,11]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(m,L){return new Promise((I,S)=>{let k="";const C=a.spawn(m,L);C.pid&&C.stdout.on("data",E=>{k+=E.toString()}),C.on("error",E=>{S(E)}),C.on("close",E=>{I(k)})})}async function P(m){if(m)if(u.isWindows){const L=await new Promise((I,S)=>{se(["windows-process-tree"],I,S)});return new Promise(I=>{L.getProcessTree(m,S=>{I(!!S&&S.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(m)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var T;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(T||(T={}));function y(m,L,I,S,k){m=m.trim().toLowerCase();let C;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?C=1:m.indexOf("cmd.exe")>=0?C=0:m.indexOf("bash")>=0?C=2:u.isWindows?C=0:C=2;let E,r=" ";switch(C){case 1:if(E=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),S){const d=(0,A.getDriveLetter)(S);d&&(r+=`${d}:; `),r+=`cd ${E(S)}; `}if(k)for(const d in k){const f=k[d];f===null?r+=`Remove-Item env:${d}; `:r+=`\${env:${d}}='${f}'; `}if(L.length>0){const d=L.shift(),f=I?d:E(d);r+=f[0]==="'"?`& ${f} `:`${f} `;for(const g of L)r+=g==="<"||g===">"||I?g:E(g),r+=" "}break;case 0:if(E=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>d.includes(f))||d.length===0?`"${d}"`:d),S){const d=(0,A.getDriveLetter)(S);d&&(r+=`${d}: && `),r+=`cd ${E(S)} && `}if(k){r+='cmd /C "';for(const d in k){let f=k[d];f===null?r+=`set "${d}=" && `:(f=f.replace(/[&^|<>]/g,g=>`^${g}`),r+=`set "${d}=${f}" && `)}}for(const d of L)r+=d==="<"||d===">"||I?d:E(d),r+=" ";k&&(r+='"');break;case 2:{E=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),f.length===0?'""':f);const d=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(S&&(r+=`cd ${E(S)} ; `),k){r+="/usr/bin/env";for(const f in k){const g=k[f];g===null?r+=` -u ${d(f)}`:r+=` ${d(`${f}=${g}`)}`}r+=" "}for(const f of L)r+=f==="<"||f===">"||I?f:E(f),r+=" ";break}}return r}e.prepareCommand=y}),define(Ce[94],Ie([1,0,22,38,64,88,18,12,11,44]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var E;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(E=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(B){B.scheme=P.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${U.join("")}]+`),he=7;function ie(le,q){const F=q.toString(he),me=`${F.length<U.length?U[F.length-1]:"z"}${F}s${(0,a.encodeBase64)(a.VSBuffer.fromString(le.scheme),!0,!0)}`;return le.with({scheme:B.scheme,fragment:me})}B.generate=ie;function V(le){if(le.scheme!==B.scheme)return;const q=le.fragment.indexOf("s");if(q<0)return;const F=parseInt(le.fragment.substring(0,q).replace(j,""),he),Q=(0,a.decodeBase64)(le.fragment.substring(q+1)).toString();if(!isNaN(F))return{handle:F,notebook:le.with({scheme:Q,fragment:null})}}B.parse=V;function J(le,q){return le.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${le.scheme!==P.Schemas.file?le.scheme:""}`})}B.generateCellOutputUri=J;function re(le){if(le.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(le.fragment);if(!q)return;const F=q[1]&&q[1]!==""?q[1]:void 0,Q=q[2];return{outputId:F,notebook:le.with({scheme:Q||P.Schemas.file,fragment:null})}}B.parseCellOutputUri=re;function ve(le,q,F){return B.generate(le,q).with({scheme:F})}B.generateCellPropertyUri=ve;function ue(le,q){if(le.scheme===q)return B.parse(le.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(f=e.CellUri||(e.CellUri={}));const g=B=>y.isWindows?B.replace(/\//g,"\\"):B;class D{constructor(U=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(U)].map(he=>({pattern:he,matches:A.parse(g(he))}))}sort(U){const j=new Map(u.Iterable.map(U,ie=>[ie,g(ie)]));let he=[];for(const{matches:ie}of this.d)for(const[V,J]of j)if(ie(J)){he.push(V),j.delete(V);break}return j.size&&(he=he.concat([...j.keys()].sort((ie,V)=>this.e.indexOf(ie)-this.e.indexOf(V)))),he}prioritize(U,j){const he=this.f(U);if(he===-1){this.d.unshift({pattern:U,matches:A.parse(g(U))});return}const ie=new Set(j.map(J=>this.f(J,he)));ie.delete(-1);const V=Array.from(ie).sort();this.d.splice(he+1,0,...V.map(J=>this.d[J]));for(let J=V.length-1;J>=0;J--)this.d.splice(V[J],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,j=this.d.length){const he=g(U);for(let ie=0;ie<j;ie++)if(this.d[ie].matches(he))return ie;return-1}}e.MimeTypeDisplayOrder=D;function p(B,U,j,he=(ie,V)=>ie===V){const ie=[];function V(ve,ue,le){if(ue===0&&le.length===0)return;const q=ie[ie.length-1];q&&q.start+q.deleteCount===ve?(q.deleteCount+=ue,q.toInsert.push(...le)):ie.push({start:ve,deleteCount:ue,toInsert:le})}let J=0,re=0;for(;;){if(J===B.length){V(J,0,U.slice(re));break}if(re===U.length){V(J,B.length-J,[]);break}const ve=B[J],ue=U[re];if(he(ve,ue)){J+=1,re+=1;continue}j(ue)?(V(J,1,[]),J+=1):(V(J,0,[ue]),re+=1)}return ie}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(B){B.default="default",B.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const U=B;return!!((typeof U.include=="string"||A.isRelativePattern(U.include))&&(typeof U.exclude=="string"||A.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=o;function s(B,U,j){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const he=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(A.match(he,(0,T.basename)(j.fsPath).toLowerCase()))return!(ie&&A.match(ie,(0,T.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(U){return`${l.d}${U}`}static parse(U){if(U.startsWith(l.d))return U.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function v(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=v;const i=new TextDecoder;function n(B){const U=[];let j=!1;for(const he of B)(U.length===0||j)&&(U.push(he),j=!0);return O(U),M(a.VSBuffer.concat(U.map(he=>a.VSBuffer.wrap(he))))}e.compressOutputItemStreams=n;const h=`${String.fromCharCode(27)}[A`,w=h.split("").map(B=>B.charCodeAt(0)),b=10;function O(B){B.forEach((U,j)=>{if(j===0||U.length<h.length)return;const he=B[j-1],ie=U.subarray(0,h.length);if(ie[0]===w[0]&&ie[1]===w[1]&&ie[2]===w[2]){const V=he.lastIndexOf(b);if(V===-1)return;B[j-1]=he.subarray(0,V),B[j]=U.subarray(h.length)}})}function H(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let j=B.match(/\r+(.*)$/m)[1];j=j+U.slice(j.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return B}const _="\b".charCodeAt(0),G="\r".charCodeAt(0);function M(B){return!B.buffer.includes(_)&&!B.buffer.includes(G)?B:a.VSBuffer.fromString(x(H(i.decode(B.buffer))))}}),define(Ce[235],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ce[57],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(P,T,y=P.parent){if(P._isRoot)return new u([T]);const m=[P.id];for(let L=y;L&&L.id!==T;L=L.parent)m.push(L.id);return m.push(T),new u(m.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const T=P.indexOf("\0");return T===-1?P:P.slice(0,T)}static fromString(P){return new u(P.split("\0"))}static join(P,T){return new u([...P.path,T])}static joinToString(P,T){return P.toString()+"\0"+T}static parentId(P){const T=P.lastIndexOf("\0");return T===-1?void 0:P.slice(0,T)}static localId(P){const T=P.lastIndexOf("\0");return T===-1?P:P.slice(T+1)}static compare(P,T){return P===T?0:T.startsWith(P+"\0")?2:P.startsWith(T+"\0")?3:1}constructor(P,T=P.length){if(this.path=P,this.d=T,P.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new u(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new u(this.path,P)}compare(P){if(typeof P=="string")return u.compare(this.toString(),P);for(let T=0;T<P.d&&T<this.d;T++)if(P.path[T]!==this.path[T])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.TestId=u}),define(Ce[76],Ie([1,0,2,32,57]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var P;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const T=i=>"runId"in i;e.isStartControllerTests=T;var y;(function(i){i.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),i.deserialize=n=>({range:A.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var m;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(m=e.TestMessageType||(e.TestMessageType={}));var L;(function(i){i.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(i,n)=>`${n?"s":"e"}${i}`;e.getMarkId=I;var S;(function(i){i.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.deserialize(n.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var k;(function(i){i.serialize=n=>n.type===0?L.serialize(n):S.serialize(n),i.deserialize=n=>n.type===0?L.deserialize(n):S.deserialize(n)})(k=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),i.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(k.serialize)}),i.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(k.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",r=(i,n)=>i+E+n;e.namespaceTestTag=r;const d=i=>{const n=i.indexOf(E);return{ctrlId:i.slice(0,n),tagId:i.slice(n+1)}};e.denamespaceTestTag=d;var f;(function(i){i.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),i.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?A.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(f=e.ITestItem||(e.ITestItem={}));var g;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(i){i.serialize=n=>({expand:n.expand,item:f.serialize(n.item)}),i.deserialize=n=>({controllerId:u.TestId.root(n.item.extId),expand:n.expand,item:f.deserialize(n.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},i.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?A.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,n)=>{n.expand!==void 0&&(i.expand=n.expand),n.item!==void 0&&(i.item=i.item?Object.assign(i.item,n.item):n.item)};e.applyTestItemUpdate=t;var o;(function(i){i.serializeWithoutMessages=n=>({...D.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),i.serialize=n=>({...D.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),i.deserialize=n=>({...D.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var c;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(i){i.deserialize=n=>n.op===0?{op:n.op,item:D.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,i.serialize=n=>n.op===0?{op:n.op,item:D.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class v{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const w of n)switch(w.op){case 0:this.j(D.deserialize(w.item),h);break;case 1:this.k(p.deserialize(w.item),h);break;case 3:this.l(w.itemId,h);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}h.complete?.()}j(n,h){const w=u.TestId.parentId(n.item.extId)?.toString();let b;if(!w)b=this.p(n),this.f.add(b),this.d.set(n.item.extId,b);else if(this.d.has(w)){const O=this.d.get(w);O.children.add(n.item.extId),b=this.p(n,O),this.d.set(n.item.extId,b)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(b),n.expand===2&&this.g++,b}k(n,h){const w=this.d.get(n.extId);if(!!w)return n.expand!==void 0&&(w.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,n),h.update?.(w),w}l(n,h){const w=this.d.get(n);if(!w)return;const b=u.TestId.parentId(w.item.extId)?.toString();b?this.d.get(b).children.delete(w.item.extId):this.f.delete(w);const O=[[n]];for(;O.length;)for(const H of O.pop()){const x=this.d.get(H);x&&(O.push(x.children),this.d.delete(H),h.remove?.(x,x!==w),x.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=v}),define(Ce[95],Ie([1,0,19,3,6,51,76,57]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const m=(f,g)=>f===g,I=Object.entries({range:(f,g)=>f===g?!0:!f||!g?!1:f.equalsRange(g),busy:m,label:m,description:m,error:m,sortText:m,tags:(f,g)=>!(f.length!==g.length||f.some(D=>!g.includes(D)))}),S=(f,g)=>{let D;for(const[p,t]of I)t(f[p],g[p])||(D?D[p]=g[p]:D={[p]:g[p]});return D};class k extends u.Disposable{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.D(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(g){this.h=g;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===g.uri){D.docv=g.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===g.item.extId){(0,P.applyTestItemUpdate)(D.item,g.item);return}if(D.op===0&&D.item.item.extId===g.item.extId){(0,P.applyTestItemUpdate)(D.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,D){const p=this.tree.get(g);if(!!p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const t=this.I(p);return t.isOpen()?this.H(p,D-1):t.wait().then(()=>this.H(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,D-1)):this.H(p,D-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,D){switch(D.op){case 3:this.L(T.TestId.joinToString(g.fullId,D.id));break;case 0:this.s(D.item,g);break;case 5:for(const p of D.ops)this.p(g,p);break;case 1:this.u(D.new,D.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:D.update}});break;case 6:this.q(g.actual.uri);break;default:(0,R.assertNever)(D)}}q(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}s(g,D){const p=T.TestId.fromExtHostTestItem(g,this.root.id,D?.actual),t=this.m.getApiFor(g);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(g.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:g,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},g.tags.forEach(this.w,this),this.tree.set(o.fullId.toString(),o),this.z(g,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(g)}}),this.F(g,o,D);return}if(o.actual===g){this.C(g,o,D);return}if(o.actual.uri?.toString()!==g.uri?.toString())return this.L(p.toString()),this.s(g,D);const s=this.m.getChildren(o.actual),c=o.actual,l=S(this.m.toITestItem(c),this.m.toITestItem(g));this.m.getApiFor(c).listener=void 0,o.actual=g,o.expand=0,l&&(l.hasOwnProperty("tags")&&(this.u(g.tags,c.tags,p.toString()),delete l.tags),this.p(o,{op:4,update:l})),this.F(g,o,D);for(const[v,i]of s)this.m.getChildren(g).get(i.id)||this.L(T.TestId.joinToString(p,i.id));this.q(o.actual.uri)}u(g,D,p){const t=new Set(D.map(o=>o.id));for(const o of g)t.delete(o.id)||this.w(o);this.pushDiff({op:1,item:{extId:p,item:{tags:g.map(o=>(0,P.namespaceTestTag)(this.m.controllerId,o.id))}}}),t.forEach(this.y,this)}w(g){const D=this.j.get(g.id);D?D.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.namespaceTestTag)(this.m.controllerId,g.id)}}))}y(g){const D=this.j.get(g);D&&!--D.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,P.namespaceTestTag)(this.m.controllerId,g)}))}z(g,D){this.m.getApiFor(g).parent=D&&D.actual!==this.root?D.actual:void 0}C(g,D,p){this.z(g,p);const t=this.m.getApiFor(g);t.parent=p?.actual,t.listener=o=>this.p(D,o),this.G(D)}F(g,D,p){this.C(g,D,p);for(const[t,o]of this.m.getChildren(g))this.s(o,D)}G(g){let D;this.h?g.resolveBarrier?D=g.resolveBarrier.isOpen()?3:2:D=g.actual.canResolveChildren?1:0:D=0,D!==g.expand&&(g.expand=D,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:D}}),D===1&&g.expandLevels!==void 0&&this.I(g))}H(g,D){if(D<0)return;const p=[];for(const[t,o]of this.m.getChildren(g.actual)){const s=this.expand(T.TestId.joinToString(g.fullId,o.id),D);(0,a.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const o=new a.Barrier;return o.open(),o}g.expand=2,this.J(g);const D=g.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let t;try{t=this.h(g.actual===this.root?void 0:g.actual)}catch(o){p(o)}return(0,a.isThenable)(t)?t.catch(p).then(()=>{D.open(),this.G(g)}):(D.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const D=this.tree.get(g);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const p=[D];for(;p.length;){const t=p.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.y(o.id);this.tree.delete(t.fullId.toString());for(const[o,s]of this.m.getChildren(t.actual))p.push(this.tree.get(T.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.TestItemCollection=k;class C extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=C;class E extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class r extends Error{constructor(g,D,p){super(`TestItem with ID "${g}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=r;const d=(f,g,D)=>{let p=new Map;return{get size(){return p.size},forEach(t,o){for(const s of p.values())t.call(o,s,this)},[Symbol.iterator](){return p.entries()},replace(t){const o=new Map,s=new Set(p.keys()),c={op:5,ops:[]};for(const l of t){if(!(l instanceof D))throw new E(l.id);const v=g(l).controllerId;if(v!==f.controllerId)throw new r(l.id,v,f.controllerId);if(o.has(l.id))throw new C(l.id);o.set(l.id,l),s.delete(l.id),c.ops.push({op:0,item:l})}for(const l of s.keys())c.ops.push({op:3,id:l});f.listener?.(c),p=o},add(t){if(!(t instanceof D))throw new E(t.id);p.set(t.id,t),f.listener?.({op:0,item:t})},delete(t){p.delete(t)&&f.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=d}),define(Ce[133],Ie([1,0,95]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,u=(P,T)=>{const y={controllerId:T};return A.set(P,y),y};e.createPrivateApiFor=u;const R=P=>{const T=A.get(P);if(!T)throw new a.InvalidTestItemError(P?.id||"<unknown>");return T};e.getPrivateApiFor=R}),define(Ce[96],Ie([1,0,18,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(T,y){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(y&&y.authority&&y.isRemote&&T.scheme===a.Schemas.file&&(T=A.URI.from({scheme:a.Schemas.vscodeRemote,authority:y.authority,path:T.path})),A.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${R(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=u;function R(T){return T.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function P(T){return T.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=P}),define(Ce[236],Ie([1,0,3,6,96]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(T,y,m){this.d=T,this.e=y,this.f=m,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const I of this.c.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,y,m,L,I){let S;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===T){S=g;break}if(!S)throw new Error("not a visible editor");const k=this,C=this.a++,E=new a.Emitter,r=new a.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,u.asWebviewUri)(g,k.f)}get cspSource(){return u.webviewGenericCspSource}set options(g){this.b=g,k.d.$setOptions(C,g)}get options(){return this.b}set html(g){this.a=g,k.d.$setHtml(C,g)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(g){return k.d.$postMessage(C,g)}},f=new class{constructor(){this.editor=T,this.line=y,this.height=m,this.webview=d,this.onDidDispose=r.event}dispose(){k.c.has(C)&&(k.c.delete(C),k.d.$disposeEditorInset(C),r.fire(),r.dispose(),E.dispose())}};return this.d.$createEditorInset(C,S.id,S.value.document.uri,y+1,m,L||{},I.identifier,I.extensionLocation),this.c.set(C,{editor:T,inset:f,onDidReceiveMessage:E}),f}$onDidDispose(T){const y=this.c.get(T);y&&y.inset.dispose()}$onDidReceiveMessage(T,y){this.c.get(T)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(Ce[237],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(P,T){super(T),this.variable=P}}e.VariableError=u}),define(Ce[238],Ie([1,0,12,36,9,23,11,114,198,237,8]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(k,C,E,r){this.g=new Map,this.a=k,this.b=C,this.d=E,r&&(this.c=r.then(d=>this.h(d)))}h(k){if(P.isWindows){const C=Object.create(null);return Object.keys(k).forEach(E=>{C[E.toLowerCase()]=k[E]}),C}return k}resolveWithEnvironment(k,C,E){return this.j({env:this.h(k),userHome:void 0},C?C.uri:void 0,E)}async resolveAsync(k,C){const E={env:await this.c,userHome:await this.d};return this.j(E,k?k.uri:void 0,C)}async i(k,C,E,r){const d=R.deepClone(C);P.isWindows&&d.windows?Object.keys(d.windows).forEach(g=>d[g]=d.windows[g]):P.isMacintosh&&d.osx?Object.keys(d.osx).forEach(g=>d[g]=d.osx[g]):P.isLinux&&d.linux&&Object.keys(d.linux).forEach(g=>d[g]=d.linux[g]),delete d.windows,delete d.osx,delete d.linux;const f={env:await this.c,userHome:await this.d};return this.j(f,k?k.uri:void 0,d,E,r)}async resolveAnyAsync(k,C,E){return this.i(k,C,E)}async resolveAnyMap(k,C,E){const r=new Map;return{newConfig:await this.i(k,C,E,r),resolvedVariables:r}}resolveWithInteractionReplace(k,C,E,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,C,E,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,C){if(this.g.has(k))throw new Error("Variable "+k+" is contributed twice.");this.g.set(k,C)}async j(k,C,E,r,d){if(u.isString(E))return this.l(k,C,E,r,d);if(Array.isArray(E))return Promise.all(E.map(f=>this.j(k,C,f,r,d)));if(u.isObject(E)){const f=Object.create(null),g=await Promise.all(Object.keys(E).map(async D=>[await this.l(k,C,D,r,d),await this.j(k,C,E[D],r,d)]));for(const[D,p]of g)f[D]=p;return f}return E}l(k,C,E,r,d){return(0,L.replaceAsync)(E,I.VARIABLE_REGEXP,async(f,g)=>{if(g.includes(I.VARIABLE_LHS))return f;let D=await this.n(k,f,g,C,r);return d?.set(g,D),D!==f&&u.isString(D)&&D.match(I.VARIABLE_REGEXP)&&(D=await this.l(k,C,D,r,d)),D})}m(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async n(k,C,E,r,d){let f;const g=E.split(":");g.length>1&&(E=g[0],f=g[1]);const D=o=>{const s=this.a.getFilePath();if(s)return(0,T.normalizeDriveLetter)(s);throw new m.VariableError(o,(0,y.localize)(0,null,C))},p=o=>{const s=D(o);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,T.normalizeDriveLetter)(c)}throw new m.VariableError(o,(0,y.localize)(1,null,C,a.basename(s)))},t=o=>{if(f){const s=this.a.getFolderUri(f);if(s)return s;throw new m.VariableError(o,(0,y.localize)(2,null,C,f))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(o,(0,y.localize)(3,null,C)):new m.VariableError(o,(0,y.localize)(4,null,C))};switch(E){case"env":if(f){if(k.env){const o=k.env[P.isWindows?f.toLowerCase():f];if(u.isString(o))return o}return""}throw new m.VariableError(m.VariableKind.Env,(0,y.localize)(5,null,C));case"config":if(f){const o=this.a.getConfigurationValue(r,f);if(u.isUndefinedOrNull(o))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(6,null,C,f));if(u.isObject(o))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(7,null,C,f));return o}throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(8,null,C));case"command":return this.o(m.VariableKind.Command,C,f,d,"command");case"input":return this.o(m.VariableKind.Input,C,f,d,"input");case"extensionInstallFolder":if(f){const o=await this.a.getExtension(f);if(!o)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,C,f));return this.m(o.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,C));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(t(m.VariableKind.WorkspaceFolder)));case"cwd":return r||f?(0,T.normalizeDriveLetter)(this.m(t(m.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(a.basename(this.m(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,y.localize)(11,null,C))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new m.VariableError(m.VariableKind.LineNumber,(0,y.localize)(12,null,C))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new m.VariableError(m.VariableKind.SelectedText,(0,y.localize)(13,null,C))}case"file":return D(m.VariableKind.File);case"fileWorkspaceFolder":return p(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||f?a.relative(this.m(t(m.VariableKind.RelativeFile)),D(m.VariableKind.RelativeFile)):D(m.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(D(m.VariableKind.RelativeFileDirname));if(r||f){const s=a.relative(this.m(t(m.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return a.dirname(D(m.VariableKind.FileDirname));case"fileExtname":return a.extname(D(m.VariableKind.FileExtname));case"fileBasename":return a.basename(D(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(D(m.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(D(m.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||C}case"execInstallFolder":{const o=this.a.getAppRoot();return o||C}case"pathSeparator":return a.sep;default:try{const o=f?`${E}:${f}`:E;return this.o(m.VariableKind.Unknown,C,o,d,void 0)}catch{return C}}}}o(k,C,E,r,d){if(E&&r){const f=d===void 0?r[E]:r[d+":"+E];if(typeof f=="string")return f;throw new m.VariableError(k,(0,y.localize)(14,null,C))}return C}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(Ce[134],Ie([1,0,4,131]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var u;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var T;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function m(C){const E=C;return(0,A.isEditorInput)(E?.editor)&&(0,A.isEditorInput)(E?.replacement)}e.isEditorReplacement=m;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function S(C){const E=C;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=S;function k(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(Ce[239],Ie([1,0,4,134]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(R){const P=R;return typeof R=="number"||(0,A.isEditorGroup)(P)}e.isPreferredGroup=u}),define(Ce[240],Ie([1,0,4,204]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(A.IEnvironmentService)}),define(Ce[135],Ie([1,0,25,3,12,6]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=P;class T{static isHostExtension(r,d,f){if(d.getExtensionDescription(r))return!1;const g=f.getExtensionDescription(r);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(r,d){this.h=r,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(k),this.e=new a.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const d=this.h.readActivationEvents(r);if(Array.isArray(d))for(let f of d)f==="onUri"&&(f=`onUri:${a.ExtensionIdentifier.toKey(r.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,d){this.d=C(this.d,d),this.d=this.d.concat(r);const f=T.k(this.d);return this.d=C(this.d,f.map(g=>g.identifier)),this.j(),this.c.fire(void 0),new P(f)}static k(r){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const s=d.getArcs(t);for(let c=0;c<s.length;c++)if(!o.has(s[c]))return!1;return!0}getNodes(){return this.e}},f=new a.ExtensionIdentifierMap;for(const t of r)if(f.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)d.addArc(a.ExtensionIdentifier.toKey(t.identifier),a.ExtensionIdentifier.toKey(o));const g=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>g.add(t));const D=d.getNodes().filter(t=>!g.has(t));let p;do{p=!1;for(let t=0;t<D.length;t++){const o=D[t];d.hasOnlyGoodArcs(o,g)&&(D.splice(t,1),t--,g.add(o),p=!0)}}while(p);return D.map(t=>f.get(t))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const d=this.g.get(r);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const d=this.e.get(r);return d||void 0}getExtensionDescriptionByUUID(r){for(const d of this.f)if(d.uuid===r)return d}getExtensionDescriptionByIdOrUUID(r,d){return this.getExtensionDescription(r)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=T,e.basicActivationEventsReader={readActivationEvents:E=>E.activationEvents};class y{constructor(r){this.d=new I,this.c=new T(r,[])}async acquireLock(r){const d=await this.d.acquire(r);return new m(this,d)}deltaExtensions(r,d,f){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,f)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,d){return this.c.getExtensionDescriptionByIdOrUUID(r,d)}}e.LockableExtensionDescriptionRegistry=y;class m extends R.Disposable{constructor(r,d){super(),this.f=r,this.c=!1,this.D(d)}isAcquiredFor(r){return!this.c&&this.f===r}}e.ExtensionDescriptionRegistryLock=m;class L{constructor(r){this.name=r,this.promise=new Promise((d,f)=>{this.c=d})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const d=new L(r);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let d=!0;const f=setTimeout(()=>{d&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{!d||(clearTimeout(f),d=!1,this.d=!1,this.e())};r.resolve((0,R.toDisposable)(g))}}var S;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})(S||(S={}));function k(E,r){const d=E.isBuiltin?0:E.isUnderDevelopment?2:1,f=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(d!==f)return d-f;const g=u.posix.basename(E.extensionLocation.path),D=u.posix.basename(r.extensionLocation.path);return g<D?-1:g>D?1:0}function C(E,r){const d=new a.ExtensionIdentifierSet(r);return E.filter(f=>!d.has(f.identifier))}}),define(Ce[241],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class u{constructor(){this.type=2}serialize(I){I[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class R{constructor(){this.type=3}serialize(I){I[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function P(L){delete L[A.ENV_KEY],delete L[u.ENV_KEY],delete L[R.ENV_KEY]}function T(L,I){P(I),L.serialize(I)}e.writeExtHostConnection=T;function y(L){if(L[A.ENV_KEY])return m(L,new A(L[A.ENV_KEY]));if(L[u.ENV_KEY])return m(L,new u);if(L[R.ENV_KEY])return m(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function m(L,I){return P(L),I}}),define(Ce[97],Ie([1,0,22]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var u;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(m){const L=a.VSBuffer.alloc(1);switch(m){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=P;function T(m,L){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=T;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[77],Ie([1,0,4,3,16,26,97,73,74,23,2,6,185]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class extends I.Disposable{constructor(d,f){super(),this.m=d,this.n=f,this.a=this.D(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=f.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,S.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(f.onDidChangeLogLevel(g=>{(0,u.isLogLevel)(g)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,f,g){const D=this.getTelemetryDetails(),p=new C(f,g,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this.l.set(d.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(d,f,g){this.f=d,this.g=f,this.c=g??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const f={};switch(f["common.extname"]=`${d.publisher}.${d.name}`,f["common.extversion"]=d.version,f["common.vscodemachineid"]=this.m.telemetryInfo.machineId,f["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,f["common.vscodeversion"]=this.m.version,f["common.isnewappinstall"]=E(this.m.telemetryInfo.firstSessionDate),f["common.product"]=this.m.environment.appHost,this.m.uiKind){case P.UIKind.Web:f["common.uikind"]="web";break;case P.UIKind.Desktop:f["common.uikind"]="desktop";break;default:f["common.uikind"]="unknown"}return f["common.remotename"]=(0,T.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),f}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const f=this.getTelemetryDetails();this.l.forEach((g,D)=>{g.isDisposed&&this.l.delete(D)}),this.l.forEach(g=>{g.updateTelemetryEnablements(f.isUsageEnabled,f.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,f){const g=this.l.get(d.value);return g&&g.isDisposed?(this.l.delete(d.value),!1):!g||g.ignoreUnhandledExtHostErrors?!1:(g.logError(f),!0)}};k=Ve([We(0,R.IExtHostInitDataService),We(1,u.ILoggerService)],k),e.ExtHostTelemetry=k;class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,f,g,D,p,t,o){this.g=g,this.h=D,this.i=p,this.j=t,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=f?.ignoreUnhandledErrors??!1,this.b=f?.ignoreBuiltInCommonProperties??!1,this.c=f?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,f){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:f},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let f=d.properties??d;return f=(0,y.cleanData)(f,[]),this.c&&(f=(0,m.mixin)(f,this.c)),this.b||(f=(0,m.mixin)(f,this.j)),d.properties?d.properties=f:d=f,d}k(d,f){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,f=this.mixInCommonPropsAndCleanData(f||{}),this.i||this.f?.sendEventData(d,f),this.h.trace(d,f))}logUsage(d,f){!this.d.isUsageEnabled||this.k(d,f)}logError(d,f){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,f):this.f.sendErrorData(d,f))}get apiTelemetryLogger(){if(!this.e){const d=this,f={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(f)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=C;function E(r){const d=Date.now()-new Date(r).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ce[27],Ie([1,0,3,2,217,129,25,4]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class y{constructor(p){this.dependency=p}}e.MissingExtensionDependency=y;var m;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(m=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class L{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,t){const o=[],s=[],c=[],l=[],v=I(this.c),i=I(p),n=(H,x)=>H.extensionLocation.toString()===x.extensionLocation.toString()||H.isBuiltin===x.isBuiltin||H.isUserBuiltin===x.isUserBuiltin||H.isUnderDevelopment===x.isUnderDevelopment;for(const H of this.c){const x=i.get(H.identifier);if(!x){o.push(H.identifier),v.delete(H.identifier);continue}if(!n(H,x)){o.push(H.identifier),v.delete(H.identifier);continue}}for(const H of p){const x=v.get(H.identifier);if(!x){s.push(H);continue}if(!n(x,H)){o.push(x.identifier),v.delete(x.identifier);continue}}const h=new P.ExtensionIdentifierSet(this.d),w=new P.ExtensionIdentifierSet(t);for(const H of this.d)w.has(H)||c.push(H);for(const H of t)h.has(H)||l.push(H);const b=R.ImplicitActivationEvents.createActivationEventsMap(s),O={toRemove:o,toAdd:s,addActivationEvents:b,myToRemove:c,myToAdd:l};return this.delta(O),O}delta(p){const{toRemove:t,toAdd:o,myToRemove:s,myToAdd:c}=p,l=new P.ExtensionIdentifierSet(t),v=new P.ExtensionIdentifierSet(s);for(let i=0;i<this.c.length;i++)l.has(this.c[i].identifier)&&(this.c.splice(i,1),i--);for(let i=0;i<this.d.length;i++)v.has(this.d[i])&&(this.d.splice(i,1),i--);for(const i of o)this.c.push(i);for(const i of c)this.d.push(i)}containsExtension(p){for(const t of this.d)if(P.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=L;function I(D){const p=new P.ExtensionIdentifierMap;for(const t of D)p.set(t.identifier,t);return p}function S(D,p){return D.enabledApiProposals?D.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=S;function k(D,p){if(!S(D,p))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.checkProposedApiEnabled=k;class C{constructor(p,t,o,s){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=s}}e.ActivationTimes=C;class E{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=E;var r;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,u.getGalleryExtensionId)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function f(D,p){return{identifier:new P.ExtensionIdentifier((0,u.getExtensionId)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!p,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform,browserNlsBundleUris:D.browserNlsBundleUris}}e.toExtensionDescription=f;class g{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=g}),define(Ce[242],Ie([1,0,10,135,25,27,16,19]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(d,f,g,D){this.startup=d,this.codeLoadingTime=f,this.activateCallTime=g,this.activateResolvedTime=D}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class m{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,f){return d===-1||f===-1?-1:f-d}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=m;class L{constructor(d,f,g,D,p,t){this.activationFailed=d,this.activationFailedError=f,this.activationTimes=g,this.module=D,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=L;class I extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class S extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class k extends L{constructor(d){super(!0,d,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(d,f,g,D){this.g=D,this.a=d,this.b=f,this.c=g,this.d=new u.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,f]of this.d)f.dispose()}isActivated(d){const f=this.d.get(d);return Boolean(f&&f.value)}getActivatedExtension(d){const f=this.d.get(d);if(!f||!f.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return f.value}async activateByEvent(d,f){if(this.f[d])return;const g=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(g.map(D=>({id:D.identifier,reason:{startup:f,extensionId:D.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,f){const g=this.a.getExtensionDescription(d);if(!g)throw new Error(`Extension '${d}' is not known`);return this.h([{id:g.identifier,reason:f}])}async h(d){const f=d.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(f.map(g=>g.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const f=this.a.getExtensionDescription(d.id);if(!f){const p=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new k(p));return this.c.onExtensionActivationError(d.id,p,new R.MissingExtensionDependency(d.id.value)),t}const g=[],D=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const p of D){if(this.m(p))continue;const t=this.d.get(p);if(t){g.push(t);continue}if(this.l(p)){g.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:d.reason}));continue}const o=this.a.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;g.push(this.j({id:o.identifier,reason:d.reason}));continue}const s=f.displayName||f.identifier.value,c=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),l=this.k(d,f.displayName,[],new k(c));return this.c.onExtensionActivationError(f.identifier,c,new R.MissingExtensionDependency(p)),l}return this.k(d,f.displayName,g,null)}k(d,f,g,D){const p=new E(d.id,f,d.reason,g,D,this.c,this.g);return this.d.set(d.id,p),p}l(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const f=this.b.getExtensionDescription(d);return f?!f.main&&!f.browser:!1}};C=Ve([We(3,P.ILogService)],C),e.ExtensionsActivator=C;let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,f,g,D,p,t,o){this.c=d,this.d=f,this.f=g,this.g=D,this.h=p,this.j=t,this.k=o,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const f=this.g[d];if(f.value&&!f.value.activationFailed){this.g.splice(d,1),d--;continue}if(f.value&&f.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);g.detail=f.value.activationFailedError,this.h=new k(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const f=new Error;if(d&&d.name&&(f.name=d.name),d&&d.message?f.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(f.stack=d.stack),this.h=new k(f),this.b&&a.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};E=Ve([We(6,P.ILogService)],E)});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[7],Ie([1,0,17,10,113,28,88,8,9,2,30,45,128,94,27]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C){"use strict";var E,r,d,f,g,D,p,t,o,s,c,l,v,i,n,h,w,b,O,H,x,_,G,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(X){return Object.assign(X,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(X,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(X,[]);{const[pe,...Te]=arguments;return Reflect.construct(X,Te,pe.constructor)}}})}var j;(function(X){X[X.Top=0]="Top",X[X.Bottom=1]="Bottom"})(j=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(X){X[X.Command=0]="Command",X[X.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let ie=t=class{static from(...W){let pe=W;return new t(function(){if(pe){for(const Te of pe)Te&&typeof Te.dispose=="function"&&Te.dispose();pe=void 0}})}constructor(W){E.set(this,void 0),Je(this,E,W,"f")}dispose(){typeof Me(this,E,"f")=="function"&&(Me(this,E,"f").call(this),Je(this,E,void 0,"f"))}};E=new WeakMap,ie=t=Ve([U],ie),e.Disposable=ie;let V=o=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Te=1;Te<W.length;Te++){const xe=W[Te];xe.isBefore(pe)&&(pe=xe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Te=1;Te<W.length;Te++){const xe=W[Te];xe.isAfter(pe)&&(pe=xe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof o)return!0;const{line:pe,character:Te}=W;return typeof pe=="number"&&typeof Te=="number"}static of(W){if(W instanceof o)return W;if(this.isPosition(W))return new o(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,A.illegalArgument)("line must be non-negative");if(pe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&pe===0?this:new o(this.line+Te,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Te===this.line&&pe===this.character?this:new o(Te,pe)}toJSON(){return{line:this.line,character:this.character}}};V=o=Ve([U],V),e.Position=V;let J=s=class{static isRange(W){return W instanceof s?!0:W?V.isPosition(W.start)&&V.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Te,xe){let _e,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"?(_e=new V(W,pe),at=new V(Te,xe)):V.isPosition(W)&&V.isPosition(pe)&&(_e=V.of(W),at=V.of(pe)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):V.isPosition(W)?!(V.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=V.Max(W.start,this.c),Te=V.Min(W.end,this.e);if(!pe.isAfter(Te))return new s(pe,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=V.Min(W.start,this.c),Te=V.Max(W.end,this.end);return new s(pe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,A.illegalArgument)();let Te;return W?V.isPosition(W)?Te=W:(Te=W.start||this.start,pe=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Te,pe)}toJSON(){return[this.start,this.end]}};J=s=Ve([U],J),e.Range=J;let re=c=class extends J{static isSelection(W){return W instanceof c?!0:W?J.isRange(W)&&V.isPosition(W.anchor)&&V.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Te,xe){let _e,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"?(_e=new V(W,pe),at=new V(Te,xe)):V.isPosition(W)&&V.isPosition(pe)&&(_e=V.of(W),at=V.of(pe)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=c=Ve([U],re),e.Selection=re;class ve{constructor(W,pe,Te){if(typeof W!="string"||W.length===0)throw(0,A.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,A.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,A.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(pe),this.connectionToken=Te}}e.ResolvedAuthority=ve;class ue extends Error{static NotAvailable(W,pe){return new ue(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new ue(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=pe,this._detail=Te,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var le;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(le=e.EndOfLine||(e.EndOfLine={}));var q;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let F=l=class{static isTextEdit(W){return W instanceof l?!0:W?J.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new l(W,pe)}static insert(W,pe){return l.replace(new J(W,W),pe)}static delete(W){return l.replace(W,"")}static setEndOfLine(W){const pe=new l(new J(new V(0,0),new V(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!J.isRange(W))throw(0,A.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,A.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,A.illegalArgument)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};F=l=Ve([U],F),e.TextEdit=F;let Q=v=class{static isNotebookCellEdit(W){return W instanceof v?!0:W?Gt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new v(W,pe)}static insertCells(W,pe){return new v(new Gt(W,W),pe)}static deleteCells(W){return new v(W,[])}static updateCellMetadata(W,pe){const Te=new v(new Gt(W,W),[]);return Te.newCellMetadata=pe,Te}static updateNotebookMetadata(W){const pe=new v(new Gt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};Q=v=Ve([U],Q),e.NotebookEdit=Q;class me{static isSnippetTextEdit(W){return W instanceof me?!0:W?J.isRange(W.range)&&ne.isSnippetString(W.snippet):!1}static replace(W,pe){return new me(W,pe)}static insert(W,pe){return me.replace(new J(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.SnippetTextEdit=me;var Ee;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace",X[X.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Te,xe){this.c.push({_type:1,from:W,to:pe,options:Te,metadata:xe})}createFile(W,pe,Te){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Te})}deleteFile(W,pe,Te){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Te})}e(W,pe,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Te,xe){const _e=pe.start,at=pe.end;(_e!==at||Te.length>0)&&this.c.push({_type:5,uri:W,index:_e,count:at-_e,cells:Te,metadata:xe})}g(W,pe,Te,xe){this.c.push({_type:3,metadata:xe,uri:W,edit:{editType:8,index:pe,metadata:Te}})}replace(W,pe,Te,xe){this.c.push({_type:2,uri:W,edit:new F(pe,Te),metadata:xe})}insert(W,pe,Te,xe){this.replace(W,new J(pe,pe),Te,xe)}delete(W,pe,Te){this.replace(W,pe,"",Te)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Te of pe){if(!Te)continue;let xe,_e;Array.isArray(Te)?(xe=Te[0],_e=Te[1]):xe=Te,Q.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(W,xe.range.start,xe.newCellMetadata,_e):xe.newNotebookMetadata?this.e(W,xe.newNotebookMetadata,_e):this.f(W,xe.range,xe.newCells,_e):me.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:W,range:xe.range,edit:xe.snippet,metadata:_e}):this.c.push({_type:2,uri:W,edit:xe,metadata:_e})}else{for(let Te=0;Te<this.c.length;Te++){const xe=this.c[Te];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(W){const pe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&pe.push(Te.edit);return pe}entries(){const W=new R.ResourceMap;for(const pe of this.c)if(pe._type===2){let Te=W.get(pe.uri);Te||(Te=[pe.uri,[]],W.set(pe.uri,Te)),Te[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Ve([U],te),e.WorkspaceEdit=te;let ne=i=class{static isSnippetString(W){return W instanceof i?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=i.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Te=new i;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=i.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Te=W.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Te=new i;Te.e=this.e,pe(Te),this.e=Te.e,pe=Te.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};ne=i=Ve([U],ne),e.SnippetString=ne;var de;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(de=e.DiagnosticTag||(e.DiagnosticTag={}));var ee;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ce=n=class{static isLocation(W){return W instanceof n?!0:W?J.isRange(W.range)&&m.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(J.isRange(pe))this.range=J.of(pe);else if(V.isPosition(pe))this.range=new J(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ce=n=Ve([U],ce),e.Location=ce;let ae=class{static is(W){return W?typeof W.message=="string"&&W.location&&J.isRange(W.location.range)&&m.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};ae=Ve([U],ae),e.DiagnosticRelatedInformation=ae;let N=class{constructor(W,pe,Te=ee.Error){if(!J.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Te}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,a.equals)(W.tags,pe.tags)&&(0,a.equals)(W.relatedInformation,pe.relatedInformation,ae.isEqual)}};N=Ve([U],N),e.Diagnostic=N;let z=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};z=Ve([U],z),e.Hover=z;var K;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(K=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Z=class{constructor(W,pe=K.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:K[this.kind]}}};Z=Ve([U],Z),e.DocumentHighlight=Z;var fe;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(fe=e.SymbolKind||(e.SymbolKind={}));var Se;(function(X){X[X.Deprecated=1]="Deprecated"})(Se=e.SymbolTag||(e.SymbolTag={}));let Ae=h=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Te,xe,_e){this.name=W,this.kind=pe,this.containerName=_e,typeof Te=="string"&&(this.containerName=Te),xe instanceof ce?this.location=xe:Te instanceof J&&(this.location=new ce(xe,Te)),h.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};Ae=h=Ve([U],Ae),e.SymbolInformation=Ae;let we=w=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(w.validate)}constructor(W,pe,Te,xe,_e){this.name=W,this.detail=pe,this.kind=Te,this.range=xe,this.selectionRange=_e,this.children=[],w.validate(this)}};we=w=Ve([U],we),e.DocumentSymbol=we;var Pe;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ke=class{constructor(W,pe){this.title=W,this.kind=pe}};ke=Ve([U],ke),e.CodeAction=ke;let ze=b=class{constructor(W){this.value=W}append(W){return new b(this.value?this.value+b.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+b.c)}};ze.c=".",ze=b=Ve([U],ze),e.CodeActionKind=ze,ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll");let qe=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};qe=Ve([U],qe),e.SelectionRange=qe;class tt{constructor(W,pe,Te,xe,_e,at){this.kind=W,this.name=pe,this.detail=Te,this.uri=xe,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=tt;class Qe{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.CallHierarchyIncomingCall=Qe;class it{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.CallHierarchyOutgoingCall=it;var rt;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Be=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};Be=Ve([U],Be),e.CodeLens=Be;let et=O=class{static isMarkdownString(W){return W instanceof O?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){r.set(this,void 0),Je(this,r,new u.MarkdownString(W,{supportThemeIcons:pe}),"f")}get value(){return Me(this,r,"f").value}set value(W){Me(this,r,"f").value=W}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(W){Me(this,r,"f").isTrusted=W}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}set supportThemeIcons(W){Me(this,r,"f").supportThemeIcons=W}get supportHtml(){return Me(this,r,"f").supportHtml}set supportHtml(W){Me(this,r,"f").supportHtml=W}get baseUri(){return Me(this,r,"f").baseUri}set baseUri(W){Me(this,r,"f").baseUri=W}appendText(W){return Me(this,r,"f").appendText(W),this}appendMarkdown(W){return Me(this,r,"f").appendMarkdown(W),this}appendCodeblock(W,pe){return Me(this,r,"f").appendCodeblock(pe??"",W),this}};r=new WeakMap,et=O=Ve([U],et),e.MarkdownString=et;let $=class{constructor(W,pe){this.label=W,this.documentation=pe}};$=Ve([U],$),e.ParameterInformation=$;let Y=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};Y=Ve([U],Y),e.SignatureInformation=Y;let ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ge=Ve([U],ge),e.SignatureHelp=ge;var Le;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(W){this.value=W}};je=Ve([U],je),e.InlayHintLabelPart=je;let Ye=class{constructor(W,pe,Te){this.position=W,this.label=pe,this.kind=Te}};Ye=Ve([U],Ye),e.InlayHint=Ye;var Xe;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var nt;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(nt=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(X){X[X.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let pt=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&nt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pt=Ve([U],pt),e.CompletionItem=pt;let bt=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};bt=Ve([U],bt),e.CompletionList=bt;let St=class{constructor(W,pe,Te){this.insertText=W,this.range=pe,this.command=Te}};St=Ve([U],St),e.InlineSuggestion=St;let Pt=class{constructor(W){this.commands=void 0,this.items=W}};Pt=Ve([U],Pt),e.InlineSuggestionList=Pt;var $t;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})($t=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var wt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(wt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function W(pe){switch(pe){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=W}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let kt=class{constructor(W,pe){if(pe&&!m.URI.isUri(pe))throw(0,A.illegalArgument)("target");if(!J.isRange(W)||W.isEmpty)throw(0,A.illegalArgument)("range");this.range=W,this.target=pe}};kt=Ve([U],kt),e.DocumentLink=kt;let At=class{constructor(W,pe,Te,xe){this.red=W,this.green=pe,this.blue=Te,this.alpha=xe}};At=Ve([U],At),e.Color=At;let Bt=class{constructor(W,pe){if(pe&&!(pe instanceof At))throw(0,A.illegalArgument)("color");if(!J.isRange(W)||W.isEmpty)throw(0,A.illegalArgument)("range");this.range=W,this.color=pe}};Bt=Ve([U],Bt),e.ColorInformation=Bt;let Ke=class{constructor(W){if(!W||typeof W!="string")throw(0,A.illegalArgument)("label");this.label=W}};Ke=Ve([U],Ke),e.ColorPresentation=Ke;var Wt;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Re;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Re=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Fe;(function(X){X[X.Unknown=0]="Unknown",X[X.Shutdown=1]="Shutdown",X[X.Process=2]="Process",X[X.User=3]="User",X[X.Extension=4]="Extension"})(Fe=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(W,pe,Te){if(this.startIndex=W,this.length=pe,this.tooltip=Te,typeof W!="number"||W<0)throw(0,A.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,A.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=ye;class oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=oe;class Oe{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Oe;var He;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(He=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(W){if(this.options=W,typeof W!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Ze;var Ge;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(Ge=e.TaskRevealKind||(e.TaskRevealKind={}));var ct;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ct=e.TaskPanelKind||(e.TaskPanelKind={}));let mt=H=class{static from(W){switch(W){case"clean":return H.Clean;case"build":return H.Build;case"rebuild":return H.Rebuild;case"test":return H.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,A.illegalArgument)("name");this.c=W}get id(){return this.c}};mt.Clean=new H("clean","Clean"),mt.Build=new H("build","Build"),mt.Rebuild=new H("rebuild","Rebuild"),mt.Test=new H("test","Test"),mt=H=Ve([U],mt),e.TaskGroup=mt;function gt(X){let W="";for(let pe=0;pe<X.length;pe++)W+=X[pe].replace(/,/g,",,")+",";return W}let dt=class{constructor(W,pe,Te){if(typeof W!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Te):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,A.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return gt(W)}};dt=Ve([U],dt),e.ProcessExecution=dt;let lt=class{constructor(W,pe,Te){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,A.illegalArgument)("command");this.e=W,this.f=pe,this.g=Te}else{if(typeof W!="string")throw(0,A.illegalArgument)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,A.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,A.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return gt(W)}};lt=Ve([U],lt),e.ShellExecution=lt;var yt;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var Tt;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Tt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=Ht;let Ft=x=class{constructor(W,pe,Te,xe,_e,at){this.j=!1,this.k=this.definition=W;let ut;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Te,this.execution=xe,ut=_e,this.j=!0):pe===Tt.Global||pe===Tt.Workspace?(this.target=pe,this.m=this.name=Te,this.t=this.source=xe,this.execution=_e,ut=at):(this.target=pe,this.m=this.name=Te,this.t=this.source=xe,this.execution=_e,ut=at),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof dt?this.k={type:x.e,id:this.n.computeId()}:this.n instanceof lt?this.k={type:x.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:x.c,id:this.n.computeId()}:this.k={type:x.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const pe=this.k.type;(x.g===pe||x.e===pe||x.f===pe||x.c===pe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Ft.c="customExecution",Ft.e="process",Ft.f="shell",Ft.g="$empty",Ft=x=Ve([U],Ft),e.Task=Ft;var ai;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var Rt;(function(X){function W(pe){const Te=pe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}X.isViewBadge=W})(Rt=e.ViewBadge||(e.ViewBadge={}));let yi=_=class{static isTreeItem(W,pe){const Te=W;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(pe,"treeItemCheckbox");const xe=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,_e=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(xe===void 0||xe!==It.Checked&&xe!==It.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(W instanceof _)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!m.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const xe=Te.iconPath;if(!xe||!(0,y.isString)(xe.light)&&!m.URI.isUri(xe.light)&&!(0,y.isString)(xe.dark)&&!m.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!m.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ci.None&&Te.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(W,pe=ci.None){this.collapsibleState=pe,m.URI.isUri(W)?this.resourceUri=W:this.label=W}};yi=_=Ve([U],yi),e.TreeItem=yi;var ci;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var It;(function(X){X[X.Unchecked=0]="Unchecked",X[X.Checked=1]="Checked"})(It=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,pe){this.value=W,this.id=pe??(0,L.generateUuid)()}};li=Ve([U],li),e.DataTransferItem=li;let ui=class{constructor(W){d.add(this),f.set(this,new Map);for(const[pe,Te]of W??[]){const xe=Me(this,f,"f").get(Me(this,d,"m",g).call(this,pe));xe?xe.push(Te):Me(this,f,"f").set(Me(this,d,"m",g).call(this,pe),[Te])}}get(W){return Me(this,f,"f").get(Me(this,d,"m",g).call(this,W))?.[0]}set(W,pe){Me(this,f,"f").set(Me(this,d,"m",g).call(this,W),[pe])}forEach(W,pe){for(const[Te,xe]of Me(this,f,"f"))for(const _e of xe)W.call(pe,_e,Te,this)}*[(f=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[W,pe]of Me(this,f,"f"))for(const Te of pe)yield[W,Te]}};g=function(W){return W.toLowerCase()},ui=Ve([U],ui),e.DataTransfer=ui;let Zt=class{constructor(W){this.insertText=W}};Zt=Ve([U],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(W){this.insertText=W}};Di=Ve([U],Di),e.DocumentPasteEdit=Di;let Dt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Dt=Ve([U],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let di=class{constructor(W){this.id=W}};di=Ve([U],di),e.ThemeColor=di;var zi;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(zi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(W){this.c=W,this.e=m.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!m.URI.isUri(W)&&!m.URI.isUri(W.uri)))throw(0,A.illegalArgument)("base");if(typeof pe!="string")throw(0,A.illegalArgument)("pattern");typeof W=="string"?this.baseUri=m.URI.file(W):m.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ve([U],ei),e.RelativePattern=ei;const ii=new WeakMap;function ht(X,W){ii.set(X,W)}e.setBreakpointId=ht;let ti=class{constructor(W,pe,Te,xe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Te=="string"&&(this.hitCondition=Te),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ii.get(this)??(0,L.generateUuid)()),this.c}};ti=Ve([U],ti),e.Breakpoint=ti;let Vt=class extends ti{constructor(W,pe,Te,xe,_e){if(super(pe,Te,xe,_e),W===null)throw(0,A.illegalArgument)("location");this.location=W}};Vt=Ve([U],Vt),e.SourceBreakpoint=Vt;let Qt=class extends ti{constructor(W,pe,Te,xe,_e){super(pe,Te,xe,_e),this.functionName=W}};Qt=Ve([U],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(W,pe,Te,xe,_e,at,ut){if(super(xe,_e,at,ut),!pe)throw(0,A.illegalArgument)("dataId");this.label=W,this.dataId=pe,this.canPersist=Te}};hi=Ve([U],hi),e.DataBreakpoint=hi;let Ci=class{constructor(W,pe,Te){this.command=W,this.args=pe||[],this.options=Te}};Ci=Ve([U],Ci),e.DebugAdapterExecutable=Ci;let Ii=class{constructor(W,pe){this.port=W,this.host=pe}};Ii=Ve([U],Ii),e.DebugAdapterServer=Ii;let fi=class{constructor(W){this.path=W}};fi=Ve([U],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(W){this.implementation=W}};ki=Ve([U],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(W,pe){this.range=W,this.expression=pe}};mi=Ve([U],mi),e.EvaluatableExpression=mi;var gi;(function(X){X[X.Invoke=0]="Invoke",X[X.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(W,pe){this.range=W,this.text=pe}};Ti=Ve([U],Ti),e.InlineValueText=Ti;let ni=class{constructor(W,pe,Te=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Te}};ni=Ve([U],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(W,pe){this.range=W,this.expression=pe}};ri=Ve([U],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};Pi=Ve([U],Pi),e.InlineValueContext=Pi;var $i;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let Yt=G=class extends Error{static FileExists(W){return new G(W,I.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(W){return new G(W,I.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(W){return new G(W,I.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(W){return new G(W,I.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(W){return new G(W,I.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(W){return new G(W,I.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(W,pe=I.FileSystemProviderErrorCode.Unknown,Te){super(m.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Yt=G=Ve([U],Yt),e.FileSystemError=Yt;let Ai=class{constructor(W,pe,Te){this.start=W,this.end=pe,this.kind=Te}};Ai=Ve([U],Ai),e.FoldingRange=Ai;var Wi;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var ji;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(ji=e.CommentThreadState||(e.CommentThreadState={}));class Vi{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.SemanticTokensLegend=Vi;function qi(X){return typeof X>"u"||(0,y.isStringArray)(X)}class si{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Te=W.tokenTypes.length;pe<Te;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Te=W.tokenModifiers.length;pe<Te;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Te,xe,_e){if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(W,pe,Te,xe,_e);if(J.isRange(W)&&typeof pe=="string"&&qi(Te))return this.m(W,pe,Te);throw(0,A.illegalArgument)()}m(W,pe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const xe=W.start.line,_e=W.start.character,at=W.end.character-W.start.character,ut=this.j.get(pe);let Mt=0;if(Te)for(const jt of Te){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(jt);Mt|=1<<qt>>>0}this.n(xe,_e,at,ut,Mt)}n(W,pe,Te,xe,_e){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let jt=0,qt=0;for(let Kt=0;Kt<Mt;Kt++){let _t=this.g[5*Kt],Li=this.g[5*Kt+1];_t===0?(_t=jt,Li+=qt):_t+=jt,this.g[5*Kt]=_t,this.g[5*Kt+1]=Li,jt=_t,qt=Li}}let at=W,ut=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ut-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ut,this.g[this.h++]=Te,this.g[this.h++]=xe,this.g[this.h++]=_e,this.c=W,this.e=pe}static o(W){const pe=[],Te=W.length/5|0;for(let ut=0;ut<Te;ut++)pe[ut]=ut;pe.sort((ut,Mt)=>{const jt=W[5*ut],qt=W[5*Mt];if(jt===qt){const Kt=W[5*ut+1],_t=W[5*Mt+1];return Kt-_t}return jt-qt});const xe=new Uint32Array(W.length);let _e=0,at=0;for(let ut=0;ut<Te;ut++){const Mt=5*pe[ut],jt=W[Mt+0],qt=W[Mt+1],Kt=W[Mt+2],_t=W[Mt+3],Li=W[Mt+4],ln=jt-_e,On=ln===0?qt-at:qt,Oi=5*ut;xe[Oi+0]=ln,xe[Oi+1]=On,xe[Oi+2]=Kt,xe[Oi+3]=_t,xe[Oi+4]=Li,_e=jt,at=qt}return xe}build(W){return this.f?new pi(new Uint32Array(this.g),W):new pi(si.o(this.g),W)}}e.SemanticTokensBuilder=si;class pi{constructor(W,pe){this.resultId=pe,this.data=W}}e.SemanticTokens=pi;class Fi{constructor(W,pe,Te){this.start=W,this.deleteCount=pe,this.data=Te}}e.SemanticTokensEdit=Fi;class $e{constructor(W,pe){this.resultId=pe,this.edits=W}}e.SemanticTokensEdits=$e;var xt;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new Dt("arrow-left")},oi=Ve([U],oi),e.QuickInputButtons=oi;var Et;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function(X){X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gi;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(Gi=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(W){if(typeof W.badge=="string"){let pe=(0,T.nextCharLength)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,T.nextCharLength)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Dt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Te){this.badge=W,this.tooltip=pe,this.color=Te}}e.FileDecoration=Mi;let Ri=class{constructor(W){this.kind=W}};Ri=Ve([U],Ri),e.ColorTheme=Ri;var bi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast",X[X.HighContrastLight=4]="HighContrastLight"})(bi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(W){return W instanceof Gt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,A.illegalArgument)("start must be positive");if(pe<0)throw(0,A.illegalArgument)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Te=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Te=W.end),pe===this.c&&Te===this.e?this:new Gt(pe,Te)}}e.NotebookRange=Gt;class vi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>vi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Te,xe,_e,at,ut){this.kind=W,this.value=pe,this.languageId=Te,this.mime=xe,this.outputs=_e??[],this.metadata=at,this.executionSummary=ut,vi.validate(this)}}e.NotebookCellData=vi;class Ki{constructor(W){this.cells=W}}e.NotebookData=Ki;class zt{static isNotebookCellOutputItem(W){return W instanceof zt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return zt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return zt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return zt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new zt(W,pe)}static text(W,pe=P.Mimes.text){const Te=Me(zt,D,"f",p).encode(String(W));return new zt(Te,pe)}static json(W,pe="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return zt.text(Te,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Te=(0,P.normalizeMimeType)(pe,!0);if(!Te)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}D=zt,p={value:new TextEncoder},e.NotebookCellOutputItem=zt;class wi{static isNotebookCellOutput(W){return W instanceof wi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Te=new Set,xe=new Set;for(let _e=0;_e<W.length;_e++){const at=W[_e],ut=(0,P.normalizeMimeType)(at.mime);if(!Te.has(ut)||(0,k.isTextStreamMime)(ut)){Te.add(ut);continue}xe.add(_e),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return xe.size===0?W:W.filter((_e,at)=>!xe.has(at))}constructor(W,pe,Te){this.items=wi.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=pe??Te)}}e.NotebookCellOutput=wi;var Xi;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ji{constructor(W,pe){this.text=W,this.alignment=pe}}e.NotebookCellStatusBarItem=Ji;var Zi;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var be;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred",X[X.Hidden=-1]="Hidden"})(be=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class De{constructor(W,pe=[]){this.uri=W,this.provides=(0,a.asArray)(pe)}}e.NotebookRendererScript=De;class Ue{constructor(W){this.label=W}}e.NotebookKernelSourceAction=Ue;let st=class{constructor(W,pe){this.label=W,this.timestamp=pe}};st=Ve([U],st),e.TimelineItem=st;var Ct;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(Ct=e.ExtensionMode||(e.ExtensionMode={}));var Lt;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Lt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.LinkedEditingRanges=gn;class pn{constructor(W,pe){this.c=W,this.e=pe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var bn;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var vn;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(vn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(W=void 0,pe=void 0,Te=void 0){this.include=W,this.exclude=pe,this.profile=Te}};Ui=Ve([U],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(W=void 0,pe=void 0,Te=void 0,xe=!1){super(W,pe,Te),this.continuous=xe}};en=Ve([U],en),e.TestRunRequest2=en;let tn=M=class{static diff(W,pe,Te){const xe=new M(W);return xe.expectedOutput=pe,xe.actualOutput=Te,xe}constructor(W){this.message=W}};tn=M=Ve([U],tn),e.TestMessage=tn;let nn=class{constructor(W){this.id=W}};nn=Ve([U],nn),e.TestTag=nn;let Ei=class{constructor(W,pe){this.covered=W,this.total=pe}};Ei=Ve([U],Ei),e.CoveredCount=Ei;let rn=B=class{static fromDetails(W,pe){const Te=new Ei(0,0),xe=new Ei(0,0),_e=new Ei(0,0);for(const ut of pe)if("branches"in ut){Te.total+=1,Te.covered+=ut.executionCount>0?1:0;for(const Mt of ut.branches)xe.total+=1,xe.covered+=Mt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const at=new B(W,Te,xe.total>0?xe:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=pe,at}constructor(W,pe,Te,xe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Te,this.functionCoverage=xe}};rn=B=Ve([U],rn),e.FileCoverage=rn;let sn=class{constructor(W,pe,Te=[]){this.executionCount=W,this.location=pe,this.branches=Te}};sn=Ve([U],sn),e.StatementCoverage=sn;let on=class{constructor(W,pe){this.executionCount=W,this.location=pe}};on=Ve([U],on),e.BranchCoverage=on;let an=class{constructor(W,pe){this.executionCount=W,this.location=pe}};an=Ve([U],an),e.FunctionCoverage=an;var wn;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var En;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(En=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(W,pe,Te,xe,_e,at){this.kind=W,this.name=pe,this.detail=Te,this.uri=xe,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=yn;class Dn{constructor(W){this.uri=W}}e.TextTabInput=Dn;class Cn{constructor(W,pe){this.original=W,this.modified=pe}}e.TextDiffTabInput=Cn;class In{constructor(W,pe,Te,xe){this.base=W,this.input1=pe,this.input2=Te,this.result=xe}}e.TextMergeTabInput=In;class kn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.CustomEditorTabInput=kn;class Tn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Tn;class Pn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.NotebookEditorTabInput=Pn;class An{constructor(W,pe,Te){this.original=W,this.modified=pe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.InteractiveWindowInput=Ln}),define(Ce[136],Ie([1,0,51,18,8,166,107,7,17]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function L(C,E){E?m.set(C,E):m.delete(C)}e.setWordDefinitionFor=L;function I(C){return m.get(C)}class S extends R.MirrorTextModel{constructor(E,r,d,f,g,D,p,t){super(r,d,f,g),this.m=E,this.p=D,this.q=p,this.notebook=t,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,y.equals)(this.d,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.c},get fileName(){return E.c.fsPath},get isUntitled(){return E.c.scheme===A.Schemas.untitled},get languageId(){return E.p},get version(){return E.g},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(r){return r?E.s(r):E.getText()},get eol(){return E.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return E.d.length},lineAt(r){return E.t(r)},offsetAt(r){return E.u(r)},positionAt(r){return E.v(r)},validateRange(r){return E.w(r)},validatePosition(r){return E.x(r)},getWordRangeAtPosition(r,d){return E.y(r,d)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,a.ok)(!this.b),this.p=E}_acceptIsDirty(E){(0,a.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(E){const r=this.w(E);if(r.isEmpty)return"";if(r.isSingleLine)return this.d[r.start.line].substring(r.start.character,r.end.character);const d=this.f,f=r.start.line,g=r.end.line,D=[];D.push(this.d[f].substring(r.start.character));for(let p=f+1;p<g;p++)D.push(this.d[p]);return D.push(this.d[g].substring(0,r.end.character)),D.join(d)}t(E){let r;if(E instanceof T.Position?r=E.line:typeof E=="number"&&(r=E),typeof r!="number"||r<0||r>=this.d.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new k(r,this.d[r],r===this.d.length-1)}u(E){return E=this.x(E),this.k(),this.h.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.k();const r=this.h.getIndexOf(E),d=this.d[r.index].length;return new T.Position(r.index,Math.min(r.remainder,d))}w(E){if(!(E instanceof T.Range))throw new Error("Invalid argument");const r=this.x(E.start),d=this.x(E.end);return r===E.start&&d===E.end?E:new T.Range(r.line,r.character,d.line,d.character)}x(E){if(!(E instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return E.with(0,0);let{line:r,character:d}=E,f=!1;if(r<0)r=0,d=0,f=!0;else if(r>=this.d.length)r=this.d.length-1,d=this.d[r].length,f=!0;else{const g=this.d[r].length;d<0?(d=0,f=!0):d>g&&(d=g,f=!0)}return f?new T.Position(r,d):E}y(E,r){const d=this.x(E);if(!r)r=I(this.p);else if((0,u.regExpLeadsToEndlessLoop)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const f=(0,P.getWordAtText)(d.character+1,(0,P.ensureValidWordDefinition)(r),this.d[d.line],0);if(f)return new T.Range(d.line,f.startColumn-1,d.line,f.endColumn-1)}}e.ExtHostDocumentData=S;class k{constructor(E,r,d){this.a=E,this.b=r,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=k}),define(Ce[243],Ie([1,0,7,20,3]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let y;switch(T){case"light":y=a.ColorThemeKind.Light;break;case"hcDark":y=a.ColorThemeKind.HighContrast;break;case"hcLight":y=a.ColorThemeKind.HighContrastLight;break;default:y=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(Ce[13],Ie([1,0,17,22,150,63,113,28,148,70,88,23,9,2,32,72,124,133,131,94,57,76,239,7]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Fe(oe){const{selectionStartLineNumber:Oe,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:Ge}=oe,ct=new o.Position(Oe-1,He-1),mt=new o.Position(Ze-1,Ge-1);return new o.Selection(ct,mt)}Re.to=Fe;function ye(oe){const{anchor:Oe,active:He}=oe;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=ye})(s=e.Selection||(e.Selection={}));var c;(function(Re){function Fe(oe){if(!oe)return;const{start:Oe,end:He}=oe;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Fe;function ye(oe){if(!oe)return;const{startLineNumber:Oe,startColumn:He,endLineNumber:Ze,endColumn:Ge}=oe;return new o.Range(Oe-1,He-1,Ze-1,Ge-1)}Re.to=ye})(c=e.Range||(e.Range={}));var l;(function(Re){function Fe(ye){switch(ye){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Fe})(l=e.TokenType||(e.TokenType={}));var v;(function(Re){function Fe(oe){return new o.Position(oe.lineNumber-1,oe.column-1)}Re.to=Fe;function ye(oe){return{lineNumber:oe.line+1,column:oe.character+1}}Re.from=ye})(v=e.Position||(e.Position={}));var i;(function(Re){function Fe(Oe,He){return(0,a.coalesce)((0,a.asArray)(Oe).map(Ze=>ye(Ze,He)))}Re.from=Fe;function ye(Oe,He){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:oe(Oe.scheme,He),pattern:ge.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function oe(Oe,He){return He&&typeof Oe=="string"?He.transformOutgoingScheme(Oe):Oe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Re){function Fe(oe){switch(oe){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function ye(oe){switch(oe){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=ye})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Re){function Fe(oe){let Oe;return oe.code&&((0,S.isString)(oe.code)||(0,S.isNumber)(oe.code)?Oe=String(oe.code):Oe={value:String(oe.code.value),target:oe.code.target}),{...c.from(oe.range),message:oe.message,source:oe.source,code:Oe,severity:b.from(oe.severity),relatedInformation:oe.relatedInformation&&oe.relatedInformation.map(w.from),tags:Array.isArray(oe.tags)?(0,a.coalesce)(oe.tags.map(n.from)):void 0}}Re.from=Fe;function ye(oe){const Oe=new o.Diagnostic(c.to(oe),oe.message,b.to(oe.severity));return Oe.source=oe.source,Oe.code=(0,S.isString)(oe.code)?oe.code:oe.code?.value,Oe.relatedInformation=oe.relatedInformation&&oe.relatedInformation.map(w.to),Oe.tags=oe.tags&&(0,a.coalesce)(oe.tags.map(n.to)),Oe}Re.to=ye})(h=e.Diagnostic||(e.Diagnostic={}));var w;(function(Re){function Fe(oe){return{...c.from(oe.location.range),message:oe.message,resource:oe.location.uri}}Re.from=Fe;function ye(oe){return new o.DiagnosticRelatedInformation(new o.Location(oe.resource,c.to(oe)),oe.message)}Re.to=ye})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var b;(function(Re){function Fe(oe){switch(oe){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Re.from=Fe;function ye(oe){switch(oe){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=ye})(b=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Re){function Fe(oe){return typeof oe=="number"&&oe>=o.ViewColumn.One?oe-1:oe===o.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Re.from=Fe;function ye(oe){if(typeof oe=="number"&&oe>=0)return oe+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ye})(O=e.ViewColumn||(e.ViewColumn={}));function H(Re){return typeof Re.range<"u"}function x(Re){return Re.length===0?!0:!!H(Re[0])}e.isDecorationOptionsArr=x;var _;(function(Re){function Fe(Ge){return Ge.map(Re.from)}Re.fromMany=Fe;function ye(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function oe(Ge){let ct;if(ye(Ge)){const{language:lt,value:yt}=Ge;ct={value:"```"+lt+`
`+yt+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const mt=Object.create(null);ct.uris=mt;const gt=lt=>{try{let yt=k.URI.parse(lt,!0);yt=yt.with({query:Oe(yt.query,mt)}),mt[lt]=yt}catch{}return""},dt=new y.marked.Renderer;return dt.link=gt,dt.image=lt=>typeof lt=="string"?gt(P.parseHrefAndDimensions(lt).href):"",(0,y.marked)(ct.value,{renderer:dt}),ct}Re.from=oe;function Oe(Ge,ct){if(!Ge)return Ge;let mt;try{mt=(0,m.parse)(Ge)}catch{}if(!mt)return Ge;let gt=!1;return mt=(0,I.cloneAndChange)(mt,dt=>{if(k.URI.isUri(dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[lt]=dt,gt=!0,lt}else return}),gt?JSON.stringify(mt):Ge}function He(Ge){const ct=new o.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?k.URI.from(Ge.baseUri):void 0,ct}Re.to=He;function Ze(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Re.from(Ge)}Re.fromStrict=Ze})(_=e.MarkdownString||(e.MarkdownString={}));function G(Re){return x(Re)?Re.map(Fe=>({range:c.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?_.fromMany(Fe.hoverMessage):Fe.hoverMessage?_.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:c.from(Fe)}))}e.fromRangeOrRangeWithMessage=G;function M(Re){return typeof Re>"u"?Re:typeof Re=="string"?k.URI.file(Re):Re}e.pathOrURIToURI=M;var B;(function(Re){function Fe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?M(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Re.from=Fe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Re){function Fe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?M(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?B.from(ye.before):void 0,after:ye.after?B.from(ye.after):void 0}}Re.from=Fe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Fe(ye){if(typeof ye>"u")return ye;switch(ye){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Re){function Fe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?j.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?U.from(ye.light):void 0,dark:ye.dark?U.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?M(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?B.from(ye.before):void 0,after:ye.after?B.from(ye.after):void 0}}Re.from=Fe})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(Re){function Fe(oe){return{text:oe.newText,eol:oe.newEol&&rt.from(oe.newEol),range:c.from(oe.range)}}Re.from=Fe;function ye(oe){const Oe=new o.TextEdit(c.to(oe.range),oe.text);return Oe.newEol=typeof oe.eol>"u"?void 0:rt.to(oe.eol),Oe}Re.to=ye})(ie=e.TextEdit||(e.TextEdit={}));var V;(function(Re){function Fe(oe,Oe){const He={edits:[]};if(oe instanceof o.WorkspaceEdit){const Ze=new T.ResourceSet;for(const Ge of oe._allEntries())Ge._type===1&&k.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of oe._allEntries())Ge._type===1?He.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?He.edits.push({resource:Ge.uri,textEdit:ie.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?He.edits.push({resource:Ge.uri,textEdit:{range:c.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?He.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&He.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return He}Re.from=Fe;function ye(oe){const Oe=new o.WorkspaceEdit;for(const He of oe.edits)He.textEdit?Oe.replace(k.URI.revive(He.resource),c.to(He.textEdit.range),He.textEdit.text):Oe.renameFile(k.URI.revive(He.oldResource),k.URI.revive(He.newResource),He.options);return Oe}Re.to=ye})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function ye(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=ye;function oe(Oe){for(const He in Fe)if(Fe[He]===Oe)return Number(He);return o.SymbolKind.Property}Re.to=oe})(J=e.SymbolKind||(e.SymbolKind={}));var re;(function(Re){function Fe(oe){switch(oe){case o.SymbolTag.Deprecated:return 1}}Re.from=Fe;function ye(oe){switch(oe){case 1:return o.SymbolTag.Deprecated}}Re.to=ye})(re=e.SymbolTag||(e.SymbolTag={}));var ve;(function(Re){function Fe(oe){return{name:oe.name,kind:J.from(oe.kind),tags:oe.tags&&oe.tags.map(re.from),containerName:oe.containerName,location:Q.from(oe.location)}}Re.from=Fe;function ye(oe){const Oe=new o.SymbolInformation(oe.name,J.to(oe.kind),oe.containerName,Q.to(oe.location));return Oe.tags=oe.tags&&oe.tags.map(re.to),Oe}Re.to=ye})(ve=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Re){function Fe(oe){const Oe={name:oe.name||"!!MISSING: name!!",detail:oe.detail,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),kind:J.from(oe.kind),tags:oe.tags?.map(re.from)??[]};return oe.children&&(Oe.children=oe.children.map(Fe)),Oe}Re.from=Fe;function ye(oe){const Oe=new o.DocumentSymbol(oe.name,oe.detail,J.to(oe.kind),c.to(oe.range),c.to(oe.selectionRange));return(0,a.isNonEmptyArray)(oe.tags)&&(Oe.tags=oe.tags.map(re.to)),oe.children&&(Oe.children=oe.children.map(ye)),Oe}Re.to=ye})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(Re){function Fe(oe){const Oe=new o.CallHierarchyItem(J.to(oe.kind),oe.name,oe.detail||"",k.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Oe._sessionId=oe._sessionId,Oe._itemId=oe._itemId,Oe}Re.to=Fe;function ye(oe,Oe,He){if(Oe=Oe??oe._sessionId,He=He??oe._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,name:oe.name,detail:oe.detail,kind:J.from(oe.kind),uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(re.from)}}Re.from=ye})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(Re){function Fe(ye){return new o.CallHierarchyIncomingCall(le.to(ye.from),ye.fromRanges.map(oe=>c.to(oe)))}Re.to=Fe})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Re){function Fe(ye){return new o.CallHierarchyOutgoingCall(le.to(ye.to),ye.fromRanges.map(oe=>c.to(oe)))}Re.to=Fe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(Re){function Fe(oe){return{range:oe.range&&c.from(oe.range),uri:oe.uri}}Re.from=Fe;function ye(oe){return new o.Location(k.URI.revive(oe.uri),c.to(oe.range))}Re.to=ye})(Q=e.location||(e.location={}));var me;(function(Re){function Fe(oe){const Oe=oe,He=oe;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:He.uri,range:c.from(Oe.targetRange?Oe.targetRange:He.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function ye(oe){return{targetUri:k.URI.revive(oe.uri),targetRange:c.to(oe.range),targetSelectionRange:oe.targetSelectionRange?c.to(oe.targetSelectionRange):void 0,originSelectionRange:oe.originSelectionRange?c.to(oe.originSelectionRange):void 0}}Re.to=ye})(me=e.DefinitionLink||(e.DefinitionLink={}));var Ee;(function(Re){function Fe(oe){return{range:c.from(oe.range),contents:_.fromMany(oe.contents)}}Re.from=Fe;function ye(oe){return new o.Hover(oe.contents.map(_.to),c.to(oe.range))}Re.to=ye})(Ee=e.Hover||(e.Hover={}));var te;(function(Re){function Fe(oe){return{range:c.from(oe.range),expression:oe.expression}}Re.from=Fe;function ye(oe){return new o.EvaluatableExpression(c.to(oe.range),oe.expression)}Re.to=ye})(te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ne;(function(Re){function Fe(oe){if(oe instanceof o.InlineValueText)return{type:"text",range:c.from(oe.range),text:oe.text};if(oe instanceof o.InlineValueVariableLookup)return{type:"variable",range:c.from(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};if(oe instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(oe.range),expression:oe.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function ye(oe){switch(oe.type){case"text":return{range:c.to(oe.range),text:oe.text};case"variable":return{range:c.to(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};case"expression":return{range:c.to(oe.range),expression:oe.expression}}}Re.to=ye})(ne=e.InlineValue||(e.InlineValue={}));var de;(function(Re){function Fe(oe){return{frameId:oe.frameId,stoppedLocation:c.from(oe.stoppedLocation)}}Re.from=Fe;function ye(oe){return new o.InlineValueContext(oe.frameId,c.to(oe.stoppedLocation))}Re.to=ye})(de=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Fe(oe){return{range:c.from(oe.range),kind:oe.kind}}Re.from=Fe;function ye(oe){return new o.DocumentHighlight(c.to(oe.range),oe.kind)}Re.to=ye})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Fe(ye){switch(ye){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Fe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Re){function Fe(ye){return{triggerKind:ce.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Re.to=Fe})(ae=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Fe(oe){switch(oe){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function ye(oe){switch(oe){case 1:return o.CompletionItemTag.Deprecated}}Re.to=ye})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Re){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ye(He){return Fe.get(He)??9}Re.from=ye;const oe=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(He){return oe.get(He)??o.CompletionItemKind.Property}Re.to=Oe})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Fe(ye,oe){const Oe=new o.CompletionItem(ye.label);return Oe.insertText=ye.insertText,Oe.kind=z.to(ye.kind),Oe.tags=ye.tags?.map(N.to),Oe.detail=ye.detail,Oe.documentation=P.isMarkdownString(ye.documentation)?_.to(ye.documentation):ye.documentation,Oe.sortText=ye.sortText,Oe.filterText=ye.filterText,Oe.preselect=ye.preselect,Oe.commitCharacters=ye.commitCharacters,C.Range.isIRange(ye.range)?Oe.range=c.to(ye.range):typeof ye.range=="object"&&(Oe.range={inserting:c.to(ye.range.insert),replacing:c.to(ye.range.replace)}),Oe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:Boolean(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Oe.insertText=new o.SnippetString(ye.insertText):(Oe.insertText=ye.insertText,Oe.textEdit=Oe.range instanceof o.Range?new o.TextEdit(Oe.range,Oe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ye.additionalTextEdits.map(He=>ie.to(He))),Oe.command=oe&&ye.command?oe.fromInternal(ye.command):void 0,Oe}Re.to=Fe})(K=e.CompletionItem||(e.CompletionItem={}));var Z;(function(Re){function Fe(oe){if(typeof oe.label!="string"&&!Array.isArray(oe.label))throw new TypeError("Invalid label");return{label:oe.label,documentation:_.fromStrict(oe.documentation)}}Re.from=Fe;function ye(oe){return{label:oe.label,documentation:P.isMarkdownString(oe.documentation)?_.to(oe.documentation):oe.documentation}}Re.to=ye})(Z=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(Re){function Fe(oe){return{label:oe.label,documentation:_.fromStrict(oe.documentation),parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.from):[],activeParameter:oe.activeParameter}}Re.from=Fe;function ye(oe){return{label:oe.label,documentation:P.isMarkdownString(oe.documentation)?_.to(oe.documentation):oe.documentation,parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.to):[],activeParameter:oe.activeParameter}}Re.to=ye})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(Re){function Fe(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(fe.from):[]}}Re.from=Fe;function ye(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(fe.to):[]}}Re.to=ye})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Fe(ye,oe){const Oe=new o.InlayHint(v.to(oe.position),typeof oe.label=="string"?oe.label:oe.label.map(we.to.bind(void 0,ye)),oe.kind&&Pe.to(oe.kind));return Oe.textEdits=oe.textEdits&&oe.textEdits.map(ie.to),Oe.tooltip=P.isMarkdownString(oe.tooltip)?_.to(oe.tooltip):oe.tooltip,Oe.paddingLeft=oe.paddingLeft,Oe.paddingRight=oe.paddingRight,Oe}Re.to=Fe})(Ae=e.InlayHint||(e.InlayHint={}));var we;(function(Re){function Fe(ye,oe){const Oe=new o.InlayHintLabelPart(oe.label);return Oe.tooltip=P.isMarkdownString(oe.tooltip)?_.to(oe.tooltip):oe.tooltip,E.Command.is(oe.command)&&(Oe.command=ye.fromInternal(oe.command)),oe.location&&(Oe.location=Q.to(oe.location)),Oe}Re.to=Fe})(we=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Re){function Fe(oe){return oe}Re.from=Fe;function ye(oe){return oe}Re.to=ye})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Fe(oe){return{range:c.from(oe.range),url:oe.target,tooltip:oe.tooltip}}Re.from=Fe;function ye(oe){let Oe;if(oe.url)try{Oe=typeof oe.url=="string"?k.URI.parse(oe.url,!0):k.URI.revive(oe.url)}catch{}return new o.DocumentLink(c.to(oe.range),Oe)}Re.to=ye})(ke=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Re){function Fe(oe){const Oe=new o.ColorPresentation(oe.label);return oe.textEdit&&(Oe.textEdit=ie.to(oe.textEdit)),oe.additionalTextEdits&&(Oe.additionalTextEdits=oe.additionalTextEdits.map(He=>ie.to(He))),Oe}Re.to=Fe;function ye(oe){return{label:oe.label,textEdit:oe.textEdit?ie.from(oe.textEdit):void 0,additionalTextEdits:oe.additionalTextEdits?oe.additionalTextEdits.map(Oe=>ie.from(Oe)):void 0}}Re.from=ye})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Re){function Fe(oe){return new o.Color(oe[0],oe[1],oe[2],oe[3])}Re.to=Fe;function ye(oe){return[oe.red,oe.green,oe.blue,oe.alpha]}Re.from=ye})(qe=e.Color||(e.Color={}));var tt;(function(Re){function Fe(oe){return{range:c.from(oe.range)}}Re.from=Fe;function ye(oe){return new o.SelectionRange(c.to(oe.range))}Re.to=ye})(tt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Fe(ye){switch(ye){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(Re){function Fe(oe){switch(oe){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function ye(oe){switch(oe){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=ye})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Re){function Fe(oe){if(oe===o.EndOfLine.CRLF)return 1;if(oe===o.EndOfLine.LF)return 0}Re.from=Fe;function ye(oe){if(oe===1)return o.EndOfLine.CRLF;if(oe===0)return o.EndOfLine.LF}Re.to=ye})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Re){function Fe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var et;(function(Re){function Fe(oe){const Oe={start:oe.start+1,end:oe.end+1};return oe.kind&&(Oe.kind=$.from(oe.kind)),Oe}Re.from=Fe;function ye(oe){const Oe={start:oe.start-1,end:oe.end-1};return oe.kind&&(Oe.kind=$.to(oe.kind)),Oe}Re.to=ye})(et=e.FoldingRange||(e.FoldingRange={}));var $;(function(Re){function Fe(oe){if(oe)switch(oe){case o.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Re.from=Fe;function ye(oe){if(oe)switch(oe.value){case E.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Re.to=ye})($=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Re){function Fe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?c.from(ye.selection):void 0,override:typeof ye.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Fe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ge;(function(Re){function Fe(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:ye(He)||oe(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Fe;function ye(He){const Ze=He;return Ze?k.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function oe(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(He){return typeof He=="string"?He:new o.RelativePattern(k.URI.revive(He.baseUri),He.pattern)}Re.to=Oe})(ge=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Re){function Fe(ye){if(ye){if(Array.isArray(ye))return ye.map(Fe);if(typeof ye=="string")return ye;{const oe=ye;return{language:oe.language,scheme:oe.scheme,pattern:ge.from(oe.pattern),exclusive:oe.exclusive,notebookType:oe.notebookType}}}else return}Re.from=Fe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Re){function Fe(oe){return{start:oe.start,end:oe.end}}Re.from=Fe;function ye(oe){return new o.NotebookRange(oe.start,oe.end)}Re.to=ye})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(Re){function Fe(oe){return{timing:typeof oe.runStartTime=="number"&&typeof oe.runEndTime=="number"?{startTime:oe.runStartTime,endTime:oe.runEndTime}:void 0,executionOrder:oe.executionOrder,success:oe.lastRunSuccess}}Re.to=Fe;function ye(oe){return{lastRunSuccess:oe.success,runStartTime:oe.timing?.startTime,runEndTime:oe.timing?.endTime,executionOrder:oe.executionOrder}}Re.from=ye})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Re){function Fe(ye){if(ye===g.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ye===g.NotebookCellExecutionState.Pending)return;if(ye===g.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Re.to=Fe})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Fe(oe){switch(oe){case o.NotebookCellKind.Markup:return g.CellKind.Markup;case o.NotebookCellKind.Code:default:return g.CellKind.Code}}Re.from=Fe;function ye(oe){switch(oe){case g.CellKind.Markup:return o.NotebookCellKind.Markup;case g.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=ye})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Re){function Fe(oe){const Oe={metadata:oe.metadata??Object.create(null),cells:[]};for(const He of oe.cells)o.NotebookCellData.validate(He),Oe.cells.push(ot.from(He));return Oe}Re.from=Fe;function ye(oe){const Oe=new o.NotebookData(oe.cells.map(ot.to));return(0,S.isEmptyObject)(oe.metadata)||(Oe.metadata=oe.metadata),Oe}Re.to=ye})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Re){function Fe(oe){return{cellKind:Xe.from(oe.kind),language:oe.languageId,mime:oe.mime,source:oe.value,metadata:oe.metadata,internalMetadata:je.from(oe.executionSummary??{}),outputs:oe.outputs?oe.outputs.map(bt.from):[]}}Re.from=Fe;function ye(oe){return new o.NotebookCellData(Xe.to(oe.cellKind),oe.source,oe.language,oe.mime,oe.outputs?oe.outputs.map(bt.to):void 0,oe.metadata,oe.internalMetadata?je.to(oe.internalMetadata):void 0)}Re.to=ye})(ot=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(Re){function Fe(oe){return{mime:oe.mime,valueBytes:A.VSBuffer.wrap(oe.data)}}Re.from=Fe;function ye(oe){return new o.NotebookCellOutputItem(oe.valueBytes.buffer,oe.mime)}Re.to=ye})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Re){function Fe(oe){return{outputId:oe.id,items:oe.items.map(pt.from),metadata:oe.metadata}}Re.from=Fe;function ye(oe){const Oe=oe.items.map(pt.to);return new o.NotebookCellOutput(Oe,oe.outputId,oe.metadata)}Re.to=ye})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var St;(function(Re){function Fe(Oe){return oe(Oe)?{include:(0,S.withNullAsUndefined)(ge.from(Oe.include)),exclude:(0,S.withNullAsUndefined)(ge.from(Oe.exclude))}:(0,S.withNullAsUndefined)(ge.from(Oe))}Re.from=Fe;function ye(Oe){return oe(Oe)?{include:ge.to(Oe.include),exclude:ge.to(Oe.exclude)}:ge.to(Oe)}Re.to=ye;function oe(Oe){const He=Oe;return He?!(0,S.isUndefinedOrNull)(He.include)&&!(0,S.isUndefinedOrNull)(He.exclude):!1}})(St=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pt;(function(Re){function Fe(ye,oe,Oe){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:oe.toInternal(He,Oe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Re.from=Fe})(Pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var $t;(function(Re){function Fe(ye,oe,Oe){const He=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:oe.toInternal(He,Oe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Re.from=Fe})($t=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Re){function Fe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Re.from=Fe})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ft;(function(Re){function Fe(oe){return{uri:oe.uri,provides:oe.provides}}Re.from=Fe;function ye(oe){return new o.NotebookRendererScript(k.URI.revive(oe.uri),oe.provides)}Re.to=ye})(ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(Re){function Fe(oe){return{message:_.fromStrict(oe.message)||"",type:0,expected:oe.expectedOutput,actual:oe.actualOutput,location:oe.location&&{range:c.from(oe.location.range),uri:oe.location.uri}}}Re.from=Fe;function ye(oe){const Oe=new o.TestMessage(typeof oe.message=="string"?oe.message:_.to(oe.message));return Oe.actualOutput=oe.actual,Oe.expectedOutput=oe.expected,Oe.location=oe.location?Q.to(oe.location):void 0,Oe}Re.to=ye})(vt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Re){Re.namespace=p.namespaceTestTag,Re.denamespace=p.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Re){function Fe(oe){const Oe=(0,d.getPrivateApiFor)(oe).controllerId;return{extId:D.TestId.fromExtHostTestItem(oe,Oe).toString(),label:oe.label,uri:k.URI.revive(oe.uri),busy:oe.busy,tags:oe.tags.map(He=>Ot.namespace(Oe,He.id)),range:C.Range.lift(c.from(oe.range)),description:oe.description||null,sortText:oe.sortText||null,error:oe.error&&_.fromStrict(oe.error)||null}}Re.from=Fe;function ye(oe){return{parent:void 0,error:void 0,id:D.TestId.fromString(oe.extId).localId,label:oe.label,uri:k.URI.revive(oe.uri),tags:(oe.tags||[]).map(Oe=>{const{tagId:He}=Ot.denamespace(Oe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(oe.range||void 0),canResolveChildren:!1,busy:oe.busy,description:oe.description||void 0,sortText:oe.sortText||void 0}}Re.toPlain=ye})(Ut=e.TestItem||(e.TestItem={})),function(Re){function Fe(oe){return{id:oe.id}}Re.from=Fe;function ye(oe){return new o.TestTag(oe.id)}Re.to=ye}(Ot=e.TestTag||(e.TestTag={}));var Nt;(function(Re){const Fe=(oe,Oe)=>{const He=[];for(const[Ge,ct]of Oe)D.TestId.compare(ct.item.extId,Ge)===2&&(Oe.delete(Ge),He.push(ct));const Ze={...Ut.toPlain(oe.item),parent:void 0,taskStates:oe.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(vt.to)})),children:He.map(Ge=>Fe(Ge,Oe))};for(const Ge of Ze.children)Ge.parent=Ze;return Ze};function ye(oe){const Oe=[],He=new Map;for(const Ze of oe.items){He.set(Ze.item.extId,Ze);const Ge=D.TestId.root(Ze.item.extId);oe.request.targets.some(ct=>ct.controllerId===Ge&&ct.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:oe.completedAt,results:Oe.map(Ze=>Fe(Ze,He))}}Re.to=ye})(Nt=e.TestResults||(e.TestResults={}));var wt;(function(Re){function Fe(He){return{covered:He.covered,total:He.covered}}function ye(He){return"line"in He?v.from(He):c.from(He)}function oe(He){return"branches"in He?{count:He.executionCount,location:ye(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ye(Ze.location)})):void 0}:{type:0,count:He.executionCount,location:ye(He.location)}}Re.fromDetailed=oe;function Oe(He){return{uri:He.uri,statement:Fe(He.statementCoverage),branch:He.branchCoverage&&Fe(He.branchCoverage),function:He.functionCoverage&&Fe(He.functionCoverage),details:He.detailedCoverage?.map(oe)}}Re.fromFile=Oe})(wt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Re){function Fe(ye){switch(ye){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Fe})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(Re){function Fe(oe){const Oe=new o.TypeHierarchyItem(J.to(oe.kind),oe.name,oe.detail||"",k.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Oe._sessionId=oe._sessionId,Oe._itemId=oe._itemId,Oe}Re.to=Fe;function ye(oe,Oe,He){if(Oe=Oe??oe._sessionId,He=He??oe._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,kind:J.from(oe.kind),name:oe.name,detail:oe.detail??"",uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(re.from)}}Re.from=ye})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Fe(ye){if(!!ye)return{value:ye.value,tooltip:ye.tooltip}}Re.from=Fe})(Bt=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Re){function Fe(He,Ze,Ge){const ct=Ze.fileData;return ct?new class extends o.DataTransferItem{asFile(){return{name:ct.name,uri:k.URI.revive(ct.uri),data:(0,R.once)(()=>Ge())}}}("",Ze.id):He===L.Mimes.uriList&&Ze.uriListData?new o.DataTransferItem(Oe(Ze.uriListData)):new o.DataTransferItem(Ze.asString)}Re.to=Fe;async function ye(He,Ze){const Ge=await Ze.asString();if(He===L.Mimes.uriList)return{id:Ze.id,asString:Ge,fileData:void 0,uriListData:oe(Ge)};const ct=Ze.asFile();return{id:Ze.id,asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}}Re.from=ye;function oe(He){return u.UriList.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return k.URI.parse(Ze)}catch{}return Ze})}function Oe(He){return u.UriList.create(He.map(Ze=>typeof Ze=="string"?Ze:k.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Re){function Fe(oe,Oe){const He=oe.items.map(([Ze,Ge])=>[Ze,Ke.to(Ze,Ge,()=>Oe(Ge.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Fe;async function ye(oe){const Oe={items:[]},He=[];return oe.forEach((Ze,Ge)=>{He.push((async()=>{Oe.items.push([Ge,await Ke.from(Ge,Ze)])})())}),await Promise.all(He),Oe}Re.toDataTransferDTO=ye})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[244],Ie([1,0,2,10,7,13,66]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(m,L,I,S={timeout:1500,errors:3}){this.c=m,this.d=L,this.f=I,this.g=S,this.a=new P.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(L,I,S)=>{const C={dispose:this.a.push([L,I,m])};return Array.isArray(S)&&S.push(C),C}}async $participateInSave(m,L){const I=a.URI.revive(m);let S=!1;const k=setTimeout(()=>S=!0,this.g.timeout),C=[];try{for(const E of[...this.a]){if(S)break;const r=this.d.getDocument(I),d=await this.h(E,{document:r,reason:R.TextDocumentSaveReason.to(L)});C.push(d)}}finally{clearTimeout(k)}return C}h([m,L,I],S){const k=this.b.get(m);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,m,L,S).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const E=this.b.get(m);this.b.set(m,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,L,I,S){const k=[],C=Date.now(),{document:E,reason:r}=S,{version:d}=E,f=Object.freeze({document:E,reason:r,waitUntil(g){if(Object.isFrozen(k))throw(0,A.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(g))}});try{L.apply(I,[f])}catch(g){return Promise.reject(g)}return Object.freeze(k),new Promise((g,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(p),g(t)}).catch(t=>{clearTimeout(p),D(t)})}).then(g=>{const D={edits:[]};for(const p of g)if(Array.isArray(p)&&p.every(t=>t instanceof u.TextEdit))for(const{newText:t,newEol:o,range:s}of p)D.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:t,eol:o&&R.EndOfLine.from(o)}});if(D.edits.length!==0)return d===E.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Ce[245],Ie([1,0,18,2,13,7,94]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(I,S,k,C){this.start=I,this.deletedCount=S,this.deletedItems=k,this.items=C}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(I,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,S,k){this.notebook=I,this.h=S,this.j=k,this.handle=k.handle,this.uri=A.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(u.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,S=this.h.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:S.document,get mime(){return I.g},set mime(C){I.g=C},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(u.NotebookCellOutput.to)}setOutputItems(I,S,k){const C=k.map(u.NotebookCellOutputItem.to),E=this.a.find(r=>r.id===I);if(E&&(S||(E.items.length=0),E.items.push(...C),E.items.length>1&&E.items.every(r=>P.isTextStreamMime(r.mime)))){const r=new Map,d=[];E.items.forEach(f=>{let g;r.has(f.mime)?g=r.get(f.mime):(g=[],r.set(f.mime,g),d.push(f.mime)),g.push(f.data)}),E.items.length=0,d.forEach(f=>{const g=P.compressOutputItemStreams(r.get(f));E.items.push({mime:f,data:g.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=y;class m{constructor(I,S,k,C,E){this.k=I,this.l=S,this.m=k,this.uri=C,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const I=this,S={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===a.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(E=>E.apiCell)},save(){return I.q()}};this.e=Object.freeze(S)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,S,k){this.g=I.versionId,this.h=S,this.acceptDocumentPropertiesChanged({metadata:k});const C={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},E=[];for(const d of I.rawEvents)d.kind===P.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,C.contentChanges):d.kind===P.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,C.contentChanges):d.kind===P.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===P.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),E.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),E.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const r=new Map;for(let d=0;d<E.length;d++){const f=E[d],g=r.get(f.cell);if(g===void 0){const D=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});r.set(f.cell,D-1)}else C.cellChanges[g]={...C.cellChanges[g],...f}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let S=I.start|0,k=I.end|0;return S<0&&(S=0),k>this.b.length&&(k=this.b.length),I.with({start:S,end:k})}p(I){I=this.o(I);const S=[];for(let k=I.start;k<I.end;k++)S.push(this.b[k]);return S}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,S,k){if(this.j)return;const C=[],E=[],r=[];if(I.reverse().forEach(d=>{const g=d[2].map(t=>{const o=new y(this,this.l,t);return S||E.push(y.asModelAddData(this.apiNotebook,t)),o}),D=new T(d[0],d[1],[],g),p=this.b.splice(d[0],d[1],...g);for(const t of p)r.push(t.uri),D.deletedItems.push(t.apiCell);C.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:r}),k)for(const d of C)k.push(d.asApiEvent())}s(I,S,k,C){const E=this.b.splice(I,S);this.b.splice(k,0,...E);const r=[new T(I,S,E.map(d=>d.apiCell),[]),new T(k,0,[],E)];for(const d of r)C.push(d.asApiEvent())}t(I,S){this.b[I].setOutputs(S)}u(I,S,k,C){this.b[I].setOutputItems(S,k,C)}v(I,S){const k=this.b[I];k.apiCell.document.languageId!==S&&this.m.$acceptModelLanguageChanged(k.uri,S)}w(I,S){const k=this.b[I];k.apiCell.mime=S}x(I,S){this.b[I].setMetadata(S)}y(I,S){this.b[I].setInternalMetadata(S)}getCellFromApiCell(I){return this.b.find(S=>S.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(S=>S.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}m.a=0,e.ExtHostNotebookDocument=m}),define(Ce[137],Ie([1,0,10,13,7]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(T,y,m,L,I,S){this.id=T,this.f=y,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=L,this.c=S}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(y){this.selections=[y]},get selections(){return T.a},set selections(y){if(!Array.isArray(y)||!y.every(u.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=y,T.g(y)},get visibleRanges(){return T.b},revealRange(y,m){T.f.$tryRevealRange(T.id,A.NotebookRange.from(y),m??u.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(A.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(Ce[246],Ie([1,0,3,16,13]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(T,y){this.c=T,this.d=y,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,y);const m=this.d.getEditorById(T);y.visibleRanges&&m._acceptVisibleRanges(y.visibleRanges.ranges.map(u.NotebookRange.to)),y.selections&&m._acceptSelections(y.selections.selections.map(u.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const y in T)this.d.getEditorById(y)._acceptViewColumn(u.ViewColumn.to(T[y]))}};R=Ve([We(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(Ce[247],Ie([1,0,13,126,183,21,62,10]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,k,C){const E=this.b++,{title:r,location:d,cancellable:f}=k,g={label:(0,u.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this.a.$startProgress(E,{location:a.ProgressLocation.from(d),title:r,source:g,cancellable:f},S.isUnderDevelopment?void 0:S.identifier.value).catch(T.onUnexpectedExternalError),this.d(E,C,!!f)}d(S,k,C){let E;C&&(E=new R.CancellationTokenSource,this.c.set(S,E));const r=f=>{this.a.$progressEnd(f),this.c.delete(f),E?.dispose()};let d;try{d=k(new L(this.a,S),C&&E?E.token:R.CancellationToken.None)}catch(f){throw r(S),f}return d.then(f=>r(S),f=>r(S)),d}$acceptProgressCanceled(S){const k=this.c.get(S);k&&(k.cancel(),this.c.delete(S))}}e.ExtHostProgress=y;function m(I,S){return I.message=S.message,typeof S.increment=="number"&&(typeof I.increment=="number"?I.increment+=S.increment:I.increment=S.increment),I}class L extends A.Progress{constructor(S,k){super(C=>this.throttledReport(C)),this.c=S,this.d=k}throttledReport(S){this.c.$progressReport(this.d,S)}}Ve([(0,P.throttle)(100,(I,S)=>m(I,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ce[138],Ie([1,0,32,133,57,95,76,13,2]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(g,D,p,t)=>{let o=D;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!p(o,s)){const c=o;o=s,g.listener?.(t(s,c))}}}},L=(g,D)=>g===D,I={range:(g,D)=>g===D?!0:!g||!D?!1:g.isEqual(D),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(g,D)=>!(g.length!==D.length||g.some(p=>!D.find(t=>p.id===t.id)))},S=g=>D=>({op:4,update:g(D)}),k=(g,D)=>({range:(()=>{let p;const t=S(o=>({range:a.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){g.listener?.({op:6}),I.range(p,o)||(p=o,g.listener?.(t(o)))}}})(),label:m(g,D,I.label,S(p=>({label:p}))),description:m(g,void 0,I.description,S(p=>({description:p}))),sortText:m(g,void 0,I.sortText,S(p=>({sortText:p}))),canResolveChildren:m(g,!1,I.canResolveChildren,p=>({op:2,state:p})),busy:m(g,!1,I.busy,S(p=>({busy:p}))),error:m(g,void 0,I.error,S(p=>({error:T.MarkdownString.fromStrict(p)||null}))),tags:m(g,[],I.tags,(p,t)=>({op:1,new:p.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),C=g=>{const D=u.TestId.fromString(g.extId),p=new r(D.controllerId,D.localId,g.label,y.URI.revive(g.uri)||void 0);return p.range=T.Range.to(g.range||void 0),p.description=g.description||void 0,p.sortText=g.sortText||void 0,p.tags=g.tags.map(t=>T.TestTag.to({id:(0,P.denamespaceTestTag)(t).tagId})),p},E=g=>{let D;for(const p of g.tests){const t=C(p.item);(0,A.getPrivateApiFor)(t).parent=D,D=t}return D};e.toItemFromContext=E;class r{constructor(D,p,t,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,A.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof d?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,r),enumerable:!0,writable:!1},...k(s,t)})}}e.TestItemImpl=r;class d extends r{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class f extends R.TestItemCollection{constructor(D,p,t){super({controllerId:D,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new d(D,p),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=f}),define(Ce[139],Ie([1,0,51,10,102,13,7]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(S,k,C){const E=T.c.nextId();S.$registerTextEditorDecorationType(k.identifier,E,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:E,dispose(){S.$removeTextEditorDecorationType(E)}})}}T.c=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=T;class y{constructor(S,k){this.g=[],this.h=void 0,this.j=!1,this.c=S,this.d=S.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(S,k){this.k();let C=null;if(S instanceof P.Position)C=new P.Range(S,S);else if(S instanceof P.Range)C=S;else throw new Error("Unrecognized location");this.l(C,k,!1)}insert(S,k){this.k(),this.l(new P.Range(S,S),k,!0)}delete(S){this.k();let k=null;if(S instanceof P.Range)k=S;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(S,k,C){const E=this.c.validateRange(S);this.g.push({range:E,text:k,forceMoveMarkers:C})}setEndOfLine(S){if(this.k(),S!==P.EndOfLine.LF&&S!==P.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=S}}class m{constructor(S,k,C,E){this.c=S,this.d=k,this._accept(C),this.e=E;const r=this;this.value={get tabSize(){return r.f},set tabSize(d){r.m(d)},get indentSize(){return r.g},set indentSize(d){r.o(d)},get insertSpaces(){return r.h},set insertSpaces(d){r.q(d)},get cursorStyle(){return r.j},set cursorStyle(d){r.s(d)},get lineNumbers(){return r.k},set lineNumbers(d){r.t(d)}}}_accept(S){this.f=S.tabSize,this.g=S.indentSize,this.h=S.insertSpaces,this.j=S.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(S.lineNumbers)}l(S){if(S==="auto")return"auto";if(typeof S=="number"){const k=Math.floor(S);return k>0?k:null}if(typeof S=="string"){const k=parseInt(S,10);return isNaN(k)?null:k>0?k:null}return null}m(S){const k=this.l(S);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(S){if(S==="tabSize")return"tabSize";if(typeof S=="number"){const k=Math.floor(S);return k>0?k:null}if(typeof S=="string"){const k=parseInt(S,10);return isNaN(k)?null:k>0?k:null}return null}o(S){const k=this.n(S);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}q(S){const k=this.p(S);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(S){this.j!==S&&(this.j=S,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:S})))}t(S){this.k!==S&&(this.k=S,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(S)})))}assign(S){const k={};let C=!1;if(typeof S.tabSize<"u"){const E=this.l(S.tabSize);E==="auto"?(C=!0,k.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,C=!0,k.tabSize=E)}if(typeof S.indentSize<"u"){const E=this.n(S.indentSize);E==="tabSize"?(C=!0,k.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,C=!0,k.indentSize=E)}if(typeof S.insertSpaces<"u"){const E=this.p(S.insertSpaces);E==="auto"?(C=!0,k.insertSpaces=E):this.h!==E&&(this.h=E,C=!0,k.insertSpaces=E)}typeof S.cursorStyle<"u"&&this.j!==S.cursorStyle&&(this.j=S.cursorStyle,C=!0,k.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this.k!==S.lineNumbers&&(this.k=S.lineNumbers,C=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(S.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(S,k){k.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this.e.warn(C)})}}e.ExtHostTextEditorOptions=m;class L{constructor(S,k,C,E,r,d,f,g){this.id=S,this.j=k,this.k=C,this.g=!1,this.h=new Set,this.c=r,this.d=new m(this.j,this.id,d,C),this.e=f,this.f=g;const D=this;this.value=Object.freeze({get document(){return E.value},set document(p){throw(0,A.readonly)("document")},get selection(){return D.c&&D.c[0]},set selection(p){if(!(p instanceof P.Selection))throw(0,A.illegalArgument)("selection");D.c=[p],D.l()},get selections(){return D.c},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof P.Selection)))throw(0,A.illegalArgument)("selections");D.c=p,D.l()},get visibleRanges(){return D.e},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return D.d.value},set options(p){D.g||D.d.assign(p)},get viewColumn(){return D.f},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new y(E.value,t);return p(o),D.m(o)},insertSnippet(p,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=D.c.map(c=>R.Range.from(c));else if(t instanceof P.Position){const{lineNumber:c,column:l}=R.Position.from(t);s=[{startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l}]}else if(t instanceof P.Range)s=[R.Range.from(t)];else{s=[];for(const c of t)if(c instanceof P.Range)s.push(R.Range.from(c));else{const{lineNumber:l,column:v}=R.Position.from(c);s.push({startLineNumber:l,startColumn:v,endLineNumber:l,endColumn:v})}}return k.$tryInsertSnippet(S,E.value.version,p.value,s,o)},setDecorations(p,t){const o=t.length===0;o&&!D.h.has(p.key)||(o?D.h.delete(p.key):D.h.add(p.key),D.n(()=>{if(R.isDecorationOptionsArr(t))return k.$trySetDecorations(S,p.key,R.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let c=0,l=t.length;c<l;c++){const v=t[c];s[4*c]=v.start.line+1,s[4*c+1]=v.start.character+1,s[4*c+2]=v.end.line+1,s[4*c+3]=v.end.character+1}return k.$trySetDecorationsFast(S,p.key,s)}}))},revealRange(p,t){D.n(()=>k.$tryRevealRange(S,R.Range.from(p),t||P.TextEditorRevealType.Default))},show(p){k.$tryShowEditor(S,R.ViewColumn.from(p))},hide(){k.$tryHideEditor(S)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(S){(0,a.ok)(!this.g),this.d._accept(S)}_acceptVisibleRanges(S){(0,a.ok)(!this.g),this.e=S}_acceptViewColumn(S){(0,a.ok)(!this.g),this.f=S}_acceptSelections(S){(0,a.ok)(!this.g),this.c=S}async l(){const S=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,S)),this.value}m(S){const k=S.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const C=k.edits.map(r=>r.range);C.sort((r,d)=>r.end.line===d.end.line?r.end.character===d.end.character?r.start.line===d.start.line?r.start.character-d.start.character:r.start.line-d.start.line:r.end.character-d.end.character:r.end.line-d.end.line);for(let r=0,d=C.length-1;r<d;r++){const f=C[r].end;if(C[r+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=k.edits.map(r=>({range:R.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,E,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(S){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.ExtHostTextEditor=L}),define(Ce[248],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[249],Ie([1,0,199,10,37,123,93,39,25,248,212,129]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=T.Registry.as(P.Extensions.JSONContribution);class k{constructor(p,t,o){this.a=p,this.b=t,this.c=o}d(p,t){this.a({type:p,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(u.default.Error,p)}warn(p){this.d(u.default.Warning,p)}info(p){this.d(u.default.Info,p)}}e.ExtensionMessageCollector=k;class C{static a(p){const t=new y.ExtensionIdentifierSet;for(let o=0,s=p.length;o<s;o++)t.add(p[o].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new C(t,[]);if(!t||!t.length)return new C([],p);const o=this.a(p),s=this.a(t),c=t.filter(v=>!o.has(v.description.identifier)),l=p.filter(v=>!s.has(v.description.identifier));return new C(c,l)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=C;class E{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=C.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=E;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class f{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new E(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,t),p.activationEventsGenerator&&I.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,S.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=f;const g={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(g.ExtensionsRegistry,new f),e.ExtensionsRegistry=T.Registry.as(g.ExtensionsRegistry),S.registerSchema(d,e.schema),S.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Ce[250],Ie([1,0,196,9,23,249,44,3]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var m;(function(S){function k(C,E,r){if(!C)return;const d=A.isString(C.type)?C.type:void 0;if(!d||d.length===0){r.error(a.localize(3,null));return}const f=[];if(Array.isArray(C.required))for(const g of C.required)A.isString(g)&&f.push(g);return{extensionId:E.value,taskType:d,required:f,properties:C.properties?u.deepClone(C.properties):{},when:C.when?P.ContextKeyExpr.deserialize(C.when):void 0}}S.from=k})(m||(m={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(S,k)=>{for(const C of S)C.type&&k.push(`onTaskType:${C.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:y}});class I{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,C)=>{L.setHandler((E,r)=>{this.c=void 0;try{for(const d of r.removed){const f=d.value;for(const g of f)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const d of r.added){const f=d.value;for(const g of f){const D=m.from(g,d.description.identifier,d.collector);D&&(this.a[D.taskType]=D)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const C of this.all()){const E={type:"object",additionalProperties:!1};C.required.length>0&&(E.required=C.required.slice(0)),C.properties!==void 0?E.properties=u.deepClone(C.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[C.taskType]},k.push(E)}this.c={oneOf:k}}return this.c}}e.TaskDefinitionRegistry=new I}),define(Ce[251],Ie([1,0,197,9,24,23,44,250]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new P.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var y;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(M){function B(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=B}(y=e.ShellQuoting||(e.ShellQuoting={}));var m;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(m=e.CommandOptions||(e.CommandOptions={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=B}(L=e.RevealKind||(e.RevealKind={}));var I;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=B}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(M){function B(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=B}(S=e.PanelKind||(e.PanelKind={}));var k;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var C;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(C=e.RuntimeType||(e.RuntimeType={})),function(M){function B(j){switch(j.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=B;function U(j){switch(j){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(C=e.RuntimeType||(e.RuntimeType={}));var E;(function(M){function B(U){return A.isString(U)?U:U.value}M.value=B})(E=e.CommandString||(e.CommandString={}));var r;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function B(j){return j===M.Clean._id||j===M.Build._id||j===M.Rebuild._id||j===M.Test._id}M.is=B;function U(j){if(j!==void 0)return A.isString(j)?B(j)?{_id:j,isDefault:!1}:void 0:j}M.from=U})(r=e.TaskGroup||(e.TaskGroup={}));var d;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var f;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function B(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=B})(f=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(M){M.parallel="parallel",M.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var D;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(D=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class t{constructor(B,U,j,he,ie,V){this._label="",this._id=B,U&&(this._label=U),j&&(this.type=j),this.runOptions=he,this.configurationProperties=ie,this._source=V}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,U=!1){if(B===void 0)return!1;if(A.isString(B))return B===this._label||B===this.configurationProperties.identifier||U&&B===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class o extends t{constructor(B,U,j,he,ie,V,J,re){super(B,j,void 0,J,re,U),this.command={},this._source=U,this.hasDefinedMatchers=V,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case C.Shell:U="shell";break;case C.Process:U="process";break;case C.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class s extends t{constructor(B,U,j,he,ie,V,J){super(B,j,he,V,J,U),this._source=U,this.configures=ie}static is(B){return B instanceof s}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}}e.ConfiguringTask=s;class c extends t{constructor(B,U,j,he,ie,V,J,re,ve){super(B,j,he,re,ve,U),this.defines=ie,this.hasDefinedMatchers=J,this.command=V,this.icon=ve.icon,this.hide=ve.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof c}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new c(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=c;class l extends t{constructor(B,U,j,he,ie,V){super(B,j,he,ie,V,U),this._source=U}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var v;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(v=e.ExecutionEngine||(e.ExecutionEngine={})),function(M){M._default=M.Terminal}(v=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(B){this.c=new Map;for(let U=0;U<B.length;U++)this.c.set(B[U].uri.toString(),U)}compare(B,U){const j=B.getWorkspaceFolder(),he=U.getWorkspaceFolder();if(j&&he){let ie=this.c.get(j.uri.toString());ie=ie===void 0?0:ie+1;let V=this.c.get(he.uri.toString());return V=V===void 0?0:V+1,ie===V?B._label.localeCompare(U._label):ie-V}else return!j&&he?-1:j&&!he?1:0}}e.TaskSorter=n;var h;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(M){M.SingleRun="singleRun",M.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var b;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(b=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(M){function B(U,j,he,ie){if(j){const V={kind:U,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:j};return U==="start"?V.resolvedVariables=ie:U==="processStarted"?V.processId=ie:U==="processEnded"&&(V.exitCode=ie),Object.freeze(V)}else return Object.freeze({kind:"changed"})}M.create=B})(O=e.TaskEvent||(e.TaskEvent={}));var H;(function(M){function B(j){const he=Object.keys(j).sort();let ie="";for(const V of he){let J=j[V];J instanceof Object?J=B(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ie+=V+","+J+","}return ie}function U(j){const ie={_key:B(j),type:j.taskType};return Object.assign(ie,j),ie}M.create=U})(H=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var _;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(_=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var G;(function(M){function B(U,j){const he=T.TaskDefinitionRegistry.get(U.type);if(he===void 0){const re=R.deepClone(U);return delete re._key,H.create(re)}const ie=Object.create(null);ie.type=he.taskType;const V=new Set;he.required.forEach(re=>V.add(re));const J=he.properties;for(const re of Object.keys(J)){const ve=U[re];if(ve!=null)ie[re]=ve;else if(V.has(re)){const ue=J[re];if(ue.default!==void 0)ie[re]=R.deepClone(ue.default);else switch(ue.type){case"boolean":ie[re]=!1;break;case"number":case"integer":ie[re]=0;break;case"string":ie[re]="";break;default:j.error(a.localize(2,null,JSON.stringify(U,void 0,0),re));return}}}return H.create(ie)}M.createTaskIdentifier=B})(G=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[252],Ie([1,0,10]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,T)=>{this.b=P,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,a.onUnexpectedError)(P))}then(P,T){return this.j().then(P,T)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.LazyPromise=A;class u extends A{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=u}),define(Ce[58],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const A=[];function u(T){const y=new a(T);return A[y.nid]=y,y}e.createProxyIdentifier=u;function R(T){return A[T].sid}e.getStringIdentifierForProxy=R;class P{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=P}),define(Ce[5],Ie([1,0,58]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var R;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var m;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(m=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(r){return r._id=I.a++,r}}I.a=0,e.IdObject=I;var S;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var C;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,a.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,a.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,a.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,a.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[78],Ie([1,0,4,16,5,20]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(y,m){this.c=m,this.a=new Set,this.b=y.getProxy(u.MainContext.MainThreadTelemetry)}report(y,m,L){const I=this.d(y,m);this.a.has(I)||(this.a.add(I),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}d(y,m){return`${y}-${m.identifier.value}`}};P=Ve([We(0,R.IExtHostRpcService),We(1,A.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(T,y,m){}})}),define(Ce[253],Ie([1,0,3,5,7,25]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(y){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,m,L,I={}){const S=R.ExtensionIdentifier.toKey(y.identifier),k=this.f.get(S)||[],C=[...L].sort().join(" ");let E=k.find(r=>r.providerId===m&&r.scopes===C);if(E)return E.result;{const r=this.g(y,S,m,L,I);E={providerId:m,scopes:C,result:r},k.push(E),this.f.set(S,k);try{await r}finally{const d=k.findIndex(f=>f.providerId===m&&f.scopes===C);d>-1&&(k.splice(d),this.f.set(S,k))}return r}}async g(y,m,L,I,S={}){await this.a.$ensureProvider(L);const k=y.displayName||y.name;return this.a.$getSession(L,I,m,k,S)}async removeSession(y,m){const L=this.b.get(y);return L?L.provider.removeSession(m):this.a.$removeSession(y,m)}registerAuthenticationProvider(y,m,L,I){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:m,provider:L,options:I??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:m});const S=L.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,m,I?.supportsMultipleAccounts??!1),new u.Disposable(()=>{S.dispose(),this.b.delete(y);const k=this.c.findIndex(C=>C.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,m){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(m));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,m){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(m));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,m){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(m));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,m){return this.d.fire({provider:{id:y,label:m}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(Ce[254],Ie([1,0,5,20,13]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(T,y){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,y,m){const L=u.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,m?.isRefactoring??!1)}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(Ce[255],Ie([1,0,5]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const P=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(T){return P.$writeText(T)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[40],Ie([1,0,9,7,13,23,5,17,16,70,32,53,2,6,4,20,138,22,58,46,43,74,77]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t){"use strict";var o,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(b,O,H){o.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),c.set(this,void 0),Je(this,o,b.getProxy(P.MainContext.MainThreadCommands),"f"),this.d=O,Je(this,c,H,"f"),Je(this,s,b.getProxy(P.MainContext.MainThreadTelemetry),"f"),this.converter=new v(this,x=>{const _=this.c.get(x);return _?.result===n.Void?_:void 0},O),this.f=[{processArgument(x){return(0,m.revive)(x)}},{processArgument(x){return(0,R.cloneAndChange)(x,function(_){if(L.Range.isIRange(_))return u.Range.to(_);if(I.Position.isIPosition(_))return u.Position.to(_);if(L.Range.isIRange(_.range)&&S.URI.isUri(_.uri))return u.location.to(_);if(_ instanceof d.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const O=this.registerCommand(!1,b.id,async(...H)=>{const x=b.args.map((G,M)=>{if(!G.validate(H[M]))throw new Error(`Invalid argument '${G.name}' when running '${b.id}', received: ${H[M]}`);return G.convert(H[M])}),_=await this.executeCommand(b.internalId,...x);return b.result.convert(_,H,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new A.Disposable(()=>{O.dispose(),this.c.delete(b.id)})}registerCommand(b,O,H,x,_,G){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:H,thisArg:x,description:_,extension:G}),b&&Me(this,o,"f").$registerCommand(O),new A.Disposable(()=>{this.b.delete(O)&&b&&Me(this,o,"f").$unregisterCommand(O)})}executeCommand(b,...O){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,O,!0)}async g(b,O,H){if(this.b.has(b))return Me(this,o,"f").$fireCommandActivationEvent(b),this.h(b,O,!1);{let x=!1;const _=(0,R.cloneAndChange)(O,function(G){if(G instanceof A.Position)return u.Position.from(G);if(G instanceof A.Range)return u.Range.from(G);if(G instanceof A.Location)return u.location.from(G);if(A.NotebookRange.isNotebookRange(G))return u.NotebookRange.from(G);if(G instanceof ArrayBuffer)return x=!0,d.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return x=!0,d.VSBuffer.wrap(G);if(G instanceof d.VSBuffer)return x=!0,G;if(!Array.isArray(G))return G});try{const G=await Me(this,o,"f").$executeCommand(b,x?new f.SerializableObjectWithBuffers(_):_,H);return(0,m.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(b,O,!1);throw G}}}async h(b,O,H){const x=this.b.get(b);if(!x)throw new Error("Unknown command");const{callback:_,thisArg:G,description:M}=x;if(M)for(let U=0;U<M.args.length;U++)try{(0,a.validateConstraint)(O[U],M.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${M.args[U].name}' - ${M.args[U].description}`)}const B=D.StopWatch.create();try{return await _.apply(G,O)}catch(U){if(b===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...O);j&&(b=j.command)}if(this.d.error(U,b,x.extension?.identifier),!H)throw U;if(x.extension?.identifier){const j=Me(this,c,"f").onExtensionError(x.extension.identifier,U);this.d.trace("forwarded error to extension?",j,x.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.toErrorMessage)(U)),this.id=b,this.source=x.extension?.displayName??x.extension?.name}}}finally{this.j(x,b,B.elapsed())}}j(b,O,H){!b.extension||Me(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new p.TelemetryTrustedValue(O),duration:H})}$executeContributedCommand(b,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const H=this.b.get(b);return H?(O=O.map(x=>this.f.reduce((_,G)=>G.processArgument(_,H.extension?.identifier),x)),this.h(b,O,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),Me(this,o,"f").$getCommands().then(O=>(b&&(O=O.filter(H=>H[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const b=Object.create(null);for(const[O,H]of this.b){const{description:x}=H;x&&(b[O]=x)}return Promise.resolve(b)}};o=new WeakMap,s=new WeakMap,c=new WeakMap,l=Ve([We(0,E.IExtHostRpcService),We(1,y.ILogService),We(2,t.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class v{constructor(b,O,H){this.d=b,this.f=O,this.g=H,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,O){if(!b)return;const H={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return H;const x=this.f(b.command);if(x)H.id=x.internalId,H.arguments=x.args.map((_,G)=>_.convert(b.arguments&&b.arguments[G]));else if((0,T.isNonEmptyArray)(b.arguments)){const _=`${b.command}/${++this.c}`;this.b.set(_,b),O.add((0,k.toDisposable)(()=>{this.b.delete(_),this.g.trace("CommandsConverter#DISPOSE",_)})),H.$ident=_,H.id=this.delegatingCommandId,H.arguments=[_],this.g.trace("CommandsConverter#CREATE",b.command,_)}return H}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const O=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.CommandsConverter=v;class i{constructor(b,O,H,x){this.name=b,this.description=O,this.validate=H,this.convert=x}optional(){return new i(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,O){return new i(b??this.name,O??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",w=>S.URI.isUri(w),w=>w),i.Position=new i("position","A position in a text document",w=>A.Position.isPosition(w),u.Position.from),i.Range=new i("range","A range in a text document",w=>A.Range.isRange(w),u.Range.from),i.Selection=new i("selection","A selection in a text document",w=>A.Selection.isSelection(w),u.Selection.from),i.Number=new i("number","",w=>typeof w=="number",w=>w),i.String=new i("string","",w=>typeof w=="string",w=>w),i.CallHierarchyItem=new i("item","A call hierarchy item",w=>w instanceof A.CallHierarchyItem,u.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",w=>w instanceof A.TypeHierarchyItem,u.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",w=>w instanceof r.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=i;class n{constructor(b,O){this.description=b,this.convert=O}}n.Void=new n("no result",w=>w),e.ApiCommandResult=n;class h{constructor(b,O,H,x,_){this.id=b,this.internalId=O,this.description=H,this.args=x,this.result=_}}e.ApiCommand=h}),define(Ce[256],Ie([1,0,17,18,2,72,121,44,125,40,13,7]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(L.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,d)=>{if((0,a.isFalsyOrEmpty)(r))return;class f extends I.SymbolInformation{static to(D){const p=new f(D.name,L.SymbolKind.to(D.kind),D.containerName||"",new I.Location(d[0],L.Range.to(D.range)));return p.detail=D.detail,p.range=p.location.range,p.selectionRange=L.Range.to(D.selectionRange),p.children=D.children?D.children.map(f.to):[],p}}return r.map(f.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(L.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(L.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(d=>I.Position.isPosition(d)),r=>r.map(L.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(d=>{let f;for(const g of d.reverse())f=new I.SelectionRange(L.Range.to(g),f);return f}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(L.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(L.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(L.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(L.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:L.Range.to(r.range),placeholder:r.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return L.WorkspaceEdit.to(r)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(L.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,P.decodeSemanticTokensDto)(r);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,P.decodeSemanticTokensDto)(r);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,d,f)=>{if(!r)return new I.CompletionList([]);const g=r.suggestions.map(D=>L.CompletionItem.to(D,f));return new I.CompletionList(g,r.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return L.SignatureHelp.to(r)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,d,f)=>C(g=>new I.CodeLens(L.Range.to(g.range),g.command&&f.fromInternal(g.command)))(r))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.Range.isRange(r),r=>I.Selection.isSelection(r)?L.Selection.from(r):L.Range.from(r)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,d,f)=>C(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(g.command)}else{const D=new I.CodeAction(g.title,g.kind?new I.CodeActionKind(g.kind):void 0);return g.edit&&(D.edit=L.WorkspaceEdit.to(g.edit)),g.command&&(D.command=f.fromInternal(g.command)),D.isPreferred=g.isPreferred,D}})(r))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(d=>new I.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",r=>r instanceof I.Color,L.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:L.Range.from(r.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(L.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,d,f)=>r.map(L.InlayHint.to.bind(void 0,f)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,d)=>{if(r)return r.map(L.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(L.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>u.URI.isUri(r)||typeof r=="string"&&(0,y.matchesSomeScheme)(r,A.Schemas.http,A.Schemas.https),r=>r),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[L.ViewColumn.from(r),void 0]:[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[L.ViewColumn.from(r),void 0]:[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],m.ApiCommandResult.Void)];class k{static register(d){S.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",T.validateWhenClauses)}}e.ExtHostApiCommands=k;function C(r){return d=>{if(Array.isArray(d))return d.map(r)}}function E(r){if(!Array.isArray(r))return;const d=[];for(const f of r)R.isLocationLink(f)?d.push(L.DefinitionLink.to(f)):d.push(L.location.to(f));return d}}),define(Ce[257],Ie([1,0,19,62,3,6,2,72,25,13,7,5]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(k,C,E){const r=k.getProxy(I.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new y.ExtensionIdentifierMap,C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const v=this.b.get(l.handle);return v?v.value:l}else if(l&&l.$mid===7){const v=this.b.get(l.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.commentThreadHandle);return i?i.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);return i?l.$mid===8?i.value:{thread:i.value,text:l.text}:l}else if(l&&l.$mid===10){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const n=l.commentUniqueId,h=i.getCommentByUniqueId(n);return h||l}else if(l&&l.$mid===11){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const n=l.text,h=l.commentUniqueId,w=i.getCommentByUniqueId(h);return w?(typeof w.body=="string"?w.body=n:w.body=new L.MarkdownString(n),w):l}return l}})}createCommentController(l,v,i){const n=d.a++,h=new g(l,n,v,i);this.b.set(h.handle,h);const w=this.c.get(l.identifier)||[];return w.push(h),this.c.set(l.identifier,w),h.value}$createCommentThreadTemplate(l,v,i){const n=this.b.get(l);!n||n.$createCommentThreadTemplate(v,i)}async $updateCommentThreadTemplate(l,v,i){const n=this.b.get(l);!n||n.$updateCommentThreadTemplate(v,i)}$deleteCommentThread(l,v){this.b.get(l)?.$deleteCommentThread(v)}$provideCommentingRanges(l,v,i){const n=this.b.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const h=E.getDocument(P.URI.revive(v));return(0,a.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(h,i)).then(w=>w?w.map(b=>m.Range.from(b)):void 0)}$toggleReaction(l,v,i,n,h){const w=this.b.get(l);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const b=w.getCommentThread(v);if(b){const O=b.getCommentByUniqueId(n.uniqueIdInThread);if(w!==void 0&&O&&w.reactionHandler)return w.reactionHandler(O,t(h))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class f{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,v,i,n,h,w,b,O){this.m=v,this.n=i,this.o=n,this.p=h,this.q=w,this.extensionDescription=b,this.r=O,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),r.$createCommentThread(v,this.handle,this.n,this.o,m.Range.from(this.p),b.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{r.$deleteCommentThread(v,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(x){H.range=x},get comments(){return H.comments},set comments(x){H.comments=x},get collapsibleState(){return H.collapsibleState},set collapsibleState(x){H.collapsibleState=x},get canReply(){return H.canReply},set canReply(x){H.canReply=x},get contextValue(){return H.contextValue},set contextValue(x){H.contextValue=x},get label(){return H.label},set label(x){H.label=x},get state(){return H.state},set state(x){H.state=x},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const l=i=>Object.prototype.hasOwnProperty.call(this.b,i),v={};l("range")&&(v.range=m.Range.from(this.p)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue??null),l("comments")&&(v.comments=this.q.map(i=>D(this,i,this.k))),l("collapsibleState")&&(v.collapseState=o(this.g)),l("canReply")&&(v.canReply=this.canReply),l("state")&&(v.state=s(this.h)),l("isTemplate")&&(v.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(l){for(const v of this.k){const i=v[0],n=v[1];if(l===n)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}f.a=0,Ve([(0,A.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,v,i,n){this.f=l,this.g=v,this.h=i,this.i=n,this.a=new Map,r.$registerCommentController(this.handle,i,n);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(w){h.options=w},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(w){h.commentingRangeProvider=w},get reactionHandler(){return h.reactionHandler},set reactionHandler(w){h.reactionHandler=w},createCommentThread(w,b,O){return h.createCommentThread(w,b,O).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(l,v,i,n){if(typeof l=="string"){const h=new f(this.id,this.handle,l,v,i,n,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new f(this.id,this.handle,void 0,l,v,i,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(l,v){const i=new f(this.id,this.handle,void 0,P.URI.revive(l),m.Range.to(v),[],this.f,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(l,v){const i=this.a.get(l);i&&(i.range=m.Range.to(v))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function D(c,l,v){let i=v.get(l);i||(i=++c.commentHandle,v.set(l,i));const n=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:typeof l.body=="string"?l.body:m.MarkdownString.from(l.body),userName:l.author.name,userIconPath:n,label:l.label,commentReactions:l.reactions?l.reactions.map(h=>p(h)):void 0,timestamp:l.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?m.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function t(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?P.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function s(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new d}e.createExtHostComments=S}),define(Ce[258],Ie([1,0,23,5,26,20]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let P=class{constructor(L,I){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,I){const S=this,k=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S.e(L,I,k,arguments)}})}e(L,I,S,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:y(k,this.b)}),this.c&&this.f(L,S,k)}};P=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],P),e.AbstractExtHostConsoleForwarder=P;const T=1e5;function y(m,L){const I=[];if(m.length)for(let S=0;S<m.length;S++){let k=m[S];if(typeof k>"u")k="undefined";else if(k instanceof Error){const C=k;C.stack?k=C.stack:k=C.toString()}I.push(k)}if(L){const S=new Error().stack;S&&I.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,a.safeStringify)(I);return S.length>T?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(Ce[140],Ie([1,0,2,5,7,4,20,16,17,8,12,27]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class Bi{constructor(C,E){this.h=E,this.f=new Map,this.g=C.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,E){const r=Bi.c++;this.f.set(r,{provider:C,extensionDescription:E}),this.g.$registerDecorationProvider(r,E.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(f=>{if(!f){this.g.$onDidChange(r,null);return}const g=(0,y.asArray)(f);if(g.length<=Bi.d){this.g.$onDidChange(r,g);return}this.h.warn("[Decorations] CAPPING events from decorations provider",E.identifier.value,g.length);const D=g.map(o=>({uri:o,rank:(0,m.count)(o.path,"/")})),p=(0,y.groupBy)(D,(o,s)=>o.rank-s.rank||(0,m.compare)(o.uri.path,s.uri.path)),t=[];e:for(const o of p){let s;for(const c of o){const l=(0,L.dirname)(c.uri.path);if(s!==l&&(s=l,t.push(c.uri)>=Bi.d))break e}}this.g.$onDidChange(r,t)});return new u.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(C,E,r){if(!this.f.has(C))return Object.create(null);const d=Object.create(null),{provider:f,extensionDescription:g}=this.f.get(C);return await Promise.all(E.map(async D=>{try{const{uri:p,id:t}=D,o=await Promise.resolve(f.provideFileDecoration(a.URI.revive(p),r));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.checkProposedApiEnabled)(g,"codiconDecoration"),d[t]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${g}': ${s}`)}}catch(p){this.h.error(p)}})),d}};S.c=0,S.d=250,S=Ve([We(0,P.IExtHostRpcService),We(1,T.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[259],Ie([1,0,180,124,2,5,7,13,3,16,28,49]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";var S,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{constructor(f,g,D,p,t,o,s){this.d=f,this.e=g,this.f=D,this.g=p,S.set(this,void 0),k.set(this,void 0),C.set(this,void 0),this.c=!1,Je(this,C,new L.ResourceMap(c=>t.getComparisonKey(c)),"f"),Je(this,S,o,"f"),Je(this,k,s,"f")}dispose(){this.c||(Me(this,k,"f").fire([...Me(this,C,"f").keys()]),Me(this,S,"f")?.$clear(this.e),Me(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(f,g){if(!f){this.clear();return}this.h();let D=[];if(u.URI.isUri(f)){if(!g){this.delete(f);return}Me(this,C,"f").set(f,g.slice()),D=[f]}else if(Array.isArray(f)){D=[];let t;f=[...f].sort(E.j);for(const o of f){const[s,c]=o;if((!t||s.toString()!==t.toString())&&(t&&Me(this,C,"f").get(t).length===0&&Me(this,C,"f").delete(t),t=s,D.push(s),Me(this,C,"f").set(s,[])),c)Me(this,C,"f").get(s)?.push(...c);else{const l=Me(this,C,"f").get(s);l&&(l.length=0)}}}if(Me(this,k,"f").fire(D),!Me(this,S,"f"))return;const p=[];for(const t of D){let o=[];const s=Me(this,C,"f").get(t);if(s)if(s.length>this.f){o=[];const c=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const v of s)if(v.severity===c[l]&&o.push({...T.Diagnostic.from(v),modelVersionId:this.g(t)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,a.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(c=>({...T.Diagnostic.from(c),modelVersionId:this.g(t)}));p.push([t,o])}Me(this,S,"f").$changeMany(this.e,p)}delete(f){this.h(),Me(this,k,"f").fire([f]),Me(this,C,"f").delete(f),Me(this,S,"f")?.$changeMany(this.e,[[f,void 0]])}clear(){this.h(),Me(this,k,"f").fire([...Me(this,C,"f").keys()]),Me(this,C,"f").clear(),Me(this,S,"f")?.$clear(this.e)}forEach(f,g){this.h();for(const[D,p]of this)f.call(g,D,p,this)}*[(S=new WeakMap,k=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const f of Me(this,C,"f").keys())yield[f,this.get(f)]}get(f){this.h();const g=Me(this,C,"f").get(f);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(f){return this.h(),Array.isArray(Me(this,C,"f").get(f))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(f,g){return f[0].toString()<g[0].toString()?-1:f[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=E;let r=class Si{static _mapper(f){const g=new L.ResourceMap;for(const D of f)g.set(D,D);return{uris:Object.freeze(Array.from(g.values()))}}constructor(f,g,D,p){this.h=g,this.j=D,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,Si._mapper),this.e=f.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,g){const{f:D,e:p,g:t,h:o,j:s,k:c}=this,l=new class{$changeMany(n,h){p.$changeMany(n,h),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,n,h.length===0?"CLEARING":h)}$clear(n){p.$clear(n),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,n)}dispose(){p.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Si.c++,v=g;else if(!D.has(g))v=g;else{this.h.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Si.c++;while(D.has(v))}return new class extends E{constructor(){super(g,v,Si.d,n=>c.getDocument(n)?.version,s.extUri,l,t),D.set(v,this)}dispose(){super.dispose(),D.delete(v)}}}getDiagnostics(f){if(f)return this.l(f);{const g=new Map,D=[];for(const p of this.f.values())p.forEach((t,o)=>{let s=g.get(t.toString());typeof s>"u"&&(s=D.length,g.set(t.toString(),s),D.push([t,[]])),D[s][1]=D[s][1].concat(...o)});return D}}l(f){let g=[];for(const D of this.f.values())D.has(f)&&(g=g.concat(D.get(f)));return g}$acceptMarkersChange(f){if(!this.m){const g="_generated_mirror",D=new E(g,g,Si.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(g,D),this.m=D}for(const[g,D]of f)this.m.set(u.URI.revive(g),D.map(T.Diagnostic.to))}};r.c=0,r.d=1e3,r=Ve([We(1,m.ILogService),We(2,I.IExtHostFileSystemInfo)],r),e.ExtHostDiagnostics=r}),define(Ce[260],Ie([1,0,2,5,27]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(T){this.a=T.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(T,y){return y?.allowUIResources&&(0,u.checkProposedApiEnabled)(T,"showLocal"),this.a.$showOpenDialog(y).then(m=>m?m.map(L=>a.URI.revive(L)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(y=>y?a.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(Ce[261],Ie([1,0,10,2,7,5,18,21,8]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(I,S,k){this.d=S,this.e=k,this.b=new Map,this.c=I.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,S){if(Object.keys(P.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=m.a++;this.b.set(k,S),this.c.$registerTextContentProvider(k,I);let C;return typeof S.onDidChange=="function"&&(C=S.onDidChange(E=>{if(E.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(k,E).then(r=>{if(!r&&typeof r!="string")return;const d=this.d.getDocument(E);if(!d)return;const f=(0,y.splitLines)(r);if(!d.equalLines(f))return this.c.$onVirtualDocumentChange(E,r)},a.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,S){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(A.URI.revive(S),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}m.a=0,e.ExtHostDocumentContentProvider=m}),define(Ce[262],Ie([1,0,3,6,2,5,136,13,9,23,7]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(k,C){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=k.getProxy(R.MainContext.MainThreadDocuments),this.g=C,this.g.onDidRemoveDocuments(E=>{for(const r of E)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(E=>{for(const r of E)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const C=this.g.getDocument(k);if(C)return C}getDocument(k){const C=this.getDocumentData(k);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return C.document}ensureDocumentData(k){const C=this.g.getDocument(k);if(C)return Promise.resolve(C);let E=this.h.get(k.toString());return E||(E=this.f.$tryOpenDocument(k).then(r=>{this.h.delete(k.toString());const d=u.URI.revive(r);return(0,y.assertIsDefined)(this.g.getDocument(d))},r=>(this.h.delete(k.toString()),Promise.reject(r))),this.h.set(k.toString(),E)),E}createDocumentData(k){return this.f.$tryCreateDocument(k).then(C=>u.URI.revive(C))}$acceptModelLanguageChanged(k,C){const E=u.URI.revive(k),r=this.g.getDocument(E);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(C),this.a.fire(r.document)}$acceptModelSaved(k){const C=u.URI.revive(k),E=this.g.getDocument(C);if(!E)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(E.document)}$acceptDirtyStateChanged(k,C){const E=u.URI.revive(k),r=this.g.getDocument(E);if(!r)throw new Error("unknown document");r._acceptIsDirty(C),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,C,E){const r=u.URI.revive(k),d=this.g.getDocument(r);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),d.onEvents(C);let f;C.isUndoing?f=L.TextDocumentChangeReason.Undo:C.isRedoing&&(f=L.TextDocumentChangeReason.Redo),this.c.fire((0,m.deepFreeze)({document:d.document,contentChanges:C.changes.map(g=>({range:T.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:f}))}setWordDefinitionFor(k,C){(0,P.setWordDefinitionFor)(k,C)}}e.ExtHostDocuments=I}),define(Ce[59],Ie([1,0,51,3,6,2,4,5,136,20,139,13,16,28,18,64,65]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(D,p){this.h=D,this.i=p,this.a=null,this.b=new Map,this.c=new k.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],t=[],o=[];if(D.removedDocuments)for(const s of D.removedDocuments){const c=R.URI.revive(s),l=this.c.get(c);l?.unref()&&(this.c.delete(c),p.push(l.value))}if(D.addedDocuments)for(const s of D.addedDocuments){const c=R.URI.revive(s.uri);let l=this.c.get(c);if(l&&c.scheme!==C.Schemas.vscodeNotebookCell&&c.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);l||(l=new d(new y.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),c,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(c,l),t.push(l.value)),l.ref()}if(D.removedEditors)for(const s of D.removedEditors){const c=this.b.get(s);this.b.delete(s),c&&o.push(c)}if(D.addedEditors)for(const s of D.addedEditors){const c=R.URI.revive(s.documentUri);a.ok(this.c.has(c),`document '${c}' does not exist`),a.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(c).value,v=new L.ExtHostTextEditor(s.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new r.Lazy(()=>l.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(i=>I.Range.to(i)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,v)}D.newActiveEditor!==void 0&&(a.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,u.dispose)(p),(0,u.dispose)(o),D.removedDocuments&&this.e.fire(p),D.addedDocuments&&this.d.fire(t),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return E.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const p=this.b.get(this.a);return D?p:p?.value}allEditors(){return[...this.b.values()]}};f=Ve([We(0,m.IExtHostRpcService),We(1,S.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[60],Ie([1,0,13,5,2,3,4,7,20,9,61]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");class I{constructor(r,d,f){this.e=f,this.d=d,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class S{constructor(r,d){this.c=[],this.d="",this.b=r,this.e=d;for(const f of r.tabs)f.isActive&&(this.d=f.id),this.c.push(new I(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return a.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(f=>f.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(f=>f.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const f=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,f),r.tabDto.isActive&&(this.d=f.tabId),f}else if(r.kind===1){const f=this.c.splice(r.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(r.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,f),f}const d=this.c.find(f=>f.tabId===r.tabDto.id);if(!d)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(r.tabDto),d}activeTabId(){return this.d}}let k=class{constructor(r){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=r.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,d={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(f=>f.apiObject))},get activeTabGroup(){const f=r.d;return(0,m.assertIsDefined)(r.e.find(D=>D.groupId===f)?.apiObject)},close:async(f,g)=>{const D=Array.isArray(f)?f:[f];return D.length?C(D[0])?this.j(D,g):this.i(D,g):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(r){const d=new Set(this.e.map(s=>s.groupId)),f=new Set(r.map(s=>s.groupId)),g=(0,L.diffSets)(d,f),D=this.e.filter(s=>g.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],t=[];this.e=r.map(s=>{const c=new S(s,()=>this.d);return g.added.includes(c.groupId)?p.push(c.apiObject):t.push(c.apiObject),c});const o=(0,m.assertIsDefined)(r.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:p,closed:D,changed:t}))}$acceptTabGroupUpdate(r){const d=this.e.find(f=>f.groupId===r.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const d=this.e.find(g=>g.groupId===r.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const f=d.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(r){for(const d of this.e)for(const f of d.tabs)if(f.apiObject===r)return f}h(r){return this.e.find(d=>d.apiObject===r)}async i(r,d){const f=[];for(const g of r){const D=this.g(g);if(!D)throw new Error("Tab close: Invalid tab not found!");f.push(D.tabId)}return this.a.$closeTab(f,d)}async j(r,d){const f=[];for(const g of r){const D=this.h(g);if(!D)throw new Error("Group close: Invalid group not found!");f.push(D.groupId)}return this.a.$closeGroup(f,d)}};k=Ve([We(0,y.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function C(E){return E.tabs!==void 0}}),define(Ce[263],Ie([1,0,2,5,6,7,13,155,8,22,27]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this.a=[]}add(C){this.b=void 0,this.a.push(C)}delete(C){const E=this.a.indexOf(C);E>=0&&(this.a.splice(E,1),this.b=void 0)}c(){if(!this.b){const C=this.a.sort(),E=[];let r,d,f=14,g=14;for(const D of C){let p=r?(0,y.commonPrefixLength)(r,D):0;for(p===0?d=1:d=g;p<D.length;p++)p+1===D.length?(f=g,g=9):g+=1,E.push([d,D.toUpperCase().charCodeAt(p),g]),E.push([d,D.toLowerCase().charCodeAt(p),g]),d=g;r=D,g=f}E.push([9,58,10]),E.push([10,47,12]),this.b=new T.StateMachine(E)}}provideDocumentLinks(C){this.c();const E=[],r=T.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this.b);for(const d of r){const f=P.DocumentLink.to(d);f.target&&E.push(f)}return E}}class S{constructor(C,E){this.i=E,this.b=new I,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=C.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(C,E,r,d={}){if(S.j(r),this.d.has(E))throw new Error(`a provider for the scheme '${E}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(C,"*",this.b));const f=this.h++;this.b.add(E),this.d.add(E),this.c.set(f,r);let g=2;d.isCaseSensitive&&(g+=1024),d.isReadonly&&(g+=2048),typeof r.copy=="function"&&(g+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,L.checkProposedApiEnabled)(C,"fsChunks"),g+=4),this.a.$registerFileSystemProvider(f,E,g).catch(p=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${E}`),console.error(p)});const D=r.onDidChangeFile(p=>{const t=[];for(const o of p){const{uri:s,type:c}=o;if(s.scheme!==E)continue;let l;switch(c){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this.a.$onFileSystemChange(f,t)});return(0,u.toDisposable)(()=>{D.dispose(),this.b.delete(E),this.d.delete(E),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static k(C){const{type:E,ctime:r,mtime:d,size:f,permissions:g}=C;return{type:E,ctime:r,mtime:d,size:f,permissions:g}}$stat(C,E){return Promise.resolve(this.l(C).stat(a.URI.revive(E))).then(r=>S.k(r))}$readdir(C,E){return Promise.resolve(this.l(C).readDirectory(a.URI.revive(E)))}$readFile(C,E){return Promise.resolve(this.l(C).readFile(a.URI.revive(E))).then(r=>m.VSBuffer.wrap(r))}$writeFile(C,E,r,d){return Promise.resolve(this.l(C).writeFile(a.URI.revive(E),r.buffer,d))}$delete(C,E,r){return Promise.resolve(this.l(C).delete(a.URI.revive(E),r))}$rename(C,E,r,d){return Promise.resolve(this.l(C).rename(a.URI.revive(E),a.URI.revive(r),d))}$copy(C,E,r,d){const f=this.l(C);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(a.URI.revive(E),a.URI.revive(r),d))}$mkdir(C,E){return Promise.resolve(this.l(C).createDirectory(a.URI.revive(E)))}$watch(C,E,r,d){const f=this.l(C).watch(a.URI.revive(r),d);this.f.set(E,f)}$unwatch(C,E){const r=this.f.get(E);r&&(r.dispose(),this.f.delete(E))}$open(C,E,r){const d=this.l(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(a.URI.revive(E),r))}$close(C,E){const r=this.l(C);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(E))}$read(C,E,r,d){const f=this.l(C);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const g=m.VSBuffer.alloc(d);return Promise.resolve(f.read(E,r,g.buffer,0,d)).then(D=>g.slice(0,D))}$write(C,E,r,d){const f=this.l(C);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(E,r,d.buffer,0,d.byteLength))}l(C){const E=this.c.get(C);if(!E){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return E}}e.ExtHostFileSystem=S}),define(Ce[79],Ie([1,0,5,45,7,22,4,20,49,6]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(S,k){this.b=new Map,this.a=S.getProxy(a.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(E){try{const r=C.b.get(E.scheme);if(!r)return await C.a.$stat(E);await C.a.$ensureActivation(E.scheme);const d=await r.stat(E);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(r){Jt.c(r)}},async readDirectory(E){try{const r=C.b.get(E.scheme);return r?(await C.a.$ensureActivation(E.scheme),(await r.readDirectory(E)).slice()):await C.a.$readdir(E)}catch(r){return Jt.c(r)}},async createDirectory(E){try{return await C.a.$mkdir(E)}catch(r){return Jt.c(r)}},async readFile(E){try{const r=C.b.get(E.scheme);return r?(await C.a.$ensureActivation(E.scheme),(await r.readFile(E)).slice()):(await C.a.$readFile(E)).buffer}catch(r){return Jt.c(r)}},async writeFile(E,r){try{return await C.a.$writeFile(E,R.VSBuffer.wrap(r))}catch(d){return Jt.c(d)}},async delete(E,r){try{const d=C.b.get(E.scheme);return d?(await C.a.$ensureActivation(E.scheme),await d.delete(E,{recursive:!1,...r})):await C.a.$delete(E,{recursive:!1,useTrash:!1,...r})}catch(d){return Jt.c(d)}},async rename(E,r,d){try{return await C.a.$rename(E,r,{overwrite:!1,...d})}catch(f){return Jt.c(f)}},async copy(E,r,d){try{return await C.a.$copy(E,r,{overwrite:!1,...d})}catch(f){return Jt.c(f)}},isWritableFileSystem(E){const r=k.getCapabilities(E);if(typeof r=="number")return!(r&2048)}})}static c(S){if(S instanceof u.FileSystemError)throw S;if(!(S instanceof Error))throw new u.FileSystemError(String(S));if(S.name==="ENOPRO"||S.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(S.message);switch(S.name){case A.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(S.message);case A.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(S.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(S.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(S.message);case A.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(S.message);case A.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(S.message);default:throw new u.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,k){return this.b.set(S,k),(0,m.toDisposable)(()=>this.b.delete(S))}};L=Ve([We(0,T.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[264],Ie([1,0,3,38,2,5,13,7]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(I,S,k,C,E,r,d,f){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const g=this.h(I,k,E);this.g=0,r&&(this.g+=1),d&&(this.g+=2),f&&(this.g+=4);const D=(0,A.parse)(E),p=typeof E=="string",t=C(o=>{if(!r)for(const s of o.created){const c=u.URI.revive(s);D(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.a.fire(c)}if(!d)for(const s of o.changed){const c=u.URI.revive(s);D(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.b.fire(c)}if(!f)for(const s of o.deleted){const c=u.URI.revive(s);D(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=T.Disposable.from(g,this.a,this.b,this.c,t)}h(I,S,k){const C=T.Disposable.from();if(typeof k=="string")return C;const E=I.getProxy(R.MainContext.MainThreadFileSystem);let r=!1;(k.pattern.includes(A.GLOBSTAR)||k.pattern.includes(A.GLOB_SPLIT))&&(r=!0);const d=Math.random();return E.$watch(S.identifier.value,d,k.baseUri,{recursive:r,excludes:[]}),T.Disposable.from({dispose:()=>E.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class m{constructor(I,S,k){this.j=I,this.k=S,this.l=k,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,S,k,C,E,r){return new y(this.j,I,S,this.a.event,P.GlobPattern.from(k),C,E,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,S){switch(I){case 2:this.b.fire(Object.freeze({files:S.map(k=>({oldUri:u.URI.revive(k.source),newUri:u.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(k=>u.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(k=>u.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,S){return(k,C,E)=>{const r=function(f){k.call(C,f)};return r.extension=I,S.event(r,void 0,E)}}async $onWillRunFileOperation(I,S,k,C){switch(I){case 2:return await this.n(this.g,{files:S.map(E=>({oldUri:u.URI.revive(E.source),newUri:u.URI.revive(E.target)}))},k,C);case 1:return await this.n(this.i,{files:S.map(E=>u.URI.revive(E.target))},k,C);case 0:case 3:return await this.n(this.h,{files:S.map(E=>u.URI.revive(E.target))},k,C)}}async n(I,S,k,C){const E=new Set,r=[];if(await I.fireAsync(S,C,async(f,g)=>{const D=Date.now(),p=await Promise.resolve(f);p instanceof T.WorkspaceEdit&&(r.push([g.extension,p]),E.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-D>k&&this.k.warn("SLOW file-participant",g.extension.identifier)}),C.isCancellationRequested||r.length===0)return;const d={edits:[]};for(const[,f]of r){const{edits:g}=P.WorkspaceEdit.from(f,{getTextDocumentVersion:D=>this.l.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(g)}return{edit:d,extensionNames:Array.from(E)}}}e.ExtHostFileSystemEventService=m}),define(Ce[265],Ie([1,0,2,40]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(P,T,y,m,L){this.a=T,this.b=y,this.c=m;const I=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new A.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new A.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new A.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new A.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const k=this.a.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(S.notebookUri),inputUri:a.URI.revive(S.inputUri),notebookEditor:k.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:a.URI.revive(S.notebookUri),inputUri:a.URI.revive(S.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(P,T,y,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:y,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=u}),define(Ce[266],Ie([1,0,6,2,5,13]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(m,L){this.extension=m,this.provider=L,this.handle=P.a++}}P.a=0;class T{constructor(m,L,I){this.e=L,this.f=I,this.b=new Map,this.c=new Map,this.d=m.getProxy(u.MainContext.MainThreadInteractiveEditor)}registerProvider(m,L){const I=new P(m,L);return this.b.set(I.handle,I),this.d.$registerInteractiveEditorProvider(I.handle,m.identifier.value),(0,a.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(I.handle),this.b.delete(I.handle)})}async $prepareInteractiveSession(m,L,I,S){const k=this.b.get(m);if(!k){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const C=this.e.getDocument(A.URI.revive(L)),E=await k.provider.prepareInteractiveEditorSession({document:C,selection:R.Selection.to(I)},S);if(!E)return;const r=T.a++;return this.c.set(r,E),{id:r,placeholder:E.placeholder}}async $provideResponse(m,L,I,S){const k=this.b.get(m);if(!k)return;const C=this.c.get(L.id);if(!C)return;const E=await k.provider.provideInteractiveEditorResponse({session:C,prompt:I.prompt,selection:R.Selection.to(I.selection),wholeRange:R.Range.to(I.wholeRange)},S);if(!!E)return{edits:E.edits.map(R.TextEdit.from),placeholder:E.placeholder}}$releaseSession(m,L){const I=this.c.get(L),S=this.b.get(m);I&&S&&S.provider.releaseInteractiveEditorSession?.(I),this.c.delete(L)}}T.a=0,e.ExtHostInteractiveEditor=T}),define(Ce[267],Ie([1,0,6,9,5]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class R{constructor(y,m){this.extension=y,this.provider=m,this.handle=R.a++}}R.a=0;class P{constructor(y,m){this.b=new Map,this.c=new Map,this.d=y.getProxy(u.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(y,m,L){const I=new R(y,L);return this.b.set(I.handle,I),this.d.$registerInteractiveSessionProvider(I.handle,m),(0,a.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(I.handle),this.b.delete(I.handle)})}addInteractiveSessionRequest(y){this.d.$addInteractiveSessionRequest(y)}async $prepareInteractiveSession(y,m,L){const I=this.b.get(y);if(!I)return;const S=await I.provider.prepareSession(m,L);if(!S)return;const k=P.a++;return this.c.set(k,S),{id:k}}async $resolveInteractiveRequest(y,m,L,I){const S=this.b.get(y);if(!S)return;const k=this.c.get(m);if(!k||!S.provider.resolveRequest)return;const C=await S.provider.resolveRequest(k,L,I);if(C)return{message:C.message}}async $provideInitialSuggestions(y,m){const L=this.b.get(y);if(!!L&&!!L.provider.provideInitialSuggestions)return(0,A.withNullAsUndefined)(await L.provider.provideInitialSuggestions(m))}async $provideInteractiveReply(y,m,L,I){const S=this.b.get(y);if(!S)return;const k=this.c.get(m);if(!k)return;const C={session:k,message:L.message};if(S.provider.provideResponse){const E=await S.provider.provideResponse(C,I);if(k.saveState){const r=k.saveState();this.d.$acceptInteractiveSessionState(m,r)}return E?(this.d.$acceptInteractiveResponseProgress(y,m,{responsePart:E.content}),{followups:E.followups}):void 0}else if(S.provider.provideResponseWithProgress){const E={report:d=>this.d.$acceptInteractiveResponseProgress(y,m,{responsePart:d.content})},r=await S.provider.provideResponseWithProgress(C,E,I);if(k.saveState){const d=k.saveState();this.d.$acceptInteractiveSessionState(m,d)}return r?{followups:r.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(y){this.c.delete(y)}}P.a=0,e.ExtHostInteractiveSession=P}),define(Ce[268],Ie([1,0,6,5]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(P){this.b=0,this.a=P.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,P),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=u}),define(Ce[269],Ie([1,0,2,23,13,7,72,5,8,32,17,9,151,21,6,121,102,75,43,10,19,27]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(N,z){this.d=N,this.e=z}async provideDocumentSymbols(N,z){const K=this.d.getDocument(N),Z=await this.e.provideDocumentSymbols(K,z);if(!(0,L.isFalsyOrEmpty)(Z))return Z[0]instanceof R.DocumentSymbol?Z.map(u.DocumentSymbol.from):t.f(Z)}static f(N){N=N.slice(0).sort((Z,fe)=>{let Se=Z.location.range.start.compareTo(fe.location.range.start);return Se===0&&(Se=fe.location.range.end.compareTo(Z.location.range.end)),Se});const z=[],K=[];for(const Z of N){const fe={name:Z.name||"!!MISSING: name!!",kind:u.SymbolKind.from(Z.kind),tags:Z.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:u.Range.from(Z.location.range),selectionRange:u.Range.from(Z.location.range),children:[]};for(;;){if(K.length===0){K.push(fe),z.push(fe);break}const Se=K[K.length-1];if(m.Range.containsRange(Se.range,fe.range)&&!m.Range.equalsRange(Se.range,fe.range)){Se.children?.push(fe),K.push(fe);break}K.pop()}}return z}}class o{constructor(N,z,K){this.g=N,this.h=z,this.j=K,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,z){const K=this.g.getDocument(N),Z=await this.j.provideCodeLenses(K,z);if(!Z||z.isCancellationRequested)return;const fe=this.e.add(Z),Se=new C.DisposableStore;this.f.set(fe,Se);const Ae={cacheId:fe,lenses:[]};for(let we=0;we<Z.length;we++)Ae.lenses.push({cacheId:[fe,we],range:u.Range.from(Z[we].range),command:this.h.toInternal(Z[we].command,Se)});return Ae}async resolveCodeLens(N,z){const K=N.cacheId&&this.e.get(...N.cacheId);if(!K)return;let Z;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?Z=K:Z=await this.j.resolveCodeLens(K,z),Z||(Z=K),z.isCancellationRequested)return;const fe=N.cacheId&&this.f.get(N.cacheId[0]);if(!!fe)return N.command=this.h.toInternal(Z.command??o.d,fe),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(ae){return Array.isArray(ae)?ae.map(u.DefinitionLink.from):ae?[u.DefinitionLink.from(ae)]:[]}class c{constructor(N,z){this.d=N,this.e=z}async provideDefinition(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideDefinition(Z,fe,K);return s(Se)}}class l{constructor(N,z){this.d=N,this.e=z}async provideDeclaration(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideDeclaration(Z,fe,K);return s(Se)}}class v{constructor(N,z){this.d=N,this.e=z}async provideImplementation(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideImplementation(Z,fe,K);return s(Se)}}class i{constructor(N,z){this.d=N,this.e=z}async provideTypeDefinition(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideTypeDefinition(Z,fe,K);return s(Se)}}class n{constructor(N,z){this.d=N,this.e=z}async provideHover(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideHover(Z,fe,K);if(!(!Se||(0,L.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=Z.getWordRangeAtPosition(fe)),Se.range||(Se.range=new R.Range(fe,fe)),u.Hover.from(Se)}}class h{constructor(N,z){this.d=N,this.e=z}async provideEvaluatableExpression(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideEvaluatableExpression(Z,fe,K);if(Se)return u.EvaluatableExpression.from(Se)}}class w{constructor(N,z){this.d=N,this.e=z}async provideInlineValues(N,z,K,Z){const fe=this.d.getDocument(N),Se=await this.e.provideInlineValues(fe,u.Range.to(z),u.InlineValueContext.to(K),Z);if(Array.isArray(Se))return Se.map(Ae=>u.InlineValue.from(Ae))}}class b{constructor(N,z){this.d=N,this.e=z}async provideDocumentHighlights(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideDocumentHighlights(Z,fe,K);if(Array.isArray(Se))return Se.map(u.DocumentHighlight.from)}}class O{constructor(N,z){this.d=N,this.e=z}async provideLinkedEditingRanges(N,z,K){const Z=this.d.getDocument(N),fe=u.Position.to(z),Se=await this.e.provideLinkedEditingRanges(Z,fe,K);if(Se&&Array.isArray(Se.ranges))return{ranges:(0,L.coalesce)(Se.ranges.map(u.Range.from)),wordPattern:Se.wordPattern}}}class H{constructor(N,z){this.d=N,this.e=z}async provideReferences(N,z,K,Z){const fe=this.d.getDocument(N),Se=u.Position.to(z),Ae=await this.e.provideReferences(fe,Se,K,Z);if(Array.isArray(Ae))return Ae.map(u.location.from)}}class x{constructor(N,z,K,Z,fe,Se,Ae){this.g=N,this.h=z,this.j=K,this.k=Z,this.l=fe,this.m=Se,this.n=Ae,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,z,K,Z){const fe=this.g.getDocument(N),Se=S.Selection.isISelection(z)?u.Selection.to(z):u.Range.to(z),Ae=[];for(const tt of this.j.getDiagnostics(N))if(Se.intersection(tt.range)&&Ae.push(tt)>x.d)break;const we={diagnostics:Ae,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:u.CodeActionTriggerKind.to(K.trigger)},Pe=await this.k.provideCodeActions(fe,Se,we,Z);if(!(0,L.isNonEmptyArray)(Pe)||Z.isCancellationRequested)return;const ke=this.e.add(Pe),ze=new C.DisposableStore;this.f.set(ke,ze);const qe=[];for(let tt=0;tt<Pe.length;tt++){const Qe=Pe[tt];!Qe||(x.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,ze)})):(we.only&&(Qe.kind?we.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[ke,tt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,ze),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(u.Diagnostic.from),edit:Qe.edit&&u.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:qe}}async resolveCodeAction(N,z){const[K,Z]=N,fe=this.e.get(K,Z);if(!fe||x.o(fe)||!this.k.resolveCodeAction)return;const Se=await this.k.resolveCodeAction(fe,z)??fe;return Se?.edit?u.WorkspaceEdit.from(Se.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}x.d=1e3;class _{constructor(N,z,K,Z){this.d=N,this.e=z,this.f=K,this.g=Z}async prepareDocumentPaste(N,z,K,Z){if(!this.f.prepareDocumentPaste)return;const fe=this.e.getDocument(N),Se=z.map(we=>u.Range.to(we)),Ae=u.DataTransfer.toDataTransfer(K,()=>{throw new g.NotImplementedError});return await this.f.prepareDocumentPaste(fe,Se,Ae,Z),u.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,z,K,Z,fe){const Se=this.e.getDocument(z),Ae=K.map(ke=>u.Range.to(ke)),we=u.DataTransfer.toDataTransfer(Z,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),Pe=await this.f.provideDocumentPasteEdits(Se,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class G{constructor(N,z){this.d=N,this.e=z}async provideDocumentFormattingEdits(N,z,K){const Z=this.d.getDocument(N),fe=await this.e.provideDocumentFormattingEdits(Z,z,K);if(Array.isArray(fe))return fe.map(u.TextEdit.from)}}class M{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeFormattingEdits(N,z,K,Z){const fe=this.d.getDocument(N),Se=u.Range.to(z),Ae=await this.e.provideDocumentRangeFormattingEdits(fe,Se,K,Z);if(Array.isArray(Ae))return Ae.map(u.TextEdit.from)}}class B{constructor(N,z){this.d=N,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,z,K,Z,fe){const Se=this.d.getDocument(N),Ae=u.Position.to(z),we=await this.e.provideOnTypeFormattingEdits(Se,Ae,K,Z,fe);if(Array.isArray(we))return we.map(u.TextEdit.from)}}class U{constructor(N,z){this.e=N,this.f=z,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,z){const K=await this.e.provideWorkspaceSymbols(N,z);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const Z=this.d.add(K),fe={cacheId:Z,symbols:[]};for(let Se=0;Se<K.length;Se++){const Ae=K[Se];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}fe.symbols.push({...u.WorkspaceSymbol.from(Ae),cacheId:[Z,Se]})}return fe}async resolveWorkspaceSymbol(N,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const Z=await this.e.resolveWorkspaceSymbol(K,z);return Z&&(0,A.mixin)(N,u.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,z,K){this.d=N,this.e=z,this.f=K}async provideRenameEdits(N,z,K,Z){const fe=this.d.getDocument(N),Se=u.Position.to(z);try{const Ae=await this.e.provideRenameEdits(fe,Se,K,Z);return Ae?u.WorkspaceEdit.from(Ae):void 0}catch(Ae){const we=j.g(Ae);return we?{rejectReason:we,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(N),fe=u.Position.to(z);try{const Se=await this.e.prepareRename(Z,fe,K);let Ae,we;if(R.Range.isRange(Se)?(Ae=Se,we=Z.getText(Se)):(0,I.isObject)(Se)&&(Ae=Se.range,we=Se.placeholder),!Ae||!we)return;if(Ae.start.line>fe.line||Ae.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Ae),text:we}}catch(Se){const Ae=j.g(Se);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(Se)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class he{constructor(N,z){this.resultId=N,this.tokens=z}}class ie{constructor(N,z){this.f=N,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,z,K){const Z=this.f.getDocument(N),fe=z!==0?this.d.get(z):null;let Se=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,fe.resultId,K):await this.g.provideDocumentSemanticTokens(Z,K);return fe&&this.d.delete(z),Se?(Se=ie.h(Se),this.o(ie.n(fe,Se),Se)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return ie.j(N)?ie.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):ie.l(N)?ie.m(N)?N:new R.SemanticTokensEdits(N.edits.map(z=>new R.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const z of N.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(N,z){if(!ie.j(z)||!N||!N.tokens)return z;const K=N.tokens,Z=K.length,fe=z.data,Se=fe.length;let Ae=0;const we=Math.min(Z,Se);for(;Ae<we&&K[Ae]===fe[Ae];)Ae++;if(Ae===Z&&Ae===Se)return new R.SemanticTokensEdits([],z.resultId);let Pe=0;const ke=we-Ae;for(;Pe<ke&&K[Z-Pe-1]===fe[Se-Pe-1];)Pe++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Z-Ae-Pe,data:fe.subarray(Ae,Se-Pe)}],z.resultId)}o(N,z){if(ie.j(N)){const K=this.e++;return this.d.set(K,new he(N.resultId,N.data)),(0,E.encodeSemanticTokensDto)({id:K,type:"full",data:N.data})}if(ie.l(N)){const K=this.e++;return ie.j(z)?this.d.set(K,new he(z.resultId,z.data)):this.d.set(K,new he(N.resultId)),(0,E.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(N.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class V{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeSemanticTokens(N,z,K){const Z=this.d.getDocument(N),fe=await this.e.provideDocumentRangeSemanticTokens(Z,u.Range.to(z),K);return fe?this.f(fe):null}f(N){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class J{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,z,K,Z,fe){this.f=N,this.g=z,this.h=K,this.j=Z,this.k=fe,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,z,K,Z){const fe=this.f.getDocument(N),Se=u.Position.to(z),Ae=fe.getWordRangeAtPosition(Se)||new R.Range(Se,Se),we=Ae.with({end:Se}),Pe=new f.StopWatch(!0),ke=await this.h.provideCompletionItems(fe,Se,Z,u.CompletionContext.to(K));if(!ke||Z.isCancellationRequested)return;const ze=Array.isArray(ke)?new R.CompletionList(ke):ke,qe=J.supportsResolving(this.h)?this.d.add(ze.items):this.d.add([]),tt=new C.DisposableStore;this.e.set(qe,tt);const Qe=[],it={x:qe,b:Qe,a:{replace:u.Range.from(Ae),insert:u.Range.from(we)},c:ze.isIncomplete||void 0,d:Pe.elapsed()};for(let rt=0;rt<ze.items.length;rt++){const Be=ze.items[rt],et=this.l(Be,[qe,rt],we,Ae);Qe.push(et)}return it}async resolveCompletionItem(N,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const Z=await this.h.resolveCompletionItem(K,z);if(!!Z)return this.l(Z,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z,K,Z){const fe=this.e.get(z[0]);if(!fe)throw Error("DisposableStore is missing...");const Se=this.g.toInternal(N.command,fe),Ae={x:z,a:N.label,b:N.kind!==void 0?u.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(u.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:u.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(u.TextEdit.from),n:Se?.$ident,o:Se?.id,p:Se?.$ident?void 0:Se?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let we;return N.textEdit?we=N.textEdit.range:N.range&&(we=N.range),R.Range.isRange(we)?Ae.j=u.Range.from(we):we&&(!K?.isEqual(we.inserting)||!Z?.isEqual(we.replacing))&&(Ae.j={insert:u.Range.from(we.inserting),replace:u.Range.from(we.replacing)}),Ae}}class re{async provideInlineCompletions(N,z,K,Z){}disposeCompletions(N){}handleDidShowCompletionItem(N,z){}handlePartialAccept(N,z,K){}}class ve extends re{constructor(N,z,K,Z){super(),this.f=N,this.g=z,this.h=K,this.j=Z,this.d=new ue,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,z,K,Z){const fe=this.g.getDocument(N),Se=u.Position.to(z),Ae=await this.h.provideInlineCompletionItems(fe,Se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:u.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Z);if(!Ae||Z.isCancellationRequested)return;const we=Array.isArray(Ae)?Ae:Ae.items,Pe=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:we}),items:we.map((qe,tt)=>{let Qe;qe.command&&(ke||(ke=new C.DisposableStore),Qe=this.j.toInternal(qe.command,ke));const it=qe.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:qe.filterText,range:qe.range?u.Range.from(qe.range):void 0,command:Qe,idx:tt,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:Pe.map(qe=>(ke||(ke=new C.DisposableStore),this.j.toInternal(qe,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,z){const K=this.d.get(N)?.items[z];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}handlePartialAccept(N,z,K){const Z=this.d.get(N)?.items[z];Z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Z,K)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const z=this.e++;return this.d.set(z,N),z}disposeReferenceId(N){const z=this.d.get(N);return this.d.delete(N),z}get(N){return this.d.get(N)}}class le{constructor(N,z){this.e=N,this.f=z,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(N,z,K,Z){const fe=this.e.getDocument(N),Se=u.Position.to(z),Ae=this.g(K),we=await this.f.provideSignatureHelp(fe,Se,Z,Ae);if(we){const Pe=this.d.add([we]);return{...u.SignatureHelp.from(we),id:Pe}}}g(N){let z;if(N.activeSignatureHelp){const K=u.SignatureHelp.to(N.activeSignatureHelp),Z=this.d.get(N.activeSignatureHelp.id,0);Z?(z=Z,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...N,activeSignatureHelp:z}}releaseSignatureHelp(N){this.d.delete(N)}}class q{constructor(N,z,K,Z,fe){this.f=N,this.g=z,this.h=K,this.j=Z,this.k=fe,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,z,K){const Z=this.f.getDocument(N),fe=u.Range.to(z),Se=await this.h.provideInlayHints(Z,fe,K);if(!Array.isArray(Se)||Se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(Se);this.e.set(Ae,new C.DisposableStore);const we={hints:[],cacheId:Ae};for(let Pe=0;Pe<Se.length;Pe++)this.l(Se[Pe],fe)&&we.hints.push(this.m(Se[Pe],[Ae,Pe]));return this.j.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),we}async resolveInlayHint(N,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const Z=await this.h.resolveInlayHint(K,z);if(!!Z&&!!this.l(Z))return this.m(Z,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(z&&!z.contains(N.position))}m(N,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:z,tooltip:u.MarkdownString.fromStrict(N.tooltip),position:u.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(u.TextEdit.from),kind:N.kind&&u.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Z.label=N.label:Z.label=N.label.map(fe=>{const Se={label:fe.value};return Se.tooltip=u.MarkdownString.fromStrict(fe.tooltip),R.Location.isLocation(fe.location)&&(Se.location=u.location.from(fe.location)),fe.command&&(Se.command=this.g.toInternal(fe.command,K)),Se}),Z}}class F{constructor(N,z){this.e=N,this.f=z,this.d=new d.Cache("DocumentLink")}async provideLinks(N,z){const K=this.e.getDocument(N),Z=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(Z)||Z.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(F.g).map(u.DocumentLink.from)};{const fe=this.d.add(Z),Se={links:[],cacheId:fe};for(let Ae=0;Ae<Z.length;Ae++){if(!F.g(Z[Ae]))continue;const we=u.DocumentLink.from(Z[Ae]);we.cacheId=[fe,Ae],Se.links.push(we)}return Se}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const Z=await this.f.resolveDocumentLink(K,z);if(!(!Z||!F.g(Z)))return u.DocumentLink.from(Z)}releaseLinks(N){this.d.delete(N)}}class Q{constructor(N,z){this.d=N,this.e=z}async provideColors(N,z){const K=this.d.getDocument(N),Z=await this.e.provideDocumentColors(K,z);return Array.isArray(Z)?Z.map(Se=>({color:u.Color.from(Se.color),range:u.Range.from(Se.range)})):[]}async provideColorPresentations(N,z,K){const Z=this.d.getDocument(N),fe=u.Range.to(z.range),Se=u.Color.to(z.color),Ae=await this.e.provideColorPresentations(Se,{document:Z,range:fe},K);if(!!Array.isArray(Ae))return Ae.map(u.ColorPresentation.from)}}class me{constructor(N,z){this.d=N,this.e=z}async provideFoldingRanges(N,z,K){const Z=this.d.getDocument(N),fe=await this.e.provideFoldingRanges(Z,z,K);if(!!Array.isArray(fe))return fe.map(u.FoldingRange.from)}}class Ee{constructor(N,z,K){this.d=N,this.e=z,this.f=K}async provideSelectionRanges(N,z,K){const Z=this.d.getDocument(N),fe=z.map(u.Position.to),Se=await this.e.provideSelectionRanges(Z,fe,K);if(!(0,L.isNonEmptyArray)(Se))return[];if(Se.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let we=0;we<fe.length;we++){const Pe=[];Ae.push(Pe);let ke=fe[we],ze=Se[we];for(;;){if(!ze.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(u.SelectionRange.from(ze)),!ze.parent)break;ke=ze.range,ze=ze.parent}}return Ae}}class te{constructor(N,z){this.f=N,this.g=z,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(N,z,K){const Z=this.f.getDocument(N),fe=u.Position.to(z),Se=await this.g.prepareCallHierarchy(Z,fe,K);if(!Se)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Se)?Se.map(we=>this.h(Ae,we)):[this.h(Ae,Se)]}async provideCallsTo(N,z,K){const Z=this.j(N,z);if(!Z)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(Z,K);if(!!fe)return fe.map(Se=>({from:this.h(N,Se.from),fromRanges:Se.fromRanges.map(Ae=>u.Range.from(Ae))}))}async provideCallsFrom(N,z,K){const Z=this.j(N,z);if(!Z)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(Z,K);if(!!fe)return fe.map(Se=>({to:this.h(N,Se.to),fromRanges:Se.fromRanges.map(Ae=>u.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,z){const K=this.e.get(N),Z=u.CallHierarchyItem.from(z,N,K.size.toString(36));return K.set(Z._itemId,z),Z}j(N,z){return this.e.get(N)?.get(z)}}class ne{constructor(N,z){this.f=N,this.g=z,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(N,z,K){const Z=this.f.getDocument(N),fe=u.Position.to(z),Se=await this.g.prepareTypeHierarchy(Z,fe,K);if(!Se)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Se)?Se.map(we=>this.h(Ae,we)):[this.h(Ae,Se)]}async provideSupertypes(N,z,K){const Z=this.j(N,z);if(!Z)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(Z,K);if(!!fe)return fe.map(Se=>this.h(N,Se))}async provideSubtypes(N,z,K){const Z=this.j(N,z);if(!Z)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(Z,K);if(!!fe)return fe.map(Se=>this.h(N,Se))}releaseSession(N){this.e.delete(N)}h(N,z){const K=this.e.get(N),Z=u.TypeHierarchyItem.from(z,N,K.size.toString(36));return K.set(Z._itemId,z),Z}j(N,z){return this.e.get(N)?.get(z)}}class de{constructor(N,z,K,Z){this.d=N,this.e=z,this.f=K,this.g=Z}async provideDocumentOnDropEdits(N,z,K,Z,fe){const Se=this.e.getDocument(z),Ae=u.Position.to(K),we=u.DataTransfer.toDataTransfer(Z,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),Pe=await this.f.provideDocumentDropEdits(Se,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class ee{constructor(N,z){this.adapter=N,this.extension=z}}class ce{constructor(N,z,K,Z,fe,Se,Ae,we){this.g=z,this.h=K,this.j=Z,this.k=fe,this.l=Se,this.m=Ae,this.n=we,this.f=new Map,this.e=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(N){return u.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,z,K,Z,fe,Se=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof z))return Z;const we=Date.now();Se||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Pe=K(Ae.adapter,Ae.extension);return Promise.resolve(Pe).catch(ke=>{(0,g.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{Se||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),k.CancellationToken.isCancellationToken(fe)?(0,D.raceCancellationError)(Pe,fe):Pe}t(N,z){const K=this.q();return this.f.set(K,new ee(N,z)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,z,K,Z){const fe=this.t(new t(this.h,K),N),Se=Z&&Z.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(fe,this.o(z),Se),this.p(fe)}$provideDocumentSymbols(N,z,K){return this.s(N,t,Z=>Z.provideDocumentSymbols(a.URI.revive(z),K),void 0,K)}registerCodeLensProvider(N,z,K){const Z=this.q(),fe=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new ee(new o(this.h,this.j.converter,K),N)),this.e.$registerCodeLensSupport(Z,this.o(z),fe);let Se=this.p(Z);if(fe!==void 0){const Ae=K.onDidChangeCodeLenses(we=>this.e.$emitCodeLensEvent(fe));Se=R.Disposable.from(Se,Ae)}return Se}$provideCodeLenses(N,z,K){return this.s(N,o,Z=>Z.provideCodeLenses(a.URI.revive(z),K),void 0,K)}$resolveCodeLens(N,z,K){return this.s(N,o,Z=>Z.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(N,z){this.s(N,o,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(N,z,K){const Z=this.t(new c(this.h,K),N);return this.e.$registerDefinitionSupport(Z,this.o(z)),this.p(Z)}$provideDefinition(N,z,K,Z){return this.s(N,c,fe=>fe.provideDefinition(a.URI.revive(z),K,Z),[],Z)}registerDeclarationProvider(N,z,K){const Z=this.t(new l(this.h,K),N);return this.e.$registerDeclarationSupport(Z,this.o(z)),this.p(Z)}$provideDeclaration(N,z,K,Z){return this.s(N,l,fe=>fe.provideDeclaration(a.URI.revive(z),K,Z),[],Z)}registerImplementationProvider(N,z,K){const Z=this.t(new v(this.h,K),N);return this.e.$registerImplementationSupport(Z,this.o(z)),this.p(Z)}$provideImplementation(N,z,K,Z){return this.s(N,v,fe=>fe.provideImplementation(a.URI.revive(z),K,Z),[],Z)}registerTypeDefinitionProvider(N,z,K){const Z=this.t(new i(this.h,K),N);return this.e.$registerTypeDefinitionSupport(Z,this.o(z)),this.p(Z)}$provideTypeDefinition(N,z,K,Z){return this.s(N,i,fe=>fe.provideTypeDefinition(a.URI.revive(z),K,Z),[],Z)}registerHoverProvider(N,z,K,Z){const fe=this.t(new n(this.h,K),N);return this.e.$registerHoverProvider(fe,this.o(z)),this.p(fe)}$provideHover(N,z,K,Z){return this.s(N,n,fe=>fe.provideHover(a.URI.revive(z),K,Z),void 0,Z)}registerEvaluatableExpressionProvider(N,z,K,Z){const fe=this.t(new h(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(z)),this.p(fe)}$provideEvaluatableExpression(N,z,K,Z){return this.s(N,h,fe=>fe.provideEvaluatableExpression(a.URI.revive(z),K,Z),void 0,Z)}registerInlineValuesProvider(N,z,K,Z){const fe=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,Se=this.t(new w(this.h,K),N);this.e.$registerInlineValuesProvider(Se,this.o(z),fe);let Ae=this.p(Se);if(fe!==void 0){const we=K.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(fe));Ae=R.Disposable.from(Ae,we)}return Ae}$provideInlineValues(N,z,K,Z,fe){return this.s(N,w,Se=>Se.provideInlineValues(a.URI.revive(z),K,Z,fe),void 0,fe)}registerDocumentHighlightProvider(N,z,K){const Z=this.t(new b(this.h,K),N);return this.e.$registerDocumentHighlightProvider(Z,this.o(z)),this.p(Z)}$provideDocumentHighlights(N,z,K,Z){return this.s(N,b,fe=>fe.provideDocumentHighlights(a.URI.revive(z),K,Z),void 0,Z)}registerLinkedEditingRangeProvider(N,z,K){const Z=this.t(new O(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(z)),this.p(Z)}$provideLinkedEditingRanges(N,z,K,Z){return this.s(N,O,async fe=>{const Se=await fe.provideLinkedEditingRanges(a.URI.revive(z),K,Z);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?ce.w(Se.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(N,z,K){const Z=this.t(new H(this.h,K),N);return this.e.$registerReferenceSupport(Z,this.o(z)),this.p(Z)}$provideReferences(N,z,K,Z,fe){return this.s(N,H,Se=>Se.provideReferences(a.URI.revive(z),K,Z,fe),void 0,fe)}registerCodeActionProvider(N,z,K,Z){const fe=new C.DisposableStore,Se=this.t(new x(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(Se,this.o(z),{providedKinds:Z?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Z?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,fe)}))},ce.u(N),Boolean(K.resolveCodeAction)),fe.add(this.p(Se)),fe}$provideCodeActions(N,z,K,Z,fe){return this.s(N,x,Se=>Se.provideCodeActions(a.URI.revive(z),K,Z,fe),void 0,fe)}$resolveCodeAction(N,z,K){return this.s(N,x,Z=>Z.resolveCodeAction(z,K),void 0,void 0)}$releaseCodeActions(N,z){this.s(N,x,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(N,z,K){const Z=this.t(new G(this.h,K),N);return this.e.$registerDocumentFormattingSupport(Z,this.o(z),N.identifier,N.displayName||N.name),this.p(Z)}$provideDocumentFormattingEdits(N,z,K,Z){return this.s(N,G,fe=>fe.provideDocumentFormattingEdits(a.URI.revive(z),K,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(N,z,K){const Z=this.t(new M(this.h,K),N);return this.e.$registerRangeFormattingSupport(Z,this.o(z),N.identifier,N.displayName||N.name),this.p(Z)}$provideDocumentRangeFormattingEdits(N,z,K,Z,fe){return this.s(N,M,Se=>Se.provideDocumentRangeFormattingEdits(a.URI.revive(z),K,Z,fe),void 0,fe)}registerOnTypeFormattingEditProvider(N,z,K,Z){const fe=this.t(new B(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(fe,this.o(z),Z,N.identifier),this.p(fe)}$provideOnTypeFormattingEdits(N,z,K,Z,fe,Se){return this.s(N,B,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(z),K,Z,fe,Se),void 0,Se)}registerWorkspaceSymbolProvider(N,z){const K=this.t(new U(z,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,z,K){return this.s(N,U,Z=>Z.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,z,K){return this.s(N,U,Z=>Z.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(N,z){this.s(N,U,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(N,z,K){const Z=this.t(new j(this.h,K,this.l),N);return this.e.$registerRenameSupport(Z,this.o(z),j.supportsResolving(K)),this.p(Z)}$provideRenameEdits(N,z,K,Z,fe){return this.s(N,j,Se=>Se.provideRenameEdits(a.URI.revive(z),K,Z,fe),void 0,fe)}$resolveRenameLocation(N,z,K,Z){return this.s(N,j,fe=>fe.resolveRenameLocation(a.URI.revive(z),K,Z),void 0,Z)}registerDocumentSemanticTokensProvider(N,z,K,Z){const fe=this.t(new ie(this.h,K),N),Se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(z),Z,Se);let Ae=this.p(fe);if(Se){const we=K.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(Se));Ae=R.Disposable.from(Ae,we)}return Ae}$provideDocumentSemanticTokens(N,z,K,Z){return this.s(N,ie,fe=>fe.provideDocumentSemanticTokens(a.URI.revive(z),K,Z),null,Z)}$releaseDocumentSemanticTokens(N,z){this.s(N,ie,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,z,K,Z){const fe=this.t(new V(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(z),Z),this.p(fe)}$provideDocumentRangeSemanticTokens(N,z,K,Z){return this.s(N,V,fe=>fe.provideDocumentRangeSemanticTokens(a.URI.revive(z),K,Z),null,Z)}registerCompletionItemProvider(N,z,K,Z){const fe=this.t(new J(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(fe,this.o(z),Z,J.supportsResolving(K),`${N.identifier.value}(${Z.join("")})`),this.p(fe)}$provideCompletionItems(N,z,K,Z,fe){return this.s(N,J,Se=>Se.provideCompletionItems(a.URI.revive(z),K,Z,fe),void 0,fe)}$resolveCompletionItem(N,z,K){return this.s(N,J,Z=>Z.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(N,z){this.s(N,J,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(N,z,K){const Z=new ve(N,this.h,K,this.j.converter),fe=this.t(Z,N);return this.e.$registerInlineCompletionsSupport(fe,this.o(z),Z.supportsHandleEvents),this.p(fe)}$provideInlineCompletions(N,z,K,Z,fe){return this.s(N,re,Se=>Se.provideInlineCompletions(a.URI.revive(z),K,Z,fe),void 0,fe)}$handleInlineCompletionDidShow(N,z,K){this.s(N,re,async Z=>{Z.handleDidShowCompletionItem(z,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,z,K,Z){this.s(N,re,async fe=>{fe.handlePartialAccept(z,K,Z)},void 0,void 0)}$freeInlineCompletionsList(N,z){this.s(N,re,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(N,z,K,Z){const fe=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,Se=this.t(new le(this.h,K),N);return this.e.$registerSignatureHelpProvider(Se,this.o(z),fe),this.p(Se)}$provideSignatureHelp(N,z,K,Z,fe){return this.s(N,le,Se=>Se.provideSignatureHelp(a.URI.revive(z),K,Z,fe),void 0,fe)}$releaseSignatureHelp(N,z){this.s(N,le,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(N,z,K){const Z=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new q(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(fe,this.o(z),typeof K.resolveInlayHint=="function",Z,ce.u(N));let Se=this.p(fe);if(Z!==void 0){const Ae=K.onDidChangeInlayHints(we=>this.e.$emitInlayHintsEvent(Z));Se=R.Disposable.from(Se,Ae)}return Se}$provideInlayHints(N,z,K,Z){return this.s(N,q,fe=>fe.provideInlayHints(a.URI.revive(z),K,Z),void 0,Z)}$resolveInlayHint(N,z,K){return this.s(N,q,Z=>Z.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(N,z){this.s(N,q,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(N,z,K){const Z=this.t(new F(this.h,K),N);return this.e.$registerDocumentLinkProvider(Z,this.o(z),typeof K.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(N,z,K){return this.s(N,F,Z=>Z.provideLinks(a.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(N,z,K){return this.s(N,F,Z=>Z.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(N,z){this.s(N,F,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(N,z,K){const Z=this.t(new Q(this.h,K),N);return this.e.$registerDocumentColorProvider(Z,this.o(z)),this.p(Z)}$provideDocumentColors(N,z,K){return this.s(N,Q,Z=>Z.provideColors(a.URI.revive(z),K),[],K)}$provideColorPresentations(N,z,K,Z){return this.s(N,Q,fe=>fe.provideColorPresentations(a.URI.revive(z),K,Z),void 0,Z)}registerFoldingRangeProvider(N,z,K){const Z=this.q(),fe=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new ee(new me(this.h,K),N)),this.e.$registerFoldingRangeProvider(Z,this.o(z),N.identifier,fe);let Se=this.p(Z);if(fe!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));Se=R.Disposable.from(Se,Ae)}return Se}$provideFoldingRanges(N,z,K,Z){return this.s(N,me,fe=>fe.provideFoldingRanges(a.URI.revive(z),K,Z),void 0,Z)}registerSelectionRangeProvider(N,z,K){const Z=this.t(new Ee(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(Z,this.o(z)),this.p(Z)}$provideSelectionRanges(N,z,K,Z){return this.s(N,Ee,fe=>fe.provideSelectionRanges(a.URI.revive(z),K,Z),[],Z)}registerCallHierarchyProvider(N,z,K){const Z=this.t(new te(this.h,K),N);return this.e.$registerCallHierarchyProvider(Z,this.o(z)),this.p(Z)}$prepareCallHierarchy(N,z,K,Z){return this.s(N,te,fe=>Promise.resolve(fe.prepareSession(a.URI.revive(z),K,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(N,z,K,Z){return this.s(N,te,fe=>fe.provideCallsTo(z,K,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(N,z,K,Z){return this.s(N,te,fe=>fe.provideCallsFrom(z,K,Z),void 0,Z)}$releaseCallHierarchy(N,z){this.s(N,te,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(N,z,K){const Z=this.t(new ne(this.h,K),N);return this.e.$registerTypeHierarchyProvider(Z,this.o(z)),this.p(Z)}$prepareTypeHierarchy(N,z,K,Z){return this.s(N,ne,fe=>Promise.resolve(fe.prepareSession(a.URI.revive(z),K,Z)),void 0,Z)}$provideTypeHierarchySupertypes(N,z,K,Z){return this.s(N,ne,fe=>fe.provideSupertypes(z,K,Z),void 0,Z)}$provideTypeHierarchySubtypes(N,z,K,Z){return this.s(N,ne,fe=>fe.provideSubtypes(z,K,Z),void 0,Z)}$releaseTypeHierarchy(N,z){this.s(N,ne,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(N,z,K){const Z=this.q();return this.f.set(Z,new ee(new de(this.e,this.h,K,Z),N)),this.e.$registerDocumentOnDropEditProvider(Z,this.o(z)),this.p(Z)}$provideDocumentOnDropEdits(N,z,K,Z,fe,Se){return this.s(N,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(z,a.URI.revive(K),Z,fe,Se)),void 0,void 0)}registerDocumentPasteEditProvider(N,z,K,Z){const fe=this.q();return this.f.set(fe,new ee(new _(this.e,this.h,K,fe),N)),this.e.$registerPasteEditProvider(fe,this.o(z),!!K.prepareDocumentPaste,Z.pasteMimeTypes),this.p(fe)}$prepareDocumentPaste(N,z,K,Z,fe){return this.s(N,_,Se=>Se.prepareDocumentPaste(a.URI.revive(z),K,Z,fe),void 0,fe)}$providePasteEdits(N,z,K,Z,fe,Se){return this.s(N,_,Ae=>Ae.providePasteEdits(z,a.URI.revive(K),Z,fe,Se),void 0,Se)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,z,K){const{wordPattern:Z}=K;if(Z&&(0,y.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(z,Z):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const fe=this.q(),Se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ce.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ce.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ce.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(fe,z,Se),this.p(fe)}$setWordDefinitions(N){for(const z of N)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(Ce[270],Ie([1,0,5,13,7,37,19,6]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,I,S,k){this.c=I,this.d=S,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,I){await this.a.$changeLanguage(L,I);const S=this.c.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,I){const S=L.version,k=A.Position.from(I),C=await this.a.$tokensAtPosition(L.uri,k),E={type:u.StandardTokenType.Other,range:L.getWordRangeAtPosition(I)??new u.Range(I.line,I.character,I.line,I.character)};if(!C)return E;const r={range:A.Range.to(C.range),type:A.TokenType.to(C.type)};return!r.range.contains(I)||S!==L.version?E:r}createLanguageStatusItem(L,I,S){const k=this.f++,C=this.a,E=this.g,r=`${L.identifier.value}/${I}`;if(E.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);E.add(r);const d={selector:S,id:I,name:L.displayName??L.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let f;const g=new T.DisposableStore,D=()=>{f?.dispose(),f=(0,P.disposableTimeout)(()=>{g.clear(),this.a.$setLanguageStatus(k,{id:r,name:d.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===u.LanguageStatusSeverity.Error?R.default.Error:d.severity===u.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this.d.toInternal(d.command,g),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},p={dispose(){g.dispose(),f?.dispose(),C.$removeLanguageStatus(k),E.delete(r)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,D()},get selector(){return d.selector},set selector(t){d.selector=t,D()},get text(){return d.text},set text(t){d.text=t,D()},get detail(){return d.detail},set detail(t){d.detail=t,D()},get severity(){return d.severity},set severity(t){d.severity=t,D()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,D()},get command(){return d.command},set command(t){d.command=t,D()},get busy(){return d.busy},set busy(t){d.busy=t,D()}};return D(),p}}e.ExtHostLanguages=y}),define(Ce[98],Ie([1,0,11,8,2,4,16,5,26,20]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(S,k,C){this.f=C,this.d=new Map,this.a=k.getProxy(T.MainContext.MainThreadLocalization),this.b=S.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(S,k){const{message:C,args:E,comment:r}=k;if(this.c)return(0,A.format2)(C,E??{});let d=C;r&&r.length>0&&(d+=`/${Array.isArray(r)?r.join(""):r}`);const f=this.d.get(S)?.contents[d];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(f??C,E??{})}getBundle(S){return this.d.get(S)?.contents}getBundleUri(S){return this.d.get(S)?.uri}async initializeLocalizedMessages(S){if(this.c||!S.l10n&&!S.isBuiltin||this.d.has(S.identifier.value))return;let k;const C=await this.g(S);if(!C){this.f.error(`No bundle location found for extension ${S.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(C),r=JSON.parse(E);k=S.isBuiltin?r.contents?.bundle:r}catch(E){this.f.error(`Failed to load translations for ${S.identifier.value} from ${C}: ${E.message}`);return}k&&this.d.set(S.identifier.value,{contents:k,uri:C})}async g(S){if(S.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(S.identifier.value,this.b);return u.URI.revive(k)}return S.l10n?u.URI.joinPath(S.extensionLocation,S.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=Ve([We(0,y.IExtHostInitDataService),We(1,m.IExtHostRpcService),We(2,P.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(Ce[141],Ie([1,0,16,5,26,20,2,70]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends a.AbstractLoggerService{constructor(I,S){super(S.logLevel,S.logsLocation,S.loggers.map(k=>(0,T.revive)(k))),this.n=I.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(I,S){S?this.setLogLevel(P.URI.revive(S),I):this.setLogLevel(I)}setVisibility(I,S){super.setVisibility(I,S),this.n.$setVisibility(I,S)}m(I,S,k){return new m(this.n,I,S,k)}};y=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class m extends a.AbstractMessageLogger{constructor(I,S,k,C){super(C?.logLevel==="always"),this.m=I,this.n=S,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger(S,C).then(()=>{this.q(this.l),this.k=!0})}g(I,S){const k=[[I,S]];this.k?this.q(k):this.l.push(...k)}q(I){this.m.$log(this.n,I)}}}),define(Ce[271],Ie([1,0,5,16,27]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(T){return T&&T.title}let P=class{constructor(y,m){this.b=m,this.a=y.getProxy(a.MainContext.MainThreadMessageService)}showMessage(y,m,L,I,S){const k={source:{identifier:y.identifier,label:y.displayName||y.name}};let C;typeof I=="string"||R(I)?C=[I,...S]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,C=S),k.useCustom&&(0,u.checkProposedApiEnabled)(y,"resolvers");const E=[];for(let r=0;r<C.length;r++){const d=C[r];if(typeof d=="string")E.push({title:d,handle:r,isCloseAffordance:!1});else if(typeof d=="object"){const{title:f,isCloseAffordance:g}=d;E.push({title:f,isCloseAffordance:!!g,handle:r})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(m,L,k,E).then(r=>{if(typeof r=="number")return C[r]})}};P=Ve([We(1,A.ILogService)],P),e.ExtHostMessageService=P}),define(Ce[272],Ie([1,0,22,3,6,28,8,9,2,75,5,40,13,7,58,245,137]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,D,p,t){this.q=p,this.r=t,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new m.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=g.getProxy(L.MainContext.MainThreadNotebook),this.c=g.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=g.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,c=o.cell.handle,v=this.g.get(s)?.getCell(c);if(v)return v.apiCell}if(o&&o.$mid===14){const s=o.uri,c=this.g.get(s);if(c)return c.apiNotebook}return o}}),d.x(D)}getEditorById(g){const D=this.h.get(g);if(!D)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(g){for(const[D,p]of this.h)if(p.apiEditor===g)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,D){const p=this.g.get(g);if(!p&&!D)throw new Error(`NO notebook document for '${g}'`);return p}static s(g,D){if(!D)return;const p=D.filenamePattern.map(t=>S.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(D.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:D.displayName,filenamePattern:p,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,D,p){const t=d.a++,o=typeof p.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(t,p),this.b.$registerNotebookCellStatusBarItemProvider(t,o,D);let s;return o!==void 0&&(s=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(o))),new k.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,o),s?.dispose()})}async createNotebookDocument(g){const D=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&S.NotebookData.from(g.content)});return y.URI.revive(D)}async openNotebookDocument(g){const D=this.g.get(g);if(D)return D.apiNotebook;const p=await this.c.$tryOpenNotebook(g),t=this.g.get(y.URI.revive(p));return(0,T.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(g,D){y.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let p;typeof D=="object"?p={position:S.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(S.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,p),o=t&&this.h.get(t)?.apiEditor;if(o)return o;throw t?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,D,p,t){const o=this.f.get(g),s=y.URI.revive(D),c=this.g.get(s);if(!c||!o)return;const l=c.getCellFromIndex(p);if(!l)return;const v=await o.provideCellStatusBarItems(l.apiCell,t);if(!v)return;const i=new u.DisposableStore,n=this.p.add([i]),w=(Array.isArray(v)?v:[v]).map(b=>S.NotebookStatusBarItem.from(b,this.i,i));return{cacheId:n,items:w}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,D,p,t,o){if((0,P.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,p),this.b.$registerNotebookSerializer(s,{id:g.identifier,location:g.extensionLocation},D,S.NotebookDocumentContentOptions.from(t),d.s(g,o)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(g,D,p){const t=this.u.get(g);if(!t)throw new Error("NO serializer found");const o=await t.deserializeNotebook(D.buffer,p);return new C.SerializableObjectWithBuffers(S.NotebookData.from(o))}async $notebookToData(g,D,p){const t=this.u.get(g);if(!t)throw new Error("NO serializer found");const o=await t.serializeNotebook(S.NotebookData.to(D.value),p);return a.VSBuffer.wrap(o)}w(g,D,p){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const t=new r.ExtHostNotebookEditor(D,this.d,g,p.visibleRanges.map(S.NotebookRange.to),p.selections.map(S.NotebookRange.to),typeof p.viewColumn=="number"?S.ViewColumn.to(p.viewColumn):void 0);this.h.set(D,t)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const p of g.value.removedDocuments){const t=y.URI.revive(p),o=this.g.get(t);o&&(o.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(o.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===t.toString()&&this.h.delete(s.id)}if(g.value.addedDocuments){const p=[];for(const t of g.value.addedDocuments){const o=y.URI.revive(t.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new E.ExtHostNotebookDocument(this.c,this.q,this.r,o,t);p.push(...t.cells.map(c=>E.ExtHostCell.asModelAddData(s.apiNotebook,c))),this.g.get(o)?.dispose(),this.g.set(o,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(s.apiNotebook)}}if(g.value.addedEditors)for(const p of g.value.addedEditors){if(this.h.has(p.id))return;const t=y.URI.revive(p.documentUri),o=this.g.get(t);o&&this.w(o,p.id,p)}const D=[];if(g.value.removedEditors)for(const p of g.value.removedEditors){const t=this.h.get(p);t&&(this.h.delete(p),this.k?.id===t.id&&(this.k=void 0),D.push(t))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const p=new Set;this.l.forEach(t=>p.add(t.id));for(const t of this.h.values()){const o=p.has(t.id);t._acceptVisibility(o)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.h.get(g.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${g.value.newActiveEditor}`),this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(g){const D=I.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new I.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>a.VSBuffer.wrap(o))],new I.ApiCommandResult("Notebook Data",o=>S.NotebookData.to(o.value))),t=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new C.SerializableObjectWithBuffers(S.NotebookData.from(o)))],new I.ApiCommandResult("Bytes",o=>o.buffer));g.registerApiCommand(p),g.registerApiCommand(t)}}d.a=0,e.ExtHostNotebookController=d}),define(Ce[273],Ie([1,0,17,19,21,3,6,28,2,25,16,75,5,40,13,7,96,235,27,58]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(l,v,i,n,h){this.k=v,this.l=i,this.m=n,this.n=h,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new I.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(S.MainContext.MainThreadNotebookKernels);const w=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const O=this.l.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:O}}else if(b&&"notebookEditor"in b){const O=this.l.getIdByEditor(b.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return b})],k.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(l,v,i,n,h,w){for(const re of this.h.values())if(re.controller.id===v&&m.ExtensionIdentifier.equals(l.identifier,re.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const b=this.i++,O=this;this.n.trace(`NotebookController[${b}], CREATED by ${l.identifier.value}, ${v}`);const H=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${l.identifier}'`);let x=!1;const _=new P.DisposableStore,G=new R.Emitter,M=new R.Emitter,B={id:s(l.identifier,v),notebookType:i,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:w?w.map(C.NotebookRendererScript.from):[]};let U=h??H,j;this.a.$addKernel(b,B).catch(re=>{console.log(re),x=!0});let he=0;const ie=()=>{if(x)return;const re=++he;Promise.resolve().then(()=>{re===he&&this.a.$updateKernel(b,B)})},V=new T.ResourceMap,J={get id(){return v},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return B.label},set label(re){B.label=re??l.displayName??l.name,ie()},get detail(){return B.detail??""},set detail(re){B.detail=re,ie()},get description(){return B.description??""},set description(re){B.description=re,ie()},get kind(){return(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind??""},set kind(re){(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind=re,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(re){B.supportedLanguages=re,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(re){B.supportsExecutionOrder=re,ie()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(re){U=re??H},get interruptHandler(){return j},set interruptHandler(re){j=re,B.supportsInterrupt=Boolean(re),ie()},createNotebookCellExecution(re){if(x)throw new Error("notebook controller is DISPOSED");if(!V.has(re.notebook.uri))throw O.n.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return O._createNotebookCellExecution(re,s(l.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${b}], DISPOSED`),x=!0,this.h.delete(b),_.dispose(),G.dispose(),M.dispose(),this.a.$removeKernel(b))},updateNotebookAffinity(re,ve){ve===E.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(b,re.uri,ve)},onDidReceiveMessage:M.event,postMessage(re,ve){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),O.a.$postMessage(b,ve&&O.l.getIdByEditor(ve),re)},asWebviewUri(re){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),(0,r.asWebviewUri)(re,O.k.remote)}};return this.h.set(b,{extensionId:l.identifier,controller:J,onDidReceiveMessage:M,onDidChangeSelection:G,associatedNotebooks:V}),J}getIdByController(l){for(const[v,i]of this.h)if(i.controller===l)return s(i.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,v){const i=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(i,v);const h={dispose:()=>{this.c.delete(i),n.a.$removeKernelDetectionTask(i)}};return this.c.set(i,h),h}registerKernelSourceActionProvider(l,v,i){const n=this.f++,h=typeof i.onDidChangeNotebookKernelSourceActions=="function"?n:void 0,w=this;this.e.set(n,i),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(n,n,v);let b;return h!==void 0&&(b=i.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.e.delete(n),w.a.$removeKernelSourceActionProvider(n,n),b?.dispose()}}}async $provideKernelSourceActions(l,v){const i=this.e.get(l);if(i){const n=new P.DisposableStore;return this.g.add([n]),(await i.provideNotebookKernelSourceActions(v)??[]).map(w=>C.NotebookKernelSourceAction.from(w,this.m.converter,n))}return[]}$acceptNotebookAssociation(l,v,i){const n=this.h.get(l);if(n){const h=this.l.getNotebookDocument(y.URI.revive(v));i?n.associatedNotebooks.set(h.uri,!0):n.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,h.uri.toString(),i),n.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(v)),w=[];for(const b of i){const O=h.getCell(b);O&&w.push(O.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,h.uri.toString(),w.length),await n.controller.executeHandler.call(n.controller,w,h.apiNotebook,n.controller)}catch(b){this.n.error(`NotebookController[${l}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(v));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,h.apiNotebook);else for(const w of i){const b=h.getCell(w);b&&this.b.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getEditorById(v);n.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(l,v,i){const h=this.l.getNotebookDocument(y.URI.revive(l)).getCell(v);if(h){const w=i?C.NotebookCellExecutionState.to(i):E.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:h.apiCell,state:w})}}_createNotebookCellExecution(l,v){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const h=new t(v,n,this.a);this.b.set(n.uri,h);const w=h.onDidChangeState(()=>{h.state===p.Resolved&&(h.dispose(),w.dispose(),this.b.delete(n.uri))});return h.asApiObject()}};D=Ve([We(4,L.ILogService)],D),e.ExtHostNotebookKernels=D;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class t extends P.Disposable{get state(){return this.f}constructor(l,v,i){super(),this.j=v,this.k=i,this.b=t.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.D(new u.CancellationTokenSource),this.h=new o(10,n=>this.m(n)),this.i=v.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const v=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new g.SerializableObjectWithBuffers(v))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(l){let v=this.j;if(l&&(v=this.j.notebook.getCellFromApiCell(l)),!v)throw new Error("INVALID cell");return v.handle}r(l){return l.map(v=>{const i=E.NotebookCellOutput.ensureUniqueMimeTypes(v.items,!0);return i===v.items?C.NotebookCellOutput.from(v):C.NotebookCellOutput.from({items:i,id:v.id,metadata:v.metadata})})}async s(l,v,i){const n=this.q(v),h=this.r((0,a.asArray)(l));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:n,append:i,outputs:h})}async t(l,v,i){return l=E.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(l),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(C.NotebookCellOutputItem.from),outputId:v.id,append:i})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(i){l.i=i,l.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(i){if(l.f===p.Resolved||l.f===p.Started)throw new Error("Cannot call start again");l.f=p.Started,l.c.fire(),l.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,n){if(l.f===p.Resolved)throw new Error("Cannot call resolve twice");l.f=p.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new g.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:i}))},clearOutput(i){return l.n(),l.s([],i,!1)},appendOutput(i,n){return l.n(),l.s(i,n,!0)},replaceOutput(i,n){return l.n(),l.s(i,n,!1)},appendOutputItems(i,n){return l.n(),l.t(i,n,!0)},replaceOutputItems(i,n){return l.n(),l.t(i,n,!1)}})}}t.a=0;class o{constructor(l,v){this.d=l,this.e=v,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const v=this.a;return this.a=[],this.e(v).finally(()=>l.complete())}}function s(c,l){return`${c.value}/${l}`}e.createKernelId=s}),define(Ce[274],Ie([1,0,3,5,137]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(T,y){this.c=y,this.a=new Map,this.b=T.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,y,m){const L=this.c.getEditorById(T);this.a.get(y)?.fire({editor:L.apiEditor,message:m})}createRendererMessaging(T,y){if(!T.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,I,S)=>this.d(y).event(L,I,S),postMessage:(L,I)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const S=I&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.b.$postMessage(S?.id,y,L)}}}d(T){let y=this.a.get(T);return y||(y=new a.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(T)}}),this.a.set(T,y),y)}}e.ExtHostNotebookRenderers=R}),define(Ce[275],Ie([1,0,6,9,2,27,5]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class T{constructor(m){this.b=new Map,this.a=m.getProxy(P.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,L,I){if((0,R.checkProposedApiEnabled)(m,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,I),this.a.$registerProfileContentHandler(L,I.name,I.description,m.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(m,L,I,S){const k=this.b.get(m);if(!k)throw new Error(`Unknown handler with id: ${m}`);return k.saveProfile(L,I,S)}async $readProfile(m,L,I){const S=this.b.get(m);if(!S)throw new Error(`Unknown handler with id: ${m}`);return S.readProfile((0,A.isString)(L)?L:u.URI.revive(L),I)}}e.ExtHostProfileContentHandlers=T}),define(Ce[276],Ie([1,0,2,5,19,13]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class P{constructor(y,m){this.d=m,this.c=new Map,this.b=y.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,m,L){const I=a.URI.revive(m),S=this.c.get(y);return S?(0,u.asPromise)(()=>S.provideOriginalResource(I,L)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,L,I){const S=P.a++;return this.c.set(S,m),this.b.$registerQuickDiffProvider(S,R.DocumentSelector.from(y,this.d),L,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(S),this.c.delete(S)}}}}P.a=0,e.ExtHostQuickDiff=P}),define(Ce[277],Ie([1,0,21,3,6,5,2,7,10,17,37,52,27,13]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(E,r,d){const f=E.getProxy(R.MainContext.MainThreadQuickOpen);class g{constructor(i,n){this.e=new Map,this.f=0,this.a=i,this.b=n}showQuickPick(i,n,h,w=a.CancellationToken.None){this.c=void 0;const b=Promise.resolve(n),O=++this.f,H=f.$show(O,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),x={},_=H.then(()=>x);return Promise.race([_,b]).then(G=>{if(G===x)return;const M=(0,S.isProposedApiEnabled)(i,"quickPickItemTooltip");return b.then(B=>{const U=[];for(let j=0;j<B.length;j++){const he=B[j];typeof he=="string"?U.push({label:he,handle:j}):he.kind===T.QuickPickItemKind.Separator?U.push({type:"separator",label:he.label}):(he.tooltip&&!M&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),U.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:M?k.MarkdownString.fromStrict(he.tooltip):void 0,handle:j}))}return h&&typeof h.onDidSelectItem=="function"&&(this.c=j=>{h.onDidSelectItem(B[j])}),f.$setItems(O,U),H.then(j=>{if(typeof j=="number")return B[j];if(Array.isArray(j))return j.map(he=>B[he])})})}).then(void 0,G=>{if(!(0,y.isCancellationError)(G))return f.$setError(O,G),Promise.reject(G)})}$onItemSelected(i){this.c?.(i)}showInput(i,n=a.CancellationToken.None){return this.d=i?.validateInput,f.$input(i,typeof this.d=="function",n).then(void 0,h=>{if(!(0,y.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(i){if(!this.d)return;const n=await this.d(i);if(!n||typeof n=="string")return n;let h;switch(n.severity){case T.InputBoxValidationSeverity.Info:h=L.default.Info;break;case T.InputBoxValidationSeverity.Warning:h=L.default.Warning;break;case T.InputBoxValidationSeverity.Error:h=L.default.Error;break;default:h=n.message?L.default.Error:L.default.Ignore;break}return{content:n.message,severity:h}}async showWorkspaceFolderPick(i,n=a.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(!!w)return w.find(b=>b.uri.toString()===h.uri.toString())}createQuickPick(i){const n=new c(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}createInputBox(i){const n=new l(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}$onDidChangeValue(i,n){this.e.get(i)?._fireDidChangeValue(n)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,n){const h=this.e.get(i);h instanceof c&&h._fireDidChangeActive(n)}$onDidChangeSelection(i,n){const h=this.e.get(i);h instanceof c&&h._fireDidChangeSelection(n)}$onDidTriggerButton(i,n){this.e.get(i)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(i,n,h){const w=this.e.get(i);w instanceof c&&w._fireDidTriggerItemButton(n,h)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class D{constructor(i,n){this.x=i,this.y=n,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((n,h)=>{const w=n===T.QuickInputButtons.Back?-1:h;this.o.set(w,n)}),this.z({buttons:i.map((n,h)=>({...s(n),tooltip:n.tooltip,handle:n===T.QuickInputButtons.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const n=this.o.get(i);n&&this.r.fire(n)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(i){if(!this.v){for(const n of Object.keys(i)){const h=i[n];this.u[n]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}D.a=1;function p(v){if(v instanceof T.ThemeIcon)return{id:v.id};const i=o(v),n=t(v);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof n=="string"?P.URI.file(n):n}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function o(v){return typeof v=="object"&&"dark"in v?v.dark:v}function s(v){const i=p(v.iconPath);let n,h;return"id"in i?h=I.ThemeIcon.asClassName(i):n=i,{iconPath:n,iconClass:h}}class c extends D{constructor(i,n){super(i.identifier,n),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((w,b)=>{this.C.set(b,w),this.D.set(w,b)});const n=(0,S.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<i.length;w++){const b=i[w];b.kind===T.QuickPickItemKind.Separator?h.push({type:"separator",label:b.label}):(b.tooltip&&!n&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),h.push({handle:w,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:n?k.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((O,H)=>({...s(O),tooltip:O.tooltip,handle:H}))}))}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(n=>this.D.has(n)),this.z({activeItems:this.J.map(n=>this.D.get(n))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(n=>this.D.has(n)),this.z({selectedItems:this.L.map(n=>this.D.get(n))})}_fireDidChangeActive(i){const n=(0,m.coalesce)(i.map(h=>this.C.get(h)));this.J=n,this.K.fire(n)}_fireDidChangeSelection(i){const n=(0,m.coalesce)(i.map(h=>this.C.get(h)));this.L=n,this.M.fire(n)}_fireDidTriggerItemButton(i,n){const h=this.C.get(i);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[n];w&&this.N.fire({button:w,item:h})}}class l extends D{constructor(i,n){super(i.identifier,n),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:L.default.Error}):this.z({validationMessage:i.message,severity:i.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new g(r,d)}e.createExtHostQuickOpen=C});var Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)},Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a};define(Ce[278],Ie([1,0,2,3,62,6,19,5,17,109,16,25,52,13,27]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C){"use strict";var E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(n){if(n)return typeof n.iconPath=="string"?a.URI.file(n.iconPath):a.URI.isUri(n.iconPath)||S.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function f(n,h){if(!n.iconPath&&!h.iconPath)return 0;if(n.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof n.iconPath=="string"?n.iconPath:a.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,b=typeof h.iconPath=="string"?h.iconPath:a.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,m.comparePaths)(w,b)}function g(n,h){let w=0;if(n.strikeThrough!==h.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==h.faded)return n.faded?1:-1;if(n.tooltip!==h.tooltip)return(n.tooltip||"").localeCompare(h.tooltip||"");if(w=f(n,h),w!==0)return w;if(n.light&&h.light)w=f(n.light,h.light);else{if(n.light)return 1;if(h.light)return-1}if(w!==0)return w;if(n.dark&&h.dark)w=f(n.dark,h.dark);else{if(n.dark)return 1;if(h.dark)return-1}return w}function D(n,h){if(n.command!==h.command)return n.command<h.command?-1:1;if(n.title!==h.title)return n.title<h.title?-1:1;if(n.tooltip!==h.tooltip){if(n.tooltip!==void 0&&h.tooltip!==void 0)return n.tooltip<h.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(n.arguments===h.arguments)return 0;if(n.arguments)if(h.arguments){if(n.arguments.length!==h.arguments.length)return n.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<n.arguments.length;w++){const b=n.arguments[w],O=h.arguments[w];if(b!==O)return b<O?-1:1}return 0}function p(n,h){let w=(0,m.comparePaths)(n.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(n.command&&h.command)w=D(n.command,h.command);else{if(n.command)return 1;if(h.command)return-1}if(w!==0)return w;if(n.decorations&&h.decorations)w=g(n.decorations,h.decorations);else{if(n.decorations)return 1;if(h.decorations)return-1}return w}function t(n,h){for(let w=0;w<n.length;w++)if(n[w]!==h[w])return!1;return!0}function o(n,h){return n.command===h.command&&n.title===h.title&&n.tooltip===h.tooltip&&(n.arguments&&h.arguments?t(n.arguments,h.arguments):n.arguments===h.arguments)}function s(n,h){return(0,y.equals)(n,h,o)}class c{get value(){return this.d}set value(h){h=h??"",Me(this,E,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Me(this,E,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,C.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Me(this,E,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Me(this,E,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Me(this,E,"f").$setInputBoxVisibility(this.l,h))}constructor(h,w,b){this.k=h,this.l=b,E.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,E,w,"f")}showValidationMessage(h,w){(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,E,"f").$showValidationMessage(this.l,h,w)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=c,E=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,w,b,O,H){this.q=h,this.s=w,this.t=b,this.u=O,this.v=H,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,w){const b=this.h.get(h);return b?(0,P.asPromise)(()=>this.s.executeCommand(b.command,...b.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(p),b=(0,y.sortedDiff)(this.o,h,p).map(x=>{const _=x.toInsert.map(G=>{const M=this.e++;this.g.set(M,G);const B=G.resourceUri;let U;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"){const q=new R.DisposableStore;U=this.s.converter.toInternal(G.command,q),this.j.set(M,q)}else this.h.set(M,G.command);const j=d(G.decorations),he=G.decorations&&d(G.decorations.light)||j,ie=G.decorations&&d(G.decorations.dark)||j,V=[he,ie],J=G.decorations&&G.decorations.tooltip||"",re=G.decorations&&!!G.decorations.strikeThrough,ve=G.decorations&&!!G.decorations.faded,ue=G.contextValue||"";return{rawResource:[M,B,V,J,re,ve,ue,U],handle:M}});return{start:x.start,deleteCount:x.deleteCount,toInsert:_}}),O=b.map(({start:x,deleteCount:_,toInsert:G})=>[x,_,G.map(M=>M.rawResource)]),H=b.reverse();for(const{start:x,deleteCount:_,toInsert:G}of H){const M=G.map(U=>U.handle),B=this.n.splice(x,_,...M);for(const U of B)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=h,O}dispose(){this.l=!0,this.m.fire()}}l.d=0;class v{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Me(this,r,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,h?.label&&(0,C.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Me(this,r,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h,quickDiffLabel:h?.label})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Me(this,r,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new R.DisposableStore,this.l=h;const w=this.v.converter.toInternal(h,this.k.value);Me(this,r,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=h;const w=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(b=>b.map(O=>this.v.converter.toInternal(O,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Me(this,r,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&s(this.p,h))return;this.o.value=new R.DisposableStore,this.p=h;const w=(h||[]).map(b=>this.v.converter.toInternal(b,this.o.value));Me(this,r,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(h,w,b,O,H,x){this.u=h,this.v=b,this.w=O,this.x=H,this.y=x,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=v.d++,this.z=new Map,this.A=new Set,Je(this,r,w,"f"),this.f=new c(h,Me(this,r,"f"),this.t),Me(this,r,"f").$registerSourceControl(this.t,O,H,x)}createResourceGroup(h,w){const b=new l(Me(this,r,"f"),this.v,this.t,h,w),O=A.Event.once(b.onDidDispose)(()=>this.z.delete(b));return this.z.set(b,O),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const h=[],w=[];for(const[b,O]of this.z){O.dispose();const H=b.onDidUpdateResourceStates(()=>{this.A.add(b),this.eventuallyUpdateResourceStates()});A.Event.once(b.onDidDispose)(()=>{this.A.delete(b),H.dispose(),this.e.delete(b.handle),Me(this,r,"f").$unregisterGroup(this.t,b.handle)}),h.push([b.handle,b.id,b.label,b.features]);const x=b._takeResourceStateSnapshot();x.length>0&&w.push([b.handle,x]),this.e.set(b.handle,b)}Me(this,r,"f").$registerGroups(this.t,h,w),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(w=>{const b=w._takeResourceStateSnapshot();b.length!==0&&h.push([w.handle,b])}),h.length>0&&Me(this,r,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Me(this,r,"f").$unregisterSourceControl(this.t)}}r=new WeakMap,v.d=0,Ve([(0,u.debounce)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ve([(0,u.debounce)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let i=class un{get onDidChangeActiveProvider(){return this.j.event}constructor(h,w,b){this.l=w,this.m=b,this.g=new Map,this.h=new I.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=h.getProxy(T.MainContext.MainThreadSCM),this.f=h.getProxy(T.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const H=this.g.get(O.sourceControlHandle);if(!H)return O;const x=H.getResourceGroup(O.groupHandle);return x?x.getResourceState(O.handle):O}else if(O&&O.$mid===4){const H=this.g.get(O.sourceControlHandle);return H?H.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const H=this.g.get(O.handle);return H||O}return O}})}createSourceControl(h,w,b,O){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,b,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const H=un.d++,x=new v(h,this.e,this.l,w,b,O);this.g.set(H,x);const _=this.h.get(h.identifier)||[];return _.push(x),this.h.set(h.identifier,_),x}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this.h.get(h.identifier),b=w&&w[w.length-1];return b&&b.inputBox}$provideOriginalResource(h,w,b){const O=a.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",h,O.toString());const H=this.g.get(h);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(O,b)).then(x=>x||null)}$onInputBoxValueChange(h,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const b=this.g.get(h);return b&&b.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,b,O){this.m.trace("ExtHostSCM#$executeResourceCommand",h,w,b);const H=this.g.get(h);if(!H)return Promise.resolve(void 0);const x=H.getResourceGroup(w);return x?x.$executeResourceCommand(b,O):Promise.resolve(void 0)}$validateInput(h,w,b){this.m.trace("ExtHostSCM#$validateInput",h);const O=this.g.get(h);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>O.inputBox.validateInput(w,b)).then(H=>{if(!H)return Promise.resolve(void 0);const x=k.MarkdownString.fromStrict(H.message);return x?Promise.resolve([x,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};i.d=0,i=Ve([We(2,L.ILogService)],i),e.ExtHostSCM=i}),define(Ce[99],Ie([1,0,5,3,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(T){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,y){return this.a.$getPassword(T,y)}store(T,y,m){return this.a.$setPassword(T,y,m)}delete(T,y){return this.a.$deletePassword(T,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[279],Ie([1,0,7,5,184,6,13,9]),function(se,e,a,A,u,R,P,T){"use strict";var y,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(C,E,r,d,f=a.StatusBarAlignment.Left,g){y.set(this,void 0),m.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,y,C,"f"),Je(this,m,E,"f"),this.c=L.a++,this.e=r,this.f=d,this.g=f,this.h=this.u(g)}u(C){if(!!(0,T.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!L.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof C=="string"?this.r={fromApi:C,internal:Me(this,m,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Me(this,m,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Me(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let E;this.m?E=this.m:E=(0,u.localize)(0,null,this.e.displayName||this.e.name);let r=this.n;this.o&&(r=L.b.get(this.o.id));const d=P.MarkdownString.fromStrict(this.l);Me(this,y,"f").$setEntry(this.c,C,E,this.k,d,this.r?.internal,r,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,m=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class I{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const E={message:C};return this.b.unshift(E),this.c(),new a.Disposable(()=>{const r=this.b.indexOf(E);r>=0&&(this.b.splice(r,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class S{constructor(C,E){this.a=C.getProxy(A.MainContext.MainThreadStatusBar),this.b=E,this.c=new I(this)}createStatusBarEntry(C,E,r,d){return new L(this.a,this.b,C,E,r,d)}setStatusBarMessage(C,E){const r=this.c.setMessage(C);let d;return typeof E=="number"?d=setTimeout(()=>r.dispose(),E):typeof E<"u"&&E.then(()=>r.dispose(),()=>r.dispose()),new a.Disposable(()=>{r.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=S}),define(Ce[100],Ie([1,0,5,3,4]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(T,y){this.c=y,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,y){this.a.$registerExtensionStorageKeysToSync(T,y)}async initializeExtensionStorage(T,y,m){const L=await this.a.$initializeExtensionStorage(T,y);let I;return L&&(I=this.d(T,y,L)),I||m}setValue(T,y,m){return this.a.$setValue(T,y,m)}$acceptValue(T,y,m){const L=this.d(T,y,m);L&&this.b.fire({shared:T,key:y,value:L})}d(T,y,m){try{return JSON.parse(m)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${T}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(Ce[80],Ie([1,0,4,26,16,79,2]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(m,L,I){this.d=L,this.f=I,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(S=>this.c=S)}async g(m){return P.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,L=await this.g(m);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(m){if(this.c)return P.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return P.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([We(0,A.IExtHostInitDataService),We(1,u.ILogService),We(2,R.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Ce[41],Ie([1,0,3,5,4,2,20,6,7,186,10,218,21,30,219,52,9,19,13]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class g{constructor(i,n,h,w){this.k=i,this._id=n,this.l=h,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(O=>this.f=O);const b=this;this.value={get name(){return b.m||""},get processId(){return b.b},get creationOptions(){return b.l},get exitStatus(){return b.h},get state(){return b.j},sendText(O,H=!0){b.o(),b.k.$sendText(b._id,O,H)},show(O){b.o(),b.k.$show(b._id,O)},hide(){b.o(),b.k.$hide(b._id)},dispose(){b.a||(b.a=!0,b.k.$dispose(b._id))},get dimensions(){if(!(b.d===void 0||b.g===void 0))return{columns:b.d,rows:b.g}}}}async create(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,r.withNullAsUndefined)(i.shellPath),shellArgs:(0,r.withNullAsUndefined)(i.shellArgs),cwd:(0,r.withNullAsUndefined)(i.cwd),env:(0,r.withNullAsUndefined)(i.env),icon:(0,r.withNullAsUndefined)(c(i.iconPath)),color:E.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,r.withNullAsUndefined)(i.message),strictEnv:(0,r.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,r.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,r.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(i.location,n?.resolvedExtHostIdentifier),isTransient:(0,r.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,n,h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:E.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(i,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,n){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in i?{viewColumn:f.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,n){this.h=Object.freeze({code:i,reason:n})}setDimensions(i,n){return i===this.d&&n===this.g||i===0||n===0?!1:(this.d=i,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(n=>{n!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=g;class D{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,n){this.g.setDimensions?.({columns:i,rows:n})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let p=1,t=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new a.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new a.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(A.MainContext.MainThreadTerminalService),this.q=new C.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.D({dispose:()=>{for(const[h,w]of this.g)w.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,n){const h=new g(this.a,(0,k.generateUuid)(),i,i.name),w=new D(i.pty);return h.createExtensionTerminal(i.location,this.L(i,n).resolvedExtHostIdentifier,c(i.iconPath),l(i.color)).then(b=>{const O=this.M(b,w);this.h[b]=O}),this.f.push(h),h.value}L(i,n){if(n=n||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const w=this.f.find(b=>b.value===h);w&&(n.resolvedExtHostIdentifier=w._id)}}else i.location&&typeof i.location!="object"?n.location=i.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(i,n){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const w=new D(n),b=this.M(i,w);this.h[i]=b}async $acceptActiveTerminalChanged(i){const n=this.b;if(i===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const h=this.O(i);h&&(this.b=h,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,n){const h=this.O(i);h&&this.I.fire({terminal:h.value,data:n})}async $acceptTerminalDimensions(i,n,h){const w=this.O(i);w&&w.setDimensions(n,h)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(i,n,h){this.g.get(i)?.resize(n,h)}async $acceptTerminalTitleChange(i,n){const h=this.O(i);h&&(h.name=n)}async $acceptTerminalClosed(i,n,h){const w=this.Q(this.f,i);if(w!==null){const b=this.f.splice(w,1)[0];b.setExitStatus(n,h),this.z.fire(b.value)}}$acceptTerminalOpened(i,n,h,w){if(n){const H=this.Q(this.f,n);if(H!==null){this.f[H]._id=i,this.C.fire(this.terminals[H]),this.f[H].isOpen=!0;return}}const b={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:R.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},O=new g(this.a,i,b,h);this.f.push(O),this.C.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(i,n){this.O(i)?._setProcessId(n)}async $startExtensionTerminal(i,n){const h=this.O(i);if(!h)return{message:(0,m.localize)(0,null,i)};h.isOpen||await new Promise(b=>{const O=this.onDidOpenTerminal(async H=>{H===h.value&&(O.dispose(),b())})});const w=this.g.get(i);w?w.startSendingEvents(n):this.j[i]={initialDimensions:n}}M(i,n){const h=new T.DisposableStore;h.add(n.onProcessReady(b=>this.a.$sendProcessReady(i,b.pid,b.cwd))),h.add(n.onDidChangeProperty(b=>this.a.$sendProcessProperty(i,b))),this.q.startBuffering(i,n.onProcessData),h.add(n.onProcessExit(b=>this.N(i,b))),this.g.set(i,n);const w=this.j[i];return w&&n instanceof D&&(n.startSendingEvents(w.initialDimensions),delete this.j[i]),h}$acceptProcessAckDataEvent(i,n){this.g.get(i)?.acknowledgeDataEvent(n)}$acceptProcessInput(i,n){this.g.get(i)?.input(n)}$acceptTerminalInteraction(i){const n=this.O(i);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(i,n,h){try{this.g.get(i)?.resize(n,h)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(i,n){this.g.get(i)?.shutdown(n)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(n=>this.a.$sendProcessProperty(i,{type:"cwd",value:n}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.s.add(i),this.s.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.s.delete(i),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,n,h){if(this.u.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.u.set(n,h),this.a.$registerProfileProvider(n,i.identifier.value),new y.Disposable(()=>{this.u.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(i,n,h){if(this.v.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.v.set(i,h),this.a.$registerQuickFixProvider(i,n),new y.Disposable(()=>{this.v.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,n){const h=new S.CancellationTokenSource().token;if(h.isCancellationRequested)return;const w=this.v.get(i);if(!w)return;const b=await w.provideTerminalQuickFixes(n,h);if(b!==null)return b}async $createContributedProfileTerminal(i,n){const h=new S.CancellationTokenSource().token;let w=await this.u.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,n);return}this.createTerminalFromOptions(w.options,n)}}async $provideLinks(i,n){const h=this.O(i);if(!h)return[];this.w.delete(i),this.y.get(i)?.dispose(!0);const b=new S.CancellationTokenSource;this.y.set(i,b);const O=[],H={terminal:h.value,line:n},x=[];for(const M of this.s)x.push(d.Promises.withAsyncBody(async B=>{b.token.onCancellationRequested(()=>B({provider:M,links:[]}));const U=await M.provideTerminalLinks(H,b.token)||[];b.token.isCancellationRequested||B({provider:M,links:U})}));const _=await Promise.all(x);if(b.token.isCancellationRequested)return[];const G=new Map;for(const M of _)M&&M.links.length>0&&O.push(...M.links.map(B=>{const U={id:p++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return G.set(U.id,{provider:M.provider,link:B}),U}));return this.w.set(i,G),O}$activateLink(i,n){const h=this.w.get(i)?.get(n);!h||h.provider.handleTerminalLink(h.link)}N(i,n){this.q.stopBuffering(i),this.g.delete(i),delete this.j[i];const h=this.h[i];h&&(h.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,n)}O(i){return this.P(this.f,i)}P(i,n){const h=this.Q(i,n);return h!==null?i[h]:null}Q(i,n){let h=null;return i.some((w,b)=>w._id===n?(h=b,!0):!1),h}getEnvironmentVariableCollection(i){let n=this.l.get(i.identifier.value);return n||(n=new o,this.S(i.identifier.value,n)),n}R(i,n){const h=(0,I.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(i,n.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(n=>{const h=n[0],w=new o(n[1]);this.S(h,w)})}$acceptDefaultProfile(i,n){const h=this.m;this.m=i,this.n=n,h?.path!==i.path&&this.J.fire(i.path)}S(i,n){this.l.set(i,n),n.onDidChangeCollection(()=>{this.R(i,n)})}};t=Ve([We(1,P.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class o{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}d(i,n){const h=this.map.get(i);(!h||h.value!==n.value||h.type!==n.type)&&(this.map.set(i,n),this.b.fire())}get(i){return this.map.get(i)}forEach(i,n){this.map.forEach((h,w)=>i.call(n,w,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends t{constructor(i){super(!1,i)}createTerminal(i,n,h){throw new L.NotSupportedError}createTerminalFromOptions(i,n){throw new L.NotSupportedError}};s=Ve([We(0,P.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function c(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function l(v){return E.ThemeColor.isThemeColor(v)?v:void 0}});var Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)},Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a};define(Ce[280],Ie([1,0,17,19,22,21,3,63,68,6,23,9,30,5,20,138,13,7,57,95,76,27]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(M,B,U){this.j=U,this.c=new P.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(k.MainContext.MainThreadTesting),this.h=new H(this.f),this.g=new i(this.f),B.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const he=j,ie=he.tests[he.tests.length-1].item.extId;return this.d.get(f.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,E.toItemFromContext)(j)}})}createTestController(M,B,U,j){if(this.d.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const he=new m.DisposableStore,ie=he.add(new E.ExtHostTestItemCollection(B,U,this.j));ie.root.label=U;const V=new Map,J=this.f,re={items:ie.root.children,get label(){return U},set label(ue){U=ue,ie.root.label=ue,J.$updateController(B,{label:U})},get refreshHandler(){return j},set refreshHandler(ue){j=ue,J.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,le,q,F,Q,me)=>{let Ee=(0,y.hash)(ue);for(;V.has(Ee);)Ee++;return me!==void 0&&(0,p.checkProposedApiEnabled)(M,"testContinuousRun"),new x(this.f,V,B,Ee,ue,le,q,F,Q,me)},createTestItem(ue,le,q){return new E.TestItemImpl(B,ue,le,q)},createTestRun:(ue,le,q=!0)=>this.g.createTestRun(B,ie,ue,le,q),set resolveHandler(ue){ie.resolveHandler=ue},get resolveHandler(){return ie.resolveHandler},dispose:()=>{he.dispose()}};J.$registerTestController(B,U,!!j),he.add((0,m.toDisposable)(()=>J.$unregisterTestController(B)));const ve={controller:re,collection:ie,profiles:V};return this.d.set(B,ve),he.add((0,m.toDisposable)(()=>this.d.delete(B))),he.add(ie.onDidGenerateDiff(ue=>J.$publishDiff(B,ue.map(D.TestsDiffOp.serialize)))),re}createTestObserver(){return this.h.checkout()}async runTests(M,B=R.CancellationToken.None){const U=n(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(he=>f.TestId.fromExtHostTestItem(he,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:_[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(he=>he.id)},B)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,B,U){return(0,a.mapFind)(this.g.trackers,he=>he.id===M?he.getCoverage(B):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,B,U,j){return(0,a.mapFind)(this.g.trackers,ie=>ie.id===M?ie.getCoverage(B):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(M,B){this.d.get(M)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(M,B){await this.d.get(M)?.controller.refreshHandler?.(B)}$publishTestResults(M){this.results=Object.freeze(M.map(B=>(0,L.deepFreeze)(r.TestResults.to(B))).concat(this.results).sort((B,U)=>U.completedAt-B.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,B){const U=this.d.get(f.TestId.fromString(M).controllerId)?.collection;U&&(await U.expand(M,B<0?1/0:B),U.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(D.TestsDiffOp.deserialize))}async $runControllerTests(M,B){return Promise.all(M.map(U=>this.k(U,!1,B)))}async $startContinuousRun(M,B){const U=new R.CancellationTokenSource(B),j=await Promise.all(M.map(he=>this.k(he,!0,U.token)));return!B.isCancellationRequested&&!j.some(he=>he.error)&&await new Promise(he=>B.onCancellationRequested(he)),U.dispose(!0),j}async k(M,B,U){const j=this.d.get(M.controllerId);if(!j)return{};const{collection:he,profiles:ie}=j,V=ie.get(M.profileId);if(!V)return{};const J=M.testIds.map(le=>he.tree.get(le)).filter(I.isDefined),re=M.excludeExtIds.map(le=>j.collection.tree.get(le)).filter(I.isDefined).filter(le=>J.some(q=>q.fullId.compare(le.fullId)===2));if(!J.length)return{};const ve=new d.TestRunRequest2(J.some(le=>le.actual instanceof E.TestItemRootImpl)?void 0:J.map(le=>le.actual),re.map(le=>le.actual),V,B),ue=(0,D.isStartControllerTests)(M)&&this.g.prepareForMainThreadTestRun(ve,h.fromInternal(M,j.collection),U);try{return await V.runHandler(ve,U),{}}catch(le){return{error:String(le)}}finally{ue&&(ue.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};s=Ve([We(0,C.IExtHostRpcService)],s),e.ExtHostTesting=s;const c=1e4;var l;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(l||(l={}));class v extends m.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,B,U){super(),this.k=M,this.l=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new P.Emitter),this.onEnd=this.j.event,this.h=this.D(new R.CancellationTokenSource(U));const j=this.D(new A.RunOnceScheduler(()=>this.m(),c));this.D(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const B=this.k.id,U=this.k.controllerId,j=(0,S.generateUuid)(),he=new w(this.l,B,j),ie=ve=>(ue,...le)=>{if(J){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ue)||(this.q(ue),ve(ue,...le))},V=(ve,ue)=>{const le=ue instanceof Array?ue.map(r.TestMessage.from):[r.TestMessage.from(ue)];if(ve.uri&&ve.range){const q={range:r.Range.from(ve.range),uri:ve.uri};for(const F of le)F.location=F.location||q}this.l.$appendTestMessagesInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),le)};let J=!1;const re={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return he.coverageProvider},set coverageProvider(ve){he.coverageProvider=ve},enqueued:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),1)}),skipped:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),5)}),started:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),2)}),errored:ie((ve,ue,le)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),6,le)}),failed:ie((ve,ue,le)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),4,le)}),passed:ie((ve,ue)=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,this.k.controllerId).toString(),3,ue)}),appendOutput:(ve,ue,le)=>{J||(le&&(this.k.isIncluded(le)?this.q(le):le=void 0),this.l.$appendOutputToRun(B,j,u.VSBuffer.fromString(ve),ue&&r.location.from(ue),le&&f.TestId.fromExtHostTestItem(le,U).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(B,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:re,coverage:he}),this.l.$startedTestRunTask(B,{id:j,name:M,running:!0}),re}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(M){if(!(M instanceof E.TestItemImpl))throw new g.InvalidTestItemError(M.id);if(this.g.has(f.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const B=[],U=this.k.colllection.root;for(;;){const j=r.TestItem.from(M);if(B.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===U))break;M=M.parent||U}this.l.$addTestsToRun(this.k.controllerId,this.k.id,B)}}class i{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,B,U){return this.f(M,B,U)}cancelRunById(M){for(const B of this.c.values())if(B.id===M){B.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,B,U,j,he){const ie=this.c.get(U);if(ie)return ie.createRun(j);const V=h.fromPublic(M,B,U,he),J=n(U);this.d.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:J&&{group:_[J.kind],id:J.profileId},exclude:U.exclude?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[],id:V.id,include:U.include?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[B.root.id],persist:he});const re=this.f(U,V);return re.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),re.dispose()}),re.createRun(j)}f(M,B,U){const j=new v(B,this.d,U);return this.c.set(M,j),j.onEnd(()=>this.c.delete(M)),j}}e.TestRunCoordinator=i;const n=G=>{if(!!G.profile){if(!(G.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class h{static fromPublic(M,B,U,j){return new h(M,(0,S.generateUuid)(),U.include?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[M],U.exclude?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[],j,B)}static fromInternal(M,B){return new h(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,B)}constructor(M,B,U,j,he,ie){this.controllerId=M,this.id=B,this.isPersisted=he,this.colllection=ie,this.c=U.map(V=>V+"\0"),this.d=j.map(V=>V+"\0")}isIncluded(M){const B=f.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.d)if(B===U||B.startsWith(U))return!1;for(const U of this.c)if(B===U||B.startsWith(U))return!0;return!1}}e.TestRunDto=h;class w{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,B,U){this.f=M,this.g=B,this.h=U}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(B){throw this.d=void 0,B}}async resolveFileCoverage(M,B){const U=await this.d;let j=U?.[M];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[M]=await this.c.resolveFileCoverage?.(j,B)??j),j.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,r.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const B=f.TestId.parentId(M.item.extId);if(B&&this.g.has(B.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:B,f:U}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...B].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class O extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new P.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,B){return{...M,revived:r.TestItem.toPlain(M.item),depth:B?B.depth+1:0,children:new Set}}o(){return new b(this.q)}}class H{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(B=>B.revived)},dispose:(0,T.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new O;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class x{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?r.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,B,U,j,he,ie,V,J=!1,re=void 0,ve=!1){this.controllerId=U,this.profileId=j,this.d=he,this.kind=ie,this.runHandler=V,this.f=J,this._tag=re,this.g=ve,t.set(this,void 0),o.set(this,void 0),Je(this,t,M,"f"),Je(this,o,B,"f"),B.set(j,this);const ue=_[ie];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Me(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:U,tag:re?r.TestTag.namespace(this.controllerId,re.id):null,label:he,group:ue,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ve})}dispose(){Me(this,o,"f")?.delete(this.profileId)&&(Je(this,o,void 0,"f"),Me(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,t=new WeakMap,o=new WeakMap;const _={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ce[281],Ie([1,0,17,3,5,139,13,7]),function(se,e,a,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,I){this.i=I,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(u.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const I=this.i.allEditors();return L?I:I.map(S=>S.value)}async showTextDocument(L,I,S){let k;typeof I=="number"?k={position:P.ViewColumn.from(I),preserveFocus:S}:typeof I=="object"?k={position:P.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?P.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const C=await this.h.$tryShowTextDocument(L.uri,k),E=C&&this.i.getEditor(C);if(E)return E.value;throw C?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,I){return new R.TextEditorDecorationType(this.h,L,I).value}$acceptEditorPropertiesChanged(L,I){const S=this.i.getEditor(L);if(!S)throw new Error("unknown text editor");if(I.options&&S._acceptOptions(I.options),I.selections){const k=I.selections.selections.map(P.Selection.to);S._acceptSelections(k)}if(I.visibleRanges){const k=a.coalesce(I.visibleRanges.map(P.Range.to));S._acceptVisibleRanges(k)}if(I.options&&this.b.fire({textEditor:S.value,options:{...I.options,lineNumbers:P.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const k=T.TextEditorSelectionChangeKind.fromValue(I.selections.source),C=I.selections.selections.map(P.Selection.to);this.a.fire({textEditor:S.value,selections:C,kind:k})}if(I.visibleRanges){const k=a.coalesce(I.visibleRanges.map(P.Range.to));this.c.fire({textEditor:S.value,visibleRanges:k})}}$acceptEditorPositionData(L){for(const I in L){const S=this.i.getEditor(I);if(!S)throw new Error("Unknown text editor");const k=P.ViewColumn.to(L[I]);S.value.viewColumn!==k&&(S._acceptViewColumn(k),this.d.fire({textEditor:S.value,viewColumn:k}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(Ce[282],Ie([1,0,2,4,5,6,7,13,25,9]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(k,C){this.b=new Map,this.c=new Map,this.a=k.getProxy(u.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(E,r)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&y.ExtensionIdentifier.equals(r,this.b.get(E.source)?.extension)){const d=E.uri===void 0?void 0:a.URI.revive(E.uri);return this.c.get(E.source)?.get(I(d))?.get(E.handle)}else return;return E}})}async $getTimeline(k,C,E,r){return this.b.get(k)?.provider.provideTimeline(a.URI.revive(C),E,r)}registerTimelineProvider(k,C,E,r){const d=new R.DisposableStore,f=this.d(C.id,r,d).bind(this);let g;C.onDidChange&&(g=C.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:C.id}),this));const D=this.c;return this.f({...C,scheme:k,onDidChange:void 0,async provideTimeline(p,t,o){t?.resetCache&&(d.clear(),D.get(C.id)?.clear());const s=await C.provideTimeline(p,t,o);if(s==null)return;const c=f(p,t);return{...s,source:C.id,items:s.items.map(c)}},dispose(){for(const p of D.values())p.get(C.id)?.clear();g?.dispose(),d.dispose()}},E)}d(k,C,E){return(r,d)=>{let f;if(d?.cacheResults){let g=this.c.get(k);g===void 0&&(g=new Map,this.c.set(k,g));const D=I(r);f=g.get(D),f===void 0&&(f=new Map,g.set(D,f))}return g=>{const{iconPath:D,...p}=g,t=`${k}|${g.id??g.timestamp}`;f?.set(t,g);let o,s,c;g.iconPath&&(D instanceof P.ThemeIcon?c={id:D.id,color:D.color}:a.URI.isUri(D)?(o=D,s=D):{light:o,dark:s}=D);let l;return P.MarkdownString.isMarkdownString(p.tooltip)?l=T.MarkdownString.from(p.tooltip):(0,m.isString)(p.tooltip)?l=p.tooltip:P.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(p.detail)):(0,m.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.detail),{...p,id:p.id??void 0,handle:t,source:k,command:g.command?C.toInternal(g.command,E):void 0,icon:o,iconDark:s,themeIcon:c,tooltip:l,accessibilityInformation:g.accessibilityInformation}}}}f(k,C){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:C}),(0,R.toDisposable)(()=>{for(const r of this.c.values())r.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=L;function I(S){return S?.toString()}}),define(Ce[283],Ie([1,0,6,18,2,5]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,m,L,I){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const S=I.schemes.find(k=>!P.a.has(k));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this.c.set(m,L),this.b.$registerUriOpener(m,I.schemes,y,I.label),(0,a.toDisposable)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(y,m,L){const I=this.c.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const S=u.URI.revive(m);return I.canOpenExternalUri(S,L)}async $openUri(y,m,L){const I=this.c.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(u.URI.revive(m.resolvedUri),{sourceUri:u.URI.revive(m.sourceUri)},L)}}P.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=P}),define(Ce[284],Ie([1,0,5,2,6,10,25]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(m){this.c=new P.ExtensionIdentifierSet,this.d=new Map,this.b=m.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(m,L){if(this.c.has(m))throw new Error(`Protocol handler already registered for extension ${m}`);const I=T.a++;return this.c.add(m),this.d.set(I,L),this.b.$registerUriHandler(I,m),(0,u.toDisposable)(()=>{this.c.delete(m),this.d.delete(I),this.b.$unregisterUriHandler(I)})}$handleExternalUri(m,L){const I=this.d.get(m);if(!I)return Promise.resolve(void 0);try{I.handleUri(A.URI.revive(L))}catch(S){(0,R.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(m){return A.URI.revive(await this.b.$createAppUri(m))}}T.a=0,e.ExtHostUrls=T});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[81],Ie([1,0,3,18,23,2,202,227,96,5]),function(se,e,a,A,u,R,P,T,y,m){"use strict";var L,I,S,k,C,E,r,d,f,g,D,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(b,O,H,x,_,G,M){L.set(this,void 0),I.set(this,void 0),S.set(this,void 0),k.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,""),d.set(this,void 0),f.set(this,!1),g.set(this,!1),D.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new a.Emitter),this._onDidDispose=Me(this,t,"f").event,Je(this,L,b,"f"),Je(this,I,O,"f"),Je(this,d,H,"f"),Je(this,k,x,"f"),Je(this,C,_,"f"),Je(this,E,G,"f"),Je(this,D,s(G),"f"),Je(this,p,c(G),"f"),Je(this,S,M,"f")}dispose(){Je(this,f,!0,"f"),Me(this,t,"f").fire(),Me(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Je(this,g,!0,"f"),(0,y.asWebviewUri)(b,Me(this,k,"f"))}get cspSource(){const b=Me(this,E,"f").extensionLocation;if(b.scheme===A.Schemas.https||b.scheme===A.Schemas.http){let O=b.toString();return O.endsWith("/")||(O+="/"),O+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Me(this,r,"f")}set html(b){this.a(),Me(this,r,"f")!==b&&(Je(this,r,b,"f"),Me(this,p,"f")&&!Me(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Je(this,g,!0,"f"),Me(this,S,"f").report("Webview vscode-resource: uris",Me(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,I,"f").$setHtml(Me(this,L,"f"),this.b(b)))}get options(){return this.a(),Me(this,d,"f")}set options(b){this.a(),u.equals(Me(this,d,"f"),b)||Me(this,I,"f").$setOptions(Me(this,L,"f"),i(Me(this,E,"f"),Me(this,C,"f"),b)),Je(this,d,b,"f")}async postMessage(b){if(Me(this,f,"f"))return!1;const O=(0,T.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Me(this,D,"f")});return Me(this,I,"f").$postMessage(Me(this,L,"f"),O.message,...O.buffers)}a(){if(Me(this,f,"f"))throw new Error("Webview is disposed")}b(b){if(!Me(this,p,"f"))return b;const O=Me(this,E,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,H=Me(this,E,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Me(this,E,"f").extensionLocation.authority:void 0;return b.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,_,G,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,y.asWebviewUri)(j,{isRemote:O,authority:H}).toString();return`${_}${he}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,_,G,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,y.asWebviewUri)(j,{isRemote:O,authority:H}).toString();return`${_}${he}${U}`})}}e.ExtHostWebview=o,L=new WeakMap,I=new WeakMap,S=new WeakMap,k=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap,g=new WeakMap,D=new WeakMap,p=new WeakMap,t=new WeakMap;function s(w){try{const b=(0,P.normalizeVersion)((0,P.parseVersion)(w.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function c(w){try{const b=(0,P.normalizeVersion)((0,P.parseVersion)(w.engines.vscode));return b?b.majorBase<1||b.majorBase===1&&b.minorBase<60:!1}catch{return!1}}class l{constructor(b,O,H,x,_){this.c=O,this.d=H,this.e=x,this.f=_,this.b=new Map,this.a=b.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(b,O,H){const x=this.g(b);if(x){const{message:_}=(0,T.deserializeWebviewMessage)(O,H.value);x._onMessageEmitter.fire(_)}}$onMissingCsp(b,O){this.e.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,O,H){const x=new o(b,this.a,n(O),this.c,this.d,H,this.f);return this.b.set(b,x),x._onDidDispose(()=>{this.b.delete(b)}),x}deleteWebview(b){this.b.delete(b)}g(b){return this.b.get(b)}}e.ExtHostWebviews=l;function v(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=v;function i(w,b,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||h(w,b)}}e.serializeWebviewOptions=i;function n(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(b=>R.URI.from(b))}}function h(w,b){return[...(b?.getWorkspaceFolders()||[]).map(O=>O.uri),w.extensionLocation]}}),define(Ce[285],Ie([1,0,21,68,6,18,24,2,13,81,75,5,7]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this.a++;return(0,P.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,c){const l=this.b(o,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const v=new k(s,c);return this.a.set(l,v),v}delete(o,s){const c=this.b(o,s.uri);this.a.delete(c)}b(o,s){return`${o}@@@${s}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class r{constructor(){this.a=new Map}addTextProvider(o,s,c){return this.b(0,o,s,c)}addCustomProvider(o,s,c){return this.b(1,o,s,c)}get(o){return this.a.get(o)}b(o,s,c,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:c,provider:l}),new S.Disposable(()=>this.a.delete(s))}}class d{constructor(o,s,c,l,v){this.d=s,this.f=c,this.g=l,this.h=v,this.b=new r,this.c=new C,this.a=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,c,l){const v=new u.DisposableStore;return g(c)?(v.add(this.b.addTextProvider(s,o,c)),this.a.$registerTextEditorProvider((0,m.toExtensionData)(o),s,l.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(o))):(v.add(this.b.addCustomProvider(s,o,c)),f(c)&&v.add(c.onDidChangeCustomDocument(i=>{const n=this.i(s,i.document.uri);if(D(i)){const h=n.addEdit(i);this.a.$onDidEdit(i.document.uri,s,h,i.label)}else this.a.$onContentChange(i.document.uri,s)})),this.a.$registerCustomEditorProvider((0,m.toExtensionData)(o),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(v,new S.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,c,l,v){const i=this.b.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${s}'`);const n=T.URI.revive(o),h=await i.provider.openCustomDocument(n,{backupId:c,untitledDocumentData:l?.buffer},v);let w;return f(i.provider)&&this.f&&(w=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(s,h,w),{editable:f(i.provider)}}async $disposeCustomDocument(o,s){const c=this.b.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=T.URI.revive(o),{document:v}=this.i(s,l);this.c.delete(s,v),v.dispose()}async $resolveCustomEditor(o,s,c,l,v,i){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);const h=y.ViewColumn.to(v),w=this.g.createNewWebview(s,l.contentOptions,n.extension),b=this.h.createNewWebviewPanel(s,c,l.title,h,l.options,w,!0),O=T.URI.revive(o);switch(n.type){case 1:{const{document:H}=this.i(c,O);return n.provider.resolveCustomEditor(H,b,i)}case 0:{const H=this.d.getDocument(O);return n.provider.resolveCustomTextEditor(H,b,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,c){this.i(s,o).disposeEdits(c)}async $onMoveCustomEditor(o,s,c){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const v=this.h.getWebviewPanel(o);if(!v)throw new Error("No webview found");const i=T.URI.revive(s),n=this.d.getDocument(i);await l.provider.moveCustomTextEditor(n,v,a.CancellationToken.None)}async $undo(o,s,c,l){return this.i(s,o).undo(c,l)}async $redo(o,s,c,l){return this.i(s,o).redo(c,l)}async $revert(o,s,c){const l=this.i(s,o);await this.j(s).revertCustomDocument(l.document,c),l.disposeBackup()}async $onSave(o,s,c){const l=this.i(s,o);await this.j(s).saveCustomDocument(l.document,c),l.disposeBackup()}async $onSaveAs(o,s,c,l){const v=this.i(s,o);return this.j(s).saveCustomDocumentAs(v.document,T.URI.revive(c),l)}async $backup(o,s,c){const l=this.i(s,o),i=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},c);return l.updateBackup(i),i.id}i(o,s){const c=this.c.get(o,T.URI.revive(s));if(!c)throw new Error("No custom document found");return c}j(o){const c=this.b.get(o)?.provider;if(!c||!f(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=d;function f(t){return!!t.onDidChangeCustomDocument}function g(t){return typeof t.resolveCustomTextEditor=="function"}function D(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const o=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[286],Ie([1,0,3,6,2,30,13,81,5,7]),function(se,e,a,A,u,R,P,T,y,m){"use strict";var L,I,S,k,C,E,r,d,f,g,D,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(v,i,n,h){super(),L.set(this,void 0),I.set(this,void 0),S.set(this,void 0),k.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,void 0),d.set(this,void 0),f.set(this,!0),g.set(this,void 0),D.set(this,!1),p.set(this,this.D(new a.Emitter)),this.onDidDispose=Me(this,p,"f").event,t.set(this,this.D(new a.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,Je(this,L,v,"f"),Je(this,I,i,"f"),Je(this,k,n,"f"),Je(this,S,h.viewType,"f"),Je(this,C,h.panelOptions,"f"),Je(this,d,h.viewColumn,"f"),Je(this,E,h.title,"f"),Je(this,g,h.active,"f")}dispose(){Me(this,D,"f")||(Je(this,D,!0,"f"),Me(this,p,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,L,"f")),Me(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,k,"f")}get viewType(){return this.c(),Me(this,S,"f")}get title(){return this.c(),Me(this,E,"f")}set title(v){this.c(),Me(this,E,"f")!==v&&(Je(this,E,v,"f"),Me(this,I,"f").$setTitle(Me(this,L,"f"),v))}get iconPath(){return this.c(),Me(this,r,"f")}set iconPath(v){this.c(),Me(this,r,"f")!==v&&(Je(this,r,v,"f"),Me(this,I,"f").$setIconPath(Me(this,L,"f"),u.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Me(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,d,"f")=="number"&&Me(this,d,"f")<0))return Me(this,d,"f")}get active(){return this.c(),Me(this,g,"f")}get visible(){return this.c(),Me(this,f,"f")}_updateViewState(v){Me(this,D,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(Je(this,g,v.active,"f"),Je(this,f,v.visible,"f"),Je(this,d,v.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(v,i){this.c(),Me(this,I,"f").$reveal(Me(this,L,"f"),{viewColumn:typeof v>"u"?void 0:P.ViewColumn.from(v),preserveFocus:!!i})}c(){if(Me(this,D,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,S=new WeakMap,k=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap,g=new WeakMap,D=new WeakMap,p=new WeakMap,t=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(v,i,n){this.g=i,this.h=n,this.e=new Map,this.f=new Map,this.d=v.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(v,i,n,h,w={}){const b=typeof h=="object"?h.viewColumn:h,O={viewColumn:P.ViewColumn.from(b),preserveFocus:typeof h=="object"&&!!h.preserveFocus},H=(0,T.shouldSerializeBuffersForPostMessage)(v),x=s.c();this.d.$createWebviewPanel((0,T.toExtensionData)(v),x,i,{title:n,panelOptions:c(w),webviewOptions:(0,T.serializeWebviewOptions)(v,this.h,w),serializeBuffersForPostMessage:H},O);const _=this.g.createNewWebview(x,w,v);return this.createNewWebviewPanel(x,i,n,b,w,_,!0)}$onDidChangeWebviewPanelViewStates(v){const i=Object.keys(v);i.sort((n,h)=>{const w=v[n],b=v[h];return w.active?1:b.active?-1:+w.visible-+b.visible});for(const n of i){const h=this.getWebviewPanel(n);if(!h)continue;const w=v[n];h._updateViewState({active:w.active,visible:w.visible,viewColumn:P.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.e.delete(v),this.g.deleteWebview(v)}registerWebviewPanelSerializer(v,i,n){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:n,extension:v}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(v)}),new m.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(v,i,n,h){const w=this.f.get(i);if(!w)throw new Error(`No serializer found for '${i}'`);const{serializer:b,extension:O}=w,H=this.g.createNewWebview(v,n.webviewOptions,O),x=this.createNewWebviewPanel(v,i,n.title,h,n.panelOptions,H,n.active);await b.deserializeWebviewPanel(x,n.state)}createNewWebviewPanel(v,i,n,h,w,b,O){const H=new o(v,this.d,b,{viewType:i,title:n,viewColumn:h,panelOptions:w,active:O});return this.e.set(v,H),H}getWebviewPanel(v){return this.e.get(v)}}e.ExtHostWebviewPanels=s;function c(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[287],Ie([1,0,3,6,81,13,5,7]),function(se,e,a,A,u,R,P,T){"use strict";var y,m,L,I,S,k,C,E,r,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends A.Disposable{constructor(t,o,s,c,l,v){super(),y.set(this,void 0),m.set(this,void 0),L.set(this,void 0),I.set(this,void 0),S.set(this,!1),k.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,void 0),d.set(this,this.D(new a.Emitter)),this.onDidChangeVisibility=Me(this,d,"f").event,f.set(this,this.D(new a.Emitter)),this.onDidDispose=Me(this,f,"f").event,Je(this,L,s,"f"),Je(this,C,c,"f"),Je(this,y,t,"f"),Je(this,m,o,"f"),Je(this,I,l,"f"),Je(this,k,v,"f")}dispose(){Me(this,S,"f")||(Je(this,S,!0,"f"),Me(this,f,"f").fire(),Me(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,C,"f")}set title(t){this.a(),Me(this,C,"f")!==t&&(Je(this,C,t,"f"),Me(this,m,"f").$setWebviewViewTitle(Me(this,y,"f"),t))}get description(){return this.a(),Me(this,E,"f")}set description(t){this.a(),Me(this,E,"f")!==t&&(Je(this,E,t,"f"),Me(this,m,"f").$setWebviewViewDescription(Me(this,y,"f"),t))}get visible(){return Me(this,k,"f")}get webview(){return Me(this,I,"f")}get viewType(){return Me(this,L,"f")}_setVisible(t){t===Me(this,k,"f")||Me(this,S,"f")||(Je(this,k,t,"f"),Me(this,d,"f").fire())}get badge(){return this.a(),Me(this,r,"f")}set badge(t){this.a(),!(t?.value===Me(this,r,"f")?.value&&t?.tooltip===Me(this,r,"f")?.tooltip)&&(Je(this,r,R.ViewBadge.from(t),"f"),Me(this,m,"f").$setWebviewViewBadge(Me(this,y,"f"),t))}show(t){this.a(),Me(this,m,"f").$show(Me(this,y,"f"),!!t)}a(){if(Me(this,S,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,m=new WeakMap,L=new WeakMap,I=new WeakMap,S=new WeakMap,k=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap;class D{constructor(t,o){this.d=o,this.b=new Map,this.c=new Map,this.a=t.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,o,s,c){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:t}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(t),o,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(t,o,s,c,l){const v=this.b.get(o);if(!v)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:n}=v,h=this.d.createNewWebview(t,{},n),w=new g(t,this.a,o,s,h,!0);this.c.set(t,w),await i.resolveWebviewView(w,{state:c},l)}async $onDidChangeWebviewViewVisibility(t,o){this.e(t)._setVisible(o)}async $disposeWebviewView(t){const o=this.e(t);this.c.delete(t),o.dispose(),this.d.deleteWebview(t)}e(t){const o=this.c.get(t);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=D}),define(Ce[142],Ie([1,0,3,5,2,18,8,4,20]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let m=class dn{get state(){return this.d}constructor(I){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=I.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}$onDidChangeWindowFocus(I){I!==this.d.focused&&(this.d={...this.d,focused:I},this.c.fire(this.d))}openUri(I,S){let k;if(typeof I=="string"){k=I;try{I=u.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,P.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this.b.$openUri(I,k,S)}async asExternalUri(I,S){if((0,P.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this.b.$asExternalUri(I,S);return u.URI.from(k)}};m.a={focused:!0},m=Ve([We(0,y.IExtHostRpcService)],m),e.ExtHostWindow=m,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Ce[288],Ie([1,0,120,289,71,40,2,16,48]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(S,k,C){this.b=S,this.c=k,this.f=C,this.a=A.createServer((E,r)=>this.h(E,r)),this.g().catch(E=>(k.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",S=>this.c.error(S))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(S,k){const C=(r,d)=>{k.writeHead(r,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),f=>f&&this.c.error(f))},E=[];S.setEncoding("utf8"),S.on("data",r=>E.push(r)),S.on("end",async()=>{try{const r=JSON.parse(E.join(""));let d;switch(r.type){case"open":d=await this.i(r);break;case"openExternal":d=await this.j(r);break;case"status":d=await this.l(r);break;case"extensionManagement":d=await this.k(r);break;default:C(404,`Unknown message type: ${r.type}`);break}C(200,d)}catch(r){const d=r instanceof Error?r.message:JSON.stringify(r);C(500,d),this.c.error("Error while processing pipe request",r)}})}async i(S){const{fileURIs:k,folderURIs:C,forceNewWindow:E,diffMode:r,mergeMode:d,addMode:f,forceReuseWindow:g,gotoLineMode:D,waitMarkerFilePath:p,remoteAuthority:t}=S,o=[];if(Array.isArray(C))for(const v of C)try{o.push({folderUri:P.URI.parse(v)})}catch{}if(Array.isArray(k))for(const v of k)try{(0,y.hasWorkspaceFileExtension)(v)?o.push({workspaceUri:P.URI.parse(v)}):o.push({fileUri:P.URI.parse(v)})}catch{}const s=p?P.URI.file(p):void 0,l={forceNewWindow:E,diffMode:r,mergeMode:d,addMode:f,gotoLineMode:D,forceReuseWindow:g,preferNewWindow:!g&&!s&&!f,waitMarkerFileURI:s,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",o,l),""}async j(S){for(const k of S.uris){const C=P.URI.parse(k),E=C.scheme==="file"?C:k;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k(S){const k=E=>E?.map(r=>/\.vsix$/i.test(r)?P.URI.parse(r):r),C={list:S.list,install:k(S.install),uninstall:k(S.uninstall),force:S.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(S){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=m;let L=class extends m{constructor(S,k){super(S,k,(0,a.createRandomIPCHandle)())}};L=Ve([We(0,R.IExtHostCommands),We(1,T.ILogService)],L),e.CLIServer=L}),define(Ce[290],Ie([1,0,258,26,20]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let P=class extends a.AbstractExtHostConsoleForwarder{constructor(y,m){super(y,m),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,m,L){const I=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),m.apply(console,L),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,m){const L=process[y],I=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(k,C,E)=>{if(!this.g){S+=k.toString(C);const r=S.length>R?S.length:S.lastIndexOf(`
`);r!==-1&&(console[m](S.slice(0,r)),S=S.slice(r+1))}I.call(L,k,C,E)}})}};P=Ve([We(0,u.IExtHostRpcService),We(1,A.IExtHostInitDataService)],P),e.ExtHostConsoleForwarder=P}),define(Ce[291],Ie([1,0,12,89,30,40,6,5,2,20]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(S,k){super();const C=S.getProxy(T.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async E=>{const r=y.URI.file((0,a.join)((0,A.tmpdir)(),(0,u.generateUuid)()));return await C.$download(E,r),r})}};L=Ve([We(0,m.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ce[292],Ie([1,0,141,18,209,30]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends a.ExtHostLoggerService{m(y,m,L){return y.scheme===A.Schemas.file?new u.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,m):super.m(y,m,L)}registerLogger(y){super.registerLogger(y),this.n.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.n.$deregisterLogger(y)}}e.ExtHostLoggerService=P}),define(Ce[293],Ie([1,0,71,12,2,80,6,18,19,29]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==T.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let c=0;do{let l;c===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${c}`:`${s}-${c}`,await I(l);const v=A.join(l,"vscode.lock"),i=await E(this.d,v,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),u.URI.file(l);c++}while(c<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(p){try{await m.Promises.stat(p);return}catch{}try{await m.Promises.mkdir(p,{recursive:!0})}catch{}}const S=1e3,k=10*60*1e3;class C extends P.Disposable{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.D(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await r(t,o);(!s||s.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await m.Promises.utimes(o,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${o}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await m.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function E(p,t,o){try{const c={pid:process.pid,willReleaseAt:0};await m.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const s=await r(p,t);return!s||s.pid!==process.pid?o?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),g(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new C(p,t))}async function r(p,t){let o;try{o=await m.Promises.readFile(t)}catch(s){return p.error(s),null}try{return JSON.parse(String(o))}catch(s){return p.error(s),null}}async function d(p,t){let o;try{o=await m.Promises.stat(t)}catch(s){return p.error(s),0}return o.mtime.getTime()}function f(p){try{return process.kill(p,0),!0}catch{return!1}}async function g(p,t){const o=await r(p,t);if(!o)return p.info(`Lock '${t}': Could not read pid of lock holder.`),D(p,t);if(o.willReleaseAt){let i=o.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,y.timeout)(Math.min(100,i)),await d(p,t)===0)return D(p,t);i=o.willReleaseAt-Date.now()}return D(p,t)}}if(!f(o.pid))return p.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),D(p,t);const s=await d(p,t),c=Date.now()-s;if(c<=k)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const l=await d(p,t),v=Date.now()-l;return v<=k?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),D(p,t))}async function D(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await m.Promises.unlink(t)}catch{}return E(p,t,!0)}}),define(Ce[294],Ie([1,0,30,20,41]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends u.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,y,m){return this.createTerminalFromOptions({name:T,shellPath:y,shellArgs:m})}createTerminalFromOptions(T,y){const m=new u.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(m),m.create(T,this.L(T,y)),m.value}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(Ce[295],Ie([1,0,5,20,190,6,26,2,47,24,29,7,11,55,3,130,103,16]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class f extends E.DisposableTunnel{}function g(i){const n=i.trim().split(`
`),h=[];return n.forEach(b=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);O&&O.length>=3&&h.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),h.reduce((b,O)=>(b[O.socket]=O,b),{})}e.getSockets=g;function D(...i){const n=[].concat(...i.map(t));return[...new Map(n.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:p(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=D;function p(i){let n="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)n+=parseInt(i.substr(h,2),16),h!==0&&(n+=".");else for(let h=i.length-4;h>=0;h-=4)n+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(n+=":");return n}function t(i){const n=i.trim().split(`
`),h=n.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return n.map(b=>b.trim().split(/\s+/).reduce((O,H,x)=>(O[h[x]||x]=H,O),{}))}e.loadConnectionTable=t;function o(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function s(i){const n=i.trim().split(`
`),h=[];return n.forEach(w=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);b&&b.length>=4&&h.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),h}e.getRootProcesses=s;async function c(i,n,h){const w=h.reduce((O,H)=>(O[H.pid]=H,O),{}),b=[];return i.forEach(({socket:O,ip:H,port:x})=>{const _=n[O]?n[O].pid:void 0,G=_?w[_]?.cmd:void 0;_&&G&&!o(G)&&b.push({host:H,port:x,detail:G,pid:_})}),b}e.findPorts=c;function l(i,n,h){const w=new Map,b=s(n);for(const O of i){const H=h.get(O.port);if(H){w.set(O.port,H);continue}const x=b.find(_=>_.cmd.includes(`${O.port}`));if(x){let _=x,G;do G=b.find(M=>M.ppid===_.pid),G&&(_=G);while(G);w.set(O.port,{host:O.ip,port:O.port,pid:_.pid,detail:_.cmd,ppid:_.ppid})}else w.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=l;let v=class extends R.Disposable{constructor(n,h,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new C.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(a.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this.a.$openTunnel(h,n.displayName);if(w){const b=new f(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.D(b),b}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}q(){return this.k++}registerPortsAttributesProvider(n,h){const w=this.q();return this.l.set(w,{selector:n,provider:h}),this.a.$registerPortsAttributesProvider(n,w),new I.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(n,h,w,b,O){const H=[];for(const _ of n){const G=this.l.get(_);if(!G)return[];H.push(...await Promise.all(h.map(async M=>G.provider.providePortAttributes(M,w,b,O))))}const x=H.filter(_=>!!_);return x.length>0?x.map(_=>({autoForwardAction:_.autoForwardAction,port:_.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const h=new r.MovingAverage;let w;for(;this.h;){const b=new Date().getTime(),O=(await this.findCandidatePorts()).filter(x=>(0,E.isLocalhost)(x.host)||(0,E.isAllInterfaces)(x.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(x=>x.port).join(", ")}`);const H=new Date().getTime()-b;h.update(H),(!w||JSON.stringify(w)!==JSON.stringify(O))&&(w=O,await this.a.$onFoundNewCandidates(w)),await new Promise(x=>setTimeout(()=>x(),this.p(h.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let h=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const w=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,h){if(this.f.has(n.host)){const w=this.f.get(n.host);w.has(n.port)&&(h&&w.get(n.port).disposeListener.dispose(),await w.get(n.port).tunnel.dispose(),w.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(n,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const b=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const O=this.D(b.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(b.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:b,disposeListener:O}),k.TunnelDtoConverter.fromApiTunnel(b)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const h=await Promise.all(n.map(b=>this.c(b.host,b.port,b.detail??""))),w=n.filter((b,O)=>h[O]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(b=>b.port).join(", ")} to ${w.map(b=>b.port).join(", ")}`),w}async findCandidatePorts(){let n="",h="";try{n=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=D(n,h),b=await new Promise(U=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,he,ie)=>{U(he)})}),O=g(b),H=await L.Promises.readdir("/proc"),x=[];for(const U of H)try{const j=Number(U),he=m.joinPath(T.URI.file("/proc"),U);if((await L.Promises.stat(he.fsPath)).isDirectory()&&!isNaN(j)){const V=await L.Promises.readlink(m.joinPath(he,"cwd").fsPath),J=await L.Promises.readFile(m.joinPath(he,"cmdline").fsPath,"utf8");x.push({pid:j,cwd:V,cmd:J})}}catch{}const _=[],G=w.filter(U=>{const j=O[U.socket];return j||_.push(U),j}),M=c(G,O,x);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${_.length}`),_.length>0){const U=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(he,ie,V)=>{j(ie)})});this.j=l(_,U,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(j=>j.port).join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};v=Ve([We(0,A.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,d.ILogService)],v),e.ExtHostTunnelService=v}),define(Ce[296],Ie([1,0,19,22,21,10,3,6,115,252,58]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(w,b){try{return JSON.stringify(w,b)}catch{return"null"}}const k="$$ref$$",C={[k]:-1};class E{constructor(b,O){this.jsonString=b,this.referencedBuffers=O}}function r(w,b=null,O=!1){const H=[];return{jsonString:(O?S:JSON.stringify)(w,(_,G)=>{if(typeof G>"u")return C;if(typeof G=="object"){if(G instanceof A.VSBuffer){const M=H.push(G)-1;return{[k]:M}}if(b)return b(_,G)}return G}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=r;function d(w,b,O){return JSON.parse(w,(H,x)=>{if(x){const _=x[k];if(typeof _=="number")return b[_];if(O&&x.$mid===1)return O.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=d;function f(w,b){return JSON.stringify(w,b)}function g(w){return w?(b,O)=>O&&O.$mid===1?w.transformOutgoing(O):O:null}var D;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class c extends T.Disposable{constructor(b,O=null,H=null){super(),this[I]=!0,this.b=this.D(new P.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=b,this.f=O,this.g=H,this.h=g(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,_=L.ProxyIdentifier.count;x<_;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new a.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.q).forEach(b=>{this.q[b].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(b){this.t===0&&(this.u=Date.now()+c.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(b){this.u=Date.now()+c.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(b){this.s!==b&&(this.s=b,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(b){return this.g?(0,y.transformIncomingURIs)(b,this.g):b}getProxy(b){const{nid:O,sid:H}=b;return this.l[O]||(this.l[O]=this.F(O,H)),this.l[O]}F(b,O){const H={get:(x,_)=>(typeof _=="string"&&!x[_]&&_.charCodeAt(0)===36&&(x[_]=(...G)=>this.O(b,_,G)),_===s?O:x[_])};return new Proxy(Object.create(null),H)}set(b,O){return this.k[b.nid]=O,O}assertRegistered(b){for(let O=0,H=b.length;O<H;O++){const x=b[O];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(b){if(this.j)return;const O=b.byteLength,H=l.read(b,0),x=H.readUInt8(),_=H.readUInt32();switch(x){case 1:case 2:{let{rpcId:G,method:M,args:B}=i.deserializeRequestJSONArgs(H);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(O,_,G,M,B,x===2);break}case 3:case 4:{let{rpcId:G,method:M,args:B}=i.deserializeRequestMixedArgs(H);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(O,_,G,M,B,x===4);break}case 5:{this.f?.logIncoming(O,_,0,"ack"),this.y(_);break}case 6:{this.I(O,_);break}case 7:{this.J(O,_,void 0);break}case 9:{let G=i.deserializeReplyOKJSON(H);this.g&&(G=(0,y.transformIncomingURIs)(G,this.g)),this.J(O,_,G);break}case 10:{const G=i.deserializeReplyOKJSONWithBuffers(H,this.g);this.J(O,_,G);break}case 8:{const G=i.deserializeReplyOKVSBuffer(H);this.J(O,_,G);break}case 11:{let G=i.deserializeReplyErrError(H);this.g&&(G=(0,y.transformIncomingURIs)(G,this.g)),this.L(O,_,G);break}case 12:{this.L(O,_,void 0);break}default:console.error("received unexpected message"),console.error(b)}}H(b,O,H,x,_,G){this.f?.logIncoming(b,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(H)}.${x}(`,_);const M=String(O);let B,U;if(G){const he=new u.CancellationTokenSource;_.push(he.token),B=this.M(H,x,_),U=()=>he.cancel()}else B=this.M(H,x,_),U=t;this.p[M]=U;const j=i.serializeAcknowledged(O);this.f?.logOutgoing(j.byteLength,O,1,"ack"),this.c.send(j),B.then(he=>{delete this.p[M];const ie=i.serializeReplyOK(O,he,this.h);this.f?.logOutgoing(ie.byteLength,O,1,"reply:",he),this.c.send(ie)},he=>{delete this.p[M];const ie=i.serializeReplyErr(O,he);this.f?.logOutgoing(ie.byteLength,O,1,"replyErr:",he),this.c.send(ie)})}I(b,O){this.f?.logIncoming(b,O,1,"receiveCancel");const H=String(O);this.p[H]?.()}J(b,O,H){this.f?.logIncoming(b,O,0,"receiveReply:",H);const x=String(O);if(!this.q.hasOwnProperty(x))return;const _=this.q[x];delete this.q[x],_.resolveOk(H)}L(b,O,H){this.f?.logIncoming(b,O,0,"receiveReplyErr:",H);const x=String(O);if(!this.q.hasOwnProperty(x))return;const _=this.q[x];delete this.q[x];let G;H&&(H.$isError?(G=new Error,G.name=H.name,G.message=H.message,G.stack=H.stack):G=H),_.resolveErr(G)}M(b,O,H){try{return Promise.resolve(this.N(b,O,H))}catch(x){return Promise.reject(x)}}N(b,O,H){const x=this.k[b];if(!x)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(b));const _=x[O];if(typeof _!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(b));return _.apply(x,H)}O(b,O,H){if(this.j)return new m.CanceledLazyPromise;let x=null;if(H.length>0&&u.CancellationToken.isCancellationToken(H[H.length-1])&&(x=H.pop()),x&&x.isCancellationRequested)return Promise.reject(R.canceled());const _=i.serializeRequestArguments(H,this.h),G=++this.m,M=String(G),B=new m.LazyPromise;x&&x.onCancellationRequested(()=>{const j=i.serializeCancel(G);this.f?.logOutgoing(j.byteLength,G,0,"cancel"),this.c.send(i.serializeCancel(G))}),this.q[M]=B,this.w(G);const U=i.serializeRequest(G,b,O,_,!!x);return this.f?.logOutgoing(U.byteLength,G,0,`request: ${(0,L.getStringIdentifierForProxy)(b)}.${O}(`,H),this.c.send(U),B}}I=o,c.a=3*1e3,e.RPCProtocol=c;class l{static alloc(b,O,H){const x=new l(A.VSBuffer.alloc(H+1+4),0);return x.writeUInt8(b),x.writeUInt32(O),x}static read(b,O){return new l(b,O)}get buffer(){return this.a}constructor(b,O){this.a=b,this.b=O}static sizeUInt8(){return 1}writeUInt8(b){this.a.writeUInt8(b,this.b),this.b+=1}readUInt8(){const b=this.a.readUInt8(this.b);return this.b+=1,b}writeUInt32(b){this.a.writeUInt32BE(b,this.b),this.b+=4}readUInt32(){const b=this.a.readUInt32BE(this.b);return this.b+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this.a.writeUInt8(b.byteLength,this.b),this.b+=1,this.a.set(b,this.b),this.b+=b.byteLength}readShortString(){const b=this.a.readUInt8(this.b);this.b+=1;const H=this.a.slice(this.b,this.b+b).toString();return this.b+=b,H}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this.a.writeUInt32BE(b.byteLength,this.b),this.b+=4,this.a.set(b,this.b),this.b+=b.byteLength}readLongString(){const b=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+b).toString();return this.b+=b,H}writeBuffer(b){this.a.writeUInt32BE(b.byteLength,this.b),this.b+=4,this.a.set(b,this.b),this.b+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this.a.writeUInt32BE(b.byteLength,this.b),this.b+=4,this.a.set(b,this.b),this.b+=b.byteLength}readVSBuffer(){const b=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+b);return this.b+=b,O}static sizeMixedArray(b){let O=0;O+=1;for(let H=0,x=b.length;H<x;H++){const _=b[H];switch(O+=1,_.type){case 1:O+=this.sizeLongString(_.value);break;case 2:O+=this.sizeVSBuffer(_.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(_.value);for(let G=0;G<_.buffers.length;++G)O+=this.sizeVSBuffer(_.buffers[G]);break;case 4:break}}return O}writeMixedArray(b){this.a.writeUInt8(b.length,this.b),this.b+=1;for(let O=0,H=b.length;O<H;O++){const x=b[O];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let _=0;_<x.buffers.length;++_)this.writeBuffer(x.buffers[_]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this.a.readUInt8(this.b);this.b+=1;const O=new Array(b);for(let H=0;H<b;H++)switch(this.readUInt8()){case 1:O[H]=this.readLongString();break;case 2:O[H]=this.readVSBuffer();break;case 3:{const _=this.readUInt32(),G=this.readLongString(),M=[];for(let B=0;B<_;++B)M.push(this.readVSBuffer());O[H]=new L.SerializableObjectWithBuffers(d(G,M,null));break}case 4:O[H]=void 0;break}return O}}l.sizeUInt32=4;var v;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(v||(v={}));class i{static a(b){for(let O=0,H=b.length;O<H;O++)if(b[O]instanceof A.VSBuffer||b[O]instanceof L.SerializableObjectWithBuffers||typeof b[O]>"u")return!0;return!1}static serializeRequestArguments(b,O){if(this.a(b)){const H=[];for(let x=0,_=b.length;x<_;x++){const G=b[x];if(G instanceof A.VSBuffer)H[x]={type:2,value:G};else if(typeof G>"u")H[x]={type:4};else if(G instanceof L.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=r(G.value,O);H[x]={type:3,value:A.VSBuffer.fromString(M),buffers:B}}else H[x]={type:1,value:A.VSBuffer.fromString(f(G,O))}}return{type:1,args:H}}return{type:0,args:f(b,O)}}static serializeRequest(b,O,H,x,_){switch(x.type){case 0:return this.b(b,O,H,x.args,_);case 1:return this.c(b,O,H,x.args,_)}}static b(b,O,H,x,_){const G=A.VSBuffer.fromString(H),M=A.VSBuffer.fromString(x);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(G),B+=l.sizeLongString(M);const U=l.alloc(_?2:1,b,B);return U.writeUInt8(O),U.writeShortString(G),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(b){const O=b.readUInt8(),H=b.readShortString(),x=b.readLongString();return{rpcId:O,method:H,args:JSON.parse(x)}}static c(b,O,H,x,_){const G=A.VSBuffer.fromString(H);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(G),M+=l.sizeMixedArray(x);const B=l.alloc(_?4:3,b,M);return B.writeUInt8(O),B.writeShortString(G),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(b){const O=b.readUInt8(),H=b.readShortString(),x=b.readMixedArray(),_=new Array(x.length);for(let G=0,M=x.length;G<M;G++){const B=x[G];typeof B=="string"?_[G]=JSON.parse(B):_[G]=B}return{rpcId:O,method:H,args:_}}static serializeAcknowledged(b){return l.alloc(5,b,0).buffer}static serializeCancel(b){return l.alloc(6,b,0).buffer}static serializeReplyOK(b,O,H){if(typeof O>"u")return this.d(b);if(O instanceof A.VSBuffer)return this.e(b,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:_}=r(O.value,H,!0);return this.g(b,x,_)}else return this.f(b,S(O,H))}static d(b){return l.alloc(7,b,0).buffer}static e(b,O){let H=0;H+=l.sizeVSBuffer(O);const x=l.alloc(8,b,H);return x.writeVSBuffer(O),x.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static f(b,O){const H=A.VSBuffer.fromString(O);let x=0;x+=l.sizeLongString(H);const _=l.alloc(9,b,x);return _.writeLongString(H),_.buffer}static g(b,O,H){const x=A.VSBuffer.fromString(O);let _=0;_+=l.sizeUInt32,_+=l.sizeLongString(x);for(const M of H)_+=l.sizeVSBuffer(M);const G=l.alloc(10,b,_);G.writeUInt32(H.length),G.writeLongString(x);for(const M of H)G.writeBuffer(M);return G.buffer}static deserializeReplyOKJSON(b){const O=b.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(b,O){const H=b.readUInt32(),x=b.readLongString(),_=[];for(let G=0;G<H;++G)_.push(b.readVSBuffer());return new L.SerializableObjectWithBuffers(d(x,_,O))}static serializeReplyErr(b,O){const H=O?S(R.transformErrorForSerialization(O),null):void 0;if(typeof H!="string")return this.h(b);const x=A.VSBuffer.fromString(H);let _=0;_+=l.sizeLongString(x);const G=l.alloc(11,b,_);return G.writeLongString(x),G.buffer}static deserializeReplyErrError(b){const O=b.readLongString();return JSON.parse(O)}static h(b){return l.alloc(12,b,0).buffer}}var n;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(Ce[297],Ie([1,0,3,39,44,4]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var P;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(L=>m.push(L)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}A.Registry.add(e.Extensions.OutputChannels,new T),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(Ce[143],Ie([1,0,5,4,20,25,16,297,79,26,49,159,22,9,45,3,6]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends P.AbstractMessageLogger{get disposed(){return this.l}constructor(p,t,o,s,c){super(),this.id=p,this.name=t,this.m=o,this.n=s,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.D(o.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.k;this.info(p),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(p,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.n.$close(this.id)}g(p,t){this.k+=S.VSBuffer.fromString(t).byteLength,(0,P.log)(this.m,p,t),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class f extends d{appendLine(p){this.append(p)}}let g=class{constructor(p,t,o,s,c,l){this.i=t,this.j=o,this.k=s,this.l=c,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(p,t,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,c=(0,k.isString)(t)?t:void 0;if((0,k.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const v=this.i.environment.extensionLogLevel?.find(([n])=>R.ExtensionIdentifier.equals(o.identifier,n))?.[1];v&&(l=(0,P.parseLogLevel)(v));const i=s?this.o(p,l,o):this.n(p,c,o);return i.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),s?this.r(p,l??this.m.getLevel(),i):this.q(p,i)}async n(p,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,c=this.k.extUri.joinPath(s,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(p,c,t,o.identifier.value);return new d(v,p,l,this.a,o)}async o(p,t,o){const s=await this.p(o),c=p.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${c}.log`),v=`${o.identifier.value}.${c}`,i=this.l.createLogger(l,{id:v,name:p,logLevel:t,extensionId:o.identifier.value});return new f(v,p,i,this.a,o)}p(p){let t=this.d.get(p.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return t}q(p,t){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(c){s(),t.then(l=>l.append(c))},appendLine(c){s(),t.then(l=>l.appendLine(c))},clear(){s(),t.then(c=>c.clear())},replace(c){s(),t.then(l=>l.replace(c))},show(c,l){s(),t.then(v=>v.show(c,l))},hide(){s(),t.then(c=>c.hide())},dispose(){o=!0,t.then(c=>c.dispose())}}}r(p,t,o){const s=new r.DisposableStore,c=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new E.Emitter);function v(i){t=i,l.fire(i)}return o.then(i=>{s.add(i),i.logLevel!==t&&v(i.logLevel),s.add(i.onDidChangeLogLevel(n=>v(n)))}),{...this.q(p,o),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(i,...n){c(),o.then(h=>h.trace(i,...n))},debug(i,...n){c(),o.then(h=>h.debug(i,...n))},info(i,...n){c(),o.then(h=>h.info(i,...n))},warn(i,...n){c(),o.then(h=>h.warn(i,...n))},error(i,...n){c(),o.then(h=>h.error(i,...n))},dispose(){s.dispose()}}}};g=Ve([We(0,u.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,P.ILoggerService),We(5,P.ILogService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Ce[298],Ie([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ce[299],Ie([1,0,33,18,12,11,24,2,4,222,48,240,298]),function(se,e,a,A,u,R,P,T,y,m,L,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let k=class hn{constructor(E,r,d,f){this.d=E,this.e=r,this.f=d,this.g=f,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const g=await this.e.getEnvironment();return this.c=g?.userHome??E})()}hasValidBasename(E,r,d){return typeof r=="string"||typeof r>"u"?this.a.then(f=>this.h(E,f,r)):this.h(E,r,d)}h(E,r,d){return E.scheme===A.Schemas.file||E.scheme===A.Schemas.vscodeRemote?(0,a.isValidBasename)(d??(0,P.basename)(E),r===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(E,r){if(E.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,m.getVirtualWorkspaceScheme)(r.getWorkspace());if(d)return d;const f=r.getWorkspace().folders[0];if(f)return f.uri.scheme;const g=r.getWorkspace().configuration;return g?g.scheme:A.Schemas.file}userHome(E){return E?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(E=>E===1?u.win32:u.posix)}async fileURI(E){let r="";if(await this.a===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const f=E.indexOf("/",2);f===-1?(r=E.substring(2),E="/"):(r=E.substring(2,f),E=E.substring(f)||"/")}return T.URI.from({scheme:A.Schemas.file,authority:r,path:E,query:"",fragment:""})}};k=Ve([We(1,S.IRemoteAgentService),We(2,I.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ce[82],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(P,T){this.line=P,this.character=T}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,T){return new a(0,0)}with(P){return new a(0,0)}}e.Position=a;class A{constructor(P,T,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(P,T),this.end=new a(y,m)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new A(0,0,0,0)}with(P){return new A(0,0,0,0)}}e.Range=A;var u;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[31],Ie([1,0,17,38,23,33,8,4,12,10,82,19]),function(se,e,a,A,u,R,P,T,y,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",k=" characters skipped \u27EB",C=(S.length+k.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var E;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(E=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function d(J){return!!J.preview}e.resultIsMatch=d;function f(J){return!!J.resource}e.isFileMatch=f;function g(J){return!!J.message}e.isProgressMessage=g;var D;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(D=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=p;class t{constructor(re,ve,ue){this.ranges=ve;const le=Array.isArray(ve)?ve:[ve];if(ue&&ue.matchLines===1&&o(le)){re=(0,P.getNLines)(re,ue.matchLines);let q="",F=0,Q=0;const me=Math.floor(ue.charsPerLine/5),Ee=[];for(const te of le){const ne=Math.max(te.startColumn-me,0),de=te.startColumn+ue.charsPerLine;if(ne>Q+me+C){const ee=S+(ne-Q)+k;q+=ee+re.slice(ne,de),F+=ne-(Q+ee.length)}else q+=re.slice(Q,de);Ee.push(new c(0,te.startColumn-F,te.endColumn-F)),Q=de}this.preview={text:q,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const q=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:re,matches:(0,a.mapArrayOrNot)(ve,F=>new s(F.startLineNumber-q,F.startColumn,F.endLineNumber-q,F.endColumn))}}}}e.TextSearchMatch=t;function o(J){const re=J[0].startLineNumber;for(const ve of J)if(ve.startLineNumber!==re||ve.endLineNumber!==re)return!1;return!0}class s{constructor(re,ve,ue,le){this.startLineNumber=re,this.startColumn=ve,this.endLineNumber=ue,this.endColumn=le}}e.SearchRange=s;class c extends s{constructor(re,ve,ue){super(re,ve,re,ue)}}e.OneLineRange=c;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var v;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,re=!0){const ve=J&&J.files&&J.files.exclude,ue=re&&J&&J.search&&J.search.exclude;if(!ve&&!ue)return;if(!ve||!ue)return ve||ue;let le=Object.create(null);return le=u.mixin(le,u.deepClone(ve)),le=u.mixin(le,u.deepClone(ue),!0),le}e.getExcludes=i;function n(J,re){return J.excludePattern&&A.match(J.excludePattern,re)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,re)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ve=>{const ue=ve.folder.fsPath;if(R.isEqualOrParent(re,ue)){const le=y.relative(ue,re);return!ve.includePattern||!!A.match(ve.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var h;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(re,ve){super(re),this.code=ve}}e.SearchError=w;function b(J){const re=J.message;if((0,m.isCancellationError)(J))return new w(re,h.canceled);try{const ve=JSON.parse(re);return new w(ve.message,ve.code)}catch{return new w(re,h.other)}}e.deserializeSearchError=b;function O(J){const re={message:J.message,code:J.code};return new Error(JSON.stringify(re))}e.serializeSearchError=O;function H(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=H;function x(J){return J.type==="success"}e.isSerializedSearchSuccess=x;function _(J){return!!J.path}e.isSerializedFileMatch=_;function G(J,re){const ve=J.searchPath?J.searchPath:J.relativePath;return(0,P.fuzzyContains)(ve,re)}e.isFilePatternMatch=G;class M{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function B(J,re){const ve={...J||{},...re||{}};return Object.keys(ve).filter(ue=>{const le=ve[ue];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=B;class U{constructor(re,ve){this.c=null,this.a={...re.excludePattern||{},...ve.excludePattern||{}},this.b=A.parse(this.a);let ue=re.includePattern;ve.includePattern&&(ue?ue={...ue,...ve.includePattern}:ue=ve.includePattern),ue&&(this.c=A.parse(ue))}matchesExcludesSync(re,ve,ue){return!!(this.b&&this.b(re,ve,ue))}includedInQuerySync(re,ve,ue){return!(this.b&&this.b(re,ve,ue)||this.c&&!this.c(re,ve,ue))}includedInQuery(re,ve,ue){const le=this.b(re,ve,ue),q=()=>this.c?!!this.c(re,ve,ue):!0;return(0,I.isThenable)(le)?le.then(F=>F?!1:q()):q()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=U;function j(J){for(const re in J)if(typeof J[re]!="boolean")return!0;return!1}function he(J){if(!J)return;let re;return ve=>(re||(re=(J()||Promise.resolve([])).then(ue=>ue?V(ue):{})),re.then(ue=>!!ue[ve]))}e.hasSiblingPromiseFn=he;function ie(J){if(!J)return;let re;return ve=>{if(!re){const ue=J();re=ue?V(ue):{}}return!!re[ve]}}e.hasSiblingFn=ie;function V(J){const re={};for(const ve of J)re[ve]=!0;return re}}),define(Ce[34],Ie([1,0,17,19,21,3,6,69,18,103,24,8,9,2,188,4,16,210,48,49,26,20,13,7,56,31,5]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t,o,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function v(x,_,G){return new L.ExtUri(M=>w(M,G)).isEqual(x,_)}function i(x,_,G){return v(x.uri,_.uri,G)?0:(0,I.compare)(x.uri.toString(),_.uri.toString())}function n(x,_,G){return x.index!==_.index?x.index<_.index?-1:1:v(x.uri,_.uri,G)?(0,I.compare)(x.name,_.name):(0,I.compare)(x.uri.toString(),_.uri.toString())}function h(x,_,G,M){const B=x.slice(0).sort((j,he)=>G(j,he,M)),U=_.slice(0).sort((j,he)=>G(j,he,M));return(0,a.delta)(B,U,(j,he)=>G(j,he,M))}function w(x,_){const G=_.getCapabilities(x.scheme);return!(G&&G&1024)}class b extends f.Workspace{static toExtHostWorkspace(_,G,M,B){if(!_)return{workspace:null,added:[],removed:[]};const{id:U,name:j,folders:he,configuration:ie,transient:V,isUntitled:J}=_,re=[],ve=G;G?he.forEach((F,Q)=>{const me=k.URI.revive(F.uri),Ee=b.o(M||G,me,B);Ee?(Ee.name=F.name,Ee.index=F.index,re.push(Ee)):re.push({uri:me,name:F.name,index:Q})}):re.push(...he.map(({uri:F,name:Q,index:me})=>({uri:k.URI.revive(F),name:Q,index:me}))),re.sort((F,Q)=>F.index<Q.index?-1:1);const ue=new b(U,j,re,!!V,ie?k.URI.revive(ie):null,!!J,F=>w(F,B)),{added:le,removed:q}=h(ve?ve.workspaceFolders:[],ue.workspaceFolders,i,B);return{workspace:ue,added:le,removed:q}}static o(_,G,M){for(let B=0;B<_.folders.length;B++){const U=_.workspaceFolders[B];if(v(U.uri,G,M))return U}}constructor(_,G,M,B,U,j,he){super(_,M.map(ie=>new f.WorkspaceFolder(ie)),B,U,he),this.t=G,this.u=j,this.q=[],this.s=T.TernarySearchTree.forUris(he),M.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(_,G){return G&&this.s.get(_)&&(_=(0,L.dirname)(_)),this.s.findSubstr(_)}resolveWorkspaceFolder(_){return this.s.get(_)}}let O=class{constructor(_,G,M,B,U){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=B,this.s=M,this.t=U,this.j=new m.Counter,this.k=new A.Barrier,this.o=_.getProxy(l.MainContext.MainThreadWorkspace),this.q=_.getProxy(l.MainContext.MainThreadMessageService);const j=G.workspace;this.l=j?new b(j.id,j.name,[],!!j.transient,j.configuration?k.URI.revive(j.configuration):null,!!j.isUntitled,he=>w(he,M)):void 0}$initializeWorkspace(_,G){this.v=G,this.$acceptWorkspaceData(_),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?k.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(_,G,M,...B){const U=[];if(Array.isArray(B)&&B.forEach(J=>{k.URI.isUri(J.uri)&&!U.some(re=>v(re.uri,J.uri,this.s))&&U.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[G,M].some(J=>typeof J!="number"||J<0)||M===0&&U.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(G+M>j.length)return!1;const he=j.slice(0);he.splice(G,M,...U.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<he.length;J++){const re=he[J];if(he.some((ve,ue)=>ue!==J&&v(re.uri,ve.uri,this.s)))return!1}he.forEach((J,re)=>J.index=re);const{added:ie,removed:V}=h(j,he,n,this.s);if(ie.length===0&&V.length===0)return!1;if(this.o){const J=_.displayName||_.name;this.o.$updateWorkspaceFolders(J,G,M,U).then(void 0,re=>{this.n=void 0;const ve={source:{identifier:_.identifier,label:_.displayName||_.name}};this.q.$showMessage(d.Severity.Error,(0,C.localize)(0,null,J,re.toString()),ve,[])})}return this.y(he),!0}getWorkspaceFolder(_,G){if(!!this.x)return this.x.getWorkspaceFolder(_,G)}async getWorkspaceFolder2(_,G){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(_,G)}async resolveWorkspaceFolder(_){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(_)}getPath(){if(!this.x)return;const{folders:_}=this.x;if(_.length!==0)return _[0].uri.fsPath}getRelativePath(_,G){let M,B="";if(typeof _=="string"?(M=k.URI.file(_),B=_):typeof _<"u"&&(M=_,B=_.fsPath),!M)return B;const U=this.getWorkspaceFolder(M,!0);if(!U)return B;typeof G>"u"&&this.x&&(G=this.x.folders.length>1);let j=(0,L.relativePath)(U.uri,M);return G&&U.name&&(j=`${U.name}/${j}`),j}y(_){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:_,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(_){const{workspace:G,added:M,removed:B}=b.toExtHostWorkspace(_,this.l,this.n,this.s);this.l=G||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:B}))}findFiles(_,G,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let j;if(G===null?j=!1:G&&(typeof G=="string"?j=G:j=G.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:ie}=H(t.GlobPattern.from(_));return this.o.$startFileSearch((0,S.withUndefinedAsNull)(he),(0,S.withUndefinedAsNull)(ie),(0,S.withUndefinedAsNull)(j),(0,S.withUndefinedAsNull)(M),U).then(V=>Array.isArray(V)?V.map(J=>k.URI.revive(J)):[])}async findTextInFiles(_,G,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),he=typeof G.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:G.previewOptions,{includePattern:ie,folder:V}=H(t.GlobPattern.from(G.include)),J=typeof G.exclude=="string"?G.exclude:G.exclude?G.exclude.pattern:void 0,re={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useGlobalIgnoreFiles=="boolean"?!G.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof G.useParentIgnoreFiles=="boolean"?!G.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof G.useDefaultExcludes=="boolean"?!G.useDefaultExcludes:!0,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:he,afterContext:G.afterContext,beforeContext:G.beforeContext,includePattern:ie,excludePattern:J},ve=!1;if(this.u[j]=ue=>{if(ve)return;const le=k.URI.revive(ue.resource);ue.results.forEach(q=>{(0,c.resultIsMatch)(q)?M({uri:le,preview:{text:q.preview.text,matches:(0,a.mapArrayOrNot)(q.preview.matches,F=>new o.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))},ranges:(0,a.mapArrayOrNot)(q.ranges,F=>new o.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))}):M({uri:le,text:q.text,lineNumber:q.lineNumber})})},U.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(_,(0,S.withUndefinedAsNull)(V),re,j,U);return delete this.u[j],ue||{}}catch(ue){throw delete this.u[j],ue}}$handleTextSearchResult(_,G){this.u[G]?.(_)}saveAll(_){return this.o.$saveAll(_)}resolveProxy(_){return this.o.$resolveProxy(_)}get trusted(){return this.v}requestWorkspaceTrust(_){return this.o.$requestWorkspaceTrust(_)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(_,G){if(this.w.has(_))throw new Error(`A provider has already been registered for scheme ${_}`);this.w.set(_,G);const M=this.t.transformOutgoingScheme(_),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,M),(0,P.toDisposable)(()=>{this.w.delete(_),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(_,G){this.h.info("Getting edit session identifier for workspaceFolder",_);const M=await this.resolveWorkspaceFolder(k.URI.revive(_));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const B=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!B),!B)return;const U=await B.provideEditSessionIdentity(M,G);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(_,G,M,B){this.h.info("Getting edit session identifier for workspaceFolder",_);const U=await this.resolveWorkspaceFolder(k.URI.revive(_));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const he=await j.provideEditSessionIdentityMatch?.(G,M,B);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(_){return(G,M,B)=>{const U=function(he){G.call(M,he)};return U.extension=_,this.A.event(U,void 0,B)}}async $onWillCreateEditSessionIdentity(_,G,M){const B=await this.resolveWorkspaceFolder(k.URI.revive(_));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},G,async(U,j)=>{const he=Date.now();await Promise.resolve(U),Date.now()-he>M&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),G.isCancellationRequested}};O=Ve([We(0,p.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,g.IExtHostFileSystemInfo),We(3,r.ILogService),We(4,s.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function H(x){let _,G;return x&&(typeof x=="string"?_=x:(_=x.pattern,G=k.URI.revive(x.baseUri))),{includePattern:_,folder:G}}}),define(Ce[35],Ie([1,0,23,3,34,5,7,213,127,9,19,4,20,16,2]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function E(o,s){if(s){const c=s.split(".");let l=o;for(let v=0;l&&v<c.length;v++)l=l[c[v]];return l}}function r(o){return o instanceof C.URI}function d(o){return o&&o.uri instanceof C.URI&&o.languageId&&typeof o.languageId=="string"}function f(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function g(o){return o&&o.uri instanceof C.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function D(o){if(r(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(f(o))return{overrideIdentifier:o.languageId};if(g(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(s,c,l){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=c,this.b=l,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,c){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,c))}};p=Ve([We(0,S.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,k.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,c,l,v){this.a=new A.Emitter,this.b=s,this.f=v,this.c=c,this.e=T.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,c){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(c,l))}getConfiguration(s,c,l){const v=D(c)||{},i=this.g(s?E(this.e.getValue(void 0,v,this.c.workspace),s):this.e.getValue(void 0,v,this.c.workspace));s&&this.h(s,v,l?.identifier);function n(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof E(i,w)<"u"},get:(w,b)=>{this.h(s?`${s}.${w}`:w,v,l?.identifier);let O=E(i,w);if(typeof O>"u")O=b;else{let H;const x=(_,G)=>{let M;const B=()=>{H=H||(0,a.deepClone)(i),M=M||E(H,G)};return(0,m.isObject)(_)?new Proxy(_,{get:(U,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return B(),()=>M;if(H)return M=M||E(H,G),M[j];const he=U[j];return typeof j=="string"?x(he,`${G}.${j}`):he},set:(U,j,he)=>(B(),M&&(M[j]=he),!0),deleteProperty:(U,j)=>(B(),M&&delete M[j],!0),defineProperty:(U,j,he)=>(B(),M&&Object.defineProperty(M,j,he),!0)}):_};O=x(O,w)}return O},update:(w,b,O,H)=>{w=s?`${s}.${w}`:w;const x=n(O);return b!==void 0?this.b.$updateConfigurationOption(x,w,b,v,H):this.b.$removeConfigurationOption(x,w,v,H)},inspect:w=>{w=s?`${s}.${w}`:w;const b=this.e.inspect(w,v,this.c.workspace);if(b)return{key:w,defaultValue:(0,a.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,a.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,a.deepClone)(b.workspace?.value),workspaceFolderValue:(0,a.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(b.default?.override),globalLanguageValue:(0,a.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,a.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(b.workspaceFolder?.override),languageIds:(0,a.deepClone)(b.overrideIdentifiers)}}};return typeof i=="object"&&(0,a.mixin)(h,i,!1),Object.freeze(h)}g(s){const c=l=>(0,m.isObject)(l)?new Proxy(l,{get:(v,i)=>c(v[i]),set:(v,i,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(v,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(v,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return c(s)}h(s,c,l){const v=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),i=l?`[${l.value}] `:"";if(v===4){typeof c?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){c?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,c){const l=new T.ConfigurationChangeEvent(s,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,i)=>l.affectsConfiguration(v,D(i))})}k(s){return s.reduce((c,l)=>(c.set(l[0],l[1]),c),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[83],Ie([1,0,2,19,3,5,7,34,59,35,21,41,20,26,4,18,11,16,78,251,10]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(_){function G(B){if(B!=null)return B}_.from=G;function M(B){if(B!=null)return B}_.to=M})(t||(t={}));var o;(function(_){function G(B){if(B!=null)return B}_.from=G;function M(B){if(B!=null)return B}_.to=M})(o||(o={}));var s;(function(_){function G(B){if(B!=null)return B}_.from=G;function M(B){if(B!=null)return B}_.to=M})(s||(s={}));var c;(function(_){function G(U){if(U){const j=U;return j&&!!j.process}else return!1}_.is=G;function M(U){if(U==null)return;const j={process:U.process,args:U.args};return U.options&&(j.options=s.from(U.options)),j}_.from=M;function B(U){if(U!=null)return new P.ProcessExecution(U.process,U.args,U.options)}_.to=B})(c||(c={}));var l;(function(_){function G(B){if(B!=null)return B}_.from=G;function M(B){if(B!=null)return B}_.to=M})(l||(l={}));var v;(function(_){function G(U){if(U){const j=U;return j&&(!!j.commandLine||!!j.command)}else return!1}_.is=G;function M(U){if(U==null)return;const j={};return U.commandLine!==void 0?j.commandLine=U.commandLine:(j.command=U.command,j.args=U.args),U.options&&(j.options=l.from(U.options)),j}_.from=M;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new P.ShellExecution(U.commandLine,U.options):new P.ShellExecution(U.command,U.args?U.args:[],U.options)}_.to=B})(v||(v={}));var i;(function(_){function G(U){if(U){const j=U;return j&&j.customExecution==="customExecution"}else return!1}_.is=G;function M(U){return{customExecution:"customExecution"}}_.from=M;function B(U,j){return j.get(U)}_.to=B})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(_){function G(M,B){let U;return M.scope!==void 0&&typeof M.scope!="number"?U=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===P.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=g.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:U}}_.from=G})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(_){function G(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}_.from=G})(h||(h={}));var w;(function(_){function G(U,j){if(U==null)return[];const he=[];for(const ie of U){const V=M(ie,j);V&&he.push(V)}return he}_.fromMany=G;function M(U,j){if(U==null)return;let he;U.execution instanceof P.ProcessExecution?he=c.from(U.execution):U.execution instanceof P.ShellExecution?he=v.from(U.execution):U.execution&&U.execution instanceof P.CustomExecution&&(he=i.from(U.execution));const ie=t.from(U.definition);let V;return U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=P.TaskScope.Workspace,!ie||!V?void 0:{_id:U._id,definition:ie,name:U.name,source:{extensionId:j.identifier.value,label:U.source,scope:V},execution:he,isBackground:U.isBackground,group:h.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}_.from=M;async function B(U,j,he){if(U==null)return;let ie;c.is(U.execution)?ie=c.to(U.execution):v.is(U.execution)?ie=v.to(U.execution):i.is(U.execution)&&(ie=i.to(U._id,he));const V=t.to(U.definition);let J;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?J=U.source.scope:J=await j.resolveWorkspaceFolder(a.URI.revive(U.source.scope)):J=P.TaskScope.Workspace),!V||!J)return;const re=new P.Task(V,J,U.name,U.source.label,ie,U.problemMatchers);return U.isBackground!==void 0&&(re.isBackground=U.isBackground),U.group!==void 0&&(re.group=P.TaskGroup.from(U.group._id),re.group&&U.group.isDefault&&(re.group=new P.TaskGroup(re.group.id,re.group.label),U.group.isDefault===!0&&(re.group.isDefault=U.group.isDefault))),U.presentationOptions&&(re.presentationOptions=o.to(U.presentationOptions)),U._id&&(re._id=U._id),U.detail&&(re.detail=U.detail),re}_.to=B})(w=e.TaskDTO||(e.TaskDTO={}));var b;(function(_){function G(B){return B}_.from=G;function M(B){if(!!B)return Object.assign(Object.create(null),B)}_.to=M})(b||(b={}));class O{constructor(G,M,B){this._id=M,this.a=B,p.set(this,void 0),Je(this,p,G,"f")}get task(){return this.a}terminate(){Me(this,p,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}p=new WeakMap;let H=class{constructor(G,M,B,U,j,he,ie,V){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=G.getProxy(R.MainContext.MainThreadTask),this.b=B,this.c=U,this.d=j,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,M,B){if(!B)return new P.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:M,provider:B,extension:G}),this.a.$registerTaskProvider(U,M),new P.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(G,M){this.a.$registerTaskSystem(G,M)}fetchTasks(G){return this.a.$fetchTasks(b.from(G)).then(async M=>{const B=[];for(const U of M){const j=await w.to(U,this.b,this.m);j&&B.push(j)}return B})}get taskExecutions(){const G=[];return this.k.forEach(M=>G.push(M)),G}terminateTask(G){if(!(G instanceof O))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,M,B){const U=this.m.get(G.id);U&&(this.o.set(G.id,U),this.e.attachPtyToTerminal(M,await U.callback(B))),this.p=G.id,this.q.fire({execution:await this.y(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){const M=await this.y(G);this.l.delete(G.id),this.k.delete(G.id),this.A(G),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const M=await this.y(G.id);this.s.fire({execution:M,processId:G.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(G){const M=await this.y(G.id);this.t.fire({execution:M,exitCode:G.exitCode})}$provideTasks(G,M){const B=this.j.get(G);if(!B)return Promise.reject(new Error("no handler found"));const U=[],j=(0,A.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(he=>this.u(M,U,B,he));return new Promise(he=>{j.then(ie=>{Promise.all(U).then(()=>{he(ie)})})})}async $resolveTask(G,M){const B=this.j.get(G);if(!B)return Promise.reject(new Error("no handler found"));if(M.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await w.to(M,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const j=await B.provider.resolveTask(U,L.CancellationToken.None);if(!j)return;this.z(j,B);const he=w.from(j,B.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(he.execution)&&await this.x(he,j,!0),await this.v(he)}w(){return this.h++}async x(G,M,B){const U=await this.a.$createTaskId(G);!B&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,M.execution)),this.m.set(U,M.execution)}async y(G,M){if(typeof G=="string"){const j=this.l.get(G);if(!j)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const B=this.l.get(G.id);if(B)return B;const U=new Promise((j,he)=>{function ie(V,J,re){re?j(new O(V,J.id,re)):he("Unexpected: Task does not exist.")}M?ie(this,G,M):w.to(G.task,this.b,this.m).then(V=>ie(this,G,V))});return this.l.set(G.id,U),U.then(j=>(this.k.set(G.id,j),j),j=>Promise.reject(j))}z(G,M){G._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}A(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const B=this.n.values();let U=B.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=B.next()}};H=Ve([We(0,S.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let x=class extends H{constructor(G,M,B,U,j,he,ie,V){super(G,M,B,U,j,he,ie,V),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:r.PlatformToString(0)})}async executeTask(G,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const B=w.from(M,G);if(B===void 0)throw new Error("Task is not valid");if(i.is(B.execution))await this.x(B,M,!1);else throw new D.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(B),M);return this.a.$executeTask(B).catch(j=>{throw new Error(j)}),U}u(G,M,B,U){const j=[];if(U)for(const he of U){this.z(he,B),(!he.definition||!G[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=w.from(he,B.extension);ie&&i.is(ie.execution)?(j.push(ie),M.push(this.x(ie,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:B.extension}}async v(G){if(i.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,M,B){}};x=Ve([We(0,S.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(Ce[300],Ie([1,0,12,21,46,38,24,43,31]),function(se,e,a,A,u,R,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(S,k,C){this.k=S,this.l=k,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=S.filePattern,this.b=S.includePattern&&R.parse(S.includePattern),this.c=S.maxResults||void 0,this.d=S.exists,this.h=new Set,this.j=S.excludePattern&&R.parse(S.excludePattern)}cancel(){this.g=!0,this.h.forEach(S=>S.cancel()),this.h=new Set}search(S){const k=this.k.folderQueries||[];return new Promise((C,E)=>{const r=d=>{this.f++,S(d)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const f=d.toString(),g=a.basename(f);this.j&&this.j(f,g)||this.v(r,{base:d,basename:g})}),Promise.all(k.map(d=>this.p(d,r))).then(d=>{C({limitHit:this.e,stats:d[0]||void 0})},d=>{E(new Error((0,u.toErrorMessage)(d)))})})}async p(S,k){const C=new A.CancellationTokenSource,E=this.q(S),r=this.r(),d=new y.QueryGlobTester(this.k,S),f=!d.hasSiblingExcludeClauses();let g;try{this.h.add(C),g=T.StopWatch.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,C.token),p=g.elapsed(),t=T.StopWatch.create();return this.g&&!this.e||(D&&D.forEach(o=>{const s=a.posix.relative(S.folder.path,o.path);if(f){const c=a.basename(o.path);this.v(k,{base:S.folder,relativePath:s,basename:c});return}this.s(r,S.folder,s,k)}),this.g&&!this.e)?null:(this.u(r,d,k),{providerTime:p,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(S){const k=(0,y.resolvePatternsForProvider)(this.k.includePattern,S.includePattern),C=(0,y.resolvePatternsForProvider)(this.k.excludePattern,S.excludePattern);return{folder:S.folder,excludes:C,includes:k,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}s({pathToEntries:S},k,C,E){if(C===this.a){const d=a.basename(this.a);this.v(E,{base:k,relativePath:this.a,basename:d})}function r(d){const f=a.basename(d),g=a.dirname(d);let D=S[g];D||(D=S[g]=[],r(g)),D.push({base:k,relativePath:d,basename:f})}r(C)}u({rootEntries:S,pathToEntries:k},C,E){const r=this,d=this.a;function f(g){const D=(0,y.hasSiblingFn)(()=>g.map(p=>p.basename));for(let p=0,t=g.length;p<t;p++){const o=g[p],{relativePath:s,basename:c}=o;if(C.matchesExcludesSync(s,c,d!==c?D:void 0))continue;const l=k[s];if(l)f(l);else{if(s===d)continue;r.v(E,o)}if(r.e)break}}f(S)}v(S,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||S(k))}}class L{constructor(){this.b=new Map}fileSearch(S,k,C,E){const r=this.c(S.cacheKey),d=new m(S,k,r&&r.token);let f=0;const g=D=>{f+=D.length,C(D.map(p=>this.d(p)))};return this.e(d,L.a,g,E).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:D.stats}}))}clearCache(S){this.c(S)?.cancel()}c(S){if(!!S)return this.b.has(S)||this.b.set(S,new A.CancellationTokenSource),this.b.get(S)}d(S){return S.relativePath?{resource:P.joinPath(S.base,S.relativePath)}:{resource:S.base}}e(S,k,C,E){E.onCancellationRequested(()=>{S.cancel()});const r=f=>{f&&(d.push(f),k>0&&d.length>=k&&(C(d),d=[]))};let d=[];return S.search(r).then(f=>(d.length&&C(d),f),f=>(d.length&&C(d),Promise.reject(f)))}}L.a=512,e.FileSearchManager=L}),define(Ce[301],Ie([1,0,17,61,38,114,28,18,12,24,8,9,2,167,200,54,16,48,134,299,31]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(w,b,O,H,x){this.a=w,this.b=b,this.c=O,this.d=H,this.e=x}text(w,b,O={}){w=this.f(w,O);const H=this.a.getValue(),x=b&&b.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(b?.map(d.toWorkspaceFolder),O),type:2,contentPattern:w,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:H.search.usePCRE2||x||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(w,b){const O=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const H={...w,wordSeparators:O.editor.wordSeparators};return this.j(w,b)&&(H.isCaseSensitive=!0),this.k(w)&&(H.isMultiline=!0),H}file(w,b={}){return{...this.h(w,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}g(w,b){return w?(w=Array.isArray(w)?w.map(l):l(w),b?this.parseSearchPaths(w):{pattern:o(...Array.isArray(w)?w:[w])}):{}}h(w=[],b={}){const O=this.g(b.includePattern,b.expandPatterns),H=this.g(b.excludePattern,b.expandPatterns),x=w.length>1,_=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(B=>this.q(B,b,H)):w.map(B=>this.r(B,b,H,x))).filter(B=>!!B),G={_reason:b._reason,folderQueries:_,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:H.pattern,includePattern:O.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const B=a.coalesce(a.flatten(this.c.groups.map(he=>he.editors.map(ie=>ie.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const U=B.filter(he=>(0,D.pathIncludedInQuery)(G,he.fsPath)),j=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...G,...j}}const M=b.extraFileResources&&b.extraFileResources.filter(B=>(0,D.pathIncludedInQuery)(G,B.fsPath));return G.extraFileResources=M&&M.length?M:void 0,G}i(w){const b=[],O=new P.ResourceMap,H={};let x=!1;return w.forEach(_=>{if(_.scheme===T.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(_)){const M=this.b.getWorkspaceFolder(_)?.uri??_.with({path:y.dirname(_.fsPath)});let B=O.get(M);B||(x=!0,B={folder:M,includePattern:{}},b.push(B),O.set(M,B));const U=y.relative(M.fsPath,_.fsPath);(0,I.assertIsDefined)(B.includePattern)[U.replace(/\\/g,"/")]=!0}else _.fsPath&&(x=!0,H[_.fsPath]=!0)}),{folderQueries:b,includePattern:H,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}j(w,b){if(b.isSmartCase){if(w.isRegExp){if(L.containsUppercaseCharacter(w.pattern,!0))return!0}else if(L.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,k.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const b=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),H=(Array.isArray(w)?w:s(w)).map(j=>{const he=this.e.resolvedUserHome;return he?(0,R.untildify)(j,he.scheme===T.Schemas.file?he.fsPath:he.path):j}),x=A.groupBy(H,j=>b(j)?"searchPaths":"exprSegments"),_=(x.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),c(j))),G={},M=this.m(x.searchPaths||[]);M&&M.length&&(G.searchPaths=M);const B=a.flatten(_),U=o(...B);return U&&(G.pattern=U),G}l(w,b){return b.disregardExcludeSettings?void 0:(0,D.getExcludes)(w,!b.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const b=w.flatMap(H=>{let{pathPortion:x,globPortion:_}=t(H);return _&&(_=v(_)),this.n(x).flatMap(M=>this.o(M,_))}),O=new Map;return b.forEach(H=>{const x=H.searchPath.toString(),_=O.get(x);_?H.pattern&&(_.pattern=_.pattern||{},_.pattern[H.pattern]=!0):O.set(x,{searchPath:H.searchPath,pattern:H.pattern?o(H.pattern):void 0})}),Array.from(O.values())}n(w){if(y.isAbsolute(w)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==T.Schemas.file?[{searchPath:b[0].uri.with({path:w})}]:[{searchPath:S.URI.file(y.normalize(w))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(w=l(w),w.startsWith("../")||w===".."){const H=y.posix.resolve(b.path,w);return[{searchPath:b.with({path:H})}]}const O=v(w);return[{searchPath:b,pattern:O}]}else{if(w==="./"||w===".\\")return[];{const b=w.replace(/^\.[\/\\]/,""),H=this.b.getWorkspace().folders.map(x=>{const _=b.match(new RegExp(`^${L.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return _?{match:_,folder:x}:null}).filter(I.isDefined);if(H.length)return H.map(x=>{const _=x.match[1];return{searchPath:x.folder.uri,pattern:_&&v(_)}});{const x=w.match(/\.[\/\\](.+)[\/\\]?/),_=x?x[1]:w,G=C.localize(0,null,_);throw new Error(G)}}}}o(w,b){const O=w.pattern&&b?`${w.pattern}/${b}`:w.pattern||b,H=[{searchPath:w.searchPath,pattern:O}];return O&&!O.endsWith("**")&&H.push({searchPath:w.searchPath,pattern:O+"/**"}),H}q(w,b,O){const H=this.r((0,d.toWorkspaceFolder)(w.searchPath),b,O,!1);return H?{...H,includePattern:w.pattern}:null}r(w,b,O,H){let x;const _=S.URI.isUri(w)?w:w.uri;if(O.searchPaths){const j=O.searchPaths.filter(he=>(0,m.isEqual)(he.searchPath,_))[0];if(j&&!j.pattern)return null;j&&(x=j.pattern)}const G=this.a.getValue({resource:_}),B={...this.l(G,b)||{},...x||{}},U=S.URI.isUri(w)?(0,m.basename)(w):w.name;return{folder:_,folderName:H?U:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!G.search.followSymlinks}}};p=Ve([We(0,E.IConfigurationService),We(1,d.IWorkspaceContextService),We(2,f.IEditorGroupsService),We(3,r.ILogService),We(4,g.IPathService)],p),e.QueryBuilder=p;function t(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const b=w.index,O=h.substr(0,b).match(/[/|\\][^/\\]*$/);if(O){let H=h.substr(0,O.index);return H.match(/[/\\]/)||(H+="/"),{pathPortion:H,globPortion:h.substr((O.index||0)+1)}}}return{pathPortion:h}}function o(...h){return h.length?h.reduce((w,b)=>(w[b]=!0,w),Object.create(null)):void 0}function s(h){return u.splitGlobAware(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function c(h){return[`**/${h}/**`,`**/${h}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function l(h){return h.replace(/\\/g,"/")}function v(h){return l(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(h){return h.replace(/([?*[\]])/g,"[$1]")}function n(h,w){h=a.distinct(h,H=>H.toString());const b=[],O=w.getWorkspace();return h&&h.forEach(H=>{let x;if(w.getWorkbenchState()===2)x=(0,m.relativePath)(O.folders[0].uri,H),x&&x!=="."&&(x="./"+x);else{const _=w.getWorkspaceFolder(H);if(_){const G=_.name;if(O.folders.filter(B=>B.name===G).length===1){const B=(0,m.relativePath)(_.uri,H);B===""?x=`./${_.name}`:x=`./${_.name}/${B}`}else x=H.fsPath}}x&&b.push(i(x))}),b}e.resolveResourcesForSearchIncludes=n}),define(Ce[302],Ie([1,0,24,2,21,10,4,301,31,48]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function I(E,r){const d=r.activationEvents;if(!d)return Promise.resolve(void 0);const f=[],g=[];for(const c of d)if(/^workspaceContains:/.test(c)){const l=c.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||E.forceUsingSearch?g.push(l):f.push(l)}if(f.length===0&&g.length===0)return Promise.resolve(void 0);let D;const p=new Promise((c,l)=>{D=c}),t=c=>D({activationEvent:c}),o=Promise.all(f.map(c=>S(E,c,t))).then(()=>{}),s=k(E,r.identifier,g,t);return Promise.all([o,s]).then(()=>{D(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function S(E,r,d){for(const f of E.folders)if(await E.exists(a.joinPath(A.URI.revive(f),r))){d(`workspaceContains:${r}`);return}}async function k(E,r,d,f){if(d.length===0)return Promise.resolve(void 0);const g=new u.CancellationTokenSource,D=E.checkExists(E.folders,d,g.token),p=setTimeout(async()=>{g.cancel(),E.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},L);let t=!1;try{t=await D}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}g.dispose(),clearTimeout(p),t&&f(`workspaceContains:${d.join(",")}`)}function C(E,r,d,f){const g=E.get(P.IInstantiationService),D=E.get(y.ISearchService),t=g.createInstance(T.QueryBuilder).file(r.map(o=>(0,m.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return D.fileSearch(t,f).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=C});var Je=this&&this.__classPrivateFieldSet||function(se,e,a,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!u:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(se,a):u?u.value=a:e.set(se,a),a},Me=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ce[42],Ie([1,0,181,12,84,24,19,6,69,2,16,5,35,242,100,34,27,135,10,25,22,224,7,128,4,26,80,20,92,55,41,3,302,99,226,18,98,43,11]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t,o,s,c,l,v,i,n,h,w,b,O,H,x,_,G,M){"use strict";var B,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let he=class fn extends T.Disposable{constructor(q,F,Q,me,Ee,te,ne,de,ee,ce,ae){super(),this.a=this.D(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=F,this.g=Q,this.f=ne,this.j=me,this.k=Ee,this.l=te,this.m=ee,this.p=ce,this.q=ae,this.s=this.g.getProxy(I.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(I.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(I.MainContext.MainThreadExtensionService),this.v=new P.Barrier,this.w=new P.Barrier,this.y=new P.Barrier,this.z=new P.Barrier,this.C=new ue(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const N=new g.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.C,re(this.G,N)),this.H=new C.ExtHostStorage(this.g,this.l),this.I=new O.ExtHostSecretState(this.g),this.J=de,this.h=q.createChild(new i.ServiceCollection([C.IExtHostStorage,this.H],[O.IExtHostSecretState,this.I])),this.L=this.D(new k.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(z,K,Z)=>{this.u.$onExtensionActivationError(z,f.transformErrorForSerialization(K),Z)},actualActivateExtension:async(z,K)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(z,this.F,this.G))return await this.u.$activateExtension(z,K),new k.HostExtension;const Z=this.F.getExtensionDescription(z);return this.Z(Z,K)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.ob(),this.v.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.mb()}catch(q){f.onUnexpectedError(q)}}async R(){this.J.onWillDeactivateAll();let q=[];try{q=this.F.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.Y(Ee))}catch{}await Promise.all(q)}terminate(q,F=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${q}`),this.l.flush(),this.p.dispose(),this.L.dispose(),f.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const Q=this.R();Promise.race([(0,P.timeout)(5e3),Q]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${F}`):this.l.info(`Extension host exiting with code ${F}`),this.l.flush(),this.l.dispose(),this.c.exit(F)})}isActivated(q){return this.y.isOpen()?this.L.isActivated(q):!1}async getExtension(q){const F=await this.u.$getExtension(q);let Q;if(F?.browserNlsBundleUris){Q={};for(const me of Object.keys(F.browserNlsBundleUris))Q[me]=m.URI.revive(F.browserNlsBundleUris[me])}return F&&{...F,identifier:new g.ExtensionIdentifier(F.identifier.value),extensionLocation:m.URI.revive(F.extensionLocation),browserNlsBundleUris:Q}}S(q,F){return this.L.activateByEvent(q,F)}U(q,F){return this.L.activateById(q,F)}activateByIdWithErrors(q,F){return this.U(q,F).then(()=>{const Q=this.L.getActivatedExtension(q);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(q=>this.F)}getExtensionExports(q){return this.y.isOpen()?this.L.getActivatedExtension(q).exports:null}async W(q){if(q.scheme!==x.Schemas.file)return q;const F=await this.c.realpath(q.fsPath);return m.URI.file(F)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(q=>new ve(q))),this.M}async X(q){const F=y.TernarySearchTree.forUris(Q=>R.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(q.map(async Q=>{if(this.pb(Q)){const me=await this.W(Q.extensionLocation);F.set(me,Q)}})),F}Y(q){let F=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(q))return F;const Q=this.L.getActivatedExtension(q);if(!Q)return F;try{typeof Q.module.deactivate=="function"&&(F=Promise.resolve(Q.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${q.value}':`),this.l.error(me)}try{(0,T.dispose)(Q.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.l.error(me)}return F}async Z(q,F){return this.f.remote.isRemote?this.u.$onWillActivateExtension(q.identifier):await this.u.$onWillActivateExtension(q.identifier),this.bb(q,F).then(Q=>{const me=Q.activationTimes;return this.u.$onDidActivateExtension(q.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,F),this.ab(q,F,"success",me),Q},Q=>{throw this.ab(q,F,"failure"),Q})}ab(q,F,Q,me){const Ee=V(q,F);this.t.$publicLog2("extensionActivationTimes",{...Ee,...me||{},outcome:Q})}bb(q,F){const Q=V(q,F);this.t.$publicLog2("activatePlugin",Q);const me=this.pb(q);if(!me)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${F.startup}, activationEvent: '${F.activationEvent}'${q.identifier.value!==F.extensionId.value?`, root cause: ${F.extensionId.value}`:""}`),this.l.flush();const Ee=new k.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this.qb(q,(0,R.joinPath)(q.extensionLocation,me),Ee),this.cb(q)]).then(te=>(u.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),fn.db(this.l,q.identifier,te[0],te[1],Ee))).then(te=>(u.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),te))}cb(q){const F=new p.ExtensionGlobalMemento(q,this.H),Q=new p.ExtensionMemento(q.identifier.value,!1,this.H),me=new H.ExtensionSecrets(q,this.I),Ee=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,te=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([F.whenReady,Q.whenReady,this.J.whenReady]).then(()=>{const ne=this;let de,ee;const ce=(0,r.isProposedApiEnabled)(q,"ipc")?this.f.messagePorts?.get(g.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:F,workspaceState:Q,secrets:me,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(ae){return A.join(q.extensionLocation.fsPath,ae)},get storagePath(){return ne.J.workspaceValue(q)?.fsPath},get globalStoragePath(){return ne.J.globalValue(q).fsPath},get logPath(){return A.join(ne.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return m.URI.joinPath(ne.f.logsLocation,q.identifier.value)},get storageUri(){return ne.J.workspaceValue(q)},get globalStorageUri(){return ne.J.globalValue(q)},get extensionMode(){return Ee},get extension(){return de===void 0&&(de=new J(ne,q.identifier,q,te,!1)),de},get extensionRuntime(){return(0,r.checkProposedApiEnabled)(q,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.p.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ee){if(!ce)return;const ae=w.Event.buffer(w.Event.fromDOMEventEmitter(ce,"message",N=>N.data));ce.start(),ee={onDidReceiveMessage:ae,postMessage:ce.postMessage.bind(ce)}}return ee}})})}static db(q,F,Q,me,Ee){return Q=Q||{activate:void 0,deactivate:void 0},this.eb(q,F,Q,me,Ee).then(te=>new k.ActivatedExtension(!1,null,Ee.build(),Q,te,me.subscriptions))}static eb(q,F,Q,me,Ee){if(typeof Q.activate=="function")try{Ee.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${F.value}`);const te=typeof global=="object"?global:self,ne=Q.activate.apply(te,[me]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(ne).then(de=>(Ee.activateResolveStop(),de))}catch(te){return Promise.reject(te)}else return Promise.resolve(Q)}fb(q,F){this.U(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:F}).then(void 0,Q=>{this.l.error(Q)})}gb(q,F=0){const me=Date.now();(0,M.setTimeout0)(()=>{for(let Ee=F;Ee<q.length;Ee+=1){const te=q[Ee];for(const ne of te.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-me>50){this.gb(q,Ee);break}else this.fb(te,ne)}})}hb(){this.u.$setPerformanceMarks(u.getMarks()),this.k.getConfigProvider().then(q=>{const F=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Q=this.F.getAllExtensionDescriptions();if(F)this.gb(Q);else for(const me of Q)if(me.activationEvents)for(const Ee of me.activationEvents)Ee==="onStartupFinished"&&this.fb(me,Ee)})}ib(){const q=this.S("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.D(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const F=this.j.workspace?this.j.workspace.folders:[],Q=this.jb(F),me=Promise.all([q,Q]).then(()=>{});return Promise.race([me,(0,P.timeout)(1e4)]).then(()=>{this.hb()}),me}jb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(F=>this.kb(q,F))).then(()=>{})}async kb(q,F){if(this.isActivated(F.identifier))return;const Q=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:q.map(te=>te.uri),forceUsingSearch:Q,exists:te=>this.c.exists(te.fsPath),checkExists:(te,ne,de)=>this.s.$checkExists(te,ne,de)},Ee=await(0,b.checkActivateWorkspaceContainsExtension)(me,F);if(!!Ee)return this.U(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Ee.activationEvent}).then(void 0,te=>this.l.error(te))}async $extensionTestsExecute(){await this.z.wait();try{return await this.lb()}catch(q){throw console.error(q),q}}async lb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:F}=this.f.environment;if(!q||!F)throw new Error(a.localize(0,null));const Q=await this.qb(null,F,new k.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(a.localize(1,null,F.toString()));return new Promise((me,Ee)=>{const te=(ee,ce)=>{ee?Ee(ee):me(typeof ce=="number"&&ce>0?1:0)},ne=(0,R.originalFSPath)(F),de=Q.run(ne,te);de&&de.then&&de.then(()=>{me(0)}).catch(ee=>{Ee(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,F){return this.N[q]=F,(0,T.toDisposable)(()=>{delete this.N[q]})}async nb(q){const F=q.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const Q=q.substr(0,F);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this.N[Q]}}async $resolveAuthority(q,F){const Q=G.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(q)},${F})][${Q.elapsed()}ms] `,Ee=ce=>this.l.info(`${me()}${ce}`),te=(ce,ae=void 0)=>this.l.error(`${me()}${ce}`,ae);Ee("activating resolver...");const{authorityPrefix:ne,resolver:de}=await this.nb(q);if(!de)return te("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};const ee=new P.IntervalTimer;try{Ee("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(de)),ee.cancelAndSet(()=>Ee("waiting..."),1e3),Ee("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${ne}`);const ce=await de.resolve(q,{resolveAttempt:F});u.mark(`code/extHost/didResolveAuthorityOK/${ne}`),ee.dispose(),Ee(`returned ${ce.host}:${ce.port}`);const ae={authority:q,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},N={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:N,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(u.mark(`code/extHost/didResolveAuthorityError/${ne}`),ee.dispose(),te("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(q,F){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(q)})`);const{resolver:Q}=await this.nb(q);if(!Q)return null;const me=m.URI.revive(F);if(typeof Q.getCanonicalURI>"u")return me;const Ee=await(0,P.asPromise)(()=>Q.getCanonicalURI(me));return Ee||me}$startExtensionHost(q){q.toAdd.forEach(me=>me.extensionLocation=m.URI.revive(me.extensionLocation));const{globalRegistry:F,myExtensions:Q}=ie(this.C,this.G,this.F,q);return this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),this.mb()}$activateByEvent(q,F){return F===1?this.S(q,!1):this.y.wait().then(Q=>this.S(q,!1))}async $activate(q,F){return await this.y.wait(),this.F.getExtensionDescription(q)?(await this.U(q,F),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(te=>te.extensionLocation=m.URI.revive(te.extensionLocation));const{globalRegistry:F,myExtensions:Q}=ie(this.C,this.G,this.F,q),me=await this.X(Q);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const F=D.VSBuffer.alloc(q),Q=Math.random()%256;for(let me=0;me<q;me++)F.writeUInt8(Q,me);return F}async $updateRemoteConnectionData(q){this.Q=q,this.a.fire()}};he=Ve([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,v.IExtHostRpcService),We(3,E.IExtHostWorkspace),We(4,S.IExtHostConfiguration),We(5,L.ILogService),We(6,c.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,n.IExtHostTunnelService),We(9,h.IExtHostTerminalService),We(10,_.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function ie(le,q,F,Q){le.addActivationEvents(Q.addActivationEvents);const me=new d.ExtensionDescriptionRegistry(le,q.getAllExtensionDescriptions());me.deltaExtensions(Q.toAdd,Q.toRemove);const Ee=new g.ExtensionIdentifierSet(F.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of Q.myToRemove)Ee.delete(ne);for(const ne of Q.myToAdd)Ee.add(ne);const te=re(me,Ee);return{globalRegistry:me,myExtensions:te}}function V(le,q){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class J{constructor(q,F,Q,me,Ee){B.set(this,void 0),U.set(this,void 0),j.set(this,void 0),Je(this,B,q,"f"),Je(this,U,F,"f"),Je(this,j,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=me,this.isFromDifferentExtensionHost=Ee}get isActive(){return Me(this,B,"f").isActivated(Me(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,j,"f"),{startup:!1,extensionId:Me(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=J,B=new WeakMap,U=new WeakMap,j=new WeakMap;function re(le,q){return le.getAllExtensionDescriptions().filter(F=>q.has(F.identifier))}class ve{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.ExtensionPaths=ve;class ue{constructor(q){this.a=new g.ExtensionIdentifierMap,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)}addActivationEvents(q){for(const F of Object.keys(q))this.a.set(F,q[F])}}}),define(Ce[303],Ie([1,0,84,2,5,35,27,25,20,26,4,42,36,16,8]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let E=class{constructor(p,t,o,s,c,l,v){this.c=p,this.d=t,this.e=o,this.f=s,this.g=c,this.h=l,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,p,this.i)),this.register(this.e.createInstance(f,t)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,t,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this.a.set(t,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(t=>p.alternativeModuleName(t))}};E=Ve([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,m.IExtHostInitDataService),We(6,k.ILogService)],E),e.RequireInterceptor=E;let r=class cn{constructor(p){if(p.environment.appRoot&&cn.a.size){const t=(0,C.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const t=this.b.exec(this.c(p));if(!t)return;const[,o,s,c]=t,l=cn.a.get(s);if(l!==void 0)return console.warn(`${s} as been renamed to ${l}, please update your imports`),o+l+c}c(p){return p.replace(/\\/g,"/")}};r.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),r=Ve([We(0,m.IExtHostInitDataService)],r);class d{constructor(p,t,o,s,c){this.c=p,this.d=t,this.e=o,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new T.ExtensionIdentifierMap}load(p,t){const o=this.d.findSubstr(t);if(o){let s=this.a.get(o.identifier);return s||(s=this.c(o,this.e,this.f),this.a.set(o.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,l)=>s+=`	${l} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(P.nullExtensionDescription,this.e,this.f)}return this.b}}let f=class{constructor(p,t,o){this.d=p,this.nodeModuleName="keytar",this.a=t.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,c=t.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let l=s.appRoot.fsPath;S.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,v)=>c.$getPassword(l,v),setPassword:(l,v,i)=>c.$setPassword(l,v,i),deletePassword:(l,v)=>c.$deletePassword(l,v),findPassword:l=>c.$findPassword(l),findCredentials(l){return c.$findCredentials(l)}}}load(p,t){const o=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const t=p.length;if(t<=7||!this.b)return;const o=t-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};f=Ve([We(1,y.IExtHostRpcService),We(2,m.IExtHostInitDataService)],f);let g=class{constructor(p,t,o){this.e=p,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this.c=(c,l)=>{const v=A.URI.parse(c);return l?this.g(c,l):v.scheme==="http"||v.scheme==="https"?s.$openUri(v,c,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?s.$openUri(v,c,{}):this.g(c,l)}}load(p,t,o){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=o(p),this.c}g(p,t){return this.i(),this.b(p,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=Ve([We(2,y.IExtHostRpcService)],g)}),define(Ce[50],Ie([1,0,65,6,12,36,4,59,60,42,7,34,238,35]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,P.createDecorator)("IExtHostVariableResolverProvider");class C extends S.AbstractVariableResolverService{constructor(d,f,g,D,p,t,o){function s(){if(g){const c=g.activeEditor();if(c)return c.document.uri;const l=D.tabGroups.all.find(v=>v.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.TextDiffTabInput||l.input instanceof L.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof L.TextTabInput||l.input instanceof L.NotebookEditorTabInput||l.input instanceof L.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:c=>{const l=t.folders.filter(v=>v.name===c);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,l)=>p.getConfiguration(void 0,c).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=s();if(c)return u.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const c=s();if(c){const l=f.getWorkspaceFolder(c);if(l)return u.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(g){const c=g.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(g){const c=g.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>d.getExtension(c)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let E=class extends A.Disposable{constructor(d,f,g,D,p){super(),this.b=d,this.c=f,this.g=g,this.h=D,this.i=p,this.a=new a.Lazy(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async c=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,s,this.j())})}getResolver(){return this.a.value}j(){}};E=Ve([We(0,m.IExtHostExtensionService),We(1,I.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,k.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],E),e.ExtHostVariableResolverProviderService=E}),define(Ce[85],Ie([1,0,19,3,9,2,4,5,60,42,20,7,34,132,231,35,50]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,P.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,l,v,i,n){this.D=c,this.E=l,this.F=v,this.G=i,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(T.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new g(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(w=>{this.I(h)}),this.I(h)})}asDebugSourceUri(s,c){const l=s;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let v=`debug:${encodeURIComponent(l.path||"")}`,i="?";return c&&(v+=`${i}session=${encodeURIComponent(c.id)}`,i="&"),v+=`${i}ref=${l.sourceReference}`,R.URI.parse(v)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const c=[];for(const l of s.getAllExtensionDescriptions())if(l.contributes){const v=l.contributes.debuggers;if(v&&v.length>0)for(const i of v)(0,C.isDebuggerMainContribution)(i)&&c.push(i.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){this.T();const c=s.filter(i=>{const n=i.id;return this.w.has(n)?!1:(this.w.set(n,i),!0)});this.U(c,[],[]);const l=[],v=new Map;for(const i of c)if(i instanceof I.SourceBreakpoint){let n=v.get(i.location.uri.toString());n||(n={type:"sourceMulti",uri:i.location.uri,lines:[]},v.set(i.location.uri.toString(),n),l.push(n)),n.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof I.FunctionBreakpoint&&l.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(s){this.T();const c=s.filter(n=>this.w.delete(n.id));this.U([],c,[]);const l=c.filter(n=>n instanceof I.SourceBreakpoint).map(n=>n.id),v=c.filter(n=>n instanceof I.FunctionBreakpoint).map(n=>n.id),i=c.filter(n=>n instanceof I.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(l,v,i)}startDebugging(s,c,l){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,l){if(!c)return new I.Disposable(()=>{});const v=this.d++;return this.f.push({type:s,handle:v,provider:c}),this.k.$registerDebugConfigurationProvider(s,l,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,v),new I.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==c),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(s,c,l){if(!l)return new I.Disposable(()=>{});if(!this.P(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:c,handle:v,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(c,v),new I.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new I.Disposable(()=>{});const l=this.i++;return this.j.push({type:s,handle:l,factory:c}),new I.Disposable(()=>{this.j=this.j.filter(v=>v.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let l;const v=await this.W(s);return v&&(l={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,c)}J(s,c){if(s.type==="implementation")return new p(s.implementation)}K(){}async $startDASession(s,c){const l=this,v=await this.V(c);return this.R(this.M(v.type),v).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const n=this.L(i),h=this.J(n,v);if(!h)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const w=h;return this.A.set(s,w),this.Q(v).then(b=>(b&&this.B.set(s,b),w.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const H=O,x={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const _=await this.C.sign(H.arguments.value);x.body={signature:_},w.sendResponse(x)}else throw new Error("no signer")}catch(_){x.success=!1,x.message=_.message,w.sendResponse(x)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(O),O=(0,C.convertToVSCPaths)(O,!0),l.k.$acceptDAMessage(s,O)}),w.onError(O=>{b&&b.onError&&b.onError(O),this.k.$acceptDAError(s,O.name,O.message,O.stack)}),w.onExit(O=>{b&&b.onExit&&b.onExit((0,u.withNullAsUndefined)(O),void 0),this.k.$acceptDAExit(s,(0,u.withNullAsUndefined)(O),void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),w.startSession()))})}$sendDAMessage(s,c){c=(0,C.convertToDAPaths)(c,!1);const l=this.B.get(s);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(c),this.A.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.B.get(s);this.B.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const l=this.A.get(s);return this.A.delete(s),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],l=[],v=[];if(s.added)for(const i of s.added){const n=i.id;if(n&&!this.w.has(n)){let h;if(i.type==="function")h=new I.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new I.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const w=R.URI.revive(i.uri);h=new I.SourceBreakpoint(new I.Location(w,new I.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,I.setBreakpointId)(h,n),this.w.set(n,h),c.push(h)}}if(s.removed)for(const i of s.removed){const n=this.w.get(i);n&&(this.w.delete(i),l.push(n))}if(s.changed){for(const i of s.changed)if(i.id){const n=this.w.get(i.id);if(n){if(n instanceof I.FunctionBreakpoint&&i.type==="function"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(n instanceof I.SourceBreakpoint&&i.type==="source"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new I.Location(R.URI.revive(i.uri),new I.Position(i.line,i.character))}v.push(n)}}}this.U(c,l,v)}$provideDebugConfigurations(s,c,l){return(0,a.asPromise)(async()=>{const v=this.O(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(c);return v.provideDebugConfigurations(i,l)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(s,c,l,v){return(0,a.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(c);return i.resolveDebugConfiguration(n,l,v)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,l,v){return(0,a.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(c);return i.resolveDebugConfigurationWithSubstitutedVariables(n,l,v)})}async $provideDebugAdapter(s,c){const l=this.N(s);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(c);return this.R(l,v).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const v={session:await this.V(s),event:c.event,body:c.body};this.u.fire(v)}L(s){if(s instanceof I.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const c=this.h.filter(l=>l.type===s);if(c.length>0)return c[0].factory}N(s){const c=this.h.filter(l=>l.handle===s);if(c.length>0)return c[0].factory}O(s){const c=this.f.filter(l=>l.handle===s);if(c.length>0)return c[0].provider}P(s,c){if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0){for(const v of l)if(v.label&&v.type&&v.type===c)return!0}}return!1}Q(s){const l=s.configuration.type,v=this.j.filter(i=>i.type===l||i.type==="*").map(i=>(0,a.asPromise)(()=>i.factory.createDebugAdapterTracker(s)).then(n=>n,n=>null));return Promise.race([Promise.all(v).then(i=>{const n=i.filter(h=>!!h);if(n.length>0)return new D(n)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(s,c){const l=c.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new I.DebugAdapterServer(l));if(s){const i=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>s.createDebugAdapterDescriptor(c,this.S(c,i))).then(n=>{if(n)return n})}const v=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,v))}S(s,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,c,l){(s.length>0||c.length>0||l.length>0)&&this.z.fire(Object.freeze({added:s,removed:c,changed:l}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const l=await this.W(s.folderUri),v=s.parent?this.l.get(s.parent):void 0;c=new f(this.k,s.id,s.type,s.name,l,s.configuration,v),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=R.URI.revive(s);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};d=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,m.IExtHostExtensionService),We(3,E.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,r.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class f{constructor(s,c,l,v,i,n,h){this.d=s,this.f=c,this.g=l,this.h=v,this.i=i,this.j=n,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=f;class g{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=g;class D{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(l=>l.onExit?l.onExit(s,c):void 0)}}class p extends k.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(s,c,l,v,i,n){super(s,c,l,v,i,n)}};t=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,m.IExtHostExtensionService),We(3,E.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,r.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[304],Ie([1,0,10,84,2,5,296,16,91,92,26,207,20,56,42,77]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class r{static async installEarlyHandler(g){const D=g.get(T.ILogService),t=g.get(S.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{D.error(o);const s=a.transformErrorForSerialization(o);t.$onUnexpectedError(s)})}static async installFullHandler(g){const D=g.get(T.ILogService),p=g.get(S.IExtHostRpcService),t=g.get(C.IExtHostExtensionService),o=g.get(E.IExtHostTelemetry),s=p.getProxy(R.MainContext.MainThreadExtensionService),c=p.getProxy(R.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),v=new WeakMap;Error.prepareStackTrace=(i,n)=>{let h="",w,b;for(const O of n)h+=`
	at ${O.toString()}`,b=O.getFileName(),!w&&b&&(w=l.findSubstr(u.URI.file(b)));return v.set(i,w?.identifier),`${i.name||"Error"}: ${i.message||""}${h}`},a.setUnexpectedErrorHandler(i=>{D.error(i);const n=a.transformErrorForSerialization(i),h=v.get(i);if(!h){c.$onUnexpectedError(n);return}s.$onExtensionRuntimeError(h,n);const w=o.onExtensionError(h,i);D.trace("forwarded error to extension?",w,h)})}}Error.stackTraceLimit=100;class d{constructor(g,D,p,t,o){this.a=p,this.b=new P.RPCProtocol(g,null,t),D=d.e(D,this.b);const s=new m.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:o}),s.set(S.IExtHostRpcService,new S.ExtHostRpcService(this.b)),s.set(k.IURITransformerService,new k.URITransformerService(t)),s.set(C.IHostUtils,p);const c=new I.InstantiationService(s,!0);c.invokeFunction(r.installEarlyHandler),this.d=c.invokeFunction(l=>l.get(T.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=c.invokeFunction(l=>l.get(C.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(r.installFullHandler)}async asBrowserUri(g){const D=this.b.getProxy(R.MainContext.MainThreadExtensionService);return u.URI.revive(await D.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,D){g.allExtensions.forEach(t=>{t.extensionLocation=u.URI.revive(D.transformIncomingURIs(t.extensionLocation));const o={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(D.transformIncomingURIs(t.browserNlsBundleUris[s]))),t.browserNlsBundleUris=o)}),g.environment.appRoot=u.URI.revive(D.transformIncomingURIs(g.environment.appRoot));const p=g.environment.extensionDevelopmentLocationURI;return p&&(g.environment.extensionDevelopmentLocationURI=p.map(t=>u.URI.revive(D.transformIncomingURIs(t)))),g.environment.extensionTestsLocationURI=u.URI.revive(D.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=u.URI.revive(D.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=u.URI.revive(D.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=u.URI.revive(D.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=u.URI.revive(D.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=u.URI.revive(D.transformIncomingURIs(g.logsLocation)),g.workspace=D.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=d}),define(Ce[305],Ie([1,0,19,11,189,206,214,85,60,42,20,41,7,50,34,232,234,35]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let f=class extends T.ExtHostDebugServiceBase{constructor(o,s,c,l,v,i,n){super(o,s,c,l,i,n),this.Z=v,this.X=new p}J(o,s){switch(o.type){case"server":return new E.SocketDebugAdapter(o);case"pipeServer":return new E.NamedPipeDebugAdapter(o);case"executable":return new E.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const c=E.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(c)return new S.DebugAdapterExecutable(c.command,c.args,c.options)}K(){return new P.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(_=>{this.X.onTerminalClosed(_)}));const c=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),v=this.Z.getDefaultShellArgs(!0),i=o.title||u.localize(0,null),n=JSON.stringify({shell:l,shellArgs:v});let h=await this.X.checkout(n,i),w,b=!1;if(h)w=o.cwd;else{const _={shellPath:l,shellArgs:v,cwd:o.cwd,name:i,iconPath:new S.ThemeIcon("debug")};b=!0,h=this.Z.createTerminalFromOptions(_,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,n)}h.show(!0);const O=await h.processId;b?await new Promise(_=>setTimeout(_,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?h.sendText("cls"):l.indexOf("bash")>=0?h.sendText("clear"):A.isWindows?h.sendText("cls"):h.sendText("clear"));const H=(0,r.prepareCommand)(l,o.args,!!o.argsCanBeInterpretedByShell,w,o.env);h.sendText(H);const x=this.onDidTerminateDebugSession(_=>{_.id===s&&(this.X.free(h),x.dispose())});return O}else if(o.kind==="external")return D(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};f=Ve([We(0,L.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,m.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,I.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,k.IExtHostVariableResolverProvider)],f),e.ExtHostDebugService=f;let g;function D(t,o){if(!g)if(A.isWindows)g=new R.WindowsExternalTerminalService;else if(A.isMacintosh)g=new R.MacExternalTerminalService;else if(A.isLinux)g=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return g.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class p{constructor(){this.b=new Map}async checkout(o,s){const l=[...this.b.entries()].map(([v,i])=>(0,a.createCancelablePromise)(async n=>{if(v.name!==s||i.lastUsedAt!==-1&&await(0,r.hasChildProcesses)(await v.processId))return null;const h=Date.now();return i.lastUsedAt+p.a>h||n.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=h,v)}));return await(0,a.firstParallel)(l,v=>!!v)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}p.a=1e3}),define(Ce[306],Ie([1,0,12,2,117,34,59,35,48,41,20,26,83,18,16,78,24,89,50]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends S.ExtHostTaskBase{constructor(p,t,o,s,c,l,v,i,n){super(p,t,o,s,c,l,v,i),this.B=o,this.C=n,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=S.TaskHandleDTO.from(o,this.B),c=await this.a.$getTaskExecution(s);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(c,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=S.TaskDTO.from(t,p);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const c=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),c}}u(p,t,o,s){const c=[];if(s)for(const l of s){this.z(l,o),(!l.definition||!p[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const v=S.TaskDTO.from(l,o.extension);v&&(c.push(v),S.CustomExecutionDTO.is(v.execution)&&t.push(this.x(v,l,!0)))}return{tasks:c,extension:o.extension}}async v(p){return p}async F(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const o=A.URI.file((0,d.homedir)());t=new y.WorkspaceFolder({uri:o,name:r.basename(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const o=A.URI.revive(p),s={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(o),l=await this.b.getWorkspaceFolders2()??[],v=await this.C.getResolver(),i=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const n of t.variables)s.variables[n]=await v.resolveAsync(i,n);if(t.process!==void 0){let n;if(t.process.path!==void 0){n=t.process.path.split(a.delimiter);for(let h=0;h<n.length;h++)n[h]=await v.resolveAsync(i,n[h])}s.process=await u.win32.findExecutable(await v.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(i,t.process.cwd):void 0,n)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,o){return u.win32.findExecutable(p,t,o)}};g=Ve([We(0,L.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,P.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,m.IExtHostTerminalService),We(6,C.ILogService),We(7,E.IExtHostApiDeprecationService),We(8,f.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(Ce[307],Ie([1,0,89,50]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends A.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(Ce[144],Ie([1,0,17,19,21,46,18,12,24,2,31]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(f,g,D,p){this.d=f,this.e=g,this.f=D,this.g=p,this.a=null,this.b=!1,this.c=0}search(f,g){const D=this.d.folderQueries||[],p=new u.CancellationTokenSource;return g.onCancellationRequested(()=>p.cancel()),new Promise((t,o)=>{this.a=new k(f);let s=!1;const c=(l,v)=>{if(!s&&!this.b){const i=this.h(l);E(l)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,s=!0,p.cancel(),l=this.j(l,this.d.maxResults-this.c));const n=this.h(l);this.c+=n,(n>0||!E(l))&&this.a.add(l,v)}};Promise.all(D.map((l,v)=>this.k(l,i=>c(i,v),p.token))).then(l=>{p.dispose(),this.a.flush();const v=l.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||v,messages:(0,a.flatten)(l.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},l=>{p.dispose();const v=(0,R.toErrorMessage)(l);o(new Error(v))})})}h(f){return E(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,g){const D=Array.isArray(f.ranges)?f.ranges:[f.ranges],p=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:D.slice(0,g),preview:{matches:p.slice(0,g),text:f.preview.text},uri:f.uri}}async k(f,g,D){const p=new L.QueryGlobTester(this.d,f),t=[],o={report:l=>{if(!this.l(l))return;const v=f.folder.scheme===P.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(l.uri))):void 0,i=y.relativePath(f.folder,l.uri);if(i){const n=p.includedInQuery(i,T.basename(i),v);(0,A.isThenable)(n)?t.push(n.then(h=>{h&&g(l)})):n&&g(l)}}},s=this.n(f),c=await this.e.provideTextSearchResults(S(this.d.contentPattern),s,o,D);return t.length&&await Promise.all(t),c}l(f){if(E(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const g=(0,L.resolvePatternsForProvider)(this.d.includePattern,f.includePattern),D=(0,L.resolvePatternsForProvider)(this.d.excludePattern,f.excludePattern),p={folder:m.URI.from(f.folder),excludes:D,includes:g,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.f.toCanonicalName(f.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=I;function S(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new r(512,g=>this.g(g))}add(f,g){this.d&&(this.b!==g||!y.isEqual(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:f.uri,results:[]}),this.d.results.push(C(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.TextSearchResultsCollector=k;function C(d){return E(d)?{preview:{matches:(0,a.mapArrayOrNot)(d.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:d.preview.text},ranges:(0,a.mapArrayOrNot)(d.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function E(d){return!!d.preview}e.extensionResultIsMatch=E;class r{constructor(f,g){this.g=f,this.h=g,this.c=0,this.d=[],this.e=0}addItem(f,g){!f||this.j(f,g)}addItems(f,g){!f||this.k(f,g)}j(f,g){this.d.push(f),this.e+=g,this.l()}k(f,g){this.d=this.d.concat(f),this.e+=g,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}r.a=4e3,r.b=50,e.BatchedCollector=r}),define(Ce[86],Ie([1,0,6,5,4,300,20,56,16,2,144]),function(se,e,a,A,u,R,P,T,y,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let I=class{constructor(E,r,d){this.k=E,this.l=r,this.n=d,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,r){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const d=this.d++;return this.e.set(d,r),this.c.$registerTextSearchProvider(d,this.o(E)),(0,a.toDisposable)(()=>{this.g.delete(E),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(E,r){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const d=this.d++;return this.h.set(d,r),this.c.$registerFileSearchProvider(d,this.o(E)),(0,a.toDisposable)(()=>{this.i.delete(E),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(E,r,d,f){const g=S(d),D=this.h.get(E);if(D)return this.j.fileSearch(g,D,p=>{this.c.$handleFileMatch(E,r,p.map(t=>t.resource))},f);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,r,d,f){const g=this.e.get(E);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const D=S(d);return this.q(D,g).search(t=>this.c.$handleTextMatch(E,r,t),f)}$enableExtensionHostSearch(){}q(E,r){return new L.TextSearchManager(E,r,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};I=Ve([We(0,P.IExtHostRpcService),We(1,T.IURITransformerService),We(2,y.ILogService)],I),e.ExtHostSearch=I;function S(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(k),extraFileResources:C.extraFileResources&&C.extraFileResources.map(E=>m.URI.revive(E))}}e.reviveQuery=S;function k(C){return{...C,folder:m.URI.revive(C.folder)}}}),define(Ce[308],Ie([1,0,91,143,34,140,35,40,59,41,83,85,86,100,55,78,142,79,49,99,77,60,141,16,50,98]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t,o,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,t.ExtHostLoggerService,1),(0,a.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration,0),(0,a.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,a.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,0),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,a.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,a.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,a.registerSingleton)(r.IExtHostWindow,r.ExtHostWindow,0),(0,a.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,a.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,0),(0,a.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Ce[101],Ie([1,0,17,16,31,82]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=P;function T(I,S,k,C){const E=(0,a.mapArrayOrNot)(k,y),r=new u.TextSearchMatch(S,E,C),d=r.preview.matches;return{ranges:(0,a.mapArrayOrNot)(E,m),uri:I,preview:{text:r.preview.text,matches:(0,a.mapArrayOrNot)(d,m)}}}e.createTextSearchResult=T;function y(I){return new u.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function m(I){return new R.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(S,k){this.a=S,this.b=k}appendLine(S){this.b.debug(`${this.a}#search`,S)}};L=Ve([We(1,A.ILogService)],L),e.OutputChannel=L}),define(Ce[309],Ie([1,0,47,12,87,33,11,8,101,310]),function(se,e,a,A,u,R,P,T,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=m.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(g,D,p,t){const o=S(g,D,p,t),s=D.folder.fsPath;return{cmd:a.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=I;function S(g,D,p,t){const o=["--files","--hidden","--case-sensitive"];C([D],p,!1).forEach(c=>{const l=(0,y.anchorGlob)(c);if(o.push("-g",l),P.isMacintosh){const v=(0,u.normalizeNFD)(l);v!==l&&o.push("-g",v)}});const s=k([D],t,void 0,!1);return s.globArgs.forEach(c=>{const l=`!${(0,y.anchorGlob)(c)}`;if(o.push("-g",l),P.isMacintosh){const v=(0,u.normalizeNFD)(l);v!==l&&o.push("-g",v)}}),D.disregardIgnoreFiles!==!1?o.push("--no-ignore"):D.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),D.ignoreSymlinks||o.push("--follow"),g.exists&&o.push("--quiet"),o.push("--no-config"),D.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function k(g,D,p,t=!0){const o=[];let s={};return g.forEach(c=>{const l=Object.assign({},c.excludePattern||{},D||{}),v=E(l,t?c.folder.fsPath:void 0,p);o.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:o,siblingClauses:s}}function C(g,D,p=!0){const t=[];return g.forEach(o=>{const s=Object.assign({},D||{},o.includePattern||{}),c=E(s,p?o.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function E(g,D,p){const t=[],o={};return Object.keys(g).forEach(s=>{if(p&&p.has(s)||!s)return;const c=g[s];s=d(D?r(D,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof c=="boolean"&&c?(s.startsWith("\\\\")&&(s+="**"),t.push(f(s))):c&&c.when&&(o[s]=c)}),{globArgs:t,siblingClauses:o}}function r(g,D){return A.isAbsolute(D)?D:A.join(g,D)}e.getAbsoluteGlob=r;function d(g){return g=T.rtrim(g,"\\"),T.rtrim(g,"/")}function f(g){return R.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=f}),define(Ce[311],Ie([1,0,47,71,12,312,17,46,38,87,33,11,43,8,9,29,31,309,112]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(s=>s())});class D{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&y.parse(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,f.prepareQuery)(this.b).normalizedLowercase),this.u=c.excludePattern&&y.parse(c.excludePattern),this.t=new Map,c.folderQueries.forEach(l=>{const v=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),i=l.folder.fsPath;c.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==i).forEach(n=>{(0,L.isEqualOrParent)(n,i)&&(v[u.relative(i,n)]=!0)}),this.t.set(i,new t(v,i))})}cancel(){this.l=!0,g.forEach(c=>c())}walk(c,l,v,i,n){if(this.m=S.StopWatch.create(!1),this.l)return n(null,this.j);l.forEach(h=>{const w=u.basename(h.fsPath);this.u&&this.u(h.fsPath,w)||this.J(v,{relativePath:h.fsPath,searchPath:void 0})}),this.r=S.StopWatch.create(!1),this.w(c,(h,w)=>{this.x(this.y,this,h,v,i,b=>{if(b){const O=(0,T.toErrorMessage)(b);console.error(O),this.q.push(O),w(b,void 0)}else w(null,void 0)})},(h,w)=>{this.m.stop();const b=h?P.coalesce(h)[0]:null;n(b,this.j)})}w(c,l,v){const i=new Array(c.length),n=new Array(c.length);let h=!1,w=0;if(c.length===0)return v(null,[]);c.forEach((b,O)=>{l(b,(H,x)=>{if(H?(h=!0,i[O]=null,n[O]=H):(i[O]=x,n[O]=null),++w===c.length)return v(h?n:null,i)})})}x(c,l,...v){try{c.apply(l,v)}catch(i){v[v.length-1](i)}}y(c,l,v,i){const n=c.folder.fsPath,h=I.isMacintosh,w=()=>_&&_.kill();g.add(w);let b=U=>{g.delete(w),b=()=>{},i(U)},O="";const H=this.D(),x=(0,d.spawnRipgrepCmd)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),_=x.cmd,G=!Object.keys(x.siblingClauses).length,M=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${x.rgDiskPath} ${M}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),v({message:B}),this.s=0,this.z(_,"utf8",v,(U,j,he)=>{if(U){b(U);return}if(this.j){b();return}const V=(O+(h?m.normalizeNFC(j||""):j)).split(`
`);if(he){const J=V.length;V[J-1]=V[J-1].trim(),V[J-1]||V.pop()}else O=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.s+=V.length,G){for(const J of V)if(this.J(l,{base:n,relativePath:J,searchPath:this.N(c,J)}),this.j){w();break}(he||this.j)&&b();return}this.G(c,H,n,V,l),he&&(this.H(H,n,l),b())})}spawnFindCmd(c){const l=this.t.get(c.folder.fsPath),v=l.getBasenameTerms(),i=l.getPathTerms(),n=["-L","."];if(v.length||i.length){n.push("-not","(","(");for(const h of v)n.push("-name",h),n.push("-o");for(const h of i)n.push("-path",h),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),a.spawn("find",n,{cwd:c.folder.fsPath})}readStdout(c,l,v){let i="";this.z(c,l,()=>{},(n,h,w)=>{if(n){v(n);return}i+=h,w&&v(null,i)})}z(c,l,v,i){let n=(b,O,H)=>{(b||H)&&(n=()=>{},this.r?.stop()),i(b,O,H)},h=!1;c.stdout?(this.A(c.stdout,l,n),c.stdout.once("data",()=>h=!0)):v({message:"stdout is null"});let w;c.stderr?w=this.B(c.stderr):v({message:"stderr is null"}),c.on("error",b=>{n(b)}),c.on("close",b=>{let O;!h&&(O=this.C(w,l))&&o(O)?n(new Error(`command failed with error code ${b}: ${this.C(w,l)}`)):(this.g&&b===0&&(this.j=!0),n(null,"",!0))})}A(c,l,v){const i=new R.StringDecoder(l);return c.on("data",n=>{v(null,i.write(n))}),i}B(c){const l=[];return c.on("data",v=>{l.push(v)}),l}C(c,l){const v=new R.StringDecoder(l);return c.map(i=>v.write(i)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:l},v,i,n){i.indexOf(this.b)!==-1&&this.J(n,{base:v,relativePath:this.b,searchPath:this.N(c,this.b)});const h=w=>{const b=u.basename(w),O=u.dirname(w);let H=l[O];H||(H=l[O]=[],h(O)),H.push({base:v,relativePath:w,basename:b,searchPath:this.N(c,w)})};i.forEach(h)}H({rootEntries:c,pathToEntries:l},v,i){const n=this,h=this.t.get(v),w=this.b;function b(O){n.o++;const H=(0,r.hasSiblingFn)(()=>O.map(x=>x.basename));for(let x=0,_=O.length;x<_;x++){const G=O[x],{relativePath:M,basename:B}=G;if(h.test(M,B,w!==B?H:void 0))continue;const U=l[M];if(U)b(U);else{if(n.p++,M===w)continue;n.J(i,G)}if(n.j)break}}b(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,l,v,i,n){const h=c.folder,w=(0,r.hasSiblingFn)(()=>v);this.w(v,(b,O)=>{if(this.l||this.j)return O(null);const H=l?[l,b].join(u.sep):b;if(this.t.get(c.folder.fsPath).test(H,b,this.a.filePattern!==b?w:void 0))return O(null);const x=[h.fsPath,H].join(u.sep);A.lstat(x,(_,G)=>{if(_||this.l||this.j)return O(null);this.L(x,G,(M,B)=>M||this.l||this.j?O(null):B.isDirectory()?(this.o++,this.M(x,G,(U,j)=>U||this.l||this.j||(j=j||"",this.v[j])?O(null):(this.v[j]=!0,E.Promises.readdir(x).then(he=>{if(this.l||this.j)return O(null);this.I(c,H,he,i,ie=>O(ie||null))},he=>{O(null)})))):(this.p++,H===this.b||this.h&&C.isNumber(B.size)&&B.size>this.h||this.J(i,{base:h.fsPath,relativePath:H,searchPath:this.N(c,H)}),O(null,void 0)))})},b=>{const O=b&&P.coalesce(b);return n(O&&O.length>0?O[0]:void 0)})}J(c,l){this.K(l)&&(!this.d||this.d(l.relativePath,u.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(l))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.isFilePatternMatch)(c,this.c)}return!0}L(c,l,v){return l.isSymbolicLink()?A.stat(c,v):v(null,l)}M(c,l,v){return l.isSymbolicLink()?A.realpath(c,(i,n)=>i?v(i):v(null,n)):v(null,c)}N(c,l){return c.folderName?u.join(c.folderName,l):l}}e.FileWalker=D;class p{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new D(c)}search(c,l,v){this.c.walk(this.a,this.b,c,l,(i,n)=>{v(i,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class t{constructor(c,l){this.expression=c,this.c=l,this.d(c)}d(c){let l,v;Object.keys(c).filter(i=>c[i]).forEach(i=>{u.isAbsolute(i)?(l=l||y.getEmptyExpression(),l[i]=c[i]):(v=v||y.getEmptyExpression(),v[i]=c[i])}),this.a=l&&y.parse(l,{trimForExclusions:!0}),this.b=v&&y.parse(v,{trimForExclusions:!0})}test(c,l,v){return this.b&&this.b(c,l,v)||this.a&&this.a(u.join(this.c,c),l,v)}getBasenameTerms(){const c=[];return this.a&&c.push(...y.getBasenameTerms(this.a)),this.b&&c.push(...y.getBasenameTerms(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...y.getPathTerms(this.a)),this.b&&c.push(...y.getPathTerms(this.b)),c}}function o(s){const c=s.trim().split(`
`),l=c[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return k.uppercaseFirstLetter(c[c.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(Ce[313],Ie([1,0,104,22]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,P=512,T=512*8,y=512*128;var m;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(m=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(c,l){super(c),this.decodeStreamErrorKind=l}}e.DecodeStreamError=L;class I{static async create(c){let l;if(c!==e.UTF8)l=(await new Promise((i,n)=>{se(["@vscode/iconv-lite-umd"],i,n)})).getDecoder(E(c));else{const v=new TextDecoder;l={write(i){return v.decode(i,{stream:!0})},end(){return v.decode()}}}return new I(l)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function S(s,c){const l=c.minBytesRequiredForDetection??c.guessEncoding?T:P;return new Promise((v,i)=>{const n=(0,a.newWriteableStream)(x=>x.join("")),h=[];let w=0,b;const O=async()=>{try{const x=await o({buffer:A.VSBuffer.concat(h),bytesRead:w},c.guessEncoding);if(x.seemsBinary&&c.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);x.encoding=await c.overwriteEncoding(x.encoding),b=await I.create(x.encoding);const _=b.write(A.VSBuffer.concat(h).buffer);n.write(_),h.length=0,w=0,v({stream:n,detected:x})}catch(x){H?.dispose(),n.destroy(),i(x)}},H=(0,a.listenStream)(s,{onData:async x=>{b?n.write(b.write(x.buffer)):(h.push(x),w+=x.byteLength,w>=l&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:x=>n.error(x),onEnd:async()=>{b||await O(),n.end(b?.end())}})})}e.toDecodeStream=S;async function k(s,c,l){const i=(await new Promise((w,b)=>{se(["@vscode/iconv-lite-umd"],w,b)})).getEncoder(E(c),l);let n=!1,h=!1;return{read(){if(h)return null;const w=s.read();if(typeof w!="string"){if(h=!0,!n&&l?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=i.end();return b&&b.length>0?(n=!0,A.VSBuffer.wrap(b)):null}return n=!0,A.VSBuffer.wrap(i.write(w))}}}e.toEncodeReadable=k;async function C(s){return(await new Promise((l,v)=>{se(["@vscode/iconv-lite-umd"],l,v)})).encodingExists(E(s))}e.encodingExists=C;function E(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=E;function r(s,c){if(!s||c<e.UTF16be_BOM.length)return null;const l=s.readUInt8(0),v=s.readUInt8(1);if(l===e.UTF16be_BOM[0]&&v===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&v===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const i=s.readUInt8(2);return l===e.UTF8_BOM[0]&&v===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=r;const d=["ascii","utf-16","utf-32"];async function f(s){const c=await new Promise((h,w)=>{se(["jschardet"],h,w)}),l=s.slice(0,y),v=p(l.buffer),i=c.detect(v);if(!i||!i.encoding)return null;const n=i.encoding.toLowerCase();return 0<=d.indexOf(n)?null:D(i.encoding)}const g={ibm866:"cp866",big5:"cp950"};function D(s){const c=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[c]||c}function p(s){let c="";for(let l=0;l<s.length;l++)c+=String.fromCharCode(s[l]);return c}function t(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=s.match(/windows(\d+)/);return c?"windows-"+c[1]:s}}}e.toCanonicalName=t;function o({buffer:s,bytesRead:c},l){let v=r(s,c),i=!1;if(v!==e.UTF16be&&v!==e.UTF16le&&s){let n=!0,h=!0,w=!1;for(let b=0;b<c&&b<R;b++){const O=b%2===1,H=s.readUInt8(b)===0;if(H&&(w=!0),n&&(O&&!H||!O&&H)&&(n=!1),h&&(O&&H||!O&&!H)&&(h=!1),H&&!n&&!h)break}w&&(n?v=e.UTF16le:h?v=e.UTF16be:i=!0)}return l&&!i&&!v&&s?f(s.slice(0,c)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:i,encoding:v}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[145],Ie([1,0,313,29,144]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends u.TextSearchManager{constructor(T,y,m=A,L="searchProcess"){super(T,y,{readdir:I=>m.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,a.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=R}),define(Ce[314],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(u){if(u&&this.a.has(u)){const R=this.a.get(u);return this.a.delete(u),R}}addDragOperationTransfer(u,R){this.a.set(u,R)}getRenderedTreeElement(u){if(this.b.has(u))return this.b.get(u)}addRenderedTreeItemElement(u,R){this.b.set(u,R)}removeRenderedTreeItemElement(u){this.b.has(u)&&this.b.delete(u)}}e.TreeviewsService=a}),define(Ce[315],Ie([1,0,187,7,24,2,3,6,229,19,7,9,17,13,21,314,27]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(D,p){if((0,I.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let t;return Array.isArray(D.highlights)&&(t=D.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:D.label,highlights:t}}}class f{constructor(p,t,o){this.d=p,this.e=t,this.f=o,this.a=new Map,this.b=new E.TreeviewsService;function s(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>s(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(l=>s(l)?this.i(l):l):c})}registerTreeDataProvider(p,t,o){const s=this.createTreeView(p,{treeDataProvider:t},o);return{dispose:()=>s.dispose()}}createTreeView(p,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,i=this.h(p,t,o),n=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:c,hasHandleDrag:l,hasHandleDrop:v});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,r.checkProposedApiEnabled)(o,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&L.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,w)=>i.reveal(h,w),dispose:async()=>{await n,this.a.delete(p),i.dispose()}}}$getChildren(p,t){const o=this.a.get(p);return o?o.getChildren(t):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,t,o,s,c,l,v,i){const n=this.a.get(p);if(!n)return Promise.reject(new y.NoTreeViewError(p));const h=k.DataTransfer.toDataTransfer(o,async w=>(await this.d.$resolveDropFileData(p,t,w)).buffer);return v===p&&i&&await this.g(h,n,i,c,l),n.onDrop(h,s,c)}async g(p,t,o,s,c){const l=this.b.removeDragOperationTransfer(c);if(l)(await l)?.forEach((v,i)=>{v&&p.set(i,v)});else if(c&&t.handleDrag){const v=t.handleDrag(o,p,s);this.b.addDragOperationTransfer(c,v),await v}return p}async $handleDrag(p,t,o,s){const c=this.a.get(p);if(!c)return Promise.reject(new y.NoTreeViewError(p));const l=await this.g(new A.DataTransfer,c,t,s,o);if(!!l)return k.DataTransfer.toDataTransferDTO(l)}async $hasResolve(p){const t=this.a.get(p);if(!t)throw new y.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,o){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);return s.resolveTreeItem(t,o)}$setExpanded(p,t,o){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);s.setExpanded(t,o)}$setSelection(p,t){const o=this.a.get(p);if(!o)throw new y.NoTreeViewError(p);o.setSelection(t)}$setFocus(p,t){const o=this.a.get(p);if(!o)throw new y.NoTreeViewError(p);o.setFocus(t)}$setVisible(p,t){const o=this.a.get(p);if(!o)throw new y.NoTreeViewError(p);o.setVisible(t)}$changeCheckboxState(p,t){const o=this.a.get(p);if(!o)throw new y.NoTreeViewError(p);o.setCheckboxState(t)}h(p,t,o){const s=new g(p,t,this.d,this.e.converter,this.f,o);return this.a.set(p,s),s}i(p){const t=this.a.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=f;class g extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,I.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,t,o,s,c,l){if(super(),this.z=p,this.C=o,this.F=s,this.G=c,this.H=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new P.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new P.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new P.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new P.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new P.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new P.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const h of l.contributes.views[n])h.id===p&&(this.J=h.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(n=>this.v.fire({message:!1,element:n})));let v,i;this.D(P.Event.debounce(this.v.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(v||(v=new Promise(w=>i=w),this.w=this.w.then(()=>v)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.y=this.y.then(()=>{const w=i;return v=null,this.U(h).then(()=>w())})),n&&this.C.$setMessage(this.z,this.I)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.Q(p);return o||(o=await this.R(t)),o?o.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,I.isUndefinedOrNull)(t.focus)?!1:t.focus,c=(0,I.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.w.then(()=>this.N(p)).then(l=>this.P(p,l[l.length-1]).then(v=>this.C.$reveal(this.z,{item:v.item,parentChain:l.map(i=>i.item)},{select:o,focus:s,expand:c})),l=>this.G.error(l)):this.C.$reveal(this.z,void 0,{select:o,focus:s,expand:c})}get message(){return this.I}set message(p){this.I=p,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.C.$setTitle(this.z,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.C.$setTitle(this.z,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=k.ViewBadge.from(p),this.C.$setBadge(this.z,p))}setExpanded(p,t){const o=this.getExtensionElement(p);o&&(t?this.q.fire(Object.freeze({element:o})):this.r.fire(Object.freeze({element:o})))}setSelection(p){(0,S.equals)(this.l,p)||(this.l=p,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.u.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,t,o){const s=[];for(const c of p){const l=this.getExtensionElement(c);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,t,o){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,m.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,t){if(!this.f.resolveTreeItem)return;const o=this.i.get(p);if(o){const s=this.j.get(o);if(s){const c=await this.f.resolveTreeItem(s.extensionItem,o,t)??s.extensionItem;return this.db(c),s.item.tooltip=this.ab(c.tooltip),s.item.command=this.bb(s.disposableStore,c.command),s.item}}}N(p){return this.O(p).then(t=>t?this.N(t).then(o=>this.P(t,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(p){const t=this.j.get(p);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,m.asPromise)(()=>this.f.getParent(p))}P(p,t){const o=this.j.get(p);return o?Promise.resolve(o):(0,m.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(s);if(c){const l=this.j.get(c);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let t;if(typeof p=="string"){const o=this.getExtensionElement(p);t=o?this.j.get(o):void 0}else t=p;return t&&t.children||void 0}return this.h}async R(p){this.nb(p);const t=new C.CancellationTokenSource(this.S.token);try{const o=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,S.coalesce)(s||[]).map(async l=>{const v=await this.f.getTreeItem(l);return v&&!t.token.isCancellationRequested?this.Z(l,v,o):null}));return t.token.isCancellationRequested?void 0:(0,S.coalesce)(c)}finally{t.dispose()}}U(p){if(p.some(o=>!o))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const o=this.W(p);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(p){const t=new Set,o=p.map(c=>this.j.get(c));for(const c of o)if(c&&!t.has(c.item.handle)){let l=c;for(;l&&l.parent&&o.findIndex(v=>l&&l.parent&&v&&v.item.handle===l.parent.item.handle)===-1;){const v=this.i.get(l.parent.item.handle);l=v?this.j.get(v):void 0}l&&!l.parent&&t.add(c.item.handle)}const s=[];return t.forEach(c=>{const l=this.i.get(c);if(l){const v=this.j.get(l);v&&(!v.parent||!t.has(v.parent.item.handle))&&s.push(c)}}),s}X(p){const t={};return Promise.all(p.map(o=>this.Y(o).then(s=>{s&&(t[o]=s.item)}))).then(()=>Object.keys(t).length?this.C.$refresh(this.z,t):void 0)}Y(p){const t=this.getExtensionElement(p);if(t){const o=this.j.get(t);if(o)return this.nb(t),(0,m.asPromise)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const c=this.eb(t,s,o.parent);return this.lb(t,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}Z(p,t,o){const s=this.eb(p,t,o);if(t.id&&this.i.has(s.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.kb(p,s),this.mb(s,o),s}ab(p){return L.MarkdownString.isMarkdownString(p)?k.MarkdownString.from(p):p}bb(p,t){return t?{...this.F.toInternal(t,p),originalId:t.command}:void 0}cb(p){if(!p.checkboxState)return;let t,o;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:o}}db(p){if(!L.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,t,o){this.db(t);const s=new T.DisposableStore,c=this.gb(p,t,o),l=this.hb(t);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.ib(t)||l,themeIcon:this.fb(t),collapsibleState:(0,I.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof L.ThemeIcon?p.iconPath:void 0}gb(p,{id:t,label:o,resourceUri:s},c,l){if(t)return`${g.b}/${t}`;const v=d(o,this.H),i=c?c.item.handle:g.a;let n=v?v.label:s?(0,u.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(p)?this.j.get(p).item.handle:void 0,w=this.Q(c)||[];let b,O=0;do{if(b=`${i}/${O}:${n}`,l||!this.i.has(b)||h===b)break;O++}while(O<=w.length);return b}hb(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,t){this.i.set(t.item.handle,p),this.j.set(p,t)}lb(p,t,o,s){this.i.delete(t.item.handle),this.j.delete(p),t.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(p,t);const c=this.Q(s)||[],l=c.filter(v=>v.item.handle===o.item.handle)[0];l&&c.splice(c.indexOf(l),1,t)}mb(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const t=this.j.get(p);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}t.children=void 0}}else this.pb()}ob(p){const t=this.j.get(p);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}g.a="0",g.b="1"}),define(Ce[316],Ie([1,0,21,10,3,37,2,122,108,154,165,45,5,97,256,255,40,257,35,259,260,261,244,262,59,42,263,264,269,270,271,143,247,277,278,279,100,41,281,315,13,7,74,284,81,142,34,25,236,268,73,140,83,85,86,16,56,20,26,272,243,55,78,253,282,80,79,287,285,286,254,49,280,283,99,60,77,273,82,274,18,125,246,225,265,6,27,230,98,221,275,276,267,266]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t,o,s,c,l,v,i,n,h,w,b,O,H,x,_,G,M,B,U,j,he,ie,V,J,re,ve,ue,le,q,F,Q,me,Ee,te,ne,de,ee,ce,ae,N,z,K,Z,fe,Se,Ae,we,Pe,ke,ze,qe,tt,Qe,it,rt,Be,et,$,Y,ge,Le,Ne,je,Ye,Xe,nt,ot,pt,bt,St,Pt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ft){const vt=ft.get(ee.IExtHostInitDataService),Ot=ft.get(ze.IExtHostFileSystemInfo),Ut=ft.get(Se.IExtHostConsumerFileSystem),Nt=ft.get(c.IExtHostExtensionService),wt=ft.get(re.IExtHostWorkspace),kt=ft.get(rt.IExtHostTelemetry),At=ft.get(f.IExtHostConfiguration),Bt=ft.get(ne.IURITransformerService),Ke=ft.get(de.IExtHostRpcService),Wt=ft.get(_.IExtHostStorage),Re=ft.get(fe.IExtensionStoragePaths),Fe=ft.get(te.ILoggerService),ye=ft.get(te.ILogService),oe=ft.get(N.IExtHostTunnelService),Oe=ft.get(z.IExtHostApiDeprecationService),He=ft.get(J.IExtHostWindow),Ze=ft.get(Qe.IExtHostSecretState),Ge=ft.get(it.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Fe),Ke.set(S.ExtHostContext.ExtHostWorkspace,wt),Ke.set(S.ExtHostContext.ExtHostConfiguration,At),Ke.set(S.ExtHostContext.ExtHostExtensionService,Nt),Ke.set(S.ExtHostContext.ExtHostStorage,Wt),Ke.set(S.ExtHostContext.ExtHostTunnelService,oe),Ke.set(S.ExtHostContext.ExtHostWindow,He),Ke.set(S.ExtHostContext.ExtHostSecretState,Ze),Ke.set(S.ExtHostContext.ExtHostTelemetry,kt),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Ge);const ct=Ke.set(S.ExtHostContext.ExtHostDecorations,ft.get(F.IExtHostDecorations)),mt=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(s.IExtHostDocumentsAndEditors)),gt=Ke.set(S.ExtHostContext.ExtHostCommands,ft.get(r.IExtHostCommands)),dt=Ke.set(S.ExtHostContext.ExtHostTerminalService,ft.get(G.IExtHostTerminalService)),lt=Ke.set(S.ExtHostContext.ExtHostDebugService,ft.get(me.IExtHostDebugService)),yt=Ke.set(S.ExtHostContext.ExtHostSearch,ft.get(Ee.IExtHostSearch)),Tt=Ke.set(S.ExtHostContext.ExtHostTask,ft.get(Q.IExtHostTask)),Ht=Ke.set(S.ExtHostContext.ExtHostOutputService,ft.get(w.IExtHostOutputService)),Ft=Ke.set(S.ExtHostContext.ExtHostLocalization,ft.get(ot.IExtHostLocalizationService)),ai=Ke.set(S.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ke)),Rt=Ke.set(S.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ke,mt)),yi=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,mt,ye)),ci=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ye,Rt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),It=Ke.set(S.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,gt,mt,Rt)),li=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(It)),ui=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new Le.ExtHostNotebookEditors(ye,It)),Zt=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new Be.ExtHostNotebookKernels(Ke,vt,It,gt,ye)),Di=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new $.ExtHostNotebookRenderers(Ke,It)),Dt=Ke.set(S.ExtHostContext.ExtHostEditors,new M.ExtHostEditors(Ke,mt)),di=Ke.set(S.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),gt,ye)),zi=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),Dt,vt.remote)),ei=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Ke,ye,Ot,mt)),ii=Ke.set(S.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(Ke,Rt,gt.converter,Bt)),ht=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,Bt,Rt,gt,ei,ye,Oe,kt)),ti=Ke.set(S.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ke,ht)),Vt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Ke,ye,mt)),Qt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,wt,gt)),hi=Ke.set(S.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(Ke,gt,ye)),Ci=Ke.set(S.ExtHostContext.ExtHostQuickDiff,new St.ExtHostQuickDiff(Ke,Bt)),Ii=Ke.set(S.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,gt,Rt)),fi=Ke.set(S.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),ki=Ke.set(S.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ke)),mi=Ke.set(S.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ke)),gi=Ke.set(S.ExtHostContext.ExtHostAuthentication,new K.ExtHostAuthentication(Ke)),Ti=Ke.set(S.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline(Ke,gt)),ni=Ke.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,vt.remote,wt,ye,Oe)),ri=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new Pe.ExtHostWebviewPanels(Ke,ni,wt)),Pi=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ke,Rt,Re,ni,ri)),$i=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(S.ExtHostContext.ExtHostTesting,new qe.ExtHostTesting(Ke,gt,mt)),Ai=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ke)),Wi=Ke.set(S.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ke,It,mt,gt,ye));const Hi=Ke.set(S.ExtHostContext.ExtHostInteractiveEditor,new $t.ExtHostInteractiveEditor(Ke,Rt,ye)),Ni=Ke.set(S.ExtHostContext.ExtHostInteractiveSession,new Pt.ExtHostInteractiveSession(Ke,ye)),ji=Object.values(S.ExtHostContext);Ke.assertRegistered(ji);const Vi=new ke.ExtHostBulkEdits(Ke,mt),qi=new E.ExtHostClipboard(Ke),si=new h.ExtHostMessageService(Ke,ye),pi=new D.ExtHostDialogs(Ke),Fi=new x.ExtHostStatusBar(Ke,gt.converter);return C.ExtHostApiCommands.register(gt),function($e,xt,oi){const Et=function(){let be=!$e.isUnderDevelopment;function De(){be||(ye.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(st){if(Array.isArray(st))st.forEach(Ue);else if(typeof st=="string")De();else{const Ct=st;typeof Ct.scheme>"u"&&De(),typeof Ct.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return st}}(),xi={getSession(be,De,Ue){return gi.getSession($e,be,De,Ue)},async hasSession(be,De){return(0,Xe.checkProposedApiEnabled)($e,"authSession"),!!await gi.getSession($e,be,De,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(be,De,Ue,st){return gi.registerAuthenticationProvider(be,De,Ue,st)}},Gi={registerCommand(be,De,Ue){return gt.registerCommand(!0,be,De,Ue,void 0,$e)},registerTextEditorCommand(be,De,Ue){return gt.registerCommand(!0,be,(...st)=>{const Ct=Dt.getActiveTextEditor();if(!Ct){ye.warn("Cannot execute "+be+" because there is no active text editor.");return}return Ct.edit(Lt=>{De.apply(Ue,[Ct,Lt,...st])}).then(Lt=>{Lt||ye.warn("Edits from command "+be+" were not applied.")},Lt=>{ye.warn("An error occurred while running command "+be,Lt)})},void 0,void 0,$e)},registerDiffInformationCommand:(be,De,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"diffCommand"),gt.registerCommand(!0,be,async(...st)=>{const Ct=mt.activeEditor(!0);if(!Ct){ye.warn("Cannot execute "+be+" because there is no active text editor.");return}const Lt=await Dt.getDiffInformation(Ct.id);De.apply(Ue,[Lt,...st])},void 0,void 0,$e)),executeCommand(be,...De){return gt.executeCommand(be,...De)},getCommands(be=!1){return gt.getCommands(be)}},Mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return qi.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)($e,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be){return rt.ExtHostTelemetryLogger.validateSender(be),kt.instantiateLogger($e,be)},openExternal(be,De){return He.openUri(be,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===vt.environment.appUriScheme)return ai.createAppUri(be);try{return await He.asExternalUri(be,{allowTunneling:!!vt.remote.authority})}catch(De){if((0,ge.matchesScheme)(be,Y.Schemas.http)||(0,ge.matchesScheme)(be,Y.Schemas.https))return be;throw De}},get remoteName(){return(0,q.getRemoteName)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)($e,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return ye.getLevel()},get onDidChangeLogLevel(){return ye.onDidChangeLogLevel}};vt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(be,De,Ue){return Yt.createTestController($e,be,De,Ue)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.createTestObserver()},runTests(be){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.runTests(be)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.results}},bi=vt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Gt={getExtension(be,De){(0,Xe.isProposedApiEnabled)($e,"extensionsAny")||(De=!1);const Ue=xt.mine.getExtensionDescription(be);if(Ue)return new c.Extension(Nt,$e.identifier,Ue,bi,!1);if(De){const st=xt.all.getExtensionDescription(be);if(st)return new c.Extension(Nt,$e.identifier,st,bi,!0)}},get all(){const be=[];for(const De of xt.mine.getAllExtensionDescriptions())be.push(new c.Extension(Nt,$e.identifier,De,bi,!1));return be},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)($e,"extensionsAny");const be=new ve.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),De=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const st=!be.has(Ue.identifier);De.push(new c.Extension(Nt,$e.identifier,Ue,bi,st))}return De},get onDidChange(){return(0,Xe.isProposedApiEnabled)($e,"extensionsAny")?u.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},vi={createDiagnosticCollection(be){return ei.createDiagnosticCollection($e.identifier,be)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:be=>ei.getDiagnostics(be),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(be,De){return ii.changeLanguage(be.uri,De)},match(be,De){const Ue=Rt.getDocumentData(De.uri)?.notebook;return(0,L.score)(U.LanguageSelector.from(be),De.uri,De.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,De,Ue){return ht.registerCodeActionProvider($e,Et(be),De,Ue)},registerDocumentPasteEditProvider(be,De,Ue){return(0,Xe.checkProposedApiEnabled)($e,"documentPaste"),ht.registerDocumentPasteEditProvider($e,Et(be),De,Ue)},registerCodeLensProvider(be,De){return ht.registerCodeLensProvider($e,Et(be),De)},registerDefinitionProvider(be,De){return ht.registerDefinitionProvider($e,Et(be),De)},registerDeclarationProvider(be,De){return ht.registerDeclarationProvider($e,Et(be),De)},registerImplementationProvider(be,De){return ht.registerImplementationProvider($e,Et(be),De)},registerTypeDefinitionProvider(be,De){return ht.registerTypeDefinitionProvider($e,Et(be),De)},registerHoverProvider(be,De){return ht.registerHoverProvider($e,Et(be),De,$e.identifier)},registerEvaluatableExpressionProvider(be,De){return ht.registerEvaluatableExpressionProvider($e,Et(be),De,$e.identifier)},registerInlineValuesProvider(be,De){return ht.registerInlineValuesProvider($e,Et(be),De,$e.identifier)},registerDocumentHighlightProvider(be,De){return ht.registerDocumentHighlightProvider($e,Et(be),De)},registerLinkedEditingRangeProvider(be,De){return ht.registerLinkedEditingRangeProvider($e,Et(be),De)},registerReferenceProvider(be,De){return ht.registerReferenceProvider($e,Et(be),De)},registerRenameProvider(be,De){return ht.registerRenameProvider($e,Et(be),De)},registerDocumentSymbolProvider(be,De,Ue){return ht.registerDocumentSymbolProvider($e,Et(be),De,Ue)},registerWorkspaceSymbolProvider(be){return ht.registerWorkspaceSymbolProvider($e,be)},registerDocumentFormattingEditProvider(be,De){return ht.registerDocumentFormattingEditProvider($e,Et(be),De)},registerDocumentRangeFormattingEditProvider(be,De){return ht.registerDocumentRangeFormattingEditProvider($e,Et(be),De)},registerOnTypeFormattingEditProvider(be,De,Ue,...st){return ht.registerOnTypeFormattingEditProvider($e,Et(be),De,[Ue].concat(st))},registerDocumentSemanticTokensProvider(be,De,Ue){return ht.registerDocumentSemanticTokensProvider($e,Et(be),De,Ue)},registerDocumentRangeSemanticTokensProvider(be,De,Ue){return ht.registerDocumentRangeSemanticTokensProvider($e,Et(be),De,Ue)},registerSignatureHelpProvider(be,De,Ue,...st){return typeof Ue=="object"?ht.registerSignatureHelpProvider($e,Et(be),De,Ue):ht.registerSignatureHelpProvider($e,Et(be),De,typeof Ue>"u"?[]:[Ue,...st])},registerCompletionItemProvider(be,De,...Ue){return ht.registerCompletionItemProvider($e,Et(be),De,Ue)},registerInlineCompletionItemProvider(be,De){return De.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider($e,Et(be),De)},registerDocumentLinkProvider(be,De){return ht.registerDocumentLinkProvider($e,Et(be),De)},registerColorProvider(be,De){return ht.registerColorProvider($e,Et(be),De)},registerFoldingRangeProvider(be,De){return ht.registerFoldingRangeProvider($e,Et(be),De)},registerSelectionRangeProvider(be,De){return ht.registerSelectionRangeProvider($e,be,De)},registerCallHierarchyProvider(be,De){return ht.registerCallHierarchyProvider($e,be,De)},registerTypeHierarchyProvider(be,De){return ht.registerTypeHierarchyProvider($e,be,De)},setLanguageConfiguration:(be,De)=>ht.setLanguageConfiguration($e,be,De),getTokenInformationAtPosition(be,De){return(0,Xe.checkProposedApiEnabled)($e,"tokenInformation"),ii.tokenAtPosition(be,De)},registerInlayHintsProvider(be,De){return ht.registerInlayHintsProvider($e,be,De)},createLanguageStatusItem(be,De){return ii.createLanguageStatusItem($e,be,De)},registerDocumentDropEditProvider(be,De){return ht.registerDocumentOnDropEditProvider($e,be,De)}},Ki={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(be,De,Ue){const st=await(P.URI.isUri(be)?Promise.resolve(zt.openTextDocument(be)):Promise.resolve(be));return Dt.showTextDocument(st,De,Ue)},createTextEditorDecorationType(be){return Dt.createTextEditorDecorationType($e,be)},onDidChangeActiveTextEditor(be,De,Ue){return Dt.onDidChangeActiveTextEditor(be,De,Ue)},onDidChangeVisibleTextEditors(be,De,Ue){return Dt.onDidChangeVisibleTextEditors(be,De,Ue)},onDidChangeTextEditorSelection(be,De,Ue){return Dt.onDidChangeTextEditorSelection(be,De,Ue)},onDidChangeTextEditorOptions(be,De,Ue){return Dt.onDidChangeTextEditorOptions(be,De,Ue)},onDidChangeTextEditorVisibleRanges(be,De,Ue){return Dt.onDidChangeTextEditorVisibleRanges(be,De,Ue)},onDidChangeTextEditorViewColumn(be,De,Ue){return Dt.onDidChangeTextEditorViewColumn(be,De,Ue)},onDidCloseTerminal(be,De,Ue){return dt.onDidCloseTerminal(be,De,Ue)},onDidOpenTerminal(be,De,Ue){return dt.onDidOpenTerminal(be,De,Ue)},onDidChangeActiveTerminal(be,De,Ue){return dt.onDidChangeActiveTerminal(be,De,Ue)},onDidChangeTerminalDimensions(be,De,Ue){return(0,Xe.checkProposedApiEnabled)($e,"terminalDimensions"),dt.onDidChangeTerminalDimensions(be,De,Ue)},onDidChangeTerminalState(be,De,Ue){return dt.onDidChangeTerminalState(be,De,Ue)},onDidWriteTerminalData(be,De,Ue){return(0,Xe.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(be,De,Ue)},get state(){return He.state},onDidChangeWindowState(be,De,Ue){return He.onDidChangeWindowState(be,De,Ue)},showInformationMessage(be,...De){return si.showMessage($e,R.default.Info,be,De[0],De.slice(1))},showWarningMessage(be,...De){return si.showMessage($e,R.default.Warning,be,De[0],De.slice(1))},showErrorMessage(be,...De){return si.showMessage($e,R.default.Error,be,De[0],De.slice(1))},showQuickPick(be,De,Ue){return Qt.showQuickPick($e,be,De,Ue)},showWorkspaceFolderPick(be){return Qt.showWorkspaceFolderPick(be)},showInputBox(be,De){return Qt.showInput(be,De)},showOpenDialog(be){return pi.showOpenDialog($e,be)},showSaveDialog(be){return pi.showSaveDialog(be)},createStatusBarItem(be,De,Ue){let st,Ct,Lt;return typeof be=="string"?(st=be,Ct=De,Lt=Ue):(Ct=be,Lt=De),Fi.createStatusBarEntry($e,st,Ct,Lt)},setStatusBarMessage(be,De){return Fi.setStatusBarMessage(be,De)},withScmProgress(be){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),fi.withProgress($e,{location:j.ProgressLocation.SourceControl},(De,Ue)=>be({report(st){}}))},withProgress(be,De){return fi.withProgress($e,be,De)},createOutputChannel(be,De){return Ht.createOutputChannel(be,De,$e)},createWebviewPanel(be,De,Ue,st){return ri.createWebviewPanel($e,be,De,Ue,st)},createWebviewTextEditorInset(be,De,Ue,st){return(0,Xe.checkProposedApiEnabled)($e,"editorInsets"),zi.createWebviewEditorInset(be,De,Ue,st,$e)},createTerminal(be,De,Ue){return typeof be=="object"?"pty"in be?dt.createExtensionTerminal(be):dt.createTerminalFromOptions(be):dt.createTerminal(be,De,Ue)},registerTerminalLinkProvider(be){return dt.registerLinkProvider(be)},registerTerminalProfileProvider(be,De){return dt.registerProfileProvider($e,be,De)},registerTerminalQuickFixProvider(be,De){return(0,Xe.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(be,$e.identifier.value,De)},registerTreeDataProvider(be,De){return di.registerTreeDataProvider(be,De,$e)},createTreeView(be,De){return di.createTreeView(be,De,$e)},registerWebviewPanelSerializer:(be,De)=>ri.registerWebviewPanelSerializer($e,be,De),registerCustomEditorProvider:(be,De,Ue={})=>Pi.registerCustomEditorProvider($e,be,De,Ue),registerFileDecorationProvider(be){return ct.registerFileDecorationProvider(be,$e)},registerUriHandler(be){return ai.registerUriHandler($e.identifier,be)},createQuickPick(){return Qt.createQuickPick($e)},createInputBox(){return Qt.createInputBox($e)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(be,De,Ue){return mi.onDidChangeActiveColorTheme(be,De,Ue)},registerWebviewViewProvider(be,De,Ue){return $i.registerWebviewViewProvider($e,be,De,Ue?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,De,Ue){return It.onDidChangeActiveNotebookEditor(be,De,Ue)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,De,Ue){return ui.onDidChangeNotebookEditorSelection(be,De,Ue)},onDidChangeNotebookEditorVisibleRanges(be,De,Ue){return ui.onDidChangeNotebookEditorVisibleRanges(be,De,Ue)},showNotebookDocument(be,De){return It.showNotebookDocument(be,De)},registerExternalUriOpener(be,De,Ue){return(0,Xe.checkProposedApiEnabled)($e,"externalUriOpener"),Ai.registerExternalUriOpener($e.identifier,be,De,Ue)},registerProfileContentHandler(be,De){return(0,Xe.checkProposedApiEnabled)($e,"profileContentHandlers"),Wi.registrProfileContentHandler($e,be,De)},registerQuickDiffProvider(be,De,Ue,st){return(0,Xe.checkProposedApiEnabled)($e,"quickDiffProvider"),Ci.registerQuickDiffProvider(Et(be),De,Ue,st)},get tabGroups(){return Ge.tabGroups}},zt={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(be){throw A.readonly()},getWorkspaceFolder(be){return wt.getWorkspaceFolder(be)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(be){throw A.readonly()},get workspaceFile(){return wt.workspaceFile},set workspaceFile(be){throw A.readonly()},updateWorkspaceFolders:(be,De,...Ue)=>wt.updateWorkspaceFolders($e,be,De||0,...Ue),onDidChangeWorkspaceFolders:function(be,De,Ue){return wt.onDidChangeWorkspace(be,De,Ue)},asRelativePath:(be,De)=>wt.getRelativePath(be,De),findFiles:(be,De,Ue,st)=>wt.findFiles(be,De,Ue,$e.identifier,st),findTextInFiles:(be,De,Ue,st)=>{(0,Xe.checkProposedApiEnabled)($e,"findTextInFiles");let Ct,Lt;return typeof De=="object"?(Ct=De,Lt=Ue):(Ct={},Lt=De,st=Ue),wt.findTextInFiles(be,Ct||{},Lt,$e.identifier,st)},saveAll:be=>wt.saveAll(be),applyEdit(be,De){return Vi.applyWorkspaceEdit(be,$e,De)},createFileSystemWatcher:(be,De,Ue,st)=>Vt.createFileSystemWatcher(wt,$e,be,De,Ue,st),get textDocuments(){return Rt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw A.readonly()},openTextDocument(be){let De;const Ue=be;if(typeof be=="string")De=Promise.resolve(P.URI.file(be));else if(P.URI.isUri(be))De=Promise.resolve(be);else if(!Ue||typeof Ue=="object")De=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(st=>Rt.ensureDocumentData(st).then(Ct=>Ct.document))},onDidOpenTextDocument:(be,De,Ue)=>Rt.onDidAddDocument(be,De,Ue),onDidCloseTextDocument:(be,De,Ue)=>Rt.onDidRemoveDocument(be,De,Ue),onDidChangeTextDocument:(be,De,Ue)=>Rt.onDidChangeDocument(be,De,Ue),onDidSaveTextDocument:(be,De,Ue)=>Rt.onDidSaveDocument(be,De,Ue),onWillSaveTextDocument:(be,De,Ue)=>ci.getOnWillSaveTextDocumentEvent($e)(be,De,Ue),get notebookDocuments(){return It.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,De){let Ue;if(P.URI.isUri(be))Ue=be,await It.openNotebookDocument(be);else if(typeof be=="string")Ue=P.URI.revive(await It.createNotebookDocument({viewType:be,content:De}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,De,Ue){return li.onDidSaveNotebookDocument(be,De,Ue)},onDidChangeNotebookDocument(be,De,Ue){return li.onDidChangeNotebookDocument(be,De,Ue)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(be,De,Ue,st){return It.registerNotebookSerializer($e,be,De,Ue,(0,Xe.isProposedApiEnabled)($e,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(be,De,Ue)=>oi.onDidChangeConfiguration(be,De,Ue),getConfiguration(be,De){return De=arguments.length===1?void 0:De,oi.getConfiguration(be,De,$e)},registerTextDocumentContentProvider(be,De){return yi.registerTextDocumentContentProvider(be,De)},registerTaskProvider:(be,De)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider($e,be,De)),registerFileSystemProvider(be,De,Ue){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider($e,be,De,Ue),Ut.addFileSystemProvider(be,De))},get fs(){return Ut.value},registerFileSearchProvider:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"fileSearchProvider"),yt.registerFileSearchProvider(be,De)),registerTextSearchProvider:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"textSearchProvider"),yt.registerTextSearchProvider(be,De)),registerRemoteAuthorityResolver:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),Nt.registerRemoteAuthorityResolver(be,De)),registerResourceLabelFormatter:be=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),ki.$registerResourceLabelFormatter(be)),onDidCreateFiles:(be,De,Ue)=>Vt.onDidCreateFile(be,De,Ue),onDidDeleteFiles:(be,De,Ue)=>Vt.onDidDeleteFile(be,De,Ue),onDidRenameFiles:(be,De,Ue)=>Vt.onDidRenameFile(be,De,Ue),onWillCreateFiles:(be,De,Ue)=>Vt.getOnWillCreateFileEvent($e)(be,De,Ue),onWillDeleteFiles:(be,De,Ue)=>Vt.getOnWillDeleteFileEvent($e)(be,De,Ue),onWillRenameFiles:(be,De,Ue)=>Vt.getOnWillRenameFileEvent($e)(be,De,Ue),openTunnel:be=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),oe.openTunnel($e,be).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,Xe.checkProposedApiEnabled)($e,"tunnels"),oe.getTunnels()},onDidChangeTunnels:(be,De,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),oe.onDidChangeTunnels(be,De,Ue)),registerPortAttributesProvider:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"portsAttributes"),oe.registerPortsAttributesProvider(be,De)),registerTimelineProvider:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"timeline"),Ti.registerTimelineProvider(be,De,$e.identifier,gt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:be=>((0,Xe.checkProposedApiEnabled)($e,"workspaceTrust"),wt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,De,Ue)=>wt.onDidGrantWorkspaceTrust(be,De,Ue),registerEditSessionIdentityProvider:(be,De)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(be,De)),onWillCreateEditSessionIdentity:(be,De,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),wt.getOnWillCreateEditSessionIdentityEvent($e)(be,De,Ue))},wi={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox($e)},createSourceControl(be,De,Ue){return hi.createSourceControl($e,be,De,Ue)}},Xi={createCommentController(be,De){return Ii.createCommentController($e,be,De)}},Qi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(be,De,Ue){return lt.onDidStartDebugSession(be,De,Ue)},onDidTerminateDebugSession(be,De,Ue){return lt.onDidTerminateDebugSession(be,De,Ue)},onDidChangeActiveDebugSession(be,De,Ue){return lt.onDidChangeActiveDebugSession(be,De,Ue)},onDidReceiveDebugSessionCustomEvent(be,De,Ue){return lt.onDidReceiveDebugSessionCustomEvent(be,De,Ue)},onDidChangeBreakpoints(be,De,Ue){return lt.onDidChangeBreakpoints(be,De,Ue)},registerDebugConfigurationProvider(be,De,Ue){return lt.registerDebugConfigurationProvider(be,De,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,De){return lt.registerDebugAdapterDescriptorFactory($e,be,De)},registerDebugAdapterTrackerFactory(be,De){return lt.registerDebugAdapterTrackerFactory(be,De)},startDebugging(be,De,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?lt.startDebugging(be,De,{parentSession:Ue}):lt.startDebugging(be,De,Ue||{})},stopDebugging(be){return lt.stopDebugging(be)},addBreakpoints(be){return lt.addBreakpoints(be)},removeBreakpoints(be){return lt.removeBreakpoints(be)},asDebugSourceUri(be,De){return lt.asDebugSourceUri(be,De)}},Yi={registerTaskProvider:(be,De)=>Tt.registerTaskProvider($e,be,De),fetchTasks:be=>Tt.fetchTasks(be),executeTask:be=>Tt.executeTask($e,be),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(be,De,Ue)=>Tt.onDidStartTask(be,De,Ue),onDidEndTask:(be,De,Ue)=>Tt.onDidEndTask(be,De,Ue),onDidStartTaskProcess:(be,De,Ue)=>Tt.onDidStartTaskProcess(be,De,Ue),onDidEndTaskProcess:(be,De,Ue)=>Tt.onDidEndTaskProcess(be,De,Ue)},_i={createNotebookController(be,De,Ue,st,Ct){return Zt.createNotebookController($e,be,De,Ue,st,(0,Xe.isProposedApiEnabled)($e,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(be,De)=>It.registerNotebookCellStatusBarItemProvider($e,be,De),createRendererMessaging(be){return Di.createRendererMessaging($e,be)},createNotebookControllerDetectionTask(be){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask($e,be)},registerKernelSourceActionProvider(be,De){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Zt.registerKernelSourceActionProvider($e,be,De)},onDidChangeNotebookCellExecutionState(be,De,Ue){return(0,Xe.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(be,De,Ue)}},Ji={t(...be){if(typeof be[0]=="string"){const De=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return Ft.getMessage($e.identifier.value,{message:De,args:Ue})}return Ft.getMessage($e.identifier.value,be[0])},get bundle(){return Ft.getBundle($e.identifier.value)},get uri(){return Ft.getBundleUri($e.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(be){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Hi.registerProvider($e,be)},registerInteractiveSessionProvider(be,De){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Ni.registerInteractiveSessionProvider($e,be,De)},addInteractiveRequest(be){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Ni.addInteractiveSessionRequest(be)}};return{version:vt.version,authentication:xi,commands:Gi,comments:Xi,debug:Qi,env:Mi,extensions:Gt,interactive:Zi,l10n:Ji,languages:vi,notebooks:_i,scm:wi,tasks:Yi,tests:Ri,window:Ki,workspace:zt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:m.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:k.UIKind,Uri:P.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:te.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(Ce[317],Ie([1,0,289,326,327,2,328]),function(se,e,a,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(I,S,k,C,E,r){const d=r.environment.useHostProxy,f=typeof d=="boolean"?d:!r.remote.isRemote,g=(0,P.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(p,t,...o)=>{switch(p){case P.LogLevel.Trace:C.trace(t,...o);break;case P.LogLevel.Debug:C.debug(t,...o);break;case P.LogLevel.Info:C.info(t,...o);break;case P.LogLevel.Warning:C.warn(t,...o);break;case P.LogLevel.Error:C.error(t,...o);break;case P.LogLevel.Critical:C.error(t,...o);break;case P.LogLevel.Off:break;default:s(p,t,o);break}function s(c,l,...v){C.error("Unknown log level",c),C.error(l,...v)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:f,env:process.env}),D=y(S,g);return L(k,D)}e.connectProxyResolver=T;function y(I,S){const k={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(E=>{k.config=I.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(E=>{C.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"off"},C,!0)),on:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"on"},C,!0)),override:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"override"},C,!0)),onRequest:Object.assign({},a,(0,P.createHttpPatch)(a,S,k,C,!0)),default:Object.assign(a,(0,P.createHttpPatch)(a,S,k,C,!1))},https:{off:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"off"},C,!0)),on:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"on"},C,!0)),override:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"override"},C,!0)),onRequest:Object.assign({},A,(0,P.createHttpPatch)(A,S,k,C,!0)),default:Object.assign(A,(0,P.createHttpPatch)(A,S,k,C,!1))},tls:Object.assign(u,(0,P.createTlsPatch)(u))}}const m=new Map;function L(I,S){return I.getExtensionPathIndex().then(k=>{const C=globalThis._VSCODE_NODE_MODULES.module,E=C._load;C._load=function(d,f,g){if(d==="tls")return S.tls;if(d!=="http"&&d!=="https")return E.apply(this,arguments);const D=S[d],p=k.findSubstr(R.URI.file(f.filename));let t=m.get(p);if(t||m.set(p,t={}),!t[d]){const o=D.default;t[d]={...o}}return t[d]}})}}),define(Ce[318],Ie([1,0,84,316,303,317,42,291,2,18,7,288,116,290]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends u.RequireInterceptor{j(){const d=this,f=globalThis._VSCODE_NODE_MODULES.module,g=f._load;f._load=function(o,s,c){return o=p(o),d.a.has(o)?d.a.get(o).load(o,y.URI.file((0,S.realpathSync)(s.filename)),l=>g.apply(this,[l,s,c])):g.apply(this,arguments)};const D=f._resolveLookupPaths;f._resolveLookupPaths=(t,o)=>D.call(this,p(t),o);const p=t=>{for(const o of d.b){const s=o(t);if(s){t=s;break}}return t}}}class E extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async ob(){this.h.createInstance(k.ExtHostConsoleForwarder);const d=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const D=this.h.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}await this.h.createInstance(C,d,{mine:this.F,all:this.G}).install(),a.mark("code/extHost/didInitAPI");const g=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,g,this,this.l,this.t,this.f),a.mark("code/extHost/didInitProxyResolver")}pb(d){return d.main}async qb(d,f,g){if(f.scheme!==m.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let D=null;g.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const p=d?.identifier.value;d&&await this.q.initializeLocalizedMessages(d);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),D=se.__$__nodeRequire(f.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),g.codeLoadingStop()}return D}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const f in d){const g=d[f];g===null?delete process.env[f]:process.env[f]=g}}}e.ExtHostExtensionService=E}),define(Ce[146],Ie([1,0,47,329,312,17,61,38,12,8,2,31,82,330,310,101]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const r=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(b){this.a=b}provideTextSearchResults(b,O,H,x){return this.a.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((_,G)=>{x.onCancellationRequested(()=>J());const M=o(b,O),B=O.folder.fsPath,U=M.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${r} ${U}
 - cwd: ${B}`);let j=a.spawn(r,M,{cwd:B});j.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),G((0,I.serializeSearchError)(new I.SearchError(q&&q.message,I.SearchErrorCode.rgProcessError)))});let he=!1;const ie=new D(O.maxResults,B,O.previewOptions);ie.on("result",q=>{he=!0,ve="",H.report(q)});let V=!1;const J=()=>{V=!0,j?.kill(),ie?.cancel()};let re=!1;ie.on("hitLimit",()=>{re=!0,J()});let ve="";j.stdout.on("data",q=>{ie.handleData(q),he||(ve+=q)});let ue=!1;j.stdout.once("data",()=>ue=!0);let le="";j.stderr.on("data",q=>{const F=q.toString();this.a.appendLine(F),le.length+F.length<1e6&&(le+=F)}),j.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(he?"Got result from parser":"No result from parser"),ve&&this.a.appendLine(`Got data without result: ${ve}`),this.a.appendLine(""),V)_({limitHit:re});else{ie.flush(),j=null;let q;le&&!ue&&(q=f(le))?G((0,I.serializeSearchError)(new I.SearchError(q.message,q.code))):_({limitHit:re})}})})}}e.RipgrepTextSearchEngine=d;function f(w){const b=w.split(`
`),O=b[0].trim();if(b.some(x=>x.startsWith("regex parse error")))return new I.SearchError(g(b),I.SearchErrorCode.regexParseError);const H=O.match(/grep config error: unknown encoding: (.*)/);if(H)return new I.SearchError(`Unknown encoding: ${H[1]}`,I.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new I.SearchError(O.charAt(0).toUpperCase()+O.substr(1),I.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new I.SearchError(O.charAt(0).toUpperCase()+O.substr(1),I.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(O,I.SearchErrorCode.regexParseError)}function g(w){const b=["Regex parse error"],O=w.filter(H=>H.startsWith("PCRE2:"));if(O.length>=1){const H=O[0].replace("PCRE2:","");if(H.indexOf(":")!==-1&&H.split(":").length>=2){const x=H.split(":")[1];b.push(":"+x)}}return b.join("")}class D extends A.EventEmitter{constructor(b,O,H){super(),this.g=b,this.h=O,this.j=H,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(b,O){return super.on(b,O),this}handleData(b){if(this.b)return;const O=typeof b=="string"?b:this.d.write(b);this.k(O)}k(b){let O=b.indexOf(`
`);const H=this.a+b;if(O>=0)O+=this.a.length;else{this.a=H;return}let x=0;for(;O>=0;)this.m(H.substring(x,O).trim()),x=O+1,O=H.indexOf(`
`,x);this.a=H.substring(x)}m(b){if(this.b||!b)return;let O;try{O=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(O.type==="match"){const H=p(O.data.path),x=L.URI.file(y.join(this.h,H)),_=this.n(O.data,x);this.p(_),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const H=p(O.data.path),x=L.URI.file(y.join(this.h,H));this.o(O.data,x).forEach(G=>this.p(G))}}n(b,O){const H=b.line_number-1,x=p(b.lines),_=Buffer.from(x);let G=0,M=0,B=H;b.submatches.length===0&&b.submatches.push(x.length?{start:0,end:1,match:{text:x[0]}}:{start:0,end:0,match:{text:""}});const U=(0,R.coalesce)(b.submatches.map((j,he)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=p(j.match),V=_.slice(G,j.start).toString(),J=t(V),re=J.numLines>0?J.lastLineLength:J.lastLineLength+M,ve=t(ie),ue=J.numLines+B,le=ve.numLines+ue,q=ve.numLines>0?ve.lastLineLength:ve.lastLineLength+re;return G=j.end,M=q,B=le,new S.Range(ue,re,le,q)}));return(0,E.createTextSearchResult)(O,x,U,this.j)}o(b,O){const H=p(b.lines),x=b.line_number;return H.replace(/\r?\n$/,"").split(`
`).map((_,G)=>({text:_,uri:O,lineNumber:x+G}))}p(b){this.emit("result",b)}}e.RipgrepParser=D;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const b=/\n/g;let O=0,H=-1,x;for(;x=b.exec(w);)O++,H=x.index;const _=H>=0?w.length-H-1:w.length;return{numLines:O,lastLineLength:_}}function o(w,b){const O=["--hidden"];O.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:H,otherIncludes:x}=(0,P.groupBy)(b.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(x&&x.length){const G=new Set;x.forEach(M=>{G.add(M)}),O.push("-g","!*"),G.forEach(M=>{s(M).map(E.anchorGlob).forEach(B=>{O.push("-g",B)})})}H&&H.length&&H.forEach(G=>{O.push("-g",G)}),b.excludes.map(E.anchorGlob).forEach(G=>O.push("-g",`!${G}`)),b.maxFileSize&&O.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?b.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),b.followSymlinks&&O.push("--follow"),b.encoding&&b.encoding!=="utf8"&&O.push("--encoding",b.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,m.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),b.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),w.isRegExp&&(w.pattern=c(w.pattern),O.push("--engine","auto"));let _;if(w.isWordMatch){const M=(0,m.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",M)}else if(w.isRegExp){let G=v(w.pattern);G=i(G),O.push("--regexp",G)}else _=w.pattern,O.push("--fixed-strings");return O.push("--no-config"),b.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),w.isMultiline&&O.push("--multiline"),b.beforeContext&&O.push("--before-context",b.beforeContext+""),b.afterContext&&O.push("--after-context",b.afterContext+""),O.push("--"),_&&O.push(_),O.push("."),O}e.getRgArgs=o;function s(w){return h(w).flatMap(O=>{const H=(0,T.splitGlobAware)(O,"/");return H.map((x,_)=>H.slice(0,_+1).join("/"))})}function c(w){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(b);)w=w.replace(b,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(O);)w=w.replace(O,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=c;const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function v(w){let b;try{b=new k.RegExpParser().parsePattern(w)}catch{return w}let O="",H=0;const x=(M,B,U)=>{O+=w.slice(H,M)+U,H=B},_=[];return new k.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=_[0];if(!B)x(M.start,M.end,"\\r?\\n");else if(!_.some(l))if(B.type==="CharacterClass")if(B.negate){const U=w.slice(B.start+2,M.start)+w.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?x(B.start,B.end,U?`[^${U}]`:"."):x(B.start,B.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=w.slice(B.start+1,M.start)+w.slice(M.end,B.end-1);x(B.start,B.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else B.type==="Quantifier"&&x(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){_.unshift(M)},onQuantifierLeave(){_.shift()},onCharacterClassRangeEnter(M){_.unshift(M)},onCharacterClassRangeLeave(){_.shift()},onCharacterClassEnter(M){_.unshift(M)},onCharacterClassLeave(){_.shift()},onAssertionEnter(M){l(M)&&_.push(M)},onAssertionLeave(M){_[0]===M&&_.shift()}}).visit(b),O+=w.slice(H),O}e.fixRegexNewline=v;function i(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function n(w){let b=!1,O=!1,H="",x="";for(let _=0;_<w.length;_++){const G=w[_];switch(G){case"\\":O?(b?x+="\\"+G:H+="\\"+G,O=!1):O=!0;break;case"{":if(O)b?x+=G:H+=G,O=!1;else{if(b)return{strInBraces:H+"{"+x+"{"+w.substring(_+1)};b=!0}break;case"}":if(O)b?x+=G:H+=G,O=!1;else{if(b)return{fixedStart:H,strInBraces:x,fixedEnd:w.substring(_+1)};H+=G}break;default:b?x+=(O?"\\":"")+G:H+=(O?"\\":"")+G,O=!1;break}}return{strInBraces:H+(b?"{"+x:"")}}function h(w){const{fixedStart:b,strInBraces:O,fixedEnd:H}=n(w);if(b===void 0||H===void 0)return[O];let x=(0,T.splitGlobAware)(O,",");x.length||(x=[""]);const _=h(H);return x.flatMap(G=>{const M=b+G;return _.map(B=>M+B)})}e.performBraceExpansionForRipgrep=h}),define(Ce[319],Ie([1,0,21,146,126,18]),function(se,e,a,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(m){this.b=m,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(m,L,I,S){const k=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:R.Schemas.file})},E=new u.Progress(r=>I.report({...r,uri:r.uri.with({scheme:L.folder.scheme})}));return this.c(S,r=>k.provideTextSearchResults(m,C,E,r))}else return this.c(S,C=>k.provideTextSearchResults(m,L,I,C))}async c(m,L){const I=T(m);this.a.add(I);const S=await L(I.token);return this.a.delete(I),S}d(){this.a.forEach(m=>m.cancel())}}e.RipgrepSearchProvider=P;function T(y){const m=new a.CancellationTokenSource;return y.onCancellationRequested(()=>m.cancel()),m}}),define(Ce[320],Ie([1,0,29,146,145]),function(se,e,a,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,m,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){L({message:k})}},S=new u.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(I),a);return new Promise((k,C)=>S.search(E=>{m(E.map(P))},y).then(E=>k({limitHit:E.limitHit,type:"success",stats:E.stats}),C))}}e.TextSearchEngineAdapter=R;function P(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((y,m)=>{if(m.ranges){const L=m;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(Ce[321],Ie([1,0,17,19,10,3,112,12,43,2,45,31,311,320]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(D="searchProcess"){this.d=D,this.b=Object.create(null)}fileSearch(D){let p;const t=d(D),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,t,c=>o.fire(c),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(D){let p;const t=d(D),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(s=>this.f(t,c=>o.fire(c),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}f(D,p,t){return D.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new k.TextSearchEngineAdapter(D).search(t,p,p)}doFileSearch(D,p,t){return this.doFileSearchWithEngine(S.Engine,D,p,t)}doFileSearchWithEngine(D,p,t,o,s=C.a){let c=0;const l=i=>{Array.isArray(i)?(c+=i.length,t(i.map(n=>this.g(n)))):i.relativePath?(c++,t(this.g(i))):t(i)};if(p.sortByScore){let i=this.k(p,l,o);if(!i){const n=p.maxResults?Object.assign({},p,{maxResults:null}):p,h=new D(n);i=this.h(h,p,t,l,o)}return new Promise((n,h)=>{i.then(([w,b])=>{const O=b.map(H=>this.g(H));this.n(O,t,s),n(w)},h)})}const v=new D(p);return this.q(v,l,s,o).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}g(D){return{path:D.base?(0,T.join)(D.base,D.relativePath):D.relativePath}}h(D,p,t,o,s){const c=new R.Emitter;let l=(0,A.createCancelablePromise)(i=>{let n=[];const h=w=>{Array.isArray(w)?n=w:(o(w),c.fire(w))};return this.q(D,h,-1,i).then(w=>[w,n])}),v;if(p.cacheKey){v=this.j(p.cacheKey);const i={promise:l,event:c.event,resolved:!1};v.resultsToSearchCache[p.filePattern||""]=i,l.then(()=>{i.resolved=!0},n=>{delete v.resultsToSearchCache[p.filePattern||""]}),l=this.r(l)}return l.then(([i,n])=>{const h=v?v.scorerCache:Object.create(null),w=(typeof p.maxResults!="number"||p.maxResults>0)&&y.StopWatch.create(!1);return this.l(p,n,h,s).then(b=>{const O=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:O,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:b.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&n.length>p.maxResults},b]})})}j(D){const p=this.b[D];return p||(this.b[D]=new E)}k(D,p,t){const o=D.cacheKey&&this.b[D.cacheKey];if(!o)return;const s=this.o(o,D.filePattern||"",p,t);if(s)return s.then(([c,l,v])=>{const i=y.StopWatch.create(!1);return this.l(D,l,o.scorerCache,t).then(n=>{const h=i.elapsed(),w={fromCache:!0,detailStats:v,type:this.d,resultCount:l.length,sortingTime:h};return[{type:"success",limitHit:c.limitHit||typeof D.maxResults=="number"&&l.length>D.maxResults,stats:w},n]})})}l(D,p,t,o){const s=(0,P.prepareQuery)(D.filePattern||""),c=(v,i)=>(0,P.compareItemsByFuzzyScore)(v,i,s,!0,r,t),l=typeof D.maxResults=="number"?D.maxResults:Number.MAX_VALUE;return a.topAsync(p,c,l,1e4,o)}n(D,p,t){if(t&&t>0)for(let o=0;o<D.length;o+=t)p(D.slice(o,o+t));else p(D)}o(D,p,t,o){const s=y.StopWatch.create(!1),c=p.indexOf(T.sep)>=0;let l;for(const h in D.resultsToSearchCache)if(p.startsWith(h)){if(c&&h.indexOf(T.sep)<0&&h!=="")continue;const w=D.resultsToSearchCache[h];l={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!l)return null;const v=s.elapsed(),i=y.StopWatch.create(!1),n=l.event(t);return o&&o.onCancellationRequested(()=>{n.dispose()}),l.promise.then(([h,w])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const b=[],O=(0,P.prepareQuery)(p).normalizedLowercase;for(const H of w)!(0,I.isFilePatternMatch)(H,O)||b.push(H);return[h,b,{cacheWasResolved:l.resolved,cacheLookupTime:v,cacheFilterTime:i.elapsed(),cacheEntryCount:w.length}]})}q(D,p,t,o){return new Promise((s,c)=>{let l=[];o?.onCancellationRequested(()=>D.cancel()),D.search(v=>{v&&(t?(l.push(v),t>0&&l.length>=t&&(p(l),l=[])):p(v))},v=>{p(v)},(v,i)=>{l.length&&p(l),v?c(v):s(i)})})}clearCache(D){return delete this.b[D],Promise.resolve(void 0)}r(D){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return D.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return D.finally(p)}}}}C.a=512,e.SearchService=C;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(g){return(0,T.basename)(g.relativePath)}getItemDescription(g){return(0,T.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function d(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(f),extraFileResources:g.extraFileResources&&g.extraFileResources.map(D=>m.URI.revive(D))}}function f(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Ce[322],Ie([1,0,6,18,2,29,16,26,20,86,56,31,321,319,101,145]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let r=class extends m.ExtHostSearch{constructor(f,g,D,p){super(f,D,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const t=new C.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new k.RipgrepSearchProvider(t)),g.remote.isRemote&&g.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const f=new C.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new k.RipgrepSearchProvider(f)),this.y(A.Schemas.file,new S.SearchService("fileSearchProvider"))}y(f,g){const D=this.d++;return this.v=g,this.t=D,this.c.$registerFileSearchProvider(D,this.o(f)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(D)})}$provideFileSearchResults(f,g,D,p){const t=(0,m.reviveQuery)(D);return f===this.t?this.z(f,g,t,p):super.$provideFileSearchResults(f,g,D,p)}z(f,g,D,p){const t=o=>{if((0,I.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(f,g,o.map(s=>u.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(D,t,p)}$clearCache(f){return this.v?.clearCache(f),super.$clearCache(f)}q(f,g){return new E.NativeTextSearchManager(f,g,void 0,"textSearchProvider")}};r=Ve([We(0,y.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,P.ILogService)],r),e.NativeExtHostSearch=r}),define(Ce[323],Ie([1,0,91,294,306,305,322,318,295,85,42,86,83,41,55,80,293,292,16,307,50,223,90]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d,f,g,D,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(L.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(f.ILoggerService,d.ExtHostLoggerService,1),(0,a.registerSingleton)(f.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,a.registerSingleton)(E.IExtensionStoragePaths,r.ExtensionStoragePaths,0),(0,a.registerSingleton)(m.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(I.IExtHostSearch,P.NativeExtHostSearch,0),(0,a.registerSingleton)(S.IExtHostTask,u.ExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(D.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService,0)}),define(Ce[331],Ie([1,0,233,332,84,10,119,120,211,97,304,22,29,116,19,122,228,241,308,323]),function(se,e,a,A,u,R,P,T,y,m,L,I,S,k,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const f=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,v=l._load;l._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const g=process.exit.bind(process);function D(l){process.exit=function(v){if(l)g(v);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(l){g()};function t(){const l=(0,d.readExtHostConnection)(process.env);if(l.type===3)return new Promise((v,i)=>{const n=h=>{const w=h[0],b=new P.BufferedEmitter;w.on("message",O=>b.fire(I.VSBuffer.wrap(O.data))),w.on("close",()=>{p("renderer closed the MessagePort")}),w.start(),v({onMessage:b.event,send:O=>w.postMessage(O.buffer)})};process.parentPort.on("message",h=>n(h.ports))});if(l.type===2)return new Promise((v,i)=>{let n=null;const h=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,b=3e5,O=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),w),H=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),b);process.on("message",(_,G)=>{if(_&&_.type==="VSCODE_EXTHOST_IPC_SOCKET"){G.setNoDelay(!0);const M=I.VSBuffer.wrap(Buffer.from(_.initialDataChunk,"base64"));let B;if(_.skipWebSocketFrames)B=new T.NodeSocket(G,"extHost-socket");else{const U=I.VSBuffer.wrap(Buffer.from(_.inflateBytes,"base64"));B=new T.WebSocketNodeSocket(new T.NodeSocket(G,"extHost-socket"),_.permessageDeflate,U,!1)}n?(O.cancel(),H.cancel(),n.beginAcceptReconnection(B,M),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(h),n=new P.PersistentProtocol({socket:B,initialChunk:M}),n.sendResume(),n.onDidDispose(()=>p("renderer disconnected")),v(n),n.onSocketClose(()=>{O.schedule()}))}if(_&&_.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(H.isScheduled())return;O.isScheduled()&&H.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const v=l.pipeName;return new Promise((i,n)=>{const h=a.createConnection(v,()=>{h.removeListener("error",n);const w=new P.PersistentProtocol({socket:new T.NodeSocket(h,"extHost-renderer")});w.sendResume(),i(w)});h.once("error",n),h.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const l=await t();return new class{constructor(){this.a=new P.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(v=>{(0,m.isMessageOfType)(v,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||l.send(v)}async drain(){if(l.drain)return l.drain()}}}function s(l){return new Promise(v=>{const i=l.onMessage(n=>{i.dispose();const h=JSON.parse(n.toString()),w=h.commit,b=y.default.commit;if(w&&b&&w!==b&&g(55),h.parentPid){let O=0;setInterval(function(){try{process.kill(h.parentPid,0),O=0}catch(x){x&&x.code==="EPERM"?(O++,O>=3&&p(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):p(`parent process ${h.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let H;try{H=globalThis._VSCODE_NODE_MODULES["native-watchdog"],H.start(h.parentPid)}catch(x){(0,R.onUnexpectedError)(x)}}l.send((0,m.createMessageOfType)(0)),v({protocol:l,initData:h})});l.send((0,m.createMessageOfType)(1))})}async function c(){const l=[];process.on("unhandledRejection",(O,H)=>{l.push(H),setTimeout(()=>{const x=l.indexOf(H);x>=0&&H.catch(_=>{l.splice(x,1),(0,R.isCancellationError)(_)||(console.warn(`rejected promise not handled within 1 second: ${_}`),_&&_.stack&&console.warn(`stack trace: ${_.stack}`),O&&(0,R.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const H=l.indexOf(O);H>=0&&l.splice(H,1)}),process.on("uncaughtException",function(O){(0,R.isSigPipeError)(O)||(0,R.onUnexpectedError)(O)}),u.mark("code/extHost/willConnectToRenderer");const v=await o();u.mark("code/extHost/didConnectToRenderer");const i=await s(v);u.mark("code/extHost/didWaitForInitData");const{initData:n}=i;D(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,E.boolean)(f.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(H){g(H)}exists(H){return S.Promises.exists(H)}realpath(H){return(0,k.realpath)(H)}};let w=null;n.remote.authority&&f.transformURIs&&(w=(0,r.createURITransformer)(n.remote.authority));const b=new L.ExtensionHostMain(i.protocol,n,h,w);p=O=>b.terminate(O)}c().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/155cd6db223feb1f8c734ca70e108b9efec7b054/core/vs/workbench/api/node/extensionHostProcess.js.map
