/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ee){for(var e=[],n=0,T=ee.length;n<T;n++)e[n]=Ae[ee[n]];return e};define(Ae[63],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(R,A){const w=Object.create(null);for(const h of R){const O=A(h);let S=w[O];S||(S=w[O]=[]),S.push(h)}return w}e.groupBy=n;function T(R,A){const w=[],h=[];for(const O of R)A.has(O)||w.push(O);for(const O of A)R.has(O)||h.push(O);return{removed:w,added:h}}e.diffSets=T;function k(R,A){const w=[],h=[];for(const[O,S]of R)A.has(O)||w.push(S);for(const[O,S]of A)R.has(O)||h.push(S);return{removed:w,added:h}}e.diffMaps=k;class M{constructor(){this.a=new Map}add(A,w){let h=this.a.get(A);h||(h=new Set,this.a.set(A,h)),h.add(w)}delete(A,w){const h=this.a.get(A);!h||(h.delete(w),h.size===0&&this.a.delete(A))}forEach(A,w){const h=this.a.get(A);!h||h.forEach(w)}}e.SetMap=M}),define(Ae[64],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(R){return(A,w,h)=>{let O=null,S=null;if(typeof h.value=="function"?(O="value",S=h.value):typeof h.get=="function"&&(O="get",S=h.get),!S)throw new Error("not supported");h[O]=R(S,w)}}function T(R,A,w){let h=null,O=null;if(typeof w.value=="function"?(h="value",O=w.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(h="get",O=w.get),!O)throw new Error("not supported");const S=`$memoize$${A}`;w[h]=function(...f){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,f)}),this[S]}}e.memoize=T;function k(R,A,w){return n((h,O)=>{const S=`$debounce$${O}`,f=`$debounce$result$${O}`;return function(...E){this[f]||(this[f]=w?w():void 0),clearTimeout(this[S]),A&&(this[f]=A(this[f],...E),E=[this[f]]),this[S]=setTimeout(()=>{h.apply(this,E),this[f]=w?w():void 0},R)}})}e.debounce=k;function M(R,A,w){return n((h,O)=>{const S=`$throttle$timer$${O}`,f=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...d){if(this[f]||(this[f]=w?w():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[f]=A(this[f],...d)),this[g])return;const t=this[E]+R;t<=Date.now()?(this[E]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[E]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0},t-Date.now()))}})}e.throttle=M}),define(Ae[84],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ae[113],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let s=0;const c=i.length;let o="",I=0,r=16,u=0;function v(j){let U=0,$=0;for(;U<j;){const B=i.charCodeAt(s);if(B>=48&&B<=57)$=$*16+B-48;else if(B>=65&&B<=70)$=$*16+B-65+10;else if(B>=97&&B<=102)$=$*16+B-97+10;else break;s++,U++}return U<j&&($=-1),$}function D(j){s=j,o="",I=0,r=16,u=0}function y(){const j=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&h(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&h(i.charCodeAt(s)))for(s++;s<i.length&&h(i.charCodeAt(s));)s++;else return u=3,i.substring(j,s);let U=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&h(i.charCodeAt(s))){for(s++;s<i.length&&h(i.charCodeAt(s));)s++;U=s}else u=3;return i.substring(j,U)}function W(){let j="",U=s;for(;;){if(s>=c){j+=i.substring(U,s),u=2;break}const $=i.charCodeAt(s);if($===34){j+=i.substring(U,s),s++;break}if($===92){if(j+=i.substring(U,s),s++,s>=c){u=2;break}switch(i.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=v(4);q>=0?j+=String.fromCharCode(q):u=4;break}default:u=5}U=s;continue}if($>=0&&$<=31)if(w($)){j+=i.substring(U,s),u=2;break}else u=6;s++}return j}function X(){if(o="",u=0,I=s,s>=c)return I=c,r=17;let j=i.charCodeAt(s);if(A(j)){do s++,o+=String.fromCharCode(j),j=i.charCodeAt(s);while(A(j));return r=15}if(w(j))return s++,o+=String.fromCharCode(j),j===13&&i.charCodeAt(s)===10&&(s++,o+=`
`),r=14;switch(j){case 123:return s++,r=1;case 125:return s++,r=2;case 91:return s++,r=3;case 93:return s++,r=4;case 58:return s++,r=6;case 44:return s++,r=5;case 34:return s++,o=W(),r=10;case 47:{const U=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<c&&!w(i.charCodeAt(s));)s++;return o=i.substring(U,s),r=12}if(i.charCodeAt(s+1)===42){s+=2;const $=c-1;let B=!1;for(;s<$;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,u=1),o=i.substring(U,s),r=13}return o+=String.fromCharCode(j),s++,r=16}case 45:if(o+=String.fromCharCode(j),s++,s===c||!h(i.charCodeAt(s)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=y(),r=11;default:for(;s<c&&_(j);)s++,j=i.charCodeAt(s);if(I!==s){switch(o=i.substring(I,s),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode(j),s++,r=16}}function _(j){if(A(j)||w(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let j;do j=X();while(j>=12&&j<=15);return j}return{setPosition:D,getPosition:()=>s,scan:l?J:X,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>I,getTokenLength:()=>s-I,getTokenError:()=>u}}e.createScanner=R;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function S(i,l){const s=[],c=new Object;let o;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function u(v,D,y,W){I.value=v,I.offset=D,I.length=y,I.type=W,I.colonOffset=void 0,o=I}try{b(i,{onObjectBegin:(v,D)=>{if(l<=v)throw c;o=void 0,r=l>v,s.push("")},onObjectProperty:(v,D,y)=>{if(l<D||(u(v,D,y,"property"),s[s.length-1]=v,l<=D+y))throw c},onObjectEnd:(v,D)=>{if(l<=v)throw c;o=void 0,s.pop()},onArrayBegin:(v,D)=>{if(l<=v)throw c;o=void 0,s.push(0)},onArrayEnd:(v,D)=>{if(l<=v)throw c;o=void 0,s.pop()},onLiteralValue:(v,D,y)=>{if(l<D||(u(v,D,y,p(v)),l<=D+y))throw c},onSeparator:(v,D,y)=>{if(l<=D)throw c;if(v===":"&&o&&o.type==="property")o.colonOffset=D,r=!1,o=void 0;else if(v===","){const W=s[s.length-1];typeof W=="number"?s[s.length-1]=W+1:(r=!0,s[s.length-1]=""),o=void 0}}})}catch(v){if(v!==c)throw v}return{path:s,previousNode:o,isAtPropertyKey:r,matches:v=>{let D=0;for(let y=0;D<v.length&&y<s.length;y++)if(v[D]===s[y]||v[D]==="*")D++;else if(v[D]!=="**")return!1;return D===v.length}}}e.getLocation=S;function f(i,l=[],s=M.DEFAULT){let c=null,o=[];const I=[];function r(v){Array.isArray(o)?o.push(v):c!==null&&(o[c]=v)}return b(i,{onObjectBegin:()=>{const v={};r(v),I.push(o),o=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{o=I.pop()},onArrayBegin:()=>{const v=[];r(v),I.push(o),o=v,c=null},onArrayEnd:()=>{o=I.pop()},onLiteralValue:r,onError:(v,D,y)=>{l.push({error:v,offset:D,length:y})}},s),o[0]}e.parse=f;function E(i,l=[],s=M.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function I(v){return c.children.push(v),v}b(i,{onObjectBegin:v=>{c=I({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,D,y)=>{c=I({type:"property",offset:D,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:D,length:y,parent:c})},onObjectEnd:(v,D)=>{c.length=v+D-c.offset,c=c.parent,o(v+D)},onArrayBegin:(v,D)=>{c=I({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,D)=>{c.length=v+D-c.offset,c=c.parent,o(v+D)},onLiteralValue:(v,D,y)=>{I({type:p(v),offset:D,length:y,parent:c,value:v}),o(D+y)},onSeparator:(v,D,y)=>{c.type==="property"&&(v===":"?c.colonOffset=D:v===","&&o(D))},onError:(v,D,y)=>{l.push({error:v,offset:D,length:y})}},s);const u=c.children[0];return u&&delete u.parent,u}e.parseTree=E;function g(i,l){if(!i)return;let s=i;for(const c of l)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const I of s.children)if(Array.isArray(I.children)&&I.children[0].value===c){s=I.children[1],o=!0;break}if(!o)return}else{const o=c;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=g;function d(i){if(!i.parent||!i.parent.children)return[];const l=d(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;l.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&l.push(s)}return l}e.getNodePath=d;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const l=Object.create(null);for(const s of i.children){const c=s.children[1];c&&(l[s.children[0].value]=t(c))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,l,s=!1){return l>=i.offset&&l<i.offset+i.length||s&&l===i.offset+i.length}e.contains=a;function m(i,l,s=!1){if(a(i,l,s)){const c=i.children;if(Array.isArray(c))for(let o=0;o<c.length&&c[o].offset<=l;o++){const I=m(c[o],l,s);if(I)return I}return i}}e.findNodeAtOffset=m;function b(i,l,s=M.DEFAULT){const c=R(i,!1);function o(Te){return Te?()=>Te(c.getTokenOffset(),c.getTokenLength()):()=>!0}function I(Te){return Te?le=>Te(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const r=o(l.onObjectBegin),u=I(l.onObjectProperty),v=o(l.onObjectEnd),D=o(l.onArrayBegin),y=o(l.onArrayEnd),W=I(l.onLiteralValue),X=I(l.onSeparator),_=o(l.onComment),J=I(l.onError),j=s&&s.disallowComments,U=s&&s.allowTrailingComma;function $(){for(;;){const Te=c.scan();switch(c.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:j||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(Te){case 12:case 13:j?B(10):_();break;case 16:B(1);break;case 15:case 14:break;default:return Te}}}function B(Te,le=[],re=[]){if(J(Te),le.length+re.length>0){let V=c.getToken();for(;V!==17;){if(le.indexOf(V)!==-1){$();break}else if(re.indexOf(V)!==-1)break;V=$()}}}function q(Te){const le=c.getTokenValue();return Te?W(le):u(le),$(),!0}function he(){switch(c.getToken()){case 11:{let Te=0;try{Te=JSON.parse(c.getTokenValue()),typeof Te!="number"&&(B(2),Te=0)}catch{B(2)}W(Te);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return $(),!0}function Ee(){return c.getToken()!==10?(B(3,[],[2,5]),!1):(q(!1),c.getToken()===6?(X(":"),$(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function ie(){r(),$();let Te=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(Te||B(4,[],[]),X(","),$(),c.getToken()===2&&U)break}else Te&&B(6,[],[]);Ee()||B(4,[],[2,5]),Te=!0}return v(),c.getToken()!==2?B(7,[2],[]):$(),!0}function ce(){D(),$();let Te=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(Te||B(4,[],[]),X(","),$(),c.getToken()===4&&U)break}else Te&&B(6,[],[]);de()||B(4,[],[4,5]),Te=!0}return y(),c.getToken()!==4?B(8,[4],[]):$(),!0}function de(){switch(c.getToken()){case 3:return ce();case 1:return ie();case 10:return q(!0);default:return he()}}return $(),c.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(c.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=b;function P(i,l){const s=R(i),c=[];let o,I=0,r;do switch(r=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:I!==r&&c.push(i.substring(I,r)),l!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,l)),I=s.getPosition();break}while(o!==17);return c.join("")}e.stripComments=P;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ae[28],Re([1,0]),function(ee,e){"use strict";var n,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(d,t,a){let m=d.get(t);return m===void 0&&(m=a,d.set(t,m)),m}e.getOrSet=M;function R(d){const t=[];return d.forEach((a,m)=>{t.push(`${m} => ${a}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=R;function A(d){const t=[];return d.forEach(a=>{t.push(a)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=A;class w{constructor(t,a){this.uri=t,this.value=a}}class h{constructor(t,a){this[n]="ResourceMap",t instanceof h?(this.b=new Map(t.b),this.c=a??h.a):(this.b=new Map,this.c=t??h.a)}set(t,a){return this.b.set(this.c(t),new w(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[m,b]of this.b)t(b.value,b.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}h.a=d=>d.toString(),e.ResourceMap=h;class O{constructor(t,a){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new h(t):(this.a=new h(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((m,b)=>t.call(a,b,b,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var S;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const m=this.a.get(t);if(!!m)return a!==0&&this.j(m,a),m.value}set(t,a,m=0){let b=this.a.get(t);if(b)b.value=a,m!==0&&this.j(b,m);else{switch(b={key:t,value:a,next:void 0,previous:void 0},m){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(t,b),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const m=this.e;let b=this.b;for(;b;){if(a?t.bind(a)(b.value,b.key,this):t(b.value,b.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const t=this,a=this.e;let m=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.key,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return b}values(){const t=this,a=this.e;let m=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.value,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return b}entries(){const t=this,a=this.e;let m=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:[m.key,m.value],done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return b}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,m=this.size;for(;a&&m>t;)this.a.delete(a.key),a=a.next,m--;this.b=a,this.d=m,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,m=t.previous;if(!a||!m)throw new Error("Invalid list");a.previous=m,m.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const m=t.next,b=t.previous;t===this.c?(b.next=void 0,this.c=b):(m.previous=b,b.next=m),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const m=t.next,b=t.previous;t===this.b?(m.previous=void 0,this.b=m):(m.previous=b,b.next=m),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,m)=>{t.push([m,a])}),t}fromJSON(t){this.clear();for(const[a,m]of t)this.set(a,m)}}e.LinkedMap=f;class E extends f{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=E;class g{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let a=this.a.get(t)||0;return a===0?!1:(a--,a===0?this.a.delete(t):this.a.set(t,a),!0)}has(t){return this.a.has(t)}}e.CounterSet=g}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ae[114],Re([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Se,ve){for(var Ce=0;Ce<ve.length;Ce++){var se=ve[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Se,se.key,se)}}function n(Se,ve,Ce){return ve&&e(Se.prototype,ve),Ce&&e(Se,Ce),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function T(Se,ve){if(!!Se){if(typeof Se=="string")return k(Se,ve);var Ce=Object.prototype.toString.call(Se).slice(8,-1);if(Ce==="Object"&&Se.constructor&&(Ce=Se.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Se);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return k(Se,ve)}}function k(Se,ve){(ve==null||ve>Se.length)&&(ve=Se.length);for(var Ce=0,se=new Array(ve);Ce<ve;Ce++)se[Ce]=Se[Ce];return se}function M(Se,ve){var Ce=typeof Symbol<"u"&&Se[Symbol.iterator]||Se["@@iterator"];if(Ce)return(Ce=Ce.call(Se)).next.bind(Ce);if(Array.isArray(Se)||(Ce=T(Se))||ve&&Se&&typeof Se.length=="number"){Ce&&(Se=Ce);var se=0;return function(){return se>=Se.length?{done:!0}:{done:!1,value:Se[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=R();function A(Se){ee.defaults=Se}var w=/[&<>"']/,h=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ve){return f[ve]};function g(Se,ve){if(ve){if(w.test(Se))return Se.replace(h,E)}else if(O.test(Se))return Se.replace(S,E);return Se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Se){return Se.replace(d,function(ve,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function m(Se,ve){Se=typeof Se=="string"?Se:Se.source,ve=ve||"";var Ce={replace:function(ae,Z){return Z=Z.source||Z,Z=Z.replace(a,"$1"),Se=Se.replace(ae,Z),Ce},getRegex:function(){return new RegExp(Se,ve)}};return Ce}var b=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Se,ve,Ce){if(Se){var se;try{se=decodeURIComponent(t(Ce)).replace(b,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!P.test(Ce)&&(Ce=o(ve,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var i={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Se,ve){i[" "+Se]||(l.test(Se)?i[" "+Se]=Se+"/":i[" "+Se]=v(Se,"/",!0)),Se=i[" "+Se];var Ce=Se.indexOf(":")===-1;return ve.substring(0,2)==="//"?Ce?ve:Se.replace(s,"$1")+ve:ve.charAt(0)==="/"?Ce?ve:Se.replace(c,"$1")+ve:Se+ve}var I={exec:function(){}};function r(Se){for(var ve=1,Ce,se;ve<arguments.length;ve++){Ce=arguments[ve];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(Se[se]=Ce[se])}return Se}function u(Se,ve){var Ce=Se.replace(/\|/g,function(Z,C,N){for(var H=!1,x=C;--x>=0&&N[x]==="\\";)H=!H;return H?"|":" |"}),se=Ce.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function v(Se,ve,Ce){var se=Se.length;if(se===0)return"";for(var ae=0;ae<se;){var Z=Se.charAt(se-ae-1);if(Z===ve&&!Ce)ae++;else if(Z!==ve&&Ce)ae++;else break}return Se.slice(0,se-ae)}function D(Se,ve){if(Se.indexOf(ve[1])===-1)return-1;for(var Ce=Se.length,se=0,ae=0;ae<Ce;ae++)if(Se[ae]==="\\")ae++;else if(Se[ae]===ve[0])se++;else if(Se[ae]===ve[1]&&(se--,se<0))return ae;return-1}function y(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Se,ve){if(ve<1)return"";for(var Ce="";ve>1;)ve&1&&(Ce+=Se),ve>>=1,Se+=Se;return Ce+Se}function X(Se,ve,Ce,se){var ae=ve.href,Z=ve.title?g(ve.title):null,C=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){se.state.inLink=!0;var N={type:"link",raw:Ce,href:ae,title:Z,text:C,tokens:se.inlineTokens(C)};return se.state.inLink=!1,N}return{type:"image",raw:Ce,href:ae,title:Z,text:g(C)}}function _(Se,ve){var Ce=Se.match(/^(\s+)(?:```)/);if(Ce===null)return ve;var se=Ce[1];return ve.split(`
`).map(function(ae){var Z=ae.match(/^\s+/);if(Z===null)return ae;var C=Z[0];return C.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var J=function(){function Se(Ce){this.options=Ce||ee.defaults}var ve=Se.prototype;return ve.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ve.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var Z=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},ve.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var Z=ae[0],C=_(Z,ae[3]||"");return{type:"code",raw:Z,lang:ae[2]?ae[2].trim():ae[2],text:C}}},ve.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var Z=ae[2].trim();if(/#$/.test(Z)){var C=v(Z,"#");(this.options.pedantic||!C||/ $/.test(C))&&(Z=C.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ve.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},ve.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var Z=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ve.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var Z,C,N,H,x,te,pe,ke,ue,De,we,$e,He=ae[1].trim(),et=He.length>1,Xe={type:"list",raw:"",ordered:et,start:et?+He.slice(0,-1):"",loose:!1,items:[]};He=et?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=et?He:"[*+-]");for(var tt=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&($e=!1,!(!(ae=tt.exec(se))||this.rules.block.hr.test(se)));){if(Z=ae[0],se=se.substring(Z.length),ke=ae[2].split(`
`,1)[0],ue=se.split(`
`,1)[0],this.options.pedantic?(H=2,we=ke.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,we=ke.slice(H),H+=ae[1].length),te=!1,!ke&&/^ *$/.test(ue)&&(Z+=ue+`
`,se=se.substring(ue.length+1),$e=!0),!$e)for(var rt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Me=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(De=se.split(`
`,1)[0],ke=De,this.options.pedantic&&(ke=ke.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(ke)||Q.test(ke)||rt.test(ke)||Me.test(se)));){if(ke.search(/[^ ]/)>=H||!ke.trim())we+=`
`+ke.slice(H);else if(!te)we+=`
`+ke;else break;!te&&!ke.trim()&&(te=!0),Z+=De+`
`,se=se.substring(De.length+1)}Xe.loose||(pe?Xe.loose=!0:/\n *\n *$/.test(Z)&&(pe=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(we),C&&(N=C[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!C,checked:N,loose:!1,text:we}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=we.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(x=0;x<Y;x++){this.lexer.state.top=!1,Xe.items[x].tokens=this.lexer.blockTokens(Xe.items[x].text,[]);var be=Xe.items[x].tokens.filter(function(ze){return ze.type==="space"}),We=be.every(function(ze){for(var Qe=ze.raw.split(""),Ye=0,Ge=M(Qe),at;!(at=Ge()).done;){var Dt=at.value;if(Dt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Xe.loose&&be.length&&We&&(Xe.loose=!0,Xe.items[x].loose=!0)}return Xe}},ve.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var Z={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]);Z.type="paragraph",Z.text=C,Z.tokens=this.lexer.inline(C)}return Z}},ve.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var Z=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ae[0],href:ae[2],title:ae[3]}}},ve.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var Z={type:"table",header:u(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ae[0];var C=Z.align.length,N,H,x,te;for(N=0;N<C;N++)/^ *-+: *$/.test(Z.align[N])?Z.align[N]="right":/^ *:-+: *$/.test(Z.align[N])?Z.align[N]="center":/^ *:-+ *$/.test(Z.align[N])?Z.align[N]="left":Z.align[N]=null;for(C=Z.rows.length,N=0;N<C;N++)Z.rows[N]=u(Z.rows[N],Z.header.length).map(function(pe){return{text:pe}});for(C=Z.header.length,H=0;H<C;H++)Z.header[H].tokens=this.lexer.inline(Z.header[H].text);for(C=Z.rows.length,H=0;H<C;H++)for(te=Z.rows[H],x=0;x<te.length;x++)te[x].tokens=this.lexer.inline(te[x].text);return Z}}},ve.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ve.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var Z=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:Z,tokens:this.lexer.inline(Z)}}},ve.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ve.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:g(ae[1])}},ve.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]):ae[0]}},ve.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var Z=ae[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var C=v(Z.slice(0,-1),"\\");if((Z.length-C.length)%2===0)return}else{var N=D(ae[2],"()");if(N>-1){var H=ae[0].indexOf("!")===0?5:4,x=H+ae[1].length+N;ae[2]=ae[2].substring(0,N),ae[0]=ae[0].substring(0,x).trim(),ae[3]=""}}var te=ae[2],pe="";if(this.options.pedantic){var ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);ke&&(te=ke[1],pe=ke[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Z)?te=te.slice(1):te=te.slice(1,-1)),X(ae,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ve.reflink=function(se,ae){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var C=(Z[2]||Z[1]).replace(/\s+/g," ");if(C=ae[C.toLowerCase()],!C||!C.href){var N=Z[0].charAt(0);return{type:"text",raw:N,text:N}}return X(Z,C,Z[0],this.lexer)}},ve.emStrong=function(se,ae,Z){Z===void 0&&(Z="");var C=this.rules.inline.emStrong.lDelim.exec(se);if(!!C&&!(C[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=C[1]||C[2]||"";if(!N||N&&(Z===""||this.rules.inline.punctuation.exec(Z))){var H=C[0].length-1,x,te,pe=H,ke=0,ue=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,ae=ae.slice(-1*se.length+H);(C=ue.exec(ae))!=null;)if(x=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!x){if(te=x.length,C[3]||C[4]){pe+=te;continue}else if((C[5]||C[6])&&H%3&&!((H+te)%3)){ke+=te;continue}if(pe-=te,!(pe>0)){if(te=Math.min(te,te+pe+ke),Math.min(H,te)%2){var De=se.slice(1,H+C.index+te);return{type:"em",raw:se.slice(0,H+C.index+te+1),text:De,tokens:this.lexer.inlineTokens(De)}}var we=se.slice(2,H+C.index+te-1);return{type:"strong",raw:se.slice(0,H+C.index+te+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},ve.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var Z=ae[2].replace(/\n/g," "),C=/[^ ]/.test(Z),N=/^ /.test(Z)&&/ $/.test(Z);return C&&N&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:ae[0],text:Z}}},ve.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},ve.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ve.autolink=function(se,ae){var Z=this.rules.inline.autolink.exec(se);if(Z){var C,N;return Z[2]==="@"?(C=g(this.options.mangle?ae(Z[1]):Z[1]),N="mailto:"+C):(C=g(Z[1]),N=C),{type:"link",raw:Z[0],text:C,href:N,tokens:[{type:"text",raw:C,text:C}]}}},ve.url=function(se,ae){var Z;if(Z=this.rules.inline.url.exec(se)){var C,N;if(Z[2]==="@")C=g(this.options.mangle?ae(Z[0]):Z[0]),N="mailto:"+C;else{var H;do H=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(H!==Z[0]);C=g(Z[0]),Z[1]==="www."?N="http://"+C:N=C}return{type:"link",raw:Z[0],text:C,href:N,tokens:[{type:"text",raw:C,text:C}]}}},ve.inlineText=function(se,ae){var Z=this.rules.inline.text.exec(se);if(Z){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:C=g(this.options.smartypants?ae(Z[0]):Z[0]),{type:"text",raw:Z[0],text:C}}},Se}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=r({},j),j.gfm=r({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=r({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=m(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=m(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=m(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=m(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=m(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=m(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=m(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=m(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=m(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=m(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=r({},U),U.pedantic=r({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=r({},U.normal,{escape:m(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=m(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=r({},U.gfm,{br:m(U.br).replace("{2,}","*").getRegex(),text:m(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Se){var ve="",Ce,se,ae=Se.length;for(Ce=0;Ce<ae;Ce++)se=Se.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var q=function(){function Se(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ee.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:j.normal,inline:U.normal};this.options.pedantic?(se.block=j.pedantic,se.inline=U.pedantic):this.options.gfm&&(se.block=j.gfm,this.options.breaks?se.inline=U.breaks:se.inline=U.gfm),this.tokenizer.rules=se}Se.lex=function(se,ae){var Z=new Se(ae);return Z.lex(se)},Se.lexInline=function(se,ae){var Z=new Se(ae);return Z.inlineTokens(se)};var ve=Se.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ve.blockTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(pe,ke,ue){return ke+"    ".repeat(ue.length)});for(var C,N,H,x;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(C=pe.call({lexer:Z},se,ae))?(se=se.substring(C.raw.length),ae.push(C),!0):!1}))){if(C=this.tokenizer.space(se)){se=se.substring(C.raw.length),C.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(C);continue}if(C=this.tokenizer.code(se)){se=se.substring(C.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(C);continue}if(C=this.tokenizer.fences(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.heading(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.hr(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.blockquote(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.list(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.html(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.def(se)){se=se.substring(C.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+C.raw,N.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.lheading(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,ke=se.slice(1),ue=void 0;Z.options.extensions.startBlock.forEach(function(De){ue=De.call({lexer:this},ke),typeof ue=="number"&&ue>=0&&(pe=Math.min(pe,ue))}),pe<1/0&&pe>=0&&(H=se.substring(0,pe+1))}(),this.state.top&&(C=this.tokenizer.paragraph(H))){N=ae[ae.length-1],x&&N.type==="paragraph"?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(C),x=H.length!==se.length,se=se.substring(C.raw.length);continue}if(C=this.tokenizer.text(se)){se=se.substring(C.raw.length),N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(C);continue}if(se){var te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ae},ve.inline=function(se,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:se,tokens:ae}),ae},ve.inlineTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]);var C,N,H,x=se,te,pe,ke;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(x))!=null;)ue.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(x))!=null;)x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(x))!=null;)x=x.slice(0,te.index)+"++"+x.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(pe||(ke=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(C=we.call({lexer:Z},se,ae))?(se=se.substring(C.raw.length),ae.push(C),!0):!1}))){if(C=this.tokenizer.escape(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.tag(se)){se=se.substring(C.raw.length),N=ae[ae.length-1],N&&C.type==="text"&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):ae.push(C);continue}if(C=this.tokenizer.link(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(C.raw.length),N=ae[ae.length-1],N&&C.type==="text"&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):ae.push(C);continue}if(C=this.tokenizer.emStrong(se,x,ke)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.codespan(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.br(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.del(se)){se=se.substring(C.raw.length),ae.push(C);continue}if(C=this.tokenizer.autolink(se,B)){se=se.substring(C.raw.length),ae.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(se,B))){se=se.substring(C.raw.length),ae.push(C);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,$e=se.slice(1),He=void 0;Z.options.extensions.startInline.forEach(function(et){He=et.call({lexer:this},$e),typeof He=="number"&&He>=0&&(we=Math.min(we,He))}),we<1/0&&we>=0&&(H=se.substring(0,we+1))}(),C=this.tokenizer.inlineText(H,$)){se=se.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(ke=C.raw.slice(-1)),pe=!0,N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):ae.push(C);continue}if(se){var De="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},n(Se,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),Se}(),he=function(){function Se(Ce){this.options=Ce||ee.defaults}var ve=Se.prototype;return ve.code=function(se,ae,Z){var C=(ae||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(se,C);N!=null&&N!==se&&(Z=!0,se=N)}return se=se.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+g(C,!0)+'">'+(Z?se:g(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:g(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,ae,Z,C){if(this.options.headerIds){var N=this.options.headerPrefix+C.slug(Z);return"<h"+ae+' id="'+N+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,ae,Z){var C=ae?"ol":"ul",N=ae&&Z!==1?' start="'+Z+'"':"";return"<"+C+N+`>
`+se+"</"+C+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,ae){var Z=ae.header?"th":"td",C=ae.align?"<"+Z+' align="'+ae.align+'">':"<"+Z+">";return C+se+("</"+Z+`>
`)},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,ae,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var C='<a href="'+g(se)+'"';return ae&&(C+=' title="'+ae+'"'),C+=">"+Z+"</a>",C},ve.image=function(se,ae,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var C='<img src="'+se+'" alt="'+Z+'"';return ae&&(C+=' title="'+ae+'"'),C+=this.options.xhtml?"/>":">",C},ve.text=function(se){return se},Se}(),Ee=function(){function Se(){}var ve=Se.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,ae,Z){return""+Z},ve.image=function(se,ae,Z){return""+Z},ve.br=function(){return""},Se}(),ie=function(){function Se(){this.seen={}}var ve=Se.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,ae){var Z=se,C=0;if(this.seen.hasOwnProperty(Z)){C=this.seen[se];do C++,Z=se+"-"+C;while(this.seen.hasOwnProperty(Z))}return ae||(this.seen[se]=C,this.seen[Z]=0),Z},ve.slug=function(se,ae){ae===void 0&&(ae={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,ae.dryrun)},Se}(),ce=function(){function Se(Ce){this.options=Ce||ee.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new ie}Se.parse=function(se,ae){var Z=new Se(ae);return Z.parse(se)},Se.parseInline=function(se,ae){var Z=new Se(ae);return Z.parseInline(se)};var ve=Se.prototype;return ve.parse=function(se,ae){ae===void 0&&(ae=!0);var Z="",C,N,H,x,te,pe,ke,ue,De,we,$e,He,et,Xe,tt,rt,Me,it,Q,Y=se.length;for(C=0;C<Y;C++){if(we=se[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Q=this.options.extensions.renderers[we.type].call({parser:this},we),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){Z+=Q||"";continue}switch(we.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(we.tokens),we.depth,t(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(ue="",ke="",x=we.header.length,N=0;N<x;N++)ke+=this.renderer.tablecell(this.parseInline(we.header[N].tokens),{header:!0,align:we.align[N]});for(ue+=this.renderer.tablerow(ke),De="",x=we.rows.length,N=0;N<x;N++){for(pe=we.rows[N],ke="",te=pe.length,H=0;H<te;H++)ke+=this.renderer.tablecell(this.parseInline(pe[H].tokens),{header:!1,align:we.align[H]});De+=this.renderer.tablerow(ke)}Z+=this.renderer.table(ue,De);continue}case"blockquote":{De=this.parse(we.tokens),Z+=this.renderer.blockquote(De);continue}case"list":{for($e=we.ordered,He=we.start,et=we.loose,x=we.items.length,De="",N=0;N<x;N++)tt=we.items[N],rt=tt.checked,Me=tt.task,Xe="",tt.task&&(it=this.renderer.checkbox(rt),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Xe+=it),Xe+=this.parse(tt.tokens,et),De+=this.renderer.listitem(Xe,Me,rt);Z+=this.renderer.list(De,$e,He);continue}case"html":{Z+=this.renderer.html(we.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(De=we.tokens?this.parseInline(we.tokens):we.text;C+1<Y&&se[C+1].type==="text";)we=se[++C],De+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);Z+=ae?this.renderer.paragraph(De):De;continue}default:{var be='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return Z},ve.parseInline=function(se,ae){ae=ae||this.renderer;var Z="",C,N,H,x=se.length;for(C=0;C<x;C++){if(N=se[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(H=this.options.extensions.renderers[N.type].call({parser:this},N),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){Z+=H||"";continue}switch(N.type){case"escape":{Z+=ae.text(N.text);break}case"html":{Z+=ae.html(N.text);break}case"link":{Z+=ae.link(N.href,N.title,this.parseInline(N.tokens,ae));break}case"image":{Z+=ae.image(N.href,N.title,N.text);break}case"strong":{Z+=ae.strong(this.parseInline(N.tokens,ae));break}case"em":{Z+=ae.em(this.parseInline(N.tokens,ae));break}case"codespan":{Z+=ae.codespan(N.text);break}case"br":{Z+=ae.br();break}case"del":{Z+=ae.del(this.parseInline(N.tokens,ae));break}case"text":{Z+=ae.text(N.text);break}default:{var te='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Z},Se}();function de(Se,ve,Ce){if(typeof Se>"u"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ve=="function"&&(Ce=ve,ve=null),ve=r({},de.defaults,ve||{}),y(ve),Ce){var se=ve.highlight,ae;try{ae=q.lex(Se,ve)}catch(x){return Ce(x)}var Z=function(te){var pe;if(!te)try{ve.walkTokens&&de.walkTokens(ae,ve.walkTokens),pe=ce.parse(ae,ve)}catch(ke){te=ke}return ve.highlight=se,te?Ce(te):Ce(null,pe)};if(!se||se.length<3||(delete ve.highlight,!ae.length))return Z();var C=0;de.walkTokens(ae,function(x){x.type==="code"&&(C++,setTimeout(function(){se(x.text,x.lang,function(te,pe){if(te)return Z(te);pe!=null&&pe!==x.text&&(x.text=pe,x.escaped=!0),C--,C===0&&Z()})},0))}),C===0&&Z();return}function N(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(x.message+"",!0)+"</pre>";throw x}try{var H=q.lex(Se,ve);if(ve.walkTokens){if(ve.async)return Promise.all(de.walkTokens(H,ve.walkTokens)).then(function(){return ce.parse(H,ve)}).catch(N);de.walkTokens(H,ve.walkTokens)}return ce.parse(H,ve)}catch(x){N(x)}}de.options=de.setOptions=function(Se){return r(de.defaults,Se),A(de.defaults),de},de.getDefaults=R,de.defaults=ee.defaults,de.use=function(){for(var Se=arguments.length,ve=new Array(Se),Ce=0;Ce<Se;Ce++)ve[Ce]=arguments[Ce];var se=r.apply(void 0,[{}].concat(ve)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},Z;ve.forEach(function(C){if(C.extensions&&(Z=!0,C.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var x=ae.renderers?ae.renderers[H.name]:null;x?ae.renderers[H.name]=function(){for(var te=arguments.length,pe=new Array(te),ke=0;ke<te;ke++)pe[ke]=arguments[ke];var ue=H.renderer.apply(this,pe);return ue===!1&&(ue=x.apply(this,pe)),ue}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),C.renderer&&function(){var H=de.defaults.renderer||new he,x=function(ke){var ue=H[ke];H[ke]=function(){for(var De=arguments.length,we=new Array(De),$e=0;$e<De;$e++)we[$e]=arguments[$e];var He=C.renderer[ke].apply(H,we);return He===!1&&(He=ue.apply(H,we)),He}};for(var te in C.renderer)x(te);se.renderer=H}(),C.tokenizer&&function(){var H=de.defaults.tokenizer||new J,x=function(ke){var ue=H[ke];H[ke]=function(){for(var De=arguments.length,we=new Array(De),$e=0;$e<De;$e++)we[$e]=arguments[$e];var He=C.tokenizer[ke].apply(H,we);return He===!1&&(He=ue.apply(H,we)),He}};for(var te in C.tokenizer)x(te);se.tokenizer=H}(),C.walkTokens){var N=de.defaults.walkTokens;se.walkTokens=function(H){var x=[];return x.push(C.walkTokens.call(this,H)),N&&(x=x.concat(N.call(this,H))),x}}Z&&(se.extensions=ae),de.setOptions(se)})},de.walkTokens=function(Se,ve){for(var Ce=[],se=function(){var N=Z.value;switch(Ce=Ce.concat(ve.call(de,N)),N.type){case"table":{for(var H=M(N.header),x;!(x=H()).done;){var te=x.value;Ce=Ce.concat(de.walkTokens(te.tokens,ve))}for(var pe=M(N.rows),ke;!(ke=pe()).done;)for(var ue=ke.value,De=M(ue),we;!(we=De()).done;){var $e=we.value;Ce=Ce.concat(de.walkTokens($e.tokens,ve))}break}case"list":{Ce=Ce.concat(de.walkTokens(N.items,ve));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[N.type]?de.defaults.extensions.childTokens[N.type].forEach(function(He){Ce=Ce.concat(de.walkTokens(N[He],ve))}):N.tokens&&(Ce=Ce.concat(de.walkTokens(N.tokens,ve)))}},ae=M(Se),Z;!(Z=ae()).done;)se();return Ce},de.parseInline=function(Se,ve){if(typeof Se>"u"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ve=r({},de.defaults,ve||{}),y(ve);try{var Ce=q.lexInline(Se,ve);return ve.walkTokens&&de.walkTokens(Ce,ve.walkTokens),ce.parseInline(Ce,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(se.message+"",!0)+"</pre>";throw se}},de.Parser=ce,de.parser=ce.parse,de.Renderer=he,de.TextRenderer=Ee,de.Lexer=q,de.lexer=q.lex,de.Tokenizer=J,de.Slugger=ie,de.parse=de;var Te=de.options,le=de.setOptions,re=de.use,V=de.walkTokens,L=de.parseInline,K=de,me=ce.parse,Ie=q.lex;ee.Lexer=q,ee.Parser=ce,ee.Renderer=he,ee.Slugger=ie,ee.TextRenderer=Ee,ee.Tokenizer=J,ee.getDefaults=R,ee.lexer=Ie,ee.marked=de,ee.options=Te,ee.parse=K,ee.parseInline=L,ee.parser=me,ee.setOptions=le,ee.use=re,ee.walkTokens=V,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ae[115],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,w,h){return Math.min(Math.max(A,w),h)}e.clamp=n;function T(A,w){return(w+A%w)%w}e.rot=T;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class M{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class R{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const h=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function ee(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function R(w){M.push(w,Date.now())}function A(){const w=[];for(let h=0;h<M.length;h+=2)w.push({name:M[h],startTime:M[h+1]});return w}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(k+R.startTime)});return M}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=n(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var T in n)(typeof exports=="object"?exports:ee)[T]=n[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function n(T){if(e[T])return e[T].exports;var k=e[T]={i:T,l:!1,exports:{}};return ee[T].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=ee,n.c=e,n.d=function(T,k,M){n.o(T,k)||Object.defineProperty(T,k,{enumerable:!0,get:M})},n.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},n.t=function(T,k){if(1&k&&(T=n(T)),8&k||4&k&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&k&&typeof T!="string")for(var R in T)n.d(M,R,function(A){return T[A]}.bind(null,R));return M},n.n=function(T){var k=T&&T.__esModule?function(){return T.default}:function(){return T};return n.d(k,"a",k),k},n.o=function(T,k){return Object.prototype.hasOwnProperty.call(T,k)},n.p="",n(n.s=0)}([function(ee,e,n){(function(T){var k;e=ee.exports=re,k=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],w=e.src=[],h=0,O=h++;w[O]="0|[1-9]\\d*";var S=h++;w[S]="[0-9]+";var f=h++;w[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=h++;w[E]="("+w[O]+")\\.("+w[O]+")\\.("+w[O]+")";var g=h++;w[g]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var d=h++;w[d]="(?:"+w[O]+"|"+w[f]+")";var t=h++;w[t]="(?:"+w[S]+"|"+w[f]+")";var a=h++;w[a]="(?:-("+w[d]+"(?:\\."+w[d]+")*))";var m=h++;w[m]="(?:-?("+w[t]+"(?:\\."+w[t]+")*))";var b=h++;w[b]="[0-9A-Za-z-]+";var P=h++;w[P]="(?:\\+("+w[b]+"(?:\\."+w[b]+")*))";var p=h++,i="v?"+w[E]+w[a]+"?"+w[P]+"?";w[p]="^"+i+"$";var l="[v=\\s]*"+w[g]+w[m]+"?"+w[P]+"?",s=h++;w[s]="^"+l+"$";var c=h++;w[c]="((?:<|>)?=?)";var o=h++;w[o]=w[S]+"|x|X|\\*";var I=h++;w[I]=w[O]+"|x|X|\\*";var r=h++;w[r]="[v=\\s]*("+w[I]+")(?:\\.("+w[I]+")(?:\\.("+w[I]+")(?:"+w[a]+")?"+w[P]+"?)?)?";var u=h++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[P]+"?)?)?";var v=h++;w[v]="^"+w[c]+"\\s*"+w[r]+"$";var D=h++;w[D]="^"+w[c]+"\\s*"+w[u]+"$";var y=h++;w[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=h++;w[W]="(?:~>?)";var X=h++;w[X]="(\\s*)"+w[W]+"\\s+",A[X]=new RegExp(w[X],"g");var _=h++;w[_]="^"+w[W]+w[r]+"$";var J=h++;w[J]="^"+w[W]+w[u]+"$";var j=h++;w[j]="(?:\\^)";var U=h++;w[U]="(\\s*)"+w[j]+"\\s+",A[U]=new RegExp(w[U],"g");var $=h++;w[$]="^"+w[j]+w[r]+"$";var B=h++;w[B]="^"+w[j]+w[u]+"$";var q=h++;w[q]="^"+w[c]+"\\s*("+l+")$|^$";var he=h++;w[he]="^"+w[c]+"\\s*("+i+")$|^$";var Ee=h++;w[Ee]="(\\s*)"+w[c]+"\\s*("+l+"|"+w[r]+")",A[Ee]=new RegExp(w[Ee],"g");var ie=h++;w[ie]="^\\s*("+w[r]+")\\s+-\\s+("+w[r]+")\\s*$";var ce=h++;w[ce]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var de=h++;w[de]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)k(Te,w[Te]),A[Te]||(A[Te]=new RegExp(w[Te]));function le(ue,De){if(ue instanceof re)return ue;if(typeof ue!="string"||ue.length>M||!(De?A[s]:A[p]).test(ue))return null;try{return new re(ue,De)}catch{return null}}function re(ue,De){if(ue instanceof re){if(ue.loose===De)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(ue,De);k("SemVer",ue,De),this.loose=De;var we=ue.trim().match(De?A[s]:A[p]);if(!we)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<R)return He}return $e}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=le,e.valid=function(ue,De){var we=le(ue,De);return we?we.version:null},e.clean=function(ue,De){var we=le(ue.trim().replace(/^[=v]+/,""),De);return we?we.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(ue){return k("SemVer.compare",this.version,this.loose,ue),ue instanceof re||(ue=new re(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},re.prototype.compareMain=function(ue){return ue instanceof re||(ue=new re(ue,this.loose)),L(this.major,ue.major)||L(this.minor,ue.minor)||L(this.patch,ue.patch)},re.prototype.comparePre=function(ue){if(ue instanceof re||(ue=new re(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var De=0;do{var we=this.prerelease[De],$e=ue.prerelease[De];if(k("prerelease compare",De,we,$e),we===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(we===void 0)return-1;if(we!==$e)return L(we,$e)}while(++De)},re.prototype.inc=function(ue,De){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,De,we,$e){typeof we=="string"&&($e=we,we=void 0);try{return new re(ue,we).inc(De,$e).version}catch{return null}},e.diff=function(ue,De){if(Se(ue,De))return null;var we=le(ue),$e=le(De);if(we.prerelease.length||$e.prerelease.length){for(var He in we)if((He==="major"||He==="minor"||He==="patch")&&we[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in we)if((He==="major"||He==="minor"||He==="patch")&&we[He]!==$e[He])return He},e.compareIdentifiers=L;var V=/^[0-9]+$/;function L(ue,De){var we=V.test(ue),$e=V.test(De);return we&&$e&&(ue=+ue,De=+De),we&&!$e?-1:$e&&!we?1:ue<De?-1:ue>De?1:0}function K(ue,De,we){return new re(ue,we).compare(new re(De,we))}function me(ue,De,we){return K(ue,De,we)>0}function Ie(ue,De,we){return K(ue,De,we)<0}function Se(ue,De,we){return K(ue,De,we)===0}function ve(ue,De,we){return K(ue,De,we)!==0}function Ce(ue,De,we){return K(ue,De,we)>=0}function se(ue,De,we){return K(ue,De,we)<=0}function ae(ue,De,we,$e){var He;switch(De){case"===":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),He=ue===we;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),He=ue!==we;break;case"":case"=":case"==":He=Se(ue,we,$e);break;case"!=":He=ve(ue,we,$e);break;case">":He=me(ue,we,$e);break;case">=":He=Ce(ue,we,$e);break;case"<":He=Ie(ue,we,$e);break;case"<=":He=se(ue,we,$e);break;default:throw new TypeError("Invalid operator: "+De)}return He}function Z(ue,De){if(ue instanceof Z){if(ue.loose===De)return ue;ue=ue.value}if(!(this instanceof Z))return new Z(ue,De);k("comparator",ue,De),this.loose=De,this.parse(ue),this.semver===C?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ue,De){return L(De,ue)},e.major=function(ue,De){return new re(ue,De).major},e.minor=function(ue,De){return new re(ue,De).minor},e.patch=function(ue,De){return new re(ue,De).patch},e.compare=K,e.compareLoose=function(ue,De){return K(ue,De,!0)},e.rcompare=function(ue,De,we){return K(De,ue,we)},e.sort=function(ue,De){return ue.sort(function(we,$e){return e.compare(we,$e,De)})},e.rsort=function(ue,De){return ue.sort(function(we,$e){return e.rcompare(we,$e,De)})},e.gt=me,e.lt=Ie,e.eq=Se,e.neq=ve,e.gte=Ce,e.lte=se,e.cmp=ae,e.Comparator=Z;var C={};function N(ue,De){if(ue instanceof N)return ue.loose===De?ue:new N(ue.raw,De);if(ue instanceof Z)return new N(ue.value,De);if(!(this instanceof N))return new N(ue,De);if(this.loose=De,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function H(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function x(ue,De,we,$e,He,et,Xe,tt,rt,Me,it,Q,Y){return((De=H(we)?"":H($e)?">="+we+".0.0":H(He)?">="+we+"."+$e+".0":">="+De)+" "+(tt=H(rt)?"":H(Me)?"<"+(+rt+1)+".0.0":H(it)?"<"+rt+"."+(+Me+1)+".0":Q?"<="+rt+"."+Me+"."+it+"-"+Q:"<="+tt)).trim()}function te(ue,De){for(var we=0;we<ue.length;we++)if(!ue[we].test(De))return!1;if(De.prerelease.length){for(we=0;we<ue.length;we++)if(k(ue[we].semver),ue[we].semver!==C&&ue[we].semver.prerelease.length>0){var $e=ue[we].semver;if($e.major===De.major&&$e.minor===De.minor&&$e.patch===De.patch)return!0}return!1}return!0}function pe(ue,De,we){try{De=new N(De,we)}catch{return!1}return De.test(ue)}function ke(ue,De,we,$e){var He,et,Xe,tt,rt;switch(ue=new re(ue,$e),De=new N(De,$e),we){case">":He=me,et=se,Xe=Ie,tt=">",rt=">=";break;case"<":He=Ie,et=Ce,Xe=me,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ue,De,$e))return!1;for(var Me=0;Me<De.set.length;++Me){var it=De.set[Me],Q=null,Y=null;if(it.forEach(function(be){be.semver===C&&(be=new Z(">=0.0.0")),Q=Q||be,Y=Y||be,He(be.semver,Q.semver,$e)?Q=be:Xe(be.semver,Y.semver,$e)&&(Y=be)}),Q.operator===tt||Q.operator===rt||(!Y.operator||Y.operator===tt)&&et(ue,Y.semver)||Y.operator===rt&&Xe(ue,Y.semver))return!1}return!0}Z.prototype.parse=function(ue){var De=this.loose?A[q]:A[he],we=ue.match(De);if(!we)throw new TypeError("Invalid comparator: "+ue);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new re(we[2],this.loose):this.semver=C},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ue){return k("Comparator.test",ue,this.loose),this.semver===C||(typeof ue=="string"&&(ue=new re(ue,this.loose)),ae(ue,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ue,De){if(!(ue instanceof Z))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new N(ue.value,De),pe(this.value,we,De);if(ue.operator==="")return we=new N(this.value,De),pe(ue.semver,we,De);var $e=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),et=this.semver.version===ue.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),tt=ae(this.semver,"<",ue.semver,De)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),rt=ae(this.semver,">",ue.semver,De)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return $e||He||et&&Xe||tt||rt},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(ue){var De=this.loose;ue=ue.trim(),k("range",ue,De);var we=De?A[ce]:A[ie];ue=ue.replace(we,x),k("hyphen replace",ue),ue=ue.replace(A[Ee],"$1$2$3"),k("comparator trim",ue,A[Ee]),ue=(ue=(ue=ue.replace(A[X],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var $e=De?A[q]:A[he],He=ue.split(" ").map(function(et){return function(Xe,tt){return k("comp",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,Y){k("caret",Q,Y);var be=Y?A[B]:A[$];return Q.replace(be,function(We,ze,Qe,Ye,Ge){var at;return k("caret",Q,We,ze,Qe,Ye,Ge),H(ze)?at="":H(Qe)?at=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(Ye)?at=ze==="0"?">="+ze+"."+Qe+".0 <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+".0 <"+(+ze+1)+".0.0":Ge?(k("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=ze==="0"?Qe==="0"?">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+Qe+"."+(+Ye+1):">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+"."+Ye+Ge+" <"+(+ze+1)+".0.0"):(k("no pr"),at=ze==="0"?Qe==="0"?">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+Qe+"."+(+Ye+1):">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+"."+Ye+" <"+(+ze+1)+".0.0"),k("caret return",at),at})}(it,Me)}).join(" ")}(Xe,tt),k("caret",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,Y){var be=Y?A[J]:A[_];return Q.replace(be,function(We,ze,Qe,Ye,Ge){var at;return k("tilde",Q,We,ze,Qe,Ye,Ge),H(ze)?at="":H(Qe)?at=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(Ye)?at=">="+ze+"."+Qe+".0 <"+ze+"."+(+Qe+1)+".0":Ge?(k("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+(+Qe+1)+".0"):at=">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+(+Qe+1)+".0",k("tilde return",at),at})}(it,Me)}).join(" ")}(Xe,tt),k("tildes",Xe),Xe=function(rt,Me){return k("replaceXRanges",rt,Me),rt.split(/\s+/).map(function(it){return function(Q,Y){Q=Q.trim();var be=Y?A[D]:A[v];return Q.replace(be,function(We,ze,Qe,Ye,Ge,at){k("xRange",Q,We,ze,Qe,Ye,Ge,at);var Dt=H(Qe),Tt=Dt||H(Ye),It=Tt||H(Ge);return ze==="="&&It&&(ze=""),Dt?We=ze===">"||ze==="<"?"<0.0.0":"*":ze&&It?(Tt&&(Ye=0),It&&(Ge=0),ze===">"?(ze=">=",Tt?(Qe=+Qe+1,Ye=0,Ge=0):It&&(Ye=+Ye+1,Ge=0)):ze==="<="&&(ze="<",Tt?Qe=+Qe+1:Ye=+Ye+1),We=ze+Qe+"."+Ye+"."+Ge):Tt?We=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":It&&(We=">="+Qe+"."+Ye+".0 <"+Qe+"."+(+Ye+1)+".0"),k("xRange return",We),We})}(it,Me)}).join(" ")}(Xe,tt),k("xrange",Xe),Xe=function(rt,Me){return k("replaceStars",rt,Me),rt.trim().replace(A[de],"")}(Xe,tt),k("stars",Xe),Xe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(et){return!!et.match($e)})),He=He.map(function(et){return new Z(et,De)})},N.prototype.intersects=function(ue,De){if(!(ue instanceof N))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function($e){return ue.set.some(function(He){return He.every(function(et){return $e.intersects(et,De)})})})})},e.toComparators=function(ue,De){return new N(ue,De).set.map(function(we){return we.map(function($e){return $e.value}).join(" ").trim().split(" ")})},N.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new re(ue,this.loose));for(var De=0;De<this.set.length;De++)if(te(this.set[De],ue))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ue,De,we){var $e=null,He=null;try{var et=new N(De,we)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==-1||(He=new re($e=Xe,we)))}),$e},e.minSatisfying=function(ue,De,we){var $e=null,He=null;try{var et=new N(De,we)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==1||(He=new re($e=Xe,we)))}),$e},e.validRange=function(ue,De){try{return new N(ue,De).range||"*"}catch{return null}},e.ltr=function(ue,De,we){return ke(ue,De,"<",we)},e.gtr=function(ue,De,we){return ke(ue,De,">",we)},e.outside=ke,e.prerelease=function(ue,De){var we=le(ue,De);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(ue,De,we){return ue=new N(ue,we),De=new N(De,we),ue.intersects(De)},e.coerce=function(ue){if(ue instanceof re)return ue;if(typeof ue!="string")return null;var De=ue.match(A[y]);return De==null?null:le((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,n(1))},function(ee,e){var n,T,k=ee.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(t){if(n===setTimeout)return setTimeout(t,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var w,h=[],O=!1,S=-1;function f(){O&&w&&(O=!1,w.length?h=w.concat(h):S=-1,h.length&&E())}function E(){if(!O){var t=A(f);O=!0;for(var a=h.length;a;){for(w=h,h=[];++S<a;)w&&w[S].run();S=-1,a=h.length}w=null,O=!1,function(m){if(T===clearTimeout)return clearTimeout(m);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(m);try{T(m)}catch{try{return T.call(null,m)}catch{return T.call(this,m)}}}(t)}}function g(t,a){this.fun=t,this.array=a}function d(){}k.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)a[m-1]=arguments[m];h.push(new g(t,a)),h.length!==1||O||A(E)},g.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=d,k.addListener=d,k.once=d,k.off=d,k.removeListener=d,k.removeAllListeners=d,k.emit=d,k.prependListener=d,k.prependOnceListener=d,k.listeners=function(t){return[]},k.binding=function(t){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(t){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Ae[116],Re([1,0,14,6]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(P){const p=P;return p?typeof p.read=="function":!1}e.isReadable=k;function M(P){const p=P;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function R(P){const p=P;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=R;function A(P,p){return new w(P,p)}e.newWriteableStream=A;class w{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,n.onUnexpectedError)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let l;switch(p){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const s=l.indexOf(i);s>=0&&l.splice(s,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(P,p){const i=[];let l;for(;(l=P.read())!==null;)i.push(l);return p(i)}e.consumeReadable=h;function O(P,p,i){const l=[];let s;for(;(s=P.read())!==null&&l.length<i;)l.push(s);return s===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const c=s;return s=void 0,c}return P.read()}}}e.peekReadable=O;function S(P,p){return new Promise((i,l)=>{const s=[];f(P,{onData:c=>{p&&s.push(c)},onError:c=>{p?l(c):i(void 0)},onEnd:()=>{i(p?p(s):void 0)}})})}e.consumeStream=S;function f(P,p){let i=!1;return P.on("error",l=>{i||p.onError(l)}),P.on("end",()=>{i||p.onEnd()}),P.on("data",l=>{i||p.onData(l)}),(0,T.toDisposable)(()=>i=!0)}e.listenStream=f;function E(P,p){return new Promise((i,l)=>{const s=new T.DisposableStore,c=[],o=u=>{if(c.push(u),c.length>p)return s.dispose(),P.pause(),i({stream:P,buffer:c,ended:!1})},I=u=>l(u),r=()=>i({stream:P,buffer:c,ended:!0});s.add((0,T.toDisposable)(()=>P.removeListener("error",I))),P.on("error",I),s.add((0,T.toDisposable)(()=>P.removeListener("end",r))),P.on("end",r),s.add((0,T.toDisposable)(()=>P.removeListener("data",o))),P.on("data",o)})}e.peekStream=E;function g(P,p){const i=A(p);return i.end(P),i}e.toStream=g;function d(){const P=A(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=d;function t(P){let p=!1;return{read:()=>p?null:(p=!0,P)}}e.toReadable=t;function a(P,p,i){const l=A(i);return f(P,{onData:s=>l.write(p.data(s)),onError:s=>l.error(p.error?p.error(s):s),onEnd:()=>l.end()}),l}e.transform=a;function m(P,p,i){let l=!1;return{read:()=>{const s=p.read();return l?s:(l=!0,s!==null?i([P,s]):P)}}}e.prefixedReadable=m;function b(P,p,i){let l=!1;const s=A(i);return f(p,{onData:c=>l?s.write(c):(l=!0,s.write(i([P,c]))),onError:c=>s.error(c),onEnd:()=>{l||(l=!0,s.write(P)),s.end()}}),s}e.prefixedStream=b}),define(Ae[25],Re([1,0,116]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let k,M;class R{static alloc(u){return T?new R(Buffer.allocUnsafe(u)):new R(new Uint8Array(u))}static wrap(u){return T&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new R(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&T?new R(Buffer.from(u)):(k||(k=new TextEncoder),new R(k.encode(u)))}static fromByteArray(u){const v=R.alloc(u.length);for(let D=0,y=u.length;D<y;D++)v.buffer[D]=u[D];return v}static concat(u,v){if(typeof v>"u"){v=0;for(let W=0,X=u.length;W<X;W++)v+=u[W].byteLength}const D=R.alloc(v);let y=0;for(let W=0,X=u.length;W<X;W++){const _=u[W];D.set(_,y),y+=_.byteLength}return D}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=R.alloc(this.byteLength);return u.set(this),u}toString(){return T?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(u,v){return new R(this.buffer.subarray(u,v))}set(u,v){if(u instanceof R)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return h(this.buffer,u)}writeUInt32BE(u,v){O(this.buffer,u,v)}readUInt32LE(u){return S(this.buffer,u)}writeUInt32LE(u,v){f(this.buffer,u,v)}readUInt8(u){return E(this.buffer,u)}writeUInt8(u,v){g(this.buffer,u,v)}}e.VSBuffer=R;function A(r,u){return r[u+0]<<0>>>0|r[u+1]<<8>>>0}e.readUInt16LE=A;function w(r,u,v){r[v+0]=u&255,u=u>>>8,r[v+1]=u&255}e.writeUInt16LE=w;function h(r,u){return r[u]*2**24+r[u+1]*2**16+r[u+2]*2**8+r[u+3]}e.readUInt32BE=h;function O(r,u,v){r[v+3]=u,u=u>>>8,r[v+2]=u,u=u>>>8,r[v+1]=u,u=u>>>8,r[v]=u}e.writeUInt32BE=O;function S(r,u){return r[u+0]<<0>>>0|r[u+1]<<8>>>0|r[u+2]<<16>>>0|r[u+3]<<24>>>0}e.readUInt32LE=S;function f(r,u,v){r[v+0]=u&255,u=u>>>8,r[v+1]=u&255,u=u>>>8,r[v+2]=u&255,u=u>>>8,r[v+3]=u&255}e.writeUInt32LE=f;function E(r,u){return r[u]}e.readUInt8=E;function g(r,u,v){r[v]=u}e.writeUInt8=g;function d(r){return n.consumeReadable(r,u=>R.concat(u))}e.readableToBuffer=d;function t(r){return n.toReadable(r)}e.bufferToReadable=t;function a(r){return n.consumeStream(r,u=>R.concat(u))}e.streamToBuffer=a;async function m(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await a(r.stream)])}e.bufferedStreamToBuffer=m;function b(r){return n.toStream(r,u=>R.concat(u))}e.bufferToStream=b;function P(r){return n.transform(r,{data:u=>typeof u=="string"?R.fromString(u):R.wrap(u)},u=>R.concat(u))}e.streamToBufferReadableStream=P;function p(r){return n.newWriteableStream(u=>R.concat(u),r)}e.newWriteableBufferStream=p;function i(r,u){return n.prefixedReadable(r,u,v=>R.concat(v))}e.prefixedBufferReadable=i;function l(r,u){return n.prefixedStream(r,u,v=>R.concat(v))}e.prefixedBufferStream=l;function s(r){let u=0,v=0,D=0;const y=new Uint8Array(Math.floor(r.length/4*3)),W=_=>{switch(v){case 3:y[D++]=u|_,v=0;break;case 2:y[D++]=u|_>>>2,u=_<<6,v=3;break;case 1:y[D++]=u|_>>>4,u=_<<4,v=2;break;default:u=_<<2,v=1}};for(let _=0;_<r.length;_++){const J=r.charCodeAt(_);if(J>=65&&J<=90)W(J-65);else if(J>=97&&J<=122)W(J-97+26);else if(J>=48&&J<=57)W(J-48+52);else if(J===43||J===45)W(62);else if(J===47||J===95)W(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${r[_]}`)}}const X=D;for(;v>0;)W(0);return R.wrap(y).slice(0,X)}e.decodeBase64=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:r},u=!0,v=!1){const D=v?o:c;let y="";const W=r.byteLength%3;let X=0;for(;X<r.byteLength-W;X+=3){const _=r[X+0],J=r[X+1],j=r[X+2];y+=D[_>>>2],y+=D[(_<<4|J>>>4)&63],y+=D[(J<<2|j>>>6)&63],y+=D[j&63]}if(W===1){const _=r[X+0];y+=D[_>>>2],y+=D[_<<4&63],u&&(y+="==")}else if(W===2){const _=r[X+0],J=r[X+1];y+=D[_>>>2],y+=D[(_<<4|J>>>4)&63],y+=D[J<<2&63],u&&(y+="=")}return y}e.encodeBase64=I}),define(Ae[117],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[39],Re([1,0,85]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(R){function A(w){return w&&typeof w=="object"&&typeof w.id=="string"}R.isThemeColor=A})(T=e.ThemeColor||(e.ThemeColor={}));function k(R){return{id:R}}e.themeColorFromId=k;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function w(m){const b=A.exec(m.id);if(!b)return w(n.Codicon.error);const[,P,p]=b,i=["codicon","codicon-"+P];return p&&i.push("codicon-modifier-"+p.substring(1)),i}R.asClassNameArray=w;function h(m){return w(m).join(" ")}R.asClassName=h;function O(m){return"."+w(m).join(".")}R.asCSSSelector=O;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||T.isThemeColor(m.color))}R.isThemeIcon=S;const f=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(m){const b=f.exec(m);if(!b)return;const[,P]=b;return{id:P}}R.fromString=E;function g(m){return{id:m}}R.fromId=g;function d(m,b){let P=m.id;const p=P.lastIndexOf("~");return p!==-1&&(P=P.substring(0,p)),b&&(P=`${P}~${b}`),{id:P}}R.modify=d;function t(m){const b=m.id.lastIndexOf("~");if(b!==-1)return m.id.substring(b+1)}R.getModifier=t;function a(m,b){return m.id===b.id&&m.color?.id===b.color?.id}R.isEqual=a})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ae[35],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(k){return n.test(k)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(A){for(let w=0;w<A.length;w++)A[w]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){k(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,h="";return h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h}}()}),define(Ae[118],Re([1,0,16,35]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(A){return{id:(0,T.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=k;function M(A,w,h){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:w,data:h}),value:void 0}}e.createFileDataTransferItem=M;class R{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,h){const O=this.a.get(w);O?O.push(h):this.a.set(this.b(w),[h])}replace(w,h){this.a.set(this.b(w),[h])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,h]of this.a.entries())for(const O of h)yield[w,O]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[h,O]of this.entries())w(O,h)}b(w){return w.toLowerCase()}}e.VSDataTransfer=R,e.UriList=Object.freeze({create:A=>(0,n.distinct)(A.map(w=>w.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(w=>!w.startsWith("#"))})}),define(Ae[119],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[120],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class T{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let w=0,h=A.notIn.length;w<h;w++)switch(A.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,w){if(A.getTokenCount()===0)return!0;const h=A.findTokenIndexAtOffset(w-2),O=A.getStandardTokenType(h);return this.isOK(O)}g(A,w){for(let h=A;h<=w;h++){const O=String.fromCharCode(h);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class k{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of A)M(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),M(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),M(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),M(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&M(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=k;function M(R,A,w){R.has(A)?R.get(A).push(w):R.set(A,[w])}}),define(Ae[121],Re([10,11]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ae[122],Re([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ae[123],Re([1,0,122]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,k=T*60,M=k*24,R=M*7,A=M*30,w=M*365;function h(S,f,E,g){typeof S!="number"&&(S=S.getTime());const d=Math.round((new Date().getTime()-S)/1e3);if(d<-30)return(0,n.localize)(0,null,h(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,n.localize)(1,null);let t;return d<T?(t=d,f?t===1?E?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):E?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?E?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):E?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):d<k?(t=Math.floor(d/T),f?t===1?E?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):E?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?E?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):E?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):d<M?(t=Math.floor(d/k),f?t===1?E?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):E?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?E?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):E?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):d<R?(t=Math.floor(d/M),f?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):d<A?(t=Math.floor(d/R),f?t===1?E?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):E?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?E?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):E?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):d<w?(t=Math.floor(d/A),f?t===1?E?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):E?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?E?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):E?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(d/w),f?t===1?E?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):E?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?E?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):E?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=h;function O(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ae[124],Re([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ae[40],Re([1,0,16,9,124]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,f){return f&&(S.stack||S.stacktrace)?k.localize(0,null,A(S),R(S.stack)||R(S.stacktrace)):A(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function A(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?k.localize(1,null,S.message):S.message||k.localize(2,null)}function w(S=null,f=!1){if(!S)return k.localize(3,null);if(Array.isArray(S)){const E=n.coalesce(S),g=w(E[0],f);return E.length>1?k.localize(4,null,g,E.length):g}if(T.isString(S))return S;if(S.detail){const E=S.detail;if(E.error)return M(E.error,f);if(E.exception)return M(E.exception,f)}return S.stack?M(S,f):S.message?S.message:k.localize(5,null)}e.toErrorMessage=w;function h(S){const f=S;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=h;function O(S,f){let E;return typeof S=="string"?E=new Error(S):E=S,E.actions=f,E}e.createErrorWithActions=O}),define(Ae[125],Re([1,0,86,19]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new n.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,v,D=!1){const y=u||"",W=v||"",X=k.value.collator.compare(y,W);return k.value.collatorIsNumeric&&X===0&&y!==W?y<W?-1:1:X}e.compareFileNames=A;function w(u,v){const D=M.value.collator;return u=u||"",v=v||"",P(D,u,v)}e.compareFileNamesDefault=w;function h(u,v){const D=M.value.collator;return u=u||"",v=v||"",s(u,v)||P(D,u,v)}e.compareFileNamesUpper=h;function O(u,v){const D=M.value.collator;return u=u||"",v=v||"",l(u,v)||P(D,u,v)}e.compareFileNamesLower=O;function S(u,v){return u=u||"",v=v||"",u===v?0:u<v?-1:1}e.compareFileNamesUnicode=S;function f(u,v){const[D,y]=m(u),[W,X]=m(v);let _=k.value.collator.compare(y,X);if(_===0){if(k.value.collatorIsNumeric&&y!==X)return y<X?-1:1;if(_=k.value.collator.compare(D,W),k.value.collatorIsNumeric&&_===0&&D!==W)return D<W?-1:1}return _}e.compareFileExtensions=f;function E(u,v){u=u||"",v=v||"";const D=b(u),y=b(v),W=M.value.collator,X=R.value.collator;return P(X,D,y)||P(W,u,v)}e.compareFileExtensionsDefault=E;function g(u,v){u=u||"",v=v||"";const D=b(u),y=b(v),W=M.value.collator,X=R.value.collator;return P(X,D,y)||s(u,v)||P(W,u,v)}e.compareFileExtensionsUpper=g;function d(u,v){u=u||"",v=v||"";const D=b(u),y=b(v),W=M.value.collator,X=R.value.collator;return P(X,D,y)||l(u,v)||P(W,u,v)}e.compareFileExtensionsLower=d;function t(u,v){u=u||"",v=v||"";const D=b(u).toLowerCase(),y=b(v).toLowerCase();return D!==y?D<y?-1:1:u!==v?u<v?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function m(u,v=!1){const D=u?a.exec(u):[];let y=[D&&D[1]||"",D&&D[3]||""];return v&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function b(u){const v=u?a.exec(u):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function P(u,v,D){const y=u.compare(v,D);return y!==0?y:v.length!==D.length?v.length<D.length?-1:1:0}function p(u){const v=u.charAt(0);return v.toLocaleUpperCase()!==v}function i(u){const v=u.charAt(0);return v.toLocaleLowerCase()!==v}function l(u,v){return p(u)&&i(v)?-1:i(u)&&p(v)?1:0}function s(u,v){return i(u)&&p(v)?-1:p(u)&&i(v)?1:0}function c(u,v,D=!1){return D||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase()),u===v?0:u<v?-1:1}function o(u,v,D=!1){const y=u.split(T.sep),W=v.split(T.sep),X=y.length-1,_=W.length-1;let J,j;for(let U=0;;U++){if(J=X===U,j=_===U,J&&j)return A(y[U],W[U],D);if(J)return-1;if(j)return 1;const $=c(y[U],W[U],D);if($!==0)return $}}e.comparePaths=o;function I(u,v,D){const y=u.toLowerCase(),W=v.toLowerCase(),X=r(u,v,D);if(X)return X;const _=y.endsWith(D),J=W.endsWith(D);if(_!==J)return _?-1:1;const j=A(y,W);return j!==0?j:y.localeCompare(W)}e.compareAnything=I;function r(u,v,D){const y=u.toLowerCase(),W=v.toLowerCase(),X=y.startsWith(D),_=W.startsWith(D);if(X!==_)return X?-1:1;if(X&&_){if(y.length<W.length)return-1;if(y.length>W.length)return 1}return 0}e.compareByPrefix=r}),define(Ae[65],Re([1,0,19]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const S=(0,n.extname)(O),f=T[S.toLowerCase()];return f!==void 0?f:R(O)}e.getMediaOrTextMime=M;function R(O){const S=(0,n.extname)(O);return k[S.toLowerCase()]}e.getMediaMime=R;function A(O){for(const S in k)if(k[S]===O)return S}e.getExtensionForMimeType=A;const w=/^(.+)\/(.+?)(;.+)?$/;function h(O,S){const f=w.exec(O);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:S?void 0:O}e.normalizeMimeType=h}),define(Ae[126],Re([1,0,5,6,121]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends T.Disposable{constructor(f,E="",g="",d=!0,t){super(),this.h=this.D(new n.Emitter),this.onDidChange=this.h.event,this.u=!0,this.j=f,this.m=E,this.q=g,this.u=d,this.z=t}get id(){return this.j}get label(){return this.m}set label(f){this.C(f)}C(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.q}set class(f){this.G(f)}G(f){this.q!==f&&(this.q=f,this.h.fire({class:f}))}get enabled(){return this.u}set enabled(f){this.H(f)}H(f){this.u!==f&&(this.u=f,this.h.fire({enabled:f}))}get checked(){return this.w}set checked(f){this.I(f)}I(f){this.w!==f&&(this.w=f,this.h.fire({checked:f}))}async run(f,E){this.z&&await this.z(f)}}e.Action=M;class R extends T.Disposable{constructor(){super(...arguments),this.f=this.D(new n.Emitter),this.onWillRun=this.f.event,this.h=this.D(new n.Emitter),this.onDidRun=this.h.event}async run(f,E){if(!f.enabled)return;this.f.fire({action:f});let g;try{await this.k(f,E)}catch(d){g=d}this.h.fire({action:f,error:g})}async k(f,E){await f.run(E)}}e.ActionRunner=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let E=[];for(const g of f)g.length&&(E.length?E=[...E,new A,...g]:E=g);return E}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class w{get actions(){return this.a}constructor(f,E,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=E,this.class=d,this.a=g}async run(){}}e.SubmenuAction=w;class h extends M{constructor(){super(h.ID,k.localize(0,null),void 0,!1)}}h.ID="vs.actions.empty",e.EmptySubmenuAction=h;function O(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.toAction=O}),define(Ae[41],Re([1,0,19,20,12,9]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(o){return o===47||o===92}e.isPathSeparator=R;function A(o){return o.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function w(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function h(o,I=n.posix.sep){if(!o)return"";const r=o.length,u=o.charCodeAt(0);if(R(u)){if(R(o.charCodeAt(1))&&!R(o.charCodeAt(2))){let D=3;const y=D;for(;D<r&&!R(o.charCodeAt(D));D++);if(y!==D&&!R(o.charCodeAt(D+1))){for(D+=1;D<r;D++)if(R(o.charCodeAt(D)))return o.slice(0,D+1).replace(/[\\/]/g,I)}}return I}else if(a(u)&&o.charCodeAt(1)===58)return R(o.charCodeAt(2))?o.slice(0,2)+I:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<r;v++)if(R(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=h;function O(o){if(!T.isWindows||!o||o.length<5)return!1;let I=o.charCodeAt(0);if(I!==92||(I=o.charCodeAt(1),I!==92))return!1;let r=2;const u=r;for(;r<o.length&&(I=o.charCodeAt(r),I!==92);r++);return!(u===r||(I=o.charCodeAt(r+1),isNaN(I)||I===92))}e.isUNC=O;const S=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(o,I=T.isWindows){const r=I?S:f;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||I&&E.test(o)||o==="."||o===".."||I&&o[o.length-1]==="."||I&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=g;function d(o,I,r){const u=o===I;return!r||u?u:!o||!I?!1:(0,k.equalsIgnoreCase)(o,I)}e.isEqual=d;function t(o,I,r,u=n.sep){if(o===I)return!0;if(!o||!I||I.length>o.length)return!1;if(r){if(!(0,k.startsWithIgnoreCase)(o,I))return!1;if(I.length===o.length)return!0;let D=I.length;return I.charAt(I.length-1)===u&&D--,o.charAt(D)===u}return I.charAt(I.length-1)!==u&&(I+=u),o.indexOf(I)===0}e.isEqualOrParent=t;function a(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=a;function m(o,I){return T.isWindows&&o.endsWith(":")&&(o+=n.sep),(0,n.isAbsolute)(o)||(o=(0,n.join)(I,o)),o=(0,n.normalize)(o),T.isWindows?(o=(0,k.rtrim)(o,n.sep),o.endsWith(":")&&(o+=n.sep)):(o=(0,k.rtrim)(o,n.sep),o||(o=n.sep)),o}e.sanitizeFilePath=m;function b(o){const I=(0,n.normalize)(o);return T.isWindows?o.length>3?!1:P(I)&&(o.length===2||I.charCodeAt(2)===92):I===n.posix.sep}e.isRootOrDriveLetter=b;function P(o,I=T.isWindows){return I?a(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function p(o){return P(o)?o[0]:void 0}e.getDriveLetter=p;function i(o,I,r){return I.length>o.length?-1:o===I?0:(r&&(o=o.toLowerCase(),I=I.toLowerCase()),o.indexOf(I))}e.indexOfPath=i;function l(o){const I=o.split(":");let r,u,v;for(const D of I){const y=Number(D);(0,M.isNumber)(y)?u===void 0?u=y:v===void 0&&(v=y):r=r?[r,D].join(":"):D}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(o,I,r=8){let u="";for(let D=0;D<r;D++)u+=s.charAt(Math.floor(Math.random()*s.length));let v;return I?v=`${I}-${u}`:v=u,o?(0,n.join)(o,v):v}e.randomPath=c}),define(Ae[127],Re([1,0,28,12]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(C,N){for(let H=0,x=Z.length;H<x;H++){const te=Z[H](C,N);if(te)return te}return null}}e.or=k,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,C,N){if(!N||N.length<C.length)return null;let H;return Z?H=T.startsWithIgnoreCase(N,C):H=N.indexOf(C)===0,H?C.length>0?[{start:0,end:C.length}]:[]:null}function R(Z,C){const N=C.toLowerCase().indexOf(Z.toLowerCase());return N===-1?null:[{start:N,end:N+Z.length}]}e.matchesContiguousSubString=R;function A(Z,C){return w(Z.toLowerCase(),C.toLowerCase(),0,0)}e.matchesSubString=A;function w(Z,C,N,H){if(N===Z.length)return[];if(H===C.length)return null;if(Z[N]===C[H]){let x=null;return(x=w(Z,C,N+1,H+1))?a({start:H,end:H+1},x):null}return w(Z,C,N,H+1)}function h(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function S(Z){return 48<=Z&&Z<=57}function f(Z){return Z===32||Z===9||Z===10||Z===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>E.add(Z.charCodeAt(0)));function g(Z){return f(Z)||E.has(Z)}function d(Z,C){return Z===C||g(Z)&&g(C)}function t(Z){return h(Z)||O(Z)||S(Z)}function a(Z,C){return C.length===0?C=[Z]:Z.end===C[0].start?C[0].start=Z.start:C.unshift(Z),C}function m(Z,C){for(let N=C;N<Z.length;N++){const H=Z.charCodeAt(N);if(O(H)||S(H)||N>0&&!t(Z.charCodeAt(N-1)))return N}return Z.length}function b(Z,C,N,H){if(N===Z.length)return[];if(H===C.length)return null;if(Z[N]!==C[H].toLowerCase())return null;{let x=null,te=H+1;for(x=b(Z,C,N+1,H+1);!x&&(te=m(C,te))<C.length;)x=b(Z,C,N+1,te),te++;return x===null?null:a({start:H,end:H+1},x)}}function P(Z){let C=0,N=0,H=0,x=0,te=0;for(let we=0;we<Z.length;we++)te=Z.charCodeAt(we),O(te)&&C++,h(te)&&N++,t(te)&&H++,S(te)&&x++;const pe=C/Z.length,ke=N/Z.length,ue=H/Z.length,De=x/Z.length;return{upperPercent:pe,lowerPercent:ke,alphaPercent:ue,numericPercent:De}}function p(Z){const{upperPercent:C,lowerPercent:N}=Z;return N===0&&C>.6}function i(Z){const{upperPercent:C,lowerPercent:N,alphaPercent:H,numericPercent:x}=Z;return N>.2&&C<.8&&H>.6&&x<.2}function l(Z){let C=0,N=0,H=0,x=0;for(let te=0;te<Z.length;te++)H=Z.charCodeAt(te),O(H)&&C++,h(H)&&N++,f(H)&&x++;return(C===0||N===0)&&x===0?Z.length<=30:C<=5}function s(Z,C){if(!C||(C=C.trim(),C.length===0)||!l(Z)||C.length>60)return null;const N=P(C);if(!i(N)){if(!p(N))return null;C=C.toLowerCase()}let H=null,x=0;for(Z=Z.toLowerCase();x<C.length&&(H=b(Z,C,0,x))===null;)x=m(C,x+1);return H}e.matchesCamelCase=s;function c(Z,C,N=!1){if(!C||C.length===0)return null;let H=null,x=0;for(Z=Z.toLowerCase(),C=C.toLowerCase();x<C.length&&(H=o(Z,C,0,x,N))===null;)x=I(C,x+1);return H}e.matchesWords=c;function o(Z,C,N,H,x){if(N===Z.length)return[];if(H===C.length)return null;if(d(Z.charCodeAt(N),C.charCodeAt(H))){let te=null,pe=H+1;if(te=o(Z,C,N+1,H+1,x),!x)for(;!te&&(pe=I(C,pe))<C.length;)te=o(Z,C,N+1,pe,x),pe++;return te?Z.charCodeAt(N)!==C.charCodeAt(H)?te:a({start:H,end:H+1},te):null}else return null}function I(Z,C){for(let N=C;N<Z.length;N++)if(g(Z.charCodeAt(N))||N>0&&g(Z.charCodeAt(N-1)))return N;return Z.length}const r=k(e.matchesPrefix,s,R),u=k(e.matchesPrefix,s,A),v=new n.LRUCache(1e4);function D(Z,C,N=!1){if(typeof Z!="string"||typeof C!="string")return null;let H=v.get(Z);H||(H=new RegExp(T.convertSimple2RegExpPattern(Z),"i"),v.set(Z,H));const x=H.exec(C);return x?[{start:x.index,end:x.index+x[0].length}]:N?u(Z,C):r(Z,C)}e.matchesFuzzy=D;function y(Z,C){const N=me(Z,Z.toLowerCase(),0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?X(N):null}e.matchesFuzzy2=y;function W(Z,C,N,H,x,te){const pe=Math.min(13,Z.length);for(;N<pe;N++){const ke=me(Z,C,N,H,x,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,te]}e.anyScore=W;function X(Z){if(typeof Z>"u")return[];const C=[],N=Z[1];for(let H=Z.length-1;H>1;H--){const x=Z[H]+N,te=C[C.length-1];te&&te.end===x?te.end=x+1:C.push({start:x,end:x+1})}return C}e.createMatches=X;const _=128;function J(){const Z=[],C=[];for(let N=0;N<=_;N++)C[N]=0;for(let N=0;N<=_;N++)Z.push(C.slice(0));return Z}function j(Z){const C=[];for(let N=0;N<=Z;N++)C[N]=0;return C}const U=j(2*_),$=j(2*_),B=J(),q=J(),he=J(),Ee=!1;function ie(Z,C,N,H,x){function te(ke,ue,De=" "){for(;ke.length<ue;)ke=De+ke;return ke}let pe=` |   |${H.split("").map(ke=>te(ke,3)).join("|")}
`;for(let ke=0;ke<=N;ke++)ke===0?pe+=" |":pe+=`${C[ke-1]}|`,pe+=Z[ke].slice(0,x+1).map(ue=>te(ue.toString(),3)).join("|")+`
`;return pe}function ce(Z,C,N,H){Z=Z.substr(C),N=N.substr(H),console.log(ie(q,Z,Z.length,N,N.length)),console.log(ie(he,Z,Z.length,N,N.length)),console.log(ie(B,Z,Z.length,N,N.length))}function de(Z,C){if(C<0||C>=Z.length)return!1;const N=Z.codePointAt(C);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(N)}}function Te(Z,C){if(C<0||C>=Z.length)return!1;switch(Z.charCodeAt(C)){case 32:case 9:return!0;default:return!1}}function le(Z,C,N){return C[Z]!==N[Z]}function re(Z,C,N,H,x,te,pe=!1){for(;C<N&&x<te;)Z[C]===H[x]&&(pe&&(U[C]=x),C+=1),x+=1;return C===N}e.isPatternInWord=re;var V;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(V||(V={}));var L;(function(Z){Z.Default=[-100,0];function C(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}Z.isDefault=C})(L=e.FuzzyScore||(e.FuzzyScore={}));class K{constructor(C,N){this.firstMatchCanBeWeak=C,this.boostFullMatch=N}}K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=K;function me(Z,C,N,H,x,te,pe=K.default){const ke=Z.length>_?_:Z.length,ue=H.length>_?_:H.length;if(N>=ke||te>=ue||ke-N>ue-te||!re(C,N,ke,x,te,ue,!0))return;Ie(ke,ue,N,te,C,x);let De=1,we=1,$e=N,He=te;const et=[!1];for(De=1,$e=N;$e<ke;De++,$e++){const it=U[$e],Q=$[$e],Y=$e+1<ke?$[$e+1]:ue;for(we=it-te+1,He=it;He<Y;we++,He++){let be=Number.MIN_SAFE_INTEGER,We=!1;He<=Q&&(be=Se(Z,C,$e,N,H,x,He,ue,te,B[De-1][we-1]===0,et));let ze=0;be!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=be+q[De-1][we-1]);const Qe=He>it,Ye=Qe?q[De][we-1]+(B[De][we-1]>0?-5:0):0,Ge=He>it+1&&B[De][we-1]>0,at=Ge?q[De][we-2]+(B[De][we-2]>0?-5:0):0;if(Ge&&(!Qe||at>=Ye)&&(!We||at>=ze))q[De][we]=at,he[De][we]=3,B[De][we]=0;else if(Qe&&(!We||Ye>=ze))q[De][we]=Ye,he[De][we]=2,B[De][we]=0;else if(We)q[De][we]=ze,he[De][we]=1,B[De][we]=B[De-1][we-1]+1;else throw new Error("not possible")}}if(Ee&&ce(Z,N,H,te),!et[0]&&!pe.firstMatchCanBeWeak)return;De--,we--;const Xe=[q[De][we],te];let tt=0,rt=0;for(;De>=1;){let it=we;do{const Q=he[De][it];if(Q===3)it=it-2;else if(Q===2)it=it-1;else break}while(it>=1);tt>1&&C[N+De-1]===x[te+we-1]&&!le(it+te-1,H,x)&&tt+1>B[De][it]&&(it=we),it===we?tt++:tt=1,rt||(rt=it),De--,we=it-1,Xe.push(we)}ue===ke&&pe.boostFullMatch&&(Xe[0]+=2);const Me=rt-ke;return Xe[0]-=Me,Xe}e.fuzzyScore=me;function Ie(Z,C,N,H,x,te){let pe=Z-1,ke=C-1;for(;pe>=N&&ke>=H;)x[pe]===te[ke]&&($[pe]=ke,pe--),ke--}function Se(Z,C,N,H,x,te,pe,ke,ue,De,we){if(C[N]!==te[pe])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return pe===N-H?$e=Z[N]===x[pe]?7:5:le(pe,x,te)&&(pe===0||!le(pe-1,x,te))?($e=Z[N]===x[pe]?7:5,He=!0):de(te,pe)&&(pe===0||!de(te,pe-1))?$e=5:(de(te,pe-1)||Te(te,pe-1))&&($e=5,He=!0),$e>1&&N===H&&(we[0]=!0),He||(He=le(pe,x,te)||de(te,pe-1)||Te(te,pe-1)),N===H?pe>ue&&($e-=He?3:5):De?$e+=He?2:0:$e+=He?0:1,pe+1===ke&&($e-=He?3:5),$e}function ve(Z,C,N,H,x,te,pe){return se(Z,C,N,H,x,te,!0,pe)}e.fuzzyScoreGracefulAggressive=ve;function Ce(Z,C,N,H,x,te,pe){return se(Z,C,N,H,x,te,!1,pe)}e.fuzzyScoreGraceful=Ce;function se(Z,C,N,H,x,te,pe,ke){let ue=me(Z,C,N,H,x,te,ke);if(ue&&!pe)return ue;if(Z.length>=3){const De=Math.min(7,Z.length-1);for(let we=N+1;we<De;we++){const $e=ae(Z,we);if($e){const He=me($e,$e.toLowerCase(),N,H,x,te,ke);He&&(He[0]-=3,(!ue||He[0]>ue[0])&&(ue=He))}}}return ue}function ae(Z,C){if(C+1>=Z.length)return;const N=Z[C],H=Z[C+1];if(N!==H)return Z.slice(0,C)+H+N+Z.slice(C+2)}}),define(Ae[128],Re([1,0,127,12,39]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",R=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function w(a){return a.replace(A,(m,b)=>b?m:`\\${m}`)}e.escapeIcons=w;const h=new RegExp(`\\\\${R.source}`,"g");function O(a){return a.replace(h,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=O;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function f(a){return a.indexOf(M)===-1?a:a.replace(S,(m,b,P,p)=>P?m:b||p||"")}e.stripIcons=f;function E(a){return a?a.replace(/\$\((.*?)\)/g,(m,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;const g=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){g.lastIndex=0;let m="";const b=[];let P=0;for(;;){const p=g.lastIndex,i=g.exec(a),l=a.substring(p,i?.index);if(l.length>0){m+=l;for(let s=0;s<l.length;s++)b.push(P)}if(!i)break;P+=i[0].length}return{text:m,iconOffsets:b}}e.parseLabelWithIcons=d;function t(a,m,b=!1){const{text:P,iconOffsets:p}=m;if(!p||p.length===0)return(0,n.matchesFuzzy)(a,P,b);const i=(0,T.ltrim)(P," "),l=P.length-i.length,s=(0,n.matchesFuzzy)(a,i,b);if(s)for(const c of s){const o=p[c.start+l]+l;c.start+=o,c.end+=o}return s}e.matchesFuzzyIconAware=t}),define(Ae[29],Re([1,0,12]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(T||(T={})),function(k){const M="error",R="warning",A="warn",w="info",h="ignore";function O(f){return f?n.equalsIgnoreCase(M,f)?k.Error:n.equalsIgnoreCase(R,f)||n.equalsIgnoreCase(A,f)?k.Warning:n.equalsIgnoreCase(w,f)?k.Info:k.Ignore:k.Ignore}k.fromValue=O;function S(f){switch(f){case k.Error:return M;case k.Warning:return R;case k.Info:return w;default:return h}}k.toString=S}(T||(T={})),e.default=T}),define(Ae[48],Re([1,0,16,12]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const g=E.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.StringIterator=k;class M{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,T.compareSubstring)(E,this.b,0,E.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class R{constructor(E=!0,g=!0){this.f=E,this.g=g}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let g=E.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,T.compareSubstring)(E,this.b,0,E.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var A;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(E,g){this.f=E,this.g=g,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(E,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,T.compare)(E,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(O||(O={}));class S{static forUris(E=()=>!1,g=()=>!1){return new S(new w(E,g))}static forPaths(E=!1){return new S(new R(void 0,!E))}static forStrings(){return new S(new k)}static forConfigKeys(){return new S(new M)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,g){if(g){const d=g.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t,E)}else{const d=E.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(E,g){const d=this.b.reset(E);let t;this.c||(this.c=new h,this.c.segment=d.value());const a=[];for(t=this.c;;){const b=d.cmp(t.segment);if(b>0)t.left||(t.left=new h,t.left.segment=d.value()),a.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new h,t.right.segment=d.value()),a.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new h,t.mid.segment=d.value()),a.push([0,t]),t=t.mid;else break}const m=t.value;t.value=g,t.key=E;for(let b=a.length-1;b>=0;b--){const P=a[b][1];P.updateHeight();const p=P.balanceFactor();if(p<-1||p>1){const i=a[b][0],l=a[b+1][0];if(i===1&&l===1)a[b][1]=P.rotateLeft();else if(i===-1&&l===-1)a[b][1]=P.rotateRight();else if(i===1&&l===-1)P.right=a[b+1][1]=a[b+1][1].rotateRight(),a[b][1]=P.rotateLeft();else if(i===-1&&l===1)P.left=a[b+1][1]=a[b+1][1].rotateLeft(),a[b][1]=P.rotateRight();else throw new Error;if(b>0)switch(a[b-1][0]){case-1:a[b-1][1].left=a[b][1];break;case 1:a[b-1][1].right=a[b][1];break;case 0:a[b-1][1].mid=a[b][1];break}else this.c=a[0][1]}}return m}get(E){return this.d(E)?.value}d(E){const g=this.b.reset(E);let d=this.c;for(;d;){const t=g.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(E){const g=this.d(E);return!(g?.value===void 0&&g?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,g){const d=this.b.reset(E),t=[];let a=this.c;for(;a;){const m=d.cmp(a.segment);if(m>0)t.push([-1,a]),a=a.left;else if(m<0)t.push([1,a]),a=a.right;else if(d.hasNext())d.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(g?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const m=this.f(a.right);if(m.key){const{key:b,value:P,segment:p}=m;this.e(m.key,!1),a.key=b,a.value=P,a.segment=p}}else{const m=a.left??a.right;if(t.length>0){const[b,P]=t[t.length-1];switch(b){case-1:P.left=m;break;case 0:P.mid=m;break;case 1:P.right=m;break}}else this.c=m}for(let m=t.length-1;m>=0;m--){const b=t[m][1];b.updateHeight();const P=b.balanceFactor();if(P>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[m][1]=b.rotateLeft()):P<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[m][1]=b.rotateRight()),m>0)switch(t[m-1][0]){case-1:t[m-1][1].left=t[m][1];break;case 1:t[m-1][1].right=t[m][1];break;case 0:t[m-1][1].mid=t[m][1];break}else this.c=t[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const g=this.b.reset(E);let d=this.c,t;for(;d;){const a=g.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(g.hasNext())g.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(E){return this.g(E,!1)}g(E,g){const d=this.b.reset(E);let t=this.c;for(;t;){const a=d.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):g?t.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[g,d]of this)E(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const g=[];return this.j(E,g),g[Symbol.iterator]()}j(E,g){!E||(E.left&&this.j(E.left,g),E.value&&g.push([E.key,E.value]),E.mid&&this.j(E.mid,g),E.right&&this.j(E.right,g))}_isBalanced(){const E=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:E(g.left)&&E(g.right)};return E(this.c)}}e.TernarySearchTree=S}),define(Ae[66],Re([1,0,25,12,2]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(h){return JSON.stringify(h,A)}e.stringify=M;function R(h){let O=JSON.parse(h);return O=w(O),O}e.parse=R;function A(h,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,T.regExpFlags)(O)}:O}function w(h,O=0){if(!h||O>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return k.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let S=0;S<h.length;++S)h[S]=w(h[S],O+1);else for(const S in h)Object.hasOwnProperty.call(h,S)&&(h[S]=w(h[S],O+1))}return h}e.revive=w}),define(Ae[15],Re([1,0,14,20,2]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${M.vscodeRemoteResource}`}set(O,S,f){this.a[O]=S,this.b[O]=f}setConnectionToken(O,S){this.c[O]=S}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(t){return n.onUnexpectedError(t),O}const S=O.authority;let f=this.a[S];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const E=this.b[S],g=this.c[S];let d=`path=${encodeURIComponent(O.path)}`;return typeof g=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),k.URI.from({scheme:T.isWeb?this.d:M.vscodeRemoteResource,authority:`${f}:${E}`,path:this.f,query:d})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const S=this.b(O,ee);return this.uriToBrowserUri(S)}uriToBrowserUri(O){return O.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===M.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${M.vscodeFileResource}://${A.a}`)?O.with({scheme:M.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const S=this.b(O,ee);return this.uriToFileUri(S)}uriToFileUri(O){return O.scheme===M.vscodeFileResource?O.with({scheme:M.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,S){return k.URI.isUri(O)?O:k.URI.parse(S.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var w;(function(h){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(O.get("3"));const S="vscode-coi";function f(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:k.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const t=d?.get(S);if(!!t)return O.get(t)}h.getHeadersFromQuery=f;function E(g,d,t){if(!globalThis.crossOriginIsolated)return;const a=d&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(S,a):g[S]=a}h.addSearchParam=E})(w=e.COI||(e.COI={}))}),define(Ae[22],Re([1,0,41,15,19,20,12,2]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=w;class h{constructor(g){this.a=g}compare(g,d,t=!1){return g===d?0:(0,R.compare)(this.getComparisonKey(g,t),this.getComparisonKey(d,t))}isEqual(g,d,t=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,t)===this.getComparisonKey(d,t)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,t=!1){if(g.scheme===d.scheme){if(g.scheme===T.Schemas.file)return n.isEqualOrParent(w(g),w(d),this.a(g))&&g.query===d.query&&(t||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return n.isEqualOrParent(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(t||g.fragment===d.fragment)}return!1}joinPath(g,...d){return A.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return k.posix.basename(g.path)}extname(g){return k.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===T.Schemas.file?d=A.URI.file(k.dirname(w(g))).path:(d=k.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===T.Schemas.file?d=A.URI.file(k.normalize(w(g))).path:d=k.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===T.Schemas.file){const m=k.relative(w(g),w(d));return M.isWindows?n.toSlashes(m):m}let t=g.path||"/";const a=d.path||"/";if(this.a(g)){let m=0;for(const b=Math.min(t.length,a.length);m<b&&!(t.charCodeAt(m)!==a.charCodeAt(m)&&t.charAt(m).toLowerCase()!==a.charAt(m).toLowerCase());m++);t=a.substr(0,m)+t.substr(m)}return k.posix.relative(t,a)}resolvePath(g,d){if(g.scheme===T.Schemas.file){const t=A.URI.file(k.resolve(w(g),d));return g.with({authority:t.authority,path:t.path})}return d=n.toPosixPath(d),g.with({path:k.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,R.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=k.sep){if(g.scheme===T.Schemas.file){const t=w(g);return t.length>n.getRoot(t).length&&t[t.length-1]===d}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=k.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=k.sep){let t=!1;if(g.scheme===T.Schemas.file){const a=w(g);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===d}else{d="/";const a=g.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(E=>E.scheme===T.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new h(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(E,g){const d=[];for(let t=0;t<E.length;t++){const a=g(E[t]);E.some((m,b)=>b===t?!1:(0,e.isEqualOrParent)(a,g(m)))||d.push(E[t])}return d}e.distinctParents=O;var S;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function g(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(b=>{const[P,p]=b.split(":");P&&p&&t.set(P,p)});const m=d.path.substring(0,d.path.indexOf(";"));return m&&t.set(E.META_DATA_MIME,m),t}E.parseMetaData=g})(S=e.DataUri||(e.DataUri={}));function f(E,g,d){if(g){let t=E.path;return t&&t[0]!==k.posix.sep&&(t=k.posix.sep+t),E.with({scheme:d,authority:g,path:t})}return E.with({scheme:d})}e.toLocalResource=f}),define(Ae[17],Re([1,0,21,14,5,6,22,20,117]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(re){return!!re&&typeof re.then=="function"}e.isThenable=h;function O(re){const V=new n.CancellationTokenSource,L=re(V.token),K=new Promise((me,Ie)=>{const Se=V.token.onCancellationRequested(()=>{Se.dispose(),V.dispose(),Ie(new T.CancellationError)});Promise.resolve(L).then(ve=>{Se.dispose(),V.dispose(),me(ve)},ve=>{Se.dispose(),V.dispose(),Ie(ve)})});return new class{cancel(){V.cancel()}then(me,Ie){return K.then(me,Ie)}catch(me){return this.then(void 0,me)}finally(me){return K.finally(me)}}}e.createCancelablePromise=O;function S(re,V,L){return new Promise((K,me)=>{const Ie=V.onCancellationRequested(()=>{Ie.dispose(),K(L)});re.then(K,me).finally(()=>Ie.dispose())})}e.raceCancellation=S;function f(re,V){return new Promise((L,K)=>{const me=V.onCancellationRequested(()=>{me.dispose(),K(new T.CancellationError)});re.then(L,K).finally(()=>me.dispose())})}e.raceCancellationError=f;async function E(re){let V=-1;const L=re.map((me,Ie)=>me.then(Se=>(V=Ie,Se))),K=await Promise.race(L);return re.forEach((me,Ie)=>{Ie!==V&&me.cancel()}),K}e.raceCancellablePromises=E;function g(re,V,L){let K;const me=setTimeout(()=>{K?.(void 0),L?.()},V);return Promise.race([re.finally(()=>clearTimeout(me)),new Promise(Ie=>K=Ie)])}e.raceTimeout=g;function d(re){return new Promise((V,L)=>{const K=re();h(K)?K.then(V,L):V(K)})}e.asPromise=d;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(V){if(this.a){if(this.d=V,!this.b){const L=()=>{this.b=null;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(L,L).then(K)})}return new Promise((L,K)=>{this.b.then(L,K)})}return this.a=V(),new Promise((L,K)=>{this.a.then(me=>{this.a=null,L(me)},me=>{this.a=null,K(me)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.Sequencer=a;class m{constructor(){this.a=new Map}queue(V,L){const me=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.a.get(V)===me&&this.a.delete(V)});return this.a.set(V,me),me}}e.SequencerByKey=m;const b=(re,V)=>{let L=!0;const K=setTimeout(()=>{L=!1,V()},re);return{isTriggered:()=>L,dispose:()=>{clearTimeout(K),L=!1}}},P=re=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,re())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class p{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,L=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((me,Ie)=>{this.d=me,this.f=Ie}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=L===w.MicrotaskDelay?P(K):b(L,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(V){this.a=new p(V),this.b=new t}trigger(V,L){return this.a.trigger(()=>this.b.queue(V),L)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class l{constructor(){this.a=!1,this.b=new Promise((V,L)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=l;class s extends l{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function c(re,V){return V?new Promise((L,K)=>{const me=setTimeout(()=>{Ie.dispose(),L()},re),Ie=V.onCancellationRequested(()=>{clearTimeout(me),Ie.dispose(),K(new T.CancellationError)})}):O(L=>c(re,L))}e.timeout=c;function o(re,V=0){const L=setTimeout(re,V);return(0,M.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=o;function I(re){const V=[];let L=0;const K=re.length;function me(){return L<K?re[L++]():null}function Ie(Se){Se!=null&&V.push(Se);const ve=me();return ve?ve.then(Ie):Promise.resolve(V)}return Promise.resolve(null).then(Ie)}e.sequence=I;function r(re,V=K=>!!K,L=null){let K=0;const me=re.length,Ie=()=>{if(K>=me)return Promise.resolve(L);const Se=re[K++];return Promise.resolve(Se()).then(Ce=>V(Ce)?Promise.resolve(Ce):Ie())};return Ie()}e.first=r;function u(re,V=K=>!!K,L=null){if(re.length===0)return Promise.resolve(L);let K=re.length;const me=()=>{K=-1;for(const Ie of re)Ie.cancel?.()};return new Promise((Ie,Se)=>{for(const ve of re)ve.then(Ce=>{--K>=0&&V(Ce)?(me(),Ie(Ce)):K===0&&Ie(L)}).catch(Ce=>{--K>=0&&(me(),Se(Ce))})})}e.firstParallel=u;class v{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((L,K)=>{this.f.push({factory:V,c:L,e:K}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const L=V.factory();L.then(V.c,V.e),L.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=v;class D extends v{constructor(){super(1)}}e.Queue=D;class y{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const V=new Ee;return this.b.add(V),V.p}d(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,L=R.extUri){const K=L.getComparisonKey(V);let me=this.a.get(K);return me||(me=new D,k.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(K),this.f()}),this.a.set(K,me)),me}f(){!this.d()||this.g()}g(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.g()}}e.ResourceQueue=y;class W{constructor(V,L){this.a=-1,typeof V=="function"&&typeof L=="number"&&this.setIfNotSet(V,L)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,L){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},L)}setIfNotSet(V,L){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},L))}}e.TimeoutTimer=W;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,L){this.cancel(),this.a=setInterval(()=>{V()},L)}}e.IntervalTimer=X;class _{constructor(V,L){this.b=-1,this.a=V,this.d=L,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=_;class J{constructor(V,L){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.a=V,this.b=L,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=J;class j extends _{constructor(V,L){super(V,L),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=j;class U extends M.Disposable{constructor(V,L){super(),this.g=V,this.h=L,this.a=[],this.b=this.D(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const L of V)this.a.push(L);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,A.setTimeout0)(()=>{if(V)return;const L=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(re,V)=>{const L=requestIdleCallback(re,typeof V=="number"?{timeout:V}:void 0);let K=!1;return{dispose(){K||(K=!0,cancelIdleCallback(L))}}}}();class ${constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(L){this.g=L}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function B(re,V,L){let K;for(let me=0;me<L;me++)try{return await re()}catch(Ie){K=Ie,await c(V)}throw K}e.retry=B;class q{hasPending(V){return this.a?typeof V=="number"?this.a.taskId===V:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(V,L,K){return this.a={taskId:V,cancel:()=>K?.(),promise:L},L.then(()=>this.d(V),()=>this.d(V)),L}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this.b)this.b.run=V;else{let L,K;const me=new Promise((Ie,Se)=>{L=Ie,K=Se});this.b={run:V,promise:me,promiseResolve:L,promiseReject:K}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=q;class he{constructor(V,L=()=>Date.now()){this.d=V,this.f=L,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class Ee{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((V,L)=>{this.a=V,this.b=L})}complete(V){return new Promise(L=>{this.a(V),this.f=!0,L()})}error(V){return new Promise(L=>{this.b(V),this.d=!0,L()})}cancel(){new Promise(V=>{this.b(new T.CancellationError),this.d=!0,V()})}}e.DeferredPromise=Ee;var ie;(function(re){async function V(K){let me;const Ie=await Promise.all(K.map(Se=>Se.then(ve=>ve,ve=>{me||(me=ve)})));if(typeof me<"u")throw me;return Ie}re.settled=V;function L(K){return new Promise(async(me,Ie)=>{try{await K(me,Ie)}catch(Se){Ie(Se)}})}re.withAsyncBody=L})(ie=e.Promises||(e.Promises={}));var ce;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ce||(ce={}));class de{static fromArray(V){return new de(L=>{L.emitMany(V)})}static fromPromise(V){return new de(async L=>{L.emitMany(await V)})}static fromPromises(V){return new de(async L=>{await Promise.all(V.map(async K=>L.emitOne(await K)))})}static merge(V){return new de(async L=>{await Promise.all(V.map(async K=>{for await(const me of K)L.emitOne(me)}))})}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const L={emitOne:K=>this.g(K),emitMany:K=>this.h(K),reject:K=>this.k(K)};try{await Promise.resolve(V(L)),this.j()}catch(K){this.k(K)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(V,L){return new de(async K=>{for await(const me of V)K.emitOne(L(me))})}map(V){return de.map(this,V)}static filter(V,L){return new de(async K=>{for await(const me of V)L(me)&&K.emitOne(me)})}filter(V){return de.filter(this,V)}static coalesce(V){return de.filter(V,L=>!!L)}coalesce(){return de.coalesce(this)}static async toPromise(V){const L=[];for await(const K of V)L.push(K);return L}toPromise(){return de.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}de.EMPTY=de.fromArray([]),e.AsyncIterableObject=de;class Te extends de{constructor(V,L){super(L),this.l=V}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Te;function le(re){const V=new n.CancellationTokenSource,L=re(V.token);return new Te(V,async K=>{const me=V.token.onCancellationRequested(()=>{me.dispose(),V.dispose(),K.reject(new T.CancellationError)});try{for await(const Ie of L){if(V.token.isCancellationRequested)return;K.emitOne(Ie)}me.dispose(),V.dispose()}catch(Ie){me.dispose(),V.dispose(),K.reject(Ie)}})}e.createCancelableAsyncIterable=le}),define(Ae[36],Re([1,0,16,17,41,28,19,20,12]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",S="[^/\\\\]",f=/\//g;function E(he,Ee){switch(he){case 0:return"";case 1:return`${S}*?`;default:return`(?:${O}|${S}+${O}${Ee?`|${O}${S}+`:""})*?`}}function g(he,Ee){if(!he)return[];const ie=[];let ce=!1,de=!1,Te="";for(const le of he){switch(le){case Ee:if(!ce&&!de){ie.push(Te),Te="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":de=!0;break;case"]":de=!1;break}Te+=le}return Te&&ie.push(Te),ie}e.splitGlobAware=g;function d(he){if(!he)return"";let Ee="";const ie=g(he,e.GLOB_SPLIT);if(ie.every(ce=>ce===e.GLOBSTAR))Ee=".*";else{let ce=!1;ie.forEach((de,Te)=>{if(de===e.GLOBSTAR){if(ce)return;Ee+=E(2,Te===ie.length-1)}else{let le=!1,re="",V=!1,L="";for(const K of de){if(K!=="}"&&le){re+=K;continue}if(V&&(K!=="]"||!L)){let me;K==="-"?me=K:(K==="^"||K==="!")&&!L?me="^":K===e.GLOB_SPLIT?me="":me=(0,w.escapeRegExpCharacters)(K),L+=me;continue}switch(K){case"{":le=!0;continue;case"[":V=!0;continue;case"}":{Ee+=`(?:${g(re,",").map(Se=>d(Se)).join("|")})`,le=!1,re="";break}case"]":{Ee+="["+L+"]",V=!1,L="";break}case"?":Ee+=S;continue;case"*":Ee+=E(1);continue;default:Ee+=(0,w.escapeRegExpCharacters)(K)}}Te<ie.length-1&&(ie[Te+1]!==e.GLOBSTAR||Te+2<ie.length)&&(Ee+=O)}ce=de===e.GLOBSTAR})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),l=function(){return!1},s=function(){return null};function c(he,Ee){if(!he)return s;let ie;typeof he!="string"?ie=he.pattern:ie=he,ie=ie.trim();const ce=`${ie}_${!!Ee.trimForExclusions}`;let de=i.get(ce);if(de)return o(de,he);let Te;return t.test(ie)?de=r(ie.substr(4),ie):(Te=a.exec(I(ie,Ee)))?de=u(Te[1],ie):(Ee.trimForExclusions?b:m).test(ie)?de=v(ie,Ee):(Te=P.exec(I(ie,Ee)))?de=D(Te[1].substr(1),ie,!0):(Te=p.exec(I(ie,Ee)))?de=D(Te[1],ie,!1):de=y(ie),i.set(ce,de),o(de,he)}function o(he,Ee){if(typeof Ee=="string")return he;const ie=function(ce,de){return(0,k.isEqualOrParent)(ce,Ee.base,!A.isLinux)?he((0,w.ltrim)(ce.substr(Ee.base.length),R.sep),de):null};return ie.allBasenames=he.allBasenames,ie.allPaths=he.allPaths,ie.basenames=he.basenames,ie.patterns=he.patterns,ie}function I(he,Ee){return Ee.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function r(he,Ee){return function(ie,ce){return typeof ie=="string"&&ie.endsWith(he)?Ee:null}}function u(he,Ee){const ie=`/${he}`,ce=`\\${he}`,de=function(le,re){return typeof le!="string"?null:re?re===he?Ee:null:le===he||le.endsWith(ie)||le.endsWith(ce)?Ee:null},Te=[he];return de.basenames=Te,de.patterns=[Ee],de.allBasenames=Te,de}function v(he,Ee){const ie=B(he.slice(1,-1).split(",").map(re=>c(re,Ee)).filter(re=>re!==s),he),ce=ie.length;if(!ce)return s;if(ce===1)return ie[0];const de=function(re,V){for(let L=0,K=ie.length;L<K;L++)if(ie[L](re,V))return he;return null},Te=ie.find(re=>!!re.allBasenames);Te&&(de.allBasenames=Te.allBasenames);const le=ie.reduce((re,V)=>V.allPaths?re.concat(V.allPaths):re,[]);return le.length&&(de.allPaths=le),de}function D(he,Ee,ie){const ce=R.sep===R.posix.sep,de=ce?he:he.replace(f,R.sep),Te=R.sep+de,le=R.posix.sep+he;let re;return ie?re=function(V,L){return typeof V=="string"&&(V===de||V.endsWith(Te)||!ce&&(V===he||V.endsWith(le)))?Ee:null}:re=function(V,L){return typeof V=="string"&&(V===de||!ce&&V===he)?Ee:null},re.allPaths=[(ie?"*/":"./")+he],re}function y(he){try{const Ee=new RegExp(`^${d(he)}$`);return function(ie){return Ee.lastIndex=0,typeof ie=="string"&&Ee.test(ie)?he:null}}catch{return s}}function W(he,Ee,ie){return!he||typeof Ee!="string"?!1:X(he)(Ee,void 0,ie)}e.match=W;function X(he,Ee={}){if(!he)return l;if(typeof he=="string"||_(he)){const ie=c(he,Ee);if(ie===s)return l;const ce=function(de,Te){return!!ie(de,Te)};return ie.allBasenames&&(ce.allBasenames=ie.allBasenames),ie.allPaths&&(ce.allPaths=ie.allPaths),ce}return U(he,Ee)}e.parse=X;function _(he){const Ee=he;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.isRelativePattern=_;function J(he){return he.allBasenames||[]}e.getBasenameTerms=J;function j(he){return he.allPaths||[]}e.getPathTerms=j;function U(he,Ee){const ie=B(Object.getOwnPropertyNames(he).map(re=>$(re,he[re],Ee)).filter(re=>re!==s)),ce=ie.length;if(!ce)return s;if(!ie.some(re=>!!re.requiresSiblings)){if(ce===1)return ie[0];const re=function(K,me){let Ie;for(let Se=0,ve=ie.length;Se<ve;Se++){const Ce=ie[Se](K,me);if(typeof Ce=="string")return Ce;(0,T.isThenable)(Ce)&&(Ie||(Ie=[]),Ie.push(Ce))}return Ie?(async()=>{for(const Se of Ie){const ve=await Se;if(typeof ve=="string")return ve}return null})():null},V=ie.find(K=>!!K.allBasenames);V&&(re.allBasenames=V.allBasenames);const L=ie.reduce((K,me)=>me.allPaths?K.concat(me.allPaths):K,[]);return L.length&&(re.allPaths=L),re}const de=function(re,V,L){let K,me;for(let Ie=0,Se=ie.length;Ie<Se;Ie++){const ve=ie[Ie];ve.requiresSiblings&&L&&(V||(V=(0,R.basename)(re)),K||(K=V.substr(0,V.length-(0,R.extname)(re).length)));const Ce=ve(re,V,K,L);if(typeof Ce=="string")return Ce;(0,T.isThenable)(Ce)&&(me||(me=[]),me.push(Ce))}return me?(async()=>{for(const Ie of me){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},Te=ie.find(re=>!!re.allBasenames);Te&&(de.allBasenames=Te.allBasenames);const le=ie.reduce((re,V)=>V.allPaths?re.concat(V.allPaths):re,[]);return le.length&&(de.allPaths=le),de}function $(he,Ee,ie){if(Ee===!1)return s;const ce=c(he,ie);if(ce===s)return s;if(typeof Ee=="boolean")return ce;if(Ee){const de=Ee.when;if(typeof de=="string"){const Te=(le,re,V,L)=>{if(!L||!ce(le,re))return null;const K=de.replace("$(basename)",()=>V),me=L(K);return(0,T.isThenable)(me)?me.then(Ie=>Ie?he:null):me?he:null};return Te.requiresSiblings=!0,Te}}return ce}function B(he,Ee){const ie=he.filter(re=>!!re.basenames);if(ie.length<2)return he;const ce=ie.reduce((re,V)=>{const L=V.basenames;return L?re.concat(L):re},[]);let de;if(Ee){de=[];for(let re=0,V=ce.length;re<V;re++)de.push(Ee)}else de=ie.reduce((re,V)=>{const L=V.patterns;return L?re.concat(L):re},[]);const Te=function(re,V){if(typeof re!="string")return null;if(!V){let K;for(K=re.length;K>0;K--){const me=re.charCodeAt(K-1);if(me===47||me===92)break}V=re.substr(K)}const L=ce.indexOf(V);return L!==-1?de[L]:null};Te.basenames=ce,Te.patterns=de,Te.allBasenames=ce;const le=he.filter(re=>!re.basenames);return le.push(Te),le}function q(he,Ee){return(0,n.equals)(he,Ee,(ie,ce)=>typeof ie=="string"&&typeof ce=="string"?ie===ce:typeof ie!="string"&&typeof ce!="string"?ie.base===ce.base&&ie.pattern===ce.pattern:!1)}e.patternsEquals=q}),define(Ae[87],Re([1,0,14,128,22,12,2]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(a="",m=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(a,m=0){return this.value+=f(this.supportThemeIcons?(0,T.escapeIcons)(a):a).replace(/([ \t]+)/g,(b,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,m){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(a,m,b){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(a),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(a,m){const b=new RegExp((0,M.escapeRegExpCharacters)(m),"g");return a.replace(b,(P,p)=>a.charAt(p-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=w;function h(t){return O(t)?!t.value:Array.isArray(t)?t.every(h):!0}e.isEmptyMarkdownString=h;function O(t){return t instanceof w?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function S(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,k.isEqual)(R.URI.from(t.baseUri),R.URI.from(a.baseUri)))}e.markdownStringEqual=S;function f(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function E(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function d(t){const a=[],m=t.split("|").map(P=>P.trim());t=m[0];const b=m[1];if(b){const P=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),i=P?P[1]:"",l=p?p[1]:"",s=isFinite(parseInt(l)),c=isFinite(parseInt(i));s&&a.push(`width="${l}"`),c&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=d}),define(Ae[88],Re([1,0,16,41,19,20,22,12]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(s,c){const{os:o,tildify:I,relative:r}=c;if(r){const D=h(s,r,o);if(typeof D=="string")return D}let u=s.fsPath;if(o===1&&!M.isWindows?u=u.replace(/\//g,"\\"):o!==1&&M.isWindows&&(u=u.replace(/\\/g,"/")),o!==1&&I?.userHome){const D=I.userHome.fsPath;let y;s.scheme!==I.userHome.scheme&&s.path.startsWith(k.posix.sep)?y=I.userHome.with({path:s.path}).fsPath:y=s.fsPath,u=f(y,D,o)}return(o===1?k.win32:k.posix).normalize(O(u,o===1))}e.getPathLabel=w;function h(s,c,o){const I=o===1?k.win32:k.posix,r=o===3?R.extUri:R.extUriIgnorePathCase,u=c.getWorkspace(),v=(0,n.firstOrDefault)(u.folders);if(!v)return;s.scheme!==v.uri.scheme&&s.path.startsWith(k.posix.sep)&&(s=v.uri.with({path:s.path}));const D=c.getWorkspaceFolder(s);if(!D)return;let y;if(r.isEqual(D.uri,s)?y="":y=r.relativePath(D.uri,s)??"",y&&(y=I.normalize(y)),u.folders.length>1&&!c.noPrefix){const W=D.name?D.name:r.basenameOrAuthority(D.uri);y=y?`${W} \u2022 ${y}`:W}return y}function O(s,c=M.isWindows){return(0,T.hasDriveLetter)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=O;let S=Object.create(null);function f(s,c,o=M.OS){if(o===1||!s||!c)return s;let I=S.original===c?S.normalized:void 0;I||(I=c,M.isWindows&&(I=(0,T.toSlashes)(I)),I=`${(0,A.rtrim)(I,k.posix.sep)}${k.posix.sep}`,S={original:c,normalized:I});let r=s;return M.isWindows&&(r=(0,T.toSlashes)(r)),(o===3?r.startsWith(I):(0,A.startsWithIgnoreCase)(r,I))?`~/${r.substr(I.length)}`:s}e.tildify=f;function E(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=E;const g="\u2026",d="\\\\",t="~";function a(s,c=k.sep){const o=new Array(s.length);let I=!1;for(let r=0;r<s.length;r++){const u=s[r];if(u===""){o[r]=`.${c}`;continue}if(!u){o[r]=u;continue}I=!0;let v="",D=u;D.indexOf(d)===0?(v=D.substr(0,D.indexOf(d)+d.length),D=D.substr(D.indexOf(d)+d.length)):D.indexOf(c)===0?(v=D.substr(0,D.indexOf(c)+c.length),D=D.substr(D.indexOf(c)+c.length)):D.indexOf(t)===0&&(v=D.substr(0,D.indexOf(t)+t.length),D=D.substr(D.indexOf(t)+t.length));const y=D.split(c);for(let W=1;I&&W<=y.length;W++)for(let X=y.length-W;I&&X>=0;X--){I=!1;let _=y.slice(X,X+W).join(c);for(let J=0;!I&&J<s.length;J++)if(J!==r&&s[J]&&s[J].indexOf(_)>-1){const j=X+W===y.length,U=X>0&&s[J].indexOf(c)>-1?c+_:_,$=s[J].endsWith(U);I=!j||$}if(!I){let J="";(y[0].endsWith(":")||v!=="")&&(X===1&&(X=0,W++,_=y[0]+c+_),X>0&&(J=y[0]+c),J=v+J),X>0&&(J=J+g+c),J=J+_,X+W<y.length&&(J=J+c+g),o[r]=J}}I&&(o[r]=u)}return o}e.shorten=a;var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function b(s,c=Object.create(null)){const o=[];let I=!1,r="";for(const u of s)if(u==="$"||I&&u==="{")r&&o.push({value:r,type:m.TEXT}),r="",I=!0;else if(u==="}"&&I){const v=c[r];if(typeof v=="string")v.length&&o.push({value:v,type:m.VARIABLE});else if(v){const D=o[o.length-1];(!D||D.type!==m.SEPARATOR)&&o.push({value:v.label,type:m.SEPARATOR})}r="",I=!1}else r+=u;return r&&!I&&o.push({value:r,type:m.TEXT}),o.filter((u,v)=>{if(u.type===m.SEPARATOR){const D=o[v-1],y=o[v+1];return[D,y].every(W=>W&&(W.type===m.VARIABLE||W.type===m.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=b;function P(s,c){return M.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function p(s,c){return M.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,o=>o==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(s){const c=s.indexOf("/")!==-1?k.posix:k.win32,o=c.basename(s),I=c.dirname(s);return o.length?{name:o,parentPath:I}:{name:I,parentPath:""}}e.splitName=l}),define(Ae[129],Re([1,0,25,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(S){return S.toJSON()}class M{constructor(f){this.a=f}transformIncoming(f){const E=this.a.transformIncoming(f);return E===f?f:k(T.URI.from(E))}transformOutgoing(f){const E=this.a.transformOutgoing(f);return E===f?f:k(T.URI.from(E))}transformOutgoingURI(f){const E=this.a.transformOutgoing(f);return E===f?f:T.URI.from(E)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,f,E){if(!S||E>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return f.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const d=R(S[g],f,E+1);d!==null&&(S[g]=d)}}return null}function A(S,f){const E=R(S,f,0);return E===null?S:E}e.transformOutgoingURIs=A;function w(S,f,E,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return E?T.URI.revive(f.transformIncoming(S)):f.transformIncoming(S);if(S instanceof n.VSBuffer)return null;for(const d in S)if(Object.hasOwnProperty.call(S,d)){const t=w(S[d],f,E,g+1);t!==null&&(S[d]=t)}}return null}function h(S,f){const E=w(S,f,!1,0);return E===null?S:E}e.transformIncomingURIs=h;function O(S,f){const E=w(S,f,!0,0);return E===null?S:E}e.transformAndReviveIncomingURIs=O}),define(Ae[130],Re([1,0,36,19]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(M,R,A,w,h,O){if(Array.isArray(M)){let S=0;for(const f of M){const E=k(f,R,A,w,h,O);if(E===10)return E;E>S&&(S=E)}return S}else{if(typeof M=="string")return w?M==="*"?5:M===A?10:0:0;if(M){const{language:S,pattern:f,scheme:E,hasAccessToAllModels:g,notebookType:d}=M;if(!w&&!g)return 0;d&&h&&(R=h);let t=0;if(E)if(E===R.scheme)t=10;else if(E==="*")t=5;else return 0;if(S)if(S===A)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(d)if(d===O)t=10;else if(d==="*"&&O!==void 0)t=Math.max(t,5);else return 0;if(f){let a;if(typeof f=="string"?a=f:a={...f,base:(0,T.normalize)(f.base)},a===R.fsPath||(0,n.match)(a,R.fsPath))t=10;else return 0}return t}else return 0}}e.score=k}),define(Ae[89],Re([1,0,25,20]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(k||(k={}));function M(S){for(let f=0,E=S.length;f<E;f+=4){const g=S[f+0],d=S[f+1],t=S[f+2],a=S[f+3];S[f+0]=a,S[f+1]=t,S[f+2]=d,S[f+3]=g}}function R(S){const f=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.isLittleEndian()||M(f),n.VSBuffer.wrap(f)}function A(S){const f=S.buffer;if(T.isLittleEndian()||M(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const E=new Uint8Array(f.byteLength);return E.set(f),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function w(S){const f=new Uint32Array(h(S));let E=0;if(f[E++]=S.id,S.type==="full")f[E++]=1,f[E++]=S.data.length,f.set(S.data,E),E+=S.data.length;else{f[E++]=2,f[E++]=S.deltas.length;for(const g of S.deltas)f[E++]=g.start,f[E++]=g.deleteCount,g.data?(f[E++]=g.data.length,f.set(g.data,E),E+=g.data.length):f[E++]=0}return R(f)}e.encodeSemanticTokensDto=w;function h(S){let f=0;if(f+=1+1,S.type==="full")f+=1+S.data.length;else{f+=1,f+=(1+1+1)*S.deltas.length;for(const E of S.deltas)E.data&&(f+=E.data.length)}return f}function O(S){const f=A(S);let E=0;const g=f[E++];if(f[E++]===1){const m=f[E++],b=f.subarray(E,E+m);return E+=m,{id:g,type:"full",data:b}}const t=f[E++],a=[];for(let m=0;m<t;m++){const b=f[E++],P=f[E++],p=f[E++];let i;p>0&&(i=f.subarray(E,E+p),E+=p),a[m]={start:b,deleteCount:P,data:i}}return{id:g,type:"delta",deltas:a}}e.decodeSemanticTokensDto=O}),define(Ae[131],Re([10,11]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ae[132],Re([1,0,131,20,133,16,23,119]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=h;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class S{constructor(Y,be,We,ze){this.id=Y,this.name=be,this.defaultValue=We,this.schema=ze}applyUpdate(Y,be){return E(Y,be)}compute(Y,be,We){return We}}class f{constructor(Y,be){this.newValue=Y,this.didChange=be}}e.ApplyUpdateResult=f;function E(Q,Y){if(typeof Q!="object"||typeof Y!="object"||!Q||!Y)return new f(Y,Q!==Y);if(Array.isArray(Q)||Array.isArray(Y)){const We=Array.isArray(Q)&&Array.isArray(Y)&&M.equals(Q,Y);return new f(Y,!We)}let be=!1;for(const We in Y)if(Y.hasOwnProperty(We)){const ze=E(Q[We],Y[We]);ze.didChange&&(Q[We]=ze.newValue,be=!0)}return new f(Q,be)}class g{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,be){return E(Y,be)}validate(Y){return this.defaultValue}}class d{constructor(Y,be,We,ze){this.id=Y,this.name=be,this.defaultValue=We,this.schema=ze}applyUpdate(Y,be){return E(Y,be)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,be,We){return We}}function t(Q,Y){return typeof Q>"u"?Y:Q==="false"?!1:Boolean(Q)}e.boolean=t;class a extends d{constructor(Y,be,We,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=We),super(Y,be,We,ze)}validate(Y){return t(Y,this.defaultValue)}}function m(Q,Y,be,We){if(typeof Q>"u")return Y;let ze=parseInt(Q,10);return isNaN(ze)?Y:(ze=Math.max(be,ze),ze=Math.min(We,ze),ze|0)}e.clampedInt=m;class b extends d{static clampedInt(Y,be,We,ze){return m(Y,be,We,ze)}constructor(Y,be,We,ze,Qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=We,Ye.minimum=ze,Ye.maximum=Qe),super(Y,be,We,Ye),this.minimum=ze,this.maximum=Qe}validate(Y){return b.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class P extends d{static clamp(Y,be,We){return Y<be?be:Y>We?We:Y}static float(Y,be){if(typeof Y=="number")return Y;if(typeof Y>"u")return be;const We=parseFloat(Y);return isNaN(We)?be:We}constructor(Y,be,We,ze,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=We),super(Y,be,We,Qe),this.validationFn=ze}validate(Y){return this.validationFn(P.float(Y,this.defaultValue))}}class p extends d{static string(Y,be){return typeof Y!="string"?be:Y}constructor(Y,be,We,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=We),super(Y,be,We,ze)}validate(Y){return p.string(Y,this.defaultValue)}}function i(Q,Y,be){return typeof Q!="string"||be.indexOf(Q)===-1?Y:Q}e.stringSet=i;class l extends d{constructor(Y,be,We,ze,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=ze,Qe.default=We),super(Y,be,We,Qe),this.c=ze}validate(Y){return i(Y,this.defaultValue,this.c)}}class s extends S{constructor(Y,be,We,ze,Qe,Ye,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Qe,Ge.default=ze),super(Y,be,We,Ge),this.c=Qe,this.d=Ye}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function c(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,be,We){return We===0?Y.accessibilitySupport:We}}class I extends S{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{insertSpace:t(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function D(Q){switch(Q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function y(Q){switch(Q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class W extends g{constructor(){super(135)}compute(Y,be,We){const ze=["monaco-editor"];return be.get(36)&&ze.push(be.get(36)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),be.get(70)==="default"?ze.push("mouse-default"):be.get(70)==="copy"&&ze.push("mouse-copy"),be.get(105)&&ze.push("showUnused"),be.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class X extends a{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Y,be,We){return We&&Y.emptySelectionClipboard}}class _ extends S{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:n.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:n.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{cursorMoveOnType:t(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":i(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":i(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(be.loop,this.defaultValue.loop)}}}class J extends S{constructor(){super(48,"fontLigatures",J.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?J.OFF:Y==="true"?J.ON:Y:Boolean(Y)?J.ON:J.OFF}}J.OFF='"liga" off, "calt" off',J.ON='"liga" on, "calt" on',e.EditorFontLigatures=J;class j extends S{constructor(){super(51,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?j.OFF:Y==="true"?j.TRANSLATE:Y:Boolean(Y)?j.TRANSLATE:j.OFF}compute(Y,be,We){return Y.fontInfo.fontVariationSettings}}j.OFF="normal",j.TRANSLATE="translate",e.EditorFontVariations=j;class U extends g{constructor(){super(47)}compute(Y,be,We){return Y.fontInfo}}class $ extends d{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Y){const be=P.float(Y,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(be,6,100)}compute(Y,be,We){return Y.fontInfo.fontSize}}class B extends S{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(b.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class q extends S{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...be},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...be},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...be},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:We,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:We,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:We,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:We,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:We,description:n.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{multiple:i(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??i(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??i(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??i(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??i(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??i(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends S{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:n.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),delay:b.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:t(be.sticky,this.defaultValue.sticky),above:t(be.above,this.defaultValue.above)}}}var Ee;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(Ee=e.RenderMinimap||(e.RenderMinimap={}));class ie extends g{constructor(){super(138)}compute(Y,be,We){return ie.computeLayout(be,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const be=Y.height/Y.lineHeight,We=Math.floor(Y.paddingTop/Y.lineHeight);let ze=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(ze=Math.max(ze,be-1));const Qe=(We+Y.viewLineCount+ze)/(Y.pixelRatio*Y.height),Ye=Math.floor(Y.viewLineCount/Qe);return{typicalViewportLineCount:be,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:ze,desiredRatio:Qe,minimapLineCount:Ye}}static c(Y,be){const We=Y.outerWidth,ze=Y.outerHeight,Qe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=be.stableMinimapLayoutInput,Ge=Ye&&Y.outerHeight===Ye.outerHeight&&Y.lineHeight===Ye.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ye.pixelRatio&&Y.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Y.paddingTop===Ye.paddingTop&&Y.paddingBottom===Ye.paddingBottom&&Y.minimap.enabled===Ye.minimap.enabled&&Y.minimap.side===Ye.minimap.side&&Y.minimap.size===Ye.minimap.size&&Y.minimap.showSlider===Ye.minimap.showSlider&&Y.minimap.renderCharacters===Ye.minimap.renderCharacters&&Y.minimap.maxColumn===Ye.minimap.maxColumn&&Y.minimap.scale===Ye.minimap.scale&&Y.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Y.isViewportWrapping===Ye.isViewportWrapping,at=Y.lineHeight,Dt=Y.typicalHalfwidthCharacterWidth,Tt=Y.scrollBeyondLastLine,It=Y.minimap.renderCharacters;let Et=Qe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Mt=Y.minimap.maxColumn,zt=Y.minimap.size,Xt=Y.minimap.side,ht=Y.verticalScrollbarWidth,gt=Y.viewLineCount,Ot=Y.remainingWidth,Ut=Y.isViewportWrapping,Lt=It?2:3;let pt=Math.floor(Qe*ze);const Ct=pt/Qe;let Pt=!1,$t=!1,Ke=Lt*Et,Wt=Et/Qe,Pe=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:xe,extraLinesBeforeFirstLine:ot,extraLinesBeyondLastLine:ft,desiredRatio:mt,minimapLineCount:lt}=ie.computeContainedMinimapLineCount({viewLineCount:gt,scrollBeyondLastLine:Tt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:ze,lineHeight:at,pixelRatio:Qe});if(gt/lt>1)Pt=!0,$t=!0,Et=1,Ke=1,Wt=Et/Qe;else{let bt=!1,kt=Et+1;if(zt==="fit"){const Ht=Math.ceil((ot+gt+ft)*Ke);Ut&&Ge&&Ot<=be.stableFitRemainingWidth?(bt=!0,kt=be.stableFitMaxMinimapScale):bt=Ht>pt}if(zt==="fill"||bt){Pt=!0;const Ht=Et;Ke=Math.min(at*Qe,Math.max(1,Math.floor(1/mt))),Ut&&Ge&&Ot<=be.stableFitRemainingWidth&&(kt=be.stableFitMaxMinimapScale),Et=Math.min(kt,Math.max(1,Math.floor(Ke/Lt))),Et>Ht&&(Pe=Math.min(2,Et/Ht)),Wt=Et/Qe/Pe,pt=Math.ceil(Math.max(xe,ot+gt+ft)*Ke),Ut?(be.stableMinimapLayoutInput=Y,be.stableFitRemainingWidth=Ot,be.stableFitMaxMinimapScale=Et):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const Le=Math.floor(Mt*Wt),fe=Math.min(Le,Math.max(0,Math.floor((Ot-ht-2)*Wt/(Dt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let G=Math.floor(Qe*fe);const Oe=G/Qe;G=Math.floor(G*Pe);const Be=It?1:2,Ze=Xt==="left"?0:We-fe-ht;return{renderMinimap:Be,minimapLeft:Ze,minimapWidth:fe,minimapHeightIsEditorHeight:Pt,minimapIsSampling:$t,minimapScale:Et,minimapLineHeight:Ke,minimapCanvasInnerWidth:G,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:Ct}}static computeLayout(Y,be){const We=be.outerWidth|0,ze=be.outerHeight|0,Qe=be.lineHeight|0,Ye=be.lineNumbersDigitCount|0,Ge=be.typicalHalfwidthCharacterWidth,at=be.maxDigitWidth,Dt=be.pixelRatio,Tt=be.viewLineCount,It=Y.get(130),Et=It==="inherit"?Y.get(129):It,Mt=Et==="inherit"?Y.get(125):Et,zt=Y.get(128),Xt=be.isDominatedByLongLines,ht=Y.get(54),gt=Y.get(64).renderType!==0,Ot=Y.get(65),Ut=Y.get(99),Lt=Y.get(80),pt=Y.get(69),Ct=Y.get(97),Pt=Ct.verticalScrollbarSize,$t=Ct.verticalHasArrows,Ke=Ct.arrowSize,Wt=Ct.horizontalScrollbarSize,Pe=Y.get(40),Le=Y.get(104)!=="never";let fe=Y.get(62);Pe&&Le&&(fe+=16);let G=0;if(gt){const ai=Math.max(Ye,Ot);G=Math.round(ai*at)}let Oe=0;ht&&(Oe=Qe);let Be=0,Ze=Be+Oe,xe=Ze+G,ot=xe+fe;const ft=We-Oe-G-fe;let mt=!1,lt=!1,ct=-1;Et==="inherit"&&Xt?(mt=!0,lt=!0):Mt==="on"||Mt==="bounded"?lt=!0:Mt==="wordWrapColumn"&&(ct=zt);const bt=ie.c({outerWidth:We,outerHeight:ze,lineHeight:Qe,typicalHalfwidthCharacterWidth:Ge,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:Lt.top,paddingBottom:Lt.bottom,minimap:pt,verticalScrollbarWidth:Pt,viewLineCount:Tt,remainingWidth:ft,isViewportWrapping:lt},be.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(Be+=bt.minimapWidth,Ze+=bt.minimapWidth,xe+=bt.minimapWidth,ot+=bt.minimapWidth);const kt=ft-bt.minimapWidth,Ht=Math.max(1,Math.floor((kt-Pt-2)/Ge)),Ft=$t?Ke:0;return lt&&(ct=Math.max(1,Ht),Mt==="bounded"&&(ct=Math.min(ct,zt))),{width:We,height:ze,glyphMarginLeft:Be,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:G,decorationsLeft:xe,decorationsWidth:fe,contentLeft:ot,contentWidth:kt,minimap:bt,viewportColumn:Ht,isWordWrapMinified:mt,isViewportWrapping:lt,wrappingColumn:ct,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Wt,overviewRuler:{top:Ft,width:Pt,height:ze-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=ie;class ce extends S{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Y){return i(Y,"simple",["simple","advanced"])}compute(Y,be,We){return be.get(2)===2?"advanced":We}}class de extends S{constructor(){const Y={enabled:!0};super(61,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:n.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class Te extends S{constructor(){const Y={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(be.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends S{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:n.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:i(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(be.fontFamily,this.defaultValue.fontFamily),padding:t(be.padding,this.defaultValue.padding)}}}class re extends S{constructor(){super(62,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):b.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,be,We){return We<0?b.clampedInt(-We*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class V extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>P.clamp(Y,0,150),{markdownDescription:n.localize(60,null)})}compute(Y,be,We){return Y.fontInfo.lineHeight}}class L extends S{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:Y.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:n.localize(71,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),autohide:t(be.autohide,this.defaultValue.autohide),size:i(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(be.side,this.defaultValue.side,["right","left"]),showSlider:i(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(be.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(be.scale,1,1,3),maxColumn:b.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function K(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends S{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{top:b.clampedInt(be.top,0,0,1e3),bottom:b.clampedInt(be.bottom,0,0,1e3)}}}class Ie extends S{constructor(){const Y={enabled:!0,cycle:!0};super(81,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:n.localize(75,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),cycle:t(be.cycle,this.defaultValue.cycle)}}}class Se extends g{constructor(){super(136)}compute(Y,be,We){return Y.pixelRatio}}class ve extends S{constructor(){const Y={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:be,default:Y.strings,description:n.localize(79,null)},comments:{anyOf:be,default:Y.comments,description:n.localize(80,null)},other:{anyOf:be,default:Y.other,description:n.localize(81,null)}},default:Y,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Dt=Y?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:be,comments:We,strings:ze}=Y,Qe=["on","inline","off"];let Ye,Ge,at;return typeof be=="boolean"?Ye=be?"on":"off":Ye=i(be,this.defaultValue.other,Qe),typeof We=="boolean"?Ge=We?"on":"off":Ge=i(We,this.defaultValue.comments,Qe),typeof ze=="boolean"?at=ze?"on":"off":at=i(ze,this.defaultValue.strings,Qe),{other:Ye,comments:Ge,strings:at}}}var Ce;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ce=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends S{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(Y){let be=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(be=4,We=Y):Y==="interval"?be=3:Y==="relative"?be=2:Y==="on"?be=1:be=0),{renderType:be,renderFn:We}}}function ae(Q){const Y=Q.get(92);return Y==="editable"?Q.get(86):Y!=="on"}e.filterValidationDecorations=ae;class Z extends S{constructor(){const Y=[],be={type:"number",description:n.localize(88,null)};super(96,"rulers",Y,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:Y,description:n.localize(90,null)})}validate(Y){if(Array.isArray(Y)){const be=[];for(const We of Y)if(typeof We=="number")be.push({column:b.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const ze=We;be.push({column:b.clampedInt(ze.column,0,0,1e4),color:ze.color})}return be.sort((We,ze)=>We.column-ze.column),be}return this.defaultValue}}function C(Q,Y){if(typeof Q!="string")return Y;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends S{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:n.localize(101,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y,We=b.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=b.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(be.vertical,this.defaultValue.vertical),horizontal:C(be.horizontal,this.defaultValue.horizontal),useShadows:t(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:b.clampedInt(be.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:b.clampedInt(be.verticalSliderSize,ze,0,1e3),scrollByPage:t(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends S{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:n.localize(108,null)}})}applyUpdate(Y,be){let We=!1;be.allowedCharacters&&Y&&(R.equals(Y.allowedCharacters,be.allowedCharacters)||(Y={...Y,allowedCharacters:be.allowedCharacters},We=!0)),be.allowedLocales&&Y&&(R.equals(Y.allowedLocales,be.allowedLocales)||(Y={...Y,allowedLocales:be.allowedLocales},We=!0));const ze=super.applyUpdate(Y,be);return We?new f(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{nonBasicASCII:ke(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ke(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ke(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,be){if(typeof Y!="object"||!Y)return be;const We={};for(const[ze,Qe]of Object.entries(Y))Qe===!0&&(We[ze]=!0);return We}}class x extends S{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),mode:i(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(be.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class te extends S{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{enabled:t(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class pe extends S{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:Y.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:Y.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:Y.highlightActiveIndentation,description:n.localize(128,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{bracketPairs:ke(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ke(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:ke(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ke(Q,Y,be){const We=be.indexOf(Q);return We===-1?Y:be[We]}class ue extends S{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:Y.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:Y.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const be=Y;return{insertMode:i(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(be.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(be.showIcons,this.defaultValue.showIcons),showStatusBar:t(be.showStatusBar,this.defaultValue.showStatusBar),preview:t(be.preview,this.defaultValue.preview),previewMode:i(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(be.showMethods,this.defaultValue.showMethods),showFunctions:t(be.showFunctions,this.defaultValue.showFunctions),showConstructors:t(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(be.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(be.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(be.showFields,this.defaultValue.showFields),showVariables:t(be.showVariables,this.defaultValue.showVariables),showClasses:t(be.showClasses,this.defaultValue.showClasses),showStructs:t(be.showStructs,this.defaultValue.showStructs),showInterfaces:t(be.showInterfaces,this.defaultValue.showInterfaces),showModules:t(be.showModules,this.defaultValue.showModules),showProperties:t(be.showProperties,this.defaultValue.showProperties),showEvents:t(be.showEvents,this.defaultValue.showEvents),showOperators:t(be.showOperators,this.defaultValue.showOperators),showUnits:t(be.showUnits,this.defaultValue.showUnits),showValues:t(be.showValues,this.defaultValue.showValues),showConstants:t(be.showConstants,this.defaultValue.showConstants),showEnums:t(be.showEnums,this.defaultValue.showEnums),showEnumMembers:t(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(be.showKeywords,this.defaultValue.showKeywords),showWords:t(be.showWords,this.defaultValue.showWords),showColors:t(be.showColors,this.defaultValue.showColors),showFiles:t(be.showFiles,this.defaultValue.showFiles),showReferences:t(be.showReferences,this.defaultValue.showReferences),showFolders:t(be.showFolders,this.defaultValue.showFolders),showTypeParameters:t(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(be.showSnippets,this.defaultValue.showSnippets),showUsers:t(be.showUsers,this.defaultValue.showUsers),showIssues:t(be.showIssues,this.defaultValue.showIssues)}}}class De extends S{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var we;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));class $e extends S{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,be,We){return be.get(2)===2?0:We}}class He extends g{constructor(){super(139)}compute(Y,be,We){const ze=be.get(138);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class et extends S{constructor(){const Y={enabled:!0};super(33,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(183,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?tt:T.isLinux?rt:Xe,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var it;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Me(new o),accessibilityPageSize:Me(new b(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Me(new p(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Me(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Me(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Me(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Me(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Me(new a(10,"automaticLayout",!1)),autoSurround:Me(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Me(new te),bracketPairGuides:Me(new pe),stickyTabStops:Me(new a(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Me(new a(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Me(new p(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Me(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Me(new a(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Me(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Me(new a(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Me(new I),contextmenu:Me(new a(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Me(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Me(new l(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Me(new s(25,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],y,{description:n.localize(222,null)})),cursorSurroundingLines:Me(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Me(new l(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Me(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Me(new a(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(31,"domReadOnly",!1)),dragAndDrop:Me(new a(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Me(new X),dropIntoEditor:Me(new et),stickyScroll:Me(new Te),experimentalWhitespaceRendering:Me(new l(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Me(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new P(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Me(new _),fixedOverflowWidgets:Me(new a(39,"fixedOverflowWidgets",!1)),folding:Me(new a(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Me(new l(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Me(new a(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Me(new a(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Me(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Me(new a(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Me(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Me(new U),fontLigatures2:Me(new J),fontSize:Me(new $),fontWeight:Me(new B),fontVariations:Me(new j),formatOnPaste:Me(new a(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Me(new a(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Me(new a(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Me(new q),hideCursorInOverviewRuler:Me(new a(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Me(new he),inDiffEditor:Me(new a(58,"inDiffEditor",!1)),letterSpacing:Me(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>P.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Me(new de),lineDecorationsWidth:Me(new re),lineHeight:Me(new V),lineNumbers:Me(new se),lineNumbersMinChars:Me(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Me(new a(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Me(new l(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Me(new L),mouseStyle:Me(new l(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new P(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Me(new a(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Me(new a(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Me(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],K,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Me(new l(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Me(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Me(new a(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Me(new a(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Me(new b(79,"overviewRulerLanes",3,0,3)),padding:Me(new me),parameterHints:Me(new Ie),peekWidgetDefaultFocus:Me(new l(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Me(new a(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Me(new ve),quickSuggestionsDelay:Me(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Me(new a(86,"readOnly",!1)),renameOnType:Me(new a(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Me(new a(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Me(new l(89,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Me(new l(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Me(new l(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Me(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Me(new Z),scrollbar:Me(new N),scrollBeyondLastColumn:Me(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Me(new a(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Me(new a(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Me(new a(101,"selectionClipboard",!0,{description:n.localize(283,null),included:T.isLinux})),selectionHighlight:Me(new a(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Me(new a(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Me(new a(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Me(new a(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Me(new le),snippetSuggestions:Me(new l(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Me(new De),smoothScrolling:Me(new a(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Me(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ue),inlineSuggest:Me(new x),suggestFontSize:Me(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Me(new l(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Me(new l(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Me(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new H),unusualLineTerminators:Me(new l(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Me(new a(121,"useShadowDOM",!0)),useTabStops:Me(new a(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Me(new l(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Me(new p(124,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Me(new l(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Me(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Me(new l(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new W),pixelRatio:Me(new Se),tabFocusMode:Me(new a(137,"tabFocusMode",!1,{markdownDescription:n.localize(323,null)})),layoutInfo:Me(new ie),wrappingInfo:Me(new He),wrappingIndent:Me(new $e),wrappingStrategy:Me(new ce)}}),define(Ae[134],Re([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[135],Re([10,11]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[136],Re([10,11]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[137],Re([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[138],Re([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[139],Re([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ae[140],Re([10,11]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ae[141],Re([10,11]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[142],Re([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ae[143],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[144],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[145],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[146],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[147],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[148],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[149],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[150],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[151],Re([10,11]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[152],Re([10,11]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ae[153],Re([10,11]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ae[154],Re([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[155],Re([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[156],Re([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[157],Re([10,11]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[158],Re([10,11]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[159],Re([10,11]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[160],Re([10,11]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[161],Re([1,0,14,136]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(k=e.TokenType||(e.TokenType={}));function M(...h){switch(h.length){case 1:return(0,T.localize)(0,null,h[0]);case 2:return(0,T.localize)(1,null,h[0],h[1]);case 3:return(0,T.localize)(2,null,h[0],h[1],h[2]);default:return}}const R=(0,T.localize)(3,null),A=(0,T.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const S=this.d,f=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:f};this.g.push({offset:S,lexeme:f,additionalInfo:O}),this.f.push(E)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const S=this.c.substring(this.d,this.e),f=w.b.get(S);f?this.k(f):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,S=!1,f=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(A);return}const g=this.c.charCodeAt(O);if(S)S=!1;else if(g===47&&!f){O++;break}else g===91?f=!0:g===92?S=!0:g===93&&(f=!1);O++}for(;O<this.c.length&&w.a.has(this.c.charCodeAt(O));)O++;this.e=O;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}w.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0))),w.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=w}),define(Ae[162],Re([1,0,22,29,138,263]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function w(a){return a=a.trim(),a==="*"||R.test(a)}e.isValidVersionStr=w;function h(a){if(!w(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=a.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=h;function O(a){if(!a)return null;const m=a.majorBase,b=a.majorMustEqual,P=a.minorBase;let p=a.minorMustEqual;const i=a.patchBase;let l=a.patchMustEqual;a.hasCaret&&(m===0||(p=!1),l=!1);let s=0;if(a.preRelease){const c=A.exec(a.preRelease);if(c){const[,o,I,r]=c;s=Date.UTC(Number(o),Number(I)-1,Number(r))}}return{majorBase:m,majorMustEqual:b,minorBase:P,minorMustEqual:p,patchBase:i,patchMustEqual:l,isMinimum:a.hasGreaterEquals,notBefore:s}}e.normalizeVersion=O;function S(a,m,b){let P;typeof a=="string"?P=O(h(a)):P=a;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let i;if(typeof b=="string"?i=O(h(b)):i=b,!P||!i)return!1;const l=P.majorBase,s=P.minorBase,c=P.patchBase;let o=i.majorBase,I=i.minorBase,r=i.patchBase;const u=i.notBefore;let v=i.majorMustEqual,D=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?l>o?!0:l<o?!1:s>I?!0:s<I||p&&p<u?!1:c>=r:(l===1&&o===0&&(!v||!D||!y)&&(o=1,I=0,r=0,v=!0,D=!1,y=!1),l<o?!1:l>o?!v:s<I?!1:s>I?!D:c<r?!1:c>r?!y:!(p&&p<u))}e.isValidVersion=S;function f(a,m,b,P,p){const i=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return i.push([T.default.Error,k.localize(0,null)]),i;if(typeof P.name!="string")return i.push([T.default.Error,k.localize(1,null,"name")]),i;if(typeof P.version!="string")return i.push([T.default.Error,k.localize(2,null,"version")]),i;if(!P.engines)return i.push([T.default.Error,k.localize(3,null,"engines")]),i;if(typeof P.engines.vscode!="string")return i.push([T.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof P.extensionDependencies<"u"&&!t(P.extensionDependencies))return i.push([T.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof P.activationEvents<"u"){if(!t(P.activationEvents))return i.push([T.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof P.main>"u"&&typeof P.browser>"u")return i.push([T.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&i.push([T.default.Warning,k.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return i.push([T.default.Error,k.localize(9,null,"main")]),i;{const c=(0,n.joinPath)(b,P.main);(0,n.isEqualOrParent)(c,b)||i.push([T.default.Warning,k.localize(10,null,c.path,b.path)])}if(typeof P.activationEvents>"u")return i.push([T.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof P.browser<"u"){if(typeof P.browser!="string")return i.push([T.default.Error,k.localize(12,null,"browser")]),i;{const c=(0,n.joinPath)(b,P.browser);(0,n.isEqualOrParent)(c,b)||i.push([T.default.Warning,k.localize(13,null,c.path,b.path)])}if(typeof P.activationEvents>"u")return i.push([T.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(P.version))return i.push([T.default.Error,k.localize(15,null)]),i;const l=[];if(!E(a,m,P,p,l))for(const c of l)i.push([T.default.Error,c]);return i}e.validateExtensionManifest=f;function E(a,m,b,P,p){return P||typeof b.main>"u"&&typeof b.browser>"u"?!0:d(a,m,b.engines.vscode,p)}e.isValidExtensionVersion=E;function g(a,m,b){return a==="*"||d(m,b,a)}e.isEngineValid=g;function d(a,m,b,P=[]){const p=O(h(b));if(!p)return P.push(k.localize(16,null,b)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return P.push(k.localize(17,null,b)),!1}else if(!p.majorMustEqual)return P.push(k.localize(18,null,b)),!1;return S(a,m,p)?!0:(P.push(k.localize(19,null,a,b)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let m=0,b=a.length;m<b;m++)if(typeof a[m]!="string")return!1;return!0}}),define(Ae[67],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(k,M=[],R=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=n}),define(Ae[68],Re([1,0,67]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var k;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function M(A,w,h){w instanceof n.SyncDescriptor||(w=new n.SyncDescriptor(w,[],Boolean(h))),T.push([A,w])}e.registerSingleton=M;function R(){return T}e.getSingletonServiceDescriptors=R}),define(Ae[163],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const A=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(R);A.outgoing.set(w.key,w),w.incoming.set(A.key,A)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let A=this.a.get(R);return A||(A=new n(R,M),this.a.set(R,A)),A}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,A]of this.a)M.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const A=new Set([M]),w=this.c(R,A);if(w)return w}}c(M,R){for(const[A,w]of M.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const h=this.c(w,R);if(h)return h;R.delete(A)}}}e.Graph=T}),define(Ae[3],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function T(R,A,w){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:w}):(A[n.DI_DEPENDENCIES]=[{id:R,index:w}],A[n.DI_TARGET]=A)}function k(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(w,h,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,w,O)};return A.toString=()=>R,n.serviceIds.set(R,A),A}e.createDecorator=k;function M(R){return R}e.refineServiceDecorator=M}),define(Ae[42],Re([1,0,9,2,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationOverrides=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=R;var A;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function h(t,a){const m=Object.create(null);for(const b in t)O(m,b,t[b],a);return m}e.toValuesTree=h;function O(t,a,m,b){const P=a.split("."),p=P.pop();let i=t;for(let l=0;l<P.length;l++){const s=P[l];let c=i[s];switch(typeof c){case"undefined":c=i[s]=Object.create(null);break;case"object":break;default:b(`Ignoring ${a} as ${P.slice(0,l+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[p]=m}catch{b(`Ignoring ${a} as ${P.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${a} as ${P.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=O;function S(t,a){const m=a.split(".");f(t,m)}e.removeFromValueTree=S;function f(t,a){const m=a.shift();if(a.length===0){delete t[m];return}if(Object.keys(t).indexOf(m)!==-1){const b=t[m];typeof b=="object"&&!Array.isArray(b)&&(f(b,a),Object.keys(b).length===0&&delete t[m])}}function E(t,a,m){function b(i,l){let s=i;for(const c of l){if(typeof s!="object"||s===null)return;s=s[c]}return s}const P=a.split("."),p=b(t,P);return typeof p>"u"?m:p}e.getConfigurationValue=E;function g(t,a,m){Object.keys(a).forEach(b=>{b!=="__proto__"&&(b in t?n.isObject(t[b])&&n.isObject(a[b])?g(t[b],a[b],m):m&&(t[b]=a[b]):t[b]=a[b])})}e.merge=g;function d(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ae[31],Re([1,0,20,12,161,3,135]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",n.isMacintosh),A.set("isLinux",n.isLinux),A.set("isWindows",n.isWindows),A.set("isWeb",n.isWeb),A.set("isMacNative",n.isMacintosh&&!n.isWeb),A.set("isEdge",n.isEdge),A.set("isFirefox",n.isFirefox),A.set("isChrome",n.isChrome),A.set("isSafari",n.isSafari);const w=Object.prototype.hasOwnProperty;var h;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));class O{static false(){return o.INSTANCE}static true(){return I.INSTANCE}static has(L){return r.create(L)}static equals(L,K){return u.create(L,K)}static notEquals(L,K){return y.create(L,K)}static regex(L,K){return $.create(L,K)}static in(L,K){return v.create(L,K)}static notIn(L,K){return D.create(L,K)}static not(L){return W.create(L)}static and(...L){return he.create(L,null,!0)}static or(...L){return Ee.create(L,null,!0)}static greater(L,K){return _.create(L,K)}static greaterEquals(L,K){return J.create(L,K)}static smaller(L,K){return j.create(L,K)}static smallerEquals(L,K){return U.create(L,K)}static deserialize(L){if(!!L)return this.c(L)}static c(L){const K=L.split("||");return Ee.create(K.map(me=>this.d(me)),null,!0)}static d(L){const K=L.split("&&");return he.create(K.map(me=>this.f(me)),null,!0)}static f(L){if(L=L.trim(),L.indexOf("!=")>=0){const K=L.split("!=");return y.create(K[0].trim(),this.g(K[1]))}if(L.indexOf("==")>=0){const K=L.split("==");return u.create(K[0].trim(),this.g(K[1]))}if(L.indexOf("=~")>=0){const K=L.split("=~");return $.create(K[0].trim(),this.h(K[1]))}if(L.indexOf(" not in ")>=0){const K=L.split(" not in ");return D.create(K[0].trim(),this.g(K[1]))}if(L.indexOf(" in ")>=0){const K=L.split(" in ");return v.create(K[0].trim(),this.g(K[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const K=L.split(">=");return J.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const K=L.split(">");return _.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const K=L.split("<=");return U.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const K=L.split("<");return j.create(K[0].trim(),K[1].trim())}return/^\!\s*/.test(L)?W.create(L.substr(1).trim()):r.create(L)}static g(L){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const K=/^'([^']*)'$/.exec(L);return K?K[1].trim():L}static h(L){if((0,T.isFalsyOrWhitespace)(L))return null;const K=L.indexOf("/"),me=L.lastIndexOf("/");if(K===me||K<0)return null;const Ie=L.slice(K+1,me),Se=L[me+1]==="i"?"i":"";try{return new RegExp(Ie,Se)}catch{return null}}}e.ContextKeyExpr=O;const S={regexParsingWithErrorRecovery:!0};class f extends Error{}const E=(0,R.localize)(0,null),g=(0,R.localize)(1,null),d=(0,R.localize)(2,null),t=(0,R.localize)(3,null),a=(0,R.localize)(4,null),m=(0,R.localize)(5,null),b=(0,R.localize)(6,null),P=(0,R.localize)(7,null),p=(0,R.localize)(8,null);class i{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(L=S){this.h=L,this.c=new k.Scanner,this.d=[],this.f=0,this.g=[]}parse(L){if(L===""){this.g.push({message:E,offset:0,lexeme:"",additionalInfo:g});return}this.d=this.c.reset(L).scan(),this.f=0,this.g=[];try{const K=this.k();if(!this.C()){const me=this.B(),Ie=me.type===17?b:void 0;throw this.g.push({message:m,offset:me.offset,lexeme:k.Scanner.getLexeme(me),additionalInfo:Ie}),new f}return K}catch(K){if(!(K instanceof f))throw K;return}}k(){return this.l()}l(){const L=[this.o()];for(;this.w(16);){const K=this.o();L.push(K)}return L.length===1?L[0]:O.or(...L)}o(){const L=[this.s()];for(;this.w(15);){const K=this.s();L.push(K)}return L.length===1?L[0]:O.and(...L)}s(){if(this.w(2)){const L=this.B();switch(L.type){case 17:return this.x(),O.not(L.lexeme);case 11:return this.x(),O.false();case 12:return this.x(),O.true();default:throw this.z("CONTEXT | true | false",L,d)}}return this.t()}t(){const L=this.B();switch(L.type){case 11:return this.x(),O.true();case 12:return this.x(),O.false();case 0:{this.x();const K=this.k();return this.y(1,a),K}case 17:{const K=L.lexeme;if(this.x(),this.w(9)){const Ie=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),Ie.type!==10)throw this.z("REGEX",Ie);const Se=Ie.lexeme,ve=Se.lastIndexOf("/"),Ce=ve===Se.length-1?void 0:Se.substring(ve+1);let se;try{se=new RegExp(Se.substring(1,ve),Ce)}catch{throw this.z("REGEX",Ie)}return $.create(K,se)}switch(Ie.type){case 10:case 19:{const Se=[Ie.lexeme];this.x();let ve=this.B(),Ce=0;for(let N=0;N<Ie.lexeme.length;N++)Ie.lexeme.charCodeAt(N)===40?Ce++:Ie.lexeme.charCodeAt(N)===41&&Ce--;for(;!this.C()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:Ce++;break;case 1:Ce--;break;case 10:case 18:for(let N=0;N<ve.lexeme.length;N++)ve.lexeme.charCodeAt(N)===40?Ce++:Ie.lexeme.charCodeAt(N)===41&&Ce--}if(Ce<0)break;Se.push(k.Scanner.getLexeme(ve)),this.x(),ve=this.B()}const se=Se.join(""),ae=se.lastIndexOf("/"),Z=ae===se.length-1?void 0:se.substring(ae+1);let C;try{C=new RegExp(se.substring(1,ae),Z)}catch{throw this.z("REGEX",Ie)}return O.regex(K,C)}case 18:{const Se=Ie.lexeme;this.x();let ve=null;if(!(0,T.isFalsyOrWhitespace)(Se)){const Ce=Se.indexOf("/"),se=Se.lastIndexOf("/");if(Ce!==se&&Ce>=0){const ae=Se.slice(Ce+1,se),Z=Se[se+1]==="i"?"i":"";try{ve=new RegExp(ae,Z)}catch{throw this.z("REGEX",Ie)}}}if(ve===null)throw this.z("REGEX",Ie);return $.create(K,ve)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,t);const Ie=this.u();return O.notIn(K,Ie)}switch(this.B().type){case 3:{this.x();const Ie=this.u();if(this.v().type===18)return O.equals(K,Ie);switch(Ie){case"true":return O.has(K);case"false":return O.not(K);default:return O.equals(K,Ie)}}case 4:{this.x();const Ie=this.u();if(this.v().type===18)return O.notEquals(K,Ie);switch(Ie){case"true":return O.not(K);case"false":return O.has(K);default:return O.notEquals(K,Ie)}}case 5:return this.x(),j.create(K,this.u());case 6:return this.x(),U.create(K,this.u());case 7:return this.x(),_.create(K,this.u());case 8:return this.x(),J.create(K,this.u());case 13:return this.x(),O.in(K,this.u());default:return O.has(K)}}case 20:throw this.g.push({message:P,offset:L.offset,lexeme:"",additionalInfo:p}),new f;default:throw this.z(`true | false | CONTEXT 
	| CONTEXT '=~' REGEX 
	| CONTEXT ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const L=this.B();switch(L.type){case 17:case 18:return this.x(),L.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(L){return this.A(L)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(L,K){if(this.A(L))return this.x();throw this.z(K,this.B())}z(L,K,me){const Ie=(0,R.localize)(9,null,L,k.Scanner.getLexeme(K)),Se=K.offset,ve=k.Scanner.getLexeme(K);return this.g.push({message:Ie,offset:Se,lexeme:ve,additionalInfo:me}),new f}A(L){return this.B().type===L}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=i;function l(V){const L=new i({regexParsingWithErrorRecovery:!1});return V.map(K=>(L.parse(K),L.lexingErrors.length>0?L.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,R.localize)(10,null,me.additionalInfo):(0,R.localize)(11,null),offset:me.offset,length:me.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=l;function s(V,L){const K=V?V.substituteConstants():void 0,me=L?L.substituteConstants():void 0;return!K&&!me?!0:!K||!me?!1:K.equals(me)}e.expressionsAreEqualWithConstantSubstitution=s;function c(V,L){return V.cmp(L)}class o{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return I.INSTANCE}}o.INSTANCE=new o,e.ContextKeyFalseExpr=o;class I{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return o.INSTANCE}}I.INSTANCE=new I,e.ContextKeyTrueExpr=I;class r{static create(L,K=null){const me=A.get(L);return typeof me=="boolean"?me?I.INSTANCE:o.INSTANCE:new r(L,K)}constructor(L,K){this.key=L,this.c=K,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?I.INSTANCE:o.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=r;class u{static create(L,K,me=null){if(typeof K=="boolean")return K?r.create(L,me):W.create(L,me);const Ie=A.get(L);return typeof Ie=="boolean"?K===(Ie?"true":"false")?I.INSTANCE:o.INSTANCE:new u(L,K,me)}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const K=L?"true":"false";return this.d===K?I.INSTANCE:o.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class v{static create(L,K){return new v(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:de(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const K=L.getValue(this.f),me=L.getValue(this.d);return Array.isArray(K)?K.includes(me):typeof me=="string"&&typeof K=="object"&&K!==null?w.call(K,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=v;class D{static create(L,K){return new D(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=11,this.c=v.create(L,K)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=D;class y{static create(L,K,me=null){if(typeof K=="boolean")return K?W.create(L,me):r.create(L,me);const Ie=A.get(L);return typeof Ie=="boolean"?K===(Ie?"true":"false")?o.INSTANCE:I.INSTANCE:new y(L,K,me)}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const K=L?"true":"false";return this.d===K?o.INSTANCE:I.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=y;class W{static create(L,K=null){const me=A.get(L);return typeof me=="boolean"?me?o.INSTANCE:I.INSTANCE:new W(L,K)}constructor(L,K){this.c=L,this.d=K,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?o.INSTANCE:I.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=r.create(this.c,this)),this.d}}e.ContextKeyNotExpr=W;function X(V,L){if(typeof V=="string"){const K=parseFloat(V);isNaN(K)||(V=K)}return typeof V=="string"||typeof V=="number"?L(V):o.INSTANCE}class _{static create(L,K,me=null){return X(K,Ie=>new _(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=_;class J{static create(L,K,me=null){return X(K,Ie=>new J(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=J;class j{static create(L,K,me=null){return X(K,Ie=>new j(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=j;class U{static create(L,K,me=null){return X(K,Ie=>new U(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=U;class ${static create(L,K){return new $(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const K=this.f?this.f.source:"",me=L.f?L.f.source:"";return K<me?-1:K>me?1:0}equals(L){if(L.type===this.type){const K=this.f?this.f.source:"",me=L.f?L.f.source:"";return this.d===L.d&&K===me}return!1}substituteConstants(){return this}evaluate(L){const K=L.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.ContextKeyRegexExpr=$;class B{static create(L){return new B(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new B(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=B;function q(V){let L=null;for(let K=0,me=V.length;K<me;K++){const Ie=V[K].substituteConstants();if(V[K]!==Ie&&L===null){L=[];for(let Se=0;Se<K;Se++)L[Se]=V[Se]}L!==null&&(L[K]=Ie)}return L===null?V:L}class he{static create(L,K,me){return he.d(L,K,me)}constructor(L,K){this.expr=L,this.c=K,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let K=0,me=this.expr.length;K<me;K++){const Ie=c(this.expr[K],L.expr[K]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].equals(L.expr[K]))return!1;return!0}return!1}substituteConstants(){const L=q(this.expr);return L===this.expr?this:he.create(L,this.c,!1)}evaluate(L){for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].evaluate(L))return!1;return!0}static d(L,K,me){const Ie=[];let Se=!1;for(const ve of L)if(!!ve){if(ve.type===1){Se=!0;continue}if(ve.type===0)return o.INSTANCE;if(ve.type===6){Ie.push(...ve.expr);continue}Ie.push(ve)}if(Ie.length===0&&Se)return I.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(c);for(let ve=1;ve<Ie.length;ve++)Ie[ve-1].equals(Ie[ve])&&(Ie.splice(ve,1),ve--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const ve=Ie[Ie.length-1];if(ve.type!==9)break;Ie.pop();const Ce=Ie.pop(),se=Ie.length===0,ae=Ee.create(ve.expr.map(Z=>he.create([Z,Ce],null,me)),null,se);ae&&(Ie.push(ae),Ie.sort(c))}if(Ie.length===1)return Ie[0];if(me){for(let ve=0;ve<Ie.length;ve++)for(let Ce=ve+1;Ce<Ie.length;Ce++)if(Ie[ve].negate().equals(Ie[Ce]))return o.INSTANCE;if(Ie.length===1)return Ie[0]}return new he(Ie,K)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const K of this.expr)L.push(...K.keys());return L}map(L){return new he(this.expr.map(K=>K.map(L)),null)}negate(){if(!this.c){const L=[];for(const K of this.expr)L.push(K.negate());this.c=Ee.create(L,this,!0)}return this.c}}class Ee{static create(L,K,me){return Ee.d(L,K,me)}constructor(L,K){this.expr=L,this.c=K,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let K=0,me=this.expr.length;K<me;K++){const Ie=c(this.expr[K],L.expr[K]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].equals(L.expr[K]))return!1;return!0}return!1}substituteConstants(){const L=q(this.expr);return L===this.expr?this:Ee.create(L,this.c,!1)}evaluate(L){for(let K=0,me=this.expr.length;K<me;K++)if(this.expr[K].evaluate(L))return!0;return!1}static d(L,K,me){let Ie=[],Se=!1;if(L){for(let ve=0,Ce=L.length;ve<Ce;ve++){const se=L[ve];if(!!se){if(se.type===0){Se=!0;continue}if(se.type===1)return I.INSTANCE;if(se.type===9){Ie=Ie.concat(se.expr);continue}Ie.push(se)}}if(Ie.length===0&&Se)return o.INSTANCE;Ie.sort(c)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let ve=1;ve<Ie.length;ve++)Ie[ve-1].equals(Ie[ve])&&(Ie.splice(ve,1),ve--);if(Ie.length===1)return Ie[0];if(me){for(let ve=0;ve<Ie.length;ve++)for(let Ce=ve+1;Ce<Ie.length;Ce++)if(Ie[ve].negate().equals(Ie[Ce]))return I.INSTANCE;if(Ie.length===1)return Ie[0]}return new Ee(Ie,K)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const K of this.expr)L.push(...K.keys());return L}map(L){return new Ee(this.expr.map(K=>K.map(L)),null)}negate(){if(!this.c){const L=[];for(const K of this.expr)L.push(K.negate());for(;L.length>1;){const K=L.shift(),me=L.shift(),Ie=[];for(const Se of re(K))for(const ve of re(me))Ie.push(he.create([Se,ve],null,!1));L.unshift(Ee.create(Ie,null,!1))}this.c=Ee.create(L,this,!0)}return this.c}}class ie extends r{static all(){return ie.d.values()}constructor(L,K,me){super(L,null),this.f=K,typeof me=="object"?ie.d.push({...me,key:L}):me!==!0&&ie.d.push({key:L,description:me,type:K!=null?typeof K:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return u.create(this.key,L)}notEqualsTo(L){return y.create(this.key,L)}}ie.d=[],e.RawContextKey=ie,e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function ce(V,L){return V<L?-1:V>L?1:0}function de(V,L,K,me){return V<K?-1:V>K?1:L<me?-1:L>me?1:0}function Te(V,L){if(V.type===0||L.type===1)return!0;if(V.type===9)return L.type===9?le(V.expr,L.expr):!1;if(L.type===9){for(const K of L.expr)if(Te(V,K))return!0;return!1}if(V.type===6){if(L.type===6)return le(L.expr,V.expr);for(const K of V.expr)if(Te(K,L))return!0;return!1}return V.equals(L)}e.implies=Te;function le(V,L){let K=0,me=0;for(;K<V.length&&me<L.length;){const Ie=V[K].cmp(L[me]);if(Ie<0)return!1;Ie===0&&K++,me++}return K===V.length}function re(V){return V.type===9?V.expr:[V]}}),define(Ae[164],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[90],Re([1,0,137,3]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function k(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function R(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function A(a,m){return m==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function w(a,m,b){return A(m,b)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===b?!0:h(b).includes(a)}e.isTargetPlatformCompatible=w;function h(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function O(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=O;var S;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var f;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var E;(function(a){a.Install="install",a.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var g;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var d;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class t extends Error{constructor(m,b){super(m),this.code=b,this.name=b}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Ae[43],Re([1,0,48,19,12,9,2,139,3,20,15]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(ie){return ie.create===!0}e.isFileOpenForWriteOptions=S;var f;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(f=e.FileType||(e.FileType={}));var E;(function(ie){ie[ie.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var g;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=d;function t(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(ie){return!!(ie.capabilities&32768)}e.hasFileCloneCapability=a;function m(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function b(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=b;function P(ie){return d(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;var p;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(ce,de){const Te=new i(ce.toString(),de);return c(Te,de),Te}constructor(ce,de){super(ce),this.code=de}}e.FileSystemProviderError=i;function l(ie,ce){return i.create(ie,ce)}e.createFileSystemProviderError=l;function s(ie){return ie||l((0,A.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function c(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=c;function o(ie){if(!ie)return p.Unknown;if(ie instanceof i)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return p.Unknown;switch(ce[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=o;function I(ie){if(ie instanceof W)return ie.fileOperationResult;switch(o(ie)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=I;var r;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class u{constructor(ce,de,Te){this.resource=ce,this.operation=de,this.target=Te}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=u;var v;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class D{constructor(ce,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Te=new Map;for(const le of ce){const re=Te.get(le.type);switch(re?re.push([le.resource,le]):Te.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,re]of Te)switch(le){case 1:this.a=n.TernarySearchTree.forUris(()=>de),this.a.fill(re);break;case 0:this.b=n.TernarySearchTree.forUris(()=>de),this.b.fill(re);break;case 2:this.c=n.TernarySearchTree.forUris(()=>de),this.c.fill(re);break}}contains(ce,...de){return this.d(ce,{includeChildren:!1},...de)}affects(ce,...de){return this.d(ce,{includeChildren:!0},...de)}d(ce,de,...Te){if(!ce)return!1;const le=Te.length>0;return!!((!le||Te.includes(1))&&(this.a?.get(ce)||de.includeChildren&&this.a?.findSuperstr(ce))||(!le||Te.includes(0))&&(this.b?.get(ce)||de.includeChildren&&this.b?.findSuperstr(ce))||(!le||Te.includes(2))&&(this.c?.findSubstr(ce)||de.includeChildren&&this.c?.findSuperstr(ce)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=D;function y(ie,ce,de){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==T.sep&&(ce+=T.sep),de?(0,k.startsWithIgnoreCase)(ie,ce):ie.indexOf(ce)===0)}e.isParent=y;class W extends Error{constructor(ce,de,Te){super(ce),this.fileOperationResult=de,this.options=Te}}e.FileOperationError=W;class X extends W{constructor(ce,de,Te,le){super(ce,de,le),this.fileOperationResult=de,this.size=Te}}e.TooLargeFileOperationError=X;class _ extends W{constructor(ce,de,Te){super(ce,2,Te),this.stat=de}}e.NotModifiedSinceFileOperationError=_;var J;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ie[ie.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=U;async function $(ie,ce){if(!ce.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(de=>{const Te=ce.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===ie.scheme&&le.added&&(Te.dispose(),de())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(ce){return(0,M.isNumber)(ce)||(ce=0),ce<B.KB?(0,A.localize)(1,null,ce.toFixed(0)):ce<B.MB?(0,A.localize)(2,null,(ce/B.KB).toFixed(2)):ce<B.GB?(0,A.localize)(3,null,(ce/B.MB).toFixed(2)):ce<B.TB?(0,A.localize)(4,null,(ce/B.GB).toFixed(2)):(0,A.localize)(5,null,(ce/B.TB).toFixed(2))}}B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB,e.ByteSize=B;var q;(function(ie){ie[ie.IA32=0]="IA32",ie[ie.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function he(ie){return{maxFileSize:ie===0?300*B.MB:16*B.GB,maxHeapSize:ie===0?700*B.MB:2*700*B.MB}}e.getPlatformFileLimits=he;function Ee(ie){const ce=typeof ie=="string"||ie?.scheme===O.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===O.Schemas.file?1024*B.MB:ce?10*B.MB:h.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=Ee}),define(Ae[69],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...k){this.a=new Map;for(const[M,R]of k)this.set(M,R)}set(k,M){const R=this.a.get(k);return this.a.set(k,M),R}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=n}),define(Ae[165],Re([1,0,17,14,6,67,163,3,69,166]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class f{constructor(t=new w.ServiceCollection,a=!1,m,b=O){this.f=t,this.g=a,this.h=m,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?m?._globalGraph??new R.Graph(P=>P):void 0}createChild(t){return new f(t,this.g,this,this.i)}invokeFunction(t,...a){const m=g.traceInvocation(this.i,t);let b=!1;try{return t({get:p=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(p,m);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...a)}finally{b=!0,m.stop()}}createInstance(t,...a){let m,b;return t instanceof M.SyncDescriptor?(m=g.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(a),m)):(m=g.traceCreation(this.i,t),b=this.j(t,a,m)),m.stop(),b}j(t,a=[],m){const b=A._util.getServiceDependencies(t).sort((i,l)=>i.index-l.index),P=[];for(const i of b){const l=this.m(i.id,m);l||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),P.push(l)}const p=b.length>0?b[0].index:a.length;if(a.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${a.length} static arguments`);const i=p-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,p)}return Reflect.construct(t,a.concat(P))}k(t,a){if(this.f.get(t)instanceof M.SyncDescriptor)this.f.set(t,a);else if(this.h)this.h.k(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const a=this.f.get(t);return!a&&this.h?this.h.l(t):a}m(t,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const m=this.l(t);return m instanceof M.SyncDescriptor?this.q(t,m,a.branch(t,!0)):(a.branch(t,!1),m)}q(t,a,m){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,a,m)}finally{this.o.delete(t)}}r(t,a,m){const b=new R.Graph(i=>i.id.toString());let P=0;const p=[{id:t,desc:a,_trace:m}];for(;p.length;){const i=p.pop();if(b.lookupOrInsertNode(i),P++>1e3)throw new S(b);for(const l of A._util.getServiceDependencies(i.desc.ctor)){const s=this.l(l.id);if(s||this.u(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),s instanceof M.SyncDescriptor){const c={id:l.id,desc:s,_trace:i._trace.branch(l.id,!0)};b.insertEdge(i,c),p.push(c)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new S(b);break}for(const{data:l}of i){if(this.l(l.id)instanceof M.SyncDescriptor){const c=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,c)}b.removeNode(l)}}return this.l(t)}s(t,a,m=[],b,P){if(this.f.get(t)instanceof M.SyncDescriptor)return this.t(t,a,m,b,P);if(this.h)return this.h.s(t,a,m,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(t,a,m=[],b,P){if(b){const p=new f(void 0,this.g,this,this.i);p.c=String(t);const i=new Map,l=new n.IdleValue(()=>{const s=p.j(a,m,P);for(const[c,o]of i){const I=s[c];if(typeof I=="function")for(const r of o)I.apply(s,r)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,c){if(!l.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let r=i.get(c);return r||(r=new h.LinkedList,i.set(c,r)),(v,D,y)=>{const W=r.push([v,D,y]);return(0,k.toDisposable)(W)}}if(c in s)return s[c];const o=l.value;let I=o[c];return typeof I!="function"||(I=I.bind(o),s[c]=I),I},set(s,c,o){return l.value[c]=o,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,m,P)}u(t,a){if(a&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=f;var E;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(E||(E={}));class g{static traceInvocation(t,a){return t?new g(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(t,a){return t?new g(1,a.name):g.c}constructor(t,a){this.type=t,this.name=a,this.g=Date.now(),this.h=[]}branch(t,a){const m=new g(3,t.toString());return this.h.push([t,a,m]),m}stop(){const t=Date.now()-this.g;g.f+=t;let a=!1;function m(P,p){const i=[],l=new Array(P+1).join("	");for(const[s,c,o]of p.h)if(c&&o){a=!0,i.push(`${l}CREATES -> ${s}`);const I=m(P+1,o);I&&i.push(I)}else i.push(`${l}uses -> ${s}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(t>2||a)&&g.all.add(b.join(`
`))}}g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0,e.Trace=g}),define(Ae[13],Re([1,0,40,5,91,6,28,20,22,9,2,31,3]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function E(){return new Date().toISOString()}function g(v){return(0,h.isNumber)(v)}e.isLogLevel=g;var d;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(v,D,y){switch(D){case d.Trace:v.trace(y);break;case d.Debug:v.debug(y);break;case d.Info:v.info(y);break;case d.Warning:v.warn(y);break;case d.Error:v.error(y);break;case d.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=t;function a(v,D=!1){let y="";for(let W=0;W<v.length;W++){let X=v[W];if(X instanceof Error&&(X=(0,n.toErrorMessage)(X,D)),typeof X=="object")try{X=JSON.stringify(X)}catch{}y+=(W>0?" ":"")+X}return y}class m extends M.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==d.Off&&this.b<=D}}e.AbstractLogger=m;class b extends m{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...y){this.f(d.Trace)&&this.g(d.Trace,a([D,...y],!0))}debug(D,...y){this.f(d.Debug)&&this.g(d.Debug,a([D,...y]))}info(D,...y){this.f(d.Info)&&this.g(d.Info,a([D,...y]))}warn(D,...y){this.f(d.Warning)&&this.g(d.Warning,a([D,...y]))}error(D,...y){if(this.f(d.Error))if(D instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=D.stack,this.g(d.Error,a(W))}else this.g(d.Error,a([D,...y]))}flush(){}}e.AbstractMessageLogger=b;class P extends m{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.g=!A.isWindows}trace(D,...y){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...y):console.log(`[main ${E()}]`,D,...y))}debug(D,...y){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...y):console.log(`[main ${E()}]`,D,...y))}info(D,...y){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...y):console.log(`[main ${E()}]`,D,...y))}warn(D,...y){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,D,...y):console.warn(`[main ${E()}]`,D,...y))}error(D,...y){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,D,...y):console.error(`[main ${E()}]`,D,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class p extends m{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D)}trace(D,...y){this.f(d.Trace)&&console.log("%cTRACE","color: #888",D,...y)}debug(D,...y){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",D,...y)}info(D,...y){this.f(d.Info)&&console.log("%c INFO","color: #33f",D,...y)}warn(D,...y){this.f(d.Warning)&&console.log("%c WARN","color: #993",D,...y)}error(D,...y){this.f(d.Error)&&console.log("%c  ERR","color: #f33",D,...y)}dispose(){}flush(){}}e.ConsoleLogger=p;class i extends m{constructor(D,y=e.DEFAULT_LOG_LEVEL){super(),this.g=D,this.setLevel(y)}trace(D,...y){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(D),...y])}debug(D,...y){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(D),...y])}info(D,...y){this.f(d.Info)&&this.g.log(d.Info,[this.h(D),...y])}warn(D,...y){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(D),...y])}error(D,...y){this.f(d.Error)&&this.g.log(d.Error,[this.h(D),...y])}h(D){return typeof D=="string"?D:(0,n.toErrorMessage)(D,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class l extends m{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const y of this.g)y.setLevel(D);super.setLevel(D)}trace(D,...y){for(const W of this.g)W.trace(D,...y)}debug(D,...y){for(const W of this.g)W.debug(D,...y)}info(D,...y){for(const W of this.g)W.info(D,...y)}warn(D,...y){for(const W of this.g)W.warn(D,...y)}error(D,...y){for(const W of this.g)W.error(D,...y)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.MultiplexLogger=l;class s extends M.Disposable{constructor(D,y,W){if(super(),this.h=D,this.j=y,this.b=new R.ResourceMap,this.c=this.D(new T.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new T.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new T.Emitter),this.onDidChangeVisibility=this.g.event,W)for(const X of W)this.b.set(X.resource,{logger:void 0,info:X})}k(D){return(0,h.isString)(D)?[...this.b.values()].find(y=>y.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,y){const W=this.l(D),X=(0,h.isString)(D)?D:y?.id??(0,k.hash)(W.toString()).toString(16);let _=this.b.get(W)?.logger;const J=y?.logLevel==="always"?d.Trace:y?.logLevel;_||(_=this.m(W,J??this.getLogLevel(W)??this.h,{...y,id:X}));const j={logger:_,info:{resource:W,id:X,logLevel:J,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(j.info),this.b.set(W,j),_}l(D){return(0,h.isString)(D)?(0,w.joinPath)(this.j,`${D}.log`):D}setLogLevel(D,y){if(O.URI.isUri(D)){const W=D,X=y,_=this.b.get(W);_&&X!==_.info.logLevel&&(_.info.logLevel=X===this.h?void 0:X,_.logger?.setLevel(X),this.b.set(_.info.resource,_),this.f.fire([W,X]))}else{this.h=D;for(const[W,X]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,y){const W=this.k(D);W&&y!==!W.info.hidden&&(W.info.hidden=!y,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,y]))}getLogLevel(D){let y;return D&&(y=this.b.get(D)?.info.logLevel),y??this.h}registerLogger(D){const y=this.b.get(D.resource);y?y.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const y=this.b.get(D);y&&(y.logger&&y.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class c{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(D){}getLevel(){return d.Info}trace(D,...y){}debug(D,...y){}info(D,...y){}warn(D,...y){}error(D,...y){}critical(D,...y){}dispose(){}flush(){}}e.NullLogger=c;class o extends c{}e.NullLogService=o;function I(v){if(v.verbose)return d.Trace;if(typeof v.logLevel=="string"){const D=u(v.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function r(v){switch(v){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function u(v){switch(v){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new S.RawContextKey("logLevel",r(d.Info))}),define(Ae[167],Re([1,0,6,13]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends n.Disposable{constructor(R,A=[]){super(),this.a=new T.MultiplexLogger([R,...A]),this.D(R.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.LogService=k}),define(Ae[92],Re([1,0,29,140,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var R;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function h(g,d){return d-g}w.compare=h;const O=Object.create(null);O[w.Error]=(0,T.localize)(0,null),O[w.Warning]=(0,T.localize)(1,null),O[w.Info]=(0,T.localize)(2,null);function S(g){return O[g]||""}w.toString=S;function f(g){switch(g){case n.default.Error:return w.Error;case n.default.Warning:return w.Warning;case n.default.Info:return w.Info;case n.default.Ignore:return w.Hint}}w.fromSeverity=f;function E(g){switch(g){case w.Error:return n.default.Error;case w.Warning:return n.default.Warning;case w.Info:return n.default.Info;case w.Hint:return n.default.Ignore}}w.toSeverity=E}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(w){const h="";function O(f){return S(f,!0)}w.makeKey=O;function S(f,E){const g=[h];return f.source?g.push(f.source.replace("\xA6","\\\xA6")):g.push(h),f.code?typeof f.code=="string"?g.push(f.code.replace("\xA6","\\\xA6")):g.push(f.code.value.replace("\xA6","\\\xA6")):g.push(h),f.severity!==void 0&&f.severity!==null?g.push(R.toString(f.severity)):g.push(h),f.message&&E?g.push(f.message.replace("\xA6","\\\xA6")):g.push(h),f.startLineNumber!==void 0&&f.startLineNumber!==null?g.push(f.startLineNumber.toString()):g.push(h),f.startColumn!==void 0&&f.startColumn!==null?g.push(f.startColumn.toString()):g.push(h),f.endLineNumber!==void 0&&f.endLineNumber!==null?g.push(f.endLineNumber.toString()):g.push(h),f.endColumn!==void 0&&f.endColumn!==null?g.push(f.endColumn.toString()):g.push(h),g.push(h),g.join("\xA6")}w.makeKeyOptionalMessage=S})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Ae[168],Re([1,0,5,29,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,k.createDecorator)("notificationService");var M;(function(h){h[h.WORKSPACE=0]="WORKSPACE",h[h.PROFILE=1]="PROFILE",h[h.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(h){h[h.OFF=0]="OFF",h[h.SILENT=1]="SILENT",h[h.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new w,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class w{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=w}),define(Ae[93],Re([1,0,12,2,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function M(h,O){return T.URI.isUri(h)?(0,n.equalsIgnoreCase)(h.scheme,O):(0,n.startsWithIgnoreCase)(h,O+":")}e.matchesScheme=M;function R(h,...O){return O.some(S=>M(h,S))}e.matchesSomeScheme=R;function A(h,O){return h.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function w(h){let O;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(h.fragment);return S&&(O={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},h=h.with({fragment:""})),{selection:O,uri:h}}e.extractSelection=w}),define(Ae[169],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(ee,e,n,T){var k=arguments.length,M=k<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,n):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ee,e,n,T);else for(var A=ee.length-1;A>=0;A--)(R=ee[A])&&(M=(k<3?R(M):k>3?R(e,n,M):R(e,n))||M);return k>3&&M&&Object.defineProperty(e,n,M),M},Ve=this&&this.__param||function(ee,e){return function(n,T){e(n,T,ee)}};define(Ae[170],Re([1,0,17,21,6,3]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var R;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(S){this.b=S}report(S){this.a=S,this.b(this.a)}}A.None=Object.freeze({report(){}}),e.Progress=A;let w=class extends k.Disposable{constructor(S,f){super(),this.a=new n.DeferredPromise,f.withProgress(S,E=>(this.b=E,this.c&&E.report(this.c),this.a.p)),this.D((0,k.toDisposable)(()=>this.a.complete()))}report(S){this.b?this.b.report(S):this.c=S}};w=je([Ve(1,e.IProgressService)],w),e.UnmanagedProgress=w;class h extends k.Disposable{constructor(S){super(),this.g=S,this.a=0,this.b=this.D(new k.DisposableStore)}start(S){this.stop();const f=++this.a,E=new T.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},S),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>E.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:E.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(S){this.a===S&&this.b.clear()}}e.LongRunningOperation=h,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,49,9]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(R,A){n.ok(T.isString(R)),n.ok(T.isObject(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new k}),define(Ae[70],Re([1,0,5,30]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,h){this.a[k(w)]=h,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;T.Registry.add(e.Extensions.JSONContribution,R)}),define(Ae[94],Re([1,0,16,5,9,134,42,70,30]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(A.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const s=new Set;this.n(i,l,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const l=new Set;this.o(i,l),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const s=new Set;this.o(l,s),this.n(i,!1,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const s=[];for(const{overrides:c,source:o}of i)for(const I in c)if(l.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const r=this.a.get(I),u=r?.valuesSources??new Map;if(o)for(const W of Object.keys(c[I]))u.set(W,o);const v={...r?.value||{},...c[I]};this.a.set(I,{source:o,value:v,valuesSources:u});const D=(0,R.getLanguageTagSettingPlainKey)(I),y={type:"object",default:v,description:M.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:k.isString(o)?void 0:o,defaultValueSource:o};s.push(...d(I)),this.d[I]=y,this.b.properties[I]=y}else{this.a.set(I,{value:c[I],source:o});const r=this.d[I];r&&(this.w(I,r),this.r(I,r))}this.m(s)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:s,source:c}of i)for(const o in s){const I=this.a.get(o),r=k.isString(c)?c:c?.id,u=k.isString(I?.source)?I?.source:I?.source?.id;if(r===u)if(l.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}}this.u()}deltaConfiguration(i){let l=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,s){i.forEach(c=>{this.p(c,l,c.extensionInfo,c.restrictedProperties,void 0,s),this.c.push(c),this.q(c)})}o(i,l){const s=c=>{if(c.properties)for(const o in c.properties){l.add(o);const I=this.d[o];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[o],this.s(o,c.properties[o])}c.allOf?.forEach(o=>s(o))};for(const c of i){s(c);const o=this.c.indexOf(c);o!==-1&&this.c.splice(o,1)}}p(i,l=!0,s,c,o=3,I){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const r=i.properties;if(r)for(const v in r){const D=r[v];if(l&&b(v,D)){delete r[v];continue}if(D.source=s,D.defaultDefaultValue=r[v].default,this.w(v,D),e.OVERRIDE_PROPERTY_REGEX.test(v)?D.scope=void 0:(D.scope=k.isUndefinedOrNull(D.scope)?o:D.scope,D.restricted=k.isUndefinedOrNull(D.restricted)?!!c?.includes(v):D.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.f[v]=r[v],delete r[v];continue}else this.d[v]=r[v],r[v].policy?.name&&this.e.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),I.add(v)}const u=i.allOf;if(u)for(const v of u)this.p(v,l,s,c,o,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=s=>{const c=s.properties;if(c)for(const I in c)this.r(I,c[I]);s.allOf?.forEach(l)};l(i)}r(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,l){const s=this.a.get(i);let c=s?.value,o=s?.source;k.isUndefined(c)&&(c=l.defaultDefaultValue,o=void 0),k.isUndefined(c)&&(c=a(l.type)),l.default=c,l.defaultValueSource=o}}const E="\\[([^\\]]+)\\]",g=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=g.exec(p);for(;l?.length;){const s=l[1].trim();s&&i.push(s),l=g.exec(p)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=d;function t(p){return p.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=t;function a(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const m=new f;w.Registry.add(e.Extensions.Configuration,m);function b(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,p,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=b;function P(){const p=[],i=m.getConfigurationProperties();for(const l of Object.keys(i))p.push([l,i[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=P}),define(Ae[171],Re([1,0,16,5,113,6,28,23,9,2,42,94,30]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(l){return Object.isFrozen(l)?l:A.deepFreeze(l)}class g{constructor(s={},c=[],o=[],I){this.b=s,this.c=c,this.d=o,this.raw=I,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof g)return c;const o=new d("");return o.parseRaw(c),o.configurationModel});this.f=s.reduce((c,o)=>o===c?o:c.merge(o),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,O.getConfigurationValue)(this.contents,s):this.contents}inspect(s,c){const o=this.rawConfiguration.getValue(s),I=c?this.rawConfiguration.getOverrideValue(s,c):void 0,r=c?this.rawConfiguration.override(c).getValue(s):o;return{value:o,override:I,merged:r}}getOverrideValue(s,c){const o=this.i(c);return o?s?(0,O.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const o of this.overrides)o.identifiers.includes(s)&&c.push(...o.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return n.distinct(s)}override(s){let c=this.a.get(s);return c||(c=this.g(s),this.a.set(s,c)),c}merge(...s){const c=A.deepClone(this.contents),o=A.deepClone(this.overrides),I=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const u of s)if(r.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(c,u.contents);for(const v of u.overrides){const[D]=o.filter(y=>n.equals(y.identifiers,v.identifiers));D?(this.h(D.contents,v.contents),D.keys.push(...v.keys),D.keys=n.distinct(D.keys)):o.push(A.deepClone(v))}for(const v of u.keys)I.indexOf(v)===-1&&I.push(v)}return new g(c,I,o,r.every(u=>u instanceof g)?void 0:r)}g(s){const c=this.i(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const o={};for(const I of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let r=this.contents[I];const u=c[I];u&&(typeof r=="object"&&typeof u=="object"?(r=A.deepClone(r),this.h(r,u)):r=u),o[I]=r}return new g(o,this.keys,this.overrides)}h(s,c){for(const o of Object.keys(c)){if(o in s&&w.isObject(s[o])&&w.isObject(c[o])){this.h(s[o],c[o]);continue}s[o]=A.deepClone(c[o])}}i(s){let c=null,o=null;const I=r=>{r&&(o?this.h(o,r):o=A.deepClone(r))};for(const r of this.overrides)n.equals(r.identifiers,[s])?c=r.contents:r.identifiers.includes(s)&&I(r.contents);return I(c),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.j(s,c,!0)}setValue(s,c){this.j(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,O.removeFromValueTree)(this.contents,s),S.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.equals(o.identifiers,(0,S.overrideIdentifiersFromKey)(s))),1))}j(s,c,o){(0,O.addToValueTree)(this.contents,s,c,I=>console.error(I)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),S.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,O.toValuesTree)(this.contents[s],I=>console.error(I))})}}e.ConfigurationModel=g;class d{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!w.isUndefinedOrNull(s)){const o=this.g(s);this.parseRaw(o,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:o,keys:I,overrides:r,restricted:u,hasExcludedProperties:v}=this.h(s,c);this.b=new g(o,I,r,v?[s]:void 0),this.c=u||[]}g(s){let c={},o=null,I=[];const r=[],u=[];function v(y){Array.isArray(I)?I.push(y):o!==null&&(I[o]=y)}const D={onObjectBegin:()=>{const y={};v(y),r.push(I),I=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{I=r.pop()},onArrayBegin:()=>{const y=[];v(y),r.push(I),I=y,o=null},onArrayEnd:()=>{I=r.pop()},onLiteralValue:v,onError:(y,W,X)=>{u.push({error:y,offset:W,length:X})}};if(s)try{k.visit(s,D),c=I[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return c}h(s,c){const o=f.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),I=this.i(s,o,!0,c);s=I.raw;const r=(0,O.toValuesTree)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),u=Object.keys(s),v=this.j(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:r,keys:u,overrides:v,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}i(s,c,o,I){let r=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:r};const u={},v=[];for(const D in s)if(S.OVERRIDE_PROPERTY_REGEX.test(D)&&o){const y=this.i(s[D],c,!1,I);u[D]=y.raw,r=r||y.hasExcludedProperties,v.push(...y.restricted)}else{const y=c[D],W=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&v.push(D),(W===void 0||I.scopes===void 0||I.scopes.includes(W))&&!(I.skipRestricted&&y?.restricted)?u[D]=s[D]:r=!0}return{raw:u,restricted:v,hasExcludedProperties:r}}j(s,c){const o=[];for(const I of Object.keys(s))if(S.OVERRIDE_PROPERTY_REGEX.test(I)){const r={};for(const u in s[I])r[u]=s[I][u];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(I),keys:Object.keys(r),contents:(0,O.toValuesTree)(r,c)})}return o}}e.ConfigurationModelParser=d;class t extends M.Disposable{constructor(s,c,o,I){super(),this.f=s,this.g=c,this.h=I,this.c=this.D(new T.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(o.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(T.Event.any(T.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(s,c,o,I,r,u,v,D,y,W,X,_,J){this.a=s,this.b=c,this.c=o,this.overrideIdentifiers=I,this.d=r,this.f=u,this.g=v,this.h=D,this.i=y,this.j=W,this.k=X,this.l=_,this.m=J}get value(){return E(this.c)}n(s,c,o){const I=s.inspect(c,o);return{get value(){return E(I.value)},get override(){return E(I.override)},get merged(){return E(I.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(s,c,o,I,r=new g,u=new g,v=new R.ResourceMap,D=new g,y=new R.ResourceMap){this.c=s,this.d=c,this.f=o,this.g=I,this.h=r,this.i=u,this.j=v,this.l=D,this.m=y,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(s,c,o){return this.q(s,c,o).getValue(s)}updateValue(s,c,o={}){let I;o.resource?(I=this.m.get(o.resource),I||(I=new g,this.m.set(o.resource,I))):I=this.l,c===void 0?I.removeValue(s):I.setValue(s,c),o.resource||(this.a=null)}inspect(s,c,o){const I=this.q(s,c,o),r=this.u(c.resource,o),u=c.resource?this.m.get(c.resource)||this.l:this.l,v=new Set;for(const D of I.overrides)for(const y of D.identifiers)I.getOverrideValue(s,y)!==void 0&&v.add(y);return new a(s,c,I.getValue(s),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,r||void 0,u)}keys(s){const c=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,c){this.j.set(s,c),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const o=[];if(!c){const{added:I,updated:r,removed:u}=p(this.c,s);c=[...I,...r,...u]}for(const I of c)for(const r of(0,S.overrideIdentifiersFromKey)(I)){const u=this.c.getKeysForOverrideIdentifier(r),v=s.getKeysForOverrideIdentifier(r),D=[...v.filter(y=>u.indexOf(y)===-1),...u.filter(y=>v.indexOf(y)===-1),...u.filter(y=>!A.equals(this.c.override(r).getValue(y),s.override(r).getValue(y)))];o.push([r,D])}return this.updateDefaultConfiguration(s),{keys:c,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:o,removed:I}=p(this.d,s),r=[...c,...o,...I];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:o,removed:I,overrides:r}=p(this.applicationConfiguration,s),u=[...c,...o,...I];return u.length&&this.updateApplicationConfiguration(s),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:o,removed:I,overrides:r}=p(this.localUserConfiguration,s),u=[...c,...o,...I];return u.length&&this.updateLocalUserConfiguration(s),{keys:u,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:o,removed:I,overrides:r}=p(this.remoteUserConfiguration,s),u=[...c,...o,...I];return u.length&&this.updateRemoteUserConfiguration(s),{keys:u,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:o,removed:I,overrides:r}=p(this.workspaceConfiguration,s),u=[...c,...o,...I];return u.length&&this.updateWorkspaceConfiguration(s),{keys:u,overrides:r}}compareAndUpdateFolderConfiguration(s,c){const o=this.p.get(s),{added:I,updated:r,removed:u,overrides:v}=p(o,c),D=[...I,...r,...u];return(D.length||!o)&&this.updateFolderConfiguration(s,c),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(s){const c=this.p.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:I,removed:r,overrides:u}=p(c,void 0);return{keys:[...o,...I,...r],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,c,o){let I=this.r(c,o);return c.overrideIdentifier&&(I=I.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(I=I.merge(this.d)),I}r({resource:s},c){let o=this.s();if(c&&s){const I=c.getFolder(s);I&&(o=this.t(I.uri)||o);const r=this.m.get(s);r&&(o=o.merge(r))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let c=this.b.get(s);if(!c){const o=this.s(),I=this.j.get(s);I?(c=o.merge(I),this.b.set(s,c)):c=o}return c}u(s,c){if(c&&s){const o=c.getFolder(s);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,c)=>{const{contents:o,overrides:I,keys:r}=this.j.get(c);return s.push([c,{contents:o,overrides:I,keys:r}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.i.keys.forEach(c=>s.add(c)),this.j.forEach(c=>c.keys.forEach(o=>s.add(o))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}w(s){const c=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(o=>c.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>c.add(o)),this.i.getKeysForOverrideIdentifier(s).forEach(o=>c.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(I=>c.add(I))),[...c.values()]}static parse(s){const c=this.x(s.defaults),o=this.x(s.policy),I=this.x(s.application),r=this.x(s.user),u=this.x(s.workspace),v=s.folders.reduce((D,y)=>(D.set(h.URI.revive(y[0]),this.x(y[1])),D),new R.ResourceMap);return new m(c,o,I,r,new g,u,v,new g,new R.ResourceMap)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.Configuration=m;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,c=new Map;for(const I of l)I.keys.forEach(r=>s.add(r)),I.overrides.forEach(([r,u])=>{const v=(0,R.getOrSet)(c,r,new Set);u.forEach(D=>v.add(D))});const o=[];return c.forEach((I,r)=>o.push([r,[...I.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=b;class P{constructor(s,c,o,I){this.change=s,this.f=c,this.g=o,this.h=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of s.keys)this.affectedKeys.add(r);for(const[,r]of s.overrides)for(const u of r)this.affectedKeys.add(u);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(s,c){const o=this.a+s,I=this.d.indexOf(o);if(I<0)return!1;const r=I+o.length;if(r>=this.d.length)return!1;const u=this.d.charCodeAt(r);if(u!==this.b&&u!==this.c)return!1;if(c){const v=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,D=this.g.getValue(s,c,this.h);return!A.equals(v,D)}return!0}}e.ConfigurationChangeEvent=P;function p(l,s){const{added:c,removed:o,updated:I}=i(s?.rawConfiguration,l?.rawConfiguration),r=[],u=l?.getAllOverrideIdentifiers()||[],v=s?.getAllOverrideIdentifiers()||[];if(s){const D=v.filter(y=>!u.includes(y));for(const y of D)r.push([y,s.getKeysForOverrideIdentifier(y)])}if(l){const D=u.filter(y=>!v.includes(y));for(const y of D)r.push([y,l.getKeysForOverrideIdentifier(y)])}if(s&&l){for(const D of u)if(v.includes(D)){const y=i({contents:l.getOverrideValue(void 0,D)||{},keys:l.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});r.push([D,[...y.added,...y.removed,...y.updated]])}}return{added:c,removed:o,updated:I,overrides:r}}function i(l,s){const c=l?s?l.keys.filter(r=>s.keys.indexOf(r)===-1):[...l.keys]:[],o=s?l?s.keys.filter(r=>l.keys.indexOf(r)===-1):[...s.keys]:[],I=[];if(l&&s){for(const r of s.keys)if(l.keys.indexOf(r)!==-1){const u=(0,O.getConfigurationValue)(s.contents,r),v=(0,O.getConfigurationValue)(l.contents,r);A.equals(u,v)||I.push(r)}}return{added:c,removed:o,updated:I}}}),define(Ae[95],Re([1,0,14,3]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof M&&w._code===k.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof M&&w._code===k.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof M&&w._code===k.NoResolverFound}static isHandled(w){return w instanceof M&&w.isHandled}constructor(w,h=k.Unknown,O){super(w),this._message=w,this._code=h,this._detail=O,this.isHandled=h===k.NotAvailable&&O===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function R(A){const w=A.indexOf("+");return w===-1?A:A.substring(0,w)}e.getRemoteAuthorityPrefix=R}),define(Ae[50],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=T;function k(h){if(!h)return;const O=h.indexOf("+");return O<0?h:h.substr(0,O)}e.getRemoteName=k;function M(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=M;function R(h){const{host:O,port:S}=w(h);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:S}}e.parseAuthorityWithPort=R;function A(h,O){let{host:S,port:f}=w(h);return typeof f>"u"&&(f=O),{host:S,port:f}}e.parseAuthorityWithOptionalPort=A;function w(h){const O=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const S=h.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const f=h.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:h,port:void 0}}}),define(Ae[24],Re([1,0,12,3,50]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var A;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const m=typeof t=="string"?t:t.value,b=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(m,b)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=w;class h{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const a of t)this.add(a)}add(t){this.c.add(w.toKey(t))}delete(t){return this.c.delete(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}}e.ExtensionIdentifierSet=h;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(w.toKey(t))}get(t){return this.c.get(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}set(t,a){this.c.set(w.toKey(t),a)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function S(d){return f(d)}e.isApplicationScopedExtension=S;function f(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function g(d,t){if(t){const a=`onResolveRemoteAuthority:${(0,k.getRemoteName)(t)}`;return!!d.activationEvents?.includes(a)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[96],Re([1,0,14,24]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const w of R){const h=this.readActivationEvents(w);h.length>0&&(A[T.ExtensionIdentifier.toKey(w.identifier)]=h)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return A;for(const w in R.contributes){const h=this.a.get(w);if(!h)continue;const O=R.contributes[w],S=Array.isArray(O)?O:[O];try{h(S,A)}catch(f){(0,n.onUnexpectedError)(f)}}return A}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ae[172],Re([1,0,20,51,2,35]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(h){if(n.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function A(h,O,S,f,E,g,d,t,a,m){const b=Object.create(null);b["common.machineId"]=d,b.sessionID=(0,M.generateUuid)()+Date.now(),b.commitHash=E,b.version=g,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.PlatformToString)(n.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=f,b["common.product"]=m||"desktop",t&&(b["common.msftInternal"]=t);let P=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.isLinuxSnap&&(b["common.snap"]="true");const i=R(S);i&&(b["common.platformDetail"]=i);try{const l=await h.readFile(k.URI.file(a));b["common.source"]=l.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function w(h){const O=T.env.USERDNSDOMAIN;if(!O)return!1;const S=O.toLowerCase();return h.some(f=>S===f)}e.verifyMicrosoftInternalDomain=w}),define(Ae[173],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ae[52],Re([1,0,23,9,5,42,50,172,173]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(o){this.value=o}}e.TelemetryTrustedValue=h;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,I){return Promise.resolve(void 0)}publicLog2(o,I){return this.publicLog(o,I)}publicLogError(o,I){return Promise.resolve(void 0)}publicLogError2(o,I){return this.publicLogError(o,I)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class S{async publicLog(o,I,r){}async publicLogError(o,I,r){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(c,o){return k.Event.debounce(o.onDidChangeConfiguration,(r,u)=>{const v=r?new Set([...r.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:v}},1e3,!0)(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(r.source),configurationKeys:Array.from(r.affectedKeys)})})}e.configurationTelemetry=f;function E(c,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!c.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=E;function g(c,o){return!(o.isBuilt||o.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=g;function d(c){const o=c.getValue(w.TELEMETRY_SETTING_ID),I=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(c){const o={},I={},r={};b(c,r);for(let u in r){u=u.length>150?u.substr(u.length-149):u;const v=r[u];typeof v=="number"?I[u]=v:typeof v=="boolean"?I[u]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${v.length}`),o[u]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(o[u]=v)}return{properties:o,measurements:I}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(c){if(!c)return"none";const o=(0,R.getRemoteName)(c);return a.has(o)?o:"other"}e.cleanRemoteAuthority=m;function b(c,o,I=0,r){if(!!c)for(const u of Object.getOwnPropertyNames(c)){const v=c[u],D=r?r+u:u;Array.isArray(v)?o[D]=(0,n.safeStringify)(v):v instanceof Date?o[D]=v.toISOString():(0,T.isObject)(v)?I<2?b(v,o,I+1,D+"."):o[D]=(0,n.safeStringify)(v):o[D]=v}}function P(c,o){const I=c.msftInternalDomains||[],r=o.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(I)||r}e.isInternalTelemetry=P;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p;function i(c,o){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let I=c;const r=[];for(const y of o)for(;;){const W=y.exec(c);if(!W)break;r.push([W.index,y.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(I="";;){const y=v.exec(c);if(!y)break;const W=r.some(([X,_])=>y.index<_&&X<v.lastIndex);!u.test(y[0])&&!W&&(I+=c.substring(D,y.index)+"<REDACTED: user-file-path>",D=v.lastIndex)}return D<c.length&&(I+=c.substr(D)),I}function l(c){if(!c)return c;const o=c.toLowerCase(),I=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of I)if(r.regex.test(o))return`<REDACTED: ${r.label}>`;return c}function s(c,o){return(0,n.cloneAndChange)(c,I=>{if(I instanceof h)return I.value;if(typeof I=="string"){let r=I.replaceAll("%20"," ");r=i(r,o);for(const u of o)r=r.replace(u,"");return r=l(r),r}})}e.cleanData=s}),define(Ae[174],Re([1,0,12,90,24,20,2,14,51,52]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(s,c){return s.uuid&&c.uuid?s.uuid===c.uuid:s.id===c.id?!0:(0,n.compareIgnoreCase)(s.id,c.id)===0}e.areSameExtensions=O;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(c){const o=c.manifest?c.manifest.version:c.version,I=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new f(c.identifier,o,I)}static parse(c){const o=S.exec(c);return o&&o[1]&&o[2]?new f({id:o[1]},o[2],o[4]||void 0):null}constructor(c,o,I="undefined"){this.version=o,this.targetPlatform=I,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof f?O(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=f;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const c=E.exec(s);return c&&c[1]?[t(c[1]),c[2]]:[t(s),void 0]}e.getIdAndVersion=g;function d(s,c){return`${s}.${c}`}e.getExtensionId=d;function t(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(s,c){return t(d(s,c))}e.getGalleryExtensionId=a;function m(s,c){const o=[],I=r=>{for(const u of o)if(u.some(v=>O(c(v),c(r))))return u;return null};for(const r of s){const u=I(r);u?u.push(r):o.push([r])}return o}e.groupByExtension=m;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function P(s){return{id:new h.TelemetryTrustedValue(s.identifier.id),name:new h.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function p(s,c){const o=[],I=c.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const r=I.shift();if(r&&o.every(u=>!O(u.identifier,{id:r}))){const u=s.filter(v=>O(v.identifier,{id:r}));u.length===1&&(o.push(u[0]),I.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=p;async function i(s,c){if(!M.isLinux)return!1;let o;try{o=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){c.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(r))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,c){const o=await i(s,c),I=(0,T.getTargetPlatform)(o?"alpine":M.platform,w.arch);return c.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=l}),define(Ae[175],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=n;function T(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=T;function k(R){return Array.from(R.entries()).map(A=>[A[0],n(A[1].map)])}e.serializeEnvironmentVariableCollections=k;function M(R){return new Map(R.map(A=>[A[0],{map:T(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ae[176],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,M,R=5){const A=M(w=>{const h=typeof w=="string"?w:w.data;let O=this.a.get(k);if(O){O.data.push(h);return}const S=setTimeout(()=>this.flushBuffer(k),R);O={data:[h],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(k),A.dispose()}},this.a.set(k,O)});return A}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const M=this.a.get(k);M&&(this.a.delete(k),this.b(k,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ae[177],Re([1,0,17,85,39,5,9,2,141,70,30]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var S;(function(P){function p(i,l){let s=i.defaults;for(;k.ThemeIcon.isThemeIcon(s);){const c=g.getIcon(s.id);if(!c)return;s=c.defaults}return s}P.getDefinition=p})(S=e.IconContribution||(e.IconContribution={}));var f;(function(P){function p(l){return{weight:l.weight,style:l.style,src:l.src.map(s=>({format:s.format,location:s.location.toString()}))}}P.toJSONObject=p;function i(l){const s=c=>(0,R.isString)(c)?c:void 0;if(l&&Array.isArray(l.src)&&l.src.every(c=>(0,R.isString)(c.format)&&(0,R.isString)(c.location)))return{weight:s(l.weight),style:s(l.style),src:l.src.map(c=>({format:c.format,location:A.URI.parse(c.location)}))}}P.fromJSONObject=i})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class E{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${k.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,i,l,s){const c=this.b[p];if(c){if(l&&!c.description){c.description=l,this.d.properties[p].markdownDescription=`${l} $(${p})`;const r=this.e.enum.indexOf(p);r!==-1&&(this.e.enumDescriptions[r]=l),this.a.fire()}return c}const o={id:p,description:l,defaults:i,deprecationMessage:s};this.b[p]=o;const I={$ref:"#/definitions/icons"};return s&&(I.deprecationMessage=s),l&&(I.markdownDescription=`${l}: $(${p})`),this.d.properties[p]=I,this.e.enum.push(p),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,i){const l=this.f[p];return l||(this.f[p]=i,this.a.fire(),i)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,o)=>c.id.localeCompare(o.id),i=c=>{for(;k.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(c=>this.b[c]);for(const c of s.filter(o=>!!o.description).sort(p))l.push(`|<i class="${i(c)}"></i>|${c.id}|${k.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const c of s.filter(o=>!k.ThemeIcon.isThemeIcon(o.defaults)).sort(p))l.push(`|<i class="${i(c)}"></i>|${c.id}|`);return l.join(`
`)}}const g=new E;O.Registry.add(e.Extensions.IconContribution,g);function d(P,p,i,l){return g.registerIcon(P,p,i,l)}e.registerIcon=d;function t(){return g}e.getIconRegistry=t;function a(){const P=(0,T.getCodiconFontCharacters)();for(const p in P){const i="\\"+P[p].toString(16);g.registerIcon(p,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const m=O.Registry.as(h.Extensions.JSONContribution);m.registerSchema(e.iconsSchemaId,g.getIconSchema());const b=new n.RunOnceScheduler(()=>m.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=d("widget-close",T.Codicon.close,(0,w.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",T.Codicon.arrowUp,(0,w.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",T.Codicon.arrowDown,(0,w.localize)(4,null)),e.syncing=k.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=k.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(Ae[178],Re([1,0,5,42,3,13]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=S;function f(d,t,a,m){if(a===1)return!1;if(a===2&&S(t)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(b?.length===4&&parseInt(b[1])>=18)return!1}return d<1024}e.isPortPrivileged=f;class E{constructor(t,a,m){this.remoteAddress=t,this.localAddress=a,this.b=m,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=E;let g=class{constructor(t,a){this.i=t,this.j=a,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],a=Array.from(this.d.values());for(const m of a){const b=Array.from(m.values());for(const P of b){const p=await P.value;p&&t.push(p)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:a}of t.values())await a.then(m=>m?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,a,m,b,P){this.o(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:m,privacy:b,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(S(t)||O(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const m=this.q(t,a);if(m)return++m.refcount,m.value}openTunnel(t,a,m,b,P,p=!1,i,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${P}.`),!t)return;if(a||(a="localhost"),b||(b=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(t,a,m,b,P,p,i,l);return s?s.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(c);return(c.tunnelRemoteHost!==a||c.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.d.get(t.tunnelRemoteHost);if(a){const m=a.get(t.tunnelRemotePort);m&&(m.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,m))}}}}async n(t,a,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const b=m.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(a),b}}async closeTunnel(t,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const m=this.d.get(t);if(m&&m.has(a)){const b=m.get(a);b.refcount=0,await this.n(t,a,b)}}o(t,a,m){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(a,{refcount:1,value:m})}async p(t,a){const m=this.d.get(t);m&&(await m.get(a)||m.delete(a),m.size===0&&this.d.delete(t))}q(t,a){const m=[t];O(t)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):S(t)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(P=>this.d.get(P));for(const P of b){const p=P?.get(a);if(p)return p}}canTunnel(t){return!!h(t)}s(t,a,m,b,P,p,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${b}.`);const l=m;this.h.add(l);const s=b===void 0?m:b,c={elevationRequired:P?this.isPortPrivileged(s):!1},o={remoteAddress:{host:a,port:m},localAddressPort:b,privacy:p,public:p?p!==A.Private:void 0,protocol:i},I=t.forwardPort(o,c);return I?(this.o(a,m,I),I.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),I}};g=je([Ve(0,M.ILogService),Ve(1,T.IConfigurationService)],g),e.AbstractTunnelService=g}),define(Ae[179],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var T;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ae[180],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(w){return w.scheme!==n.Schemas.file&&w.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=T;function k(w){if(w.folders.length)return w.folders.every(h=>T(h.uri))?w.folders[0].uri:void 0;if(w.configuration&&T(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=k;function M(w){return k(w)?.scheme}e.getVirtualWorkspaceScheme=M;function R(w){return k(w)?.authority}e.getVirtualWorkspaceAuthority=R;function A(w){return k(w)!==void 0}e.isVirtualWorkspace=A}),define(Ae[53],Re([1,0,142,19,48,22,2,3,15]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function h(c){const o=c;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=h;function O(c){return typeof c?.id=="string"&&!h(c)&&!f(c)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(c,o){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,T.basename)(c)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=c;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=S;function f(c){const o=c;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=f;function E(c){const o=c;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const I=c;if(I?.configPath)return{id:I.id,configPath:R.URI.revive(I.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=E;var g;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(c){const o=c;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function t(c){const o=c;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(o,I,r,u,v){this.h=o,this.j=r,this.k=u,this.l=v,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=I}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class m{constructor(o,I){this.raw=I,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,M.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(c){return new m({uri:c,index:0,name:(0,M.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(c,o){return M.extUriBiasedIgnorePathCase.isEqualOrParent(c,o.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function p(c){let o;return R.URI.isUri(c)?o=c:o=c.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function l(c,o){return!P(c,o)&&!p(c)}e.isSavedWorkspace=l;function s(c){return(typeof c=="string"?(0,T.extname)(c):(0,M.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ae[54],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const M=this.c++;return this.b.set(M,k),this.e(),M}get(k,M){return this.b.has(k)?this.b.get(k)[M]:void 0}delete(k){this.b.delete(k),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Ae[37],Re([1,0,15,22,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(A=>{const w=this.b.get(A.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(A,w){w===null?this.b.delete(A.scheme):this.b.set(A.scheme,w)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ae[181],Re([1,0,145,13,167,27]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends k.LogService{constructor(w,h,O){const S=O.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",f=O.remote.isRemote?(0,n.localize)(0,null):w?(0,n.localize)(1,null):(0,n.localize)(2,null);super(h.createLogger(S,{name:f}))}};R=je([Ve(1,T.ILoggerService),Ve(2,M.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(Ae[182],Re([1,0,17]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(R,A,w){this.h=new Map,this.a=R,this.b=A,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(h=>(this.f=h,this)),this.g=this.c.onDidChangeStorage(h=>{h.shared===this.b&&h.key===this.a&&(this.f=h.value)}),this.i=new n.RunOnceScheduler(()=>{const h=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of h.values())O.complete()}catch(O){for(const S of h.values())S.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,A){let w=this.f[R];return typeof w>"u"&&(w=A),w}update(R,A){this.f[R]=A;const w=this.h.get(R);if(w!==void 0)return w.p;const h=new n.DeferredPromise;return this.h.set(R,h),this.i.isScheduled()||this.i.schedule(),h.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class k extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,A){super(R.identifier.value,!0,A),this.j=R}}e.ExtensionGlobalMemento=k}),define(Ae[183],Re([1,0,5,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(R){this.c=R,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,A,w,h){const S=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(A.value,w,h);this.b.fire(S)}$acceptDirtyStateChanged(R,A){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(A)}$acceptModelSaved(R){const A=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Ae[18],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[184],Re([1,0,24,5]),function(ee,e,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,w){k.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),Je(this,k,w,"f"),Fe(this,k,"f").onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(A){return Fe(this,k,"f").get(this.a,A)}store(A,w){return Fe(this,k,"f").store(this.a,A,w)}delete(A){return Fe(this,k,"f").delete(this.a,A)}}e.ExtensionSecrets=M,k=new WeakMap}),define(Ae[71],Re([1,0,3,178,5,18]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(w){function h(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:S.protocol}}w.fromApiTunnel=h;function O(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==T.TunnelPrivacyId.ConstantPrivate&&S.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}w.fromServiceTunnel=O})(R=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=class{constructor(h){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(h){return h}async openTunnel(h,O){}async getTunnels(){return[]}async setTunnelFactory(h){return{dispose:()=>{}}}registerPortsAttributesProvider(h,O){return{dispose:()=>{}}}async $providePortAttributes(h,O,S,f,E){return[]}async $forwardPort(h,O){}async $closeTunnel(h){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=je([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ae[55],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=T}),define(Ae[185],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(w){let h=this.buffers.indexOf(w);return h<0&&(h=this.buffers.length,this.buffers.push(w)),h}}function k(A,w){if(w.serializeBuffersForPostMessage){const h=new T,O=(E,g)=>{if(g instanceof ArrayBuffer){const d=h.add(g);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(g)){const d=M(g);if(d){const t=h.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},S=JSON.stringify(A,O),f=h.buffers.map(E=>{const g=new Uint8Array(E);return n.VSBuffer.wrap(g)});return{message:S,buffers:f}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=k;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(A,w){const h=w.map(f=>{const E=new ArrayBuffer(f.byteLength);return new Uint8Array(E).set(f.buffer),E}),O=w.length?(f,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const g=E,{index:d}=g,t=h[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return E}:void 0;return{message:JSON.parse(A,O),arrayBuffers:h}}e.deserializeWebviewMessage=R}),define(Ae[97],Re([1,0,152,9,2,6,3,30,43,15,40,126,29]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(E=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function d(le){const re=le;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(le,re,V){for(const L of V.visibleEditorPanes)if(L.group.id===re&&le.matches(L.input))return L.getViewState()}e.findViewStateForEditor=t;function a(le){if(u(le))return!1;const re=le;return k.URI.isUri(re?.resource)}e.isResourceEditorInput=a;function m(le){if(u(le))return!1;const re=le;return re?.original!==void 0&&re.modified!==void 0}e.isResourceDiffEditorInput=m;function b(le){if(u(le)||m(le))return!1;const re=le;return re?.primary!==void 0&&re.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function P(le){if(u(le))return!1;const re=le;return re?re.resource===void 0||re.resource.scheme===h.Schemas.untitled||re.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const p=/Untitled-\d+/;function i(le){return le.scheme===h.Schemas.untitled&&le.path.length>1&&!p.test(le.path)}e.isUntitledWithAssociatedResource=i;function l(le){if(u(le))return!1;const re=le;return k.URI.isUri(re?.base?.resource)&&k.URI.isUri(re?.input1?.resource)&&k.URI.isUri(re?.input2?.resource)&&k.URI.isUri(re?.result?.resource)}e.isResourceMergeEditorInput=l;var s;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(re,V){let L=this.a.get(re);return L||(L={source:re,label:V},this.a.set(re,L)),L.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.SaveSourceRegistry=new o;var I;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends M.Disposable{}e.AbstractEditorInput=r;function u(le){return le instanceof r}e.isEditorInput=u;function v(le){const re=le;return k.URI.isUri(re?.preferredResource)}function D(le){const re=le;return u(re?.primary)&&u(re?.secondary)}e.isSideBySideEditorInput=D;function y(le){const re=le;return u(re?.modified)&&u(re?.original)}e.isDiffEditorInput=y;function W(le,re,V,L,K){return Te(L,[(0,S.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const me={...V,limits:{size:Number.MAX_VALUE}};le.openEditor(re,me)}}),(0,S.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=W;function X(le){return u(le?.editor)}e.isEditorInputWithOptions=X;function _(le){const re=le;return X(le)&&re?.group!==void 0}e.isEditorInputWithOptionsAndGroup=_;function J(le){const re=le;return typeof re?.groupId=="number"&&u(re.editor)}e.isEditorIdentifier=J;var j;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class B{getOriginalUri(re,V){if(!re)return;if(l(re))return e.EditorResourceAccessor.getOriginalUri(re.result,V);if(V?.supportSideBySide){const{primary:K,secondary:me}=this.a(re);if(K&&me){if(V?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===$.ANY)return this.getOriginalUri(K,{filterByScheme:V.filterByScheme})??this.getOriginalUri(me,{filterByScheme:V.filterByScheme});re=V.supportSideBySide===$.PRIMARY?K:me}}if(m(re)||b(re)||l(re))return;const L=v(re)?re.preferredResource:re.resource;return!L||!V||!V.filterByScheme?L:this.b(L,V.filterByScheme)}a(re){return D(re)||b(re)?{primary:re.primary,secondary:re.secondary}:y(re)||m(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,V){if(!re)return;if(l(re))return e.EditorResourceAccessor.getCanonicalUri(re.result,V);if(V?.supportSideBySide){const{primary:K,secondary:me}=this.a(re);if(K&&me){if(V?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===$.ANY)return this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:V.filterByScheme});re=V.supportSideBySide===$.PRIMARY?K:me}}if(m(re)||b(re)||l(re))return;const L=re.resource;return!L||!V||!V.filterByScheme?L:this.b(L,V.filterByScheme)}b(re,V){if(Array.isArray(V)){if(V.some(L=>re.scheme===L))return re}else if(V===re.scheme)return re}}e.EditorResourceAccessor=new B;var q;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(q=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(re){const V=this.a=re.get(R.IInstantiationService);for(const[L,K]of this.c)this.e(L,K,V);this.c.clear()}e(re,V,L){const K=L.createInstance(V);this.d.set(re,K)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(re,V){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,V,this.a):this.c.set(re,V),(0,M.toDisposable)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new he);async function Ee(le,re,V){return!le||!le.length?[]:await Promise.all(le.map(async L=>{const K=k.URI.revive(L.fileUri);if(!K){V.info("Cannot resolve the path because it is not valid.",L);return}if(!await re.canHandleResource(K)){V.info("Cannot resolve the path because it cannot be handled",L);return}let Ie=L.exists,Se=L.type;if(typeof Ie!="boolean"||typeof Se!="number")try{Se=(await re.stat(K)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Ie=!0}catch(Ce){V.error(Ce),Ie=!1}if(!Ie&&L.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",L);return}if(Se===w.FileType.Directory){V.info("Cannot resolve the path because it is a directory",L);return}const ve={...L.options,pinned:!0};return Ie?{resource:K,options:ve}:{resource:K,options:ve,forceUntitled:!0}}))}e.pathsToEditors=Ee;var ie;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(ie=e.EditorsOrder||(e.EditorsOrder={}));function ce(le){const re=le;if(!re)return!1;const V=re;if(V.modified)return ce(V.modified);const L=re;return!!(L.contributionsState&&L.viewState&&Array.isArray(L.cursorState))}e.isTextEditorViewState=ce;function de(le){return(0,O.isErrorWithActions)(le)}e.isEditorOpenError=de;function Te(le,re,V){const L=(0,O.createErrorWithActions)(le,re);return L.forceMessage=V?.forceMessage,L.forceSeverity=V?.forceSeverity,L.allowDialog=V?.allowDialog,L}e.createEditorOpenError=Te}),define(Ae[186],Re([1,0,5,153,3,6,28,30,16,63,23,85,177]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",S.Codicon.window,(0,T.localize)(0,null));var E;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(E=e.Extensions||(e.Extensions={}));var g;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function d(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends M.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,w.flatten)([...this.g.values()])}registerViewContainer(c,o,I){const r=this.get(c.id);if(r)return r;const u=c;return u.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,R.getOrSet)(this.g,o,[]).push(u),I?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:o}),u}deregisterViewContainer(c){for(const o of this.g.keys()){const I=this.g.get(o),r=I?.indexOf(c);if(r!==-1){I?.splice(r,1),I.length===0&&this.g.delete(o),this.f.fire({viewContainer:c,viewContainerLocation:o});return}}}get(c){return this.all.filter(o=>o.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(I=>I?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(o=>this.getViewContainerLocation(o)===c)}}A.Registry.add(E.ViewContainersRegistry,new t);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function m(s,c){const o=s.group??a.More,I=c.group??a.More;return o!==I?o.localeCompare(I):(s.order??5)-(c.order??5)}class b extends M.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new h.SetMap}registerViews(c,o){this.registerViews2([{views:c,viewContainer:o}])}registerViews2(c){c.forEach(({views:o,viewContainer:I})=>this.l(o,I)),this.c.fire(c)}deregisterViews(c,o){const I=this.m(c,o);I.length&&this.f.fire({views:I,viewContainer:o})}moveViews(c,o){for(const I of this.j.keys())if(I!==o){const r=this.m(c,I);r.length&&(this.l(r,o),this.g.fire({views:r,from:I,to:o}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const o of this.i){const I=(this.j.get(o)||[]).filter(r=>r.id===c)[0];if(I)return I}return null}getViewContainer(c){for(const o of this.i)if((this.j.get(o)||[]).filter(r=>r.id===c)[0])return o;return null}registerViewWelcomeContent(c,o){return this.k.add(c,o),this.h.fire(c),(0,M.toDisposable)(()=>{this.k.delete(c,o),this.h.fire(c)})}registerViewWelcomeContent2(c,o){const I=new Map;for(const[r,u]of o)this.k.add(c,u),I.set(r,(0,M.toDisposable)(()=>{this.k.delete(c,u),this.h.fire(c)}));return this.h.fire(c),I}getViewWelcomeContent(c){const o=[];return this.k.forEach(c,I=>o.push(I)),o.sort(m)}l(c,o){let I=this.j.get(o);I||(I=[],this.j.set(o,I),this.i.push(o));for(const r of c){if(this.getView(r.id)!==null)throw new Error((0,T.localize)(1,null,r.id));I.push(r)}}m(c,o){const I=this.j.get(o);if(!I)return[];const r=[],u=[];for(const v of I)c.includes(v)?r.push(v):u.push(v);return r.length&&(u.length?this.j.set(o,u):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),r}}A.Registry.add(E.ViewsRegistry,new b),e.IViewsService=(0,k.createDecorator)("viewsService"),e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var P;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,o){this.c=!1,this.d=!1,(0,O.mixin)(this,c),this.d=!!o,this.resolve=async I=>{if(o&&!this.c){const r=await o(I);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}I.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class l extends Error{constructor(c){super((0,T.localize)(2,null,c))}}e.NoTreeViewError=l}),define(Ae[187],Re([1,0,5,17,154]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,w,h,O){const S={command:A};if(w&&Object.keys(w).length>0&&(S.arguments=w),this.s("request",S),typeof O=="number"){const f=setTimeout(()=>{clearTimeout(f);const E=this.f.get(S.seq);if(E){this.f.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:A,message:(0,k.localize)(0,null,O,A)};E(g)}},O)}return h&&this.f.set(S.seq,h),S.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,w){return A.type!=="event"||w.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,T.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const w=A,h=this.f.get(w.request_seq);h&&(this.f.delete(w.request_seq),h(w));break}}}}s(A,w){w.type=A,w.seq=this.d++,this.sendMessage(w)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((w,h)=>A.set(h,w)),await(0,T.timeout)(500),A.forEach((w,h)=>{w({type:"response",seq:0,request_seq:h,success:!1,command:"canceled",message:"canceled"}),this.f.delete(h)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ae[188],Re([1,0,155,31,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=f=>n.localize(51,null,f);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var R;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(R=e.State||(e.State={}));function A(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var w;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var h;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(h=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var S;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ae[189],Re([1,0,12,2,19,23,15,44,21,16]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function S(r,u,v){return r.replace(O,function(D,y){return u&&y.length>0&&y[0]!=="_"?D:v&&v.hasOwnProperty(y)?v[y]:D})}e.formatPII=S;function f(r){const u={};for(const v of Object.keys(r))v.startsWith("!")||(u[v]=r[v]);return u}e.filterExceptionsFromTelemetry=f;function E(r){return r.configuration.request==="attach"&&!g(r)&&(!r.parentSession||E(r.parentSession))}e.isSessionAttach=E;function g(r){let u=r.configuration.type;if(!!u)return u==="vslsShare"&&(u=r.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(u,"extensionhost")||(0,n.equalsIgnoreCase)(u,"pwa-extensionhost")?r:r.parentSession?g(r.parentSession):void 0}e.getExtensionHostDebugSession=g;function d(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=d;function t(r,u,v){let D,y=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let X=null;for(;X=W.exec(r);){const _=X.index+1,J=_+X[0].length;if(_<=u&&J>=v){D=X[0],y=_;break}}if(D){const _=/\w+/g;let J=null;for(;(J=_.exec(D))&&!(J.index+1+y+J[0].length>=v););J&&(D=D.substring(0,_.lastIndex))}return D?{start:y,end:y+D.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(r,u,v,D){if(r.evaluatableExpressionProvider.has(u)){const y=r.evaluatableExpressionProvider.ordered(u),W=(0,h.coalesce)(await Promise.all(y.map(async X=>{try{return await X.provideEvaluatableExpression(u,v,D??w.CancellationToken.None)}catch{return}})));if(W.length>0){let X=W[0].expression;const _=W[0].range;return X||(X=u.getLineContent(v.lineNumber).substring(_.startColumn-1,_.endColumn-1)),{range:_,matchingExpression:X}}}else{const y=u.getLineContent(v.lineNumber),{start:W,end:X}=t(y,v.column,v.column),_=y.substring(W-1,X);return{matchingExpression:_,range:new A.Range(v.lineNumber,W,v.lineNumber,W+_.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(r){return!!(r&&r.match(m))}e.isUri=b;function P(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(b(r.path))return T.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return T.URI.file(r.path)}return r.path}function p(r){if(typeof r.path=="object"){const u=T.URI.revive(r.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return r.path}function i(r,u){const v=u?P:p,D=(0,M.deepClone)(r);return s(D,(y,W)=>{y&&W&&(W.path=v(W))}),D}e.convertToDAPaths=i;function l(r,u){const v=u?P:p,D=(0,M.deepClone)(r);return s(D,(y,W)=>{!y&&W&&(W.path=v(W))}),D}e.convertToVSCPaths=l;function s(r,u){switch(r.type){case"event":{const v=r;switch(v.event){case"output":u(!1,v.body.source);break;case"loadedSource":u(!1,v.body.source);break;case"breakpoint":u(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=r;switch(v.command){case"setBreakpoints":u(!0,v.arguments.source);break;case"breakpointLocations":u(!0,v.arguments.source);break;case"source":u(!0,v.arguments.source);break;case"gotoTargets":u(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(D=>u(!1,D));break;default:break}break}case"response":{const v=r;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(D=>u(!1,D.source));break;case"loadedSources":v.body.sources.forEach(D=>u(!1,D));break;case"scopes":v.body.scopes.forEach(D=>u(!1,D.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(D=>u(!1,D.source));break;case"setBreakpoints":v.body.breakpoints.forEach(D=>u(!1,D.source));break;case"disassemble":v.body?.instructions.forEach(y=>u(!1,y.location));break;default:break}break}}}function c(r){return r.filter(u=>!u.presentation?.hidden).sort((u,v)=>u.presentation?v.presentation?u.presentation.group?v.presentation.group?u.presentation.group!==v.presentation.group?u.presentation.group.localeCompare(v.presentation.group):o(u.presentation.order,v.presentation.order):-1:v.presentation.group?1:o(u.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=c;function o(r,u){return typeof r!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:r-u}async function I(r,u){const v=r.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(v!=="none"&&(await u.saveAll(),v==="allEditorsInActiveGroup")){const D=u.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:D.input,groupId:D.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Ae[72],Re([1,0,25,36,190,65,15,19,20,31]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var f;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var m;(function($){$.scheme=R.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${B.join("")}]+`),he=7;function Ee(re,V){const L=V.toString(he),me=`${L.length<B.length?B[L.length-1]:"z"}${L}s${(0,n.encodeBase64)(n.VSBuffer.fromString(re.scheme),!0,!0)}`;return re.with({scheme:$.scheme,fragment:me})}$.generate=Ee;function ie(re){if(re.scheme!==$.scheme)return;const V=re.fragment.indexOf("s");if(V<0)return;const L=parseInt(re.fragment.substring(0,V).replace(q,""),he),K=(0,n.decodeBase64)(re.fragment.substring(V+1)).toString();if(!isNaN(L))return{handle:L,notebook:re.with({scheme:K,fragment:null})}}$.parse=ie;function ce(re,V){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${V??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}$.generateCellOutputUri=ce;function de(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const V=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!V)return;const L=V[1]&&V[1]!==""?V[1]:void 0,K=V[2];return{outputId:L,notebook:re.with({scheme:K||R.Schemas.file,fragment:null})}}$.parseCellOutputUri=de;function Te(re,V,L){return $.generate(re,V).with({scheme:L})}$.generateCellPropertyUri=Te;function le(re,V){if(re.scheme===V)return $.parse(re.with({scheme:$.scheme}))}$.parseCellPropertyUri=le})(m=e.CellUri||(e.CellUri={}));const b=$=>w.isWindows?$.replace(/\//g,"\\"):$;class P{constructor(B=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.e=q,this.d=[...new Set(B)].map(he=>({pattern:he,matches:T.parse(b(he))}))}sort(B){const q=new Map(k.Iterable.map(B,Ee=>[Ee,b(Ee)]));let he=[];for(const{matches:Ee}of this.d)for(const[ie,ce]of q)if(Ee(ce)){he.push(ie),q.delete(ie);break}return q.size&&(he=he.concat([...q.keys()].sort((Ee,ie)=>this.e.indexOf(Ee)-this.e.indexOf(ie)))),he}prioritize(B,q){const he=this.f(B);if(he===-1){this.d.unshift({pattern:B,matches:T.parse(b(B))});return}const Ee=new Set(q.map(ce=>this.f(ce,he)));Ee.delete(-1);const ie=Array.from(Ee).sort();this.d.splice(he+1,0,...ie.map(ce=>this.d[ce]));for(let ce=ie.length-1;ce>=0;ce--)this.d.splice(ie[ce],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,q=this.d.length){const he=b(B);for(let Ee=0;Ee<q;Ee++)if(this.d[Ee].matches(he))return Ee;return-1}}e.MimeTypeDisplayOrder=P;function p($,B,q,he=(Ee,ie)=>Ee===ie){const Ee=[];function ie(Te,le,re){if(le===0&&re.length===0)return;const V=Ee[Ee.length-1];V&&V.start+V.deleteCount===Te?(V.deleteCount+=le,V.toInsert.push(...re)):Ee.push({start:Te,deleteCount:le,toInsert:re})}let ce=0,de=0;for(;;){if(ce===$.length){ie(ce,0,B.slice(de));break}if(de===B.length){ie(ce,$.length-ce,[]);break}const Te=$[ce],le=B[de];if(he(Te,le)){ce+=1,de+=1;continue}q(le)?(ie(ce,1,[]),ce+=1):(ie(ce,0,[le]),de+=1)}return Ee}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function($){$.default="default",$.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l($){const B=$;return!!((typeof B.include=="string"||T.isRelativePattern(B.include))&&(typeof B.exclude=="string"||T.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=l;function s($,B,q){if(Array.isArray($.viewType)&&$.viewType.indexOf(B)>=0||$.viewType===B)return!0;if($.filenamePattern){const he=l($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,Ee=l($.filenamePattern)?$.filenamePattern.exclude:void 0;if(T.match(he,(0,A.basename)(q.fsPath).toLowerCase()))return!(Ee&&T.match(Ee,(0,A.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(B){return`${o.d}${B}`}static parse(B){if(B.startsWith(o.d))return B.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function I($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=I;const r=new TextDecoder;function u($){const B=[];let q=!1;for(const he of $)(B.length===0||q)&&(B.push(he),q=!0);return W(B),U(n.VSBuffer.concat(B.map(he=>n.VSBuffer.wrap(he))))}e.compressOutputItemStreams=u;const v=`${String.fromCharCode(27)}[A`,D=v.split("").map($=>$.charCodeAt(0)),y=10;function W($){$.forEach((B,q)=>{if(q===0||B.length<v.length)return;const he=$[q-1],Ee=B.subarray(0,v.length);if(Ee[0]===D[0]&&Ee[1]===D[1]&&Ee[2]===D[2]){const ie=he.lastIndexOf(y);if(ie===-1)return;$[q-1]=he.subarray(0,ie),$[q]=B.subarray(v.length)}})}function X($){let B=$;do $=B,B=$.replace(/[^\n]\x08/gm,"");while(B.length<$.length);return $}function _($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const B=$.match(/^(.*)\r+/m)[1];let q=$.match(/\r+(.*)$/m)[1];q=q+B.slice(q.length,B.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return $}const J="\b".charCodeAt(0),j="\r".charCodeAt(0);function U($){return!$.buffer.includes(J)&&!$.buffer.includes(j)?$:n.VSBuffer.fromString(_(X(r.decode($.buffer))))}}),define(Ae[191],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(R,A,w=R.parent){if(R._isRoot)return new k([A]);const h=[R.id];for(let O=w;O&&O.id!==A;O=O.parent)h.push(O.id);return h.push(A),new k(h.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const A=R.indexOf("\0");return A===-1?R:R.slice(0,A)}static fromString(R){return new k(R.split("\0"))}static join(R,A){return new k([...R.path,A])}static joinToString(R,A){return R.toString()+"\0"+A}static parentId(R){const A=R.lastIndexOf("\0");return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf("\0");return A===-1?R:R.slice(A+1)}static compare(R,A){return R===A?0:A.startsWith(R+"\0")?2:R.startsWith(A+"\0")?3:1}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new k(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new k(this.path,R)}compare(R){if(typeof R=="string")return k.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.TestId=k}),define(Ae[56],Re([1,0,2,44,45]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var R;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=r=>"runId"in r;e.isStartControllerTests=A;var w;(function(r){r.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),r.deserialize=u=>({range:T.Range.lift(u.range),uri:n.URI.revive(u.uri)})})(w=e.IRichLocation||(e.IRichLocation={}));var h;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(h=e.TestMessageType||(e.TestMessageType={}));var O;(function(r){r.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&w.serialize(u.location)}),r.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&w.deserialize(u.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const S=(r,u)=>`${u?"s":"e"}${r}`;e.getMarkId=S;var f;(function(r){r.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&w.serialize(u.location)}),r.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&w.deserialize(u.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(r){r.serialize=u=>u.type===0?O.serialize(u):f.serialize(u),r.deserialize=u=>u.type===0?O.deserialize(u):f.deserialize(u)})(E=e.ITestMessage||(e.ITestMessage={}));var g;(function(r){r.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),r.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(E.serialize)}),r.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(E.deserialize)})})(g=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",t=(r,u)=>r+d+u;e.namespaceTestTag=t;const a=r=>{const u=r.indexOf(d);return{ctrlId:r.slice(0,u),tagId:r.slice(u+1)}};e.denamespaceTestTag=a;var m;(function(r){r.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),r.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?n.URI.revive(u.uri):void 0,range:u.range?T.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(m=e.ITestItem||(e.ITestItem={}));var b;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(r){r.serialize=u=>({expand:u.expand,item:m.serialize(u.item)}),r.deserialize=u=>({controllerId:k.TestId.root(u.item.extId),expand:u.expand,item:m.deserialize(u.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=u=>{let v;return u.item&&(v={},u.item.label!==void 0&&(v.label=u.item.label),u.item.tags!==void 0&&(v.tags=u.item.tags),u.item.busy!==void 0&&(v.busy=u.item.busy),u.item.uri!==void 0&&(v.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(v.range=u.item.range?.toJSON()),u.item.description!==void 0&&(v.description=u.item.description),u.item.error!==void 0&&(v.error=u.item.error),u.item.sortText!==void 0&&(v.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:v}},r.deserialize=u=>{let v;return u.item&&(v={},u.item.label!==void 0&&(v.label=u.item.label),u.item.tags!==void 0&&(v.tags=u.item.tags),u.item.busy!==void 0&&(v.busy=u.item.busy),u.item.range!==void 0&&(v.range=u.item.range?T.Range.lift(u.item.range):null),u.item.description!==void 0&&(v.description=u.item.description),u.item.error!==void 0&&(v.error=u.item.error),u.item.sortText!==void 0&&(v.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:v}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,u)=>{u.expand!==void 0&&(r.expand=u.expand),u.item!==void 0&&(r.item=r.item?Object.assign(r.item,u.item):u.item)};e.applyTestItemUpdate=i;var l;(function(r){r.serializeWithoutMessages=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serializeWithoutMessages),retired:u.retired}),r.serialize=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serialize),retired:u.retired}),r.deserialize=u=>({...P.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var s;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var c;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(r){r.deserialize=u=>u.op===0?{op:u.op,item:P.deserialize(u.item)}:u.op===1?{op:u.op,item:p.deserialize(u.item)}:u.op===2?{op:u.op,uri:n.URI.revive(u.uri),docv:u.docv}:u,r.serialize=u=>u.op===0?{op:u.op,item:P.serialize(u.item)}:u.op===1?{op:u.op,item:p.serialize(u.item)}:u})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const v=this.o();for(const D of u)switch(D.op){case 0:this.j(P.deserialize(D.item),v);break;case 1:this.k(p.deserialize(D.item),v);break;case 3:this.l(D.itemId,v);break;case 5:this.m(D.itemId);break;case 4:this.updatePendingRoots(D.amount);break;case 6:this.c.set(D.tag.id,D.tag);break;case 7:this.c.delete(D.id);break}v.complete?.()}j(u,v){const D=k.TestId.parentId(u.item.extId)?.toString();let y;if(!D)y=this.p(u),this.f.add(y),this.d.set(u.item.extId,y);else if(this.d.has(D)){const W=this.d.get(D);W.children.add(u.item.extId),y=this.p(u,W),this.d.set(u.item.extId,y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return v.add?.(y),u.expand===2&&this.g++,y}k(u,v){const D=this.d.get(u.extId);if(!!D)return u.expand!==void 0&&(D.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(D,u),v.update?.(D),D}l(u,v){const D=this.d.get(u);if(!D)return;const y=k.TestId.parentId(D.item.extId)?.toString();y?this.d.get(y).children.delete(D.item.extId):this.f.delete(D);const W=[[u]];for(;W.length;)for(const X of W.pop()){const _=this.d.get(X);_&&(W.push(_.children),this.d.delete(X),v.remove?.(_,_!==D),_.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=I}),define(Ae[73],Re([1,0,17,5,6,49,56,45]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const h=(m,b)=>m===b,S=Object.entries({range:(m,b)=>m===b?!0:!m||!b?!1:m.equalsRange(b),busy:h,label:h,description:h,error:h,sortText:h,tags:(m,b)=>!(m.length!==b.length||m.some(P=>!b.includes(P)))}),f=(m,b)=>{let P;for(const[p,i]of S)i(m[p],b[p])||(P?P[p]=b[p]:P={[p]:b[p]});return P};class E extends k.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.D(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(b){this.h=b;for(const P of this.tree.values())this.G(P)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===b.uri){P.docv=b.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===b.item.extId){(0,R.applyTestItemUpdate)(P.item,b.item);return}if(P.op===0&&P.item.item.extId===b.item.extId){(0,R.applyTestItemUpdate)(P.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,P){const p=this.tree.get(b);if(!!p){if((p.expandLevels===void 0||P>p.expandLevels)&&(p.expandLevels=P),p.expand===1){const i=this.I(p);return i.isOpen()?this.H(p,P-1):i.wait().then(()=>this.H(p,P-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,P-1)):this.H(p,P-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,P){switch(P.op){case 3:this.L(A.TestId.joinToString(b.fullId,P.id));break;case 0:this.s(P.item,b);break;case 5:for(const p of P.ops)this.p(b,p);break;case 1:this.u(P.new,P.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:P.update}});break;case 6:this.q(b.actual.uri);break;default:(0,M.assertNever)(P)}}q(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}s(b,P){const p=A.TestId.fromExtHostTestItem(b,this.root.id,P?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==P?.actual&&this.m.getChildren(i.parent).delete(b.id);let l=this.tree.get(p.toString());if(!l){l={fullId:p,actual:b,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},b.tags.forEach(this.w,this),this.tree.set(l.fullId.toString(),l),this.z(b,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(b)}}),this.F(b,l,P);return}if(l.actual===b){this.C(b,l,P);return}if(l.actual.uri?.toString()!==b.uri?.toString())return this.L(p.toString()),this.s(b,P);const s=this.m.getChildren(l.actual),c=l.actual,o=f(this.m.toITestItem(c),this.m.toITestItem(b));this.m.getApiFor(c).listener=void 0,l.actual=b,l.expand=0,o&&(o.hasOwnProperty("tags")&&(this.u(b.tags,c.tags,p.toString()),delete o.tags),this.p(l,{op:4,update:o})),this.F(b,l,P);for(const[I,r]of s)this.m.getChildren(b).get(r.id)||this.L(A.TestId.joinToString(p,r.id));this.q(l.actual.uri)}u(b,P,p){const i=new Set(P.map(l=>l.id));for(const l of b)i.delete(l.id)||this.w(l);this.pushDiff({op:1,item:{extId:p,item:{tags:b.map(l=>(0,R.namespaceTestTag)(this.m.controllerId,l.id))}}}),i.forEach(this.y,this)}w(b){const P=this.j.get(b.id);P?P.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.m.controllerId,b.id)}}))}y(b){const P=this.j.get(b);P&&!--P.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.m.controllerId,b)}))}z(b,P){this.m.getApiFor(b).parent=P&&P.actual!==this.root?P.actual:void 0}C(b,P,p){this.z(b,p);const i=this.m.getApiFor(b);i.parent=p?.actual,i.listener=l=>this.p(P,l),this.G(P)}F(b,P,p){this.C(b,P,p);for(const[i,l]of this.m.getChildren(b))this.s(l,P)}G(b){let P;this.h?b.resolveBarrier?P=b.resolveBarrier.isOpen()?3:2:P=b.actual.canResolveChildren?1:0:P=0,P!==b.expand&&(b.expand=P,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:P}}),P===1&&b.expandLevels!==void 0&&this.I(b))}H(b,P){if(P<0)return;const p=[];for(const[i,l]of this.m.getChildren(b.actual)){const s=this.expand(A.TestId.joinToString(b.fullId,l.id),P);(0,n.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const l=new n.Barrier;return l.open(),l}b.expand=2,this.J(b);const P=b.resolveBarrier=new n.Barrier,p=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(l){p(l)}return(0,n.isThenable)(i)?i.catch(p).then(()=>{P.open(),this.G(b)}):(P.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const P=this.tree.get(b);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const p=[P];for(;p.length;){const i=p.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.y(l.id);this.tree.delete(i.fullId.toString());for(const[l,s]of this.m.getChildren(i.actual))p.push(this.tree.get(A.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=E;class g extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=g;class d extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(b,P,p){super(`TestItem with ID "${b}" is from controller "${P}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const a=(m,b,P)=>{let p=new Map;return{get size(){return p.size},forEach(i,l){for(const s of p.values())i.call(l,s,this)},[Symbol.iterator](){return p.entries()},replace(i){const l=new Map,s=new Set(p.keys()),c={op:5,ops:[]};for(const o of i){if(!(o instanceof P))throw new d(o.id);const I=b(o).controllerId;if(I!==m.controllerId)throw new t(o.id,I,m.controllerId);if(l.has(o.id))throw new g(o.id);l.set(o.id,o),s.delete(o.id),c.ops.push({op:0,item:o})}for(const o of s.keys())c.ops.push({op:3,id:o});m.listener?.(c),p=l},add(i){if(!(i instanceof P))throw new d(i.id);p.set(i.id,i),m.listener?.({op:0,item:i})},delete(i){p.delete(i)&&m.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=a}),define(Ae[98],Re([1,0,73]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,k=(R,A)=>{const w={controllerId:A};return T.set(R,w),w};e.createPrivateApiFor=k;const M=R=>{const A=T.get(R);if(!A)throw new n.InvalidTestItemError(R?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ae[74],Re([1,0,15,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(A,w){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(w&&w.authority&&w.isRemote&&A.scheme===n.Schemas.file&&(A=T.URI.from({scheme:n.Schemas.vscodeRemote,authority:w.authority,path:A.path})),T.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=k;function M(A){return A.replace(/./g,w=>{const h=w.charCodeAt(0);return h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57?w:"-"+h.toString(16).padStart(4,"0")})}function R(A){return A.replace(/-([0-9a-f]{4})/g,(w,h)=>String.fromCharCode(parseInt(h,16)))}e.decodeAuthority=R}),define(Ae[192],Re([1,0,5,6,74]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,w,h){this.d=A,this.e=w,this.f=h,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const O=w.getVisibleTextEditors();for(const S of this.c.values())O.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,w,h,O,S){let f;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){f=b;break}if(!f)throw new Error("not a visible editor");const E=this,g=this.a++,d=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,k.asWebviewUri)(b,E.f)}get cspSource(){return k.webviewGenericCspSource}set options(b){this.b=b,E.d.$setOptions(g,b)}get options(){return this.b}set html(b){this.a=b,E.d.$setHtml(g,b)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(b){return E.d.$postMessage(g,b)}},m=new class{constructor(){this.editor=A,this.line=w,this.height=h,this.webview=a,this.onDidDispose=t.event}dispose(){E.c.has(g)&&(E.c.delete(g),E.d.$disposeEditorInset(g),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset(g,f.id,f.value.document.uri,w+1,h,O||{},S.identifier,S.extensionLocation),this.c.set(g,{editor:A,inset:m,onDidReceiveMessage:d}),m}$onDidDispose(A){const w=this.c.get(A);w&&w.inset.dispose()}$onDidReceiveMessage(A,w){this.c.get(A)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=M}),define(Ae[193],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(R,A){super(A),this.variable=R}}e.VariableError=k}),define(Ae[194],Re([1,0,19,51,9,23,20,88,158,193,12]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(E,g,d,t){this.g=new Map,this.a=E,this.b=g,this.d=d,t&&(this.c=t.then(a=>this.h(a)))}h(E){if(R.isWindows){const g=Object.create(null);return Object.keys(E).forEach(d=>{g[d.toLowerCase()]=E[d]}),g}return E}resolveWithEnvironment(E,g,d){return this.j({env:this.h(E),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(E,g){const d={env:await this.c,userHome:await this.d};return this.j(d,E?E.uri:void 0,g)}async i(E,g,d,t){const a=M.deepClone(g);R.isWindows&&a.windows?Object.keys(a.windows).forEach(b=>a[b]=a.windows[b]):R.isMacintosh&&a.osx?Object.keys(a.osx).forEach(b=>a[b]=a.osx[b]):R.isLinux&&a.linux&&Object.keys(a.linux).forEach(b=>a[b]=a.linux[b]),delete a.windows,delete a.osx,delete a.linux;const m={env:await this.c,userHome:await this.d};return this.j(m,E?E.uri:void 0,a,d,t)}async resolveAnyAsync(E,g,d){return this.i(E,g,d)}async resolveAnyMap(E,g,d){const t=new Map;return{newConfig:await this.i(E,g,d,t),resolvedVariables:t}}resolveWithInteractionReplace(E,g,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,g,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,g){if(this.g.has(E))throw new Error("Variable "+E+" is contributed twice.");this.g.set(E,g)}async j(E,g,d,t,a){if(k.isString(d))return this.l(E,g,d,t,a);if(Array.isArray(d))return Promise.all(d.map(m=>this.j(E,g,m,t,a)));if(k.isObject(d)){const m=Object.create(null),b=await Promise.all(Object.keys(d).map(async P=>[await this.l(E,g,P,t,a),await this.j(E,g,d[P],t,a)]));for(const[P,p]of b)m[P]=p;return m}return d}l(E,g,d,t,a){return(0,O.replaceAsync)(d,S.VARIABLE_REGEXP,async(m,b)=>{if(b.includes(S.VARIABLE_LHS))return m;let P=await this.n(E,m,b,g,t);return a?.set(b,P),P!==m&&k.isString(P)&&P.match(S.VARIABLE_REGEXP)&&(P=await this.l(E,g,P,t,a)),P})}m(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async n(E,g,d,t,a){let m;const b=d.split(":");b.length>1&&(d=b[0],m=b[1]);const P=l=>{const s=this.a.getFilePath();if(s)return(0,A.normalizeDriveLetter)(s);throw new h.VariableError(l,(0,w.localize)(0,null,g))},p=l=>{const s=P(l);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,A.normalizeDriveLetter)(c)}throw new h.VariableError(l,(0,w.localize)(1,null,g,n.basename(s)))},i=l=>{if(m){const s=this.a.getFolderUri(m);if(s)return s;throw new h.VariableError(l,(0,w.localize)(2,null,g,m))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new h.VariableError(l,(0,w.localize)(3,null,g)):new h.VariableError(l,(0,w.localize)(4,null,g))};switch(d){case"env":if(m){if(E.env){const l=E.env[R.isWindows?m.toLowerCase():m];if(k.isString(l))return l}return""}throw new h.VariableError(h.VariableKind.Env,(0,w.localize)(5,null,g));case"config":if(m){const l=this.a.getConfigurationValue(t,m);if(k.isUndefinedOrNull(l))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(6,null,g,m));if(k.isObject(l))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(7,null,g,m));return l}throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(8,null,g));case"command":return this.o(h.VariableKind.Command,g,m,a,"command");case"input":return this.o(h.VariableKind.Input,g,m,a,"input");case"extensionInstallFolder":if(m){const l=await this.a.getExtension(m);if(!l)throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,g,m));return this.m(l.extensionLocation)}throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(h.VariableKind.WorkspaceFolder)));case"cwd":return t||m?(0,A.normalizeDriveLetter)(this.m(i(h.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.m(i(h.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new h.VariableError(h.VariableKind.UserHome,(0,w.localize)(11,null,g))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new h.VariableError(h.VariableKind.LineNumber,(0,w.localize)(12,null,g))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new h.VariableError(h.VariableKind.SelectedText,(0,w.localize)(13,null,g))}case"file":return P(h.VariableKind.File);case"fileWorkspaceFolder":return p(h.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||m?n.relative(this.m(i(h.VariableKind.RelativeFile)),P(h.VariableKind.RelativeFile)):P(h.VariableKind.RelativeFile);case"relativeFileDirname":{const l=n.dirname(P(h.VariableKind.RelativeFileDirname));if(t||m){const s=n.relative(this.m(i(h.VariableKind.RelativeFileDirname)),l);return s.length===0?".":s}return l}case"fileDirname":return n.dirname(P(h.VariableKind.FileDirname));case"fileExtname":return n.extname(P(h.VariableKind.FileExtname));case"fileBasename":return n.basename(P(h.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=n.basename(P(h.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-n.extname(l).length)}case"fileDirnameBasename":return n.basename(n.dirname(P(h.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||g}case"execInstallFolder":{const l=this.a.getAppRoot();return l||g}case"pathSeparator":return n.sep;default:try{const l=m?`${d}:${m}`:d;return this.o(h.VariableKind.Unknown,g,l,a,void 0)}catch{return g}}}}o(E,g,d,t,a){if(d&&t){const m=a===void 0?t[d]:t[a+":"+d];if(typeof m=="string")return m;throw new h.VariableError(E,(0,w.localize)(14,null,g))}return g}}S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=S}),define(Ae[99],Re([1,0,3,97]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var k;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function h(g){const d=g;return(0,T.isEditorInput)(d?.editor)&&(0,T.isEditorInput)(d?.replacement)}e.isEditorReplacement=h;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function f(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=f;function E(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ae[195],Re([1,0,3,99]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(M){const R=M;return typeof M=="number"||(0,T.isEditorGroup)(R)}e.isPreferredGroup=k}),define(Ae[196],Re([1,0,3,164]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(T.IEnvironmentService)}),define(Ae[100],Re([1,0,24,5,19,6]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class A{static isHostExtension(t,a,m){if(a.getExtensionDescription(t))return!1;const b=m.getExtensionDescription(t);return b?!!((b.main||b.browser)&&b.api==="none"):!1}constructor(t,a){this.h=t,this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=a,this.j()}j(){this.d.sort(E),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const a=this.h.readActivationEvents(t);if(Array.isArray(a))for(let m of a)m==="onUri"&&(m=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,a){this.d=g(this.d,a),this.d=this.d.concat(t);const m=A.k(this.d);return this.d=g(this.d,m.map(b=>b.identifier)),this.j(),this.c.fire(void 0),new R(m)}static k(t){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,l){this.addNode(i),this.addNode(l),this.c.has(i)?this.c.get(i).push(l):this.c.set(i,[l])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,l){const s=a.getArcs(i);for(let c=0;c<s.length;c++)if(!l.has(s[c]))return!1;return!0}getNodes(){return this.e}},m=new n.ExtensionIdentifierMap;for(const i of t)if(m.set(i.identifier,i),i.extensionDependencies)for(const l of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(l));const b=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>b.add(i));const P=a.getNodes().filter(i=>!b.has(i));let p;do{p=!1;for(let i=0;i<P.length;i++){const l=P[i];a.hasOnlyGoodArcs(l,b)&&(P.splice(i,1),i--,b.add(l),p=!0)}}while(p);return P.map(i=>m.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this.g.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const a=this.e.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this.f)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class w{constructor(t){this.d=new S,this.c=new A(t,[])}async acquireLock(t){const a=await this.d.acquire(t);return new h(this,a)}deltaExtensions(t,a,m){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,m)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this.c.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=w;class h extends M.Disposable{constructor(t,a){super(),this.f=t,this.c=!1,this.D(a)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=h;class O{constructor(t){this.name=t,this.promise=new Promise((a,m)=>{this.c=a})}resolve(t){this.c(t)}}class S{constructor(){this.c=[],this.d=!1}async acquire(t){const a=new O(t);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let a=!0;const m=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),b=()=>{!a||(clearTimeout(m),a=!1,this.d=!1,this.e())};t.resolve((0,M.toDisposable)(b))}}var f;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(f||(f={}));function E(d,t){const a=d.isBuiltin?0:d.isUnderDevelopment?2:1,m=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==m)return a-m;const b=k.posix.basename(d.extensionLocation.path),P=k.posix.basename(t.extensionLocation.path);return b<P?-1:b>P?1:0}function g(d,t){const a=new n.ExtensionIdentifierSet(t);return d.filter(m=>!a.has(m.identifier))}}),define(Ae[75],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(h){h[h.VersionMismatch=55]="VersionMismatch",h[h.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(h){h[h.Initialized=0]="Initialized",h[h.Ready=1]="Ready",h[h.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function R(h){const O=n.VSBuffer.alloc(1);switch(h){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=R;function A(h,O){if(h.byteLength!==1)return!1;switch(h.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var w;(function(h){h.Start="START_NATIVE_LOG",h.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ae[57],Re([1,0,3,5,13,27,75,50,52,23,2,6,148]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends S.Disposable{constructor(a,m){super(),this.m=a,this.n=m,this.a=this.D(new T.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new T.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=m.createLogger(this.j,{id:w.extensionTelemetryLogChannelId,name:(0,f.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(m.onDidChangeLogLevel(b=>{(0,k.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,m,b){const P=this.getTelemetryDetails(),p=new g(m,b,a,this.k,this.i,this.getBuiltInCommonProperties(a),{isUsageEnabled:P.isUsageEnabled,isErrorsEnabled:P.isErrorsEnabled});return this.l.set(a.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(a,m,b){this.f=a,this.g=m,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(a){const m={};switch(m["common.extname"]=`${a.publisher}.${a.name}`,m["common.extversion"]=a.version,m["common.vscodemachineid"]=this.m.telemetryInfo.machineId,m["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,m["common.vscodeversion"]=this.m.version,m["common.isnewappinstall"]=d(this.m.telemetryInfo.firstSessionDate),m["common.product"]=this.m.environment.appHost,this.m.uiKind){case R.UIKind.Web:m["common.uikind"]="web";break;case R.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,A.getRemoteName)((0,w.cleanRemoteAuthority)(this.m.remote.authority)),m}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const m=this.getTelemetryDetails();this.l.forEach((b,P)=>{b.isDisposed&&this.l.delete(P)}),this.l.forEach(b=>{b.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(a,m){const b=this.l.get(a.value);return b&&b.isDisposed?(this.l.delete(a.value),!1):!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(m),!0)}};E=je([Ve(0,M.IExtHostInitDataService),Ve(1,k.ILoggerService)],E),e.ExtHostTelemetry=E;class g{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,m,b,P,p,i,l){this.g=b,this.h=P,this.i=p,this.j=i,this.a=new T.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(a,m){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let m=a.properties??a;return m=(0,w.cleanData)(m,[]),this.c&&(m=(0,h.mixin)(m,this.c)),this.b||(m=(0,h.mixin)(m,this.j)),a.properties?a.properties=m:a=m,a}k(a,m){!this.f||(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(a,m),this.h.trace(a,m))}logUsage(a,m){!this.d.isUsageEnabled||this.k(a,m)}logError(a,m){!this.d.isErrorsEnabled||!this.f||(typeof a=="string"?this.k(a,m):this.f.sendErrorData(a,m))}get apiTelemetryLogger(){if(!this.e){const a=this,m={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function d(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,174,96,24,3]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var h;(function(P){P[P.EagerAutoStart=1]="EagerAutoStart",P[P.EagerManualStart=2]="EagerManualStart",P[P.Lazy=3]="Lazy"})(h=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,i){const l=[],s=[],c=[],o=[],I=S(this.c),r=S(p),u=(X,_)=>X.extensionLocation.toString()===_.extensionLocation.toString()||X.isBuiltin===_.isBuiltin||X.isUserBuiltin===_.isUserBuiltin||X.isUnderDevelopment===_.isUnderDevelopment;for(const X of this.c){const _=r.get(X.identifier);if(!_){l.push(X.identifier),I.delete(X.identifier);continue}if(!u(X,_)){l.push(X.identifier),I.delete(X.identifier);continue}}for(const X of p){const _=I.get(X.identifier);if(!_){s.push(X);continue}if(!u(_,X)){l.push(_.identifier),I.delete(_.identifier);continue}}const v=new R.ExtensionIdentifierSet(this.d),D=new R.ExtensionIdentifierSet(i);for(const X of this.d)D.has(X)||c.push(X);for(const X of i)v.has(X)||o.push(X);const y=M.ImplicitActivationEvents.createActivationEventsMap(s),W={toRemove:l,toAdd:s,addActivationEvents:y,myToRemove:c,myToAdd:o};return this.delta(W),W}delta(p){const{toRemove:i,toAdd:l,myToRemove:s,myToAdd:c}=p,o=new R.ExtensionIdentifierSet(i),I=new R.ExtensionIdentifierSet(s);for(let r=0;r<this.c.length;r++)o.has(this.c[r].identifier)&&(this.c.splice(r,1),r--);for(let r=0;r<this.d.length;r++)I.has(this.d[r])&&(this.d.splice(r,1),r--);for(const r of l)this.c.push(r);for(const r of c)this.d.push(r)}containsExtension(p){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,p))return!0;return!1}}e.ExtensionHostExtensions=O;function S(P){const p=new R.ExtensionIdentifierMap;for(const i of P)p.set(i.identifier,i);return p}function f(P,p){return P.enabledApiProposals?P.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=f;function E(P,p){if(!f(P,p))throw new Error(`Extension '${P.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${P.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${P.identifier.value}`)}e.checkProposedApiEnabled=E;class g{constructor(p,i,l,s){this.codeLoadingTime=p,this.activateCallTime=i,this.activateResolvedTime=l,this.activationReason=s}}e.ActivationTimes=g;class d{constructor(p,i){this.description=p,this.value=i}}e.ExtensionPointContribution=d;var t;(function(P){P[P.Normal=0]="Normal",P[P.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(P){return{type:P.isBuiltin?0:1,isBuiltin:P.isBuiltin||P.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(P.publisher,P.name),uuid:P.uuid},manifest:P,location:P.extensionLocation,targetPlatform:P.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function m(P,p){return{identifier:new R.ExtensionIdentifier((0,k.getExtensionId)(P.manifest.publisher,P.manifest.name)),isBuiltin:P.type===0,isUserBuiltin:P.type===1&&P.isBuiltin,isUnderDevelopment:!!p,extensionLocation:P.location,...P.manifest,uuid:P.identifier.uuid,targetPlatform:P.targetPlatform,browserNlsBundleUris:P.browserNlsBundleUris}}e.toExtensionDescription=m;class b{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=b}),define(Ae[197],Re([1,0,14,100,24,26,13,17]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class w{constructor(a,m,b,P){this.startup=a,this.codeLoadingTime=m,this.activateCallTime=b,this.activateResolvedTime=P}}w.NONE=new w(!1,-1,-1,-1),e.ExtensionActivationTimes=w;class h{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,m){return a===-1||m===-1?-1:m-a}build(){return new w(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=h;class O{constructor(a,m,b,P,p,i){this.activationFailed=a,this.activationFailedError=m,this.activationTimes=b,this.module=P,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=O;class S extends O{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=S;class f extends O{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class E extends O{constructor(a){super(!0,a,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(a,m,b,P){this.g=P,this.a=a,this.b=m,this.c=b,this.d=new k.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[a,m]of this.d)m.dispose()}isActivated(a){const m=this.d.get(a);return Boolean(m&&m.value)}getActivatedExtension(a){const m=this.d.get(a);if(!m||!m.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return m.value}async activateByEvent(a,m){if(this.f[a])return;const b=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(b.map(P=>({id:P.identifier,reason:{startup:m,extensionId:P.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,m){const b=this.a.getExtensionDescription(a);if(!b)throw new Error(`Extension '${a}' is not known`);return this.h([{id:b.identifier,reason:m}])}async h(a){const m=a.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(m.map(b=>b.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const m=this.a.getExtensionDescription(a.id);if(!m){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new E(p));return this.c.onExtensionActivationError(a.id,p,new M.MissingExtensionDependency(a.id.value)),i}const b=[],P=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const p of P){if(this.m(p))continue;const i=this.d.get(p);if(i){b.push(i);continue}if(this.l(p)){b.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:a.reason}));continue}const l=this.a.getExtensionDescription(p);if(l){if(!l.main&&!l.browser)continue;b.push(this.j({id:l.identifier,reason:a.reason}));continue}const s=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),o=this.k(a,m.displayName,[],new E(c));return this.c.onExtensionActivationError(m.identifier,c,new M.MissingExtensionDependency(p)),o}return this.k(a,m.displayName,b,null)}k(a,m,b,P){const p=new d(a.id,m,a.reason,b,P,this.c,this.g);return this.d.set(a.id,p),p}l(a){return T.ExtensionDescriptionRegistry.isHostExtension(a,this.a,this.b)}m(a){const m=this.b.getExtensionDescription(a);return m?!m.main&&!m.browser:!1}};g=je([Ve(3,R.ILogService)],g),e.ExtensionsActivator=g;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,m,b,P,p,i,l){this.c=a,this.d=m,this.f=b,this.g=P,this.h=p,this.j=i,this.k=l,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const m=this.g[a];if(m.value&&!m.value.activationFailed){this.g.splice(a,1),a--;continue}if(m.value&&m.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);b.detail=m.value.activationFailedError,this.h=new E(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const m=new Error;if(a&&a.name&&(m.name=a.name),a&&a.message?m.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(m.stack=a.stack),this.h=new E(m),this.b&&n.isCancellationError(a))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};d=je([Ve(6,R.ILogService)],d)});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[7],Re([1,0,16,14,87,28,65,12,9,2,35,43,95,72,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g){"use strict";var d,t,a,m,b,P,p,i,l,s,c,o,I,r,u,v,D,y,W,X,_,J,j,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...ye]=arguments;return Reflect.construct(z,ye,ne.constructor)}}})}var q;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(q=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let Ee=i=class{static from(...F){let ne=F;return new i(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}constructor(F){d.set(this,void 0),Je(this,d,F,"f")}dispose(){typeof Fe(this,d,"f")=="function"&&(Fe(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,Ee=i=je([B],Ee),e.Disposable=Ee;let ie=l=class{static Min(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let ye=1;ye<F.length;ye++){const qe=F[ye];qe.isBefore(ne)&&(ne=qe)}return ne}static Max(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let ye=1;ye<F.length;ye++){const qe=F[ye];qe.isAfter(ne)&&(ne=qe)}return ne}static isPosition(F){if(!F)return!1;if(F instanceof l)return!0;const{line:ne,character:ye}=F;return typeof ne=="number"&&typeof ye=="number"}static of(F){if(F instanceof l)return F;if(this.isPosition(F))return new l(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ne){if(F<0)throw(0,T.illegalArgument)("line must be non-negative");if(ne<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=F,this.e=ne}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ne=0){if(F===null||ne===null)throw(0,T.illegalArgument)();let ye;return typeof F>"u"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,ne=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&ne===0?this:new l(this.line+ye,this.character+ne)}with(F,ne=this.character){if(F===null||ne===null)throw(0,T.illegalArgument)();let ye;return typeof F>"u"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,ne=typeof F.character=="number"?F.character:this.character),ye===this.line&&ne===this.character?this:new l(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};ie=l=je([B],ie),e.Position=ie;let ce=s=class{static isRange(F){return F instanceof s?!0:F?ie.isPosition(F.start)&&ie.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ne,ye,qe){let _e,st;if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(F,ne),st=new ie(ye,qe)):ie.isPosition(F)&&ie.isPosition(ne)&&(_e=ie.of(F),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");_e.isBefore(st)?(this.c=_e,this.e=st):(this.c=st,this.e=_e)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):ie.isPosition(F)?!(ie.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ne=ie.Max(F.start,this.c),ye=ie.Min(F.end,this.e);if(!ne.isAfter(ye))return new s(ne,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ne=ie.Min(F.start,this.c),ye=ie.Max(F.end,this.end);return new s(ne,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ne=this.end){if(F===null||ne===null)throw(0,T.illegalArgument)();let ye;return F?ie.isPosition(F)?ye=F:(ye=F.start||this.start,ne=F.end||this.end):ye=this.start,ye.isEqual(this.c)&&ne.isEqual(this.end)?this:new s(ye,ne)}toJSON(){return[this.start,this.end]}};ce=s=je([B],ce),e.Range=ce;let de=c=class extends ce{static isSelection(F){return F instanceof c?!0:F?ce.isRange(F)&&ie.isPosition(F.anchor)&&ie.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ne,ye,qe){let _e,st;if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(F,ne),st=new ie(ye,qe)):ie.isPosition(F)&&ie.isPosition(ne)&&(_e=ie.of(F),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");super(_e,st),this.f=_e,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};de=c=je([B],de),e.Selection=de;class Te{constructor(F,ne,ye){if(typeof F!="string"||F.length===0)throw(0,T.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.illegalArgument)("port");if(typeof ye<"u"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z_\-]+$/.test(ye)))throw(0,T.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=Te;class le extends Error{static NotAvailable(F,ne){return new le(F,f.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(F){return new le(F,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ne=f.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F),this._message=F,this._code=ne,this._detail=ye,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var V;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let L=o=class{static isTextEdit(F){return F instanceof o?!0:F?ce.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ne){return new o(F,ne)}static insert(F,ne){return o.replace(new ce(F,F),ne)}static delete(F){return o.replace(F,"")}static setEndOfLine(F){const ne=new o(new ce(new ie(0,0),new ie(0,0)),"");return ne.newEol=F,ne}get range(){return this.c}set range(F){if(F&&!ce.isRange(F))throw(0,T.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,T.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,T.illegalArgument)("newEol");this.f=F}constructor(F,ne){this.c=F,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};L=o=je([B],L),e.TextEdit=L;let K=I=class{static isNotebookCellEdit(F){return F instanceof I?!0:F?Kt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ne){return new I(F,ne)}static insertCells(F,ne){return new I(new Kt(F,F),ne)}static deleteCells(F){return new I(F,[])}static updateCellMetadata(F,ne){const ye=new I(new Kt(F,F),[]);return ye.newCellMetadata=ne,ye}static updateNotebookMetadata(F){const ne=new I(new Kt(0,0),[]);return ne.newNotebookMetadata=F,ne}constructor(F,ne){this.range=F,this.newCells=ne}};K=I=je([B],K),e.NotebookEdit=K;class me{static isSnippetTextEdit(F){return F instanceof me?!0:F?ce.isRange(F.range)&&ve.isSnippetString(F.snippet):!1}static replace(F,ne){return new me(F,ne)}static insert(F,ne){return me.replace(new ce(F,F),ne)}constructor(F,ne){this.range=F,this.snippet=ne}}e.SnippetTextEdit=me;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ne,ye,qe){this.c.push({_type:1,from:F,to:ne,options:ye,metadata:qe})}createFile(F,ne,ye){this.c.push({_type:1,from:void 0,to:F,options:ne,metadata:ye})}deleteFile(F,ne,ye){this.c.push({_type:1,from:F,to:void 0,options:ne,metadata:ye})}e(F,ne,ye){this.c.push({_type:3,metadata:ye,uri:F,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(F,ne,ye,qe){const _e=ne.start,st=ne.end;(_e!==st||ye.length>0)&&this.c.push({_type:5,uri:F,index:_e,count:st-_e,cells:ye,metadata:qe})}g(F,ne,ye,qe){this.c.push({_type:3,metadata:qe,uri:F,edit:{editType:8,index:ne,metadata:ye}})}replace(F,ne,ye,qe){this.c.push({_type:2,uri:F,edit:new L(ne,ye),metadata:qe})}insert(F,ne,ye,qe){this.replace(F,new ce(ne,ne),ye,qe)}delete(F,ne,ye){this.replace(F,ne,"",ye)}has(F){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===F.toString())}set(F,ne){if(ne)for(const ye of ne){if(!ye)continue;let qe,_e;Array.isArray(ye)?(qe=ye[0],_e=ye[1]):qe=ye,K.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(F,qe.range.start,qe.newCellMetadata,_e):qe.newNotebookMetadata?this.e(F,qe.newNotebookMetadata,_e):this.f(F,qe.range,qe.newCells,_e):me.isSnippetTextEdit(qe)?this.c.push({_type:6,uri:F,range:qe.range,edit:qe.snippet,metadata:_e}):this.c.push({_type:2,uri:F,edit:qe,metadata:_e})}else{for(let ye=0;ye<this.c.length;ye++){const qe=this.c[ye];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===F.toString()&&(this.c[ye]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(F){const ne=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===F.toString()&&ne.push(ye.edit);return ne}entries(){const F=new M.ResourceMap;for(const ne of this.c)if(ne._type===2){let ye=F.get(ne.uri);ye||(ye=[ne.uri,[]],F.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=je([B],Se),e.WorkspaceEdit=Se;let ve=r=class{static isSnippetString(F){return F instanceof r?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=r.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ne=this.e++){if(typeof F=="function"){const ye=new r;ye.e=this.e,F(ye),this.e=ye.e,F=ye.value}else F=r.c(F);return this.value+="${",this.value+=ne,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ne=this.e++){const ye=F.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,ne){if(typeof ne=="function"){const ye=new r;ye.e=this.e,ne(ye),this.e=ye.e,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ve=r=je([B],ve),e.SnippetString=ve;var Ce;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Ce=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=u=class{static isLocation(F){return F instanceof u?!0:F?ce.isRange(F.range)&&h.URI.isUri(F.uri):!1}constructor(F,ne){if(this.uri=F,ne)if(ce.isRange(ne))this.range=ce.of(ne);else if(ie.isPosition(ne))this.range=new ce(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=u=je([B],ae),e.Location=ae;let Z=class{static is(F){return F?typeof F.message=="string"&&F.location&&ce.isRange(F.location.range)&&h.URI.isUri(F.location.uri):!1}constructor(F,ne){this.location=F,this.message=ne}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.location.range.isEqual(ne.location.range)&&F.location.uri.toString()===ne.location.uri.toString()}};Z=je([B],Z),e.DiagnosticRelatedInformation=Z;let C=class{constructor(F,ne,ye=se.Error){if(!ce.isRange(F))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=F,this.message=ne,this.severity=ye}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.severity===ne.severity&&F.code===ne.code&&F.severity===ne.severity&&F.source===ne.source&&F.range.isEqual(ne.range)&&(0,n.equals)(F.tags,ne.tags)&&(0,n.equals)(F.relatedInformation,ne.relatedInformation,Z.isEqual)}};C=je([B],C),e.Diagnostic=C;let N=class{constructor(F,ne){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ne}};N=je([B],N),e.Hover=N;var H;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(H=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let x=class{constructor(F,ne=H.Text){this.range=F,this.kind=ne}toJSON(){return{range:this.range,kind:H[this.kind]}}};x=je([B],x),e.DocumentHighlight=x;var te;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(te=e.SymbolKind||(e.SymbolKind={}));var pe;(function(z){z[z.Deprecated=1]="Deprecated"})(pe=e.SymbolTag||(e.SymbolTag={}));let ke=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ne,ye,qe,_e){this.name=F,this.kind=ne,this.containerName=_e,typeof ye=="string"&&(this.containerName=ye),qe instanceof ae?this.location=qe:ye instanceof ce&&(this.location=new ae(qe,ye)),v.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};ke=v=je([B],ke),e.SymbolInformation=ke;let ue=D=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(D.validate)}constructor(F,ne,ye,qe,_e){this.name=F,this.detail=ne,this.kind=ye,this.range=qe,this.selectionRange=_e,this.children=[],D.validate(this)}};ue=D=je([B],ue),e.DocumentSymbol=ue;var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let we=class{constructor(F,ne){this.title=F,this.kind=ne}};we=je([B],we),e.CodeAction=we;let $e=y=class{constructor(F){this.value=F}append(F){return new y(this.value?this.value+y.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+y.c)}};$e.c=".",$e=y=je([B],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let He=class{constructor(F,ne){if(this.range=F,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};He=je([B],He),e.SelectionRange=He;class et{constructor(F,ne,ye,qe,_e,st){this.kind=F,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.CallHierarchyItem=et;class Xe{constructor(F,ne){this.fromRanges=ne,this.from=F}}e.CallHierarchyIncomingCall=Xe;class tt{constructor(F,ne){this.fromRanges=ne,this.to=F}}e.CallHierarchyOutgoingCall=tt;var rt;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(F,ne){this.range=F,this.command=ne}get isResolved(){return!!this.command}};Me=je([B],Me),e.CodeLens=Me;let it=W=class{static isMarkdownString(F){return F instanceof W?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ne=!1){t.set(this,void 0),Je(this,t,new k.MarkdownString(F,{supportThemeIcons:ne}),"f")}get value(){return Fe(this,t,"f").value}set value(F){Fe(this,t,"f").value=F}get isTrusted(){return Fe(this,t,"f").isTrusted}set isTrusted(F){Fe(this,t,"f").isTrusted=F}get supportThemeIcons(){return Fe(this,t,"f").supportThemeIcons}set supportThemeIcons(F){Fe(this,t,"f").supportThemeIcons=F}get supportHtml(){return Fe(this,t,"f").supportHtml}set supportHtml(F){Fe(this,t,"f").supportHtml=F}get baseUri(){return Fe(this,t,"f").baseUri}set baseUri(F){Fe(this,t,"f").baseUri=F}appendText(F){return Fe(this,t,"f").appendText(F),this}appendMarkdown(F){return Fe(this,t,"f").appendMarkdown(F),this}appendCodeblock(F,ne){return Fe(this,t,"f").appendCodeblock(ne??"",F),this}};t=new WeakMap,it=W=je([B],it),e.MarkdownString=it;let Q=class{constructor(F,ne){this.label=F,this.documentation=ne}};Q=je([B],Q),e.ParameterInformation=Q;let Y=class{constructor(F,ne){this.label=F,this.documentation=ne,this.parameters=[]}};Y=je([B],Y),e.SignatureInformation=Y;let be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};be=je([B],be),e.SignatureHelp=be;var We;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(We=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(F){this.value=F}};Qe=je([B],Qe),e.InlayHintLabelPart=Qe;let Ye=class{constructor(F,ne,ye){this.position=F,this.label=ne,this.kind=ye}};Ye=je([B],Ye),e.InlayHint=Ye;var Ge;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var Dt;(function(z){z[z.Deprecated=1]="Deprecated"})(Dt=e.CompletionItemTag||(e.CompletionItemTag={}));let Tt=class{constructor(F,ne){this.label=F,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Tt=je([B],Tt),e.CompletionItem=Tt;let It=class{constructor(F=[],ne=!1){this.items=F,this.isIncomplete=ne}};It=je([B],It),e.CompletionList=It;let Et=class{constructor(F,ne,ye){this.insertText=F,this.range=ne,this.command=ye}};Et=je([B],Et),e.InlineSuggestion=Et;let Mt=class{constructor(F){this.commands=void 0,this.items=F}};Mt=je([B],Mt),e.InlineSuggestionList=Mt;var zt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(zt=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ht;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ht=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Lt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Lt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function F(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ct=class{constructor(F,ne){if(ne&&!h.URI.isUri(ne))throw(0,T.illegalArgument)("target");if(!ce.isRange(F)||F.isEmpty)throw(0,T.illegalArgument)("range");this.range=F,this.target=ne}};Ct=je([B],Ct),e.DocumentLink=Ct;let Pt=class{constructor(F,ne,ye,qe){this.red=F,this.green=ne,this.blue=ye,this.alpha=qe}};Pt=je([B],Pt),e.Color=Pt;let $t=class{constructor(F,ne){if(ne&&!(ne instanceof Pt))throw(0,T.illegalArgument)("color");if(!ce.isRange(F)||F.isEmpty)throw(0,T.illegalArgument)("range");this.range=F,this.color=ne}};$t=je([B],$t),e.ColorInformation=$t;let Ke=class{constructor(F){if(!F||typeof F!="string")throw(0,T.illegalArgument)("label");this.label=F}};Ke=je([B],Ke),e.ColorPresentation=Ke;var Wt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Pe;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Le;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Le=e.TerminalExitReason||(e.TerminalExitReason={}));class fe{constructor(F,ne,ye){if(this.startIndex=F,this.length=ne,this.tooltip=ye,typeof F!="number"||F<0)throw(0,T.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,T.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=fe;class G{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=G;class Oe{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=Oe;var Be;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Be=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(F){if(this.options=F,typeof F!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Ze;var xe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var ot;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ot=e.TaskPanelKind||(e.TaskPanelKind={}));let ft=X=class{static from(F){switch(F){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(F,ne){if(this.label=ne,typeof F!="string"||typeof ne!="string")throw(0,T.illegalArgument)("name");this.c=F}get id(){return this.c}};ft.Clean=new X("clean","Clean"),ft.Build=new X("build","Build"),ft.Rebuild=new X("rebuild","Rebuild"),ft.Test=new X("test","Test"),ft=X=je([B],ft),e.TaskGroup=ft;function mt(z){let F="";for(let ne=0;ne<z.length;ne++)F+=z[ne].replace(/,/g,",,")+",";return F}let lt=class{constructor(F,ne,ye){if(typeof F!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=F,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ye):this.f=ne)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,T.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)F.push(ne);return mt(F)}};lt=je([B],lt),e.ProcessExecution=lt;let ct=class{constructor(F,ne,ye){if(this.f=[],Array.isArray(ne)){if(!F)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,T.illegalArgument)("command");this.e=F,this.f=ne,this.g=ye}else{if(typeof F!="string")throw(0,T.illegalArgument)("commandLine");this.c=F,this.g=ne}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,T.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,T.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)F.push(typeof ne=="string"?ne:ne.value);return mt(F)}};ct=je([B],ct),e.ShellExecution=ct;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(F){this.c=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=Ht;let Ft=_=class{constructor(F,ne,ye,qe,_e,st){this.j=!1,this.k=this.definition=F;let ut;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ye,this.execution=qe,ut=_e,this.j=!0):ne===kt.Global||ne===kt.Workspace?(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st):(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:_.e,id:this.n.computeId()}:this.n instanceof ct?this.k={type:_.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:_.c,id:this.n.computeId()}:this.k={type:_.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const ne=this.k.type;(_.g===ne||_.e===ne||_.f===ne||_.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};Ft.c="customExecution",Ft.e="process",Ft.f="shell",Ft.g="$empty",Ft=_=je([B],Ft),e.Task=Ft;var ai;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(z){function F(ne){const ye=ne;return(0,w.isNumber)(ye.value)?ye.tooltip&&!(0,w.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=F})(At=e.ViewBadge||(e.ViewBadge={}));let yi=J=class{static isTreeItem(F,ne){const ye=F;if(ye.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(ne,"treeItemCheckbox");const qe=(0,w.isNumber)(ye.checkboxState)?ye.checkboxState:(0,w.isObject)(ye.checkboxState)&&(0,w.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,_e=!(0,w.isNumber)(ye.checkboxState)&&(0,w.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(qe===void 0||qe!==yt.Checked&&qe!==yt.Unchecked||_e!==void 0&&!(0,w.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(F instanceof J)return!0;if(ye.label!==void 0&&!(0,w.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,w.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,w.isString)(ye.iconPath)&&!h.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,w.isString)(ye.iconPath.id))){const qe=ye.iconPath;if(!qe||!(0,w.isString)(qe.light)&&!h.URI.isUri(qe.light)&&!(0,w.isString)(qe.dark)&&!h.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,w.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!h.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,w.isString)(ye.tooltip)&&!(ye.tooltip instanceof it)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<ci.None&&ye.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,w.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(F,ne=ci.None){this.collapsibleState=ne,h.URI.isUri(F)?this.resourceUri=F:this.label=F}};yi=J=je([B],yi),e.TreeItem=yi;var ci;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var yt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(yt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ui=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,ne){this.value=F,this.id=ne??(0,O.generateUuid)()}};ui=je([B],ui),e.DataTransferItem=ui;let li=class{constructor(F){a.add(this),m.set(this,new Map);for(const[ne,ye]of F??[]){const qe=Fe(this,m,"f").get(Fe(this,a,"m",b).call(this,ne));qe?qe.push(ye):Fe(this,m,"f").set(Fe(this,a,"m",b).call(this,ne),[ye])}}get(F){return Fe(this,m,"f").get(Fe(this,a,"m",b).call(this,F))?.[0]}set(F,ne){Fe(this,m,"f").set(Fe(this,a,"m",b).call(this,F),[ne])}forEach(F,ne){for(const[ye,qe]of Fe(this,m,"f"))for(const _e of qe)F.call(ne,_e,ye,this)}*[(m=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[F,ne]of Fe(this,m,"f"))for(const ye of ne)yield[F,ye]}};b=function(F){return F.toLowerCase()},li=je([B],li),e.DataTransfer=li;let Zt=class{constructor(F){this.insertText=F}};Zt=je([B],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(F){this.insertText=F}};Di=je([B],Di),e.DocumentPasteEdit=Di;let wt=class{constructor(F,ne){this.id=F,this.color=ne}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};wt=je([B],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let di=class{constructor(F){this.id=F}};di=je([B],di),e.ThemeColor=di;var Bi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Bi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(F){this.c=F,this.e=h.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ne){if(typeof F!="string"&&(!F||!h.URI.isUri(F)&&!h.URI.isUri(F.uri)))throw(0,T.illegalArgument)("base");if(typeof ne!="string")throw(0,T.illegalArgument)("pattern");typeof F=="string"?this.baseUri=h.URI.file(F):h.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=je([B],ei),e.RelativePattern=ei;const ii=new WeakMap;function dt(z,F){ii.set(z,F)}e.setBreakpointId=dt;let ti=class{constructor(F,ne,ye,qe){this.enabled=typeof F=="boolean"?F:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this.c||(this.c=ii.get(this)??(0,O.generateUuid)()),this.c}};ti=je([B],ti),e.Breakpoint=ti;let jt=class extends ti{constructor(F,ne,ye,qe,_e){if(super(ne,ye,qe,_e),F===null)throw(0,T.illegalArgument)("location");this.location=F}};jt=je([B],jt),e.SourceBreakpoint=jt;let Qt=class extends ti{constructor(F,ne,ye,qe,_e){super(ne,ye,qe,_e),this.functionName=F}};Qt=je([B],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(F,ne,ye,qe,_e,st,ut){if(super(qe,_e,st,ut),!ne)throw(0,T.illegalArgument)("dataId");this.label=F,this.dataId=ne,this.canPersist=ye}};hi=je([B],hi),e.DataBreakpoint=hi;let Ii=class{constructor(F,ne,ye){this.command=F,this.args=ne||[],this.options=ye}};Ii=je([B],Ii),e.DebugAdapterExecutable=Ii;let Ci=class{constructor(F,ne){this.port=F,this.host=ne}};Ci=je([B],Ci),e.DebugAdapterServer=Ci;let fi=class{constructor(F){this.path=F}};fi=je([B],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(F){this.implementation=F}};ki=je([B],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(F,ne){this.range=F,this.expression=ne}};mi=je([B],mi),e.EvaluatableExpression=mi;var gi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(F,ne){this.range=F,this.text=ne}};Ti=je([B],Ti),e.InlineValueText=Ti;let ni=class{constructor(F,ne,ye=!0){this.range=F,this.variableName=ne,this.caseSensitiveLookup=ye}};ni=je([B],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(F,ne){this.range=F,this.expression=ne}};ri=je([B],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(F,ne){this.frameId=F,this.stoppedLocation=ne}};Pi=je([B],Pi),e.InlineValueContext=Pi;var zi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(zi=e.FileChangeType||(e.FileChangeType={}));let Yt=j=class extends Error{static FileExists(F){return new j(F,S.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(F){return new j(F,S.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(F){return new j(F,S.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(F){return new j(F,S.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(F){return new j(F,S.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(F){return new j(F,S.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(F,ne=S.FileSystemProviderErrorCode.Unknown,ye){super(h.URI.isUri(F)?F.toString(!0):F),this.code=ye?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};Yt=j=je([B],Yt),e.FileSystemError=Yt;let Ai=class{constructor(F,ne,ye){this.start=F,this.end=ne,this.kind=ye}};Ai=je([B],Ai),e.FoldingRange=Ai;var Wi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Vi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Vi=e.CommentThreadState||(e.CommentThreadState={}));class ji{constructor(F,ne=[]){this.tokenTypes=F,this.tokenModifiers=ne}}e.SemanticTokensLegend=ji;function qi(z){return typeof z>"u"||(0,w.isStringArray)(z)}class si{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let ne=0,ye=F.tokenTypes.length;ne<ye;ne++)this.j.set(F.tokenTypes[ne],ne);for(let ne=0,ye=F.tokenModifiers.length;ne<ye;ne++)this.k.set(F.tokenModifiers[ne],ne)}}push(F,ne,ye,qe,_e){if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(F,ne,ye,qe,_e);if(ce.isRange(F)&&typeof ne=="string"&&qi(ye))return this.m(F,ne,ye);throw(0,T.illegalArgument)()}m(F,ne,ye){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const qe=F.start.line,_e=F.start.character,st=F.end.character-F.start.character,ut=this.j.get(ne);let Nt=0;if(ye)for(const Vt of ye){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Vt);Nt|=1<<qt>>>0}this.n(qe,_e,st,ut,Nt)}n(F,ne,ye,qe,_e){if(this.f&&(F<this.c||F===this.c&&ne<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Vt=0,qt=0;for(let Gt=0;Gt<Nt;Gt++){let _t=this.g[5*Gt],Oi=this.g[5*Gt+1];_t===0?(_t=Vt,Oi+=qt):_t+=Vt,this.g[5*Gt]=_t,this.g[5*Gt+1]=Oi,Vt=_t,qt=Oi}}let st=F,ut=ne;this.f&&this.h>0&&(st-=this.c,st===0&&(ut-=this.e)),this.g[this.h++]=st,this.g[this.h++]=ut,this.g[this.h++]=ye,this.g[this.h++]=qe,this.g[this.h++]=_e,this.c=F,this.e=ne}static o(F){const ne=[],ye=F.length/5|0;for(let ut=0;ut<ye;ut++)ne[ut]=ut;ne.sort((ut,Nt)=>{const Vt=F[5*ut],qt=F[5*Nt];if(Vt===qt){const Gt=F[5*ut+1],_t=F[5*Nt+1];return Gt-_t}return Vt-qt});const qe=new Uint32Array(F.length);let _e=0,st=0;for(let ut=0;ut<ye;ut++){const Nt=5*ne[ut],Vt=F[Nt+0],qt=F[Nt+1],Gt=F[Nt+2],_t=F[Nt+3],Oi=F[Nt+4],un=Vt-_e,Ln=un===0?qt-st:qt,Li=5*ut;qe[Li+0]=un,qe[Li+1]=Ln,qe[Li+2]=Gt,qe[Li+3]=_t,qe[Li+4]=Oi,_e=Vt,st=qt}return qe}build(F){return this.f?new pi(new Uint32Array(this.g),F):new pi(si.o(this.g),F)}}e.SemanticTokensBuilder=si;class pi{constructor(F,ne){this.resultId=ne,this.data=F}}e.SemanticTokens=pi;class Ni{constructor(F,ne,ye){this.start=F,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=Ni;class Ue{constructor(F,ne){this.resultId=ne,this.edits=F}}e.SemanticTokensEdits=Ue;var xt;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new wt("arrow-left")},oi=je([B],oi),e.QuickInputButtons=oi;var vt;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(vt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ki;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ki=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(F){if(typeof F.badge=="string"){let ne=(0,A.nextCharLength)(F.badge,0);if(ne<F.badge.length&&(ne+=(0,A.nextCharLength)(F.badge,ne)),F.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!wt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ne,ye){this.badge=F,this.tooltip=ne,this.color=ye}}e.FileDecoration=Mi;let Ri=class{constructor(F){this.kind=F}};Ri=je([B],Ri),e.ColorTheme=Ri;var vi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(vi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(F){return F instanceof Kt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ne){if(F<0)throw(0,T.illegalArgument)("start must be positive");if(ne<0)throw(0,T.illegalArgument)("end must be positive");F<=ne?(this.c=F,this.e=ne):(this.c=ne,this.e=F)}with(F){let ne=this.c,ye=this.e;return F.start!==void 0&&(ne=F.start),F.end!==void 0&&(ye=F.end),ne===this.c&&ye===this.e?this:new Kt(ne,ye)}}e.NotebookRange=Kt;class bi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(F){return!0}constructor(F,ne,ye,qe,_e,st,ut){this.kind=F,this.value=ne,this.languageId=ye,this.mime=qe,this.outputs=_e??[],this.metadata=st,this.executionSummary=ut,bi.validate(this)}}e.NotebookCellData=bi;class Gi{constructor(F){this.cells=F}}e.NotebookData=Gi;class Bt{static isNotebookCellOutputItem(F){return F instanceof Bt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ne={name:F.name,message:F.message,stack:F.stack};return Bt.json(ne,"application/vnd.code.notebook.error")}static stdout(F){return Bt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Bt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ne="application/octet-stream"){return new Bt(F,ne)}static text(F,ne=R.Mimes.text){const ye=Fe(Bt,P,"f",p).encode(String(F));return new Bt(ye,ne)}static json(F,ne="text/x-json"){const ye=JSON.stringify(F,void 0,"	");return Bt.text(ye,ne)}constructor(F,ne){this.data=F,this.mime=ne;const ye=(0,R.normalizeMimeType)(ne,!0);if(!ye)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}P=Bt,p={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class Ei{static isNotebookCellOutput(F){return F instanceof Ei?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ne=!1){const ye=new Set,qe=new Set;for(let _e=0;_e<F.length;_e++){const st=F[_e],ut=(0,R.normalizeMimeType)(st.mime);if(!ye.has(ut)||(0,E.isTextStreamMime)(ut)){ye.add(ut);continue}qe.add(_e),ne&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?F:F.filter((_e,st)=>!qe.has(st))}constructor(F,ne,ye){this.items=Ei.ensureUniqueMimeTypes(F,!0),typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,O.generateUuid)(),this.metadata=ne??ye)}}e.NotebookCellOutput=Ei;var Xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ji{constructor(F,ne){this.text=F,this.alignment=ne}}e.NotebookCellStatusBarItem=Ji;var Zi;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var oe;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ge{constructor(F,ne=[]){this.uri=F,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=ge;class Ne{constructor(F){this.label=F}}e.NotebookKernelSourceAction=Ne;let nt=class{constructor(F,ne){this.label=F,this.timestamp=ne}};nt=je([B],nt),e.TimelineItem=nt;var St;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(St=e.ExtensionMode||(e.ExtensionMode={}));var Rt;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(F,ne){this.ranges=F,this.wordPattern=ne}}e.LinkedEditingRanges=gn;class pn{constructor(F,ne){this.c=F,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var vn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(vn=e.TestResultState||(e.TestResultState={}));var bn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(bn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(F=void 0,ne=void 0,ye=void 0){this.include=F,this.exclude=ne,this.profile=ye}};Ui=je([B],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(F=void 0,ne=void 0,ye=void 0,qe=!1){super(F,ne,ye),this.continuous=qe}};en=je([B],en),e.TestRunRequest2=en;let tn=U=class{static diff(F,ne,ye){const qe=new U(F);return qe.expectedOutput=ne,qe.actualOutput=ye,qe}constructor(F){this.message=F}};tn=U=je([B],tn),e.TestMessage=tn;let nn=class{constructor(F){this.id=F}};nn=je([B],nn),e.TestTag=nn;let wi=class{constructor(F,ne){this.covered=F,this.total=ne}};wi=je([B],wi),e.CoveredCount=wi;let rn=$=class{static fromDetails(F,ne){const ye=new wi(0,0),qe=new wi(0,0),_e=new wi(0,0);for(const ut of ne)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const Nt of ut.branches)qe.total+=1,qe.covered+=Nt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const st=new $(F,ye,qe.total>0?qe:void 0,_e.total>0?_e:void 0);return st.detailedCoverage=ne,st}constructor(F,ne,ye,qe){this.uri=F,this.statementCoverage=ne,this.branchCoverage=ye,this.functionCoverage=qe}};rn=$=je([B],rn),e.FileCoverage=rn;let sn=class{constructor(F,ne,ye=[]){this.executionCount=F,this.location=ne,this.branches=ye}};sn=je([B],sn),e.StatementCoverage=sn;let on=class{constructor(F,ne){this.executionCount=F,this.location=ne}};on=je([B],on),e.BranchCoverage=on;let an=class{constructor(F,ne){this.executionCount=F,this.location=ne}};an=je([B],an),e.FunctionCoverage=an;var En;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(En=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(F,ne,ye,qe,_e,st){this.kind=F,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.TypeHierarchyItem=yn;class Dn{constructor(F){this.uri=F}}e.TextTabInput=Dn;class In{constructor(F,ne){this.original=F,this.modified=ne}}e.TextDiffTabInput=In;class Cn{constructor(F,ne,ye,qe){this.base=F,this.input1=ne,this.input2=ye,this.result=qe}}e.TextMergeTabInput=Cn;class kn{constructor(F,ne){this.uri=F,this.viewType=ne}}e.CustomEditorTabInput=kn;class Tn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Tn;class Pn{constructor(F,ne){this.uri=F,this.notebookType=ne}}e.NotebookEditorTabInput=Pn;class An{constructor(F,ne,ye){this.original=F,this.modified=ne,this.notebookType=ye}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class On{constructor(F,ne){this.uri=F,this.inputBoxUri=ne}}e.InteractiveWindowInput=On}),define(Ae[101],Re([1,0,49,15,12,264,133,7,16]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const h=new Map;function O(g,d){d?h.set(g,d):h.delete(g)}e.setWordDefinitionFor=O;function S(g){return h.get(g)}class f extends M.MirrorTextModel{constructor(d,t,a,m,b,P,p,i){super(t,a,m,b),this.m=d,this.p=P,this.q=p,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,w.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===T.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,a){return d.y(t,a)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,n.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,n.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.d[t.start.line].substring(t.start.character,t.end.character);const a=this.f,m=t.start.line,b=t.end.line,P=[];P.push(this.d[m].substring(t.start.character));for(let p=m+1;p<b;p++)P.push(this.d[p]);return P.push(this.d[b].substring(0,t.end.character)),P.join(a)}t(d){let t;if(d instanceof A.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.d.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new E(t,this.d[t],t===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const t=this.h.getIndexOf(d),a=this.d[t.index].length;return new A.Position(t.index,Math.min(t.remainder,a))}w(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const t=this.x(d.start),a=this.x(d.end);return t===d.start&&a===d.end?d:new A.Range(t.line,t.character,a.line,a.character)}x(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:t,character:a}=d,m=!1;if(t<0)t=0,a=0,m=!0;else if(t>=this.d.length)t=this.d.length-1,a=this.d[t].length,m=!0;else{const b=this.d[t].length;a<0?(a=0,m=!0):a>b&&(a=b,m=!0)}return m?new A.Position(t,a):d}y(d,t){const a=this.x(d);if(!t)t=S(this.p);else if((0,k.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const m=(0,R.getWordAtText)(a.character+1,(0,R.ensureValidWordDefinition)(t),this.d[a.line],0);if(m)return new A.Range(a.line,m.startColumn-1,a.line,m.endColumn-1)}}e.ExtHostDocumentData=f;class E{constructor(d,t,a){this.a=d,this.b=t,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=E}),define(Ae[198],Re([1,0,7,18,5]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let w;switch(A){case"light":w=n.ColorThemeKind.Light;break;case"hcDark":w=n.ColorThemeKind.HighContrast;break;case"hcLight":w=n.ColorThemeKind.HighContrastLight;break;default:w=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=je([Ve(0,T.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ae[8],Re([1,0,16,25,118,199,87,28,114,66,65,23,9,2,44,76,92,98,97,72,45,56,195,7]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Pe){function Le(G){const{selectionStartLineNumber:Oe,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:xe}=G,ot=new l.Position(Oe-1,Be-1),ft=new l.Position(Ze-1,xe-1);return new l.Selection(ot,ft)}Pe.to=Le;function fe(G){const{anchor:Oe,active:Be}=G;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Pe.from=fe})(s=e.Selection||(e.Selection={}));var c;(function(Pe){function Le(G){if(!G)return;const{start:Oe,end:Be}=G;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Pe.from=Le;function fe(G){if(!G)return;const{startLineNumber:Oe,startColumn:Be,endLineNumber:Ze,endColumn:xe}=G;return new l.Range(Oe-1,Be-1,Ze-1,xe-1)}Pe.to=fe})(c=e.Range||(e.Range={}));var o;(function(Pe){function Le(fe){switch(fe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Pe.to=Le})(o=e.TokenType||(e.TokenType={}));var I;(function(Pe){function Le(G){return new l.Position(G.lineNumber-1,G.column-1)}Pe.to=Le;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Pe.from=fe})(I=e.Position||(e.Position={}));var r;(function(Pe){function Le(Oe,Be){return(0,n.coalesce)((0,n.asArray)(Oe).map(Ze=>fe(Ze,Be)))}Pe.from=Le;function fe(Oe,Be){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:G(Oe.scheme,Be),pattern:be.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function G(Oe,Be){return Be&&typeof Oe=="string"?Be.transformOutgoingScheme(Oe):Oe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(Pe){function Le(G){switch(G){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function fe(G){switch(G){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Pe.to=fe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Pe){function Le(G){let Oe;return G.code&&((0,f.isString)(G.code)||(0,f.isNumber)(G.code)?Oe=String(G.code):Oe={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:Oe,severity:y.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(D.from),tags:Array.isArray(G.tags)?(0,n.coalesce)(G.tags.map(u.from)):void 0}}Pe.from=Le;function fe(G){const Oe=new l.Diagnostic(c.to(G),G.message,y.to(G.severity));return Oe.source=G.source,Oe.code=(0,f.isString)(G.code)?G.code:G.code?.value,Oe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(D.to),Oe.tags=G.tags&&(0,n.coalesce)(G.tags.map(u.to)),Oe}Pe.to=fe})(v=e.Diagnostic||(e.Diagnostic={}));var D;(function(Pe){function Le(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}Pe.from=Le;function fe(G){return new l.DiagnosticRelatedInformation(new l.Location(G.resource,c.to(G)),G.message)}Pe.to=fe})(D=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var y;(function(Pe){function Le(G){switch(G){case l.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=Le;function fe(G){switch(G){case t.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Pe.to=fe})(y=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var W;(function(Pe){function Le(G){return typeof G=="number"&&G>=l.ViewColumn.One?G-1:G===l.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Pe.from=Le;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=fe})(W=e.ViewColumn||(e.ViewColumn={}));function X(Pe){return typeof Pe.range<"u"}function _(Pe){return Pe.length===0?!0:!!X(Pe[0])}e.isDecorationOptionsArr=_;var J;(function(Pe){function Le(xe){return xe.map(Pe.from)}Pe.fromMany=Le;function fe(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function G(xe){let ot;if(fe(xe)){const{language:ct,value:bt}=xe;ot={value:"```"+ct+`
`+bt+"\n```\n"}}else l.MarkdownString.isMarkdownString(xe)?ot={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?ot={value:xe}:ot={value:""};const ft=Object.create(null);ot.uris=ft;const mt=ct=>{try{let bt=E.URI.parse(ct,!0);bt=bt.with({query:Oe(bt.query,ft)}),ft[ct]=bt}catch{}return""},lt=new w.marked.Renderer;return lt.link=mt,lt.image=ct=>typeof ct=="string"?mt(R.parseHrefAndDimensions(ct).href):"",(0,w.marked)(ot.value,{renderer:lt}),ot}Pe.from=G;function Oe(xe,ot){if(!xe)return xe;let ft;try{ft=(0,h.parse)(xe)}catch{}if(!ft)return xe;let mt=!1;return ft=(0,S.cloneAndChange)(ft,lt=>{if(E.URI.isUri(lt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ct]=lt,mt=!0,ct}else return}),mt?JSON.stringify(ft):xe}function Be(xe){const ot=new l.MarkdownString(xe.value,xe.supportThemeIcons);return ot.isTrusted=xe.isTrusted,ot.supportHtml=xe.supportHtml,ot.baseUri=xe.baseUri?E.URI.from(xe.baseUri):void 0,ot}Pe.to=Be;function Ze(xe){if(!!xe)return typeof xe=="string"?xe:Pe.from(xe)}Pe.fromStrict=Ze})(J=e.MarkdownString||(e.MarkdownString={}));function j(Pe){return _(Pe)?Pe.map(Le=>({range:c.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?J.fromMany(Le.hoverMessage):Le.hoverMessage?J.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:c.from(Le)}))}e.fromRangeOrRangeWithMessage=j;function U(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?E.URI.file(Pe):Pe}e.pathOrURIToURI=U;var $;(function(Pe){function Le(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?U(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Pe.from=Le})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Pe){function Le(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Pe.from=Le})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(Pe){function Le(fe){if(typeof fe>"u")return fe;switch(fe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Pe){function Le(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?q.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?B.from(fe.light):void 0,dark:fe.dark?B.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Pe.from=Le})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Ee;(function(Pe){function Le(G){return{text:G.newText,eol:G.newEol&&rt.from(G.newEol),range:c.from(G.range)}}Pe.from=Le;function fe(G){const Oe=new l.TextEdit(c.to(G.range),G.text);return Oe.newEol=typeof G.eol>"u"?void 0:rt.to(G.eol),Oe}Pe.to=fe})(Ee=e.TextEdit||(e.TextEdit={}));var ie;(function(Pe){function Le(G,Oe){const Be={edits:[]};if(G instanceof l.WorkspaceEdit){const Ze=new A.ResourceSet;for(const xe of G._allEntries())xe._type===1&&E.URI.isUri(xe.to)&&xe.from===void 0&&Ze.add(xe.to);for(const xe of G._allEntries())xe._type===1?Be.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?Be.edits.push({resource:xe.uri,textEdit:Ee.from(xe.edit),versionId:Ze.has(xe.uri)?void 0:Oe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?Be.edits.push({resource:xe.uri,textEdit:{range:c.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(xe.uri)?void 0:Oe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Be.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Be.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Dt.from)}})}return Be}Pe.from=Le;function fe(G){const Oe=new l.WorkspaceEdit;for(const Be of G.edits)Be.textEdit?Oe.replace(E.URI.revive(Be.resource),c.to(Be.textEdit.range),Be.textEdit.text):Oe.renameFile(E.URI.revive(Be.oldResource),E.URI.revive(Be.newResource),Be.options);return Oe}Pe.to=fe})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(Pe){const Le=Object.create(null);Le[l.SymbolKind.File]=0,Le[l.SymbolKind.Module]=1,Le[l.SymbolKind.Namespace]=2,Le[l.SymbolKind.Package]=3,Le[l.SymbolKind.Class]=4,Le[l.SymbolKind.Method]=5,Le[l.SymbolKind.Property]=6,Le[l.SymbolKind.Field]=7,Le[l.SymbolKind.Constructor]=8,Le[l.SymbolKind.Enum]=9,Le[l.SymbolKind.Interface]=10,Le[l.SymbolKind.Function]=11,Le[l.SymbolKind.Variable]=12,Le[l.SymbolKind.Constant]=13,Le[l.SymbolKind.String]=14,Le[l.SymbolKind.Number]=15,Le[l.SymbolKind.Boolean]=16,Le[l.SymbolKind.Array]=17,Le[l.SymbolKind.Object]=18,Le[l.SymbolKind.Key]=19,Le[l.SymbolKind.Null]=20,Le[l.SymbolKind.EnumMember]=21,Le[l.SymbolKind.Struct]=22,Le[l.SymbolKind.Event]=23,Le[l.SymbolKind.Operator]=24,Le[l.SymbolKind.TypeParameter]=25;function fe(Oe){return typeof Le[Oe]=="number"?Le[Oe]:6}Pe.from=fe;function G(Oe){for(const Be in Le)if(Le[Be]===Oe)return Number(Be);return l.SymbolKind.Property}Pe.to=G})(ce=e.SymbolKind||(e.SymbolKind={}));var de;(function(Pe){function Le(G){switch(G){case l.SymbolTag.Deprecated:return 1}}Pe.from=Le;function fe(G){switch(G){case 1:return l.SymbolTag.Deprecated}}Pe.to=fe})(de=e.SymbolTag||(e.SymbolTag={}));var Te;(function(Pe){function Le(G){return{name:G.name,kind:ce.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:K.from(G.location)}}Pe.from=Le;function fe(G){const Oe=new l.SymbolInformation(G.name,ce.to(G.kind),G.containerName,K.to(G.location));return Oe.tags=G.tags&&G.tags.map(de.to),Oe}Pe.to=fe})(Te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Pe){function Le(G){const Oe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:ce.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Oe.children=G.children.map(Le)),Oe}Pe.from=Le;function fe(G){const Oe=new l.DocumentSymbol(G.name,G.detail,ce.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,n.isNonEmptyArray)(G.tags)&&(Oe.tags=G.tags.map(de.to)),G.children&&(Oe.children=G.children.map(fe)),Oe}Pe.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(Pe){function Le(G){const Oe=new l.CallHierarchyItem(ce.to(G.kind),G.name,G.detail||"",E.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Pe.to=Le;function fe(G,Oe,Be){if(Oe=Oe??G._sessionId,Be=Be??G._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,name:G.name,detail:G.detail,kind:ce.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=fe})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var V;(function(Pe){function Le(fe){return new l.CallHierarchyIncomingCall(re.to(fe.from),fe.fromRanges.map(G=>c.to(G)))}Pe.to=Le})(V=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Pe){function Le(fe){return new l.CallHierarchyOutgoingCall(re.to(fe.to),fe.fromRanges.map(G=>c.to(G)))}Pe.to=Le})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(Pe){function Le(G){return{range:G.range&&c.from(G.range),uri:G.uri}}Pe.from=Le;function fe(G){return new l.Location(E.URI.revive(G.uri),c.to(G.range))}Pe.to=fe})(K=e.location||(e.location={}));var me;(function(Pe){function Le(G){const Oe=G,Be=G;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Be.uri,range:c.from(Oe.targetRange?Oe.targetRange:Be.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Pe.from=Le;function fe(G){return{targetUri:E.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}Pe.to=fe})(me=e.DefinitionLink||(e.DefinitionLink={}));var Ie;(function(Pe){function Le(G){return{range:c.from(G.range),contents:J.fromMany(G.contents)}}Pe.from=Le;function fe(G){return new l.Hover(G.contents.map(J.to),c.to(G.range))}Pe.to=fe})(Ie=e.Hover||(e.Hover={}));var Se;(function(Pe){function Le(G){return{range:c.from(G.range),expression:G.expression}}Pe.from=Le;function fe(G){return new l.EvaluatableExpression(c.to(G.range),G.expression)}Pe.to=fe})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Pe){function Le(G){if(G instanceof l.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof l.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function fe(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}Pe.to=fe})(ve=e.InlineValue||(e.InlineValue={}));var Ce;(function(Pe){function Le(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}Pe.from=Le;function fe(G){return new l.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}Pe.to=fe})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Pe){function Le(G){return{range:c.from(G.range),kind:G.kind}}Pe.from=Le;function fe(G){return new l.DocumentHighlight(c.to(G.range),G.kind)}Pe.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Pe){function Le(fe){switch(fe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Pe.to=Le})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Le(fe){return{triggerKind:ae.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Pe.to=Le})(Z=e.CompletionContext||(e.CompletionContext={}));var C;(function(Pe){function Le(G){switch(G){case l.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function fe(G){switch(G){case 1:return l.CompletionItemTag.Deprecated}}Pe.to=fe})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var N;(function(Pe){const Le=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function fe(Be){return Le.get(Be)??9}Pe.from=fe;const G=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Oe(Be){return G.get(Be)??l.CompletionItemKind.Property}Pe.to=Oe})(N=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(Pe){function Le(fe,G){const Oe=new l.CompletionItem(fe.label);return Oe.insertText=fe.insertText,Oe.kind=N.to(fe.kind),Oe.tags=fe.tags?.map(C.to),Oe.detail=fe.detail,Oe.documentation=R.isMarkdownString(fe.documentation)?J.to(fe.documentation):fe.documentation,Oe.sortText=fe.sortText,Oe.filterText=fe.filterText,Oe.preselect=fe.preselect,Oe.commitCharacters=fe.commitCharacters,g.Range.isIRange(fe.range)?Oe.range=c.to(fe.range):typeof fe.range=="object"&&(Oe.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Oe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Oe.insertText=new l.SnippetString(fe.insertText):(Oe.insertText=fe.insertText,Oe.textEdit=Oe.range instanceof l.Range?new l.TextEdit(Oe.range,Oe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Oe.additionalTextEdits=fe.additionalTextEdits.map(Be=>Ee.to(Be))),Oe.command=G&&fe.command?G.fromInternal(fe.command):void 0,Oe}Pe.to=Le})(H=e.CompletionItem||(e.CompletionItem={}));var x;(function(Pe){function Le(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:J.fromStrict(G.documentation)}}Pe.from=Le;function fe(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?J.to(G.documentation):G.documentation}}Pe.to=fe})(x=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(Pe){function Le(G){return{label:G.label,documentation:J.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(x.from):[],activeParameter:G.activeParameter}}Pe.from=Le;function fe(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?J.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(x.to):[],activeParameter:G.activeParameter}}Pe.to=fe})(te=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(Pe){function Le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.from):[]}}Pe.from=Le;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.to):[]}}Pe.to=fe})(pe=e.SignatureHelp||(e.SignatureHelp={}));var ke;(function(Pe){function Le(fe,G){const Oe=new l.InlayHint(I.to(G.position),typeof G.label=="string"?G.label:G.label.map(ue.to.bind(void 0,fe)),G.kind&&De.to(G.kind));return Oe.textEdits=G.textEdits&&G.textEdits.map(Ee.to),Oe.tooltip=R.isMarkdownString(G.tooltip)?J.to(G.tooltip):G.tooltip,Oe.paddingLeft=G.paddingLeft,Oe.paddingRight=G.paddingRight,Oe}Pe.to=Le})(ke=e.InlayHint||(e.InlayHint={}));var ue;(function(Pe){function Le(fe,G){const Oe=new l.InlayHintLabelPart(G.label);return Oe.tooltip=R.isMarkdownString(G.tooltip)?J.to(G.tooltip):G.tooltip,d.Command.is(G.command)&&(Oe.command=fe.fromInternal(G.command)),G.location&&(Oe.location=K.to(G.location)),Oe}Pe.to=Le})(ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Pe){function Le(G){return G}Pe.from=Le;function fe(G){return G}Pe.to=fe})(De=e.InlayHintKind||(e.InlayHintKind={}));var we;(function(Pe){function Le(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}Pe.from=Le;function fe(G){let Oe;if(G.url)try{Oe=typeof G.url=="string"?E.URI.parse(G.url,!0):E.URI.revive(G.url)}catch{}return new l.DocumentLink(c.to(G.range),Oe)}Pe.to=fe})(we=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Pe){function Le(G){const Oe=new l.ColorPresentation(G.label);return G.textEdit&&(Oe.textEdit=Ee.to(G.textEdit)),G.additionalTextEdits&&(Oe.additionalTextEdits=G.additionalTextEdits.map(Be=>Ee.to(Be))),Oe}Pe.to=Le;function fe(G){return{label:G.label,textEdit:G.textEdit?Ee.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Oe=>Ee.from(Oe)):void 0}}Pe.from=fe})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(Pe){function Le(G){return new l.Color(G[0],G[1],G[2],G[3])}Pe.to=Le;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Pe.from=fe})(He=e.Color||(e.Color={}));var et;(function(Pe){function Le(G){return{range:c.from(G.range)}}Pe.from=Le;function fe(G){return new l.SelectionRange(c.to(G.range))}Pe.to=fe})(et=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Pe){function Le(fe){switch(fe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Pe){function Le(G){switch(G){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function fe(G){switch(G){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Pe.to=fe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Pe){function Le(G){if(G===l.EndOfLine.CRLF)return 1;if(G===l.EndOfLine.LF)return 0}Pe.from=Le;function fe(G){if(G===1)return l.EndOfLine.CRLF;if(G===0)return l.EndOfLine.LF}Pe.to=fe})(rt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Pe){function Le(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(Me=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Pe){function Le(G){const Oe={start:G.start+1,end:G.end+1};return G.kind&&(Oe.kind=Q.from(G.kind)),Oe}Pe.from=Le;function fe(G){const Oe={start:G.start-1,end:G.end-1};return G.kind&&(Oe.kind=Q.to(G.kind)),Oe}Pe.to=fe})(it=e.FoldingRange||(e.FoldingRange={}));var Q;(function(Pe){function Le(G){if(G)switch(G){case l.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Pe.from=Le;function fe(G){if(G)switch(G.value){case d.FoldingRangeKind.Comment.value:return l.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return l.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return l.FoldingRangeKind.Region}}Pe.to=fe})(Q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Pe){function Le(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Le})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var be;(function(Pe){function Le(Be){return Be instanceof l.RelativePattern?Be.toJSON():typeof Be=="string"?Be:fe(Be)||G(Be)?new l.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Pe.from=Le;function fe(Be){const Ze=Be;return Ze?E.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(Be){return typeof Be=="string"?Be:new l.RelativePattern(E.URI.revive(Be.baseUri),Be.pattern)}Pe.to=Oe})(be=e.GlobPattern||(e.GlobPattern={}));var We;(function(Pe){function Le(fe){if(fe){if(Array.isArray(fe))return fe.map(Le);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:be.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Pe.from=Le})(We=e.LanguageSelector||(e.LanguageSelector={}));var ze;(function(Pe){function Le(G){return{start:G.start,end:G.end}}Pe.from=Le;function fe(G){return new l.NotebookRange(G.start,G.end)}Pe.to=fe})(ze=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Pe){function Le(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Pe.to=Le;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Pe.from=fe})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Pe){function Le(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Pe.to=Le})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Pe){function Le(G){switch(G){case l.NotebookCellKind.Markup:return b.CellKind.Markup;case l.NotebookCellKind.Code:default:return b.CellKind.Code}}Pe.from=Le;function fe(G){switch(G){case b.CellKind.Markup:return l.NotebookCellKind.Markup;case b.CellKind.Code:default:return l.NotebookCellKind.Code}}Pe.to=fe})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Pe){function Le(G){const Oe={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)l.NotebookCellData.validate(Be),Oe.cells.push(Dt.from(Be));return Oe}Pe.from=Le;function fe(G){const Oe=new l.NotebookData(G.cells.map(Dt.to));return(0,f.isEmptyObject)(G.metadata)||(Oe.metadata=G.metadata),Oe}Pe.to=fe})(at=e.NotebookData||(e.NotebookData={}));var Dt;(function(Pe){function Le(G){return{cellKind:Ge.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(It.from):[]}}Pe.from=Le;function fe(G){return new l.NotebookCellData(Ge.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(It.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Pe.to=fe})(Dt=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(Pe){function Le(G){return{mime:G.mime,valueBytes:T.VSBuffer.wrap(G.data)}}Pe.from=Le;function fe(G){return new l.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Pe.to=fe})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(Pe){function Le(G){return{outputId:G.id,items:G.items.map(Tt.from),metadata:G.metadata}}Pe.from=Le;function fe(G){const Oe=G.items.map(Tt.to);return new l.NotebookCellOutput(Oe,G.outputId,G.metadata)}Pe.to=fe})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Pe){function Le(Oe){return G(Oe)?{include:(0,f.withNullAsUndefined)(be.from(Oe.include)),exclude:(0,f.withNullAsUndefined)(be.from(Oe.exclude))}:(0,f.withNullAsUndefined)(be.from(Oe))}Pe.from=Le;function fe(Oe){return G(Oe)?{include:be.to(Oe.include),exclude:be.to(Oe.exclude)}:be.to(Oe)}Pe.to=fe;function G(Oe){const Be=Oe;return Be?!(0,f.isUndefinedOrNull)(Be.include)&&!(0,f.isUndefinedOrNull)(Be.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Mt;(function(Pe){function Le(fe,G,Oe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Oe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Pe.from=Le})(Mt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var zt;(function(Pe){function Le(fe,G,Oe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Be,Oe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Pe.from=Le})(zt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Pe){function Le(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Pe.from=Le})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ht;(function(Pe){function Le(G){return{uri:G.uri,provides:G.provides}}Pe.from=Le;function fe(G){return new l.NotebookRendererScript(E.URI.revive(G.uri),G.provides)}Pe.to=fe})(ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Pe){function Le(G){return{message:J.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:c.from(G.location.range),uri:G.location.uri}}}Pe.from=Le;function fe(G){const Oe=new l.TestMessage(typeof G.message=="string"?G.message:J.to(G.message));return Oe.actualOutput=G.actual,Oe.expectedOutput=G.expected,Oe.location=G.location?K.to(G.location):void 0,Oe}Pe.to=fe})(gt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Pe){function Le(G){const Oe=(0,a.getPrivateApiFor)(G).controllerId;return{extId:P.TestId.fromExtHostTestItem(G,Oe).toString(),label:G.label,uri:E.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Ot.namespace(Oe,Be.id)),range:g.Range.lift(c.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&J.fromStrict(G.error)||null}}Pe.from=Le;function fe(G){return{parent:void 0,error:void 0,id:P.TestId.fromString(G.extId).localId,label:G.label,uri:E.URI.revive(G.uri),tags:(G.tags||[]).map(Oe=>{const{tagId:Be}=Ot.denamespace(Oe);return new l.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Pe.toPlain=fe})(Ut=e.TestItem||(e.TestItem={})),function(Pe){function Le(G){return{id:G.id}}Pe.from=Le;function fe(G){return new l.TestTag(G.id)}Pe.to=fe}(Ot=e.TestTag||(e.TestTag={}));var Lt;(function(Pe){const Le=(G,Oe)=>{const Be=[];for(const[xe,ot]of Oe)P.TestId.compare(ot.item.extId,xe)===2&&(Oe.delete(xe),Be.push(ot));const Ze={...Ut.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(ot=>ot.type===0).map(gt.to)})),children:Be.map(xe=>Le(xe,Oe))};for(const xe of Ze.children)xe.parent=Ze;return Ze};function fe(G){const Oe=[],Be=new Map;for(const Ze of G.items){Be.set(Ze.item.extId,Ze);const xe=P.TestId.root(Ze.item.extId);G.request.targets.some(ot=>ot.controllerId===xe&&ot.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:G.completedAt,results:Oe.map(Ze=>Le(Ze,Be))}}Pe.to=fe})(Lt=e.TestResults||(e.TestResults={}));var pt;(function(Pe){function Le(Be){return{covered:Be.covered,total:Be.covered}}function fe(Be){return"line"in Be?I.from(Be):c.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:fe(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&fe(Ze.location)})):void 0}:{type:0,count:Be.executionCount,location:fe(Be.location)}}Pe.fromDetailed=G;function Oe(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Pe.fromFile=Oe})(pt=e.TestCoverage||(e.TestCoverage={}));var Ct;(function(Pe){function Le(fe){switch(fe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Pe){function Le(G){const Oe=new l.TypeHierarchyItem(ce.to(G.kind),G.name,G.detail||"",E.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Pe.to=Le;function fe(G,Oe,Be){if(Oe=Oe??G._sessionId,Be=Be??G._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,kind:ce.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=fe})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var $t;(function(Pe){function Le(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Pe.from=Le})($t=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Pe){function Le(Be,Ze,xe){const ot=Ze.fileData;return ot?new class extends l.DataTransferItem{asFile(){return{name:ot.name,uri:E.URI.revive(ot.uri),data:(0,M.once)(()=>xe())}}}("",Ze.id):Be===O.Mimes.uriList&&Ze.uriListData?new l.DataTransferItem(Oe(Ze.uriListData)):new l.DataTransferItem(Ze.asString)}Pe.to=Le;async function fe(Be,Ze){const xe=await Ze.asString();if(Be===O.Mimes.uriList)return{id:Ze.id,asString:xe,fileData:void 0,uriListData:G(xe)};const ot=Ze.asFile();return{id:Ze.id,asString:xe,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}}Pe.from=fe;function G(Be){return k.UriList.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return E.URI.parse(Ze)}catch{}return Ze})}function Oe(Be){return k.UriList.create(Be.map(Ze=>typeof Ze=="string"?Ze:E.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Pe){function Le(G,Oe){const Be=G.items.map(([Ze,xe])=>[Ze,Ke.to(Ze,xe,()=>Oe(xe.id))]);return new l.DataTransfer(Be)}Pe.toDataTransfer=Le;async function fe(G){const Oe={items:[]},Be=[];return G.forEach((Ze,xe)=>{Be.push((async()=>{Oe.items.push([xe,await Ke.from(xe,Ze)])})())}),await Promise.all(Be),Oe}Pe.toDataTransferDTO=fe})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(Ae[200],Re([1,0,2,14,7,8,166]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(h,O,S,f={timeout:1500,errors:3}){this.c=h,this.d=O,this.f=S,this.g=f,this.a=new R.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(h){return(O,S,f)=>{const g={dispose:this.a.push([O,S,h])};return Array.isArray(f)&&f.push(g),g}}async $participateInSave(h,O){const S=n.URI.revive(h);let f=!1;const E=setTimeout(()=>f=!0,this.g.timeout),g=[];try{for(const d of[...this.a]){if(f)break;const t=this.d.getDocument(S),a=await this.h(d,{document:t,reason:M.TextDocumentSaveReason.to(O)});g.push(a)}}finally{clearTimeout(E)}return g}h([h,O,S],f){const E=this.b.get(h);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(S,h,O,f).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this.b.get(h);this.b.set(h,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(h,O,S,f){const E=[],g=Date.now(),{document:d,reason:t}=f,{version:a}=d,m=Object.freeze({document:d,reason:t,waitUntil(b){if(Object.isFrozen(E))throw(0,T.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(b))}});try{O.apply(S,[m])}catch(b){return Promise.reject(b)}return Object.freeze(E),new Promise((b,P)=>{const p=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(E).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(p),b(i)}).catch(i=>{clearTimeout(p),P(i)})}).then(b=>{const P={edits:[]};for(const p of b)if(Array.isArray(p)&&p.every(i=>i instanceof k.TextEdit))for(const{newText:i,newEol:l,range:s}of p)P.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:s&&M.Range.from(s),text:i,eol:l&&M.EndOfLine.from(l)}});if(P.edits.length!==0)return a===d.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ae[201],Re([1,0,15,2,8,7,72]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(S,f,E,g){this.start=S,this.deletedCount=f,this.deletedItems=E,this.items=g}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(S,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,f,E){this.notebook=S,this.h=f,this.j=E,this.handle=E.handle,this.uri=T.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(k.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return S.g},set mime(g){S.g=g},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(E)}return this.f}setOutputs(S){this.a=S.map(k.NotebookCellOutput.to)}setOutputItems(S,f,E){const g=E.map(k.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===S);if(d&&(f||(d.items.length=0),d.items.push(...g),d.items.length>1&&d.items.every(t=>R.isTextStreamMime(t.mime)))){const t=new Map,a=[];d.items.forEach(m=>{let b;t.has(m.mime)?b=t.get(m.mime):(b=[],t.set(m.mime,b),a.push(m.mime)),b.push(m.data)}),d.items.length=0,a.forEach(m=>{const b=R.compressOutputItemStreams(t.get(m));d.items.push({mime:m,data:b.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=w;class h{constructor(S,f,E,g,d){this.k=S,this.l=f,this.m=E,this.uri=g,this.handle=h.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const S=this,f={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===n.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(E){return E=S.n(E),S.b[E].apiCell},getCells(E){return(E?S.p(E):S.b).map(d=>d.apiCell)},save(){return S.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,f,E){this.g=S.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:E});const g={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},d=[];for(const a of S.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,g.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,g.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),d.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),d.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<d.length;a++){const m=d[a],b=t.get(m.cell);if(b===void 0){const P=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});t.set(m.cell,P-1)}else g.cellChanges[b]={...g.cellChanges[b],...m}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let f=S.start|0,E=S.end|0;return f<0&&(f=0),E>this.b.length&&(E=this.b.length),S.with({start:f,end:E})}p(S){S=this.o(S);const f=[];for(let E=S.start;E<S.end;E++)f.push(this.b[E]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,f,E){if(this.j)return;const g=[],d=[],t=[];if(S.reverse().forEach(a=>{const b=a[2].map(i=>{const l=new w(this,this.l,i);return f||d.push(w.asModelAddData(this.apiNotebook,i)),l}),P=new A(a[0],a[1],[],b),p=this.b.splice(a[0],a[1],...b);for(const i of p)t.push(i.uri),P.deletedItems.push(i.apiCell);g.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),E)for(const a of g)E.push(a.asApiEvent())}s(S,f,E,g){const d=this.b.splice(S,f);this.b.splice(E,0,...d);const t=[new A(S,f,d.map(a=>a.apiCell),[]),new A(E,0,[],d)];for(const a of t)g.push(a.asApiEvent())}t(S,f){this.b[S].setOutputs(f)}u(S,f,E,g){this.b[S].setOutputItems(f,E,g)}v(S,f){const E=this.b[S];E.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(E.uri,f)}w(S,f){const E=this.b[S];E.apiCell.mime=f}x(S,f){this.b[S].setMetadata(f)}y(S,f){this.b[S].setInternalMetadata(f)}getCellFromApiCell(S){return this.b.find(f=>f.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(f=>f.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}h.a=0,e.ExtHostNotebookDocument=h}),define(Ae[102],Re([1,0,14,8,7]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,w,h,O,S,f){this.id=A,this.f=w,this.notebookData=h,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=O,this.c=f}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(w){this.selections=[w]},get selections(){return A.a},set selections(w){if(!Array.isArray(w)||!w.every(k.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=w,A.g(w)},get visibleRanges(){return A.b},revealRange(w,h){A.f.$tryRevealRange(A.id,T.NotebookRange.from(w),h??k.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(T.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Ae[202],Re([1,0,5,13,8]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,w){this.c=A,this.d=w,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,w);const h=this.d.getEditorById(A);w.visibleRanges&&h._acceptVisibleRanges(w.visibleRanges.ranges.map(k.NotebookRange.to)),w.selections&&h._acceptSelections(w.selections.selections.map(k.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const w in A)this.d.getEditorById(w)._acceptViewColumn(k.ViewColumn.to(A[w]))}};M=je([Ve(0,T.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ae[203],Re([1,0,8,170,146,21,64,14]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,E,g){const d=this.b++,{title:t,location:a,cancellable:m}=E,b={label:(0,k.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(d,{location:n.ProgressLocation.from(a),title:t,source:b,cancellable:m},f.isUnderDevelopment?void 0:f.identifier.value).catch(A.onUnexpectedExternalError),this.d(d,g,!!m)}d(f,E,g){let d;g&&(d=new M.CancellationTokenSource,this.c.set(f,d));const t=m=>{this.a.$progressEnd(m),this.c.delete(m),d?.dispose()};let a;try{a=E(new O(this.a,f),g&&d?d.token:M.CancellationToken.None)}catch(m){throw t(f),m}return a.then(m=>t(f),m=>t(f)),a}$acceptProgressCanceled(f){const E=this.c.get(f);E&&(E.cancel(),this.c.delete(f))}}e.ExtHostProgress=w;function h(S,f){return S.message=f.message,typeof f.increment=="number"&&(typeof S.increment=="number"?S.increment+=f.increment:S.increment=f.increment),S}class O extends T.Progress{constructor(f,E){super(g=>this.throttledReport(g)),this.c=f,this.d=E}throttledReport(f){this.c.$progressReport(this.d,f)}}je([(0,R.throttle)(100,(S,f)=>h(S,f),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ae[103],Re([1,0,44,98,45,73,56,8,2]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const h=(b,P,p,i)=>{let l=P;return{enumerable:!0,configurable:!1,get(){return l},set(s){if(!p(l,s)){const c=l;l=s,b.listener?.(i(s,c))}}}},O=(b,P)=>b===P,S={range:(b,P)=>b===P?!0:!b||!P?!1:b.isEqual(P),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,P)=>!(b.length!==P.length||b.some(p=>!P.find(i=>p.id===i.id)))},f=b=>P=>({op:4,update:b(P)}),E=(b,P)=>({range:(()=>{let p;const i=f(l=>({range:n.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return p},set(l){b.listener?.({op:6}),S.range(p,l)||(p=l,b.listener?.(i(l)))}}})(),label:h(b,P,S.label,f(p=>({label:p}))),description:h(b,void 0,S.description,f(p=>({description:p}))),sortText:h(b,void 0,S.sortText,f(p=>({sortText:p}))),canResolveChildren:h(b,!1,S.canResolveChildren,p=>({op:2,state:p})),busy:h(b,!1,S.busy,f(p=>({busy:p}))),error:h(b,void 0,S.error,f(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:h(b,[],S.tags,(p,i)=>({op:1,new:p.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),g=b=>{const P=k.TestId.fromString(b.extId),p=new t(P.controllerId,P.localId,b.label,w.URI.revive(b.uri)||void 0);return p.range=A.Range.to(b.range||void 0),p.description=b.description||void 0,p.sortText=b.sortText||void 0,p.tags=b.tags.map(i=>A.TestTag.to({id:(0,R.denamespaceTestTag)(i).tagId})),p},d=b=>{let P;for(const p of b.tests){const i=g(p.item);(0,T.getPrivateApiFor)(i).parent=P,P=i}return P};e.toItemFromContext=d;class t{constructor(P,p,i,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,T.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,M.createTestItemChildren)(s,T.getPrivateApiFor,t),enumerable:!0,writable:!1},...E(s,i)})}}e.TestItemImpl=t;class a extends t{constructor(P,p){super(P,P,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class m extends M.TestItemCollection{constructor(P,p,i){super({controllerId:P,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:T.getPrivateApiFor,getChildren:l=>l.children,root:new a(P,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(Ae[104],Re([1,0,49,14,84,8,7]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(f,E,g){const d=A.c.nextId();f.$registerTextEditorDecorationType(E.identifier,d,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){f.$removeTextEditorDecorationType(d)}})}}A.c=new k.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class w{constructor(f,E){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,E){this.k();let g=null;if(f instanceof R.Position)g=new R.Range(f,f);else if(f instanceof R.Range)g=f;else throw new Error("Unrecognized location");this.l(g,E,!1)}insert(f,E){this.k(),this.l(new R.Range(f,f),E,!0)}delete(f){this.k();let E=null;if(f instanceof R.Range)E=f;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(f,E,g){const d=this.c.validateRange(f);this.g.push({range:d,text:E,forceMoveMarkers:g})}setEndOfLine(f){if(this.k(),f!==R.EndOfLine.LF&&f!==R.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=f}}class h{constructor(f,E,g,d){this.c=f,this.d=E,this._accept(g),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(a){t.m(a)},get indentSize(){return t.g},set indentSize(a){t.o(a)},get insertSpaces(){return t.h},set insertSpaces(a){t.q(a)},get cursorStyle(){return t.j},set cursorStyle(a){t.s(a)},get lineNumbers(){return t.k},set lineNumbers(a){t.t(a)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const E=Math.floor(f);return E>0?E:null}if(typeof f=="string"){const E=parseInt(f,10);return isNaN(E)?null:E>0?E:null}return null}m(f){const E=this.l(f);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const E=Math.floor(f);return E>0?E:null}if(typeof f=="string"){const E=parseInt(f,10);return isNaN(E)?null:E>0?E:null}return null}o(f){const E=this.n(f);if(E!==null){if(typeof E=="number"){if(this.g===E)return;this.g=E}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const E=this.p(f);if(typeof E=="boolean"){if(this.h===E)return;this.h=E}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(f)})))}assign(f){const E={};let g=!1;if(typeof f.tabSize<"u"){const d=this.l(f.tabSize);d==="auto"?(g=!0,E.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,g=!0,E.tabSize=d)}if(typeof f.indentSize<"u"){const d=this.n(f.indentSize);d==="tabSize"?(g=!0,E.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,g=!0,E.indentSize=d)}if(typeof f.insertSpaces<"u"){const d=this.p(f.insertSpaces);d==="auto"?(g=!0,E.insertSpaces=d):this.h!==d&&(this.h=d,g=!0,E.insertSpaces=d)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,g=!0,E.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,g=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(f.lineNumbers)),g&&this.u("setOptions",this.c.$trySetOptions(this.d,E))}u(f,E){E.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(g)})}}e.ExtHostTextEditorOptions=h;class O{constructor(f,E,g,d,t,a,m,b){this.id=f,this.j=E,this.k=g,this.g=!1,this.h=new Set,this.c=t,this.d=new h(this.j,this.id,a,g),this.e=m,this.f=b;const P=this;this.value=Object.freeze({get document(){return d.value},set document(p){throw(0,T.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,T.illegalArgument)("selection");P.c=[p],P.l()},get selections(){return P.c},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof R.Selection)))throw(0,T.illegalArgument)("selections");P.c=p,P.l()},get visibleRanges(){return P.e},set visibleRanges(p){throw(0,T.readonly)("visibleRanges")},get options(){return P.d.value},set options(p){P.g||P.d.assign(p)},get viewColumn(){return P.f},set viewColumn(p){throw(0,T.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new w(d.value,i);return p(l),P.m(l)},insertSnippet(p,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=P.c.map(c=>M.Range.from(c));else if(i instanceof R.Position){const{lineNumber:c,column:o}=M.Position.from(i);s=[{startLineNumber:c,startColumn:o,endLineNumber:c,endColumn:o}]}else if(i instanceof R.Range)s=[M.Range.from(i)];else{s=[];for(const c of i)if(c instanceof R.Range)s.push(M.Range.from(c));else{const{lineNumber:o,column:I}=M.Position.from(c);s.push({startLineNumber:o,startColumn:I,endLineNumber:o,endColumn:I})}}return E.$tryInsertSnippet(f,d.value.version,p.value,s,l)},setDecorations(p,i){const l=i.length===0;l&&!P.h.has(p.key)||(l?P.h.delete(p.key):P.h.add(p.key),P.n(()=>{if(M.isDecorationOptionsArr(i))return E.$trySetDecorations(f,p.key,M.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let c=0,o=i.length;c<o;c++){const I=i[c];s[4*c]=I.start.line+1,s[4*c+1]=I.start.character+1,s[4*c+2]=I.end.line+1,s[4*c+3]=I.end.character+1}return E.$trySetDecorationsFast(f,p.key,s)}}))},revealRange(p,i){P.n(()=>E.$tryRevealRange(f,M.Range.from(p),i||R.TextEditorRevealType.Default))},show(p){E.$tryShowEditor(f,M.ViewColumn.from(p))},hide(){E.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const E=f.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const g=E.edits.map(t=>t.range);g.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=g.length-1;t<a;t++){const m=g[t].end;if(g[t+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=E.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,d,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.ExtHostTextEditor=O}),define(Ae[204],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[205],Re([1,0,159,14,29,90,70,30,24,204,169,96]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=A.Registry.as(R.Extensions.JSONContribution);class E{constructor(p,i,l){this.a=p,this.b=i,this.c=l}d(p,i){this.a({type:p,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(k.default.Error,p)}warn(p){this.d(k.default.Warning,p)}info(p){this.d(k.default.Info,p)}}e.ExtensionMessageCollector=E;class g{static a(p){const i=new w.ExtensionIdentifierSet;for(let l=0,s=p.length;l<s;l++)i.add(p[l].description.identifier);return i}static compute(p,i){if(!p||!p.length)return new g(i,[]);if(!i||!i.length)return new g([],p);const l=this.a(p),s=this.a(i),c=i.filter(I=>!l.has(I.description.identifier)),o=p.filter(I=>!s.has(I.description.identifier));return new g(c,o)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=g;class d{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=g.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,T.onUnexpectedError)(p)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class m{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new d(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,i),p.activationEventsGenerator&&S.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,f.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=m;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new m),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),f.registerSchema(a,e.schema),f.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}}]}}}})}),define(Ae[206],Re([1,0,156,9,23,205,31,5]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var h;(function(f){function E(g,d,t){if(!g)return;const a=T.isString(g.type)?g.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const m=[];if(Array.isArray(g.required))for(const b of g.required)T.isString(b)&&m.push(b);return{extensionId:d.value,taskType:a,required:m,properties:g.properties?k.deepClone(g.properties):{},when:g.when?R.ContextKeyExpr.deserialize(g.when):void 0}}f.from=E})(h||(h={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,E)=>{for(const g of f)g.type&&E.push(`onTaskType:${g.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:w}});class S{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,g)=>{O.setHandler((d,t)=>{this.c=void 0;try{for(const a of t.removed){const m=a.value;for(const b of m)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const a of t.added){const m=a.value;for(const b of m){const P=h.from(b,a.description.identifier,a.collector);P&&(this.a[P.taskType]=P)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const g of this.all()){const d={type:"object",additionalProperties:!1};g.required.length>0&&(d.required=g.required.slice(0)),g.properties!==void 0?d.properties=k.deepClone(g.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[g.taskType]},E.push(d)}this.c={oneOf:E}}return this.c}}e.TaskDefinitionRegistry=new S}),define(Ae[207],Re([1,0,157,9,22,23,31,206]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var w;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function $(B){if(!B)return U.Strong;switch(B.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=$}(w=e.ShellQuoting||(e.ShellQuoting={}));var h;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(h=e.CommandOptions||(e.CommandOptions={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(U){function $(B){switch(B.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var S;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function $(B){switch(B.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=$}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(U){function $(B){switch(B.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=$}(f=e.PanelKind||(e.PanelKind={}));var E;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:S.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(U){function $(q){switch(q.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=$;function B(q){switch(q){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=B}(g=e.RuntimeType||(e.RuntimeType={}));var d;(function(U){function $(B){return T.isString(B)?B:B.value}U.value=$})(d=e.CommandString||(e.CommandString={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function $(q){return q===U.Clean._id||q===U.Build._id||q===U.Rebuild._id||q===U.Test._id}U.is=$;function B(q){if(q!==void 0)return T.isString(q)?$(q)?{_id:q,isDefault:!1}:void 0:q}U.from=B})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var m;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function $(B){switch(B){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=$})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(U){U.parallel="parallel",U.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var P;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor($,B,q,he,Ee,ie){this._label="",this._id=$,B&&(this._label=B),q&&(this.type=q),this.runOptions=he,this.configurationProperties=Ee,this._source=ie}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,B=!1){if($===void 0)return!1;if(T.isString($))return $===this._label||$===this.configurationProperties.identifier||B&&$===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class l extends i{constructor($,B,q,he,Ee,ie,ce,de){super($,q,void 0,ce,de,B),this.command={},this._source=B,this.hasDefinedMatchers=ie,Ee&&(this.command=Ee)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case g.Shell:B="shell";break;case g.Process:B="process";break;case g.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is($){return $ instanceof l}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let B=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(B+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:B};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new l($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=l;class s extends i{constructor($,B,q,he,Ee,ie,ce){super($,q,he,ie,ce,B),this._source=B,this.configures=Ee}static is($){return $ instanceof s}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let B=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(B+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:B};return JSON.stringify(q)}}e.ConfiguringTask=s;class c extends i{constructor($,B,q,he,Ee,ie,ce,de,Te){super($,q,he,de,Te,B),this.defines=Ee,this.hasDefinedMatchers=ce,this.command=ie,this.icon=Te.icon,this.hide=Te.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof c}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new c($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=c;class o extends i{constructor($,B,q,he,Ee,ie){super($,q,he,Ee,ie,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new o($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=o;var I;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(I=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(I=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor($){this.c=new Map;for(let B=0;B<$.length;B++)this.c.set($[B].uri.toString(),B)}compare($,B){const q=$.getWorkspaceFolder(),he=B.getWorkspaceFolder();if(q&&he){let Ee=this.c.get(q.uri.toString());Ee=Ee===void 0?0:Ee+1;let ie=this.c.get(he.uri.toString());return ie=ie===void 0?0:ie+1,Ee===ie?$._label.localeCompare(B._label):Ee-ie}else return!q&&he?-1:q&&!he?1:0}}e.TaskSorter=u;var v;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var D;(function(U){U.SingleRun="singleRun",U.Background="background"})(D=e.TaskRunType||(e.TaskRunType={}));var y;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(y=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(U){function $(B,q,he,Ee){if(q){const ie={kind:B,taskId:q._id,taskName:q.configurationProperties.name,runType:q.configurationProperties.isBackground?"background":"singleRun",group:q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:q};return B==="start"?ie.resolvedVariables=Ee:B==="processStarted"?ie.processId=Ee:B==="processEnded"&&(ie.exitCode=Ee),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}U.create=$})(W=e.TaskEvent||(e.TaskEvent={}));var X;(function(U){function $(q){const he=Object.keys(q).sort();let Ee="";for(const ie of he){let ce=q[ie];ce instanceof Object?ce=$(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),Ee+=ie+","+ce+","}return Ee}function B(q){const Ee={_key:$(q),type:q.taskType};return Object.assign(Ee,q),Ee}U.create=B})(X=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var _;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(_=e.TaskSettingId||(e.TaskSettingId={}));var J;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(J=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var j;(function(U){function $(B,q){const he=A.TaskDefinitionRegistry.get(B.type);if(he===void 0){const de=M.deepClone(B);return delete de._key,X.create(de)}const Ee=Object.create(null);Ee.type=he.taskType;const ie=new Set;he.required.forEach(de=>ie.add(de));const ce=he.properties;for(const de of Object.keys(ce)){const Te=B[de];if(Te!=null)Ee[de]=Te;else if(ie.has(de)){const le=ce[de];if(le.default!==void 0)Ee[de]=M.deepClone(le.default);else switch(le.type){case"boolean":Ee[de]=!1;break;case"number":case"integer":Ee[de]=0;break;case"string":Ee[de]="";break;default:q.error(n.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return X.create(Ee)}U.createTaskIdentifier=$})(j=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ae[208],Re([1,0,14]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,A)=>{this.b=R,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,n.onUnexpectedError)(R))}then(R,A){return this.j().then(R,A)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.LazyPromise=T;class k extends T{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=k}),define(Ae[46],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const T=[];function k(A){const w=new n(A);return T[w.nid]=w,w}e.createProxyIdentifier=k;function M(A){return T[A].sid}e.getStringIdentifierForProxy=M;class R{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=R}),define(Ae[4],Re([1,0,46]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var M;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var h;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(h=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(t){return t._id=S.a++,t}}S.a=0,e.IdObject=S;var f;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ae[77],Re([1,0,3,13,4,18]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(w,h){this.c=h,this.a=new Set,this.b=w.getProxy(k.MainContext.MainThreadTelemetry)}report(w,h,O){const S=this.d(w,h);this.a.has(S)||(this.a.add(S),h.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:h.identifier.value,apiId:w}))}d(w,h){return`${w}-${h.identifier.value}`}};R=je([Ve(0,M.IExtHostRpcService),Ve(1,T.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(A,w,h){}})}),define(Ae[209],Re([1,0,5,4,7,24]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=w.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,h,O,S={}){const f=M.ExtensionIdentifier.toKey(w.identifier),E=this.f.get(f)||[],g=[...O].sort().join(" ");let d=E.find(t=>t.providerId===h&&t.scopes===g);if(d)return d.result;{const t=this.g(w,f,h,O,S);d={providerId:h,scopes:g,result:t},E.push(d),this.f.set(f,E);try{await t}finally{const a=E.findIndex(m=>m.providerId===h&&m.scopes===g);a>-1&&(E.splice(a),this.f.set(f,E))}return t}}async g(w,h,O,S,f={}){await this.a.$ensureProvider(O);const E=w.displayName||w.name;return this.a.$getSession(O,S,h,E,f)}async removeSession(w,h){const O=this.b.get(w);return O?O.provider.removeSession(h):this.a.$removeSession(w,h)}registerAuthenticationProvider(w,h,O,S){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:h,provider:O,options:S??{supportsMultipleAccounts:!1}}),this.c.find(E=>E.id===w)||this.c.push({id:w,label:h});const f=O.onDidChangeSessions(E=>{this.a.$sendDidChangeSessions(w,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this.a.$registerAuthenticationProvider(w,h,S?.supportsMultipleAccounts??!1),new k.Disposable(()=>{f.dispose(),this.b.delete(w);const E=this.c.findIndex(g=>g.id===w);E>-1&&this.c.splice(E),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.createSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.removeSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.getSessions(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,h){return this.d.fire({provider:{id:w,label:h}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(Ae[210],Re([1,0,4,18,8]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,w){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:h=>w.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,w,h){const O=k.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,h?.isRefactoring??!1)}};M=je([Ve(0,T.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ae[211],Re([1,0,4]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(M){const R=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(A){return R.$writeText(A)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[38],Re([1,0,9,7,8,23,4,16,13,66,44,265,2,6,3,18,103,25,46,40,78,52,57]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i){"use strict";var l,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(y,W,X){l.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),c.set(this,void 0),Je(this,l,y.getProxy(R.MainContext.MainThreadCommands),"f"),this.d=W,Je(this,c,X,"f"),Je(this,s,y.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,_=>{const J=this.c.get(_);return J?.result===u.Void?J:void 0},W),this.f=[{processArgument(_){return(0,h.revive)(_)}},{processArgument(_){return(0,M.cloneAndChange)(_,function(J){if(O.Range.isIRange(J))return k.Range.to(J);if(S.Position.isIPosition(J))return k.Position.to(J);if(O.Range.isIRange(J.range)&&f.URI.isUri(J.uri))return k.location.to(J);if(J instanceof a.VSBuffer)return J.buffer.buffer;if(!Array.isArray(J))return J})}}]}registerArgumentProcessor(y){this.f.push(y)}registerApiCommand(y){const W=this.registerCommand(!1,y.id,async(...X)=>{const _=y.args.map((j,U)=>{if(!j.validate(X[U]))throw new Error(`Invalid argument '${j.name}' when running '${y.id}', received: ${X[U]}`);return j.convert(X[U])}),J=await this.executeCommand(y.internalId,..._);return y.result.convert(J,X,this.converter)},void 0,{description:y.description,args:y.args,returns:y.result.description});return this.c.set(y.id,y),new T.Disposable(()=>{W.dispose(),this.c.delete(y.id)})}registerCommand(y,W,X,_,J,j){if(this.d.trace("ExtHostCommands#registerCommand",W),!W.trim().length)throw new Error("invalid id");if(this.b.has(W))throw new Error(`command '${W}' already exists`);return this.b.set(W,{callback:X,thisArg:_,description:J,extension:j}),y&&Fe(this,l,"f").$registerCommand(W),new T.Disposable(()=>{this.b.delete(W)&&y&&Fe(this,l,"f").$unregisterCommand(W)})}executeCommand(y,...W){return this.d.trace("ExtHostCommands#executeCommand",y),this.g(y,W,!0)}async g(y,W,X){if(this.b.has(y))return Fe(this,l,"f").$fireCommandActivationEvent(y),this.h(y,W,!1);{let _=!1;const J=(0,M.cloneAndChange)(W,function(j){if(j instanceof T.Position)return k.Position.from(j);if(j instanceof T.Range)return k.Range.from(j);if(j instanceof T.Location)return k.location.from(j);if(T.NotebookRange.isNotebookRange(j))return k.NotebookRange.from(j);if(j instanceof ArrayBuffer)return _=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return _=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return _=!0,j;if(!Array.isArray(j))return j});try{const j=await Fe(this,l,"f").$executeCommand(y,_?new m.SerializableObjectWithBuffers(J):J,X);return(0,h.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(y,W,!1);throw j}}}async h(y,W,X){const _=this.b.get(y);if(!_)throw new Error("Unknown command");const{callback:J,thisArg:j,description:U}=_;if(U)for(let B=0;B<U.args.length;B++)try{(0,n.validateConstraint)(W[B],U.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${y}' failed. Illegal argument '${U.args[B].name}' - ${U.args[B].description}`)}const $=P.StopWatch.create();try{return await J.apply(j,W)}catch(B){if(y===this.converter.delegatingCommandId){const q=this.converter.getActualCommand(...W);q&&(y=q.command)}if(this.d.error(B,y,_.extension?.identifier),!X)throw B;if(_.extension?.identifier){const q=Fe(this,c,"f").onExtensionError(_.extension.identifier,B);this.d.trace("forwarded error to extension?",q,_.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(B)),this.id=y,this.source=_.extension?.displayName??_.extension?.name}}}finally{this.j(_,y,$.elapsed())}}j(y,W,X){!y.extension||Fe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:y.extension.identifier.value,id:new p.TelemetryTrustedValue(W),duration:X})}$executeContributedCommand(y,...W){this.d.trace("ExtHostCommands#$executeContributedCommand",y);const X=this.b.get(y);return X?(W=W.map(_=>this.f.reduce((J,j)=>j.processArgument(J,X.extension?.identifier),_)),this.h(y,W,!0)):Promise.reject(new Error(`Contributed command '${y}' does not exist.`))}getCommands(y=!1){return this.d.trace("ExtHostCommands#getCommands",y),Fe(this,l,"f").$getCommands().then(W=>(y&&(W=W.filter(X=>X[0]!=="_")),W))}$getContributedCommandHandlerDescriptions(){const y=Object.create(null);for(const[W,X]of this.b){const{description:_}=X;_&&(y[W]=_)}return Promise.resolve(y)}};l=new WeakMap,s=new WeakMap,c=new WeakMap,o=je([Ve(0,d.IExtHostRpcService),Ve(1,w.ILogService),Ve(2,i.IExtHostTelemetry)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class I{constructor(y,W,X){this.d=y,this.f=W,this.g=X,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(y,W){if(!y)return;const X={$ident:void 0,id:y.command,title:y.title,tooltip:y.tooltip};if(!y.command)return X;const _=this.f(y.command);if(_)X.id=_.internalId,X.arguments=_.args.map((J,j)=>J.convert(y.arguments&&y.arguments[j]));else if((0,A.isNonEmptyArray)(y.arguments)){const J=`${y.command}/${++this.c}`;this.b.set(J,y),W.add((0,E.toDisposable)(()=>{this.b.delete(J),this.g.trace("CommandsConverter#DISPOSE",J)})),X.$ident=J,X.id=this.delegatingCommandId,X.arguments=[J],this.g.trace("CommandsConverter#CREATE",y.command,J)}return X}fromInternal(y){return typeof y.$ident=="string"?this.b.get(y.$ident):{command:y.id,title:y.title,arguments:y.arguments}}getActualCommand(...y){return this.b.get(y[0])}h(...y){const W=this.getActualCommand(...y);return this.g.trace("CommandsConverter#EXECUTE",y[0],W?W.command:"MISSING"),W?this.d.executeCommand(W.command,...W.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${y[0]}`)}}e.CommandsConverter=I;class r{constructor(y,W,X,_){this.name=y,this.description=W,this.validate=X,this.convert=_}optional(){return new r(this.name,`(optional) ${this.description}`,y=>y==null||this.validate(y),y=>y===void 0?void 0:y===null?null:this.convert(y))}with(y,W){return new r(y??this.name,W??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",D=>f.URI.isUri(D),D=>D),r.Position=new r("position","A position in a text document",D=>T.Position.isPosition(D),k.Position.from),r.Range=new r("range","A range in a text document",D=>T.Range.isRange(D),k.Range.from),r.Selection=new r("selection","A selection in a text document",D=>T.Selection.isSelection(D),k.Selection.from),r.Number=new r("number","",D=>typeof D=="number",D=>D),r.String=new r("string","",D=>typeof D=="string",D=>D),r.CallHierarchyItem=new r("item","A call hierarchy item",D=>D instanceof T.CallHierarchyItem,k.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",D=>D instanceof T.TypeHierarchyItem,k.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",D=>D instanceof t.TestItemImpl,k.TestItem.from),e.ApiCommandArgument=r;class u{constructor(y,W){this.description=y,this.convert=W}}u.Void=new u("no result",D=>D),e.ApiCommandResult=u;class v{constructor(y,W,X,_,J){this.id=y,this.internalId=W,this.description=X,this.args=_,this.result=J}}e.ApiCommand=v}),define(Ae[212],Re([1,0,16,15,2,76,89,31,93,38,8,7]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const f=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(O.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,n.isFalsyOrEmpty)(t))return;class m extends S.SymbolInformation{static to(P){const p=new m(P.name,O.SymbolKind.to(P.kind),P.containerName||"",new S.Location(a[0],O.Range.to(P.range)));return p.detail=P.detail,p.range=p.location.range,p.selectionRange=O.Range.to(P.selectionRange),p.children=P.children?P.children.map(m.to):[],p}}return t.map(m.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(O.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(O.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>S.Position.isPosition(a)),t=>t.map(O.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let m;for(const b of a.reverse())m=new S.SelectionRange(O.Range.to(b),m);return m}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(O.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(O.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(O.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(O.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:O.Range.to(t.range),placeholder:t.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return O.WorkspaceEdit.to(t)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(O.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new S.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new S.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,m)=>{if(!t)return new S.CompletionList([]);const b=t.suggestions.map(P=>O.CompletionItem.to(P,m));return new S.CompletionList(b,t.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return O.SignatureHelp.to(t)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,m)=>g(b=>new S.CodeLens(O.Range.to(b.range),b.command&&m.fromInternal(b.command)))(t))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.Range.isRange(t),t=>S.Selection.isSelection(t)?O.Selection.from(t):O.Range.from(t)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,m)=>g(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(b.command)}else{const P=new S.CodeAction(b.title,b.kind?new S.CodeActionKind(b.kind):void 0);return b.edit&&(P.edit=O.WorkspaceEdit.to(b.edit)),b.command&&(P.command=m.fromInternal(b.command)),P.isPreferred=b.isPreferred,P}})(t))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new S.ColorInformation(O.Range.to(a.range),O.Color.to(a.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",t=>t instanceof S.Color,O.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:O.Range.from(t.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(O.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,m)=>t.map(O.InlayHint.to.bind(void 0,m)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,a)=>{if(t)return t.map(O.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>O.NotebookExclusiveDocumentPattern.to(a))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(O.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>k.URI.isUri(t)||typeof t=="string"&&(0,w.matchesSomeScheme)(t,T.Schemas.http,T.Schemas.https),t=>t),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],h.ApiCommandResult.Void)];class E{static register(a){f.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=E;function g(t){return a=>{if(Array.isArray(a))return a.map(t)}}function d(t){if(!Array.isArray(t))return;const a=[];for(const m of t)M.isLocationLink(m)?a.push(O.DefinitionLink.to(m)):a.push(O.location.to(m));return a}}),define(Ae[213],Re([1,0,17,64,5,6,2,76,24,8,7,4]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(E,g,d){const t=E.getProxy(S.MainContext.MainThreadComments);class a{constructor(){this.b=new Map,this.c=new w.ExtensionIdentifierMap,g.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const I=this.b.get(o.handle);return I?I.value:o}else if(o&&o.$mid===7){const I=this.b.get(o.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.commentThreadHandle);return r?r.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);return r?o.$mid===8?r.value:{thread:r.value,text:o.text}:o}else if(o&&o.$mid===10){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);if(!r)return o;const u=o.commentUniqueId,v=r.getCommentByUniqueId(u);return v||o}else if(o&&o.$mid===11){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);if(!r)return o;const u=o.text,v=o.commentUniqueId,D=r.getCommentByUniqueId(v);return D?(typeof D.body=="string"?D.body=u:D.body=new O.MarkdownString(u),D):o}return o}})}createCommentController(o,I,r){const u=a.a++,v=new b(o,u,I,r);this.b.set(v.handle,v);const D=this.c.get(o.identifier)||[];return D.push(v),this.c.set(o.identifier,D),v.value}$createCommentThreadTemplate(o,I,r){const u=this.b.get(o);!u||u.$createCommentThreadTemplate(I,r)}async $updateCommentThreadTemplate(o,I,r){const u=this.b.get(o);!u||u.$updateCommentThreadTemplate(I,r)}$deleteCommentThread(o,I){this.b.get(o)?.$deleteCommentThread(I)}$provideCommentingRanges(o,I,r){const u=this.b.get(o);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const v=d.getDocument(R.URI.revive(I));return(0,n.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(v,r)).then(D=>D?D.map(y=>h.Range.from(y)):void 0)}$toggleReaction(o,I,r,u,v){const D=this.b.get(o);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const y=D.getCommentThread(I);if(y){const W=y.getCommentByUniqueId(u.uniqueIdInThread);if(D!==void 0&&W&&D.reactionHandler)return D.reactionHandler(W,i(v))}return Promise.resolve(void 0)})}dispose(){}}a.a=0;class m{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){o.isEqual(this.p)||(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return this.h}set state(o){this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,I,r,u,v,D,y,W){this.m=I,this.n=r,this.o=u,this.p=v,this.q=D,this.extensionDescription=y,this.r=W,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${o}.${this.handle}`),t.$createCommentThread(I,this.handle,this.n,this.o,h.Range.from(this.p),y.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(I,this.handle)}});const X=this;this.value={get uri(){return X.uri},get range(){return X.range},set range(_){X.range=_},get comments(){return X.comments},set comments(_){X.comments=_},get collapsibleState(){return X.collapsibleState},set collapsibleState(_){X.collapsibleState=_},get canReply(){return X.canReply},set canReply(_){X.canReply=_},get contextValue(){return X.contextValue},set contextValue(_){X.contextValue=_},get label(){return X.label},set label(_){X.label=_},get state(){return X.state},set state(_){X.state=_},dispose:()=>{X.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const o=r=>Object.prototype.hasOwnProperty.call(this.b,r),I={};o("range")&&(I.range=h.Range.from(this.p)),o("label")&&(I.label=this.label),o("contextValue")&&(I.contextValue=this.contextValue??null),o("comments")&&(I.comments=this.q.map(r=>P(this,r,this.k))),o("collapsibleState")&&(I.collapseState=l(this.g)),o("canReply")&&(I.canReply=this.canReply),o("state")&&(I.state=s(this.h)),o("isTemplate")&&(I.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(o){for(const I of this.k){const r=I[0],u=I[1];if(o===u)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}m.a=0,je([(0,T.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,I,r,u){this.f=o,this.g=I,this.h=r,this.i=u,this.a=new Map,t.$registerCommentController(this.handle,r,u);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(D){v.options=D},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(D){v.commentingRangeProvider=D},get reactionHandler(){return v.reactionHandler},set reactionHandler(D){v.reactionHandler=D},createCommentThread(D,y,W){return v.createCommentThread(D,y,W).value},dispose:()=>{v.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(o,I,r,u){if(typeof o=="string"){const v=new m(this.id,this.handle,o,I,r,u,this.f,!1);return this.a.set(v.handle,v),v}else{const v=new m(this.id,this.handle,void 0,o,I,r,this.f,!1);return this.a.set(v.handle,v),v}}$createCommentThreadTemplate(o,I){const r=new m(this.id,this.handle,void 0,R.URI.revive(o),h.Range.to(I),[],this.f,!0);return r.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(o,I){const r=this.a.get(o);r&&(r.range=h.Range.to(I))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function P(c,o,I){let r=I.get(o);r||(r=++c.commentHandle,I.set(o,r));const u=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:r,body:typeof o.body=="string"?o.body:h.MarkdownString.from(o.body),userName:o.author.name,userIconPath:u,label:o.label,commentReactions:o.reactions?o.reactions.map(v=>p(v)):void 0,timestamp:o.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?h.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function i(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function l(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function s(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new a}e.createExtHostComments=f}),define(Ae[214],Re([1,0,23,4,27,18]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(O,S){this.a=O.getProxy(T.MainContext.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,S){const f=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){f.e(O,S,E,arguments)}})}e(O,S,f,E){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:w(E,this.b)}),this.c&&this.f(O,f,E)}};R=je([Ve(0,M.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],R),e.AbstractExtHostConsoleForwarder=R;const A=1e5;function w(h,O){const S=[];if(h.length)for(let f=0;f<h.length;f++){let E=h[f];if(typeof E>"u")E="undefined";else if(E instanceof Error){const g=E;g.stack?E=g.stack:E=g.toString()}S.push(E)}if(O){const f=new Error().stack;f&&S.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(S);return f.length>A?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ae[105],Re([1,0,2,4,7,3,18,13,16,12,19,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class $i{constructor(g,d){this.h=d,this.f=new Map,this.g=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,d){const t=$i.c++;this.f.set(t,{provider:g,extensionDescription:d}),this.g.$registerDecorationProvider(t,d.identifier.value);const a=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(t,null);return}const b=(0,w.asArray)(m);if(b.length<=$i.d){this.g.$onDidChange(t,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,b.length);const P=b.map(l=>({uri:l,rank:(0,h.count)(l.path,"/")})),p=(0,w.groupBy)(P,(l,s)=>l.rank-s.rank||(0,h.compare)(l.uri.path,s.uri.path)),i=[];e:for(const l of p){let s;for(const c of l){const o=(0,O.dirname)(c.uri.path);if(s!==o&&(s=o,i.push(c.uri)>=$i.d))break e}}this.g.$onDidChange(t,i)});return new k.Disposable(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(g,d,t){if(!this.f.has(g))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:b}=this.f.get(g);return await Promise.all(d.map(async P=>{try{const{uri:p,id:i}=P,l=await Promise.resolve(m.provideFileDecoration(n.URI.revive(p),t));if(!l)return;try{k.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,S.checkProposedApiEnabled)(b,"codiconDecoration"),a[i]=[l.propagate,l.tooltip,l.badge,l.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(p){this.h.error(p)}})),a}};f.c=0,f.d=250,f=je([Ve(0,R.IExtHostRpcService),Ve(1,A.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[215],Re([1,0,143,92,2,4,7,8,5,13,28,37]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";var f,E,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(m,b,P,p,i,l,s){this.d=m,this.e=b,this.f=P,this.g=p,f.set(this,void 0),E.set(this,void 0),g.set(this,void 0),this.c=!1,Je(this,g,new O.ResourceMap(c=>i.getComparisonKey(c)),"f"),Je(this,f,l,"f"),Je(this,E,s,"f")}dispose(){this.c||(Fe(this,E,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,f,"f")?.$clear(this.e),Fe(this,g,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(m,b){if(!m){this.clear();return}this.h();let P=[];if(k.URI.isUri(m)){if(!b){this.delete(m);return}Fe(this,g,"f").set(m,b.slice()),P=[m]}else if(Array.isArray(m)){P=[];let i;m=[...m].sort(d.j);for(const l of m){const[s,c]=l;if((!i||s.toString()!==i.toString())&&(i&&Fe(this,g,"f").get(i).length===0&&Fe(this,g,"f").delete(i),i=s,P.push(s),Fe(this,g,"f").set(s,[])),c)Fe(this,g,"f").get(s)?.push(...c);else{const o=Fe(this,g,"f").get(s);o&&(o.length=0)}}}if(Fe(this,E,"f").fire(P),!Fe(this,f,"f"))return;const p=[];for(const i of P){let l=[];const s=Fe(this,g,"f").get(i);if(s)if(s.length>this.f){l=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const I of s)if(I.severity===c[o]&&l.push({...A.Diagnostic.from(I),modelVersionId:this.g(i)})===this.f)break e;l.push({severity:T.MarkerSeverity.Info,message:(0,n.localize)(0,null,s.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=s.map(c=>({...A.Diagnostic.from(c),modelVersionId:this.g(i)}));p.push([i,l])}Fe(this,f,"f").$changeMany(this.e,p)}delete(m){this.h(),Fe(this,E,"f").fire([m]),Fe(this,g,"f").delete(m),Fe(this,f,"f")?.$changeMany(this.e,[[m,void 0]])}clear(){this.h(),Fe(this,E,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,g,"f").clear(),Fe(this,f,"f")?.$clear(this.e)}forEach(m,b){this.h();for(const[P,p]of this)m.call(b,P,p,this)}*[(f=new WeakMap,E=new WeakMap,g=new WeakMap,Symbol.iterator)](){this.h();for(const m of Fe(this,g,"f").keys())yield[m,this.get(m)]}get(m){this.h();const b=Fe(this,g,"f").get(m);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(m){return this.h(),Array.isArray(Fe(this,g,"f").get(m))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(m,b){return m[0].toString()<b[0].toString()?-1:m[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=d;let t=class Si{static _mapper(m){const b=new O.ResourceMap;for(const P of m)b.set(P,P);return{uris:Object.freeze(Array.from(b.values()))}}constructor(m,b,P,p){this.h=b,this.j=P,this.k=p,this.f=new Map,this.g=new w.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.g.event,Si._mapper),this.e=m.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,b){const{f:P,e:p,g:i,h:l,j:s,k:c}=this,o=new class{$changeMany(u,v){p.$changeMany(u,v),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,u,v.length===0?"CLEARING":v)}$clear(u){p.$clear(u),l.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,u)}dispose(){p.dispose()}};let I;if(!b)b="_generated_diagnostic_collection_name_#"+Si.c++,I=b;else if(!P.has(b))I=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do I=b+Si.c++;while(P.has(I))}return new class extends d{constructor(){super(b,I,Si.d,u=>c.getDocument(u)?.version,s.extUri,o,i),P.set(I,this)}dispose(){super.dispose(),P.delete(I)}}}getDiagnostics(m){if(m)return this.l(m);{const b=new Map,P=[];for(const p of this.f.values())p.forEach((i,l)=>{let s=b.get(i.toString());typeof s>"u"&&(s=P.length,b.set(i.toString(),s),P.push([i,[]])),P[s][1]=P[s][1].concat(...l)});return P}}l(m){let b=[];for(const P of this.f.values())P.has(m)&&(b=b.concat(P.get(m)));return b}$acceptMarkersChange(m){if(!this.m){const b="_generated_mirror",P=new d(b,b,Si.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(b,P),this.m=P}for(const[b,P]of m)this.m.set(k.URI.revive(b),P.map(A.Diagnostic.to))}};t.c=0,t.d=1e3,t=je([Ve(1,h.ILogService),Ve(2,S.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Ae[216],Re([1,0,2,4,26]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(A){this.a=A.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(A,w){return w?.allowUIResources&&(0,k.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(w).then(h=>h?h.map(O=>n.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(w=>w?n.URI.revive(w):void 0)}}e.ExtHostDialogs=M}),define(Ae[217],Re([1,0,14,2,7,4,15,21,12]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class h{constructor(S,f,E){this.d=f,this.e=E,this.b=new Map,this.c=S.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,f){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const E=h.a++;this.b.set(E,f),this.c.$registerTextContentProvider(E,S);let g;return typeof f.onDidChange=="function"&&(g=f.onDidChange(d=>{if(d.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(E,d).then(t=>{if(!t&&typeof t!="string")return;const a=this.d.getDocument(d);if(!a)return;const m=(0,w.splitLines)(t);if(!a.equalLines(m))return this.c.$onVirtualDocumentChange(d,t)},n.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,f){const E=this.b.get(S);return E?Promise.resolve(E.provideTextDocumentContent(T.URI.revive(f),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}h.a=0,e.ExtHostDocumentContentProvider=h}),define(Ae[218],Re([1,0,5,6,2,4,101,8,9,23,7]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(E,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=E.getProxy(M.MainContext.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(d=>{for(const t of d)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const t of d)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const g=this.g.getDocument(E);if(g)return g}getDocument(E){const g=this.getDocumentData(E);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return g.document}ensureDocumentData(E){const g=this.g.getDocument(E);if(g)return Promise.resolve(g);let d=this.h.get(E.toString());return d||(d=this.f.$tryOpenDocument(E).then(t=>{this.h.delete(E.toString());const a=k.URI.revive(t);return(0,w.assertIsDefined)(this.g.getDocument(a))},t=>(this.h.delete(E.toString()),Promise.reject(t))),this.h.set(E.toString(),d)),d}createDocumentData(E){return this.f.$tryCreateDocument(E).then(g=>k.URI.revive(g))}$acceptModelLanguageChanged(E,g){const d=k.URI.revive(E),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(g),this.a.fire(t.document)}$acceptModelSaved(E){const g=k.URI.revive(E),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(E,g){const d=k.URI.revive(E),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,g,d){const t=k.URI.revive(E),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(g);let m;g.isUndoing?m=O.TextDocumentChangeReason.Undo:g.isRedoing&&(m=O.TextDocumentChangeReason.Redo),this.c.fire((0,h.deepFreeze)({document:a.document,contentChanges:g.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:m}))}setWordDefinitionFor(E,g){(0,R.setWordDefinitionFor)(E,g)}}e.ExtHostDocuments=S}),define(Ae[58],Re([1,0,49,5,6,2,3,4,101,18,104,8,13,28,15,190,86]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(P,p){this.h=P,this.i=p,this.a=null,this.b=new Map,this.c=new E.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const p=[],i=[],l=[];if(P.removedDocuments)for(const s of P.removedDocuments){const c=M.URI.revive(s),o=this.c.get(c);o?.unref()&&(this.c.delete(c),p.push(o.value))}if(P.addedDocuments)for(const s of P.addedDocuments){const c=M.URI.revive(s.uri);let o=this.c.get(c);if(o&&c.scheme!==g.Schemas.vscodeNotebookCell&&c.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);o||(o=new a(new w.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),c,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(c,o),i.push(o.value)),o.ref()}if(P.removedEditors)for(const s of P.removedEditors){const c=this.b.get(s);this.b.delete(s),c&&l.push(c)}if(P.addedEditors)for(const s of P.addedEditors){const c=M.URI.revive(s.documentUri);n.ok(this.c.has(c),`document '${c}' does not exist`),n.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const o=this.c.get(c).value,I=new O.ExtHostTextEditor(s.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>o.document),s.selections.map(S.Selection.to),s.options,s.visibleRanges.map(r=>S.Range.to(r)),typeof s.editorPosition=="number"?S.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,I)}P.newActiveEditor!==void 0&&(n.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(l),P.removedDocuments&&this.e.fire(p),P.addedDocuments&&this.d.fire(i),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return d.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const p=this.b.get(this.a);return P?p:p?.value}allEditors(){return[...this.b.values()]}};m=je([Ve(0,h.IExtHostRpcService),Ve(1,f.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[59],Re([1,0,8,4,2,5,3,7,18,9,63]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class S{constructor(t,a,m){this.e=m,this.d=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(t,a){this.c=[],this.d="",this.b=t,this.e=a;for(const m of t.tabs)m.isActive&&(this.d=m.id),this.c.push(new S(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(m=>m.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(m=>m.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const m=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,m),t.tabDto.isActive&&(this.d=m.tabId),m}else if(t.kind===1){const m=this.c.splice(t.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(t.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,m),m}const a=this.c.find(m=>m.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(t){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=t.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,a={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(m=>m.apiObject))},get activeTabGroup(){const m=t.d;return(0,h.assertIsDefined)(t.e.find(P=>P.groupId===m)?.apiObject)},close:async(m,b)=>{const P=Array.isArray(m)?m:[m];return P.length?g(P[0])?this.j(P,b):this.i(P,b):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(t){const a=new Set(this.e.map(s=>s.groupId)),m=new Set(t.map(s=>s.groupId)),b=(0,O.diffSets)(a,m),P=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],i=[];this.e=t.map(s=>{const c=new f(s,()=>this.d);return b.added.includes(c.groupId)?p.push(c.apiObject):i.push(c.apiObject),c});const l=(0,h.assertIsDefined)(t.find(s=>s.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:p,closed:P,changed:i}))}$acceptTabGroupUpdate(t){const a=this.e.find(m=>m.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this.e.find(b=>b.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const m=a.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(t){for(const a of this.e)for(const m of a.tabs)if(m.apiObject===t)return m}h(t){return this.e.find(a=>a.apiObject===t)}async i(t,a){const m=[];for(const b of t){const P=this.g(b);if(!P)throw new Error("Tab close: Invalid tab not found!");m.push(P.tabId)}return this.a.$closeTab(m,a)}async j(t,a){const m=[];for(const b of t){const P=this.h(b);if(!P)throw new Error("Group close: Invalid group not found!");m.push(P.groupId)}return this.a.$closeGroup(m,a)}};E=je([Ve(0,w.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function g(d){return d.tabs!==void 0}}),define(Ae[219],Re([1,0,2,4,6,7,8,266,12,25,26]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const d=this.a.indexOf(g);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),d=[];let t,a,m=14,b=14;for(const P of g){let p=t?(0,w.commonPrefixLength)(t,P):0;for(p===0?a=1:a=b;p<P.length;p++)p+1===P.length?(m=b,b=9):b+=1,d.push([a,P.toUpperCase().charCodeAt(p),b]),d.push([a,P.toLowerCase().charCodeAt(p),b]),a=b;t=P,b=m}d.push([9,58,10]),d.push([10,47,12]),this.b=new A.StateMachine(d)}}provideDocumentLinks(g){this.c();const d=[],t=A.LinkComputer.computeLinks({getLineContent(a){return g.lineAt(a-1).text},getLineCount(){return g.lineCount}},this.b);for(const a of t){const m=R.DocumentLink.to(a);m.target&&d.push(m)}return d}}class f{constructor(g,d){this.i=d,this.b=new S,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,d,t,a={}){if(f.j(t),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const m=this.h++;this.b.add(d),this.d.add(d),this.c.set(m,t);let b=2;a.isCaseSensitive&&(b+=1024),a.isReadonly&&(b+=2048),typeof t.copy=="function"&&(b+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,O.checkProposedApiEnabled)(g,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(m,d,b).catch(p=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(p)});const P=t.onDidChangeFile(p=>{const i=[];for(const l of p){const{uri:s,type:c}=l;if(s.scheme!==d)continue;let o;switch(c){case M.FileChangeType.Changed:o=0;break;case M.FileChangeType.Created:o=1;break;case M.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:o})}this.a.$onFileSystemChange(m,i)});return(0,k.toDisposable)(()=>{P.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:d,ctime:t,mtime:a,size:m,permissions:b}=g;return{type:d,ctime:t,mtime:a,size:m,permissions:b}}$stat(g,d){return Promise.resolve(this.l(g).stat(n.URI.revive(d))).then(t=>f.k(t))}$readdir(g,d){return Promise.resolve(this.l(g).readDirectory(n.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this.l(g).readFile(n.URI.revive(d))).then(t=>h.VSBuffer.wrap(t))}$writeFile(g,d,t,a){return Promise.resolve(this.l(g).writeFile(n.URI.revive(d),t.buffer,a))}$delete(g,d,t){return Promise.resolve(this.l(g).delete(n.URI.revive(d),t))}$rename(g,d,t,a){return Promise.resolve(this.l(g).rename(n.URI.revive(d),n.URI.revive(t),a))}$copy(g,d,t,a){const m=this.l(g);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(n.URI.revive(d),n.URI.revive(t),a))}$mkdir(g,d){return Promise.resolve(this.l(g).createDirectory(n.URI.revive(d)))}$watch(g,d,t,a){const m=this.l(g).watch(n.URI.revive(t),a);this.f.set(d,m)}$unwatch(g,d){const t=this.f.get(d);t&&(t.dispose(),this.f.delete(d))}$open(g,d,t){const a=this.l(g);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(d),t))}$close(g,d){const t=this.l(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(g,d,t,a){const m=this.l(g);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const b=h.VSBuffer.alloc(a);return Promise.resolve(m.read(d,t,b.buffer,0,a)).then(P=>b.slice(0,P))}$write(g,d,t,a){const m=this.l(g);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(d,t,a.buffer,0,a.byteLength))}l(g){const d=this.c.get(g);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=f}),define(Ae[60],Re([1,0,4,43,7,25,3,18,37,6]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Jt{constructor(f,E){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{const t=g.b.get(d.scheme);if(!t)return await g.a.$stat(d);await g.a.$ensureActivation(d.scheme);const a=await t.stat(d);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){Jt.c(t)}},async readDirectory(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readDirectory(d)).slice()):await g.a.$readdir(d)}catch(t){return Jt.c(t)}},async createDirectory(d){try{return await g.a.$mkdir(d)}catch(t){return Jt.c(t)}},async readFile(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readFile(d)).slice()):(await g.a.$readFile(d)).buffer}catch(t){return Jt.c(t)}},async writeFile(d,t){try{return await g.a.$writeFile(d,M.VSBuffer.wrap(t))}catch(a){return Jt.c(a)}},async delete(d,t){try{const a=g.b.get(d.scheme);return a?(await g.a.$ensureActivation(d.scheme),await a.delete(d,{recursive:!1,...t})):await g.a.$delete(d,{recursive:!1,useTrash:!1,...t})}catch(a){return Jt.c(a)}},async rename(d,t,a){try{return await g.a.$rename(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},async copy(d,t,a){try{return await g.a.$copy(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},isWritableFileSystem(d){const t=E.getCapabilities(d);if(typeof t=="number")return!(t&2048)}})}static c(f){if(f instanceof k.FileSystemError)throw f;if(!(f instanceof Error))throw new k.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(f.message);default:throw new k.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,E){return this.b.set(f,E),(0,h.toDisposable)(()=>this.b.delete(f))}};O=je([Ve(0,A.IExtHostRpcService),Ve(1,w.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[220],Re([1,0,5,36,2,4,8,7]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(S,f,E,g,d,t,a,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const b=this.h(S,E,d);this.g=0,t&&(this.g+=1),a&&(this.g+=2),m&&(this.g+=4);const P=(0,T.parse)(d),p=typeof d=="string",i=g(l=>{if(!t)for(const s of l.created){const c=k.URI.revive(s);P(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.a.fire(c)}if(!a)for(const s of l.changed){const c=k.URI.revive(s);P(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.b.fire(c)}if(!m)for(const s of l.deleted){const c=k.URI.revive(s);P(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,i)}h(S,f,E){const g=A.Disposable.from();if(typeof E=="string")return g;const d=S.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(E.pattern.includes(T.GLOBSTAR)||E.pattern.includes(T.GLOB_SPLIT))&&(t=!0);const a=Math.random();return d.$watch(f.identifier.value,a,E.baseUri,{recursive:t,excludes:[]}),A.Disposable.from({dispose:()=>d.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class h{constructor(S,f,E){this.j=S,this.k=f,this.l=E,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,f,E,g,d,t){return new w(this.j,S,f,this.a.event,R.GlobPattern.from(E),g,d,t)}$onFileEvent(S){this.a.fire(S)}$onDidRunFileOperation(S,f){switch(S){case 2:this.b.fire(Object.freeze({files:f.map(E=>({oldUri:k.URI.revive(E.source),newUri:k.URI.revive(E.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(E=>k.URI.revive(E.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(E=>k.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,f){return(E,g,d)=>{const t=function(m){E.call(g,m)};return t.extension=S,f.event(t,void 0,d)}}async $onWillRunFileOperation(S,f,E,g){switch(S){case 2:return await this.n(this.g,{files:f.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},E,g);case 1:return await this.n(this.i,{files:f.map(d=>k.URI.revive(d.target))},E,g);case 0:case 3:return await this.n(this.h,{files:f.map(d=>k.URI.revive(d.target))},E,g)}}async n(S,f,E,g){const d=new Set,t=[];if(await S.fireAsync(f,g,async(m,b)=>{const P=Date.now(),p=await Promise.resolve(m);p instanceof A.WorkspaceEdit&&(t.push([b.extension,p]),d.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-P>E&&this.k.warn("SLOW file-participant",b.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,m]of t){const{edits:b}=R.WorkspaceEdit.from(m,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(b)}return{edit:a,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=h}),define(Ae[221],Re([1,0,2,38]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(R,A,w,h,O){this.a=A,this.b=w,this.c=h;const S=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new T.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new T.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new T.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new T.ApiCommandResult("Notebook and input URI",f=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const E=this.a.getEditorById(f.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,A,w,h){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:w,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(h))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=k}),define(Ae[222],Re([1,0,6,2,4,8]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class R{constructor(h,O){this.extension=h,this.provider=O,this.handle=R.a++}}R.a=0;class A{constructor(h,O,S){this.e=O,this.f=S,this.b=new Map,this.c=new Map,this.d=h.getProxy(k.MainContext.MainThreadInteractiveEditor)}registerProvider(h,O){const S=new R(h,O);return this.b.set(S.handle,S),this.d.$registerInteractiveEditorProvider(S.handle,h.identifier.value),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(S.handle),this.b.delete(S.handle)})}async $prepareInteractiveSession(h,O,S,f){const E=this.b.get(h);if(!E){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const g=this.e.getDocument(T.URI.revive(O)),d=await E.provider.prepareInteractiveEditorSession({document:g,selection:M.Selection.to(S)},f);if(!d)return;const t=A.a++;return this.c.set(t,d),{id:t,placeholder:d.placeholder}}async $provideResponse(h,O,S,f){const E=this.b.get(h);if(!E)return;const g=this.c.get(O.id);if(!g)return;const d=await E.provider.provideInteractiveEditorResponse({session:g,prompt:S.prompt,selection:M.Selection.to(S.selection),wholeRange:M.Range.to(S.wholeRange)},f);if(!!d)return{edits:d.edits.map(M.TextEdit.from),placeholder:d.placeholder}}$releaseSession(h,O){const S=this.c.get(O),f=this.b.get(h);S&&f&&f.provider.releaseInteractiveEditorSession?.(S),this.c.delete(O)}}A.a=0,e.ExtHostInteractiveEditor=A}),define(Ae[223],Re([1,0,6,9,4]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class M{constructor(w,h){this.extension=w,this.provider=h,this.handle=M.a++}}M.a=0;class R{constructor(w,h){this.b=new Map,this.c=new Map,this.d=w.getProxy(k.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(w,h,O){const S=new M(w,O);return this.b.set(S.handle,S),this.d.$registerInteractiveSessionProvider(S.handle,h),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(S.handle),this.b.delete(S.handle)})}addInteractiveSessionRequest(w){this.d.$addInteractiveSessionRequest(w)}async $prepareInteractiveSession(w,h,O){const S=this.b.get(w);if(!S)return;const f=await S.provider.prepareSession(h,O);if(!f)return;const E=R.a++;return this.c.set(E,f),{id:E}}async $resolveInteractiveRequest(w,h,O,S){const f=this.b.get(w);if(!f)return;const E=this.c.get(h);if(!E||!f.provider.resolveRequest)return;const g=await f.provider.resolveRequest(E,O,S);if(g)return{message:g.message}}async $provideInitialSuggestions(w,h){const O=this.b.get(w);if(!!O&&!!O.provider.provideInitialSuggestions)return(0,T.withNullAsUndefined)(await O.provider.provideInitialSuggestions(h))}async $provideInteractiveReply(w,h,O,S){const f=this.b.get(w);if(!f)return;const E=this.c.get(h);if(!E)return;const g={session:E,message:O.message};if(f.provider.provideResponse){const d=await f.provider.provideResponse(g,S);if(E.saveState){const t=E.saveState();this.d.$acceptInteractiveSessionState(h,t)}return d?(this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:d.content}),{followups:d.followups}):void 0}else if(f.provider.provideResponseWithProgress){const d={report:a=>this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:a.content})},t=await f.provider.provideResponseWithProgress(g,d,S);if(E.saveState){const a=E.saveState();this.d.$acceptInteractiveSessionState(h,a)}return t?{followups:t.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(w){this.c.delete(w)}}R.a=0,e.ExtHostInteractiveSession=R}),define(Ae[224],Re([1,0,6,4]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(R){this.b=0,this.a=R.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,R),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=k}),define(Ae[225],Re([1,0,2,23,8,7,76,4,12,44,16,9,267,21,6,89,84,54,78,14,17,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(C,N){this.d=C,this.e=N}async provideDocumentSymbols(C,N){const H=this.d.getDocument(C),x=await this.e.provideDocumentSymbols(H,N);if(!(0,O.isFalsyOrEmpty)(x))return x[0]instanceof M.DocumentSymbol?x.map(k.DocumentSymbol.from):i.f(x)}static f(C){C=C.slice(0).sort((x,te)=>{let pe=x.location.range.start.compareTo(te.location.range.start);return pe===0&&(pe=te.location.range.end.compareTo(x.location.range.end)),pe});const N=[],H=[];for(const x of C){const te={name:x.name||"!!MISSING: name!!",kind:k.SymbolKind.from(x.kind),tags:x.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:k.Range.from(x.location.range),selectionRange:k.Range.from(x.location.range),children:[]};for(;;){if(H.length===0){H.push(te),N.push(te);break}const pe=H[H.length-1];if(h.Range.containsRange(pe.range,te.range)&&!h.Range.equalsRange(pe.range,te.range)){pe.children?.push(te),H.push(te);break}H.pop()}}return N}}class l{constructor(C,N,H){this.g=C,this.h=N,this.j=H,this.e=new a.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(C,N){const H=this.g.getDocument(C),x=await this.j.provideCodeLenses(H,N);if(!x||N.isCancellationRequested)return;const te=this.e.add(x),pe=new g.DisposableStore;this.f.set(te,pe);const ke={cacheId:te,lenses:[]};for(let ue=0;ue<x.length;ue++)ke.lenses.push({cacheId:[te,ue],range:k.Range.from(x[ue].range),command:this.h.toInternal(x[ue].command,pe)});return ke}async resolveCodeLens(C,N){const H=C.cacheId&&this.e.get(...C.cacheId);if(!H)return;let x;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?x=H:x=await this.j.resolveCodeLens(H,N),x||(x=H),N.isCancellationRequested)return;const te=C.cacheId&&this.f.get(C.cacheId[0]);if(!!te)return C.command=this.h.toInternal(x.command??l.d,te),C}releaseCodeLenses(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}}l.d={command:"missing",title:"!!MISSING: command!!"};function s(Z){return Array.isArray(Z)?Z.map(k.DefinitionLink.from):Z?[k.DefinitionLink.from(Z)]:[]}class c{constructor(C,N){this.d=C,this.e=N}async provideDefinition(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideDefinition(x,te,H);return s(pe)}}class o{constructor(C,N){this.d=C,this.e=N}async provideDeclaration(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideDeclaration(x,te,H);return s(pe)}}class I{constructor(C,N){this.d=C,this.e=N}async provideImplementation(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideImplementation(x,te,H);return s(pe)}}class r{constructor(C,N){this.d=C,this.e=N}async provideTypeDefinition(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideTypeDefinition(x,te,H);return s(pe)}}class u{constructor(C,N){this.d=C,this.e=N}async provideHover(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideHover(x,te,H);if(!(!pe||(0,O.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=x.getWordRangeAtPosition(te)),pe.range||(pe.range=new M.Range(te,te)),k.Hover.from(pe)}}class v{constructor(C,N){this.d=C,this.e=N}async provideEvaluatableExpression(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideEvaluatableExpression(x,te,H);if(pe)return k.EvaluatableExpression.from(pe)}}class D{constructor(C,N){this.d=C,this.e=N}async provideInlineValues(C,N,H,x){const te=this.d.getDocument(C),pe=await this.e.provideInlineValues(te,k.Range.to(N),k.InlineValueContext.to(H),x);if(Array.isArray(pe))return pe.map(ke=>k.InlineValue.from(ke))}}class y{constructor(C,N){this.d=C,this.e=N}async provideDocumentHighlights(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideDocumentHighlights(x,te,H);if(Array.isArray(pe))return pe.map(k.DocumentHighlight.from)}}class W{constructor(C,N){this.d=C,this.e=N}async provideLinkedEditingRanges(C,N,H){const x=this.d.getDocument(C),te=k.Position.to(N),pe=await this.e.provideLinkedEditingRanges(x,te,H);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,O.coalesce)(pe.ranges.map(k.Range.from)),wordPattern:pe.wordPattern}}}class X{constructor(C,N){this.d=C,this.e=N}async provideReferences(C,N,H,x){const te=this.d.getDocument(C),pe=k.Position.to(N),ke=await this.e.provideReferences(te,pe,H,x);if(Array.isArray(ke))return ke.map(k.location.from)}}class _{constructor(C,N,H,x,te,pe,ke){this.g=C,this.h=N,this.j=H,this.k=x,this.l=te,this.m=pe,this.n=ke,this.e=new a.Cache("CodeAction"),this.f=new Map}async provideCodeActions(C,N,H,x){const te=this.g.getDocument(C),pe=f.Selection.isISelection(N)?k.Selection.to(N):k.Range.to(N),ke=[];for(const et of this.j.getDiagnostics(C))if(pe.intersection(et.range)&&ke.push(et)>_.d)break;const ue={diagnostics:ke,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:k.CodeActionTriggerKind.to(H.trigger)},De=await this.k.provideCodeActions(te,pe,ue,x);if(!(0,O.isNonEmptyArray)(De)||x.isCancellationRequested)return;const we=this.e.add(De),$e=new g.DisposableStore;this.f.set(we,$e);const He=[];for(let et=0;et<De.length;et++){const Xe=De[et];!Xe||(_.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,$e)})):(ue.only&&(Xe.kind?ue.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[we,et],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,$e),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(k.Diagnostic.from),edit:Xe.edit&&k.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:we,actions:He}}async resolveCodeAction(C,N){const[H,x]=C,te=this.e.get(H,x);if(!te||_.o(te)||!this.k.resolveCodeAction)return;const pe=await this.k.resolveCodeAction(te,N)??te;return pe?.edit?k.WorkspaceEdit.from(pe.edit,void 0):void 0}releaseCodeActions(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}static o(C){return typeof C.command=="string"&&typeof C.title=="string"}}_.d=1e3;class J{constructor(C,N,H,x){this.d=C,this.e=N,this.f=H,this.g=x}async prepareDocumentPaste(C,N,H,x){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(C),pe=N.map(ue=>k.Range.to(ue)),ke=k.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(te,pe,ke,x),k.DataTransfer.toDataTransferDTO(ke)}async providePasteEdits(C,N,H,x,te){const pe=this.e.getDocument(N),ke=H.map(we=>k.Range.to(we)),ue=k.DataTransfer.toDataTransfer(x,async we=>(await this.d.$resolvePasteFileData(this.g,C,we)).buffer),De=await this.f.provideDocumentPasteEdits(pe,ke,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class j{constructor(C,N){this.d=C,this.e=N}async provideDocumentFormattingEdits(C,N,H){const x=this.d.getDocument(C),te=await this.e.provideDocumentFormattingEdits(x,N,H);if(Array.isArray(te))return te.map(k.TextEdit.from)}}class U{constructor(C,N){this.d=C,this.e=N}async provideDocumentRangeFormattingEdits(C,N,H,x){const te=this.d.getDocument(C),pe=k.Range.to(N),ke=await this.e.provideDocumentRangeFormattingEdits(te,pe,H,x);if(Array.isArray(ke))return ke.map(k.TextEdit.from)}}class ${constructor(C,N){this.d=C,this.e=N,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,N,H,x,te){const pe=this.d.getDocument(C),ke=k.Position.to(N),ue=await this.e.provideOnTypeFormattingEdits(pe,ke,H,x,te);if(Array.isArray(ue))return ue.map(k.TextEdit.from)}}class B{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,N){const H=await this.e.provideWorkspaceSymbols(C,N);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const x=this.d.add(H),te={cacheId:x,symbols:[]};for(let pe=0;pe<H.length;pe++){const ke=H[pe];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}te.symbols.push({...k.WorkspaceSymbol.from(ke),cacheId:[x,pe]})}return te}async resolveWorkspaceSymbol(C,N){if(typeof this.e.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const H=this.d.get(...C.cacheId);if(H){const x=await this.e.resolveWorkspaceSymbol(H,N);return x&&(0,T.mixin)(C,k.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(C){this.d.delete(C)}}class q{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,N,H){this.d=C,this.e=N,this.f=H}async provideRenameEdits(C,N,H,x){const te=this.d.getDocument(C),pe=k.Position.to(N);try{const ke=await this.e.provideRenameEdits(te,pe,H,x);return ke?k.WorkspaceEdit.from(ke):void 0}catch(ke){const ue=q.g(ke);return ue?{rejectReason:ue,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(C,N,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(C),te=k.Position.to(N);try{const pe=await this.e.prepareRename(x,te,H);let ke,ue;if(M.Range.isRange(pe)?(ke=pe,ue=x.getText(pe)):(0,S.isObject)(pe)&&(ke=pe.range,ue=pe.placeholder),!ke||!ue)return;if(ke.start.line>te.line||ke.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ke),text:ue}}catch(pe){const ke=q.g(pe);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(pe)}}static g(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class he{constructor(C,N){this.resultId=C,this.tokens=N}}class Ee{constructor(C,N){this.f=C,this.g=N,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(C,N,H){const x=this.f.getDocument(C),te=N!==0?this.d.get(N):null;let pe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,te.resultId,H):await this.g.provideDocumentSemanticTokens(x,H);return te&&this.d.delete(N),pe?(pe=Ee.h(pe),this.o(Ee.n(te,pe),pe)):null}async releaseDocumentSemanticColoring(C){this.d.delete(C)}static h(C){return Ee.j(C)?Ee.k(C)?C:new M.SemanticTokens(new Uint32Array(C.data),C.resultId):Ee.l(C)?Ee.m(C)?C:new M.SemanticTokensEdits(C.edits.map(N=>new M.SemanticTokensEdit(N.start,N.deleteCount,N.data?new Uint32Array(N.data):N.data)),C.resultId):C}static j(C){return C&&!!C.data}static k(C){return C.data instanceof Uint32Array}static l(C){return C&&Array.isArray(C.edits)}static m(C){for(const N of C.edits)if(!(N.data instanceof Uint32Array))return!1;return!0}static n(C,N){if(!Ee.j(N)||!C||!C.tokens)return N;const H=C.tokens,x=H.length,te=N.data,pe=te.length;let ke=0;const ue=Math.min(x,pe);for(;ke<ue&&H[ke]===te[ke];)ke++;if(ke===x&&ke===pe)return new M.SemanticTokensEdits([],N.resultId);let De=0;const we=ue-ke;for(;De<we&&H[x-De-1]===te[pe-De-1];)De++;return new M.SemanticTokensEdits([{start:ke,deleteCount:x-ke-De,data:te.subarray(ke,pe-De)}],N.resultId)}o(C,N){if(Ee.j(C)){const H=this.e++;return this.d.set(H,new he(C.resultId,C.data)),(0,d.encodeSemanticTokensDto)({id:H,type:"full",data:C.data})}if(Ee.l(C)){const H=this.e++;return Ee.j(N)?this.d.set(H,new he(N.resultId,N.data)):this.d.set(H,new he(C.resultId)),(0,d.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(C.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ie{constructor(C,N){this.d=C,this.e=N}async provideDocumentRangeSemanticTokens(C,N,H){const x=this.d.getDocument(C),te=await this.e.provideDocumentRangeSemanticTokens(x,k.Range.to(N),H);return te?this.f(te):null}f(C){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class ce{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,N,H,x,te){this.f=C,this.g=N,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(C,N,H,x){const te=this.f.getDocument(C),pe=k.Position.to(N),ke=te.getWordRangeAtPosition(pe)||new M.Range(pe,pe),ue=ke.with({end:pe}),De=new m.StopWatch(!0),we=await this.h.provideCompletionItems(te,pe,x,k.CompletionContext.to(H));if(!we||x.isCancellationRequested)return;const $e=Array.isArray(we)?new M.CompletionList(we):we,He=ce.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),et=new g.DisposableStore;this.e.set(He,et);const Xe=[],tt={x:He,b:Xe,a:{replace:k.Range.from(ke),insert:k.Range.from(ue)},c:$e.isIncomplete||void 0,d:De.elapsed()};for(let rt=0;rt<$e.items.length;rt++){const Me=$e.items[rt],it=this.l(Me,[He,rt],ue,ke);Xe.push(it)}return tt}async resolveCompletionItem(C,N){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...C);if(!H)return;const x=await this.h.resolveCompletionItem(H,N);if(!!x)return this.l(x,C)}releaseCompletionItems(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,N,H,x){const te=this.e.get(N[0]);if(!te)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(C.command,te),ke={x:N,a:C.label,b:C.kind!==void 0?k.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(k.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:k.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(k.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};C.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke.h=C.textEdit.newText):typeof C.insertText=="string"?ke.h=C.insertText:C.insertText instanceof M.SnippetString&&(ke.h=C.insertText.value,ke.i|=4);let ue;return C.textEdit?ue=C.textEdit.range:C.range&&(ue=C.range),M.Range.isRange(ue)?ke.j=k.Range.from(ue):ue&&(!H?.isEqual(ue.inserting)||!x?.isEqual(ue.replacing))&&(ke.j={insert:k.Range.from(ue.inserting),replace:k.Range.from(ue.replacing)}),ke}}class de{async provideInlineCompletions(C,N,H,x){}disposeCompletions(C){}handleDidShowCompletionItem(C,N){}handlePartialAccept(C,N,H){}}class Te extends de{constructor(C,N,H,x){super(),this.f=C,this.g=N,this.h=H,this.j=x,this.d=new le,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,N,H,x){const te=this.g.getDocument(C),pe=k.Position.to(N),ke=await this.h.provideInlineCompletionItems(te,pe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:k.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},x);if(!ke||x.isCancellationRequested)return;const ue=Array.isArray(ke)?ke:ke.items,De=this.e?Array.isArray(ke)?[]:ke.commands||[]:[];let we;return{pid:this.d.createReferenceId({dispose(){we?.dispose()},items:ue}),items:ue.map((He,et)=>{let Xe;He.command&&(we||(we=new g.DisposableStore),Xe=this.j.toInternal(He.command,we));const tt=He.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:He.filterText,range:He.range?k.Range.from(He.range):void 0,command:Xe,idx:et,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:De.map(He=>(we||(we=new g.DisposableStore),this.j.toInternal(He,we)))}}disposeCompletions(C){this.d.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,N){const H=this.d.get(C)?.items[N];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}handlePartialAccept(C,N,H){const x=this.d.get(C)?.items[N];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(C){const N=this.e++;return this.d.set(N,C),N}disposeReferenceId(C){const N=this.d.get(C);return this.d.delete(C),N}get(C){return this.d.get(C)}}class re{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("SignatureHelp")}async provideSignatureHelp(C,N,H,x){const te=this.e.getDocument(C),pe=k.Position.to(N),ke=this.g(H),ue=await this.f.provideSignatureHelp(te,pe,x,ke);if(ue){const De=this.d.add([ue]);return{...k.SignatureHelp.from(ue),id:De}}}g(C){let N;if(C.activeSignatureHelp){const H=k.SignatureHelp.to(C.activeSignatureHelp),x=this.d.get(C.activeSignatureHelp.id,0);x?(N=x,N.activeSignature=H.activeSignature,N.activeParameter=H.activeParameter):N=H}return{...C,activeSignatureHelp:N}}releaseSignatureHelp(C){this.d.delete(C)}}class V{constructor(C,N,H,x,te){this.f=C,this.g=N,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("InlayHints"),this.e=new Map}async provideInlayHints(C,N,H){const x=this.f.getDocument(C),te=k.Range.to(N),pe=await this.h.provideInlayHints(x,te,H);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${N}`);return}if(H.isCancellationRequested)return;const ke=this.d.add(pe);this.e.set(ke,new g.DisposableStore);const ue={hints:[],cacheId:ke};for(let De=0;De<pe.length;De++)this.l(pe[De],te)&&ue.hints.push(this.m(pe[De],[ke,De]));return this.j.trace(`[InlayHints] ${ue.hints.length} inlay hints from '${this.k.identifier.value}' for ${N}`),ue}async resolveInlayHint(C,N){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...C);if(!H)return;const x=await this.h.resolveInlayHint(H,N);if(!!x&&!!this.l(x))return this.m(x,C)}releaseHints(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,N){return C.label.length===0||Array.isArray(C.label)&&C.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(N&&!N.contains(C.position))}m(C,N){const H=this.e.get(N[0]);if(!H)throw Error("DisposableStore is missing...");const x={label:"",cacheId:N,tooltip:k.MarkdownString.fromStrict(C.tooltip),position:k.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(k.TextEdit.from),kind:C.kind&&k.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?x.label=C.label:x.label=C.label.map(te=>{const pe={label:te.value};return pe.tooltip=k.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(pe.location=k.location.from(te.location)),te.command&&(pe.command=this.g.toInternal(te.command,H)),pe}),x}}class L{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("DocumentLink")}async provideLinks(C,N){const H=this.e.getDocument(C),x=await this.f.provideDocumentLinks(H,N);if(!(!Array.isArray(x)||x.length===0)&&!N.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(L.g).map(k.DocumentLink.from)};{const te=this.d.add(x),pe={links:[],cacheId:te};for(let ke=0;ke<x.length;ke++){if(!L.g(x[ke]))continue;const ue=k.DocumentLink.from(x[ke]);ue.cacheId=[te,ke],pe.links.push(ue)}return pe}}}static g(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,N){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...C);if(!H)return;const x=await this.f.resolveDocumentLink(H,N);if(!(!x||!L.g(x)))return k.DocumentLink.from(x)}releaseLinks(C){this.d.delete(C)}}class K{constructor(C,N){this.d=C,this.e=N}async provideColors(C,N){const H=this.d.getDocument(C),x=await this.e.provideDocumentColors(H,N);return Array.isArray(x)?x.map(pe=>({color:k.Color.from(pe.color),range:k.Range.from(pe.range)})):[]}async provideColorPresentations(C,N,H){const x=this.d.getDocument(C),te=k.Range.to(N.range),pe=k.Color.to(N.color),ke=await this.e.provideColorPresentations(pe,{document:x,range:te},H);if(!!Array.isArray(ke))return ke.map(k.ColorPresentation.from)}}class me{constructor(C,N){this.d=C,this.e=N}async provideFoldingRanges(C,N,H){const x=this.d.getDocument(C),te=await this.e.provideFoldingRanges(x,N,H);if(!!Array.isArray(te))return te.map(k.FoldingRange.from)}}class Ie{constructor(C,N,H){this.d=C,this.e=N,this.f=H}async provideSelectionRanges(C,N,H){const x=this.d.getDocument(C),te=N.map(k.Position.to),pe=await this.e.provideSelectionRanges(x,te,H);if(!(0,O.isNonEmptyArray)(pe))return[];if(pe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let ue=0;ue<te.length;ue++){const De=[];ke.push(De);let we=te[ue],$e=pe[ue];for(;;){if(!$e.range.contains(we))throw new Error("INVALID selection range, must contain the previous range");if(De.push(k.SelectionRange.from($e)),!$e.parent)break;we=$e.range,$e=$e.parent}}return ke}}class Se{constructor(C,N){this.f=C,this.g=N,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,N,H){const x=this.f.getDocument(C),te=k.Position.to(N),pe=await this.g.prepareCallHierarchy(x,te,H);if(!pe)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(pe)?pe.map(ue=>this.h(ke,ue)):[this.h(ke,pe)]}async provideCallsTo(C,N,H){const x=this.j(C,N);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(x,H);if(!!te)return te.map(pe=>({from:this.h(C,pe.from),fromRanges:pe.fromRanges.map(ke=>k.Range.from(ke))}))}async provideCallsFrom(C,N,H){const x=this.j(C,N);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(x,H);if(!!te)return te.map(pe=>({to:this.h(C,pe.to),fromRanges:pe.fromRanges.map(ke=>k.Range.from(ke))}))}releaseSession(C){this.e.delete(C)}h(C,N){const H=this.e.get(C),x=k.CallHierarchyItem.from(N,C,H.size.toString(36));return H.set(x._itemId,N),x}j(C,N){return this.e.get(C)?.get(N)}}class ve{constructor(C,N){this.f=C,this.g=N,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,N,H){const x=this.f.getDocument(C),te=k.Position.to(N),pe=await this.g.prepareTypeHierarchy(x,te,H);if(!pe)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(pe)?pe.map(ue=>this.h(ke,ue)):[this.h(ke,pe)]}async provideSupertypes(C,N,H){const x=this.j(C,N);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(x,H);if(!!te)return te.map(pe=>this.h(C,pe))}async provideSubtypes(C,N,H){const x=this.j(C,N);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(x,H);if(!!te)return te.map(pe=>this.h(C,pe))}releaseSession(C){this.e.delete(C)}h(C,N){const H=this.e.get(C),x=k.TypeHierarchyItem.from(N,C,H.size.toString(36));return H.set(x._itemId,N),x}j(C,N){return this.e.get(C)?.get(N)}}class Ce{constructor(C,N,H,x){this.d=C,this.e=N,this.f=H,this.g=x}async provideDocumentOnDropEdits(C,N,H,x,te){const pe=this.e.getDocument(N),ke=k.Position.to(H),ue=k.DataTransfer.toDataTransfer(x,async we=>(await this.d.$resolveDocumentOnDropFileData(this.g,C,we)).buffer),De=await this.f.provideDocumentDropEdits(pe,ke,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class se{constructor(C,N){this.adapter=C,this.extension=N}}class ae{constructor(C,N,H,x,te,pe,ke,ue){this.g=N,this.h=H,this.j=x,this.k=te,this.l=pe,this.m=ke,this.n=ue,this.f=new Map,this.e=C.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(C){return k.DocumentSelector.from(C,this.g)}p(C){return new M.Disposable(()=>{this.f.delete(C),this.e.$unregister(C)})}q(){return ae.d++}async s(C,N,H,x,te,pe=!1){const ke=this.f.get(C);if(!ke||!(ke.adapter instanceof N))return x;const ue=Date.now();pe||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const De=H(ke.adapter,ke.extension);return Promise.resolve(De).catch(we=>{(0,b.isCancellationError)(we)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(we),this.n.onExtensionError(ke.extension.identifier,we))}).finally(()=>{pe||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-ue}ms`)}),E.CancellationToken.isCancellationToken(te)?(0,P.raceCancellationError)(De,te):De}t(C,N){const H=this.q();return this.f.set(H,new se(C,N)),H}static u(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,N,H,x){const te=this.t(new i(this.h,H),C),pe=x&&x.label||ae.u(C);return this.e.$registerDocumentSymbolProvider(te,this.o(N),pe),this.p(te)}$provideDocumentSymbols(C,N,H){return this.s(C,i,x=>x.provideDocumentSymbols(n.URI.revive(N),H),void 0,H)}registerCodeLensProvider(C,N,H){const x=this.q(),te=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new se(new l(this.h,this.j.converter,H),C)),this.e.$registerCodeLensSupport(x,this.o(N),te);let pe=this.p(x);if(te!==void 0){const ke=H.onDidChangeCodeLenses(ue=>this.e.$emitCodeLensEvent(te));pe=M.Disposable.from(pe,ke)}return pe}$provideCodeLenses(C,N,H){return this.s(C,l,x=>x.provideCodeLenses(n.URI.revive(N),H),void 0,H)}$resolveCodeLens(C,N,H){return this.s(C,l,x=>x.resolveCodeLens(N,H),void 0,void 0)}$releaseCodeLenses(C,N){this.s(C,l,H=>Promise.resolve(H.releaseCodeLenses(N)),void 0,void 0)}registerDefinitionProvider(C,N,H){const x=this.t(new c(this.h,H),C);return this.e.$registerDefinitionSupport(x,this.o(N)),this.p(x)}$provideDefinition(C,N,H,x){return this.s(C,c,te=>te.provideDefinition(n.URI.revive(N),H,x),[],x)}registerDeclarationProvider(C,N,H){const x=this.t(new o(this.h,H),C);return this.e.$registerDeclarationSupport(x,this.o(N)),this.p(x)}$provideDeclaration(C,N,H,x){return this.s(C,o,te=>te.provideDeclaration(n.URI.revive(N),H,x),[],x)}registerImplementationProvider(C,N,H){const x=this.t(new I(this.h,H),C);return this.e.$registerImplementationSupport(x,this.o(N)),this.p(x)}$provideImplementation(C,N,H,x){return this.s(C,I,te=>te.provideImplementation(n.URI.revive(N),H,x),[],x)}registerTypeDefinitionProvider(C,N,H){const x=this.t(new r(this.h,H),C);return this.e.$registerTypeDefinitionSupport(x,this.o(N)),this.p(x)}$provideTypeDefinition(C,N,H,x){return this.s(C,r,te=>te.provideTypeDefinition(n.URI.revive(N),H,x),[],x)}registerHoverProvider(C,N,H,x){const te=this.t(new u(this.h,H),C);return this.e.$registerHoverProvider(te,this.o(N)),this.p(te)}$provideHover(C,N,H,x){return this.s(C,u,te=>te.provideHover(n.URI.revive(N),H,x),void 0,x)}registerEvaluatableExpressionProvider(C,N,H,x){const te=this.t(new v(this.h,H),C);return this.e.$registerEvaluatableExpressionProvider(te,this.o(N)),this.p(te)}$provideEvaluatableExpression(C,N,H,x){return this.s(C,v,te=>te.provideEvaluatableExpression(n.URI.revive(N),H,x),void 0,x)}registerInlineValuesProvider(C,N,H,x){const te=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new D(this.h,H),C);this.e.$registerInlineValuesProvider(pe,this.o(N),te);let ke=this.p(pe);if(te!==void 0){const ue=H.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(te));ke=M.Disposable.from(ke,ue)}return ke}$provideInlineValues(C,N,H,x,te){return this.s(C,D,pe=>pe.provideInlineValues(n.URI.revive(N),H,x,te),void 0,te)}registerDocumentHighlightProvider(C,N,H){const x=this.t(new y(this.h,H),C);return this.e.$registerDocumentHighlightProvider(x,this.o(N)),this.p(x)}$provideDocumentHighlights(C,N,H,x){return this.s(C,y,te=>te.provideDocumentHighlights(n.URI.revive(N),H,x),void 0,x)}registerLinkedEditingRangeProvider(C,N,H){const x=this.t(new W(this.h,H),C);return this.e.$registerLinkedEditingRangeProvider(x,this.o(N)),this.p(x)}$provideLinkedEditingRanges(C,N,H,x){return this.s(C,W,async te=>{const pe=await te.provideLinkedEditingRanges(n.URI.revive(N),H,x);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?ae.w(pe.wordPattern):void 0}},void 0,x)}registerReferenceProvider(C,N,H){const x=this.t(new X(this.h,H),C);return this.e.$registerReferenceSupport(x,this.o(N)),this.p(x)}$provideReferences(C,N,H,x,te){return this.s(C,X,pe=>pe.provideReferences(n.URI.revive(N),H,x,te),void 0,te)}registerCodeActionProvider(C,N,H,x){const te=new g.DisposableStore,pe=this.t(new _(this.h,this.j.converter,this.k,H,this.l,C,this.m),C);return this.e.$registerQuickFixSupport(pe,this.o(N),{providedKinds:x?.providedCodeActionKinds?.map(ke=>ke.value),documentation:x?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,te)}))},ae.u(C),Boolean(H.resolveCodeAction)),te.add(this.p(pe)),te}$provideCodeActions(C,N,H,x,te){return this.s(C,_,pe=>pe.provideCodeActions(n.URI.revive(N),H,x,te),void 0,te)}$resolveCodeAction(C,N,H){return this.s(C,_,x=>x.resolveCodeAction(N,H),void 0,void 0)}$releaseCodeActions(C,N){this.s(C,_,H=>Promise.resolve(H.releaseCodeActions(N)),void 0,void 0)}registerDocumentFormattingEditProvider(C,N,H){const x=this.t(new j(this.h,H),C);return this.e.$registerDocumentFormattingSupport(x,this.o(N),C.identifier,C.displayName||C.name),this.p(x)}$provideDocumentFormattingEdits(C,N,H,x){return this.s(C,j,te=>te.provideDocumentFormattingEdits(n.URI.revive(N),H,x),void 0,x)}registerDocumentRangeFormattingEditProvider(C,N,H){const x=this.t(new U(this.h,H),C);return this.e.$registerRangeFormattingSupport(x,this.o(N),C.identifier,C.displayName||C.name),this.p(x)}$provideDocumentRangeFormattingEdits(C,N,H,x,te){return this.s(C,U,pe=>pe.provideDocumentRangeFormattingEdits(n.URI.revive(N),H,x,te),void 0,te)}registerOnTypeFormattingEditProvider(C,N,H,x){const te=this.t(new $(this.h,H),C);return this.e.$registerOnTypeFormattingSupport(te,this.o(N),x,C.identifier),this.p(te)}$provideOnTypeFormattingEdits(C,N,H,x,te,pe){return this.s(C,$,ke=>ke.provideOnTypeFormattingEdits(n.URI.revive(N),H,x,te,pe),void 0,pe)}registerWorkspaceSymbolProvider(C,N){const H=this.t(new B(N,this.l),C);return this.e.$registerNavigateTypeSupport(H,typeof N.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(C,N,H){return this.s(C,B,x=>x.provideWorkspaceSymbols(N,H),{symbols:[]},H)}$resolveWorkspaceSymbol(C,N,H){return this.s(C,B,x=>x.resolveWorkspaceSymbol(N,H),void 0,void 0)}$releaseWorkspaceSymbols(C,N){this.s(C,B,H=>H.releaseWorkspaceSymbols(N),void 0,void 0)}registerRenameProvider(C,N,H){const x=this.t(new q(this.h,H,this.l),C);return this.e.$registerRenameSupport(x,this.o(N),q.supportsResolving(H)),this.p(x)}$provideRenameEdits(C,N,H,x,te){return this.s(C,q,pe=>pe.provideRenameEdits(n.URI.revive(N),H,x,te),void 0,te)}$resolveRenameLocation(C,N,H,x){return this.s(C,q,te=>te.resolveRenameLocation(n.URI.revive(N),H,x),void 0,x)}registerDocumentSemanticTokensProvider(C,N,H,x){const te=this.t(new Ee(this.h,H),C),pe=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(N),x,pe);let ke=this.p(te);if(pe){const ue=H.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(pe));ke=M.Disposable.from(ke,ue)}return ke}$provideDocumentSemanticTokens(C,N,H,x){return this.s(C,Ee,te=>te.provideDocumentSemanticTokens(n.URI.revive(N),H,x),null,x)}$releaseDocumentSemanticTokens(C,N){this.s(C,Ee,H=>H.releaseDocumentSemanticColoring(N),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,N,H,x){const te=this.t(new ie(this.h,H),C);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(N),x),this.p(te)}$provideDocumentRangeSemanticTokens(C,N,H,x){return this.s(C,ie,te=>te.provideDocumentRangeSemanticTokens(n.URI.revive(N),H,x),null,x)}registerCompletionItemProvider(C,N,H,x){const te=this.t(new ce(this.h,this.j.converter,H,this.m,C),C);return this.e.$registerCompletionsProvider(te,this.o(N),x,ce.supportsResolving(H),`${C.identifier.value}(${x.join("")})`),this.p(te)}$provideCompletionItems(C,N,H,x,te){return this.s(C,ce,pe=>pe.provideCompletionItems(n.URI.revive(N),H,x,te),void 0,te)}$resolveCompletionItem(C,N,H){return this.s(C,ce,x=>x.resolveCompletionItem(N,H),void 0,H)}$releaseCompletionItems(C,N){this.s(C,ce,H=>H.releaseCompletionItems(N),void 0,void 0)}registerInlineCompletionsProvider(C,N,H){const x=new Te(C,this.h,H,this.j.converter),te=this.t(x,C);return this.e.$registerInlineCompletionsSupport(te,this.o(N),x.supportsHandleEvents),this.p(te)}$provideInlineCompletions(C,N,H,x,te){return this.s(C,de,pe=>pe.provideInlineCompletions(n.URI.revive(N),H,x,te),void 0,te)}$handleInlineCompletionDidShow(C,N,H){this.s(C,de,async x=>{x.handleDidShowCompletionItem(N,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,N,H,x){this.s(C,de,async te=>{te.handlePartialAccept(N,H,x)},void 0,void 0)}$freeInlineCompletionsList(C,N){this.s(C,de,async H=>{H.disposeCompletions(N)},void 0,void 0)}registerSignatureHelpProvider(C,N,H,x){const te=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,pe=this.t(new re(this.h,H),C);return this.e.$registerSignatureHelpProvider(pe,this.o(N),te),this.p(pe)}$provideSignatureHelp(C,N,H,x,te){return this.s(C,re,pe=>pe.provideSignatureHelp(n.URI.revive(N),H,x,te),void 0,te)}$releaseSignatureHelp(C,N){this.s(C,re,H=>H.releaseSignatureHelp(N),void 0,void 0)}registerInlayHintsProvider(C,N,H){const x=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new V(this.h,this.j.converter,H,this.l,C),C);this.e.$registerInlayHintsProvider(te,this.o(N),typeof H.resolveInlayHint=="function",x,ae.u(C));let pe=this.p(te);if(x!==void 0){const ke=H.onDidChangeInlayHints(ue=>this.e.$emitInlayHintsEvent(x));pe=M.Disposable.from(pe,ke)}return pe}$provideInlayHints(C,N,H,x){return this.s(C,V,te=>te.provideInlayHints(n.URI.revive(N),H,x),void 0,x)}$resolveInlayHint(C,N,H){return this.s(C,V,x=>x.resolveInlayHint(N,H),void 0,H)}$releaseInlayHints(C,N){this.s(C,V,H=>H.releaseHints(N),void 0,void 0)}registerDocumentLinkProvider(C,N,H){const x=this.t(new L(this.h,H),C);return this.e.$registerDocumentLinkProvider(x,this.o(N),typeof H.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(C,N,H){return this.s(C,L,x=>x.provideLinks(n.URI.revive(N),H),void 0,H,N.scheme==="output")}$resolveDocumentLink(C,N,H){return this.s(C,L,x=>x.resolveLink(N,H),void 0,void 0,!0)}$releaseDocumentLinks(C,N){this.s(C,L,H=>H.releaseLinks(N),void 0,void 0,!0)}registerColorProvider(C,N,H){const x=this.t(new K(this.h,H),C);return this.e.$registerDocumentColorProvider(x,this.o(N)),this.p(x)}$provideDocumentColors(C,N,H){return this.s(C,K,x=>x.provideColors(n.URI.revive(N),H),[],H)}$provideColorPresentations(C,N,H,x){return this.s(C,K,te=>te.provideColorPresentations(n.URI.revive(N),H,x),void 0,x)}registerFoldingRangeProvider(C,N,H){const x=this.q(),te=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new se(new me(this.h,H),C)),this.e.$registerFoldingRangeProvider(x,this.o(N),C.identifier,te);let pe=this.p(x);if(te!==void 0){const ke=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));pe=M.Disposable.from(pe,ke)}return pe}$provideFoldingRanges(C,N,H,x){return this.s(C,me,te=>te.provideFoldingRanges(n.URI.revive(N),H,x),void 0,x)}registerSelectionRangeProvider(C,N,H){const x=this.t(new Ie(this.h,H,this.l),C);return this.e.$registerSelectionRangeProvider(x,this.o(N)),this.p(x)}$provideSelectionRanges(C,N,H,x){return this.s(C,Ie,te=>te.provideSelectionRanges(n.URI.revive(N),H,x),[],x)}registerCallHierarchyProvider(C,N,H){const x=this.t(new Se(this.h,H),C);return this.e.$registerCallHierarchyProvider(x,this.o(N)),this.p(x)}$prepareCallHierarchy(C,N,H,x){return this.s(C,Se,te=>Promise.resolve(te.prepareSession(n.URI.revive(N),H,x)),void 0,x)}$provideCallHierarchyIncomingCalls(C,N,H,x){return this.s(C,Se,te=>te.provideCallsTo(N,H,x),void 0,x)}$provideCallHierarchyOutgoingCalls(C,N,H,x){return this.s(C,Se,te=>te.provideCallsFrom(N,H,x),void 0,x)}$releaseCallHierarchy(C,N){this.s(C,Se,H=>Promise.resolve(H.releaseSession(N)),void 0,void 0)}registerTypeHierarchyProvider(C,N,H){const x=this.t(new ve(this.h,H),C);return this.e.$registerTypeHierarchyProvider(x,this.o(N)),this.p(x)}$prepareTypeHierarchy(C,N,H,x){return this.s(C,ve,te=>Promise.resolve(te.prepareSession(n.URI.revive(N),H,x)),void 0,x)}$provideTypeHierarchySupertypes(C,N,H,x){return this.s(C,ve,te=>te.provideSupertypes(N,H,x),void 0,x)}$provideTypeHierarchySubtypes(C,N,H,x){return this.s(C,ve,te=>te.provideSubtypes(N,H,x),void 0,x)}$releaseTypeHierarchy(C,N){this.s(C,ve,H=>Promise.resolve(H.releaseSession(N)),void 0,void 0)}registerDocumentOnDropEditProvider(C,N,H){const x=this.q();return this.f.set(x,new se(new Ce(this.e,this.h,H,x),C)),this.e.$registerDocumentOnDropEditProvider(x,this.o(N)),this.p(x)}$provideDocumentOnDropEdits(C,N,H,x,te,pe){return this.s(C,Ce,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(N,n.URI.revive(H),x,te,pe)),void 0,void 0)}registerDocumentPasteEditProvider(C,N,H,x){const te=this.q();return this.f.set(te,new se(new J(this.e,this.h,H,te),C)),this.e.$registerPasteEditProvider(te,this.o(N),!!H.prepareDocumentPaste,x.pasteMimeTypes),this.p(te)}$prepareDocumentPaste(C,N,H,x,te){return this.s(C,J,pe=>pe.prepareDocumentPaste(n.URI.revive(N),H,x,te),void 0,te)}$providePasteEdits(C,N,H,x,te,pe){return this.s(C,J,ke=>ke.providePasteEdits(N,n.URI.revive(H),x,te,pe),void 0,pe)}static w(C){return{pattern:C.source,flags:(0,w.regExpFlags)(C)}}static y(C){return{decreaseIndentPattern:ae.w(C.decreaseIndentPattern),increaseIndentPattern:ae.w(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?ae.w(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?ae.w(C.unIndentedLinePattern):void 0}}static z(C){return{beforeText:ae.w(C.beforeText),afterText:C.afterText?ae.w(C.afterText):void 0,previousLineText:C.previousLineText?ae.w(C.previousLineText):void 0,action:C.action}}static B(C){return C.map(ae.z)}setLanguageConfiguration(C,N,H){const{wordPattern:x}=H;if(x&&(0,w.regExpLeadsToEndlessLoop)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(N,x):this.h.setWordDefinitionFor(N,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const te=this.q(),pe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(te,N,pe),this.p(te)}$setWordDefinitions(C){for(const N of C)this.h.setWordDefinitionFor(N.languageId,new RegExp(N.regexSource,N.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(Ae[226],Re([1,0,4,8,7,29,17,6]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(O,S,f,E){this.c=S,this.d=f,this.e=E,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,S){await this.a.$changeLanguage(O,S);const f=this.c.getDocumentData(O);if(!f)throw new Error(`document '${O.toString()}' NOT found`);return f.document}async tokenAtPosition(O,S){const f=O.version,E=T.Position.from(S),g=await this.a.$tokensAtPosition(O.uri,E),d={type:k.StandardTokenType.Other,range:O.getWordRangeAtPosition(S)??new k.Range(S.line,S.character,S.line,S.character)};if(!g)return d;const t={range:T.Range.to(g.range),type:T.TokenType.to(g.type)};return!t.range.contains(S)||f!==O.version?d:t}createLanguageStatusItem(O,S,f){const E=this.f++,g=this.a,d=this.g,t=`${O.identifier.value}/${S}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);d.add(t);const a={selector:f,id:S,name:O.displayName??O.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const b=new A.DisposableStore,P=()=>{m?.dispose(),m=(0,R.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(E,{id:t,name:a.name??O.displayName??O.name,source:O.displayName??O.name,selector:T.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===k.LanguageStatusSeverity.Error?M.default.Error:a.severity===k.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this.d.toInternal(a.command,b),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},p={dispose(){b.dispose(),m?.dispose(),g.$removeLanguageStatus(E),d.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,P()},get selector(){return a.selector},set selector(i){a.selector=i,P()},get text(){return a.text},set text(i){a.text=i,P()},get detail(){return a.detail},set detail(i){a.detail=i,P()},get severity(){return a.severity},set severity(i){a.severity=i,P()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,P()},get command(){return a.command},set command(i){a.command=i,P()},get busy(){return a.busy},set busy(i){a.busy=i,P()}};return P(),p}}e.ExtHostLanguages=w}),define(Ae[79],Re([1,0,20,12,2,3,13,4,27,18]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(f,E,g){this.f=g,this.d=new Map,this.a=E.getProxy(A.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,E){const{message:g,args:d,comment:t}=E;if(this.c)return(0,T.format2)(g,d??{});let a=g;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const m=this.d.get(f)?.contents[a];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,T.format2)(m??g,d??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let E;const g=await this.g(f);if(!g){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(g),t=JSON.parse(d);E=f.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${f.identifier.value} from ${g}: ${d.message}`);return}E&&this.d.set(f.identifier.value,{contents:E,uri:g})}async g(f){if(f.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return k.URI.revive(E)}return f.l10n?k.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=je([Ve(0,w.IExtHostInitDataService),Ve(1,h.IExtHostRpcService),Ve(2,R.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ae[227],Re([1,0,13,4,27,18,2,66]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(S,f){super(f.logLevel,f.logsLocation,f.loggers.map(E=>(0,A.revive)(E))),this.n=S.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(S,f){f?this.setLogLevel(R.URI.revive(f),S):this.setLogLevel(S)}setVisibility(S,f){super.setVisibility(S,f),this.n.$setVisibility(S,f)}m(S,f,E){return new h(this.n,S,f,E)}};w=je([Ve(0,M.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],w),e.ExtHostLoggerService=w;class h extends n.AbstractMessageLogger{constructor(S,f,E,g){super(g?.logLevel==="always"),this.m=S,this.n=f,this.k=!1,this.l=[],this.setLevel(E),this.m.$createLogger(f,g).then(()=>{this.q(this.l),this.k=!0})}g(S,f){const E=[[S,f]];this.k?this.q(E):this.l.push(...E)}q(S){this.m.$log(this.n,S)}}}),define(Ae[228],Re([1,0,4,13,26]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let R=class{constructor(w,h){this.b=h,this.a=w.getProxy(n.MainContext.MainThreadMessageService)}showMessage(w,h,O,S,f){const E={source:{identifier:w.identifier,label:w.displayName||w.name}};let g;typeof S=="string"||M(S)?g=[S,...f]:(E.modal=S?.modal,E.useCustom=S?.useCustom,E.detail=S?.detail,g=f),E.useCustom&&(0,k.checkProposedApiEnabled)(w,"resolvers");const d=[];for(let t=0;t<g.length;t++){const a=g[t];if(typeof a=="string")d.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:m,isCloseAffordance:b}=a;d.push({title:m,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",a)}return this.a.$showMessage(h,O,E,d).then(t=>{if(typeof t=="number")return g[t]})}};R=je([Ve(1,T.ILogService)],R),e.ExtHostMessageService=R}),define(Ae[229],Re([1,0,25,5,6,28,12,9,2,54,4,38,8,7,46,201,102]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,P,p,i){this.q=p,this.r=i,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===13){const s=l.notebookEditor?.notebookUri,c=l.cell.handle,I=this.g.get(s)?.getCell(c);if(I)return I.apiCell}if(l&&l.$mid===14){const s=l.uri,c=this.g.get(s);if(c)return c.apiNotebook}return l}}),a.x(P)}getEditorById(b){const P=this.h.get(b);if(!P)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(b){for(const[P,p]of this.h)if(p.apiEditor===b)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,P){const p=this.g.get(b);if(!p&&!P)throw new Error(`NO notebook document for '${b}'`);return p}static s(b,P){if(!P)return;const p=P.filenamePattern.map(i=>f.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(P.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:P.displayName,filenamePattern:p,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,P,p){const i=a.a++,l=typeof p.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(i,p),this.b.$registerNotebookCellStatusBarItemProvider(i,l,P);let s;return l!==void 0&&(s=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(l))),new E.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,l),s?.dispose()})}async createNotebookDocument(b){const P=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return w.URI.revive(P)}async openNotebookDocument(b){const P=this.g.get(b);if(P)return P.apiNotebook;const p=await this.c.$tryOpenNotebook(b),i=this.g.get(w.URI.revive(p));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,P){w.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof P=="object"?p={position:f.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(f.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,p),l=i&&this.h.get(i)?.apiEditor;if(l)return l;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,P,p,i){const l=this.f.get(b),s=w.URI.revive(P),c=this.g.get(s);if(!c||!l)return;const o=c.getCellFromIndex(p);if(!o)return;const I=await l.provideCellStatusBarItems(o.apiCell,i);if(!I)return;const r=new k.DisposableStore,u=this.p.add([r]),D=(Array.isArray(I)?I:[I]).map(y=>f.NotebookStatusBarItem.from(y,this.i,r));return{cacheId:u,items:D}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,P,p,i,l){if((0,R.isFalsyOrWhitespace)(P))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,p),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},P,f.NotebookDocumentContentOptions.from(i),a.s(b,l)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,P,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const l=await i.deserializeNotebook(P.buffer,p);return new g.SerializableObjectWithBuffers(f.NotebookData.from(l))}async $notebookToData(b,P,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const l=await i.serializeNotebook(f.NotebookData.to(P.value),p);return n.VSBuffer.wrap(l)}w(b,P,p){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const i=new t.ExtHostNotebookEditor(P,this.d,b,p.visibleRanges.map(f.NotebookRange.to),p.selections.map(f.NotebookRange.to),typeof p.viewColumn=="number"?f.ViewColumn.to(p.viewColumn):void 0);this.h.set(P,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const p of b.value.removedDocuments){const i=w.URI.revive(p),l=this.g.get(i);l&&(l.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(l.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===i.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const p=[];for(const i of b.value.addedDocuments){const l=w.URI.revive(i.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const s=new d.ExtHostNotebookDocument(this.c,this.q,this.r,l,i);p.push(...i.cells.map(c=>d.ExtHostCell.asModelAddData(s.apiNotebook,c))),this.g.get(l)?.dispose(),this.g.set(l,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const p of b.value.addedEditors){if(this.h.has(p.id))return;const i=w.URI.revive(p.documentUri),l=this.g.get(i);l&&this.w(l,p.id,p)}const P=[];if(b.value.removedEditors)for(const p of b.value.removedEditors){const i=this.h.get(p);i&&(this.h.delete(p),this.k?.id===i.id&&(this.k=void 0),P.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const p=new Set;this.l.forEach(i=>p.add(i.id));for(const i of this.h.values()){const l=p.has(i.id);i._acceptVisibility(l)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const P=S.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new S.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>n.VSBuffer.wrap(l))],new S.ApiCommandResult("Notebook Data",l=>f.NotebookData.to(l.value))),i=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new g.SerializableObjectWithBuffers(f.NotebookData.from(l)))],new S.ApiCommandResult("Bytes",l=>l.buffer));b.registerApiCommand(p),b.registerApiCommand(i)}}a.a=0,e.ExtHostNotebookController=a}),define(Ae[230],Re([1,0,16,17,21,5,6,28,2,24,13,54,4,38,8,7,74,191,26,46]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(o,I,r,u,v){this.k=I,this.l=r,this.m=u,this.n=v,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new S.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(f.MainContext.MainThreadNotebookKernels);const D=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const W=this.l.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:W}}else if(y&&"notebookEditor"in y){const W=this.l.getIdByEditor(y.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return y})],E.ApiCommandResult.Void);this.m.registerApiCommand(D)}createNotebookController(o,I,r,u,v,D){for(const de of this.h.values())if(de.controller.id===I&&h.ExtensionIdentifier.equals(o.identifier,de.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const y=this.i++,W=this;this.n.trace(`NotebookController[${y}], CREATED by ${o.identifier.value}, ${I}`);const X=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${o.identifier}'`);let _=!1;const J=new R.DisposableStore,j=new M.Emitter,U=new M.Emitter,$={id:s(o.identifier,I),notebookType:r,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:u||o.identifier.value,preloads:D?D.map(g.NotebookRendererScript.from):[]};let B=v??X,q;this.a.$addKernel(y,$).catch(de=>{console.log(de),_=!0});let he=0;const Ee=()=>{if(_)return;const de=++he;Promise.resolve().then(()=>{de===he&&this.a.$updateKernel(y,$)})},ie=new A.ResourceMap,ce={get id(){return I},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return $.label},set label(de){$.label=de??o.displayName??o.name,Ee()},get detail(){return $.detail??""},set detail(de){$.detail=de,Ee()},get description(){return $.description??""},set description(de){$.description=de,Ee()},get kind(){return(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind??""},set kind(de){(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind=de,Ee()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(de){$.supportedLanguages=de,Ee()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(de){$.supportsExecutionOrder=de,Ee()},get rendererScripts(){return $.preloads?$.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(de){B=de??X},get interruptHandler(){return q},set interruptHandler(de){q=de,$.supportsInterrupt=Boolean(de),Ee()},createNotebookCellExecution(de){if(_)throw new Error("notebook controller is DISPOSED");if(!ie.has(de.notebook.uri))throw W.n.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return W._createNotebookCellExecution(de,s(o.identifier,this.id))},dispose:()=>{_||(this.n.trace(`NotebookController[${y}], DISPOSED`),_=!0,this.h.delete(y),J.dispose(),j.dispose(),U.dispose(),this.a.$removeKernel(y))},updateNotebookAffinity(de,Te){Te===d.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(y,de.uri,Te)},onDidReceiveMessage:U.event,postMessage(de,Te){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),W.a.$postMessage(y,Te&&W.l.getIdByEditor(Te),de)},asWebviewUri(de){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),(0,t.asWebviewUri)(de,W.k.remote)}};return this.h.set(y,{extensionId:o.identifier,controller:ce,onDidReceiveMessage:U,onDidChangeSelection:j,associatedNotebooks:ie}),ce}getIdByController(o){for(const[I,r]of this.h)if(r.controller===o)return s(r.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,I){const r=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(r,I);const v={dispose:()=>{this.c.delete(r),u.a.$removeKernelDetectionTask(r)}};return this.c.set(r,v),v}registerKernelSourceActionProvider(o,I,r){const u=this.f++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,D=this;this.e.set(u,r),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let y;return v!==void 0&&(y=r.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.e.delete(u),D.a.$removeKernelSourceActionProvider(u,u),y?.dispose()}}}async $provideKernelSourceActions(o,I){const r=this.e.get(o);if(r){const u=new R.DisposableStore;return this.g.add([u]),(await r.provideNotebookKernelSourceActions(I)??[]).map(D=>g.NotebookKernelSourceAction.from(D,this.m.converter,u))}return[]}$acceptNotebookAssociation(o,I,r){const u=this.h.get(o);if(u){const v=this.l.getNotebookDocument(w.URI.revive(I));r?u.associatedNotebooks.set(v.uri,!0):u.associatedNotebooks.delete(v.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,v.uri.toString(),r),u.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(o,I,r){const u=this.h.get(o);if(!u)return;const v=this.l.getNotebookDocument(w.URI.revive(I)),D=[];for(const y of r){const W=v.getCell(y);W&&D.push(W.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,v.uri.toString(),D.length),await u.controller.executeHandler.call(u.controller,D,v.apiNotebook,u.controller)}catch(y){this.n.error(`NotebookController[${o}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(o,I,r){const u=this.h.get(o);if(!u)return;const v=this.l.getNotebookDocument(w.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,v.apiNotebook);else for(const D of r){const y=v.getCell(D);y&&this.b.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,I,r){const u=this.h.get(o);if(!u)return;const v=this.l.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(o,I,r){const v=this.l.getNotebookDocument(w.URI.revive(o)).getCell(I);if(v){const D=r?g.NotebookCellExecutionState.to(r):d.NotebookCellExecutionState.Idle;D!==void 0&&this.j.fire({cell:v.apiCell,state:D})}}_createNotebookCellExecution(o,I){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const v=new i(I,u,this.a);this.b.set(u.uri,v);const D=v.onDidChangeState(()=>{v.state===p.Resolved&&(v.dispose(),D.dispose(),this.b.delete(u.uri))});return v.asApiObject()}};P=je([Ve(4,O.ILogService)],P),e.ExtHostNotebookKernels=P;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class i extends R.Disposable{get state(){return this.f}constructor(o,I,r){super(),this.j=I,this.k=r,this.b=i.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.D(new k.CancellationTokenSource),this.h=new l(10,u=>this.m(u)),this.i=I.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const I=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(I))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(o){let I=this.j;if(o&&(I=this.j.notebook.getCellFromApiCell(o)),!I)throw new Error("INVALID cell");return I.handle}r(o){return o.map(I=>{const r=d.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return r===I.items?g.NotebookCellOutput.from(I):g.NotebookCellOutput.from({items:r,id:I.id,metadata:I.metadata})})}async s(o,I,r){const u=this.q(I),v=this.r((0,n.asArray)(o));return this.l({editType:a.CellExecutionUpdateType.Output,cellHandle:u,append:r,outputs:v})}async t(o,I,r){return o=d.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(o),!0),this.l({editType:a.CellExecutionUpdateType.OutputItems,items:o.map(g.NotebookCellOutputItem.from),outputId:I.id,append:r})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(r){o.i=r,o.m([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(r){if(o.f===p.Resolved||o.f===p.Started)throw new Error("Cannot call start again");o.f=p.Started,o.c.fire(),o.m({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,u){if(o.f===p.Resolved)throw new Error("Cannot call resolve twice");o.f=p.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new b.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:r}))},clearOutput(r){return o.n(),o.s([],r,!1)},appendOutput(r,u){return o.n(),o.s(r,u,!0)},replaceOutput(r,u){return o.n(),o.s(r,u,!1)},appendOutputItems(r,u){return o.n(),o.t(r,u,!0)},replaceOutputItems(r,u){return o.n(),o.t(r,u,!1)}})}}i.a=0;class l{constructor(o,I){this.d=o,this.e=I,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const I=this.a;return this.a=[],this.e(I).finally(()=>o.complete())}}function s(c,o){return`${c.value}/${o}`}e.createKernelId=s}),define(Ae[231],Re([1,0,5,4,102]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,w){this.c=w,this.a=new Map,this.b=A.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,w,h){const O=this.c.getEditorById(A);this.a.get(w)?.fire({editor:O.apiEditor,message:h})}createRendererMessaging(A,w){if(!A.contributes?.notebookRenderer?.some(O=>O.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(O,S,f)=>this.d(w).event(O,S,f),postMessage:(O,S)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,S]=[S,O]);const f=S&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.b.$postMessage(f?.id,w,O)}}}d(A){let w=this.a.get(A);return w||(w=new n.Emitter({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(A)}}),this.a.set(A,w),w)}}e.ExtHostNotebookRenderers=M}),define(Ae[232],Re([1,0,6,9,2,26,4]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(h){this.b=new Map,this.a=h.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(h,O,S){if((0,M.checkProposedApiEnabled)(h,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,S),this.a.$registerProfileContentHandler(O,S.name,S.description,h.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(h,O,S,f){const E=this.b.get(h);if(!E)throw new Error(`Unknown handler with id: ${h}`);return E.saveProfile(O,S,f)}async $readProfile(h,O,S){const f=this.b.get(h);if(!f)throw new Error(`Unknown handler with id: ${h}`);return f.readProfile((0,T.isString)(O)?O:k.URI.revive(O),S)}}e.ExtHostProfileContentHandlers=A}),define(Ae[233],Re([1,0,2,4,17,8]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(w,h){this.d=h,this.c=new Map,this.b=w.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(w,h,O){const S=n.URI.revive(h),f=this.c.get(w);return f?(0,k.asPromise)(()=>f.provideOriginalResource(S,O)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(w,h,O,S){const f=R.a++;return this.c.set(f,h),this.b.$registerQuickDiffProvider(f,M.DocumentSelector.from(w,this.d),O,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}R.a=0,e.ExtHostQuickDiff=R}),define(Ae[234],Re([1,0,21,5,6,4,2,7,14,16,29,39,26,8]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(d,t,a){const m=d.getProxy(M.MainContext.MainThreadQuickOpen);class b{constructor(r,u){this.e=new Map,this.f=0,this.a=r,this.b=u}showQuickPick(r,u,v,D=n.CancellationToken.None){this.c=void 0;const y=Promise.resolve(u),W=++this.f,X=m.$show(W,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},D),_={},J=X.then(()=>_);return Promise.race([J,y]).then(j=>{if(j===_)return;const U=(0,f.isProposedApiEnabled)(r,"quickPickItemTooltip");return y.then($=>{const B=[];for(let q=0;q<$.length;q++){const he=$[q];typeof he=="string"?B.push({label:he,handle:q}):he.kind===A.QuickPickItemKind.Separator?B.push({type:"separator",label:he.label}):(he.tooltip&&!U&&console.warn(`Extension '${r.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${r.identifier.value}`),B.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:U?E.MarkdownString.fromStrict(he.tooltip):void 0,handle:q}))}return v&&typeof v.onDidSelectItem=="function"&&(this.c=q=>{v.onDidSelectItem($[q])}),m.$setItems(W,B),X.then(q=>{if(typeof q=="number")return $[q];if(Array.isArray(q))return q.map(he=>$[he])})})}).then(void 0,j=>{if(!(0,w.isCancellationError)(j))return m.$setError(W,j),Promise.reject(j)})}$onItemSelected(r){this.c?.(r)}showInput(r,u=n.CancellationToken.None){return this.d=r?.validateInput,m.$input(r,typeof this.d=="function",u).then(void 0,v=>{if(!(0,w.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(r){if(!this.d)return;const u=await this.d(r);if(!u||typeof u=="string")return u;let v;switch(u.severity){case A.InputBoxValidationSeverity.Info:v=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:v=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:v=O.default.Error;break;default:v=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:v}}async showWorkspaceFolderPick(r,u=n.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!v)return;const D=await this.a.getWorkspaceFolders2();if(!!D)return D.find(y=>y.uri.toString()===v.uri.toString())}createQuickPick(r){const u=new c(r,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(r){const u=new o(r,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(r,u){this.e.get(r)?._fireDidChangeValue(u)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,u){const v=this.e.get(r);v instanceof c&&v._fireDidChangeActive(u)}$onDidChangeSelection(r,u){const v=this.e.get(r);v instanceof c&&v._fireDidChangeSelection(u)}$onDidTriggerButton(r,u){this.e.get(r)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(r,u,v){const D=this.e.get(r);D instanceof c&&D._fireDidTriggerItemButton(u,v)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class P{constructor(r,u){this.x=r,this.y=u,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((u,v)=>{const D=u===A.QuickInputButtons.Back?-1:v;this.o.set(D,u)}),this.z({buttons:r.map((u,v)=>({...s(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const u=this.o.get(r);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(r){if(!this.v){for(const u of Object.keys(r)){const v=r[u];this.u[u]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}P.a=1;function p(I){if(I instanceof A.ThemeIcon)return{id:I.id};const r=l(I),u=i(I);return{dark:typeof r=="string"?R.URI.file(r):r,light:typeof u=="string"?R.URI.file(u):u}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function s(I){const r=p(I.iconPath);let u,v;return"id"in r?v=S.ThemeIcon.asClassName(r):u=r,{iconPath:u,iconClass:v}}class c extends P{constructor(r,u){super(r.identifier,u),this.O=r,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((D,y)=>{this.C.set(y,D),this.D.set(D,y)});const u=(0,f.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),v=[];for(let D=0;D<r.length;D++){const y=r[D];y.kind===A.QuickPickItemKind.Separator?v.push({type:"separator",label:y.label}):(y.tooltip&&!u&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),v.push({handle:D,label:y.label,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:u?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((W,X)=>({...s(W),tooltip:W.tooltip,handle:X}))}))}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(r){const u=(0,h.coalesce)(r.map(v=>this.C.get(v)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(r){const u=(0,h.coalesce)(r.map(v=>this.C.get(v)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(r,u){const v=this.C.get(r);if(!v||!v.buttons||!v.buttons.length)return;const D=v.buttons[u];D&&this.N.fire({button:D,item:v})}}class o extends P{constructor(r,u){super(r.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:O.default.Error}):this.z({validationMessage:r.message,severity:r.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new b(t,a)}e.createExtHostQuickOpen=g});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n};define(Ae[235],Re([1,0,2,5,64,6,17,4,16,125,13,24,39,8,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g){"use strict";var d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(u){if(u)return typeof u.iconPath=="string"?n.URI.file(u.iconPath):n.URI.isUri(u.iconPath)||f.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function m(u,v){if(!u.iconPath&&!v.iconPath)return 0;if(u.iconPath){if(!v.iconPath)return 1}else return-1;const D=typeof u.iconPath=="string"?u.iconPath:n.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,y=typeof v.iconPath=="string"?v.iconPath:n.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,h.comparePaths)(D,y)}function b(u,v){let D=0;if(u.strikeThrough!==v.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==v.faded)return u.faded?1:-1;if(u.tooltip!==v.tooltip)return(u.tooltip||"").localeCompare(v.tooltip||"");if(D=m(u,v),D!==0)return D;if(u.light&&v.light)D=m(u.light,v.light);else{if(u.light)return 1;if(v.light)return-1}if(D!==0)return D;if(u.dark&&v.dark)D=m(u.dark,v.dark);else{if(u.dark)return 1;if(v.dark)return-1}return D}function P(u,v){if(u.command!==v.command)return u.command<v.command?-1:1;if(u.title!==v.title)return u.title<v.title?-1:1;if(u.tooltip!==v.tooltip){if(u.tooltip!==void 0&&v.tooltip!==void 0)return u.tooltip<v.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(u.arguments===v.arguments)return 0;if(u.arguments)if(v.arguments){if(u.arguments.length!==v.arguments.length)return u.arguments.length-v.arguments.length}else return 1;else return-1;for(let D=0;D<u.arguments.length;D++){const y=u.arguments[D],W=v.arguments[D];if(y!==W)return y<W?-1:1}return 0}function p(u,v){let D=(0,h.comparePaths)(u.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(D!==0)return D;if(u.command&&v.command)D=P(u.command,v.command);else{if(u.command)return 1;if(v.command)return-1}if(D!==0)return D;if(u.decorations&&v.decorations)D=b(u.decorations,v.decorations);else{if(u.decorations)return 1;if(v.decorations)return-1}return D}function i(u,v){for(let D=0;D<u.length;D++)if(u[D]!==v[D])return!1;return!0}function l(u,v){return u.command===v.command&&u.title===v.title&&u.tooltip===v.tooltip&&(u.arguments&&v.arguments?i(u.arguments,v.arguments):u.arguments===v.arguments)}function s(u,v){return(0,w.equals)(u,v,l)}class c{get value(){return this.d}set value(v){v=v??"",Fe(this,d,"f").$setInputBoxValue(this.l,v),this.m(v)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(v){Fe(this,d,"f").$setInputBoxPlaceholder(this.l,v),this.f=v}get validateInput(){return(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(v){if((0,g.checkProposedApiEnabled)(this.k,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=v,Fe(this,d,"f").$setValidationProviderIsEnabled(this.l,!!v)}get enabled(){return this.h}set enabled(v){v=!!v,this.h!==v&&(this.h=v,Fe(this,d,"f").$setInputBoxEnablement(this.l,v))}get visible(){return this.j}set visible(v){v=!!v,this.j!==v&&(this.j=v,Fe(this,d,"f").$setInputBoxVisibility(this.l,v))}constructor(v,D,y){this.k=v,this.l=y,d.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,D,"f")}showValidationMessage(v,D){(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,d,"f").$showValidationMessage(this.l,v,D)}$onInputBoxValueChange(v){this.m(v)}m(v){this.d=v,this.e.fire(v)}}e.ExtHostSCMInputBox=c,d=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(v){this.v=v,this.q.$updateGroupLabel(this.t,this.handle,v)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(v){this.p=v,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(v){this.f=[...v],this.k.fire()}constructor(v,D,y,W,X){this.q=v,this.s=D,this.t=y,this.u=W,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(v){return this.g.get(v)}$executeResourceCommand(v,D){const y=this.h.get(v);return y?(0,R.asPromise)(()=>this.s.executeCommand(y.command,...y.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this.f].sort(p),y=(0,w.sortedDiff)(this.o,v,p).map(_=>{const J=_.toInsert.map(j=>{const U=this.e++;this.g.set(U,j);const $=j.resourceUri;let B;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const V=new M.DisposableStore;B=this.s.converter.toInternal(j.command,V),this.j.set(U,V)}else this.h.set(U,j.command);const q=a(j.decorations),he=j.decorations&&a(j.decorations.light)||q,Ee=j.decorations&&a(j.decorations.dark)||q,ie=[he,Ee],ce=j.decorations&&j.decorations.tooltip||"",de=j.decorations&&!!j.decorations.strikeThrough,Te=j.decorations&&!!j.decorations.faded,le=j.contextValue||"";return{rawResource:[U,$,ie,ce,de,Te,le,B],handle:U}});return{start:_.start,deleteCount:_.deleteCount,toInsert:J}}),W=y.map(({start:_,deleteCount:J,toInsert:j})=>[_,J,j.map(U=>U.rawResource)]),X=y.reverse();for(const{start:_,deleteCount:J,toInsert:j}of X){const U=j.map(B=>B.handle),$=this.n.splice(_,J,...U);for(const B of $)this.g.delete(B),this.h.delete(B),this.j.get(B)?.dispose(),this.j.delete(B)}return this.o=v,W}dispose(){this.l=!0,this.m.fire()}}o.d=0;class I{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(v){this.g!==v&&(this.g=v,Fe(this,t,"f").$updateSourceControl(this.t,{count:v}))}get quickDiffProvider(){return this.h}set quickDiffProvider(v){this.h=v,v?.label&&(0,g.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Fe(this,t,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!v,quickDiffLabel:v?.label})}get commitTemplate(){return this.j}set commitTemplate(v){v!==this.j&&(this.j=v,Fe(this,t,"f").$updateSourceControl(this.t,{commitTemplate:v}))}get acceptInputCommand(){return this.l}set acceptInputCommand(v){this.k.value=new M.DisposableStore,this.l=v;const D=this.v.converter.toInternal(v,this.k.value);Fe(this,t,"f").$updateSourceControl(this.t,{acceptInputCommand:D})}get actionButton(){return(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(v){(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=v;const D=v!==void 0?{command:this.v.converter.toInternal(v.command,this.m.value),secondaryCommands:v.secondaryCommands?.map(y=>y.map(W=>this.v.converter.toInternal(W,this.m.value))),description:v.description,enabled:v.enabled}:void 0;Fe(this,t,"f").$updateSourceControl(this.t,{actionButton:D??null})}get statusBarCommands(){return this.p}set statusBarCommands(v){if(this.p&&v&&s(this.p,v))return;this.o.value=new M.DisposableStore,this.p=v;const D=(v||[]).map(y=>this.v.converter.toInternal(y,this.o.value));Fe(this,t,"f").$updateSourceControl(this.t,{statusBarCommands:D})}get selected(){return this.q}constructor(v,D,y,W,X,_){this.u=v,this.v=y,this.w=W,this.x=X,this.y=_,t.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=I.d++,this.z=new Map,this.A=new Set,Je(this,t,D,"f"),this.f=new c(v,Fe(this,t,"f"),this.t),Fe(this,t,"f").$registerSourceControl(this.t,W,X,_)}createResourceGroup(v,D){const y=new o(Fe(this,t,"f"),this.v,this.t,v,D),W=T.Event.once(y.onDidDispose)(()=>this.z.delete(y));return this.z.set(y,W),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const v=[],D=[];for(const[y,W]of this.z){W.dispose();const X=y.onDidUpdateResourceStates(()=>{this.A.add(y),this.eventuallyUpdateResourceStates()});T.Event.once(y.onDidDispose)(()=>{this.A.delete(y),X.dispose(),this.e.delete(y.handle),Fe(this,t,"f").$unregisterGroup(this.t,y.handle)}),v.push([y.handle,y.id,y.label,y.features]);const _=y._takeResourceStateSnapshot();_.length>0&&D.push([y.handle,_]),this.e.set(y.handle,y)}Fe(this,t,"f").$registerGroups(this.t,v,D),this.z.clear()}eventuallyUpdateResourceStates(){const v=[];this.A.forEach(D=>{const y=D._takeResourceStateSnapshot();y.length!==0&&v.push([D.handle,y])}),v.length>0&&Fe(this,t,"f").$spliceResourceStates(this.t,v),this.A.clear()}getResourceGroup(v){return this.e.get(v)}setSelectionState(v){this.q=v,this.s.fire(v)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(v=>v.dispose()),Fe(this,t,"f").$unregisterSourceControl(this.t)}}t=new WeakMap,I.d=0,je([(0,k.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),je([(0,k.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let r=class ln{get onDidChangeActiveProvider(){return this.j.event}constructor(v,D,y){this.l=D,this.m=y,this.g=new Map,this.h=new S.ExtensionIdentifierMap,this.j=new T.Emitter,this.e=v.getProxy(A.MainContext.MainThreadSCM),this.f=v.getProxy(A.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const X=this.g.get(W.sourceControlHandle);if(!X)return W;const _=X.getResourceGroup(W.groupHandle);return _?_.getResourceState(W.handle):W}else if(W&&W.$mid===4){const X=this.g.get(W.sourceControlHandle);return X?X.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const X=this.g.get(W.handle);return X||W}return W}})}createSourceControl(v,D,y,W){this.m.trace("ExtHostSCM#createSourceControl",v.identifier.value,D,y,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const X=ln.d++,_=new I(v,this.e,this.l,D,y,W);this.g.set(X,_);const J=this.h.get(v.identifier)||[];return J.push(_),this.h.set(v.identifier,J),_}getLastInputBox(v){this.m.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const D=this.h.get(v.identifier),y=D&&D[D.length-1];return y&&y.inputBox}$provideOriginalResource(v,D,y){const W=n.URI.revive(D);this.m.trace("ExtHostSCM#$provideOriginalResource",v,W.toString());const X=this.g.get(v);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>X.quickDiffProvider.provideOriginalResource(W,y)).then(_=>_||null)}$onInputBoxValueChange(v,D){this.m.trace("ExtHostSCM#$onInputBoxValueChange",v);const y=this.g.get(v);return y&&y.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(v,D,y,W){this.m.trace("ExtHostSCM#$executeResourceCommand",v,D,y);const X=this.g.get(v);if(!X)return Promise.resolve(void 0);const _=X.getResourceGroup(D);return _?_.$executeResourceCommand(y,W):Promise.resolve(void 0)}$validateInput(v,D,y){this.m.trace("ExtHostSCM#$validateInput",v);const W=this.g.get(v);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>W.inputBox.validateInput(D,y)).then(X=>{if(!X)return Promise.resolve(void 0);const _=E.MarkdownString.fromStrict(X.message);return _?Promise.resolve([_,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this.g.get(v)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=v,Promise.resolve(void 0)}};r.d=0,r=je([Ve(2,O.ILogService)],r),e.ExtHostSCM=r}),define(Ae[80],Re([1,0,4,5,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,w){return this.a.$getPassword(A,w)}store(A,w,h){return this.a.$setPassword(A,w,h)}delete(A,w){return this.a.$deletePassword(A,w)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[236],Re([1,0,7,4,147,6,8,9]),function(ee,e,n,T,k,M,R,A){"use strict";var w,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(g,d,t,a,m=n.StatusBarAlignment.Left,b){w.set(this,void 0),h.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,w,g,"f"),Je(this,h,d,"f"),this.c=O.a++,this.e=t,this.f=a,this.g=m,this.h=this.u(b)}u(g){if(!!(0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!O.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof g=="string"?this.r={fromApi:g,internal:Fe(this,h,"f").toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:Fe(this,h,"f").toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Fe(this,w,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let d;this.m?d=this.m:d=(0,k.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=O.b.get(this.o.id));const a=R.MarkdownString.fromStrict(this.l);Fe(this,w,"f").$setEntry(this.c,g,d,this.k,a,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}w=new WeakMap,h=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class S{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const d={message:g};return this.b.unshift(d),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(d);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(g,d){this.a=g.getProxy(T.MainContext.MainThreadStatusBar),this.b=d,this.c=new S(this)}createStatusBarEntry(g,d,t,a){return new O(this.a,this.b,g,d,t,a)}setStatusBarMessage(g,d){const t=this.c.setMessage(g);let a;return typeof d=="number"?a=setTimeout(()=>t.dispose(),d):typeof d<"u"&&d.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=f}),define(Ae[81],Re([1,0,4,5,3]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,w){this.c=w,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,w){this.a.$registerExtensionStorageKeysToSync(A,w)}async initializeExtensionStorage(A,w,h){const O=await this.a.$initializeExtensionStorage(A,w);let S;return O&&(S=this.d(A,w,O)),S||h}setValue(A,w,h){return this.a.$setValue(A,w,h)}$acceptValue(A,w,h){const O=this.d(A,w,h);O&&this.b.fire({shared:A,key:w,value:O})}d(A,w,h){try{return JSON.parse(h)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${A}): ${O}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Ae[82],Re([1,0,3,27,13,60,2]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=class{constructor(h,O,S){this.d=O,this.f=S,this.a=h.workspace??void 0,this.b=h.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(h){return R.URI.joinPath(this.b.workspaceStorageHome,h)}async h(){if(!this.a)return Promise.resolve(void 0);const h=this.a.id,O=await this.g(h);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(h){if(this.c)return R.URI.joinPath(this.c,h.identifier.value)}globalValue(h){return R.URI.joinPath(this.b.globalStorageHome,h.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=je([Ve(0,T.IExtHostInitDataService),Ve(1,k.ILogService),Ve(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ae[61],Re([1,0,5,4,3,2,18,6,7,149,14,175,21,35,176,39,9,17,8]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(r,u,v,D){this.k=r,this._id=u,this.l=v,this.m=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(W=>this.f=W);const y=this;this.value={get name(){return y.m||""},get processId(){return y.b},get creationOptions(){return y.l},get exitStatus(){return y.h},get state(){return y.j},sendText(W,X=!0){y.o(),y.k.$sendText(y._id,W,X)},show(W){y.o(),y.k.$show(y._id,W)},hide(){y.o(),y.k.$hide(y._id)},dispose(){y.a||(y.a=!0,y.k.$dispose(y._id))},get dimensions(){if(!(y.d===void 0||y.g===void 0))return{columns:y.d,rows:y.g}}}}async create(r,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:(0,t.withNullAsUndefined)(r.shellPath),shellArgs:(0,t.withNullAsUndefined)(r.shellArgs),cwd:(0,t.withNullAsUndefined)(r.cwd),env:(0,t.withNullAsUndefined)(r.env),icon:(0,t.withNullAsUndefined)(c(r.iconPath)),color:d.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,t.withNullAsUndefined)(r.message),strictEnv:(0,t.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(r.location,u?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,u,v,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:d.ThemeColor.isThemeColor(D)?D.id:void 0,location:this.n(r,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,u){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in r?{viewColumn:m.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,u){this.h=Object.freeze({code:r,reason:u})}setDimensions(r,u){return r===this.d&&u===this.g||r===0||u===0?!1:(this.d=r,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(u=>{u!==r&&(this.b=Promise.resolve(r))})}}e.ExtHostTerminal=b;class P{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,u){this.g.setDimensions?.({columns:r,rows:u})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:""})}}let p=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}get onDidWriteTerminalData(){return this.I.event}constructor(r,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new n.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new n.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(T.MainContext.MainThreadTerminalService),this.q=new g.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(r),this.D({dispose:()=>{for(const[v,D]of this.g)D.shutdown(!0)}})}getDefaultShell(r){return(r?this.n:this.m)?.path||""}getDefaultShellArgs(r){return(r?this.n:this.m)?.args||[]}createExtensionTerminal(r,u){const v=new b(this.a,(0,E.generateUuid)(),r,r.name),D=new P(r.pty);return v.createExtensionTerminal(r.location,this.L(r,u).resolvedExtHostIdentifier,c(r.iconPath),o(r.color)).then(y=>{const W=this.M(y,D);this.h[y]=W}),this.f.push(v),v.value}L(r,u){if(u=u||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const D=this.f.find(y=>y.value===v);D&&(u.resolvedExtHostIdentifier=D._id)}}else r.location&&typeof r.location!="object"?u.location=r.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(r,u){if(!this.O(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const D=new P(u),y=this.M(r,D);this.h[r]=y}async $acceptActiveTerminalChanged(r){const u=this.b;if(r===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const v=this.O(r);v&&(this.b=v,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,u){const v=this.O(r);v&&this.I.fire({terminal:v.value,data:u})}async $acceptTerminalDimensions(r,u,v){const D=this.O(r);D&&D.setDimensions(u,v)&&this.G.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(r,u,v){this.g.get(r)?.resize(u,v)}async $acceptTerminalTitleChange(r,u){const v=this.O(r);v&&(v.name=u)}async $acceptTerminalClosed(r,u,v){const D=this.Q(this.f,r);if(D!==null){const y=this.f.splice(D,1)[0];y.setExitStatus(u,v),this.z.fire(y.value)}}$acceptTerminalOpened(r,u,v,D){if(u){const X=this.Q(this.f,u);if(X!==null){this.f[X]._id=r,this.C.fire(this.terminals[X]),this.f[X].isOpen=!0;return}}const y={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:M.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},W=new b(this.a,r,y,v);this.f.push(W),this.C.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(r,u){this.O(r)?._setProcessId(u)}async $startExtensionTerminal(r,u){const v=this.O(r);if(!v)return{message:(0,h.localize)(0,null,r)};v.isOpen||await new Promise(y=>{const W=this.onDidOpenTerminal(async X=>{X===v.value&&(W.dispose(),y())})});const D=this.g.get(r);D?D.startSendingEvents(u):this.j[r]={initialDimensions:u}}M(r,u){const v=new A.DisposableStore;v.add(u.onProcessReady(y=>this.a.$sendProcessReady(r,y.pid,y.cwd))),v.add(u.onDidChangeProperty(y=>this.a.$sendProcessProperty(r,y))),this.q.startBuffering(r,u.onProcessData),v.add(u.onProcessExit(y=>this.N(r,y))),this.g.set(r,u);const D=this.j[r];return D&&u instanceof P&&(u.startSendingEvents(D.initialDimensions),delete this.j[r]),v}$acceptProcessAckDataEvent(r,u){this.g.get(r)?.acknowledgeDataEvent(u)}$acceptProcessInput(r,u){this.g.get(r)?.input(u)}$acceptTerminalInteraction(r){const u=this.O(r);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(r,u,v){try{this.g.get(r)?.resize(u,v)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(r,u){this.g.get(r)?.shutdown(u)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(u=>this.a.$sendProcessProperty(r,{type:"cwd",value:u}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.s.add(r),this.s.size===1&&this.a.$startLinkProvider(),new w.Disposable(()=>{this.s.delete(r),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,u,v){if(this.u.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.u.set(u,v),this.a.$registerProfileProvider(u,r.identifier.value),new w.Disposable(()=>{this.u.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(r,u,v){if(this.v.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.v.set(r,v),this.a.$registerQuickFixProvider(r,u),new w.Disposable(()=>{this.v.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,u){const v=new f.CancellationTokenSource().token;if(v.isCancellationRequested)return;const D=this.v.get(r);if(!D)return;const y=await D.provideTerminalQuickFixes(u,v);if(y!==null)return y}async $createContributedProfileTerminal(r,u){const v=new f.CancellationTokenSource().token;let D=await this.u.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,u);return}this.createTerminalFromOptions(D.options,u)}}async $provideLinks(r,u){const v=this.O(r);if(!v)return[];this.w.delete(r),this.y.get(r)?.dispose(!0);const y=new f.CancellationTokenSource;this.y.set(r,y);const W=[],X={terminal:v.value,line:u},_=[];for(const U of this.s)_.push(a.Promises.withAsyncBody(async $=>{y.token.onCancellationRequested(()=>$({provider:U,links:[]}));const B=await U.provideTerminalLinks(X,y.token)||[];y.token.isCancellationRequested||$({provider:U,links:B})}));const J=await Promise.all(_);if(y.token.isCancellationRequested)return[];const j=new Map;for(const U of J)U&&U.links.length>0&&W.push(...U.links.map($=>{const B={id:p++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return j.set(B.id,{provider:U.provider,link:$}),B}));return this.w.set(r,j),W}$activateLink(r,u){const v=this.w.get(r)?.get(u);!v||v.provider.handleTerminalLink(v.link)}N(r,u){this.q.stopBuffering(r),this.g.delete(r),delete this.j[r];const v=this.h[r];v&&(v.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,u)}O(r){return this.P(this.f,r)}P(r,u){const v=this.Q(r,u);return v!==null?r[v]:null}Q(r,u){let v=null;return r.some((D,y)=>D._id===u?(v=y,!0):!1),v}getEnvironmentVariableCollection(r){let u=this.l.get(r.identifier.value);return u||(u=new l,this.S(r.identifier.value,u)),u}R(r,u){const v=(0,S.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(r,u.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(r){r.forEach(u=>{const v=u[0],D=new l(u[1]);this.S(v,D)})}$acceptDefaultProfile(r,u){const v=this.m;this.m=r,this.n=u,v?.path!==r.path&&this.J.fire(r.path)}S(r,u){this.l.set(r,u),u.onDidChangeCollection(()=>{this.R(r,u)})}};i=je([Ve(1,R.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class l{get persistent(){return this.a}set persistent(r){this.a=r,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(r){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,u){this.d(r,{value:u,type:w.EnvironmentVariableMutatorType.Replace})}append(r,u){this.d(r,{value:u,type:w.EnvironmentVariableMutatorType.Append})}prepend(r,u){this.d(r,{value:u,type:w.EnvironmentVariableMutatorType.Prepend})}d(r,u){const v=this.map.get(r);(!v||v.value!==u.value||v.type!==u.type)&&(this.map.set(r,u),this.b.fire())}get(r){return this.map.get(r)}forEach(r,u){this.map.forEach((v,D)=>r.call(u,D,v,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(r){super(!1,r)}createTerminal(r,u,v){throw new O.NotSupportedError}createTerminalFromOptions(r,u){throw new O.NotSupportedError}};s=je([Ve(0,R.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function c(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function o(I){return d.ThemeColor.isThemeColor(I)?I:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n};define(Ae[237],Re([1,0,16,17,25,21,5,199,91,6,23,9,35,4,18,103,8,7,45,73,56,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p){"use strict";var i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(U,$,B){this.j=B,this.c=new R.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(E.MainContext.MainThreadTesting),this.h=new X(this.f),this.g=new r(this.f),$.registerArgumentProcessor({processArgument:q=>{if(q?.$mid!==15)return q;const he=q,Ee=he.tests[he.tests.length-1].item.extId;return this.d.get(m.TestId.root(Ee))?.collection.tree.get(Ee)?.actual??(0,d.toItemFromContext)(q)}})}createTestController(U,$,B,q){if(this.d.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const he=new h.DisposableStore,Ee=he.add(new d.ExtHostTestItemCollection($,B,this.j));Ee.root.label=B;const ie=new Map,ce=this.f,de={items:Ee.root.children,get label(){return B},set label(le){B=le,Ee.root.label=le,ce.$updateController($,{label:B})},get refreshHandler(){return q},set refreshHandler(le){q=le,ce.$updateController($,{canRefresh:!!le})},get id(){return $},createRunProfile:(le,re,V,L,K,me)=>{let Ie=(0,w.hash)(le);for(;ie.has(Ie);)Ie++;return me!==void 0&&(0,p.checkProposedApiEnabled)(U,"testContinuousRun"),new _(this.f,ie,$,Ie,le,re,V,L,K,me)},createTestItem(le,re,V){return new d.TestItemImpl($,le,re,V)},createTestRun:(le,re,V=!0)=>this.g.createTestRun($,Ee,le,re,V),set resolveHandler(le){Ee.resolveHandler=le},get resolveHandler(){return Ee.resolveHandler},dispose:()=>{he.dispose()}};ce.$registerTestController($,B,!!q),he.add((0,h.toDisposable)(()=>ce.$unregisterTestController($)));const Te={controller:de,collection:Ee,profiles:ie};return this.d.set($,Te),he.add((0,h.toDisposable)(()=>this.d.delete($))),he.add(Ee.onDidGenerateDiff(le=>ce.$publishDiff($,le.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(U,$=M.CancellationToken.None){const B=u(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.d.get(B.controllerId);if(!q)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(he=>m.TestId.fromExtHostTestItem(he,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:J[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(he=>he.id)},$)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,$,B){return(0,n.mapFind)(this.g.trackers,he=>he.id===U?he.getCoverage($):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(U,$,B,q){return(0,n.mapFind)(this.g.trackers,Ee=>Ee.id===U?Ee.getCoverage($):void 0)?.resolveFileCoverage(B,q)??Promise.resolve([])}$configureRunProfile(U,$){this.d.get(U)?.profiles.get($)?.configureHandler?.()}async $refreshTests(U,$){await this.d.get(U)?.controller.refreshHandler?.($)}$publishTestResults(U){this.results=Object.freeze(U.map($=>(0,O.deepFreeze)(t.TestResults.to($))).concat(this.results).sort(($,B)=>B.completedAt-$.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,$){const B=this.d.get(m.TestId.fromString(U).controllerId)?.collection;B&&(await B.expand(U,$<0?1/0:$),B.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(P.TestsDiffOp.deserialize))}async $runControllerTests(U,$){return Promise.all(U.map(B=>this.k(B,!1,$)))}async $startContinuousRun(U,$){const B=new M.CancellationTokenSource($),q=await Promise.all(U.map(he=>this.k(he,!0,B.token)));return!$.isCancellationRequested&&!q.some(he=>he.error)&&await new Promise(he=>$.onCancellationRequested(he)),B.dispose(!0),q}async k(U,$,B){const q=this.d.get(U.controllerId);if(!q)return{};const{collection:he,profiles:Ee}=q,ie=Ee.get(U.profileId);if(!ie)return{};const ce=U.testIds.map(re=>he.tree.get(re)).filter(S.isDefined),de=U.excludeExtIds.map(re=>q.collection.tree.get(re)).filter(S.isDefined).filter(re=>ce.some(V=>V.fullId.compare(re.fullId)===2));if(!ce.length)return{};const Te=new a.TestRunRequest2(ce.some(re=>re.actual instanceof d.TestItemRootImpl)?void 0:ce.map(re=>re.actual),de.map(re=>re.actual),ie,$),le=(0,P.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(Te,v.fromInternal(U,q.collection),B);try{return await ie.runHandler(Te,B),{}}catch(re){return{error:String(re)}}finally{le&&(le.hasRunningTasks&&!B.isCancellationRequested&&await R.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};s=je([Ve(0,g.IExtHostRpcService)],s),e.ExtHostTesting=s;const c=1e4;var o;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(o||(o={}));class I extends h.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,$,B){super(),this.k=U,this.l=$,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new R.Emitter),this.onEnd=this.j.event,this.h=this.D(new M.CancellationTokenSource(B));const q=this.D(new T.RunOnceScheduler(()=>this.m(),c));this.D(this.h.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const $=this.k.id,B=this.k.controllerId,q=(0,f.generateUuid)(),he=new D(this.l,$,q),Ee=Te=>(le,...re)=>{if(ce){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(le)||(this.q(le),Te(le,...re))},ie=(Te,le)=>{const re=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Te.uri&&Te.range){const V={range:t.Range.from(Te.range),uri:Te.uri};for(const L of re)L.location=L.location||V}this.l.$appendTestMessagesInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),re)};let ce=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return he.coverageProvider},set coverageProvider(Te){he.coverageProvider=Te},enqueued:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),1)}),skipped:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),5)}),started:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),2)}),errored:Ee((Te,le,re)=>{ie(Te,le),this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),6,re)}),failed:Ee((Te,le,re)=>{ie(Te,le),this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),4,re)}),passed:Ee((Te,le)=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,this.k.controllerId).toString(),3,le)}),appendOutput:(Te,le,re)=>{ce||(re&&(this.k.isIncluded(re)?this.q(re):re=void 0),this.l.$appendOutputToRun($,q,k.VSBuffer.fromString(Te),le&&t.location.from(le),re&&m.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{ce||(ce=!0,this.l.$finishedTestRunTask($,q),this.f.delete(q),this.f.size||this.p())}};return this.f.set(q,{run:de,coverage:he}),this.l.$startedTestRunTask($,{id:q,name:U,running:!0}),de}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(U){if(!(U instanceof d.TestItemImpl))throw new b.InvalidTestItemError(U.id);if(this.g.has(m.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const $=[],B=this.k.colllection.root;for(;;){const q=t.TestItem.from(U);if($.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),U===B))break;U=U.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,$)}}class r{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,$,B){return this.f(U,$,B)}cancelRunById(U){for(const $ of this.c.values())if($.id===U){$.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,$,B,q,he){const Ee=this.c.get(B);if(Ee)return Ee.createRun(q);const ie=v.fromPublic(U,$,B,he),ce=u(B);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!B.continuous,profile:ce&&{group:J[ce.kind],id:ce.profileId},exclude:B.exclude?.map(Te=>m.TestId.fromExtHostTestItem(Te,$.root.id).toString())??[],id:ie.id,include:B.include?.map(Te=>m.TestId.fromExtHostTestItem(Te,$.root.id).toString())??[$.root.id],persist:he});const de=this.f(B,ie);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),de.dispose()}),de.createRun(q)}f(U,$,B){const q=new I($,this.d,B);return this.c.set(U,q),q.onEnd(()=>this.c.delete(U)),q}}e.TestRunCoordinator=r;const u=j=>{if(!!j.profile){if(!(j.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class v{static fromPublic(U,$,B,q){return new v(U,(0,f.generateUuid)(),B.include?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[U],B.exclude?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[],q,$)}static fromInternal(U,$){return new v(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,$)}constructor(U,$,B,q,he,Ee){this.controllerId=U,this.id=$,this.isPersisted=he,this.colllection=Ee,this.c=B.map(ie=>ie+"\0"),this.d=q.map(ie=>ie+"\0")}isIncluded(U){const $=m.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if($===B||$.startsWith(B))return!1;for(const B of this.c)if($===B||$.startsWith(B))return!0;return!1}}e.TestRunDto=v;class D{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,$,B){this.f=U,this.g=$,this.h=B}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch($){throw this.d=void 0,$}}async resolveFileCoverage(U,$){const B=await this.d;let q=B?.[U];return!this.c||!B||!q?[]:(q.detailedCoverage||(q=B[U]=await this.c.resolveFileCoverage?.(q,$)??q),q.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class y{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const $=m.TestId.parentId(U.item.extId);if($&&this.g.has($.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:$,f:B}=this;return{get added(){return[...U].map(q=>q.revived)},get updated(){return[...$].map(q=>q.revived)},get removed(){return[...B].map(q=>q.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class W extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new R.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,$){return{...U,revived:t.TestItem.toPlain(U.item),depth:$?$.depth+1:0,children:new Set}}o(){return new y(this.q)}}class X{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map($=>$.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new W;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class _{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,$,B,q,he,Ee,ie,ce=!1,de=void 0,Te=!1){this.controllerId=B,this.profileId=q,this.d=he,this.kind=Ee,this.runHandler=ie,this.f=ce,this._tag=de,this.g=Te,i.set(this,void 0),l.set(this,void 0),Je(this,i,U,"f"),Je(this,l,$,"f"),$.set(q,this);const le=J[Ee];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Ee}`);Fe(this,i,"f").$publishTestRunProfile({profileId:q,controllerId:B,tag:de?t.TestTag.namespace(this.controllerId,de.id):null,label:he,group:le,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:Te})}dispose(){Fe(this,l,"f")?.delete(this.profileId)&&(Je(this,l,void 0,"f"),Fe(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,i=new WeakMap,l=new WeakMap;const J={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ae[238],Re([1,0,16,5,4,104,8,7]),function(ee,e,n,T,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(O,S){this.i=S,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const S=this.i.allEditors();return O?S:S.map(f=>f.value)}async showTextDocument(O,S,f){let E;typeof S=="number"?E={position:R.ViewColumn.from(S),preserveFocus:f}:typeof S=="object"?E={position:R.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?R.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:E={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(O.uri,E),d=g&&this.i.getEditor(g);if(d)return d.value;throw g?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,S){return new M.TextEditorDecorationType(this.h,O,S).value}$acceptEditorPropertiesChanged(O,S){const f=this.i.getEditor(O);if(!f)throw new Error("unknown text editor");if(S.options&&f._acceptOptions(S.options),S.selections){const E=S.selections.selections.map(R.Selection.to);f._acceptSelections(E)}if(S.visibleRanges){const E=n.coalesce(S.visibleRanges.map(R.Range.to));f._acceptVisibleRanges(E)}if(S.options&&this.b.fire({textEditor:f.value,options:{...S.options,lineNumbers:R.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const E=A.TextEditorSelectionChangeKind.fromValue(S.selections.source),g=S.selections.selections.map(R.Selection.to);this.a.fire({textEditor:f.value,selections:g,kind:E})}if(S.visibleRanges){const E=n.coalesce(S.visibleRanges.map(R.Range.to));this.c.fire({textEditor:f.value,visibleRanges:E})}}$acceptEditorPositionData(O){for(const S in O){const f=this.i.getEditor(S);if(!f)throw new Error("Unknown text editor");const E=R.ViewColumn.to(O[S]);f.value.viewColumn!==E&&(f._acceptViewColumn(E),this.d.fire({textEditor:f.value,viewColumn:E}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=w}),define(Ae[239],Re([1,0,2,3,4,6,7,8,24,9]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class O{constructor(E,g){this.b=new Map,this.c=new Map,this.a=E.getProxy(k.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&w.ExtensionIdentifier.equals(t,this.b.get(d.source)?.extension)){const a=d.uri===void 0?void 0:n.URI.revive(d.uri);return this.c.get(d.source)?.get(S(a))?.get(d.handle)}else return;return d}})}async $getTimeline(E,g,d,t){return this.b.get(E)?.provider.provideTimeline(n.URI.revive(g),d,t)}registerTimelineProvider(E,g,d,t){const a=new M.DisposableStore,m=this.d(g.id,t,a).bind(this);let b;g.onDidChange&&(b=g.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const P=this.c;return this.f({...g,scheme:E,onDidChange:void 0,async provideTimeline(p,i,l){i?.resetCache&&(a.clear(),P.get(g.id)?.clear());const s=await g.provideTimeline(p,i,l);if(s==null)return;const c=m(p,i);return{...s,source:g.id,items:s.items.map(c)}},dispose(){for(const p of P.values())p.get(g.id)?.clear();b?.dispose(),a.dispose()}},d)}d(E,g,d){return(t,a)=>{let m;if(a?.cacheResults){let b=this.c.get(E);b===void 0&&(b=new Map,this.c.set(E,b));const P=S(t);m=b.get(P),m===void 0&&(m=new Map,b.set(P,m))}return b=>{const{iconPath:P,...p}=b,i=`${E}|${b.id??b.timestamp}`;m?.set(i,b);let l,s,c;b.iconPath&&(P instanceof R.ThemeIcon?c={id:P.id,color:P.color}:n.URI.isUri(P)?(l=P,s=P):{light:l,dark:s}=P);let o;return R.MarkdownString.isMarkdownString(p.tooltip)?o=A.MarkdownString.from(p.tooltip):(0,h.isString)(p.tooltip)?o=p.tooltip:R.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=A.MarkdownString.from(p.detail)):(0,h.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=p.detail),{...p,id:p.id??void 0,handle:i,source:E,command:b.command?g.toInternal(b.command,d):void 0,icon:l,iconDark:s,themeIcon:c,tooltip:o,accessibilityInformation:b.accessibilityInformation}}}}f(E,g){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:g}),(0,M.toDisposable)(()=>{for(const t of this.c.values())t.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=O;function S(f){return f?.toString()}}),define(Ae[240],Re([1,0,6,15,2,4]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(w){this.c=new Map,this.b=w.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,h,O,S){if(this.c.has(h))throw new Error(`Opener with id '${h}' already registered`);const f=S.schemes.find(E=>!R.a.has(E));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(h,O),this.b.$registerUriOpener(h,S.schemes,w,S.label),(0,n.toDisposable)(()=>{this.c.delete(h),this.b.$unregisterUriOpener(h)})}async $canOpenUri(w,h,O){const S=this.c.get(w);if(!S)throw new Error(`Unknown opener with id: ${w}`);const f=k.URI.revive(h);return S.canOpenExternalUri(f,O)}async $openUri(w,h,O){const S=this.c.get(w);if(!S)throw new Error(`Unknown opener id: '${w}'`);return S.openExternalUri(k.URI.revive(h.resolvedUri),{sourceUri:k.URI.revive(h.sourceUri)},O)}}R.a=new Set([T.Schemas.http,T.Schemas.https]),e.ExtHostUriOpeners=R}),define(Ae[241],Re([1,0,4,2,6,14,24]),function(ee,e,n,T,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(h){this.c=new R.ExtensionIdentifierSet,this.d=new Map,this.b=h.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(h,O){if(this.c.has(h))throw new Error(`Protocol handler already registered for extension ${h}`);const S=A.a++;return this.c.add(h),this.d.set(S,O),this.b.$registerUriHandler(S,h),(0,k.toDisposable)(()=>{this.c.delete(h),this.d.delete(S),this.b.$unregisterUriHandler(S)})}$handleExternalUri(h,O){const S=this.d.get(h);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(O))}catch(f){(0,M.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(h){return T.URI.revive(await this.b.$createAppUri(h))}}A.a=0,e.ExtHostUrls=A});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[62],Re([1,0,5,15,23,2,162,185,74,4]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";var O,S,f,E,g,d,t,a,m,b,P,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(y,W,X,_,J,j,U){O.set(this,void 0),S.set(this,void 0),f.set(this,void 0),E.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,""),a.set(this,void 0),m.set(this,!1),b.set(this,!1),P.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Fe(this,i,"f").event,Je(this,O,y,"f"),Je(this,S,W,"f"),Je(this,a,X,"f"),Je(this,E,_,"f"),Je(this,g,J,"f"),Je(this,d,j,"f"),Je(this,P,s(j),"f"),Je(this,p,c(j),"f"),Je(this,f,U,"f")}dispose(){Je(this,m,!0,"f"),Fe(this,i,"f").fire(),Fe(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(y){return Je(this,b,!0,"f"),(0,w.asWebviewUri)(y,Fe(this,E,"f"))}get cspSource(){const y=Fe(this,d,"f").extensionLocation;if(y.scheme===T.Schemas.https||y.scheme===T.Schemas.http){let W=y.toString();return W.endsWith("/")||(W+="/"),W+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.a(),Fe(this,t,"f")}set html(y){this.a(),Fe(this,t,"f")!==y&&(Je(this,t,y,"f"),Fe(this,p,"f")&&!Fe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(y)&&(Je(this,b,!0,"f"),Fe(this,f,"f").report("Webview vscode-resource: uris",Fe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,S,"f").$setHtml(Fe(this,O,"f"),this.b(y)))}get options(){return this.a(),Fe(this,a,"f")}set options(y){this.a(),k.equals(Fe(this,a,"f"),y)||Fe(this,S,"f").$setOptions(Fe(this,O,"f"),r(Fe(this,d,"f"),Fe(this,g,"f"),y)),Je(this,a,y,"f")}async postMessage(y){if(Fe(this,m,"f"))return!1;const W=(0,A.serializeWebviewMessage)(y,{serializeBuffersForPostMessage:Fe(this,P,"f")});return Fe(this,S,"f").$postMessage(Fe(this,O,"f"),W.message,...W.buffers)}a(){if(Fe(this,m,"f"))throw new Error("Webview is disposed")}b(y){if(!Fe(this,p,"f"))return y;const W=Fe(this,d,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,X=Fe(this,d,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Fe(this,d,"f").extensionLocation.authority:void 0;return y.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(_,J,j,U,$,B)=>{const q=M.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(q,{isRemote:W,authority:X}).toString();return`${J}${he}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(_,J,j,U,$,B)=>{const q=M.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(q,{isRemote:W,authority:X}).toString();return`${J}${he}${B}`})}}e.ExtHostWebview=l,O=new WeakMap,S=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,b=new WeakMap,P=new WeakMap,p=new WeakMap,i=new WeakMap;function s(D){try{const y=(0,R.normalizeVersion)((0,R.parseVersion)(D.engines.vscode));return!!y&&y.majorBase>=1&&y.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function c(D){try{const y=(0,R.normalizeVersion)((0,R.parseVersion)(D.engines.vscode));return y?y.majorBase<1||y.majorBase===1&&y.minorBase<60:!1}catch{return!1}}class o{constructor(y,W,X,_,J){this.c=W,this.d=X,this.e=_,this.f=J,this.b=new Map,this.a=y.getProxy(h.MainContext.MainThreadWebviews)}$onMessage(y,W,X){const _=this.g(y);if(_){const{message:J}=(0,A.deserializeWebviewMessage)(W,X.value);_._onMessageEmitter.fire(J)}}$onMissingCsp(y,W){this.e.warn(`${W} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(y,W,X){const _=new l(y,this.a,u(W),this.c,this.d,X,this.f);return this.b.set(y,_),_._onDidDispose(()=>{this.b.delete(y)}),_}deleteWebview(y){this.b.delete(y)}g(y){return this.b.get(y)}}e.ExtHostWebviews=o;function I(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=I;function r(D,y,W){return{enableCommandUris:W.enableCommandUris,enableScripts:W.enableScripts,enableForms:W.enableForms,portMapping:W.portMapping,localResourceRoots:W.localResourceRoots||v(D,y)}}e.serializeWebviewOptions=r;function u(D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots?.map(y=>M.URI.from(y))}}function v(D,y){return[...(y?.getWorkspaceFolders()||[]).map(W=>W.uri),D.extensionLocation]}}),define(Ae[242],Re([1,0,21,91,6,15,22,2,8,62,54,4,7]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(l,s){this.document=l,this.b=s,this.a=1,this.c=new O.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,s){await this.f(l).undo(),s||this.disposeBackup()}async redo(l,s){await this.f(l).redo(),s||this.disposeBackup()}disposeEdits(l){for(const s of l)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this.a++;return(0,R.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const s=this.c.get(l,0);if(!s)throw new Error("No edit found");return s}}class g{constructor(){this.a=new Map}get(l,s){return this.a.get(this.b(l,s))}add(l,s,c){const o=this.b(l,s.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${l} resource:${s.uri}`);const I=new E(s,c);return this.a.set(o,I),I}delete(l,s){const c=this.b(l,s.uri);this.a.delete(c)}b(l,s){return`${l}@@@${s}`}}var d;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(l,s,c){return this.b(0,l,s,c)}addCustomProvider(l,s,c){return this.b(1,l,s,c)}get(l){return this.a.get(l)}b(l,s,c,o){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:l,extension:c,provider:o}),new f.Disposable(()=>this.a.delete(s))}}class a{constructor(l,s,c,o,I){this.d=s,this.f=c,this.g=o,this.h=I,this.b=new t,this.c=new g,this.a=l.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,s,c,o){const I=new k.DisposableStore;return b(c)?(I.add(this.b.addTextProvider(s,l,c)),this.a.$registerTextEditorProvider((0,h.toExtensionData)(l),s,o.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,h.shouldSerializeBuffersForPostMessage)(l))):(I.add(this.b.addCustomProvider(s,l,c)),m(c)&&I.add(c.onDidChangeCustomDocument(r=>{const u=this.i(s,r.document.uri);if(P(r)){const v=u.addEdit(r);this.a.$onDidEdit(r.document.uri,s,v,r.label)}else this.a.$onContentChange(r.document.uri,s)})),this.a.$registerCustomEditorProvider((0,h.toExtensionData)(l),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,h.shouldSerializeBuffersForPostMessage)(l))),f.Disposable.from(I,new f.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(l,s,c,o,I){const r=this.b.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${s}'`);const u=A.URI.revive(l),v=await r.provider.openCustomDocument(u,{backupId:c,untitledDocumentData:o?.buffer},I);let D;return m(r.provider)&&this.f&&(D=this.f.workspaceValue(r.extension)??this.f.globalValue(r.extension)),this.c.add(s,v,D),{editable:m(r.provider)}}async $disposeCustomDocument(l,s){const c=this.b.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=A.URI.revive(l),{document:I}=this.i(s,o);this.c.delete(s,I),I.dispose()}async $resolveCustomEditor(l,s,c,o,I,r){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);const v=w.ViewColumn.to(I),D=this.g.createNewWebview(s,o.contentOptions,u.extension),y=this.h.createNewWebviewPanel(s,c,o.title,v,o.options,D,!0),W=A.URI.revive(l);switch(u.type){case 1:{const{document:X}=this.i(c,W);return u.provider.resolveCustomEditor(X,y,r)}case 0:{const X=this.d.getDocument(W);return u.provider.resolveCustomTextEditor(X,y,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,s,c){this.i(s,l).disposeEdits(c)}async $onMoveCustomEditor(l,s,c){const o=this.b.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const r=A.URI.revive(s),u=this.d.getDocument(r);await o.provider.moveCustomTextEditor(u,I,n.CancellationToken.None)}async $undo(l,s,c,o){return this.i(s,l).undo(c,o)}async $redo(l,s,c,o){return this.i(s,l).redo(c,o)}async $revert(l,s,c){const o=this.i(s,l);await this.j(s).revertCustomDocument(o.document,c),o.disposeBackup()}async $onSave(l,s,c){const o=this.i(s,l);await this.j(s).saveCustomDocument(o.document,c),o.disposeBackup()}async $onSaveAs(l,s,c,o){const I=this.i(s,l);return this.j(s).saveCustomDocumentAs(I.document,A.URI.revive(c),o)}async $backup(l,s,c){const o=this.i(s,l),r=await this.j(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},c);return o.updateBackup(r),r.id}i(l,s){const c=this.c.get(l,A.URI.revive(s));if(!c)throw new Error("No custom document found");return c}j(l){const c=this.b.get(l)?.provider;if(!c||!m(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=a;function m(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function P(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const l=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[243],Re([1,0,5,6,2,35,8,62,4,7]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";var O,S,f,E,g,d,t,a,m,b,P,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends T.Disposable{constructor(I,r,u,v){super(),O.set(this,void 0),S.set(this,void 0),f.set(this,void 0),E.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,void 0),m.set(this,!0),b.set(this,void 0),P.set(this,!1),p.set(this,this.D(new n.Emitter)),this.onDidDispose=Fe(this,p,"f").event,i.set(this,this.D(new n.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,Je(this,O,I,"f"),Je(this,S,r,"f"),Je(this,E,u,"f"),Je(this,f,v.viewType,"f"),Je(this,g,v.panelOptions,"f"),Je(this,a,v.viewColumn,"f"),Je(this,d,v.title,"f"),Je(this,b,v.active,"f")}dispose(){Fe(this,P,"f")||(Je(this,P,!0,"f"),Fe(this,p,"f").fire(),Fe(this,S,"f").$disposeWebview(Fe(this,O,"f")),Fe(this,E,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,E,"f")}get viewType(){return this.c(),Fe(this,f,"f")}get title(){return this.c(),Fe(this,d,"f")}set title(I){this.c(),Fe(this,d,"f")!==I&&(Je(this,d,I,"f"),Fe(this,S,"f").$setTitle(Fe(this,O,"f"),I))}get iconPath(){return this.c(),Fe(this,t,"f")}set iconPath(I){this.c(),Fe(this,t,"f")!==I&&(Je(this,t,I,"f"),Fe(this,S,"f").$setIconPath(Fe(this,O,"f"),k.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Fe(this,g,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,a,"f")=="number"&&Fe(this,a,"f")<0))return Fe(this,a,"f")}get active(){return this.c(),Fe(this,b,"f")}get visible(){return this.c(),Fe(this,m,"f")}_updateViewState(I){Fe(this,P,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Je(this,b,I.active,"f"),Je(this,m,I.visible,"f"),Je(this,a,I.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(I,r){this.c(),Fe(this,S,"f").$reveal(Fe(this,O,"f"),{viewColumn:typeof I>"u"?void 0:R.ViewColumn.from(I),preserveFocus:!!r})}c(){if(Fe(this,P,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,S=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,b=new WeakMap,P=new WeakMap,p=new WeakMap,i=new WeakMap;class s{static c(){return(0,M.generateUuid)()}constructor(I,r,u){this.g=r,this.h=u,this.e=new Map,this.f=new Map,this.d=I.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,r,u,v,D={}){const y=typeof v=="object"?v.viewColumn:v,W={viewColumn:R.ViewColumn.from(y),preserveFocus:typeof v=="object"&&!!v.preserveFocus},X=(0,A.shouldSerializeBuffersForPostMessage)(I),_=s.c();this.d.$createWebviewPanel((0,A.toExtensionData)(I),_,r,{title:u,panelOptions:c(D),webviewOptions:(0,A.serializeWebviewOptions)(I,this.h,D),serializeBuffersForPostMessage:X},W);const J=this.g.createNewWebview(_,D,I);return this.createNewWebviewPanel(_,r,u,y,D,J,!0)}$onDidChangeWebviewPanelViewStates(I){const r=Object.keys(I);r.sort((u,v)=>{const D=I[u],y=I[v];return D.active?1:y.active?-1:+D.visible-+y.visible});for(const u of r){const v=this.getWebviewPanel(u);if(!v)continue;const D=I[u];v._updateViewState({active:D.active,visible:D.visible,viewColumn:R.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this.e.delete(I),this.g.deleteWebview(I)}registerWebviewPanelSerializer(I,r,u){if(this.f.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.f.set(r,{serializer:u,extension:I}),this.d.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(I)}),new h.Disposable(()=>{this.f.delete(r),this.d.$unregisterSerializer(r)})}async $deserializeWebviewPanel(I,r,u,v){const D=this.f.get(r);if(!D)throw new Error(`No serializer found for '${r}'`);const{serializer:y,extension:W}=D,X=this.g.createNewWebview(I,u.webviewOptions,W),_=this.createNewWebviewPanel(I,r,u.title,v,u.panelOptions,X,u.active);await y.deserializeWebviewPanel(_,u.state)}createNewWebviewPanel(I,r,u,v,D,y,W){const X=new l(I,this.d,y,{viewType:r,title:u,viewColumn:v,panelOptions:D,active:W});return this.e.set(I,X),X}getWebviewPanel(I){return this.e.get(I)}}e.ExtHostWebviewPanels=s;function c(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[244],Re([1,0,5,6,62,8,4,7]),function(ee,e,n,T,k,M,R,A){"use strict";var w,h,O,S,f,E,g,d,t,a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(i,l,s,c,o,I){super(),w.set(this,void 0),h.set(this,void 0),O.set(this,void 0),S.set(this,void 0),f.set(this,!1),E.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,this.D(new n.Emitter)),this.onDidChangeVisibility=Fe(this,a,"f").event,m.set(this,this.D(new n.Emitter)),this.onDidDispose=Fe(this,m,"f").event,Je(this,O,s,"f"),Je(this,g,c,"f"),Je(this,w,i,"f"),Je(this,h,l,"f"),Je(this,S,o,"f"),Je(this,E,I,"f")}dispose(){Fe(this,f,"f")||(Je(this,f,!0,"f"),Fe(this,m,"f").fire(),Fe(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,g,"f")}set title(i){this.a(),Fe(this,g,"f")!==i&&(Je(this,g,i,"f"),Fe(this,h,"f").$setWebviewViewTitle(Fe(this,w,"f"),i))}get description(){return this.a(),Fe(this,d,"f")}set description(i){this.a(),Fe(this,d,"f")!==i&&(Je(this,d,i,"f"),Fe(this,h,"f").$setWebviewViewDescription(Fe(this,w,"f"),i))}get visible(){return Fe(this,E,"f")}get webview(){return Fe(this,S,"f")}get viewType(){return Fe(this,O,"f")}_setVisible(i){i===Fe(this,E,"f")||Fe(this,f,"f")||(Je(this,E,i,"f"),Fe(this,a,"f").fire())}get badge(){return this.a(),Fe(this,t,"f")}set badge(i){this.a(),!(i?.value===Fe(this,t,"f")?.value&&i?.tooltip===Fe(this,t,"f")?.tooltip)&&(Je(this,t,M.ViewBadge.from(i),"f"),Fe(this,h,"f").$setWebviewViewBadge(Fe(this,w,"f"),i))}show(i){this.a(),Fe(this,h,"f").$show(Fe(this,w,"f"),!!i)}a(){if(Fe(this,f,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,h=new WeakMap,O=new WeakMap,S=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap;class P{constructor(i,l){this.d=l,this.b=new Map,this.c=new Map,this.a=i.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,l,s,c){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(i),l,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(i,l,s,c,o){const I=this.b.get(l);if(!I)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:u}=I,v=this.d.createNewWebview(i,{},u),D=new b(i,this.a,l,s,v,!0);this.c.set(i,D),await r.resolveWebviewView(D,{state:c},o)}async $onDidChangeWebviewViewVisibility(i,l){this.e(i)._setVisible(l)}async $disposeWebviewView(i){const l=this.e(i);this.c.delete(i),l.dispose(),this.d.deleteWebview(i)}e(i){const l=this.c.get(i);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=P}),define(Ae[106],Re([1,0,5,4,2,15,12,3,18]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let h=class dn{get state(){return this.d}constructor(S){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=S.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(S){S!==this.d.focused&&(this.d={...this.d,focused:S},this.c.fire(this.d))}openUri(S,f){let E;if(typeof S=="string"){E=S;try{S=k.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,R.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,E,f)}async asExternalUri(S,f){if((0,R.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this.b.$asExternalUri(S,f);return k.URI.from(E)}};h.a={focused:!0},h=je([Ve(0,w.IExtHostRpcService)],h),e.ExtHostWindow=h,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ae[245],Re([1,0,214,27,18]),function(ee,e,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(A,w){super(A,w)}f(A,w,h){w.apply(console,h)}};M=je([Ve(0,k.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ae[246],Re([1,0,17,25,21,14,5,6,129,208,46]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(D,y){try{return JSON.stringify(D,y)}catch{return"null"}}const E="$$ref$$",g={[E]:-1};class d{constructor(y,W){this.jsonString=y,this.referencedBuffers=W}}function t(D,y=null,W=!1){const X=[];return{jsonString:(W?f:JSON.stringify)(D,(J,j)=>{if(typeof j>"u")return g;if(typeof j=="object"){if(j instanceof T.VSBuffer){const U=X.push(j)-1;return{[E]:U}}if(y)return y(J,j)}return j}),referencedBuffers:X}}e.stringifyJsonWithBufferRefs=t;function a(D,y,W){return JSON.parse(D,(X,_)=>{if(_){const J=_[E];if(typeof J=="number")return y[J];if(W&&_.$mid===1)return W.transformIncoming(_)}return _})}e.parseJsonAndRestoreBufferRefs=a;function m(D,y){return JSON.stringify(D,y)}function b(D){return D?(y,W)=>W&&W.$mid===1?D.transformOutgoing(W):W:null}var P;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class c extends A.Disposable{constructor(y,W=null,X=null){super(),this[S]=!0,this.b=this.D(new R.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=y,this.f=W,this.g=X,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let _=0,J=O.ProxyIdentifier.count;_<J;_++)this.k[_]=null,this.l[_]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new n.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(_=>this.G(_))}dispose(){this.j=!0,Object.keys(this.q).forEach(y=>{this.q[y].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(y){this.t===0&&(this.u=Date.now()+c.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(y){this.u=Date.now()+c.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(y){this.s!==y&&(this.s=y,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(y){return this.g?(0,w.transformIncomingURIs)(y,this.g):y}getProxy(y){const{nid:W,sid:X}=y;return this.l[W]||(this.l[W]=this.F(W,X)),this.l[W]}F(y,W){const X={get:(_,J)=>(typeof J=="string"&&!_[J]&&J.charCodeAt(0)===36&&(_[J]=(...j)=>this.O(y,J,j)),J===s?W:_[J])};return new Proxy(Object.create(null),X)}set(y,W){return this.k[y.nid]=W,W}assertRegistered(y){for(let W=0,X=y.length;W<X;W++){const _=y[W];if(!this.k[_.nid])throw new Error(`Missing proxy instance ${_.sid}`)}}G(y){if(this.j)return;const W=y.byteLength,X=o.read(y,0),_=X.readUInt8(),J=X.readUInt32();switch(_){case 1:case 2:{let{rpcId:j,method:U,args:$}=r.deserializeRequestJSONArgs(X);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,j,U,$,_===2);break}case 3:case 4:{let{rpcId:j,method:U,args:$}=r.deserializeRequestMixedArgs(X);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,j,U,$,_===4);break}case 5:{this.f?.logIncoming(W,J,0,"ack"),this.y(J);break}case 6:{this.I(W,J);break}case 7:{this.J(W,J,void 0);break}case 9:{let j=r.deserializeReplyOKJSON(X);this.g&&(j=(0,w.transformIncomingURIs)(j,this.g)),this.J(W,J,j);break}case 10:{const j=r.deserializeReplyOKJSONWithBuffers(X,this.g);this.J(W,J,j);break}case 8:{const j=r.deserializeReplyOKVSBuffer(X);this.J(W,J,j);break}case 11:{let j=r.deserializeReplyErrError(X);this.g&&(j=(0,w.transformIncomingURIs)(j,this.g)),this.L(W,J,j);break}case 12:{this.L(W,J,void 0);break}default:console.error("received unexpected message"),console.error(y)}}H(y,W,X,_,J,j){this.f?.logIncoming(y,W,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(X)}.${_}(`,J);const U=String(W);let $,B;if(j){const he=new k.CancellationTokenSource;J.push(he.token),$=this.M(X,_,J),B=()=>he.cancel()}else $=this.M(X,_,J),B=i;this.p[U]=B;const q=r.serializeAcknowledged(W);this.f?.logOutgoing(q.byteLength,W,1,"ack"),this.c.send(q),$.then(he=>{delete this.p[U];const Ee=r.serializeReplyOK(W,he,this.h);this.f?.logOutgoing(Ee.byteLength,W,1,"reply:",he),this.c.send(Ee)},he=>{delete this.p[U];const Ee=r.serializeReplyErr(W,he);this.f?.logOutgoing(Ee.byteLength,W,1,"replyErr:",he),this.c.send(Ee)})}I(y,W){this.f?.logIncoming(y,W,1,"receiveCancel");const X=String(W);this.p[X]?.()}J(y,W,X){this.f?.logIncoming(y,W,0,"receiveReply:",X);const _=String(W);if(!this.q.hasOwnProperty(_))return;const J=this.q[_];delete this.q[_],J.resolveOk(X)}L(y,W,X){this.f?.logIncoming(y,W,0,"receiveReplyErr:",X);const _=String(W);if(!this.q.hasOwnProperty(_))return;const J=this.q[_];delete this.q[_];let j;X&&(X.$isError?(j=new Error,j.name=X.name,j.message=X.message,j.stack=X.stack):j=X),J.resolveErr(j)}M(y,W,X){try{return Promise.resolve(this.N(y,W,X))}catch(_){return Promise.reject(_)}}N(y,W,X){const _=this.k[y];if(!_)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(y));const J=_[W];if(typeof J!="function")throw new Error("Unknown method "+W+" on actor "+(0,O.getStringIdentifierForProxy)(y));return J.apply(_,X)}O(y,W,X){if(this.j)return new h.CanceledLazyPromise;let _=null;if(X.length>0&&k.CancellationToken.isCancellationToken(X[X.length-1])&&(_=X.pop()),_&&_.isCancellationRequested)return Promise.reject(M.canceled());const J=r.serializeRequestArguments(X,this.h),j=++this.m,U=String(j),$=new h.LazyPromise;_&&_.onCancellationRequested(()=>{const q=r.serializeCancel(j);this.f?.logOutgoing(q.byteLength,j,0,"cancel"),this.c.send(r.serializeCancel(j))}),this.q[U]=$,this.w(j);const B=r.serializeRequest(j,y,W,J,!!_);return this.f?.logOutgoing(B.byteLength,j,0,`request: ${(0,O.getStringIdentifierForProxy)(y)}.${W}(`,X),this.c.send(B),$}}S=l,c.a=3*1e3,e.RPCProtocol=c;class o{static alloc(y,W,X){const _=new o(T.VSBuffer.alloc(X+1+4),0);return _.writeUInt8(y),_.writeUInt32(W),_}static read(y,W){return new o(y,W)}get buffer(){return this.a}constructor(y,W){this.a=y,this.b=W}static sizeUInt8(){return 1}writeUInt8(y){this.a.writeUInt8(y,this.b),this.b+=1}readUInt8(){const y=this.a.readUInt8(this.b);return this.b+=1,y}writeUInt32(y){this.a.writeUInt32BE(y,this.b),this.b+=4}readUInt32(){const y=this.a.readUInt32BE(this.b);return this.b+=4,y}static sizeShortString(y){return 1+y.byteLength}writeShortString(y){this.a.writeUInt8(y.byteLength,this.b),this.b+=1,this.a.set(y,this.b),this.b+=y.byteLength}readShortString(){const y=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+y).toString();return this.b+=y,X}static sizeLongString(y){return 4+y.byteLength}writeLongString(y){this.a.writeUInt32BE(y.byteLength,this.b),this.b+=4,this.a.set(y,this.b),this.b+=y.byteLength}readLongString(){const y=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+y).toString();return this.b+=y,X}writeBuffer(y){this.a.writeUInt32BE(y.byteLength,this.b),this.b+=4,this.a.set(y,this.b),this.b+=y.byteLength}static sizeVSBuffer(y){return 4+y.byteLength}writeVSBuffer(y){this.a.writeUInt32BE(y.byteLength,this.b),this.b+=4,this.a.set(y,this.b),this.b+=y.byteLength}readVSBuffer(){const y=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+y);return this.b+=y,W}static sizeMixedArray(y){let W=0;W+=1;for(let X=0,_=y.length;X<_;X++){const J=y[X];switch(W+=1,J.type){case 1:W+=this.sizeLongString(J.value);break;case 2:W+=this.sizeVSBuffer(J.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(J.value);for(let j=0;j<J.buffers.length;++j)W+=this.sizeVSBuffer(J.buffers[j]);break;case 4:break}}return W}writeMixedArray(y){this.a.writeUInt8(y.length,this.b),this.b+=1;for(let W=0,X=y.length;W<X;W++){const _=y[W];switch(_.type){case 1:this.writeUInt8(1),this.writeLongString(_.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(_.value);break;case 3:this.writeUInt8(3),this.writeUInt32(_.buffers.length),this.writeLongString(_.value);for(let J=0;J<_.buffers.length;++J)this.writeBuffer(_.buffers[J]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const y=this.a.readUInt8(this.b);this.b+=1;const W=new Array(y);for(let X=0;X<y;X++)switch(this.readUInt8()){case 1:W[X]=this.readLongString();break;case 2:W[X]=this.readVSBuffer();break;case 3:{const J=this.readUInt32(),j=this.readLongString(),U=[];for(let $=0;$<J;++$)U.push(this.readVSBuffer());W[X]=new O.SerializableObjectWithBuffers(a(j,U,null));break}case 4:W[X]=void 0;break}return W}}o.sizeUInt32=4;var I;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(I||(I={}));class r{static a(y){for(let W=0,X=y.length;W<X;W++)if(y[W]instanceof T.VSBuffer||y[W]instanceof O.SerializableObjectWithBuffers||typeof y[W]>"u")return!0;return!1}static serializeRequestArguments(y,W){if(this.a(y)){const X=[];for(let _=0,J=y.length;_<J;_++){const j=y[_];if(j instanceof T.VSBuffer)X[_]={type:2,value:j};else if(typeof j>"u")X[_]={type:4};else if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:$}=t(j.value,W);X[_]={type:3,value:T.VSBuffer.fromString(U),buffers:$}}else X[_]={type:1,value:T.VSBuffer.fromString(m(j,W))}}return{type:1,args:X}}return{type:0,args:m(y,W)}}static serializeRequest(y,W,X,_,J){switch(_.type){case 0:return this.b(y,W,X,_.args,J);case 1:return this.c(y,W,X,_.args,J)}}static b(y,W,X,_,J){const j=T.VSBuffer.fromString(X),U=T.VSBuffer.fromString(_);let $=0;$+=o.sizeUInt8(),$+=o.sizeShortString(j),$+=o.sizeLongString(U);const B=o.alloc(J?2:1,y,$);return B.writeUInt8(W),B.writeShortString(j),B.writeLongString(U),B.buffer}static deserializeRequestJSONArgs(y){const W=y.readUInt8(),X=y.readShortString(),_=y.readLongString();return{rpcId:W,method:X,args:JSON.parse(_)}}static c(y,W,X,_,J){const j=T.VSBuffer.fromString(X);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(j),U+=o.sizeMixedArray(_);const $=o.alloc(J?4:3,y,U);return $.writeUInt8(W),$.writeShortString(j),$.writeMixedArray(_),$.buffer}static deserializeRequestMixedArgs(y){const W=y.readUInt8(),X=y.readShortString(),_=y.readMixedArray(),J=new Array(_.length);for(let j=0,U=_.length;j<U;j++){const $=_[j];typeof $=="string"?J[j]=JSON.parse($):J[j]=$}return{rpcId:W,method:X,args:J}}static serializeAcknowledged(y){return o.alloc(5,y,0).buffer}static serializeCancel(y){return o.alloc(6,y,0).buffer}static serializeReplyOK(y,W,X){if(typeof W>"u")return this.d(y);if(W instanceof T.VSBuffer)return this.e(y,W);if(W instanceof O.SerializableObjectWithBuffers){const{jsonString:_,referencedBuffers:J}=t(W.value,X,!0);return this.g(y,_,J)}else return this.f(y,f(W,X))}static d(y){return o.alloc(7,y,0).buffer}static e(y,W){let X=0;X+=o.sizeVSBuffer(W);const _=o.alloc(8,y,X);return _.writeVSBuffer(W),_.buffer}static deserializeReplyOKVSBuffer(y){return y.readVSBuffer()}static f(y,W){const X=T.VSBuffer.fromString(W);let _=0;_+=o.sizeLongString(X);const J=o.alloc(9,y,_);return J.writeLongString(X),J.buffer}static g(y,W,X){const _=T.VSBuffer.fromString(W);let J=0;J+=o.sizeUInt32,J+=o.sizeLongString(_);for(const U of X)J+=o.sizeVSBuffer(U);const j=o.alloc(10,y,J);j.writeUInt32(X.length),j.writeLongString(_);for(const U of X)j.writeBuffer(U);return j.buffer}static deserializeReplyOKJSON(y){const W=y.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(y,W){const X=y.readUInt32(),_=y.readLongString(),J=[];for(let j=0;j<X;++j)J.push(y.readVSBuffer());return new O.SerializableObjectWithBuffers(a(_,J,W))}static serializeReplyErr(y,W){const X=W?f(M.transformErrorForSerialization(W),null):void 0;if(typeof X!="string")return this.h(y);const _=T.VSBuffer.fromString(X);let J=0;J+=o.sizeLongString(_);const j=o.alloc(11,y,J);return j.writeLongString(_),j.buffer}static deserializeReplyErrError(y){const W=y.readLongString();return JSON.parse(W)}static h(y){return o.alloc(12,y,0).buffer}}var u;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var v;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(v||(v={}))}),define(Ae[247],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const R=A=>{globalThis.removeEventListener("message",R);const w=A.data;Object.defineProperties(globalThis,{postMessage:{value(h,O){w.postMessage(h,O)}},onmessage:{get(){return w.onmessage},set(h){w.onmessage=h}}}),w.addEventListener("message",h=>{globalThis.dispatchEvent(new MessageEvent("message",{data:h.data}))}),w.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(M,R,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${n})('${R}'))`,h=new Blob([w],{type:"application/javascript"}),O=URL.createObjectURL(h),S=new MessageChannel,f=O,E={type:"_newWorker",id:f,port:S.port2,url:O,options:A};M(E,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:f}),URL.revokeObjectURL(O),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const d=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(d)}),S.port1.addEventListener("message",g=>{const d=new MessageEvent("message",{data:g.data});this.dispatchEvent(d)}),S.port1.start()}}e.NestedWorker=T}),define(Ae[248],Re([1,0,5,30,31,3]),function(ee,e,n,T,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var R;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(R=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(O=>h.push(O)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}T.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Ae[107],Re([1,0,4,3,18,24,13,248,60,27,37,123,25,9,43,5,6]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends R.AbstractMessageLogger{get disposed(){return this.l}constructor(p,i,l,s,c){super(),this.id=p,this.name=i,this.m=l,this.n=s,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.D(l.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(p,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.n.$close(this.id)}g(p,i){this.k+=f.VSBuffer.fromString(i).byteLength,(0,R.log)(this.m,p,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class m extends a{appendLine(p){this.append(p)}}let b=class{constructor(p,i,l,s,c,o){this.i=i,this.j=l,this.k=s,this.l=c,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[i,l]of this.g)l.visible=i===this.h}createOutputChannel(p,i,l){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,c=(0,E.isString)(i)?i:void 0;if((0,E.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const I=this.i.environment.extensionLogLevel?.find(([u])=>M.ExtensionIdentifier.equals(l.identifier,u))?.[1];I&&(o=(0,R.parseLogLevel)(I));const r=s?this.o(p,o,l):this.n(p,c,l);return r.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),s?this.r(p,o??this.m.getLevel(),r):this.q(p,r)}async n(p,i,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,c=this.k.extUri.joinPath(s,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(p,c,i,l.identifier.value);return new a(I,p,o,this.a,l)}async o(p,i,l){const s=await this.p(l),c=p.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(s,`${c}.log`),I=`${l.identifier.value}.${c}`,r=this.l.createLogger(o,{id:I,name:p,logLevel:i,extensionId:l.identifier.value});return new m(I,p,r,this.a,l)}p(p){let i=this.d.get(p.identifier.value);if(!i){const l=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(l)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}return l})())}return i}q(p,i){let l=!1;const s=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return p},append(c){s(),i.then(o=>o.append(c))},appendLine(c){s(),i.then(o=>o.appendLine(c))},clear(){s(),i.then(c=>c.clear())},replace(c){s(),i.then(o=>o.replace(c))},show(c,o){s(),i.then(I=>I.show(c,o))},hide(){s(),i.then(c=>c.hide())},dispose(){l=!0,i.then(c=>c.dispose())}}}r(p,i,l){const s=new t.DisposableStore,c=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},o=s.add(new d.Emitter);function I(r){i=r,o.fire(r)}return l.then(r=>{s.add(r),r.logLevel!==i&&I(r.logLevel),s.add(r.onDidChangeLogLevel(u=>I(u)))}),{...this.q(p,l),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(r,...u){c(),l.then(v=>v.trace(r,...u))},debug(r,...u){c(),l.then(v=>v.debug(r,...u))},info(r,...u){c(),l.then(v=>v.info(r,...u))},warn(r,...u){c(),l.then(v=>v.warn(r,...u))},error(r,...u){c(),l.then(v=>v.error(r,...u))},dispose(){s.dispose()}}}};b=je([Ve(0,k.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,w.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,R.ILoggerService),Ve(5,R.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ae[249],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ae[250],Re([1,0,41,15,19,20,22,2,3,180,53,196,249]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let E=class hn{constructor(d,t,a,m){this.d=d,this.e=t,this.f=a,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??d})()}hasValidBasename(d,t,a){return typeof t=="string"||typeof t>"u"?this.a.then(m=>this.h(d,m,t)):this.h(d,t,a)}h(d,t,a){return d.scheme===T.Schemas.file||d.scheme===T.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,R.basename)(d),t===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,t){if(d.remoteAuthority)return T.Schemas.vscodeRemote;const a=(0,h.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const m=t.getWorkspace().folders[0];if(m)return m.uri.scheme;const b=t.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let t="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const m=d.indexOf("/",2);m===-1?(t=d.substring(2),d="/"):(t=d.substring(2,m),d=d.substring(m)||"/")}return A.URI.from({scheme:T.Schemas.file,authority:t,path:d,query:"",fragment:""})}};E=je([Ve(1,f.IRemoteAgentService),Ve(2,S.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(Ae[108],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(R,A){this.line=R,this.character=A}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,A){return new n(0,0)}with(R){return new n(0,0)}}e.Position=n;class T{constructor(R,A,w,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(R,A),this.end=new n(w,h)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.Range=T;var k;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ae[47],Re([1,0,16,36,23,41,12,3,19,14,108,17]),function(ee,e,n,T,k,M,R,A,w,h,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",E=" characters skipped \u27EB",g=(f.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var d;(function(ce){ce[ce.file=0]="file",ce[ce.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(ce){ce[ce.File=1]="File",ce[ce.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(ce){return!!ce.preview}e.resultIsMatch=a;function m(ce){return!!ce.resource}e.isFileMatch=m;function b(ce){return!!ce.message}e.isProgressMessage=b;var P;(function(ce){ce[ce.Normal=0]="Normal",ce[ce.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class i{constructor(de,Te,le){this.ranges=Te;const re=Array.isArray(Te)?Te:[Te];if(le&&le.matchLines===1&&l(re)){de=(0,R.getNLines)(de,le.matchLines);let V="",L=0,K=0;const me=Math.floor(le.charsPerLine/5),Ie=[];for(const Se of re){const ve=Math.max(Se.startColumn-me,0),Ce=Se.startColumn+le.charsPerLine;if(ve>K+me+g){const se=f+(ve-K)+E;V+=se+de.slice(ve,Ce),L+=ve-(K+se.length)}else V+=de.slice(K,Ce);Ie.push(new c(0,Se.startColumn-L,Se.endColumn-L)),K=Ce}this.preview={text:V,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const V=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(Te,L=>new s(L.startLineNumber-V,L.startColumn,L.endLineNumber-V,L.endColumn))}}}}e.TextSearchMatch=i;function l(ce){const de=ce[0].startLineNumber;for(const Te of ce)if(Te.startLineNumber!==de||Te.endLineNumber!==de)return!1;return!0}class s{constructor(de,Te,le,re){this.startLineNumber=de,this.startColumn=Te,this.endLineNumber=le,this.endColumn=re}}e.SearchRange=s;class c extends s{constructor(de,Te,le){super(de,Te,de,le)}}e.OneLineRange=c;var o;(function(ce){ce.List="list",ce.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var I;(function(ce){ce.Default="default",ce.FileNames="fileNames",ce.Type="type",ce.Modified="modified",ce.CountDescending="countDescending",ce.CountAscending="countAscending"})(I=e.SearchSortOrder||(e.SearchSortOrder={}));function r(ce,de=!0){const Te=ce&&ce.files&&ce.files.exclude,le=de&&ce&&ce.search&&ce.search.exclude;if(!Te&&!le)return;if(!Te||!le)return Te||le;let re=Object.create(null);return re=k.mixin(re,k.deepClone(Te)),re=k.mixin(re,k.deepClone(le),!0),re}e.getExcludes=r;function u(ce,de){return ce.excludePattern&&T.match(ce.excludePattern,de)?!1:ce.includePattern||ce.usingSearchPaths?ce.includePattern&&T.match(ce.includePattern,de)?!0:ce.usingSearchPaths?!!ce.folderQueries&&ce.folderQueries.some(Te=>{const le=Te.folder.fsPath;if(M.isEqualOrParent(de,le)){const re=w.relative(le,de);return!Te.includePattern||!!T.match(Te.includePattern,re)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var v;(function(ce){ce[ce.unknownEncoding=1]="unknownEncoding",ce[ce.regexParseError=2]="regexParseError",ce[ce.globParseError=3]="globParseError",ce[ce.invalidLiteral=4]="invalidLiteral",ce[ce.rgProcessError=5]="rgProcessError",ce[ce.other=6]="other",ce[ce.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(de,Te){super(de),this.code=Te}}e.SearchError=D;function y(ce){const de=ce.message;if((0,h.isCancellationError)(ce))return new D(de,v.canceled);try{const Te=JSON.parse(de);return new D(Te.message,Te.code)}catch{return new D(de,v.other)}}e.deserializeSearchError=y;function W(ce){const de={message:ce.message,code:ce.code};return new Error(JSON.stringify(de))}e.serializeSearchError=W;function X(ce){return ce.type==="error"?!0:ce.type==="success"}e.isSerializedSearchComplete=X;function _(ce){return ce.type==="success"}e.isSerializedSearchSuccess=_;function J(ce){return!!ce.path}e.isSerializedFileMatch=J;function j(ce,de){const Te=ce.searchPath?ce.searchPath:ce.relativePath;return(0,R.fuzzyContains)(Te,de)}e.isFilePatternMatch=j;class U{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function $(ce,de){const Te={...ce||{},...de||{}};return Object.keys(Te).filter(le=>{const re=Te[le];return typeof re=="boolean"&&re})}e.resolvePatternsForProvider=$;class B{constructor(de,Te){this.c=null,this.a={...de.excludePattern||{},...Te.excludePattern||{}},this.b=T.parse(this.a);let le=de.includePattern;Te.includePattern&&(le?le={...le,...Te.includePattern}:le=Te.includePattern),le&&(this.c=T.parse(le))}matchesExcludesSync(de,Te,le){return!!(this.b&&this.b(de,Te,le))}includedInQuerySync(de,Te,le){return!(this.b&&this.b(de,Te,le)||this.c&&!this.c(de,Te,le))}includedInQuery(de,Te,le){const re=this.b(de,Te,le),V=()=>this.c?!!this.c(de,Te,le):!0;return(0,S.isThenable)(re)?re.then(L=>L?!1:V()):V()}hasSiblingExcludeClauses(){return q(this.a)}}e.QueryGlobTester=B;function q(ce){for(const de in ce)if(typeof ce[de]!="boolean")return!0;return!1}function he(ce){if(!ce)return;let de;return Te=>(de||(de=(ce()||Promise.resolve([])).then(le=>le?ie(le):{})),de.then(le=>!!le[Te]))}e.hasSiblingPromiseFn=he;function Ee(ce){if(!ce)return;let de;return Te=>{if(!de){const le=ce();de=le?ie(le):{}}return!!de[Te]}}e.hasSiblingFn=Ee;function ie(ce){const de={};for(const Te of ce)de[Te]=!0;return de}}),define(Ae[32],Re([1,0,16,17,21,5,6,48,15,115,22,12,9,2,151,3,13,168,53,37,27,18,8,7,55,47,4]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i,l,s,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(_,J,j){return new O.ExtUri(U=>D(U,j)).isEqual(_,J)}function r(_,J,j){return I(_.uri,J.uri,j)?0:(0,S.compare)(_.uri.toString(),J.uri.toString())}function u(_,J,j){return _.index!==J.index?_.index<J.index?-1:1:I(_.uri,J.uri,j)?(0,S.compare)(_.name,J.name):(0,S.compare)(_.uri.toString(),J.uri.toString())}function v(_,J,j,U){const $=_.slice(0).sort((q,he)=>j(q,he,U)),B=J.slice(0).sort((q,he)=>j(q,he,U));return(0,n.delta)($,B,(q,he)=>j(q,he,U))}function D(_,J){const j=J.getCapabilities(_.scheme);return!(j&&j&1024)}class y extends m.Workspace{static toExtHostWorkspace(J,j,U,$){if(!J)return{workspace:null,added:[],removed:[]};const{id:B,name:q,folders:he,configuration:Ee,transient:ie,isUntitled:ce}=J,de=[],Te=j;j?he.forEach((L,K)=>{const me=E.URI.revive(L.uri),Ie=y.o(U||j,me,$);Ie?(Ie.name=L.name,Ie.index=L.index,de.push(Ie)):de.push({uri:me,name:L.name,index:K})}):de.push(...he.map(({uri:L,name:K,index:me})=>({uri:E.URI.revive(L),name:K,index:me}))),de.sort((L,K)=>L.index<K.index?-1:1);const le=new y(B,q,de,!!ie,Ee?E.URI.revive(Ee):null,!!ce,L=>D(L,$)),{added:re,removed:V}=v(Te?Te.workspaceFolders:[],le.workspaceFolders,r,$);return{workspace:le,added:re,removed:V}}static o(J,j,U){for(let $=0;$<J.folders.length;$++){const B=J.workspaceFolders[$];if(I(B.uri,j,U))return B}}constructor(J,j,U,$,B,q,he){super(J,U.map(Ee=>new m.WorkspaceFolder(Ee)),$,B,he),this.t=j,this.u=q,this.q=[],this.s=A.TernarySearchTree.forUris(he),U.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,j){return j&&this.s.get(J)&&(J=(0,O.dirname)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let W=class{constructor(J,j,U,$,B){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=$,this.s=U,this.t=B,this.j=new h.Counter,this.k=new T.Barrier,this.o=J.getProxy(o.MainContext.MainThreadWorkspace),this.q=J.getProxy(o.MainContext.MainThreadMessageService);const q=j.workspace;this.l=q?new y(q.id,q.name,[],!!q.transient,q.configuration?E.URI.revive(q.configuration):null,!!q.isUntitled,he=>D(he,U)):void 0}$initializeWorkspace(J,j){this.v=j,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?E.URI.from({scheme:w.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,j,U,...$){const B=[];if(Array.isArray($)&&$.forEach(ce=>{E.URI.isUri(ce.uri)&&!B.some(de=>I(de.uri,ce.uri,this.s))&&B.push({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri)})}),this.n||[j,U].some(ce=>typeof ce!="number"||ce<0)||U===0&&B.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(j+U>q.length)return!1;const he=q.slice(0);he.splice(j,U,...B.map(ce=>({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<he.length;ce++){const de=he[ce];if(he.some((Te,le)=>le!==ce&&I(de.uri,Te.uri,this.s)))return!1}he.forEach((ce,de)=>ce.index=de);const{added:Ee,removed:ie}=v(q,he,u,this.s);if(Ee.length===0&&ie.length===0)return!1;if(this.o){const ce=J.displayName||J.name;this.o.$updateWorkspaceFolders(ce,j,U,B).then(void 0,de=>{this.n=void 0;const Te={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(a.Severity.Error,(0,g.localize)(0,null,ce,de.toString()),Te,[])})}return this.y(he),!0}getWorkspaceFolder(J,j){if(!!this.x)return this.x.getWorkspaceFolder(J,j)}async getWorkspaceFolder2(J,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,j)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,j){let U,$="";if(typeof J=="string"?(U=E.URI.file(J),$=J):typeof J<"u"&&(U=J,$=J.fsPath),!U)return $;const B=this.getWorkspaceFolder(U,!0);if(!B)return $;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let q=(0,O.relativePath)(B.uri,U);return j&&B.name&&(q=`${B.name}/${q}`),q}y(J){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:j,added:U,removed:$}=y.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:$}))}findFiles(J,j,U,$,B=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let q;if(j===null?q=!1:j&&(typeof j=="string"?q=j:q=j.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:Ee}=X(i.GlobPattern.from(J));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(he),(0,f.withUndefinedAsNull)(Ee),(0,f.withUndefinedAsNull)(q),(0,f.withUndefinedAsNull)(U),B).then(ie=>Array.isArray(ie)?ie.map(ce=>E.URI.revive(ce)):[])}async findTextInFiles(J,j,U,$,B=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),he=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:ie}=X(i.GlobPattern.from(j.include)),ce=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,de={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:he,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:ce},Te=!1;if(this.u[q]=le=>{if(Te)return;const re=E.URI.revive(le.resource);le.results.forEach(V=>{(0,c.resultIsMatch)(V)?U({uri:re,preview:{text:V.preview.text,matches:(0,n.mapArrayOrNot)(V.preview.matches,L=>new l.Range(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))},ranges:(0,n.mapArrayOrNot)(V.ranges,L=>new l.Range(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))}):U({uri:re,text:V.text,lineNumber:V.lineNumber})})},B.isCancellationRequested)return{};try{const le=await this.o.$startTextSearch(J,(0,f.withUndefinedAsNull)(ie),de,q,B);return delete this.u[q],le||{}}catch(le){throw delete this.u[q],le}}$handleTextSearchResult(J,j){this.u[j]?.(J)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,j){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,j);const U=this.t.transformOutgoingScheme(J),$=this.z++;return this.o.$registerEditSessionIdentityProvider($,U),(0,R.toDisposable)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(J,j){this.h.info("Getting edit session identifier for workspaceFolder",J);const U=await this.resolveWorkspaceFolder(E.URI.revive(J));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const $=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!$),!$)return;const B=await $.provideEditSessionIdentity(U,j);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(J,j,U,$){this.h.info("Getting edit session identifier for workspaceFolder",J);const B=await this.resolveWorkspaceFolder(E.URI.revive(J));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const q=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!q),!q)return;const he=await q.provideEditSessionIdentityMatch?.(j,U,$);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(J){return(j,U,$)=>{const B=function(he){j.call(U,he)};return B.extension=J,this.A.event(B,void 0,$)}}async $onWillCreateEditSessionIdentity(J,j,U){const $=await this.resolveWorkspaceFolder(E.URI.revive(J));if($===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:$},j,async(B,q)=>{const he=Date.now();await Promise.resolve(B),Date.now()-he>U&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),j.isCancellationRequested}};W=je([Ve(0,p.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,b.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,s.IURITransformerService)],W),e.ExtHostWorkspace=W,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function X(_){let J,j;return _&&(typeof _=="string"?J=_:(J=_.pattern,j=E.URI.revive(_.baseUri))),{includePattern:J,folder:j}}}),define(Ae[33],Re([1,0,23,5,32,4,7,171,94,9,17,3,18,13,2]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(l,s){if(s){const c=s.split(".");let o=l;for(let I=0;o&&I<c.length;I++)o=o[c[I]];return o}}function t(l){return l instanceof g.URI}function a(l){return l&&l.uri instanceof g.URI&&l.languageId&&typeof l.languageId=="string"}function m(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function b(l){return l&&l.uri instanceof g.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function P(l){if(t(l))return{resource:l};if(a(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(m(l))return{overrideIdentifier:l.languageId};if(b(l))return{resource:l.uri};if(l===null)return{resource:null}}let p=class{constructor(s,c,o){this.a=s.getProxy(M.MainContext.MainThreadConfiguration),this.c=c,this.b=o,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,c){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,c))}};p=je([Ve(0,f.IExtHostRpcService),Ve(1,k.IExtHostWorkspace),Ve(2,E.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(s,c,o,I){this.a=new T.Emitter,this.b=s,this.f=I,this.c=c,this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,c){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(c,o))}getConfiguration(s,c,o){const I=P(c)||{},r=this.g(s?d(this.e.getValue(void 0,I,this.c.workspace),s):this.e.getValue(void 0,I,this.c.workspace));s&&this.h(s,I,o?.identifier);function u(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(D){return typeof d(r,D)<"u"},get:(D,y)=>{this.h(s?`${s}.${D}`:D,I,o?.identifier);let W=d(r,D);if(typeof W>"u")W=y;else{let X;const _=(J,j)=>{let U;const $=()=>{X=X||(0,n.deepClone)(r),U=U||d(X,j)};return(0,h.isObject)(J)?new Proxy(J,{get:(B,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return $(),()=>U;if(X)return U=U||d(X,j),U[q];const he=B[q];return typeof q=="string"?_(he,`${j}.${q}`):he},set:(B,q,he)=>($(),U&&(U[q]=he),!0),deleteProperty:(B,q)=>($(),U&&delete U[q],!0),defineProperty:(B,q,he)=>($(),U&&Object.defineProperty(U,q,he),!0)}):J};W=_(W,D)}return W},update:(D,y,W,X)=>{D=s?`${s}.${D}`:D;const _=u(W);return y!==void 0?this.b.$updateConfigurationOption(_,D,y,I,X):this.b.$removeConfigurationOption(_,D,I,X)},inspect:D=>{D=s?`${s}.${D}`:D;const y=this.e.inspect(D,I,this.c.workspace);if(y)return{key:D,defaultValue:(0,n.deepClone)(y.policy?.value??y.default?.value),globalValue:(0,n.deepClone)(y.user?.value??y.application?.value),workspaceValue:(0,n.deepClone)(y.workspace?.value),workspaceFolderValue:(0,n.deepClone)(y.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(y.default?.override),globalLanguageValue:(0,n.deepClone)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,n.deepClone)(y.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(y.workspaceFolder?.override),languageIds:(0,n.deepClone)(y.overrideIdentifiers)}}};return typeof r=="object"&&(0,n.mixin)(v,r,!1),Object.freeze(v)}g(s){const c=o=>(0,h.isObject)(o)?new Proxy(o,{get:(I,r)=>c(I[r]),set:(I,r,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(I,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(I,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return c(s)}h(s,c,o){const I=w.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),r=o?`[${o.value}] `:"";if(I===4){typeof c?.resource>"u"&&this.f.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){c?.resource&&this.f.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,c){const o=new A.ConfigurationChangeEvent(s,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(I,r)=>o.affectsConfiguration(I,P(r))})}k(s){return s.reduce((c,o)=>(c.set(o[0],o[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[109],Re([1,0,2,17,5,4,7,32,58,33,21,61,18,27,3,15,20,13,77,207,14]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(i||(i={}));var l;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(l||(l={}));var s;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(s||(s={}));var c;(function(J){function j(B){if(B){const q=B;return q&&!!q.process}else return!1}J.is=j;function U(B){if(B==null)return;const q={process:B.process,args:B.args};return B.options&&(q.options=s.from(B.options)),q}J.from=U;function $(B){if(B!=null)return new R.ProcessExecution(B.process,B.args,B.options)}J.to=$})(c||(c={}));var o;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(o||(o={}));var I;(function(J){function j(B){if(B){const q=B;return q&&(!!q.commandLine||!!q.command)}else return!1}J.is=j;function U(B){if(B==null)return;const q={};return B.commandLine!==void 0?q.commandLine=B.commandLine:(q.command=B.command,q.args=B.args),B.options&&(q.options=o.from(B.options)),q}J.from=U;function $(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.ShellExecution(B.commandLine,B.options):new R.ShellExecution(B.command,B.args?B.args:[],B.options)}J.to=$})(I||(I={}));var r;(function(J){function j(B){if(B){const q=B;return q&&q.customExecution==="customExecution"}else return!1}J.is=j;function U(B){return{customExecution:"customExecution"}}J.from=U;function $(B,q){return q.get(B)}J.to=$})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(J){function j(U,$){let B;return U.scope!==void 0&&typeof U.scope!="number"?B=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&$&&$.workspaceFile?B=$.workspaceFile:B=b.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:B}}J.from=j})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(J){function j(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=j})(v||(v={}));var D;(function(J){function j(B,q){if(B==null)return[];const he=[];for(const Ee of B){const ie=U(Ee,q);ie&&he.push(ie)}return he}J.fromMany=j;function U(B,q){if(B==null)return;let he;B.execution instanceof R.ProcessExecution?he=c.from(B.execution):B.execution instanceof R.ShellExecution?he=I.from(B.execution):B.execution&&B.execution instanceof R.CustomExecution&&(he=r.from(B.execution));const Ee=i.from(B.definition);let ie;return B.scope?typeof B.scope=="number"?ie=B.scope:ie=B.scope.uri:ie=R.TaskScope.Workspace,!Ee||!ie?void 0:{_id:B._id,definition:Ee,name:B.name,source:{extensionId:q.identifier.value,label:B.source,scope:ie},execution:he,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:l.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}J.from=U;async function $(B,q,he){if(B==null)return;let Ee;c.is(B.execution)?Ee=c.to(B.execution):I.is(B.execution)?Ee=I.to(B.execution):r.is(B.execution)&&(Ee=r.to(B._id,he));const ie=i.to(B.definition);let ce;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ce=B.source.scope:ce=await q.resolveWorkspaceFolder(n.URI.revive(B.source.scope)):ce=R.TaskScope.Workspace),!ie||!ce)return;const de=new R.Task(ie,ce,B.name,B.source.label,Ee,B.problemMatchers);return B.isBackground!==void 0&&(de.isBackground=B.isBackground),B.group!==void 0&&(de.group=R.TaskGroup.from(B.group._id),de.group&&B.group.isDefault&&(de.group=new R.TaskGroup(de.group.id,de.group.label),B.group.isDefault===!0&&(de.group.isDefault=B.group.isDefault))),B.presentationOptions&&(de.presentationOptions=l.to(B.presentationOptions)),B._id&&(de._id=B._id),B.detail&&(de.detail=B.detail),de}J.to=$})(D=e.TaskDTO||(e.TaskDTO={}));var y;(function(J){function j($){return $}J.from=j;function U($){if(!!$)return Object.assign(Object.create(null),$)}J.to=U})(y||(y={}));class W{constructor(j,U,$){this._id=U,this.a=$,p.set(this,void 0),Je(this,p,j,"f")}get task(){return this.a}terminate(){Fe(this,p,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}p=new WeakMap;let X=class{constructor(j,U,$,B,q,he,Ee,ie){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=j.getProxy(M.MainContext.MainThreadTask),this.b=$,this.c=B,this.d=q,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,U,$){if(!$)return new R.Disposable(()=>{});const B=this.w();return this.j.set(B,{type:U,provider:$,extension:j}),this.a.$registerTaskProvider(B,U),new R.Disposable(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(j,U){this.a.$registerTaskSystem(j,U)}fetchTasks(j){return this.a.$fetchTasks(y.from(j)).then(async U=>{const $=[];for(const B of U){const q=await D.to(B,this.b,this.m);q&&$.push(q)}return $})}get taskExecutions(){const j=[];return this.k.forEach(U=>j.push(U)),j}terminateTask(j){if(!(j instanceof W))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,U,$){const B=this.m.get(j.id);B&&(this.o.set(j.id,B),this.e.attachPtyToTerminal(U,await B.callback($))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const U=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const U=await this.y(j.id);this.s.fire({execution:U,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const U=await this.y(j.id);this.t.fire({execution:U,exitCode:j.exitCode})}$provideTasks(j,U){const $=this.j.get(j);if(!$)return Promise.reject(new Error("no handler found"));const B=[],q=(0,T.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(he=>this.u(U,B,$,he));return new Promise(he=>{q.then(Ee=>{Promise.all(B).then(()=>{he(Ee)})})})}async $resolveTask(j,U){const $=this.j.get(j);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const B=await D.to(U,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const q=await $.provider.resolveTask(B,O.CancellationToken.None);if(!q)return;this.z(q,$);const he=D.from(q,$.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(he.execution)&&await this.x(he,q,!0),await this.v(he)}w(){return this.h++}async x(j,U,$){const B=await this.a.$createTaskId(j);!$&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,U.execution)),this.m.set(B,U.execution)}async y(j,U){if(typeof j=="string"){const q=this.l.get(j);if(!q)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return q}const $=this.l.get(j.id);if($)return $;const B=new Promise((q,he)=>{function Ee(ie,ce,de){de?q(new W(ie,ce.id,de)):he("Unexpected: Task does not exist.")}U?Ee(this,j,U):D.to(j.task,this.b,this.m).then(ie=>Ee(this,j,ie))});return this.l.set(j.id,B),B.then(q=>(this.k.set(j.id,q),q),q=>Promise.reject(q))}z(j,U){j._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const $=this.n.values();let B=$.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=$.next()}};X=je([Ve(0,f.IExtHostRpcService),Ve(1,E.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,S.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],X),e.ExtHostTaskBase=X;let _=class extends X{constructor(j,U,$,B,q,he,Ee,ie){super(j,U,$,B,q,he,Ee,ie),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(j,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=D.from(U,j);if($===void 0)throw new Error("Task is not valid");if(r.is($.execution))await this.x($,U,!1);else throw new P.NotSupportedError;const B=await this.y(await this.a.$getTaskExecution($),U);return this.a.$executeTask($).catch(q=>{throw new Error(q)}),B}u(j,U,$,B){const q=[];if(B)for(const he of B){this.z(he,$),(!he.definition||!j[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=D.from(he,$.extension);Ee&&r.is(Ee.execution)?(q.push(Ee),U.push(this.x(Ee,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:$.extension}}async v(j){if(r.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,U,$){}};_=je([Ve(0,f.IExtHostRpcService),Ve(1,E.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,S.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],_),e.WorkerExtHostTask=_,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ae[251],Re([1,0,19,21,40,36,22,78,47]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class h{constructor(f,E,g){this.k=f,this.l=E,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&M.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&M.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const E=this.k.folderQueries||[];return new Promise((g,d)=>{const t=a=>{this.f++,f(a)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const m=a.toString(),b=n.basename(m);this.j&&this.j(m,b)||this.v(t,{base:a,basename:b})}),Promise.all(E.map(a=>this.p(a,t))).then(a=>{g({limitHit:this.e,stats:a[0]||void 0})},a=>{d(new Error((0,k.toErrorMessage)(a)))})})}async p(f,E){const g=new T.CancellationTokenSource,d=this.q(f),t=this.r(),a=new w.QueryGlobTester(this.k,f),m=!a.hasSiblingExcludeClauses();let b;try{this.h.add(g),b=A.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,g.token),p=b.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(l=>{const s=n.posix.relative(f.folder.path,l.path);if(m){const c=n.basename(l.path);this.v(E,{base:f.folder,relativePath:s,basename:c});return}this.s(t,f.folder,s,E)}),this.g&&!this.e)?null:(this.u(t,a,E),{providerTime:p,postProcessTime:i.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(f){const E=(0,w.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),g=(0,w.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:g,includes:E,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},E,g,d){if(g===this.a){const a=n.basename(this.a);this.v(d,{base:E,relativePath:this.a,basename:a})}function t(a){const m=n.basename(a),b=n.dirname(a);let P=f[b];P||(P=f[b]=[],t(b)),P.push({base:E,relativePath:a,basename:m})}t(g)}u({rootEntries:f,pathToEntries:E},g,d){const t=this,a=this.a;function m(b){const P=(0,w.hasSiblingFn)(()=>b.map(p=>p.basename));for(let p=0,i=b.length;p<i;p++){const l=b[p],{relativePath:s,basename:c}=l;if(g.matchesExcludesSync(s,c,a!==c?P:void 0))continue;const o=E[s];if(o)m(o);else{if(s===a)continue;t.v(d,l)}if(t.e)break}}m(f)}v(f,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(E))}}class O{constructor(){this.b=new Map}fileSearch(f,E,g,d){const t=this.c(f.cacheKey),a=new h(f,E,t&&t.token);let m=0;const b=P=>{m+=P.length,g(P.map(p=>this.d(p)))};return this.e(a,O.a,b,d).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:P.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new T.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:R.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,E,g,d){d.onCancellationRequested(()=>{f.cancel()});const t=m=>{m&&(a.push(m),E>0&&a.length>=E&&(g(a),a=[]))};let a=[];return f.search(t).then(m=>(a.length&&g(a),m),m=>(a.length&&g(a),Promise.reject(m)))}}O.a=512,e.FileSearchManager=O}),define(Ae[252],Re([1,0,16,63,36,88,28,15,19,22,12,9,2,268,160,42,13,53,99,250,47]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(D,y,W,X,_){this.a=D,this.b=y,this.c=W,this.d=X,this.e=_}text(D,y,W={}){D=this.f(D,W);const X=this.a.getValue(),_=y&&y.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(y?.map(a.toWorkspaceFolder),W),type:2,contentPattern:D,previewOptions:W.previewOptions,maxFileSize:W.maxFileSize,usePCRE2:X.search.usePCRE2||_||!1,beforeContext:W.beforeContext,afterContext:W.afterContext,userDisabledExcludesAndIgnoreFiles:W.disregardExcludeSettings&&W.disregardIgnoreFiles}}f(D,y){const W=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const X={...D,wordSeparators:W.editor.wordSeparators};return this.j(D,y)&&(X.isCaseSensitive=!0),this.k(D)&&(X.isMultiline=!0),X}file(D,y={}){return{...this.h(D,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(D,y){return D?(D=Array.isArray(D)?D.map(o):o(D),y?this.parseSearchPaths(D):{pattern:l(...Array.isArray(D)?D:[D])}):{}}h(D=[],y={}){const W=this.g(y.includePattern,y.expandPatterns),X=this.g(y.excludePattern,y.expandPatterns),_=D.length>1,J=(W.searchPaths&&W.searchPaths.length?W.searchPaths.map($=>this.q($,y,X)):D.map($=>this.r($,y,X,_))).filter($=>!!$),j={_reason:y._reason,folderQueries:J,usingSearchPaths:!!(W.searchPaths&&W.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:X.pattern,includePattern:W.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const $=n.coalesce(n.flatten(this.c.groups.map(he=>he.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const B=$.filter(he=>(0,P.pathIncludedInQuery)(j,he.fsPath)),q=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const U=y.extraFileResources&&y.extraFileResources.filter($=>(0,P.pathIncludedInQuery)(j,$.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(D){const y=[],W=new R.ResourceMap,X={};let _=!1;return D.forEach(J=>{if(J.scheme===A.Schemas.walkThrough)return;if((0,h.isAbsolutePath)(J)){const U=this.b.getWorkspaceFolder(J)?.uri??J.with({path:w.dirname(J.fsPath)});let $=W.get(U);$||(_=!0,$={folder:U,includePattern:{}},y.push($),W.set(U,$));const B=w.relative(U.fsPath,J.fsPath);(0,S.assertIsDefined)($.includePattern)[B.replace(/\\/g,"/")]=!0}else J.fsPath&&(_=!0,X[J.fsPath]=!0)}),{folderQueries:y,includePattern:X,usingSearchPaths:!0,excludePattern:_?void 0:{"**/*":!0}}}j(D,y){if(y.isSmartCase){if(D.isRegExp){if(O.containsUppercaseCharacter(D.pattern,!0))return!0}else if(O.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,E.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const y=q=>w.isAbsolute(q)||/^\.\.?([\/\\]|$)/.test(q),X=(Array.isArray(D)?D:s(D)).map(q=>{const he=this.e.resolvedUserHome;return he?(0,M.untildify)(q,he.scheme===A.Schemas.file?he.fsPath:he.path):q}),_=T.groupBy(X,q=>y(q)?"searchPaths":"exprSegments"),J=(_.exprSegments||[]).map(q=>O.rtrim(q,"/")).map(q=>O.rtrim(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),c(q))),j={},U=this.m(_.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const $=n.flatten(J),B=l(...$);return B&&(j.pattern=B),j}l(D,y){return y.disregardExcludeSettings?void 0:(0,P.getExcludes)(D,!y.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const y=D.flatMap(X=>{let{pathPortion:_,globPortion:J}=i(X);return J&&(J=I(J)),this.n(_).flatMap(U=>this.o(U,J))}),W=new Map;return y.forEach(X=>{const _=X.searchPath.toString(),J=W.get(_);J?X.pattern&&(J.pattern=J.pattern||{},J.pattern[X.pattern]=!0):W.set(_,{searchPath:X.searchPath,pattern:X.pattern?l(X.pattern):void 0})}),Array.from(W.values())}n(D){if(w.isAbsolute(D)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==A.Schemas.file?[{searchPath:y[0].uri.with({path:D})}]:[{searchPath:f.URI.file(w.normalize(D))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(D=o(D),D.startsWith("../")||D===".."){const X=w.posix.resolve(y.path,D);return[{searchPath:y.with({path:X})}]}const W=I(D);return[{searchPath:y,pattern:W}]}else{if(D==="./"||D===".\\")return[];{const y=D.replace(/^\.[\/\\]/,""),X=this.b.getWorkspace().folders.map(_=>{const J=y.match(new RegExp(`^${O.escapeRegExpCharacters(_.name)}(?:/(.*)|$)`));return J?{match:J,folder:_}:null}).filter(S.isDefined);if(X.length)return X.map(_=>{const J=_.match[1];return{searchPath:_.folder.uri,pattern:J&&I(J)}});{const _=D.match(/\.[\/\\](.+)[\/\\]?/),J=_?_[1]:D,j=g.localize(0,null,J);throw new Error(j)}}}}o(D,y){const W=D.pattern&&y?`${D.pattern}/${y}`:D.pattern||y,X=[{searchPath:D.searchPath,pattern:W}];return W&&!W.endsWith("**")&&X.push({searchPath:D.searchPath,pattern:W+"/**"}),X}q(D,y,W){const X=this.r((0,a.toWorkspaceFolder)(D.searchPath),y,W,!1);return X?{...X,includePattern:D.pattern}:null}r(D,y,W,X){let _;const J=f.URI.isUri(D)?D:D.uri;if(W.searchPaths){const q=W.searchPaths.filter(he=>(0,h.isEqual)(he.searchPath,J))[0];if(q&&!q.pattern)return null;q&&(_=q.pattern)}const j=this.a.getValue({resource:J}),$={...this.l(j,y)||{},..._||{}},B=f.URI.isUri(D)?(0,h.basename)(D):D.name;return{folder:J,folderName:X?B:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!j.search.followSymlinks}}};p=je([Ve(0,d.IConfigurationService),Ve(1,a.IWorkspaceContextService),Ve(2,m.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,b.IPathService)],p),e.QueryBuilder=p;function i(v){const D=v.match(/[\*\{\}\(\)\[\]\?]/);if(D){const y=D.index,W=v.substr(0,y).match(/[/|\\][^/\\]*$/);if(W){let X=v.substr(0,W.index);return X.match(/[/\\]/)||(X+="/"),{pathPortion:X,globPortion:v.substr((W.index||0)+1)}}}return{pathPortion:v}}function l(...v){return v.length?v.reduce((D,y)=>(D[y]=!0,D),Object.create(null)):void 0}function s(v){return k.splitGlobAware(v,",").map(D=>D.trim()).filter(D=>!!D.length)}function c(v){return[`**/${v}/**`,`**/${v}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function I(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(v){return v.replace(/([?*[\]])/g,"[$1]")}function u(v,D){v=n.distinct(v,X=>X.toString());const y=[],W=D.getWorkspace();return v&&v.forEach(X=>{let _;if(D.getWorkbenchState()===2)_=(0,h.relativePath)(W.folders[0].uri,X),_&&_!=="."&&(_="./"+_);else{const J=D.getWorkspaceFolder(X);if(J){const j=J.name;if(W.folders.filter($=>$.name===j).length===1){const $=(0,h.relativePath)(J.uri,X);$===""?_=`./${J.name}`:_=`./${J.name}/${$}`}else _=X.fsPath}}_&&y.push(r(_))}),y}e.resolveResourcesForSearchIncludes=u}),define(Ae[253],Re([1,0,22,2,21,14,3,252,47,53]),function(ee,e,n,T,k,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function S(d,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const m=[],b=[];for(const c of a)if(/^workspaceContains:/.test(c)){const o=c.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||d.forceUsingSearch?b.push(o):m.push(o)}if(m.length===0&&b.length===0)return Promise.resolve(void 0);let P;const p=new Promise((c,o)=>{P=c}),i=c=>P({activationEvent:c}),l=Promise.all(m.map(c=>f(d,c,i))).then(()=>{}),s=E(d,t.identifier,b,i);return Promise.all([l,s]).then(()=>{P(void 0)}),p}e.checkActivateWorkspaceContainsExtension=S;async function f(d,t,a){for(const m of d.folders)if(await d.exists(n.joinPath(T.URI.revive(m),t))){a(`workspaceContains:${t}`);return}}async function E(d,t,a,m){if(a.length===0)return Promise.resolve(void 0);const b=new k.CancellationTokenSource,P=d.checkExists(d.folders,a,b.token),p=setTimeout(async()=>{b.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},O);let i=!1;try{i=await P}catch(l){M.isCancellationError(l)||M.onUnexpectedError(l)}b.dispose(),clearTimeout(p),i&&m(`workspaceContains:${a.join(",")}`)}function g(d,t,a,m){const b=d.get(R.IInstantiationService),P=d.get(w.ISearchService),i=b.createInstance(A.QueryBuilder).file(t.map(l=>(0,h.toWorkspaceFolder)(T.URI.revive(l))),{_reason:"checkExists",includePattern:a,exists:!0});return P.fileSearch(i,m).then(l=>!!l.limitHit,l=>M.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=g});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,k){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ae[34],Re([1,0,144,19,83,22,17,6,48,2,13,4,33,197,81,32,26,100,14,24,25,182,7,95,3,27,82,18,69,71,61,5,253,80,184,15,79,78,20]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i,l,s,c,o,I,r,u,v,D,y,W,X,_,J,j,U){"use strict";var $,B,q;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let he=class fn extends A.Disposable{constructor(V,L,K,me,Ie,Se,ve,Ce,se,ae,Z){super(),this.a=this.D(new D.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=L,this.g=K,this.f=ve,this.j=me,this.k=Ie,this.l=Se,this.m=se,this.p=ae,this.q=Z,this.s=this.g.getProxy(S.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(S.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(S.MainContext.MainThreadExtensionService),this.v=new R.Barrier,this.w=new R.Barrier,this.y=new R.Barrier,this.z=new R.Barrier,this.C=new le(this.f.activationEvents),this.G=new a.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const C=new b.ExtensionIdentifierSet(this.f.myExtensions);this.F=new a.ExtensionDescriptionRegistry(this.C,de(this.G,C)),this.H=new g.ExtHostStorage(this.g,this.l),this.I=new W.ExtHostSecretState(this.g),this.J=Ce,this.h=V.createChild(new r.ServiceCollection([g.IExtHostStorage,this.H],[W.IExtHostSecretState,this.I])),this.L=this.D(new E.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(N,H,x)=>{this.u.$onExtensionActivationError(N,m.transformErrorForSerialization(H),x)},actualActivateExtension:async(N,H)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(N,this.F,this.G))return await this.u.$activateExtension(N,H),new E.HostExtension;const x=this.F.getExtensionDescription(N);return this.Z(x,H)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.ob(),this.v.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.mb()}catch(V){m.onUnexpectedError(V)}}async R(){this.J.onWillDeactivateAll();let V=[];try{V=this.F.getAllExtensionDescriptions().map(Ie=>Ie.identifier).filter(Ie=>this.isActivated(Ie)).map(Ie=>this.Y(Ie))}catch{}await Promise.all(V)}terminate(V,L=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${V}`),this.l.flush(),this.p.dispose(),this.L.dispose(),m.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const K=this.R();Promise.race([(0,R.timeout)(5e3),K]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${L}`):this.l.info(`Extension host exiting with code ${L}`),this.l.flush(),this.l.dispose(),this.c.exit(L)})}isActivated(V){return this.y.isOpen()?this.L.isActivated(V):!1}async getExtension(V){const L=await this.u.$getExtension(V);let K;if(L?.browserNlsBundleUris){K={};for(const me of Object.keys(L.browserNlsBundleUris))K[me]=h.URI.revive(L.browserNlsBundleUris[me])}return L&&{...L,identifier:new b.ExtensionIdentifier(L.identifier.value),extensionLocation:h.URI.revive(L.extensionLocation),browserNlsBundleUris:K}}S(V,L){return this.L.activateByEvent(V,L)}U(V,L){return this.L.activateById(V,L)}activateByIdWithErrors(V,L){return this.U(V,L).then(()=>{const K=this.L.getActivatedExtension(V);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(V=>this.F)}getExtensionExports(V){return this.y.isOpen()?this.L.getActivatedExtension(V).exports:null}async W(V){if(V.scheme!==_.Schemas.file)return V;const L=await this.c.realpath(V.fsPath);return h.URI.file(L)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(V=>new Te(V))),this.M}async X(V){const L=w.TernarySearchTree.forUris(K=>M.extUriBiasedIgnorePathCase.ignorePathCasing(K));return await Promise.all(V.map(async K=>{if(this.pb(K)){const me=await this.W(K.extensionLocation);L.set(me,K)}})),L}Y(V){let L=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(V))return L;const K=this.L.getActivatedExtension(V);if(!K)return L;try{typeof K.module.deactivate=="function"&&(L=Promise.resolve(K.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${V.value}':`),this.l.error(me)}try{(0,A.dispose)(K.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.l.error(me)}return L}async Z(V,L){return this.f.remote.isRemote?this.u.$onWillActivateExtension(V.identifier):await this.u.$onWillActivateExtension(V.identifier),this.bb(V,L).then(K=>{const me=K.activationTimes;return this.u.$onDidActivateExtension(V.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,L),this.ab(V,L,"success",me),K},K=>{throw this.ab(V,L,"failure"),K})}ab(V,L,K,me){const Ie=ie(V,L);this.t.$publicLog2("extensionActivationTimes",{...Ie,...me||{},outcome:K})}bb(V,L){const K=ie(V,L);this.t.$publicLog2("activatePlugin",K);const me=this.pb(V);if(!me)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${L.startup}, activationEvent: '${L.activationEvent}'${V.identifier.value!==L.extensionId.value?`, root cause: ${L.extensionId.value}`:""}`),this.l.flush();const Ie=new E.ExtensionActivationTimesBuilder(L.startup);return Promise.all([this.qb(V,(0,M.joinPath)(V.extensionLocation,me),Ie),this.cb(V)]).then(Se=>(k.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),fn.db(this.l,V.identifier,Se[0],Se[1],Ie))).then(Se=>(k.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),Se))}cb(V){const L=new p.ExtensionGlobalMemento(V,this.H),K=new p.ExtensionMemento(V.identifier.value,!1,this.H),me=new X.ExtensionSecrets(V,this.I),Ie=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Se=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([L.whenReady,K.whenReady,this.J.whenReady]).then(()=>{const ve=this;let Ce,se;const ae=(0,t.isProposedApiEnabled)(V,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:L,workspaceState:K,secrets:me,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Z){return T.join(V.extensionLocation.fsPath,Z)},get storagePath(){return ve.J.workspaceValue(V)?.fsPath},get globalStoragePath(){return ve.J.globalValue(V).fsPath},get logPath(){return T.join(ve.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return h.URI.joinPath(ve.f.logsLocation,V.identifier.value)},get storageUri(){return ve.J.workspaceValue(V)},get globalStorageUri(){return ve.J.globalValue(V)},get extensionMode(){return Ie},get extension(){return Ce===void 0&&(Ce=new ce(ve,V.identifier,V,Se,!1)),Ce},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(V,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!se){if(!ae)return;const Z=D.Event.buffer(D.Event.fromDOMEventEmitter(ae,"message",C=>C.data));ae.start(),se={onDidReceiveMessage:Z,postMessage:ae.postMessage.bind(ae)}}return se}})})}static db(V,L,K,me,Ie){return K=K||{activate:void 0,deactivate:void 0},this.eb(V,L,K,me,Ie).then(Se=>new E.ActivatedExtension(!1,null,Ie.build(),K,Se,me.subscriptions))}static eb(V,L,K,me,Ie){if(typeof K.activate=="function")try{Ie.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${L.value}`);const Se=typeof global=="object"?global:self,ve=K.activate.apply(Se,[me]);return Ie.activateCallStop(),Ie.activateResolveStart(),Promise.resolve(ve).then(Ce=>(Ie.activateResolveStop(),Ce))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(K)}fb(V,L){this.U(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:L}).then(void 0,K=>{this.l.error(K)})}gb(V,L=0){const me=Date.now();(0,U.setTimeout0)(()=>{for(let Ie=L;Ie<V.length;Ie+=1){const Se=V[Ie];for(const ve of Se.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-me>50){this.gb(V,Ie);break}else this.fb(Se,ve)}})}hb(){this.u.$setPerformanceMarks(k.getMarks()),this.k.getConfigProvider().then(V=>{const L=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.F.getAllExtensionDescriptions();if(L)this.gb(K);else for(const me of K)if(me.activationEvents)for(const Ie of me.activationEvents)Ie==="onStartupFinished"&&this.fb(me,Ie)})}ib(){const V=this.S("*",!0).then(void 0,Ie=>{this.l.error(Ie)});this.D(this.j.onDidChangeWorkspace(Ie=>this.jb(Ie.added)));const L=this.j.workspace?this.j.workspace.folders:[],K=this.jb(L),me=Promise.all([V,K]).then(()=>{});return Promise.race([me,(0,R.timeout)(1e4)]).then(()=>{this.hb()}),me}jb(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(L=>this.kb(V,L))).then(()=>{})}async kb(V,L){if(this.isActivated(L.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:V.map(Se=>Se.uri),forceUsingSearch:K,exists:Se=>this.c.exists(Se.fsPath),checkExists:(Se,ve,Ce)=>this.s.$checkExists(Se,ve,Ce)},Ie=await(0,y.checkActivateWorkspaceContainsExtension)(me,L);if(!!Ie)return this.U(L.identifier,{startup:!0,extensionId:L.identifier,activationEvent:Ie.activationEvent}).then(void 0,Se=>this.l.error(Se))}async $extensionTestsExecute(){await this.z.wait();try{return await this.lb()}catch(V){throw console.error(V),V}}async lb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:L}=this.f.environment;if(!V||!L)throw new Error(n.localize(0,null));const K=await this.qb(null,L,new E.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(n.localize(1,null,L.toString()));return new Promise((me,Ie)=>{const Se=(se,ae)=>{se?Ie(se):me(typeof ae=="number"&&ae>0?1:0)},ve=(0,M.originalFSPath)(L),Ce=K.run(ve,Se);Ce&&Ce.then&&Ce.then(()=>{me(0)}).catch(se=>{Ie(se instanceof Error&&se.stack?se.stack:String(se))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,L){return this.N[V]=L,(0,A.toDisposable)(()=>{delete this.N[V]})}async nb(V){const L=V.indexOf("+");if(L===-1)throw new Error("Not an authority that can be resolved!");const K=V.substr(0,L);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.N[K]}}async $resolveAuthority(V,L){const K=j.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(V)},${L})][${K.elapsed()}ms] `,Ie=ae=>this.l.info(`${me()}${ae}`),Se=(ae,Z=void 0)=>this.l.error(`${me()}${ae}`,Z);Ie("activating resolver...");const{authorityPrefix:ve,resolver:Ce}=await this.nb(V);if(!Ce)return Se("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};const se=new R.IntervalTimer;try{Ie("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(Ce)),se.cancelAndSet(()=>Ie("waiting..."),1e3),Ie("invoking resolve()..."),k.mark(`code/extHost/willResolveAuthority/${ve}`);const ae=await Ce.resolve(V,{resolveAttempt:L});k.mark(`code/extHost/didResolveAuthorityOK/${ve}`),se.dispose(),Ie(`returned ${ae.host}:${ae.port}`);const Z={authority:V,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},C={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:C,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(k.mark(`code/extHost/didResolveAuthorityError/${ve}`),se.dispose(),Se("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(V,L){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(V)})`);const{resolver:K}=await this.nb(V);if(!K)return null;const me=h.URI.revive(L);if(typeof K.getCanonicalURI>"u")return me;const Ie=await(0,R.asPromise)(()=>K.getCanonicalURI(me));return Ie||me}$startExtensionHost(V){V.toAdd.forEach(me=>me.extensionLocation=h.URI.revive(me.extensionLocation));const{globalRegistry:L,myExtensions:K}=Ee(this.C,this.G,this.F,V);return this.G.set(L.getAllExtensionDescriptions()),this.F.set(K),this.mb()}$activateByEvent(V,L){return L===1?this.S(V,!1):this.y.wait().then(K=>this.S(V,!1))}async $activate(V,L){return await this.y.wait(),this.F.getExtensionDescription(V)?(await this.U(V,L),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(Se=>Se.extensionLocation=h.URI.revive(Se.extensionLocation));const{globalRegistry:L,myExtensions:K}=Ee(this.C,this.G,this.F,V),me=await this.X(K);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(L.getAllExtensionDescriptions()),this.F.set(K),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const L=P.VSBuffer.alloc(V),K=Math.random()%256;for(let me=0;me<V;me++)L.writeUInt8(K,me);return L}async $updateRemoteConnectionData(V){this.Q=V,this.a.fire()}};he=je([Ve(0,s.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,I.IExtHostRpcService),Ve(3,d.IExtHostWorkspace),Ve(4,f.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,c.IExtHostInitDataService),Ve(7,o.IExtensionStoragePaths),Ve(8,u.IExtHostTunnelService),Ve(9,v.IExtHostTerminalService),Ve(10,J.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function Ee(re,V,L,K){re.addActivationEvents(K.addActivationEvents);const me=new a.ExtensionDescriptionRegistry(re,V.getAllExtensionDescriptions());me.deltaExtensions(K.toAdd,K.toRemove);const Ie=new b.ExtensionIdentifierSet(L.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of K.myToRemove)Ie.delete(ve);for(const ve of K.myToAdd)Ie.add(ve);const Se=de(me,Ie);return{globalRegistry:me,myExtensions:Se}}function ie(re,V){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class ce{constructor(V,L,K,me,Ie){$.set(this,void 0),B.set(this,void 0),q.set(this,void 0),Je(this,$,V,"f"),Je(this,B,L,"f"),Je(this,q,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=T.normalize((0,M.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=me,this.isFromDifferentExtensionHost=Ie}get isActive(){return Fe(this,$,"f").isActivated(Fe(this,q,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,$,"f").getExtensionExports(Fe(this,q,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,$,"f").activateByIdWithErrors(Fe(this,q,"f"),{startup:!1,extensionId:Fe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=ce,$=new WeakMap,B=new WeakMap,q=new WeakMap;function de(re,V){return re.getAllExtensionDescriptions().filter(L=>V.has(L.identifier))}class Te{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.ExtensionPaths=Te;class le{constructor(V){this.a=new b.ExtensionIdentifierMap,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)}addActivationEvents(V){for(const L of Object.keys(V))this.a.set(L,V[L])}}}),define(Ae[254],Re([1,0,83,2,4,33,26,24,18,27,3,34,51,13,12]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(p,i,l,s,c,o,I){this.c=p,this.d=i,this.e=l,this.f=s,this.g=c,this.h=o,this.i=I,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,p,this.i)),this.register(this.e.createInstance(m,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this.a.set(i,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(i=>p.alternativeModuleName(i))}};d=je([Ve(2,O.IInstantiationService),Ve(3,M.IExtHostConfiguration),Ve(4,S.IExtHostExtensionService),Ve(5,h.IExtHostInitDataService),Ve(6,E.ILogService)],d),e.RequireInterceptor=d;let t=class cn{constructor(p){if(p.environment.appRoot&&cn.a.size){const i=(0,g.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),l="[a-z0-9_.-]",s=`@${l}+\\/${l}+|${l}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const i=this.b.exec(this.c(p));if(!i)return;const[,l,s,c]=i,o=cn.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),l+o+c}c(p){return p.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=je([Ve(0,h.IExtHostInitDataService)],t);class a{constructor(p,i,l,s,c){this.c=p,this.d=i,this.e=l,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new A.ExtensionIdentifierMap}load(p,i){const l=this.d.findSubstr(i);if(l){let s=this.a.get(l.identifier);return s||(s=this.c(l,this.e,this.f),this.a.set(l.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,o)=>s+=`	${o} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(R.nullExtensionDescription,this.e,this.f)}return this.b}}let m=class{constructor(p,i,l){this.d=p,this.nodeModuleName="keytar",this.a=i.getProxy(k.MainContext.MainThreadTelemetry);const{environment:s}=l,c=i.getProxy(k.MainContext.MainThreadKeytar);if(s.appRoot){let o=s.appRoot.fsPath;f.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,I)=>c.$getPassword(o,I),setPassword:(o,I,r)=>c.$setPassword(o,I,r),deletePassword:(o,I)=>c.$deletePassword(o,I),findPassword:o=>c.$findPassword(o),findCredentials(o){return c.$findCredentials(o)}}}load(p,i){const l=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const i=p.length;if(i<=7||!this.b)return;const l=i-7;if((p.charAt(l)==="/"||p.charAt(l)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};m=je([Ve(1,w.IExtHostRpcService),Ve(2,h.IExtHostInitDataService)],m);let b=class{constructor(p,i,l){this.e=p,this.f=i,this.nodeModuleName=["open","opn"],this.d=l.getProxy(k.MainContext.MainThreadTelemetry);const s=l.getProxy(k.MainContext.MainThreadWindow);this.c=(c,o)=>{const I=T.URI.parse(c);return o?this.g(c,o):I.scheme==="http"||I.scheme==="https"?s.$openUri(I,c,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this.f?s.$openUri(I,c,{}):this.g(c,o)}}load(p,i,l){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=l(p),this.c}g(p,i){return this.i(),this.b(p,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=je([Ve(2,w.IExtHostRpcService)],b)}),define(Ae[110],Re([1,0,86,6,19,51,3,58,59,34,7,32,194,33]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class g extends f.AbstractVariableResolverService{constructor(a,m,b,P,p,i,l){function s(){if(b){const c=b.activeEditor();if(c)return c.document.uri;const o=P.tabGroups.all.find(I=>I.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof O.TextDiffTabInput||o.input instanceof O.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof O.TextTabInput||o.input instanceof O.NotebookEditorTabInput||o.input instanceof O.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:c=>{const o=i.folders.filter(I=>I.name===c);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,o)=>p.getConfiguration(void 0,c).get(o),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=s();if(c)return k.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const c=s();if(c){const o=m.getWorkspaceFolder(c);if(o)return k.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(b){const c=b.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(b){const c=b.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(M.env))}}let d=class extends T.Disposable{constructor(a,m,b,P,p){super(),this.b=a,this.c=m,this.g=b,this.h=P,this.i=p,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async c=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};d=je([Ve(0,h.IExtHostExtensionService),Ve(1,S.IExtHostWorkspace),Ve(2,A.IExtHostDocumentsAndEditors),Ve(3,E.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Ae[111],Re([1,0,17,5,9,2,3,4,59,34,18,7,32,187,189,33,110]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,o,I,r,u){this.D=c,this.E=o,this.F=I,this.G=r,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=s.getProxy(A.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(v=>{v.onDidChange(D=>{this.I(v)}),this.I(v)})}asDebugSourceUri(s,c){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let I=`debug:${encodeURIComponent(o.path||"")}`,r="?";return c&&(I+=`${r}session=${encodeURIComponent(c.id)}`,r="&"),I+=`${r}ref=${o.sourceReference}`,M.URI.parse(I)}else{if(o.path)return M.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const c=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const I=o.contributes.debuggers;if(I&&I.length>0)for(const r of I)(0,g.isDebuggerMainContribution)(r)&&c.push(r.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){this.T();const c=s.filter(r=>{const u=r.id;return this.w.has(u)?!1:(this.w.set(u,r),!0)});this.U(c,[],[]);const o=[],I=new Map;for(const r of c)if(r instanceof S.SourceBreakpoint){let u=I.get(r.location.uri.toString());u||(u={type:"sourceMulti",uri:r.location.uri,lines:[]},I.set(r.location.uri.toString(),u),o.push(u)),u.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof S.FunctionBreakpoint&&o.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){this.T();const c=s.filter(u=>this.w.delete(u.id));this.U([],c,[]);const o=c.filter(u=>u instanceof S.SourceBreakpoint).map(u=>u.id),I=c.filter(u=>u instanceof S.FunctionBreakpoint).map(u=>u.id),r=c.filter(u=>u instanceof S.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(o,I,r)}startDebugging(s,c,o){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,o){if(!c)return new S.Disposable(()=>{});const I=this.d++;return this.f.push({type:s,handle:I,provider:c}),this.k.$registerDebugConfigurationProvider(s,o,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,I),new S.Disposable(()=>{this.f=this.f.filter(r=>r.provider!==c),this.k.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(s,c,o){if(!o)return new S.Disposable(()=>{});if(!this.P(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:c,handle:I,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(c,I),new S.Disposable(()=>{this.h=this.h.filter(r=>r.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new S.Disposable(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:c}),new S.Disposable(()=>{this.j=this.j.filter(I=>I.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let o;const I=await this.W(s);return I&&(o={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,c)}J(s,c){if(s.type==="implementation")return new p(s.implementation)}K(){}async $startDASession(s,c){const o=this,I=await this.V(c);return this.R(this.M(I.type),I).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const u=this.L(r),v=this.J(u,I);if(!v)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const D=v;return this.A.set(s,D),this.Q(I).then(y=>(y&&this.B.set(s,y),D.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const X=W,_={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const J=await this.C.sign(X.arguments.value);_.body={signature:J},D.sendResponse(_)}else throw new Error("no signer")}catch(J){_.success=!1,_.message=J.message,D.sendResponse(_)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(W),W=(0,g.convertToVSCPaths)(W,!0),o.k.$acceptDAMessage(s,W)}),D.onError(W=>{y&&y.onError&&y.onError(W),this.k.$acceptDAError(s,W.name,W.message,W.stack)}),D.onExit(W=>{y&&y.onExit&&y.onExit((0,k.withNullAsUndefined)(W),void 0),this.k.$acceptDAExit(s,(0,k.withNullAsUndefined)(W),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),D.startSession()))})}$sendDAMessage(s,c){c=(0,g.convertToDAPaths)(c,!1);const o=this.B.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(c),this.A.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.B.get(s);this.B.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const o=this.A.get(s);return this.A.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],o=[],I=[];if(s.added)for(const r of s.added){const u=r.id;if(u&&!this.w.has(u)){let v;if(r.type==="function")v=new S.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")v=new S.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const D=M.URI.revive(r.uri);v=new S.SourceBreakpoint(new S.Location(D,new S.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,S.setBreakpointId)(v,u),this.w.set(u,v),c.push(v)}}if(s.removed)for(const r of s.removed){const u=this.w.get(r);u&&(this.w.delete(r),o.push(u))}if(s.changed){for(const r of s.changed)if(r.id){const u=this.w.get(r.id);if(u){if(u instanceof S.FunctionBreakpoint&&r.type==="function"){const v=u;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.functionName=r.functionName}else if(u instanceof S.SourceBreakpoint&&r.type==="source"){const v=u;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.location=new S.Location(M.URI.revive(r.uri),new S.Position(r.line,r.character))}I.push(u)}}}this.U(c,o,I)}$provideDebugConfigurations(s,c,o){return(0,n.asPromise)(async()=>{const I=this.O(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.W(c);return I.provideDebugConfigurations(r,o)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(s,c,o,I){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(c);return r.resolveDebugConfiguration(u,o,I)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,o,I){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(c);return r.resolveDebugConfigurationWithSubstitutedVariables(u,o,I)})}async $provideDebugAdapter(s,c){const o=this.N(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.V(c);return this.R(o,I).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.L(r)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const I={session:await this.V(s),event:c.event,body:c.body};this.u.fire(I)}L(s){if(s instanceof S.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof S.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const c=this.h.filter(o=>o.type===s);if(c.length>0)return c[0].factory}N(s){const c=this.h.filter(o=>o.handle===s);if(c.length>0)return c[0].factory}O(s){const c=this.f.filter(o=>o.handle===s);if(c.length>0)return c[0].provider}P(s,c){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const I of o)if(I.label&&I.type&&I.type===c)return!0}}return!1}Q(s){const o=s.configuration.type,I=this.j.filter(r=>r.type===o||r.type==="*").map(r=>(0,n.asPromise)(()=>r.factory.createDebugAdapterTracker(s)).then(u=>u,u=>null));return Promise.race([Promise.all(I).then(r=>{const u=r.filter(v=>!!v);if(u.length>0)return new P(u)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async R(s,c){const o=c.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new S.DebugAdapterServer(o));if(s){const r=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>s.createDebugAdapterDescriptor(c,this.S(c,r))).then(u=>{if(u)return u})}const I=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,I))}S(s,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,c,o){(s.length>0||c.length>0||o.length>0)&&this.z.fire(Object.freeze({added:s,removed:c,changed:o}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const o=await this.W(s.folderUri),I=s.parent?this.l.get(s.parent):void 0;c=new m(this.k,s.id,s.type,s.name,o,s.configuration,I),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=M.URI.revive(s);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};a=je([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class m{constructor(s,c,o,I,r,u,v){this.d=s,this.f=c,this.g=o,this.h=I,this.i=r,this.j=u,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=m;class b{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=b;class P{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(o=>o.onExit?o.onExit(s,c):void 0)}}class p extends E.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(s,c,o,I,r,u){super(s,c,o,I,r,u)}};i=je([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ae[255],Re([1,0,14,83,2,4,246,13,68,69,27,165,18,55,34,57]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(b){const P=b.get(A.ILogService),i=b.get(f.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(l=>{P.error(l);const s=n.transformErrorForSerialization(l);i.$onUnexpectedError(s)})}static async installFullHandler(b){const P=b.get(A.ILogService),p=b.get(f.IExtHostRpcService),i=b.get(g.IExtHostExtensionService),l=b.get(d.IExtHostTelemetry),s=p.getProxy(M.MainContext.MainThreadExtensionService),c=p.getProxy(M.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),I=new WeakMap;Error.prepareStackTrace=(r,u)=>{let v="",D,y;for(const W of u)v+=`
	at ${W.toString()}`,y=W.getFileName(),!D&&y&&(D=o.findSubstr(k.URI.file(y)));return I.set(r,D?.identifier),`${r.name||"Error"}: ${r.message||""}${v}`},n.setUnexpectedErrorHandler(r=>{P.error(r);const u=n.transformErrorForSerialization(r),v=I.get(r);if(!v){c.$onUnexpectedError(u);return}s.$onExtensionRuntimeError(v,u);const D=l.onExtensionError(v,r);P.trace("forwarded error to extension?",D,v)})}}Error.stackTraceLimit=100;class a{constructor(b,P,p,i,l){this.a=p,this.b=new R.RPCProtocol(b,null,i),P=a.e(P,this.b);const s=new h.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());s.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:l}),s.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),s.set(E.IURITransformerService,new E.URITransformerService(i)),s.set(g.IHostUtils,p);const c=new S.InstantiationService(s,!0);c.invokeFunction(t.installEarlyHandler),this.d=c.invokeFunction(o=>o.get(A.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=c.invokeFunction(o=>o.get(g.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const P=this.b.getProxy(M.MainContext.MainThreadExtensionService);return k.URI.revive(await P.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,P){b.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(P.transformIncomingURIs(i.extensionLocation));const l={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>l[s]=k.URI.revive(P.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=l)}),b.environment.appRoot=k.URI.revive(P.transformIncomingURIs(b.environment.appRoot));const p=b.environment.extensionDevelopmentLocationURI;return p&&(b.environment.extensionDevelopmentLocationURI=p.map(i=>k.URI.revive(P.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=k.URI.revive(P.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=k.URI.revive(P.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=k.URI.revive(P.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=k.URI.revive(P.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=k.URI.revive(P.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=k.URI.revive(P.transformIncomingURIs(b.logsLocation)),b.workspace=P.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=a}),define(Ae[256],Re([1,0,16,17,21,40,15,19,22,2,47]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(m,b,P,p){this.d=m,this.e=b,this.f=P,this.g=p,this.a=null,this.b=!1,this.c=0}search(m,b){const P=this.d.folderQueries||[],p=new k.CancellationTokenSource;return b.onCancellationRequested(()=>p.cancel()),new Promise((i,l)=>{this.a=new E(m);let s=!1;const c=(o,I)=>{if(!s&&!this.b){const r=this.h(o);d(o)&&typeof this.d.maxResults=="number"&&this.c+r>this.d.maxResults&&(this.b=!0,s=!0,p.cancel(),o=this.j(o,this.d.maxResults-this.c));const u=this.h(o);this.c+=u,(u>0||!d(o))&&this.a.add(o,I)}};Promise.all(P.map((o,I)=>this.k(o,r=>c(r,I),p.token))).then(o=>{p.dispose(),this.a.flush();const I=o.some(r=>!!r&&!!r.limitHit);i({limitHit:this.b||I,messages:(0,n.flatten)(o.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.g}})},o=>{p.dispose();const I=(0,M.toErrorMessage)(o);l(new Error(I))})})}h(m){return d(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,b){const P=Array.isArray(m.ranges)?m.ranges:[m.ranges],p=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:P.slice(0,b),preview:{matches:p.slice(0,b),text:m.preview.text},uri:m.uri}}async k(m,b,P){const p=new O.QueryGlobTester(this.d,m),i=[],l={report:o=>{if(!this.l(o))return;const I=m.folder.scheme===R.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(w.dirname(o.uri))):void 0,r=w.relativePath(m.folder,o.uri);if(r){const u=p.includedInQuery(r,A.basename(r),I);(0,T.isThenable)(u)?i.push(u.then(v=>{v&&b(o)})):u&&b(o)}}},s=this.n(m),c=await this.e.provideTextSearchResults(f(this.d.contentPattern),s,l,P);return i.length&&await Promise.all(i),c}l(m){if(d(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,m.includePattern),P=(0,O.resolvePatternsForProvider)(this.d.excludePattern,m.excludePattern),p={folder:h.URI.from(m.folder),excludes:P,includes:b,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.f.toCanonicalName(m.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=S;function f(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(m,b){this.d&&(this.b!==b||!w.isEqual(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:m.uri,results:[]}),this.d.results.push(g(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.TextSearchResultsCollector=E;function g(a){return d(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}e.extensionResultIsMatch=d;class t{constructor(m,b){this.g=m,this.h=b,this.c=0,this.d=[],this.e=0}addItem(m,b){!m||this.j(m,b)}addItems(m,b){!m||this.k(m,b)}j(m,b){this.d.push(m),this.e+=b,this.l()}k(m,b){this.d=this.d.concat(m),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}t.a=4e3,t.b=50,e.BatchedCollector=t}),define(Ae[112],Re([1,0,6,4,3,251,18,55,13,2,256]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let S=class{constructor(d,t,a){this.k=d,this.l=t,this.n=a,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const a=this.d++;return this.e.set(a,t),this.c.$registerTextSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.g.delete(d),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const a=this.d++;return this.h.set(a,t),this.c.$registerFileSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.i.delete(d),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(d,t,a,m){const b=f(a),P=this.h.get(d);if(P)return this.j.fileSearch(b,P,p=>{this.c.$handleFileMatch(d,t,p.map(i=>i.resource))},m);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,a,m){const b=this.e.get(d);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const P=f(a);return this.q(P,b).search(i=>this.c.$handleTextMatch(d,t,i),m)}$enableExtensionHostSearch(){}q(d,t){return new O.TextSearchManager(d,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};S=je([Ve(0,R.IExtHostRpcService),Ve(1,A.IURITransformerService),Ve(2,w.ILogService)],S),e.ExtHostSearch=S;function f(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(E),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>h.URI.revive(d))}}e.reviveQuery=f;function E(g){return{...g,folder:h.URI.revive(g.folder)}}}),define(Ae[257],Re([1,0,68,107,32,105,33,38,58,61,109,111,112,81,71,77,106,60,37,80,57,59,227,13,110,79]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i,l,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(l.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(h.IExtHostTerminalService,h.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,n.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,n.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Ae[258],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const M=this.a.get(k);return this.a.delete(k),M}}addDragOperationTransfer(k,M){this.a.set(k,M)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,M){this.b.set(k,M)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=n}),define(Ae[259],Re([1,0,150,7,22,2,5,6,186,17,7,9,16,8,21,258,26]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(P,p){if((0,S.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let i;return Array.isArray(P.highlights)&&(i=P.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),i=i.length?i:void 0),{label:P.label,highlights:i}}}class m{constructor(p,i,l){this.d=p,this.e=i,this.f=l,this.a=new Map,this.b=new d.TreeviewsService;function s(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>s(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(o=>s(o)?this.i(o):o):c})}registerTreeDataProvider(p,i,l){const s=this.createTreeView(p,{treeDataProvider:i},l);return{dispose:()=>s.dispose()}}createTreeView(p,i,l){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],o=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,r=this.h(p,i,l),u=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:c,hasHandleDrag:o,hasHandleDrop:I});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(l,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(v){r.message=v},get title(){return r.title},set title(v){r.title=v},get description(){return r.description},set description(v){r.description=v},get badge(){return r.badge},set badge(v){v!==void 0&&O.ViewBadge.isViewBadge(v)?r.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(r.badge=void 0)},reveal:(v,D)=>r.reveal(v,D),dispose:async()=>{await u,this.a.delete(p),r.dispose()}}}$getChildren(p,i){const l=this.a.get(p);return l?l.getChildren(i):Promise.reject(new w.NoTreeViewError(p))}async $handleDrop(p,i,l,s,c,o,I,r){const u=this.a.get(p);if(!u)return Promise.reject(new w.NoTreeViewError(p));const v=E.DataTransfer.toDataTransfer(l,async D=>(await this.d.$resolveDropFileData(p,i,D)).buffer);return I===p&&r&&await this.g(v,u,r,c,o),u.onDrop(v,s,c)}async g(p,i,l,s,c){const o=this.b.removeDragOperationTransfer(c);if(o)(await o)?.forEach((I,r)=>{I&&p.set(r,I)});else if(c&&i.handleDrag){const I=i.handleDrag(l,p,s);this.b.addDragOperationTransfer(c,I),await I}return p}async $handleDrag(p,i,l,s){const c=this.a.get(p);if(!c)return Promise.reject(new w.NoTreeViewError(p));const o=await this.g(new T.DataTransfer,c,i,s,l);if(!!o)return E.DataTransfer.toDataTransferDTO(o)}async $hasResolve(p){const i=this.a.get(p);if(!i)throw new w.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,l){const s=this.a.get(p);if(!s)throw new w.NoTreeViewError(p);return s.resolveTreeItem(i,l)}$setExpanded(p,i,l){const s=this.a.get(p);if(!s)throw new w.NoTreeViewError(p);s.setExpanded(i,l)}$setSelection(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setSelection(i)}$setFocus(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setFocus(i)}$setVisible(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setVisible(i)}$changeCheckboxState(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setCheckboxState(i)}h(p,i,l){const s=new b(p,i,this.d,this.e.converter,this.f,l);return this.a.set(p,s),s}i(p){const i=this.a.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=m;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,S.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,i,l,s,c,o){if(super(),this.z=p,this.C=l,this.F=s,this.G=c,this.H=o,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new R.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new R.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new R.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new R.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new R.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new R.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new g.CancellationTokenSource,o.contributes&&o.contributes.views)for(const u in o.contributes.views)for(const v of o.contributes.views[u])v.id===p&&(this.J=v.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(u=>this.v.fire({message:!1,element:u})));let I,r;this.D(R.Event.debounce(this.v.event,(u,v)=>(u||(u={message:!1,elements:[]}),v.element!==!1&&(I||(I=new Promise(D=>r=D),this.w=this.w.then(()=>I)),Array.isArray(v.element)?u.elements.push(...v.element):u.elements.push(v.element)),v.message&&(u.message=!0),u),200,!0)(({message:u,elements:v})=>{v.length&&(this.y=this.y.then(()=>{const D=r;return I=null,this.U(v).then(()=>D())})),u&&this.C.$setMessage(this.z,this.I)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let l=this.Q(p);return l||(l=await this.R(i)),l?l.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const l=(0,S.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,S.isUndefinedOrNull)(i.focus)?!1:i.focus,c=(0,S.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.w.then(()=>this.N(p)).then(o=>this.P(p,o[o.length-1]).then(I=>this.C.$reveal(this.z,{item:I.item,parentChain:o.map(r=>r.item)},{select:l,focus:s,expand:c})),o=>this.G.error(o)):this.C.$reveal(this.z,void 0,{select:l,focus:s,expand:c})}get message(){return this.I}set message(p){this.I=p,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.C.$setTitle(this.z,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.C.$setTitle(this.z,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=E.ViewBadge.from(p),this.C.$setBadge(this.z,p))}setExpanded(p,i){const l=this.getExtensionElement(p);l&&(i?this.q.fire(Object.freeze({element:l})):this.r.fire(Object.freeze({element:l})))}setSelection(p){(0,f.equals)(this.l,p)||(this.l=p,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async l=>{const s=this.getExtensionElement(l.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);i.forEach(l=>{l.treeItem.checkboxState=l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.u.fire({items:i.map(l=>[l.extensionItem,l.newState])})}async handleDrag(p,i,l){const s=[];for(const c of p){const o=this.getExtensionElement(c);o&&s.push(o)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,l),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,i,l){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,h.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,i){if(!this.f.resolveTreeItem)return;const l=this.i.get(p);if(l){const s=this.j.get(l);if(s){const c=await this.f.resolveTreeItem(s.extensionItem,l,i)??s.extensionItem;return this.db(c),s.item.tooltip=this.ab(c.tooltip),s.item.command=this.bb(s.disposableStore,c.command),s.item}}}N(p){return this.O(p).then(i=>i?this.N(i).then(l=>this.P(i,l[l.length-1]).then(s=>(l.push(s),l))):Promise.resolve([]))}O(p){const i=this.j.get(p);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,h.asPromise)(()=>this.f.getParent(p))}P(p,i){const l=this.j.get(p);return l?Promise.resolve(l):(0,h.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(s);if(c){const o=this.j.get(c);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let i;if(typeof p=="string"){const l=this.getExtensionElement(p);i=l?this.j.get(l):void 0}else i=p;return i&&i.children||void 0}return this.h}async R(p){this.nb(p);const i=new g.CancellationTokenSource(this.S.token);try{const l=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(i.token.isCancellationRequested)return;const c=await Promise.all((0,f.coalesce)(s||[]).map(async o=>{const I=await this.f.getTreeItem(o);return I&&!i.token.isCancellationRequested?this.Z(o,I,l):null}));return i.token.isCancellationRequested?void 0:(0,f.coalesce)(c)}finally{i.dispose()}}U(p){if(p.some(l=>!l))return this.S.dispose(!0),this.S=new g.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const l=this.W(p);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(p){const i=new Set,l=p.map(c=>this.j.get(c));for(const c of l)if(c&&!i.has(c.item.handle)){let o=c;for(;o&&o.parent&&l.findIndex(I=>o&&o.parent&&I&&I.item.handle===o.parent.item.handle)===-1;){const I=this.i.get(o.parent.item.handle);o=I?this.j.get(I):void 0}o&&!o.parent&&i.add(c.item.handle)}const s=[];return i.forEach(c=>{const o=this.i.get(c);if(o){const I=this.j.get(o);I&&(!I.parent||!i.has(I.parent.item.handle))&&s.push(c)}}),s}X(p){const i={};return Promise.all(p.map(l=>this.Y(l).then(s=>{s&&(i[l]=s.item)}))).then(()=>Object.keys(i).length?this.C.$refresh(this.z,i):void 0)}Y(p){const i=this.getExtensionElement(p);if(i){const l=this.j.get(i);if(l)return this.nb(i),(0,h.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const c=this.eb(i,s,l.parent);return this.lb(i,c,l,l.parent),l.dispose(),c}return null})}return Promise.resolve(null)}Z(p,i,l){const s=this.eb(p,i,l);if(i.id&&this.i.has(s.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(p,s),this.mb(s,l),s}ab(p){return O.MarkdownString.isMarkdownString(p)?E.MarkdownString.from(p):p}bb(p,i){return i?{...this.F.toInternal(i,p),originalId:i.command}:void 0}cb(p){if(!p.checkboxState)return;let i,l;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,l=p.checkboxState.tooltip),{isChecked:i===O.TreeItemCheckboxState.Checked,tooltip:l}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,i,l){this.db(i);const s=new A.DisposableStore,c=this.gb(p,i,l),o=this.hb(i);return{item:{handle:c,parentHandle:l?l.item.handle:void 0,label:a(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:o,iconDark:this.ib(i)||o,themeIcon:this.fb(i),collapsibleState:(0,S.isUndefinedOrNull)(i.collapsibleState)?O.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:l,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:i,label:l,resourceUri:s},c,o){if(i)return`${b.b}/${i}`;const I=a(l,this.H),r=c?c.item.handle:b.a;let u=I?I.label:s?(0,k.basename)(s):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const v=this.j.has(p)?this.j.get(p).item.handle:void 0,D=this.Q(c)||[];let y,W=0;do{if(y=`${r}/${W}:${u}`,o||!this.i.has(y)||v===y)break;W++}while(W<=D.length);return y}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return M.URI.isUri(p)?p:M.URI.file(p)}kb(p,i){this.i.set(i.item.handle,p),this.j.set(p,i)}lb(p,i,l,s){this.i.delete(i.item.handle),this.j.delete(p),i.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(p,i);const c=this.Q(s)||[],o=c.filter(I=>I.item.handle===l.item.handle)[0];o&&c.splice(c.indexOf(o),1,i)}mb(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const i=this.j.get(p);if(i){if(i.children)for(const l of i.children){const s=this.i.get(l.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(p){const i=this.j.get(p);if(i){if(i.children)for(const l of i.children){const s=this.i.get(l.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}b.a="0",b.b="1"}),define(Ae[260],Re([1,0,21,14,5,29,2,132,269,120,130,43,4,75,212,211,38,213,33,215,216,217,200,218,58,34,219,220,225,226,228,107,203,234,235,236,81,61,238,259,8,7,52,241,62,106,32,24,192,224,50,105,109,111,112,13,55,18,27,229,198,71,77,209,239,82,60,244,242,243,210,37,237,240,80,59,57,230,108,231,15,93,202,183,221,6,26,188,79,179,232,233,223,222]),function(ee,e,n,T,k,M,R,A,w,h,O,S,f,E,g,d,t,a,m,b,P,p,i,l,s,c,o,I,r,u,v,D,y,W,X,_,J,j,U,$,B,q,he,Ee,ie,ce,de,Te,le,re,V,L,K,me,Ie,Se,ve,Ce,se,ae,Z,C,N,H,x,te,pe,ke,ue,De,we,$e,He,et,Xe,tt,rt,Me,it,Q,Y,be,We,ze,Qe,Ye,Ge,at,Dt,Tt,It,Et,Mt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ht){const gt=ht.get(se.IExtHostInitDataService),Ot=ht.get($e.IExtHostFileSystemInfo),Ut=ht.get(pe.IExtHostConsumerFileSystem),Lt=ht.get(c.IExtHostExtensionService),pt=ht.get(de.IExtHostWorkspace),Ct=ht.get(rt.IExtHostTelemetry),Pt=ht.get(m.IExtHostConfiguration),$t=ht.get(ve.IURITransformerService),Ke=ht.get(Ce.IExtHostRpcService),Wt=ht.get(J.IExtHostStorage),Pe=ht.get(te.IExtensionStoragePaths),Le=ht.get(Se.ILoggerService),fe=ht.get(Se.ILogService),G=ht.get(C.IExtHostTunnelService),Oe=ht.get(N.IExtHostApiDeprecationService),Be=ht.get(ce.IExtHostWindow),Ze=ht.get(Xe.IExtHostSecretState),xe=ht.get(tt.IExtHostEditorTabs);Ke.set(f.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Le),Ke.set(f.ExtHostContext.ExtHostWorkspace,pt),Ke.set(f.ExtHostContext.ExtHostConfiguration,Pt),Ke.set(f.ExtHostContext.ExtHostExtensionService,Lt),Ke.set(f.ExtHostContext.ExtHostStorage,Wt),Ke.set(f.ExtHostContext.ExtHostTunnelService,G),Ke.set(f.ExtHostContext.ExtHostWindow,Be),Ke.set(f.ExtHostContext.ExtHostSecretState,Ze),Ke.set(f.ExtHostContext.ExtHostTelemetry,Ct),Ke.set(f.ExtHostContext.ExtHostEditorTabs,xe);const ot=Ke.set(f.ExtHostContext.ExtHostDecorations,ht.get(L.IExtHostDecorations)),ft=Ke.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(s.IExtHostDocumentsAndEditors)),mt=Ke.set(f.ExtHostContext.ExtHostCommands,ht.get(t.IExtHostCommands)),lt=Ke.set(f.ExtHostContext.ExtHostTerminalService,ht.get(j.IExtHostTerminalService)),ct=Ke.set(f.ExtHostContext.ExtHostDebugService,ht.get(me.IExtHostDebugService)),bt=Ke.set(f.ExtHostContext.ExtHostSearch,ht.get(Ie.IExtHostSearch)),kt=Ke.set(f.ExtHostContext.ExtHostTask,ht.get(K.IExtHostTask)),Ht=Ke.set(f.ExtHostContext.ExtHostOutputService,ht.get(D.IExtHostOutputService)),Ft=Ke.set(f.ExtHostContext.ExtHostLocalization,ht.get(Dt.IExtHostLocalizationService)),ai=Ke.set(f.ExtHostContext.ExtHostUrls,new Ee.ExtHostUrls(Ke)),At=Ke.set(f.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Ke,ft)),yi=Ke.set(f.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,ft,fe)),ci=Ke.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(fe,At,Ke.getProxy(f.MainContext.MainThreadBulkEdits))),yt=Ke.set(f.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,mt,ft,At)),ui=Ke.set(f.ExtHostContext.ExtHostNotebookDocuments,new ze.ExtHostNotebookDocuments(yt)),li=Ke.set(f.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(fe,yt)),Zt=Ke.set(f.ExtHostContext.ExtHostNotebookKernels,new Me.ExtHostNotebookKernels(Ke,gt,yt,mt,fe)),Di=Ke.set(f.ExtHostContext.ExtHostNotebookRenderers,new Q.ExtHostNotebookRenderers(Ke,yt)),wt=Ke.set(f.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,ft)),di=Ke.set(f.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ke.getProxy(f.MainContext.MainThreadTreeViews),mt,fe)),Bi=Ke.set(f.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ke.getProxy(f.MainContext.MainThreadEditorInsets),wt,gt.remote)),ei=Ke.set(f.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ke,fe,Ot,ft)),ii=Ke.set(f.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,At,mt.converter,$t)),dt=Ke.set(f.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Ke,$t,At,mt,ei,fe,Oe,Ct)),ti=Ke.set(f.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ke,dt)),jt=Ke.set(f.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(Ke,fe,ft)),Qt=Ke.set(f.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ke,pt,mt)),hi=Ke.set(f.ExtHostContext.ExtHostSCM,new X.ExtHostSCM(Ke,mt,fe)),Ii=Ke.set(f.ExtHostContext.ExtHostQuickDiff,new Et.ExtHostQuickDiff(Ke,$t)),Ci=Ke.set(f.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ke,mt,At)),fi=Ke.set(f.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Ke.getProxy(f.MainContext.MainThreadProgress))),ki=Ke.set(f.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(Ke)),mi=Ke.set(f.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ke)),gi=Ke.set(f.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Ke)),Ti=Ke.set(f.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Ke,mt)),ni=Ke.set(f.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ke,gt.remote,pt,fe,Oe)),ri=Ke.set(f.ExtHostContext.ExtHostWebviewPanels,new De.ExtHostWebviewPanels(Ke,ni,pt)),Pi=Ke.set(f.ExtHostContext.ExtHostCustomEditors,new ue.ExtHostCustomEditors(Ke,At,Pe,ni,ri)),zi=Ke.set(f.ExtHostContext.ExtHostWebviewViews,new ke.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(f.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ke,mt,ft)),Ai=Ke.set(f.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Wi=Ke.set(f.ExtHostContext.ExtHostProfileContentHandlers,new It.ExtHostProfileContentHandlers(Ke));Ke.set(f.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(Ke,yt,ft,mt,fe));const Hi=Ke.set(f.ExtHostContext.ExtHostInteractiveEditor,new zt.ExtHostInteractiveEditor(Ke,At,fe)),Fi=Ke.set(f.ExtHostContext.ExtHostInteractiveSession,new Mt.ExtHostInteractiveSession(Ke,fe)),Vi=Object.values(f.ExtHostContext);Ke.assertRegistered(Vi);const ji=new we.ExtHostBulkEdits(Ke,ft),qi=new d.ExtHostClipboard(Ke),si=new v.ExtHostMessageService(Ke,fe),pi=new P.ExtHostDialogs(Ke),Ni=new _.ExtHostStatusBar(Ke,mt.converter);return g.ExtHostApiCommands.register(mt),function(Ue,xt,oi){const vt=function(){let oe=!Ue.isUnderDevelopment;function ge(){oe||(fe.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Ne(nt){if(Array.isArray(nt))nt.forEach(Ne);else if(typeof nt=="string")ge();else{const St=nt;typeof St.scheme>"u"&&ge(),typeof St.exclusive=="boolean"&&(0,Ge.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),xi={getSession(oe,ge,Ne){return gi.getSession(Ue,oe,ge,Ne)},async hasSession(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"authSession"),!!await gi.getSession(Ue,oe,ge,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(oe,ge,Ne,nt){return gi.registerAuthenticationProvider(oe,ge,Ne,nt)}},Ki={registerCommand(oe,ge,Ne){return mt.registerCommand(!0,oe,ge,Ne,void 0,Ue)},registerTextEditorCommand(oe,ge,Ne){return mt.registerCommand(!0,oe,(...nt)=>{const St=wt.getActiveTextEditor();if(!St){fe.warn("Cannot execute "+oe+" because there is no active text editor.");return}return St.edit(Rt=>{ge.apply(Ne,[St,Rt,...nt])}).then(Rt=>{Rt||fe.warn("Edits from command "+oe+" were not applied.")},Rt=>{fe.warn("An error occurred while running command "+oe,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(oe,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"diffCommand"),mt.registerCommand(!0,oe,async(...nt)=>{const St=ft.activeEditor(!0);if(!St){fe.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Rt=await wt.getDiffInformation(St.id);ge.apply(Ne,[Rt,...nt])},void 0,void 0,Ue)),executeCommand(oe,...ge){return mt.executeCommand(oe,...ge)},getCommands(oe=!1){return mt.getCommands(oe)}},Mi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return qi.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ge.checkProposedApiEnabled)(Ue,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(oe){return rt.ExtHostTelemetryLogger.validateSender(oe),Ct.instantiateLogger(Ue,oe)},openExternal(oe,ge){return Be.openUri(oe,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===gt.environment.appUriScheme)return ai.createAppUri(oe);try{return await Be.asExternalUri(oe,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,be.matchesScheme)(oe,Y.Schemas.http)||(0,be.matchesScheme)(oe,Y.Schemas.https))return oe;throw ge}},get remoteName(){return(0,V.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return fe.getLevel()},get onDidChangeLogLevel(){return fe.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(oe,ge,Ne){return Yt.createTestController(Ue,oe,ge,Ne)},createTestObserver(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(oe)},get onDidChangeTestResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},vi=gt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Kt={getExtension(oe,ge){(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")||(ge=!1);const Ne=xt.mine.getExtensionDescription(oe);if(Ne)return new c.Extension(Lt,Ue.identifier,Ne,vi,!1);if(ge){const nt=xt.all.getExtensionDescription(oe);if(nt)return new c.Extension(Lt,Ue.identifier,nt,vi,!0)}},get all(){const oe=[];for(const ge of xt.mine.getAllExtensionDescriptions())oe.push(new c.Extension(Lt,Ue.identifier,ge,vi,!1));return oe},get allAcrossExtensionHosts(){(0,Ge.checkProposedApiEnabled)(Ue,"extensionsAny");const oe=new Te.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ge=[];for(const Ne of xt.all.getAllExtensionDescriptions()){const nt=!oe.has(Ne.identifier);ge.push(new c.Extension(Lt,Ue.identifier,Ne,vi,nt))}return ge},get onDidChange(){return(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")?k.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},bi={createDiagnosticCollection(oe){return ei.createDiagnosticCollection(Ue.identifier,oe)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:oe=>ei.getDiagnostics(oe),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(oe,ge){return ii.changeLanguage(oe.uri,ge)},match(oe,ge){const Ne=At.getDocumentData(ge.uri)?.notebook;return(0,O.score)(B.LanguageSelector.from(oe),ge.uri,ge.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(oe,ge,Ne){return dt.registerCodeActionProvider(Ue,vt(oe),ge,Ne)},registerDocumentPasteEditProvider(oe,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,vt(oe),ge,Ne)},registerCodeLensProvider(oe,ge){return dt.registerCodeLensProvider(Ue,vt(oe),ge)},registerDefinitionProvider(oe,ge){return dt.registerDefinitionProvider(Ue,vt(oe),ge)},registerDeclarationProvider(oe,ge){return dt.registerDeclarationProvider(Ue,vt(oe),ge)},registerImplementationProvider(oe,ge){return dt.registerImplementationProvider(Ue,vt(oe),ge)},registerTypeDefinitionProvider(oe,ge){return dt.registerTypeDefinitionProvider(Ue,vt(oe),ge)},registerHoverProvider(oe,ge){return dt.registerHoverProvider(Ue,vt(oe),ge,Ue.identifier)},registerEvaluatableExpressionProvider(oe,ge){return dt.registerEvaluatableExpressionProvider(Ue,vt(oe),ge,Ue.identifier)},registerInlineValuesProvider(oe,ge){return dt.registerInlineValuesProvider(Ue,vt(oe),ge,Ue.identifier)},registerDocumentHighlightProvider(oe,ge){return dt.registerDocumentHighlightProvider(Ue,vt(oe),ge)},registerLinkedEditingRangeProvider(oe,ge){return dt.registerLinkedEditingRangeProvider(Ue,vt(oe),ge)},registerReferenceProvider(oe,ge){return dt.registerReferenceProvider(Ue,vt(oe),ge)},registerRenameProvider(oe,ge){return dt.registerRenameProvider(Ue,vt(oe),ge)},registerDocumentSymbolProvider(oe,ge,Ne){return dt.registerDocumentSymbolProvider(Ue,vt(oe),ge,Ne)},registerWorkspaceSymbolProvider(oe){return dt.registerWorkspaceSymbolProvider(Ue,oe)},registerDocumentFormattingEditProvider(oe,ge){return dt.registerDocumentFormattingEditProvider(Ue,vt(oe),ge)},registerDocumentRangeFormattingEditProvider(oe,ge){return dt.registerDocumentRangeFormattingEditProvider(Ue,vt(oe),ge)},registerOnTypeFormattingEditProvider(oe,ge,Ne,...nt){return dt.registerOnTypeFormattingEditProvider(Ue,vt(oe),ge,[Ne].concat(nt))},registerDocumentSemanticTokensProvider(oe,ge,Ne){return dt.registerDocumentSemanticTokensProvider(Ue,vt(oe),ge,Ne)},registerDocumentRangeSemanticTokensProvider(oe,ge,Ne){return dt.registerDocumentRangeSemanticTokensProvider(Ue,vt(oe),ge,Ne)},registerSignatureHelpProvider(oe,ge,Ne,...nt){return typeof Ne=="object"?dt.registerSignatureHelpProvider(Ue,vt(oe),ge,Ne):dt.registerSignatureHelpProvider(Ue,vt(oe),ge,typeof Ne>"u"?[]:[Ne,...nt])},registerCompletionItemProvider(oe,ge,...Ne){return dt.registerCompletionItemProvider(Ue,vt(oe),ge,Ne)},registerInlineCompletionItemProvider(oe,ge){return ge.handleDidShowCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,vt(oe),ge)},registerDocumentLinkProvider(oe,ge){return dt.registerDocumentLinkProvider(Ue,vt(oe),ge)},registerColorProvider(oe,ge){return dt.registerColorProvider(Ue,vt(oe),ge)},registerFoldingRangeProvider(oe,ge){return dt.registerFoldingRangeProvider(Ue,vt(oe),ge)},registerSelectionRangeProvider(oe,ge){return dt.registerSelectionRangeProvider(Ue,oe,ge)},registerCallHierarchyProvider(oe,ge){return dt.registerCallHierarchyProvider(Ue,oe,ge)},registerTypeHierarchyProvider(oe,ge){return dt.registerTypeHierarchyProvider(Ue,oe,ge)},setLanguageConfiguration:(oe,ge)=>dt.setLanguageConfiguration(Ue,oe,ge),getTokenInformationAtPosition(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"tokenInformation"),ii.tokenAtPosition(oe,ge)},registerInlayHintsProvider(oe,ge){return dt.registerInlayHintsProvider(Ue,oe,ge)},createLanguageStatusItem(oe,ge){return ii.createLanguageStatusItem(Ue,oe,ge)},registerDocumentDropEditProvider(oe,ge){return dt.registerDocumentOnDropEditProvider(Ue,oe,ge)}},Gi={get activeTextEditor(){return wt.getActiveTextEditor()},get visibleTextEditors(){return wt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(oe,ge,Ne){const nt=await(R.URI.isUri(oe)?Promise.resolve(Bt.openTextDocument(oe)):Promise.resolve(oe));return wt.showTextDocument(nt,ge,Ne)},createTextEditorDecorationType(oe){return wt.createTextEditorDecorationType(Ue,oe)},onDidChangeActiveTextEditor(oe,ge,Ne){return wt.onDidChangeActiveTextEditor(oe,ge,Ne)},onDidChangeVisibleTextEditors(oe,ge,Ne){return wt.onDidChangeVisibleTextEditors(oe,ge,Ne)},onDidChangeTextEditorSelection(oe,ge,Ne){return wt.onDidChangeTextEditorSelection(oe,ge,Ne)},onDidChangeTextEditorOptions(oe,ge,Ne){return wt.onDidChangeTextEditorOptions(oe,ge,Ne)},onDidChangeTextEditorVisibleRanges(oe,ge,Ne){return wt.onDidChangeTextEditorVisibleRanges(oe,ge,Ne)},onDidChangeTextEditorViewColumn(oe,ge,Ne){return wt.onDidChangeTextEditorViewColumn(oe,ge,Ne)},onDidCloseTerminal(oe,ge,Ne){return lt.onDidCloseTerminal(oe,ge,Ne)},onDidOpenTerminal(oe,ge,Ne){return lt.onDidOpenTerminal(oe,ge,Ne)},onDidChangeActiveTerminal(oe,ge,Ne){return lt.onDidChangeActiveTerminal(oe,ge,Ne)},onDidChangeTerminalDimensions(oe,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDimensions"),lt.onDidChangeTerminalDimensions(oe,ge,Ne)},onDidChangeTerminalState(oe,ge,Ne){return lt.onDidChangeTerminalState(oe,ge,Ne)},onDidWriteTerminalData(oe,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(oe,ge,Ne)},get state(){return Be.state},onDidChangeWindowState(oe,ge,Ne){return Be.onDidChangeWindowState(oe,ge,Ne)},showInformationMessage(oe,...ge){return si.showMessage(Ue,M.default.Info,oe,ge[0],ge.slice(1))},showWarningMessage(oe,...ge){return si.showMessage(Ue,M.default.Warning,oe,ge[0],ge.slice(1))},showErrorMessage(oe,...ge){return si.showMessage(Ue,M.default.Error,oe,ge[0],ge.slice(1))},showQuickPick(oe,ge,Ne){return Qt.showQuickPick(Ue,oe,ge,Ne)},showWorkspaceFolderPick(oe){return Qt.showWorkspaceFolderPick(oe)},showInputBox(oe,ge){return Qt.showInput(oe,ge)},showOpenDialog(oe){return pi.showOpenDialog(Ue,oe)},showSaveDialog(oe){return pi.showSaveDialog(oe)},createStatusBarItem(oe,ge,Ne){let nt,St,Rt;return typeof oe=="string"?(nt=oe,St=ge,Rt=Ne):(St=oe,Rt=ge),Ni.createStatusBarEntry(Ue,nt,St,Rt)},setStatusBarMessage(oe,ge){return Ni.setStatusBarMessage(oe,ge)},withScmProgress(oe){return Oe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(ge,Ne)=>oe({report(nt){}}))},withProgress(oe,ge){return fi.withProgress(Ue,oe,ge)},createOutputChannel(oe,ge){return Ht.createOutputChannel(oe,ge,Ue)},createWebviewPanel(oe,ge,Ne,nt){return ri.createWebviewPanel(Ue,oe,ge,Ne,nt)},createWebviewTextEditorInset(oe,ge,Ne,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"editorInsets"),Bi.createWebviewEditorInset(oe,ge,Ne,nt,Ue)},createTerminal(oe,ge,Ne){return typeof oe=="object"?"pty"in oe?lt.createExtensionTerminal(oe):lt.createTerminalFromOptions(oe):lt.createTerminal(oe,ge,Ne)},registerTerminalLinkProvider(oe){return lt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,ge){return lt.registerProfileProvider(Ue,oe,ge)},registerTerminalQuickFixProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),lt.registerTerminalQuickFixProvider(oe,Ue.identifier.value,ge)},registerTreeDataProvider(oe,ge){return di.registerTreeDataProvider(oe,ge,Ue)},createTreeView(oe,ge){return di.createTreeView(oe,ge,Ue)},registerWebviewPanelSerializer:(oe,ge)=>ri.registerWebviewPanelSerializer(Ue,oe,ge),registerCustomEditorProvider:(oe,ge,Ne={})=>Pi.registerCustomEditorProvider(Ue,oe,ge,Ne),registerFileDecorationProvider(oe){return ot.registerFileDecorationProvider(oe,Ue)},registerUriHandler(oe){return ai.registerUriHandler(Ue.identifier,oe)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(oe,ge,Ne){return mi.onDidChangeActiveColorTheme(oe,ge,Ne)},registerWebviewViewProvider(oe,ge,Ne){return zi.registerWebviewViewProvider(Ue,oe,ge,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,ge,Ne){return yt.onDidChangeActiveNotebookEditor(oe,ge,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,ge,Ne){return li.onDidChangeNotebookEditorSelection(oe,ge,Ne)},onDidChangeNotebookEditorVisibleRanges(oe,ge,Ne){return li.onDidChangeNotebookEditorVisibleRanges(oe,ge,Ne)},showNotebookDocument(oe,ge){return yt.showNotebookDocument(oe,ge)},registerExternalUriOpener(oe,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ai.registerExternalUriOpener(Ue.identifier,oe,ge,Ne)},registerProfileContentHandler(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Wi.registrProfileContentHandler(Ue,oe,ge)},registerQuickDiffProvider(oe,ge,Ne,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider(vt(oe),ge,Ne,nt)},get tabGroups(){return xe.tabGroups}},Bt={get rootPath(){return Oe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(oe){throw T.readonly()},getWorkspaceFolder(oe){return pt.getWorkspaceFolder(oe)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(oe){throw T.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(oe){throw T.readonly()},updateWorkspaceFolders:(oe,ge,...Ne)=>pt.updateWorkspaceFolders(Ue,oe,ge||0,...Ne),onDidChangeWorkspaceFolders:function(oe,ge,Ne){return pt.onDidChangeWorkspace(oe,ge,Ne)},asRelativePath:(oe,ge)=>pt.getRelativePath(oe,ge),findFiles:(oe,ge,Ne,nt)=>pt.findFiles(oe,ge,Ne,Ue.identifier,nt),findTextInFiles:(oe,ge,Ne,nt)=>{(0,Ge.checkProposedApiEnabled)(Ue,"findTextInFiles");let St,Rt;return typeof ge=="object"?(St=ge,Rt=Ne):(St={},Rt=ge,nt=Ne),pt.findTextInFiles(oe,St||{},Rt,Ue.identifier,nt)},saveAll:oe=>pt.saveAll(oe),applyEdit(oe,ge){return ji.applyWorkspaceEdit(oe,Ue,ge)},createFileSystemWatcher:(oe,ge,Ne,nt)=>jt.createFileSystemWatcher(pt,Ue,oe,ge,Ne,nt),get textDocuments(){return At.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw T.readonly()},openTextDocument(oe){let ge;const Ne=oe;if(typeof oe=="string")ge=Promise.resolve(R.URI.file(oe));else if(R.URI.isUri(oe))ge=Promise.resolve(oe);else if(!Ne||typeof Ne=="object")ge=At.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(nt=>At.ensureDocumentData(nt).then(St=>St.document))},onDidOpenTextDocument:(oe,ge,Ne)=>At.onDidAddDocument(oe,ge,Ne),onDidCloseTextDocument:(oe,ge,Ne)=>At.onDidRemoveDocument(oe,ge,Ne),onDidChangeTextDocument:(oe,ge,Ne)=>At.onDidChangeDocument(oe,ge,Ne),onDidSaveTextDocument:(oe,ge,Ne)=>At.onDidSaveDocument(oe,ge,Ne),onWillSaveTextDocument:(oe,ge,Ne)=>ci.getOnWillSaveTextDocumentEvent(Ue)(oe,ge,Ne),get notebookDocuments(){return yt.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,ge){let Ne;if(R.URI.isUri(oe))Ne=oe,await yt.openNotebookDocument(oe);else if(typeof oe=="string")Ne=R.URI.revive(await yt.createNotebookDocument({viewType:oe,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(oe,ge,Ne){return ui.onDidSaveNotebookDocument(oe,ge,Ne)},onDidChangeNotebookDocument(oe,ge,Ne){return ui.onDidChangeNotebookDocument(oe,ge,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(oe,ge,Ne,nt){return yt.registerNotebookSerializer(Ue,oe,ge,Ne,(0,Ge.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(oe,ge,Ne)=>oi.onDidChangeConfiguration(oe,ge,Ne),getConfiguration(oe,ge){return ge=arguments.length===1?void 0:ge,oi.getConfiguration(oe,ge,Ue)},registerTextDocumentContentProvider(oe,ge){return yi.registerTextDocumentContentProvider(oe,ge)},registerTaskProvider:(oe,ge)=>(Oe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ue,oe,ge)),registerFileSystemProvider(oe,ge,Ne){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider(Ue,oe,ge,Ne),Ut.addFileSystemProvider(oe,ge))},get fs(){return Ut.value},registerFileSearchProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(oe,ge)),registerTextSearchProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(oe,ge)),registerRemoteAuthorityResolver:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(oe,ge)),registerResourceLabelFormatter:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),ki.$registerResourceLabelFormatter(oe)),onDidCreateFiles:(oe,ge,Ne)=>jt.onDidCreateFile(oe,ge,Ne),onDidDeleteFiles:(oe,ge,Ne)=>jt.onDidDeleteFile(oe,ge,Ne),onDidRenameFiles:(oe,ge,Ne)=>jt.onDidRenameFile(oe,ge,Ne),onWillCreateFiles:(oe,ge,Ne)=>jt.getOnWillCreateFileEvent(Ue)(oe,ge,Ne),onWillDeleteFiles:(oe,ge,Ne)=>jt.getOnWillDeleteFileEvent(Ue)(oe,ge,Ne),onWillRenameFiles:(oe,ge,Ne)=>jt.getOnWillRenameFileEvent(Ue)(oe,ge,Ne),openTunnel:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.openTunnel(Ue,oe).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.getTunnels()},onDidChangeTunnels:(oe,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.onDidChangeTunnels(oe,ge,Ne)),registerPortAttributesProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"portsAttributes"),G.registerPortsAttributesProvider(oe,ge)),registerTimelineProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"timeline"),Ti.registerTimelineProvider(oe,ge,Ue.identifier,mt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"workspaceTrust"),pt.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,ge,Ne)=>pt.onDidGrantWorkspaceTrust(oe,ge,Ne),registerEditSessionIdentityProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(oe,ge)),onWillCreateEditSessionIdentity:(oe,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent(Ue)(oe,ge,Ne))},Ei={get inputBox(){return Oe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Ue)},createSourceControl(oe,ge,Ne){return hi.createSourceControl(Ue,oe,ge,Ne)}},Xi={createCommentController(oe,ge){return Ci.createCommentController(Ue,oe,ge)}},Qi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(oe,ge,Ne){return ct.onDidStartDebugSession(oe,ge,Ne)},onDidTerminateDebugSession(oe,ge,Ne){return ct.onDidTerminateDebugSession(oe,ge,Ne)},onDidChangeActiveDebugSession(oe,ge,Ne){return ct.onDidChangeActiveDebugSession(oe,ge,Ne)},onDidReceiveDebugSessionCustomEvent(oe,ge,Ne){return ct.onDidReceiveDebugSessionCustomEvent(oe,ge,Ne)},onDidChangeBreakpoints(oe,ge,Ne){return ct.onDidChangeBreakpoints(oe,ge,Ne)},registerDebugConfigurationProvider(oe,ge,Ne){return ct.registerDebugConfigurationProvider(oe,ge,Ne||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,ge){return ct.registerDebugAdapterDescriptorFactory(Ue,oe,ge)},registerDebugAdapterTrackerFactory(oe,ge){return ct.registerDebugAdapterTrackerFactory(oe,ge)},startDebugging(oe,ge,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?ct.startDebugging(oe,ge,{parentSession:Ne}):ct.startDebugging(oe,ge,Ne||{})},stopDebugging(oe){return ct.stopDebugging(oe)},addBreakpoints(oe){return ct.addBreakpoints(oe)},removeBreakpoints(oe){return ct.removeBreakpoints(oe)},asDebugSourceUri(oe,ge){return ct.asDebugSourceUri(oe,ge)}},Yi={registerTaskProvider:(oe,ge)=>kt.registerTaskProvider(Ue,oe,ge),fetchTasks:oe=>kt.fetchTasks(oe),executeTask:oe=>kt.executeTask(Ue,oe),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(oe,ge,Ne)=>kt.onDidStartTask(oe,ge,Ne),onDidEndTask:(oe,ge,Ne)=>kt.onDidEndTask(oe,ge,Ne),onDidStartTaskProcess:(oe,ge,Ne)=>kt.onDidStartTaskProcess(oe,ge,Ne),onDidEndTaskProcess:(oe,ge,Ne)=>kt.onDidEndTaskProcess(oe,ge,Ne)},_i={createNotebookController(oe,ge,Ne,nt,St){return Zt.createNotebookController(Ue,oe,ge,Ne,nt,(0,Ge.isProposedApiEnabled)(Ue,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(oe,ge)=>yt.registerNotebookCellStatusBarItemProvider(Ue,oe,ge),createRendererMessaging(oe){return Di.createRendererMessaging(Ue,oe)},createNotebookControllerDetectionTask(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,oe)},registerKernelSourceActionProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,oe,ge)},onDidChangeNotebookCellExecutionState(oe,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(oe,ge,Ne)}},Ji={t(...oe){if(typeof oe[0]=="string"){const ge=oe.shift(),Ne=!oe||typeof oe[0]!="object"?oe:oe[0];return Ft.getMessage(Ue.identifier.value,{message:ge,args:Ne})}return Ft.getMessage(Ue.identifier.value,oe[0])},get bundle(){return Ft.getBundle(Ue.identifier.value)},get uri(){return Ft.getBundleUri(Ue.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Hi.registerProvider(Ue,oe)},registerInteractiveSessionProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Fi.registerInteractiveSessionProvider(Ue,oe,ge)},addInteractiveRequest(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Fi.addInteractiveSessionRequest(oe)}};return{version:gt.version,authentication:xi,commands:Ki,comments:Xi,debug:Qi,env:Mi,extensions:Kt,interactive:Zi,l10n:Ji,languages:bi,notebooks:_i,scm:Ei,tasks:Yi,tests:Ri,window:Gi,workspace:Bt,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,IndentAction:h.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TerminalQuickFixType:q.TerminalQuickFixType,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItem2:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:E.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentDropEdit:q.DocumentDropEdit,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestRunRequest2:q.TestRunRequest2,TestMessage:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,CoveredCount:q.CoveredCount,FileCoverage:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,FunctionCoverage:q.FunctionCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:Se.LogLevel,EditSessionIdentityMatch:Tt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(Ae[261],Re([1,0,260,34,2,254,7,17,245]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends M.RequireInterceptor{j(){}getModule(E,g){for(const d of this.b){const t=d(E);if(t){E=t;break}}if(this.a.has(E))return this.a.get(E).load(E,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ob(){this.h.createInstance(w.ExtHostConsoleForwarder);const E=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(h,E,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.ub()}pb(E){return E.browser}async qb(E,g,d){g=g.with({path:S(g.path,".js")});const t=E?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=k.URI.revive(await this.u.$asBrowserUri(g)),m=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),m.status!==200)throw new Error(m.statusText);const b=await m.text(),P=`${g.toString(!0)}#vscode-extension`,p=`${b}
//# sourceURL=${P}`;let i;try{i=new Function("module","exports","require",p)}catch(o){throw console.error(t?`Loading code for extension ${t} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${g.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}E&&await this.q.initializeLocalizedMessages(E);const l={},s={exports:l},c=o=>{const I=this.r.getModule(o,g);if(I===void 0)throw new Error(`Cannot load module '${o}'`);return I};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(s,l,c),s.exports!==l?s.exports:l}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(E){}async ub(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+E;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function S(f,E){return f.endsWith(E)?f:f+E}}),define(Ae[262],Re([1,0,67,68,13,34,181,82,261]),function(ee,e,n,T,k,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.registerSingleton)(k.ILogService,new n.SyncDescriptor(R.ExtHostLogService,[!0],!0)),(0,T.registerSingleton)(M.IExtHostExtensionService,w.ExtHostExtensionService,0),(0,T.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,0)}),define(Ae[270],Re([1,0,25,5,75,255,247,19,83,15,2,257,262]),function(ee,e,n,T,k,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(i){return/^(file|vscode-remote):/i.test(i)}const g=fetch.bind(self);function d(i){self.fetch=async function(l,s){return l instanceof Request||E(String(l))&&(l=(await i(O.URI.parse(String(l)))).toString(!0)),g(l,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,s,c,o,I){(async()=>(E(s.toString())&&(s=(await i(O.URI.parse(s.toString()))).toString(!0)),super.open(l,s,c??!0,o,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(l,s){if(/^file:/i.test(l.toString()))l=h.FileAccess.uriToBrowserUri(O.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(v){function D(X){return typeof X=="string"||X instanceof URL?String(X).replace(/^file:\/\//i,"vscode-file://vscode-app"):X}const y=fetch.bind(self);self.fetch=function(X,_){return X instanceof Request?y(X,_):y(D(X),_)},self.XMLHttpRequest=class extends XMLHttpRequest{open(X,_,J,j,U){return super.open(X,D(_),J??!0,j,U)}};const W=importScripts.bind(self);self.importScripts=(...X)=>{W(...X.map(D))},W(v)}.toString()}('${l}'))`;s=s||{},s.name=s.name||A.basename(l.toString());const I=new Blob([o],{type:"application/javascript"}),r=URL.createObjectURL(I);return new i(r,s)}}else self.Worker=class extends R.NestedWorker{constructor(i,l){super(f,i,{name:A.basename(i.toString()),...l})}};const t=new class{constructor(){this.pid=void 0}exit(i){S()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const l=new MessageChannel,s=new T.Emitter;let c=!1;f(l.port2,[l.port2]),l.port1.onmessage=o=>{const{data:I}=o;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const r=n.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,k.isMessageOfType)(r,2)){c=!0,b("received terminate message from renderer");return}s.fire(r)},this.protocol={onMessage:s.event,send:o=>{if(!c){const I=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function m(i){return new Promise(l=>{const s=i.onMessage(c=>{s.dispose();const o=JSON.parse(c.toString());i.send((0,k.createMessageOfType)(0)),l({protocol:i,initData:o})});i.send((0,k.createMessageOfType)(1))})}let b=i=>S();function P(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function p(){w.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(l){!P(l)||m(i.protocol).then(s=>{w.mark("code/extHost/didWaitForInitData");const c=new M.ExtensionHostMain(s.protocol,s.initData,t,null,l.data);d(o=>c.asBrowserUri(o)),b=o=>c.terminate(o)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/155cd6db223feb1f8c734ca70e108b9efec7b054/core/vs/workbench/api/worker/extensionHostWorker.js.map
